# pySCHED



**pySCHED** is a program for planning and scheduling very long baseline interferometry (VLBI) observations conducted by different networks such as the European VLBI Network (EVN), the Very Long Baseline Array (VLBA), the High Sensitivity Array (HSA), the Global VLBI, the Australian Long Baseline Array (LBA), or the Korean VLBI Network (KVN). **pySCHED** produces the standard files that need to be distributed to the different telescopes and correlators for VLBI observations and operations.

**pySCHED** is built upon the [NRAO SCHED](http://www.aoc.nrao.edu/~cwalker/sched/) program developed by Craig Walker at NRAO, and adds unique features:

- Central catalog management on GitHub. The version controlled catalogs provide full access to the change history of each catalog file. By default, at startup, **pySCHED** always updates the catalogs; using old/outdated catalogs is no cause for errors anymore. We note that the feature can be switched off if needed (e.g. for multi-epoch observations).
- Full DBBC2 scheduling support, essential for EVN observations.
- Since v1.8.1 **pySCHED** checks for updates upon startup, informing the user of a new(er) version being available.
- The KEYIN file can be a template schedule with executable Python-code in it. This could simplify scheduling standard observations.
- Can generate VEX1 as well as VEX2 output.
- Plotting is now done through Python's `matplotlib` library, making it easier to control/enhance and/or implement different plots.



## Getting started

To learn how to write a scheduling file (`.key`) that can be used to generate the observing files (`.vex` file) with **pySCHED**, you can follow the User Guide at the [EVN Scheduling Page](https://www.evlbi.org/evn-scheduling). This documentaion is focused on observations with the European VLBI Network (EVN). For a more extended documentation on how to write the scheduling files, please take a look at the general [NRAO SCHED User Manual](http://www.aoc.nrao.edu/~cwalker/sched/).

Once the `.key` file is prepared, **pySCHED** can generate the scheduling files. The basic operations can be conducted by running:

```bash
sched.py [-p] -k {keyfile}
```

where the optional parameter `-p`  retrieves the graphical mode in order to be able to make plots about the observation.



## Installation



### Dependecies

- Python (>= 3.6).
- NumPy (>= 1.16).
- Git.



### pip

```bash
sudo pip3 install numpy
sudo pip3 install pythonSCHED
```

`pip3` is included in most python3 installations, otherwise it can be installed with:

```bash
sudo apt-get install python3-pip
```

### conda

Alternatively, if you use `conda`, [this](https://github.com/jive-vlbi/sched/raw/python/pySCHED.yaml) YAML file is a conda environment which includes both `NumPy` and **pySCHED**. To use it:

```bash
conda env create -f pySCHED.yaml  
conda activate pySCHED
```



## Update

The command to update pySCHED is:

```bash
sudo pip3 install --upgrade pythonSCHED
```

Or when using a conda installation:

```bash
conda activate pySCHED
pip install --upgrade pythonSCHED
```



## Usage

After executing either the `pip` or `conda` installation method, the executable `sched.py` should be available in your `$PATH`.

One of the features of **pySCHED** is that the catalog files will be downloaded/updated on start-up of `sched.py`. This allows for the catalog files to be updated separate from the pySCHED release cycle. The files will be installed in `~/.pysched`. `$SCHED` will be set to this directory in **pySCHED** if not otherwise specified. The process of downloading and updating requires the version control software `git` to be installed and available in the `$PATH`. On most GNU/Linux systems, `git` will be available. If it is not, it can be installed with:

```bash
sudo apt-get install git
```


### Using pySCHED within a SCHED environment

The aforementioned usage can potentially generate some issues when pySCHED runs in an environment where the variable `$SCHED` is set for the NRAO SCHED program. If `$SCHED` is indeed set to the path that points to the NRAO SCHED directory, then pySCHED will read the catalogs under that directory. In this case, pySCHED will not use the most up-to-date catalogs and may fail to schedule experiments requiring the latest updates.

We therefore recommend to unset this variable before running pySCHED (which would then use the default `~/.pysched` directory) or to be sure the catalogs under the `$SCHED` directory are proficient to schedule your experiment.




# Release history

* __v1.2.0 (2019-09-27)__: Merge with SCHED release 11.5.
* __v1.2.1 (2019-10-18)__: Bug fixes for readline and matplotlib version.
* __v1.3.0 (2019-11-19)__: Added SCANEXPS keyword to signal intent in VEX2 files. To make that work, Fortran function leading to calls of SCNDUP are translated to Python.
* __v1.4.0 (2019-12-13)__: Added 'eMERL' value to DAR keyword, to enable eMERLIN out-station automatic IF and BBC assignment.
* __v1.5.0 (2020-02-25)__: Improved error/warning messages.
* __v1.5.1 (2020-03-24)__: Updated the error message for a missing '/'.
* __v1.5.2 (2020-03-26)__: Update version restriction to PyQt version.
* __v1.5.3 (2020-04-02)__: Handle changes made in matplotlib version 3.2.
* __v1.6.0 (2020-05-12)__: Catalog updates for May/June session and plot improvements.
* __v1.7.0 (2020-05-18)__: Include pySCHED version in command line and interactive help text.
* __v1.8.0 (2020-05-19)__: Do a version check on start-up.
* __v1.8.1 (2020-05-20)__: Include README.md in distribution, it is required for installation.
* __v1.8.2 (2020-05-27)__: Fixed update catalog writing to an unopened log file.
* __v1.9.0 (2020-06-09)__: Overhaul of the README.
* __v1.10.0 (2020-06-22)__: SCHED 11.6 merged into pySCHED.
* __v1.11.0 (2020-07-11)__: Add warning message on empty KEYIN input record.
* __v1.12.0 (2020-07-21)__: Runtime improved by about 30%.
* __v1.12.1 (2020-09-10)__: Bug fix, continuous recording warning would trigger too often.
* __v1.13.0 (2020-10-05)__: Allow double bandwidth for eMERLIN if 1 bits sampling is used.
* __v1.13.1 (2020-10-07)__: Bug(s) in exit.c function triggered compiler error. Turned out to be unused code, so removed from compilation list.
* __v1.13.2 (2020-10-14)__: Update code to support matplotlib version 3.3.
* __v1.14.0 (2020-10-23)__: Updated legend layout of uptime plot and added a help button in the plot toolbar.
* __v1.14.1 (2020-11-05)__: pySCHED uses string formatting introduced in python version 3.6. Make this requirement explicit.
* __v1.14.2 (2020-11-06)__: Fortran index was used to index Python array, causing an error when 16 BBCs were used.
* __v1.15.0 (2020-11-23)__: Cleared up confusion about the starting day of time based plots.


# Contact


**pySCHED** is maintained at the [Joint Institute for VLBI ERIC (JIVE)](https://www.jive.eu). You can reach the maintainers at [pysched@jive.eu](mailto:pysched@jive.eu).


# Acknowledgement


This project has received funding from the European Union’s Horizon 2020 research and innovation programme under grant agreement No 730884.

README file for the SCHED root directory.
By Craig Walker

This is the root directory for everything needed to install and run
the VLBI scheduling program SCHED.  If you are seeing this, you
have probably already unpacked the distribution tar file.  If not,
that is the first thing to do.

To utilize SCHED, you should set the environment variable SCHED to
point to this directory.  The environment variables PGPLOT_DIR and
PGPLOT_FONT should be set to the location of your pgplot libraries and
font file.  Note PGPLOT_FONT is usually $PGPLOT_DIR/grfont.dat.

An HTML version of the SCHED Manual is on the Internet at
http://www.aoc.nrao.edu/software/sched/index.html.   
Another copy, which might be newer during the release process, is at:
http://www.aoc.nrao.edu/~cwalker/sched/sched.html or
http://www.aoc.nrao.edu/~cwalker/sched_beta/sched/sched.html
After you unpack the release tar file, the manual is availble locally
on your machine at $SCHED/doc/sched/sched.html.  A postscript version 
can be made by running latex on sched.tex in ./doc. Warning, it is 
large - almost 300 pages - and evolving rapidly.  If you can use a
Web version, it is more convenient and will be kept up to date.  The
author has not generated a postscript or pdf version in many years.

The subdirectories here are:

./bin:          Base location of the execute modules and some scripts.
                There are execute modules or links for the site default
                computer type here.
                This, or the type specific subdirectory, can be added 
                to your PATH for easy execution.

./bin/<arch>:   Possible computer type specific directories containing 
                execute modules.

./catalogs:     Station, source, and linename catalogs.  Also some
                stuff that may be ignored related to catalog 
                conversions.  There are some {\sl Master} subdirectories
                containing the versions of the frequency and station
                catalogs that are actually maintained, but users 
                need not be concerned about them

./catalogs/Master_JIVE:  Contains station and frequency catalog segments
                maintained at JIVE.  Not meant for users.

./catalogs/Master_NRAO:  Contains station and frequency catalog segments
                maintained at NRAO.  Not meant for users.

./catalogs/Master_HSTK:  Contains station and frequency catalog segments
                maintained at HSTK for mm VLBI.  Not meant for users.

./doc:          The SCHED Manual and some other documentation files.

./examples:     Some example SCHED input files.  A good place to 
                look for templates.  Also the location of the 
                verification script Verify.

./examples/Stdout:  Versions of outputs from the Verify script.  Will 
                be used as comparison with local output when 
                Verify is run.  There is considerable disk space here
                and it is only used when testing SCHED with Verify,
                so this area can be emptied if space is tight.

./setups:       Setup files.  Look here for what you need or 
                something close that can be modified.

./src:          The source code directory.  Also the location of the
                Makefile (which requires GNU make - get from
                prep.ai.mit.edu or the SCHED ftp area if necessary)

./src/Cit:      A directory structure containing routines, some 
                machine specific, taken, or closely associated  
                with, the Caltech VLBI package.  There are a number
                of architecture specific subdirectories (eg sys_sun)
                that are needed for specific machines.

./src/Sched:    The code for SCHED.

./src/Jpl:      The code for planetary ephemeris access.

./src/Jplstub:  Stub routines if the planetary routines are not
                wanted.  These are probably not really needed
                since the Jpl routines should compile anywhere.
                Just don't try accessing the ephemeris if you
                don't have it.

./src/Plot:     Most of the plotting routines for SCHED.

./src/PlotNRAO: A few plot routines supported at NRAO.

./src/Plotstub: The stub routines for sites that don't have
                PGPLOT.  SCHED won't link without these if 
                PGPLOT libraries are not available.

./src/Vex:      The code for writing VEX format files.

./src/Sla:      The routines from the SLALIB required by SCHED and 
                UPTIME.  This is only a subset of the SLALIB.

./PGPLOT:       Location code and libraries for PGPLOT in case 
                it is not installed on your machine already.

Any subdirectories in all capital letters are associated with code
management and testing and usually can be ignored (should not be in
the export version).  The most likely exception is if you want to
use the version of PGPLOT sent with SCHED.

For all use of SCHED, you should unpack the tar file.  It has the
catalogs, examples, standard setups, binaries for various
architectures, etc.  It also has the code in case you need to
recompile.

For certain types of computers, binary executables are provided.  As
of April 2014, those are Linux on Intel, Solaris, and Mac OSX (Intel).
All Linux versions are for 64 bit machines (LINUX64).  There is a
version with (LINUX64SPICE) and without (LINUX64) the code needed for
spacecraft tracking.  Most of the Linux versions use g77, but there is
a gfortran compilation of the 64 bit, non-satellite version.  If one
of those is what you need, your simplest installation scheme is to
copy the binary file to the bin directory, or wherever you wish to
keep your load modules.

If you need or want to compile SCHED cd to the src subdirectory.
There, for one of the architectures mentioned above and a few others,
you may be able to use one of the very short scripts, such as
configureLinux, that constructs a Makefile based on Makefile.master (if
someone can contribute a proper configure script, it would be
appreciated).  If there are problems, edit the Makefile.master to
reflect your local conditions.  Makefile.master is heavily commented
to try to make this easy.  Once you have the makefile ready, run gnu
make (the default on Linux and Mac - gmake on Sun), and SCHED should
compile and the executable should be put in the $SCHED/bin directory.
For more information, see the manual.

SCHED uses the PGPLOT routines from Caltech for plotting.  SCHED
requires PGPLOT Version 5.2 or later.  Usually these routines are
acquired independently of SCHED.  They can be installed from from the
Caltech distribution.  There is exensive documenation, including
instructions on how to get it, on the Internet at
http://astro.caltech.edu/~tjp/pgplot.  I have found the pgplot is
often available as a package for apt-get, fink and the like so check
your repositories.  Note that you may run into trouble with the 32-64
bit transition and the g77-gfortran transition when trying to use
pgplot.  Your pgplot and sched should be compiled for the same
combination.

PGPLOT version 5.3.1 is included in the SCHED tar file in the
PGPLOT subdirectory along with compiled libraries for some
architectures.  You might be able to use one of these versions,
or build your own from the code that is included.

If you cannot get pgplot, stubs are available and the comments in
the Makefile show how to use them instead of the real pgplot.  In
this case, plotting will not work, but otherwise the programs
should be fine.  Plotting is not critical for the main program
tasks.  But as of the 6 Mar 98 version, the plotting capabilities
are quite nice and it is well worth the effort of getting pgplot
installed.  It really helps with experiment planning.

SCHED understands how to get positions for the planets, the Moon and
the Sun.  For this it uses a JPL ephemeris.  It is expected that, at
least for now, this will only be used for testing and will probably
only be used at the AOC.  The emphemeris file is not included in the
distribution because of its large size.  If you need it, contact
cwalker@nrao.edu.  Also, the subroutines do not isolate machine
dependencies so they could cause problems in the installation.  If
they do, follow the directions in the Makefile to use the available
stub.  The ephemeris file (input parameter EPHFILE) is kept in a
separate directory tree.  On unix systems, the environment variable
{\tt PLANET_DATA} can be used to set the directory in which the
ephemeris is located.  Note that the emphemeris is binary so it cannot
be shared between machines that use different binary formats, such as
Sun workstations and i86 Linux boxes.

SCHED can now deal with satellites via SPICE files.  This is meant for
tracking deep space missions, not near Earth satellites, although some
targets as close as geostationary orbits have been scheduled.  Again
both the SPICE related code and the ephemeris files will not be
distributed with SCHED because they are not expected to be used
outside of the AOC and they are very bulky.

It seems that there are problems with the routine isatty on SGI
machines.  This may involve a compiler bug.  If you have this problem,
routine TSTTTY in ./src/Cit/sys_unix should just be modified to return
.FALSE. (as it does in citmsdos.for).  Or check out the alternative
in the sys_linux subdirectory.

As of the May 2002 version, SCHED can plot the locations of stations
on a map.  SCHED can read vector files to generate continental,
national, and US state boundaries and New Mexico roads (it is being
used for New Mexico Array configuration studies).  The vector files
are kept in the same directory as the ephemeris.  They are not
distributed with SCHED again because of bulk.  If you want the files,
contact cwalker@nrao.edu for information on where to pick them up.

Good luck and happy scheduling!

Between me and a concerted effort by Franco Tinarelli in Bologna,
a few years ago, SCHED has been tested on:

Current support as of April 2014
  Linux on Intel 64 bit machines using g77
  Linux on Intel 64 bit machine using gfortran
  Sun Sparc workstation using Solaris.
  Mac OS X v10.7 with gfortran on an Intel Macbook Pro  and Mac Pro.

Tested recently as of Jan 2011
  Linux on Intel 32 and 64 bit machines using g77
  Linux on Intel 64 bit machine using gfortran
  Sun Sparc workstation using Solaris.
  Mac OS X v10.6 with gfortran on an Intel Macbook Pro 
  Mac OS X v10.5 with gfortran on an Intel Mac Pro

Tested as at NRAO (Apr. 2005)
  Intel PC with LINUX using g77  (current development environment)
  SUN Sparc stations under Solaris  (actively supported at the AOC)
  Mac OS X v10.3 with g77 on PPC (First on a Mac iBook G4, Dec 2003).
  Mac OS X v10.5 with gfortran on PPC (Powerbook)

Tested not too many years ago:
  Intel PC with LINUX using fort77 (f2c and gcc).
  DEC Alpha
  HP
  SGI
  IBM with AIX (Maybe not so recent).


The Makefile contains the necessary compiler switches etc for all of
the above.  SCHED has not been tested on non-unix machines in several
years although it once worked on DOS PCs and VMS VAXs.  Note that Mac
OS X is a flavor of unix and sched is supported, and even partially
developed on this environment.  If you install SCHED on anything other
than the above please let me know.  The FORTRAN is very generic
FORTRAN77 and the known machine dependent pieces are isolated in the
sys areas so ports should be fairly easy.  A few extensions to
FORTRAN77 are used, but I have not met a compiler yet that doesn't
support them.

Most of SCHED is supported by Craig Walker at NRAO, Socorro, NM.
(cwalker@nrao.edu).  The VEX portions of SCHED are supported by Des
Small at JIVE in the Netherlands (small@jive.nl) with contributions
from Cormac Reynolds at CSIRO (cormac.reynolds@csiro.au). The
interactive plotting capabilities were supported by Franco Tinarelli in
Bologna, Italy (TINARELLI@astbo1.bo.cnr.it), although some of the
changes for configuration studies were added by Craig Walker.

This directory contains the subsections of the station and frequency catalogs
that are being managed from NRAO by Craig Walker. 

Some of these subsections are maintained by different people, but not
as independently as those in ../Master_JIVE

The script "../Update" combines the subsections into the distributed
frequency (freq.dat) and stations (stations.dat) catalogs.

Craig Walker.

      SUBROUTINE VXWRAN
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C
C     Added wrap zones for VLBA  Jan 23, 2014  RCW.
C     Was erroneously in the STATION section for a short time.
C
C     In this case the AN = $ANTENNA section 
C     By H.J. van Langevelde, JIVE, 300496 
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
C     Huib's local variables 
C      
      INTEGER   IXX, ISTA, ISCAT, I
      INTEGER   LEN1
      CHARACTER ZONE*5
C ----------------------------------------------------------------------
C
C     Antenna section
C
      WRITE( IVEX, '( A, A1 )' ) '$ANTENNA', SEP
      DO IXX = 1, NANVEX
C
C        find a station to which this refers
C
         ISTA = -1
         DO I = 1, NSTA
            IF( ISTAAN(I) .EQ. IXX ) ISTA = I
         END DO
C
         IF( ISTA .LT. 0 ) 
     1        CALL ERRLOG(' VXWRAN: no station for $ANTENNA def ')
C
         ISCAT = STANUM(ISTA)
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1       ANLINK(IXX)(1:LEN1(ANLINK(IXX))),SEP
C
         IF( MOUNT(ISCAT) .EQ. 'ALTAZ' ) THEN
            WRITE( IVEX, '( 5X, A, A, 1X, A1, 1X, A, A1 )' )
     1          'axis_type = ', 'az', COL, 'el', SEP
C
C           assuming axrate is elev first. It's in deg/min
C
            WRITE( IVEX, '( 5X, A, A, 1X, A1, F6.1, 1X, A, 1X, A1,
     1           I3, 1X, A, A1, 2X, A1, 1X, F8.3, 1X, A )' )
     2           'antenna_motion = ', 'el', COL, AX2RATE(ISCAT), 
     3           'deg/min', COL, NINT(TSETTLE(ISCAT)), 'sec', SEP, COM,
     4           AX2ACC(1,ISCAT), 'deg/sec/sec'
            WRITE( IVEX, '( 5X, A, A, 1X, A1, F6.1, 1X, A, 1X, A1, 
     1           I3, 1X, A, A1, 2X, A1, 1X, F8.3, 1X, A )' )
     2           'antenna_motion = ', 'az', COL, AX1RATE(ISCAT), 
     3           'deg/min', COL, NINT(TSETTLE(ISCAT)), 'sec', SEP, COM,
     4           AX1ACC(1,ISCAT), 'deg/sec/sec'
C
C           Wrap zones for this mount type only.
C           For now, only do for VLBA.  Jan. 23, 2014  RCW.
C
            IF( STANAME(ISTA)(1:4) .EQ. 'VLBA' ) THEN
               CALL WRAPZONE( IVEX, 0, ISTA, ZONE )
            END IF
C
         ELSE IF( MOUNT(ISCAT) .EQ. 'EQUAT' ) THEN
            WRITE( IVEX, '( 5X, A, A, 1X, A1, 1X, A, A1 )' )
     1           'axis_type = ', 'ha', COL, 'dec', SEP
C
C           assuming axrate is dec first. In deg/min...
C
            WRITE( IVEX, '( 5X, A, A, 1X, A1, F6.1, 1X, A, 1X, A1, 
     1           I3, 1X, A, A1, 2X, A1, 1X, F8.3, 1X, A )' )
     2           'antenna_motion = ', 'dec', COL, AX2RATE(ISCAT), 
     3           'deg/min', COL, NINT(TSETTLE(ISCAT)), 'sec', SEP, COM,
     4           AX2ACC(1,ISCAT), 'deg/sec/sec'
            WRITE( IVEX, '( 5X, A, A, 1X, A1, F6.1, 1X, A, 1X, A1, 
     1           I3, 1X, A, A1, 2X, A1, 1X, F8.3, 1X, A )' )
     2           'antenna_motion = ', 'ha', COL, AX1RATE(ISCAT), 
     3           'deg/min', COL, NINT(TSETTLE(ISCAT)), 'sec', SEP, COM,
     4           AX1ACC(1,ISCAT), 'deg/sec/sec'
         ELSE IF( MOUNT(ISCAT) .EQ. 'XYNS' ) THEN
            WRITE( IVEX, '( 5X, A, A, 1X, A1, 1X, A, A1 )' )
     1           'axis_type = ', 'x', COL, 'yns', SEP
C
C           assuming axrate is x first. In deg/min...
C
            WRITE( IVEX, '( 5X, A, A, 1X, A1, F6.1, 1X, A, 1X, A1, 
     1           I3, 1X, A, A1, 2X, A1, 1X, F8.3, 1X, A )' )
     2           'antenna_motion = ', 'x', COL, AX1RATE(ISCAT), 
     3           'deg/min', COL, NINT(TSETTLE(ISCAT)), 'sec', SEP, COM,
     4           AX1ACC(1,ISCAT), 'deg/sec/sec'
            WRITE( IVEX, '( 5X, A, A, 1X, A1, F6.1, 1X, A, 1X, A1, 
     1           I3, 1X, A, A1, 2X, A1, 1X, F8.3, 1X, A )' )
     2           'antenna_motion = ', 'y', COL, AX2RATE(ISCAT), 
     3           'deg/min', COL, NINT(TSETTLE(ISCAT)), 'sec', SEP, COM,
     4           AX2ACC(1,ISCAT), 'deg/sec/sec'
         ELSE IF( MOUNT(ISCAT) .EQ. 'XYEW' ) THEN
            WRITE( IVEX, '( 5X, A, A, 1X, A1, 1X, A, A1 )' )
     1           'axis_type = ', 'x', COL, 'yew', SEP
C
C           assuming axrate is x first. In deg/min...
C
            WRITE( IVEX, '( 5X, A, A, 1X, A1, F6.1, 1X, A, 1X, A1, 
     1           I3, 1X, A, A1, 2X, A1, 1X, F8.3, 1X, A )' )
     2           'antenna_motion = ', 'x', COL, AX1RATE(ISCAT), 
     3           'deg/min', COL, NINT(TSETTLE(ISCAT)), 'sec', SEP, COM,
     4           AX1ACC(1,ISCAT), 'deg/sec/sec'
            WRITE( IVEX, '( 5X, A, A, 1X, A1, F6.1, 1X, A, 1X, A1, 
     1           I3, 1X, A, A1, 2X, A1, 1X, F8.3, 1X, A )' )
     2           'antenna_motion = ', 'y', COL, AX2RATE(ISCAT), 
     3           'deg/min', COL, NINT(TSETTLE(ISCAT)), 'sec', SEP, COM,
     4           AX2ACC(1,ISCAT), 'deg/sec/sec'
         ELSE
            WRITE( IVEX, '( 5X, A, A, 1X, A1, 1X, A, A1 )' )
     1           'axis_type = ', 'un-', COL, 'known', SEP
            CALL WLOG( 1,' VXWRAN: unknown antenna mount: '//
     1           MOUNT(ISCAT) )
         ENDIF
C
C           axis offset now available
C
         WRITE( IVEX, '( 5X, A, F10.5, 1X, A, A1 )' ) 
     1       'axis_offset = ',AXOFF(ISCAT),'m', SEP         
C
C        no cable wraps etc
C            
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP  
      END DO
      WRITE( IVEX, '( A )' ) COMLIN
      RETURN
      END

      SUBROUTINE WRAPZONE( IUNIT, ISCN, ISTA, ZONE )
C
C     Subroutine for SCHED that determines the WRAP segment that 
C     antenna ISTA is expected to be in for scan ISCN. 
C
C     If ISCN=0, the routine determines the names and ranges for each
C     valid zone, and writes them to the Vex file for the $ANTENNA 
C     section. (erroneously put in STATION section at first).  Fixed
C     on Jan 23, 2014.  RCW.
C
C     When ISCN is not zero, the zone name is returned.  This is
C     used with writing the $SCHED section of the Vex file.
C
C     The wrap zone names are taken from the Vex documentation.
C
C     The zone specification is for the start of the scan, but 
C     shouldn't change.
C
C     Written Jan. 8, 2014  RCW.
C
      INCLUDE  'sched.inc'
C
      INTEGER       ISCN, ISTA, NZONES, IUNIT, LEN1
      REAL          ZLOWAZ(6), ZHIGHAZ(6), ZLOWEL(6), ZHIGHEL(6)
      CHARACTER     ZONE*(*), ZNAMES(6)*5
C
      INTEGER       KSTA, I
C -------------------------------------------------------------------
      KSTA = STANUM(ISTA)
C
C     Deal with setting up the zones.  These are not saved, but 
C     rather recalculated for each case.  Only do this for ALTAZ
C     antennas.  Note AR has a range of 720 deg and we don't want
C     to exclude it.
C
      IF( MOUNT(KSTA) .EQ. 'ALTAZ' .AND. 
     1   AX1LIM(2,KSTA) - AX1LIM(1,KSTA) .LE. 720.0 ) THEN
         IF( ISCN .EQ. 0 ) THEN
C
C           Get the zones, including any over-the-top zones.
C
C           First, the unlikely case that there is no overlap region
C           so there is only one zone, or 2 with over-the-top:
C
            IF( AX1LIM(2,KSTA) - AX1LIM(1,KSTA) .LE. 360.0 ) THEN
               ZNAMES(1) = '&n'
               ZLOWAZ(1) = AX1LIM(1,KSTA)
               ZHIGHAZ(1) = AX1LIM(2,KSTA)
               IF( AX2LIM(2,KSTA) .LE. 90.0001 ) THEN
                  NZONES = 1
                  ZLOWEL(1) = AX2LIM(1,KSTA)
                  ZHIGHEL(1) = AX2LIM(2,KSTA)
               ELSE
                  NZONES = 2
                  ZLOWEL(1) = AX2LIM(1,KSTA)
                  ZHIGHEL(1) = 90.0
C
                  ZNAMES(2) = '&np'
                  ZLOWEL(2) = 90.0
                  ZHIGHEL(2) = AX2LIM(2,KSTA)
C
C                 Write a warning about support level.
C 
                  CALL WLOG( 1, 'WRAPZONE: ' //
     1               STATION(KSTA) // ' has over-the-top pointing.' )
                  CALL WLOG( 1, '          This is not well supported '
     1               // 'in SCHED.  Az and El may be wrong ' )
                  CALL WLOG( 1, '          and slew calculations may '
     1               // 'be way off.' )
               END IF
            ELSE 
C
C              Now the more normal case with overlap (usually
C              the overlap is 180 deg), but less than 2 turns.
C
               IF( AX2LIM(2,KSTA) .LE. 90.0001 ) THEN
                  NZONES = 3
                  DO I = 1, 3
                     ZLOWEL(I) = AX2LIM(1,KSTA)
                     ZHIGHEL(I) = AX2LIM(2,KSTA)
                  END DO
               ELSE
                  NZONES = 6
                  DO I = 1, 3
                     ZLOWEL(I) = AX2LIM(1,KSTA)
                     ZHIGHEL(I) = 90.0
                     ZLOWEL(I+3) = 90.0
                     ZHIGHEL(I+3) = AX2LIM(2,KSTA)
                  END DO
               END IF
               ZNAMES(1) = '&ccw'
               ZLOWAZ(1) = AX1LIM(1,KSTA)
               ZHIGHAZ(1) = AX1LIM(2,KSTA) - 360.0
C      
               ZNAMES(2) = '&n'
               ZLOWAZ(2) = AX1LIM(2,KSTA) - 360.0
               ZHIGHAZ(2) = AX1LIM(1,KSTA) + 360.0
C      
               ZNAMES(3) = '&cw'
               ZLOWAZ(3) = AX1LIM(1,KSTA) + 360.0
               ZHIGHAZ(3) = AX1LIM(2,KSTA)
C
               IF( NZONES .EQ. 6 ) THEN
                  ZNAMES(4) = '&ccwp'         
                  ZLOWAZ(4) = ZLOWAZ(1) 
                  ZHIGHAZ(4) = ZHIGHAZ(1)
C
                  ZNAMES(5) = '&ccwp'         
                  ZLOWAZ(5) = ZLOWAZ(2) 
                  ZHIGHAZ(5) = ZHIGHAZ(2)
C
                  ZNAMES(6) = '&ccwp'         
                  ZLOWAZ(6) = ZLOWAZ(3) 
                  ZHIGHAZ(6) = ZHIGHAZ(3)
               END IF
            END IF
C
C           Now write out the pointing sector lines for the Vex file. 
C           Note we are only doing this for ALTAZ antennas with less 
C           than 720 deg range.
C
            DO I = 1, NZONES
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, A, F7.2, A, F7.2, A, F6.2, A, '
     1            // 'F6.2, A, I2 )' ) '     pointing_sector = ', 
     2            ZNAMES(I),
     3            ' : az :', ZLOWAZ(I), ' deg:', ZHIGHAZ(I), 
     4            ' deg: el :', ZLOWEL(I), ' deg:', ZHIGHEL(I), 
     5            ' deg; * cable wrap zone', I
               WRITE( IUNIT, '(A)' ) MSGTXT(1:LEN1(MSGTXT))
            END DO
C
         ELSE
C
C           Process a scan/antenna if it is in the scan.
C           The routine probably won't be called if the combination
C           is not in the scan, but be careful.
C
            IF( STASCN(ISCN,ISTA) ) THEN
               IF( AZ1(ISCN,ISTA) .GE. AX1LIM(1,KSTA) .AND. 
     1             AZ1(ISCN,ISTA) .LT. AX1LIM(2,KSTA) - 360.0 ) THEN
                  ZONE = '&ccw'
               ELSE IF( AZ1(ISCN,ISTA) .GT. AX1LIM(1,KSTA) +360.0 .AND. 
     1                  AZ1(ISCN,ISTA) .LE. AX1LIM(2,KSTA) ) THEN
                  ZONE = '&cw'
               ELSE
                  ZONE = '&n'
               END IF
C
C              Deal with over-the-top.
C
               IF( AX2LIM(2,KSTA) .GT. 90.0 .AND. 
     1             EL1(ISCN,ISTA) .GT. 90.0 ) THEN
                  ZONE = ZONE // 'p'
               END IF
            ELSE
               ZONE = ' '
            END IF
         END IF
C            
      ELSE IF( MOUNT(KSTA) .EQ. 'ALTAZ' .AND. 
     1    AX1LIM(2,KSTA) - AX1LIM(1,KSTA) .GT. 720.0 ) THEN
C
C        There are more than 2 turns.  Refuse this for now.
C        Only warn on ISCN=0 call
C
         IF( ISCN .EQ. 0 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A )' )
     1         'WRAPZONE: Station ', STATION(KSTA), 
     2         ' has an azimuth wrap range over 180 degrees.'
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1,
     1         '          SCHED is not set up for that.' )
            CALL WLOG( 1,
     1         '          Will not give wrap zones in VEX file.' )
            NZONES = 0
            ZONE = ' '
         END IF
      ELSE
C
C        Other mount 
C
         NZONES = 0
         ZONE = ' '
      END IF
C
      RETURN
      END

      DOUBLE PRECISION FUNCTION sla_DSEP (A1, B1, A2, B2)
*+
*     - - - - -
*      D S E P
*     - - - - -
*
*  Angle between two points on a sphere.
*
*  (double precision)
*
*  Given:
*     A1,B1    d     spherical coordinates of one point
*     A2,B2    d     spherical coordinates of the other point
*
*  (The spherical coordinates are [RA,Dec], [Long,Lat] etc, in radians.)
*
*  The result is the angle, in radians, between the two points.  It
*  is always positive.
*
*  Called:  sla_DCS2C, sla_DSEPV
*
*  Last revision:   7 May 2000
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION A1,B1,A2,B2

      DOUBLE PRECISION V1(3),V2(3)
      DOUBLE PRECISION sla_DSEPV



*  Convert coordinates from spherical to Cartesian.
      CALL sla_DCS2C(A1,B1,V1)
      CALL sla_DCS2C(A2,B2,V2)

*  Angle between the vectors.
      sla_DSEP = sla_DSEPV(V1,V2)

      END

      SUBROUTINE STAGEO( ISCN, ISTA, T_EST1, LSCN,
     1                   LASTTIME, T_AVAIL, CALLER )
Cf2py intent(in) ISCN, ISTA, T_EST1, LSCN, CALLER
Cf2py intent(out) LASTTIME, T_AVAIL
C
C     General purpose geometry routine for calculation of
C     the geometry for a station in a scan.  It is used a lot
C     in the SCHED optimization routines.  This routine will
C     not reset scan parameters such as STARTJ or STASCN, 
C     but it will fill in the geometry variables based on
C     the input times and antenna participation.
C
C     For calculation of the geometry of all stations in a
C     scan, use SCNGEO, which calls this routine.  Note that
C     it calls this routine whether or not the station is
C     actually included in the scan in case it is desired
C     to see where the antenna would be pointed if it were
C     included.
C     
C     This routine used (pre-Dec 2010) to be called OPTGEO.
C     I (RCW) renamed it to make its role more clear.
C
C     ISCN and ISTA are the input scan and station numbers.
C     T_EST1 is the estimated start time for the scan.
C     LSCN is input giving the scan number for the last scan
C       that the station was in.
C     LASTTIME is output giving the last time the station was
C       scheduled for something.
C     T_AVAIL is the output time when the station can observe this
C       source.  For DWELL type scheduling, this will be when the
C       antenna is on source.  For DUR type scheduling, it will
C       be the end of the previous scan.  For this reason, T_AVAIL
C       should not be used later for the final setting of TONSRC.  
C       STAGEO does set TONSRC correctly before setting T_AVAIL.
C
C       The geometric parameters are in the HA1, EL1 etc arrays.
C       This is set to the next even second.
C
C     CALLER is the name of the calling routine.  This routine 
C       is called from so many places that, during debugging, 
C       it can help a lot to know who called it.
C
C     If this is the first scan (LSCN=0), return 0.D0 for
C     LASTTIME and T_AVAIL.  The calling routine should not use
C     these times.
C
      INCLUDE 'sched.inc'
C
      INTEGER          ISCN, ISTA, LSCN
      DOUBLE PRECISION T_EST1, T_EST2, T_AVAIL, LASTTIME
      CHARACTER        HORCHK*1, CALLER*(*)
C ----------------------------------------------------------------
      IF( DEBUG .AND. ISCN .LE. 3 ) THEN
          MSGTXT = ' '
          WRITE( MSGTXT, '( A, A )' )
     1        'STAGEO: starting. Called by ', CALLER
          CALL WLOG( 0, MSGTXT )
      END IF
C      write(*,*) 'stageo: called by ', caller
C
C     Get geometric parameters for this station and this scan.
C
      T_EST2 = T_EST1 + DUR(ISCN)
C
C     The calls to SCHGEO, WRAP, and HORCHK used to be in SCHSRC.  
C     I absorb them into this routine for ease of comprehension of 
C     the overall geometry software.
C        Old call:  CALL SCHSRC( LSCN, ISCN, ISTA, T_EST1, T_EST2 )
C
C     Get geometry at start and end of scan.  
C
      CALL SCHGEO( ISCN, ISTA, T_EST1, HA1(ISCN,ISTA), 
     1             EL1(ISCN,ISTA), AZ1(ISCN,ISTA),
     2             LST1(ISCN,ISTA), PA1(ISCN,ISTA) )
C
      CALL SCHGEO( ISCN, ISTA, T_EST2, HA2(ISCN,ISTA),
     1             EL2(ISCN,ISTA), AZ2(ISCN,ISTA),
     2             LST2(ISCN,ISTA), PA2(ISCN,ISTA) )
C
C     Adjust azimuth for cable wrap for ALTAZ antennas.  Note that
C     WRAP uses the geometry for the end of the last scan the 
C     station was in plus the geometry of the new source at the same
C     time, which is what the antennas do.  It also uses the 
C     geometry at the nominal end of the scan to check need for a
C     wrap.  The latter may not be right before the final scan times
C     are set.  T_EST1 is used as and estimated slew start time when
C     LSCN is zero.
C
      CALL WRAP( ISCN, LSCN, ISTA, T_EST1 )
C
C     Check if rising, setting, below horizon, etc.  Should be called
C     before SLEW because of the consistency check in ANTPOS which is
C     called by SLEW.
C
      UP1(ISCN,ISTA) = HORCHK( STANUM(ISTA), HA1(ISCN,ISTA), 
     1           AZ1(ISCN,ISTA), EL1(ISCN,ISTA), SRCNUM(ISCN) )
      UP2(ISCN,ISTA) = HORCHK( STANUM(ISTA), HA2(ISCN,ISTA), 
     1           AZ2(ISCN,ISTA), EL2(ISCN,ISTA), SRCNUM(ISCN) )
C
C     Get the slew time.
C
      CALL SLEW( ISCN, LSCN, ISTA )
C
C     Get the last observing time and first available time for this
C     antenna.  Also get the time the antenna will be on source.  The
C     zeros for the first scan basically mean that the antenna is
C     ready any time.
C
      IF( LSCN .EQ. 0 ) THEN
C
C        First scan for this antenna.
C
         LASTTIME = 0.D0
         T_AVAIL = 0.D0
         TONSRC(ISCN,ISTA) = STARTJ(ISCN)
C
      ELSE
         LASTTIME = STOPJ(LSCN)
         TONSRC(ISCN,ISTA) = STOPJ(LSCN) + TSLEW(ISCN,ISTA)
C
C        Get when the antenna will be available.  This part is
C        mainly for the optimization routines.  It is only set beyond
C        LASTTIME if the antenna is up throughout the scan - ie it is
C        useful for an optimized schedule.
C
         IF( UP1(ISCN,ISTA) .EQ. ' ' .AND. UP2(ISCN,ISTA) .EQ. ' ' ) 
     1       THEN
C
C           Source is up.  Get the earliest time that the source is 
C           available at that antenna.  Honor requests to not take 
C           slew into account.  Won't get here for ISCN=1.
C
            IF( ( DURONLY(ISCN) .EQ. 1 .OR. DURONLY(ISCN) .EQ. 4 ) 
     1          .AND. DWELL(ISCN) ) THEN
               T_AVAIL = TONSRC(ISCN,ISTA)
            ELSE
               T_AVAIL = LASTTIME
            END IF
         ELSE
C
C           Source not up.  Antenna still available at last scan stop.
C
            T_AVAIL = LASTTIME
C
         END IF
C
      END IF
C
      RETURN 
      END

      SUBROUTINE MAKESCN( LASTISCN, ISCN, JSCN, ISRC, SRCN, TAPPROX, 
     1                    MINEL, NGOOD, OKSTA, USETIME )
C
C     Routine for SCHED, initially used in ADDGEO, to make a scan
C     on a source based on a template scan and a source name.
C     The scan times coming out of this are good enough to use
C     in SCHOPT after SCHOPT has nominally done it's final tweaks.
C
C     LASTISCN is the scan number of the last scan the station was in.
C     ISCN is the scan number being constructed.
C     JSCN is the template scan.  It will be in the original
C        range of 1 to NSCANS.  Pay attention to its STASCN.
C     ISRC is the source number in the main catalog.
C     SRCN is the name of the source to use.
C     TAPPROX is an input approximate time for the scan.  Used for 
C         initial geometry calculations.  Also, if there was no
C         preceeding scan, this becomes the start time of the scan.
C     MINEL is the required minimum elevation for the source to
C         be counted as up (SCNSRC will be set according to 
C         being above the antenna horizons).
C     NGOOD (output) is the nubmer of antennas for which the 
C         source is above MINEL and the station horizon
C     OKSTA is an output array of logicals indicating the station is
C         up for this scan, including above the horizon.
C     USETIME true means force use of TAPPROX as the scan time rather
C         than the experiment start time when none of the stations
C         involved has been in a previous scan.
C         
C
      INCLUDE 'sched.inc'
C
      INTEGER            ISCN, JSCN, ISRC, ISTA, NGOOD, LASTISCN(*)
      REAL               MINEL
      LOGICAL            OKSTA(*), USETIME
      DOUBLE PRECISION   TAPPROX, LASTTIME, T_AVAIL
      CHARACTER          SRCN*12
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'MAKESCN starting.' )
C
C     Copy the template scan.
C
      CALL SCNDUP ( ISCN, JSCN, .FALSE., 'MAKESCN' )
C
C     Insert the source.
C
      SRCNUM(ISCN) = ISRC
      SCNSRC(ISCN) = SRCN
C
C     Loop through stations to see which ones are up at TAPPROX.
C     Also see how many are above the minimum elevation.
C     This pass determines the approximate geometry - enough to 
C     edit stations and count the good ones.
C
      NGOOD = 0
      DO ISTA = 1, NSTA
         OKSTA(ISTA) = .FALSE.
         IF( STASCN(JSCN,ISTA) ) THEN
            CALL STAGEO( ISCN, ISTA, TAPPROX, LASTISCN(ISTA),  
     1          LASTTIME, T_AVAIL, 'MAKESCN' )
            IF( UP1(ISCN,ISTA) .EQ. ' ' .AND. 
     1          UP2(ISCN,ISTA) .EQ. ' ' .AND. 
     2          EL1(ISCN,ISTA) .GT. MINEL .AND.
     3          EL2(ISCN,ISTA) .GT. MINEL ) THEN
               OKSTA(ISTA) = .TRUE.
               NGOOD = NGOOD + 1
            END IF
         END IF
      END DO
C
C     Set the scan stations list based on the results from STAGEO.
C
      DO ISTA = 1, NSTA
         STASCN(ISCN,ISTA) = STASCN(JSCN,ISTA) .AND. OKSTA(ISTA)
      END DO
C
C     Get the final timing and geometry.
C     Consider whether to make the SCNGEO call optional depending 
C     on how long the geo source selection takes.  It lengthens 
C     the time in this routine for minor geometry tweaks not needed
C     while optimizing, but wanted for finally pushing the scans 
C     out the door.  OPTTIM is needed regardless to set start and 
C     stop times.  The restriction to a minimum number of good antennas
C     will be done elsewhere.
C
      IF( NGOOD .GE. 1 ) THEN
         STARTJ(ISCN) = TAPPROX
C
C        Adjust the scan times based on a geometry calculation.
C        This reruns the above STAGEO so it could possibly be made
C        more efficient some day.  Don't apply PRESCAN.  Assume
C        we can assume LASTISCN and LASTSSCN are the same for this
C        call - there is no confusion with preceding inserted pointing.
C        is that always true?
C
         CALL OPTTIM( LASTISCN, LASTISCN, ISCN, .TRUE., 
     1                USETIME, .FALSE. )
C
C        Determine the geometry, slew times, and time of arrival 
C        on source based on the final times.  NGOOD is 
C        redetermined based on the final times.
C
         CALL SCNGEO( LASTISCN, NGOOD, ISCN )
C
      END IF
C
      RETURN
      END

      SUBROUTINE FRCHAR( FRIN, NPER, NFC1, NFCN, FRTXT )
C
C     Utility formatting routine that takes in a double precision
C     number FRIN and creats a text string (FRTXT) containing that 
C     number with the decimal point in position NPER (input) with
C     the first number in position NFC1 (output) and the last non-zero 
C     number in position NFCN (output).
C
C     The primary intended use is to deal with displaying frequencies
C     with more digits than we are used to displaying (.01 MHz) but
C     only when they are needed.
C
C     Do enough digits that the calling routine can sense non-integer
C     values (at least in most cases) if needed.
C
      DOUBLE PRECISION   FRIN
      INTEGER            NPER, NFC1, NFCN, IC
      CHARACTER          FRTXT*16, FMTF*30
C -------------------------------------------------------------------
C
C     Derive the format and write the number to the character string.
C
      IF( NPER .GT. 6 ) THEN
         WRITE( FMTF, '( A6, I1, A2 )' ) 
     1         '( F16.', 16 - NPER, ' )'
      ELSE
         WRITE( FMTF, '( A6, I2, A2 )' ) 
     1         '( F16.', 16 - NPER, ' )'
      END IF
C
C     Write the output string.
C
      WRITE( FRTXT, FMTF ) FRIN
C
C     Get the first digit position and the last non-zero digit position
C     for digits beyond the decimal.  At the decimal if all zero.
C     Set up to print 2 digits (the usual in the past) regardless.
C 
      NFC1 = NPER
      NFCN = NPER + 2
      DO IC = NPER, 1, -1
         IF( FRTXT(IC:IC) .NE. ' ' ) NFC1 = IC
      END DO
      DO IC = NPER+3, 16
         IF( FRTXT(IC:IC) .NE. '0' ) NFCN = IC
      END DO
C
      RETURN
      END

      SUBROUTINE VXWRT
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 030596 
C     opens vex file, does some sorting and writes setup and 
C     schedule sections
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER    VLBOPE, LEN1, IOERR, IXX, ISTA, JSTA
      CHARACTER  OPTEXT*255, OPSTAT*4, VXNMPR*32
      LOGICAL    EXISTS, VIOLFS
      REAL       PLTVER, VERJPL
C ----------------------------------------------------------------------
C
C     Create a VEX output file
C
      VIOLFS = .FALSE.
      IF( DEBUG ) CALL WLOG( 1, 'VXWRT: Starting VEX section' )
      WRITE( VEXFILE, '( A, A )' )  EXPCODE(1:LEN1(EXPCODE)), '.VEX'
      CALL DWCASE( VEXFILE )
C     
C     Find out if the .vex file already exists.
C
      INQUIRE( FILE=VEXFILE, EXIST=EXISTS )
      IF( EXISTS .AND. ( OVERWRIT ) ) THEN
         OPSTAT = 'OLD'
      ELSE IF( EXISTS ) THEN
         CALL WLOG( 1, 'VXWRT: '//VEXFILE//' already exists.' )
         CALL ERRLOG( 'VXWRT: You need to delete old output files' )
      ELSE
         OPSTAT = 'NEW'
      END IF
C     
C     OPEN VEX file 
C
      CALL WLOG( 1, 'VXWRT :  Writing  V E X  file ' //
     1     VEXFILE(1:LEN1(VEXFILE)) )
      IOERR = VLBOPE( IVEX, VEXFILE, 'TEXT', OPSTAT, OPTEXT )
      IF( IOERR .NE. 1 ) CALL ERRLOG( ' Open problem:'//OPTEXT )
C
C     First line defines version of VEX we are trying to adopt
C
      WRITE( IVEX, '( A, A3, A1 )' ) 'VEX_rev = ', VEXVER, SEP
C
C     Give version of Sched
C
      IF( VERSION .NE. ' ' ) 
     1     WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'SCHED vers: ', 
     2     VERSION(1:LEN1(VERSION))      
C
C     Version of VX software
C
      WRITE( IVEX, '( A1, 4X, A, A3, A3 )' ) COM, 'VEX/SCHED:  ',
     1    VEXVER, VXSOFT
C
C     Version of Sched main
C
C      CALL VERSCHED(VERSCH)
      CALL PLVER(PLTVER)
      CALL JPLVER(VERJPL)
      
      WRITE( IVEX, '( A1, 4X, A, F5.1, 2X, A, F4.2, 2X, A, 
     1          F4.2 )' ) 
     2    COM, 'Other versions: Sched: ', VERNUM, 
     3    'Plot: ', PLTVER, 'JPL-ephem: ', 
     4    VERJPL
      WRITE( IVEX, '( A )' ) COMLIN
C
C     Warn if there are moving sources and the Vex file positions
C     should not be used for correlation.
C
      IF( MOVING ) THEN
         WRITE( IVEX, '( A, / A, /, A, /, A, /, A )' )
     1      '*',
     2      '*   ++++  WARNING:  File contains moving sources ',
     3      '*          Do no use positions for correlation.',
     4      '*          Moving coordinates not described in VEX.',
     5      '*'
         WRITE( IVEX, '( A )' ) COMLIN
      END IF
      IF( OBSTYP .EQ. 'PTVLBA' ) THEN
         WRITE( IVEX, '( A, / A, /, A, /, A, /, A, /, A )' )
     1      '*',
     2      '*   ++++  WARNING:  This file is meant for VLBA single',
     3      '*          dish observing.  It may contain setups',
     4      '*          with FORMAT=NONE or other constructs that',
     5      '*          will not work at some stations.',
     6      '*'
         WRITE( IVEX, '( A )' ) COMLIN
      END IF
C
C     first issue warnings if violates PCFS constraints
C     See email exchange of June 26, 2013 for change to 40.
C      
      IF( NSTA .GT. 40 ) THEN
         WRITE( MSGTXT, '( A, I3, A )' ) 
     1       'VXWRT: WARNING: More than 40 stations (', NSTA,
     2       ') in this schedule.' 
         CALL WLOG( 1,MSGTXT)
         VIOLFS = .TRUE.
      END IF
C
C     Warn if PCFS will have problem, but tone it down for ALLVLBA.
C     The DRUDG limit is 20000.  See email from Ed Himwich 18sep2014.
C     He claims it has been that large since October 2007 (version 9.1)
C     so I'm not sure why this was still set to 2000 until now.
C     I am changing it to 20000.  But note that MAXSCNS in sched.inc
C     is 4000 as of this writing, so we should not hit this test
C     unless that parameter is changed.
C
      IF( SCANL-SCAN1 .GT. 20000 ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I6, A )' ) 
     1       'VXWRT: WARNING: More than 20000 scans (', (SCANL-SCAN1),
     2       ') in this schedule.' 
         CALL WLOG( 1,MSGTXT)
         IF( ALLVLBA ) THEN
            CALL WLOG( 1, '                It will not run on PCFS '//
     1          'stations but should be ok on the VLBA.' )
         ELSE
            VIOLFS = .TRUE.
         END IF
      END IF
C
C     And if there are non-unique station codes
C      
      IF( NSTA .GT. 2 ) THEN 
         DO ISTA = 1, NSTA-1
            DO JSTA = ISTA+1, NSTA
               IF( STCODE(STANUM(ISTA)) .EQ. STCODE(STANUM(JSTA)) ) THEN
                  WRITE( MSGTXT, '( A, A2, A )' )
     1                'VXWRT: WARNING: The station code ', 
     2                STCODE(STANUM(ISTA)), ' occurs twice '
                  CALL WLOG( 1,MSGTXT)
                  VIOLFS = .TRUE.
               END IF
            END DO
         END DO
      END IF
C     
      IF( VIOLFS )
     1    CALL WLOG( 1,'VXWRT: WARNING Violating the limits '//
     2       'of PCFS, this VEX will NOT run!!!!')
C
C     
C     Find out if any of the VLBAs are doing something different to the
C     other VLBAs, so we can treat these as special cases later.
C     CR: 050801. VXVLBS no longer necessary (all stations get own setups)
C      CALL VXVLBS 
C     first find out how many modes there are
C
      CALL VXMODE
C
C     sort out how many FQ sections exist and how they are referenced
C     If doing single dish, skip some that are not needed.  RCW Nov 2011
C
C     Freqency
C
      CALL VXSORT( 'FQ', NFQVEX, FQISSET, NMODFQ, IMODFQ,
     1     NSTAFQ, ISTAFQ, FQLINK )
C
C     IF
C
      CALL VXSORT( 'IF', NIFVEX, IFISSET, NMODIF, IMODIF,
     1     NSTAIF, ISTAIF, IFLINK )
C
C     BBC
C
      CALL VXSORT( 'BB', NBBVEX, BBISSET, NMODBB, IMODBB,
     1     NSTABB, ISTABB, BBLINK )
C
C     Tracks
C
      CALL VXSORT( 'TR', NTRVEX, TRISSET, NMODTR, IMODTR,
     2       NSTATR, ISTATR, TRLINK )
C
C        Head position
C
      IF( OBSTYP .NE. 'PTVLBA' ) THEN
         CALL VXSORT( 'HP', NHPVEX, HPISSET, NMODHP, IMODHP,
     1       NSTAHP, ISTAHP, HPLINK )
C
C        Pass order.
C
         CALL VXSORT( 'PO', NPOVEX, POISSET, NMODPO, IMODPO,
     2       NSTAPO, ISTAPO, POLINK )
C
C        Roll
C
         CALL VXSORT( 'RL', NRLVEX, RLISSET, NMODRL, IMODRL,
     1        NSTARL, ISTARL, RLLINK )
      END IF
C
C     Phase Cal
C
      CALL VXSORT( 'PH', NPHVEX, PHISSET, NMODPH, IMODPH,
     1     NSTAPH, ISTAPH, PHLINK )
C
C
C     the Data acquisition info is station based, as are site and antenna
C
      CALL VXTELS( 'DA', NDAVEX, ISTADA, DALINK )
C
      CALL VXTELS( 'SI', NSIVEX, ISTASI, SILINK )
C
      CALL VXTELS( 'AN', NANVEX, ISTAAN, ANLINK )
C
C     most commonly used FQ and PH values have to be stored by mode
C     rather than SET, to make sorting in schedule possible (VXSCNS).
C
      CALL VXFQVX
C
C     setup the phase cal tone links and tone1 (sort out relations
C     between tones and freqs, needs to be run first to detect new
C     freq and phasecal blocks
C
      CALL VXTONE
C
C     sort out the extra modes from changes in the schedule
C
      CALL VXSCNS
C
C     Find the freq and phasecal blocks for the new modes
C     redoes some of the work, no problem.
C
      CALL VXTONE
C
C
C     and setting up PROCEDURES is completely trivial
C
      NPRVEX = NMDVEX
      DO IXX = 1, NPRVEX
         PRLINK( IXX ) = VXNMPR( IXX )
         CALL VXUNQL( IXX, PRLINK )
      END DO
C
C     now actually write the setups
C
      CALL VXDEFS
C
C     and finally, write the schedule
C
      CALL VXSCH
C
      CLOSE( UNIT=IVEX )
C
      IF( DEBUG ) CALL WLOG( 1, 'VXWRT: Done with VEX section' )
      RETURN
      END

      SUBROUTINE PKFINISH
C
C     Routine for SCHED that ties up loose ends on setting up for      
C     automatic insertion of reference pointing scans.  It is put
C     after the reading of the inputs to insure that the station
C     and source catalogs have been read.
C
      INCLUDE      'sched.inc'
      INCLUDE      'schpeak.inc'
C
      INTEGER           ISTA, KSTA, IGRP, IPKSTA
      LOGICAL           DOIT
C ---------------------------------------------------------------------
C
C     Get the full station names for any stations that were
C     specified using station codes.  Keep 'VLBA' as a way of
C     specifying any VLBA station not otherwise listed.  
C
      IF( NPKGRP .GT. 0 ) THEN
         DO IGRP = 1, NPKGRP
            IF( NPKSTA(IGRP) .GT. 0 ) THEN
               DO IPKSTA = 1, NPKSTA(IGRP)
                  IF( PKSTA(IPKSTA,IGRP) .NE. 'VLBA' ) THEN
                     CALL STANO( PKSTA(IPKSTA,IGRP), KSTA, ISTA, DOIT )
                     IF( KSTA .EQ. 0 ) THEN
                        MSGTXT = 'PKFINISH: Pointing group station ' //
     1                      PKSTA(IPKSTA,IGRP) //
     2                      ' not found in station catalog.'
                        CALL ERRLOG( MSGTXT )
                     ELSE
                        PKSTA(IPKSTA,IGRP) = STATION(KSTA)
                     END IF
                  END IF
               END DO
            END IF
         END DO
      END IF
C
C     Get pointers from stations to groups.  Note that PKGROUP's
C     dimension (MPKSTA) will be assured to be .GE. MAXSTA by
C     an error message in STMSG.  So use PKGROUP as if it is 
C     dimensioned MAXSTA.  Note this enforces that each station
C     is only in one group.  Take some care to allow a 'VLBA'
C     default and have that pick up only stations not in other
C     groups.
C
      DO ISTA = 1, NSTA
         IF( NPKGRP .GT. 0 ) THEN
C
            DO IGRP = 1, NPKGRP
               IF( NPKSTA(IGRP) .GT. 0 ) THEN
                  DO IPKSTA = 1, NPKSTA(IGRP)
                     IF( PKSTA(IPKSTA,IGRP) .EQ. STANAME(ISTA) ) THEN
                        PKGROUP(ISTA) = IGRP
                     END IF
                  END DO
               END IF
            END DO
C
C           Now pick up the VLBA defaulted stations.
C
            DO IGRP = 1, NPKGRP
               IF( NPKSTA(IGRP) .GT. 0 ) THEN
                  DO IPKSTA = 1, NPKSTA(IGRP)
                     IF( PKSTA(IPKSTA,IGRP) .EQ. 'VLBA' .AND.
     1                   STANAME(ISTA)(1:4) .EQ. 'VLBA' .AND.
     2                   PKGROUP(ISTA) .EQ. 0 ) THEN
                        PKGROUP(ISTA) = IGRP
                     END IF
                  END DO
               END IF
            END DO
C
         END IF
      END DO
C
C     The pointing source catalog will be read by later routines.
C
      RETURN
      END

      SUBROUTINE SETSTDEF( KS )
C
C     Routine for SCHED called by SETEXPND that sets the stations in
C     a setup file prior to the expansion into single station groups.
C     If station = ' ', this routine looks for all stations that
C     use this setup and adds them to the list.  If stations are
C     specified, it eliminates the ones that are not in the schedule
C     (this helps avoid having excessive groups for, for example,
C     VLBA only projects that use lots of setups).
C
C     At the time this routine is run, the automatic pointing scan
C     insertion has not happened.  Therefore we will need to assume
C     that any setups that might be invoked by that process actually
C     are used.
C
C     Expand 'VLBA' to be the full list of VLBA stations. (Dec2004)
C
      INCLUDE      'sched.inc'
      INCLUDE      'schset.inc'
      INCLUDE      'schpeak.inc'
C
      INTEGER     KS, JS, ISCN, ISTA, KSTA, NOUT
      INTEGER     ANTKS(MANT)
      LOGICAL     ANTFILE(MANT)
      CHARACTER   NEWSTA(2*MANT)*8
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SETSTDEF: Starting.' )
C
      DO NOUT = 1, MANT
         NEWSTA(NOUT) = ' '
      END DO
C
C     First find the setup group within this setup file where any
C     specifically mentioned stations are located.
C     It doesn't matter if the other groups have had their defaults
C     expanded yet, I don't think.  First look for a generic VLBA
C     specification, then for individual stations.  That puts any
C     VLBA stations with specific requests in the right place.
C     Include this group in the search.
C
      DO ISTA = 1, NSTA
         ANTKS(ISTA) = 0
         DO JS = 1, NSET
            IF( ISETNUM(JS) .EQ. ISETNUM(KS) ) THEN
               DO KSTA = 1, MANT
                  IF( STANAME(ISTA)(1:4) .EQ. 'VLBA' .AND. 
     1                  SETSTA(KSTA,JS) .EQ. 'VLBA' ) 
     2                ANTKS(ISTA) = JS
                  IF( STANAME(ISTA) .EQ. SETSTA(KSTA,JS) ) 
     1                ANTKS(ISTA) = JS
               END DO
            END IF
         END DO
      END DO
C
C     If no station was specified, that means use this for any 
C     stations not explicitly covered elsewhere.  Go through and 
C     set ANTKS to this group for all as-yet unspecified stations.
C
      IF( SETSTA(1,KS) .EQ. ' ' ) THEN
         DO ISTA = 1, NSTA
            IF( ANTKS(ISTA) .EQ. 0 ) ANTKS(ISTA) = KS
         END DO
      END IF
C
C     Now go through and eliminate stations that obviously did not
C     use this setup group.  Do by determining if each station might
C     have used this setup file, and then correlating with the ANTKS.
C
C     Loop over stations in the schedule, then scans (for simple 
C     schedules, this will be quick as we won't get past the 
C     first scan or first few scans.
C
      DO ISTA = 1, NSTA
         ANTFILE(ISTA) = .FALSE.
         DO ISCN = 1, NSCANS
            IF( STASCN(ISCN,ISTA) .AND. 
     1          SETNUM(ISCN) .EQ. ISETNUM(KS) ) THEN
               ANTFILE(ISTA) = .TRUE.
               GO TO 100
            END IF
         END DO
  100    CONTINUE
      END DO
C
C     Now check any stations that might get added by the automatic
C     pointing scan insertions.  Utilize PKGROUP that was set up
C     in RDPEAK and PKFINISH to simplify this sort of thing.  Test
C     for both the continuum and line setup files.
C
      IF( DOPOINT .AND. NPKGRP .GT. 0 ) THEN
         DO ISTA = 1, NSTA
            IF( PKGROUP(ISTA) .NE. 0 ) THEN
               IF( PKLSET(PKGROUP(ISTA)) .EQ. ISETNUM(KS) .OR. 
     1             PKLSETL(PKGROUP(ISTA)) .EQ. ISETNUM(KS) ) THEN
                  ANTFILE(ISTA) = .TRUE.
               END IF
            END IF
         END DO
      END IF
C
C     We now have a complete list of stations using this setup file.
C     Create the NEWSTA list.
C
      NOUT = 0
      DO ISTA = 1, NSTA
         IF( ANTFILE(ISTA) .AND. ANTKS(ISTA) .EQ. KS ) THEN
            NOUT = NOUT + 1
            NEWSTA(NOUT) = STANAME(ISTA)
         END IF
      END DO
C
C     Now replace the station list with the new one.  Note that
C     all will be blank if no used stations were found.  NEWSTA
C     may have had stations eliminated above so not all elements
C     should be used.  First reinitialize the SETSTA.
C     Strictly speaking, I didn't need to go through NEWSTA.  That
C     was left from an older and much more complicated version of
C     this routine - before giving each VLBA station a group.
C     It may be useful again some day.
C
      DO ISTA = 1, MANT
         SETSTA(ISTA,KS) = ' '
      END DO
C
C     Then transfer NEWSTA
C
      DO ISTA = 1, NOUT
         SETSTA(ISTA,KS) = NEWSTA(ISTA)
      END DO
C
      RETURN
      END

      DOUBLE PRECISION FUNCTION sla_EPJ (DATE)
*+
*     - - - -
*      E P J
*     - - - -
*
*  Conversion of Modified Julian Date to Julian Epoch (double precision)
*
*  Given:
*     DATE     dp       Modified Julian Date (JD - 2400000.5)
*
*  The result is the Julian Epoch.
*
*  Reference:
*     Lieske,J.H., 1979. Astron.Astrophys.,73,282.
*
*  P.T.Wallace   Starlink   February 1984
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE


      sla_EPJ = 2000D0 + (DATE-51544.5D0)/365.25D0

      END

      SUBROUTINE RDBEMTCH( KS, KF, ICH, IIF, RFIF1, RFIF2, 
     1        RFRQ1, RFRQ2, RCHOVER )
C
C     Routine called by FMATCH to penalize a frequency file entry if 
C     there are crossover problems.  At the time of the call, 
C     FREQREF, BBFILT, and NETSIDE are known for each channel.  
C     Other parameter might not have been set yet.
C
C     KS is the setup group.
C     KF is the frequency catalog group.
C     ICH is the baseband channel number.
C     IIF is the frequency file entry IF number.
C     RFIF1 and RFIF2 are lower and upper RF frequencies for the
C     frequency catalog entry.
C     RFRQ1 and RFRQ2 are lower and upper RF frequencies for the
C     baseband channel.  They don't appear to be used.  
C     RCHOVER was set in FMATCH without knowledge of crossover
C     frequencies.  It is reduced here by the amount of data
C     on the far side of a crossover from FREQREF.
C
C     BBCFR1 and BBCFR2 are the baseband frequencies of the LO 
C     edge (FREQREF) and other edge BBC frequencies for the
C     baseband channel. 
C
C     BBIF1 and BBIF2 are the baseband frequencies corresponding
C     to the edges of the RF band (RFIF1 and RFIF2)
C
C     BBCFR1 
C
C     CROSS are the baseband frequencies of the crossovers.
C
C     Note this routine tries to work even when the RF range is
C     not the usual 512 MHz for the RDBE.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
      INCLUDE   'schfreq.inc'
C
      INTEGER           KS, KF, IIF, ICH, IC
      INTEGER           IFSIDE, BBSIDE, NCROSS, LEN1
      REAL              RCHOVER, RCHOIN
      DOUBLE PRECISION  RFIF1, RFIF2, BBIF1, BBIF2
      DOUBLE PRECISION  RFRQ1, RFRQ2, BBCFR1, BBCFR2

      INTEGER           MCROSS
      PARAMETER         (MCROSS=16)
      DOUBLE PRECISION  CROSS(MCROSS)
      CHARACTER         LDBE*8
      SAVE              LDBE, CROSS, NCROSS
      DATA              LDBE / '    ' /
C ----------------------------------------------------------------------
C
C     Set the crossover points if needed.  These are fixed for each
C     personality.
C
      IF( DBE(KS) .NE. LDBE ) THEN
         IF( DBE(KS) .EQ. 'RDBE_DDC' ) THEN
            NCROSS = 2
            DO IC = 1, NCROSS
               CROSS(IC) = 640 + ( IC - 1 ) * 256
            END DO
         ELSE IF( DBE(KS) .EQ. 'RDBE_PFB' ) THEN
            NCROSS = 15
            DO IC = 1, NCROSS
               CROSS(IC) = 528.D0 + ( IC - 1 ) * 32.D0
            END DO
         END IF
      END IF
      LDBE = DBE(KS)
C
C     Get the BBCFREQ and IF sideband with this frequency set and
C     channel, assuming the LO of this frequency entry.  Also get
C     to   <apparent projectus interruptus - what was the meant to be?>
C
C     This is called before potential sideband inversion (CORINV -
C     used when RF sideband can't be matched with the PFB)
C     or using FREQ or DOPPLER on a scan basis.  Don't worry 
C     about that now.  The choice of frequency file group will 
C     likely be ok.  If necessary, the user can force the choice
C     of frequency information with FIRSTLO. IFSIDE is the IF sideband.
C     while BBSIDE is the baseband sideband.
C     The BBFRADn values will be the lower and upper IF values
C     corresponding the the freq catalog entry RF range.  They
C     will be in inverse order relative to FRADn for lower IF
C     sideband.
C
      IF( FREQREF(ICH,KS) .GT. FLO1(IIF,KF) ) THEN
         IFSIDE = 1
         BBCFR1 = FREQREF(ICH,KS) - FLO1(IIF,KF)
         BBIF1  = RFIF1 - FLO1(IIF,KF)
         BBIF2  = RFIF2 - FLO1(IIF,KF)
      ELSE
         IFSIDE = -1
         BBCFR1 = FLO1(IIF,KF) - FREQREF(ICH,KS)
         BBIF1  = FLO1(IIF,KF) - RFIF2
         BBIF2  = FLO1(IIF,KF) - RFIF1
      END IF
C
      IF( ( NETSIDE(ICH,KS) .EQ. 'U' .AND. IFSIDE .EQ. 1 ) .OR.
     1    ( NETSIDE(ICH,KS) .EQ. 'L' .AND. IFSIDE .EQ. -1 ) ) THEN
         BBCFR2 = BBCFR1 + BBFILT(ICH,KS)
         BBSIDE = 1
      ELSE 
         BBCFR2 = BBCFR1 - BBFILT(ICH,KS)
         BBSIDE = -1
      END IF
C
C     Subtract the part lost to the crossovers in the RDBE_DDC.
C     Only bother when the crossover is within both the 
C     frequency window and the channel band.  Otherwise
C     CHOVER will not be affected.  Recall that any lost to the IF
C     edges is already accounted for.
C
C     Actually this is calculated for the PFB too, but the frequencies
C     are not allowed (elsewhere) to be set to values that would span
C     a crossover.  RCHOIN related to the debug printout.
C
      RCHOIN = RCHOVER
      DO IC = 1, NCROSS
C
C        First check that the crossover is in the IF.
C
         IF( CROSS(IC) .GT. BBIF1 .AND. 
     1       CROSS(IC) .LE. BBIF2 ) THEN
C
C           Now, if the crossover is in the baseband, 
C           get the amount of the baseband spectrum that is on 
C           the far side of the crossover from the LO sum.  This
C           part will be lost so add it to RCHOVER.
C           The different sidebands need to be treated slightly
C           differently because the side of the crossover that 
C           will be kept is at the LO sum band edge.  The IF
C           edges get into the act here for those cases where the
C           IF is limited to less than the expected 512 MHz and
C           part of the frequency loss has already entered RCHOVER
C           through the CHOVER calculation in FMATCH.
C
            IF( BBSIDE .EQ. 1 .AND. ( CROSS(IC) .GT. BBCFR1 .AND. 
     1          CROSS(IC) .LE. BBCFR2 ) ) THEN
               RCHOVER = RCHOVER - 
     1            ( MIN( BBIF2, BBCFR2 ) - CROSS(IC) )
            ELSE IF( BBSIDE .EQ. -1 .AND. ( CROSS(IC) .LT. BBCFR1 
     1          .AND. CROSS(IC) .GE. BBCFR2 ) ) THEN
               RCHOVER = RCHOVER - 
     1            ( CROSS(IC) - MAX( BBIF1, BBCFR2 ) )
            END IF
C
C           Some debug printout in the loop.
C
            IF( SDEBUG ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, 
     1             '( A, 4I3, F8.2, I5, 3F8.2, I3, 2F8.2 )' )
     2             'RDBEMTCH CROSS: ', KS, KF, ICH, IIF, FLO1(IIF,KF),
     3             IC, CROSS(IC), BBCFR1, BBCFR2, BBSIDE, 
     4             BBIF1, BBIF2
                   CALL WLOG( 0, MSGTXT )
            END IF
         END IF
      END DO
C
C     Provide feedback if debugging.
C
      IF( SDEBUG .AND. RCHOIN .GT. RCHOVER ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I4, A, F6.2, A, A, A )' )
     1         'RDBEMTCH: Channel ', ICH, 
     2         ' will lose ', RCHOIN - RCHOVER, 
     3         ' MHZ due to a crossover if Freq. catalog group ', 
     4         FRNAME(KF)(1:LEN1(FRNAME(KF))), ' is used.'
         CALL WLOG( 0, MSGTXT )
      END IF
C
      RETURN
      END

      SUBROUTINE SETFORM
C
C     Routine for SCHED, called by SETREC, to set the recording
C     formats for the setup groups.
C
C     Conform to the modern disk world.  Jan. 11, 2011. RCW.  This
C     mainly means stop worrying about matching many recording
C     parameters across stations.

C     Much of this routine might be unnecessary after the legacy 
C     VLBA and MKIV systems go away.  Save the recoding until 
C     then.

C     ************  Have not actually done the modifications for
C       the above two comments yet.  Things are working for now
C       and time is going to more critical changes.

C
C     The following applies to MarkIV and VLBA tape or Mark5A systems.
C     The fan out is not a concept for the digital backends.
C
C     The nastiest recording parameter choice is deciding on the
C     format to use, which amounts to choosing the fan out.  This
C     cannot be done individually per setup group because of
C     the following global constraints.
C
C     1.  Obsolete: Try to avoid changing the number of heads in use at a 
C         station between scans with VLBA and Mark IV systems.  This would
C         be ok with disk systems.  This constraint is driven by
C         the tape usage accounting nightmare that variations in 
C         head use would cause.
C
C     2.  Obsolete (don't think it ever was true for JIVE): 
C         For some correlators (JIVE, old Socorro), the track bit rate
C         should be the same for all stations in a scan - which here
C         means for all setup groups in a setup file.  This has the
C         additional impact of insuring a constant speedup factor.
C         Treat all correlators as if they have this constraint.
C         This does not affect the DiFX correlators.
C
C     3.  Obsolete.  It's not necessarly to worry about this with disk.
C         Don't use more than one drive or head unless necessary.
C         But if any scan at a station uses more than one, do so
C         for all scans (basically the same as the constant heads
C         constraint).  This should not affect disk recordings.
C
C     4.  For multiple drive/head observations, allow stations 
C         without full resources to record reduced bandwidth by 
C         reducing the number of channels.  Actually this can
C         be done for any setup where a station has inadequate
C         resources.  Just cut NCHAN for the setup group.  Do this
C         after setting all the formats to reduce confusion.  
C         This part obsolete:
C         But during the setting, try hard to stay on one drive or head.
C         The recording resources should no longer cause this, but
C         DAR's might.
C
C     5.  Obsolete
C         Eventually there will be systems (eg MARK5B) that don't
C         care about speed up factors and number of tracks.  I think
C         they will be easier.  Actually the disk systems and 
C         correlators remaining after FXCORR was turned off qualify.
C
C     Trying to conform to the above constraints is a messy problem.
C     Here is the scheme that will be used:
C
C     1.  Go through forcing any formats where there is no choice.
C         This is done in SETFMT and the routines it calls.
C         A.  Tape or Mark 5A bit rates of 256 Mbps or more.
C         B.  Samplerate of 32 Msamp/sec.
C         C.  Samplerate of 2 Msamp/sec or less.
C         D.  While at it, cut the bandwidth at stations that 
C             can't handle the request (limited heads/drives/bbcs)
C         E.  Stop if all formats are set.
C
C     2.  For each setup file, if any group has fixed bit rate/track,
C         force the others in the group.  Done in FSPREAD.
C
C     3.  Try to force all setups to use the same number of tracks.
C         This assumes all stations have the same number of tracks 
C         available.  This should be ok since the single drive/head
C         stations have not been dealt with yet.  Later they will
C         be forced to use no more than 32 tracks.  Done in FSPREAD.
C
C     4.  For all unfixed setup groups, try to find an appropriate
C         set of track bit rates that will give an average speedup
C         factor near 2.  Adjust to conform to the constant bit rate
C         per track in a setup file and constant number of tracks
C         at a station.  
C
C     This should produce a consistent set of setups that gives
C     a speed up of as close as possible to 2 for current standard
C     correlation.
C
C     Confused yet?  I hope I'm not still!
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
      INTEGER           KS, ISETF, ISTA, ISCN
      REAL              MAXBPS, HDFACT
      LOGICAL           OK, NEEDFMT(MSET)
      LOGICAL           ANYLEFT, ANYLFT2
C -------------------------------------------------------------------- 
      IF( DEBUG ) CALL WLOG( 0, 'SETFORM: Starting' )
C
C     MARKIII no longer supported.
C
      DO KS = 1, NSET
         IF( FORMAT(KS) .EQ. 'MARKIII' ) THEN
            CALL ERRLOG ( 
     1         'MARKIII format no longer in use.  Fix setup.' )
         END IF
      END DO
C
C     Initialize the format related variables.  This helps prevent
C     problems on restarts.  Initialize TAPEMODE to the setup file
C     TPMODE value.
C
      DO KS = 1, NSET
         SPEEDUP(KS) = 0.0
         FANOUT(KS) = 0.0
         TAPEMODE(KS) = TPMODE(KS)
      END DO

C
C     First, set as much of the format as possible from the 
C     information provided in the setup file and catalogs.
C
C     If the format was not specified at all, set the default
C     general type based on the type of DAR/DBE at the station where
C     this can be done as with most modern systems.
C     Actually, this is not always right, but, if not, the
C     user will need to be specific.
C     Note the ELSE option deals with the VLBA and MKIV MARK5A/B systems.
C
C     For the VLBA/RDBE, the default will be firmware dependent with
C     MARK5B used for the PFB and VDIF used for the DDC.  The DDC
C     is the only allowed firmware when actually using 2 RDBEs, but that
C     will be dealt with elsewhere.  Assume for now that the DBBC
C     will use MARK5B in all cases.
C
      DO KS = 1, NSET
         IF( FORMAT(KS) .EQ. ' ' ) THEN
            IF( DISK(ISETSTA(KS)) .EQ. 'MARK5C' .AND.
     1           ( DBE(KS) .EQ. 'RDBE_PFB' .OR.
     2             DBE(KS) .EQ. 'DBBC_PFB' .OR.
     3             DBE(KS) .EQ. 'DBBC_DDC' ) ) THEN
               FORMAT(KS) = 'MARK5B'
C
            ELSE IF( DISK(ISETSTA(KS)) .EQ. 'MARK5C' .AND.
     1             DBE(KS) .EQ. 'RDBE_DDC' ) THEN
               FORMAT(KS) = 'VDIF'
C
            ELSE IF( DISK(ISETSTA(KS)) .EQ. 'MARK5B' ) THEN
               FORMAT(KS) = 'MARK5B'
C
            ELSE IF( DAR(ISETSTA(KS)) .EQ. 'WIDAR' ) THEN
               FORMAT(KS) = 'VDIF'
C
            ELSE
               FORMAT(KS) = DAR(ISETSTA(KS))
            END IF
C
C           Don't get goofed up by some of the VLBA varients.
C
            IF( FORMAT(KS) .EQ. 'VLBAG' ) FORMAT(KS) = 'VLBA'
            IF( FORMAT(KS) .EQ. 'VLBA4' ) FORMAT(KS) = 'MKIV'
         END IF
      END DO
C
C     Flag VLBA and MKIV format setup groups.  This is used by
C     various other routines besides this one.  Get the total
C     bit rate nice and early.  Initialize RECUSED.
C     TOTBPS is the old version and is the nominal data rate.
C     For calculations of actual disk space used, the true bit
C     rate WRTBPS should be used as it includes the effects
C     of the headers.
C     The factors for the header contribution are as per email 
C     from W. Brisken on Jan. 8, 2013.  If the format is not a 
C     recognized one, assume the overhead is 1.0.  For VDIF, 
C     the overhead can depend on specific flavor.  Use the one 
C     that we're starting with (5032 => 32 byte header on 5000 
C     bytes data).
C
      DO KS = 1, NSET
         VLBAMKIV(KS) = FORMAT(KS)(1:4) .EQ. 'VLBA' .OR. 
     1                  FORMAT(KS)(1:4) .EQ. 'MKIV'
         RECUSED(KS) = .FALSE.
C
         IF( FORMAT(KS)(1:4) .EQ. 'VLBA' ) THEN
            HDFACT = 1.008
         ELSE IF( FORMAT(KS)(1:4) .EQ. 'MKIV' ) THEN
            HDFACT = 1.0
         ELSE IF( FORMAT(KS)(1:6) .EQ. 'MARK5B' ) THEN
            HDFACT = 1.0016
         ELSE IF( FORMAT(KS)(1:4) .EQ. 'VDIF' ) THEN
            HDFACT = 1.0064
         ELSE
            HDFACT = 1.0
         END IF
         TOTBPS(KS)  = NCHAN(KS) * SAMPRATE(KS) * BITS(1,KS)
         WRTBPS(KS)  = TOTBPS(KS) * HDFACT
      END DO
C
C     Go through scans and stations to determine which 
C     format groups were actually used for recording and to get
C     the maximum bit rate used in the experiment in VLBA and
C     MKIV formats.  Those are the ones that need correlated formats.
C     From those determine if two head or fast track (16 Mbps/track)
C     observations are needed for VLBA and MKIV systems.
C
      MAXBPS = 0
      DO ISCN = 1, NSCANS
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
               KS = NSETUP(ISCN,ISTA)
               ISETF = ISETNUM(KS)
               IF( ( VLBAMKIV(KS) .OR. FORMAT(KS) .EQ. 'MARKIII' ) .AND.
     1               .NOT. NOREC(ISCN) ) THEN
                  MAXBPS = MAX( MAXBPS, TOTBPS(KS) )
               END IF
               IF( .NOT. NOREC(ISCN) ) THEN
                  RECUSED(KS) = .TRUE.
               END IF
            END IF
         END DO
      END DO
      TWOHEAD = MAXBPS .GT. 256.0
      FASTTRK = MAXBPS .GT. 512.0
C
C     Warn user about TWOHEAD and set HEADMODE for the wide band
C     modes.
C
      CALL TWOHDSET
C
C     Go through all setup groups setting the format parameters
C     (FORMAT, SPEEDUP, FANOUT, and TAPEMODE) that can be set at
C     this time.  After this, NEEDFMT can be used to tell if 
C     this format still needs to be set.  For any setups where the
C     format details can be set independently of other setups, this
C     will finish the job.
C
      ANYLEFT = .FALSE.
      DO KS = 1, NSET
         CALL SETFMT( KS, 0.0, OK )
         NEEDFMT(KS) = .NOT. OK
         IF( NEEDFMT(KS) ) ANYLEFT = .TRUE.
      END DO
C
C     For some systems (VLBA, MkIV), the track bit rate must be
C     constant across a setup file and the number of channels
C     should be constant in time.  This allows even one forced
C     format to cause the rest to be set.  Set any formats that can
C     be set because of these constraints.  FSPREAD does one pass
C     of spreading the track bit rate across setup files, and then
C     spreading the number of tracks across setup files by station.
C
C     When making some disk related updates, I found that the 
C     last statement now in the IF was actually outside.  That set
C     ANYLEFT to the undefined ANYLFT2 and could go into FMTPICK
C     even when things were already set.  Not sure how often that
C     caused a problem.
C

C  **********  Do I need to avoid changing bit rates in some cases.
C     see end of old okmodes.f (in older versions only now.)
C     I've got emails out to ask.


      IF( ANYLEFT ) THEN
         CALL FSPREAD( NEEDFMT )
         ANYLFT2 = .FALSE.
         DO KS = 1, NSET
            IF( NEEDFMT(KS) ) ANYLFT2 = .TRUE.
         END DO
         ANYLEFT = ANYLFT2
      END IF
C
C     If the above still did not force the outcome for all setups,
C     try to pick an option that gives a speedup factor averaging
C     about 2.  This was painful to program and I hope I got it ok,
C     but keep an eye on it.  
C
C     In the era of disk, this is not needed and, in fact, it is
C     not likely that the program will enter this call.  I should
C     confirm that, and maybe ditch FMTPICK.
C
      IF( ANYLEFT ) THEN
         CALL FMTPICK( NEEDFMT )
      END IF
C
C     That should be the end of picking any recording formats.  Check.
C
      DO KS = 1, NSET
         IF( RECUSED(KS) .AND. NEEDFMT(KS) ) THEN
            CALL WLOG( 1, 'SETFORM:  Setup file below has format not '
     1          // 'fully specified when it should be.' )
            CALL ERRSET( KS )
         END IF
      END DO
C
C     Drop the number of channels in any formats for stations that don't
C     have adequate resources.
C
      DO KS = 1, NSET
         IF( VLBAMKIV(KS) .AND. RECUSED(KS) .AND. .NOT. NEEDFMT(KS) )
     1       THEN
C
C           Look for just too much bandwidth.
C
            IF( ( TBPS(KS) .GT. 8.0 .AND. TOTBPS(KS) .GT. 1024.0 ) .OR.
     1         ( TBPS(KS) .LE. 8.0 .AND. TOTBPS(KS) .GT. 512.0 ) ) THEN
               CALL WLOG( 1, 'SETFORM: Too much bandwidth requested.' )
               CALL ERRSET( KS )
            END IF
C
C           Look for inappropriate bit rates for the format.
C
            IF( TBPS(KS) .GT. 8.0 .AND. 
     1          FORMAT(KS)(1:4) .NE. 'MKIV' ) THEN
               CALL WLOG( 1, 'SETFORM: Attempted to set track bit ' //
     1             'rate higher than 8 Mbps for inappropriate format.' )
               CALL ERRSET( KS )
            END IF
C
C           Test to look for too much bandwidth for stations of reduced
C           capability (single drive) removed.  Was a tape only test.
C           July 23, 2010  RCW.
C
         END IF
      END DO
C
C     Now set formats for setups only used in non-recording scans.
C     These will basically be dummy values, but set anyway.  Try
C     to match the fan-outs for following scans.
C
      CALL SETNOREC( NEEDFMT )
C
C     This is by no means done.
C
  999 CONTINUE
      RETURN
      END

      SUBROUTINE OMSSRC
C
C     Routine for SCHED that writes source information to the
C     .oms file for use by the VLBA correlator bookkeeping software.
C
      INCLUDE     'sched.inc'
C
      INTEGER     ISRC, J, LENR, LEN1, LEND, LENS
      CHARACTER   TDEC20*16, TRA20*16, TFORM*16
C -------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'OMSSRC starting' )
C
      DO ISRC = 1, MSRC
         IF( SUSED(ISRC) ) THEN
            TRA20 = TFORM( RA2000(ISRC), 'T', 0, 2, 9, 'hms' )
            LENR = LEN1( TRA20 )
            IF( D2000(ISRC) .GE. 0.D0 ) THEN
              TDEC20 = TFORM( D2000(ISRC),  ' ', 0, 2, 8, 'd''"' )
            ELSE
              TDEC20 = TFORM( D2000(ISRC),  ' ', 1, 2, 8, 'd''"' )
            END IF
            LEND = LEN1( TDEC20 )
C     
            DO J = 1, MALIAS
               IF( CSUSED(J,ISRC) .NE. ' ' ) THEN
                  LENS = LEN1( SOURCE(J,ISRC) )
C                  
                  WRITE( IOMS, '( 1X, /, A, /, 1X )' )
     1              'BEGIN = SOURCE_INFO'
                  WRITE( IOMS, '( 2A )' )
     1              '    SOURCE_NAME       = ', SOURCE(J,ISRC)(1:LENS)
                  WRITE( IOMS, '( 2A )' )
     1              '    CAL_CODE          = ', CALCODE(ISRC)
                  WRITE( IOMS, '( 2A )' )
     1              '    SOURCE_RA         = ', TRA20(1:LENR)
                  WRITE( IOMS, '( 2A )' )
     1              '    SOURCE_DEC        = ', TDEC20(1:LEND)
                  WRITE( IOMS, '( 1X, /, A )' )
     1              'END = SOURCE_INFO'
               END IF
            END DO
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE GLSTDAY( ISCN, YEAR, DAY, TIME, RDAY )
C
C     Routine for SCHED's LST scheduling capability that takes the 
C     provided year, day, and time, when that time is an LST time, 
C     and finds the local sidereal day (RDAY) at the sidereal 
C     reference station.  The input DAY can be the day of year, if
C     a UT date was given, or a LST day number, in which case this 
C     routine just passes the number to the right variable.
C
      INCLUDE    'sched.inc'
C
      INTEGER            YEAR, DAY, RDAY, SIDDAY, ISCN, ERR
      DOUBLE PRECISION   TIME, RJDAY, LSTMID, LSTDAY
C  --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'GLSTDAY starting' )
C
      IF( DAY .LE. 366 ) THEN
C
C        Deal with a UT day.
C        Get the MJD and then the LST at 0 hr UT of DAY.
C
         CALL SLA_CLDJ( YEAR, 1, DAY, RJDAY, ERR )
         CALL SIDTIM( RJDAY, LONG(LSTSTA), TWOPI, SIDDAY, LSTMID,
     1                   LSTDAY )
C
C        Now make RDAY the modified Julian LST day number.
C        If the start LST was before the 0hr LST, assume that
C        the start was on the day before.  Also deal with the
C        short period when the UT day specification is ambiguous.
C
         RDAY = SIDDAY
         IF( TIME .GT. LSTMID / TWOPI .AND.
     1       TIME .LE. LSTMID / TWOPI + ( SIDR - 1.D0 ) ) THEN
            CALL WLOG( 1, 'GLSTDAY:  This is your lucky day!' )
            MSGTXT = ' '
            WRITE( MSGTXT, '( 2A, I8 )' )
     1                 '          You have specified an LST ',
     2                 'time and a UT date for scan ', ISCN
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, '          There are about 3.9 minutes '
     1               //  'each day when this is not unique.' )
            CALL WLOG( 1, '          Your time is in that range.' )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A, I8, A, I8 )' )
     1                    '          Your Local Sidereal Day could ',
     2                 'be either ', SIDDAY, ' or ', SIDDAY + 1
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, '          Set input parameter ''DAY'' to'
     1               //  ' the desired one and rerun SCHED.' )
            CALL ERRLOG( 'Need unique LST start day.' )
         ELSE IF( TIME * TWOPI .LT. LSTMID ) THEN
            RDAY = RDAY + 1
         END IF
         CALL WLOG( 1, 'GLSTDAY: CAUTION:  You have specified a '
     1       // 'UT start day for an LST schedule.' )
         CALL WLOG( 1, '    Unless this is for dynamic scheduling,'
     1          // ' please check scan dates carefully.' )
C
      ELSE
C
C        Start day was an LST day number.  Just send it back out.
C
         RDAY = DAY
      END IF
C
      RETURN
      END

      SUBROUTINE MAXBAS( XYMAX )
C
C     Routine for SCHED plotting to determine the maximum baseline
C     length for plotting.  Make it 5% longer than the longest baseline.
C
      INCLUDE  'sched.inc'
C
      INTEGER           ISTA, KSTA
      DOUBLE PRECISION  BMAX, BLEN
      REAL              XYMAX
C ----------------------------------------------------------------------
C     Loop over baselines finding the longest.
C
      BMAX = 0.D0
      DO ISTA = 1, NSTA - 1
         DO KSTA = ISTA + 1, NSTA
            BLEN = ( XPOS(STANUM(ISTA)) - XPOS(STANUM(KSTA)) )**2 +
     1             ( YPOS(STANUM(ISTA)) - YPOS(STANUM(KSTA)) )**2 +
     2             ( ZPOS(STANUM(ISTA)) - ZPOS(STANUM(KSTA)) )**2
            BLEN = SQRT( BLEN )
            BMAX = MAX( BMAX, BLEN )
         END DO
      END DO 
C
C     Add 5 percent and convert to km.
C
      XYMAX = 1.05D0 * BMAX / 1.D3
C
      RETURN
      END

      SUBROUTINE SATEP( ISAT, ISCN, ISTA, INSTRU, RA, DEC, 
     1                  DRA, DDEC, T0, DISTAU )
C
C     This is the stub for the satellite tracking routine.  It
C     will complain and die if it is called.
C
      INTEGER            ISAT, ISCN, ISTA
      CHARACTER          INSTRU*(*)
      DOUBLE PRECISION   RA, DEC, DRA, DDEC, T0, DISTAU
C --------------------------------------------------------------
      CALL ERROR( 'SATEP stub: Satellite tracking routine '//
     1   'called but not supported in this installation of SCHED.' )
      RETURN
      END

      SUBROUTINE OMSOUT( RESTART )
C
C     Write information to the file to be read by OMS.
C     Do regardless of correlator to be used.
C
      INCLUDE           'sched.inc'
C
      INTEGER           LEN1, NCH, I, ISCN, VLBOPE, IOERR
      LOGICAL           EXISTS, RESTART
      CHARACTER         OMSFILE*80, TFORM*8, TIME1*8, TIME2*8
      CHARACTER         OPSTAT*4, OPTEXT*255
      DOUBLE PRECISION  START1, STOPL, START, STOP
      INTEGER           DAY1, DAY2, YEAR1, YEAR2
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'OMSOUT starting' )
C
C     Construct the name of the oms file.
C     
      WRITE( OMSFILE, '(A,A)' )  EXPCODE(1:LEN1(EXPCODE)), '.OMS'
      CALL DWCASE( OMSFILE )
      IF( DEBUG ) CALL WLOG( 0, 'OMSOUT: Opening ' //
     1      OMSFILE(1:LEN1(OMSFILE)) )
C     
C     Find out if the .oms file already exists.
C     
      INQUIRE( FILE=OMSFILE, EXIST=EXISTS )
      IF( EXISTS .AND. ( RESTART .OR. OVERWRIT ) ) THEN
         OPSTAT = 'OLD'
      ELSE IF( EXISTS ) THEN
         WRITE( MSGTXT, '( A, A, A )' )  'OMSOUT: ', 
     1       OMSFILE(1:LEN1(OMSFILE)), ' already exists.'
         CALL WLOG( 1, MSGTXT )
         CALL ERRLOG( 
     1      'OMSOUT: You need to delete old output files '//
     2      'or use OVERWRIT.')
      ELSE
         OPSTAT = 'NEW'
      END IF
C     
C     Announce your intentions.
C     
      CALL WLOG( 0, 'OMSOUT:  Writing OMS file ' //
     1     OMSFILE(1:LEN1(OMSFILE)) )
C     
C     OPEN OMS file.
      
      IOERR = VLBOPE( IOMS, OMSFILE, 'TEXT', OPSTAT, OPTEXT )
      IF( IOERR .NE. 1 ) CALL ERRLOG( ' Open problem:'//OPTEXT )
C     
C     If there is a cover letter, write it here:
C     
      IF( COVERLET ) THEN
         WRITE( IOMS, '( 1X, /, A, /, 1X )' ) 'COVER LETTER:'
         CALL WRTCOV( IOMS )
      ELSE
         WRITE( IOMS, '( 1X, /, A )' )
     1      'No cover letter provided.'
      END IF
C     
C     Write the program information to the file.
C     
      WRITE( IOMS, '( 1X, /, A, /, 1X )' )
     1   'BEGIN = PROJECT_INFO'
C     
      WRITE( IOMS, '( A, A )' ) '    PROJECT_CODE       = ',
     1   EXPCODE
C     
C     Rich would like PROJECT_CODE and SEGMENT_CODE but I don't
C     have those separated and I am reluctant to guess.
C     
      WRITE( IOMS, '( A, A )' ) '    TITLE              = ',
     1    EXPT(1:LEN1(EXPT))
      WRITE( IOMS, '( A, A )' ) '    PI_NAME            = ',
     1    PINAME(1:LEN1(PINAME))
      DO I = 1, 4
         NCH = LEN1( ADDRESS(I) )
         IF( NCH .GT. 0 ) THEN
            WRITE( IOMS, '( A, A )' ) '    PI_ADDRESS         = ',
     1         ADDRESS(I)(1:NCH)
         END IF
      END DO     
      WRITE( IOMS, '( A, A )' ) '    PI_PHONE           = ',
     1    PHONE(1:LEN1(PHONE))
      WRITE( IOMS, '( A, A )' ) '    PI_OBS_PHONE       = ',
     1    OBSPHONE(1:LEN1(OBSPHONE))
      WRITE( IOMS, '( A, A )' ) '    PI_EMAIL           = ',
     1    EMAIL(1:LEN1(EMAIL))
      WRITE( IOMS, '( A, A )' ) '    PI_FAX             = ',
     1    FAX(1:LEN1(FAX))
C     
C     Get the first and last times.
C     
      START1 = STARTJ(SCAN1)
      STOPL = STOPJ(SCANL)
      DO ISCN = SCAN1, SCANL
         IF( .NOT. NOREC(ISCN) ) THEN
            START1 = MIN( START1, STARTJ(ISCN) )
            STOPL  = MAX( STOPL,  STOPJ(ISCN) )
         END IF
      END DO
      CALL TIMEJ( START1, YEAR1, DAY1, START )
      CALL TIMEJ( STOPL, YEAR2, DAY2, STOP )
      TIME1 = TFORM( START, 'T', 0, 2, 2, '::@' )
      TIME2 = TFORM( STOP, 'T', 0, 2, 2, '::@' )
      WRITE( IOMS, '( A, I4, A, I3.3, A, A )' ) 
     1    '    START              = ', YEAR1, '-', DAY1, '/', TIME1
      WRITE( IOMS, '( A, I4, A, I3.3, A, A )' ) 
     1    '    STOP               = ', YEAR2, '-', DAY2, '/', TIME2
C     
      WRITE( IOMS, '( A, A )' ) '    CORRELATOR         = ', 
     1       CORREL(1:LEN1(CORREL))
      WRITE( IOMS, '( 1X, /, A, /, 1X )' )
     1   'END = PROJECT_INFO'
C     
C     Write setup information if there is a setup (there may not be
C     for planning modes).
C
      IF( .NOT. NOSET ) CALL OMSSET
C     
C     Write the station info - one per station.
C     
      CALL OMSSTA
C     
C     Write the source info - one per source.
C     
      CALL OMSSRC
C     
C     Write the correlation parameters.
C     
      CALL OMSCOR
C
      RETURN
      END

      SUBROUTINE PVOBS (PHI, ELONG, HEIGHT, GAST, LITTLG)
c
c calculate the position of the observer on the surface of the Earth,
c in an Earth-fixed, geocentric, right-handed coordinate system with 
c the xy-plane the Earth's equator, the xz-plane the Greenwich 
c meridian, and the z-axis pointed toward the north terrestrial pole.  
c taken from section 3.353 of the Explanatory Supplement to the 
c Astronomical Almanac.
c
c  Inputs:
c   PHI    = observer's geodetic latitude (radians)
c   ELONG  = observer's East longitude (radians)
c   HEIGHT = observer's height above geoid (meters)
c   GAST   = Greenwich Apparent Sidereal Time (radians)
c
c  Outputs:
c   LITTLG = the geocentric position and velocity vector of
c            the observer (AU, AU/day)
c
c  Calls: sla_DMXM, sla_DMXV
c
C  B.J.Butler    NRAO/VLA   summer 1996

      IMPLICIT NONE

      DOUBLE PRECISION PHI, ELONG, HEIGHT, GAST, LITTLG(6)
      DOUBLE PRECISION FLAT, EQRAD, OMEGA, AU
      PARAMETER (FLAT = 1.0D0 / 298.257D0)
      PARAMETER (EQRAD = 6.37814D6)
      PARAMETER (OMEGA = 7.2921151467D-5)
      PARAMETER (AU = 1.49597870D11)
      DOUBLE PRECISION CPHI, SPHI, CVAL, SVAL, TVAL, XP, YP
      DOUBLE PRECISION LITTLR(3), R1(3,3), R2(3,3), R3(3,3),
     *                 IMTX1(3,3), IMTX2(3,3)
      INTEGER II

c 3.351 Location and Universal Time of the Observation
c step b
      CPHI = DCOS (PHI)
      SPHI = DSIN (PHI)
      TVAL = (1 - FLAT) * (1 - FLAT)
      CVAL = 1.0D0 / DSQRT (CPHI * CPHI + TVAL * SPHI * SPHI)
      SVAL = CVAL * TVAL
      LITTLR(1) = (EQRAD * CVAL + HEIGHT) * CPHI * DCOS (ELONG)
      LITTLR(2) = (EQRAD * CVAL + HEIGHT) * CPHI * DSIN (ELONG)
      LITTLR(3) = (EQRAD * SVAL + HEIGHT) * SPHI
c 3.353 Geocentric Position and Velocity Vectors of the Observer
c step e
c   here, if you have access to the coordinates of the Celestial
c   Ephemeris Pole (CEP), XP and YP, put them in.  i haven't put
c   in a routine to calculate them yet, although it appears that
c   it could be done (see the web site at:
c   file://maia.usno.navy.mil/standards/iersch5.t2)
c   the supplement states that neglecting these terms affects the
c   topocentric place of the moon by several milliarcsec, with a
c   smaller effect, inversely proportional to distance, for other
c   bodies.  neglecting these terms is in effect setting R1 and
c   R2 to unit matrices...
c   set up the XP matrix (R2):
      XP = 0.0D0
      R2(1,1) = DCOS (XP)
      R2(1,2) = 0.0D0
      R2(1,3) = -DSIN (XP)
      R2(2,1) = 0.0D0
      R2(2,2) = 1.0D0
      R2(2,3) = 0.0D0
      R2(3,1) = DSIN (XP)
      R2(3,2) = 0.0D0
      R2(3,3) = DCOS (XP)
c   set up the YP matrix (R1):
      YP = 0.0D0
      R1(1,1) = 1.0D0
      R1(1,2) = 0.0D0
      R1(1,3) = 0.0D0
      R1(2,1) = 0.0D0
      R1(2,2) = DCOS (YP)
      R1(2,3) = DSIN (YP)
      R1(3,1) = 0.0D0
      R1(3,2) = -DSIN (YP)
      R1(3,3) = DCOS (YP)
c   set up the GAST matrix (R3) [remember, rotating by -GAST]:
      R3(1,1) = DCOS (GAST)
      R3(1,2) = -DSIN (GAST)
      R3(1,3) = 0.0D0
      R3(2,1) = DSIN (GAST)
      R3(2,2) = DCOS (GAST)
      R3(2,3) = 0.0D0
      R3(3,1) = 0.0D0
      R3(3,2) = 0.0D0
      R3(3,3) = 1.0D0
c   multiply R3 and R1, and store in an intermediate matrix:
      CALL sla_DMXM (R3, R1, IMTX1)
c   multiply that intermediate matrix by R2, and store in another
c   intermediate matrix:
      CALL sla_DMXM (IMTX1, R2, IMTX2)
c   multiply this by the observers position vector:
      CALL sla_DMXV (IMTX2, LITTLR, LITTLG)
c   now, set up the rotation vector (R3 again...)
      R3(1,1) = -DSIN (GAST)
      R3(1,2) = -DCOS (GAST)
      R3(1,3) = 0.0D0
      R3(2,1) = DCOS (GAST)
      R3(2,2) = -DSIN (GAST)
      R3(2,3) = 0.0D0
      R3(3,1) = 0.0D0
      R3(3,2) = 0.0D0
      R3(3,3) = 0.0D0
c   multiply R3 and R1, and store in an intermediate matrix:
      CALL sla_DMXM (R3, R1, IMTX1)
c   multiply that intermediate matrix by R2, and store in another
c   intermediate matrix:
      CALL sla_DMXM (IMTX1, R2, IMTX2)
c   multiply this by the observers velocity vector:
      CALL sla_DMXV (IMTX2, LITTLR, LITTLG(4))
c   multiply by earth rotation rate:
      DO II = 4, 6
         LITTLG(II) = LITTLG(II) * OMEGA
      END DO
c step f
      DO II = 1, 3
         LITTLG(II) = LITTLG(II) / AU
      END DO
      DO II = 4, 6
         LITTLG(II) = LITTLG(II) * 86400.0D0 / AU
      END DO
      RETURN
      END

      SUBROUTINE sla_PM (R0, D0, PR, PD, PX, RV, EP0, EP1, R1, D1)
*+
*     - - -
*      P M
*     - - -
*
*  Apply corrections for proper motion to a star RA,Dec
*  (double precision)
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Given:
*     R0,D0    dp     RA,Dec at epoch EP0 (rad)
*     PR,PD    dp     proper motions:  RA,Dec changes per year of epoch
*     PX       dp     parallax (arcsec)
*     RV       dp     radial velocity (km/sec, +ve if receding)
*     EP0      dp     start epoch in years (e.g. Julian epoch)
*     EP1      dp     end epoch in years (same system as EP0)
*
*  Returned:
*     R1,D1    dp     RA,Dec at epoch EP1 (rad)
*
*  Called:
*     sla_DCS2C       spherical to Cartesian
*     sla_DCC2S       Cartesian to spherical
*     sla_DRANRM      normalize angle 0-2Pi
*
*  Notes:
*
*  1  The proper motions in RA are dRA/dt rather than cos(Dec)*dRA/dt,
*     and are in the same coordinate system as R0,D0.
*
*  2  If the available proper motions are pre-FK5 they will be per
*     tropical year rather than per Julian year, and so the epochs
*     must both be Besselian rather than Julian.  In such cases, a
*     scaling factor of 365.2422D0/365.25D0 should be applied to the
*     radial velocity before use.
*
*  P.T.Wallace   Starlink   19 January 2000
*
*  Copyright (C) 2000 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION R0,D0,PR,PD,PX,RV,EP0,EP1,R1,D1

*  Km/s to AU/year multiplied by arcseconds to radians
      DOUBLE PRECISION VFR
      PARAMETER (VFR=(365.25D0*86400D0/149597870D0)*4.8481368111D-6)

      INTEGER I
      DOUBLE PRECISION sla_DRANRM
      DOUBLE PRECISION W,EM(3),T,P(3)



*  Spherical to Cartesian
      CALL sla_DCS2C(R0,D0,P)

*  Space motion (radians per year)
      W=VFR*RV*PX
      EM(1)=-PR*P(2)-PD*COS(R0)*SIN(D0)+W*P(1)
      EM(2)= PR*P(1)-PD*SIN(R0)*SIN(D0)+W*P(2)
      EM(3)=         PD*COS(D0)        +W*P(3)

*  Apply the motion
      T=EP1-EP0
      DO I=1,3
         P(I)=P(I)+T*EM(I)
      END DO

*  Cartesian to spherical
      CALL sla_DCC2S(P,R1,D1)
      R1=sla_DRANRM(R1)

      END

      SUBROUTINE VXS2MD( ISET, S2MODE, VALID, NS2USD, IS2USD, DOWARN )
Cf2py intent(in) ISET, DOWARN
Cf2py intent(out) S2MODE, VALID, NS2USD, IS2USD
C 
C     Routine specific for the VEX extension of SCHED. 
C     Figures out S2 mode name and checks validity
C     By H.J. van Langevelde, JIVE, 230996
C     This routine figures out the S2 mode for ISET
C     and returns the cable identification IS2USD
C     Checks wether the mode is a valid S2 mode
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
C
      INTEGER ISET, NS2USD
      CHARACTER IS2USD(16)*4, S2MODE*7
      LOGICAL VALID, DOWARN
      CHARACTER THEDAR*5
C
      INTEGER ISTA,I
C ----------------------------------------------------------------------
C     set up defaults
C
      DO I = 1, 16
         IS2USD(I) = ' '
      END DO
C
C     first find out what DAR
C
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,ISET) )
     1       THEDAR = DAR(STANUM(ISTA))
      END DO
C
C     user channels must be 1, 2, 4, 8, 16
C
      IF( THEDAR .EQ. 'VLBA' .OR. 
     1    THEDAR .EQ. 'VLBAG' ) THEN
         IF( DEBUG ) CALL WLOG( 1,'       Using VXS2VL ')
         CALL VXS2VL( NCHAN(ISET), BBC(1, ISET), 
     1       NETSIDE(1, ISET), SAMPRATE(ISET), BITS(1,ISET), 
     2       TAPEMODE(ISET), S2MODE, VALID, NS2USD, IS2USD )
      ELSE
         WRITE( MSGTXT, '( A, A, A )' )
     1       'VXS2MD: S2 Modes with DAR = ', THEDAR,
     2       ' wiring not implemented, using naive S2 mode '
         IF( DOWARN )
     1       CALL WLOG( 1, MSGTXT ) 
         IF( DEBUG ) CALL WLOG( 1,'       Using VXS2DF ')
         CALL VXS2DF( NCHAN(ISET), SAMPRATE(ISET), BITS(1,ISET), 
     1       TAPEMODE(ISET), S2MODE, VALID, NS2USD, IS2USD )
      END IF 
C
      RETURN
      END

      SUBROUTINE GETFSET
C
C     Routine for SCHED that gets the frequency sets.
C
C     A setup group specifies most of the information about the 
C     configuration at a station.  But SCHED has scan dependent
C     variables that can impose variations on what is in the setup.
C     Those are FREQ, BW, DOPPLER, PCAL, CRDFREQ, CRDBW, and CRDDOP.
C     A frequency set is a unique combination of these parameters.  
C     There will be a different frequency set for each different 
C     combination of these parameters that is found.
C
C     Until August 2013, SCHED also had pulse cal sets.  Those
C     are being merged into the frequency sets to ease some bookkeeping
C     issues.  It was done at the time the ability to set the legacy 
C     system BBCs used for reference pointing separately from the RDBE 
C     channels was added.  RCW.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    ISCN, ISTA, IFS, KS, ICH, JF, KSCN
      LOGICAL    MATCH, FSMATCH
      CHARACTER  GFSPCAL*4
C ----------------------------------------------------------------------
      NFSET = 0
C
C     Loop through scans and stations accumulating the frequency sets.
C
      DO ISCN = SCAN1, SCANL
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
C
C              Get the current setup.
C
               KS = NSETUP(ISCN,ISTA)
C
C              Get the PCAL state for this scan/station.  If it was 
C              specified in the schedule, take that.  If not, use the
C              value from the setup group.  Keep in a local variable
C              for now.
C
               IF( PCAL(ISCN) .NE. ' ' ) THEN
                  GFSPCAL = PCAL(ISCN)
               ELSE
                  GFSPCAL = SPCAL(KS)
               END IF
C
C              Deal with first data scan.
C
               IF( NFSET .EQ. 0 ) THEN
                  NFSET = 1
                  FSETI(ISCN,ISTA) = 1
                  FSETKS(NFSET) = KS
                  FSETSCN(NFSET) = ISCN
                  FSSAME(NFSET) = NFSET
                  FSPCAL(NFSET) = GFSPCAL
               ELSE
C
C                 No longer first, initialize FSETI, the pointer
C                 to a frequency set for each scan/station.
C
                  FSETI(ISCN,ISTA) = 0
C
C                 Look for a previous match.
C                 Compare with previous fsets.
C                  
                  DO IFS = 1, NFSET
C
C                    Compare setup group.  Note this will only 
C                    match for the same station as it is one group
C                    per station.  There will be separate frequency
C                    groups for each station, but details will not
C                    all be listed for matching sets - like the setup
C                    groups.
C
                     MATCH = FSETKS(IFS) .EQ. KS
C
C                    Compare frequency and bandwidth specified with 
C                    a scan.  The Doppler setting has already been 
C                    done and the results are in FREQ.  Note that 
C                    having both zero is a match, probably the most
C                    common kind.  Same with BW.  Recall the FREQ and BW
C                    scan inputs are not station dependent.
C
                     KSCN = FSETSCN(IFS)
                     IF( MATCH ) THEN
                        DO ICH = 1, NCHAN(KS)
                           MATCH = MATCH .AND. 
     1                        FREQ(ICH,ISCN) .EQ. FREQ(ICH,KSCN)
                           MATCH = MATCH .AND.
     1                        BW(ICH,ISCN) .EQ. BW(ICH,KSCN)
                        END DO
C
C                       Compare the VLBA legacy system settings.
C                       First require both scans either have or don't
C                       have GOTCRD set, which means they have had
C                       CRDFREQ or CRDDOP specified.  And require that
C                       the same number of channels, CRDNCH, was specified
C                       and that, if a channel mapping, CRDSETCH, was
C                       set, perhaps based on CRDCH1, that it matches.
C                       For the channels, always require that CRDBW
C                       match and that CRDFREQ matches if GOTCRD was
C                       set.  We are allowing CRDNCH, CRDSETCH, CRDCH1,
C                       and CRDBW to be used even when CRDFREQ and 
C                       CRDDOP are not.  I believe CRDSETCH here will
C                       be equivalent to running GETCRDN and testing
C                       CRSETC.
C
C                       Note that the Doppler setting for the legacy 
C                       system has already been done and the results 
C                       are in CRDFREQ.
C
C                       FORTRAN WARNING:  The parentheses around the
C                       .EQV. below are needed or all the logical 
C                       operations earlier in the line are evaluated
C                       as the left side of the .EQV.
C
                        IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) THEN
                           MATCH = MATCH .AND.
     1                        CRDNCH(ISCN) .EQ. CRDNCH(KSCN) .AND. 
     2                        ( GOTCRD(ISCN) .EQV. GOTCRD(KSCN) )
                           IF( CRDNCH(ISCN) .GT. 0 ) THEN
                              DO ICH = 1, CRDNCH(ISCN)
                                 IF( GOTCRD(ISCN) ) THEN
                                    MATCH = MATCH .AND. 
     1                              CRDFREQ(ICH,ISCN) .EQ. 
     2                              CRDFREQ(ICH,KSCN)
                                 END IF
                                 MATCH = MATCH .AND. 
     1                             CRDBW(ICH,ISCN) .EQ. CRDBW(ICH,KSCN)
                                 MATCH = MATCH .AND. CRDSETCH(ICH,ISCN)
     1                               .EQ. CRDSETCH(ICH,KSCN)
                              END DO
                           END IF
C
                        END IF
C
C                       Compare the pcal state.
C
                        MATCH = MATCH .AND. GFSPCAL .EQ. FSPCAL(IFS)
C
                     END IF
C
C                    Deal with a match.
C
                     IF( MATCH ) THEN
                        FSETI(ISCN,ISTA) = IFS
                     END IF
                  END DO
C
C                 Need a new set - FSETI was not set above.
C
                  IF( FSETI(ISCN,ISTA) .EQ. 0 ) THEN
                     NFSET = NFSET + 1
                     IF( NFSET .GT. MFSET ) THEN
                        CALL ERRLOG( 
     1                      'GETFSET: Too many frequency sets.')
                     END IF
                     FSETI(ISCN,ISTA) = NFSET
                     FSETKS(NFSET) = KS
                     FSETSCN(NFSET) = ISCN
                     FSPCAL(NFSET) = GFSPCAL
C
C                    Also set the pointer to the lowest numbered
C                    frequency set that has the same frequency parameters.
C                    Loop backwards so FSSAME is the smallest match.
C
                     FSSAME(NFSET) = NFSET
                     IF( NFSET .GE. 2 ) THEN
                        DO JF = NFSET - 1, 1, -1
                           IF( FSMATCH( NFSET, JF ) ) THEN
                              FSSAME(NFSET) = JF
                           END IF
                        END DO
                     END IF     
C
                  END IF
C
               END IF
            END IF
         END DO
      END DO
C
      RETURN
      END

      CHARACTER*1 FUNCTION HORCHK( KSTA, HA, AZ, EL, KSRC )
C
C     Routine for sched that checks if a source is above the
C     hardware limits and the local horizon as specified in the
C     antennas file.
C
C     Returns ' ' if the source is up.
C             'D' if it is below the hardware limits.
C             'H' if it is above the hardware limits but below the
C                   horizon mask.
C
C     Note that KSTA is the station number in the station catalog.
C     Call with STANUM(ISTA) where ISTA is the station in SCHED's
C     internal schedule.  Also KSRC is the source number in the
C     catalog.
C
      INCLUDE 'sched.inc'
C
      INTEGER   KSTA, NH, I, KSRC
      REAL      HA, AZ, EL, HEL, DEC4D, AZTEST
      REAL      AZA, AZB, ELA, ELB
      REAL      TAX1, TAX2
      CHARACTER*1  UP
C -----------------------------------------------------------------
C     Check the slew limits for the various antenna types using the
C     type specific subroutines.
C
      IF( MOUNT(KSTA) .EQ. 'ALTAZ' ) THEN
         CALL MTALTAZ( KSTA, UP, AZ, EL, TAX1, TAX2 )
      ELSE IF( MOUNT(KSTA) .EQ. 'EQUAT' ) THEN
         DEC4D = DECP(KSRC) / RADDEG
         CALL MTEQUAT( KSTA, UP, EL, HA, DEC4D, TAX1, TAX2 )
      ELSE IF( MOUNT(KSTA) .EQ. 'XYNS' ) THEN
         CALL MTXYNS( KSTA, UP, AZ, EL, TAX1, TAX2 )
      ELSE IF( MOUNT(KSTA) .EQ. 'XYEW' ) THEN
         CALL MTXYEW( KSTA, UP, AZ, EL, TAX1, TAX2 )
      ELSE
C
C        Take the opportunity to check for valid mount type since
C        this is a place that will require update if any are added.
C
         CALL ERRLOG( 'HORCHK: Invalid mount type '//MOUNT(KSTA)//
     1       ' for '//STATION(KSTA) )
      END IF
C
C     Transfer the result to HORCHK.  I'm uneasy about putting 
C     HORCHK in the calls.
C
      HORCHK = UP
C
C     Check the horizon mask it the source is otherwise up.
C
C     Note that, if NHORIZ(KSTA)=1, one of first two IF conditions
C     will apply so all cases are covered.
C
      IF( HORCHK .EQ. ' ' ) THEN
C
C        Need to check azimuth in 0-360 range.  Also rigorously
C        prevent use of uninitialized variables even though the IF's
C        should include all cases.
C
         AZTEST = MOD( AZ, 360.0 )
         IF( AZTEST .LT. 0.0 ) AZTEST = AZTEST + 360.0         
         AZA = 0.0
         AZB = 360.0
         ELA = 0.0
         ELB = 0.0
C
         NH = NHORIZ(KSTA)
         IF( NH .GT. 0 ) THEN
            IF( AZTEST .LE. HORAZ(1,KSTA) ) THEN
               AZA = HORAZ(NH,KSTA) - 360.0
               AZB = HORAZ(1,KSTA)      
               ELA = HOREL(NH,KSTA)
               ELB = HOREL(1,KSTA)
            ELSE IF( AZTEST .GT. HORAZ(NH,KSTA) ) THEN
               AZA = HORAZ(NH,KSTA)
               AZB = HORAZ(1,KSTA) + 360.0
               ELA = HOREL(NH,KSTA)
               ELB = HOREL(1,KSTA)
            ELSE IF( NH .GE. 2 ) THEN
               DO I = 2, NH
                  IF( AZTEST .LE. HORAZ(I,KSTA) ) THEN
                     AZA = HORAZ(I-1,KSTA)
                     AZB = HORAZ(I,KSTA)
                     ELA = HOREL(I-1,KSTA)
                     ELB = HOREL(I,KSTA)
                     GO TO 100
                  END IF
               END DO
  100          CONTINUE
            END IF
C
C           Now interpolate to the current horizon.
C           Don't divide by zero.
C
            IF( AZA .EQ. AZB ) THEN
               HEL = ELA
            ELSE
               HEL = ELA + ( ELB - ELA ) * (AZTEST - AZA) / (AZB - AZA )
            END IF
            IF( EL .LT. HEL ) HORCHK = 'H'
         END IF
      END IF
C
      RETURN
      END

      CHARACTER*32 FUNCTION VXNMTR( IXX ) 
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 010996 
C     returns a name for an TRACKS block definition
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER IXX, ISET, ICH, NDUMMY, NCH
      CHARACTER NAME*32, MODE*1, S2MDNM*7, CDUMMY(16)*4
      LOGICAL DUBLSB, DUALPL, S2OK
      INTEGER LEN1
C ----------------------------------------------------------------------
C
      ISET = TRISSET( IXX )
C
      NAME = ' '
C
C     no fan in's, mode depends on TAPEMODE too, but not used for name
C
      IF( .NOT. (FORMAT(ISET)(1:6) .EQ. 'VLBA1:' .OR. 
     1    FORMAT(ISET)(1:7) .EQ. 'MARKIII' .OR.
     2    FORMAT(ISET)(1:2) .EQ. 'S2' .OR.
     3    FORMAT(ISET)(1:3) .EQ. 'LBA' .OR.
     4    FORMAT(ISET)(1:6) .EQ. 'MKIV1:' .OR.
     5    FORMAT(ISET)(1:6) .EQ. 'MARK5B' .OR.
     6    FORMAT(ISET)(1:4) .EQ. 'VDIF' .OR.
     7    FORMAT(ISET)(1:4) .EQ. 'NONE' ) ) THEN
         MSGTXT = 'VXNMTR: unsupported recording mode: ' // FORMAT(ISET)
         CALL ERRLOG( MSGTXT )
      END IF
C     
      IF( FORMAT(ISET)(1:7) .EQ. 'MARKIII' ) THEN 
         DUALPL = .FALSE.
         DUBLSB = .FALSE.
         IF( NCHAN(ISET) .GT. 1 ) THEN
            DO ICH = 2, NCHAN(ISET)
               IF( NETSIDE(ICH,ISET) .NE. NETSIDE(1,ISET) ) 
     1             DUBLSB = .TRUE.
               IF( POL(ICH,ISET) .NE. POL(1,ISET) )
     1             DUALPL = .TRUE.
            END DO
            IF( DUBLSB ) THEN
               IF ( DUALPL ) THEN 
                  MODE = 'A'
               ELSE
                  MODE = 'B'
               END IF
            ELSE
               IF ( DUALPL ) THEN
                  MODE = 'C'
               ELSE
                  MODE = 'E'
               END IF
            END IF
         ELSE
            MODE = 'D'
         END IF               
         WRITE( NAME, '( A5, A1, I2.2, A )' )  
     1       'Mk3md',MODE, NCHAN(ISET),'Ch'
C
C     S2 details
C
      ELSE IF( FORMAT(ISET)(1:2) .EQ. 'S2' ) THEN
         CALL VXS2MD( ISET, S2MDNM, S2OK, NDUMMY, CDUMMY, .FALSE. )
         IF( .NOT. S2OK ) 
     1       CALL ERRLOG(' VXNMTR: inconsistent or impossible'//
     2       ' S2 mode ')
         WRITE( NAME, '( A, A )' ) 'S2.', S2MDNM(1:LEN1(S2MDNM))
C
C     FORMAT = NONE 
C
      ELSE IF( FORMAT(ISET)(1:4) .EQ. 'NONE' ) THEN
         WRITE( NAME, '( A )' ) 'TRACKS.NONE'
C
      ELSE
C
C        either MkIV or VLBA or LBA or MARK5B:
C
         IF( FORMAT(ISET) .EQ. 'MARK5B' ) THEN
            NCH = 6
         ELSE
            NCH = 4
         END IF
         IF( NCHAN(ISET) .GT. 9 ) THEN
            WRITE( NAME, '( A, A1, I2, A2, I1, A3, A3, I1 )' )  
     1          FORMAT(ISET)(1:NCH), '.', NCHAN(ISET),'Ch', 
     2          BITS(1,ISET),'bit','1to', NINT(FANOUT(ISET))
         ELSE
            WRITE( NAME, '( A, A1, I1, A2, I1, A3, A3, I1 )' )  
     1          FORMAT(ISET)(1:NCH), '.', NCHAN(ISET),'Ch', 
     2          BITS(1,ISET), 'bit','1to', NINT(FANOUT(ISET))
         ENDIF
      ENDIF
C
      VXNMTR = NAME
C
      RETURN
      END

C*UPCASE -- convert character string to upper case
C+
      SUBROUTINE UPCASE (SRC)
      CHARACTER*(*) SRC
C
C Convert character string to upper case; all lower case letters
C (a-z) are converted to upper case equivalents (A-Z); other characters
C are unchanged. This version assumes the ASCII character set.
C
C Arguments:
C  SRC    (in/out) : input string to be converted.
C
C History:
C  1987 nov 12 - TJP.
C-----------------------------------------------------------------------
      INTEGER I, K
C
      DO 10 I=1,LEN(SRC)
          K = ICHAR(SRC(I:I))
          IF (K.GE.ICHAR('a') .AND. K.LE.ICHAR('z'))
     1         SRC(I:I) = CHAR(K-32)
   10 CONTINUE
C
      END

      SUBROUTINE CHKWIDAR( KS, ERRS )
Cf2py intent(in, out) ERRS
C
C     Routine for SCHED called by CHKSET that checks items related
C     to the use of the WIDAR correlator to format Mark5 disks.
C
C     This is basically just a stub so far.
C
C     Started May 09, 2012.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER           KS !  , ICH
      LOGICAL           ERRS
C      LOGICAL           DDWARN, SBWARN
C      CHARACTER         USEDIFC(2)*2
C      DATA              DDWARN, SBWARN / .TRUE., .TRUE. /
C      SAVE              DDWARN, SBWARN
C ------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKWIDAR: Starting' )
      ERRS = .FALSE.
      RETURN
      END

      SUBROUTINE sla_DCC2S (V, A, B)
*+
*     - - - - - -
*      D C C 2 S
*     - - - - - -
*
*  Cartesian to spherical coordinates (double precision)
*
*  Given:
*     V     d(3)   x,y,z vector
*
*  Returned:
*     A,B   d      spherical coordinates in radians
*
*  The spherical coordinates are longitude (+ve anticlockwise looking
*  from the +ve latitude pole) and latitude.  The Cartesian coordinates
*  are right handed, with the x axis at zero longitude and latitude, and
*  the z axis at the +ve latitude pole.
*
*  If V is null, zero A and B are returned.  At either pole, zero A is
*  returned.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION V(3),A,B

      DOUBLE PRECISION X,Y,Z,R


      X = V(1)
      Y = V(2)
      Z = V(3)
      R = SQRT(X*X+Y*Y)

      IF (R.EQ.0D0) THEN
         A = 0D0
      ELSE
         A = ATAN2(Y,X)
      END IF

      IF (Z.EQ.0D0) THEN
         B = 0D0
      ELSE
         B = ATAN2(Z,R)
      END IF

      END

      SUBROUTINE VXWRFQ
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the FQ = $FREQ section 
C     By H.J. van Langevelde, JIVE, 300496 
C     Increased digits for channel bandwidth.  Not enough
C     for 62.5 kHz.  RCW Aug. 31, 2009.
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
C     Huib's local variables 
C      
      INTEGER   IFQ, KS, ICH, LPOS
      INTEGER   LEN1, NPER, NFC1, NFCN
      CHARACTER LINE*132, FRTXT*16
C ----------------------------------------------------------------------
C
      LINE = ' ' 
C
C     Write the FREQ section
C
      WRITE( IVEX, '( A, A1 )' ) '$FREQ', SEP     
      DO IFQ = 1, NFQVEX
         KS = FQISSET(IFQ)
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1        FQLINK(IFQ)(1:LEN1(FQLINK(IFQ))), SEP
         CALL VXSTLI( IFQ, NSTAFQ, ISTAFQ )
C     
C        first the sample rate and bits/sample
C            
         WRITE( IVEX, '( 5X, A, F9.3, A, A1, 2X, A1, A, I1, A )' ) 
     1        'sample_rate = ',SAMPRATE(KS),' Ms/sec', SEP, COM,
     2        ' (', BITS(1,KS) ,'bits/sample)'
C
C        channel definitions, find number of BBC's on the fly
C
         IF( NCHAN(KS) .NE. NVXCHN(IFQ) ) CALL ERRLOG(' VXWRFQ: '//
     1        'NCHAN in set does not match NCHAN in FQ def ')
         DO ICH = 1, NVXCHN(IFQ)
C
C           most things set through IFQ now, use KS for items fixed in Set
C
            LINE = ' '
            WRITE( LINE(6:16), '( A )' ) 'chan_def = '
C
C           must find band somewhere, is in crd file, but it is only
C           there to find right band for source catalogue; not important.
C               
            LPOS = LEN1(LINE)+1
            WRITE( LINE(LPOS:LPOS+3), '( A1, A1 )' ) 
     1          BLN, COL
C
C           next is Sky freq:
C           Make the number of digits depend on how many are needed.
C
            NPER = 7
            CALL FRCHAR( VXLOSUM(ICH,IFQ), NPER, NFC1, NFCN, FRTXT )
            IF( NFCN .GT. NPER + 6 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I3, A, I3, A, F15.8)' )
     1            ' Channel ', ICH, ' of freq set ', IFQ, 
     2            ' not an integer Hz: ', VXLOSUM(ICH,IFQ)
               CALL ERRLOG( MSGTXT )
            END IF
C
C           Now actually write the frequency.  Allow plenty of
C           room.  The next LPOS will truncate the blanks.
C
            LPOS = LEN1(LINE)+1
            WRITE( LINE(LPOS:LPOS+25), '( A, A, A )' ) 
     1             FRTXT(1:NFCN),' MHz ', COL
C
C           and sideband (net)
C
            LPOS = LEN1(LINE)+1
            WRITE( LINE(LPOS:LPOS+3), '( 1X, A1, 1X, A1 )' ) 
     1           VXNETSID(ICH,IFQ), COL
C
C           the channel width
C
            LPOS = LEN1(LINE)+1
            IF( VXBBFILT(ICH,IFQ) .GE. 1.0 ) THEN
               WRITE( LINE(LPOS:LPOS+12), '( F7.2, 1X, A3, 1X, A1 )')
     1             VXBBFILT(ICH,IFQ), 'MHz', COL
            ELSE
               WRITE( LINE(LPOS:LPOS+12), '( F7.3, 1X, A3, 1X, A1 )')
     1             VXBBFILT(ICH,IFQ) * 1000.0, 'kHz', COL
            END IF
C     
C           and channel and BBC links
C
            LPOS = LEN1(LINE)+1
            WRITE( LINE(LPOS:LPOS+16), '( 1X, A1, A2, I2.2, 1X, A1, 
     1           1X, A1, A3, I2.2, 1X, A1 )' ) LNK, 'CH', ICH, COL, 
     2           LNK, 'BBC', BBC(ICH,KS), COL
C
C           write the PH-link that is involved
C
            LPOS = LEN1(LINE)+1
            WRITE( LINE(LPOS:LPOS+7), '( 1X, A1, A5, A1 )' )
     1           LNK, TONLNK(TONCHN(ICH,IFQ),FQTOPH(IFQ)), SEP
C
C           add polarization in a comment:
C
            LPOS = LEN1(LINE)+1
            WRITE( LINE(LPOS:LPOS+5), '( 1X, A1, A1, A2 )' )
     1          COM, POL(ICH,KS)(1:1), 'cp'
C
C           It's quite a nice line, write to file
C
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
      ENDDO
C
      WRITE( IVEX, '( A )' ) COMLIN
      RETURN
      END

      SUBROUTINE BBCWIDAR( KS )
C
C     Routine called by SETBBC to set the BBC assignments for
C     the WIDAR digital backend at the VLA
C
C     This is basically a copy of BBCRDBE, which was based on
C     BBCVLBA.   Started May 9, 2012.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
      INCLUDE    'schfreq.inc'
C
      INTEGER    ICH, JCH, KS ! , MMBBC
C --------------------------------------------------------------
C
C     Use the hard wired freqeuncies.
C
      DO ICH = 1, NCHAN(KS)
         IF( BBC(ICH,KS) .EQ. 0 ) BBC(ICH,KS) = ICH
      END DO
C
C     Check for duplicates in case the user assigned some.
C
      IF( NCHAN(KS) .GE. 2 ) THEN
         DO ICH = 2, NCHAN(KS)
            DO JCH = 1, ICH -1
               IF( BBC(ICH,KS) .EQ. BBC(JCH,KS) ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( 2A )' )
     1               'BBCWIDAR:  For WIDAR, all channels must be set ',
     2               'to different BBCs.'
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, 2I5, A, I5 )' )
     1               '          Channels ', ICH, JCH, ' both use BBC ',
     2               BBC(ICH,KS)
                  CALL WLOG( 1, MSGTXT )
                  CALL ERRLOG( 'Fix BBC assignments' )
               END IF
            END DO
         END DO
      END IF
C
      RETURN
      END

      SUBROUTINE SUMSCN( PDATE )
C
C     Routine for SCHED called by SCHSUM that writes the main
C     summary information lines for all scans.  
C     Pulled out of SCHSUM 4 Feb 2003 RCW.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
C     STALINE is the number of stations to print on one line.
C
      INTEGER     STALINE
      PARAMETER   (STALINE=20)
C
      INTEGER     ISCN, ISTA, LEN1, LINE, ICH1, ICH2, IREP, JSUM, NSUM
      INTEGER     NREP, ISTA1, ISTA2, IPASS
      INTEGER     LSETNUM, NPASS, IT1, IT2, LTXT1, LTXT2
      INTEGER     YEAR, DAY1, DAY2
      DOUBLE PRECISION  START, STOP
      LOGICAL     SKIPPED, LABFLG1, LABFLG2
      CHARACTER   LINE1*160, LINE2*160
      CHARACTER   TFORM*8, SUMDAT*6
      CHARACTER   FF*1, PDATE*(*)
      CHARACTER   SUMTXT1*100, SUMTXT2*100, SUMDESC*100, EXTN*4
      CHARACTER   PRESYM*1
C-----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SUMSCN: Starting.' )
      FF = CHAR(12)
C
C     Don't allow too many stations for paper width.  NREP passes
C     will be needed for each pair of output items.
C
      NREP = ( NSTA - 1 ) / STALINE + 1
C
C     More than one complete summary can be written.  
C     What is printed is controlled by user input SUMITEM.
C     Two items from SUMITEM will be printed in each pass.
C     Figure out how many passes are going to be needed to print
C     all the summary items.  This will be NPASS.
C
      NSUM = 0
      DO JSUM = 1, 10
         IF( SUMITEM(JSUM) .NE. ' ' ) NSUM = JSUM
      END DO
      NPASS = ( NSUM - 1) / 2 + 1
C
C     Loop through the requested summary items.
C
      IF( NPASS .GE. 1 ) THEN
         DO IPASS = 1, NPASS
            IT1 = 2 * IPASS - 1
            IT2 = 2 * IPASS
            SUMTXT1 = SUMDESC( SUMITEM(IT1), LTXT1, LABFLG1 )
            SUMTXT2 = SUMDESC( SUMITEM(IT2), LTXT2, LABFLG2 )
C
C           Loop through the passes if many stations.
C
            DO IREP = 1, NREP
               LINE = 0
               ISTA1 = ( IREP - 1 ) * STALINE + 1
               ISTA2 = MIN( NSTA, IREP*STALINE )
C
C              Loop through scans.
C
               DO ISCN = SCAN1, SCANL
C
C                 Write page header if needed.
C
                  IF( LINE .GT. LINEPG ) LINE = 0
                  IF( LINE .EQ. 0 ) THEN
C
                     WRITE( ISUM, '( 1X, /, 1X, /, A1, A, A, A ) ' )
     1                 FF, ' SCAN SUMMARY for experiment ', EXPCODE, 
     1                 EXPT(1:LEN1(EXPT))
                     LINE = 2
C
                     IF( DOSCANS(1) .GT. 0 ) THEN
                        WRITE( ISUM, '( 3A )' )
     1                     '     DOSCANS specified.  ''X'' in col 1 ',
     2                     'means scan will not be in VEX and other ',
     3                     'output files.'
                     END IF
C
                     IF( GOTPREEM ) THEN
                        WRITE( ISUM, '( 3A )' )
     1                     '     Symbol after SCAN number (based ', 
     2                     'on PREEMPT): ''+'' EXTRA scan.  ',
     3                     '''-'' Do not preempt for USNO.'
                        LINE = LINE + 1
                        IF( DOSCANS(1) .EQ. 0 ) THEN
                           WRITE( ISUM, '( 3A )' ) 
     1                        '       DOSCANS not specified so the ',
     2                        '''EXTRA'' scans will not be written ',
     3                        'to the VEX, crd, and other files.'
                           LINE = LINE + 1
                        END IF
                     END IF
C
                     IF( LABFLG1 .OR. LABFLG2 ) THEN
                        WRITE( ISUM, '( 5X, A, A, A )' )
     1                     'Flags: ',
     2                     'D=>Down, H=>Below Horizon, R=>Rises, ',
     3                     'S=>Sets, W=>Slew too long, t=>Tape Chg.'
                        LINE = LINE + 1
                     END IF
C
                     WRITE( ISUM, '( 5X, A, A, / 5X, A, A )' ) 
     3                 'Top item is:    ', SUMTXT1(1:LTXT1),
     4                 'Bottom item is: ', SUMTXT2(1:LTXT2)
                     LINE = LINE + 2
C
C                    "Type" entry.
C                    
                     WRITE( ISUM, '( 5X, 3A )' ) 
     1                      'TYPE top: -=> normal scan, ',
     2                      'P=>Pointing or Ta;  ',
     3                      'bottom: -=>recording, N=>not recording.'
C
                     WRITE( ISUM, '( 5X, A )' ) PDATE
                     LINE = LINE + 3
                     WRITE( ISUM, '( 2X )' )
C
                     LINE1 = 'SCAN  DAY START UT  SOURCE     TYPE  '//
     1                       'STATIONS    t => tape change '
                     LINE2 = '           STOP UT'
                     DO ISTA = ISTA1, ISTA2 
                        ICH1 = 39 + 6 * ( ISTA - ISTA1 )
                        ICH2 = ICH1 + 2
                        LINE2(ICH1:ICH2) = STCODE(STANUM(ISTA))
                     END DO
C
                     WRITE( ISUM, '( A, /, A /, 2X )' ) 
     1                  LINE1(1:LEN1(LINE1)),
     2                  LINE2(1:LEN1(LINE2))
C
C                    Clear the variables (needed for small experiments).
C
                     LINE1 = ' '
                     LINE2 = ' '
C
C                    Force setup name for first scan of page.
C
                     LSETNUM = 0
C
                  END IF
C
C                 Get the symbol based on PREEMPT.
C 
                  IF( PREEMPT(ISCN) .EQ. 'EXTRA' ) THEN
                     PRESYM = '+'
                  ELSE IF( PREEMPT(ISCN) .EQ. 'NO' ) THEN
                     PRESYM = '-'
                  ELSE
                     PRESYM = ' '
                  END IF
C
C                 Write any comments that the user might have given.
C
                  IF( ANNOT(ISCN) .NE. ' ' ) THEN
                     WRITE ( ISUM, '( '' ---------- '',A, ' //
     1                  ' '' ----------'', /, A )' )
     1                  ANNOT(ISCN)(1:MAX(1,LEN1(ANNOT(ISCN)))), ' '
      		     LINE = LINE + 2
                  END IF
C
C                 If the scan was skipped, detect and note that fact.
C
                  SKIPPED = .TRUE.
                  DO ISTA = 1, NSTA
                     IF( STASCN(ISCN,ISTA) ) SKIPPED = .FALSE.
                  END DO
                  IF( SKIPPED .AND. NSTA .GT. 1 ) THEN
                     WRITE( ISUM, '( I4, 3A )' ) ISCN, PRESYM, 
     1                     '  Skipping scan on ',
     2                     SCNSRC(ISCN)(1:LEN1(SCNSRC(ISCN)))
                     LINE = LINE + 1
                  ELSE IF( SKIPPED .AND. NSTA .EQ. 1 ) THEN
                     WRITE( ISUM, '( I4, 4A, F8.2 )' ) ISCN, PRESYM,
     1                     '  Skipping scan on ',
     2                     SCNSRC(ISCN)(1:LEN1(SCNSRC(ISCN))),
     3                     '  at El=', EL1(ISCN,1)
                     LINE = LINE + 1
                  ELSE
C  
C                    Now process a good scan.
C                    Get scan times.
C
                     CALL TIMEJ( STARTJ(ISCN), YEAR, DAY1, START )
                     CALL TIMEJ( STOPJ(ISCN), YEAR, DAY2, STOP )
                     WRITE( LINE1(1:9), '( I4, A, I4 )' ) 
     1                    ISCN, PRESYM, DAY1
                     WRITE( LINE2(1:9), '( A4, I5 )' ) 
     1                    SCANTAG(ISCN), DAY2
                     LINE1(11:18) = TFORM( START, 'T', 0, 2, 2, '::@' )
                     LINE2(11:18) = TFORM( STOP, 'T', 0, 2, 2, '::@' )
                     LINE1(20:31) = SCNSRC(ISCN)
C
C                    Write setup name under source when it changes or at
C                    first scan of page.  Don't write the .set.
C
                     IF( SETNUM(ISCN) .NE. LSETNUM ) THEN
                        ICH1 = 1
                        ICH2 = LEN1(SETFILE(SETNUM(ISCN)))
                        IF( ICH2 .GE. 12 ) THEN
                           EXTN = SETFILE(SETNUM(ISCN))(ICH2-3:ICH2)
                           IF( EXTN .EQ. '.set' .OR. 
     1                         EXTN .EQ. '.SET' ) ICH2 = ICH2 - 4
                           ICH1 = ICH2 - 11
                           IF( ICH1 .LT. 1 ) ICH1 = 1
                        END IF
                        LINE2(20:31) = SETFILE(SETNUM(ISCN))(ICH1:ICH2)
                     ELSE
                        LINE2(20:31) = '-'
                     END IF
                     LSETNUM = SETNUM(ISCN)
C
C                    Get type and record/no record.
C
                     IF( POINT(ISCN) .GE. 0 .OR. PNTVLBA(ISCN) .OR. 
     1                   TANVLBA(ISCN) .OR. DOPEAK(ISCN) .GT. 0 .OR.
     2                   DOPN3DB(ISCN) .OR.
     3                   VLAMODE(ISCN) .EQ. 'IR' ) THEN
                        LINE1(34:34) = 'P'
                     ELSE
                        LINE1(34:34) = '-'
                     END IF
                     IF( NOREC(ISCN) .OR. .NOT. VLBITP ) THEN
                        LINE2(34:34) = 'N'
                     ELSE
                        LINE2(34:34) = '-'
                     END IF
C
C                    Get the scan data.  
C
                     DO ISTA = ISTA1, ISTA2
                        ICH1 = 36 + 6 * ( ISTA - ISTA1 )
                        ICH2 = ICH1 + 5
C
                        LINE1(ICH1:ICH2) = 
     1                        SUMDAT( SUMITEM(IT1), ISCN, ISTA )
                        LINE2(ICH1:ICH2) = 
     1                        SUMDAT( SUMITEM(IT2), ISCN, ISTA )
                     END DO
C
C                    Write scan information with the indicator
C                    derived from DOSCANS.
C
                     IF( DOSCANS(1) .EQ. 0 .OR. 
     1                   ( ISCN .GE. DOSCANS(1) .AND. 
     2                   ISCN .LE. DOSCANS(2) ) ) THEN
                        WRITE( ISUM, '( A, /, A )' ) 
     1                        LINE1(1:LEN1(LINE1)),
     2                        LINE2(1:LEN1(LINE2))
                     ELSE
                        WRITE( ISUM, '( A A, /, A, A )' ) 
     1                        'X ', LINE1(1:LEN1(LINE1)),
     2                        'X ', LINE2(1:LEN1(LINE2))
                     END IF
                     LINE = LINE + 2
C
C                    Write sun warning if needed.
C
                     IF( SUMITEM(IT1)(1:4) .NE. 'TAPE' ) THEN
                        CALL SUNWARN( ISCN, 10.0, LINE, ISUM )
                     END IF 
C
                  END IF
C
C                 Write blank line after scan.
C
                  WRITE( ISUM, '( 1X )' )
                  LINE = LINE + 1
C
               END DO
            END DO
         END DO
      END IF
C
C     Finished
C
      RETURN
      END

      SUBROUTINE SUNWARN( ISCN, DLIM, LINE, IUNIT )
C
C     Routine for SCHED that writes a warning in the operator schedule
C     or the summary file when a source is closer than DLIM to the
C     sun.  GETSUN must have been run earlier to have calculated
C     the sun distance SUNDIS which is in SCHED.INC.
C
C     LINE is the line counter for the print routines.
C
      INCLUDE 'sched.inc'
C
      INTEGER   ISCN, IUNIT, LINE
      REAL      DLIM
C --------------------------------------------------------------------
C     Check the target source.
C
      IF( SUNDIS(SRCNUM(ISCN)) .LT. DLIM ) THEN
         WRITE( IUNIT, '( A, F6.1, A )' ) 
     1      '        Source only ', SUNDIS(SRCNUM(ISCN)),
     2      ' degrees from the Sun.'
         LINE = LINE + 1
      END IF
C
C     Now check the VLA phasing source.  
C
      IF( IVLAPHS(ISCN) .NE. 0 .AND. IVLAPHS(ISCN) .NE. SRCNUM(ISCN) )
     1     THEN
         IF( SUNDIS(IVLAPHS(ISCN)) .LT. DLIM ) THEN
            WRITE( IUNIT, '( A, F6.1, A )' ) 
     1      '        VLA phasing source only ', SUNDIS(IVLAPHS(ISCN)),
     2      ' degrees from the Sun.'
            LINE = LINE + 1
         END IF
      END IF
C
C     The dop source doesn't matter.
C
      RETURN
      END

      SUBROUTINE SCHGEO( ISCN, ISTA, JTIME, HA, EL, AZ, LSTTIM, PA )
Cf2py intent(in) ISCN, ISTA, JTIME
Cf2py intent(out) HA, EL, AZ, LSTTIM, PA
C
C     Subroutine to calculate HA, EL, AZ, and LST from
C     Modified Julian time (JTIME), RA, DEC, LONG, and LAT.
C     Also gets paralactic angle for altaz antenna (PA)
C
C     The PA equations for XY mounts are from Sovers, Fanselow, and 
C     Jacobs.  The equat version agrees with that reference too.
C
C     Note that some approximations are made that make this routine
C     inappropriate for accurate work.  First SLA_GMST delivers the
C     Greenwich mean sidereal time when what is really wanted is the
C     Greenwich apparent sidereal time.  The difference is typically
C     under a second.  Refraction is not taken into account which 
C     might affect when something actually goes behind a mountain.
C
C     Oct. 9, 2010.  For planets and satellites, get the current 
C     scan/station position.  RCW.
C
C     This routine does not modify any of the scan data from the
C     COMMONs in the include file, so it can be used to calculate
C     hypothetical cases without corrupting scan calculations that
C     were made before.  WRAP will do that.
C
      INCLUDE 'sched.inc' 
C
      INTEGER          ISCN, ISRC, ISTA, KSTA
      REAL             HA, ZA, EL, AZ, PA
      REAL             PDRA, PDDEC
      DOUBLE PRECISION JTIME, LSTTIM
      DOUBLE PRECISION GAST, CD, SD, SL, CL, CH, SH, SLA_GMST
      DOUBLE PRECISION PRA, PDEC, PPMTIME, DATERA, DATEDEC
C --------------------------------------------------------------------
      IF( ISCN .EQ. 0 ) CALL ERRLOG( 'SCHGEO called for scan 0.' //
     1    '  Programming problem.' )
      IF( ISTA .EQ. 0 ) CALL ERRLOG( 'SCHGEO called for station 0.' //
     1    '  Programming problem.' )
C
C     Get the source position to use.  For moving sources, this can 
C     be station and scan dependent.  Note that SRCLOC returns
C     J2000 coordinates where the geometry calculation needs to be
C     based on coordinates of date.  Use the same precession as in
C     SCHPRE which is for the first stop time.
C     Bypass these calls if the source is not moving because they are
C     a bit slow, causing problems for some optimization routines.
C
      ISRC = SRCNUM(ISCN)
      IF( PLANET(ISRC) .OR. SATEL(ISRC) .OR. 
     1      DRA(ISRC) .NE. 0.0 .OR. DDEC(ISRC) .NE. 0.0 ) THEN
         CALL SRCLOC( ISCN, ISTA, PRA, PDEC, PPMTIME, PDRA, PDDEC )
         CALL SLA_MAP( PRA, PDEC, 0.D0, 0.D0, 0.D0, 0.D0, 2000.D0, 
     1              STOPJ(1), DATERA, DATEDEC )
      ELSE
         DATERA = RAP(ISRC)
         DATEDEC = DECP(ISRC)
      END IF
C
C     Now get the geometry.
C
      GAST = SLA_GMST( JTIME )
      HA = MOD(  GAST - DATERA - LONG(STANUM(ISTA)), TWOPI )
      LSTTIM = MOD( GAST - LONG(STANUM(ISTA)), TWOPI )
      IF( LSTTIM. LT. 0.D0 ) LSTTIM = LSTTIM + TWOPI
      CD = COS(DATEDEC)
      SD = SIN(DATEDEC)
      CL = COS(LAT(STANUM(ISTA)))
      SL = SIN(LAT(STANUM(ISTA)))
      CH = COS(HA)
      SH = SIN(HA)
      HA = HA / RADHR
      IF( HA.LE.-12.0 ) HA = HA + 24.0
      IF( HA.GT. 12.0 ) HA = HA - 24.0
      ZA = ACOS(CD*CL*CH + SD*SL) / RADDEG
      EL = 90.0 - ZA
      AZ = ATAN2(SD*CL - CD*SL*CH, CD*SH) / RADDEG
      AZ = AMOD( AZ - 90.0, 360.0 )
      IF( AZ .LT. 0.0 ) AZ = AZ + 360.0
C
C     Get paralactic angle depending on mount type.
C
      KSTA = STANUM(ISTA)
      IF( MOUNT(KSTA) .EQ. 'ALTAZ' ) THEN
         PA = ATAN2( CL*SH, SL*CD - CL*SD*CH ) / RADDEG
      ELSE IF( MOUNT(KSTA) .EQ. 'EQUAT' ) THEN
         PA = 0.0
      ELSE IF( MOUNT(KSTA) .EQ. 'XYNS' ) THEN
         PA = ATAN2( -1.*SL*SH, CL*CD + SL*SD*CH ) / RADDEG
      ELSE IF( MOUNT(KSTA) .EQ. 'XYEW' ) THEN
         PA = ATAN2( CH, SD*SH ) / RADDEG
      ELSE
         WRITE( MSGTXT, '( A, A, A, A )' ) 
     1      'SCHGEO: Unknown mount type ', MOUNT(KSTA), ' at ',
     2      STATION(KSTA)
         CALL ERRLOG( MSGTXT )
      END IF
C
      RETURN
      END

      SUBROUTINE PLFFT( A, B, NTOT, N, NSPAN, ISN )
C
C     Multivariate Complex Fourier Transform, computed in place
C     using mixed-radix Fast Fourier Transform algorithm.
C     By R. C. SINGLETON, Stanford Research Institute, Oct. 1968.
C
C     Arrays A and B originally hold the real and imaginary
C     components of the data, and return the real and
C     imaginary components of the resulting fourier coefficients.
C
C     Multivariate data is indexed according to the fortran
C     array element successor function, without limit
C     on the number of implied multiple subscripts.
C     The subroutine is called once for each variate.
C     The calls for a multivariate transform may be in any order.
C
C     NTOT is the total number of complex data values.
C
C     N is the dimension of the current variable.
C
C     NSPAN/N is the spacing of consecutive values while indexing
C     the current variable.
C
C     The sign of ISN determines the sign of the complex
C     exponential, and the magnitude of ISN is normally one.
C
C     A tri-variate transform with A(N1,N2,N3), B(N1,N2,N3)
C     is computed by
C       CALL FFT(A,B,N1*N2*N3,N1,N1,1)
C       CALL FFT(A,B,N1*N2*N3,N2,N1*N2,1)
C       CALL FFT(A,B,N1*N2*N3,N3,N1*N2*N3,1)
C
C     For a single-variate transform,
C     NTOT = N = NSPAN = (number of complex data values), F.G.
C       CALL FFT(A,B,N,N,N,1)
C
C     The data may alternatively be stored in a single complex
C     array A, then the magnitude of ISN is changed to two to
C     give the correct indexing increment and A(2) is used to
C     pass the initial address for the sequence of imaginary
C     values, E.G.
C       CALL FFT(A,A(2),NTOT,N,NSPAN,2)
C
C     Arrays AT(MAXF), CK(MAXF), BT(MAXF), SK(MAXF), and NP(MAXP)
C     are used for temporary storage.  If the available storage
C     is insufficient, the program is terminated by a stop.
C     MAXF must be .GE. the maximum prime factor of N.
C     MAXP must be .GT. the number of prime factors of N.
C     In addition, if the square-free portion K of N has two or
C     more prime factors, then MAXP must be .GE. K-1.
C
C     Array storage in NFAC for a maximum of 11 factors of N.
C     If N has more than one square-free factor, the product of the
C     square-free factors must be .LE. 210
C
C     Array storage for maximum prime factor of 23
C
C     PLFFT is an alias of subroutine FFT that is part of
C     the program "INVERT" ( AUG. 23,1982 )
C
      INCLUDE 'beam.inc'
C
      INTEGER           NTOT, N, NSPAN, ISN
      INTEGER           I, M, K, J, JJ, II, NP, NT, NN, JC, JF, KS
      INTEGER           KT, KK, K1, K2, K3, K4
      INTEGER           INC, NFAC, MAXF, MAXP, KSPAN, KSPNN
      DOUBLE PRECISION  A, B
      DOUBLE PRECISION  AT, CK, BT, SK, AA, AJ, AK, BB, BJ, BK
      DOUBLE PRECISION  CD, C1, C2, C3, SD, S1, S2, S3, AKP, AKM
      DOUBLE PRECISION  AJP, AJM, BKP, BKM, BJP, BJM, RAD, RADF
      DOUBLE PRECISION  S72, C72, S120
      DIMENSION         A(KXSIZE*4), B(KXSIZE*4-1)
      DIMENSION         NFAC(11), NP(209)
      DIMENSION         AT(23), CK(23), BT(23), SK(23)
      EQUIVALENCE       (I, II)
C -------------------------------------------------------------------
C
C     The following two constants should agree with the array
C     dimensions.
C
      MAXF = 23
      MAXP = 209
      IF( N .LT. 2 ) RETURN
C
      INC  = ISN
      RAD  = 8.0 * ATAN( 1.0 )
      S72  = RAD / 5.0
      C72  = COS( S72 )
      S72  = SIN( S72 )
      S120 = SQRT( 0.75 )
C
      IF( ISN .LT. 0 ) THEN
         S72  = -S72
         S120 = -S120
         RAD  = -RAD
         INC  = -INC
      END IF
C
      NT    = INC * NTOT
      KS    = INC * NSPAN
      KSPAN = KS
      NN    = NT - INC
      JC    = KS / N
      RADF  = RAD * FLOAT( JC ) * 0.5
      I     = 0
      JF    = 0
C
C     Determine the factors of N
C
      M = 0
      K = N
      GOTO 20
C
 15   M       = M + 1
      NFAC(M) = 4
      K       = K / 16
C
 20   IF( K - ( K / 16 ) * 16 .EQ. 0 ) GOTO 15
      J  = 3
      JJ = 9
      GOTO 30
C
 25   M       = M + 1
      NFAC(M) = J
      K       = K / JJ
C
 30   IF( MOD( K, JJ ) .EQ. 0 ) GOTO 25
      J  = J + 2
      JJ = J**2
      IF( JJ .LE. K ) GOTO 30
      IF( K  .GT. 4 ) GOTO 40
      KT        = M
      NFAC(M+1) = K
      IF( K .NE. 1 ) M = M + 1
      GOTO 80
C
 40   IF( K - ( K / 4 ) * 4 .NE. 0 ) GOTO 50
      M       = M + 1
      NFAC(M) = 2
      K       = K / 4
C
 50   KT = M
      J  = 2
C
 60   IF( MOD( K, J ) .NE. 0 ) GOTO 70
      M=M+1
      NFAC(M)=J
      K=K/J
   70 J=((J+1)/2)*2+1
      IF(J .LE. K) GO TO 60
   80 IF(KT .EQ. 0) GO TO 100
      J=KT
   90 M=M+1
      NFAC(M)=NFAC(J)
      J=J-1
      IF(J .NE. 0) GO TO 90
C
C     Compute Fourier Transform
C
  100 SD=RADF/FLOAT(KSPAN)
      CD=2.0*SIN(SD)**2
      SD=SIN(SD+SD)
      KK=1
      I=I+1
      IF(NFAC(I) .NE. 2) GO TO 400
C
C     Transform for factor of 2 (including rotation factor)
C
      KSPAN=KSPAN/2
      K1=KSPAN+2
  210 K2=KK+KSPAN
      AK=A(K2)
      BK=B(K2)
      A(K2)=A(KK)-AK
      B(K2)=B(KK)-BK
      A(KK)=A(KK)+AK
      B(KK)=B(KK)+BK
      KK=K2+KSPAN
      IF(KK .LE. NN) GO TO 210
      KK=KK-NN
      IF(KK .LE. JC) GO TO 210
      IF(KK .GT.KSPAN) GO TO 800
  220 C1=1.0-CD
      S1=SD
  230 K2=KK+KSPAN
      AK=A(KK)-A(K2)
      BK=B(KK)-B(K2)
      A(KK)=A(KK)+A(K2)
      B(KK)=B(KK)+B(K2)
      A(K2)=C1*AK-S1*BK
      B(K2)=S1*AK+C1*BK
      KK=K2+KSPAN
      IF(KK .LT. NT) GO TO 230
      K2=KK-NT
      C1=-C1
      KK=K1-K2
      IF(KK .GT. K2) GO TO 230
      AK=C1-(CD*C1+SD*S1)
      S1=(SD*C1-CD*S1)+S1
C
C     The following three statements compensate for truncation
C     error.  If rounded arithmetic is used, substitute
C     C1=AK
C
C      C1=0.5/(AK**2+S1**2)+0.5
C      S1=C1*S1
C      C1=C1*AK
      C1=AK
C
      KK=KK+JC
      IF(KK .LT. K2) GO TO 230
      K1=K1+INC+INC
      KK=(K1-KSPAN)/2+JC
      IF(KK .LE. JC+JC) GO TO 220
      GO TO 100
C
C     Transform for factor of 3 (optional code)
C
  320 K1=KK+KSPAN
      K2=K1+KSPAN
      AK=A(KK)
      BK=B(KK)
      AJ=A(K1)+A(K2)
      BJ=B(K1)+B(K2)
      A(KK)=AK+AJ
      B(KK)=BK+BJ
      AK=-0.5*AJ+AK
      BK=-0.5*BJ+BK
      AJ=(A(K1)-A(K2))*S120
      BJ=(B(K1)-B(K2))*S120
      A(K1)=AK-BJ
      B(K1)=BK+AJ
      A(K2)=AK+BJ
      B(K2)=BK-AJ
      KK=K2+KSPAN
      IF(KK .LT. NN) GO TO 320
      KK=KK-NN
      IF(KK .LE. KSPAN) GO TO 320
      GO TO 700
C
C     Transform for factor of 4
C
  400 IF(NFAC(I) .NE. 4) GO TO 600
      KSPNN=KSPAN
      KSPAN=KSPAN/4
  410 C1=1.0
      S1=0
  420 K1=KK+KSPAN
      K2=K1+KSPAN
      K3=K2+KSPAN
      AKP=A(KK)+A(K2)
      AKM=A(KK)-A(K2)
      AJP=A(K1)+A(K3)
      AJM=A(K1)-A(K3)
      A(KK)=AKP+AJP
      AJP=AKP-AJP
      BKP=B(KK)+B(K2)
      BKM=B(KK)-B(K2)
      BJP=B(K1)+B(K3)
      BJM=B(K1)-B(K3)
      B(KK)=BKP+BJP
      BJP=BKP-BJP
      IF(ISN.LT.0) GO TO 450
      AKP=AKM-BJM
      BKP=BKM+AJM
      BKM=BKM-AJM
      IF(S1.EQ.0.0) GO TO 460
  430 A(K1)=AKP*C1-BKP*S1
      B(K1)=AKP*S1+BKP*C1
      A(K2)=AJP*C2-BJP*S2
      B(K2)=AJP*S2+BJP*C2
      A(K3)=AKM*C3-BKM*S3
      B(K3)=AKM*S3+BKM*C3
      KK=K3+KSPAN
      IF(KK.LE.NT) GO TO 420
  440 C2=C1-(CD*C1+SD*S1)
      S1=(SD*C1-CD*S1)+S1
C
C     The following three statements compensate for truncation
C     error. If rounded arithmetic is used, substitute
C     C1=C2
C
C      C1=0.5/(C2**2+S1**2)+0.5
C      S1=C1*S1
C      C1=C1*C2
      C1=C2
C
      C2=C1**2-S1**2
      S2=2.0*C1*S1
      C3=C2*C1-S2*S1
      S3=C2*S1+S2*C1
      KK=KK-NT+JC
      IF(KK.LE.KSPAN) GO TO 420
      KK=KK-KSPAN+INC
      IF(KK.LE.JC) GO TO 410
      IF(KSPAN.EQ.JC) GO TO 800
      GO TO 100
  450 AKP=AKM+BJM
      AKM=AKM-BJM
      BKP=BKM-AJM
      BKM=BKM+AJM
      IF(S1.NE.0.0) GO TO 430
  460 A(K1)=AKP
      B(K1)=BKP
      A(K2)=AJP
      B(K2)=BJP
      A(K3)=AKM
      B(K3)=BKM
      KK=K3+KSPAN
      IF(KK.LE.NT) GO TO 420
      GO TO 440
C
C     Transform for factor of 5 (optional code)
C
  510 C2=C72**2-S72**2
      S2=2.0*C72*S72
  520 K1=KK+KSPAN
      K2=K1+KSPAN
      K3=K2+KSPAN
      K4=K3+KSPAN
      AKP=A(K1)+A(K4)
      AKM=A(K1)-A(K4)
      BKP=B(K1)+B(K4)
      BKM=B(K1)-B(K4)
      AJP=A(K2)+A(K3)
      AJM=A(K2)-A(K3)
      BJP=B(K2)+B(K3)
      BJM=B(K2)-B(K3)
      AA=A(KK)
      BB=B(KK)
      A(KK)=AA+AKP+AJP
      B(KK)=BB+BKP+BJP
      AK=AKP*C72+AJP*C2+AA
      BK=BKP*C72+BJP*C2+BB
      AJ=AKM*S72+AJM*S2
      BJ=BKM*S72+BJM*S2
      A(K1)=AK-BJ
      A(K4)=AK+BJ
      B(K1)=BK+AJ
      B(K4)=BK-AJ
      AK=AKP*C2+AJP*C72+AA
      BK=BKP*C2+BJP*C72+BB
      AJ=AKM*S2-AJM*S72
      BJ=BKM*S2-BJM*S72
      A(K2)=AK-BJ
      A(K3) = AK+BJ
      B(K2)=BK+AJ
      B(K3)=BK-AJ
      KK = K4+KSPAN
      IF(KK.LT.NN) GO TO 520
      KK=KK-NN
      IF(KK.LE.KSPAN) GO TO 520
      GO TO 700
C
C     Transform for odd factors
C
  600 K=NFAC(I)
      KSPNN=KSPAN
      KSPAN=KSPAN/K
      IF(K.EQ.3) GOTO 320
      IF(K.EQ.5) GOTO 510
      IF(K.EQ.JF) GOTO 640
      JF = K
      S1=RAD/FLOAT(K)
      C1=COS(S1)
      S1=SIN(S1)
C
C     Check for Insufficient Array Storage
C
      IF( JF .GT. MAXF ) THEN
         ISN = 0
         RETURN
      END IF
C
      CK(JF)=1.0
      SK(JF)=0.0
      J=1
  630 CK(J)=CK(K)*C1+SK(K)*S1
      SK(J)=CK(K)*S1-SK(K)*C1
      K=K-1
      CK(K)=CK(J)
      SK(K)=-SK(J)
      J = J + 1
      IF(J.LT.K) GOTO 630
  640 K1=KK
      K2=KK+KSPNN
      AA=A(KK)
      BB=B(KK)
      AK=AA
      BK=BB
      J=1
      K1=K1+KSPAN
  650 K2=K2-KSPAN
      J=J+1
      AT(J)=A(K1)+A(K2)
      AK=AT(J)+AK
      BT(J)=B(K1)+B(K2)
      BK=BT(J)+BK
      J=J+1
      AT(J)=A(K1)-A(K2)
      BT(J)=B(K1)-B(K2)
      K1=K1+KSPAN
      IF(K1.LT.K2) GOTO 650
      A(KK)=AK
      B(KK)=BK
      K1=KK
      K2=KK+KSPNN
      J=1
  660 K1=K1+KSPAN
      K2=K2-KSPAN
      JJ=J
      AK=AA
      BK=BB
      AJ=0.0
      BJ=0.0
      K=1
  670 K = K+1
      AK=AT(K)*CK(JJ)+AK
      BK=BT(K)*CK(JJ)+BK
      K=K+1
      AJ=AT(K)*SK(JJ)+AJ
      BJ=BT(K)*SK(JJ)+BJ
      JJ=JJ+J
      IF(JJ.GT.JF) JJ=JJ-JF
      IF(K.LT.JF) GOTO 670
      K=JF-J
      A(K1)=AK-BJ
      B(K1)=BK+AJ
      A(K2)=AK+BJ
      B(K2)=BK-AJ
      J=J+1
      IF(J.LT. K) GOTO 660
      KK=KK+KSPNN
      IF(KK.LE.NN) GOTO 640
      KK=KK-NN
      IF(KK.LE.KSPAN) GOTO 640
C
C     Multiply by rotation factor (except for factors of 2 and 4)
C
  700 IF(I.EQ.M) GOTO 800
      KK=JC+1
  710 C2=1.0-CD
      S1=SD
  720 C1=C2
      S2=S1
      KK=KK+KSPAN
  730 AK=A(KK)
      A(KK)=C2*AK-S2*B(KK)
      B(KK)=S2*AK+C2*B(KK)
      KK=KK+KSPNN
      IF(KK.LE.NT) GOTO 730
      AK=S1*S2
      S2=S1*C2+C1*S2
      C2=C1*C2-AK
      KK=KK-NT+KSPAN
      IF(KK.LE.KSPNN) GOTO 730
      C2=C1-(CD*C1+SD*S1)
      S1=S1+(SD*C1-CD*S1)
C
C    the following three statements compensate for truncation
C    error. If rounded arithmetic is used, they may
C    be deleted.
C
C      C1=0.5/(C2**2+S1**2)+0.5
C      S1=C1*S1
C      C2=C1*C2
      KK=KK-KSPNN+JC
      IF(KK.LE.KSPAN) GOTO 720
      KK=KK-KSPAN+JC+INC
      IF(KK.LE.JC+JC) GOTO 710
      GOTO 100
C
C     Permute the results to normal order---done in two stages
C     permutation for square factors of N
C
  800 NP(1)=KS
      IF (KT.EQ. 0) GOTO 890
      K=KT+KT+1
      IF(M.LT.K) K=K-1
      J=1
      NP(K+1)=JC
  810 NP(J+1)=NP(J)/NFAC(J)
      NP(K)=NP(K+1)*NFAC(J)
      J=J+1
      K=K-1
      IF(J.LT.K) GOTO 810
      K3=NP(K+1)
      KSPAN=NP(2)
      KK=JC+1
      K2=KSPAN+1
      J=1
      IF(N.NE.NTOT) GOTO 850
C
C     Permutation for single-variate transform (optional code)
C
  820 AK=A(KK)
      A(KK)=A(K2)
      A(K2)=AK
      BK=B(KK)
      B(KK)=B(K2)
      B(K2)=BK
      KK=KK+INC
      K2=KSPAN+K2
      IF(K2.LT.KS) GOTO 820
  830 K2=K2-NP(J)
      J=J+1
      K2=NP(J+1)+K2
      IF(K2.GT.NP(J)) GOTO 830
      J=1
  840 IF(KK.LT.K2) GOTO 820
      KK=KK+INC
      K2=KSPAN+K2
      IF(K2.LT.KS ) GOTO 840
      IF(KK .LT. KS) GOTO 830
      JC = K3
      GOTO 890
C
C     Permutation for multi-variate transform
C
  850 K=KK+JC
  860 AK=A(KK)
      A(KK)=A(K2)
      A(K2)=AK
      BK=B(KK)
      B(KK)=B(K2)
      B(K2)=BK
      KK=KK+INC
      K2=K2+INC
      IF(KK.LT.K) GOTO 860
      KK=KK+KS-JC
      K2=K2+KS-JC
      IF(KK.LT.NT) GOTO 850
      K2=K2-NT+KSPAN
      KK=KK-NT+JC
      IF(K2.LT.KS) GOTO 850
  870 K2=K2-NP(J)
      J=J+1
      K2=NP(J+1)+K2
      IF(K2.GT.NP(J)) GOTO 870
      J=1
  880 IF(KK.LT.K2) GOTO 850
      KK=KK+JC
      K2=KSPAN+K2
      IF(K2.LT.KS) GOTO 880
      IF(KK.LT.KS) GOTO 870
      JC=K3
  890 IF(2*KT+1 .GE. M) RETURN
      KSPNN=NP(KT+1)
C
C     Permutation for square-free factors of N
C
      J=M-KT
      NFAC(J+1)=1
  900 NFAC(J)=NFAC(J)*NFAC(J+1)
      J=J-1
      IF(J.NE.KT) GOTO 900
      KT=KT+1
      NN=NFAC(KT)-1
C
C     Check for Insufficient Array Storage
C
      IF( NN .GT. MAXP ) THEN
         ISN = 0
         RETURN
      END IF
C
      CK(JF)=1.0
      JJ=0
      J=0
      GOTO 906
  902 JJ=JJ-K2
      K2=KK
      K=K+1
      KK=NFAC(K)
  904 JJ=KK+JJ
      IF(JJ.GE.K2) GOTO 902
      NP(J) = JJ
  906 K2=NFAC(KT)
      K=KT+1
      KK=NFAC(K)
      J=J+1
      IF(J.LE.NN) GOTO 904
C
C     Determine the permutation cycles of length greater than 1
C
      J=0
      GOTO 914
  910 K=KK
      KK=NP(K)
      NP(K)=-KK
      IF(KK.NE.J) GOTO 910
      K3=KK
  914 J=J+1
      KK=NP(J)
      IF(KK.LT.0) GOTO 914
      IF(KK.NE.J) GOTO 910
      NP(J)=-J
      IF(J.NE.NN) GOTO 914
      MAXF=INC*MAXF
C
C     Reorder A and B, following the permutation cycles
C
      GO TO 950
  924 J=J-1
      IF(NP(J) .LT. 0) GO TO 924
      JJ=JC
  926 KSPAN=JJ
      IF(JJ .GT. MAXF) KSPAN=MAXF
      JJ=JJ-KSPAN
      K=NP(J)
      KK=JC*K+II+JJ
      K1=KK+KSPAN
      K2=0
  928 K2=K2+1
      AT(K2)=A(K1)
      BT(K2)=B(K1)
      K1=K1-INC
      IF(K1 .NE. KK) GO TO 928
  932 K1=KK+KSPAN
      K2=K1-JC*(K+NP(K))
      K=-NP(K)
  936 A(K1)=A(K2)
      B(K1)=B(K2)
      K1=K1-INC
      K2=K2-INC
      IF(K1 .NE. KK) GO TO 936
      KK=K2
      IF(K .NE. J) GO TO 932
      K1=KK+KSPAN
      K2=0
  940 K2=K2+1
      A(K1)=AT(K2)
      B(K1)=BT(K2)
      K1=K1-INC
      IF(K1 .NE. KK) GO TO 940
      IF(JJ .NE. 0) GO TO 926
      IF(J .NE. 1) GO TO 924
  950 J=K3+1
      NT=NT-KSPNN
      II=NT-INC+1
      IF(NT .GE. 0) GO TO 924
      RETURN
      END

      SUBROUTINE SETDEFS
C
C     Routine for SCHED, called by DEFSET, which in turn is called
C     by DEFAULTS.  At this point, all setup files have been read.
C     This routine sets many setup file defaults.  Much use
C     is made of information from the station and frequency catalogs. 
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
      INCLUDE   'schfreq.inc'
C
      INTEGER    KS, ISETF, ICH
      LOGICAL    NEEDCAT(MSET)
C ---------------------------------------------------------------------
      IF( SDEBUG ) CALL WLOG( 0, 'SETDEFS: Starting' )
C
C     Now begin the real work.  First set the global parameters
C     that are station independent and should match across stations.  
C     But for the moment, don't attempt to check that they do match.
C     Some checking is done in CHKSFIL.
C     These are: 
C     FREQREF   LO sum for channel.
C     BBFILT    Bandwidth for channel
C     SAMPRATE  Sample rate for channel
C     NCHAN     Number of baseband channels
C     BITS      Bits per sample
C     POL       Polarazition of each channel
C     NETSIDE   Net sideband of each channel
C     SPEEDUP   Processing speedup factor.
C
C     Set the contents of the baseband channels.
C
C     First determine the resources available and requested.
C
C     Determine the minimum number of BBC's available at the 
C     stations that use each setup file (MINBBC).  Also get
C     the maximum number of channels requested for each setup file.
C
      DO ISETF = 1, NSETF
         MSCHN(ISETF)  = 0
         MINBBC(ISETF) = 99
      END DO
      DO KS = 1, NSET
         ISETF = ISETNUM(KS)
         MSCHN(ISETF) = MAX( MSCHN(ISETF), NCHAN(KS) )
         MINBBC(ISETF) =  MIN( MINBBC(ISETF), NBBC(ISETSTA(KS)) )
      END DO
C
C     Set the DBE early, if needed.
C
      CALL SETFIRM
C
C     Try to set many defaults.  For now, don't attempt to do so
C     for VLA-only observations.
C
      IF( .NOT. VLAONLY ) THEN
         DO KS = 1, NSET
C
C           Apply defaults for polarization, samplerate and
C           sidebands as required.  This is hardware independent
C           stuff.
C
            CALL SETCHAN( KS )
C
C           Set the frequencies based on the various inputs.
C
            CALL SETFREQ( KS, NEEDCAT(KS) )
C
C           Now the generic channel information is mostly known
C           although the polarization might not be known until
C           after the frequency catalog is read, if IFCHANs 
C           were specified in the setup.  Perhaps this should not
C           be allowed.  I don't think it is done.
C
C           Set some hardware dependent items that need to be set
C           from setup file data before the station dependent 
C           default data is gathered from the frequency catalog.  
C           The IFCHANS are one such item.
C
            CALL SETHW1( KS )
C
         END DO
C
C        Now that we have FREQREF and NETSIDE, we can get the 
C        FIRSTLO, FE, IFCHAN, synthesizer settings for the VLBA, etc.
C        This is done based on the frequency catalog.  SETFCAT
C        identifies the appropriate frequency catalog entry to use
C        sets the required parameters.  Of course, much of this is 
C        station hardware dependent.
C
         DO KS = 1, NSET
            CALL SETFCAT( KS, NEEDCAT(KS) )
         END DO
C
C        Make the BBC assignments based on the channel contents
C        and the DAR and RECORDER types.  
C
         DO KS = 1, NSET
            CALL SETBBC( KS )
         END DO
C
C        Now everything except formatting and recording details
C        are set.
C
C        Set the recorder information including FORMAT etc.
C
         CALL SETREC
C
C        Set the default track assignments for wide band modes.
C
         DO KS = 1, NSET
            IF( TRACK(1,1,KS) .EQ. 0 .AND.
     1        ( FORMAT(KS)(1:4) .EQ. 'VLBA' .OR.
     2          FORMAT(KS)(1:4) .EQ. 'MKIV' .OR.
     3          FORMAT(KS)(1:4) .EQ. 'VDIF' .OR.
     4          FORMAT(KS)(1:6) .EQ. 'MARK5B' .OR.
     5          FORMAT(KS)(1:3) .EQ. 'LBA' ) ) THEN
C
               CALL SETTRK( NCHAN(KS), TAPEMODE(KS), FORMAT(KS), 
     1               BITS(1,KS), TRACK(1,1,KS), MCHAN, BBC(1,KS), 
     2               SIDEBD(1,KS), DBE(KS), DAR(ISETSTA(KS)),
     3               KS, TWOHEAD, DEBUG, ILOG )
C
            END IF
         END DO
C
C        Set the unspecified synthesizers for the VLBA
C
         CALL SETUSYN
C
C        Set the pointer from channel to synthesizer to 0.  It
C        will be set properly for the VLBA in CHKVLBA and left
C        at zero for others.
C
         DO KS = 1, NSET
            DO ICH = 1, NCHAN(KS)
               VFESYN(ICH,KS) = 0
            END DO
         END DO
C
      END IF
C
      RETURN
      END

      SUBROUTINE SATTIM( ISCN, START, STOP, DAY, YEAR )
C
C     Routine to test input times and process them to form Julian
C     start and stop times which will be used throughout the rest of
C     the SCHED.  All times are fractional days.
C
C     Note that this routine is not where dwell time scheduling, or other
C     optimization is done and the times can be quite far off.  Scan 
C     times should not be used for anything that matters until after
C     SCHOPT is called.
C     
C     This was called SETTIM, but the MicroSoft fortran library also has
C     a routine of that name.
C
      INCLUDE 'sched.inc'
C
      DOUBLE PRECISION   START, STOP, RJDAY
      DOUBLE PRECISION   INSTOP, UT, INDUR, INGAP
      INTEGER            DAY, YEAR, ISCN, LASTDAY, ERR
      INTEGER            RDAY, INDAY, INYEAR
      LOGICAL            WARN1, WARN2
      SAVE               LASTDAY, WARN1, WARN2
C ---------------------------------------------------------------------
C     First, do a series of checks that the inputs are appropriate.
C
C     Test for required time information in first scan.
C
      IF( ISCN .EQ. 1 ) THEN
         IF( START .EQ. UNSET ) 
     1       CALL ERRLOG( 
     2           'SATTIM: Start time required for first scan.' )
         IF( DAY .EQ. 0 ) 
     1       CALL ERRLOG( 'SATTIM: Day required for first scan.' )
         IF( YEAR .EQ. 0 .AND. .NOT. ( LST .AND. DAY .GT. 366 ) ) 
     1       CALL ERRLOG( 'SATTIM: Year required for first scan.' )
         LASTDAY = DAY
         WARN1 = .TRUE.
         WARN2 = .TRUE.
         TFIRST = 999.D9
      END IF
C
C     Check for inappropriate specification of new day with duration
C     scheduling.
C
      IF( DAY .NE. 0 ) THEN
         IF( START .EQ. UNSET .AND. STOP .EQ. UNSET )  THEN
            IF( DAY .NE. LASTDAY ) THEN
               CALL ERRLOG('SATTIM: Day not allowed to change without'//
     1           '  new START or STOP ' )
            END IF
         END IF
         LASTDAY = DAY
      END IF
C
C     Make sure we know how long the scan should be.
C
      IF( STOP .EQ. UNSET .AND. DUR(ISCN) .LE. 0.D0 ) THEN
         WRITE( MSGTXT, '( A, I5 )' )
     1     'SATTIM: No STOP time or DURation available for scan ', ISCN
         CALL ERRLOG( MSGTXT )
      END IF
C
C     Warn if both GAP and START were specified.  Don't worry about
C     first scan - might be valid spec, especially if optimizing.
C
      IF( START .NE. UNSET .AND. GAP(ISCN) .NE. 0.D0 .AND. 
     1    ISCN .NE. 1 .AND. WARN1 ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, A, I5 )' ) 
     1     'SATTIM: WARNING - Both GAP and START specified.',
     2     '  Will use START.  Scan: ', ISCN
         CALL WLOG( 1, MSGTXT )
         WARN1 = .FALSE. 
      END IF
C
C     If START and DWELL were specified, warn of what will happen.
C     Don't worry about first scan - might be valid spec, especially 
C     if optimizing.
C
      IF( START .NE. UNSET .AND. DWELL(ISCN) .AND. ISCN .NE. 1 .AND.
     1    WARN2 ) THEN
         CALL WLOG( 1, 'SATTIM: WARNING, both START and DWELL given.'//
     1        '  Will use START.' )
         WARN2 = .FALSE.
      END IF
C
C     Now use the inputs to establish the first cut at scan times.
C     These may be modified later if there is any optimization.
C     Avoid dealing with the start time day number - confusing with
C     LST options.
C
C     Transfer input parameters to local variables in preparation for
C     possible changes if a day boundary was crossed or if LST was
C     specified.
C
      INSTOP  = STOP
      INDUR   = DUR(ISCN)
      INGAP   = GAP(ISCN)
      INYEAR  = YEAR
      INDAY   = DAY
C
C     Above we required that STOP or DUR be set.  If STOP was not
C     set, and START was, set INSTOP now.  Later, once we have
C     STOPJ, we will reconstruct STARTJ from DUR.  This avoids
C     a lot of hoop jumping concerning the start day number.
C     If START, STOP, and DUR were given, require consistency to
C     better than 1 second.
C     Also add a day to DUR if start and stop on different days.
C     Warn the user when this happens.
C
      IF( START .NE. UNSET .AND. INSTOP .EQ. UNSET ) THEN
         IF( START + INDUR .GT. 1.D0 - ONESEC ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I4, 2A )' ) 
     1           'SATTIM: ** WARNING:  Scan ', ISCN, ' has a specified',
     2        ' start time and crosses midnight (or almost).'
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, '        Remember that YEAR, MONTH, and DAY'//
     1        ' apply to the scan stop time.' )
            CALL WLOG( 1, '        Also if the stop was right at 24hr,'
     1        // ' it might be adjusted to 23:59:59 after application'
     2        // ' of the day.' )
            CALL WLOG( 1, '        Check your scan dates carefully.' )
         END IF
         INSTOP = MOD( START + INDUR, 1.D0 )
      END IF
      IF( START .NE. UNSET .AND. INSTOP .NE. UNSET ) THEN
         INDUR = INSTOP - START
         IF( INDUR .LT. 0.D0 ) INDUR = INDUR + 1.D0
         IF( DUR(ISCN) .NE. 0.D0 .AND. 
     1       ABS( DUR(ISCN) - INDUR ) .GT. 1.D0 / 86400.D0 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5 )' ) 
     1         'SATTIM: START, STOP, and DURATION all given for scan ', 
     2         ISCN
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, '        They are not consistent. ' )
            CALL ERRLOG( ' Please fix times, or remove one.' )
         END IF
      END IF
C
C     If LST was specified, convert times to UT.
C     START, STOP, DUR, DWELL, and GAP are assumed to be sidereal times.
C     The day can be specified in one of two ways.  If DAY is greater
C     than 366, it is assumed to be the Local Sidereal Day as found on
C     VLA schedules and YEAR and MONTH are ignored.  If it is less than
C     366, YEAR, MONTH, and DAY are assumed to specify a UT day.
C     The following converts INYEAR, INDAY, INSTOP, INDUR, and INGAP
C     to UT times.
C
      IF( LST ) THEN
C
         IF( INSTOP .NE. UNSET ) THEN
            CALL GLSTDAY( ISCN, INYEAR, INDAY, INSTOP, RDAY )
C
            CALL LST2UT( LONG(LSTSTA), RDAY, INSTOP,
     1                   INYEAR, INDAY, UT )
            INSTOP = UT
         END IF
C
C        Convert sidereal duration to UT duration.
C
         INDUR = INDUR / SIDR 
         INGAP = INGAP / SIDR
C
      END IF
C
C     Check for reasonable year.
C
      IF( ( INSTOP .NE. UNSET .AND.
     1    ( INYEAR .LT. 1900 .OR. INYEAR .GT. 2100 ) ) ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I6 )' ) 
     1      ' **** WARNING: Unlikely year: ', INYEAR
         CALL WLOG( 1, MSGTXT )
      END IF
C
C     Determine STOPJ(ISCN), which is a Modified Julian day number, 
C     if we have INSTOP. This form of time is used to avoid 24 hr 
C     ambiguities.
C
      IF( INSTOP .NE. UNSET )  THEN
         CALL SLA_CLDJ( INYEAR, 1, INDAY, RJDAY, ERR )
         IF( ERR .NE. 0 .AND. ERR .NE. 3 ) 
     1         CALL ERRLOG( 'Problem converting to MJD' )
         STOPJ(ISCN) = INSTOP + RJDAY
      END IF
C
C     Now get STARTJ(ISCN), either from the stop of this scan, if
C     we have INDUR, or from the previous scan stop time.
C
      IF( INSTOP .NE. UNSET .AND. INDUR .NE. 0.D0 ) THEN
         STARTJ(ISCN) = STOPJ(ISCN) - INDUR
      ELSE 
         STARTJ(ISCN) = STOPJ(ISCN-1) + INGAP
      END IF
C
C     Now get STOPJ(ISCN) if we don't already have it.
C
      IF( INSTOP .EQ. UNSET ) THEN
         STOPJ(ISCN) = STARTJ(ISCN) + INDUR
      END IF
C
C     Set DUR(ISCN) and GAP(ISCN) according to above adjustments.
C     This also accomplishes the LST to UT conversion.
C     Note GAP is not set to STARTJ(ISCN) - STOPJ(ISCN-1) because
C     that could do odd things when START was specified.
C
      DUR(ISCN) = STOPJ(ISCN) - STARTJ(ISCN)
      GAP(ISCN) = INGAP
C
C     Adjustments for PRESCAN will be made in OPTTIM called by SCHOPT.
C
C     Find the earliest start time of the experiment.  This used
C     to be done after most schedule optimization, but is needed
C     for some tape handling options earlier than that.  Adjust
C     for PRESCAN assuming that the full PRESCAN will be used
C     on the first scan (no concern about not overlapping an
C     earlier scan.
C
      TFIRST = MIN( STARTJ(ISCN) + PRESCAN(ISCN), TFIRST )
C
      RETURN
      END

      LOGICAL FUNCTION DEQUAL( A, B )
C
C     Function to use to test the "equality" of two double 
C     precision variables making allowance for the fact that they
C     could well differ in the lowest order bits.  Require
C     equality at the level of a part in 1.D-14
C
      DOUBLE PRECISION   A, B
C ------------------------------------------------------------
      DEQUAL = DABS( A - B ) .LT. 1.0D-14 * ( A + B )
      RETURN
      END

      SUBROUTINE sla_ECOR (RM, DM, IY, ID, FD, RV, TL)
*+
*     - - - - -
*      E C O R
*     - - - - -
*
*  Component of Earth orbit velocity and heliocentric
*  light time in a given direction (single precision)
*
*  Given:
*     RM,DM    real    mean RA, Dec of date (radians)
*     IY       int     year
*     ID       int     day in year (1 = Jan 1st)
*     FD       real    fraction of day
*
*  Returned:
*     RV       real    component of Earth orbital velocity (km/sec)
*     TL       real    component of heliocentric light time (sec)
*
*  Notes:
*
*  1  The date and time is TDB (loosely ET) in a Julian calendar
*     which has been aligned to the ordinary Gregorian
*     calendar for the interval 1900 March 1 to 2100 February 28.
*     The year and day can be obtained by calling sla_CALYD or
*     sla_CLYD.
*
*  2  Sign convention:
*
*     The velocity component is +ve when the Earth is receding from
*     the given point on the sky.  The light time component is +ve
*     when the Earth lies between the Sun and the given point on
*     the sky.
*
*  3  Accuracy:
*
*     The velocity component is usually within 0.004 km/s of the
*     correct value and is never in error by more than 0.007 km/s.
*     The error in light time correction is about 0.03s at worst,
*     but is usually better than 0.01s. For applications requiring
*     higher accuracy, see the sla_EVP and sla_EPV routines.
*
*  Called:  sla_EARTH, sla_CS2C, sla_VDV
*
*  Last revision:   5 April 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      REAL RM,DM
      INTEGER IY,ID
      REAL FD,RV,TL

      REAL sla_VDV

      REAL PV(6),V(3),AUKM,AUSEC

*  AU to km and light sec (1985 Almanac)
      PARAMETER (AUKM=1.4959787066E8,
     :           AUSEC=499.0047837)



*  Sun:Earth position & velocity vector
      CALL sla_EARTH(IY,ID,FD,PV)

*  Star position vector
      CALL sla_CS2C(RM,DM,V)

*  Velocity component
      RV=-AUKM*sla_VDV(PV(4),V)

*  Light time component
      TL=AUSEC*sla_VDV(PV(1),V)

      END

      SUBROUTINE VLBAINI( ISCN, ISTA )
C
C     Routine for SCHED called by VLBA that starts a vlba control file.
C
      INCLUDE   'sched.inc'
C
      INTEGER           ISCN, ISTA, KSTA
      INTEGER           I, J, LEN1, DOY1
      CHARACTER         HUMAND1*16, VLBAD1*9, ESTART*9, TFORM*15
      CHARACTER         DISKD*6
      DOUBLE PRECISION  FRACD1, DPSTART
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'VLBAINI: Starting.' )
C
C     Get the pointer to entries in the station catalog for this 
C     schedule station ISTA.
C
      KSTA = STANUM(ISTA)
C
C     Write identifying information and program name 
C     at top of schedule.
C
      WRITE( IUVBA, '(''!*  Schedule for '', A8,''  *!'')')
     1      STATION(KSTA)
      WRITE( IUVBA, '(''!*  Experiment '', A, '' *!'' )' ) 
     1      EXPCODE
C
      DO I = 1, MCOVER
         J = LEN1( COVER(I) )
         IF( J .GT. 0) THEN
           WRITE( IUVBA, '( A )' ) '!* '//COVER(I)(1:J)//' *!'
         ELSE
           WRITE( IUVBA, '( A )' ) '!*  *!'
         END IF
      END DO
C
C     Give a start time for the experiment in a comment.  Give
C     the earlier of the specified start time (STARTJ - PRESCAN)
C     and the recording start time.
C
      DPSTART = MIN( STARTJ(ISCN) - PRESCAN(ISCN),
     1               STARTJ(ISCN) - TPSTART(ISCN,ISTA) )
      CALL SCHDAY( DPSTART, VLBAD1, HUMAND1, DOY1, FRACD1 )
      ESTART = TFORM( FRACD1*TWOPI, 'T', 0, 2, 2, 'hms' )
      WRITE( IUVBA, '(''!*  Start at '', A9, 5X, A, 
     1    ''  Day of year '', I4, ''   *!'')' ) 
     2     ESTART, HUMAND1, DOY1
      WRITE( IUVBA, '( A, A )' ) 'program=', EXPCODE
C
C     Specify the disk format, even though this line is ignored
C     by the on-line system.  Presume that it will be the
C     format of the drive that is at the station and that it
C     will not change.  But for the RDBE/MARK5C, claim it is 
C     mark5a because that is all the crd file can control.
C     Also write a warning that the VEX file probably cannot be
C     used for correlation.
C
      IF( VLBITP .AND. USEDISK(ISTA) ) THEN
         IF( DAR(KSTA)(1:4) .EQ. 'RDBE' .AND. DOMKA ) THEN
            DISKD = 'mark5a'
            WRITE( IUVBA, '( 1X, /, 2A )' ) 
     1         '!*  WARNING:  This crd file ',
     2         'can be used to record data on the Mark5a system.*!'
            WRITE( IUVBA, '( 3A )' ) '!*  WARNING:  But the VEX ',
     1         'file is for the RDBE/MARK5C data and will most ', 
     2         'likely *!'
            WRITE( IUVBA, '( 2A )' ) '!*  WARNING:  ',
     1         'not work as is for correlation. *!'
            WRITE( IUVBA, '( 3A )' ) '!*  WARNING:  The channel ',
     1         'number, frequency, and bandwidth are probably ',
     2         'different. *!'
         ELSE
            DISKD = DISK(KSTA)
         END IF
         CALL DWCASE( DISKD )
         WRITE( IUVBA, '( 1X, /, 2A )' ) 'diskformat=', DISKD
      END IF
C
C     Tell operations what can be used.  This used to distinguish
C     tape and disk, but tape has been removed.  Keep in case
C     there are other distinctions later.
C
      IF( .NOT. DISK(KSTA) .EQ. 'NONE' ) THEN
         IF( .NOT. VLBITP ) THEN
            WRITE( IUVBA, '( A )' ) 'media=(1,none)'
         ELSE
            IF( USEDISK(ISTA) ) THEN
               WRITE( IUVBA, '( A )' ) 'media=(1,disk)'
            ELSE
               CALL ERRLOG( 'VLBAINI: VLBI schedule without '//
     1             'disk specified?' )
            END IF            
         END IF
      END IF
C
C     A setup scan before the first scan of the experiment will
C     be made for all observations.  This allows the operators to
C     check the setup before the observation starts and insures
C     that a header will be written in the monitor data for the
C     first scan after the experiment start time.  The actual 
C     setup scan will be written later where the Mark III etc 
C     setup scans are written.  Only a message is written here.
C
      WRITE( IUVBA, '( 1X, /, A, /, A )' ) 
     1   '!* The first scan is preceeded by a setup scan *!',
     2   '!* that ends at the start time of the first scan  *!'
C
      RETURN
      END

      SUBROUTINE FMATCH( KS, KF, OVERLAP, CENTER, OKIF, USEIF )
C
C   ****  Something is dangling here for RDBE_DDC - CROSS is not yet used.
C          CROSS in RDBEMTCH   Fixed mar 2014?
C        
C     Routine for SCHED called by SETFCAT that finds the best IF
C     channel from the frequency catalog to use for a setup file 
C     channel.   By this point, FREQREF, BBFILT, and NETSIDE 
C     are known.  Other items may still be unset.
C
C     KS is the setup group.
C     KF is the frequency catalog group.
C     OVERLAP is the amount of bandwidth overlap.
C     CENTER is maximum offset of the center of the any channel from 
C            the center of the IF band.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
      INCLUDE   'schfreq.inc'
C
      INTEGER           KS, KF, IIF, ICH
      INTEGER           USEIF(MCHAN)
      REAL              OVERLAP, CENTER
      REAL              BESTCN
      REAL              CHOVER(MCHAN,MFIF), CHCENT(MCHAN,MFIF)
      LOGICAL           OKIF(MCHAN,MFIF)
      DOUBLE PRECISION  FRQ1(MCHAN), FRQ2(MCHAN)
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'FMATCH starting' )
C
C     Loop over the channels.
C
      DO ICH = 1, NCHAN(KS)
C
C        Get the minimum and maximum frequency in each channel.
C        Also get the baseband converter frequency.
C
         IF( NETSIDE(ICH,KS) .EQ. 'L' ) THEN
            FRQ1(ICH) = FREQREF(ICH,KS) - BBFILT(ICH,KS)
            FRQ2(ICH) = FREQREF(ICH,KS)
         ELSE
            FRQ1(ICH) = FREQREF(ICH,KS)
            FRQ2(ICH) = FREQREF(ICH,KS) + BBFILT(ICH,KS)
         END IF
C
C        Loop over the frequency catalog IF channels looking for
C        a match.  Default to USEIF(ICH) = 0 if there is no match for now.
C        Recall that OKIF means the channel matches except that the 
C        frequency might be off by some tolerance set in FCOMPARE. 
C        That tolerance was 20% when this was written.
C        Set the default CHOVER and CHCENT to discourage a channel with
C        false OKIF.
C
         USEIF(ICH) = 0
         DO IIF = 1, FNIF(KF)
            CHOVER(ICH,IIF) = 0.0
            CHCENT(ICH,IIF) = 1.E5
C
C           Be sure this is an ok match according to FCOMPARE.
C
            IF( OKIF(ICH,IIF) ) THEN
C
C              Check how much bandwidth overlaps.
C              For the RDBE, only count the part between the
C              LO sum and a crossover if one is in the channel.
C
               IF( FRQ2(ICH) .GT. FRF1(IIF,KF) .AND. 
     1             FRQ1(ICH) .LT. FRF2(IIF,KF) ) THEN
                  CHOVER(ICH,IIF) = MIN( FRQ2(ICH), FRF2(IIF,KF) ) - 
     1                              MAX( FRQ1(ICH), FRF1(IIF,KF) )
                  IF( DBE(KS)(1:4) .EQ. 'RDBE' ) THEN
                     CALL RDBEMTCH( KS, KF, ICH, IIF, 
     1                   FRF1(IIF,KF), FRF2(IIF,KF),
     2                   FRQ1(ICH), FRQ2(ICH), CHOVER(ICH,IIF) )
                  END IF
               ELSE
                  CHOVER(ICH,IIF) = 0.0
               END IF
C
C              Get centering - the offset between the middle of the IF
C              and the middle of the baseband.
C
               CHCENT(ICH,IIF) = ABS( 
     1                  ( FRF1(IIF,KF) + FRF2(IIF,KF) )/2.0
     2                - ( FRQ1(ICH) + FRQ2(ICH) ) / 2.0 )
C
               IF( SDEBUG ) THEN
                  SETMSG = ' '
                  WRITE( SETMSG, '( A, 2I4, 4F10.3)' ) 
     1                  'FMATCH: Channel ',
     2                  ICH, IIF, FRQ1(ICH), FRQ2(ICH), 
     3                  CHOVER(ICH,IIF),CHCENT(ICH,IIF)
                  CALL WLOG( 0, SETMSG )
               END IF
            END IF
         END DO
C
C        Get the best IF for the channel.
C        Try for best frequency match (best centered with all other
C        parameters right (OKIF true).
C
         BESTCN = 1.E5
         DO IIF = 1, FNIF(KF)
            IF( OKIF(ICH,IIF) ) THEN
               IF( CHCENT(ICH,IIF) .LT. BESTCN ) THEN
                  BESTCN = CHCENT(ICH,IIF)
                  USEIF(ICH) = IIF
               END IF
            END IF
         END DO
C
      END DO
C
C     Loop over the channels and get the total overlap bandwidth
C     and the worst center.  These will be used to select the best
C     frequency catalog group.  If a channel did not fit all, even
C     with the frequency tolerance USEIF(ICH) will be zero.
C     Allow for that possibility in the calling routine.
C
      OVERLAP = 0.0
      CENTER = 0.0
      DO ICH = 1, NCHAN(KS)
         IIF = USEIF(ICH)
         IF( IIF .GT. 0 ) THEN
            OVERLAP = OVERLAP + CHOVER(ICH,IIF)
            CENTER = MAX( CENTER, CHCENT(ICH,IIF) )
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE VXWRDA
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the DA = $DAS section 
C     By H.J. van Langevelde, JIVE, 300496 
C     Fix 1.5 version for DAS = none 070397
C
C     Removed much tape handling July 22, 2010  RCW.
C     Initialize HEAD for pointing type observations.  Nov. 11, 2011 RCW.
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
C     Huib's local variables 
C      
      INTEGER   IXX, ISTA, I, ISCAT, KS, IDRIV, JHEAD
      INTEGER   LEN1
      CHARACTER HEAD*10, WRDISK*6
      LOGICAL   VIOLFS
C ----------------------------------------------------------------------
C     write $DAS section 
C     
      VIOLFS = .FALSE.
      WRITE( IVEX, '( A, A1 )' ) '$DAS', SEP     
C
C     first, for recording system
C
      DO IXX = 1, NDAVEX
C
C        find a station to which this refers
C
         ISTA = -1
         DO I = 1, NSTA
            IF( ISTADA(I) .EQ. IXX ) ISTA = I
         END DO
         ISCAT = STANUM(ISTA)
C
         IF( ISTA .LT. 0 ) 
     1       CALL ERRLOG(' VXWRDA: no station for $DAS def ')
C
C        Prevent use of MkIII recorder and DAS with VEX in current version
C        proper implementation reuires work on chk3dar and a lot on
C        chk3dar, if PCFS will ever support this...
C
C        MKIII blocked at schedule read time so removed here.  July 22, 2010
C        RCW.
C
         ISCAT = STANUM(ISTA)
C
C        start with regular stuff
C
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' )  'def ', 
     1       DALINK(IXX)(1:LEN1(DALINK(IXX))),SEP
C
C        Start by finding a set in which this station occurs,
C        because some things need to know eg. FORMAT
C        RCW  Dec 2011.  Don't avoid FORMAT=NONE.
C
         DO I = 1, NSET
C            IF ( USED(I) .AND. ( FORMAT(I) .NE. 'NONE' .OR.
C     1          OBSTYP .EQ. 'PTVLBA' ) .AND.
C     1          ( STATION(ISCAT) .EQ. SETSTA(1,I) )) KS = I
            IF ( USED(I) .AND. STATION(ISCAT) .EQ. SETSTA(1,I) ) KS = I
         END DO
C
C        Now write recorder.
C
         IF( USEDISK(ISTA) ) THEN
             IF( DISK(STANUM(ISTA)) .EQ. 'MARK5A' .OR.
     1           DISK(STANUM(ISTA)) .EQ. 'MARK5B' .OR.
     2           DISK(STANUM(ISTA)) .EQ. 'MARK5C'    ) THEN
                WRDISK = 'Mark5'//DISK(STANUM(ISTA))(6:6)//' '
                WRITE( IVEX, '( 5X, A, A, A1 )' )
     1              'record_transport_type = ',
     2              WRDISK(1:LEN1(WRDISK)), SEP
             ELSE IF( DISK(STANUM(ISTA)) .EQ. 'LBADR' ) THEN
                WRITE( IVEX, '( 5X, A, A, A1 )' )
     1              'record_transport_type = ',
     2              'S2', SEP
C     2              'Mark5A', SEP
             ELSE
                CALL ERRLOG(' VXWRDA: Unknown recorder of type: '//
     1              RECORDER(ISCAT) )
             END IF
         END IF
C
C        Next electronic rack
C
         IF( DAR(ISCAT) .EQ. 'VLBA' .OR. 
     1       DAR(ISCAT) .EQ. 'RDBE' .OR. 
     2       DAR(ISCAT) .EQ. 'RDBE2' .OR. 
     3       DAR(ISCAT) .EQ. 'S2' .OR. 
     4       DAR(ISCAT) .EQ. 'VLBAG' .OR.
     5       DAR(ISCAT) .EQ. 'VLBA4' .OR. 
     6       DAR(ISCAT) .EQ. 'K4' ) THEN
            WRITE( IVEX, '( 5X, A, A, A1 )' ) 
     1          'electronics_rack_type = ',
     2          DAR(ISCAT)(1:LEN1(DAR(ISCAT))), SEP
         ELSE IF( DAR(ISCAT) .EQ. 'MKIII' ) THEN
            WRITE( IVEX, '( 5X, A, A, A1 )' ) 
     1          'electronics_rack_type = ',
     2          'Mark3A', SEP
         ELSE IF( DAR(ISCAT) .EQ. 'MKIV' ) THEN
            WRITE( IVEX, '( 5X, A, A, A1 )' ) 
     1          'electronics_rack_type = ',
     2          'Mark4', SEP
         ELSE IF( DAR(ISCAT) .EQ. 'WIDAR' ) THEN
            WRITE( IVEX, '( 5X, A, A, A1 )' ) 
     1          'electronics_rack_type = ',
     2          'WIDAR', SEP
         ELSE IF( DAR(ISCAT) .EQ. 'LBA' ) THEN
            WRITE( IVEX, '( 5X, A, A, A1 )' ) 
     1          'electronics_rack_type = ',
     2          'LBA', SEP
         ELSE IF( DAR(ISCAT) .EQ. 'NONE' ) THEN
            WRITE( IVEX, '( 5X, A, A, A1 )' ) 
     1          'electronics_rack_type = ',
     2          'none', SEP
         ELSE IF( DAR(ISCAT) .EQ. 'DBBC' ) THEN
            WRITE( IVEX, '( 5X, A, A, A1 )' ) 
     1          'electronics_rack_type = ',
     2          'DBBC', SEP
C
C    2011-09-30 small@astron:
C    Also add support for KVAZAR stations here.
C    (Note that "KVAZAR" is a back-transliteration 
C     of the Cyrillic transliteration of "quasar".
C     "KVAZAR" is apparently preferred at JIVE, although
C     the Russians write "QUASAR" in English.)
C
         ELSE IF( DAR(ISCAT) .EQ. 'R1002' ) THEN
            WRITE( IVEX, '( 5X, A, A, A1)' )
     1          'electronics_rack_type = ',
     2          'Mark4', SEP
         ELSE
            CALL ERRLOG(' VXWRDA: Unknown DAR of type: '//
     1          DAR(ISCAT) )
         END IF
C
C        S2 blocked on input so don't worry about it here.
C
C        Write number of drives.
C
         WRITE( IVEX, '( 5X, A, I1, A1 )' ) 'number_drives = ',
     1       STNDRIV(STANUM(ISTA)), SEP
C
C        Check if this fits the PCFS
C
         IF (NHEADS(STANUM(ISTA)) .GT. 2 ) THEN
            VIOLFS = .TRUE.
            WRITE( MSGTXT, '( A, A, A, I3, A )' ) 
     1          'VXWRDA: WARNING: More than 2 heads on ',
     2          STATION(STANUM(ISTA)), ' recorder (', 
     3          NHEADS(STANUM(ISTA)), ')'
            CALL WLOG( 1, MSGTXT )
         END IF            
C     
C        And the headstacks for each
C
         IF( USEDISK(ISTA) .OR. OBSTYP .EQ. 'NONE' .OR. 
     1       OBSTYP .EQ. 'PTVLBA' .OR. FORMAT(KS)(1:4) .EQ. 'NONE' ) 
     2       THEN
C           WRITE (HEAD, '( A )' ) ''
            HEAD = ' '
         END IF
         IF( STNDRIV(STANUM(ISTA)) .LT. 1 .OR. 
     1       STNDRIV(STANUM(ISTA)) .GT. 9 .OR.
     2       NHEADS(STANUM(ISTA)) .LT. 1 .OR.
     3       NHEADS(STANUM(ISTA)) .GT. 9 ) THEN
            CALL ERRLOG('VXWRDA inconsitent number of'//
     1          ' drives/headstacks')
         ELSE
            DO IDRIV = 1, STNDRIV(STANUM(ISTA)) 
               DO JHEAD = 1, NHEADS(STANUM(ISTA))
                  WRITE( IVEX, '( 5X, A, I1, 1X, A1, 1X, A, 
     1                1X, A1, 1X, I1, 1X, A1 )' ) 
     2                'headstack = ', 
     3                JHEAD + NHEADS(STANUM(ISTA))*(IDRIV-1), COL,
     4                HEAD, COL, IDRIV-1, SEP
               END DO
            END DO
         END IF
C
C        tapemotion can be start/stop or adaptive but fixed params!
C        Use this for disks as well, as 0 second gaps seem to cause a
C        problem - allow switching it off by using VEXTEST in case
C        this gets fixed
C
         IF( USETAPE(ISTA) .OR. .NOT. VEXTEST ) THEN
            WRITE( IVEX, '( 5X, A, A, A1, I2, A, A1, I2, A, A1, 
     1          I3, A, A1 )' ) 'tape_motion = ', 
     2          'adaptive ', COL, 0, ' min', COL,
     3          0, ' min', COL, 10, ' sec', SEP
         END IF
C
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
C
      END DO
      WRITE( IVEX, '( A )' ) COMLIN
      IF( VIOLFS )
     1    CALL WLOG( 1,'VXWRDA: More than 2 headstacks '//
     2    'not supported in PCFS; this VEX will NOT run!!!!')
      RETURN
      END

      SUBROUTINE PLBEAM( BEAM, U, V, IUVMAX, UVMAX, PBMWGT,
     1                   PBMCEL, XYINT )
C
C     Routine for sched that regrid the two vectors of U and V,
C     for the stations selected, and give Dirty Beam.
C
C     PLBEAM is an alias of program "INVERT" ( AUG. 23,1982 ) 
C     
C     Basis of "INVERT" is by D.Rogstad, modifications by S.Kent,
C     A.Readhead, P.Wilkinson, C.Fanti and F.Tinarelli
C     Reads data baseline by baseline, grids with a gaussian convolution 
C     function and inverts to give dirty beam.
C     Inverse weighting of points by density of coverage in U,V plane is
C     used.
C
C     The program use the Singleton FFT routine, i.e. multiple of only
C     2,3,4,5.
C
      INCLUDE 'beam.inc'
C
      INTEGER           NPTS(NBASE), IUVMAX, PBMCEL
      INTEGER           KLDIMU, KLDIMV, PBMWGT
      INTEGER           IDIMU, IUU, IUUM
      INTEGER           IDIMV, IVV, IVVM
      INTEGER           KLMAXU, KLMAXV
      INTEGER           KLLOU, KLHIU, KLLOV, KLHIV, I, J, M, L, LL, K
      INTEGER           KK, JJ, II, MSLO, NSLO, NSHI, MSHI
      INTEGER           INDX, IMAX, IU, IV, IUP, IVP, KLO
      INTEGER           KHI, LLO, LHI, IUO, IVO, KO, LO, NN, NPLO
      INTEGER           N, MM, MPLO, NCOL, IRI, IRF, JCL, JCR, JQ, IQ
      LOGICAL           BFLG
      REAL              BEAM(KXSIZE,KYSIZE)
Cf2py intent(out) BEAM
      DOUBLE PRECISION  U(NPBAS,NBASE), V(NPBAS,NBASE), UVMAX 
      DOUBLE PRECISION  XMAX, YMAX, XYINT
Cf2py intent(out) XYINT
      DOUBLE PRECISION  VZ(KXSIZE*2,KYSIZE*2), CONV(60,60)
      DOUBLE PRECISION  W(NPBAS,NBASE)
      DOUBLE PRECISION  RADSEC, PI, OFST, ARG
      DOUBLE PRECISION  CA, SA, UINT, VINT, UUT, VVT
      DOUBLE PRECISION  SIGMAU, SIGMAV, SIGSQU, SIGSQV, TEMP
      DOUBLE PRECISION  TMPA, SUM, FACT, WSUM, UP, VP
      DOUBLE PRECISION  DATA, CDATA, SDATA, AMAX, SCALE, UNIT, VMX
      DOUBLE PRECISION  VAB, FNORMS, FNORM, SSQ, VVZ, CORR
      COMPLEX*16        CSU(KXSIZE*2), CSV(KXSIZE*2), TT(KXSIZE*2)
C -------------------------------------------------------------------
C
      RADSEC = 4.848137E-6
      PI     = 3.1415926536
      BFLG   = .TRUE.
      KLDIMU = KXSIZE
      KLDIMV = KYSIZE
C
C     Set up array parameters
C
      IDIMU = 2 * KLDIMU
      IUU   = IDIMU * 10
      IUUM  = IUU / 2
      IDIMV = 2 * KLDIMV
      IVV   = IDIMV * 10
      IVVM  = IVV / 2
C
C     Fill cosine-sine array
C
      OFST = PI * KLDIMU / 2.0
C
      DO 5 I = 1, IDIMU
         ARG    = PI * ( I - 1 ) - OFST
         CA     = DCOS( ARG )
         SA     = DSIN( ARG )
         CSU(I) = CMPLX( CA, SA )
  5   CONTINUE
C
      OFST = PI * KLDIMV / 2.0
C
      DO 6 I = 1, IDIMV
         ARG    = PI * ( I - 1 ) - OFST
         CA     = DCOS( ARG )
         SA     = DSIN( ARG )
         CSV(I) = CMPLX( CA, SA )
  6   CONTINUE
C
      UVMAX   = UVMAX * 0.0001
      NPTS(1) = IUVMAX
      UNIT    = 3.0
C
C     Now compute x,y and u,v sampling.
C     Factor 1.2 is to avoid truncation in the gaussian convolving
C     function.
C
      XMAX  = KLDIMU / (2.0 * PBMCEL * KLDIMU * UVMAX * 1.2 * RADSEC)
      YMAX  = KLDIMV / (2.0 * PBMCEL * KLDIMV * UVMAX * 1.2 * RADSEC)
      XYINT = MIN( XMAX, YMAX )
      UINT  = 1.0 / ( 2.0 * KLDIMU * XYINT * RADSEC )
      VINT  = 1.0 / ( 2.0 * KLDIMV * XYINT * RADSEC )
C
C     Compute Uniform or Natural Weights
C
      IF( PBMWGT .EQ. 1 ) THEN
         CALL PLWEIG( VZ, U, V, W, NPTS, KLDIMU,
     1                KLDIMV, UINT, VINT )
      ELSE
         DO 4 INDX = 1, NBASE
            IMAX = NPTS(INDX)
            DO 4 I= 1, IMAX
               W(I,INDX) = 1.0
 4       CONTINUE
      END IF
C
      UUT    = UINT / 10.0
      VVT    = VINT / 10.0
      KLMAXU = 1.2 * UVMAX * PBMCEL / UINT + 0.55
      KLMAXV = 1.2 * UVMAX * PBMCEL / VINT + 0.55
      KLLOU  = KLDIMU - KLMAXU + 1
      KLHIU  = KLDIMU + KLMAXU
      KLLOV  = KLDIMV - KLMAXV + 1
      KLHIV  = KLDIMV + KLMAXV
      SIGMAU = UINT
      SIGMAV = VINT
      SIGSQU = 0.6931 * ( UUT / SIGMAU )**2
      SIGSQV = 0.6931 * ( VVT / SIGMAV )**2
C
C     Fill Convolution array and normalize
C
      DO 10 J = 1, 60
         TEMP = SIGSQV * ( J - 30 )**2
         DO 10 I = 1 , 60
            TMPA = TEMP + SIGSQU * ( I - 30 )**2
            CONV(I,J) = EXP( -TMPA )
 10   CONTINUE 
C
      DO 30 L = 1, 10
         LL = L - 1
         DO 30 K = 1, 10
            KK  = K - 1
            SUM = 0.0
            DO 20 J = 1, 6
               JJ = J * 10 - LL
               DO 20 I = 1, 6
                  II  = I * 10 - KK
                  SUM = SUM + CONV(II,JJ)
 20         CONTINUE
            FACT = 1.0 / SUM
            DO 25 J = 1 , 6
               JJ = J * 10 - LL
               DO 25 I = 1, 6
                  II  = I * 10 - KK
                  CONV(II,JJ) = FACT * CONV(II,JJ)
 25         CONTINUE
 30   CONTINUE
C
C     Form Dirty Beam
C
      MSLO = KLDIMU
      NSLO = 1
      NSHI = IDIMV
      MSHI = IDIMU
C
C     Clear Visibility array
C
      DO 40 L = 1, IDIMV
         DO 40 K = 1, IDIMU
            VZ(K,L) = 0.0
 40   CONTINUE
      WSUM = 0.0
C
      DO 110 INDX = 1, NBASE
         IMAX = NPTS(INDX)
C
C        Set V=-V because DHR and MHC use different definitions of V
C
         DO 58 I= 1, IMAX
            V(I,INDX) = -V(I,INDX)
 58      CONTINUE
C
C        ADD TO ARRAY
C
         DO 110 I = 1, IMAX
            UP    = U(I,INDX)
            VP    = V(I,INDX)
            IU    = UP / UUT + 0.5 * UP / ABS( UP )
            IV    = VP / VVT + 0.5 * VP / ABS( VP )
            IU    = IUUM + IU
            IV    = IVVM - IV
            WSUM  = WSUM + W(I,INDX)
            CDATA = W(I,INDX) * 100.0
            SDATA = 0.0
C
            DO 100 J = 1, 4
               GO TO( 60, 65, 70, 75 ), J
C
C                Add Imag Part
C
 60              IF( BFLG ) GO TO 100
                 DATA = SDATA
                 GO TO 80
C
C                Add Real Part
C
 65              IV = IVV - IV
                 DATA = CDATA
                 GO TO 80
C
C                Add -Imag Part (reflected)
C
 70              IU = IUU - IU
                 IF( BFLG ) GO TO 100
                 DATA = -SDATA
                 GO TO 80
C
C                add Real Part (reflected)
C
 75              IV = IVV - IV
                 DATA = CDATA
C
 80            IUP = IU / 10
               IVP = IV / 10
               KLO = MAX0(IUP-1,KLLOU)
               KHI = MIN0(IUP+4,KLHIU)
               LLO = MAX0(IVP-1,KLLOV)
               LHI = MIN0(IVP+4,KLHIV)
               IUO = IU - 10 * IUP
               IVO = IV - 10 * IVP
               KO  = KLO - 1
               LO  = LLO - 1
C
               DO 90 L = LLO, LHI
                  LL = ( L - LO ) * 10 - IVO
                  DO 90 K = KLO, KHI
                     KK = ( K - KO ) * 10 - IUO
                     VZ(K,L) = VZ(K,L) + DATA * CONV(KK,LL)
 90            CONTINUE
 100        CONTINUE
 110  CONTINUE
C
C     Rescale Visibility Array
C
      AMAX  = 2.0E + 4
      SCALE = 10.0**( UNIT - 2.0 ) / ( 2.0 * WSUM )
      VMX   = 0.0
      DO 125 L = KLLOV, KLHIV
         DO 125 K = KLLOU, KLHIU
            VAB = ABS( VZ(K,L) )
            IF( VAB .GT. VMX ) VMX = VAB
 125  CONTINUE
C
      VMX = VMX * SCALE
      FNORMS = MIN( AMAX / VMX,( AMAX / ( VMX *2.0 * KLMAXU ) )**2,
     1            ( AMAX / ( VMX * 2.0 * KLMAXV ) )**2 )
      FNORM  = 1.0 / DSQRT( FNORMS )
      SCALE  = SCALE * FNORMS
C
      DO 130 L = KLLOV, KLHIV
         DO 130 K = KLLOU, KLHIU
            VZ(K,L) = VZ(K,L) * SCALE
 130  CONTINUE
C
      SCALE = FNORMS * 10**UNIT
      MPLO  = MSLO - KLDIMU + 1
      NPLO  = NSLO
C
C     Fourier Transform DV
C
      CALL PLTRAN( VZ, TT, CSU, CSV, IDIMU, IDIMV,
     1             KLLOU, KLHIU, KLLOV, KLHIV, MSLO, MSHI,
     2             NSLO, NSHI, FNORM)
C
C     Correct BEAM for convolution taper 
C
      SIGSQU = ( XYINT * RADSEC * SIGMAU * PI )**2 / 0.6931
      SIGSQV = ( XYINT * RADSEC * SIGMAV * PI )**2 / 0.6931
      NN     = NPLO - 1
      DO 155 N = NSLO, NSHI
         NN  = NN + 1
         MM  = MPLO - 1
         SSQ = SIGSQV * ( KLDIMV - N )**2
         DO 155 M = MSLO, MSHI
            MM      = MM + 1
            VVZ     = VZ(M,N)
            CORR    = EXP( SIGSQU * ( KLDIMU - M )**2 + SSQ )
            VZ(M,N) = VVZ * CORR
 155     CONTINUE
C
C     Fill the Centre of Dirty Beam to Plot
C   
      NCOL = KXSIZE / 2
C
      IRI  = KLDIMU + 1
      IRF  = KLDIMU + NCOL
      JCL  = KLDIMV - NCOL + 1
      JCR  = KLDIMV + NCOL
      JQ   = 0
      DO J = JCL, JCR
         IQ  = NCOL - 1
         JQ  = JQ + 1
         DO I = IRI, IRF
            IQ  = IQ + 1
            BEAM(IQ,JQ) = VZ(I,J)
         END DO
      END DO
C
      IRI  = KLDIMU + 2
      IRF  = KLDIMU + NCOL
      JCL  = KLDIMV - NCOL + 2
      JCR  = KLDIMV + NCOL + 1
      JQ   = NCOL * 2 + 1
      DO J = JCL, JCR
         IQ  = NCOL
         JQ  = JQ - 1
         DO I = IRI, IRF
            IQ  = IQ - 1
            BEAM(IQ,JQ) = VZ(I,J)
         END DO
      END DO
C
      RETURN
      END

      SUBROUTINE DISKPOS( ISCN, ISTA, LASTISCN )
Cf2py intent(in) ISCN, ISTA, LASTISCN
C
C     Routine for SCHED called by SCHTAPE that deals with the
C     accounting for disk based systems.  Basically it just gets
C     the byte count at the end of the scan.
C
C     Distinguish between core and extras.  But need to only count
C     extras that are before or after the core, not during.
C     Don't try to separate core from extra scans (see PREEMPT) here
C     because this routine is called before the handling of PREEMPT.
C
C     Note that GBYTES here is the value at the end of the scan when
C     this routine returns.  In the VEX file, the value shown needs
C     to be for the start of the scan.  AARG.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER   KS, ISCN, ISTA, KSTA, LASTISCN(MAXSTA)
      DOUBLE PRECISION  RECSTART
      REAL      RECTIME
C ---------------------------------------------------------------------
C     Initialize GBYTES and EGBYTES to the value at the start
C     of the scan.  Will add this scan below.
C
      IF( LASTISCN(ISTA) .EQ. 0 ) THEN
         GBYTES(ISCN,ISTA) = 0
      ELSE
         GBYTES(ISCN,ISTA) = GBYTES(LASTISCN(ISTA),ISTA)
      END IF
C
C     Now add on the contribution from this scan.
C
C     We've already selected on STASCN and NOREC before this routine
C     was called.
C
C     This has gotten somewhat more complicated the fact that 
C     STARTJ(ISCN) - TPSTART(ISCN,ISTA) is no longer the start of
C     recording for some VEX controlled stations.  These include
C     the VLA and the MARK5C system on the VLBA.
C     Also pay attention to NOREC.
C
      IF( NOREC(ISCN) ) THEN
         RECTIME = 0.D0
      ELSE
         KSTA = STANUM(ISTA)
         IF( USEONSRC(KSTA) ) THEN
            RECSTART = MAX( STARTJ(ISCN) - TPSTART(ISCN,ISTA), 
     1             TONSRC(ISCN,ISTA) )
         ELSE
            RECSTART = STARTJ(ISCN) - TPSTART(ISCN,ISTA)
         END IF
         RECTIME = DNINT( ( STOPJ(ISCN) - RECSTART ) * 86400.D0 )
      END IF
C
C     Get the actual bits recorded.  The factor 1000 is
C     the conversion from Mbps to Gbps.  Note that this is the
C     decimal version, not the binary one which may be what is
C     wanted.  The factor of 8 is the conversion to bytes.
C     Use WRTBPS here because it includes the FORMAT-specific
C     contribution from headers and we're interested in bytes on
C     the recording.
C
C     Nov. 1, 2013.  For some reason, the above comment previously
C     suggested not using WRTBPS here.  But the uses of GBYTES all
C     seem more appropriate with it and that is what was in the line
C     of code, so I changed the comment.  RCW.
C
      KS = NSETUP(ISCN,ISTA)
      IF( RECUSED(KS) ) THEN
         GBYTES(ISCN,ISTA) = GBYTES(ISCN,ISTA) + 
     1       RECTIME * WRTBPS(KS) / ( 1000.0 * 8. )
      END IF
C
      RETURN
      END

      LOGICAL FUNCTION VXCFSI( ISTA, JSTA )
C 
C     Routine specific for the VEX extension of SCHED. 
C     returns true if SI block in 2 SCHED STAs are identical
C     for now it always when ISTA and JSTA are identical
C     By H.J. van Langevelde, JIVE, 300496 
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER ISTA, JSTA
      LOGICAL IDENT
C ----------------------------------------------------------------------
C
      IDENT = .TRUE.      
C
C     Find out both the same station or not...
C
      IF( ISTA .NE. JSTA) IDENT = .FALSE.
C
      VXCFSI = IDENT 
C
      RETURN
      END

      SUBROUTINE VXWRST
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the ST = $STATION section 
C     By H.J. van Langevelde, JIVE, 300496 
C     Added pointing_sector.  RCW.  Jan. 7, 2014.
C     Removed pointing_sector - belongs in ANTENNA section.  Jan 23, 2014 RCW
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C      
      INTEGER   ISTA, ISCAT
      INTEGER   LEN1
C ----------------------------------------------------------------------
C
C     loop through antennas for STATION section
C
      WRITE( IVEX, '( A, A1 )' ) '$STATION', SEP
      DO ISTA = 1, NSTA
         ISCAT = STANUM(ISTA)
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1           STCODE(ISCAT)(1:LEN1(STCODE(ISCAT))), SEP
C
C        there is a difference between site and antenna
C        both are not mandatory, but we have things for both
C        do not write CLOCK section or station ID for now
C
         WRITE( IVEX, '( 5X, A, A, A1 )' ) 'ref $SITE = ',
     1       SILINK(ISTASI(ISTA))(1:LEN1(SILINK(ISTASI(ISTA)))), SEP
         WRITE( IVEX, '( 5X, A, A, A1 )' ) 'ref $ANTENNA = ',
     1       ANLINK(ISTAAN(ISTA))(1:LEN1(ANLINK(ISTAAN(ISTA)))), SEP
         WRITE( IVEX, '( 5X, A, A, A1 )' ) 'ref $DAS = ',
     1       DALINK(ISTADA(ISTA))(1:LEN1(DALINK(ISTADA(ISTA)))), SEP
C
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
C
      END DO
      WRITE( IVEX, '( A )' ) COMLIN
      RETURN
      END

      SUBROUTINE PGQINF( ITEM, VALUE, LENGTH )
C
C     Stub version for the PGPLOT routine that can deliver the PGPLOT
C     version number.
C
      CHARACTER   ITEM*(*), VALUE*(*)
      INTEGER     LENGTH
C ----------------------------------------------------------------------
      IF( ITEM .EQ. 'VERSION' ) THEN
         LENGTH = 4
         VALUE = '0.00'
      ELSE
         CALL PUTOUT( 'Stub version of PGQINF - bad ITEM request' )
         LENGTH = 4
         VALUE = '----'
      END IF
      RETURN
      END

       SUBROUTINE TDATECW(Y,M,D,JD,MNAME,DNAME)
C
C               Input: date (y/m/d) in Y,M,D   (may be 'unnormalized')
C               Output: 'normalized' date in Y/M/D, julian day
C               number at 12 hrs UT (JD), name of month (MNAME),
C               day of week (DNAME)
C
C               TJP  1978 March 8
C               RCW  1991 April 12  Convert to characters for MNAME and
C                                   DNAME
C
        CHARACTER MLIST(12)*3, MNAME*3, DNAME*3, DLIST(7)*3
Cf2py intent(out) MNAME
Cf2py intent(out) DNAME
        INTEGER MLENG(12), Y, M, D, JD, J, NYRM1, IC, NDAYS, LEAP, ML
Cf2py intent(in, out) Y
Cf2py intent(in, out) M
Cf2py intent(in, out) D
Cf2py intent(out) JD
        DATA MLIST/'Jan','Feb','Mar','Apr','May','Jun',
     1             'Jul','Aug','Sep','Oct','Nov','Dec'/
        DATA MLENG/31,28,31,30,31,30,31,31,30,31,30,31/
        DATA DLIST/'Mon','Tue','Wed','Thu','Fri','Sat','Sun'/
C
C               JD number at 12 hrs UT on Jan 0 of year Y
C               (Gregorian calendar)
C
        IF(M.GE.1 .AND. M.LE.12) GOTO 1
           Y = Y + (M-1)/12
           M = MOD(M-1,12)+1
           IF(M.LT.0) Y=Y-1
           IF(M.LT.0) M=M+12
    1   NYRM1=Y-1
        IC=NYRM1/100
        JD=1721425 + 365*NYRM1 + NYRM1/4 - IC + IC/4
C
C               Day number; is it a leap year?
C
        NDAYS=D
        IF(M.EQ.1) GOTO 20
        DO 10 J=2,M
   10   NDAYS=NDAYS+MLENG(J-1)
   20   LEAP=0
        IF((MOD(Y,4).EQ.0.AND.MOD(Y,100).NE.0).OR.(MOD(Y,400).EQ.0))
     1          LEAP=1
        IF(M.GT.2) NDAYS=NDAYS+LEAP
C
C               Return JD and DNAME
C
        JD=JD+NDAYS
        DNAME=DLIST(1+MOD(JD,7))
C
C               Convert back to M/D
C
        DO 30 J=1,12
        ML=MLENG(J)
        IF(J.EQ.2) ML=ML+LEAP
        IF(NDAYS.LE.ML) GOTO 40
   30   NDAYS=NDAYS-ML
        Y=Y+1
        M=1
        D=NDAYS
        GOTO 1
C
   40   M=J
        D=NDAYS
        MNAME=MLIST(J)
        RETURN
        END

      SUBROUTINE SBPAIR
C
C     This routine for SCHED, called by GETSET, determines if any
C     channels are from the same BBC at any station in a setup
C     file.  If so, it sets up arrays that will be used to cause
C     Doppler calculations to set the channels to the same LO
C     frequency.  Also it will balk if any station is being asked
C     in the setup file to set different frequencies into the same 
C     BBC.  The situations of concern arise when upper-lower 
C     sideband pairs are being used.
C
C     The Doppler calculations will not be allowed if channels
C     don't match between stations.  Exact matches are not required,
C     but each channel must correspond to one of the "logical"
C     channels for the setup file as determined by SFINFO.  Some
C     of the tests here are skipped if matches don't exist (OKXC 
C     false).
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER  KS, ICHN, KCHN, LEN1, ISETF, ILC, KLC
      LOGICAL  ERRS, WARN
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SBPAIR: starting' )
C
      ERRS = .FALSE.
      WARN = .FALSE.
      IF( .NOT. VLAONLY ) THEN
C
C        Initialize.  These are the "logical channels".
C
         DO ISETF = 1, NSETF
            DO ICHN = 1, MAXCHN
               SAMEBBC(ICHN,ISETF) = 0
            END DO
         END DO
C
C        Now loop through the setup groups.
C
         DO KS = 1, NSET
            ISETF = ISETNUM(KS)
            IF( NCHAN(KS) .GT. 1 ) THEN
C
C              Look at pairs of channels.
C
               DO ICHN = 2, NCHAN(KS)
                  DO KCHN = 1, ICHN - 1
C
C                    Select those that use the same BBC.
C
                     IF( BBC(ICHN,KS) .EQ. BBC(KCHN,KS) .AND. 
     1                   DAR(ISETSTA(KS)) .NE. 'NONE' ) THEN
C
C                       Balk at setting them to different frequencies.
C                       (LBA is different)
C
                        IF( BBSYN(ICHN,KS) .NE. BBSYN(KCHN,KS) .AND.
     1                      DAR(ISETSTA(KS)) .NE. 'LBA' ) THEN
                           WRITE( MSGTXT, '( A, I3, A, A, 2I3 )' )
     1                         'SBPAIR: Attempting to set BBC ',
     2                         BBC(ICHN,KS), ' to two frequencies,',
     3                         ' channels: ', ICHN, KCHN
                           CALL WLOG( 1, MSGTXT )
                           ERRS = .TRUE.
C                           
C                         For LBA just make sure they are selected from the
C                         same 64 MHz band (there are more constraints,
C                         but for now...)
C
                        ELSE IF( ABS(BBSYN(ICHN,KS) - BBSYN(KCHN,KS)) 
     1                           .GT. 64 .AND.
     2                           DAR(ISETSTA(KS)) .EQ. 'LBA' ) THEN
                           WRITE( MSGTXT, '( A, I3, A, A, 2I3 )' )
     1                         'SBPAIR: Attempting to set LBA BBC ',
     2                         BBC(ICHN,KS), 
     3                      ' to frequencies more than 64 MHz apart,',
     4                         ' channels: ', ICHN, KCHN
                           CALL WLOG( 1, MSGTXT )
                           ERRS = .TRUE.
                        END IF
C
C                       Cross check that corresponding logical
C                       channels share BBCs at different
C                       stations.
C
                        IF( OKXC(ISETF) ) THEN 
                           ILC = SFCHAN(ICHN,KS)
                           KLC = SFCHAN(KCHN,KS)
                           IF( SAMEBBC(ILC,ISETF) .NE. 0 .AND.
     1                         SAMEBBC(ILC,ISETF) .NE. KLC ) THEN
                              MSGTXT = ' '
                              WRITE( MSGTXT, '( 3A )' )
     1                         'SBPAIR: Assignment of BBCs to pairs',
     2                         ' of channels don''t seem consistent',
     3                         ' between stations.'
                              CALL WLOG( 1, MSGTXT )
                              MSGTXT = ' '
                              WRITE( MSGTXT, '( A, A, A, I3, A, I3 )' )
     1                          '    For ', SETSTA(1,KS), ', Channel',
     2                            ICHN, ' paired with channel ', KCHN
                              CALL WLOG( 1, MSGTXT )
                              MSGTXT = ' '
                              WRITE( MSGTXT, '( A, I3, A, I3 )' )
     1                          '    These are logical channels: ',
     2                          ILC, ' and ', KLC
                              CALL WLOG( 1, MSGTXT )
                              MSGTXT = ' '
                              WRITE( MSGTXT, '( A, I3, A, I3 )' )
     1                         '     For an earlier station, ', ILC, 
     2                         ' was paired with logical channel ', 
     3                         SAMEBBC(ILC,ISETF)
                              WARN = .TRUE.
                           END IF
                           SAMEBBC(ILC,ISETF) = KLC
                        END IF
                     END IF
                  END DO
               END DO
            END IF
C
C           Issue the warning.
C
            IF( ERRS .OR. WARN ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A )' ) 
     1            'SBPAIR: The problem occured in ',
     2            SETNAME(KS)(1:LEN1(SETNAME(KS)))
               CALL WLOG( 1, MSGTXT )
               IF( ERRS ) CALL ERRLOG( 
     1            'SBPAIR: Fix the problem and try again' )
            END IF
C
         END DO
C
      END IF
C
C
      RETURN
      END

      SUBROUTINE JPLPO2 (DATEP, NP, ELONG, PHI, HEIGHT, RA, RARAT,
     *                   DEC, DECRAT, DIST, OBSV)
C
C  Exact geocentric or topocentric apparent RA, RA rate, Dec, Dec rate,
C  and distance of a planet, in either J2000.0 or position of date.  
C  Based on section 3.3 of the Explanatory Supplement to the 
C  Astronomical Almanac.  Specifically, this subroutine performs the 
C  steps in equation 3.31-1 for positions of date, and 3.41-1 for 
C  positions of J2000.  For topocentric positions, the correction 
C  described in section 3.35 is performed.  The 4 different 
C  combinations of J2000/date/geocentric/topocentric correspond to
C  the following designations and sections in the Explanatory Suppl:
C    date+geocentric = 'Apparent-Place'; section 3.31
C    date+topocentric = 'Topocentric-Place'; section 3.35
C    J2000+geocentric = 'Virtual Place'; section 3.41
C    J2000+topocentric = 'Local Place'; section 3.42
C  This routine calls the very accurate JPL ephemeris routines.  The 
C  most current ephemeris at JPL is DE403 (as of 6/25/96), which is the 
C  one used by this routine.  Errors are very small, on the order of a 
C  few milliarcseconds (without rigorous testing, though...).
C
C  !!!NOTE!!!
C     This version of the ephemeris subroutine (JPLPO2) is a modified 
C     version of the standard subroutine (JPLPOS).  JPLPO2 is set up 
C     specifically to supply positions which, when used by either the 
C     VLA or the VLBA, will result in correct pointings for the planets.
C     For the VLA, desired coordinates are geocentric, of date 
C     (Apparent-Place).  The corrections applied by the on-line system
C     are the diurnal parallax and diurnal aberration.  So, 
C     gravitational deflection, annual aberration, precession, and 
C     nutation need to be included in the supplied geocentric positions.
C     For the VLBA, desired coordinates are topocentric, of J2000.0 
C     (Local Place).  The corrections applied by the on-line system are 
C     the gravitational deflection, the annual aberration, the 
C     precession, and the nutation.  So, the diurnal aberration needs 
C     to be included in the supplied positions.  Note that the way 
C     these supplied positions (with some included corrections) are 
C     processed by the on-line systems will cause some inaccuracy in 
C     the pointed positions, since the order in which these things are 
C     done will make a difference.  This inaccuracy should be small, 
C     though.
C  !!!END NOTE!!!
C
C  Inputs:
C   DATEP   = MJD of observation (JD - 2400000.5), in the TDT timescale
C   NP      = planet for which positions and rates are desired: 
C                1 = Mercury
C                2 = Venus
C                3 = Moon
C                4 = Mars
C                5 = Jupiter
C                6 = Saturn
C                7 = Uranus
C                8 = Neptune
C                9 = Pluto
C                else = Sun
C   ELONG   = observer's East longitude (rad)
C   PHI     = observer's geodetic latitude (rad)
C   HEIGHT  = observer's height above geoid (meters)
C   OBSV    = which observatory: 'VLA' or 'VLBA'
C
C  Outputs:
C   RA      = RA, for equinox and equator of J2000.0 or of date (rad)
C   DEC     = Dec, for equinox and equator of J2000.0 or of date (rad)
C   RARAT   = RA rate, for J2000.0 or date (seconds of time per UT day)
C   DECRAT  = Dec rate, for J2000.0 or date (seconds of arc per UT day)
C   DIST    = distance, for the desired date (AU)
C                               
C  Calls: sla_EPJ, sla_GMST, sla_EQEQX, sla_PRECL, sla_NUT, sla_DMXV,
C         sla_DCC2S, sla_DRANRM, PVOBS, PLEPH, FINDT, TRANSP
C
C    All sla_XXX routines are from the slalib library, PLEPH and related
C    routines are from the JPL software, PVOBS, FINDT and TRANSP are 
C    my own routines.
C
C  B J Butler    NRAO/VLA   summer 1996, modified summer 1997

      IMPLICIT NONE

c passed parameters:
      DOUBLE PRECISION DATEP, ELONG, PHI, HEIGHT, RA, DEC, DIST, 
     *                 RARAT, DECRAT
      INTEGER NP
      CHARACTER OBSV*(*)
c constants:
      DOUBLE PRECISION PI, CC, MU
      PARAMETER (PI = 3.14159265358979323846D0)
      PARAMETER (CC = 173.144633D0)
      PARAMETER (MU = 2.9591220788654D-4)
c time stuff:
      DOUBLE PRECISION JEDP, DATE, JED, TPRIME, MM, SS, TT, UT1, GMST,
     *                 GAST, DELTAT, FINDT
c position and velocity vectors:
      DOUBLE PRECISION EB(6), SB(6), EH(6), UB(6), UU(6), QQ(6), 
     *                 LITTLU(6), LITTLQ(6), LITTLE(6), VEC1(3), 
     *                 VEC2(3), PP(3), VV(3), U1(6), U2(6), U3(6), 
     *                 U4(6), LITTLG(6), BIGG(6), BIGG2(6)
c other stuff:
      DOUBLE PRECISION LITTIM, LITTIP, DU, DE, DQ, G1, G2, QDOTE, UDOTQ,
     *                 EDOTU, BETA, F1, F2, ARGV,
     *                 RMATP(3,3), RMATN(3,3)
      LOGICAL ISSUN, ISVLA
c slalib functions:
      DOUBLE PRECISION sla_GMST, sla_EQEQX, sla_EPJ, sla_DRANRM
      INTEGER CONVRT(0:9), OTHBOD, IP, II

      DATA CONVRT / 11, 1, 2, 10, 4, 5, 6, 7, 8, 9 /

c 3.311 Relevant Time Arguments
c step a
      JEDP = DATEP + 2400000.5D0
c step b
      TPRIME = (JEDP - 2451545.0D0) / 36525.0D0
c step c
      MM = (357.528D0 + 35999.050D0 * TPRIME) * 2.0D0 * PI / 360.0D0
c step d
      SS = 0.001658D0 * DSIN (MM + 0.1671D0 * DSIN (MM))
      JED = JEDP + SS / 86400.0D0
      DATE = JED - 2400000.5D0
      TT = (JED - 2451545.0D0) / 36525.0D0
      ISVLA = OBSV .EQ. 'VLA'
      IF (.NOT. ISVLA) THEN
c this is VLBA, so do topocentric part...
c step a of topocentric part
c   first, find deltaT, the difference between TDT and UT1
         DELTAT = FINDT (sla_EPJ (DATEP))
         UT1 = DATEP - DELTAT / 86400.0D0
c step d of topocentric part
         GMST = sla_GMST (UT1)
         GAST = GMST + sla_EQEQX (DATEP)
c        LST = GAST + ELONG
c steps b, e & f of topocentric part
         CALL PVOBS (PHI, ELONG, HEIGHT, GAST, LITTLG)
c step g of topocentric part
c   Nutation:
         CALL sla_NUT (DATE, RMATN)
c   transpose...  
         CALL TRANSP (RMATN)
c   apply:
         CALL sla_DMXV (RMATN, LITTLG, BIGG)
         CALL sla_DMXV (RMATN, LITTLG(4), BIGG(4))
c   Precession:
         CALL sla_PRECL (2000.0D0, sla_EPJ (DATE), RMATP)
c   transpose...  
         CALL TRANSP (RMATP)
c   apply:
         CALL sla_DMXV (RMATP, BIGG, BIGG2)
         CALL sla_DMXV (RMATP, BIGG(4), BIGG2(4))
c step h of topocentric part
c   barycentric position and velocity of the earth
         CALL PLEPH (JED, 3, 12, EB)
         DO II = 1, 6
            EB(II) = EB(II) + BIGG2(II)
         END DO
      ELSE
c step e
c 3.312 Ephemeris Data for the Earth and Sun
c step f
c   barycentric position and velocity of the earth
         CALL PLEPH (JED, 3, 12, EB)
      END IF
c   barycentric position and velocity of the sun
      CALL PLEPH (JED, 11, 12, SB)
c   form the heliocentric position of the earth
      DO II = 1, 3
         EH(II) = EB(II) - SB(II)
      END DO
c step g
c   first, classify the other body, and convert it to JPL's notation...
      IP = NP
      IF (IP .LT. 0 .OR. IP .GT. 9) IP = 0
      OTHBOD = CONVRT(IP)
      ISSUN = OTHBOD .EQ. 11
c   barycentric position and velocity of the desired body
      CALL PLEPH (JED, OTHBOD, 12, UB)
c 3.314 Geometric Distance Between Earth and Planet
c step h
c   first, distance
      DIST = DSQRT ((UB(1) - EB(1)) ** 2.0D0 +
     *              (UB(2) - EB(2)) ** 2.0D0 +
     *              (UB(3) - EB(3)) ** 2.0D0)
c   then, light-time
      LITTIP = DIST / CC
c 3.315 Geocentric Position of Planet, Accounting for Light-Time
c precalculate this one:
      DE = DSQRT (EH(1) ** 2.0D0 + EH(2) ** 2.0D0 + EH(3) ** 2.0D0)
      LITTIM = 0.0D0
      DO WHILE (DABS (LITTIM - LITTIP) .GE. 1.0D-8)
         LITTIM = LITTIP
c step i
c   barycentric position and velocity of the desired body
         CALL PLEPH (JED-LITTIP, OTHBOD, 12, UB)
c   barycentric position and velocity of the sun
         IF (.NOT. ISSUN) CALL PLEPH (JED-LITTIP, 11, 12, SB)
c step j
         DO II = 1, 3
c   geocentric position of the planet
            UU(II) = UB(II) - EB(II)
c   heliocentric position of the planet
            IF (.NOT. ISSUN) QQ(II) = UB(II) - SB(II)
         END DO
c step k
c   first, magnitudes of vectors
         DU = DSQRT (UU(1) ** 2.0D0 + UU(2) ** 2.0D0 + UU(3) ** 2.0D0)
         IF (.NOT. ISSUN) THEN
            DQ = DSQRT (QQ(1)**2.0D0 + QQ(2)**2.0D0 + QQ(3)**2.0D0)
c   the second term is due to the relativistic delay caused by the
c   Sun's gravitational field, so we only calculate it (and the
c   necessary other quantities) if we're not looking at the Sun itself.
            LITTIP = (DU + (2.0D0 * MU / CC ** 2.0D0) *
     *                DLOG ((DE + DU + DQ) / (DE - DU + DQ))) / CC
         ELSE
            LITTIP = DU / CC
         END IF
      END DO
c step l
c   barycentric position and velocity of the desired body
      CALL PLEPH (JED-LITTIP, OTHBOD, 12, UB)
c   barycentric position and velocity of the sun
      CALL PLEPH (JED-LITTIP, 11, 12, SB)
      DO II = 1, 6
c   geocentric position of the planet
         UU(II) = UB(II) - EB(II)
c   heliocentric position of the planet
         QQ(II) = UB(II) - SB(II)
      END DO
c if this is the sun itself, or if this is VLBA, then don't do
c the gravitational deflection calculation
      IF (ISSUN .OR. .NOT. ISVLA) THEN
         DO II = 1, 3
            U1(II) = UU(II)
         END DO
      ELSE 
c 3.316 Relativistic Deflection of Light
c step m
         DU = DSQRT (UU(1) ** 2.0D0 + UU(2) ** 2.0D0 + UU(3) ** 2.0D0)
         DQ = DSQRT (QQ(1) ** 2.0D0 + QQ(2) ** 2.0D0 + QQ(3) ** 2.0D0)
         DO II = 1, 3
            LITTLU(II) = UU(II) / DU
            LITTLQ(II) = QQ(II) / DQ
            LITTLE(II) = EH(II) / DE
         END DO
         G1 = 2 * MU / (CC * CC * DE)
         QDOTE = LITTLQ(1) * LITTLE(1) + LITTLQ(2) * LITTLE(2) +
     *           LITTLQ(3) * LITTLE(3) 
         G2 = 1.0D0 + QDOTE
c step n
         UDOTQ = LITTLU(1) * LITTLQ(1) + LITTLU(2) * LITTLQ(2) +
     *           LITTLU(3) * LITTLQ(3) 
         EDOTU = LITTLE(1) * LITTLU(1) + LITTLE(2) * LITTLU(2) +
     *           LITTLE(3) * LITTLU(3) 
         DO II = 1, 3
            VEC1(II) = UDOTQ * LITTLE(II)
            VEC2(II) = EDOTU * LITTLQ(II)
         END DO
         DO II = 1, 3
            U1(II) = DU * (LITTLU(II) + (G1/G2) * (VEC1(II) - VEC2(II)))
         END DO
      END IF
c 3.317 Aberration of Light
c step o
      DU = DSQRT (U1(1) ** 2.0D0 + U1(2) ** 2.0D0 + U1(3) ** 2.0D0)
      DO II = 1, 3
         PP(II) = U1(II) / DU
         IF (ISVLA) THEN
            VV(II) = EB(II+3) / CC
         ELSE
c here is the complication of wanting the diurnal aberration part, 
c but not the annual part for VLBA positions.  BIGG2 contains only the 
c diurnal rotation part of the entire relative velocity, so just use it.
            VV(II) = BIGG2(II+3) / CC
         END IF
      END DO
      ARGV = VV(1) * VV(1) + VV(2) * VV(2) + VV(3) * VV(3)
      BETA = DSQRT (1.0D0 - ARGV)
      F1 = PP(1) * VV(1) + PP(2) * VV(2) + PP(3) * VV(3) 
      F2 = 1.0D0 + F1 / (1 + BETA)
c step p
      DO II = 1, 3
         U2(II) = (BETA * U1(II) + F2 * DU * VV(II)) / (1.0D0 + F1)
      END DO
c XXX don't know for sure if this is right, but it seems so...  XXX
      DO II = 4, 6
         U2(II) = UU(II)
      END DO
c 3.318 Precession, & 3.319 Nutation 
      IF (ISVLA) THEN
c    step q
         CALL sla_PRECL (2000.0D0, sla_EPJ (DATE), RMATP)
c    step s
         CALL sla_NUT (DATE, RMATN)
c    step r
         CALL sla_DMXV (RMATP, U2, U3)
         CALL sla_DMXV (RMATP, U2(4), U3(4))
c    step t
         CALL sla_DMXV (RMATN, U3, U4)
         CALL sla_DMXV (RMATN, U3(4), U4(4))
      ELSE
         DO II = 1, 6
            U4(II) = U2(II)
         END DO
      END IF
c    step u
      CALL sla_DCC2S (U4, RA, DEC)
      RA = sla_DRANRM (RA)
      DIST = DSQRT (U4(1) ** 2.0D0 + U4(2) ** 2.0D0 + U4(3) ** 2.0D0)
c rates...
      RARAT = (U4(1) * U4(5) - U4(2) * U4(4)) /
     *        (U4(1) ** 2.0D0 + U4(2) ** 2.0D0)
c   convert to seconds of time per UT day:
      RARAT = 4.32D4 * RARAT / PI
      DECRAT = ((U4(6) * (U4(1) ** 2.0D0 + U4(2) ** 2.0D0)) -
     *          (U4(3) * (U4(1) * U4(4) + U4(2) * U4(5)))) /
     *         ((U4(1) * U4(1) + U4(2) * U4(2) + U4(3) * U4(3)) *
     *          DSQRT (U4(1) * U4(1) + U4(2) * U4(2)))
c   convert to seconds of arc per UT day:
      DECRAT = 6.48D5 * DECRAT / PI
      RETURN
      END

      SUBROUTINE VXTONE
C
C     Subroutine sets up names, and values of tones needed for Vex
C     because the cross-referencing is complicated, not done on the fly
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 130596 
C
C     Allow this to run with FORMAT='NONE' if OBSTYP='PTVLBA' - single
C     dish VLBA observations.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER IPH, IFQ, IIF, I, J, ICH, NUP, NLO, ILPH, ILFQ, ILIF
      INTEGER IMODE
C From commented code: INTEGER  VXGTST, ISET
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'VXTONE: Starting' )
C
C     first find out which PH, there are at least as many FQ sections
C
      DO IMODE = 1, NMDVEX
C 
C     first check that it is not using FORMAT=NONE
C     RCW  Dec 2011.  Remove this check so all scans can be configured.
C     The stations that don't want FORMAT=NONE scans will not be included
C     in them in the $SCHED section.
C
C         ISET = VXGTST( IMODE )
C         IF( FORMAT(ISET)(1:4) .NE. 'NONE' .OR. 
C     1       OBSTYP .EQ. 'PTVLBA' ) THEN
C
C          in this mode find all IPH for which there are all antennas
C
           DO I = 1, NMODPH(IMODE)
              IPH = IMODPH(I, IMODE)
              DO ILPH= 1, NSTAPH(IPH,IMODE)               
C
C             now find same antennas in one of the FQ in the same MODE
C
                 DO J = 1, NMODFQ(IMODE)
                    IFQ = IMODFQ(J, IMODE)
                    DO ILFQ= 1, NSTAFQ(IFQ,IMODE)
C
C                      matching stations define links.
C                      Huibhier...
C
                       IF( ISTAFQ(ILFQ,IFQ,IMODE) .EQ. 
     1                      ISTAPH(ILPH,IPH,IMODE) ) THEN
                          IF( FQTOPH(IFQ) .EQ. 0) THEN
                             FQTOPH(IFQ) = IPH
                          ELSE
                             IF( FQTOPH(IFQ) .NE. IPH ) THEN
                               CALL ERRLOG(
     2                           'VXTONE: different PHASE_CAL scheme '//
     3                           'within FREQUENCY block')
C
C                               when different phase cal schemes for
C                               different telescopes need to be enabled,
C                               the simplest thing is to have vxcffq to
C                               look at the tone and detection schemes.
C
                             END IF
                          END IF
                       END IF
                    END DO
                 END DO
C
C             loop PH stations
C
              END DO
           END DO
C                     END IF
      END DO
C
C     first find out which IF, there are at least as many FQ sections
C
      DO IMODE = 1, NMDVEX
C 
C     first check that it is not using FORMAT=NONE, unless it is a 
C     VLBA pointing project.
C     RCW Dec 2011.  Remove the FORMAT=NONE check here too.
C
C         ISET = VXGTST( IMODE )
C         IF( FORMAT(ISET)(1:4) .NE. 'NONE' .OR. 
C     1         OBSTYP .EQ. 'PTVLBA' ) THEN
C
C          in this mode find all IIF for which there are all antennas
C
           DO I = 1, NMODIF(IMODE)
              IIF = IMODIF(I, IMODE)
              DO ILIF= 1, NSTAIF(IIF,IMODE)               
C
C             now find same antennas in one of the FQ in the same MODE
C
                 DO J = 1, NMODFQ(IMODE)
                    IFQ = IMODFQ(J, IMODE)
                    DO ILFQ= 1, NSTAFQ(IFQ,IMODE)
C
C                      matching stations defined links.
C
                       IF( ISTAFQ(ILFQ,IFQ,IMODE) .EQ. 
     1                      ISTAIF(ILIF,IIF,IMODE) ) THEN
                          IF( FQTOIF(IFQ) .EQ. 0) THEN
                             FQTOIF(IFQ) = IIF
                          ELSE
C
C                            one FQ can refer to many IF, let's assume
C                            tones are identical and register first
C
                             IF( FQTOIF(IFQ) .NE. IIF ) THEN
                                IF( TONEINT(IIF) .NE. 
     1                              TONEINT(FQTOIF(IFQ)) ) THEN
                                   CALL ERRLOG(
     1                                 'VXTONE: sorry different LO '//
     2                                 'MUST have same TONE insertion')
                                END IF
                             END IF
                          END IF
                       END IF
                    END DO
                 END DO
C
C                loop IF stations
C
              END DO
           END DO
C                 END IF
C
C        loop Modes
C
      END DO
C
C     go through all PH sections
C
      DO IPH = 1, NPHVEX
C
C        find all FQ's that match
C
         DO IFQ = 1, NFQVEX
            IF( IPH .EQ. FQTOPH(IFQ) ) THEN
C     
C              Do  all channels and setup tonedetections
C
               CALL VXTON2(-1, FQISSET(IFQ), NVXCHN(IFQ), 
     1             VXLOSUM(1,IFQ), VXNETSID(1,IFQ), VXBBFILT(1,IFQ), 
     2             TONEINT(FQTOIF(IFQ)), NTONES(IPH), TONCHN(1,IFQ),
     3             NTONDET(1,IPH), ITONDET(1,1,IPH) )
C
C              Name the tone links, we have matching IPH and IFQ
C     
               NUP = 0
               NLO = 0
               DO I = 1, NTONES(IPH)
                  IF( TONEINT(FQTOIF(IFQ)) .GT. 1e-15 ) THEN
                     DO ICH = 1, NVXCHN(IFQ)
                        IF( TONCHN(ICH,IFQ) .EQ. I ) THEN
                           IF( VXNETSID(ICH,IFQ) .EQ. 'U' ) THEN
                              NUP = NUP + 1
                              WRITE( TONLNK(I,IPH), 
     1                             '( A1, I1, A3 )' ) 
     2                             'U', NUP, 'Cal'
                           ELSE
                              NLO = NLO + 1
                              WRITE( TONLNK(I,IPH), 
     1                             '( A1, I1, A3 )' ) 
     2                             'L', NLO, 'Cal'
                           END IF
C
C                          found 1 that's enough, jump out
C
                           GOTO 100
                        END IF
                     END DO
 100                 CONTINUE
                  ELSE
                     TONLNK(I,IPH) = 'NoCal'
                  END IF
               END DO
C
C           close matching FQ
C
            END IF
         END DO
C
C        if it is simply 1 up and/or 1 lo
C
         IF( NUP .EQ. 1 .OR. NLO .EQ. 1 ) THEN
            DO ICH = 1, NTONES(IPH)
               TONLNK(ICH,IPH)(2:2) = '_'
            END DO
         END IF
C     
      END DO
C
      RETURN
      END

      SUBROUTINE CHKVDIFX
C
C     Routine for SCHED called by DEFSET that checks that various
C     parameters are consistent with correlation on the VLBA DiFX
C     software correlator.
C
      INCLUDE     'sched.inc'
      INCLUDE     'schset.inc'
C
      INTEGER     KS, LEN1, ISET
      LOGICAL     WARNBW
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKVDIFX: starting.' )
C
C
      IF( ( CORREL(1:8) .EQ. 'VLBADIFX' .OR.
     1      CORREL(1:4) .EQ. 'VLBA' .OR.
     2      CORREL(1:7) .EQ. 'SOCORRO' ) .AND. .NOT. NOTAPE ) THEN
C
C        Give a short explanation of the style of average time chosen.
C
         IF( CAEXACT ) THEN
            CALL WRTMSG( 0, 'CHKVDIFX', 'CORAVGsetting1' )
         ELSE
            CALL WRTMSG( 0, 'CHKVDIFX', 'CORAVGsetting2' )
         END IF
C
C        Check for known formats.  Allow format NONE among the
C        normal recording formats.
C
         DO KS = 1, NSET
            IF( FORMAT(KS)(1:4) .NE. 'VLBA' .AND.
     1          FORMAT(KS)(1:6) .NE. 'MARK5B' .AND. 
     2          FORMAT(KS)(1:4) .NE. 'MKIV' .AND.
     3          FORMAT(KS)(1:4) .NE. 'VDIF' .AND.
     4          FORMAT(KS)(1:4) .NE. 'NONE' ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, A )' ) 
     1            'CHKVDIFX:  Socorro DIFX correlator does not ',
     2            'understand format: ', FORMAT(KS)(1:LEN1(FORMAT(KS)))
               CALL ERRLOG( MSGTXT )
            END IF
         END DO
C
C        Check for inappropriate number of channels.
C        We recommend 0.5 MHz per channel or less.  Warn about
C        cases where there are more.  Don't try too hard to get
C        all corners of parameters here - it's just a warning.
C
         WARNBW = .FALSE.
         DO ISET = 1, NSET
            IF( CORCHAN .LT. INT( BBFILT(1,ISET)*2.D0 - 0.1D0 ) ) THEN
               WARNBW = .TRUE.
            END IF
         END DO
         IF( WARNBW ) THEN
            CALL WLOG( 1, 'CHKVDIFX: Your CORCHAN request gives '//
     1         'more than 0.5 MHz per spectral channel for some '//
     2         'setup.' )
            CALL WLOG( 1, '          This may cause excessive '//
     1         'smearing with common a priori clock errors.' )
            CALL WLOG( 1, '          Consider using more channels.' )
         END IF
C
      END IF
C
      RETURN
      END

      SUBROUTINE CHARS( STRING, I1, I2, J1, J2 )
C
C     In STRING(I1:I2), determine the first (J1) and last (J2)
C     non-blank character.
C
      CHARACTER   STRING*(*)
      INTEGER     I1, I2, J1, J2, I, J
C ------------------------------------------------------------------
      J1 = 0
      DO I = I1, I2
         J = I2 + I1 - I
         IF( STRING(J:J) .NE. ' ' ) J1 = J
         IF( STRING(I:I) .NE. ' ' ) J2 = I
      END DO
C
      RETURN
      END

      SUBROUTINE SIDTIM( JULTIM, LONG, TWOPI, SIDDAY, LST, LSTDAY )
C
C     Routine for SCHED for calculating LST (or GMST).
C
C     Input: 
C        JULTIM      Julian time (eg, STARTJ or STOPJ in SCHED).
C        LONG        Longitude.  Give station longitude for LST. 
C                                Give 0.D0 for GMST.
C                    In SCHED, use LONG(STANUM(ISTA)).
C        TWOPI       ~2.D0 * 3.14159....  (SCHED keeps it in common).
C
C     Output:
C        SIDDAY      LST (GMST) day number as required for VLA 
C                    schedules.  Zero point set to match VLA schedules.
C        LST         The local sidereal time in radians (modulo 2pi).
C        LSTDAY      The LST day plus fractional day with the zero
C                    point the same as for SIDDAY.  This may be 
C                    useful for plotting.
C
C     The code closely follows SLA_GMST, but retains the full day
C     numbers.
C
      DOUBLE PRECISION  JULTIM, LONG, TWOPI, LST, LSTDAY
      INTEGER           SIDDAY
Cf2py intent(out) SIDDAY, LST, LSTDAY
      DOUBLE PRECISION  TU, S2R, GMSTD
C --------------------------------------------------------------------
C      call wlog( 0, 'sidtim starting' )
C
      S2R = TWOPI / 86400.D0
C     
C     Julian centuries from fundamental epoch J2000 to this UT
C     Note that a Julian century is defined as 36525 days rather than
C     the more realistic 365.242198781.  The Julian century is what
C     is used in the time axis for these calculations, as I understand
C     it.
C     
      TU = (JULTIM-51544.5D0)/36525.D0
C     
C     GMST at this UT.
C     
      GMSTD = JULTIM * TWOPI + ( 24110.54841D0 + (8640184.812866D0
     1    + ( 0.093104D0 - 6.2D-6 * TU ) * TU ) * TU ) * S2R 
C
C     Get the local sidereal time including a day.  I'm not sure what
C     the meaning of the zero is at this point.
C
      LSTDAY =  6713.D0 + ( GMSTD - LONG ) / TWOPI
C
C     Get the local sidereal day number as for VLA schedules.
C     Is this a well defined quantity?  Anyway, it matches the 
C     sidereal day numbers needed VLA schedules.  The constants
C     involved were determined by matching a specific schedule 
C     from OBSERV.
C
      SIDDAY = DINT( LSTDAY )
C
C     Get the LST modulo 24 hours (still radians).
C
      LST  = DMOD( LSTDAY, 1.D0 ) * TWOPI
C
      RETURN
      END

      SUBROUTINE CHKVLA( KS, ERRS )
Cf2py intent(in, out) ERRS
C
C     Subroutine for SCHED called by CHKSET that checks some
C     VLA specific setup file parameters.
C
C     If ERRS is returned as TRUE, CHKSET will give the setup
C     file name and then crash the program.
C
C     The VLA routines are getting major surgery for the switch from
C     the old VLA system to the new hardware.  The VLA now uses VEX for 
C     control and WIDAR for the DAR.  For now (Oct 2012), the VLA
C     is restricted to 4 channels.  Each must be from a separate
C     IF and they must be in polarization pairs.  The channels must
C     be net USB.  This is changing to 16 channels, four each from
C     each IF.  That is coming soon enough that this routine will
C     assume it is here (Dec. 28, 2012).
C
C     Conversion to new system started May 9, 2012 RCW.  
C     For the old code, look for versions of SCHED 10.1 or earlier.
C     More work in Oct. 2012.  RCW
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER     VMIF, MVFE
      PARAMETER   (VMIF=4)
      PARAMETER   (MVFE=10)
      CHARACTER   VIFNAME(VMIF)*1, VIFPOL(VMIF)*3
      CHARACTER   VBANDS(MVFE)*2, VBANDSL(MVFE)*2, VLBBANDS(MVFE)*4
      INTEGER     KS, ICH, JCH, NCIF(VMIF), IIF, NAC, NBD, ISCN
      INTEGER     ISETF, IB, LEN1
      LOGICAL     ERRS, GOTPAIR, IFOK
      DOUBLE PRECISION  VIFFLO(VMIF), VIFFHI(VMIF), FRMAX, FRMIN
      DOUBLE PRECISION  ACAVG, BDAVG
      DOUBLE PRECISION  VLFREQ(MVFE), VHFREQ(MVFE)
      DATA  VIFNAME  / 'A', 'B', 'C', 'D' /
      DATA  VIFPOL   / 'RCP', 'RCP', 'LCP', 'LCP' /
C
C     The following are the lower and upper frequencies for each band
C     in MHz.
C
      DATA  VLFREQ  / 0.D0, 200.D0, 900.D0, 2000.D0, 4000.D0, 8000.D0,
     1               12.D3, 18.D3, 26.5D3, 40.D3 /
      DATA  VHFREQ  / 200.D0, 900.D0, 2000.D0, 4000.D0, 8000.D0, 12.D3,
     2               18.D3, 26.5D3, 40.D3, 50.D3 /
C
C     The following are the official band names.
C
      DATA  VBANDS  / '4', 'P', 'L', 'S', 'C', 'X', 
     1                'Ku', 'K', 'Ka', 'Q' /
C
C       The following are used for testing because FE, on input, is
C       down-cased.  They will be converted to the above.
C
      DATA  VBANDSL / '4', 'p', 'l', 's', 'c', 'x', 
     1                'ku', 'k', 'ka', 'q' /
C
C       The following are the VLBA names.  If found, translate to VLA.
C
      DATA  VLBBANDS / 'NA', '50cm', '20cm', '13cm', '6cm', '4cm', 
     1                '2cm', '1cm', 'NA', '7mm' /


C  --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKVLA: Starting.' )
      ISETF = ISETNUM(KS) 
C
C     Get rid of the pre-EVLA inhibition against 24+ hr schedules due to 
C     no day number in the obs files.  Also remove "vlaover24" from 
C     messages.txt.  Dec. 28, 2012.  RCW
C
C     Check VLARFANT.  Not sure if this will do anything for VLA.
C     This parameter is not used for the new system, so ignore it.
C     Keep the code in case it comes back.
C
C      IF( VLARFANT .LT. 1 .OR. VLARFANT .GT. 28 ) THEN
C         SETMSG = ' '
C         WRITE( SETMSG, '( A, I7, A )' ) 'CHKVLA: VLARFANT ', 
C     1      VLARFANT, ' out of range 1 to 28.'
C         CALL WLOG( 1, SETMSG )
C         ERRS = .TRUE.
C      END IF
C
C      Check the format.  Must be VDIF.
C
       IF( FORMAT(KS)(1:4) .NE. 'VDIF' ) THEN
          CALL WLOG( 1, 'CHKVLA:  The recording format at the VLA '//
     1       'must be VDIF, not '//FORMAT(KS) )
          CALL ERRLOG( 'Change the FORMAT and try again.' )
       END IF
C
C     Check the maximum number of channels.
C     This is modified for the new 16 channel option  Dec. 28, 2012.
C     Embed the 16 channel check in separate 4 channel checks for each
C     IF.  If there are more than 16, it will fail that test.
C     Check the polarization spec while at it.
C     Also check the frequency range for each IF.  Assume upper sideband
C     here.  That will be checked later.
C
C     Initializations for summary info.
C
      DO IIF = 1, VMIF
         NCIF(IIF) = 0
         VIFFLO(IIF) = 1.D15
         VIFFHI(IIF) = 0.D0
         ACAVG = 0.D0
         BDAVG = 0.D0
         NAC = 0
         NBD = 0
      END DO
      FRMAX = 0.D0
      FRMIN = 1.D12
      DO ICH = 1, NCHAN(KS)
C
C        Initialize - bad IF spec until proven good!
C
         IFOK = .FALSE.
C
C        Get which IF this is.
C
         DO IIF = 1, VMIF
            IF( IFCHAN(ICH,KS) .EQ. VIFNAME(IIF) ) THEN
               NCIF(IIF) = NCIF(IIF) + 1
               IFOK = .TRUE.
C
C              Check polarization specification.
C
               IF( POL(ICH,KS) .NE. VIFPOL(IIF) ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A, A, A3, A, A3, A, 2I5 )' )
     1              'CHKVLA: VLA IF ', IFCHAN(ICH,KS), 
     2              ' is ', VIFPOL(IIF), ' but ', POL(ICH,KS), 
     3              ' requested for setup, channel ', KS, ICH
                  CALL WLOG( 1, MSGTXT )
                  ERRS = .TRUE.
               END IF
C
C              Get the minimum and maximum frequencies for the IF.
C              Recall that the VLA is always upper sideband.
C
               VIFFLO(IIF) = MIN( VIFFLO(IIF), FREQREF(ICH,KS) )
               VIFFHI(IIF) = MAX( VIFFHI(IIF), 
     1                            FREQREF(ICH,KS) + BBFILT(ICH,KS) )
               FRMAX = MAX( VIFFHI(IIF), FRMAX )
               FRMIN = MAX( VIFFLO(IIF), FRMIN )
               IF( VIFNAME(IIF) .EQ. 'A' .OR. 
     1             VIFNAME(IIF) .EQ. 'C' ) THEN
                  NAC = NAC + 1
                  ACAVG = ACAVG + FREQ(ICH,KS) + 0.5D0 * BBFILT(ICH,KS)
               ELSE IF( VIFNAME(IIF) .EQ. 'B' .OR. 
     1                  VIFNAME(IIF) .EQ. 'D' ) THEN
                  NBD = NBD + 1
                  BDAVG = BDAVG + FREQ(ICH,KS) + 0.5D0 * BBFILT(ICH,KS)
               END IF
            END IF
         END DO
C
C        Complain about an unrecognized IF name.
C
         IF( .NOT. IFOK ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I4, 3A )' )
     1          'CHKVLA: VLA baseband channel ', ICH, ' has IFCHAN ',
     2          IFCHAN(ICH,KS), ' which is not a VLA IF.'
            ERRS = .TRUE.
         END IF
      END DO
      IF( NAC .GT. 0 ) ACAVG = ACAVG / NAC
      IF( NBD .GT. 0 ) BDAVG = BDAVG / NBD
C
C     Now complain if any IF has too many channels and do other 
C     checks of the IFs.
C
      DO IIF = 1, VMIF
         IF( NCIF(IIF) .GT. 4 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A, I4, A, A )' )
     1          'CHKVLA: ', NCIF(IIF),
     2          ' channels were assigned to VLA IF ', VIFNAME(IIF),
     3          '  The maximum allowed is 4.'
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
C        Complain if frequency range is too high for IF's that got used.
C
         IF( NCIF(IIF) .GT. 0 .AND. 
     1       VIFFHI(IIF) - VIFFLO(IIF) .GT. 1024.D0 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A, A, A )' )
     1          'CHKVLA: Frequency range of channels assigned to ',
     2          'VLA IF ', VIFNAME(IIF), 
     3          ' span over 1024 MHz (', VIFFHI(IIF) - VIFFLO(IIF),
     4          ' MHz).' 
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
C        Deal with the VLA receiver names.  And complain if they
C        don't seem right.  Base this on the lowest frequency
C        requested for the IF.  Given that the frequencies span 
C        all of the logical space, one should stop somewhere in this
C        loop.
C
         IF( VIFFLO(IIF) .GT. VHFREQ(MVFE) ) THEN
            FE(IIF,KS) = 'omit'
         ELSE 
            DO IB = 1, MVFE
               IF( VIFFLO(IIF) .GT. VLFREQ(IB) .AND. 
     1             VIFFLO(IIF) .LE. VHFREQ(IB) ) THEN
                  IF( FE(IIF,KS) .EQ. ' ' .OR. 
     1                FE(IIF,KS) .EQ. 'omit' .OR.
     2                FE(IIF,KS) .EQ. VBANDSL(IB) .OR.
     3                FE(IIF,KS) .EQ. VLBBANDS(IB) ) THEN
                     FE(IIF,KS) = VBANDS(IB)
                  ELSE IF( FE(IIF,KS) .NE. VBANDS(IB) ) THEN
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( A, I5, 4A )' )
     1                  'CHKVLA: Apparently incorrect VLA FE name ',
     2                  'for setup:', KS, '.  Is: ', FE(IIF,KS),
     3                  '  Should be: ', VBANDS(IB)
                     CALL WLOG( 1, MSGTXT )
                     CALL ERRLOG( 'Fix VLA BAND name in setup'//
     1                   SETFILE(ISETF)(1:LEN1(SETFILE(ISETF))) )
                  END IF
               END IF
            END DO
         END IF
      END DO
C
C     Enforce AC > BD for F>18GHz and data requested from AC and BD.
C     Comment this out.  It only affects cases that won't be used for 
C     VLBI, like Ka band.  Leave the hook here in case we get Ka band
C     on the VLBA some day.
C
C      IF( FRMAX .GT. 18000.0 .AND. NAC .GT. 0 .AND. NBD .GT. 0 ) THEN
C         IF( BDAVG .GT. ACAVG ) THEN
C            CALL WLOG( 1, 'CHKVLA WARNING:  Above 18 GHz, '//
C     1               'it is best, and sometimes required, that the ' )
C            CALL WLOG( 1, MSGTXT )
C            CALL WLOG( 1, '                  VLA AC IFs be at '//
C     1               'higher frequencies than the BD IFs.' )
C            MSGTXT = ' '
C            WRITE( MSGTXT, '( 2A )' )
C     1                    '                  Please fix setup ', 
C     2         SETFILE(ISETF)(1:LEN1(SETFILE(ISETF)))
C            CALL WLOG( 1, MSGTXT )
C         END IF
C      END IF
C
C     Require dual polarization pairs.
C     Do this a bit crudely - go through all channels looking for the
C     partner.  This is twice as many checks as required, but it is
C     such a short loop it doesn't matter.
C     I am also not checking the frequency sets.  Maybe should.
C
      IF( NCHAN(KS) .GT. 1 ) THEN
         DO ICH = 1, NCHAN(KS)
            GOTPAIR = .FALSE.
            DO JCH = 1, NCHAN(KS)
               IF( ICH .NE. JCH .AND.
     1             FREQREF(ICH,KS) .EQ. FREQREF(JCH,KS) .AND.
     2             BBFILT(ICH,KS) .EQ. BBFILT(JCH,KS) .AND.
     3             POL(ICH,KS) .NE. POL(JCH,KS) .AND.
     4             NETSIDE(ICH,KS) .EQ. NETSIDE(JCH,KS) ) THEN
                  GOTPAIR = .TRUE.
               END IF
            END DO
            IF( .NOT. GOTPAIR ) THEN
               SETMSG = ' '
               WRITE( SETMSG, '( 2A, I4, A )' ) 
     1           'CHKVLA: At the VLA, baseband channels must be ', 
     2           'polarization pairs.  Channel ', ICH,
     3           ' does not have a partner.'
               CALL WLOG( 1, SETMSG )
               ERRS = .TRUE.
            END IF
         END DO      
      END IF
C
C     Require net upper sideband.
C
      DO ICH = 1, NCHAN(KS)
         IF( NETSIDE(ICH,KS) .NE. 'U' ) THEN
            SETMSG = ' '
            WRITE( SETMSG, '( 2A, I4, A )' ) 
     1        'CHKVLA: At the VLA, baseband channels must be ', 
     2        'net upper sideband.  Channel ', ICH,
     3        ' is not.'
            CALL WLOG( 1, SETMSG )
            ERRS = .TRUE.
         END IF
      END DO
C
C     Require that FE be set.
C
      DO ICH = 1, NCHAN(KS)
         IF( ( IFCHAN(ICH,KS).EQ.'A' .AND. FE(1,KS).EQ.'omit' ) .OR.
     1       ( IFCHAN(ICH,KS).EQ.'B' .AND. FE(2,KS).EQ.'omit' ) .OR.
     2       ( IFCHAN(ICH,KS).EQ.'C' .AND. FE(3,KS).EQ.'omit' ) .OR.
     3       ( IFCHAN(ICH,KS).EQ.'D' .AND. FE(4,KS).EQ.'omit' ) ) THEN
            SETMSG = ' '
            WRITE( SETMSG, '( 3A )' ) 
     1         'CHKVLA: FE not specified for IF ', IFCHAN(ICH,KS),
     2         ' at the VLA.'
            CALL WLOG( 1, SETMSG )
            ERRS = .TRUE.
         END IF
      END DO
C
C     Check VLAPTIME is 10 seconds or more.
C
      DO ISCN = SCAN1, SCANL
         IF( VLAPTIME(ISCN) .LT. 10 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A, I7, A, I5 )' )
     1         'CHKVLA:  VLA phase time (VLAPTIME) should be 10 sec ',
     2         'or more.', VLAPTIME(ISCN), ' s found on scan ', ISCN
            CALL ERRLOG( MSGTXT )
         END IF
      END DO
C
C     Consider checking the frequency ranges at some point, but it is not
C     critical for now because the VLA can hit any frequency that the VLBA
C     can.  The main problems will occur with the sideband restrictions 
C     which will not be compatible with WIDAR (USB) and the PFB on the VLBA
C     when the IF is upper sideband.  We will need the sideband inverting 
C     mode for that.
C
      RETURN
      END

      LOGICAL FUNCTION FSMATCH( KF, JF )
C
C     Check if two frequency sets are the same.
C     The frequency sets and the pulse cal sets need to have 
C     already been established.  This allows, for example, the 
C     xx.sum file to only list the details for one of the frequency
C     sets and just flag the rest as being the same.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
      INTEGER   KF, JF
      INTEGER   ICH, KS, JS, NNCHAN, NCCHAN
      LOGICAL   SAMESET
      DOUBLE PRECISION   KBBCFREQ(MCHAN), KBBCBW(MCHAN)
      DOUBLE PRECISION   KLOSUM(MCHAN)
      DOUBLE PRECISION   JBBCFREQ(MCHAN), JBBCBW(MCHAN)
      DOUBLE PRECISION   JLOSUM(MCHAN)
      INTEGER            KCRDN, JCRDN, KCRSETC(MAXCHN), JCRSETC(MAXCHN)
      DOUBLE PRECISION   KCRDF(MCHAN), KCRDB(MCHAN), KCRDLOSU(MCHAN)
      DOUBLE PRECISION   JCRDF(MCHAN), JCRDB(MCHAN), JCRDLOSU(MCHAN)
      CHARACTER          KCRDS(MCHAN)*1, JCRDS(MCHAN)*1
C -------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'FSMATCH starting' )
C
C     Get the setup group numbers these are from.
C
      KS = FSETKS(KF)
      JS = FSETKS(JF)
C
C     Initialize the output using FSMATCH, which checks if the
C     setup groups are basically the same except the station and
C     the information in the frequency set.  This also assures
C     that the number of channels is the same.
C
      FSMATCH = SAMESET( KS, JS )
C
C     Now compare the frequency set information as delivered
C     by FSFREQ.  This includes LOSUM, FREQ, and BW for the main
C     observing and the CRD parameters for the VLBA station
C     legacy systems.  The CRD parameters should automatically match
C     for non-VLBA stations because of the way FSFREQ deals with them.
C
      IF( FSMATCH ) THEN
         CALL FSFREQ( KF, KLOSUM, KBBCFREQ, KBBCBW,
     1         KCRDN, KCRDF, KCRDB, KCRDS, KCRDLOSU, KCRSETC )
         CALL FSFREQ( JF, JLOSUM, JBBCFREQ, JBBCBW,
     1         JCRDN, JCRDF, JCRDB, JCRDS, JCRDLOSU, JCRSETC )
C
C        Loop over the main setup channels.  Recall that SAMESET
C        assures that NCHAN(KS) = NCHAN(JS)
         NNCHAN = NCHAN(KS)
         DO ICH = 1, NNCHAN
            IF( ABS( KLOSUM(ICH) - JLOSUM(ICH) ) .GT. 1.0D-6 .OR.
     1          ABS( KBBCFREQ(ICH) - JBBCFREQ(ICH) ) .GT. 1.0D-6 .OR.
     2          ABS( KBBCBW(ICH) - JBBCBW(ICH) ) .GT. 1.0D-6 ) THEN
               FSMATCH = .FALSE.
            END IF
         END DO
C
C        Compare the CRD channels.
C
         FSMATCH = FSMATCH .AND. KCRDN .EQ. JCRDN
         NCCHAN = KCRDN
         IF( FSMATCH .AND. NCCHAN .GT. 0 ) THEN
            DO ICH = 1, NCCHAN
               IF( ABS( KCRDF(ICH) - JCRDF(ICH) ) .GT. 1.0D-6 .OR.
     1             ABS( KCRDB(ICH) - JCRDB(ICH) ) .GT. 1.0D-6 .OR.
     2             KCRDS(ICH) .NE. JCRDS(ICH) .OR.
     3             ABS( KCRDLOSU(ICH) - JCRDLOSU(ICH) ) .GT. 1.0D-6 ) 
     4                THEN
                  FSMATCH = .FALSE.
               END IF
            END DO
         END IF
      END IF
C
C     Check for same pcal generator setting.  Any specified pcalx 
C     settings are in the setup groups and compared there.  If those
C     have to be modified because of a scan specified PCAL, the nature
C     of the new ones is forced in FSFREQ by the setting of PCAL.
C     to check for same settings, it is only necessary that the 
C     frequency set and the PCAL setting are the same.
C
      FSMATCH = FSMATCH .AND. FSPCAL(KF) .EQ. FSPCAL(JF)
C
      RETURN
      END

      SUBROUTINE BBCALT( KS, MAXBBC, MAXIF, IFBBC, IFNAM, UBBC, NNBBC,
     1                   WARNING, CALLER )
C
C     Routine for SCHED called by BBCGEO, BBCM4, BBCVS2, BBCDBBC and
C     BBCLBA to assign BBC's to IF channels.  BBCGEO is for VLBA systems
C     with geodetic wiring.  BBCM4 is for Mark IV systems.  BBCVS2 is
C     for S2 systems attached to VLBA DAR's. BBCDBBC is for Hat-lab's
C     (Tuccari) DBBC. BBCLBA is for the Australian LBA DAS. They are
C     similar in many ways and the code needed to process them is the
C     same.  They differ in the wiring configurations as embodied in the
C     IFBBC and IFNAM arrays.  This routine is not used for VLBA systems.
C
C     Inputs are:
C        KS            Setup group
C        MAXBBC        The maximum number of BBCs available.
C        MAXIF         The maximum number of IFs available.
C        IFBBC         Array of flags (1,0) MAXBBC by MAXIF indicating
C                      whether the BBC can see the IF
C        IFNAM         The names of the IFs
C        CALLER        The calling subroutine name to help debugging.
C     Outputs are:
C        UBBC          Flag for BBCs that were assigned.
C        NNBBC         
C        WARNING       Text indicating the backend type.
C        
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    ICH, JCH, KS, IBBC, NNBBC, IIF, i
      INTEGER    MAXBBC, MAXIF, MAXIFI
      PARAMETER  (MAXIFI=8)
      INTEGER    IFBBC(MAXBBC,MAXIF)
      CHARACTER  IFNAM(MAXIF)*2, WARNING*(*), CHKNAM*2
      CHARACTER  IFINPUT(MAXIFI)*2, CALLER*(*)
      LOGICAL    UBBC(MAXBBC)
C -------------------------------------------------------------------  
      IF( DEBUG ) THEN
         MSGTXT = 'BBCALT starting. Called by '// CALLER
         CALL WLOG( 0, MSGTXT )
      END IF
C
C     Since MAXIF could not be used for IFINPUT, check that MAXIFI
C     is big enough.
C
      IF( MAXIF .GT. MAXIFI ) CALL ERRLOG( 'BBCALT:  MAXIF bigger '//
     1  'than MAXIFI - programming error' )
C
C     Initialize the array that flags used BBC's.
C
      DO IBBC = 1, NNBBC
         UBBC(IBBC) = .FALSE.
      END DO
C
C     Initialize the array that flags used IF inputs on the DBBC
C
      DO IIF = 1, MAXIF
         IFINPUT(IIF) = 'ZZ'
      END DO
C
C     Flag those that have been used.
C
      DO ICH = 1, NCHAN(KS)
         IF( BBC(ICH,KS) .GT. 0 ) UBBC(BBC(ICH,KS)) = .TRUE.
      END DO
C
C     Loop through channels assigning the channel to the
C     same BBC as a previous one with the same FREQREF and IFCHAN,
C     if there is one (can be difference sideband), or to a new BBC.
C
      DO ICH = 1, NCHAN(KS)
         IF( BBC(ICH,KS) .EQ. 0 .AND. ICH .GT. 1 ) THEN
            DO JCH = 1, ICH-1
               IF( FREQREF(ICH,KS) .EQ. FREQREF(JCH,KS) ) THEN
                  IF( IFCHAN(ICH,KS) .EQ. IFCHAN(JCH,KS) ) THEN
                     BBC(ICH,KS) = BBC(JCH,KS)
                     GO TO 100
                  ELSE IF( ALTIFC(ICH,KS) .EQ. IFCHAN(JCH,KS) ) THEN
                     BBC(ICH,KS) = BBC(JCH,KS)
                     IFCHAN(ICH,KS) = ALTIFC(ICH,KS)
                     GO TO 100
                  END IF
               END IF
            END DO
  100       CONTINUE
         END IF
C
C        If BBC is still 0, assign the next one that can see this IF.
C
         IF( BBC(ICH,KS) .EQ. 0 ) THEN
C
C           Find the next available BBC that can see this IFCHAN.
C           Take the alt chan if available and necessary.
C
            DO IBBC = 1, NNBBC
               IF( .NOT. UBBC(IBBC) ) THEN
                  DO IIF = 1, MAXIF
C
C                    For DBBC only first letter of IFCHAN is
C                    significant, unless an input has already been
C                    assigned for this IF.
C
C                    From Uwe Bach email of Dec. 7, 2013, at least at
C                    Effelsberg, RCP is on A1 and B1 while LCP is on
C                    A3 and B3.  So it looks like the number is also
C                    important.  The IFNAMs defined in BBCDBBC are
C                    A, B, C, D, so I'm not quite sure how this relates.
C                    I smell a possible naming mess.
C
C                    Meanwhile, I'm trying to force the IF names in
C                    hsa1cm.key and it is not accepting what I give.
C                    So at least fix that.
C
                     CHKNAM = IFNAM(IIF)
                     IF( WARNING .EQ. 'DBBC' ) THEN
                        IF( IFINPUT(IIF) .EQ. 'ZZ' ) THEN
                           CHKNAM = CHKNAM(1:1)//IFCHAN(ICH,KS)(2:2)
                        ELSE
                           CHKNAM=IFINPUT(IIF)
                        END IF
                     END IF
C
                     IF( IFCHAN(ICH,KS) .EQ. CHKNAM .AND.
     1                   IFBBC(IBBC,IIF) .EQ. 1 ) THEN
                        BBC(ICH,KS) = IBBC                  
                        UBBC(IBBC) = .TRUE.
                        IFINPUT(IIF) = IFCHAN(ICH,KS)
                        GO TO 200
                     END IF
                     IF( WARNING .EQ. 'DBBC' ) THEN
                        IF( IFINPUT(IIF) .EQ. 'ZZ' ) THEN
                           CHKNAM = CHKNAM(1:1)//ALTIFC(ICH,KS)(2:2)
                        ELSE
                           CHKNAM=IFINPUT(IIF)
                        END IF
                     END IF
C
                     IF( ALTIFC(ICH,KS) .EQ. CHKNAM .AND.
     1                   IFBBC(IBBC,IIF) .EQ. 1 ) THEN
                        BBC(ICH,KS) = IBBC                  
                        UBBC(IBBC) = .TRUE.
                        IFCHAN(ICH,KS) = ALTIFC(ICH,KS)
                        IFINPUT(IIF) = IFCHAN(ICH,KS)
                        GO TO 200
                     END IF
                  END DO
               END IF
            END DO
C
C           If get here, did not assign a BBC.
C
            CALL WLOG( 1, ' ' )
            CALL WLOG( 1, 'BBCALT:  BBC setting problem: ' )
            CALL WLOG( 1, '         Setup file: '//SETNAME(KS) )
            CALL WLOG( 1, '         Station: '//SETSTA(1,KS) )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I3, A, A, A, A, A, I3 )' )
     1          '         ICHAN=', ICH, '  IFNAME=', IFCHAN(ICH,KS), 
     2          '  ALTIFC=', ALTIFC(ICH,KS), '  NNBBC=', NNBBC
            CALL WLOG( 0, MSGTXT )
            CALL WRTMSG( 0, 'BBCALT', 'noassignbbc' )
            IF( ICH .GT. 5 ) CALL WLOG( 1, 
     1          '         Maybe too many channels are requested'//
     2          ' for the same IF channel.' )
C
C           A number of special cases need more explanation.
C
            IF( WARNING .EQ. 'GEO1' .OR. WARNING .EQ. 'GEO2' ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( 3A )' ) '        ',
     1           'Note that ''geodetic'' VLBA systems',
     2           ' have restrictions on IF assignments.' 
               CALL WLOG( 0, MSGTXT )
               CALL WLOG( 0, '        See IFCHAN in the manual.' )
            END IF
            IF( WARNING .EQ. 'GEO2' ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( 3A )' ) '        ',
     1           '  They also cannot use 2 bits from more than 8 BBCs.'
               CALL WLOG( 0, MSGTXT )
            END IF
            IF( WARNING .EQ. 'S2' ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A )' )
     1                'Note that the S2 system is not hooked to all ',
     2                'BBCs.'              
               CALL WLOG( 0, MSGTXT )
            END IF
            CALL ERRSET( KS )
C
         END IF
C
C        Jump here when have an assignment.
C
  200    CONTINUE
C
      END DO
C
      RETURN 
      END

      SUBROUTINE SCHSUM( RESTART )
C
C     This routine generates a summary listing.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER     I, ISCN, ISTA, KSTA, JSTA, KS, JS, ICH, LEN1
      INTEGER     YEAR, DAY, DOY, JD, MONTH
      INTEGER     NSCHED, MJD
      LOGICAL     RESTART, GOTSCN
      LOGICAL     PRTHEAD, PRTED(MSET), SAMESET, DUPSET
      DOUBLE PRECISION   STOP
      CHARACTER   DNAME*3, MNAME*3
      CHARACTER   FF*1, PDATE*50
      INTEGER     LENGTH
      REAL        VEXVER, VXVER, PLTVER, JPVER
      CHARACTER   PGVER*8, LINE*128, EXTIME*30
C-----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SCHSUM: Starting.' )
      FF = CHAR(12)
      DO KS = 1, MSET
         PRTED(KS) = .FALSE.
      END DO
C
C     Set up a date line.
C
      CALL TIMEJ( STOPJ(1), YEAR, DOY, STOP )
      MONTH = 1
      DAY = DOY
      CALL TDATECW( YEAR, MONTH, DAY, JD, MNAME, DNAME )
      MJD = INT( JD - 2400000.5 )
      WRITE( PDATE, '( A, I3, A, A3, I4, 1X, A3, I5, A, I6 )' )
     1         'Day ', DOY, ' is ',  DNAME, DAY, MNAME, YEAR,
     2    '   MJD ', MJD
C
C     Open the summary file and write some initial stuff.
C
      CALL SUMOPE( RESTART, PDATE, MJD )
C
C     Get the number of scans actually scheduled, taking into
C     account those that might have been skipped.
C
      NSCHED = 0
      DO ISCN = SCAN1, SCANL
         GOTSCN = .FALSE.
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) GOTSCN = .TRUE.
         END DO
         IF( GOTSCN) NSCHED = NSCHED + 1
      END DO
C
C     Add some experiment summary information.  This will come
C     out just before of the setup file information.
C
      WRITE( ISUM, '( 1X, /, 1X, /, 1X, /, 1X )' )
      WRITE( ISUM, '( A )' ) 'EXPERIMENT SUMMARY:'
      WRITE( ISUM, '( A, I6 )' )  
     1        '  Number of input scans:     ', NSCANS
      WRITE( ISUM, '( A, I6 )' )  
     1        '  Number of scans scheduled: ', NSCHED
      WRITE( ISUM, '( A, I6 )' )
     1        '  Number of stations:        ', NSTA
      WRITE( ISUM, '( A, I6 )' )
     1        '  Number of sources input:   ', NSRC
      WRITE( ISUM, '( A, I6 )' )
     1        '  Number of setup files used:', NSETF
      WRITE( ISUM, '( 1X )' )
C
C     Write some information about each station.
C
      CALL STSUM
C
C     Write the setup information for setup groups that were used.
C     Avoid repeats of identical setups, but let the user know which
C     are identical.
C
      WRITE( ISUM, '( 1X, /, 1X, /, A )' )
     1   ' SETUP FILES:'
C
      IF( NOSET ) THEN
         WRITE( ISUM, '( 1X, /, A, /, A )' )
     1    'NOSETUP specified.  No setups used. ',
     2    '        Cannot write telescope control files. '
      ELSE
         DO KS = 1, NSET
            IF( .NOT. PRTED(KS) ) THEN
               IF( KS .LT. NSET ) THEN
                  PRTHEAD = .TRUE.
                  LINE = ' '
                  IF( KS .LT. NSET ) THEN
                     DO JS = KS + 1, NSET
C
C                       If setups KS and JS are the same except for
C                       the station, note that to user and flag
C                       JS not to be printed in the future.  SAMESET
C                       doesn't test recording medium, so test that
C                       too.  Do call tape and disk stations the same
C                       for non-recording setups (eg pointing).
C                       FORTRAN: Parentheses around the .EQV. required
C                       or previous logicals evaluated as left side.
C
                        KSTA = ISCHSTA(ISETSTA(KS))
                        JSTA = ISCHSTA(ISETSTA(JS))
                        DUPSET = SAMESET( KS, JS ) .AND.
     1                   ( ( .NOT. RECUSED(KS) .AND. .NOT. RECUSED(JS) )
     2                   .OR. ( USEDISK(KSTA) .EQV. USEDISK(JSTA) ) )
C
                        IF( DUPSET ) THEN
C
                           PRTED(JS) = .TRUE.
C
C                          Keep track of which got a full listing.
C                          To this point, LISTKS(KS) was set to KS.
C                          For the printed one (KS here maybe), this
C                          doesn't change.  For JS, set to KS if dup.
C
                           LISTKS(JS) = KS
C
                           IF( PRTHEAD ) THEN
                              WRITE( ISUM, '( 1X,/,1X,/, A, A, I4, A )')
     1                          'The following setup groups ',
     2                          'are the same as group', KS, ' below.'
                              PRTHEAD = .FALSE.
                           END IF
C
C                          Deal with a need for more than one line.
C
                           ICH = LEN1(LINE) + 1
                           IF( ICH .GT. 65 ) THEN
                              WRITE( ISUM, '( A )' ) LINE(1:ICH-1)
                              ICH = 1           
                              LINE = ' '
                           END IF
C
C                          Add this station to the line.
C
                           WRITE( LINE(ICH:ICH+12), '( I4, A, A )' )
     1                          JS, ':', SETSTA(1,JS)
                        END IF
                     END DO
                  END IF
C
C                 Write out any accumulated stations in LINE.
C
                  ICH = LEN1( LINE )
                  IF( ICH .GT. 2 ) THEN
                     WRITE( ISUM, '( A )' ) LINE(1:ICH)
                  END IF
C
               END IF
C
C              Write the setup file details if this one needs it.
C
               CALL PRTSET( KS, ISUM )
               PRTED(KS) = .TRUE.
C
            END IF
         END DO
      END IF
C
C     Write the main scan listings.
C
      CALL SUMSCN( PDATE )
C
C     Produce a summary of the range of times and total bytes
C     at each station.  Versions before Feb. 2008 made a summary
C     of tape change times here, but that has been removed/modified.
C
      IF( VLBITP ) WRITE( ISUM, '( A )' ) FF
      IF( VLBITP .AND. .NOT. NOSET ) THEN
         CALL TPSUM( .TRUE. )
      END IF
C
C     Add a source list including one in a format for addition to
C     the correlator data base.
C
      CALL SRCLST( ISUM, 2 )
C
C     Note the configuration breaks for generating correlator blocks.
C     No longer needed.  Subroutine deleted (still in SVN and old
C     versions in case it is needed.
C      CALL CORBLK
C
C     Write the available catalog versions.
C
      WRITE( ISUM, '( 1X, /, 1X, /, A )' ) 
     1     'CATALOGS, FILES, and CODE VERSIONS'
C
      WRITE( ISUM, '( 1X, /, A )' )
     1   'Catalogs: '  
C
      WRITE( ISUM, '( A, A / A, A )' )
     1   '  Station:   ', STAFILE(1:LEN1(STAFILE)),
     2   '                 Version:  ', STVER(1:LEN1(STVER))
      WRITE( ISUM, '( A, A / A, A )' )
     1   '  Location:  ', LOCAFILE(1:LEN1(LOCAFILE)), 
     2   '                 Version:  ', LOCAVER(1:LEN1(LOCAVER))
C
      WRITE( ISUM, '( A, A / A, A )' )
     1   '  Frequency: ', FREQFILE(1:LEN1(FREQFILE)),
     2   '                 Version:  ', FREQVER(1:LEN1(FREQVER))
C
      WRITE( ISUM, '( A, A / A, A )' )
     1   '  Source:   ', SRCFILE(1:LEN1(SRCFILE)),
     2   '                 Version:  ', SRVER(1:LEN1(SRVER))
      WRITE( ISUM, '( A, A / A, A )' )
     1   '  Source2:  ', SRCFILE2(1:LEN1(SRCFILE2)),
     2   '                 Version:  ', SRVER2(1:LEN1(SRVER2))
C
C     Other external files.
C
      WRITE( ISUM, '( 1X, /, 1X, /, A )' )
     1   'Other external files: '  
C
      WRITE( ISUM, '( A, A )' )
     1   '  Ephemeris: ', EPHFILE(1:LEN1(EPHFILE))
C
      WRITE( ISUM, '( A, A )' )
     1   '  PEAKFILE:  ', PEAKFILE(1:LEN1(PEAKFILE))
C
      WRITE( ISUM, '( A, A )' )
     1   '  MSGFILE:   ', MSGFILE(1:LEN1(MSGFILE))
C
      IF( NSAT .GT. 0 ) THEN
         DO I = 1, NSAT
            WRITE( ISUM, '( A, A )' )
     1      '  SATNAME:   ', SATNAME(I)(1:LEN1(SATNAME(I)))
            IF( SATFILE(I)(1:4) .NE. 'NONE' ) THEN
               WRITE( ISUM, '( A, A )' )
     1           '     SATFILE:   ', SATFILE(I)(1:LEN1(SATFILE(I)))
            END IF
            IF( TLEFILE(I)(1:4) .NE. 'NONE' ) THEN
               WRITE( ISUM, '( A, A )' )
     1           '     TLEFILE:   ', TLEFILE(I)(1:LEN1(SATFILE(I)))
            END IF
            WRITE( ISUM, '( A, A )' )
     1      '     KERFILE:   ', KERFILE(I)(1:LEN1(KERFILE(I)))
         END DO
      END IF
C
C     Finish off with the code versions.
C
      WRITE( ISUM, '( 1X, /, 1X, /, A )' )
     1   'Code versions: '  
C
      WRITE( ISUM, '( A, F6.2, 2X, A )' )
     1   '  Release version:          ', VERNUM, 
     2   VERSION(1:LEN1(VERSION))
C
      CALL VXVERS( VXVER, VEXVER )
      WRITE( ISUM, '( A, F5.2 )' )
     1   '  Version of VEX standard:  ', VEXVER
C
      WRITE( ISUM, '( A, F5.2 )' )
     1   '  Version of VEX code:      ', VXVER
C
      CALL PLVER( PLTVER )
      WRITE( ISUM, '( A, F5.2 )' )
     1   '  Version of plot code:     ', PLTVER
C
      CALL JPLVER( JPVER )
      WRITE( ISUM, '( A, F5.2 )' )
     1   '  Version of ephemeris code:', JPVER
C
C     Get the pgplot version.  Note that there is a special
C     version of PGQINF in the Plotstub directory in case
C     pgplot is not available.
C
C     Note for future:  Problems with the PGPLOT installation can
C     cause execution to go into an infinite loop here.  I had to
C     rebuild the PGPLOT libraries Jan. 14, 2012 to get past this.
C     To my knowledge, I had done nothing to trigger the problem
C     except maybe some software updates for the OS.
C
      IF( DEBUG ) CALL WLOG(1, 'SCHSUM calling PGQINF. '//
     1    'Trouble here can mean wrong PGPLOT_DIR' )
      CALL PGQINF( 'VERSION', PGVER, LENGTH ) 
      WRITE( ISUM, '( A, A )' )
     1   '  Version of PGPLOT:        ', PGVER(1:LENGTH)
C
C     Write the time of execution.
C
      CALL FDATE( EXTIME )
      WRITE( ISUM, '( 1X, /, A, A )' ) 'This schedule produced on: ',
     1    EXTIME
C
C     Close the summary file.
C
      CLOSE( UNIT=ISUM )
      RETURN
      END

      SUBROUTINE VXSTNM( NAMEIN, SERIOUS )
C
C     routine to check NAMEIN is a valid (unquoted) VEX string
C     suitable for VEX def/ref name, alter if necessary
C     no blanks, etc, 32 chars, produces warning if SERIOUS
C     H.J. van Langevelde, JIVE 121200 (from VXSTRN)
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      CHARACTER NAMEIN*(*)
      LOGICAL SERIOUS
C
      CHARACTER NAMORI*32
      INTEGER LPOS, I, LENGTH, ISTART
      LOGICAL CHRFND, CHANGED
      INTEGER LEN1
C ----------------------------------------------------------------------
C
      CHANGED = .FALSE.
      NAMORI = NAMEIN
      IF( NAMEIN .EQ. ' ' ) NAMEIN = 'Nescio'
      LENGTH = LEN(NAMEIN)
C
C     search for leading blanks
C
      DO LPOS = 1, LENGTH
         IF( NAMEIN(LPOS:LPOS) .NE. BLN ) GOTO 50
      END DO
   50 CONTINUE
      ISTART = LPOS
C
C     remove leading blanks
C
      IF( ISTART .NE. 1 ) THEN
         DO LPOS = 1, LENGTH + 1 - ISTART
            NAMEIN(LPOS:LPOS) = NAMEIN(LPOS+ISTART-1:LPOS+ISTART-1)
         END DO
         DO LPOS = LENGTH - ISTART + 1, LENGTH
            NAMEIN(LPOS:LPOS) = BLN
         END DO
      END IF
C
C     search for first blank, if followed by non blanks change to _
C
      DO LPOS = 1, LENGTH
         IF( NAMEIN(LPOS:LPOS) .EQ. BLN ) THEN
            CHRFND = .FALSE.
            DO I = LPOS+1, LENGTH
               IF( NAMEIN(I:I) .NE. BLN) CHRFND = .TRUE.
            END DO
            IF( CHRFND ) THEN
               NAMEIN(LPOS:LPOS) = '_'
               CHANGED = .TRUE.
            ELSE
C
C              nothing left to do, jump out
C
               GOTO 100         
            END IF
         END IF
      END DO
  100 CONTINUE
C
C     characters &, :, ; $ * are reserved in VEX, I reserve #
C     for numbering, change all occurences to X
C
      DO LPOS = 1, LENGTH
         IF( NAMEIN(LPOS:LPOS) .EQ. COL .OR.
     1       NAMEIN(LPOS:LPOS) .EQ. SEP .OR.
     2       NAMEIN(LPOS:LPOS) .EQ. LNK .OR. 
     3       NAMEIN(LPOS:LPOS) .EQ. '$' .OR.
     4       NAMEIN(LPOS:LPOS) .EQ. COM .OR.
     5       NAMEIN(LPOS:LPOS) .EQ. '#' ) THEN
            CHANGED = .TRUE.
            NAMEIN(LPOS:LPOS) = 'X'
         END IF
      END DO
C
      IF( LENGTH .GT. 32 ) THEN
         DO LPOS = 33, LENGTH
            NAMEIN(LPOS:LPOS) = BLN
         END DO
      END IF
C
      IF( CHANGED .AND. (SERIOUS .OR. DEBUG)) THEN
         WRITE( MSGTXT , '( A, A )' )
     1        'VXSTNM: Changed VEX string: ', NAMORI(1:LEN1(NAMORI))
         CALL WLOG( 1, MSGTXT )
         WRITE( MSGTXT , '( A, A )' )
     1        'VXSTNM:                 to: ', 
     2        NAMEIN(1:LEN1(NAMEIN))
         CALL WLOG( 1, MSGTXT )
      END IF
C     
      RETURN
      END

      SUBROUTINE SOCDEF( CHPOL )
C
C     A routine for SCHED, called by GETCOR, that checks that the
C     required correlator parameters have been specified for the
C     VLBA correlator in Socorro.  SCHED intentionally forces the
C     user to think about the values of these parameters rather than
C     just setting reasonable defaults.  This is for both the original
C     hardward correlator and the DiFX software correlator.
C
      INCLUDE 'sched.inc'
C
      LOGICAL    MISCOR
      CHARACTER  CHPOL*(*), PRTPOL*3
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SOCDEF starting.' )
      MISCOR = .FALSE.
C
C     First abort if FXCORR chosen.  That is the original VLBA FX
C     correlator and it no longer exists.
C
      IF( CORREL(1:6) .EQ. 'FXCORR' ) THEN
         CALL ERRLOG( 'SOCDEF:  The original VLBA correlator FXCORR '//
     1     'no longer exists.  Choose another CORREL.' )
      END IF
C
      IF( CORAVG .EQ. 0.0 ) THEN
         MISCOR = .TRUE.
         CALL WLOG( 1, '        Correlator average time missing.' )
      END IF
C
      IF( CORCHAN .EQ. 0 ) THEN
         MISCOR = .TRUE.
         CALL WLOG( 1, '        Number of correlator spectral '//
     1        'channels not specified' )
      END IF
C
      IF( CORNANT .EQ. 0 ) THEN
C        Don't make this one fatal.         MISCOR = .TRUE.
         CORNANT = NSTA
         CALL WLOG( 1, '        Had to set the number of antennas '//
     1      'to be correlated to the number in the schedule.' )
      END IF
C
      IF( CHPOL(1:2) .NE. 'ON ' .AND. CHPOL(1:3) .NE. 'OFF' ) THEN
         MISCOR = .TRUE.
         PRTPOL = CHPOL
         CALL WLOG( 1, '        Invalid polarization spec: ' // 
     1         PRTPOL )
      END IF
C
C
C     Deal with case where parameters weren't provided.
C
      IF( MISCOR ) THEN
         CALL WLOG( 1, 'SOCDEF:  Correlator parameters are '//
     1      'required for VLBI' )
         CALL WLOG( 1, '         observations to be processed in '//
     1          'Socorro.' )
         CALL WLOG( 1, '         The defaults are only used for '//
     1          'projects to be processed elsewhere.' )
C
C        Allow plotting, but not output files.
C
         IF( PLOT ) THEN
            MISSING = .TRUE.
         ELSE
            CALL ERRLOG( 'Add correlator info and try again.' )   
         END IF
      END IF
C
      RETURN
      END

      LOGICAL FUNCTION VXCFAN( ISTA, JSTA )
C 
C     Routine specific for the VEX extension of SCHED. 
C     returns true if AN block in 2 SCHED STAs are identical
C     but maybe could have generic telescopes, like VLBA
C     By H.J. van Langevelde, JIVE, 300496 
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER ISTA, JSTA
      LOGICAL IDENT
C ----------------------------------------------------------------------
C
      IDENT = .TRUE.      
C
C     Find out both rolls
C
      IF( ISTA .NE. JSTA ) IDENT = .FALSE.
C
      VXCFAN = IDENT 
C
      RETURN
      END

      SUBROUTINE VXWRGL
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the GL = $GLOBAL section 
C     By H.J. van Langevelde, JIVE, 300496 
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C      
      INTEGER   LEN1
      CHARACTER TMPEXP*32
C ----------------------------------------------------------------------
C
C     Write $GLOBAL section is trivial but probably mandatory
C
      TMPEXP = EXPCODE
      CALL VXSTNM(TMPEXP,.FALSE.)
      WRITE( IVEX, '( A, A1, /, 5X, A, A, A1 )' ) '$GLOBAL', SEP,
     1     'ref $EXPER = ', TMPEXP(1:LEN1(TMPEXP)), SEP
C
C     write the revision code in comment
C
      WRITE( IVEX, '( A1, 54X, A14 )' ) COM, '+------------+'
      WRITE( IVEX, '( A1, 25X, A, 10X, A1, F10.4, 2X, A1 )' ) COM, 
     1    'PI revision number:', '|', SCHVER, '|'
      WRITE( IVEX, '( A1, 54X, A14 )' ) COM, '+------------+' 
C
C     start with mode in comment
C
      IF( OBSMODE .NE. ' ' ) 
     1     WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'mode:       ', 
     2     OBSMODE(1:LEN1(OBSMODE))      
C
      WRITE( IVEX, '( A )' ) COMLIN
      RETURN
      END

      SUBROUTINE VXDEFS
C
C     Routine specific for the VEX extension of SCHED. 
C     Writes the different $sections in the VEX output, except $SCHED
C     I think this is a logical order...
C     By H.J. van Langevelde, JIVE, 301196 
C     Labeled by RCW, Nov 2011, after too much confusion.
C
      INCLUDE 'sched.inc'
C ----------------------------------------------------------------------
C
C     Global
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on GL def ')
      CALL VXWRGL
C
C     Experiment
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on EX def ')
      CALL VXWREX
C
C     Mode
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on MD def ')
      CALL VXWRMD
C
C     Station
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on ST def ')
      CALL VXWRST
C
C     Procedures
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on PR def ')
      CALL VXWRPR
C
C     Sites
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on SI def ')
      CALL VXWRSI
C
C     Antennas.
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on AN def ')
      CALL VXWRAN
C
C     DAS
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on DA def ')
      CALL VXWRDA
C
C     Source
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on SU def ')
      CALL VXWRSU
C
C     Frequencies.
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on FQ def ')
      CALL VXWRFQ
C
C     IFs
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on IF def ')
      CALL VXWRIF
C
C     BBCs
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on BB def ')
      CALL VXWRBB
C
C     Phase cal.
C
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on PH def ')
      CALL VXWRPH
C
C     Tracks  (This is needed in practice, if not in principle,
C     for OBSTYP=PTVLBA.  There is code in the routine to 
C     provide dummy data for such projects).
C      
      IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on TR def ')
      CALL VXWRTR
C
C     Skip the following for single dish.  They are also not
C     needed for the RDBE, I believe, but deal with that 
C     later.  RCW  Nov 2011.
C
      IF( .NOT. OBSTYP .EQ. 'PTVLBA' ) THEN
C      
C        Head positions
C      
         IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on HP def ')
         CALL VXWRHP
C      
C        Pass order
C      
         IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on PO def ')
         CALL VXWRPO
C      
C        Roll
C      
         IF (DEBUG) CALL WLOG( 1,'   VXDEFS: Start on RL def ')
         CALL VXWRRL
C
      END IF
C
      RETURN
      END

      SUBROUTINE LSTFREQ( IPRT, SFREQ, SBBC, SBW, ICH1, NCHL, ILINE,
     1       MLL, MFRL, DOWRTF, DOWRTB, LABFR, LABBB, LABBW )
C
C     Routine to write the lists of frequencies in the summary file,
C     sch files, and maybe elsewhere.  Called by PRTSCH, PRTFREQ.
C
C     This used to be simple formatted writes in the parent routines.
C     But the need to deal with a possible large number of significant 
C     figures with the DDC made it much more complicated so it was
C     put here.
C
C     Note that for most uses, we want lists with about 8 frequencies
C     per line.  But the OMS file wants everything on one line.
C     Hence MLL and MFRL are inputs.
C
C     Parameters (all input - output is to print file).
C        IPRT - output file unit number
C        SFREQ - the channel LO sums
C        SBBC  - the channel BBC frequencies
C        SBW   - the channel bandwidths
C        ICH1  - the number of characters reserved for the line labels.
C        NCHL  - the number of channels
C        ILINE - the line of the page we're on.
C        MLL   - the maximum line length
C        MFRL  - the maximum number of frequencies per line.
C        DOWRTF - logical - write the LO sums and BB frequencies
C        DOWRTB - logical - write the bandwidths.
C        LABFR  - label for frequency line
C        LABBB  - label for the baseband freq line.
C        LABBW  - label for the bandwidth line
C
      INTEGER            IPRT, ICH1, NCHL, ILINE, INLINE
      INTEGER            NPER, NFC1, NFCN, MLL, MFRL
      INTEGER            MCH, ICH, IFREQ
      INTEGER            LEN1
      LOGICAL            DOWRTF, DOWRTB
      DOUBLE PRECISION   SFREQ(*), SBBC(*), SBW(*)
      CHARACTER          PRLINE*1024, FRTXT*16
      CHARACTER          LABFR*(*), LABBB*(*), LABBW*(*)
C -------------------------------------------------------------------
      NPER = 7
C
C     Sanity check.
C
      IF( MLL .GT. 1025 ) CALL ERRLOG( 'LSTFREQ: Line too long' )
C
C     Get the length of the first item printed to help with 
C     formatting.
C
      CALL FRCHAR( SFREQ(1), NPER, NFC1, NFCN, FRTXT )
      MCH = NFC1
C
C     Write the frequencies.
C
      IF( DOWRTF ) THEN
         PRLINE = ' '
         PRLINE = LABFR
         ICH  = ICH1
         INLINE = 0
         DO IFREQ = 1, NCHL
            CALL FRCHAR( SFREQ(IFREQ), NPER, NFC1, NFCN, FRTXT )
            NFC1 = MIN( NFC1, MCH )
            IF( ICH+NFCN-NFC1 .GT. MLL .OR. INLINE .GE. MFRL  ) THEN
               WRITE( IPRT, '( A )' ) PRLINE(1:ICH)
               ILINE = ILINE + 1
               PRLINE = ' '
               ICH = ICH1
               INLINE = 0
            END IF
            PRLINE = PRLINE(1:ICH)//'  '//FRTXT(NFC1:NFCN)
            ICH = MAX( LEN1( PRLINE ), ICH1 )
            INLINE = INLINE + 1
         END DO
         IF( ICH .GT. ICH1 ) THEN
            WRITE( IPRT, '( A )' ) PRLINE(1:ICH)
            ILINE = ILINE + 1
         END IF
C
         PRLINE = ' '
         PRLINE = LABBB
         ICH  = ICH1
         INLINE = 0
         DO IFREQ = 1, NCHL
            CALL FRCHAR( SBBC(IFREQ), NPER, NFC1, NFCN, FRTXT )
            NFC1 = MIN( NFC1, MCH )
            IF( ICH+NFCN-NFC1 .GT. MLL .OR. INLINE .GE. MFRL  ) THEN
               WRITE( IPRT, '( A )' ) PRLINE(1:ICH)
               ILINE = ILINE + 1
               PRLINE = ' '
               ICH = ICH1
               INLINE = 0
            END IF
            PRLINE = PRLINE(1:ICH)//'  '//FRTXT(NFC1:NFCN)
            ICH = MAX( LEN1( PRLINE ), ICH1 )
            INLINE = INLINE + 1
         END DO
         IF( ICH .GT. ICH1 ) THEN
            WRITE( IPRT, '( A )' ) PRLINE(1:ICH)
            ILINE = ILINE + 1
         END IF
      END IF
C
C     Write the bandwidths.
C
      IF( DOWRTB ) THEN
         PRLINE = ' '
         PRLINE = LABBW
         ICH  = ICH1
         INLINE = 0
         DO IFREQ = 1, NCHL
            CALL FRCHAR( SBW(IFREQ), NPER, NFC1, NFCN, FRTXT )
            NFC1 = MIN( NFC1, MCH )
            IF( ICH+NFCN-NFC1 .GT. MLL .OR. INLINE .GE. MFRL  ) THEN
               WRITE( IPRT, '( A )' ) PRLINE(1:ICH)
               ILINE = ILINE + 1
               PRLINE = ' '
               ICH = ICH1
               INLINE = 0
            END IF
            PRLINE = PRLINE(1:ICH)//'  '//FRTXT(NFC1:NFCN)
            ICH = MAX( LEN1( PRLINE ), ICH1 )
            INLINE = INLINE + 1
         END DO
         IF( ICH .GT. ICH1 ) THEN
            WRITE( IPRT, '( A )' ) PRLINE(1:ICH)
            ILINE = ILINE + 1
         END IF
      END IF
C
C
      RETURN
      END

      SUBROUTINE VLBACHAR( LABEL, NCL, NCHAN, ARRAY, OLDARRAY, 
     1                    OLDCHAN, FIRSTS, IUVBA ) 
C
C     Routine to put an array of setup parameters into a VLBA style
C     control file.  This one is for character variables. 
C
C     Only NCHAN channels will be written.  The current array will be
C     tested against the most recent one and only channels that have
C     changed will be written.  LABEL*NCL is the keyword for the output
C     record (eg SIDEBAND) and IUVBA is the output unit number.  
C     OLDARRAY should be dimensioned the same as ARRAY.  If the 
C     number of channels changes, write out all information for the 
C     new ones.
C
C     Some hoop jumping is done to avoid writing blanks.
C
      CHARACTER   LABEL*(*), OUTLINE*80, FMT1*4, FMT2*4
      CHARACTER   FMTCH*4, ARRAY(*)*(*), OLDARRAY(*)*(*)
      INTEGER     NCHAN, OLDCHAN, KCHAR, NCHAR, LEN1, NCL, NCA
      INTEGER     I, ICHADD, IUVBA
      LOGICAL     FIRSTS, WRTLAB
      SAVE        FMT1, FMT2
C
      DATA        FMT1, FMT2  / '(I1)', '(I2)' /
C----------------------------------------------------------------------
      NCHAR = 0
      WRTLAB = .TRUE.
      IF( FIRSTS ) OLDCHAN = 0
      DO I = 1, NCHAN
C
C        Does this channel need to be processed?
C
         IF( ( FIRSTS .OR. ARRAY(I) .NE. OLDARRAY(I) .OR. I.GT.OLDCHAN)
     1        .AND. ARRAY(I) .NE. 'omit' ) THEN
C
C           Get the format and number of digits needed for the channel 
C           number.
C
            IF( I .LE. 9 ) THEN
               FMTCH = FMT1
               ICHADD = 1
            ELSE
               FMTCH = FMT2
               ICHADD = 2
            END IF
C
C           Get the number of characters in ARRAY(I)
C           Protect against a blank requesting write to a substring
C           of negative length.
C
            NCA = MAX( LEN1( ARRAY(I) ), 1 )
C
C           Get the number of characters for this point.
C
            KCHAR = ICHADD + NCA + 4
            IF( NCHAR + KCHAR .GT. 80 ) THEN
C
C              Write out the previous line.
C
               WRITE( IUVBA, '(A)' ) OUTLINE(1:NCHAR)
C
               NCHAR = 0
               WRTLAB = .TRUE.
            END IF
C
C           Write the beginning of the line.
C
            IF( WRTLAB ) THEN
               OUTLINE = ' '
               NCHAR = NCL
               OUTLINE(1:NCHAR+1) = LABEL(1:NCL)//'='
               NCHAR = NCHAR + 1
               WRTLAB = .FALSE.
            ELSE
               OUTLINE(NCHAR+1:NCHAR+1) = ','
               NCHAR = NCHAR + 1
            END IF
C
C           Write in the actual data point
C
            OUTLINE(NCHAR+1:NCHAR+1) = '('
            WRITE( OUTLINE(NCHAR+2:NCHAR+ICHADD+1), FMTCH ) I
            NCHAR = NCHAR + ICHADD + 2
            OUTLINE(NCHAR:NCHAR) = ','
            WRITE( OUTLINE(NCHAR+1:NCHAR+NCA), '(A)' ) 
     1             ARRAY(I)(1:NCA)
            NCHAR = NCHAR + NCA + 1
            OUTLINE(NCHAR:NCHAR) = ')'
C
         END IF
C
C        Arrange to sense changes next time.
C
         OLDARRAY(I) = ARRAY(I)
C
      END DO
C
C     Record number of channels
C
      OLDCHAN = NCHAN
C
C     Write out the last line.
C
      IF( NCHAR .GT. 0 ) WRITE( IUVBA, '(A)' ) OUTLINE(1:NCHAR)
C
      RETURN
      END

      SUBROUTINE SETHW1( KS )
C
C     Routine for SCHED that sets some hardware items that can 
C     be set at the time this routine is called by SETDEFS.
C
C     Removed from SETCHAN as part of effort to isolate hardware
C     dependencies.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
      INTEGER           ICH, KS
C ---------------------------------------------------------------------
C     If the polarization is now known and RCHAN and LCHAN were set,
C     the IFCHAN can now be set.
C
      DO ICH = 1, NCHAN(KS)
         IF( POL(ICH,KS)(1:3) .EQ. 'RCP' .AND. RCHAN(KS) .NE. ' ' .AND.
     1       IFCHAN(ICH,KS) .EQ. ' ' ) THEN
            IFCHAN(ICH,KS) = RCHAN(KS)
         END IF
         IF( POL(ICH,KS)(1:3) .EQ. 'LCP' .AND. LCHAN(KS) .NE. ' ' .AND.
     1       IFCHAN(ICH,KS) .EQ. ' ') THEN
            IFCHAN(ICH,KS) = LCHAN(KS)
         END IF
      END DO
C
C     Not much here yet.
C
      RETURN
      END

      SUBROUTINE CHKV4DAR( KS, ERRS )
Cf2py intent(in, out) ERRS
C
C     Routine for SCHED called by CHKSET that checks a few specific
C     restrictions on the VLBA4 racks, original VLBAG racks with a MkIV
C     formatter.
C     By H.J. van Langevelde, JIVE, 151099 
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER    KS, ICH, IIF, IBBC
      LOGICAL    ERRS, OK, SOMEBAD
C
      INTEGER    MAXBBC, MAXIF, I
      PARAMETER  (MAXBBC=14)
      PARAMETER  (MAXIF=4)
      INTEGER    IFBBC(MAXBBC,MAXIF)
      CHARACTER  IFNAM(MAXIF)*2
      DATA  (IFBBC(I,1),I=1,MAXBBC) / 1,1,1,1,1,1,1,1,0,0,0,0,0,0 /
      DATA  (IFBBC(I,2),I=1,MAXBBC) / 1,1,0,0,0,0,0,0,1,1,1,1,1,1 /
      DATA  (IFBBC(I,3),I=1,MAXBBC) / 1,1,1,1,1,1,1,1,0,0,0,0,0,0 /
      DATA  (IFBBC(I,4),I=1,MAXBBC) / 1,1,0,0,0,0,0,0,1,1,1,1,1,1 /
      DATA  (IFNAM(I),I=1,MAXIF) / 'A', 'B', 'C', 'D' /
C
C     Note that the above data statement is also in BBCGEO.  Changes
C     should be made in both places.
C ---------------------------------------------------------------------
      IF( SDEBUG ) CALL WLOG( 1, 'CHKV4DAR: Starting.' )
C
C
C
      IF( VLBITP .AND. FORMAT(KS) .NE. 'NONE' ) THEN
         IF( FORMAT(KS) .NE. 'MARKIII' .AND. 
     1       FORMAT(KS) .NE. 'MKIV1:1' .AND. 
     2       FORMAT(KS) .NE. 'MKIV1:2' .AND.
     3       FORMAT(KS) .NE. 'MKIV1:4' .AND. 
     4       FORMAT(KS) .NE. 'MKIV2:1' .AND.
     5       FORMAT(KS) .NE. 'MKIV4:1' .AND.
     6       FORMAT(KS) .NE. 'MARK5B' .AND.
     7       FORMAT(KS) .NE. 'S2' ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A)' )
     1          'CHKV4DAR: Invalid FORMAT for wideband observing '//
     2          '(see OBSTYPE): ', FORMAT(KS)
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
      END IF
C
C     Loop through the channels checking IF assignments.
C
      SOMEBAD = .FALSE.
      DO ICH = 1, NCHAN(KS)
C
C        See if this channel uses an allowed IF given the wiring
C        constraints embodied in the IFBBC array.
C
         OK = .FALSE.
         IBBC = BBC(ICH,KS)
         DO IIF = 1, MAXIF
            IF( IFNAM(IIF) .EQ. IFCHAN(ICH,KS) .AND. 
     1          IFBBC(IBBC,IIF) .EQ. 1 ) OK = .TRUE.
         END DO
C
C        Give warnings if it was not allowed.
C
         IF( .NOT. OK ) THEN
            SOMEBAD = .TRUE.
            SETMSG = ' '
            WRITE( SETMSG, '( 3A, I4 )' )
     1          'CHKV4DAR: Illegal IF input ', IFCHAN(ICH,KS),
     2          ' for VLBA4 geodetic type VLBA rack, channel ', ICH
            CALL WLOG( 1, SETMSG )
            ERRS = .TRUE.
         END IF
C
      END DO
      IF( SOMEBAD ) THEN
         SETMSG = ' '
         WRITE( SETMSG, '( 2A )' )
     1       '         Be careful of special wiring restrictions ',
     2       'for these DARs.' 
         CALL WLOG( 1, SETMSG )
      END IF
C
C     For VLBA 4 no need to check number of bits is restricted to first 8
C
      RETURN
      END

      SUBROUTINE OMSSTA
C
C     Routine for SCHED that writes station information for OMS
C     at the VLBA correlator.
C
      INCLUDE       'sched.inc'
      INCLUDE       'schset.inc'
C
      INTEGER            ISTA, KSTA, ISCN 
      CHARACTER          TFORM*8, TIME1*8, TIME2*8
      DOUBLE PRECISION   START1, STOPL, START, STOP
      INTEGER            DAY1, DAY2, YEAR1, YEAR2
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'OMSSTA starting' )
C
      DO ISTA = 1, NSTA
C
C        Get the first and last times.  Also use this to determine
C        if anything should be done for this station or if it
C        really wasn't used.
C
         START1 = 1.0D10
         STOPL = 0.D0
         DO ISCN = SCAN1, SCANL
            IF( STASCN(ISCN,ISTA) .AND. .NOT. NOREC(ISCN) ) THEN
               START1 = MIN( START1, STARTJ(ISCN) )
               STOPL  = MAX( STOPL,  STOPJ(ISCN) )
            END IF
         END DO
         IF( START1 .NE. 1.0D10 ) THEN
C
C           Now process the station.  Start by getting the index
C           in the station catalog.
C
            KSTA = STANUM(ISTA)
C
            WRITE( IOMS, '( 1X, /, A, /, 1X )' )
     1          'BEGIN = STATION_INFO'
C
            WRITE( IOMS, '( A, A )' )  '    STATION_ID         = ',
     1          STCODEU(KSTA)
            WRITE( IOMS, '( A, A )' )  '    STATION_NAME       = ',
     1          STATION(KSTA)
C
            WRITE( IOMS, '( A )' ) '    TAPES              =   0'
            WRITE( IOMS, '( A )' ) '    PASSES             =    0'
            WRITE( IOMS, '( A, F7.1 )' ) '    DISK               = ',
     1         TGBYTES(ISTA)
C
C           Get the first and last times.
C
            START1 = 1.0D10
            STOPL = 0.D0
            DO ISCN = SCAN1, SCANL
               IF( STASCN(ISCN,ISTA) .AND. .NOT. NOREC(ISCN) ) THEN
                  START1 = MIN( START1, STARTJ(ISCN) )
                  STOPL  = MAX( STOPL,  STOPJ(ISCN) )
               END IF
            END DO
            CALL TIMEJ( START1, YEAR1, DAY1, START )
            CALL TIMEJ( STOPL, YEAR2, DAY2, STOP )
            TIME1 = TFORM( START, 'T', 0, 2, 2, '::@' )
            TIME2 = TFORM( STOP, 'T', 0, 2, 2, '::@' )
            WRITE( IOMS, '( A, I4, A, I3.3, A, A )' ) 
     1             '    START              = ', YEAR1, '-', DAY1, 
     2             '/', TIME1
            WRITE( IOMS, '( A, I4, A, I3.3, A, A )' ) 
     1             '    STOP               = ', YEAR2, '-', DAY2, 
     2             '/', TIME2
C
            WRITE( IOMS, '( 1X, /, A, /, 1X )' )
     1          'END = STATION_INFO'
C
         END IF
C
      END DO
C
      RETURN
      END

      LOGICAL FUNCTION SAMESET( KS, JS )
C
C     Compare setup group KS with group JS to determine if they 
C     are the same.
C
C     This will be used, for example, to help prevent a lot of 
C     repetition in the summary file when different stations have
C     the same setup (like VLBA stations).
C
C     In the comparison, don't compare:
C       Station name
C       Frequency set info
C
C     But do compare the CONTROL and DAR.  Not comparing these 
C     caused problems with the display of frequency set parameters
C     when EB and GB were treated as the same.  (added Mar. 3, 2014 RCW)
C
C     Provide several spots to skip tests if SA becomes false - just
C     jump to the end.
C 
      INTEGER   KS, JS, I, ICH, IIF, ITP, IPC
      INTEGER   LEN1, KSTN, JSTN
      LOGICAL   SA, LOCDBG
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      PARAMETER  (LOCDBG=.FALSE.)
C ---------------------------------------------------------------------
      IF( SDEBUG .OR. LOCDBG ) THEN
         WRITE( MSGTXT, '( A, I4, A, I4 )' )
     1      'SAMESET: Starting on setups ', KS, ' and ', JS
            CALL WLOG( 0, MSGTXT(1:LEN1(MSGTXT)) )
            MSGTXT = ' '
      END IF
C
C     Assume guilty unless proven otherwise.  SA true means they
C     are the same.
C
      SA = .TRUE.
C
C     Are we even using the same sort of hardware?
C
      SA = SA .AND.
     1     DBE(KS) .EQ. DBE(JS) .AND.
     2     FIRMFILE(KS) .EQ. FIRMFILE(KS)
C
C     First gross tests of setup file and number of channels.
C     Having channels equal allows simpler loops later.
C
      SA = SA .AND. ISETNUM(KS) .EQ. ISETNUM(JS) .AND.
     1     NCHAN(KS) .EQ. NCHAN(JS)
      IF ( .NOT. SA ) THEN
         IF( LOCDBG ) CALL WLOG( 0, 'SAMESET: setnum or nchan' )
         GO TO 999 
      END IF
C
      DO ICH = 1, NCHAN(KS)
         SA = SA .AND.
     1        SFCHAN(ICH,KS)  .EQ. SFCHAN(ICH,JS) .AND.
     2        SGCHAN(ICH,KS)  .EQ. SGCHAN(ICH,JS) .AND.
     3        FREQREF(ICH,KS) .EQ. FREQREF(ICH,JS) .AND.
     4        FIRSTLO(ICH,KS) .EQ. FIRSTLO(ICH,JS) .AND.
     5        FIFMIN(ICH,KS)  .EQ. FIFMIN(ICH,JS) .AND.
     6        FIFMAX(ICH,KS)  .EQ. FIFMAX(ICH,JS)
      END DO
C
C     Don't worry about the pointing offsets since they don't appear
C     in the outputs dependent on SAMESET.  Leave the commented
C     code here in case it matters some day.
C
C     SA = SA .AND.
C    1     AZCOLIM(KS) .EQ. AZCOLIM(JS) .AND.
C    2     ELCOLIM(KS) .EQ. ELCOLIM(JS) .AND.
C    3     PTINCR(KS)  .EQ. PTINCR(JS)  .AND.
C    4     PTOFF(KS)   .EQ. PTOFF(JS)
C
      DO ICH = 1, NCHAN(KS)
         SA = SA .AND.
     1        BBSYN(ICH,KS)  .EQ. BBSYN(ICH,JS)  .AND.
     2        BBSYN2(ICH,KS) .EQ. BBSYN2(ICH,JS) .AND.
     3        BBFILT(ICH,KS) .EQ. BBFILT(ICH,JS)
      END DO
      IF ( .NOT. SA ) THEN
         IF( LOCDBG ) CALL WLOG( 0, 'SAMESET: before bbfilt' )
         GO TO 999 
      END IF
C
      SA = SA .AND.
     1     SAMPRATE(KS) .EQ. SAMPRATE(JS) .AND.
     2     SYNTH(1,KS)  .EQ. SYNTH(1,JS)  .AND.
     3     SYNTH(2,KS)  .EQ. SYNTH(2,JS)  .AND.
     4     SYNTH(3,KS)  .EQ. SYNTH(3,JS)  .AND.
     7     FANOUT(KS)   .EQ. FANOUT(JS)
C
      SA = SA .AND.
     1     SPEEDUP(KS)  .EQ. SPEEDUP(JS)  .AND.
     2     BESTOVER(KS) .EQ. BESTOVER(JS) .AND.
     3     TOTBW(KS)    .EQ. TOTBW(JS)
      IF ( .NOT. SA ) THEN
         IF( LOCDBG ) CALL WLOG( 0, 'SAMESET: before totbw' )
         GO TO 999 
      END IF
C
      DO ICH = 1, NCHAN(KS)
         DO ITP = 1, TAPEMODE(KS)
            SA = SA .AND.
     1          TRACK(ICH,ITP,KS) .EQ. TRACK(ICH,ITP,JS)
         END DO
         SA = SA .AND.
     1     BITS(ICH,KS) .EQ. BITS(ICH,JS) .AND.
     2     BBC(ICH,KS)  .EQ. BBC(ICH,JS)
      END DO
      SA = SA .AND.
     1     PERIOD(KS)   .EQ. PERIOD(JS)   .AND.
     2     LEVEL(KS)    .EQ. LEVEL(JS)    .AND.
     3     TAPEMODE(KS) .EQ. TAPEMODE(JS) .AND.
     4     TPMODE(KS)   .EQ. TPMODE(JS)   .AND.
     5     SWTCHDUR(KS) .EQ. SWTCHDUR(JS)
      IF ( .NOT. SA ) THEN
         IF( LOCDBG ) CALL WLOG( 0, 'SAMESET: before swtchdur' )
         GO TO 999 
      END IF
C
      DO IPC = 1, MAXPC
         SA = SA .AND.
     1        PCALFR1(IPC,KS) .EQ. PCALFR1(IPC,JS) .AND.
     2        PCALFR2(IPC,KS) .EQ. PCALFR2(IPC,JS) .AND.
     3        PCALX1(IPC,KS)  .EQ. PCALX1(IPC,JS)  .AND.
     4        PCALX2(IPC,KS)  .EQ. PCALX2(IPC,JS)
      END DO
      IF ( .NOT. SA ) THEN
         IF( LOCDBG ) CALL WLOG( 0, 'SAMESET: before pcalx2' )
         GO TO 999 
      END IF
C
C     Don't test quite all of these.
C     I thought I had found g77 compiler bug, but I am not used to
C     .EQV. and it turns out the .AND.s get evaluated first, producing
C     very confusing results without parentheses.
C
      SA = SA .AND.
     1     ( DUALPOL(KS) .EQV. DUALPOL(JS) ) .AND.
     2     ( FRSWITCH(KS) .EQV. FRSWITCH(JS) ) .AND.
     3     ( DUALX(KS)    .EQV. DUALX(JS) ) .AND.
     4     ( MODETEST(KS) .EQV. MODETEST(JS) ) .AND.
     5     ( BAND(KS) .EQ. BAND(JS) )
C     5     ( USED(KS)     .EQV. USED(JS) )     .AND. 
      IF ( .NOT. SA ) THEN
         IF( LOCDBG ) CALL WLOG( 1, 'SAMESET: before band' )
         GO TO 999 
      END IF
C
      DO IIF = 1, 4
         SA = SA .AND.
     1        IFDIST(IIF,KS) .EQ. IFDIST(IIF,JS) .AND.
     2        NOISE(IIF,KS)  .EQ. NOISE(IIF,JS)  .AND.
     3        FE(IIF,KS)     .EQ. FE(IIF,JS) 
      END DO
      IF ( .NOT. SA ) THEN
         IF( LOCDBG ) CALL WLOG( 0, 'SAMESET: before fe' )
         GO TO 999 
      END IF
C
      DO ICH = 1, NCHAN(KS)
         SA = SA .AND.
     1        SIDEBD(ICH,KS)  .EQ. SIDEBD(ICH,JS)  .AND.
     2        POL(ICH,KS)     .EQ. POL(ICH,JS)     .AND.
     3        IFCHAN(ICH,KS)  .EQ. IFCHAN(ICH,JS)  .AND.
     4        ALTIFC(ICH,KS)  .EQ. ALTIFC(ICH,JS)  .AND.
     5        NETSIDE(ICH,KS) .EQ. NETSIDE(ICH,JS) .AND.
     6        SIDE1(ICH,KS)   .EQ. SIDE1(ICH,JS) 
      END DO
C
      DO I = 1, 4
         SA = SA .AND.
     1   STRING(4,KS) .EQ. STRING(4,JS)
      END DO
      IF ( .NOT. SA ) THEN
         IF( LOCDBG ) CALL WLOG( 0, 'SAMESET: before string' )
         GO TO 999 
      END IF
C
      SA = SA .AND.
     1  NOISEFRQ(KS) .EQ. NOISEFRQ(JS) .AND.
     2  LOGGING(KS)  .EQ. LOGGING(JS)  .AND.
     3  FORMAT(KS)   .EQ. FORMAT(JS)   .AND.
     4  SPCAL(KS)    .EQ. SPCAL(JS)    .AND.
     5  RCHAN(KS)    .EQ. RCHAN(JS)    .AND.
     6  LCHAN(KS)    .EQ. LCHAN(JS)    .AND.
     7  LCP50CM(KS)  .EQ. LCP50CM(JS)  .AND.
     8  RCP50CM(KS)  .EQ. RCP50CM(JS)  .AND.
     9  BARREL(KS)   .EQ. BARREL(JS) 
      IF ( .NOT. SA .AND. LOCDBG ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, A, A, A )' ) '     BARREL (KS), (JS) ',
     1       BARREL(KS), '   ', BARREL(JS)
         CALL WLOG( 0, MSGTXT )
         CALL WLOG( 0, 'SAMESET: before BARREL' )
         GO TO 999 
      END IF
C
      SA = SA .AND.
     1  MINTRAK(KS)  .EQ. MINTRAK(JS)  .AND.
     2  MAXTRAK(KS)  .EQ. MAXTRAK(JS)  .AND.
     3  MINTBPS(KS)  .EQ. MINTBPS(JS)  .AND.
     4  MAXTBPS(KS)  .EQ. MAXTBPS(JS)  .AND.
     5  TBPS(KS)     .EQ. TBPS(JS)     .AND.
     6  TOTBPS(KS)   .EQ. TOTBPS(JS)   .AND.
     7  ( VLBAMKIV(KS) .EQV. VLBAMKIV(JS) )
      IF ( .NOT. SA .AND. LOCDBG ) THEN
         CALL WLOG( 0, 'SAMESET: before vlbamkiv' )
         GO TO 999 
      END IF
C
C     Only check the VLA parameters if both antennas are VLA.
C     Also don't allow them to pretend to be the same if one
C     is a VLA antenna and the other is not (will need VLA
C     parameters in the VLA listing).
C
C     The check of all the old VLA parameters has been removed.
C
      SA = SA .AND. 
     1     ( SETSTA(1,KS)(1:3) .EQ. 'VLA' .AND. 
     2       SETSTA(1,JS)(1:3) .EQ. 'VLA' ) .OR.
     3     ( SETSTA(1,KS)(1:3) .NE. 'VLA' .AND. 
     4       SETSTA(1,JS)(1:3) .NE. 'VLA' )
C
      IF ( .NOT. SA ) THEN
         IF( LOCDBG ) CALL WLOG( 0, 'SAMESET: before vlavl' )
         GO TO 999 
      END IF
C
C     Compare some station hardware so we don't combine dissimilar 
C     stations.  This caused some problems with CRD parameters.
C
      KSTN = ISETSTA(KS)
      JSTN = ISETSTA(JS)
      SA = SA .AND. 
     1     CONTROL(KSTN) .EQ. CONTROL(JSTN) .AND.
     2     DAR(KSTN) .EQ. DAR(JSTN)
C
C     Don't forget to deal with frequency sets and pcal sets
C     separately.  They are not compared here.  Think about what
C     to do.

  999 CONTINUE
      SAMESET = SA
      RETURN
      END

      SUBROUTINE SCHOPT
C
C     Routine for the optimization of a schedule.  This will always
C     be called.  In the simplest mode, it just sets SCAN1 and SCANL,
C     calculates the geometric and media parameters, checks time 
C     sequences, avoids bad scan times, and returns.  The next 
C     simplest mode involves dwell time scheduling.  There are also 
C     more complicated modes that use the input scans as essentially 
C     a source list and generate an entirely new schedule that will 
C     be put in scans beyond NSCANS.  After such a use, SCAN1 will
C     be NSCANS + 1 and SCANL will be something higher.
C
C     In addition, SCHOPT can pick it's own sources to either create
C     pointing scans, or to create geodetic (DELZN) sequences.  These
C     scan insertion options are handled with somewhat different logic
C     from the other optimazations.
C
C     The more sophisticated options are used mainly for geodetic or 
C     pointing scheduling, or for scheduling surveys.  This would be 
C     the place to insert the code for other useful optimizations.
C     that would be good to add some day would be:
C
C     An output file that can be used for the scans input of another   
C     sched input can be written if hand editing of the optimized
C     schedule is desired.
C
C     Note that the scan times up to this point are only meaningful 
C     for fixed or duration scheduling.  For dwell scheduling, they
C     are generally well before the actual time after accounting for
C     slews.  For other optimization modes where the input scans are
C     more of a source list, the times are meaningless.
C
C     OPDUR is the experiment total duration.  No scans will be 
C     scheduled after that time.
C
C     Modes (OPTMODE input) are
C      "NONE"   The default.  Don't optimize.  Make adjustments for
C               PRESCAN and get geometry and tape data.  Can include
C               dwell time scheduling.
C      "SCANS"  The original optimizing mode.  It is also used for
C               dwell time scheduling.  The input file has a list 
C               of scans (sometimes a big loop).
C               This routine goes through list taking scans
C               that qualify according to the optimization parameters 
C               and sets the start time to when all antennas are there.
C      "CELLS"  A mode that splits the sky over each antenna
C               into a number of cells and tries to optimize the
C               coverage of those cells.  The input file should contain
C               one scan for each source.  They will not be used in
C               order and each may get used several times.
C      "CSUB"   Like "CELLS" with subarraying.  May not be working.
C      "UPTIME" Makes a series of scans of total length OPDUR for each
C               input scan.  This is meant to help the UPTIME 
C               replacement.
C      "HAS"    Create a schedule using the input scans as a source list
C               with one input scan per output scan.  Try to optimize
C               for hour angles.  This is a one pass operation.  This
C               was used to schedule the VIPS survey project and should
C               be good for other surveys.
C
C
C     In the loop through output scans:
C       KSCN is a count of the passes through the calls to the
C            optimization routines.  For many modes, this keeps
C            track of input scan to consider.  But this is not
C            true for modes that use the input scans as a source list.
C       ISCN is output scan number of the scan to be processed.  This 
C            is the index of the scan in all the arrays that have an 
C            element per scan.  Inserting peaking scans etc can 
C            increment this.  ISCN will in general either equal KSCN
C            or be greater than the NSCANS, the number of input scans.
C            When KSCN > ISCN, the optimization routines need to
C            fill in the scan dependent information (most can be
C            filled with SCNDUP).
C       DONE indicates that there should be no more output scans.
C       KEEP indicates that this scan is to be kept.
C       ADJUST indicates that OPTTIM should adjust the times.
C       LASTISCN(ISTA) is the most recent output scan of any sort,
C            including pointing scans, for station ISTA prior to the 
C            current one.
C       LASTSSCN(ISTA) is the most recent output scan for the station
C            that was not an automatically inserted pointing scan.
C            If pointing scans have been inserted, gap will be honored
C            for LASTSSCN, but not for LASTISCN.
C       NGSCANS is a count of scans that have good data.  Recall that
C            some scans may have no stations up.
C
C     After the optimization loop, the rest of SCHED should use
C     scans SCAN1 through SCANL.
C
      INCLUDE 'sched.inc'
C
      INTEGER           ISCN, KSCN, ISTA, NGSCANS
      INTEGER           LASTISCN(MAXSTA), LASTSSCN(MAXSTA)
      INTEGER           NGOOD, YEAR, DAY1, DAY2, ICSRC
      INTEGER           PEAKOPT, GEOOPT
      LOGICAL           ADJUST, IADJUST, KEEP, DONE, GOTALL
      DOUBLE PRECISION  START, STOP
      CHARACTER         TFORM*8, TIME1*8, TIME2*8
C
C     For test only.
C
C      double precision      SIGMA(20)
C      real                   DUM1
       integer                len1
C
      SAVE              LASTISCN, LASTSSCN
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SCHOPT: Starting.' )
C
C     Initializations.
C
      KSCN = 0
      SCANL = 0
      DONE = .FALSE. 
      NGSCANS = 0
      DO ISTA = 1, NSTA
         LASTISCN(ISTA) = 0
         LASTSSCN(ISTA) = 0
      END DO
C
C     ORIGEN indicates the source of the scan.  It was introduced
C     in Feb. 2014 to help with dealing with using GAP in the presence
C     of automatically inserted pointing scans.  GAP needs to refer
C     back to the last original scan.  Options for ORIGEN are:
C        ORIGEN=1  Scan explicitly specified in the key file.
C        ORIGEN=2  Scan inserted by an optimization mode.
C        ORIGEN=3  Scan inserted for a geodetic segment.
C        ORIGEN=4  Scan inserted for reference pointing.
C     At this point, we only have scans from the key file.
C
      DO ISCN = 1, NSCANS
         ORIGEN(ISCN) = 1
      END DO
C
C     PEAKOPT is related to reference pointing which is triggered by 
C     the user setting AUTOPEAK.  PEAKOPT tells how many more 
C     peaking scans are needed at the moment.  If zero, get the 
C     next target scan.  GEOOPT is a similar variable for insertion
C     of geodetic segments.
C
C     The output scans can be the input scans for OPTMODE 'NONE'
C     and 'SCANS' without automatic insertion of reference pointing.
C     Otherwise, new scans should be created and the output schedule
C     should start at scan SCAN1=NSCANS+1.
C
      PEAKOPT = 0
      GEOOPT = 0
      IF( ( OPTMODE .NE. 'NONE' .AND. OPTMODE .NE. 'SCANS' ) .OR.
     1      AUTOPEAK .OR. ANYGEO ) THEN
         ISCN = NSCANS
         SCAN1 = NSCANS + 1
      ELSE
         ISCN = 0
         SCAN1 = 1
      END IF
      WRITE( MSGTXT, '( A, I5 )' ) 
     1       'SCHOPT:  First output scan will be number ', SCAN1
      CALL WLOG( 0, MSGTXT )
C
C
C     Scan loop.  We are looping over output scans, which may not
C     correspond to input scans.
C
C
      DO WHILE( .NOT. DONE )
         ISCN = ISCN + 1
         IF( ISCN .GT. MAXSCN ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5 )' )
     1       'SCHOPT:  Trying to generate too many scans. Max:', MAXSCN
            CALL ERRLOG( MSGTXT )
         END IF
C
         IF( PEAKOPT .NE. 0 .OR. GEOOPT .NE. 0 ) THEN
C
C           The insertion of geodetic sequences and reference pointing
C           scans is initiated by this routine.  The first time that
C           ADDGEO or ADDPEAK is called while processing a scan for
C           which geodetic or pointing scans will be added, all of the
C           required output scans related to the input scan will be
C           generated and added to the output scan sequence.  That
C           pass of this scan loop will then finish by processing the
C           first of the added scans.
C
C           For the following passes through the scan loop, the added
C           scans need to be processed without invoking the optimization
C           routines.   PEAKOPT and GEOOPT keep track of how many more
C           added scans need to be processed so when they are not
C           zero, jump around the optimization routines.  But be 
C           sure to call PEAKOPT or GEOOPT (by setting KEEP and DONE)
C           so that they can decrement PEAKOPT or GEOOPT.
C
            KEEP = .TRUE.
            DONE = .FALSE.
C
         ELSE
C
C           Get a new main scan if no peaking or geodetic scan insertions 
C           are in progress.
C
C           Increment the input pass counter (for many, but not all
C           modes, this is the input scan number).  Note that it does
C           not get incremented while peaking or geoseg scans are
C           being added.
C
            KSCN = KSCN + 1
C
C           Protect against a possible programming error.  Users
C           should not see this one.
C
            IF( KSCN .NE. ISCN .AND. ISCN .LT. NSCANS ) THEN
               WRITE( MSGTXT, '( A, A, 3I7 )' )
     1              'SCHOPT possible programming error. ', 
     2              ' KSCN ne ISCN and ISCN < NSCANS ', 
     3              KSCN, ISCN, NSCANS
               CALL ERRLOG( MSGTXT )
            END IF
C
C           Here is where the optimization subroutines are called.
C           They specify the the next output scan, with source, 
C           stations, and times.  If ADJUST is true, the start time
C           is assumed to be approximate and can be adjusted for 
C           slews etc later.  If false, the times are fixed.  Note
C           that the stop time will also be adjusted if ADJUST is
C           true if only a duration (or dwell) was specified by the user
C           for the scan.  Otherwise the user specified time will be
C           used (if the user specified start, ADJUST will be false).
C   
            IF( OPTMODE .EQ. 'NONE' ) THEN
C   
C              Non-optimizing mode:  Just use next input scan.  If
C              KSCN ne ISCN, then KSCN scan info will be copied to
C              ISCN.  Note that timing from DWELL scheduling will be
C              handled in the OPTTIM call later.  ADJUST will be set
C              appropriately here.  The DWELL case used to be separate
C              but there was no need.  OPTDWELL was deleted.
C   
               CALL OPTNONE( KSCN, ISCN, ADJUST, KEEP, DONE )
C   
            ELSE IF( OPTMODE .EQ. 'SCANS' ) THEN
C   
C              Select scans by number of antennas up and various other 
C              criteria.  The scan start time is set to a good guess. 
C              It will be fine tuned later in OPTTIM.
C   
               CALL OPTSKD( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
C   
            ELSE IF( OPTMODE .EQ. 'CELLS' ) THEN
C   
C              Cells type optimization:  Here we really try getting
C              fancy.  The input NSCANS scans are used like a source
C              list.  OPTCELLS selects which one to use next and 
C              puts it in scan KSCN + SCAN1 - 1.
C   
               CALL OPTCELLS( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
               ORIGEN(ISCN) = 2
C   
            ELSE IF( OPTMODE .EQ. 'CSUB' ) THEN
C   
C              Cells type optimization like CELLS, but with subarrays
C              created.
C   
               CALL OPTCSUB( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
               ORIGEN(ISCN) = 2
C   
            ELSE IF( OPTMODE .EQ. 'UPTIME' ) THEN
C   
C              Creates a string of scans of total length OPDUR for each
C              input scan.  This is for planning.
C   
               CALL OPTUPT( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
               ORIGEN(ISCN) = 2
C   
            ELSE IF( OPTMODE .EQ. 'HAS' ) THEN
C
C              Create a schedule using the input scans as a source list
C              with one input scan per output scan.  Try to optimize
C              for hour angles.  This is a one pass operation.
C
               CALL OPTHAS( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
               ORIGEN(ISCN) = 2
C
            ELSE IF( OPTMODE .EQ. 'HIGHEL' ) THEN
C
C              Create a schedule using the input scans as a source list
C              with groups of scans, designated using HIGROUP, from which
C              the one with the highest minimum elevation will be 
C              chosen.  Note this routine can change KSCN.
C
               CALL OPTHIEL( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
               ORIGEN(ISCN) = 2
C
            ELSE
C   
C              Invalid optimization mode.
C   
               CALL ERRLOG( 'SCHOPT: Invalid OPTMODE: '//OPTMODE )
C   
            END IF
C
C                Some potentially useful debug code.
C                call timej( startj(iscn), year, day1, start )
C                time1 = tform( start, 'T', 0, 2, 2, '::@' )
C                if( iscn .gt. 170 .and. iscn .lt. 190 ) then
C                  write(*,*) ' '
C                  write(*,*) 'schopt 1:        ', kscn, iscn, adjust, ' ', 
C               1                  iadjust, ' ', time1, ' ', scnsrc(iscn)
C                end if
C
C           KSCN not used below this point.
C
C           Some of the optimization routines only give approximate
C           scan times.  Get better, ones now.  Inserted pointing 
C           scans have not been added yet, but they won't 
C           be allowed to adjust the main scan times.  When geodetic
C           scans are being inserted, the times for here are for the
C           dummy scan to which the geodetic segment insertion 
C           parameters are attached.  That scan will not actually
C           be used so what is calculated here is a bit superfluous,
C           but there isn't much overhead and it is simpler not to
C           try to trap that case.  ADDGEO will call OPTTIM and 
C           SCNGEO (in GMKSCN) for the geodetic scans, plus they will
C           get called yet again after the insertions are done.
C
            IF( KEEP .AND. .NOT. DONE ) THEN
C        
C              Get slew times and exact start time of next scan.  The
C              adjustments for DWELL scheduling are done here.  Note
C              that OPTTIM does not calculate geometry for all scans
C              and, even when it does, it may be for the wrong time - 
C              like for a guessed start time.
C        
               CALL OPTTIM( LASTISCN, LASTSSCN, ISCN, ADJUST, 
     1                      .FALSE., .FALSE. )
C        
C              Now be sure that the experiment time boundaries have
C              not been exceeded.  Some optimization modes watch this
C              themselves and miss some closeout stuff (like printing
C              summaries if they aren't the ones that set DONE.  In
C              close cases, they might not think a scan has gone over
C              where the adjustments above cause it to do so.  So
C              avoid this test for those modes.
C        
               IF( OPDUR .NE. 0.D0 .AND. 
     1             STOPJ(ISCN) .GT. STARTJ(SCAN1) + OPDUR .AND.
     2             OPTMODE .NE. 'HAS' ) THEN
                  DONE = .TRUE.
               END IF
C
C              Update the real geometry for the scan.  OPTTIM doesn't
C              really do this.  The pointing insertion system below
C              assumes that this has been done.
C
               CALL SCNGEO( LASTISCN, NGOOD, ISCN )
C        
            END IF
         END IF
C
C        ADJUST was set above for the nominal scan.  The insertion
C        routines below can postpone dealing with that scan and may
C        want other values of ADJUST than was set above.  But then
C        when the main scan is processed in OPTTIM, we may want the
C        original value.  So transfer ADJUST to IADJUST here, then
C        allow the insertion routines to change IADJUST as they
C        see fit.  ADJUST should not be changed below here, or above 
C        while flushing through inserted scans.
C
         IADJUST = ADJUST
C
C        Only keep the scan if told to do so by optimization routine.  
C        Also enter this section if in the middle of adding pointing
C        or geodetic scans.
C
         IF( KEEP .AND. .NOT. DONE ) THEN
C
C           This is the section where additional scans can be inserted 
C           at specific places in the schedule, not as the result of
C           any global optimization.  For now, this means geodetic
C           segments or pointing scans.
C
C           Insert geodetic segment scans if requested.
C
C           Only do it if not in the middle of inserting pointing.
C           Mixing pointing and geo insertion might work, but it
C           sounds both dangerous and unnecessary.
C
C           For any inserted scans, ADDGEO will have run OPTTIM and
C           SCNGEO so use IADJUST to not allow the later runs to 
C           move things around.
C
            IF( PEAKOPT .EQ. 0 .AND. ( GEOLEN(ISCN) .GT. 0.D0 .OR. 
     1            GEOOPT .GE. 1 ) ) THEN
               IADJUST = .FALSE.
               CALL ADDGEO( LASTISCN, ISCN, GEOOPT, KEEP )
            END IF
C
C           Get the geodetic quality measure for some scans.  This
C           was written for testing a premade sequence.  GEOQUAL does the 
C           printing.  Keep the code here in case I want to make it
C           a feature with a switch like GEOTEST = 13 on the last 
C           scan of the group.  The fourth parameter should be a scan
C           that includes all sources (may need to test to find one).
C
C            IF( GEOTEST(ISCN) .GT. 0 ) THEN
C               CALL GEOQUAL( ISCN - GEOTEST + 1, ISCN - GEOTEST + 1, 
C     1              ISCN, ISCN - GEOTEST + 1,
C     2              0.0, DUM1, .TRUE., SIGMA )
C            END IF
C
C           Insert reference pointing scans if requested.
C           It is possible that several scans will be inserted (NADDED 
C           in ADDPEAK).  The primary observing scan will be moved 
C           to scan ISCN+NADDED and the reference pointing scans 
C           will be put in between.  ADDPEAK will firmly establish 
C           the times for the added scans.
C
C           ADDPEAK will also set PEAKOPT so that the optimization
C           routines will be skipped until all the peaking scans and
C           the main scan have been processed.  It will set IADJUST
C           false for all inserted scans.
C      
            CALL ADDPEAK( LASTISCN, ISCN, PEAKOPT, IADJUST )
C      
C           The scans added by ADDPEAK will have the right times and 
C           source but the main scan's setup.  POINT will be set.  
C           MAKEPTG will convert it, or any other scan with POINT 
C           set, into a reference pointing scan.
C           
            CALL MAKEPTG( LASTISCN, ISCN, KEEP )
C      
         END IF
C
C        All possible scan insertions etc are now done.  The details 
C        of the current scan can be finalized.
C
C        Retest KEEP and DONE to allow them (actually only KEEP) be 
C        reset by the above insertion routines.  The main case is 
C        that MAKEPTG may discover no stations that can do reference 
C        pointing are in the scan.
C
         IF( KEEP .AND. .NOT. DONE ) THEN
C
C           Now that all the insertions are done, if they happened,
C           do a final pass of the geometry calculations.  This will
C           not actually be needed in most (any?) cases, but it doesn't 
C           cost much and this ensures everything is in good shape.
C           This can tweak the scan timing (in OPTTIM if IADJUST is 
C           true), gets the geometry at the stations and counts the
C           stations that are considered UP.  Note NGOOD in SCNGEO
C           is not needed here (also determined by AUTODOWN) but 
C           SCNGEO is used elsewhere where it is needed.
C
C           This is the last call to OPTTIM, so apply the PRESCAN 
C           offsets here.  They should only be applied once.
C
            CALL OPTTIM( LASTISCN, LASTSSCN, ISCN, IADJUST, 
     1                   .FALSE., .TRUE. )
            CALL SCNGEO( LASTISCN, NGOOD, ISCN )
C
C           Eliminate stations using disk recorders
C           for which the source is down. Also eliminate antennas
C           that don't reach the source until the scan is over.
C           Don't attempt any scan timing adjustments, but do
C           recalculate NGOOD to reflect new truths.
C
            CALL AUTODOWN( LASTISCN, ISCN, NGOOD )
C
C           Only accept scans with enough antennas up.
C           Make a special case for OPTMODE=CSUB since it will put
C           small numbers of antennas into the 3ed subarray.
C           Also don't complain about small subarrays for reference
C           pointing.
C           Also make an exception for OPTMODE=HAS for which the 
C           optimizing routine makes this selection and small tweaks
C           in scan times might upset those results.
C
            KEEP = KEEP .AND.
     1          ( NGOOD .GE. OPMIAN(ISCN) .OR. OPTMODE .EQ. 'CSUB' .OR.
     2          OPTMODE .EQ. 'HAS' .OR. POINT(ISCN) .GE. 0 )
C
            IF( .NOT. KEEP ) THEN
C
C              Set so that no stations are included.  This is understood
C              in later parts of the program.
C
               DO ISTA = 1, NSTA
                  STASCN(ISCN,ISTA) = .FALSE.
               END DO
C
            ELSE
C
C              Accepted scan.
C
C              Set the start time for data recording.
C              If DOVEX, do not adjust later.
C
               CALL SETTPS( ISCN, LASTISCN )
C
C              If using disk, get the amount of disk used and 
C              add to total.  Also set tape info to default while
C              in a station loop.
C
               DO ISTA = 1, NSTA
                  IF( STASCN(ISCN,ISTA) .AND. 
     1                VLBITP .AND. .NOT. NOSET ) THEN
                     IF( USEDISK(ISTA) ) THEN
                        CALL DISKPOS( ISCN, ISTA, LASTISCN )
                     END IF
                  END IF
               END DO
C
C              Write the new KEYIN input for another run of SCHED
C              in case the user wants to do some edits.  This is
C              most likely to be useful for optimized schedules.
C
               IF( ( OPTMODE .NE. 'NONE' .AND. OPTMODE .NE. 'UPTIME' ) 
     1             .OR. ANYGEO ) THEN
                  CALL OPTSCH( ISCN ) 
               END IF
C
C              Keep a count of the number of scans that will actually
C              have data.
C
               NGSCANS = NGSCANS + 1
C
C              Flag sources that have been used.  Here so that sources
C              inserted for pointing will be included.
C
               SUSED(SRCNUM(ISCN)) = .TRUE.
               IF( .NOT. NOREC(ISCN) ) USEDREC(SRCNUM(ISCN)) = .TRUE.
               IF( IDOPSRC(ISCN) .NE. 0 ) SUSED(IDOPSRC(ISCN)) = .TRUE.
               IF( IVLAPHS(ISCN) .NE. 0 ) SUSED(IVLAPHS(ISCN)) = .TRUE.
               IF( ICENT(ISCN) .NE. 0 ) THEN
                  USEDCENT(SRCNUM(ISCN)) = .TRUE.
                  DO ICSRC = 1, NCSRC(ICENT(ISCN))
                     USEDPHS(CTRSRCI(ICSRC,ICENT(ISCN))) = .TRUE.
                  END DO
               END IF
C
            END IF
C
C           Mark this as most recent scan for each station that is in
C           the scan.  Also mark it as the last non-inserted pointing
C           scan if that is true.
C
            DO ISTA = 1, NSTA
               IF( STASCN(ISCN,ISTA) ) THEN
                  LASTISCN(ISTA) = ISCN
                  IF( ORIGEN(ISCN) .LT. 4 ) THEN
                     LASTSSCN(ISTA) = ISCN
                  END IF
               END IF
            END DO
C
C           Set the last output scan number.
C
            SCANL = ISCN
C
         END IF
C     
C                More potentially useful debug code.
C                call timej( startj(iscn), year, day1, start )
C                time1 = tform( start, 'T', 0, 2, 2, '::@' )
C                if( iscn .gt. 170 .and. iscn .lt. 190 ) then
C                write(*,*) 'schopt 2:        ', kscn, iscn, adjust, ' ', 
C               1                  iadjust, ' ', time1, ' ', scnsrc(iscn)
C                end if
      END DO
C
      IF( DEBUG ) CALL WLOG( 0, 'SCHOPT: 9.' )
      IF( OPTMODE .EQ. 'SCANS' ) THEN
         WRITE( MSGTXT, '( A, I5, A, I5, A )' ) 'SCHOPT optimization: ',
     1       NGSCANS, ' of ', SCANL - SCAN1 + 1, ' scans used. ' 
      END IF
C
C     Check that we have something.
C
      IF( SCANL .EQ. 0 ) THEN
         CALL WLOG( 1, 'SCHOPT: Did not schedule any scans' )
         CALL ERRLOG( ' Abort' )
      END IF
C
C     Rebuild the list of sources actually used in the schedule,
C     the "schedule sources" in the include file.  The only
C     variables affected are NSRC, SRCATN(ISRC), and SRCNAME(ISRC).
C     The rebuild is needed because some of the optimization modes 
C     and pointing modes add scans and sources and some scans may 
C     have been eliminated.  Rebuild the list of schedule sources 
C     with ACCSRC, ignoring potential pointing sources, planets,
C     satellites etc this time because they are already in scans.
C     They weren't when SRFINISH was run earlier.
C     Then rebuild the pointers and flags with SRCFLG.
C
      CALL ACCSRC( .FALSE.)
      CALL SRCFLG( GOTALL )
C
      IF( .NOT. GOTALL ) CALL ERRLOG( 
     1  'SCHOPT: Not all sources found; programming problem.' )
C
C     Take the opportunity to construct a list of pointing center
C     sources paired with lists of offset phase centers.
C
      CALL GETPAIRS
C
C     Write the scan and time range.
C
      MSGTXT = ' '
      CALL TIMEJ( STARTJ(SCAN1), YEAR, DAY1, START )
      CALL TIMEJ( STOPJ(SCANL), YEAR, DAY2, STOP )
      TIME1 = TFORM( START, 'T', 0, 2, 2, '::@' )
      TIME2 = TFORM( STOP, 'T', 0, 2, 2, '::@' )
      WRITE( MSGTXT, '( A, I5, A, I5, A, I5, A, I3, 3A, I3, 2A )' ) 
     1        'SCHOPT:  There will be ',
     2        SCANL - SCAN1 + 1, ' output scans (', SCAN1, ' - ', SCANL,
     3        ') from ', 
     4        DAY1, '/', TIME1, ' to ', 
     5        DAY2, '/', TIME2
      CALL WLOG( 0, MSGTXT )
C
C     Check for a monotonic time sequence at each station.
C     Also, get the extreme times of experiment (used for Mark II tape
C     scheduling, Doppler calculations, and Sun position).  While at
C     it, get statistics for summaries on numbers of scans, hours etc.
C
      CALL  SCHTIM
C
C     Avoid day number confusions for start and stop times 
C     near midnight.
C
      CALL SCH24
C
      IF( DEBUG ) CALL WLOG( 0, 'SCHOPT: Done.' )
C
      RETURN
      END

      SUBROUTINE sla_PRECES (SYSTEM, EP0, EP1, RA, DC)
*+
*     - - - - - - -
*      P R E C E S
*     - - - - - - -
*
*  Precession - either FK4 (Bessel-Newcomb, pre IAU 1976) or
*  FK5 (Fricke, post IAU 1976) as required.
*
*  Given:
*     SYSTEM     char   precession to be applied: 'FK4' or 'FK5'
*     EP0,EP1    dp     starting and ending epoch
*     RA,DC      dp     RA,Dec, mean equator & equinox of epoch EP0
*
*  Returned:
*     RA,DC      dp     RA,Dec, mean equator & equinox of epoch EP1
*
*  Called:    sla_DRANRM, sla_PREBN, sla_PREC, sla_DCS2C,
*             sla_DMXV, sla_DCC2S
*
*  Notes:
*
*     1)  Lowercase characters in SYSTEM are acceptable.
*
*     2)  The epochs are Besselian if SYSTEM='FK4' and Julian if 'FK5'.
*         For example, to precess coordinates in the old system from
*         equinox 1900.0 to 1950.0 the call would be:
*             CALL sla_PRECES ('FK4', 1900D0, 1950D0, RA, DC)
*
*     3)  This routine will NOT correctly convert between the old and
*         the new systems - for example conversion from B1950 to J2000.
*         For these purposes see sla_FK425, sla_FK524, sla_FK45Z and
*         sla_FK54Z.
*
*     4)  If an invalid SYSTEM is supplied, values of -99D0,-99D0 will
*         be returned for both RA and DC.
*
*  P.T.Wallace   Starlink   20 April 1990
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      CHARACTER SYSTEM*(*)
      DOUBLE PRECISION EP0,EP1,RA,DC

      DOUBLE PRECISION PM(3,3),V1(3),V2(3)
      CHARACTER SYSUC*3

      DOUBLE PRECISION sla_DRANRM




*  Convert to uppercase and validate SYSTEM
      SYSUC=SYSTEM
      IF (SYSUC(1:1).EQ.'f') SYSUC(1:1)='F'
      IF (SYSUC(2:2).EQ.'k') SYSUC(2:2)='K'
      IF (SYSUC.NE.'FK4'.AND.SYSUC.NE.'FK5') THEN
         RA=-99D0
         DC=-99D0
      ELSE

*     Generate appropriate precession matrix
         IF (SYSUC.EQ.'FK4') THEN
            CALL sla_PREBN(EP0,EP1,PM)
         ELSE
            CALL sla_PREC(EP0,EP1,PM)
         END IF

*     Convert RA,Dec to x,y,z
         CALL sla_DCS2C(RA,DC,V1)

*     Precess
         CALL sla_DMXV(PM,V1,V2)

*     Back to RA,Dec
         CALL sla_DCC2S(V2,RA,DC)
         RA=sla_DRANRM(RA)

      END IF

      END

C ======================================
      LOGICAL FUNCTION INARRAY(ELEM, ARRAY, LENGTH)
C
C Check if element is in array
C Original: Cormac Reynolds 2017-06-22 (used by chkdbfq.f)
C
      INTEGER   LENGTH, I
      CHARACTER ELEM*(*), ARRAY(LENGTH)*(*)
C
      INARRAY = .FALSE.
      DO I = 1, LENGTH
        IF( ARRAY(I) .EQ. ELEM ) INARRAY = .TRUE.
      END DO
C
      RETURN
      END

      SUBROUTINE JPLVER( JPVER )
C
C     Set a version number for the SCHED main code.  
C     Note that a coarser, date based version is set in sched.f
C
      REAL JPVER
Cf2py intent(out) JPVER
C ----------------------------------------------------------------------
      JPVER = 1.01
C
      RETURN
      END

      SUBROUTINE VLBAREAL( LABEL, NCL, NCHAN, ARRAY, OLDARRAY, OLDCHAN,
     1                    FMT, NDIG, FIRSTS, IUVBA ) 
C
C     Routine to put an array of setup parameters into a VLBA style
C     control file.  This one is for real numbers.
C     It turns out that when this routine is wanted, the arrays
C     are now double precision, so just change the declares here rather
C     than creating a VLBADBL.
C
C     Only NCHAN channels will be written.  The current array will be
C     tested against the most recent one and only channels that have
C     changed will be written.  LABEL*NCL is the keyword for the output
C     record (eg BBSYN) and IUVBA is the output unit number.  OLDARRAY
C     should be dimensioned the same as ARRAY.  If the number of 
C     channels increases, write out the new ones.
C
      CHARACTER   LABEL*(*), OUTLINE*80, FMT*6
      DOUBLE PRECISION  ARRAY(*), OLDARRAY(*)
      INTEGER     NCHAN, OLDCHAN, KCHAR, NCHAR, NCL
      INTEGER     I, IUVBA, NDIG
      LOGICAL     FIRSTS, WRTLAB, DEQUAL
C----------------------------------------------------------------------
      NCHAR = 0
      WRTLAB = .TRUE.
      IF( FIRSTS ) OLDCHAN = 0
      DO I = 1, NCHAN
C
C        Does this channel need to be processed?
C
         IF( FIRSTS .OR. I .GT. OLDCHAN .OR.
     1       .NOT. DEQUAL( ARRAY(I), OLDARRAY(I) ) ) THEN
C
C           Get the number of characters for this point.
C
            KCHAR = NDIG + 6
            IF( NCHAR + KCHAR .GT. 80 ) THEN
C
C              Write out the previous line.
C
               WRITE( IUVBA, '(A)' ) OUTLINE(1:NCHAR)
C
               NCHAR = 0
               WRTLAB = .TRUE.
            END IF
C
C           Write the beginning of the line.
C
            IF( WRTLAB ) THEN
               OUTLINE = ' '
               NCHAR = NCL
               OUTLINE(1:NCHAR+1) = LABEL(1:NCL)//'='
               NCHAR = NCHAR + 1
               WRTLAB = .FALSE.
            ELSE
               OUTLINE(NCHAR+1:NCHAR+1) = ','
               NCHAR = NCHAR + 1
            END IF
C
C           Write in the actual data point
C
            OUTLINE(NCHAR+1:NCHAR+1) = '('
            WRITE( OUTLINE(NCHAR+1:NCHAR+4), '(A1, I2, A1)' ) 
     1              '(', I, ','
            NCHAR = NCHAR + 4
            WRITE( OUTLINE(NCHAR+1:NCHAR+NDIG), FMT ) ARRAY(I)
            NCHAR = NCHAR + NDIG + 1
            OUTLINE(NCHAR:NCHAR) = ')'
C
         END IF
C
C        Arrange to sense changes next time.
C
         OLDARRAY(I) = ARRAY(I)
C
      END DO
C
C     Record number of channels done.
C
      OLDCHAN = NCHAN
C
C     Write out the last line.
C
      IF( NCHAR .GT. 0 ) WRITE( IUVBA, '(A)' ) OUTLINE(1:NCHAR)
C
      RETURN
      END

      SUBROUTINE VLBASU(ISCN, ISTA, FIRSTS, FRS, WRTSET )
C
C     Subroutine for SCHED that writes setup parameters for VLBA 
C     systems.  The setup files are read in GETSET.  For each 
C     parameter, only write it out if it has changed or if this is 
C     the first scan for the station.  The VLBAINT etc. routines 
C     take care of detecting changes.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER       I, LEN1, LENS, ISTA, ISCN, ICH, KSTA
      INTEGER       CRDN, CRSETC(MAXCHN), KS, ICHS, ISYN
      LOGICAL       FIRSTS, FRS, LPNTVLBA, LTANVLBA, LDOPN3DB
      LOGICAL       WRTSET, SWARNS
      LOGICAL       SCRD, XCRD, SALL, XALL
C
C     Parameters to hold previous values to avoid duplication.
C     Each one needs a counter for the number of channels.
C
      INTEGER       MBBC, MPERIOD, MBITS, MIFDIST
      INTEGER       MSYNTH, MSIDEBD, MNOISE, MFE, MIFCHAN, MSAMPR 
C
      INTEGER       USEBBC(MCHAN), LBBC(MCHAN), LNCHAN
      INTEGER       RPERIOD(MCHAN), LPERIOD(MCHAN), LBITS(MCHAN)
      INTEGER       RLEVEL(MCHAN), TEMPINT(MAXCHN)
      REAL          LAZCOLIM, LELCOLIM, LROTAT, LFOCUS
      REAL          DOAZ, DOEL
      DOUBLE PRECISION  DSYNTH(3), LSYNTH(3), DSAMPR, LSAMPR, RSYNTH
      LOGICAL       LDUALX, LUSEDIF(4), WARNCRD, TOOMANY
      CHARACTER     LSIDEBD(MCHAN)*1, LNOISE(4)*6, LFE(4)*5
      CHARACTER     LIFCHAN(MCHAN)*1, LLOGGING*8, LSTRING(4)*80
      CHARACTER     LFORMAT*8, PFORMAT*8, LIFDIST(4)*3
      CHARACTER     LLCP50CM*6, LRCP50CM*6, LNOISEF*4
      CHARACTER     TEMPCHAR(MAXCHN)*2
C
C     Save all the numbers that we need to keep between calls.
C
      SAVE          LPNTVLBA, LTANVLBA, LDOPN3DB
      SAVE          MBBC, MPERIOD, MBITS, MIFDIST
      SAVE          MSYNTH, MSIDEBD, MNOISE, MFE, MIFCHAN, MSAMPR 
      SAVE          LBBC, LNCHAN, LPERIOD, LBITS
      SAVE          LAZCOLIM, LELCOLIM, LROTAT, LFOCUS
      SAVE          LSAMPR, LSYNTH
      SAVE          LDUALX, LUSEDIF, LSIDEBD, LNOISE, LFE
      SAVE          LIFCHAN, LLOGGING, LSTRING, LFORMAT, LIFDIST
      SAVE          LLCP50CM, LRCP50CM, LNOISEF, WARNCRD
C
C     External L.O. stuff.
C
      DOUBLE PRECISION  EXTLO(4), LEXTLO(4)
      LOGICAL       USEDIF(4)
      CHARACTER     IFLABEL(4)*1, SIDEX(4)*1, LSIDEX(4)*1
      SAVE          LEXTLO, LSIDEX, SWARNS
C
      DATA          IFLABEL / 'A', 'B', 'C', 'D' /
      DATA          WARNCRD / .TRUE. /
C
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'VLBASU: Starting.' )
C
C     Get the number of channels and which setup channels to use.  When
C     using the RDBE, this might not be the same as the setup file.
C
      KS = NSETUP(ISCN,ISTA)
      CALL GETCRDN( ISCN, ISTA, CRDN, CRSETC )
C
C     Do an important legacy system check.  Done here rather than in chk
C     routines because it is legacy VLBA system specific, as is this routine,
C     and will go away when the VME's are replaced.  The legacy system 
C     controls the subreflector.  The new system controls the ellipsoid.  Both
C     sense the difference between S/X projects and pure S or X projects by
C     the presence of both bands among the baseband channels.  When there are
C     fewer crd channels than RDBE channels, it is possible to end up with
C     crd channels in only one band.  For example, S band can only take a small
C     number of channels from the RDBE_PFB, so simple defaulting can end up
C     only assigning X band channels.  Then the subreflector gets pointed 
C     at the X band which is blocked by the ellipsoid.  Don't ask how we lost
C     two days of wide band observing this way!
C
C     Use a simple method to detect the bad situation.  Note this might claim
C     some C band setups have X band, but that should not matter as they
C     will not have S band and will test as a single band setup.
C
      SCRD = .FALSE.
      XCRD = .FALSE.
      SALL = .FALSE.
      XALL = .FALSE.
      DO ICH = 1, CRDN
         IF( FREQREF(CRSETC(ICH),KS) .GT. 2000.D0 .AND.
     1       FREQREF(CRSETC(ICH),KS) .LT. 2900.D0 ) SCRD = .TRUE.
         IF( FREQREF(CRSETC(ICH),KS) .GT. 7700.D0 .AND.
     1       FREQREF(CRSETC(ICH),KS) .LT. 9500.D0 ) XCRD = .TRUE.
      END DO
      DO ICH = 1, NCHAN(KS)
         IF( FREQREF(ICH,KS) .GT. 2000.D0 .AND.
     1       FREQREF(ICH,KS) .LT. 2900.D0 ) SALL = .TRUE.
         IF( FREQREF(ICH,KS) .GT. 7700.D0 .AND.
     1       FREQREF(ICH,KS) .LT. 9500.D0 ) XALL = .TRUE.
      END DO
C
C     Detect an S/X observation.  If have one, make sure the crd 
C     channels cover both bands.  Note that the crd channels cannot
C     cover a band not in the main setup, so don't worry about S/X
C     in the CRD channels and only one band in the main setup - can't
C     happen.
C
      IF( XALL .AND. SALL ) THEN
         IF( .NOT. XCRD .OR. .NOT. SCRD ) THEN
            CALL WLOG( 1, 
     1         'VLBASU:  The main setup file has both S and X band.' )
            CALL WLOG( 1, 
     1         '         The crd files (VLBA legacy system) have '//
     2         'only one band. ' )
            CALL WLOG( 1, 
     1         '         The subreflector will not be positioned '//
     2         'properly.' )
            IF( .NOT. SCRD ) CALL WLOG( 1, 
     1         '         There will be no fringes!' )
            CALL WLOG( 1,
     1         '         Setup file: ' // SETNAME(KS) )
     2         
            CALL ERRLOG( '  Use SCHED defaults or use CRDSETCH '//
     1         'and CRDNCH to set both S and X band channels '//
     2         'for the crd files.' )
         END IF
      END IF
C
      IF( FIRSTS ) SWARNS = .TRUE.
C
C     Need pointer to entries in the station catalog for this 
C     schedule station ISTA.
C
      KSTA = STANUM(ISTA)
C
C     Protect against requesting too many BBC's.
C     GETCRDN also does some of this, but be sure.
C
      TOOMANY = .FALSE.
      IF( DAR(KSTA)(1:4) .EQ. 'RDBE' ) THEN
         IF( CRDN .GT. NBBC(KSTA) ) TOOMANY = .TRUE.
      ELSE
         DO I = 1, CRDN
            IF( BBC(CRSETC(I),KS) .GT. NBBC(KSTA) ) TOOMANY = .TRUE.
         END DO
      END IF
      IF( TOOMANY ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I3, A, I4, A, 2I4 )' )
     1         'VLBASU: ' // STATION(KSTA) // ' only has',
     2         NBBC(KSTA), ' BBCs.  Setup ', KS, ' requested more.',
     3         BBC(CRSETC(1),KS), BBC(CRSETC(CRDN),KS)
         CALL ERRLOG( MSGTXT )
      END IF
C
C     If there has been no change of setup or station, skip much of 
C     this routine.
C
      IF( WRTSET ) THEN
C
C        Much of setup is not desired for a station with just a
C        VLBA DAR (VLA, Green Bank, Bonn ...).  This is triggered
C        by either CONTROL='VLA' or by CONTROL(5:5)='V'
C

C     worry about validity of VLBADAR in the modern world.

         IF( .NOT. VLBADAR(KSTA) ) THEN
C
C           Front end spec.
C
            IF( FIRSTS ) THEN
               DO I = 1, 4
                  LFE(I) = 'xxxxx'
               END DO
            END IF
            CALL VLBACHAR( 'fe', 2, 4, FE(1,KS), LFE, MFE,
     1                     FIRSTS, IUVBA )
C
C           Set transfer switch if dual X band is to be used.
C
            IF( FIRSTS .OR. (DUALX(KS) .NEQV. LDUALX) ) THEN
               IF( DUALX(KS) ) THEN
                  WRITE( IUVBA, '( ''fexfer=(2,split)'' )' )
               ELSE
                  WRITE( IUVBA, '( ''fexfer=(2,norm)'' )' )
               END IF
               LDUALX = DUALX(KS)
            END IF
C
C           50 cm filter.  Don't write if the default of NARROW
C           is used.
C
            IF( FIRSTS ) THEN
               LLCP50CM = 'NARROW'
               LRCP50CM = 'NARROW'
            END IF
            IF( LCP50CM(KS) .NE. LLCP50CM ) THEN
               WRITE( IUVBA, '( A, A )' ) 'lcp50cm=', LCP50CM(KS)
            END IF
            IF( RCP50CM(KS) .NE. LRCP50CM ) THEN
               WRITE( IUVBA, '( A, A )' ) 'rcp50cm=', RCP50CM(KS)
            END IF
            LLCP50CM = LCP50CM(KS)
            LRCP50CM = RCP50CM(KS)
C
C           Various parameters in standard formats not wanted for VLA.
C
            CALL VLBACHAR( 'noise', 5, 4, NOISE(1,KS), LNOISE, 
     1             MNOISE, FIRSTS, IUVBA )
C
C           Round SYNTH to try to avoid digital precision issues
C           resulting in repeat prints.  It is not clear that this
C           is still needed after the change of SYNTH to double
C           precision, but it shouldn't hurt. Use 1 kHz rounding.  
C           The new synthesizers will be more finely tunable but will 
C           still be multiples of 10 kHz. Recall that the SYNTH values are GHz.
C
            DO I = 1, 3
               DSYNTH(I) = DNINT( SYNTH(I,KS) * 1.0D6 ) / 1.D6
            END DO
C
C           If using the new synthesizers (should be installed in 
C           2013/2014), lie to the legacy system to avoid generating
C           complaints about invalid frequencies.  The new synthesizers
C           are controlled by the Executor, so they will not be affected
C           by what is given here.  They, and the correlator are controlled
C           by the VEX file.  Lying here will result in incorrect frequencies
C           being given in monitor data and operator displays, but we
C           do not believe that is a problem.  Put a warning in the
C           crd file if the value has been changed.  Recall synthesizer 3
C           will still be the old style, so don't change it.
C
C
            IF( MODETEST(KS) ) THEN
               DO I = 1, 2
                  RSYNTH = 0.5D0 * DNINT( DSYNTH(I) * 2.D0 )
                  IF( DSYNTH(I) .GT. RSYNTH ) THEN
                    RSYNTH = RSYNTH + 0.1D0
                  ELSE
                    RSYNTH = RSYNTH - 0.1D0
                  END IF

                  IF( DSYNTH(I) .NE. RSYNTH .AND. SWARNS ) THEN
                     WRITE( IUVBA, '( A )' ) ' '
                     MSGTXT = '!*  synth 1 & 2 values shown are '//
     1               'not actual values used in new synthesizers.   *!'
                     WRITE( IUVBA, '( A )' ) MSGTXT(1:LEN1(MSGTXT))
                     MSGTXT = '!*  This suppresses warnings for '//
     1               'settings that the old synthesizers cannot use.*!'
                     WRITE( IUVBA, '( A )' ) MSGTXT(1:LEN1(MSGTXT))
                     WRITE( IUVBA, '( A )' ) ' '
                     SWARNS = .FALSE.
                  END IF
                  DSYNTH(I) = RSYNTH
               END DO
            END IF
C           
C
C           For the new (2012) C band receiver on the VLBA, the sideband
C           after the FIRSTLO mixes is not unique.  The same FIRSTLO can
C           be used for different frequencies.  The desired sideband is
C           encoded in SIDE1, so try to use that.  The variable VFESYN
C           was set in CHKVLBA to give the synthesizer being used for
C           each channel.  Here set the sign of the synthesizer setting
C           according to the first channel that uses that synthesizer.
C           Do not change anything if the synthesizer is not used (it
C           may be getting set to a benign value).  Look over all 
C           channels, not just the psuedo subset that will be written
C           for the old hardware when using the RDBE.
C
            DO ICHS = 1, NCHAN(KS)
C
C              For negative IF sideband, make DSYNTH negative.
C              Loop over all setup file parameters for this one.
C
               IF( FIRSTLO(ICHS,KS) .GT. FREQREF(ICHS,KS) .AND. 
     1            STANAME(ISTA)(1:4) .EQ. 'VLBA' ) THEN
                  ISYN = VFESYN(ICHS,KS)
                  IF( ISYN .GE. 1 .AND. ISYN .LE. 3 ) THEN
                     DSYNTH(ISYN) = -1.D0 * ABS( DSYNTH(ISYN) )
                  ELSE IF( FREQREF(ICHS,KS) .GT. 800.D0 .AND.
     1                     SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) THEN
                     MSGTXT = ' ' 
                     WRITE( MSGTXT, '( A, A, I3, I4, F10.2 )' ) 
     1                  'VLBASU: Program error. ',
     2                  'VFESYN not set ', ICHS, KS, FREQREF(ICHS,KS)
                     CALL WLOG( 1, MSGTXT )
                  END IF
               END IF
            END DO
            CALL VLBAREAL( 'synth', 5, 3, DSYNTH, LSYNTH, 
     1             MSYNTH, '(F4.1)', 4, FIRSTS, IUVBA )
C
C           For Pie Town link experiments, tell PT to switch to the
C           other noise cal switching frequency.
C
           IF( STANAME(ISTA) .EQ. 'VLBA_PT' .AND. 
     1          ( FIRSTS .OR. NOISEFRQ(KS) .NE. LNOISEF ) ) THEN
               WRITE( IUVBA, '( 2A )' ) 'noisefreq=', 
     1           NOISEFRQ(KS)(1:LEN1(NOISEFRQ(KS)))
               LNOISEF = NOISEFRQ(KS)
            END IF
C
C           End of non-VLA items.
C
         ELSE
C
C           Removed some VLAMODE checking here.
C
         END IF
C
C        Write the external LO and sideband specifications for all 
C        non-VLBA stations, even if they want fe etc (eg Bonn). 
C        Trigger on the station name - I don't really like doing this
C        but I don't see a clean alternative.
C        These are by channel.  They are supposed to be in GHz.
C

         IF( STANAME(ISTA)(1:4) .NE. 'VLBA' ) THEN
C
C           First find the data for each  used IF channel.
C           For this, loop over all setup file channels rather than
C           just the ones to be specified in the crd file.
C
            DO I = 1, 4
               USEDIF(I) = .FALSE.
               IF( FIRSTS ) THEN
                  LEXTLO(I) = UNSET
                  LSIDEX(I) = ' '
                  LUSEDIF(I) = .FALSE.
               END IF
               DO ICH = 1, NCHAN(KS)
                  IF( IFCHAN(ICH,KS) .EQ. IFLABEL(I) ) THEN
                     EXTLO(I) = FIRSTLO(ICH,KS) / 1000.D0
                     SIDEX(I) = SIDE1(ICH,KS)
                     USEDIF(I) = .TRUE.
                  END IF
               END DO
            END DO
C
C           Now write out the information for any channels that
C           have changed or are seen for the first time.
C
            DO I = 1, 4
               IF( USEDIF(I) .AND. ( EXTLO(I) .NE. LEXTLO(I) .OR.
     1                SIDEX(I) .NE. LSIDEX(I) .OR. 
     2                .NOT. LUSEDIF(I) )  ) THEN
                  WRITE( IUVBA, '( A, I1, A, F14.10, A )' )
     1                'extlo = (', I, ',', EXTLO(I), ')' 
                  WRITE( IUVBA, '( A, I1, A, A1, A )' )
     1                'extlosideband = (', I, ',', SIDEX(I), ')' 
                  LEXTLO(I) = EXTLO(I)
                  LSIDEX(I) = SIDEX(I)
               END IF
               LUSEDIF(I) = USEDIF(I)
            END DO
C
         END IF
C
C        Logging type:
C
         IF( FIRSTS .OR. LOGGING(KS) .NE. LLOGGING ) THEN
            WRITE( IUVBA, '( A, A )' ) 'logging=', LOGGING(KS)
            LLOGGING = LOGGING(KS)
         END IF
C
C        Number of channels.
C
         IF( FIRSTS .OR. CRDN .NE. LNCHAN ) THEN 
            WRITE( IUVBA, '( A, I2 )' ) 'nchan=', CRDN
            LNCHAN = CRDN
         END IF
C
C        Various parameters in standard formats. 
C
C        For the format, don't just make it "NONE" if using 
C        the RDBE.  That shuts off all formatter configuration
C        which means the pulse cal doesn't get set up.
C        So specify a valid format for the samplerate.  Note
C        that CRDBW may cause a high oversampling, but that
C        should be ok.  We can't just use the setup file format
C        (formats are VDIF and MARK5B) because that will not 
C        encode the fan-out that the legacy system wants to 
C        know about.  So base it on the samprate.
C
         IF( DAR(KSTA)(1:4) .EQ. 'RDBE' ) THEN
            IF( FORMAT(KS) .EQ. 'NONE' ) THEN
               PFORMAT = 'NONE'
            ELSE IF( SAMPRATE(KS) .GT. 16.0 ) THEN
               PFORMAT = 'VLBA1:4'
            ELSE IF( SAMPRATE(KS) .EQ. 16.0 ) THEN
               PFORMAT = 'VLBA1:2'
            ELSE IF( SAMPRATE(KS) .LT. 16.0 ) THEN
               PFORMAT = 'VLBA1:1'
            ELSE
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I5, F10.2, A )' )
     1            'VLBASU:  Something wrong with SAMPRATE ',
     2            KS, SAMPRATE(KS), '  Programming error?'
               CALL ERRLOG( MSGTXT )
            END IF
C
C           Write a message about the crd files - just once.
C
            IF( WARNCRD ) THEN
               CALL WRTMSG( 0, 'VLBASU', 'CRD_RDBE_Warning' )
               WARNCRD = .FALSE.
            END IF
C
         ELSE
C
C           For non-RDBE projects, use the setup file format.
C
            PFORMAT = FORMAT(KS)
C
         END IF
C
C        Now write the format if it has changed.
C
         IF( FIRSTS .OR. PFORMAT .NE. LFORMAT ) THEN
C
C           For non-RDBE projects, use the setup file format.
C
            WRITE( IUVBA, '( 2A )' )
     1             'format=', PFORMAT(1:LEN1(PFORMAT))
         END IF
         LFORMAT = PFORMAT
C
C        Removed barrel roll spec for tape.
C
C        When the VLBA legacy system is being used for recording, 
C        or for non-VLBA systems (which shouldn't get into this routine
C        anyway), the baseband converter assignment should be
C        as per the setup file.  But when the VLBA the RDBE system
C        is used, different assignments are needed.  Most obviously,
C        when the RDBE_PFB is used, there are too many channels.
C        For these cases, the number of channels is restricted to
C        no more than 8 (4 after early 2014), the number of BBCs, and 
C        we can just assign the BBCs sequentially (BBC number = channel 
C        number).
C
C        Note CONTROL(KSTA) .EQ. 'VLBA' .OR. VLBADAR(KSTA) can be
C        assumed because of the call to VLBA in CRDWRT.  VLBA calls
C        this routine.  For non-RDBE cases, CRSETC(ICH) will almost certainly
C        be ICH and the second loop will actually be over 1 to NCHAN(KS).
C
         IF( DAR(KSTA)(1:4) .EQ. 'RDBE' ) THEN
            DO ICH = 1, CRDN
               USEBBC(ICH) = ICH
            END DO
         ELSE 
            DO ICH = 1, CRDN
               USEBBC(ICH) = BBC(CRSETC(ICH),KS)
            END DO
         END IF
C
C
C        Signal routing and properties information.
C        Now we use the restricted set of channels.
C        But IFDIST is per IF, not baseband channel.
C

         CALL VLBACHAR( 'ifdistr', 7, 4, IFDIST(1,KS), LIFDIST, 
     1          MIFDIST, FIRSTS, IUVBA )
         CALL VLBAINT( 'baseband', 8, CRDN, USEBBC, LBBC,
     1          MBBC, FIRSTS, IUVBA )
         DO ICH = 1, CRDN
            TEMPCHAR(ICH) = IFCHAN(CRSETC(ICH),KS)
         END DO
         CALL VLBACHAR( 'ifchan', 6, CRDN, TEMPCHAR, 
     1          LIFCHAN, MIFCHAN, FIRSTS, IUVBA )
         DO ICH = 1, CRDN
            TEMPCHAR(ICH) = SIDEBD(CRSETC(ICH),KS)
         END DO
         CALL VLBACHAR( 'sideband', 8, CRDN, TEMPCHAR, 
     1          LSIDEBD, MSIDEBD, FIRSTS, IUVBA )
         DO ICH = 1, CRDN
            TEMPINT(ICH) = BITS(CRSETC(ICH),KS)
         END DO
         CALL VLBAINT( 'bits', 4, CRDN, TEMPINT, LBITS,
     1          MBITS, FIRSTS, IUVBA )
C
C        Some parameters for which NCHAN versions should be printed,
C        but for which SCHED only allows one input.
C
         IF( FIRSTS .OR. PERIOD(KS) .NE. LPERIOD(1) ) THEN
            DO I = 1, CRDN
               RPERIOD(I) = PERIOD(KS)
            END DO
            CALL VLBAINT( 'period', 6, CRDN, RPERIOD, LPERIOD,
     1           MPERIOD, FIRSTS, IUVBA )
         END IF
C
C        Write any direct transfer strings.
C
         IF( FIRSTS ) THEN
            DO I = 1, 4
               LSTRING(I) = ' '
            END DO
         END IF
         DO I = 1, 4
            IF( STRING(I,KS) .NE. LSTRING(I) ) THEN
               LENS = LEN1( STRING(I,KS) )
               IF( LENS .NE. 0 ) THEN
                  WRITE( IUVBA, '(A)' ) STRING(I,KS)(1:LENS)
               END IF
               LSTRING(I) = STRING(I,KS)
            END IF
         END DO
C
      END IF                   ! New setup.
C
C     Reset the levels.  This can happen even without a new setup
C     if there have been pointing or Ta scans.
C
      IF( FIRSTS .OR. LEVEL(KS) .NE. LLEVEL(1) ) THEN
         DO I = 1, CRDN
            RLEVEL(I) = LEVEL(KS)
         END DO
         CALL VLBAINT( 'level', 5, CRDN, RLEVEL, LLEVEL,
     1           MLEVEL, FIRSTS, IUVBA )
      END IF
C
C     Write focus and rotation commands if needed.
C
      IF( FIRSTS ) THEN
         LFOCUS = 0.0
         LROTAT = 0.0
      END IF
      IF( ROTPAT .EQ. 0 .AND. 
     1    ( FOCUS(ISCN) .NE. LFOCUS .OR. ROTATION(ISCN) .NE. LROTAT ) )
     2     THEN
         WRITE( IUVBA, '( A, F7.2, A, F7.2 )' ) 
     1      'focus = ', FOCUS(ISCN), '  rotation = ', ROTATION(ISCN)
         LFOCUS = FOCUS(ISCN)
         LROTAT = ROTATION(ISCN)
      END IF
C
C     Colimation offsets - do on first scan, when there has been a
C     change, and when going from pointing or Ta scans to non-pointing
C     scans.  Note that colimation offsets can come from either the
C     setup file or the schedule.
C
      DOAZ = SAZCOL(ISCN) + AZCOLIM(KS)
      DOEL = SELCOL(ISCN) + ELCOLIM(KS)
C
      IF( FIRSTS .OR. DOAZ .NE. LAZCOLIM .OR. DOEL .NE. LELCOLIM .OR.
     1    ( LPNTVLBA .AND. .NOT. PNTVLBA(ISCN) ) .OR.
     2    ( LTANVLBA .AND. .NOT. TANVLBA(ISCN) ) .OR. 
     3    ( LDOPN3DB .AND. .NOT. DOPN3DB(ISCN) ) ) THEN
C
         WRITE( IUVBA, '( A, F7.2, A, F7.2 )' ) 'azcolim=', 
     1              DOAZ, '  elcolim=', DOEL
C
      END IF
      LAZCOLIM = DOAZ
      LELCOLIM = DOEL
      LPNTVLBA = PNTVLBA(ISCN)
      LTANVLBA = TANVLBA(ISCN)
      LDOPN3DB = DOPN3DB(ISCN)
C
C     Deal with synthesizer settings (freq and bw) and pulse cal.  
C     This can change scan by scan because of DOPCAL and main 
C     routine FREQ and BW.  It can also be set by the CRD parameters
C     when using the RDBE.
C
      CALL WRTFREQ( ISCN, ISTA, FIRSTS, WRTSET )
C
C     Tape track and sample rate specifications.  
C     Tracks can also change without setup change, mainly on direction
C     changes when not all heads are in use.
C     Initialize the "L" variables indepently on the first scan in
C     case the output calls are skipped because the first scan is 
C     pointing with format NONE.  Without this, the station can wind
C     up with no track assignments.
C
      IF( FIRSTS ) THEN
         LSAMPR = 0.0
      END IF
C
C     Don't write formatter type commands for non-recording scans.
C     This is to try to prevent formatter reconfigures when things
C     like reference pointing are done.
C     When I first tried this, omitting the samplerate, cksched 
C     complained about incompatible samplerate and format.  So I
C     moved the NOREC check to cover only the track specification.
C     Also protect against too high samplerate when using the RDBE.
C
C     Note tht the samprate will be likely be rather far from 
C     appropriate if crdbw is selected far different from bbcbw.
C     I don't think that matters, but keep an eye on it.
C
      IF( VLBITP .AND. FORMAT(KS) .NE. 'NONE' ) THEN
C
         IF( DAR(KSTA)(1:4) .NE. 'RDBE' ) THEN
            DSAMPR = SAMPRATE(KS)
         ELSE
            DSAMPR = MIN( SAMPRATE(KS), 32.0 )
         END IF
         CALL VLBABWS( 'samplerate', 10, 1, DSAMPR, LSAMPR, 
     1       MSAMPR, FIRSTS, IUVBA )
C
C        Removed track assignments that were used for tape.
C
      END IF
C
C     Set frequency switching request.
C
      FRS = FRSWITCH(KS)
C
      IF( DEBUG ) CALL WLOG( 0, 'VLBASU: Ending' )
      RETURN
      END          

      SUBROUTINE STSUM
C
C     This routine, called by SCHSUM, writes some summary 
C     information about about the numbers of scans, and hours at
C     each station. Much of the data were gathered in SCHTIM.  
C     Note NOTAPE really means no recordings.
C
C     This was made a separate routine from SCHSUM when there
C     got to be too many combinations of FUZZY and MK5C vs MK5A
C     so a lot of code was needed.
C
C     For the legacy VLBA system, we want to keep track of 
C     formatter reconfigures.  Don't bother when they are 
C     not needed.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER     ISCN, ISTA, KSTA, LEN1, IC
      INTEGER     NTPS
      LOGICAL     GOTTPS, DORECONF
      CHARACTER   LINE*90
C ----------------------------------------------------------------
C     Sense if there are any stations with a VLBA DAR.  Those are
C     the ones that need to worry about the reconfigures.  These
C     are the legacy (MARK5A/Tape) DARs that are no longer in use
C     for recording, so this might be removed some day.
C
      DORECONF = .FALSE.
      DO ISTA = 1, NSTA
         KSTA = STANUM(ISTA)
         IF( DAR(KSTA) .EQ. 'VLBA' ) DORECONF = .TRUE.
      END DO
C
C     Do most of this only if stations were recording.
C     Note NOTAPE means that the whole observation is a non-recording
C     observation, like OBSTYP = PTVLBA or CONFIG.
C
      IF( .NOT. NOTAPE ) THEN
C
C        Potentially do tables for the core scans, the all scans
C        including the PREEMPT=EXTRA scans, and the DOSCANS range.
C        Only do the latter two if needed.
C
         WRITE( ISUM, '( 1X, /, A )' ) 'STATION SCAN SUMMARIES:'
C
         IF( FUZZY ) THEN
            WRITE( ISUM, '( 1X, /, A )' )  
     1       '  Summary for core scans (PREEMPT not set to ''EXTRA''): '
         END IF         
C
C        Write the table.  It will either be the only one, or
C        the one for the core depending on FUZZY and DOSCANS.
C
         LINE = '  Station  Control   Scans   Scan   Record  Record'//
     1       '   Gbytes'
         IF( DORECONF ) LINE = LINE(1:LEN1(LINE))//
     1       '     Formatter       Sync '
         WRITE( ISUM, '( A )' ) LINE(1:LEN1(LINE))
C
         LINE = ' '
         LINE(29:52) = 'Hours   Hours   Scans'
         IF( DORECONF ) LINE(64:86) = 'Reconfigures    Hours'
         WRITE( ISUM, '( A )' ) LINE(1:LEN1(LINE))
C
         DO ISTA = 1, NSTA
            LINE = ' '
            WRITE( LINE, '( 2X, A8, 2X, A5, 2X, I6, F8.2, F8.2,
     1         I8, 2X, F8.0 )' )
     2         STANAME(ISTA), CONTROL(STANUM(ISTA)), NSTSC(ISTA), 
     3         SCNHR(ISTA), TPHR(ISTA), TPSCN(ISTA), TGBYTES(ISTA)
            IC = LEN1( LINE ) + 1
            IF( DORECONF ) THEN
               IF( DAR(STANUM(ISTA))(1:4) .NE. 'VLBA' ) THEN
                  WRITE( LINE(IC:IC+30), '( I13, F12.2 )' )
     1                 NRECONF(1,ISTA), TTSYNC(ISTA) * 24.0
               ELSE
                  WRITE( LINE(IC:IC+30), '( I9, A, I3, F12.2 )' )
     1               NRECONF(1,ISTA), '/', NRECONF(2,ISTA), 
     2               TTSYNC(ISTA) * 24.0
               END IF
            END IF
            WRITE( ISUM, '( A )' ) LINE(1:LEN1(LINE))
         END DO
C
C        If there are EXTRA scans, then write the table over
C        for the the full time.
C
         IF( FUZZY ) THEN
C
C
            WRITE( ISUM, '( 1X, /, A )' )  
     1        '  Summary for all scans (including PREEMPT = ''EXTRA''):'
            LINE = '  Station  Control   Scans   Scan   Record  '//
     1        'Record   Gbytes'
            IF( DORECONF ) LINE = LINE(1:LEN1(LINE))//
     1        '     Formatter       Sync '
            WRITE( ISUM, '( A )' ) LINE(1:LEN1(LINE))
C
            LINE = ' '
            LINE(29:52) = 'Hours   Hours   Scans'
            IF( DORECONF ) LINE(64:86) = 'Reconfigures    Hours'
            WRITE( ISUM, '( A )' ) LINE(1:LEN1(LINE))
C
            DO ISTA = 1, NSTA
               LINE = ' '
               WRITE( LINE, '( 2X, A8, 2X, A5, 2X, I6, F8.2, F8.2,
     1            I8, 2X, F8.0 )' )
     2            STANAME(ISTA), CONTROL(STANUM(ISTA)), 
     3            ENSTSC(ISTA), ESCNHR(ISTA), ETPHR(ISTA), 
     4            ETPSCN(ISTA), EGBYTES(ISTA)
               IC = LEN1( LINE ) + 1
               IF( DORECONF ) THEN
                  IF( DAR(STANUM(ISTA))(1:4) .NE. 'VLBA' ) THEN
                     WRITE( LINE(IC:IC+30), '( I13, F12.2 )' )
     1                    NRECONF(1,ISTA), TTSYNC(ISTA) * 24.0
                  ELSE
                     WRITE( LINE(IC:IC+30), '( I9, A, I3, F12.2 )' )
     1                  NRECONF(1,ISTA), '/', NRECONF(2,ISTA), 
     2                  TTSYNC(ISTA) * 24.0
                  END IF
               END IF
               WRITE( ISUM, '( A )' ) LINE(1:LEN1(LINE))
            END DO
         END IF
C
C        Do a set for a DOSCANS range.
C
         IF( DOSCANS(1) .GT. 0 ) THEN
C
            WRITE( ISUM, '( 1X, /, A )' )  
     1        '  Summary for all scans selected by DOSCANS:'
            LINE = '  Station  Control   Scans   Scan   Record  '//
     1        'Record   Gbytes'
            IF( DORECONF ) LINE = LINE(1:LEN1(LINE))//
     1        '     Formatter       Sync '
            WRITE( ISUM, '( A )' ) LINE(1:LEN1(LINE))
C
            LINE = ' '
            LINE(29:52) = 'Hours   Hours   Scans'
            IF( DORECONF ) LINE(64:86) = 'Reconfigures    Hours'
            WRITE( ISUM, '( A )' ) LINE(1:LEN1(LINE))
C
C probably still need to get case dependent nreconfs.  Deal with
C after SCHED 11.0
C
            DO ISTA = 1, NSTA
               LINE = ' '
               WRITE( LINE, '( 2X, A8, 2X, A5, 2X, I6, F8.2, F8.2,
     1            I8, 2X, F8.0 )' )
     2            STANAME(ISTA), CONTROL(STANUM(ISTA)), 
     3            DNSTSC(ISTA), DSCNHR(ISTA), DTPHR(ISTA), 
     4            DTPSCN(ISTA), DGBYTES(ISTA)
               IC = LEN1( LINE ) + 1
               IF( DORECONF ) THEN
                  IF( DAR(STANUM(ISTA))(1:4) .NE. 'VLBA' ) THEN
                     WRITE( LINE(IC:IC+30), '( I13, F12.2 )' )
     1                    NRECONF(1,ISTA), TTSYNC(ISTA) * 24.0
                  ELSE
                     WRITE( LINE(IC:IC+30), '( I9, A, I3, F12.2 )' )
     1                  NRECONF(1,ISTA), '/', NRECONF(2,ISTA), 
     2                  TTSYNC(ISTA) * 24.0
                  END IF
               END IF
               WRITE( ISUM, '( A )' ) LINE(1:LEN1(LINE))
            END DO
         END IF
C
C
      ELSE
         WRITE( ISUM, '( A, /, A )' )  'STATION SCAN SUMMARIES: ',
     1       '  Station  Control   Scans '
         DO ISTA = 1, NSTA
            WRITE( ISUM, '( 2X, A8, 2X, A5, 2X, I6 )' ) 
     1          STANAME(ISTA), CONTROL(STANUM(ISTA)), NSTSC(ISTA) 
         END DO
      END IF
C
C     Explain Sync Hours.
C
      WRITE( ISUM, '( 1X )' )
      WRITE( ISUM, '( A )' )
     1      '  Notes on the station scan summaries: '
      WRITE( ISUM, '( 1X )' )
      WRITE( ISUM, '( A, /, A, /, A, /, A, /, A, /, A )' )
     1      '    "Record Scans" are periods of recording with no '//
     2      'gap.  The Mark5A disk systems ', 
     3      '    have a limit of 1024 such scans.  There are often '//
     4      'multiple projects on a disk pack.',
     5      '    If using MARK5A, try to keep above about 6 GB per '//
     6      'record scan by using MINPAUSE ',
     7      '    and PRESTART to prevent short gaps.  However, '//
     8      'also try to prevent record scans ', 
     9      '    of more than an hour to minimize risk to data '//
     A      'from playback problems.',
     B      '    MARK5C will have one observe scan per record scan '//
     C      'and there is no limit to the number.'
      WRITE( ISUM, '( 1X )' )
C
C     Only talk about reconfigurations and sync when they might be an issue.
C
      IF( .NOT. NOTAPE .AND. DORECONF ) THEN
         WRITE( ISUM, '( A, /, A)' )
     1      '    "Sync Hours" is on-source, in-scan time ' //
     2      'lost during correlation to resyncing',
     3      '    recordings.  Resyncs follow tape stoppages '//
     4      'and formatter reconfigures.'
         WRITE( ISUM, '( 1X )' )
         WRITE( ISUM, '( A, /, A, /, A )' )
     1      '    For VLBA DAR stations, total reconfigures and ' //
     2      'reconfigures during recording are shown.',
     3      '    Reconfigures during recording can cause ' //
     4      'slow correlator sync.',
     5      '    Any reconfigure can slow sync at JIVE.'
      END IF
C
C     Set up a warning about early tape starts.
C
      NTPS = 0
      GOTTPS = .FALSE.
      DO ISCN = SCAN1, SCANL
         DO ISTA = 1, NSTA
            IF( TPSTART(ISCN,ISTA) .NE. 0.D0 ) THEN
               GOTTPS = .TRUE.
               NTPS = NTPS + 1
            END IF
         END DO
      END DO
      IF( GOTTPS ) THEN
         WRITE( ISUM, '( 1X )' )
         WRITE( ISUM, '( 2A, I5, A )' ) '    Recording started',
     1         ' before scan start time ', NTPS, 
     2         ' times.  See PRESTART and MINPAUSE.'
         WRITE( ISUM, '( 2A )' )
     1         '    They may have been kept running through ',
     2         'short scan gaps.'
         WRITE( ISUM, '( 2A )' )
     1         '    The number can be large because each ',
     2         'station/scan combination counts.'
      END IF
      WRITE( ISUM, '( 1X, /, 1X, / )' )
C
      RETURN
      END

      SUBROUTINE AUTODOWN( LASTISCN, ISCN, NGOOD )
Cf2py intent(in) LASTISCN, ISCN
Cf2py intent(out) NGOOD
C
C     Subroutine for SCHED that removes any stations using 
C     disk recording from a scan in which the 
C     source is not up. This helps save media, especially at MK, 
C     and can prevent excessive trips to the site by the site tech.
C     It also helps Mark5 stations avoid slews to unnecessary scans.
C
C     Recalculate NGOOD since that can be changed here.
C
      INCLUDE   'sched.inc'
C
      INTEGER   ISCN, ISTA, NGOOD, KSTA, LASTISCN(MAXSTA)
      INTEGER   DROPSTA(MAXSTA), IDROP, NDROP, NKEEP
      REAL      SLEWD
      LOGICAL   DOWNWARN, SLEWWARN
      DATA      DOWNWARN   / .TRUE. /
      DATA      SLEWWARN   / .TRUE. /
      SAVE      DOWNWARN, SLEWWARN
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'AUTODOWN starting. ' )
C
      NGOOD = 0
C
      NDROP = 0
      DO ISTA = 1, NSTA
C
C        Take out stations that are down.
C
         IF( STASCN(ISCN,ISTA) ) THEN
            IF( .NOT. DODOWN(ISCN) .AND. ( USEDISK(ISTA) .AND.
     1           ( UP1(ISCN,ISTA) .EQ. 'D' .AND.
     2             UP2(ISCN,ISTA) .EQ. 'D' ) 
     3           ) ) THEN
               STASCN(ISCN,ISTA) = .FALSE.
               IF( DOWNWARN ) THEN
                  CALL WRTMSG( 0, 'AUTODOWN', 'scanremoval' )
                  DOWNWARN = .FALSE.
               END IF
            END IF
         END IF
C
C        Now take out any station that just can't get there
C        before the end of the scan because of a slow slew.
C        
C        Make an exception for a wrap.  The Verify schedules 
C        have found several cases when phase referencing when
C        a wrap is needed for one well before the other.  
C        The antenna is left on the second source for several
C        scan pairs where, if it had just gone ahead, it could
C        get there, perhaps after missing the scan, but then
C        go back and forth at the new wrap.  So, do not take
C        the source out if it is an altaz antenna and the 
C        azimuth slew is more than 315 degrees (limit is
C        arbitrary, but probably ok).  Still go ahead and put
C        a W beside such scans.
C
C        Make another exception - don't take all stations out
C        of a scan because of the slew.  One of the examples 
C        had a lot of short phase referencing scans, scheduled
C        with duration, that followed a long slew for which the
C        duration was not adequate for any antenna to get there.
C        All of those short scans got sucked up against the long
C        slew and dropped.
C
         IF( STASCN(ISCN,ISTA) ) THEN
            IF( USEDISK(ISTA) .AND.
     1            TONSRC(ISCN,ISTA) .GE. STOPJ(ISCN) ) THEN
               IF( .NOT. DODOWN(ISCN) ) THEN
                  KSTA = STANUM(ISTA)
                  SLEWD = ABS( AZ1(ISCN,ISTA) - 
     1                         AZ2(LASTISCN(ISTA),ISTA) )
                  IF( MOUNT(KSTA) .NE. 'ALTAZ' .OR. 
     1                 SLEWD .LT. 315.0 ) THEN
                     STASCN(ISCN,ISTA) = .FALSE.
                     NDROP = NDROP + 1
                     DROPSTA(NDROP) = ISTA
                  END IF
               END IF
               
C
C              Change the up/down warning to a slew warning.
C              Keep these even if keeping the scan to indicate
C              it won't get there.
C
               UP1(ISCN,ISTA) = 'W'
               UP2(ISCN,ISTA) = 'W'
               IF( SLEWWARN ) THEN
                  CALL WRTMSG( 0, 'AUTODOWN', 'slewremoval' )
                  SLEWWARN = .FALSE.
               END IF
C
            END IF
         END IF
C
      END DO
C
C     See how many stations got kept.
C
      NKEEP = 0
      DO ISTA = 1, NSTA
         IF( STASCN(ISCN,ISTA) ) THEN
            NKEEP = NKEEP + 1
         END IF
      END DO
C
C     If NKEEP is zero, and some were dropped only because of 
C     slew, put them back to avoid never getting to a DUR scheduled
C     phase referencing sequence.
C
      IF( NKEEP .EQ. 0 .AND. NDROP .GE. 1 ) THEN
         DO IDROP = 1, NDROP
            STASCN(ISCN,DROPSTA(IDROP)) = .TRUE.
         END DO
      END IF      
C
C     Get NGOOD after the above adjustments.
C
      DO ISTA = 1, NSTA
         IF( STASCN(ISCN,ISTA) .AND.
     1       ( EL1(ISCN,ISTA) .GE. OPMINEL(ISCN) .AND. 
     2         EL2(ISCN,ISTA) .GE. OPMINEL(ISCN) .AND.
     3         UP1(ISCN,ISTA) .EQ. ' ' .AND. 
     4         UP2(ISCN,ISTA) .EQ. ' ' ) ) THEN
             NGOOD = NGOOD + 1
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE VXVBRX( KS, ICH, VBCOM )
C
C     Routine for writing comment information to the $IF segments
C     of a VEX file to indicate the receiver, any receiver LO 
C     (when there is a second mix in an IF converter) and any
C     externally selected filter.  This only for VLBA stations
C     but was changed to do all stations on Dec. 13, 2012 (RCW).
C
C     This information is required at the VLBA telescopes and at
C     the VLA because it cannot be deduced in all cases from other 
C     information in the VEX file and there is not normally enough
C     operator interaction to let someone take care of it outside
C     the schedule.  Among other things, it is required to set 
C     the various switches on the VLBA antennas.  
C
C     All of the information needed is in the setup group on a per
C     IF basis.  The calling program has both the setup group KS
C     and ICH, so we only need those to get the info needed.
C
C     Routine by RCW Sep. 2011.
C     Bug fix Nov. 15, 2011.  Was using IF number as channel number.
C
C     Bug found Sept. 10, 2012.  if_def lines are reused if they are 
C     good for more than one station.  But the line is only 
C     constructed based on the first station to use it.  If a 
C     non-VLBA station is first, the comments get omitted.  A user
C     ran into this when he specified EB first.  I am going to 
C     prevent the Vex code (VXCFIF) from using the same if_def for two
C     IFs that are not both VLBA or both non-VLBA.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER        KS, ICH
      INTEGER        LEN1
      INTEGER        SYNPRT
      LOGICAL        GOTIT
      CHARACTER      VBCOM*(*), LOPRT*20, FETXT*6, FILTTXT*6

C ------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'VXVBRX starting.' )
C
      GOTIT = .FALSE.
C
C     Do for all stations.
C                  IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) THEN
C
C
C         Get the first two FE synth settings for the VLBA.
C         This is for once the new synthesizers are installed.
C
          IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) THEN
             WRITE( LOPRT, '( 2F10.2 )' ) SYNTH(1,KS) * 1.D3, 
     1          SYNTH(2,KS) * 1.D3
          ELSE
             LOPRT = '  0.0   0.0 '
          END IF
C
C         Get the receiver.  Recall that, on the VLBA,
C         IFs A, B, C, D correspond to the 4 elements of the
C         FE array.
C
          IF( IFCHAN(ICH,KS) .EQ. 'A' ) THEN
             FETXT = FE(1,KS)
          ELSE IF( IFCHAN(ICH,KS) .EQ. 'B' ) THEN
             FETXT = FE(2,KS)
          ELSE IF( IFCHAN(ICH,KS) .EQ. 'C' ) THEN
             FETXT = FE(3,KS)
          ELSE IF( IFCHAN(ICH,KS) .EQ. 'D' ) THEN
             FETXT = FE(4,KS)
          ELSE
             FETXT = 'NA'
          END IF
C
C         Get the receiver LO frequency, but only for the VLBA
C         because this depends on the synthesizer settings which
C         don't translate well for other stations.
C
C         Whenever the third synthesizer comes under the control
C         of the Executor, we will likely want to put its frequency
C         setting here even when it is not used.  But Matthias and
C         I decided to hold off on that for now (RCW  March 2013).
C
          IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) THEN
             IF( FETXT .EQ. '1cm' ) THEN
                SYNPRT = NINT( 1000.D0 * SYNTH(3,KS) )
             ELSE IF( FETXT .EQ. '7mm' ) THEN
                SYNPRT = NINT( 3000.D0 * SYNTH(3,KS) )
             ELSE IF( FETXT .EQ. '3mm' ) THEN
                SYNPRT = NINT( 6000.D0 * SYNTH(3,KS) )
             ELSE
                SYNPRT = 0
             END IF
          ELSE
             SYNPRT = 0
          END IF
C
C         Get the 50cm filter setting for the VLBA.
C
          IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' .AND. 
     1        ( FETXT .EQ. '50cm' .OR. FETXT .EQ. '90cm' ) ) THEN
             IF( IFCHAN(ICH,KS) .EQ. 'A' .OR.
     1           IFCHAN(ICH,KS) .EQ. 'C' ) THEN
                FILTTXT = RCP50CM(KS)
             ELSE IF( IFCHAN(ICH,KS) .EQ. 'B' .OR.
     1           IFCHAN(ICH,KS) .EQ. 'D' ) THEN
                FILTTXT = LCP50CM(KS)
             END IF
          ELSE
             FILTTXT = 'NA'
          END IF
C
          GOTIT = .TRUE.
C         END IF              Doing for all stations.
C
C     Fill out VBCOM
C
      VBCOM = ' '
      IF( GOTIT ) THEN
         WRITE( VBCOM, '( 1X, A, 2X, A, I6, 1X, A )' )
     1       LOPRT(1:LEN1(LOPRT)), FETXT(1:LEN1(FETXT)), SYNPRT,
     2       FILTTXT(1:LEN1(FILTTXT))
      ELSE
         VBCOM = ' '
      END IF
C
      RETURN
      END

      SUBROUTINE SETNOREC( NEEDFMT )
C
C     Set the formats for non-recording scans.
C     Try to match following scans fan out.  That might help
C     avoid a reconfigure.
C     Don't worry about keeping the bit rates constant across
C     stations - that doesn't matter for non-recording scans.
C
C     Called by SETFORM, which has already checked that all 
C     recording scans have formats already set.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER  KS, ISTA, ISCN
      REAL     FANBUFF, TRKBPS
      LOGICAL  NEEDFMT(*), OK
C ----------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SETNOREC: starting' )
C
C     Loop through stations to find unset formats.
C
      DO ISTA = 1, NSTA
C
C        Go backwards through time to make it easier to match
C        the following scans.
C
         FANBUFF = 0.0
         DO ISCN = NSCANS, 1, -1
C
            IF( STASCN(ISCN,ISTA) ) THEN
               KS = NSETUP(ISCN,ISTA)
C
C              Record the last fanout on a previously set scan.
C
               IF( VLBAMKIV(KS) .AND. .NOT. NEEDFMT(KS) ) THEN
                  FANBUFF = SAMPRATE(KS) / TBPS(KS)
               END IF
C
C              Set the format if needed.  Recall that SETFORM
C              already called SETFMT with TRKBPS set to 0.0 so 
C              any forced formats have been dealt with, including
C              all wide band formats.  Use the same fanout previously
C              determined on a recording scan, but constrain the
C              track bit rate to lie in the allowed range.
C
               IF( VLBAMKIV(KS) .AND. NEEDFMT(KS) .AND. .NOT. 
     1             RECUSED(KS) ) THEN
C
                  IF( FANBUFF .NE. 0.0 ) THEN
                     TRKBPS = SAMPRATE(KS) / FANBUFF
                     TRKBPS = MIN( 8.0, TRKBPS )
                     TRKBPS = MAX( 2.0, TRKBPS )
                     CALL SETFMT( KS, TRKBPS, OK )
                     IF( OK ) NEEDFMT(KS) = .FALSE.
                  END IF
C
               END IF
            END IF
         END DO
C
      END DO
C
C     Set the formats of anything left, if possible.  Again recall
C     that all forcable formats were dealt with on the first 
C     call to SETFMT from SETFORM.  So don't worry about the wide
C     bandwidth cases.
C
      DO KS = 1, NSET
         IF( VLBAMKIV(KS) .AND. NEEDFMT(KS) ) THEN
            IF( SAMPRATE(KS) .GT. 8.0 ) THEN
               TRKBPS = 8.0
            ELSE
               TRKBPS = SAMPRATE(KS)
            END IF
C
            CALL SETFMT( KS, TRKBPS, OK )
            IF( OK ) NEEDFMT(KS) = .FALSE.
C
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE BBCVLBA( KS )
C
C     Routine for SCHED, called by SETBBC, that sets the BBC
C     assignments for full VLBA systems.  These are systems
C     for which all BBCs can see all 4 IFs.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
      INCLUDE    'schfreq.inc'
C
      INTEGER    ICH, JCH, KS, MMBBC
C -------------------------------------------------------------------  
C     Determine the highest numbered BBC already assigned.
C     Usually if any are to be defaulted, all will be so this will
C     be zero.
C
      MMBBC = 0
      DO ICH = 1, NCHAN(KS)
         MMBBC = MAX( MMBBC, BBC(ICH,KS) )
      END DO
C
C     Loop through channels assigning the channel to the
C     same BBC as a previous one with the same FREQREF and IFCHAN,
C     if there is one (can be difference sideband), or to a new BBC.
C
      DO ICH = 1, NCHAN(KS)
         IF( BBC(ICH,KS) .EQ. 0 .AND. ICH .GT. 1 ) THEN
            DO JCH = 1, ICH-1
               IF( FREQREF(ICH,KS) .EQ. FREQREF(JCH,KS) .AND.
     1             IFCHAN(ICH,KS) .EQ. IFCHAN(JCH,KS) ) THEN
                  BBC(ICH,KS) = BBC(JCH,KS)
                  GO TO 100
               END IF
            END DO
  100       CONTINUE
         END IF
C
C        If BBC is still 0, assign the next one.
C
         IF( BBC(ICH,KS) .EQ. 0 ) THEN
            BBC(ICH,KS) = MMBBC + 1
         END IF
C
C        Determine new highest assigned BBC.
C
         MMBBC = MAX( MMBBC, BBC(ICH,KS) )
C
      END DO
C
      RETURN 
      END

      SUBROUTINE TPTPNS
C
C     Subroutine for SCHED called by SCHIN that transfers the tape
C     initialization information to station dependent cells in the
C     arrays in sched.inc.  The information was temporarily stored
C     in the RTP arrays in tpinit.inc by TPINI.  This two step
C     process was used because the station list was not necessarily
C     known when the tape initialization information was read.
C
C     Also resolve which NDRIVES input to use.
C
C     Modified for post-tape era where it becomes a routine for
C     setting some defaults.  July 22, 2010.  RCW.
C
      INCLUDE 'sched.inc'
C
      INTEGER       ISTA
      LOGICAL       ISLBA
C --------------------------------------------------------------
C     Now fill the arrays that used to be influenced by TAPEINI.
C     Commented ones no longer used.
C     Some of these that are defaulted here should be eliminated 
C     eventually but they are tangled in the VEX stuff in 
C     interesting ways.
C
      DO ISTA = 1, NSTA
C         TPTIME(ISTA)   = -1.0D0
C         TPSDRIV(ISTA)  = 1
C         TPSINDX(ISTA)  = 1
C         TPLENG(ISTA)   = 17600.
         NDRIVE(ISTA)   = 1
         NHDPOS(ISTA)   = 14
         DENSITY(ISTA)  = 'H'
         HEADMODE(ISTA) = ' '
         MEDIA(ISTA)    = ' '
      END DO
C
C     Deal with MEDIA defaults etc.
C
      ANYTAPE = .FALSE.
      ALLDISK = .TRUE.
C
      DO ISTA = 1, NSTA
C
C        Determine whether to use tape.  This is the default if
C        tape is available in the station catalog and MEDIADEF was
C        not set to DISK
C
C        Retain a proper deterimination of USETAPE to trigger a
C        complaint if it turns out to be positive.
C
         USETAPE(ISTA) = VLBITP .AND. 
     1        RECORDER(STANUM(ISTA)) .NE. 'NONE' .AND.
     2        ( INDEX( MEDIA(ISTA), 'TAPE' ) .NE. 0 .OR.
     3          DISK(STANUM(ISTA)) .EQ. 'NONE' .OR.
     4          (  MEDIA(ISTA) .EQ. ' ' .AND. 
     5           MEDIADEF(STANUM(ISTA)) .EQ. 'TAPE' ) )
         IF( USETAPE(ISTA) ) THEN
            ANYTAPE = .TRUE.
            CALL ERRLOG( 'SCHED thinks you asked for tape at '//
     1      STATION(STANUM(ISTA))//'but tape is no longer supported.' )
         END IF     
C
C        Determine whether to use disk.
C
         USEDISK(ISTA) = VLBITP .AND. 
     1        DISK(STANUM(ISTA)) .NE. 'NONE' .AND.
     2        ( INDEX( MEDIA(ISTA), 'DISK' ) .NE. 0 .OR.
     3          RECORDER(STANUM(ISTA)) .EQ. 'NONE' .OR.
     4          (  MEDIA(ISTA) .EQ. ' ' .AND. 
     5          ( MEDIADEF(STANUM(ISTA)) .EQ. 'DISK' .OR. 
     6            MEDIADEF(STANUM(ISTA)) .EQ. 'NONE' ) ) )
C
C        LBA recorders use disks but have different constraints to Mk5
C        This change added by Cormac.  I'm (Craig) not sure I like it
C        as I was planning to use ALLDISK to say not to worry about 
C        tape.  But in practice, as of Version 9.3, ALLDISK is only
C        used in SETTPS for long recording scan warnings (not wanted
C        for the LBA) and I test against MARK5A there.  So I'll
C        leave it for now.  Reconsider if used for something else.
C
         ISLBA = .FALSE.
         IF (DISK(STANUM(ISTA))(1:5) .EQ. 'LBADR') ISLBA = .TRUE.
         ALLDISK = ALLDISK .AND. USEDISK(ISTA) .AND. .NOT. ISLBA
C
C        If VLBITP, insist that we use one for recording 
C        observations.
C
         IF( VLBITP .AND. .NOT. USEDISK(ISTA) ) THEN
            WRITE( MSGTXT, '( 2A )' ) 
     1         'TPTPNS:  **** You have specified OBSTYPE = VLBI ',
     2         'or equivalent.'
            CALL WLOG( 1, MSGTXT )
            WRITE( MSGTXT, '( 4A )' ) '              But you '// 
     1          'are not using a recording system.'
            CALL WLOG( 1, MSGTXT )
            CALL ERRLOG( 'TPTPNS:  Specify the recording system.' )
C
         END IF
C
      END DO
C
      RETURN
      END

      SUBROUTINE WRAP( ISCN, LSCN, ISTA, T_EST1 )
C
C     Routine for SCHED that determines where in the full range of
C     azimuth for ALTAZ antennas the antenna will be.  Typically there
C     will be a range of azimuths where there are two possible antenna
C     positions (cable wrap) and which is in use depends on the 
C     recent history of scans.  This routine attempts to duplicate
C     what will happen at the antenna.  It has to worry about the
C     full time of the scan (by looking at both ends).
C
C     This routine assumes that the antenna takes the shortest time
C     slew to get to the next source without trying to optimize when
C     to slew relative to a series of scans.  The algorithm is simple
C     to try to increase the chances that it will reproduce what 
C     happens at the antennas, the antennas having been encouraged to
C     also keep it simple.  The algorithm does check that the azimuth
C     of the new source both at the start of the slew and at the end
C     of the scan are within the limits.
C
C     When called during the process of setting scan times, the 
C     stop time may get adjusted again later.  For ultimate
C     accuracy, there should be a second pass after the scan times
C     are close.  Note that using the position at the start of the 
C     slew may cause quite a large time offset if the station has 
C     not been used in a previous scan.  So that might not be
C     optimal, but I think that is what the antennas do too.
C
C     This routine will be called by STAGEO for use while optimizing
C     the pointing to take into account slew times and in SCHSRC
C     so that AZ1 and AZ2 in the main schedule variables have the
C     wrap position.  Then SLEW does not need to worry about wraps.
C     Note that STAGEO gets called by STNGEO for all antennas regardless
C     of whether they are in the scan to get the geometry in case 
C     of need to know what would have happened.  But when considering
C     the wrap, only consider the last scan the station was in.
C
C     There is a nasty case that is encountered most obviously in 
C     egplan.key where each source is "tracked" for 24 hours.  The
C     source spends a lot of time down, during which it moves a 
C     long distance in Az while not participating in scans.  The 
C     first scan after the rise has its slew parameters calculated
C     at the end of the last scan (as would happen on the antenna so
C     we can't change this).  For the wrap calculation, SCHED and 
C     the on-line system look at the azimuth at the start of the 
C     slew (end of last scan) and at the end of the actual scan,
C     which can be very far apart and have very different azimuths.
C     As far as the VLBA on-line system is concerned, there really
C     is such a long scan, although it is a "setup" scan with no
C     recording.  The effect is that CURAZ1 below will have a value
C     in the northwest (northern sources) and CURAZ2 will be in the
C     northeast.  
C
C     There are also a variety of issues when a phase reference pair
C     goes near the zenith.  See AUTODOWN for dealing with those.
C     To duplicate what happens at the VLBA antennas, the Az of the
C     new source is needed at the time the slew starts (STOPJ(LSCN)) 
C     and at the end of the scan.  What constitutes the end of the
C     scan is a bit "interesting".  For the VLBA legacy on-line system,
C     a scan is always in progress.  It can be the normal (probably 
C     recording) scan, or it can be the setup scan.  The setup scan 
C     fills the time between recordings during which the antenna might
C     be slewing, or might be sitting waiting.  The on-line system does
C     not distinguish the type of scan, so the position used for the 
C     end of scan for slew calculations may be the end of the setup,
C     which corresponds to the start of the recording scan.  This is 
C     not optimal and can lead to slews being needed at the start of 
C     the recording scan when there was plenty of time in the setup 
C     scan.
C
C     VLBA:
C
C     It was realized rather late (Jan. 8, 2014) that the algorithm
C     here is not quite the same as what is used on the VLBA.  The
C     algorithm here is the desired one and will be kept.  But the
C     setup scan confuses the issue on the VLBA.  The legacy on-line 
C     system only sees a scan.  It does not distinguish setup and 
C     recording scans.  So when it looks at the stop time, it is the 
C     end of the setup scan, which corresponds to the start of recording.  
C     Thus it will not detect a pending limit hit during recording until
C     the start of recording.  This can cause a slew during recording
C     even when there was a nice long setup during which it could 
C     have been done.
C
C     The legacy system is no longer controlling recording so there is
C     a bit more freedom to pick a solution to this issue than there 
C     was before.  In writing the crd file, I plan to eliminate the
C     setup scan if AZ1 and AZ2 flank the boundary between the ccw
C     overlap region and the normal region - ie 90 deg azimuth for
C     the VLBA - and the final AZ2 of the preceeding scan was greater
C     than an arbitrary number like 250 deg Az.  This is the case
C     where SCHED may have chosen the CCW wrap based on the limit
C     crossing during the scan, but the on-line system might have
C     gone to near the CW limit based on the end of the setup scan.
C     I won't worry about scans at the other limit crossing at 270 deg
C     because that limit will never be crossed while tracking - 
C     negative azimuth rates are only seen at other azimuths.  The
C     code for this will be entirely confined to subroutine VLBA.
C
C     Note that predictions will not be perfect because the on-line 
C     system makes its choices based on the azimuth after the pointing
C     equation is applied and SCHED does not know those equations.  The
C     azimuth encoder offset can be pretty large.  SKED will deal with
C     this by having exclusion zones.  I am avoiding that so far.  The
C     best solution is for the antennas to follow the wrap instructions
C     from the schedulers.
C
C     Over-the-top.
C
C     Some antennas have the ability to go beyond 90 deg El.  SCHED
C     does not yet include that as an option.  Someday, it probably
C     should.
C
      INCLUDE 'sched.inc'
C
      INTEGER        ISCN, LSCN, ISTA, KSTA, NT1
      INTEGER        IWRAP, NWRAP1, NWRAP2, IMSLEW, IMSLEW2, IMSLEWE
      REAL           CURAZ1, CURAZ2, LASTAZ, MINSLEW, MINSLEW2
      REAL           CURHA1, CUREL1, CURPA1, AZSLEW, MINSLEWE
      DOUBLE PRECISION  CURLST1, STTIME, T_EST1
C ------------------------------------------------------------------
      KSTA = STANUM(ISTA)
C
C     Don't do anything if the mount is not ALTAZ.
C
      IF( MOUNT(KSTA) .NE. 'ALTAZ' ) RETURN
C
C     First get the previous position.  If the source was down,
C     assume that it was tracking at the station elevation limit. 
C     If this is the first scan for the station, assume that it
C     is at the low point of the wrap range.  This used to be the
C     mid point, but that option was causing problems at Effelsberg.
C
      IF( LSCN .NE. 0 ) THEN
         LASTAZ = AZ2(LSCN,ISTA)
      ELSE
         LASTAZ = AX1LIM(1,KSTA)
      END IF
C
C     Get the antenna position required to observe the new source
C     at the time of the start of the slew (end of previous scan).
C     This is where the calculation is done on the VLBA to determine
C     the wrap condition.  Also get the azimuth at the nominal end 
C     of the scan.  The on-line system also looks at that in 
C     deciding about a wrap.  Note that, while the on-line system
C     knows the true end of scan time, at the time this routine is
C     run, that may not be so clear as the dwell adjustments have 
C     not yet been done.  For now, assume that this will not cause
C     problems often enough to be a concern.
C
C     Azimuths from SCHGEO will be in range 0-360 and will be 
C     adjusted as required below for the wrap condition.
C
C     For LSCN=0 and not the first scan (say other stations have
C     started), we basically have no idea when the scan will finally
C     be scheduled.  It may depend on the history for other stations
C     in the scan.  And it may deviate from the currently set scan
C     times because, in the optimazation process where scans are skipped,
C     scan times can keep incrementing even though none are accepeted, 
C     until one is finally accepted.  I think for all this, I will
C     just assume that the calling routine has a better idea of when
C     the scan will start than this routine has, so I'll use T_EST1.
C
      IF( SCANL .EQ. 0 ) THEN
C
C        No scans scheduled yet.
C
         STTIME = TFIRST
C
      ELSE IF( LSCN .NE. 0 ) THEN
C
C        This station has previous scans.  Pick up from last.
C
         STTIME = STOPJ(LSCN)
C
      ELSE
C
C        First scan for this station, but not for experiment.  Assume the
C        calling routine had an idea what it was doing.
C        An alternative that worked for pointing cases: STTIME=STARTJ(SCANL)
C        But that doesn't work well when different antennas are being scheduled
C        separately.
C
         STTIME = T_EST1
C
      END IF
      CALL SCHGEO( ISCN, ISTA, STTIME, CURHA1,
     1             CUREL1, CURAZ1, CURLST1, CURPA1 )
      CURAZ2 = AZ2(ISCN,ISTA)
C
C     Adjust CURAZ2 to be the azimuth the telescope would end
C     up at if tracking the source starting at CURAZ1.  
C     Unfortunately this is not quite so simple in cases where
C     the source goes very near the zenith during the scan - or
C     since the stop of the last scan.  So we need to do this in
C     a declination dependent manner.  I think we don't need
C     to distinguish hemispheres.
C     First put both AZ values in 0-360 deg.
C
      CURAZ1 = MOD( CURAZ1, 360.0 )
      CURAZ2 = MOD( CURAZ2, 360.0 )
      IF( CURAZ1 .LT. 0.0 ) CURAZ1 = CURAZ1 + 360.0
      IF( CURAZ2 .LT. 0.0 ) CURAZ2 = CURAZ2 + 360.0
C
C     Deal with situations where a source crosses the line
C     between 0 and 360 deg azimuth and azimuths confined to
C     0 - 360 deg won't be on the same wrap.  The line is
C     crossed at upper culmination (0hr hour angle) when 
C     the source declination is higher than than the 
C     station latitude.  It is crossed 12 hours later 
C     at lower culmination when the source declination is 
C     higher than the negative of the latitude (imagine a 
C     station directly opposite on the Earth where 
C     upper culmination would occur at this time).  When a 
C     source crosses the line at 0hr HA, subtract 360 
C     from CURAZ2.  When it happens at 12hr HA, add 360 
C     to CURAZ2.
C
      IF( DECP(SRCNUM(ISCN)) .GT. LAT(STANUM(ISTA)) .AND.
     1    CURHA1 .LE. 0.0 .AND. HA2(ISCN,ISTA) .GT. 0.0 )
     2   CURAZ2 = CURAZ2 - 360.0
C
      IF( DECP(SRCNUM(ISCN)) .GT. -1.0 * LAT(STANUM(ISTA)) .AND.
     1    CURHA1 .GT. 0.0 .AND. HA2(ISCN,ISTA) .LE. 0.0 )
     2   CURAZ2 = CURAZ2 + 360.0
C
C     Find the range of possible wraps assuming that CURAZ1 is in 0-360.
C       Note:  For AX1LIM(1,KSTA) > 0 or AX1LIM(2,KSTA) < 360,
C       more wraps than necessary are checked, but these will be rare
C       cases and it is better to keep the code simple.
C
      NWRAP1 = INT( AX1LIM(1,KSTA) / 360.0 ) - 1
      NWRAP2 = INT( AX1LIM(2,KSTA) / 360.0 )
C
C     Now find the shortest slew consistent with the AZ limits.
C     Initialize IMSLEW in order to detect if there is no
C     acceptable wrap state.  IMSLEW2 will detect a usable
C     wrap state for the start of scan only.  That will be 
C     used if there is nothing acceptable for both.  If there
C     is nothing at all, just use the input positions.
C
      MINSLEW = 99999.0
      IMSLEW = -99
      DO IWRAP = NWRAP1, NWRAP2
         IF( CURAZ1 + IWRAP * 360.0 .GE. AX1LIM(1,KSTA) .AND.
     1       CURAZ1 + IWRAP * 360.0 .LE. AX1LIM(2,KSTA) .AND.
     2       CURAZ2 + IWRAP * 360.0 .GE. AX1LIM(1,KSTA) .AND.
     3       CURAZ2 + IWRAP * 360.0 .LE. AX1LIM(2,KSTA) ) THEN
            AZSLEW = ABS( CURAZ1 + IWRAP * 360.0 - LASTAZ )
            IF( AZSLEW .LT. MINSLEW ) THEN
               MINSLEW = AZSLEW
               IMSLEW = IWRAP
            END IF
         END IF
      END DO
C
C     Set the Az values to the best wrap.  But only if a 
C     wrap worked.
C
      IF( IMSLEW .NE. -99 ) THEN
         CURAZ1 = CURAZ1 + IMSLEW * 360.0
         CURAZ2 = CURAZ2 + IMSLEW * 360.0
C
      ELSE
C
C        This is the case where the wrap didn't work.  For 
C        example, Haystack in the current station catalog
C        (Dec. 2010) has az limits of 0 and 360, so a northern
C        scan cannot track through zero, and such scans will
C        have problems.  I presume that the antenna will try
C        to get to the next source at its position at the end
C        of the previous scan (ie CURAZ1).  So determine the
C        wrap for that position.
C
C        This can also happen if the estimated start time is
C        way off (like end of previous station's scans when 
C        scheduling antennas separately in the old scheme.
C
C        When we don't have an acceptable combination, a 
C        common wrap for start and end is not viable by definition.
C        Then assume a wrap will happen during the scan.
C
         MINSLEW2 = 99999.0
         IMSLEW2 = -99
         DO IWRAP = NWRAP1, NWRAP2
            IF( CURAZ1 + IWRAP * 360.0 .GE. AX1LIM(1,KSTA) .AND.
     1          CURAZ1 + IWRAP * 360.0 .LE. AX1LIM(2,KSTA) ) THEN
               AZSLEW = ABS( CURAZ1 + IWRAP * 360.0 - LASTAZ )
               IF( AZSLEW .LT. MINSLEW2 ) THEN
                  MINSLEW2 = AZSLEW
                  IMSLEW2 = IWRAP
               END IF
            END IF
         END DO
C
         IF( IMSLEW2 .NE. -99 ) THEN
C
C           Get the minimum slew to the end of scan.
C           This might even help fix (get a non-slewing end of scan) 
C           the azimuths when a very bad start time gave a 
C           messed up projected start position.  At least it 
C           shouldn't give illegal azimuths at the end of scan.
C
            MINSLEWE = 99999.0
            IMSLEWE = -99
            DO IWRAP = NWRAP1, NWRAP2
               IF( CURAZ2 + IWRAP * 360.0 .GE. AX1LIM(1,KSTA) .AND.
     1             CURAZ2 + IWRAP * 360.0 .LE. AX1LIM(2,KSTA) ) THEN
                  AZSLEW = ABS( CURAZ2 + IWRAP * 360.0 - CURAZ1 )
                  IF( AZSLEW .LT. MINSLEWE ) THEN
                     MINSLEWE = AZSLEW
                     IMSLEWE = IWRAP
                  END IF
               END IF
            END DO
            IF( IMSLEWE .NE. -99 ) THEN
               CURAZ2 = CURAZ2 + IMSLEWE * 360.0
            ELSE
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I4, A, A, A )' )
     1            'WRAP:  Could not get wrap for end of scan ', ISCN, 
     2            ', station: ', STANAME(ISTA),
     3            '  Program logic problem?' 
               CALL WLOG( 1, MSGTXT )
            END IF
         ELSE
C           
C           Leave CURAZ1 and CURAZ2 as is, but complain.
C
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I4, A, A )' )
     1         'WRAP:  Could not get wrap for scan ', ISCN, 
     2         ', station: ', STANAME(ISTA),
     3         '  Program logic problem?' 
            CALL WLOG( 1, MSGTXT )
         END IF
      END IF
C
C     Get AZ1 and AZ2 on the right wrap.  Don't recalculate
C     their values, but rather make sure they are on the same
C     wrap as CURAZ1 and CURAZ2.  Specifically don't use CURAZ1
C     because it was recalculated for the end of the previous
C     scan, not the start of the current scan in order to 
C     duplicate what will be done at the antennas, at least on
C     the VLBA.
C
      AZ1(ISCN,ISTA) = AZ1(ISCN,ISTA) + 
     1     360.0 * NINT( ( CURAZ1 - AZ1(ISCN,ISTA) ) / 360.0 )
      AZ2(ISCN,ISTA) = AZ2(ISCN,ISTA) + 
     1     360.0 * NINT( ( CURAZ2 - AZ2(ISCN,ISTA) ) / 360.0 )
C
C     Note that there are situations where CURAZ1 and AZ1 can
C     be very different (such as a planning schedule when
C     CURAZ1 is calculated for about the time the source set
C     and AZ1 is for around when it rises).  But it should be
C     appropriate to put AZ1 on the same wrap as CURAZ1 
C     because CURAZ1 and CURAZ2 have been forced to be on the
C     same wrap and AZ1 is between.  
C
C     The one corner case left over is when there was no 
C     acceptable wrap for both CURAZ1 and CURAZ2 (eg HS across 
C     0 AZ) and AZ1 is on the same wrap as AZ2 because it came
C     well after CURAZ1.  Then the Azimuths should be moved
C     into the acceptable range. So if AZ1 is outside the 
C     allowed range, force AZ1 to the good range and move
C     AZ2 by the same amount.
C
      IF( AZ1(ISCN,ISTA) .LT. AX1LIM(1,KSTA) ) THEN
         NT1 = INT( ( AX1LIM(1,KSTA) - AZ1(ISCN,ISTA) ) / 360.0 ) + 1
         AZ1(ISCN,ISTA) = AZ1(ISCN,ISTA) + NT1 * 360.0
         AZ2(ISCN,ISTA) = AZ2(ISCN,ISTA) + NT1 * 360.0
      ELSE IF( AZ1(ISCN,ISTA) .GT. AX1LIM(2,KSTA) ) THEN
         NT1 = INT( ( AZ1(ISCN,ISTA) - AX1LIM(2,KSTA) ) / 360.0 ) + 1
         AZ1(ISCN,ISTA) = AZ1(ISCN,ISTA) - NT1 * 360.0
         AZ2(ISCN,ISTA) = AZ2(ISCN,ISTA) - NT1 * 360.0
      END IF
C
C     This was all a lot messier than I like and it still may not 
C     be perfect for antennas that don't use an algorithm very
C     similar to the VLBA.  Some day, I hope we can specify the
C     wrap in the VEX file and have it used at the antennas, so
C     we don't have to guess what the antenna will do.
C
      RETURN
      END

      SUBROUTINE PROTECT( IUNIT )
C
C     Called by SUMOPE during writing of the .sum file.  Must be
C     called before the main scan listings and the generation of
C     the crd and VEX files.
C
C     Make a listing in the summary file (IUNIT) of the times when
C     a couple of stations can be taken from the project.
C     This allows users to protect critical calibration scans
C     or other critical scans.
C
C     Also deal with specification of "extra" scans whose scheduling
C     is optional.  Only allow that at the ends of the project.
C
C     The preempt concept is  mainly to support scheduling of the 
C     USNO observations on the VLBA.  These observations will take 
C     1.5 hr per day on the PT-MK baseline.  The USNO will have 
C     some flexibility in schedule time - something like 6 hours.  
C     This routine will try to enforce providing adequate 
C     unprotected opportunities.
C
C     PESTART and PESTOP are the start and stop times of intervals
C     when preemption is ok.  Such intervals have intervals between
C     unpreemptable scans longer than MINTPE long (set to 2 hr).  
C
C     The algorithm would be fairly simple if it weren't that SCHED 
C     does not demand that scans be in time order.  Only each station
C     needs to be in time order, but subarrays can make a hash out
C     of the ordering.
C
C     Allow a first and last preemptable block that are shorter as
C     the USNO observation could start earlier or stop later than
C     the project.
C
      INCLUDE 'sched.inc'
C
      INTEGER            MPROT
      DOUBLE PRECISION   MINTPE, MAXBLOCK
      PARAMETER          (MPROT = 50)
      PARAMETER          (MINTPE = 1.6666D0 / 24.D0 )      
      PARAMETER          (MAXBLOCK = 4.D0 / 24.D0 )
      INTEGER            IP, NP, ISCN, JSCN, IUNIT, ISTA
      INTEGER            SY, SD, TY, TD, CBY, CBD, CEY, CED, LEN1
      INTEGER            IOERR, VLBOPE, CORESC1, CORESCL
      LOGICAL            GOTPTMK, TOOLONG, IGWARN, EXISTS
      LOGICAL            SCNPTMK(MAXSCN), ADDEND
      DOUBLE PRECISION   ST, TL, CBT, CEL
      DOUBLE PRECISION   PESTART(MPROT), PESTOP(MPROT)
      DOUBLE PRECISION   BLOCK1, BLOCKL
      CHARACTER          TFORM*8, CSTART*8, CSTOP*8
      CHARACTER          CBSTART*8, CESTOP*8
      CHARACTER          PREFILE*80, OPSTAT*4, OPTEXT*255
      CHARACTER          LINE1*80, LINE2*80, LINE3*80, LINE4*80 
      CHARACTER          LINE5*80, LINE6*80, LINE7*80
C  -----------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'PROTECT starting' )
C
C     First check PREEMPT for valid arguments.
C
      DO ISCN = SCAN1, SCANL
         IF( PREEMPT(ISCN) .NE. 'OK' .AND. 
     1       PREEMPT(ISCN) .NE. 'NO' .AND.
     2       PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A, A, I5, A )' )
     1         'PROTECT:  Invalid input PREEMPT=''',
     2         PREEMPT(ISCN)(1:LEN1(PREEMPT(ISCN))), ''' on scan ', 
     3         ISCN, '.  Must be OK, NO, or EXTRA.'
            CALL ERRLOG( MSGTXT )
         END IF
      END DO
C
C     If the the VLBA is not in use and no PREEMPT=EXTRA scans were
C     specified, get out of here silently.  This routine will 
C     only cause confusion.
C
      IF( .NOT. GOTVLBA .AND. .NOT. FUZZY ) RETURN
C
C     Recall that the default PREEMPT is OK for normal scans
C     and NO for DELZN scans (GEOLEN .NE. 0).  That was set
C     in SCHIN.  FUZZY was also set there if any PREEMPT=EXTRA scans
C     were seen.
C
C     Check if PT or MK are included in the project.  If not, 
C     record that fact and don't worry about preemptable scans.
C     But will still need to worry about EXTRA scans if FUZZY.
C
      GOTPTMK = .FALSE.
      DO ISTA = 1, NSTA
         IF( STANAME(ISTA) .EQ. 'VLBA_PT' .OR. 
     1       STANAME(ISTA) .EQ. 'VLBA_MK' ) THEN
            GOTPTMK = .TRUE.
         END IF
      END DO
      IF( .NOT. GOTPTMK ) THEN
         CALL WLOG( 1, 'PROTECT:  No PT or MK, so will not check '//
     1       'that times preemptable for USNO are present.' )
         IF( .NOT. FUZZY ) RETURN
      END IF
C
C     Determine scan by scan if PT or MK are present.
C
      DO ISCN = SCAN1, SCANL
         SCNPTMK(ISCN) = .FALSE.
         IF( GOTPTMK ) THEN
            DO ISTA = 1, NSTA
               IF( ( STANAME(ISTA) .EQ. 'VLBA_PT' .OR. 
     1             STANAME(ISTA) .EQ. 'VLBA_MK' ) .AND.
     2             STASCN(ISCN,ISTA) ) THEN
                  SCNPTMK(ISCN) = .TRUE.
               END IF
            END DO
         END IF
      END DO
C
C     By this point, either PT and MK are present, or EXTRA scans were
C     specified.  Open the .preempt file.  Construct the name, then 
C     check if it  exists.  Finally open it with VLBOPE.
C
      WRITE( PREFILE, '( A,A )' )  EXPCODE(1:LEN1(EXPCODE)), '.PREEMPT'
      CALL DWCASE( PREFILE )
      INQUIRE( FILE=PREFILE, EXIST=EXISTS )
      IF( EXISTS .AND. OVERWRIT ) THEN
         OPSTAT = 'OLD'
      ELSE IF( EXISTS ) THEN
         WRITE( MSGTXT, '( A, A, A )' )  'PROTECT: ', 
     1       PREFILE(1:LEN1(PREFILE)), ' already exists.'
         CALL WLOG( 1, MSGTXT )
         CALL ERRLOG( 
     1      'PROTECT: You need to delete old output files '//
     2      'or use OVERWRIT.')
      ELSE
         OPSTAT = 'NEW'
      END IF
      IOERR = VLBOPE( IPRE, PREFILE, 'TEXT', OPSTAT, OPTEXT )
      IF( IOERR .NE. 1 ) CALL ERRLOG( ' PROTECT open problem:'//OPTEXT )
C
C     Collect the first and last times of protected data (the core), 
C     and the times of the first and last scans of the core 
C     (not PREEMPT(ISCN)=EXTRA).  The overall experiment first and 
C     last times are already in TFIRST and TEND.
C
      CORESC1 = 100000
      CORESCL = 1
      COREBEG = 1.D10
      COREEND = 0.D0
      DO ISCN = SCAN1, SCANL
         IF( PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
            COREBEG = MIN( COREBEG, STARTJ(ISCN) )
            COREEND = MAX( COREEND, STOPJ(ISCN) )
            CORESC1 = MIN( CORESC1, ISCN )
            CORESCL = MAX( CORESCL, ISCN )
         END IF
      END DO
C
C     Don't allow all EXTRA scans.  Also don't allow 
C     EXTRA scans in the core range.
C
      IF( COREBEG .EQ. 1.D10 ) THEN
         CALL ERRLOG( 'PROTECT:  You must have some scans with '//
     1        'PREEMPT not set to EXTRA.' )
      END IF
      DO ISCN = CORESC1, CORESCL
         IF( PREEMPT(ISCN) .EQ. 'EXTRA' ) THEN
            CALL WLOG( 1, 'PROTECT: PREEMPT=EXTRA is only allowed in '//
     1         'blocks at the start and end.' )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5, A )' )
     1         '         Scan ', ISCN, ' is in the core and is EXTRA.'
            CALL WLOG( 1, MSGTXT )
            CALL ERRLOG( 
     1           'Please change PREEMPT for the offending scan.' )
         END IF
      END DO
C
C     Get BLOCK1 and BLOCKL, the first and last times for protected
C     scans.
C
      BLOCK1 = TEND
      BLOCKL = TFIRST
      DO ISCN = SCAN1, SCANL
         IF( PREEMPT(ISCN) .EQ. 'NO' .AND. SCNPTMK(ISCN) ) THEN
            BLOCK1 = MIN( BLOCK1, STARTJ(ISCN) )
            BLOCKL = MAX( BLOCKL, STOPJ(ISCN) )
         END IF
      END DO
C
C     Initialize the time ranges of the individual preemptable periods.  
C     Assume the whole time range is ok to start with.
C
      DO IP = 1, MPROT
         PESTART(IP) = TFIRST
         PESTOP(IP) = TEND
      END DO
C
C     Now look for blocks of preemptable times in a manner that works
C     with scans not in time order.
C
C     First see if there is a block at the start of non-zero
C     length.
C
      NP = 0
      IF( BLOCK1 .GT. TFIRST ) THEN
         PESTART(1) = TFIRST
         PESTOP(1) = BLOCK1
         NP = 1
      END IF
C
C     Now look for other good periods based on scan times.
C     Assume that any available block other than the first (which
C     has already been specified) will start with the end of
C     a protected scan.  Then see if such a block is long enough.
C     If not, ignore it.  If so, add it to the list.  Note that
C     there will be no further attempts to start a block in that
C     gap because, by definition, there aren't any. 
C     It is just possible, in very weird circumstances, that 
C     finding the open periods this way will result in blocks out 
C     of time order.  In this process, ignore scans without PT or MK.
C     Don't do this for the last scan (in terms of time) as it 
C     cannot start a valid interval.
C
      DO ISCN = SCAN1, SCANL
         IF( PREEMPT(ISCN) .EQ. 'NO' .AND. SCNPTMK(ISCN) .AND.
     1       STOPJ(ISCN) .NE. TEND ) THEN
            NP = NP + 1
            PESTART(NP) = STOPJ(ISCN)
            DO JSCN = SCAN1, SCANL
C
C              Look only at blocked scans that include PT and MK.  
C              Also don't look at the current scan (ISCN).
C
               IF( JSCN .NE. ISCN .AND.
     1             PREEMPT(JSCN) .EQ. 'NO' .AND. SCNPTMK(JSCN) ) THEN
C
C                 Find if this scan makes the gap after PESTART too
C                 short.  If so, this PESTART cannot be used so jump
C                 to the next ISCN.  It must be a scan that does
C                 extend to after PESTART to be of interest.
C
                  IF( STOPJ(JSCN) .GT. PESTART(NP) ) THEN
                     IF( STARTJ(JSCN) .LT. PESTART(NP) + MINTPE ) THEN
C
C                       Available period is too short.
C
                        NP = NP - 1
                        GO TO 100
                     ELSE
C
C                       Set the end of the available period to the
C                       earliest of the start of the test scan or the
C                       current stop time of the interval.
C
                        PESTOP(NP) = MIN( STARTJ(JSCN), PESTOP(NP) )
                     END IF
                  END IF
               END IF
            END DO
         END IF
C
C        Jump here when this scan stop can't be used as the start
C        of a preemptable period.
C
  100    CONTINUE
      END DO
C
C     Now see if there is a short, but finite period of preemptable
C     scans at the end.  If the final period is long, then PESTOP(NP)
C     should equal TEND and a segment won't be added.
C
      ADDEND = .FALSE.
      IF( NP .EQ. 0 ) THEN
         ADDEND =  ABS( BLOCKL - TEND ) .GT. ONESEC
      ELSE 
         ADDEND =  ABS( PESTOP(NP) - TEND ) .GT. ONESEC .AND. 
     1             ABS( BLOCKL - TEND ) .GT. ONESEC 
      END IF
      IF( ADDEND ) THEN
         NP = NP + 1
         PESTART(NP) = BLOCKL
         PESTOP(NP) = TEND
      END IF       
C
C     Write the periods and complain if there are inadequate times
C     to run the EOP project.  This included a fair amount of text
C     which is being written to both the .sum file and the .preempt files.
C
      LINE1 = ' Dynamically scheduled VLBA projects can have '//
     1        'optional scans at'
      LINE2 = ' the start and end designated by PREEMPT=''EXTRA''.  '//
     1        'These can be'
      LINE3 = ' used or not used to help with efficient meshing '//
     1        'with previous'
      LINE4 = ' and following projects.  Only the core time range '//
     1        'will be used '
      LINE5 = ' for the initial dynamic project selection.  DOSCANS'//
     1        'can be used to '
      LINE6 = ' restrict the scan range sent to the .vex, .oms, '//
     1        'crd., sch., and'
      LINE7 = ' .flag files. '
C
      WRITE( IUNIT, '( A, 10( /, A ) )' )
     1        ' ', ' ', 'ALLOWED PREEMPTION TIMES', ' ', 
     2        LINE1, LINE2, LINE3, LINE4, LINE5, LINE6, LINE7
      WRITE( IPRE, '( A, 8( /, A ) )' )
     1        'ALLOWED PREEMPTION TIMES', ' ', 
     2        LINE1, LINE2, LINE3, LINE4, LINE5, LINE6, LINE7
C
      LINE1 = ' The schedule can also designate which scans can be '//
     1        'preempted at'
      LINE2 = ' PT and MK for daily USNO EOP observations using '//
     1        'PREEMPT=''OK'' '
      LINE3 = ' or ''NO''.  For details, see the manual discussion '//
     1        'of PREEMPT.'
      WRITE( IUNIT, '( A, 4( /, A ) )' ) ' ', LINE1, LINE2, LINE3, ' '
      WRITE( IPRE, '( A, 4( /, A ) )' ) ' ', LINE1, LINE2, LINE3, ' '
C
C     Deal with the case where the entire project is protected.  Complain,
C     but then be forgiving if the project is short.  This information also
C     goes to the screen and logfile.
C
      IGWARN = .FALSE.
      IF( NP .EQ. 0 ) THEN
C
         LINE1 = ' ******* This schedule has no times that ' //
     1     'can be preempted for EOP observations.'
         WRITE( IUNIT, '( A, / ,A )' ) ' *******', LINE1
         WRITE( IPRE, '( A, /, A )' ) ' *******', LINE1
         CALL WLOG( 1, ' *******' )
         CALL WLOG( 1, LINE1 )
C
C        Deal with short projects.
C
         IF( TEND - TFIRST .LE. MAXBLOCK ) THEN
C
            LINE1 = ' '
            WRITE( LINE1, '( A, F5.1, A )' ) 
     1          ' ******* But the project is less than ', 
     2          MAXBLOCK * 24.D0, ' hours long so this may not be a'
            LINE2 = ' ******* problem unless 2 such runs are '//
     1          'scheduled back to back.'
            LINE3 = ' ******* If that happens, your protection '//
     1          'requests may be ignored.'
            LINE4 = ' *******'
            WRITE( IUNIT, '( A, /, A, /, A, /, A )' ) 
     1          LINE1, LINE2, LINE3, LINE4
            WRITE( IPRE, '( A, /, A, /, A, /, A )' ) 
     1          LINE1, LINE2, LINE3, LINE4
            CALL WLOG( 1, LINE1 )
            CALL WLOG( 1, LINE2 )
            CALL WLOG( 1, LINE3 )
            CALL WLOG( 1, LINE4 )
C
         ELSE
C
C           Now flag the case of a long project with no preemption times.
C
            IGWARN = .TRUE.
C
         END IF
      ELSE
C
C        This is the case where there are some available blocks.
C
         LINE1 = ' Time ranges available for USNO daily EOP '//
     1        'observations at PT and MK:'
         WRITE( IUNIT, '( A )' ) LINE1
         WRITE( IPRE, '( A )' ) LINE1
C
         DO IP = 1, NP
            CALL TIMEJ( PESTART(IP), SY, SD, ST )
            CALL TIMEJ( PESTOP(IP), TY, TD, TL )
            CSTART = TFORM( ST, 'T', 0, 2, 2, '::@' )
            CSTOP = TFORM( TL, 'T', 0, 2, 2, '::@' )
            MSGTXT = ' '
            WRITE( MSGTXT, 
     1          '( I3, 4X, A, I3.3, A, A8, A, I3.3, A,  A8 )' ) 
     2          IP, '(', SD, ') ', CSTART, '  to  (', TD, ') ', CSTOP
            WRITE( IUNIT, '( A )' ) MSGTXT(1:LEN1(MSGTXT))
            WRITE( IPRE, '( A )' ) MSGTXT(1:LEN1(MSGTXT))
         END DO
C
C        Check for adequate options.  Look for, and complain about, 
C        protected periods of MAXBLOCK hours or more.  This assumes
C        time order, but that should be the case given how the blocks
C        were derived.
C
         TOOLONG = .FALSE.
         IF( PESTART(1) - TFIRST .GT. MAXBLOCK ) TOOLONG = .TRUE.
         IF( TEND - PESTOP(NP) .GT. MAXBLOCK ) TOOLONG = .TRUE.
         IF( NP .GE. 2 ) THEN
            DO IP = 2, NP
               IF( PESTART(NP) - PESTOP(NP-1) .GT. MAXBLOCK ) 
     1            TOOLONG = .TRUE.
            END DO
         END IF
C
C        Complain about long blocked periods.
C
         IF( TOOLONG ) THEN
            LINE1 = ' *******'
            LINE2 = ' '
            WRITE( LINE2, '( A, F5.1, A )' )
     1         ' ******* There is at least one block of over ', 
     2         MAXBLOCK * 24.D0, 'hr'
            LINE3 = ' '
            WRITE( LINE3, '( A, F5.1, A )' )
     1         ' ******* when your PREEMPT specification does not '//
     2         'allow ', MINTPE * 24.D0, ' hr'
            LINE4 = ' ******* EOP observations on '//
     1         'one baseline (PT-MK usually) to be inserted.'
            LINE5 = ' ******* See details in the .sum or .preempt file.'
            WRITE( IUNIT, '( A, 4( /, A ) )' )
     1          LINE1, LINE2, LINE3, LINE4, LINE5
            WRITE( IPRE, '( A, 4( /, A ) )' )
     1          LINE1, LINE2, LINE3, LINE4, LINE5
            CALL WLOG( 1, LINE1 )
            CALL WLOG( 1, LINE2 )
            CALL WLOG( 1, LINE3 )
            CALL WLOG( 1, LINE4 )
            CALL WLOG( 1, LINE5 )
C
            IGWARN = .TRUE.
         END IF
      END IF
C
C     Warn user his/her instructions may be ignored.
C
      IF( IGWARN ) THEN 
         LINE1 = 
     1     ' ******* Your requests to protect scans will be ignored.'
         LINE2 = 
     1     ' ******* See the SCHED manual info on parameter PREEMPT.'
         LINE3 = ' *******'
         WRITE( IUNIT, '( A, /, A, /, A )' ) LINE1, LINE2, LINE3
         WRITE( IPRE, '( A, /, A, /, A )' ) LINE1, LINE2, LINE3
         CALL WLOG( 1, LINE1 )
         CALL WLOG( 1, LINE2 )
         CALL WLOG( 1, LINE3 )
      END IF
C
C     Write the time ranges of the EXTRA and CORE scans.
C
      LINE1 = ' Project times summary:'
      CALL TIMEJ( TFIRST, SY, SD, ST )
      CALL TIMEJ( TEND, TY, TD, TL )
      CALL TIMEJ( COREBEG, CBY, CBD, CBT )
      CALL TIMEJ( COREEND, CEY, CED, CEL )
      CSTART = TFORM( ST, 'T', 0, 2, 2, '::@' )
      CSTOP = TFORM( TL, 'T', 0, 2, 2, '::@' )
      CBSTART = TFORM( CBT, 'T', 0, 2, 2, '::@' )
      CESTOP = TFORM( CEL, 'T', 0, 2, 2, '::@' )
C
      WRITE( IUNIT, '( A, /, A )' ) ' ', LINE1
      WRITE( IPRE, '( A, /, A )' ) ' ', LINE1
      IF( TFIRST .LT. COREBEG ) THEN
         WRITE( LINE2, 
     1     '( A, 4X, A, I3.3, A, A8, A, I3.3, A,  A8 )' ) 
     2     ' Extra scans at start:    ', '(', SD, ') ', 
     3     CSTART, '  to  (', CBD, ') ', CBSTART
         WRITE( IUNIT, '( A )' ) LINE2
         WRITE( IPRE, '( A )' ) LINE2
      END IF
      WRITE( LINE3,
     1    '( A, 4X, A, I3.3, A, A8, A, I3.3, A,  A8 )' ) 
     2    ' Core start and stop:     ', '(', CBD, ') ', 
     3    CBSTART, '  to  (', CED, ') ', CESTOP
      WRITE( IUNIT, '( A )' ) LINE3
      WRITE( IPRE, '( A )' ) LINE3
      IF( TEND .GT. COREEND ) THEN
         WRITE( LINE4, 
     1      '( A, 4X, A, I3.3, A, A8, A, I3.3, A,  A8 )' ) 
     2      ' Extra scans at end:      ', '(', CED, ') ', 
     3      CESTOP, '  to  (', TD, ') ', CSTOP
         WRITE( IUNIT, '( A )' ) LINE4
         WRITE( IPRE, '( A )' ) LINE4
      END IF
      WRITE( IUNIT, '( A )' ) ' '
C
C     If DOSCANS was specified, give the time range.
C     Reuse some temporary variables from above.
C
      IF( DOSCANS(1) .NE. 0 ) THEN
         WRITE( LINE1, '( A, I5, A, I5 )' ) 
     1       ' DOSCANS was set to only pass scans ', 
     2       DOSCANS(1), ' to ', DOSCANS(2)
         CALL TIMEJ( STARTJ(DOSCANS(1)), SY, SD, ST )
         CALL TIMEJ( STOPJ(DOSCANS(2)), TY, TD, TL )
         CSTART = TFORM( ST, 'T', 0, 2, 2, '::@' )
         CSTOP = TFORM( TL, 'T', 0, 2, 2, '::@' )
         WRITE( LINE2, 
     1     '( A, 4X, A, I3.3, A, A8, A, I3.3, A,  A8 )' ) 
     2     ' DOSCANS time range:      ', '(', SD, ') ', 
     3     CSTART, '  to  (', TD, ') ', CSTOP
         WRITE( IUNIT, '( A, /, A)' ) LINE1, LINE2
         WRITE( IPRE, '( A, /, A)' ) LINE1, LINE2
      END IF
C
      RETURN
      END

      SUBROUTINE sla_CALYD (IY, IM, ID, NY, ND, J)
*+
*     - - - - - -
*      C A L Y D
*     - - - - - -
*
*  Gregorian calendar date to year and day in year (in a Julian
*  calendar aligned to the 20th/21st century Gregorian calendar).
*
*  (Includes century default feature:  use sla_CLYD for years
*   before 100AD.)
*
*  Given:
*     IY,IM,ID   int    year, month, day in Gregorian calendar
*                       (year may optionally omit the century)
*  Returned:
*     NY         int    year (re-aligned Julian calendar)
*     ND         int    day in year (1 = January 1st)
*     J          int    status:
*                         0 = OK
*                         1 = bad year (before -4711)
*                         2 = bad month
*                         3 = bad day (but conversion performed)
*
*  Notes:
*
*  1  This routine exists to support the low-precision routines
*     sla_EARTH, sla_MOON and sla_ECOR.
*
*  2  Between 1900 March 1 and 2100 February 28 it returns answers
*     which are consistent with the ordinary Gregorian calendar.
*     Outside this range there will be a discrepancy which increases
*     by one day for every non-leap century year.
*
*  3  Years in the range 50-99 are interpreted as 1950-1999, and
*     years in the range 00-49 are interpreted as 2000-2049.
*
*  Called:  sla_CLYD
*
*  P.T.Wallace   Starlink   23 November 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      INTEGER IY,IM,ID,NY,ND,J
Cf2py intent(out) NY
Cf2py intent(out) ND
Cf2py intent(out) J

      INTEGER I



*  Default century if appropriate
      IF (IY.GE.0.AND.IY.LE.49) THEN
         I=IY+2000
      ELSE IF (IY.GE.50.AND.IY.LE.99) THEN
         I=IY+1900
      ELSE
         I=IY
      END IF

*  Perform the conversion
      CALL sla_CLYD(I,IM,ID,NY,ND,J)

      END

      SUBROUTINE PHINT
C
C     Routine for SCHED called by chkscn that deals with INTENTs for
C     reference pointing for stations other than the VLA (the VLA is
C     handled in VLASCNS).
C
C     The main indicator that peaking has been requested is that the
C     PEAK command was set which is in the variable DOPEAK.  That
C     command is not station specific, so for now don't try to be 
C     station specific.  
C
      INCLUDE  'sched.inc'
C
      INTEGER         ISCN, ISTA, II, IIDE, IIAP, IIAD, IIOF
      LOGICAL         GOTPTINT, GOTDOPK, GOTPK1, JUSTVLA
C  ----------------------------------------------------------------------
C
C     First see if the user has added their own peaking INTENTS.  If
C     so, don't try to do more.
C
      IIDE = 0
      IIAP = 0
      IIAD = 0
      IIOF = 0
      IF( NINTENT .GE. 1 ) THEN
         DO II = 1, NINTENT
            IF( INDEX( INTENT(II), ':' ) .EQ. 0  .OR. 
     1          INDEX( INTENT(II), 'VLA:' ) .EQ. 0 ) THEN
               IF( INDEX( INTENT(II), 'REFERENCE_POINTING_DETERMINE' ) 
     1              .NE. 0 ) IIDE = II
               IF( INDEX( INTENT(II), 'REFERENCE_POINTING_APPLY' ) 
     1              .NE. 0 ) IIAP = II
               IF( INDEX( INTENT(II), 'REFERENCE_POINTING_ADJUST' ) 
     1              .NE. 0 ) IIAD = II
               IF( INDEX( INTENT(II), 'REFERENCE_POINTING_OFF' ) 
     1              .NE. 0 ) IIOF = II
            END IF
         END DO
      END IF
      GOTPTINT = IIDE .NE. 0 .OR. IIAP .NE. 0 .OR. IIAD .NE. 0 .OR.
     1           IIOF .NE. 0
C
C     Now process scans if we don't already have INTENTS.
C
      IF( .NOT. GOTPTINT ) THEN
C
C        First see if DOPEAK was ever set for a non-VLA station.  If 
C        not, don't do anyting.
C
         GOTDOPK = .FALSE.
         DO ISCN = SCAN1, SCANL
            IF( DOPEAK(ISCN) .GT. 0 ) THEN
               DO ISTA = 1, NSTA
                  IF( STASCN(ISCN,ISTA) ) THEN
                     IF( INDEX( STANAME(ISTA), 'VLA' ) .EQ. 0 ) THEN
                        GOTDOPK = .TRUE.
                        GO TO 100
                     END IF
                  END IF
               END DO
             END IF
          END DO
  100     CONTINUE
C
C         Now, if the INTENTS weren't set by the user and peaking is 
C         used, set them.
C
          IF( GOTDOPK ) THEN
C
C            First add the intents to the list.
C            I don't think the available inputs allow the use of ADJUST.
C
             IF( NINTENT + 3 .GT. MINTENT ) THEN
                CALL WLOG( 1, 'PHINT:  Too many INTENTS when adding '//
     1              'ones for non-VLA reference pointing.' )
                CALL ERRLOG( 
     1               'Report SCHED problem and use fewer INTENTS' )
             ENDIF
C
             INTENT(NINTENT+1) = 'REFERENCE_POINTING_DETERMINE'
             INTENT(NINTENT+2) = 'REFERENCE_POINTING_APPLY'
             INTENT(NINTENT+3) = 'REFERENCE_POINTING_OFF'
             IIDE = NINTENT + 1
             IIAP = NINTENT + 2
             IIOF = NINTENT + 3
             NINTENT = NINTENT + 3
C
C            Now go through the scans.  For now, issue OFF until the first
C            DOPEAK ge 1 is found.  Then do DETERMINE and APPLY.  The user
C            doesn't really have control of when the pointing is really 
C            applied so don't worry about that.  If there is a long slew,
C            or a long time, the on-line system or operators may stop 
C            applying on its own.
C
C            Don't do anything on a scan that only includes the VLA 
C            (probably a phasing or VLA pointing scan).
C
             GOTPK1 = .FALSE.
             DO ISCN = SCAN1, SCANL
C
                JUSTVLA = .TRUE.
                DO ISTA = 1, NSTA
                  IF( STASCN(ISCN,ISTA) .AND. 
     1                INDEX( STANAME(ISTA), 'VLA' ) .EQ. 0 ) THEN
                     JUSTVLA = .FALSE.
                     GO TO 200
                  END IF
                END DO
  200           CONTINUE
                IF( .NOT. JUSTVLA ) THEN
                   NSCINT(ISCN) = NSCINT(ISCN) + 1
                   IF( DOPEAK(ISCN) .GE. 1 ) THEN
                      ISCINT(NSCINT(ISCN),ISCN) = IIDE
                      GOTPK1 = .TRUE.
                   ELSE
                      IF( GOTPK1 ) THEN
                         ISCINT(NSCINT(ISCN),ISCN) = IIAP
                      ELSE
                         ISCINT(NSCINT(ISCN),ISCN) = IIOF
                      END IF
                   END IF
                END IF
             END DO
          END IF
      END IF
C
      RETURN
      END
      

      SUBROUTINE BBCLBA( KS )
C
C     Routine for SCHED, called by SETBBC, that sets the BBC
C     assignments for Australian LBA systems.  
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
      INCLUDE    'schfreq.inc'
C
      INTEGER    ICH, JCH, KS, MMBBC
      LOGICAL    GOTMATCH(MCHAN)
C -------------------------------------------------------------------  
      IF( SDEBUG ) CALL WLOG( 0, 'BBCLBA: Starting.' )
C     Determine the highest numbered BBC already assigned.
C     Usually if any are to be defaulted, all will be so this will
C     be zero.
C
      MMBBC = 0
      DO ICH = 1, NCHAN(KS)
         MMBBC = MAX( MMBBC, BBC(ICH,KS) )
         GOTMATCH(ICH) = .FALSE.
      END DO
C
C     Loop through channels assigning the channel to the
C     same BBC as a previous one with the same FREQREF and IFCHAN,
C     if there is one (can be different sideband), or to a new BBC.
C     Note that LBA BBCs can each provide 2 *USB* sidebands with contiguous
C     frequencies or a conventional LSB/USB in 16 MHz mode. In 64 MHz
C     mode, dual sideband is not possible. Use GOTMATCH to record
C     whether a given BBC already has been assigned to a frequency.
C
      DO ICH = 1, NCHAN(KS)
         IF( BBC(ICH,KS) .EQ. 0 .AND. ICH .GT. 1 ) THEN
            DO JCH = 1, ICH-1
               IF( (FREQREF(ICH,KS) .EQ. FREQREF(JCH,KS) .OR.
     1          (FREQREF(ICH,KS) - BBFILT(ICH,KS)) .EQ. FREQREF(JCH,KS))
     2             .AND. (IFCHAN(ICH,KS) .EQ. IFCHAN(JCH,KS) )
     3             .AND. ( ABS(BBFILT(ICH,KS) - 64.0) > 1E-3)
     4             .AND. .NOT. GOTMATCH(JCH) 
     5             .AND. .NOT. GOTMATCH(ICH) ) THEN
                     BBC(ICH,KS) = BBC(JCH,KS)
                     GOTMATCH(JCH) = .TRUE.
                     GOTMATCH(ICH) = .TRUE.
                     GO TO 100
               END IF
            END DO
  100       CONTINUE
         END IF
C
C        If BBC is still 0, assign the next one.
C
         IF( BBC(ICH,KS) .EQ. 0 ) THEN
            BBC(ICH,KS) = MMBBC + 1
         END IF
C
C        Determine new highest assigned BBC.
C
         MMBBC = MAX( MMBBC, BBC(ICH,KS) )
C
      END DO
C
      RETURN 
      END

      SUBROUTINE RDBELEVT
C
C     The RDBE takes a finite amount of time to set power levels.  This 
C     routine checks that adequate time is available to do this operation.
C     It was more important when the times were longer.
C
C     There are two level setting operations.  The first is to set the analog
C     power level before the sampler.  That is a "set and remember" operation.
C     It is done only once per project just before the first scan that uses
C     a particular setup in terms of RF band, external LOs etc - items that
C     can affect the power level in the 512 MHz.  The on-line system will 
C     try to start this operation 5 seconds before the scan start, but will
C     delay the start by the required amount to allow 5 seconds if necessary.
C     This was originally 15 seconds when this routine was written, so was
C     rather more important than now. The antenna catalog parameter TLEVSET 
C     can be used to be sure this time is provided.
C
C     If this operation is not done properly, the whole experiment at that
C     band (setup file) can be messed up pretty badly.  After the first time,
C     it is still a good idea to allow time any time there is a setup change
C     because the set will need to be redone if the schedule is restarted.
C     Note that different dopplar shifts for different sources typically keep
C     the same setup and so don't need to redo the set.
C
C     The second set happens at the beginning of each scan.  It is to set
C     the thresholds for the final resampling to 2 bits.  That operation
C     is allocated 2 seconds (absorbed in the 5 seconds for the first time).  
C     This used to be 5 seconds. So every scan should have that much of a 
C     gap.  To be sure this time is added for DWELL scheduled projects, use 
C     the antenna catalog parameter MINSETUP.
C
C     Craig Walker  Oct. 23, 2012.
C     Changed to reflect faster times, May 22, 2013
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    ISTA, ISCN, LSCN, KS, LASTSET, LEN1
      LOGICAL    SETSEEN(MSET), WARNMSG
      LOGICAL    TRWARN, TSWARN2
      DOUBLE PRECISION   TSAMPLEV, TRESAMP, STARTS, TOL
      PARAMETER          ( TSAMPLEV = 5.D0 )
      PARAMETER          ( TRESAMP = 2.D0 )
      PARAMETER          ( TOL = 0.1 )
      DATA       TRWARN, TSWARN2, WARNMSG / 3*.TRUE. /
      SAVE       TRWARN, TSWARN2, WARNMSG
C
C     The following are for use if a code segment below if reactivated.
C
C      LOGICAL    TRWARN, TSWARN1, TSWARN2
C      DATA       TRWARN / .TRUE. /
C      SAVE       TSWARN1
C ---------------------------------------------------------------------
C     Loop over stations.  Do this operation on a per station basis except
C     don't repeat the warnings too often. Only worry about RDBE stations.
C
      DO ISTA = 1, NSTA
         IF( DAR(STANUM(ISTA))(1:4) .EQ. 'RDBE' ) THEN
C
C           Loop over scans.  Look for setup changes.  Assume for the
C           purposes of this check that a change of setup group
C           means a change in the RF of the IF and so requires a new
C           analog level.  That is not strictly true but is close enough
C           for the current purpose given that this just issue warnings.
C
C           Also check that the scan gap is more than the resampler
C           leveler needs.
C
C           Initializations:
C
            LSCN = 0
            LASTSET = 0
            DO KS = 1, NSET
               SETSEEN(KS) = .FALSE.
            END DO
C
C           Loop over scans, looking only at scans using this station.
C
            DO ISCN = SCAN1, SCANL
               IF( STASCN(ISCN,ISTA) ) THEN
C
C                 Get the start time that will be used by the on-line
C                 system.  It is the "start" plus the start offset as
C                 written to the VEX file.  That will be the later of
C                 the tape start time ("start" in the Vex file) and 
C                 when the antenna gets to source (TONSRC - which, when
C                 later than the start time, shows up as an offset from
C                 the tape start time in the $SCHED section).
C
C                 Note that the main SCHED would allow TPSTART to be 
C                 station dependent within a scan, but the VEX part of
C                 SCHED will not allow that.  All stations must start
C                 their "tape recording" at the same time and that time
C                 is specified by "start=".  The VEX file also records
C                 the expected start time of good data via an offset.
C                 Wide band disk recordings are not started until that 
C                 expected good data time is reached, and that can be 
C                 station dependent.  That is the time that matters 
C                 regarding the setting of levels.
C
                  STARTS = MAX( TONSRC(ISCN,ISTA), 
     1                     STARTJ(ISCN) - TPSTART(ISCN,ISTA) ) 
C
                  KS = NSETUP(ISCN,ISTA)
                  IF( KS .NE. LASTSET ) THEN
C
C                    First check if there was time for an analog level 
C                    reset when there is a setup change.  Only worry
C                    about the first time the setup is seen.  There
C                    doesn't seem to be any reasonable way to deal
C                    with restarts and still allow frequency referencing.
C
                     IF( LSCN .NE. 0 ) THEN
                       IF( STARTS - STOPJ(LSCN) .LT. 
     1                     ( TSAMPLEV - TOL ) * ONESEC ) THEN
C
C                         Issue a description of the problem.
C
                          IF( WARNMSG .AND. .NOT. SETSEEN(KS) ) THEN
                             CALL WRTMSG( 1, 'RDBELEVT', 
     1                            "Level_Settings" )
                             WARNMSG = .FALSE.
                          END IF
C
C                         Issue the specific warning which is different
C                         the first time than later because it will always
C                         be a problem the first time, but usually not later.
C
                          IF( SETSEEN(KS) ) THEN
C
C                            Don't do this one, but save the code in case
C                            we decide to change that.
C
C                             IF( TSWARN1 ) THEN
C
C                               Issue a mild warning
C
C                                MSGTXT = ' '
C                                WRITE( MSGTXT, '( 4A, I4 )' ) 
C     1                             'RDBELEVT: Excessively short scan ',
C     2                             'gap at ', STANAME(ISTA), 
C     3                             ' at scan ', ISCN
C                                CALL WLOG( 1, MSGTXT )
C                                MSGTXT = ' '
C                                WRITE( MSGTXT, '( 10X, 2A, I4, A )' ) 
C     1                             'after switch back to use of a ', 
C     2                             'setup group, ', KS, 
C     3                             ', that was seen earlier.'
C                                CALL WLOG( 1, MSGTXT )
C                                CALL WLOG( 1, 
C     1                           '          This could degrade data '//
C     2                           'if the on-line system is restarted.' )
C                             END IF
C                             WARNMSG = .FALSE.
C                             TSWARN1 = .FALSE.
                          ELSE
                             IF( WARNMSG ) THEN
                                CALL WRTMSG( 1, 'RDBELEVT', 
     1                               "Level_Settings" )
                                WARNMSG = .FALSE.
                             END IF
                             WARNMSG = .FALSE.
                             IF( TSWARN2 ) THEN
C
C                               Strong warning
C
                                MSGTXT = ' '
                                WRITE( MSGTXT, '( 2A, I4, A )' ) 
     1                             'RDBELEVT: Excessively short scan ',
     2                             'gap for the first scan (', ISCN, ')'
                                CALL WLOG( 1, MSGTXT )
                                MSGTXT = ' '
                                WRITE( MSGTXT, '( 10X, 4A )' ) 
     1                             'with setup file',
     2                             SETNAME(KS)(1:LEN1(SETNAME(KS))), 
     3                             ' at ', STANAME(ISTA)
                                CALL WLOG( 1, MSGTXT )
                                CALL WLOG( 1, 
     1                           '          This will cause loss of '//
     2                           'data at the start of this scan.' )
                             END IF
                             TSWARN2 = .FALSE.
                          END IF
                       END IF
                     END IF
C
                  END IF
C
C                 Always check if there is time for the resampling level set.
C                 If no gap is set, both one of the above warnings, and
C                 this one might be triggered.
C
                  IF( LSCN .NE. 0 ) THEN
                     IF( STARTS - STOPJ(LSCN) .LT. TRESAMP * ONESEC )
     1                  THEN
                       IF( WARNMSG ) THEN
                          CALL WRTMSG( 1, 'RDBELEVT', 
     1                         "Level_Settings" )
                          WARNMSG = .FALSE.
                       END IF
                       WARNMSG = .FALSE.
                       IF( TRWARN ) THEN
C
C                         Mild warning
C
                          WRITE( MSGTXT, '( 2A, I4, 2A )' ) 
     1                       'RDBELEVT: Excessively short scan ',
     2                       'gap for scan', ISCN, 
     3                       ' without setup change at ', STANAME(ISTA)
                          CALL WLOG( 1, MSGTXT )
                          CALL WLOG( 1, '          The first few '//
     1                       'of the scan may be corrupted.' )

                       END IF
                       TRWARN = .FALSE.
                     END IF
                  END IF
C
C                 Keep track of the last setup and scan for this station
C                 and keep track of whether this setup has been seen before.
C
                  LASTSET = KS
                  LSCN = ISCN
                  SETSEEN(KS) = .TRUE.
               END IF
            END DO
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE SETFREQ( KS, NEEDCAT )
Cf2py intent(out) NEEDCAT
C
C     Routine called by setup defaulting routine, SETDEFS,
C     to establish the frequencies and sidebands of all 
C     channels of an experiment.  It balks if not enough 
C     information is provided to deduce all parameters and it
C     checks consistency when more parameters are specified
C     than the minimum required.  Technically, there are some
C     incomplete combinations of information that would allow
C     valid schedules to be produced, but they don't allow proper
C     "extlo" specifications for non VLBA stations or good pcal
C     defaults.
C
C     Force there to be enough information to deduce all of the
C     following for each channel (note FREQREF here is 
C     FREQREF+FREQOFF from setup file): 
C
C        LOSUM    - sum of all LO's.   - FREQREF+FREQOFF in setup..
C        NETSD    - net sideband.      - NETSIDE in setup.
C        FIRSTLO  - LO sum before BBC. - FIRSTLO in setup.
C        SIDE1    - first LO sideband. - Not in setup.
C        BBSYN    - BBC frequency.     - BBSYN in setup.
C        SIDEBD   - BBC sideband.      - SIDEBAND in setup.
C
C     The parameters are related by (where sidebands are +-1)
C        LOSUM = FIRSTLO + SIDE1*BBSYN
C        SIDE1 = NETSD*SIDEBD
C        SIDE1 = U if LOSUM .GT. FIRSTLO else = L
C
C     The following 2 lines each give a complete list of adequate 
C     combinations of inputs.  Require that one be present.
C        FREQREF, FIRSTLO, (NETSIDE or SIDEBAND)
C        BBSYN, SIDEBAND, NETSIDE, (FREQREF or FIRSTLO)
C
C     Note that the LOSUM and BBSYN deduced here may be modified in 
C     routine WRTFREQ when FREQ from the main schedule is applied.
C     That routine will not allow sideband or first LO changes.
C
C     NEEDCAT is returned .FALSE. if all of the above can be
C     determined.  If FREQREF and NETSIDE are available, it should
C     be possible to determine the rest based on the frequency
C     catalog.  If the catalog will be required for a complete set,
C     set NEEDCAT true.
C
C     VLA note - the sidebands etc work out ok as long as FIRSTLO
C     is set right.  For BBC settings above 600 MHz and keeping
C     the same IF sideband as the VLA, use FIRSTLO = VLALO - 600.
C     For BBC below 600 (other sideband) use VLALO + 600.
C
C     For non-VLBA stations with VLBA control files, FIRSTLO and
C     NETSD will be used for keywords "extlo" and "extlosideband".
C     This is needed by the correlator and is part of why a complete 
C     set will now be required.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER            KS, ICH
      INTEGER            INETSD, ISIDE1, ISIDEBD
      LOGICAL            GOTNETS, GOTNETF, GOTBBS, GOTBBF, GOTLO1
      LOGICAL            NEEDCAT
      DOUBLE PRECISION   TEMP8
      CHARACTER          STDMSG*70
C-------------------------------------------------------------------
      IF( KS .LE. 3 .AND. SDEBUG ) CALL WLOG( 0, 'SETFREQ: Starting' )
C
      NEEDCAT = .FALSE.
      STDMSG =  'SETFREQ: Overspecified and inconsistent'//
     1      ' frequencies and sidebands.'
C
C     Allow frequency to be set by way of the BAND.
C
      CALL SETBAND( KS )
C
C     Loop over channels.
C
      DO ICH = 1, NCHAN(KS)
C
C        See what we've got.
C        Net sideband:
C
         INETSD = 0
         IF( NETSIDE(ICH,KS) .EQ. 'U' ) INETSD = 1
         IF( NETSIDE(ICH,KS) .EQ. 'L' ) INETSD = -1
         GOTNETS = INETSD .NE. 0       
C
C        BBC sideband:
C
         ISIDEBD = 0
         IF( SIDEBD(ICH,KS) .EQ. 'U' ) ISIDEBD = 1
         IF( SIDEBD(ICH,KS) .EQ. 'L' ) ISIDEBD = -1
         GOTBBS = ISIDEBD .NE. 0       
C
C        Sky frequency, First LO, and Baseband frequency.
C
         GOTNETF = FREQREF(ICH,KS) .GT. 0.D0
         GOTLO1  = FIRSTLO(ICH,KS) .NE. NOTSET
         GOTBBF  = BBSYN(ICH,KS) .NE. 0.0D0
C
C        Now go through the 4 possible combinations that work - see
C        comments at top of routine.
C
C        First cases that need BBSYN
C
         IF( GOTNETF .AND. GOTLO1 .AND. ( GOTNETS .OR. GOTBBS ) ) THEN
            IF( FREQREF(ICH,KS) .GT. FIRSTLO(ICH,KS) ) THEN
               ISIDE1 = 1
            ELSE
               ISIDE1 = -1
            END IF
            TEMP8 = ISIDE1 * ( FREQREF(ICH,KS) - FIRSTLO(ICH,KS) )
            IF( GOTBBF .AND. ABS(TEMP8-BBSYN(ICH,KS)) .GT. 1.D-3 ) THEN
               CALL WLOG( 1, 'SETFREQ: BBSYN, FREQREF+FREQOFF, and '//
     1             ' FIRSTLO specified but not consistent.' )
               CALL ERRLOG( STDMSG )
            ELSE IF( GOTNETS .AND. GOTBBS .AND. 
     1           ISIDE1 * INETSD .NE. ISIDEBD ) THEN
               CALL WLOG( 1, 'SETFREQ: Inconsistent sidebands.' )
               CALL ERRLOG( STDMSG )
            END IF
            BBSYN(ICH,KS) = TEMP8
            IF( GOTNETS ) ISIDEBD = ISIDE1 * INETSD
            IF( GOTBBS )  INETSD  = ISIDE1 * ISIDEBD
C
C        Then those that have BBSYN but need other things.
C
         ELSE IF( GOTBBF .AND. GOTBBS .AND. GOTNETS .AND.
     1        ( GOTNETF .OR. GOTLO1 ) ) THEN
            ISIDE1 = ISIDEBD * INETSD
            IF( GOTNETF ) THEN
               TEMP8 = FREQREF(ICH,KS) - ISIDE1 * BBSYN(ICH,KS)
               IF( GOTLO1 .AND. ABS( TEMP8 - FIRSTLO(ICH,KS) ) .GT.
     1              0.0000001 ) THEN
                  CALL WLOG( 1, 'SETFREQ: Inconsistent frequencies' )
                  CALL ERRLOG( STDMSG )
               END IF              
               FIRSTLO(ICH,KS) = TEMP8
            ELSE IF( GOTLO1 ) THEN
               TEMP8 = FIRSTLO(ICH,KS) + ISIDE1 * BBSYN(ICH,KS)
               IF( GOTNETF .AND. 
     1             ABS( FREQREF(ICH,KS) - TEMP8 ) .GT. 0.0000001 ) THEN
                  CALL WLOG( 1, 'SETFREQ: Inconsistent frequencies' )
                  CALL ERRLOG( STDMSG )
               END IF              
               FREQREF(ICH,KS) = TEMP8
            END IF
C
C        If don't have a minimal complete set.  If have FREQREF
C        and NETSIDE, it can be done from the frequencies file,
C        if there is an appropriate entry in that file.  Note
C        that the cases where these items can be calculated from
C        others are covered in the complete sets.
C
         ELSE IF( GOTNETF .AND. GOTNETS ) THEN
C
            NEEDCAT = .TRUE.
C
C        Finally, abort if there just isn't enough information.
C
         ELSE
            CALL WLOG( 1, ' ' )
            CALL WLOG( 1, ' ' )
            SETMSG = ' '
            WRITE( SETMSG, '( A, A, I2, A )' )
     1         ' Incomplete frequency and sideband specifications ',
     2         'for channel ', ICH, ' in setup: '
            CALL WLOG( 1, SETMSG )
            CALL WLOG( 1, '        ' // SETNAME(KS) )
C
C           Explain the problem.
C
            CALL WLOG( 1,
     1         'SETFREQ: Need one of the following combinations:')
            CALL WLOG( 1, 'SETFREQ:'//
     1       '      FREQREF, FIRSTLO, and (NETSIDE or SIDEBAND)' )
            CALL WLOG( 1, 'SETFREQ:'//
     1       '   or BBSYN, SIDEBAND, NETSIDE, and (FREQREF or FIRSTLO)')
C
            IF( GOTNETS ) THEN
               CALL WLOG( 1, '   Have net sideband - NETSIDE.' )
            ELSE
               CALL WLOG( 1, '   Missing net sideband - NETSIDE.' )
            END IF
C
            IF( GOTBBS ) THEN
               CALL WLOG( 1, '   Have BBC sideband - SIDEBAND. ' )
            ELSE
               CALL WLOG( 1, '   Missing BBC sideband - SIDEBAND. ' )
            END IF
C
            IF( GOTNETF ) THEN
               CALL WLOG( 1, '   Have reference frequency - FREQREF. ' )
            ELSE
               CALL WLOG( 1, 
     1              '   Missing reference frequency - FREQREF.')
            END IF
C
            IF( GOTLO1 ) THEN
               CALL WLOG( 1, '   Have FIRSTLO. ' )
            ELSE
               CALL WLOG( 1, '   Missing FIRSTLO. ' )
            END IF
C
            IF( GOTBBF ) THEN
               CALL WLOG( 1, '   Have BBC frequency - BBSYN. ' ) 
            ELSE
               CALL WLOG( 1, '   Missing BBC frequency - BBSYN. ' ) 
            END IF
C
            CALL ERRLOG('SETFREQ: Note that old setups might not work.')
         END IF
C
C        Now have everything.  Put net sideband into proper form.
C        Put the other sideband into proper form after dealing
C        with possible information from the frequency catalog.
C
         IF( INETSD  .EQ.  1 ) NETSIDE(ICH,KS) = 'U'
         IF( INETSD  .EQ. -1 ) NETSIDE(ICH,KS) = 'L'
C
      END DO   ! Channel loop.
C
      RETURN
      END

      SUBROUTINE SCH24
C
C     Adjust start and stop times to avoid times of 24:00:00
C     This can happen when a time is between 23:59:59 and 24:00:00.
C     Also avoid having stop times right on 00:00:00 as per the
C     older version, although I'm not sure this is necessary.
C
C     Try not to introduce a quick recording stoppage that can throw
C     disks out of sync as per request from Brisken (Nov 2006 RCW)
C     Previously a 2 second setup scan could appear.  And don't 
C     introduce variation in TPSTART where it is not allowed (DOVEX).
C     This routine will only worry about these timing issues near 
C     midnight.  Trust other parts of SCHED to avoid other short gaps.
C
C     Warn of scans having negative duration (possible when 
C     specifying stop times and forgetting to change day number).
C     Old warning about crossing 0 hr UT commented.
C
C     Old prohibition about crossing midnight removed.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER           ISCN, ISTA, LSCN(MAXSTA)
      INTEGER           SY, SD, TY, TD
      DOUBLE PRECISION  ST, TL
      DOUBLE PRECISION  TDIFF, TWOSEC
      DOUBLE PRECISION  JDAY, RECSTRT, MINTPS
      PARAMETER         (TWOSEC = 2.D0 * ONESEC )
      CHARACTER         TFORM*8, CSTART*8, CSTOP*8
C---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SCH24 starting' )
C
      DO ISTA = 1, NSTA
         LSCN(ISTA) = 0
      END DO
C
      DO ISCN = 1, NSCANS
C
C        Move any stop time that is within plus or minus one 
C        second of midnight to one second before midnight.
C
         JDAY = DNINT( STOPJ(ISCN) )
         TDIFF = DABS( JDAY - STOPJ(ISCN) )
         IF( TDIFF .LT. ONESEC ) THEN
            STOPJ(ISCN) = JDAY - ONESEC 
         END IF
C	 	 
C        Move a scan start time that is within the one second 
C        before midnight to midnight.
C	 	 
         TDIFF = DMOD( STARTJ(ISCN), 1.D0 )
         IF( TDIFF .GT. 1.D0 - ONESEC ) 
     1      STARTJ(ISCN) = DNINT( STARTJ(ISCN) )
C
C        Move the media start time for each station to midnight 
C        if it is within the preceeding second by adjusting
C        TPSTART.
C
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
               RECSTRT = STARTJ(ISCN) - TPSTART(ISCN,ISTA)
               TDIFF = DMOD( RECSTRT, 1.D0 )
               IF( TDIFF .GT. 1.D0 - ONESEC ) THEN
                  TPSTART(ISCN,ISTA) = STARTJ(ISCN) - DNINT( RECSTRT )
               END IF
            END IF
         END DO
C
C        Adjust the TPSTARTS if needed to avoid media stoppages of
C        less than 2 seconds.  Note that, while this is meant to cover
C        any problems introduced above, it will work over the full
C        time range.  Don't just restrict this to stop times near 
C        midnight because the possible STARTJ change, combined with 
C        TPSTART, could affect a scan transition somewhat earlier.
C
C        This tangled with the effort in settps to prevent long
C        recording scans where 2 second gaps are introduced.  Change
C        settps to a 3 second gap.  This comment here so this 
C        connection is not forgotten.
C
         MINTPS = -1.D0 * UNSET
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) .AND. LSCN(ISTA) .GT. 0 ) THEN
               RECSTRT = STARTJ(ISCN) - TPSTART(ISCN,ISTA)
               IF( DABS( RECSTRT - STOPJ(LSCN(ISTA)) ) .LT. TWOSEC )
     1              THEN
                  TPSTART(ISCN,ISTA) = 
     1                STARTJ(ISCN) - STOPJ(LSCN(ISTA)) 
               END IF
               MINTPS = MIN( MINTPS, TPSTART(ISCN,ISTA) )
            END IF
         END DO
C
C        Now undo any unequal TPSTARTS when that is not allowed.
C
         IF( DOVEX .AND. MINTPS .NE. -1.D0 * UNSET ) THEN
            DO ISTA = 1, NSTA
               IF( STASCN(ISCN,ISTA) ) THEN
                  TPSTART(ISCN,ISTA) = MINTPS
               END IF
            END DO
         END IF
C
C        Check for negative duration scan.
C
         IF( STARTJ(ISCN) .GT. STOPJ(ISCN) ) THEN
            CALL TIMEJ( STARTJ(ISCN), SY, SD, ST )
            CALL TIMEJ( STOPJ(ISCN), TY, TD, TL )
            CSTART = TFORM( ST, 'T', 0, 2, 2, '::@' )
            CSTOP = TFORM( TL, 'T', 0, 2, 2, '::@' )
            WRITE(6, '( 3A, I4, /, 3A, I4 )' )
     1               ' Start: ', CSTART, ' on Day ', SD, 
     2               ' Stop:  ', CSTOP,  ' on Day ', TD
            CALL ERRLOG ( ' This is a scan of negative duration!' )
         END IF
C
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
               LSCN(ISTA) = ISCN
            END IF
         END DO
      END DO
C
      RETURN
      END

      SUBROUTINE VXVERS( VERVX, VERVEX )
C
C     Return the version of the VEX standard to which the current code  
C     applies
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
      INCLUDE    'vxlink.inc'
C
      REAL       VERVX
      REAL       VERVEX
      CHARACTER  TEST*3
C ----------------------------------------------------------------------
      TEST = VXSOFT
      READ( TEST, '( F3.2)' ) VERVX
C
      TEST = VEXVER
      READ( TEST, '( F3.1)' ) VERVEX
C
      RETURN
      END

      SUBROUTINE sla_DMXM (A, B, C)
*+
*     - - - - -
*      D M X M
*     - - - - -
*
*  Product of two 3x3 matrices:
*
*      matrix C  =  matrix A  x  matrix B
*
*  (double precision)
*
*  Given:
*      A      dp(3,3)        matrix
*      B      dp(3,3)        matrix
*
*  Returned:
*      C      dp(3,3)        matrix result
*
*  To comply with the ANSI Fortran 77 standard, A, B and C must
*  be different arrays.  However, the routine is coded so as to
*  work properly on many platforms even if this rule is violated.
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION A(3,3),B(3,3),C(3,3)

      INTEGER I,J,K
      DOUBLE PRECISION W,WM(3,3)


*  Multiply into scratch matrix
      DO I=1,3
         DO J=1,3
            W=0D0
            DO K=1,3
               W=W+A(I,K)*B(K,J)
            END DO
            WM(I,J)=W
         END DO
      END DO

*  Return the result
      DO J=1,3
         DO I=1,3
            C(I,J)=WM(I,J)
         END DO
      END DO

      END

      SUBROUTINE OPTSCH( ISCN )
Cf2py intent(in) ISCN
C
C     Routine for optimization mode that writes the keyin input for 
C     the optimized schedule.
C
C     ISCN is the sched scan number.
C     LINE is a line-on-page counter.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      DOUBLE PRECISION  START, STOP
      INTEGER     ISCN, ISTA, LEN1, I, ISCH, LSCH, ISTN, IDUR
      INTEGER     IOERR, VLBOPE, YEAR, DAY1, DAY2, KSCH
      INTEGER     LSET, PTCHAR, LASTDAY, LASTDUR
      INTEGER     I1, I2, IEL, MISCH, MISTN
      DOUBLE PRECISION  LASTBW(MAXCHN)
      CHARACTER   LINESC*256, SCHFILE*80, LINEPT*132, LASTLINE*256
      CHARACTER   TFORM*8, OPTEXT*256, OPSTAT*4, USENAME*8, CEL*3
      LOGICAL     NEWBW, FIRSTPT, EXISTS, NEEDPAR
      LOGICAL     LDOPCAL, LNOREC
      DOUBLE PRECISION  LSTDAY, PTLONG, GAST, PTLST, SLA_GMST
      SAVE        FIRSTPT, LASTLINE, LSCH, LSET, LASTDUR
      SAVE        LDOPCAL, LNOREC, LASTDAY, LASTBW, MISCH
      DATA        FIRSTPT / .TRUE. /
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'OPTSCH starting' )
C
C     Some initializations.
C
      IF( FIRSTPT ) THEN
         LASTLINE = ' '
         LSCH = 0
         LSET = 0
         LASTDUR = -1.0
         LDOPCAL = .FALSE.
         LNOREC  = .FALSE.
         LASTDAY = -1
         DO I = 1, MAXCHN
            LASTBW(MAXCHN) = 0.0D0
         END DO
         MISCH = 0
C
C        Open output SCH file - contains the new schedule.
C
         SCHFILE = EXPCODE(1:LEN1(EXPCODE))//'.sch'
         CALL DWCASE( SCHFILE )
         INQUIRE( FILE=SCHFILE, EXIST=EXISTS )
         IF( EXISTS .AND. OVERWRIT ) THEN
            OPSTAT = 'OLD'
         ELSE IF( EXISTS ) THEN
            CALL WLOG( 1, 'OPTSCH: '//SCHFILE//' already exists.' )
            CALL ERRLOG( 'OPTSCH: You need to delete old output files'
     1                // ' or set OVERWRIT.' )
         ELSE
            OPSTAT = 'NEW'
         END IF
         IOERR = VLBOPE( IUOPT, SCHFILE, 'TEXT', OPSTAT, OPTEXT )
         IF( IOERR .NE. 1 ) CALL ERRLOG( OPTEXT )
C
C        If the original schedule was LST, make the output LST.
C
         IF( LST ) THEN
C
C           Write introductory lines
C
            WRITE( IUOPT, '( A )' ) '!  LST schedule '
            WRITE( IUOPT, '( A, A )' ) ' LST = ', STATION(LSTSTA)
         ELSE
            WRITE( IUOPT, '( A )' ) '!  PTLST given for start times.'//
     1          '  Those are Pie Town LST.'
            WRITE( IUOPT, '( A )' ) '!  PTLST is not understood by '//
     1          'SCHED so it will need to be edited.'
         END IF
C
      END IF
      LINEPT = ' '
      LINESC = ' '
C
C     Get the time information for the scan.
C     Worry about roundoff for IDUR.
C
C     If the input schedule was in LST, make the output in LST too.
C     Later, the variables we want are DAY2 and START.
C
      IF( LST ) THEN
         CALL SIDTIM( STARTJ(ISCN), LONG(STANUM(LSTSTA)), TWOPI, 
     1        DAY1, START, LSTDAY )
         CALL SIDTIM( STOPJ(ISCN), LONG(STANUM(LSTSTA)), TWOPI, 
     1        DAY2, STOP, LSTDAY )
      ELSE
         CALL TIMEJ( STARTJ(ISCN), YEAR, DAY1, START )
         CALL TIMEJ( STOPJ(ISCN), YEAR, DAY2, STOP )
      END IF
      IDUR = ( STOPJ(ISCN) - STARTJ(ISCN) ) * 3600.D0 * 24.D0 + 0.05D0
C
C     Write the new schedule output lines.
C
      LINEPT = ' '
      PTCHAR = 0
C
C     First deal with setup files.
C
      IF( FIRSTPT .OR. LSET .NE. SETNUM(ISCN) ) THEN
         LSET = SETNUM(ISCN)
         PTCHAR = LEN1( SETNAME(LSET) )
         LINEPT(1:PTCHAR+9) = ' setup='''//SETNAME(LSET)(1:PTCHAR)//''''
         PTCHAR = PTCHAR + 9
      END IF
C
C     Doppler calculation request.
C
      IF( DOPCAL(ISCN) .AND. .NOT. LDOPCAL ) THEN
         LINEPT(PTCHAR+4:PTCHAR+10) = 'dopcal'
         PTCHAR = PTCHAR + 10
      ELSE IF( LDOPCAL .AND. .NOT. DOPCAL(ISCN) ) THEN
         LINEPT(PTCHAR+4:PTCHAR+13) = 'dopcal=-1'
         PTCHAR = PTCHAR + 13
      END IF
      LDOPCAL = DOPCAL(ISCN)
C
C     record/norecord.
C
      IF( NOREC(ISCN) .AND. .NOT. LNOREC ) THEN
         LINEPT(PTCHAR+4:PTCHAR+12) = 'record=-1'
         PTCHAR = PTCHAR + 12
      ELSE IF( LNOREC .AND. .NOT. NOREC(ISCN) ) THEN
         LINEPT(PTCHAR+4:PTCHAR+9) = 'record'
         PTCHAR = PTCHAR + 9
      END IF
      LNOREC = NOREC(ISCN)
C
C     Bandwidth.
C
      NEWBW = .FALSE.
      DO I = 1, MSCHN(SETNUM(ISCN))
         IF( LASTBW(I) .NE. BW(I,ISCN) ) NEWBW = .TRUE.
         LASTBW(I) = BW(I,ISCN)
      END DO
      IF( NEWBW ) THEN
         IF( MSCHN(SETNUM(ISCN)) .GT. 4 ) THEN
             WRITE( IUOPT, '(A)' ) LINEPT(1:PTCHAR)
             PTCHAR = 0
         END IF
         WRITE( LINEPT(PTCHAR+1:132),
     1       '( A, 16( F7.3, :, '','' ), / , 16( F7.3, :, '','' ) )' ) 
     2       '  bw=', (BW(I,ISCN),I=1,MSCHN(SETNUM(ISCN)))
         PTCHAR = PTCHAR + 5 + MSCHN(SETNUM(ISCN)) * 8 - 1
      END IF
C
      IF( IDUR .NE. LASTDUR ) THEN
         WRITE( LINEPT(PTCHAR+4:PTCHAR+12), '( A, I4 )' ) ' DUR=', IDUR
         LASTDUR = IDUR
         PTCHAR = PTCHAR + 12
      END IF
C
C     Adjust day number if needed.
C
      IF( DAY2 .NE. LASTDAY ) THEN
         WRITE( LINEPT(PTCHAR+4:PTCHAR+13), '( A, I5 )' ) ' DAY=', DAY2
         LASTDAY = DAY2
         PTCHAR = PTCHAR + 14
      END IF
C
C     Write out the line.
C
      IF( PTCHAR .NE. 0 ) THEN
         WRITE( IUOPT, '(A)' ) LINEPT(1:PTCHAR)
      END IF
C
C
C
C     Write out scan information line:
C
C     The source name.
C
      WRITE( LINESC(1:22), '(3A)' ) ' SOURCE=''',
     1       SCNSRC(ISCN)(1:LEN1(SCNSRC(ISCN))),''''
C
C     Write out scan time.  Based on TIMEJ calls earlier.
C     Use the LST at Pie Town for the time.  But don't assume
C     that Pie town is present.
C
      PTLONG = 108.11919D0 * RADDEG
      GAST = SLA_GMST( STARTJ(ISCN) )
      PTLST = DMOD( GAST - PTLONG, TWOPI )
      IF( PTLST .LT. 0.0D0 ) PTLST = PTLST + TWOPI
C
C
C
C      LINESC(25:38) = 'START=' // TFORM( START, 'T', 0, 2, 2, '::@' )
      LINESC(25:38) = 'PTLST=' // TFORM( PTLST, 'T', 0, 2, 2, '::@' )
C
C     Set up stations list.
C     Use codes for VLBA.
C     Also keep track of length if all stations are present.
C     The initial value for MISTN is for the 'STATIONS='
C
      ISCH = 42
      KSCH = ISCH
      MISTN = 9 + ISCH
      NEEDPAR = .TRUE.
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA))(1:4) .EQ. 'VLBA' ) THEN
            USENAME = STCODE(STANUM(ISTA))
         ELSE
            USENAME = STATION(STANUM(ISTA))
         END IF
         ISTN = LEN1( USENAME )
         MISTN = MISTN + ISTN + 1
         IF( STASCN(ISCN,ISTA) ) THEN
            IF( NEEDPAR ) THEN
               WRITE( LINESC(ISCH:ISCH+8), '(A)' ) 'STATIONS='
               ISCH = ISCH + 9
               NEEDPAR = .FALSE.
            END IF
            WRITE( LINESC(ISCH:ISCH+ISTN+1), '(2A)' )
     1          USENAME(1:ISTN),','
            ISCH = ISCH + ISTN + 1
         END IF
      END DO
C
C     Write the stations line.  
C     Write one every line in case we break into the middle.
C     Old code to limit the writes is commented.
C
C      IF( LSCH .NE. ISCH .OR. 
C     1    LASTLINE(66:ISCH-2) .NE. LINESC(66:ISCH-2) ) THEN
C         WRITE( LINESC(57:65), '(A)' ) 'STATIONS='
C         LSCH = ISCH
C      ELSE
C         ISCH = 57
C      END IF
C
C     Add slash on the end.  And save the line to this point.
C
      WRITE( LINESC(ISCH-1:ISCH), '(A)' ) ' /'
      LASTLINE = LINESC
      ISCH = ISCH + 2
      MISCH = MAX( ISCH, MISCH )
      MISTN = MISTN + 2
      IF( MISCH .GT. MISTN ) THEN
         CALL WLOG( 1, 'OPTSCH:  Programming error - MISTN wrong ' )
      END IF
C
C     Add a list of elevations to the end of the line.
C
      I1 = MISTN
      DO ISTA = 1, NSTA
         I1 = I1 + 3
         I2 = I1 + 2
         IEL = ( EL1(ISCN, ISTA) + EL2(ISCN,ISTA) ) / 2.0
         WRITE( CEL, '(I3)' ) IEL         
         IF( STASCN(ISCN,ISTA) ) THEN
            LINESC(I1:I2) = CEL
         ELSE
            LINESC(I1:I2) = ' **'
         END IF
         ISCH = I2
      END DO
C     Actually write out the line with a slash on the end.
C
      WRITE( IUOPT, '(A)' ) LINESC(1:ISCH)
C
      FIRSTPT = .FALSE.
C
      RETURN
      END

      SUBROUTINE sla_DVN (V, UV, VM)
*+
*     - - - -
*      D V N
*     - - - -
*
*  Normalizes a 3-vector also giving the modulus (double precision)
*
*  Given:
*     V       d(3)      vector
*
*  Returned:
*     UV      d(3)      unit vector in direction of V
*     VM      d         modulus of V
*
*  Notes:
*
*  1  If the modulus of V is zero, UV is set to zero as well.
*
*  2  To comply with the ANSI Fortran 77 standard, V and UV must be
*     different arrays.  However, the routine is coded so as to work
*     properly on most platforms even if this rule is violated.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION V(3),UV(3),VM

      INTEGER I
      DOUBLE PRECISION W1,W2


*  Modulus.
      W1 = 0D0
      DO I=1,3
         W2 = V(I)
         W1 = W1+W2*W2
      END DO
      W1 = SQRT(W1)
      VM = W1

*  Normalize the vector.
      IF (W1.LE.0D0) W1 = 1D0
      DO I=1,3
         UV(I) = V(I)/W1
      END DO

      END

      SUBROUTINE VXTRAPH(ISCN, NMODE, OMODE, INTERVAL, NTONE,
     1    NTONTMP, ITONTMP )
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 250796 
C
C     Adds a couple of extra PH definitions, becasue
C     a change of Phase cal insertion is detected in VXSCNS
C     NMODE = MODE # new mode in which these PH come
C     OMODE = MODE # of mode to which changes are made
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      REAL INTERVAL
      INTEGER NMODE, OMODE, ISCN, NTONE, NTONTMP(MAXCHN)
      INTEGER ITONTMP(2*MAXPC, MAXCHN)
C
      LOGICAL VXCFPH, FOUND
      CHARACTER VXNMPH*32
C
      INTEGER IXTRA, IP, ICH, ISTA, JSCN, INSCAN
C ----------------------------------------------------------------
C
      NMODPH(NMODE) = NMODPH(OMODE)
C
C     start adding a number of modes
C
      DO IXTRA = 1, NMODPH(NMODE)
         NPHVEX = NPHVEX + 1
         IF( NPHVEX .GT. MAXMOD ) CALL ERRLOG(
     1       'VXTRAPH: Number of $PH defs exceeding MAXMOD '//
     2       'array size...')
C
C        Need the SETUPS that are valid for this scan
C
         IMODPH(IXTRA,NMODE) = NPHVEX
         PHISSET(NPHVEX)=PHISSET(IMODPH(IXTRA,OMODE))
C     
C        and the corresponding links
C
         IF( INTERVAL .GT. 1E-15 ) DODETECT(NPHVEX) = .TRUE.
         NTONES(NPHVEX) = NTONE
         DO ICH = 1, NTONES(NPHVEX)
            NTONDET(ICH,NPHVEX) = NTONTMP(ICH)
            DO IP = 1, NTONTMP(ICH)
               ITONDET(IP,ICH,NPHVEX) = ITONTMP(IP,ICH)
            END DO
         END DO
C
C        Tone names and linking to FQ blocks sorted out
C        in VXTONE, but need a list of stations used.
C
         DO ISTA = 1, NSTA
            FOUND = .FALSE.
            DO JSCN = ISCN, SCANL
C
C              Look whether used in any scans which use this Group
C
               IF( SETNUM(ISCN) .EQ. SETNUM(JSCN) .AND. 
     1             STASCN(JSCN,ISTA) ) THEN 
                  FOUND = .TRUE.
                  INSCAN = JSCN
                  GOTO 100
               END IF
            END DO
C
  100       CONTINUE
            IF( FOUND ) THEN
C     
C           No danger to go over MAXSTA here
C
               IF( VXCFPH(NSETUP(INSCAN,ISTA), PHISSET(NPHVEX))) THEN 
                  NSTAPH(NPHVEX,NMODE) = NSTAPH(NPHVEX,NMODE) + 1
                  ISTAPH(NSTAPH(NPHVEX,NMODE),NPHVEX,NMODE) = ISTA
               END IF
            END IF
         END DO
C
C        IF names can be obtained from VXNMPH
C        Again 2nd par set .TRUE. to use VXLINK frequencies
C
         PHLINK(NPHVEX) = VXNMPH( NPHVEX, .TRUE. )
         CALL VXUNQL( NPHVEX, PHLINK )
C     
C        done inventing new PH
C
      END DO
C
      RETURN
      END

      SUBROUTINE CHKSCN
C
C     Routine for SCHED called by the main routine that checks scan 
C     parameters after SCHOPT and all other scan adjusting routines
C     are run.  Also, collects the "frequency sets".  See also
C     CHKSC1 which is called before SCHOPT.
C
C     VEX driven correlators need to have all stations to be correlated
C     together to be in the same scan.  That was not true of the log
C     driven correlators.  Warn about probable attempts to schedule
C     parallel scans that are meant to be correlated together.
C     Added Dec. 26, 2012.  RCW.
C
C     Set up INTENTS for pointing at stations other than the VLA.
C     Added Jan. 18, 2013.  RCW.
C
C     Deal with VLAPTIME.  Jan. 4, 2013
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    ISCN, KCHAN, ISET, ISTA, KSTA, LSRC, JSCN, KS, KF
      INTEGER    ICH, IINT
      INTEGER    NEXPECT, NLATE, NNEVER, NSLATE, CRSETC(MAXCHN)
      REAL       NSRCCHG
      LOGICAL    DOPWARN, WARNLONG, OVWARN, VLAPTG
      LOGICAL    SKIPI, SKIPJ
      DOUBLE PRECISION  FRSUM(MAXCHN), FRBB(MAXCHN), FRBW(MAXCHN)
      DOUBLE PRECISION  TIME1, TIMEDUR, MINFR(MSET), MAXFR(MSET)
      DOUBLE PRECISION  MINFRI, MAXFRI, MINFRJ, MAXFRJ
      DOUBLE PRECISION  MINDEF, MAXDEF, FR1, FR2
      DOUBLE PRECISION  SCANLEN, VPT
      INTEGER            CRDN
      DOUBLE PRECISION   CRDF(MCHAN), CRDB(MCHAN), CRDLOSUM(MCHAN)
      CHARACTER          CRDS(MCHAN)*1, USEDDBE*8, USEDSETF*80
      PARAMETER         ( MINDEF = 1.D15 )
      PARAMETER         ( MAXDEF = 0.D0 ) 
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKSCN starting' )
C
C     Try to protect against errors in use of DOPSRC.  Assume that if  
C     DOPSRC .NE. SOURCE, SOURCE is probably meant to be a continuum
C     calibrator.  Therefore check in that situation if DOPPLER
C     Continuum sources have channel velocities of -1.E9
C
      DOPWARN = .FALSE.
      DO ISCN = SCAN1, SCANL
         IF( SRCNUM(ISCN) .NE. IDOPSRC(ISCN) .AND. DOPCAL(ISCN) ) THEN
            DO KCHAN = 1, MSCHN(SETNUM(ISCN))
               IF( VLSR(KCHAN,SRCNUM(ISCN)) .GT. -1.E8 .AND.
     1             VLSR(KCHAN,IDOPSRC(ISCN)) .GT. -1.E8 ) THEN
                  DOPWARN = .TRUE.
               END IF
            END DO
         END IF
      END DO
      IF( DOPWARN ) THEN
         CALL WLOG( 1, 'CHKSCN:  **** WARNING ****' )
         CALL WLOG( 1, '    This schedule contains scans ' //
     1      'for which SOURCE and DOPSRC are different and' )
         CALL WLOG( 1, '    are both line sources.' //
     1              '  Is this intentional?' )
      END IF
C
C     Determine which setups were actually used.  Some had been kept
C     because they might be used in inserted pointing scans.  Here
C     is where we flag them as not used.
C
      DO ISET = 1, NSET
         USED(ISET) = .FALSE.
         DO ISCN = SCAN1, SCANL
            DO ISTA = 1, NSTA
               IF( STASCN(ISCN,ISTA) .AND. NSETUP(ISCN,ISTA) .EQ. ISET )
     1             THEN
                  USED(ISET) = .TRUE.
                  GO TO 100
               END IF
            END DO
         END DO
  100    CONTINUE
      END DO
C
C     Check for violations of the maximum number of scans per hour 
C     specified.
C
      DO ISTA = 1, NSTA
         IF( MAXSRCHR(STANUM(ISTA)) .LT. 1.D4 ) THEN
            LSRC = 0
            NSRCCHG = 0
            DO ISCN = SCAN1, SCANL
                IF( STASCN(ISCN,ISTA) ) THEN
                   IF( LSRC .EQ. 0 ) TIME1 = STARTJ(ISCN)
                   TIMEDUR = STOPJ(ISCN) - TIME1
                   IF( SRCNUM(ISCN) .NE. LSRC ) NSRCCHG = NSRCCHG + 1.0
                   LSRC = SRCNUM(ISCN)
                END IF
            END DO
C
C           Abort with info if there are too many changes.
C
            IF( NSRCCHG / TIMEDUR .GT. MAXSRCHR(STANUM(ISTA)) * 24.0 ) 
     1           THEN
               CALL WLOG( 1, 'CHKSCN: ***************************' //
     1                '****************' )
               CALL WLOG( 1, '    TOO MANY SOURCES PER HOUR AT ' //
     1               STANAME(ISTA) )
               MSGTXT = '  '
               WRITE( MSGTXT, '( A, F5.1 )' )
     1               '    OBSERVATORY WILL NOT ALLOW MORE THAN', 
     2               MAXSRCHR(STANUM(ISTA))
               CALL WLOG( 1, MSGTXT )
               MSGTXT = '  '
               WRITE( MSGTXT, '( A, F5.1 )' )
     1               '    YOU HAVE SPECIFIED ', 
     2               NSRCCHG / ( TIMEDUR * 24.D0 )
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, 
     1             '    REDUCE NUMBER OF SCANS FOR THIS STATION' )
C               Switch to this line if we want this to stop SCHED.
C               CALL ERRLOG( 
C     1             '    REDUCE NUMBER OF SCANS FOR THIS STATION' )
               CALL WLOG( 1, 'CHKSCN: ***************************' //
     1                '****************' )
            END IF
         END IF
      END DO
C
C     Do some checking that only applies when using real setups.
C
      IF( .NOT. NOSET ) THEN
C
C        Get the "frequency sets".
C
         CALL GETFSET
C
C        "pcal sets" are no longer used.
C
C         CALL GETPSET
C
C        Check for possible data loss due to correlator resyncs and 
C        formatter reconfigures.
C
         CALL RESYNC
C
C        Check for adequate time to set the levels in the RDBE.
C
         CALL RDBELEVT
C
C        Enforce use of only one personality on the RDBE and DBBC
C
         DO ISTA = 1, NSTA
            USEDDBE = 'xx'
            KSTA = STANUM(ISTA)
            IF( DAR(KSTA)(1:4) .EQ. 'RDBE' .OR. 
     1          DAR(KSTA)(1:4) .EQ. 'DBBC' ) THEN
               DO ISCN = SCAN1, SCANL
                  IF( STASCN(ISCN,ISTA) ) THEN
                     KS = NSETUP(ISCN,ISTA)
                     IF( USEDDBE .EQ. 'xx' ) THEN
                        USEDDBE = DBE(KS)
                        USEDSETF = SETNAME(KS)
                     ELSE IF( USEDDBE .NE. DBE(KS) ) THEN
                        CALL WLOG( 1, 'CHKSCN: Cannot use 2 DBE ' //
     1                     'personalities in one experiment' )
                        CALL WLOG( 1, '        You used ' // USEDDBE //
     1                     ' and ' // DBE(KS) // ' at ' // 
     2                     STANAME(ISTA) )
                        CALL WLOG( 1, '        The setup files were:' )
                        CALL WLOG( 1, '           ' // SETNAME(KS) )
                        CALL WLOG( 1, '           ' // USEDSETF )
                        CALL ERRLOG( '       Use the same DBE for ' //
     1                     'any given station.' )
                     END IF
                  END IF
               END DO
            END IF
         END DO
C
      END IF
C
C     Check for scans that are excessively long.  Setting 40min as
C     the standard for now.  Such scans put a lot of data at risk if
C     there are issues such as some that we've had with mid-scan disk
C     changes.
C
      WARNLONG = .TRUE.
      DO ISCN = SCAN1, SCANL
         IF( STOPJ(ISCN) - STARTJ(ISCN) .GT. 40.0 / 1440.D0 .AND. 
     1       WARNLONG ) THEN
            CALL WLOG( 1, 'See sched.runlog for warning on long scans.')
            CALL WRTMSG( 0, 'CHKSCN', 'warnlong' )
            WARNLONG = .FALSE.
         END IF
      END DO
C
C     Look for scans that start or, worse, end before very many antennas
C     are on-source.  Allow a one second tolerance on the start to 
C     avoid round off problems.
C
      NSLATE = 0
      DO ISCN = SCAN1, SCANL
         NEXPECT = 0
         NLATE   = 0
         NNEVER  = 0
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
               NEXPECT = NEXPECT + 1
               IF( TONSRC(ISCN, ISTA) .GT. STARTJ(ISCN) + ONESEC ) 
     1             NLATE = NLATE + 1
               IF( TONSRC(ISCN, ISTA) .GT. STOPJ(ISCN) )
     1             NNEVER = NNEVER + 1
            END IF
         END DO
C
C        Warn of an individual scan with few antennas ever reaching the 
C        source.
C
         IF( NNEVER .GT. NEXPECT/2 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5, 2A )' )
     1         'CHKSCN:  WARNING - Scan ', ISCN, ' had fewer than ', 
     2         'half the antennas on source by the stop time!'
            CALL WLOG( 1, MSGTXT )
         END IF
C
C        Accumulate the number of scans with most antennas not on source
C        at the start.
C
         IF( NLATE .GT. NEXPECT/2 ) NSLATE = NSLATE + 1
      END DO
C
C     Tell the user about the number of scans with late arrival by most
C     antennas.
C
      IF( NSLATE .GT. 0 ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I5, 2A )' )
     1      'CHKSCN: ',  NSLATE, ' scans had more than half the ',
     2      'antennas arrive on-source after the start time.'
         CALL WLOG( 1, MSGTXT )
         MSGTXT = ' '
         WRITE( MSGTXT, '( 2A )' )
     1      '              This could be normal if using duration ',
     2      'scheduling with small gaps.'
         CALL WLOG( 1, MSGTXT )
      END IF
C
C     Check some VLA issues.
C        This routine doesn't do anything now.  Perhaps a new one will
C        be needed.  The original routine has been put in 
C        ~/files/sched_ARCHIVE_nonSVN/obsolete_routines/
C
C        CALL VLASCHK
C
C
C     Look for parallel scans meant to be correlated.  Don't bother
C     checking frequencies in detail - just check the range.
C
C     First gather the minimum and maximum frequency in each setup
C     group.  Just loop through the frequency sets and find the max
C     and min for the associated setup group.
C
C     Initialize.
C
      DO KS = 1, NSET
         MINFR(KS) = MINDEF
         MAXFR(KS) = MAXDEF
      END DO
C
C     Get the extrema.
C
      DO KF = 1, NFSET
         KS = FSETKS(KF)
         ISTA = ISCHSTA(ISETSTA(KS))
         CALL FSFREQ( KF, FRSUM, FRBB, FRBW,
     1                CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC )
         DO ICH = 1, NCHAN(KS)
            IF( NETSIDE(ICH,KS) .EQ. 'U' ) THEN
               FR1 = FRSUM(ICH)
               FR2 = FRSUM(ICH) + FRBW(ICH)
            ELSE
               FR1 = FRSUM(ICH) - FRBW(ICH)
               FR2 = FRSUM(ICH)
            END IF
            MINFR(KS) = MIN( MINFR(KS), FR1 )
            MAXFR(KS) = MAX( MAXFR(KS), FR2 )
         END DO            
      END DO
C
C     Now do the double scan loop looking for matches.
C     Note that we don't need to check the station because other
C     code assures that a station will not have two scans that
C     overlap.
C
      OVWARN = .TRUE.
      DO ISCN = SCAN1 + 1, SCANL
        IF( .NOT. NOREC(ISCN) ) THEN
          DO JSCN = SCAN1, ISCN - 1
            IF( .NOT. NOREC(JSCN) ) THEN
              IF( SCNSRC(ISCN) .EQ. SCNSRC(JSCN) .AND.
     1           STARTJ(ISCN) .LT. STOPJ(JSCN) .AND.
     2           STOPJ(ISCN) .GT. STARTJ(JSCN) ) THEN
                MINFRI = MINDEF
                MAXFRI = MAXDEF
                MINFRJ = MINDEF
                MAXFRJ = MAXDEF
                SKIPI = .TRUE.
                SKIPJ = .TRUE.
                DO ISTA = 1, NSTA
                   KS = NSETUP(ISCN,ISTA)
                   IF( STASCN(ISCN,ISTA) ) THEN
                      SKIPI = .FALSE.
                      MINFRI = MIN( MINFR(KS), MINFRI )
                      MAXFRI = MAX( MAXFR(KS), MAXFRI )
                   END IF
                   IF( STASCN(JSCN,ISTA) ) THEN
                      SKIPJ = .FALSE.
                      MINFRJ = MIN( MINFR(KS), MINFRJ )
                      MAXFRJ = MAX( MAXFR(KS), MAXFRJ )
                   END IF
                END DO               
C
C               Don't get confused by empty scans.  They can have
C               weird properties - like overlapping times.
C
                IF( .NOT. SKIPI .AND. .NOT. SKIPJ ) THEN
C
C                  First complain if frequency groups not found.
C
                   IF( MINFRI .EQ. MINDEF .OR. MAXFRI .EQ. MAXDEF ) THEN
                      MSGTXT = ' '
                      WRITE( MSGTXT, '( A, I5, A )' )
     1                   'CHKSCN: Frequency group not found for scan ',
     2                   ISCN, '.  Should not happen.'
                      CALL ERRLOG( MSGTXT )
                   END IF
                   IF( MINFRJ .EQ. MINDEF .OR. MAXFRJ .EQ. MAXDEF ) THEN
                      MSGTXT = ' '
                      WRITE( MSGTXT, '( A, I5, A )' )
     1                   'CHKSCN: Frequency group not found for scan ',
     2                   JSCN, '.  Should not happen.'
                      CALL ERRLOG( MSGTXT )
                   END IF
C
C                  Now if there are overlapping frequencies, actually
C                  warn about the overlapping scans.
C
                   IF( MINFRI .LT. MAXFRJ .AND. MAXFRI .GT. MINFRJ ) 
     1                 THEN
                     IF( OVWARN ) THEN
                       CALL WRTMSG(  0, 'CHKSCN', 'overlap_scans' )
                       CALL WLOG( 1, 'CHKSCN:  ***** WARNING ****** ' )
                       MSGTXT = ' '
                       WRITE( MSGTXT, '( A, 2I5, A )' )
     1                   '  Two scans (', ISCN, JSCN, 
     3                   ') overlap in source, time, and frequency.'
                       CALL WLOG( 1, MSGTXT )
                       MSGTXT = ' '
                       WRITE( MSGTXT, '( 3A )' )
     1                   '  At VEX driven correlators (others too?) ',
     2                   'antennas in these scans will not be cross ',
     3                   'correlated.'
                       CALL WLOG( 1, MSGTXT )
                       CALL WLOG( 1, 
     1                      '  See sched.runlog for more info.' )
                       OVWARN = .FALSE.
                     ELSE
                       MSGTXT = ' ' 
                       WRITE( MSGTXT, '( A, 2I5 )' )
     1                    '  Additional overlapping scans: ', ISCN, JSCN
                       CALL WLOG( 1, MSGTXT )
                     END IF
                  END IF
                END IF
              END IF
            END IF
          END DO
        END IF
      END DO
C
C     Add phasing INTENTs for stations other than VLA.
C
      CALL PHINT
C
C     Check that VLA phasing scans are at least 4 times VLAPTIME
C     in length.  VLASTA set in VLASCNS.  Establish the PHASING
C     parameter which will ease writing the VLAPTIME based intent
C     in VXSCH.
C
C     Loop through scans to be sure the VLA phasing time is appropriate.
C     Use less indention here because of deep nest and long lines.
C     First be sure the VLA is in the observation and that phasing is
C     requested.  VLASCNS took care of adding INTENTS when VLAMODE
C     is used.
C
C     While at it, this is a convenient place to throw a fit if the
C     user is trying to phase and reference point at the same time.
C
      IF( VLASTA .NE. 0 ) THEN
       DO ISCN = SCAN1, SCANL
        PHASING(ISCN) = .FALSE.
        VLAPTG = .FALSE.
        IF( STASCN(ISCN,VLASTA) ) THEN
          IF( NSCINT(ISCN) .NE. 0 ) THEN
            DO IINT = 1, NSCINT(ISCN)
              IF( INDEX( INTENT(ISCINT(IINT,ISCN)),
     1           'AUTOPHASE_DETERMINE' ) .NE. 0 .AND.
     2         ( INDEX( INTENT(ISCINT(IINT,ISCN)), ':' ) .EQ. 0 .OR.
     3           INDEX( INTENT(ISCINT(IINT,ISCN)), 'VLA' ) .NE. 0 ) )
     4              THEN
                PHASING(ISCN) = .TRUE. 
              END IF
              IF( INDEX( INTENT(ISCINT(IINT,ISCN)),
     1           'REFERENCE_POINTING_DETERMINE' ) .NE. 0 .AND.
     2         ( INDEX( INTENT(ISCINT(IINT,ISCN)), ':' ) .EQ. 0 .OR.
     3           INDEX( INTENT(ISCINT(IINT,ISCN)), 'VLA' ) .NE. 0 ) )
     4              THEN
                VLAPTG = .TRUE. 
              END IF
            END DO
          END IF
C
C         If it's a phasing scan, complain if it is also a pointing scan.
C         If not, then check the length.
C
          IF( PHASING(ISCN) ) THEN  
             IF( VLAPTG ) THEN
                MSGTXT = ' '
                WRITE(MSGTXT, '( 2A, I5 )' )
     1             'CHKSCN:  VLA reference pointing AND phasing ',
     2             'requested in scan ', ISCN
                CALL WLOG( 1, MSGTXT )
                CALL WLOG( 1, '         That is not possible.' )
                CALL ERRLOG( 
     1              'Make separate pointing and phasing scans.' )
             END IF
C
             VPT = DBLE( VLAPTIME(ISCN) ) * ONESEC 
             SCANLEN = STOPJ(ISCN) - 
     1            MAX ( ( STARTJ(ISCN) - TPSTART(ISCN,VLASTA) ), 
     2                    TONSRC(ISCN,VLASTA) )
             IF( SCANLEN / VPT .LT. 4.D0 ) THEN
                MSGTXT = ' ' 
                WRITE( MSGTXT, '( 2A )' )
     1             'CHKSCN:  ** VLA phasing scan must be at least 4 ',
     2             'times longer than the phasing time from VLAPTIME.'
                CALL WLOG( 1, MSGTXT )
                MSGTXT = ' '
                WRITE( MSGTXT, '( A, I5, 3A, F8.1, A, F8.1 )' )
     1             '         Please fix scan', ISCN, ' on ',
     2             SCNSRC(ISCN), ' Scan length:', SCANLEN / ONESEC,
     3             '  VLAPTIME:',  VPT / ONESEC
                CALL ERRLOG( MSGTXT )
             END IF
          END IF
        END IF
       END DO
      END IF
C
C
      RETURN
      END

      SUBROUTINE SETCOP( FROM, TO )
C
C     Routine for SCHED that copies all information except the station
C     name from one setup group to another.  This is to allow users
C     to specify several stations with generic information but have 
C     SCHED treat them separately as it fills out defaults based on
C     the frequency catalog and other information.  SETCOP is used
C     by SETEXPND.
C
C     The input group is index FROM.  It is copied to TO.
C     If NSET is less than TO, it will be set to TO.
C
C     I guess this would be a good place for a C structure.  Maybe 
C     someday in FORTRAN 90.  But I need to be sure the compilers
C     are everywhere before I do that.
C
C     Double check that all variables in schset.inc that should be
C     copied are copied.  Found a couple missing! - 24mar2000 RCW.
C
C     Don't copy IFREQNUM, IFREQIF, SETSTA, ISETSTA
C     as they won't be set yet and/or would be wrong anyway.
C     These all depend on the station and the reason for copying
C     the setup is to get one for another station.
C     Also don't copy the frequency and pcal set information.  It
C     is not organized by setup group.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER   FROM, TO, I, J, IF
C --------------------------------------------------------------------
      IF( TO .GT. NSET ) NSET = TO
C
C     Go copy.  Variables are in the order that they appear in 
C     schset.inc, other than that multidimension arrays are in
C     loops below.
C
      ISETNUM(TO)  = ISETNUM(FROM)            
      SETNAME(TO)  = SETNAME(FROM)
C
C     Reals
C
      AZCOLIM(TO)  = AZCOLIM(FROM)  
      ELCOLIM(TO)  = ELCOLIM(FROM)  
      PTINCR(TO)   = PTINCR(FROM)             
      PTOFF(TO)    = PTOFF(FROM)
      SAMPRATE(TO) = SAMPRATE(FROM)           
      SPEEDH(TO)   = SPEEDH(FROM)             
      SPEEDL(TO)   = SPEEDL(FROM)             
      FANOUT(TO)   = FANOUT(FROM)             
      SPEEDUP(TO)  = SPEEDUP(FROM)            
      BESTOVER(TO) = BESTOVER(FROM)
      TOTBW(TO)    = TOTBW(FROM)
C
C     Integers
C
      NCHAN(TO)    = NCHAN(FROM)              
      PERIOD(TO)   = PERIOD(FROM)             
      LEVEL(TO)    = LEVEL(FROM)              
      TAPEMODE(TO) = TAPEMODE(FROM)           
      TPMODE(TO)   = TPMODE(FROM)           
      SWTCHDUR(TO) = SWTCHDUR(FROM)           
C
C     Logicals
C
      DUALPOL(TO)  = DUALPOL(FROM)
      FRSWITCH(TO) = FRSWITCH(FROM)           
      DUALX(TO)    = DUALX(FROM)              
      MODETEST(TO) = MODETEST(FROM)
      USED(TO)     = USED(FROM)
C
C     Characters
C
      BAND(TO)     = BAND(FROM)
      NOISEFRQ(TO) = NOISEFRQ(FROM)     
      LOGGING(TO)  = LOGGING(FROM)          
      FORMAT(TO)   = FORMAT(FROM)           
      DBE(TO)      = DBE(FROM)
      FIRMFILE(TO) = FIRMFILE(FROM)
      SPCAL(TO)    = SPCAL(FROM)            
      RCHAN(TO)    = RCHAN(FROM)            
      LCHAN(TO)    = LCHAN(FROM)            
      LCP50CM(TO)  = LCP50CM(FROM)          
      RCP50CM(TO)  = RCP50CM(FROM)          
      BARREL(TO)   = BARREL(FROM)           
      M4PATCH(TO)  = M4PATCH(FROM)
C
C     Derived quantities.
C
      MINTRAK(TO)  = MINTRAK(FROM)
      MAXTRAK(TO)  = MAXTRAK(FROM)
      MINTBPS(TO)  = MINTBPS(FROM)
      MAXTBPS(TO)  = MAXTBPS(FROM)
      TBPS(TO)     = TBPS(FROM)
      TOTBPS(TO)   = TOTBPS(FROM)
      VLBAMKIV(TO) = VLBAMKIV(FROM)
      RECUSED(TO)  = RECUSED(FROM)
C
C     Multi-dimension arrays that need loops.
C
      DO IF = 1, 4
         IFDIST(IF,TO) = IFDIST(IF,FROM)         
         NOISE(IF,TO)  = NOISE(IF,FROM)          
         FE(IF,TO)     = FE(IF,FROM)             
      END DO
C
      DO I = 1, 4
         STRING(I,TO) = STRING(I,FROM)        
      END DO
C
      DO I = 1, 3
         SYNTH(I,TO)  = SYNTH(I,FROM)            
      END DO  
C
      DO I = 1, MCHAN
         FREQREF(I,TO) = FREQREF(I,FROM)          
         FIRSTLO(I,TO) = FIRSTLO(I,FROM)      
         FIFMIN(I,TO)  = FIFMIN(I,FROM)
         FIFMAX(I,TO)  = FIFMAX(I,FROM)
         BBSYN(I,TO)   = BBSYN(I,FROM)        
         BBSYN2(I,TO)  = BBSYN2(I,FROM)       
         CORINV(I,TO)  = CORINV(I,FROM)
         BBFILT(I,TO)  = BBFILT(I,FROM)       
         BITS(I,TO)    = BITS(I,FROM)         
         BBC(I,TO)     = BBC(I,FROM)          
         SIDEBD(I,TO)  = SIDEBD(I,FROM)     
         CRDSIDE(I,TO) = CRDSIDE(I,FROM)     
         POL(I,TO)     = POL(I,FROM)        
         IFCHAN(I,TO)  = IFCHAN(I,FROM)     
         ALTIFC(I,TO)  = ALTIFC(I,FROM)
         NETSIDE(I,TO) = NETSIDE(I,FROM)    
         SIDE1(I,TO)   = SIDE1(I,FROM)      
         SFCHAN(I,TO)  = SFCHAN(I,FROM)
         SGCHAN(I,TO)  = SGCHAN(I,FROM)
         VFESYN(I,TO)  = VFESYN(I,FROM)
         DO J = 1, MTPMOD
            TRACK(I,J,TO) = TRACK(I,J,FROM)      
         END DO
      END DO
C
      DO I = 1, MAXPC
         PCALFR1(I,TO) = PCALFR1(I,FROM)     
         PCALFR2(I,TO) = PCALFR2(I,FROM)     
         PCALX1(I,TO)  = PCALX1(I,FROM)    
         PCALX2(I,TO)  = PCALX2(I,FROM)    
      END DO
C
      RETURN
      END

      SUBROUTINE sla_MAPPA (EQ, DATE, AMPRMS)
*+
*     - - - - - -
*      M A P P A
*     - - - - - -
*
*  Compute star-independent parameters in preparation for
*  conversions between mean place and geocentric apparent place.
*
*  The parameters produced by this routine are required in the
*  parallax, light deflection, aberration, and precession/nutation
*  parts of the mean/apparent transformations.
*
*  The reference frames and timescales used are post IAU 1976.
*
*  Given:
*     EQ       d      epoch of mean equinox to be used (Julian)
*     DATE     d      TDB (JD-2400000.5)
*
*  Returned:
*     AMPRMS   d(21)  star-independent mean-to-apparent parameters:
*
*       (1)      time interval for proper motion (Julian years)
*       (2-4)    barycentric position of the Earth (AU)
*       (5-7)    heliocentric direction of the Earth (unit vector)
*       (8)      (grav rad Sun)*2/(Sun-Earth distance)
*       (9-11)   ABV: barycentric Earth velocity in units of c
*       (12)     sqrt(1-v**2) where v=modulus(ABV)
*       (13-21)  precession/nutation (3,3) matrix
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Notes:
*
*  1)  For DATE, the distinction between the required TDB and TT
*      is always negligible.  Moreover, for all but the most
*      critical applications UTC is adequate.
*
*  2)  The vectors AMPRMS(2-4) and AMPRMS(5-7) are referred to
*      the mean equinox and equator of epoch EQ.
*
*  3)  The parameters AMPRMS produced by this routine are used by
*      sla_AMPQK, sla_MAPQK and sla_MAPQKZ.
*
*  4)  The accuracy is sub-milliarcsecond, limited by the
*      precession-nutation model (IAU 1976 precession, Shirai &
*      Fukushima 2001 forced nutation and precession corrections).
*
*  5)  A further limit to the accuracy of routines using the parameter
*      array AMPRMS is imposed by the routine sla_EVP, used here to
*      compute the Earth position and velocity by the methods of
*      Stumpff.  The maximum error in the resulting aberration
*      corrections is about 0.3 milliarcsecond.
*
*  Called:
*     sla_EPJ         MDJ to Julian epoch
*     sla_EVP         earth position & velocity
*     sla_DVN         normalize vector
*     sla_PRENUT      precession/nutation matrix
*
*  P.T.Wallace   Starlink   24 October 2003
*
*  Copyright (C) 2003 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION EQ,DATE,AMPRMS(21)

*  Light time for 1 AU (sec)
      DOUBLE PRECISION CR
      PARAMETER (CR=499.004782D0)

*  Gravitational radius of the Sun x 2 (2*mu/c**2, AU)
      DOUBLE PRECISION GR2
      PARAMETER (GR2=2D0*9.87063D-9)

      INTEGER I

      DOUBLE PRECISION EBD(3),EHD(3),EH(3),E,VN(3),VM

      DOUBLE PRECISION sla_EPJ



*  Time interval for proper motion correction
      AMPRMS(1) = sla_EPJ(DATE)-EQ

*  Get Earth barycentric and heliocentric position and velocity
      CALL sla_EVP(DATE,EQ,EBD,AMPRMS(2),EHD,EH)

*  Heliocentric direction of earth (normalized) and modulus
      CALL sla_DVN(EH,AMPRMS(5),E)

*  Light deflection parameter
      AMPRMS(8) = GR2/E

*  Aberration parameters
      DO I=1,3
         AMPRMS(I+8) = EBD(I)*CR
      END DO
      CALL sla_DVN(AMPRMS(9),VN,VM)
      AMPRMS(12) = SQRT(1D0-VM*VM)

*  Precession/nutation matrix
      CALL sla_PRENUT(EQ,DATE,AMPRMS(13))

      END

      DOUBLE PRECISION FUNCTION sla_DT (EPOCH)
*+
*     - - -
*      D T
*     - - -
*
*  Estimate the offset between dynamical time and Universal Time
*  for a given historical epoch.
*
*  Given:
*     EPOCH       d        (Julian) epoch (e.g. 1850D0)
*
*  The result is a rough estimate of ET-UT (after 1984, TT-UT) at
*  the given epoch, in seconds.
*
*  Notes:
*
*  1  Depending on the epoch, one of three parabolic approximations
*     is used:
*
*      before 979    Stephenson & Morrison's 390 BC to AD 948 model
*      979 to 1708   Stephenson & Morrison's 948 to 1600 model
*      after 1708    McCarthy & Babcock's post-1650 model
*
*     The breakpoints are chosen to ensure continuity:  they occur
*     at places where the adjacent models give the same answer as
*     each other.
*
*  2  The accuracy is modest, with errors of up to 20 sec during
*     the interval since 1650, rising to perhaps 30 min by 1000 BC.
*     Comparatively accurate values from AD 1600 are tabulated in
*     the Astronomical Almanac (see section K8 of the 1995 AA).
*
*  3  The use of double-precision for both argument and result is
*     purely for compatibility with other SLALIB time routines.
*
*  4  The models used are based on a lunar tidal acceleration value
*     of -26.00 arcsec per century.
*
*  Reference:  Explanatory Supplement to the Astronomical Almanac,
*              ed P.K.Seidelmann, University Science Books (1992),
*              section 2.553, p83.  This contains references to
*              the Stephenson & Morrison and McCarthy & Babcock
*              papers.
*
*  P.T.Wallace   Starlink   1 March 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION EPOCH
      DOUBLE PRECISION T,W,S


*  Centuries since 1800
      T=(EPOCH-1800D0)/100D0

*  Select model
      IF (EPOCH.GE.1708.185161980887D0) THEN

*     Post-1708: use McCarthy & Babcock
         W=T-0.19D0
         S=5.156D0+13.3066D0*W*W
      ELSE IF (EPOCH.GE.979.0258204760233D0) THEN

*     979-1708: use Stephenson & Morrison's 948-1600 model
         S=25.5D0*T*T
      ELSE

*     Pre-979: use Stephenson & Morrison's 390 BC to AD 948 model
         S=1360.0D0+(320D0+44.3D0*T)*T
      END IF

*  Result
      sla_DT=S

      END

      LOGICAL FUNCTION VXCFIF( ISET, JSET )
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 290596 
C     returns true if IF block in 2 SCHED sets are identical
C
C     The if_def lines for the VLBA require extra information
C     in comments not required for other stations.  When those
C     lines are shared between VLBA and non-VLBA stations, there
C     can be confusion.  So return false if one station is a 
C     VLBA station and the other not.  Sept. 10, 2012.  RCW.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER ISET, JSET, I, J, ISTA
      INTEGER NICHAN, NJCHAN, ILIST(MCHAN), JLIST(MCHAN)
      LOGICAL NEWFND, IDENT, IVLBA, JVLBA
      CHARACTER UPCALI*4, UPCALJ*4, IDAR*5, JDAR*5
C ----------------------------------------------------------------------
C
      IDENT = .TRUE.      
C
C     figure out how many unique IF's in ISET; look for codes in IFCHAN
C
      NICHAN = 0
      DO I = 1, NCHAN(ISET)
         NEWFND = .FALSE.
         IF( I .EQ. 1) THEN
            NEWFND = .TRUE.
         ELSE
            NEWFND = .TRUE.
            DO J = 1, NICHAN
               IF( IFCHAN(I,ISET) .EQ. IFCHAN(ILIST(J),ISET) )
     1             NEWFND = .FALSE.
            END DO
         END IF
         IF( NEWFND ) THEN
            NICHAN = NICHAN + 1
            ILIST( NICHAN ) = I
         END IF
      END DO
C
C     and in J for that matter
C
      NJCHAN = 0
      DO I = 1, NCHAN(JSET)
         NEWFND = .FALSE.
         IF( I .EQ. 1 ) THEN
            NEWFND = .TRUE.
         ELSE
            NEWFND = .TRUE.
            DO J = 1, NJCHAN
               IF( IFCHAN(I,JSET) .EQ. IFCHAN(JLIST(J),JSET) )
     1              NEWFND = .FALSE.
            END DO
         END IF
         IF( NEWFND ) THEN
            NJCHAN = NJCHAN + 1
            JLIST( NJCHAN ) = I
         END IF
      END DO
C
C     now compare, first the PCal
C
      UPCALI = SPCAL(ISET)
      UPCALJ = SPCAL(JSET)
      CALL UPCASE(UPCALI)
      CALL UPCASE(UPCALJ)
      IF( UPCALI .NE. UPCALJ ) THEN
         IDENT = .FALSE.
      ELSE IF( NICHAN .NE. NJCHAN ) THEN
         IDENT = .FALSE.
      ELSE 
         DO I = 1, NICHAN
C
C        this assumes they have to come out in same order, which is OK
C
            IF( ABS( FIRSTLO(ILIST(I),ISET) - 
     1          FIRSTLO(JLIST(I),JSET) ) .GT. 1E-4 ) 
     2          IDENT = .FALSE.
            IF( SIDE1(ILIST(I),ISET) .NE. SIDE1(JLIST(I),JSET) )
     1          IDENT = .FALSE.
            IF( IFCHAN(ILIST(I),ISET) .NE. IFCHAN(JLIST(I),JSET) ) 
     1          IDENT = .FALSE.
         END DO
      END IF
C
C     can also have different IF blocks if have different IF-coding
C     so need to find DAR for station involved
C
C     Use this piece of code to test for both VLBA or both not VLBA.
C
C
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,ISET) ) THEN
            IDAR = DAR(STANUM(ISTA))
            IVLBA = STATION(STANUM(ISTA))(1:4) .EQ. 'VLBA'
         END IF
      END DO
C 
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,JSET) ) THEN
            JDAR = DAR(STANUM(ISTA))
            JVLBA = STATION(STANUM(ISTA))(1:4) .EQ. 'VLBA'
         END IF
      END DO
C
C     the following statement covers MkIII/MkIV and VLBA/VLBAG
C     It also tests for both VLBA or both not VLBA
C
      IF( ( IDAR(1:3) .NE. JDAR(1:3) ) .OR.
     1    ( IVLBA .NEQV. JVLBA ) ) IDENT = .FALSE.
C
      VXCFIF = IDENT 
C
      RETURN
      END

      SUBROUTINE VLBAST( ISCN, ISTA, FIRSTS, LSTOP,
     1           TSTART, TSTOP, DOSET, DOY1, DOY2, VLBAD1, VLBAD2 )
C
C     Routine for SCHED called by VLBA that writes basic scan 
C     information to a VLBA control file.  It also gets much
C     timing information that is used in the main routine.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
      INTEGER           ISCN, ISRC, ISTA, LCALTIME
      REAL              PDRA, PDDEC
      INTEGER           PMDOY, QUOUT, NCHAR, LEN1, I
      INTEGER           DOY1, DOY2
      LOGICAL           DOSET, PMSET, FIRSTS
      CHARACTER         TSTART*9, TSTOP*9, TRA*16, TDEC*16, TFORM*16
      CHARACTER         PMFT*9, PMVLBAD*9, PMHUMAND*16
      CHARACTER         HUMAND1*16, HUMAND2*16, VLBAD1*9, VLBAD2*9
      CHARACTER         DFMT*30
      DOUBLE PRECISION  LSTOP, PRA, PDEC, PPMTIME
      DOUBLE PRECISION  PMFRACD, FRACD1, FRACD2
      SAVE              PMSET, LCALTIME
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'VLBAST: Starting.' )
C
C     Some initializations.
C
      ISRC   = SRCNUM(ISCN)
      IF( FIRSTS ) THEN
         PMSET = .FALSE.
         LCALTIME = -999
      END IF
C
C     Get various forms for start and stop time.
C
      CALL SCHDAY( STARTJ(ISCN) - TPSTART(ISCN,ISTA), VLBAD1, 
     1             HUMAND1, DOY1, FRACD1 )
      CALL SCHDAY( STOPJ(ISCN), VLBAD2, HUMAND2, DOY2, FRACD2 )
      TSTART = TFORM( FRACD1*TWOPI, 'T', 0, 2, 2, 'hms' )
      TSTOP  = TFORM( FRACD2*TWOPI, 'T', 0, 2, 2, 'hms' )
C
C     If there is a SETUP scan, it should not end at 00h00m00s
C
      IF( DOSET .OR. FIRSTS ) THEN
         IF( TSTART .EQ. '00h00m00s' ) TSTART = '00h00m01s'
      END IF
C
C     Write scan header line.
C
      WRITE( IUVBA, '( 1X, /, 4A, 3X, 2A )' ) '!* --- Scan from ',
     1     TSTART, ' to ', TSTOP, HUMAND1, ' --- *!'
C
C     Write comment.  Protect against "!" which causes problems.
C
      MSGTXT = ANNOT(ISCN)
      NCHAR = LEN1( ANNOT(ISCN) )
      DO I = 1, NCHAR
         IF( MSGTXT(I:I) .EQ. '!' ) MSGTXT(I:I) = '.'
      END DO
      IF( ANNOT(ISCN) .NE. ' ' ) THEN
         WRITE(IUVBA,'(''!*  '',A,''  *!'')') MSGTXT(1:NCHAR)
      END IF
C
C     Source information.  Do in subroutine to get satellite
C     and planet positions for specific scan.
C
      CALL SRCLOC( ISCN, ISTA, PRA, PDEC, PPMTIME, PDRA, PDDEC )
C
C     Get character form of RA and DEC that will be 
C     needed several times.
C
      TRA  = TFORM( PRA, 'T', 0, 2, 9, 'hms' )
      TDEC = TFORM( PDEC, ' ', 1, 2, 8, 'd''"' )
C
C     The qualifier is being used to distinguish setup scans from
C     real scans in monitor data.  Set to 999 on setup scan.
C
      IF( DOSET .OR. FIRSTS ) THEN
         QUOUT = 999
      ELSE
         QUOUT = QUAL(ISCN)
      END IF
C
C     Use the 12 character source name for all cases.
C
      NCHAR = LEN1( SCNSRC(ISCN) )
      WRITE(IUVBA,'( 7A, I3, 3A  )' ) 
     1      'sname=''', SCNSRC(ISCN)(1:NCHAR), '''  ra=', TRA, 
     2      '  dec=', TDEC, '  qual=', QUOUT, 
     3      '  calib=''', CALCODE(ISRC), ''''
C
C     Write proper motion information if needed.
C     A crazy user wants scan rates close to the slew rates and
C     the old format is not providing enough digits.  Increase
C     the digits, but only if needed.
C
      IF( PDRA .NE. 0.0 .OR. PDDEC .NE. 0.0  ) THEN
         CALL SCHDAY( PPMTIME, PMVLBAD, PMHUMAND, PMDOY, PMFRACD )
         PMFT = TFORM( PMFRACD*TWOPI, 'T', 0, 2, 2, 'hms' )
         IF( ABS( PDRA ) .GT. 1.D5 .OR. ABS( PDDEC ).GT. 1.D5 ) THEN
            DFMT = '( 5A, F14.2, A, F14.2 )'
         ELSE 
            DFMT = '( 5A, F10.2, A, F10.2 )'
         END IF
         WRITE( IUVBA, DFMT )
     1        ' epochd=', PMVLBAD, ' epocht=', PMFT, 
     2        ' dra=', PDRA, ' ddec=', PDDEC
         PMSET = .TRUE.
      ELSE IF( PMSET ) THEN
         WRITE( IUVBA, '( A )' ) '   dra=0.0  ddec=0.0 '
         PMSET = .FALSE.
      END IF
C
C     Write the caltime request.  Should happen on first call.
C
      IF( CALTIME(ISCN) .NE. LCALTIME ) THEN
         LCALTIME = CALTIME(ISCN)
         WRITE( IUVBA, '( A, I4 )' ) 'maxcaltime=', LCALTIME
      END IF
C
      IF( DEBUG ) CALL WLOG( 0, 'VLBAST: Ending.' )
      RETURN
      END

      SUBROUTINE GMKSCN( LASTISCN, ISCN, JSCN, ISRC, SRCN, TAPPROX, 
     1                 MINEL, KEEPSTA, NGOOD, OKSTA, SSTASCN, GMODE )
Cf2py intent(in) LASTISCN, ISCN, JSCN, ISRC, SRCN, TAPPROX, MINEL, KEEPSTA
Cf2py intent(in) GMODE
Cf2py intent(out) NGOOD
C OKSTA is an out argument, but make it (in, out) to define its size
Cf2py intent(in, out) OKSTA, SSTASCN
C
C     This is varient of MAKESCN to be used in the process of the
C     geodetic scan insertion.  Besides what MAKESCN does, it can
C     remove stations, or even inhibit use of the new scan, based
C     on slew times.  It was needed several times in MAKESEG and
C     ADDGEO, so I have consolidated it here.
C
C     GMODE = 'SET' means set STASCN and other parameters based on
C             the geometry and on JSCN.
C
C     GMODE = 'FORCE' means set STASCN = SSTASCN and set the other
C             indicators (NGOOD, OKSTA) based on SSTASCN.  Basically
C             in these cases, this routine has been called earlier
C             and the selections done based on that.  Now we basically
C             want MAKESCN but with STASCN forced to the previously
C             derived values.  That forcing avoids unexpected edge
C             effects with slight time shifts.
C
C     KEEPSTA can be set to an antenna that should not be dropped
C             for long slews.
C
      INCLUDE 'sched.inc'
C
C     Call arguments, mostly for MAKESCN
C 
      INTEGER            LASTISCN(*), ISCN, JSCN, ISRC, NGOOD
      INTEGER            KEEPSTA
      CHARACTER          SRCN*12, GMODE*5
      REAL               MINEL
      DOUBLE PRECISION   TAPPROX
      LOGICAL            OKSTA(*), SSTASCN(*)
C
C     Internal variables.
C
      INTEGER            ISTA, INSCN, ARRSEQ(MAXSTA), K, ITEMP
      DOUBLE PRECISION   LASTTIME, T_AVAIL, TMED
C ------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'GMKSCN starting.' )
C
C     The first part is lifted from MAKESCN, then modified to deal
C     with SSTASCN.
C
      NGOOD = 0
C
C     Copy the template scan.
C
      CALL SCNDUP ( ISCN, JSCN, .FALSE., 'GMKSCN' )
C
C     Insert the source.
C
      SRCNUM(ISCN) = ISRC
      SCNSRC(ISCN) = SRCN
C
C     Deal with a request to make a scan but determine and leave off 
C     slow slew stations.
C
      IF( GMODE .EQ. 'SET' ) THEN
C
C        Loop through stations to see which ones are up at TAPPROX.
C        Also see how many are above the minimum elevation.
C        This pass determines the approximate geometry - enough to 
C        edit stations and count the good ones. 
C
         DO ISTA = 1, NSTA
            OKSTA(ISTA) = .FALSE.
            IF( STASCN(JSCN,ISTA) ) THEN
               CALL STAGEO( ISCN, ISTA, TAPPROX, LASTISCN(ISTA),  
     1             LASTTIME, T_AVAIL, 'GMKSCN' )
               IF( UP1(ISCN,ISTA) .EQ. ' ' .AND. 
     1             UP2(ISCN,ISTA) .EQ. ' ' .AND. 
     2             EL1(ISCN,ISTA) .GT. MINEL .AND.
     3             EL2(ISCN,ISTA) .GT. MINEL ) THEN
                  OKSTA(ISTA) = .TRUE.
                  NGOOD = NGOOD + 1
               END IF
            END IF
         END DO
C
C        Set the scan stations list based on the results from STAGEO.
C
         DO ISTA = 1, NSTA
            STASCN(ISCN,ISTA) = STASCN(JSCN,ISTA) .AND. OKSTA(ISTA)
         END DO
C
C        Get the final timing and geometry.  OPTTIM sets the scan
C        timing and SCNGEO gets the geometry, slew times, on-source
C        times etc.  
C        The restriction to a minimum number of good antennas
C        will be done elsewhere.
C      
         IF( NGOOD .GE. 1 ) THEN
            STARTJ(ISCN) = TAPPROX
C      
C           Adjust the scan times based on a geometry calculation.
C           This reruns the above STAGEO so it could possibly be made
C           more efficient some day.  Assume LASTISCN and LASTSSCN
C           are the same in circumstances where GMKSCN is used, or
C           at least that such an assumption will not get us in trouble.
C           The difference relates to whether or not the scan is 
C           preceded by automatically inserted pointing scans.
C      
            CALL OPTTIM( LASTISCN, LASTISCN, ISCN, .TRUE., 
     1                   .FALSE., .FALSE. )
C      
C           Determine the geometry, slew times, and time of arrival 
C           on source based on the final times.  NGOOD is 
C           redetermined based on the final times.
C      
            CALL SCNGEO( LASTISCN, NGOOD, ISCN )
         END IF
C
C        Try to prevent long waits for small numbers of
C        antennas.  Get the average TONSRC for stations
C        that were in the preceding scan (Could be distorted
C        badly if those that could slew during the last scan
C        are counted).  Then look at any station that is
C        later than the average by 30 seconds or more.
C        If the elevation at that station is high, eliminate
C        the station (adjust STASCN, NGOOD, OKSTA).  Note
C        that the final times will change, but this routine
C        will only be called in "SET" mode by routines (MAKESEG)
C        that will call it again in "FORCE" mode before scan
C        parameters are finalized.
C
C        If the source is at low elevation at
C        the slow station, block use of the scan here in 
C        the hope that it will be picked up later.  Do that
C        by setting NGOOD=0.
C
C        Don't bother with these calculations if the source 
C        won't be selected anyway (NGOOD too small regardless).
C        Also don't do it for the first scan of an experiment.
C
         IF( NGOOD .GE. OPMIAN(JSCN) .AND. 
     1       ISCN .GT. SCAN1 ) THEN
C
C           Get the time to compare with TONSRC to determine if an
C           antenna gets there late.  Naively this could be the 
C           average time of arrival of the antennas that were in 
C           the previous scan (ISCN-1).  I tried 
C           that.  But if there is a scan with no antennas in the
C           previous scan, this creates trouble.  I hit that at the
C           start of a geodetic sequence following a pointing scan
C           at the GBT.  So instead try something else.  For the 
C           moment, it will be the third last arrival time.
C
            INSCN = 0
            DO ISTA = 1, NSTA
               ARRSEQ(ISTA) = 0
            END DO
            DO ISTA = 1, NSTA
               IF( STASCN(ISCN,ISTA) ) THEN
                  INSCN = INSCN + 1
C
C                 Put current station at end of list, then sort to
C                 right place.
C
                  ARRSEQ(INSCN) = ISTA
                  IF( INSCN .GE. 2 ) THEN
                     DO K = INSCN, 2, -1
                        IF( TONSRC(ISCN,ARRSEQ(K)) .GT. 
     1                      TONSRC(ISCN,ARRSEQ(K-1)) ) THEN
                           ITEMP = ARRSEQ(K-1)
                           ARRSEQ(K-1) = ARRSEQ(K)
                           ARRSEQ(K) = ITEMP
                        END IF
                     END DO
                  END IF
               END IF
            END DO
            IF( INSCN .GT. 0 ) THEN
               TMED = TONSRC(ISCN,ARRSEQ(MIN(INSCN,3)))
            ELSE
               CALL ERRLOG( 'GMKSCN: INSCN zero.  Programming error' )
            END IF
C
C       Various debugging printouts I don't want to retype if I need them
C       again.
C            write(*,*) 'gmkscn median', iscn, inscn, ' ', srcn, 
C      1        (tonsrc(iscn,arrseq(1))-55452.D0)/onesec, 
C      2        (tmed-55452.D0)/onesec, 
C      1        (tonsrc(iscn,arrseq(1))-55452.D0)/onesec - 
C      2        (tmed-55452.D0)/onesec, 
C      3        arrseq(1), arrseq(2), arrseq(3)
C
C      Note that the following debugging print is specific to an 
C      11 station observation so it is not subject to GEOPRT.
C       write(*,'(A,A,11l2,11F6.0,3X,11F6.1)') 'gmkscn --', srcn,
C     1     (stascn(iscn,ista),ista=1,nsta),
C     2     ((tonsrc(iscn,ista)-tonsum)/onesec,ista=1,nsta),
C     3     (el1(iscn,ista),ista=1,nsta)
C
C
C           Deal with late stations.
C           But don't drop the antenna that is really needs improvement.
C
            DO ISTA = 1, NSTA
               IF( STASCN(ISCN,ISTA) .AND. ISTA .NE. KEEPSTA .AND.
     1             LASTISCN(ISTA) .NE. 0 ) THEN
                  IF( TONSRC(ISCN,ISTA) .GT. 
     1                TMED + GEOSLOW * ONESEC ) THEN
C
C                    Low elevation scan for the slow antenna.
C
                     IF( EL1(ISCN,ISTA) .LT. GEOLOWEL ) THEN
                        NGOOD = 0
                        IF( GEOPRT .GE. 2 ) THEN
                           MSGTXT = ' '
                           WRITE( MSGTXT,* ) 
     1                         '**gmkscn: Dropping scan - '//
     2                         'low el for slow ant',
     3                         ISTA, ISCN, '   ', SRCN, 
     4                         EL1(ISCN,ISTA)
                           CALL WLOG( 0, MSGTXT )
                        END IF
C
C                    High elevation scan for the slow antenna.
C                    Remove the station from the scan.
C
                     ELSE
                        NGOOD = MAX( NGOOD - 1, 0 )
                        STASCN(ISCN,ISTA) = .FALSE.
                        OKSTA(ISTA) = .FALSE.
                        IF( GEOPRT .GE. 2 ) THEN
                           MSGTXT = ' '
                           WRITE( MSGTXT, '( A, I3, A, 2I5, 3A )' ) 
     1                        '++gmkscn: Dropping station ',
     2                        ISTA, '  Scan ', ISCN, SCAN1, 
     3                        '  Geosrc: ', SRCN, ' for long slew.'
                           CALL WLOG( 0, MSGTXT )
                        END IF
                     END IF
                  END IF
               END IF
            END DO
         END IF
C
C        Set the output equivalent to STASCN.
C
         DO ISTA = 1, NSTA
            SSTASCN(ISTA) = STASCN(ISCN,ISTA)
         END DO
C
C     ==========================================
C     Now deal with the FORCE case.  Make STASCN match
C     SSTASCN and don't reset it based on the geometry.
C     Set NGOOD and OKSTA based on SSTASCN.
C
      ELSE IF( GMODE .EQ. 'FORCE' ) THEN
         DO ISTA = 1, NSTA
            STASCN(ISCN,ISTA) = SSTASCN(ISTA)
            IF( SSTASCN(ISTA) ) THEN
               OKSTA(ISTA) = .TRUE.
               NGOOD = NGOOD + 1
            ELSE
               OKSTA(ISTA) = .FALSE.
            END IF
         END DO
C
C        Get the geometry with the same calls as used for the
C        GMODE=SET version.  Assume that it is ok to use
C        LASTISCN for LASTSSCN.  This certainly true if the
C        preceding scan is not an inserted pointing scan.
C
         IF( NGOOD .GE. 1 ) THEN
            STARTJ(ISCN) = TAPPROX
            CALL OPTTIM( LASTISCN, LASTISCN, ISCN, .TRUE., 
     1                   .FALSE., .FALSE. )
            CALL SCNGEO( LASTISCN, NGOOD, ISCN )
         END IF

      ELSE
         CALL ERRLOG( 'GMKSCN: Bad GMODE.  Programming error.' )
      END IF
      RETURN
      END

      SUBROUTINE GETSUN
C
C     Calculate the distance from the sun for all sources.  Just
C     getting one number per source.
C
C     Use the low accuracy SLALIB routines.
C
C     Use the times for the extremes of the experiment calculated
C     in SCHTIM.
C
      INCLUDE 'sched.inc'
C
      INTEGER           ISRC
      DOUBLE PRECISION  TMID, RAS, DECS, SLA_DSEP
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'GETSUN starting' )
C
C     Get the position of the sun.
C
      TMID = TFIRST + ( TEND - TFIRST ) / 2.D0
      CALL SUNPOS( TMID, RAS, DECS )
C
C     Get the angular offset from each source.
C
      DO ISRC = 1, MSRC
         SUNDIS(ISRC) = SLA_DSEP( RAP(ISRC), DECP(ISRC),
     1         RAS, DECS ) / RADDEG
      END DO
C
      RETURN
      END

      SUBROUTINE SETEXPND
C
C     Routine for SCHED, called by GETSET, that takes setup groups 
C     specified for more than one antenna and expands them out to
C     one group per antenna.  This allows an input setup file specified
C     with only generic parameters to apply to many antennas and
C     yet allows SCHED to make the ultimate information in the setup
C     to be station dependent after utilizing the data from the
C     frequency catalog.
C
C     Also, get ISETSTA, the pointer to the station catalog entry of the
C     station of the final setup group.
C
C     After SETSTDEF, there should be no default stations like "VLBA".
C     This was a change in Dec. 2004.  Now each station has it's own
C     setup.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER      KS, IS, KSO 
C     INTEGER      JS
      INTEGER      LSTA, ISCN, KSI, GNSET
C      LOGICAL      USEIT
C  --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SETEXPND: Starting.' )
C
C     Eliminate stations that don't use the setup and expand a
C     defaulted station (blank) if that was given.  Note that
C     it is possible that the setup group will not be used at all.
C
      DO KS = 1, NSET
         CALL SETSTDEF( KS )
      END DO
C
C     Going backwards through both the setup groups and the stations,
C     expand each setup file to one group per station, eliminating 
C     unused groups.  Put them at the back of the setup file arrays 
C     to avoid overwrites.  Later, move them up.  MSET is maximum 
C     number of setup groups.
C
      KSO = MSET + 1
C
      DO KS = NSET, 1, -1
         DO IS = MANT, 1, -1
            IF( SETSTA(IS,KS) .NE. ' ' ) THEN
               KSO = KSO - 1
C
C              Check that we will not end up with too many setup groups
C              and that unexpanded ones, including the current one,
C              won't be overwritten.
C
               IF( KSO .LE. KS ) THEN
                  CALL WLOG( 1, 'SETEXPND: ' //
     1              'There are too many setup groups after '//
     2              'creating new ones ' )
                  CALL WLOG( 1, '          ' //
     1              'for each station in the input setups.' )
                  WRITE( MSGTXT, '( A, I5, A )' )
     1              '          Maximum is ', MSET, 
     2              ' which is setups times stations.'
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT = ' '
                  CALL ERRLOG( 'SETEXPND: ' //
     1              'You need fewer setups or a bigger MSET in SCHED.' )
               END IF
C
C              Copy setup to single station version at end of pack.
C
               CALL SETCOP( KS, KSO )
               SETSTA(1,KSO) = SETSTA(IS,KS)
C
            END IF
         END DO
      END DO
C
C     Check that we got something.
C
      IF( KSO .EQ. MSET + 1 ) THEN
         CALL ERRLOG('SETEXPND: None of the specified setups are used.')
      END IF
C
C     Now copy the new ones to the front of the list.
C     NSET will be set to the highest value seen by SETCOP.
C
      NSET = 0
      DO KS = 1, MSET - KSO + 1
         KSI = KS + KSO - 1
         CALL SETCOP( KSI, KS )
         SETSTA(1,KS) = SETSTA(1,KSI)
      END DO
C
C     Fill in the NSETUP array with the setup group used for each
C     scan/station.
C
      DO LSTA = 1, NSTA
         DO ISCN = 1, NSCANS
            NSETUP(ISCN,LSTA) = GNSET(ISCN,LSTA)
         END DO
      END DO
C
C     Initialize LISTKS to KS.  This will eventually be the setup
C     group that is actually printed in the SUM file for the collection
C     of groups that are basically the same, just for different 
C     stations.
C
      DO KS = 1, NSET
         LISTKS(KS) = KS
      END DO
C
C     Get ISETSTA.  
C
C     This used to be a bit tricky because of the possible
C     defaulting.  As of Dec 2004, each station has a setup so
C     it should no longer be a problem.  Keep the legacy code
C     (commented) in case it is needed some day.
C
C     Do it by looping through the schedule stations
C     and then the scans looking for a match.  Allow NSETUP
C     to make the final match determination.  Make a simple check
C     here to avoid looping through scans when there is an 
C     obvious mismatch.  Note that, for some default cases, ISETSTA
C     will be for the last matching station.
C
      DO KS = 1, NSET
         ISETSTA(KS) = 0
         DO LSTA = 1, NSTA
            IF( SETSTA(1,KS) .EQ. STANAME(LSTA) ) THEN
               ISETSTA(KS) = STANUM(LSTA)
            END IF
         END DO
C
C
C        The following defaulting is no longer used.
C
C        Now look for a station to use for a default like VLBA.
C        Use a VLBA station that is not explicitly specified in another
C        group from the same setup file.
C
C         IF( ISETSTA(KS) .EQ. 0 .AND. 
C     1       SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) THEN
C
C            write(*,*) 'setexpnd:  Should not get here'
C            DO LSTA = 1, NSTA
C               IF( STANAME(LSTA)(1:4) .EQ. 'VLBA' ) THEN
C                  USEIT = .TRUE.
C                  DO JS = 1, NSET
C                     IF( JS .NE. KS .AND. 
C     1                   ISETNUM(JS) .EQ. ISETNUM(KS) .AND.
C     2                   SETSTA(1,JS) .EQ. STANAME(LSTA) ) THEN
C                        USEIT = .FALSE.
C                     END IF
C                  END DO
C                  IF( USEIT ) THEN
C                     ISETSTA(KS) = STANUM(LSTA)
C                     GO TO 50
C                  END IF
C               END IF
C            END DO
C         END IF
C   50    CONTINUE
C
C
C        Complain if could not get a station number.  I think this
C        is always a programming problem.  A station not in the
C        station list should not have survived the earier paring
C        down of the station list.
C
         IF( ISETSTA(KS) .EQ. 0 ) THEN
            CALL WLOG( 1, 'SETEXPND: Did not get station number. ' //
     1        'Programming problem.' )
            CALL WLOG( 1, '          Station: ' // SETSTA(1,KS) )
            CALL ERRSET( KS )
         END IF
C
      END DO
C
      RETURN
      END

      SUBROUTINE VXWRPO
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the PO = $PASS_ORDER section 
C     By H.J. van Langevelde, JIVE, 300496 
C
C     Removed tape handling July 20, 2010  RCW.  It used a subroutine
C     that was removed from the main Sched area.
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
      INTEGER   IPO, KS, IP
      INTEGER   LEN1, ASTAT, IMODE
      CHARACTER LINE*132, DEL*1
      LOGICAL   VIOLFS
C ----------------------------------------------------------------------
C
C     Write the PASSORDER sections, this is tough
C
      VIOLFS = .FALSE.
      WRITE( IVEX, '( A, A1 )' ) '$PASS_ORDER', SEP   
      DO IPO = 1, NPOVEX

         KS = POISSET(IPO)
C
C        Find a station in this VEX group
C
         DO IMODE = 1, NMDVEX
            IF ( NSTAHP(IPO,IMODE) .GT. 0 ) THEN 
               ASTAT = ISTAHP(1,IPO,IMODE)
            ENDIF
         ENDDO
C
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1       POLINK(IPO)(1:LEN1(POLINK(IPO))), SEP
         CALL VXSTLI( IPO, NSTAPO, ISTAPO )
C
         LINE = ' ' 
C
         IF( FORMAT(KS) .NE. 'S2' .AND. FORMAT(KS) .NE. 'LBA' ) THEN 
C
C        Check if PCFS can do
C
            IF( TAPEMODE( KS ) .GT. 36 ) THEN
               VIOLFS = .TRUE.
               WRITE( MSGTXT, '( A, I3, A, A )' ) 
     1             'VXWRPO: WARNING: More than 36 subpasses (',
     2             TAPEMODE( KS ),') in ',
     3             POLINK(IPO)(1:LEN1(POLINK(IPO)))
               CALL WLOG( 1, MSGTXT )
            END IF            
C
            IF( USEDISK(ASTAT) ) THEN
C
C                 No passorder for disks
C
                  WRITE( IVEX, '( A1, 4X, A )' ) COM,
     1                ' Pass orders irrelevant for Disk: empty def'
            END IF
         ELSE IF( FORMAT(KS)(1:3) .EQ. 'LBA' ) THEN
C        
            WRITE( IVEX, '( A1, A )' )  COM,
     1         ' LBA masquerading as S2 needs a dummy value'
            WRITE( IVEX, '( 5X, A )' )  'S2_group_order = 0;'
         ELSE
C
C           Quite different
C
            WRITE( LINE(1:21) , '( 5X, A )' ) 'S2_group_order ='
            DO IP = 1, TAPEMODE( KS )    
               DEL = COL
               IF( IP .EQ. TAPEMODE( KS ) ) DEL = SEP
               WRITE(LINE(22+(IP-1)*3:21+IP*3), '( I2, A1 )' )
     1             (IP-1), DEL
            END DO
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END IF
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
      ENDDO
      WRITE( IVEX, '( A )' ) COMLIN

      IF( VIOLFS )
     1    CALL WLOG( 1,'VXWRPO: More than 36 subpasses '//
     2    'not supported in PCFS; this VEX will NOT run!!!!')
      RETURN
      END

      SUBROUTINE VXWRHP
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the HP = $HEAD_POSITION section 
C     By H.J. van Langevelde, JIVE, 300496 
C
C     Tape stuff removed July 22, 2010  RCW
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
      INTEGER   IHP, KS, ASTAT, IMODE
      INTEGER   LEN1
C ----------------------------------------------------------------------
C
C     Write the HEADPOS sections, this is fixed
C
      WRITE( IVEX, '( A, A1 )' ) '$HEAD_POS', SEP   
      DO IHP = 1, NHPVEX
         KS = HPISSET(IHP)
C
C        Find a station in this VEX group
C
         DO IMODE = 1, NMDVEX
            IF ( NSTAHP(IHP,IMODE) .GT. 0 ) THEN 
               ASTAT = ISTAHP(1,IHP,IMODE)
            ENDIF
         END DO
C
C        Removed 2 head test - Tape only.
C
C        Not much to do any more - head positions are history.
C
         IF( USEDISK (ASTAT) ) THEN 
            WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1          HPLINK(IHP)(1:LEN1(HPLINK(IHP))), SEP  
            CALL VXSTLI( IHP, NSTAHP, ISTAHP )
            WRITE( IVEX, '( A1, 4X, A )' ) COM,
     1          ' Head positions irrelevant for Disk: empty def'
            WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
         END IF
      END DO
C
      WRITE( IVEX, '( A )' ) COMLIN
      RETURN
      END

      SUBROUTINE CORSOC
C
C     Subroutine for SCHED, called by CORLST, that deals with correlator
C     constraints specific to the Socorro VLBA hardware correlator.  This
C     is now out of date because that correlator is shut down as of late
C     December 2009.  Changed the meaning of CORREL=SOCORRO or VLBA to
C     be DIFX and added FXCORR to mean the hardware correlator, just in
C     case someone wants it.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER           LSTA, LSCN, NSANT, MOSTCH
      REAL              FIRRATE, MAXFIRR, RCORCH
      LOGICAL           WARN
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CORSOC starting.' )
      WARN = .FALSE.
C
C     This routine is only for the SOCORRO VLBA correlator
C
C      IF( CORREL(1:7) .EQ. 'SOCORRO' .OR. 
C     1   ( CORREL(1:4) .EQ. 'VLBA' .AND. LEN1( CORREL ) .EQ. 4 ) ) THEN
      IF( CORREL(1:6) .EQ. 'FXCORR' ) THEN
C
C        Do some initializations.
C
         MAXFIRR = 0.0
         MOSTCH = 0
C
C        Loop through scans.
C
         DO LSCN = SCAN1, SCANL
C
C           Get number of stations in the scan.
C
            NSANT = 0
            DO LSTA = 1, NSTA
               IF( STASCN(LSCN,LSTA) ) THEN
                  NSANT = NSANT + 1            
               END IF
            END DO
            IF( NSANT .GT. 0 .AND. .NOT. NOREC(LSCN) ) THEN
C
C              Deal with a special internal limitation in the 
C              SOCORRO hardware correlator.
C
C              Get the rate that channels are transferred through
C              the FIR filter in the correlator.  This cannot be
C              more than 44236-2048=41188 spectral channels per
C              0.131 sec tic.  The correlator always transfers
C              2048 spectral channels divided by the spectral
C              averaging, regardless of how many are kept.
C              Usually, the correlator does 512 point FFTs producing
C              256 point spectra, which are then averaged to 16 
C              or 32 for continuum projects.  
C              Use a real version of CORCHAN to avoid getting zero
C              out of one of the ratios while it is still integer.
C
               RCORCH = CORCHAN
               FIRRATE = ( 0.131 / CORAVG ) * 
     1                   ( NSANT * ( NSANT + 1.0 ) / 2.0 ) *
     2                   2048.0 * ( RCORCH / MAX( 256.0, RCORCH ) )
     3                   * FSPEED(SETNUM(LSCN))
               MOSTCH = MAX( MSCHN(SETNUM(LSCN)), MOSTCH )
C
               MAXFIRR = MAX( MAXFIRR, FIRRATE )
            END IF
         END DO

C
C        Warn if data rate is too high.  The limit was changed from
C        500 Mbytes/sec to 1000 Mbytes/sec on May 9, 2003.
C
         IF( MAXDR .GT. 1000000. .AND. .NOT. TWOHEAD ) THEN
            WRITE( ISUM, '( A, /, A, A / A )' )
     1           ' **** WARNING ****',
     2           '    Projected correlator output data rate ',
     3           'exceeds VLBA correlator ',
     4           '    limit of 1000 kbytes per second. '
C            WRITE( ISUM, '( A, A )' ) 
C     1           '                    ',
C     2           'Higher rates may be ok.  Contact Socorro for info.'
            CALL WLOG( 1, 'CORSOC:  **** WARNING ****' )
            CALL WLOG( 1, '    Correlator output '//
     1         'data rate limit exceeded.  See summary file.' )
            WARN = .TRUE.
         ELSE IF( MAXDR .GT. 2.0E6 .AND. TWOHEAD ) THEN
            WRITE( ISUM, '( A, A, A / T22, A )' )
     1           ' **** WARNING ****',
     2           'Projected correlator output data rate ',
     3           'exceeds VLBA correlator ',
     4           'limit of 1000 kbytes per second per pass. '
C            WRITE( ISUM, '( A, A )' ) 
C     1           '                    ',
C     2           'Higher rates may be ok.  Contact Socorro for info.'
            WRITE( ISUM, '( T22, A, A )' )
     1           'Assuming 2 pass processing for this wide band ',
     2           'observation.'
            CALL WLOG( 1, 'CORSOC: **** WARNING **** ' )
            CALL WLOG( 1, '    Correlator output '//
     1           'data rate limit exceeded.  See summary.' )
            WARN = .TRUE.
         END IF
C
C        Warn of the FIR transfer rate limit if it is exceeded for
C        the SOCORRO correlator.
C
         IF( MAXFIRR .GT. 41188 ) THEN
            WRITE( ISUM, '( 1X, A, A / T22, A, F8.0 )' )
     1      ' ******** WARNING:  You have exceeded the FIR transfer ',
     2      'rate limit of 41188 ',
     3      'channels per tic.  Your projected rate is ', MAXFIRR
            IF( CORAVG .NE. CORAV2 .AND. CORAV2 .NE. 0.0 ) THEN
               WRITE( ISUM, '( T22, A, A )' )
     1             'This projection does not take into account your ',
     2             'secondary averaging time.'
            END IF
            IF( MOSTCH .GT. 1 ) THEN
               WRITE( ISUM, '( T22, A, A )' ) 
     1                   'This cannot be fixed by processing ',
     2                   'IF channels separately.'
            END IF
            WRITE( ISUM, '( T22, A, A )' )
     1         'Please contact someone in Socorro if you don''t ',
     2         'understand this.'
            WARN = .TRUE.
         END IF
         IF( WARN .AND. TWOHEAD ) THEN
            WRITE( ISUM, '( T5, 2A, /, T5, 2A )' )
     1                    'If you are doing two pass processing ',
     2                    '(eg 512 Mbps), ',
     3                    'the output bit rate and FIR rate limits ',
     4                    'are twice the above values.'
         END IF
      END IF

      RETURN
      END

      SUBROUTINE FSPREAD( NEEDFMT )
C
C     This routine is likely to be obsolete thanks to disk 
C     systems that don't end up in management nightmares when
C     the number of tracks change and to correlators that don't
C     care when different stations have different track bit 
C     rates.
C
C     Routine for SCHED, called by SETFORM, that propagates
C     track bit rates across setup files and numbers of track
C     through time for each station.  It is part of the format
C     setting mechanism.  Such behavior is confined to formats
C     for such systems as require these constrains, mainly 
C     VLBA and MKIV, although Mark III formats are checked, 
C     but not set (they were already forced by the first SETFMT
C     call).
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER  KS, ISETF
      INTEGER  NTRACK, MINSTRK, USETRK
      REAL     MAXTOT, TRKBPS
      REAL     TTBPS(MAXSET), BTBPS(MAXSET)
      REAL     SETTBPS(MAXSET), FSAMPR(MAXSET), MAXFTOT(MAXSET)
      LOGICAL  NEEDFMT(*), OK
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'FSPREAD starting' )
C
C     Ask for feedback if the routine is called.
C
      CALL WLOG( 1, 'FSPREAD:  Please inform Craig Walker at '//
     1  'cwalker@nrao.edu if you see this message.' )
      CALL WLOG( 1, '          It means you reached a part of SCHED '//
     1  'not thought to still be active.' )
      CALL WLOG( 1, '          Please include your input file.' )
C
C     Get some information about the parameters in the setup files.
C
      MAXTOT = 0.0
      DO ISETF = 1, NSETF
         TTBPS(ISETF)   = 1.E5
         BTBPS(ISETF)   = 0.0
         FSAMPR(ISETF)  = 0.0
         MAXFTOT(ISETF) = 0.0
C         SETTBPS(ISETF) = 0.0
      END DO
      DO KS = 1, NSET
         ISETF = ISETNUM(KS)
         IF( RECUSED(KS) .AND.
     1     ( VLBAMKIV(KS) .OR. FORMAT(KS) .EQ. 'MARKIII' ) ) THEN  
C
C           Get the minimum and maximum acceptable track bit rates
C           for each setup file.  Any incompatibility in previously
C           set files should show up here.  Include MARKIII, although
C           mixed mode observations should be a thing of the past.
C           Should S2 be included?  I don't think so.
C
            IF( NEEDFMT(KS) ) THEN
               TTBPS(ISETF) = MIN( TTBPS(ISETF), MAXTBPS(KS) )
               BTBPS(ISETF) = MAX( BTBPS(ISETF), MINTBPS(KS) )
            ELSE
               TTBPS(ISETF) = MIN( TTBPS(ISETF), TBPS(KS) )
               BTBPS(ISETF) = MAX( BTBPS(ISETF), TBPS(KS) )
            END IF
C
C           Enforce constant sample rate in a setup file.
C           This is done later by CHKSFIL, but we need it here.
C
            IF( FSAMPR(ISETF) .NE. 0.0 .AND. 
     1          FSAMPR(ISETF) .NE. SAMPRATE(KS) ) THEN
               CALL WLOG( 1, 'FSPREAD: Sample rate not constant ' //
     1            'across setup groups in setup file:' )
               CALL WLOG( 1, '       ' // SETFILE(ISETF) )
               CALL ERRLOG( 'Fix the unequal rates.' )
            ELSE IF( FSAMPR(ISETF) .EQ. 0.0 ) THEN
               FSAMPR(ISETF) = SAMPRATE(KS)
            END IF
C
C           With the disk systems, the following is not needed so
C           don't do it (RCW  Jan. 11, 2011).
C 
C           Enforce constant track bit rate in a setup file.
C           This is also done later, but again we need it here.
C           This is only for groups whose format has already been set.
C
C            IF( .NOT. NEEDFMT(KS) ) THEN
C               IF( SETTBPS(ISETF) .NE. 0.0 .AND. 
C     1             SETTBPS(ISETF) .NE. TBPS(KS) ) THEN
C                  CALL WLOG( 1, 'FSPREAD: Track bit rate not ' //
C     1            'constant across setup groups in setup file:' )
C                  CALL WLOG( 1, '       ' // SETFILE(ISETF) )
C                  CALL ERRLOG( 'Fix the unequal rates.' )
C               ELSE IF( SETTBPS(ISETF) .EQ. 0.0 ) THEN
C                  SETTBPS(ISETF) = TBPS(KS)
C               END IF
C            END IF
C
C           Get the maximum total bit rate for the setup file and 
C           overall.  Use the nominal rates TOTBPS rather than the
C           format specific true bit rates WRTBPS.
C
            MAXFTOT(ISETF) = MAX( MAXFTOT(ISETF), TOTBPS(KS) )
            MAXTOT = MAX( MAXTOT, TOTBPS(KS) )
C
         END IF
      END DO
C
C     Now deal with the setup files.  Reuse SETTBPS.
C
      DO ISETF = 1, NSETF
         SETTBPS(ISETF) = 0.0
C
C        Moan if the setup groups are incompatible.  With equal
C        sample rates, I think this is hard, especially with the
C        checks already done.
C
         IF( TTBPS(ISETF) .LT. BTBPS(ISETF) ) THEN
            CALL WLOG( 1, 'FSPREAD: Cannot set all VLBA and MKIV ' //
     1         ' setup groups in a setup file to the same ' )
            CALL WLOG( 1, '         track bit rate.  This is ' //
     1                 'not allowed.' )
            CALL ERRLOG( ' The setup file is: ' // SETFILE(ISETF) )
         END IF
C
C        Set any formats in this setup file if we can, which is when
C        there is no remaining choice in track bit rate.  The obvious
C        case is when a setup has been forced.  But other cases
C        might arise when two setup groups have allowed ranges that
C        only overlap by one.
C
         IF( TTBPS(ISETF) .EQ. BTBPS(ISETF) ) THEN
            SETTBPS(ISETF) = TTBPS(ISETF)
            DO KS = 1, NSET
               IF( ISETF .EQ. ISETNUM(KS) .AND. VLBAMKIV(KS) .AND.
     1             RECUSED(KS) .AND. NEEDFMT(KS) ) THEN
                  TRKBPS = SETTBPS(ISETF)
                  CALL SETFMT( KS, TRKBPS, OK )
                  IF( OK ) NEEDFMT(KS) = .FALSE.
               END IF
            END DO
         END IF            
C
      END DO
C
C
C     Now try to get all setup files to use the same number of
C     tracks.  I've driven myself nuts trying to do this on a
C     per-station basis, but still enforcing constant track bit
C     rate per setup file and allowing some setups, either previously
C     set or still unset, to use fewer tracks than the rest.
C     So now, I will assume that all stations use the same number
C     of tracks.  Note that we haven't dropped the number of tracks
C     at single head/drive stations yet, so this approximation is
C     not that bad.  It is almost certainly possible to fool this
C     scheme using setup files for subsets of antennas, but I'll let
C     the user fix those by forcing TPMODE or FORMAT.
C
C     Determine the minimum number of tracks that the observation can
C     use (USETRK).  Hopefully this will end up being equal to the
C     number used by setups with preset formats, but it could
C     be larger.  It is not allowed to be smaller.  Larger is not 
C     good because tape will be wasted in the scans using the forced 
C     setups, so try to keep any excess to a minimum.
C     NTRACK is the number of tracks required to support preset 
C     formats.  MINSTRK is the minimum number required to support 
C     other setups at the maximum track bits per second allowed
C     for the setup file (TTBPS) (that should be the same or larger than
C     what would be derived using MINTRAK(KS) because of the way TTBPS
C     is derived).
C     
      MINSTRK = 0
      NTRACK = 0
      DO KS = 1, NSET
         ISETF = ISETNUM(KS)
         IF( RECUSED(KS) .AND. 
     1    ( VLBAMKIV(KS) .OR. FORMAT(KS) .EQ. 'MARKIII' ) ) THEN
            MINSTRK = MAX( MINSTRK, NINT( TOTBPS(KS) / TTBPS(ISETF) ) )
            IF( .NOT. NEEDFMT(KS) ) THEN
               NTRACK = MAX( NTRACK, NINT( TOTBPS(KS) / TBPS(KS) ) )
            END IF
         END IF
      END DO
      USETRK = MAX( NTRACK, MINSTRK )
C
C     If there were no forced setups, we can't do any more so jump
C     over the rest.
C
      IF( NTRACK .NE. 0 ) THEN      
C
C        Ok, we have something to force the choices.  Try it.
C        Simply set all setups to use USETRK or fewer tracks.
C        Only take the fewer option when absolutely necessary.
C        If SETTBPS is not zero, the setup has already been forced
C        if it can be and all forced setups have SETTBPS non zero.
C        MAXFTOT will only be non-zero if the setup file was used
C        in a recording scan and is of appropriate type.
C
         DO ISETF = 1, NSETF
            IF( SETTBPS(ISETF) .EQ. 0.0 ) THEN
               SETTBPS(ISETF) = MAXFTOT(ISETF) / USETRK
C
C              Sanity check and adjust if needed.  Note logic above
C              forces SETTBPS <= TTBPS so don't check that.
C
               IF( SETTBPS(ISETF) .NE. 0.0 .AND.
     1             SETTBPS(ISETF) .LT. BTBPS(ISETF) ) THEN
                  SETTBPS(ISETF) = BTBPS(ISETF)
                  CALL WLOG( 1, 'FSPREAD: Setup file below will ' //
     1               'use fewer tracks than other setups.' )
                  CALL WLOG( 1, '         Some tape will be ' //
     1               'wasted.' )
                  CALL WLOG( 1, '         File: '// SETFILE(ISETF) )
               END IF
            END IF
         END DO
C
C        Loop through setup groups forcing the formats
C
         DO KS = 1, NSET
            ISETF = ISETNUM(KS)
            IF( SETTBPS(ISETF) .NE. 0.0 .AND. NEEDFMT(KS) .AND.
     1          VLBAMKIV(KS) .AND. RECUSED(KS) ) THEN
               TRKBPS = SETTBPS(ISETF)
               CALL SETFMT( KS, TRKBPS, OK )
               IF( OK ) NEEDFMT(KS) = .FALSE.
            END IF
         END DO
C
      END IF
C
      RETURN
      END

C*ERROR -- print error message on stdout, and abort [Convex-UNIX]
C+
      SUBROUTINE ERROR(STRING)
      CHARACTER*(*) STRING
C
C This subroutine prints its argument (a character string) on the 
C standard output, prefixed with '++ERROR++', and then terminates 
C execution of the program, returning an error status to its parent
C (shell or command interpreter).
C
C Argument:
C  STRING (input)  : text of message
C
C Subroutines required:
C  EXIT
C  PUTOUT
C
C History:
C  1987 Apr 8 - TJP.
C  1996 May 31 - RCW.  Deal with f2c reluctance to concatenate strings
C                      declared with *(*).
C
      INTEGER        LEN1
      CHARACTER*133  MSG
C-----------------------------------------------------------------------
      MSG = STRING
      CALL PUTOUT('+++ERROR+++ '//MSG(1:LEN1(MSG)) )
      CALL EXIT(1)
C
      END

      SUBROUTINE SCNRANGE
C
C     Adjust the scan range (SCAN1 and SCANL) for the output scans 
C     from SCHED, other than the .sum file, to reflect the 
C     specifications of PREEMPT and DOSCANS.
C
C     Consider having a time range some day, but that needs more 
C     complicated input.
C
C     Moved from MAIN (sched.f) to keep that routine simple.
C
      INCLUDE   'sched.inc'
C
      INTEGER   CORE1, COREL, ISCN
      LOGICAL   GOTC1
C -----------------------------------------------------------------

      IF( DOSCANS(1) .NE. 0 .AND. DOSCANS(2) .NE. 0 ) THEN
         MSGTXT = ' ' 
         WRITE( MSGTXT, '( A, I5, A, I5, A  )' )
     1      'SCHED: --- DOSCANS given to restrict output to scans ',
     2      DOSCANS(1), ' to ', DOSCANS(2), ' ---'
         CALL WLOG( 1, ' ' )
         CALL WLOG( 1, MSGTXT )
         CALL WLOG( 1, '       --- This affects the .vex, .oms, '//
     1        'crd., sch., and .flag files ---' )
         CALL WLOG( 1, ' ' )
         SCAN1 = DOSCANS(1)
         SCANL = DOSCANS(2)
      ELSE IF( FUZZY ) THEN
         CORE1 = SCAN1
         COREL = SCAN1
         GOTC1 = .FALSE.
         DO ISCN = SCAN1, SCANL
            IF( .NOT. GOTC1 .AND. PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
               CORE1 = ISCN
               GOTC1 = .TRUE.
            END IF
            IF( PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
               COREL = ISCN
            END IF
         END DO
         CALL WLOG( 1, ' ' )
         CALL WLOG( 1, 'SCNRANGE: --- PREEMPT=EXTRA scans were '//
     1      'specified but no DOSCANS were given.      --- ' )
         MSGTXT = ' ' 
         IF( CORE1 .GT. SCAN1 .AND. COREL .LT. SCANL ) THEN
            WRITE( MSGTXT, '( A, I5, A, I5, A, I5, A, I5, A )' )
     1        '          --- EXTRA scans ', SCAN1, ' to ', CORE1-1, 
     2        ' and ', COREL, ' to ', SCANL, ' will not be written. ---'
         ELSE IF( CORE1 .GT. SCAN1 ) THEN
            WRITE( MSGTXT, '( A, I5, A, I5, A )' )
     1        '          --- EXTRA scans ', SCAN1, ' to ', CORE1-1, 
     2        ' will not be written. ---'
         ELSE
            WRITE( MSGTXT, '( A, I5, A, I5, A )' )
     1        '          --- EXTRA scans ', COREL, ' to ', SCANL, 
     2        ' will not be written. ---'
         END IF
         CALL WLOG( 1, MSGTXT )
         CALL WLOG( 1, '          --- This affects the .vex, .oms, '//
     1        'crd., sch., and .flag files           ---' )
         CALL WLOG( 1, ' ' )
         SCAN1 = CORE1
         SCANL = COREL
      END IF
C
      RETURN
      END

      SUBROUTINE sla_DJCL (DJM, IY, IM, ID, FD, J)
*+
*     - - - - -
*      D J C L
*     - - - - -
*
*  Modified Julian Date to Gregorian year, month, day,
*  and fraction of a day.
*
*  Given:
*     DJM      dp     modified Julian Date (JD-2400000.5)
*
*  Returned:
*     IY       int    year
*     IM       int    month
*     ID       int    day
*     FD       dp     fraction of day
*     J        int    status:
*                       0 = OK
*                      -1 = unacceptable date (before 4701BC March 1)
*
*  The algorithm is adapted from Hatcher 1984 (QJRAS 25, 53-55).
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DJM
      INTEGER IY,IM,ID
      DOUBLE PRECISION FD
      INTEGER J

      DOUBLE PRECISION F,D
      INTEGER JD,N4,ND10


*  Check if date is acceptable.
      IF ( DJM.LE.-2395520D0 .OR. DJM.GE.1D9 ) THEN
         J = -1
      ELSE
         J = 0

*     Separate day and fraction.
         F = MOD(DJM,1D0)
         IF (F.LT.0D0) F = F+1D0
         D = ANINT(DJM-F)

*     Express day in Gregorian calendar.
         JD = NINT(D)+2400001

         N4 = 4*(JD+((6*((4*JD-17918)/146097))/4+1)/2-37)
         ND10 = 10*(MOD(N4-237,1461)/4)+5

         IY = N4/1461-4712
         IM = MOD(ND10/306+2,12)+1
         ID = MOD(ND10,306)/10+1
         FD = F

         J=0

      END IF

      END

      SUBROUTINE SETFIRM
C
C     Routine called by SETDEF that sets DBE if needed.
C
C     This was separated from CHKFIRM on Oct 31, 2013 for logical
C     cleanliness in SCHED where I like to separate the settings
C     from the checking.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER   KS, KSTA
C ----------------------------------------------------------------
C
C     Loop over the setup files which are now one per station (after
C     SETEXPND).
C
      DO KS = 1, NSET
         KSTA = ISETSTA(KS)
C
C        Note that all VLBA stations (all RDBE stations?) will be
C        RDBE2.  Somewhere else, protect against using the PFB with
C        more than one RDBE.
C
         IF( DBE(KS) .EQ. ' ' ) THEN
C
C           For the RDBE, we need to choose PFB or DDC.  If the DDC
C           can do it, use that.  If not, use PFB.  That will be based
C           on the number of channels.  The PFB also depends on lots
C           of other restrictions too, but let the check routines 
C           deal with that.
C  
C           CR: DBBC defaults to DDC personality 
C
C           If none of the specific cases are met, assume we don't 
C           need DBE and leave it blank.
C
            IF( DAR(KSTA)(1:4) .EQ. 'RDBE' .AND. NCHAN(KS) .GT. 8 ) THEN
               DBE(KS) = 'RDBE_PFB'
            ELSE IF( DAR(KSTA)(1:4) .EQ. 'RDBE' ) THEN
               DBE(KS) = 'RDBE_DDC'
            ELSE IF( DAR(KSTA) .EQ. 'DBBC' ) THEN
               DBE(KS) = 'DBBC_DDC'
            ELSE IF( DAR(KSTA) .EQ. 'WIDAR' ) THEN
               DBE(KS) = 'WIDAR'
            END IF
         END IF
      END DO
      RETURN
      END

      SUBROUTINE VXFQVX
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 020596 
C     Sets up a few basic features for FQ and PH section
C     to be indexed by VEX internal def section, 
C     rather than through SCHED SETs in order to enable scan by scan 
C     changes of frequency and phase cal.
C     Updated for 1.5 240796, Huib
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER   IIF, IFQ, IPH, KS, ISIDE1, ICH
      CHARACTER UPCAL*4
C ----------------------------------------------------------------------
C
      WRITE( MSGTXT, '( A )' ) 
     1    'VXFQVX: Start digesting frequency and phasecal links '
      IF( DEBUG ) CALL WLOG( 1, MSGTXT )
C
C     set phasecal in numerical variable for all IF sections
C
      DO IIF = 1, NIFVEX
         KS = IFISSET(IIF)
         UPCAL = SPCAL(KS)
         CALL UPCASE(UPCAL)
         IF( UPCAL .EQ. 'OFF' ) THEN
            TONEINT(IIF) = 0.
         ELSE IF( UPCAL .EQ. '1MHZ' ) THEN 
            TONEINT(IIF) = 1.
         ELSE IF( UPCAL .EQ. '5MHZ' ) THEN
            TONEINT(IIF) = 5.D0
         ELSE IF( UPCAL .EQ. ' ' ) THEN
            TONEINT(IIF) = 1.
         ELSE 
            CALL ERRLOG( 'VXFQVX: Invalid PCAL: '//SPCAL(KS)//
     1           ' - Must be 1MHz, 5MHz, or off.' )
         END IF      
      END DO
C     
C     Need to find a few things for each FQ
C
      DO IFQ = 1, NFQVEX
         KS = FQISSET(IFQ)
         NVXCHN(IFQ) = NCHAN(KS)
         DO ICH = 1, NCHAN(KS)
            IF( SIDE1(ICH,KS) .EQ. 'U' ) THEN
               ISIDE1 = 1
            ELSE IF( SIDE1(ICH,KS) .EQ. 'L' ) THEN
               ISIDE1 = -1
            ELSE
               CALL ERRLOG('VXFQVX: First LO sideband problem.' )
            END IF
            VXLOSUM(ICH,IFQ) = FIRSTLO(ICH,KS) + ISIDE1 * BBSYN(ICH,KS)
            VXNETSID(ICH,IFQ) = NETSIDE(ICH,KS)
            VXBBFILT(ICH,IFQ) = BBFILT(ICH,KS)
         END DO
      END DO
C
C     For PH need to know whether will detect or not 
C
      DO IPH = 1, NPHVEX
         KS = PHISSET(IPH)
         UPCAL = SPCAL(KS)
         CALL UPCASE(UPCAL)
         IF( UPCAL .EQ. 'OFF' ) THEN
            DODETECT(IPH) = .FALSE.
         ELSE IF( UPCAL .EQ. '1MHZ' ) THEN 
            DODETECT(IPH) = .TRUE.
         ELSE IF( UPCAL .EQ. '5MHZ' ) THEN
            DODETECT(IPH) = .TRUE.
         ELSE IF( UPCAL .EQ. ' ' ) THEN
            DODETECT(IPH) = .TRUE.
         ELSE 
            CALL ERRLOG( 'VXFQVX: Invalid PCAL: '//SPCAL(KS)//
     1           ' - Must be 1MHz, 5MHz, or off.' )
         END IF      
C
      END DO
      RETURN
      END

      SUBROUTINE VXWRPH
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the PH = $PHASE_CAL section 
C     By H.J. van Langevelde, JIVE, 300496 
C     Updated for 1.4, 240796
C
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C      
      INTEGER   IPH, ICH, KS, IP, LPOS
      INTEGER   LEN1
      CHARACTER LINE*132
C ----------------------------------------------------------------------
C
      LINE = ' ' 
C
C     write PHASE_CAL section
C         
      WRITE( IVEX, '( A, A1 )' ) '$PHASE_CAL_DETECT', SEP     
      DO IPH = 1, NPHVEX
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1        PHLINK(IPH)(1:LEN1(PHLINK(IPH))), SEP      
         CALL VXSTLI( IPH, NSTAPH, ISTAPH )
         KS = PHISSET(IPH)
C
C        write the tone numbers!
C
         IF( DODETECT(IPH) ) THEN
            DO ICH = 1, NTONES(IPH)
               WRITE( LINE(1:), '( 5X, A, A1, A5 )' )
     1             'phase_cal_detect = ', LNK, TONLNK(ICH,IPH)
               DO IP = 1, NTONDET(ICH, IPH)
                  LPOS = LEN1(LINE)+1
                  WRITE( LINE(LPOS:LPOS+4), '( 1X, A1, I3 )' ) COL, 
     1                ITONDET(IP, ICH,IPH)
               END DO
               LPOS = LEN1(LINE)+1
               WRITE( LINE(LPOS:LPOS), '( A1 )' ) SEP
               WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))              
            END DO
         ELSE
            WRITE( IVEX, '( 5X, A, A1, A5, A1 )' ) 
     1          'phase_cal_detect = ', LNK, TONLNK(1,IPH), SEP
         END IF
C
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
      ENDDO
      WRITE( IVEX, '( A )' ) COMLIN
      RETURN
      END

      SUBROUTINE MTALTAZ( KSTA, UP, SAZ, SEL, TAZ, TEL )
C
C     Mount type specific for SCHED for ALTAZ antennas that
C     Tests limits to see if source is up at requested position 
C     of SAZ and SEL and, if not, tells where it will actually 
C     be (TAZ, TEL).
C
C     KSTA is the station number in the station catalog.
C     SAZ and SEL are the requested AZ and EL.
C     TAZ and TEL are the actual AZ and EL.
C     UP is a single character.
C
C     Subroutine WRAP finds where in AZ the antenna should be for
C     ALTAZ antennas.  It will assure that the Az is above the
C     lower azimuth limit.  Test here if it is above just in case
C     or the weird case of an antenna with an AZ range of less than
C     360 degrees.
C
      INCLUDE 'sched.inc'
C
      INTEGER           KSTA
      REAL              SAZ, SEL, TAZ, TEL
      CHARACTER*1       UP
C ------------------------------------------------------------------
C     Complain if limits not given.
C
      IF( NAXLIM(KSTA) .NE. 1 ) THEN
         CALL ERRLOG( 'MTALTAZ: Need 1 and only 1 set of axis limits'//
     1     ' for '//STATION(KSTA) )
      END IF
C
C     Set up as if source up, then change if down.
C
      UP = ' '
      TAZ = SAZ
      TEL = SEL
C
C     Elevation limits:
C
      IF( SEL .LT. AX2LIM(1,KSTA) ) THEN
         UP = 'D'
         TEL = AX2LIM(1,KSTA)
      ELSE IF( SEL .GT. AX2LIM(2,KSTA) ) THEN
         UP = 'D'
         TEL = AX2LIM(2,KSTA)
      END IF        
C
C     Azimuth limit (WRAP insured we are above lower limit).
C
      IF( SAZ .GT. AX1LIM(2,KSTA) ) THEN
         UP = 'D'
         TAZ = AX1LIM(2,KSTA)
      END IF
C
C     Check the zenith angle limit.  Don't assume that the antenna
C     will be here - it will probably be at the AX2LIM(1,KSTA)
C
      IF( 90.0 - SEL .GT. ZALIM(KSTA) ) THEN
         UP = 'D'
      END IF
C
      RETURN
      END

      SUBROUTINE VLBADK( ISCN, ISTA, SETSC )
C
C     Routine for SCHED to write disk commands into telescope 
C     schedule.  This is pretty simple so far.  Let's hope it 
C     stays that way, but put it here to keep it isolated.
C
C     SETSC indicates this is a setup scan.  It is hardwired in
C     the calling routine vlba.f in each of the 2 calls.
C
      INCLUDE  'sched.inc'
      INCLUDE   'schset.inc'
      INTEGER  ISCN, ISTA, KS
      LOGICAL  SETSC
C ---------------------------------------------------------------------
C     Write disk=on if recording, else disk=off.  Assume FORMAT=NONE
C     means not recording.  That might happen without NOREC for 
C     RDBE schedules where the recording is happening outside the 
C     control of the crd files.
C
C
      KS = NSETUP(ISCN,ISTA)
      IF( USEDISK(ISTA) ) THEN
         IF( NOREC(ISCN) .OR. SETSC .OR. FORMAT(KS) .EQ. 'NONE' .OR.
     1       ( DAR(STANUM(ISTA))(1:4) .EQ. 'RDBE' .AND. 
     2       .NOT. DOMKA ) ) THEN
            WRITE( IUVBA, '( A )' ) 'disk=off'
         ELSE
            WRITE( IUVBA, '( A )' ) 'disk=on'
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE VXTRAMD(IMODE,IFS)
      IMPLICIT NONE
C
C     Make a new mode, NMDVEX.  Called by VXSCNS when it encounters
C     a need for a mode because of FREQ, BW, PCAL.
C     IMODE is the current VEX mode template, IFS (and IPS before pcal
C     sets were removed) is the augmenting freq set for one of the 
C     stations needing the new mode.
C     RCW Oct. 15, 2011.  Adding some comments while debugging 
C     transfer of incorrect setup data (sideband this time) from setup file.
C     RCW Sep. 10, 2013.  Removing pulse cal sets.  They have been merged
C     with the frequency sets.  Make case of PulseCal name portion from
C     the frequency set upper case for consistency with old files.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'       
C
      INTEGER ISCN, ICH, ISET, ISETFL, IMODE, I, IP, IFS
      INTEGER IFQ, IPH, IIF
      INTEGER ISTA, NTMP, TTMPCHN(MAXCHN), IXX
      INTEGER NTONTMP(MAXCHN), ITONTMP(MAXTON,MAXCHN)
      INTEGER NPER, NFC1, NFCN, LEN1, LPOS
      REAL    PHTONE
      LOGICAL MATCHPH
      CHARACTER NAME*32, UPCAL*4, FRTXT*16
C
C     Setup the necessary pointers
C *********************************************************************
C  This gets into trouble because these really need to be station
C  dependent when they are used to pass parameters - certainly parameters
C  that might vary by station.  I have fixed the use of IFQ in VXTRAFQ,
C  but these other parameters should also be dealt with in this routine.
C  I don't have time to deal with them now.  That means that the tone
C  specifications, in particular, may be wrong at least with sideband
C  inversion.  RCW  Oct. 16, 2011.
C *********************************************************************
C
      IFQ = IMODFQ(1,IMODE)
      IPH = IMODPH(1,IMODE)
      IIF = IMODIF(1,IMODE)
C
C     New MD increase numbers
C
      NMDVEX = NMDVEX + 1
      IF( NMDVEX .GT. MAXMOD ) CALL ERRLOG(
     1    'VXSCNS: Number of $MODE defs '//
     2    'exceeding MAXMOD aray size...')
C
C     The reference to the original set will be 
C     used for samprate, number of bits etc.
C
      ISCN = FSETSCN(IFS)
      ISETFL = SETNUM(ISCN)
      MDISFIL(NMDVEX) = ISETFL
C
C     Need first of the ISET SETUPS that is valid for this scan
C
      ISET = -1
      DO ISTA = 1, NSTA
         IF( STASCN(ISCN,ISTA) ) THEN
            ISET = NSETUP(ISCN,ISTA)
            GOTO 100
         END IF
      END DO
      IF( ISET .LT. 0 ) CALL ERRLOG('VXTRAMD: Scan not observed')
  100 CONTINUE
C     
C     And name the mode, currently nothing special
C
      NAME = ' '
      IF( FREQ(1,ISCN) .GT. 1E-6 ) THEN
         IF( .NOT. DOPCAL(ISCN) ) THEN
            NAME(1:10) = 'SwitchFreq'
            NPER=7
            CALL FRCHAR( FREQ(1,ISCN), NPER, NFC1, NFCN, FRTXT )
            WRITE( NAME(11:25), '(A)' ) FRTXT(NFC1:NFCN)
            LPOS = LEN1( NAME ) + 1
            WRITE( NAME(LPOS:LPOS+2), '(A)' ) 'MHz'
         ELSE
            NAME(1:8) = 'Doppler@'
            WRITE( NAME(9:20), '( A12 )' ) DOPSRC(ISCN)
         END IF
      ELSE
         IF( BW(1,ISCN) .GT. 1E-6 ) THEN
            NAME(1:8) = 'SwitchBW'
            IF( BW(1,ISCN) .LT. 1.0 ) THEN
               WRITE( NAME(9:14), '( I3, A3 )' ) 
     1             NINT( 1E3 * BW(1,ISCN)), 'kHz'
            ELSE IF (BW(1,ISCN) .GT. 10.0 ) THEN
               WRITE( NAME(9:16), '( F5.2, A3 )' ) BW(1,ISCN), 'MHz'
            ELSE
               WRITE( NAME(9:15), '( F4.2, A3 )' ) BW(1,ISCN), 'MHz'
            END IF
         ELSE
            NAME(1:8) = 'PulseCal'
            UPCAL = FSPCAL(IFS)
            CALL UPCASE( UPCAL )
            WRITE( NAME(9:12), '( A4 )' ) UPCAL
         END IF
      END IF
      MDLINK(NMDVEX) = NAME
      CALL VXUNQL( NMDVEX, MDLINK )
C
      IF( DEBUG ) THEN 
         WRITE( MSGTXT, '( A, A, A )' )
     1       'VXSCNS (VXTRAMD): Mode change in schedule',
     2       ', inserted $MODE:', MDLINK(NMDVEX)
         CALL WLOG( 1, MSGTXT )
      END IF
C
C     Always call new FQ (can be multiple now) 
C
C     IFQ is set above to be  IFQ = IMODFQ(1,IMODE). IMODFQ is the list of 
C     FQ blocks in IMODE.  VXTRAFQ takes a number of parameters from the 
C     IFQ entry.  But IMODFQ is station dependent.  Only using the first 
C     one causes wrong parameters to be passed.  In particular, the wrong 
C     netsideband is passed when correlator sideband inversion is used.  
C     This has to be fixed in VXTRAFQ inside the loop through FQ blocks.  
C     This is a problem was found in testing with egrdbe2.key in the TEST 
C     area, which includes GBT at K band with a sideband inversion, plus 
C     a FREQ spec part way through (would do the same if using Doppler).
C     So I modified VXTRAFQ to not use the IFQ from the call.  RCW
C     Oct 16, 2011.
C 
      CALL VXTRAFQ(ISCN, NMDVEX, IMODE, IFQ)
C     
C     Copy other links to this new MODE
C
      NMODBB(NMDVEX) = NMODBB(IMODE)
      DO I = 1, NMODBB(NMDVEX)
         IMODBB(I,NMDVEX) = IMODBB(I,IMODE)
         IXX = IMODBB(I,NMDVEX)
         NSTABB(IXX,NMDVEX) = NSTABB(IXX,IMODE)
         DO ISTA = 1, NSTABB(IXX,NMDVEX)
            ISTABB(ISTA,IXX,NMDVEX) = ISTABB(ISTA,IXX,IMODE)
         ENDDO
      END DO 
C     
      NMODTR(NMDVEX) = NMODTR(IMODE)
      DO I = 1, NMODTR(NMDVEX)
         IMODTR(I,NMDVEX) = IMODTR(I,IMODE)
         IXX = IMODTR(I,NMDVEX)
         NSTATR(IXX,NMDVEX) = NSTATR(IXX,IMODE)
         DO ISTA = 1, NSTATR(IXX,NMDVEX)
            ISTATR(ISTA,IXX,NMDVEX) = ISTATR(ISTA,IXX,IMODE)
         ENDDO
      END DO
C
      NMODHP(NMDVEX) = NMODHP(IMODE)
      DO I = 1, NMODHP(NMDVEX)
         IMODHP(I,NMDVEX) = IMODHP(I,IMODE)
         IXX = IMODHP(I,NMDVEX)
         NSTAHP(IXX,NMDVEX) = NSTAHP(IXX,IMODE)
         DO ISTA = 1, NSTAHP(IXX,NMDVEX)
            ISTAHP(ISTA,IXX,NMDVEX) = ISTAHP(ISTA,IXX,IMODE)
         ENDDO
      END DO
C     
      NMODPO(NMDVEX) = NMODPO(IMODE)
      DO I = 1, NMODPO(NMDVEX)
         IMODPO(I,NMDVEX) = IMODPO(I,IMODE)
         IXX = IMODPO(I,NMDVEX)
         NSTAPO(IXX,NMDVEX) = NSTAPO(IXX,IMODE)
         DO ISTA = 1, NSTAPO(IXX,NMDVEX)
            ISTAPO(ISTA,IXX,NMDVEX) = ISTAPO(ISTA,IXX,IMODE)
         ENDDO
      END DO
C     
      NMODRL(NMDVEX) = NMODRL(IMODE)
      DO I = 1, NMODRL(NMDVEX)
         IMODRL(I,NMDVEX) = IMODRL(I,IMODE)
         IXX = IMODRL(I,NMDVEX)
         NSTARL(IXX,NMDVEX) = NSTARL(IXX,IMODE)
         DO ISTA = 1, NSTARL(IXX,NMDVEX)
            ISTARL(ISTA,IXX,NMDVEX) = ISTARL(ISTA,IXX,IMODE)
         ENDDO
      END DO
C
C     Phase cal is complex, tones may change because
C     PHASECAL because of a FREQ change.
C     Calculate where the tones come in.
C     Update UPCAL - might not have been set before.
C
      UPCAL = FSPCAL(IFS)
      CALL UPCASE(UPCAL)
      IF( UPCAL .EQ. 'OFF' ) THEN
         PHTONE = 0.
      ELSE IF( UPCAL .EQ. ' ' ) THEN
         PHTONE = 1.
      ELSE IF( UPCAL .EQ. '1MHZ' ) THEN 
         PHTONE = 1.
      ELSE IF( UPCAL .EQ. '5MHZ' ) THEN
         PHTONE = 5.0
      ELSE 
         CALL ERRLOG( 'VXSCNS: Invalid PCAL: '
     1       //FSPCAL(IFS)//
     1       ' - Must be 1MHz, 5MHz, or off.' )
      END IF   
      CALL VXTON2( -1, ISET, NVXCHN(NFQVEX), 
     1    VXLOSUM(1,IFQ), 
     1    VXNETSID(1,NFQVEX), VXBBFILT(1,NFQVEX), 
     2    PHTONE, NTMP, TTMPCHN,
     3    NTONTMP, ITONTMP )
C     
C     check for change
C
      MATCHPH = PHTONE .EQ. TONEINT(IIF)
C     
C     with tones off, it doesn't matter where they go
C     
      IF( PHTONE .GT. 1E-3 ) THEN
         IF( NTMP .NE. NTONES(IPH) ) THEN 
            MATCHPH = .FALSE.
         ELSE
            DO ICH = 1, NTMP
               IF( NTONDET(ICH, IPH).NE.NTONTMP(ICH)) 
     1             THEN 
                  MATCHPH = .FALSE.
               ELSE
                  DO IP = 1, NTONDET(ICH,IPH)
                     IF( ITONDET(IP, ICH, IPH) .NE.
     1                   ITONTMP(IP, ICH) ) 
     2                   MATCHPH = .FALSE.
                  END DO
               END IF
            END DO
         END IF
      END IF
C     
C     So if this has remained the same it is easy
C     
      IF( MATCHPH ) THEN
C
C     Copy PH and IF def into the new MODE
C     CR 7 Oct 2004: fixed a horrible bug here in the indexing for
C       NSTAIF and NSTAPH (cf difference between IXX and I below)
C
         NMODIF(NMDVEX) = NMODIF(IMODE)
         DO I = 1, NMODIF(NMDVEX)
            IXX = IMODIF (I, IMODE)
            IMODIF(I,NMDVEX) = IMODIF(I,IMODE)
            NSTAIF(IXX,NMDVEX) = NSTAIF(IXX,IMODE)
            DO ISTA = 1, NSTAIF(IXX,IMODE)
               ISTAIF(ISTA,IXX,NMDVEX) = 
     1             ISTAIF(ISTA,IXX,IMODE)
            END DO
         END DO
C     
         NMODPH(NMDVEX) = NMODPH(IMODE)
         DO I = 1, NMODPH(NMDVEX)
            IXX = IMODPH (I, IMODE)
            IMODPH(I,NMDVEX) = IMODPH(I,IMODE)
            NSTAPH(IXX,NMDVEX) = NSTAPH(IXX,IMODE)
            DO ISTA = 1, NSTAPH(IXX,IMODE)
               ISTAPH(ISTA,IXX,NMDVEX) = 
     1             ISTAPH(ISTA,IXX,IMODE)
            END DO
         END DO
      ELSE
C     
C        carefully setup new modes
C
         CALL VXTRAPH( ISCN, NMDVEX, IMODE, PHTONE,
     1       NTMP, NTONTMP, ITONTMP )
C     
C        done inventing new PH 
C        do same for IF section
C     
         CALL VXTRAIF( ISCN, NMDVEX, IMODE, PHTONE )

C         
      END IF
C
      RETURN
      END

      SUBROUTINE GEOXYZ( MODE, LONG, LAT, HT, X, Y, Z, IER )
C
C     Routine to make conversions between geodetic and geocentric
C     coordinates.  There are two modes:
C       MODE=0:   Input data are longitude, latitude and height,
C                 either goecentric or geodetic (height < 1E6)
C                 Output data are geodetic long, lat, and ht and
C                 geocentric X, Y, and Z.
C       MODE=1:   Input data are geocentric X, Y, and Z.
C                 Output data are geodetic long, lat, and height
C                 above the geoid.
C
C       IER is a return code.  0 => ok.  1 => bad mode.
C       
C     All input variables are double precision.  Longitude and
C     latitude are in radians.  HT, X, Y, and Z are in meters.
C
C     Algorithms from the 1992 Astronomical Almanac Explanatory
C     Supplement, Chapter 4, are used.  The IERS 1989 ellipsoid
C     is used (Semi-major axis and inverse flattening).
C
C     Note that the sign of longitude is backwards from a right
C     handed coordinate system.
C
C     On 29 Jan 2002, I tried some tests against Web conversion sites.
C     The equations here clearly apply to WGS84
C     There is an example at http://www.anzlic.org.au/icsm/gdatm/xyzcd.htm
C       An australian site.
C     For 
C     station=TEST     elev=737.574 lat=-37:39:10.1598 long=143:55:35.3730 
C     Sched gets with      SMAXIX=6378136.D0 and FLATEN=1.D0/298.257D0
C       SCHED:         -4087094.75 -2977467.03 -3875456.72 
C     The web site uses XMAXIX=6378137.D0 and FLATTEN=1.D0/298.25722210
C       Web example    -4087095.384 2977467.494 -3875457.340
C     Change this code to  SMAXIS=6378137.D0 FLATEN=1.D0/298.257D0
C       SCHED:         -4087095.39 -2977467.50 -3875457.32 
C     This now agrees at the 1cm level.  Try for other opinions on A and 1/f
C     At a laser site at gsfc, 6378136.3 and 298.257
C     At a USNO site, 6378137  298.257222101
C     In the WGSMAN24.PDF document that I have in my geodesy area, 
C     the values are 6378137  298.257223563.  This is a European document.
C     Modify 1/f to the USNO site value.
C     SCHED (6378137  298.257222101)  -4087095.39 -2977467.49 -3875457.34  
C     This agrees with the Ausi site to under a cm.
C     From NIMA, which Bryan Butler figures is the best reference, the
C     values to use are  6378137  298.257223563 - same as the European site.
C     So now install those values.
C
C     R. C. Walker
C
      INTEGER           MODE, IER
Cf2py intent(out) IER
      DOUBLE PRECISION  LONG, LAT, HT, X, Y, Z
Cf2py intent(in, out) LONG
Cf2py intent(in, out) LAT
Cf2py intent(in, out) HT
Cf2py intent(in, out) X
Cf2py intent(in, out) Y
Cf2py intent(in, out) Z
      DOUBLE PRECISION  SMAXIS, FLATEN, C, S
      PARAMETER         (SMAXIS=6378137.D0)
      PARAMETER         (FLATEN=1.D0/298.257223563D0)
      DOUBLE PRECISION  SLAT, CLAT, SLONG, CLONG
      DOUBLE PRECISION  B, R, E, F, P, Q, D, NU, G, T, PI
      LOGICAL           MAKEGD
C ----------------------------------------------------------------
      PI = DATAN( 1.0D0 ) * 4.D0
      MAKEGD = MODE .EQ. 1
      IER = 1
      IF( MODE .EQ. 0 ) THEN
C
C        Input is long, lat, and ht of some sort.
C
         IF( HT .LT. 1.D6 ) THEN
C
C           Input coordinates are geodetic long, lat, ht.
C
            SLAT = DSIN( LAT )
            CLAT = DCOS( LAT )
            SLONG = DSIN( -LONG )
            CLONG = DCOS( -LONG )
            C = CLAT**2 + ( 1.D0 - FLATEN )**2 * SLAT**2
            C = 1.D0 / SQRT( C )
            S = ( 1.D0 - FLATEN )**2 * C
            X = ( SMAXIS * C + HT ) * CLAT * CLONG
            Y = ( SMAXIS * C + HT ) * CLAT * SLONG
            Z = ( SMAXIS * S + HT ) * SLAT
            IER = 0

         ELSE
C
C           Input coordinates are geocentric long, lat, ht.
C           Derive X, Y, and Z.  Then convert angles to 
C           geodetic in section for data starting with X, Y, Z.
C
            X = HT * COS( LAT ) * COS( -LONG )
            Y = HT * COS( LAT ) * SIN( -LONG )
            Z = HT * SIN( LAT )
            MAKEGD = .TRUE.
         END IF
      END IF
C
C     Now do any required geocentric to geodetic conversion.
C
      IF( MAKEGD ) THEN
         R = SQRT( X**2 + Y**2 )
C
C        Deal with singular cases.
C
         IF( Z .EQ. 0.D0 .AND. R .NE. 0.D0 ) THEN
C
C           On equitorial plane.
C
            LAT = 0.D0
            LONG = -DATAN2( Y, X )
            HT = SQRT( X**2 + Y**2 ) - SMAXIS
C
         ELSE IF( R .EQ. 0.D0 .AND. Z .NE. 0.D0 ) THEN
C
C           On Z axis.
C
            LAT = DSIGN( PI / 2.D0, Z )
            LONG = 0.D0
            HT = Z - SMAXIS * ( 1.D0 - FLATEN )
C
         ELSE IF( R .EQ. 0.D0 .AND. Z .EQ. 0.D0 ) THEN
C
C           Center of earth.
C
            LAT = 0.D0
            LONG = 0.D0
            HT = -SMAXIS
         ELSE
C
C           Reasonable range.
C
            B = DSIGN( SMAXIS * ( 1.D0 - FLATEN ), Z )
            E = ( B * Z - ( SMAXIS**2 - B**2 ) ) / ( SMAXIS * R )
            F = ( B * Z + ( SMAXIS**2 - B**2 ) ) / ( SMAXIS * R )
            P = ( 4.0D0 / 3.0D0 ) * ( E * F + 1.D0 )
            Q = 2.D0 * ( E**2 - F**2 )
            D = P**3 + Q**2
            IF( D .LT. 0.D0 ) THEN
               NU = 2.D0 * SQRT( -P ) * COS( (1.D0/3.D0) *
     1              ACOS( Q / ( P * SQRT( -P ) ) ) )
            ELSE
               NU = ( SQRT( D ) - Q )**(1.D0/3.D0) - 
     1              ( SQRT( D ) + Q )**(1.D0/3.D0)
            END IF
C
C           Deal with cases near singularities as per Almanac.
C           The criteria are a wild guess.
C
            IF( Z .LT. SMAXIS / 1.D5 .OR. R .LT. SMAXIS / 1.D5 ) THEN
               NU = (-1.D0) * ( NU**3 + 2.D0 * Q ) / ( 3.D0 * P )
            END IF
            G = 0.5D0 * ( SQRT( E**2 + NU ) + E )
            T = SQRT( G**2 + ( F - NU * G ) / ( 2.D0 * G - E ) ) - G
            LAT = DATAN( SMAXIS * ( 1.D0 - T**2 ) / ( 2.D0 * B * T ) )
            HT = ( R - SMAXIS * T ) * COS( LAT ) + 
     1           ( Z - B ) * SIN( LAT )
            LONG = -DATAN2( Y, X )
         END IF
         IER = 0
      END IF
C
      RETURN
      END

      SUBROUTINE STAFRD( ISCN, ISTA, IE, DFRDX, DFRDY, DDELDX, DDELDY )
C
C     This looks like "projectus interruptus".  It is not called from
C     anywhere that I found in a quick look in Feb. 2010 and was last
C     modified in 2008.  So keep it here in case I remember what was
C     up, but don't worry about it.
C
C     Subroutine calculate the numbers for plotting the residual
C     fringe rates and delays from 1 arcsecond offsets in X and Y.
C
C     The results here might be thought of as for a baseline from the
C     center of the Earth to the station.  Actual baseline parameters
C     can be calculated from differences.
C
C     IE specifies which end of the scan to process.
C
C     Updated the FSFREQ call Aug. 30, 2013 RCW
C         Also dealt with MCHAN rather than MAXCHN in some declared.
C         MCHAN comes from schset.inc which isn't invoked, but it is
C         set equal to MAXCHN (from sched.inc) in schset.inc.  Just
C         use MAXCHN here.
C
      INCLUDE 'sched.inc'
C
      INTEGER     ISCN, ISTA, CATSTA, CATSRC, KF, IE
      REAL        U
C use commented out     REAL        V
      REAL        HAR, CH, SH, CD, SD, UXY
      DOUBLE PRECISION  BBCFREQ(MAXCHN), BBCBW(MAXCHN), FRQ
      REAL        DFRDX, DFRDY, DDELDX, DDELDY
      LOGICAL     WARNFQ
      DOUBLE PRECISION  LOSUM(MAXCHN)
      INTEGER            CRDN, CRSETC(MAXCHN)
      DOUBLE PRECISION   CRDF(MAXCHN), CRDB(MAXCHN), CRDLOSUM(MAXCHN)
      CHARACTER          CRDS(MAXCHN)*1
C
C     OMEGA is the rotation rate of the Earth in radians per second.
C
      REAL        OMEGA, C, CONST
      PARAMETER   ( OMEGA = 7.2722052E-5 )
      PARAMETER   ( C = 2.99792458E8 )
      DATA        WARNFQ / .TRUE. /
C -------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'STAFRD starting ' )
C
C     Get the frequency.  Use the first channel.
C
      KF = FSETI( ISCN, ISTA )
      IF( KF .EQ. 0 .OR. NOSET ) THEN
         FRQ = 22200.0
         IF( WARNFQ ) THEN
            CALL WLOG( 1, 'STAFRD:  No setup, using 22.2 '//
     1                'GHz for fringe rate plot.' )
         END IF
         WARNFQ = .FALSE.
      ELSE
         CALL FSFREQ( KF, LOSUM, BBCFREQ, BBCBW,
     1         CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC )
         FRQ = LOSUM(1)
      END IF
C
C     Get station number in catalog.
C
      CATSTA = STANUM(ISTA)
      CATSRC = SRCNUM(ISCN)
C
C     Get the trig terms.
C
      IF( IE .EQ. 1 ) THEN
         HAR = HA1(ISCN,ISTA) * RADHR
      ELSE IF( IE .EQ. 2 ) THEN
         HAR = HA2(ISCN,ISTA) * RADHR
      ELSE
         CALL ERRLOG( 'Bad end parameter in STAFRD.  Need 1 or 2.' )
      END IF
      CD = COS( DECP(CATSRC) )
      SD = SIN( DECP(CATSRC) )
      UXY = SQRT( XPOS(CATSTA)**2 + YPOS(CATSTA)**2 )
      CH = COS( HAR )
      SH = SIN( HAR )
      U =  (-UXY) * SH / 1000.0 
C      V = ( ZPOS(CATSTA) * CD - UXY * SD * CH ) / 1000.0
C
C     Now get the fringe rate derivatives.
C     Note DFRDX = CONST * CD * CH / CD where one CD deals with
C     projection and the other deals with the difference between
C     an offset on the sky and the corresponding change in RA.
C     FR = -1.0 * UXY * SH * CD * FRQ * 1.E6 / C = -1.0 * CONST * SH * CD
C     DEL = -1.0 * ZPOS * SD + UXY * CD * CH
C     The sign convention is to be determined.
C
      CONST = 1000.0 * (RADDEG/3600.0) * UXY * OMEGA * FRQ * 1.E6 / C
      DFRDX = -1.0 * CONST * CH
      DFRDY = CONST * SD * SH
C
C     Next delay.  Note that there is are CDs that cancel in DELDX
C     as in DFRDX.
C
      CONST = 1.0E9 * RADDEG / ( 3600.0 * C )
      DDELDX = CONST * ( -1.0 * UXY * SH )
      DDELDY = CONST * ( -1.0 * ZPOS(CATSTA) * CD + UXY * SD * CD )
C
C     debug printout.
C
C      write(*,'(A,3I6,E10.3,4F10.3)') ' stafrd ', ista, iscn, kf, uxy,
C     1     dfrdx, dfrdy, ddeldx, ddeldy
C
      RETURN
      END

      SUBROUTINE OPTSKD( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
Cf2py intent(in) LASTISCN, KSCN, ISCN
Cf2py intent(out) ADJUST, KEEP, DONE
C
C     Routine for optimization mode of sched that decides what to
C     do with the next input scan.  It is used for OPTMODE=SCANS.
C     It will not decide to leave it out of the list, so it is
C     not necessary to create a new scan list.  But it may flag the
C     scan not to be used, which the rest of SCHED understands.  It
C     does that by setting all STASCN entries .FALSE.
C
C
      INCLUDE 'sched.inc'
C
      INTEGER           LASTISCN(MAXSTA), KSCN, ISCN
      LOGICAL           KEEP, ADJUST, DONE
C
      INTEGER           NGOOD, NPRIO, SKIP(MAXSRC), ISTA, ISRC
      INTEGER           MISSED
      DOUBLE PRECISION  TAPPROX, TBEGIN, T_AVAIL, LASTTIME
      LOGICAL           OKSTA(MAXSTA)
      SAVE              SKIP, MISSED
C ---------------------------------------------------------------------
      DONE = .FALSE.
C
C     KSCN is the count of input scans for this optimization mode.
C     Quit when all have been processed.
C
      IF( KSCN .GT. NSCANS ) THEN
         DONE = .TRUE.
         GO TO 999
      END IF
C
C     Copy the input scan to the output if necessary.
C
      IF( KSCN .NE. ISCN ) THEN
         CALL SCNDUP( ISCN, KSCN, .TRUE., 'OPTSKD' )
      END IF
C
C     Determine whether to use input scan time.  Only do this for
C     scans for which no fixed time was specified (used DUR or DWELL
C     so DURONLY = 1).  By this rule, the first scan will keep
C     it's start time.  (The old version also allowed adjustments
C     if just the stop time was specified).
C
      ADJUST = DURONLY(ISCN) .EQ. 1 
C
C     Initialize stuff for skipping scans - the mode initialized
C     with OPSKIP.  This causes a source to be skipped OPSKIP times 
C     before it is used.  If it is in a favored elevation window,
C     set by OPELPRIO, every pass will be taken.  Initialize SKIP
C     so a source is taken the first pass.
C     Also initialize the counter of missed scans.
C
      IF( ISCN .EQ. 1 ) THEN
         DO ISRC = 1, MAXSRC
            SKIP(ISRC) = OPSKIP
         END DO
         MISSED = 0
      END IF
C
C     Get the time for which to do the geometric calculations.
C
      IF( .NOT. ADJUST ) THEN
C
C        If the times are not going to be adjusted, use the start
C        time of the scan.
C
         TAPPROX = STARTJ(ISCN)
C
      ELSE
C
C        Otherwise, get the most recent stop time for any antenna 
C        scheduled to be in this scan.   
C        Use the nominal start time if this is the first scan for
C        all participating stations.  Also, make sure if only some 
C        antennas are new, they don't set the start time.
C
         TAPPROX = TFIRST
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
               IF( LASTISCN(ISTA) .NE. 0 ) THEN
                  TAPPROX = MAX( TAPPROX, 
     1                 STOPJ(LASTISCN(ISTA)) + GAP(ISCN) )
               END IF
            END IF
         END DO
      END IF
C
C     Loop through stations to see how many are up.
C     Also see how many are in prefered elevation ranges.
C     Get TBEGIN which is an estimated start time for the scan
C     could start taking into account slews, which TAPPROX does not.
C     It can be earlier than TAPPROX if the station that set
C     that time is not selected.  If no stations had a previous
C     time, use the experiment start time.
C
      NGOOD = 0
      NPRIO = 0
      TBEGIN = TFIRST
      DO ISTA = 1, NSTA
         OKSTA(ISTA) = .FALSE.
         IF( STASCN(ISCN,ISTA) ) THEN
            CALL STAGEO( ISCN, ISTA, TAPPROX, LASTISCN(ISTA),  
     1          LASTTIME, T_AVAIL, 'OPTSKD' )
            IF( UP1(ISCN,ISTA) .EQ. ' ' .AND. 
     1          UP2(ISCN,ISTA) .EQ. ' ' .AND. 
     2          EL1(ISCN,ISTA) .GT. OPMINEL(ISCN) .AND.
     3          EL2(ISCN,ISTA) .GT. OPMINEL(ISCN) ) THEN
               OKSTA(ISTA) = .TRUE.
               NGOOD = NGOOD + 1
               IF( LASTISCN(ISTA) .NE. 0 ) THEN
                  T_AVAIL = MAX( T_AVAIL, 
     1                  STOPJ(LASTISCN(ISTA)) + GAP(ISCN) )
                  TBEGIN = MAX( TBEGIN, T_AVAIL )
               END IF
               IF( ( EL1(ISCN,ISTA) .GT. OPELPRIO(1) .AND.
     1               EL1(ISCN,ISTA) .LT. OPELPRIO(2) ) .OR.
     2             ( EL1(ISCN,ISTA) .GT. OPELPRIO(3) .AND.
     3               EL1(ISCN,ISTA) .LT. OPELPRIO(4) ) ) 
     4                NPRIO = NPRIO + 1
            END IF
         END IF
      END DO
C
C     If there were no stations that were up and had a previous
C     scan, use the same default as TAPPROX.  If this is because
C     all stations are down, this scan will be rejected so it
C     doesn't matter.  If it is because all good stations are 
C     on their first scan, use the experiment start time.
C     As for TAPPROX, if the scan time is not to be adjusted,
C     use the specified scan start time.
C
      IF( .NOT. ADJUST .OR. TBEGIN .EQ. TFIRST ) TBEGIN = TAPPROX
C
C     Get source number for this scan.  This just saves nested
C     subscripts later.
C
      ISRC = SRCNUM(ISCN)
C
C     Determine whether to accept the scan.  If OPMIAN was not
C     set, require at least one good antenna.
C
      KEEP = ( NGOOD .GE. MAX( OPMIAN(ISCN), 1 ) .AND. 
     1       ( SKIP(ISRC) .GE. OPSKIP .OR. NPRIO .GE. 1 ) )
C
C     The following deactivates the minimum number of antennas
C     and the skip ability for pointing and antenna temperature
C     observations.  This allows a single antenna (eg MK) to be
C     doing pointing while the rest of the array is doing 
C     regular observing with OPMIAN set or skipping turned on.
C
C     The deactivation is not done if the OBSTYPE indicates that
C     this is single dish observing.
C
C
      IF( OBSTYP .NE. 'NONE' .AND. OBSTYP .NE. 'PTVLBA' ) THEN
         KEEP = KEEP .OR. ( NGOOD .GE. 1 .AND. 
     1       ( PNTVLBA(ISCN) .OR. TANVLBA(ISCN) .OR. DOPN3DB(ISCN) ) )
      END IF
C
C     Only keep the scan if a sufficient number of preceeding scans
C     have been missed.  This allows for low priority sources.
C
      KEEP = KEEP .AND. MISSED .GE. OPMISS(ISCN)
C
      IF( KEEP ) THEN
C
         SKIP(ISRC) = 0
C
C        Set the start time to TBEGIN if we are going to adjust scan
C        times.  Otherwise keep the original.
C
         IF( ADJUST ) THEN
            STARTJ(ISCN) = TBEGIN
            STOPJ(ISCN)  = TBEGIN + DUR(ISCN)
         END IF
C
C        Set which stations will be in the scan.  Take only ones that 
C        are up unless told to take all.
C
         DO ISTA = 1, NSTA
            STASCN(ISCN,ISTA) = OKSTA(ISTA) .OR. OPNOSUB
         END DO
C
         MISSED = 0
      ELSE 
C
C        Increment the skip counter if the scan is not kept.
C
         IF( NGOOD .GE. OPMIAN(ISCN) ) THEN
            SKIP(ISRC) = SKIP(ISRC) + 1
         END IF
C
C        Turn off all stations for the scan.
C
         DO ISTA = 1, NSTA
            STASCN(ISCN,ISTA) = .FALSE.
         END DO
C
         MISSED = MISSED + 1
      END IF
C
  999 CONTINUE
C
      RETURN
      END

      SUBROUTINE GEOQUAL( SC1, SC1A, SC2, JSCN, MINSEL, TESTQUAL,
     1                    PRDEBUG, ZATMERR )
Cf2py intent(in) SC1, SC1A, SC2, JSCN, MINSEL, PRDEBUG
Cf2py intent(out) TESTQUAL
Cf2py intent(in, out) ZATMERR
C
C     Get the quality measure of scans SC1 to SC2.  This gets the
C     quality measure for this particular choice of sources.  The calling
C     program will then pick the highest set with the highest quality
C     measure.  
C
C     If SC1A is not equal to SC1, it is assumed that the
C     previous call accumulated data for SC1 to SC1A-1 and that only
C     SC1A to SC2 need to be accumulated here.  This is an attempt to
C     reduce the run time in the MAKESEG process.
C
C     Isolate this to a subroutine in case someone wants to brew 
C     their own measure.  If someone has a quality measure that should
C     be low, it can just be multiplied by -1 and I think it should
C     work.
C
C     For the original version of the routine, the measure was the minimum 
C     over stations of the rms SecZ times sqrt(N).  The sqrt(N) 
C     favors sequences with more scans.  Otherwise, we are selecting
C     on the worst RMS spanned SecZ.
C
C     Mark Reid pointed out that the stations should not be done in 
C     isolation.  For example, a scan with all stations high plus
C     a scan with all stations low would have a good spread of secZ
C     but would not produce a good solution because there is nothing
C     tieing the low to the high.  One needs at least one or more
C     scans with some stations high and some low.  
C
C     Because of the above, I have set up a dummy least squares fit 
C     for the atmospheric terms (ignoring clock) and look at the errors 
C     on the derived zenith atmospheric delays.  I then look at the
C     worst such error.   The initial trials allowed one station with
C     very little SecZ range.  This might be because the fit does not
C     include a constant term so even one observation constrains SecZ.
C     Add a clock offset.
C
C     MINSEL allows minimizing the reward for really low elevation
C     scans.  The secZ will not be allowed to go above sec(90-minsel)
C
C     The tests are only done for stations in the template scan (JSCN)
C
      INCLUDE 'sched.inc'
C
      INTEGER               SC1, SC1A, SC2, JSCN, ISCN
      INTEGER               ISTA, JSTA, ICH
      INTEGER               IBAS, NBAS, IERR
      REAL                  TESTQUAL, SECZ
      REAL                  TRIQUAL, RELEV  !  , RAN5
      REAL                  MINSEL, SMINSEL
      LOGICAL               PRDEBUG
C
C     For fit:
C
      INTEGER               MAXDAT, MAXPAR
      PARAMETER             ( MAXDAT = 10000 )
      PARAMETER             ( MAXPAR = MAXSTA*2 )
      INTEGER               SOLVE(MAXPAR), NNBAS(MAXSCN), LSC2
      INTEGER               NSTASCN(MAXSTA), MINNSS
      DOUBLE PRECISION      RESDEL(MAXDAT), DELERR(MAXDAT)
      DOUBLE PRECISION      GUESS(MAXPAR)
      DOUBLE PRECISION      PARTIAL(MAXDAT,MAXPAR)
      DOUBLE PRECISION      PPARTIAL(MAXDAT,MAXPAR)
      DOUBLE PRECISION      ZATM(MAXPAR), ZATMERR(*)
C
      DATA   SOLVE  / MAXPAR * 1 /
      DATA   GUESS  / MAXPAR * 0.D0 /
      DATA   RESDEL / MAXDAT * 0.D0 /
      DATA   DELERR / MAXDAT * 100.D0 /
      DATA   LSC2   / 0 /
C
C     Save some numbers for incremental calls.
C
      SAVE                  NNBAS, PARTIAL, LSC2
C -----------------------------------------------------------------------
C     The least squares fit will be done on dummy data for all 
C     baselines.  I need actual dummy measured values (zero), 
C     sigmas (arbitrary 20ps), and the partial derivatives
C     (secZ for the two stations of a baseline with an appropriate
C     sign).  
C
C     Try setting the sigmas to 100ps to match what Mark did.  July 23
C     2010
C
C     Require that the station be in the template scan and in
C     the individual scans.  Actually, that is inforced when STASCN
C     is set for the individual scans.
C
      IF( NSTA .LE. 1 ) THEN
         CALL ERRLOG( 'GEOQUAL:  Cannot insert DELZN segments for '//
     1           'single station observations.' )
      END IF
C
C     Initializations.  Set NBAS to use the values previously
C     calculated for scans SC1 to SC1A.
C
      IF( SC1 .EQ. SC1A ) THEN
         NBAS = 0
         DO ISCN = SC1, SC2
            NNBAS(ISCN) = 0
         END DO
      ELSE
         NBAS = NNBAS(SC1A-1)
         DO ISCN = SC1A, SC2
            NNBAS(ISCN) = 0
         END DO
      END IF
C
      DO ISTA = 1, 2 * NSTA
         DO IBAS = NBAS+1, MAXDAT
            PARTIAL(IBAS,ISTA) = 0.D0
         END DO
      END DO
C
      SMINSEL = 1.0 / SIN( MINSEL * RADDEG )
      DO ISCN = SC1A, SC2
C
C        Station 1 loop.
C
         DO ISTA = 2, NSTA
            IF( STASCN(ISCN,ISTA) .AND. UP1(ISCN,ISTA) .EQ. ' ' .AND.
     1          UP2(ISCN,ISTA) .EQ. ' ' ) THEN
C
C              Station 2 loop.
C
               DO JSTA = 1, ISTA - 1
                  IF( STASCN(ISCN,JSTA) .AND. UP1(ISCN,JSTA) .EQ. ' '
     1                .AND. UP2(ISCN,JSTA) .EQ. ' ' ) THEN
C
C                    Get the baseline data for the fit.
C
                     NBAS = NBAS + 1
C
                     IF( NBAS .GT. MAXDAT ) THEN
                        CALL ERRLOG( 'GEOQUAL: Too many scan/'//
     1                    'baselines in making geodetic segment.' )
                     END IF
C
C                    Accumulate the highest number baseline for
C                    each scan for use in incremental calls.
C
                     NNBAS(ISCN) = NBAS
C
C                    SecZ partial for first station.
C                    Don't reward excessively low elevation scans.
C                    Try a max secz for the fit corresponding to
C                    MINSEL.  Make a parameter so that it can be
C                    used differently in MAKESEG and in the final
C                    selection.
C
                     RELEV = EL1(ISCN,ISTA)
                     SECZ = MIN( 1.0 / SIN( RELEV * RADDEG ), SMINSEL )
                     PARTIAL(NBAS,ISTA) = SECZ
C
C                    SecZ partial for second station (is negative of secZ).
C
                     RELEV = EL1(ISCN,JSTA)
                     SECZ = MIN( 1.0 / SIN( RELEV * RADDEG ), SMINSEL )
                     PARTIAL(NBAS,JSTA) = -1.0 * SECZ
C
C                    Add the partials for the clock terms.  Put those 
C                    in NSTA+1 to NSTA*2-1.  Do not fit for station 
C                    NSTA (one has to be fixed) and making it the last
C                    simplifies some bookkeeping.
C
                     IF( ISTA .NE. NSTA) THEN
                        PARTIAL(NBAS,ISTA+NSTA) = 1.0
                     END IF
                     PARTIAL(NBAS,JSTA+NSTA) = -1.0
C
                  END IF
               END DO
            END IF
         END DO
      END DO
C
C     Move the partials for all baselines to an array to pass
C     to LSQFIT.  LSQFIT modifies them, so this step is needed
C     when trying to save computations above by not redoing
C     the ones for scans SC1 to SC1A-1.  
C
      DO ISTA = 1, NSTA*2-1
         DO IBAS = 1, NBAS
            PPARTIAL(IBAS,ISTA) = PARTIAL(IBAS,ISTA)
         END DO
      END DO
C
C     Do the fit.  Note that the first half of the ZATM and ZATMERR 
C     arrays will be the items apparent from the names for all
C     stations.  The second half of the arrays, minus one, will be
C     for the clocks at the stations.  One clock is held fixed.
C     Jump throughsome hoops to prevent spewing excessive error
C     messages.
C
      IF( LSC2 .NE. SC2 ) THEN
         IERR = GEOPRT
      ELSE
         IF( IERR .GE. 1 ) IERR = 0
      END IF
C
C     Sometimes there might be too little data to fit for all the
C     parameters.  In fact, we are counting baselines, but many are
C     actually redundant in terms of giving useful information.  So
C     don't do the fit unless each station participates in 3 scans.
C     That is one more than strictly needed, but should be ok.
C
      DO ISTA = 1, NSTA
         NSTASCN(ISTA) = 0
         DO ISCN = SC1, SC2
            IF( STASCN(ISCN,ISTA) .AND. UP1(ISCN,ISTA) .EQ. ' ' .AND.
     1          UP2(ISCN,ISTA) .EQ. ' ' ) THEN
               NSTASCN(ISTA) = NSTASCN(ISTA) + 1
            END IF
         END DO
      END DO
      MINNSS=999
      DO ISTA = 1, NSTA
         MINNSS = MIN( NSTASCN(ISTA), MINNSS )
      END DO
C
C     If there aren't enough delays to each station, skip the fit.  
C     Set IERR = 1 so the rest of the routine thinks the fit failed.
C     Tell the user if appropriate.
C
      IF( MINNSS .LT. 3 ) THEN
         IERR = 1
         IF( GEOPRT .GE. 1 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, 5I5 )' ) 
     1         'GEOQUAL skipping fit - inadequate data ', 
     2         NSTA, NBAS, SC1, SC1A, SC2
            CALL WLOG( 0, MSGTXT )
            MSGTXT = ' '
         END IF
      ELSE
         CALL LSQFIT( 0, .FALSE., .FALSE., MAXDAT, NSTA*2-1, NBAS,
     1         STANAME, GUESS, SOLVE, RESDEL, PPARTIAL, DELERR,
     2         ZATM, ZATMERR, IERR )
C
C        Initialize the quality measure.  Use zero since the final
C        derived quality measure will be the highest across stations.
C
         TESTQUAL = 0.0
      END IF
C
C     Deal with failure to invert the matrix.  Cause the scan to be 
C     skipped by setting a very high quality measure.  Also write
C     out a bit of information in the hopes of figureing out the
C     cause some day.
C
      IF( IERR .NE. 0 ) THEN
         TESTQUAL = 1.E6
         IF( GEOPRT .GE. 2 ) THEN
            DO ISCN = SC1, SC2
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I5, A, 20L2  )' ) ' Scan: ', ISCN, 
     1          '  Stations in scan: ', (STASCN(ISCN,ISTA),ISTA=1,NSTA)
               CALL WLOG( 0, MSGTXT )
            END DO
         END IF
         IF( GEOPRT .GE. 1 ) THEN
            IF( SC2 .NE. LSC2 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( 3A, 2I5, 3A )' ) 
     1            ' GEOQUAL: Fit error when testing ', SCNSRC(SC2), 
     2            ' to scans:', SC1, SC2, ' Skip source this scan.' 
               CALL WLOG( 0, MSGTXT )
               CALL WLOG( 0, '        This message can usually be'//
     1            ' ignored safely when inserting geodetic segments.' )
               LSC2 = SC2
            ELSE
               CALL WLOG( 0, ' GEOQUAL: Similar error testing '//
     1             SCNSRC(SC2) )
            END IF
C              
         END IF
C         
C         WRITE(*,*) 'GEOQUAL: Partials matrix: '
C         DO J = 1, NBAS
C            WRITE(*,'( I5, 40F8.3 )' ) J, 
C     1             ( PARTIAL(J,I), I=1, NSTA*2-1 )
C         END DO
      END IF
C
C     Set TESTQUAL to the highest (worst) ZATMERR seen across
C     stations.  Later the set with the lowest TESTQUAL will
C     be chosen.
C
      IF( PRDEBUG ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A )' )
     1        'GEOQUAL:   Sta  Zatm RMS      El by scan. '
         CALL WLOG( 0, MSGTXT )
      END IF
      DO ISTA = 1, NSTA
         IF( STASCN(JSCN,ISTA) ) THEN
C
C           Pick the quality measure.  Separated to TRIQUAL 
C           in case I want to try varients.
C
            TRIQUAL =  ZATMERR(ISTA)
C
            TESTQUAL = MAX( TESTQUAL, TRIQUAL )
C
C           Some printout if the programmer is trying to watch
C           the process in detail.  MKGDEBUG is hard wired in 
C           GEOMAKE.
C
            IF( PRDEBUG ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, 2X, A3, F8.3 )' ) 
     1               'GEOQUAL:  ', STCODE(STANUM(ISTA)), 
     2               ZATMERR(ISTA)
               ICH = 26
               DO ISCN = SC1, SC2
                  IF( ICH .GT. 250 ) THEN
                     CALL WLOG( 1, MSGTXT ) 
                     MSGTXT = ' '
                     ICH = 26
                  END IF
                  IF( STASCN(ISCN,ISTA) ) THEN
                     WRITE( MSGTXT(ICH:ICH+5), '( F6.1 )' ) 
     1                       EL1(ISCN,ISTA)
                  ELSE
                     WRITE( MSGTXT(ICH:ICH+5), '( A )' ) '  --- '
                  END IF
                  ICH = ICH + 6
               END DO
               CALL WLOG( 0, MSGTXT )
               MSGTXT = ' '
            END IF
         END IF
      END DO
C
C
      RETURN
      END

      SUBROUTINE ACCSRC( INCLPTG )
Cf2py intent(in) INCLPTG
C
C     Subroutine for SCHED that accumulates a list of all sources
C     that have been used in the schedule.  It looks for the main
C     sources in scans, doppler sources, vla phasing sources, and
C     multiple phase center sources.
C
C     Optionally, it can look for sources that might get used for
C     reference pointing or for insertion of geodetic segments.  
C     These need to be counted when reading the catalogs so they 
C     won't get left out.  But after the schedule optimization and 
C     reference insertion is done, only the ones that made it to 
C     scans are needed, and they are counted anyway.
C
C     The name of any source found is put in SRCNAME and counted with
C     NSRC.  
C
C     This routine is run at various points in SCHED when the current 
C     list of sources is needed.  It is run by INPUT before the main 
C     source catalog is read so that the catalog reading routine 
C     can limit which sources it keeps (the catalog can be very large).
C     It is also run late in SCHOPT after the final scans list is known.
C     Each time it is run, it rebuilds all the lists and pointers.
C
C     Eventually the array SRCATN will be used to associate these
C     sources with catalog entries.  That is filled by SRCFLG later.
C     It has to be done after all catalogs are read.
C
C     Do the types of source sequentially so a new one is not counted
C     multiple times.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schpeak.inc'
C
      INTEGER    ISCN, KSRC, PSRC, IGRP, JCENT, ICSRC, IGEO
      LOGICAL    GOTSS, GOTSD, GOTSP, GOTPTG, INCLPTG, GOTPHS, GOTGEO
      LOGICAL    GOTPCEN
C ---------------------------------------------------------------------
C     Initialize counters etc.  Recall that this routine is called
C     more than once.
C
      NSRC = 0
C
C     Loop over SCAN1 to SCANL as will be needed in the call from
C     SCHOPT.
C
      DO ISCN = SCAN1, SCANL
C
C        The main scan sources.
C
         GOTSS = .FALSE.
         IF( NSRC .GE. 1 ) THEN
            DO KSRC = 1, NSRC
               IF( SCNSRC(ISCN) .EQ. SRCNAME(KSRC) ) GOTSS = .TRUE.
            END DO
         END IF
         IF( .NOT. GOTSS ) THEN
            IF( NSRC .EQ. MAXSRC ) GO TO 900
            NSRC = NSRC + 1
            SRCNAME(NSRC) = SCNSRC(ISCN)
         END IF
C
C        The Doppler sources.
C
         GOTSD = .FALSE.
         IF( NSRC .GE. 1 ) THEN
            DO KSRC = 1, NSRC
               IF( DOPSRC(ISCN) .EQ. SRCNAME(KSRC) ) GOTSD = .TRUE.
            END DO
         END IF
         IF( .NOT. GOTSD ) THEN
            IF( NSRC .EQ. MAXSRC ) GO TO 900
            NSRC = NSRC + 1
            SRCNAME(NSRC) = DOPSRC(ISCN)
         END IF
C
C        The VLA phasing sources.
C
         GOTSP = .FALSE.
         IF( NSRC .GE. 1 ) THEN
            DO KSRC = 1, NSRC
               IF( VLAPHS(ISCN) .EQ. SRCNAME(KSRC) ) GOTSP = .TRUE.
            END DO
         END IF
         IF( .NOT. GOTSP ) THEN
            IF( NSRC .EQ. MAXSRC ) GO TO 900
            NSRC = NSRC + 1
            SRCNAME(NSRC) = VLAPHS(ISCN)
         END IF
C
C        The multiple phase center sources.
C
         ICENT(ISCN) = 0
C
C        If a centers has been specified, find its sources.
C
         IF( CENTERS(ISCN) .NE. ' ' ) THEN
            GOTPCEN = .FALSE.
            DO JCENT = 1, NCENT
               IF( CENTERS(ISCN) .EQ. CTRNAME(JCENT) ) THEN
                  GOTPCEN = .TRUE.
                  ICENT(ISCN) = JCENT
                  DO ICSRC = 1, NCSRC(JCENT)
                     GOTPHS = .FALSE.
                     IF( NSRC .GE. 1 ) THEN
                        DO KSRC = 1, NSRC
                           IF( CTRSRCN(ICSRC,JCENT) .EQ. 
     1                           SRCNAME(KSRC) ) THEN 
                              GOTPHS = .TRUE.
                           END IF
                        END DO                        
                     END IF
                     IF( .NOT. GOTPHS ) THEN
                        IF( NSRC .EQ. MAXSRC ) GO TO 900
                        NSRC = NSRC + 1
                        SRCNAME(NSRC) = CTRSRCN(ICSRC,JCENT)
                     END IF
                  END DO
               END IF
            END DO
C
C           Complain if centers not found.
C
            IF( .NOT. GOTPCEN ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A )' )
     1            'ACCSRC: Could not find pcenters ', 
     2            CENTERS(ISCN)
               CALL ERRLOG( MSGTXT )
            END IF
         END IF

      END DO
C
C     The sources that might get used for reference pointing.
C     Loop over reference pointing groups and sources in the groups.
C
      IF( INCLPTG ) THEN
         IF( AUTOPEAK .AND. NPKGRP .GT. 0 ) THEN
            DO IGRP = 1, NPKGRP
               IF( NPKSRC(IGRP) .GT. 0 ) THEN
                  DO PSRC = 1, NPKSRC(IGRP)
                     GOTPTG = .FALSE.
                     IF( NSRC .GE. 1 ) THEN  
                        DO KSRC = 1, NSRC
                           IF( PKSRC(PSRC,IGRP) .EQ. SRCNAME(KSRC) ) 
     1                            THEN
                              GOTPTG = .TRUE.
                           END IF
                        END DO
                     END IF
                     IF( .NOT. GOTPTG ) THEN
                        IF( NSRC .EQ. MAXSRC ) GO TO 900
                        NSRC = NSRC + 1
                        SRCNAME(NSRC) = PKSRC(PSRC,IGRP)
                     END IF
                  END DO
               END IF
            END DO
         END IF
C
C        Also look for sources that might be involved in insertion
C        of geodetic segments.  They are in GEOSRC.
C
         IF( ANYGEO ) THEN
            DO IGEO = 1, NGEO
               GOTGEO = .FALSE.
               IF( NSRC .GE. 1 ) THEN
                  DO KSRC = 1, NSRC 
                     IF( GEOSRC(IGEO) .EQ. SRCNAME(KSRC) ) 
     1                    GOTGEO = .TRUE.
                  END DO
               END IF
               IF( .NOT. GOTGEO ) THEN
                  IF( NSRC .EQ. MAXSRC ) GO TO 900
                  NSRC = NSRC + 1
                  SRCNAME(NSRC) = GEOSRC(IGEO)
               END IF
            END DO
         END IF
C
      END IF
C
      RETURN
C
C     Jump here if NSRC got too big.
C
  900 CONTINUE
      WRITE( MSGTXT, '( A, I6 )' ) 
     1     'ACCSRC: Too many sources needed by schedule.  Max', MAXSRC
      CALL ERRLOG( MSGTXT )
C
      RETURN
      END

      SUBROUTINE CHKIFWRP( KS, RESULT, LOSUM, BBCBW )
Cf2py intent(in) KS, LOSUM, BBCBW
Cf2py intent(out) RESULT     
      INTEGER            KS
      CHARACTER          RESULT*(100)
      DOUBLE PRECISION   BBCBW(32)
      DOUBLE PRECISION   LOSUM(32)
      CALL CHKIF(KS, RESULT, LOSUM, BBCBW)
      RETURN
      END

      DOUBLE PRECISION FUNCTION sla_EQEQX (DATE)
*+
*     - - - - - -
*      E Q E Q X
*     - - - - - -
*
*  Equation of the equinoxes  (IAU 1994, double precision)
*
*  Given:
*     DATE    dp      TDB (loosely ET) as Modified Julian Date
*                                          (JD-2400000.5)
*
*  The result is the equation of the equinoxes (double precision)
*  in radians:
*
*     Greenwich apparent ST = GMST + sla_EQEQX
*
*  References:  IAU Resolution C7, Recommendation 3 (1994)
*               Capitaine, N. & Gontier, A.-M., Astron. Astrophys.,
*               275, 645-650 (1993)
*
*  Called:  sla_NUTC
*
*  Patrick Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE

*  Turns to arc seconds and arc seconds to radians
      DOUBLE PRECISION T2AS,AS2R
      PARAMETER (T2AS=1296000D0,
     :           AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T,OM,DPSI,DEPS,EPS0



*  Interval between basic epoch J2000.0 and current epoch (JC)
      T=(DATE-51544.5D0)/36525D0

*  Longitude of the mean ascending node of the lunar orbit on the
*   ecliptic, measured from the mean equinox of date
      OM=AS2R*(450160.280D0+(-5D0*T2AS-482890.539D0
     :         +(7.455D0+0.008D0*T)*T)*T)

*  Nutation
      CALL sla_NUTC(DATE,DPSI,DEPS,EPS0)

*  Equation of the equinoxes
      sla_EQEQX=DPSI*COS(EPS0)+AS2R*(0.00264D0*SIN(OM)+
     :                               0.000063D0*SIN(OM+OM))

      END

      SUBROUTINE WRTMSG( TERM, CALLER, MSGNAM )
C
C     Subroutine for SCHED for writing messages to the log file.
C     The messages are found in the MSGFILE which is kept in 
C     the catalogs area.  Normally it is messages.txt.  It is 
C     a user input only because some machines might not be able
C     to deal with logical variables to get the default right.
C
C     This routine opens the message file and reads through until
C     it finds a line that matches ++MSGNAM.  It then writes 
C     everything it finds to the log file until it finds another 
C     line that starts with ++.
C
C     TERM is the WLOG input of that name.  0=> write to log file
C     only.  1=> Write to log file and terminal.
C
      INCLUDE  'sched.inc'
C
      CHARACTER   CALLER*(*), MSGNAM*(*), INLINE*256, OPTEXT*256
      INTEGER     VLBOPE, IERR, LEN1, NCH, TERM
      LOGICAL     INMSG
C ---------------------------------------------------------------------
      INMSG = .FALSE.
C
C     Put request information
C
      MSGTXT = 'WRTMSG: Special message from routine ' //
     1      CALLER(1:LEN1(CALLER)) // ':'
      CALL WLOG( TERM, ' ' )
      CALL WLOG( TERM, MSGTXT )
C
C     Open the message file:
C
      IERR = VLBOPE( IMSG, MSGFILE, 'TEXT', 'OLD', OPTEXT )
      IF( IERR .NE. 1 ) THEN
         CALL WLOG( 1, 'WRTMSG: Could not open message file.' )
         CALL WLOG( 1, OPTEXT )
      ELSE
C
C        Get the message.
C
  100    CONTINUE
         INLINE = ' '
         READ( IMSG, '( A )', END = 200, ERR = 990 ) INLINE
C
C        Process the message.
C
         IF( .NOT. INMSG ) THEN
C
C           Check if this is the start of our message.
C
            NCH = LEN1( INLINE )
            IF( NCH .GE. 3 ) THEN
               IF( INLINE(1:2) .EQ. '++' .AND. 
     1              INLINE(3:NCH) .EQ. MSGNAM(1:LEN1(MSGNAM)) ) THEN
                  INMSG = .TRUE.
               END IF
            END IF
         ELSE
C
C           Check if done.
C
            IF( INLINE(1:2) .EQ. '++' ) GO TO 999
C
C           Check for comment.
C
            IF( INLINE(1:2) .NE. '--' ) THEN
C
C              If not, write the line to the log file.
C              Set to ask user to read the log file.  This will
C              happen for each line, but that is not a big
C              burden.
C
               CALL WLOG( TERM, INLINE )
               READLOG = .TRUE.
C
            END IF
         END IF
C
C        Jump back for the next line.
C
         GO TO 100
C
      END IF
C
C     Jump here if out of data.  Complain if not reading the 
C     message, which means it wasn't found.
C
  200 CONTINUE
      IF( .NOT. INMSG ) THEN
         MSGTXT = 'WRTMSG: Message ' //
     1     MSGNAM // ' not found!'
         CALL WLOG( 1, MSGTXT )
      END IF
      GO TO 999
C
C     Problem reading the file.
C
  990 CONTINUE
      CALL WLOG( 1, 'WRTMSG:  Error reading the messages file.' )
C
C     End of program.  Close the message file.
C
  999 CONTINUE
      IF( IERR .EQ. 1 ) CLOSE( UNIT=IMSG )
C
      RETURN
      END

      CHARACTER*6 FUNCTION SUMDAT( ITEM, ISCN, ISTA )
C
C     A function to generate the character string for an individual
C     item in a the summary file.
C
      INCLUDE 'sched.inc'
C
      INTEGER     ISCN, ISTA, TEARLY, TDWELL, ITSLEW, ISYNC
      CHARACTER   ITEM*(*)
      INTEGER          IGB
      CHARACTER        UPA*1, UPC*2
C -------------------------------------------------------------------
C     Get the average rise state.  Not needed in most, but 
C     easier to just get it without fussing about whether
C     it's needed.  Also, keep out of the STASCN IF because
C     it may be wanted for sources that have been removed
C     because of being down.
C
      UPA = ' '
      UPC = UP1(ISCN,ISTA)//UP2(ISCN,ISTA)
      IF( UPC .EQ. 'HH' ) UPA = 'H'
      IF( UPC .EQ. 'DD' ) UPA = 'D'
      IF( UPC .EQ. ' D' .OR. UPC .EQ. ' H' ) UPA = 'S'
      IF( UPC .EQ. 'D ' .OR. UPC .EQ. 'H ' ) UPA = 'R'
      IF( UPC .EQ. 'HD' .OR. UPC .EQ. 'DH' ) UPA = 'H'
      IF( UPC .EQ. 'WW' ) UPA = 'W'
C
C     Detect if the station is to be used.
C
      IF( STASCN(ISCN,ISTA) ) THEN 
C
C        Get the desired item.
C
         IF( ITEM .EQ. 'EL1' ) THEN
            WRITE( SUMDAT, '( I5, A1 )' ) 
     1           NINT( EL1(ISCN,ISTA) ), UP1(ISCN,ISTA)
C
         ELSE IF( ITEM .EQ. 'EL2' ) THEN
            WRITE( SUMDAT, '( I5, A1 )' ) 
     1           NINT( EL2(ISCN,ISTA) ), UP2(ISCN,ISTA)
C
         ELSE IF( ITEM .EQ. 'ELA' ) THEN
            WRITE( SUMDAT, '( I5, A1 )' ) 
     1           NINT( ( EL1(ISCN,ISTA) + EL2(ISCN,ISTA) ) / 2 ), 
     2           UPA
C
         ELSE IF( ITEM .EQ. 'AZ1' ) THEN
            WRITE( SUMDAT, '( I5, A1 )' ) 
     1           NINT( AZ1(ISCN,ISTA) ), UP1(ISCN,ISTA)
C
         ELSE IF( ITEM .EQ. 'AZ2' ) THEN
            WRITE( SUMDAT, '( I5, A1 )' ) 
     1           NINT( AZ2(ISCN,ISTA) ), UP2(ISCN,ISTA)
C
         ELSE IF( ITEM .EQ. 'AZA' ) THEN
            WRITE( SUMDAT, '( I5, A1 )' ) 
     1           NINT( ( AZ1(ISCN,ISTA) + AZ2(ISCN,ISTA) ) / 2 ), 
     2           UPA
C
         ELSE IF( ITEM .EQ. 'PA1' ) THEN
            WRITE( SUMDAT, '( I5, 1X )' ) NINT( PA1(ISCN,ISTA) )
C
         ELSE IF( ITEM .EQ. 'PA2' ) THEN
            WRITE( SUMDAT, '( I5, 1X )' ) NINT( PA2(ISCN,ISTA) )
C
         ELSE IF( ITEM .EQ. 'HA1' ) THEN
            WRITE( SUMDAT, '( F5.1 )' ) HA1(ISCN,ISTA) 
C
         ELSE IF( ITEM .EQ. 'HA2' ) THEN
            WRITE( SUMDAT, '( F5.1 )' ) HA2(ISCN,ISTA)
C
C        The following section is tape items.  Remove some day.
C
         ELSE IF( ITEM(1:4) .EQ. 'TAPE' ) THEN
C
C           No longer supporting tape.  Put the disk bytes in 
C           for TAPE1 and nothing for TAPE2
C
            IF( ITEM .EQ. 'TAPE1' ) THEN
               IF( NOREC(ISCN) ) THEN 
                  SUMDAT = 'Stop '
               ELSE IF( USEDISK(ISTA)  ) THEN
                  IGB = NINT( GBYTES(ISCN,ISTA) )
                  WRITE( SUMDAT, '( I5 )' ) IGB
               END IF
C
            ELSE IF( ITEM .EQ. 'TAPE2' ) THEN
               SUMDAT = '---- '
            END IF
C
         ELSE IF( ITEM .EQ. 'DISK' .OR. ITEM .EQ. 'DISC' ) THEN
            IF( NOREC(ISCN) ) THEN
                  SUMDAT = ' Stop '
            ELSE IF( USEDISK(ISTA) ) THEN
               IGB = NINT( GBYTES(ISCN,ISTA) )
               WRITE( SUMDAT, '( I5 )' ) IGB
            ELSE
               SUMDAT = '----'
            END IF
C
         ELSE IF( ITEM .EQ. 'TPSTART' ) THEN
            WRITE( SUMDAT, '( I5, 1X )' ) IDNINT( TPSTART(ISCN,ISTA) * 
     1            86400.D0 )
C
         ELSE IF( ITEM .EQ. 'EARLY' ) THEN
            TEARLY = IDNINT( ( STARTJ(ISCN) - TONSRC(ISCN,ISTA) ) * 
     1               86400.D0 )
            WRITE( SUMDAT, '( I5, A1 )' ) TEARLY, UPA
C
         ELSE IF( ITEM .EQ. 'DWELL' ) THEN
            TEARLY = IDNINT( ( STARTJ(ISCN) - TONSRC(ISCN,ISTA) ) * 
     1               86400.D0 )
            IF( UP1(ISCN,ISTA) .EQ. ' ' .AND. UP2(ISCN,ISTA) .EQ. ' ' ) 
     1          THEN
               IF( TEARLY .GE. 0 ) THEN
                  TDWELL = IDNINT( ( STOPJ(ISCN) - STARTJ(ISCN) ) * 
     1                  86400.D0 )
               ELSE
                  TDWELL = IDNINT( ( STOPJ(ISCN) - TONSRC(ISCN,ISTA) ) *
     1                  86400.D0 )
               END IF
            ELSE
               TDWELL = 0
            END IF
            WRITE( SUMDAT, '( I5, A1 )' ) TDWELL, UPA
C
         ELSE IF( ITEM .EQ. 'SLEW' ) THEN
            ITSLEW = IDNINT( TSLEW(ISCN,ISTA) * 86400.D0 )
            WRITE( SUMDAT, '( I5, 1X )' ) ITSLEW
C
         ELSE IF( ITEM .EQ. 'SYNC' ) THEN
            ISYNC = IDNINT( ( STOPJ(ISCN) - TCORR(ISCN,ISTA) ) *
     1              86400.D0 )
            WRITE( SUMDAT, '( I5, 1X )' ) ISYNC
C
         ELSE IF( ITEM .EQ. ' ' ) THEN
            SUMDAT = '     '
C
C        Test for understood items is in SUMDESC.
C
         END IF
C
      ELSE
C
C        Station not in scan.  But still give the UP indicators
C        in case the station was removed by SCHED to show why.
C
         IF( ITEM .EQ. 'EL1' .OR. ITEM .EQ. 'AZ1' ) THEN
            WRITE( SUMDAT, '( A5, A1 )' ) '  ---', UP1(ISCN,ISTA)
         ELSE IF( ITEM .EQ. 'EL2' .OR. ITEM .EQ. 'AZ2' ) THEN
            WRITE( SUMDAT, '( A5, A1 )' ) '  ---', UP2(ISCN,ISTA)
         ELSE IF( ITEM .EQ. 'ELA' .OR. ITEM .EQ. 'AZA' .OR.
     1            ITEM .EQ. 'DWELL' .OR. ITEM .EQ. 'EARLY' ) THEN
            WRITE( SUMDAT, '( A5, A1 )' ) '  ---', UPA
         ELSE
            SUMDAT = '  --- '
         END IF
C
      END IF
C
      RETURN
      END

      SUBROUTINE SBHOURS( ISRC, TSCAN, TBASE, ESCAN, EBASE, 
     1                    ISET, KFSETS)
C
C     Routine for sched, called by srclst, that gets the number 
C     of hours in scans and in baselines for each source using a
C     setup file.  It gets it both for the core and for all scans
C     including the PREEMPT = EXTRA scans.
C
C     KFSETS is an ascii list of the frequency sets used with 
C     this source and setup.
C
C     Core scans are those with PREEMPT .NE. 'EXTRA'.  
C     TSCAN is the output scan hours for the core scans. 
C     TBASE is the baseline hours for the core scans.
C     ESCAN is the scan hours for all scans if DOSCANS is not
C           used.  Otherwise it is the hours for scans in 
C           the DOSCANS range.
C     EBASE is the baseline hours for the same scans as ESCAN.
C
      INCLUDE     'sched.inc'
      INCLUDE     'schset.inc'
C
      INTEGER     MFP
      PARAMETER   ( MFP = 26 )   !  1/3 dimension of KFSETS
      INTEGER     I, ISCN, ISTA, JSTA, ISRC, ISET, NC
      INTEGER     NFP, IFP, IFS, IFSETS(MFP)
      LOGICAL     GOTFS, SCNUSED
      DOUBLE PRECISION   TBASE, TSCAN, TBSTRT, ESCAN, EBASE
      CHARACTER   KFSETS*(*), IFMT*6
C -----------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'SBHOURS starting.' )
      TSCAN = 0.D0
      TBASE = 0.D0
      ESCAN = 0.D0
      EBASE = 0.D0
      NFP = 0
      DO I = 1, MFP
         IFSETS(I) = 0 
      END DO
C
C     Loop over scans.
C
      DO ISCN = SCAN1, SCANL
C
C        Select recording scans on the current source.
C        Note that pure pointing schedules tend to have NOREC set 
C        to false while recording schedules set NOREC true for 
C        scans like pointing scans (true as of July 2011).  I
C        might change that but I'm not sure that is not what I want.
C
C        Don't count scans that are skipped by all stations being 
C        processed.
C
         SCNUSED = .FALSE.
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) SCNUSED = .TRUE.
         END DO
C
         IF( SCNUSED .AND. SRCNUM(ISCN) .EQ. ISRC .AND. 
     1       ( .NOT. NOREC(ISCN) ) .AND.
     2       SETNUM(ISCN) .EQ. ISET ) THEN
C
C           Add the scan time.
C           The "E" variables are either all scans or DOSCANS scans
C           depending on if DOSCANS is in use.  The "T" variables are
C           for the "core" - scans with PREEMPT not set to EXTRA.
C
            IF( DOSCANS(1) .EQ. 0 ) THEN
               ESCAN = ESCAN + ( STOPJ(ISCN) - STARTJ(ISCN) )
            ELSE IF( ISCN .GE. DOSCANS(1) .AND. 
     1               ISCN .LE. DOSCANS(2) ) THEN
               ESCAN = ESCAN + ( STOPJ(ISCN) - STARTJ(ISCN) )
            END IF
            IF( PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
               TSCAN = TSCAN + ( STOPJ(ISCN) - STARTJ(ISCN) )
            END IF
C
C           Get baseline time using double loop over stations.
C           Require source be up at both ends of scan.
C
            IF( NSTA .GT. 1 ) THEN
               DO ISTA = 1, NSTA -1
                  IF( STASCN(ISCN,ISTA) .AND. 
     1                UP1(ISCN,ISTA) .EQ. ' ' .AND.
     2                UP2(ISCN,ISTA) .EQ. ' ' ) THEN
                     DO JSTA = ISTA + 1, NSTA
                        IF( STASCN(ISCN,JSTA) .AND.
     1                    UP1(ISCN,JSTA) .EQ. ' ' .AND.
     2                    UP2(ISCN,JSTA) .EQ. ' ' .AND.
     3                    TONSRC(ISCN,ISTA).LT.STOPJ(ISCN) .AND.
     4                    TONSRC(ISCN,JSTA).LT.STOPJ(ISCN)
     5                         ) THEN
C
C                          Get start time of data for the baseline.
C
                           TBSTRT = MAX( STARTJ(ISCN), 
     1                                  TONSRC(ISCN,ISTA) )
                           TBSTRT = MAX( TBSTRT,
     1                                  TONSRC(ISCN,JSTA) )
C
C                          Get baseline hours.
C
                           IF( DOSCANS(1) .EQ. 0 ) THEN
                              EBASE = EBASE + STOPJ(ISCN) - TBSTRT
                           ELSE IF( ISCN .GE. DOSCANS(1) .AND. 
     1                              ISCN .LE. DOSCANS(2) ) THEN
                              EBASE = EBASE + STOPJ(ISCN) - TBSTRT
                           END IF
                           IF( PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
                              TBASE = TBASE + STOPJ(ISCN) - TBSTRT
                           END IF
C
                        END IF
                     END DO
                  END IF
               END DO
            END IF                  
C
C           Now get the FSETS used.  Only require that the setup
C           is used at one station.  For many pointing observations,
C           there is only one station so the 2 station scheme gets
C           into trouble.
C
C           Don't try to distinguish core from all from DOSCANS 
C           for this.
C
            IF( NSTA .GE. 1 ) THEN
               DO ISTA = 1, NSTA
                  IF( STASCN(ISCN,ISTA) .AND. 
     1                UP1(ISCN,ISTA) .EQ. ' ' .AND.
     2                UP2(ISCN,ISTA) .EQ. ' ' .AND. 
     3                TONSRC(ISCN,ISTA).LT.STOPJ(ISCN) ) THEN
C
C                          Get the FSETS used - check both
C                          stations.  Use FSETI(ISCN,ISTA).
C                          This is a bit tedious, but simple.
C
                     IF( NFP .EQ. 0 ) THEN
                        IFSETS(1) = FSETI(ISCN,ISTA)
                        NFP = 1
                     END IF                          
C
C                    Check ISTA
C
                     GOTFS = .FALSE.
                     DO IFS = 1, NFP
                        IF( FSETI(ISCN,ISTA) .EQ. IFSETS(IFS) )
     1                     GOTFS = .TRUE. 
                     END DO
                     IF( .NOT. GOTFS .AND. NFP .LT. MFP ) THEN
                        NFP = NFP + 1
                        IFSETS(NFP) = FSETI(ISCN,ISTA)
                     END IF
                  END IF
               END DO
            END IF                  
         END IF
      END DO
C
C     Write the character string KFSETS based on the frequency sets.
C     Only write the ones that don't have a matching one of smaller 
C     number as determined elsewhere and encoded in FSSAME.
C     But need to include the smaller number one somewhere - it might
C     not be in IFSETS.  Minimize the number of blanks.
C
      I = 1
      NC = 1
      KFSETS = ' '
      DO IFS = 1, NFSET
         DO IFP = 1, NFP
            IF( FSSAME(IFSETS(IFP)) .EQ. IFS ) THEN
               IF( IFS .GE. 10 ) NC = 2
               IF( IFS .GE. 100 ) NC = 3
               IF( IFS .GE. 1000 ) NC = 4
               WRITE( IFMT, '( A, I1, A )' ) '( I', NC+1, ' )'
               WRITE( KFSETS(I:I+NC), IFMT ) IFS
               I = I + NC + 1
               GO TO 300
            END IF
         END DO
  300    CONTINUE
      END DO
C
      RETURN
      END

      SUBROUTINE sla_EARTH (IY, ID, FD, PV)
*+
*     - - - - - -
*      E A R T H
*     - - - - - -
*
*  Approximate heliocentric position and velocity of the Earth
*
*  Given:
*     IY       I       year
*     ID       I       day in year (1 = Jan 1st)
*     FD       R       fraction of day
*
*  Returned:
*     PV       R(6)    Earth position & velocity vector
*
*  Notes:
*
*  1  The date and time is TDB (loosely ET) in a Julian calendar
*     which has been aligned to the ordinary Gregorian
*     calendar for the interval 1900 March 1 to 2100 February 28.
*     The year and day can be obtained by calling sla_CALYD or
*     sla_CLYD.
*
*  2  The Earth heliocentric 6-vector is mean equator and equinox
*     of date.  Position part, PV(1-3), is in AU;  velocity part,
*     PV(4-6), is in AU/sec.
*
*  3  Max/RMS errors 1950-2050:
*       13/5 E-5 AU = 19200/7600 km in position
*       47/26 E-10 AU/s = 0.0070/0.0039 km/s in speed
*
*  4  More accurate results are obtainable with the routines sla_EVP
*     and sla_EPV.
*
*  Last revision:   5 April 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      INTEGER IY,ID
      REAL FD,PV(6)

      INTEGER IY4
      REAL TWOPI,SPEED,REMB,SEMB,YI,YF,T,ELM,GAMMA,EM,ELT,EPS0,
     :     E,ESQ,V,R,ELMM,COSELT,SINEPS,COSEPS,W1,W2,SELMM,CELMM

      PARAMETER (TWOPI=6.28318530718)

*  Mean orbital speed of Earth, AU/s
      PARAMETER (SPEED=1.9913E-7)

*  Mean Earth:EMB distance and speed, AU and AU/s
      PARAMETER (REMB=3.12E-5,SEMB=8.31E-11)



*  Whole years & fraction of year, and years since J1900.0
      YI=FLOAT(IY-1900)
      IY4=MOD(MOD(IY,4)+4,4)
      YF=(FLOAT(4*(ID-1/(IY4+1))-IY4-2)+4.0*FD)/1461.0
      T=YI+YF

*  Geometric mean longitude of Sun
*  (cf 4.881627938+6.283319509911*T MOD 2PI)
      ELM=MOD(4.881628+TWOPI*YF+0.00013420*T,TWOPI)

*  Mean longitude of perihelion
      GAMMA=4.908230+3.0005E-4*T

*  Mean anomaly
      EM=ELM-GAMMA

*  Mean obliquity
      EPS0=0.40931975-2.27E-6*T

*  Eccentricity
      E=0.016751-4.2E-7*T
      ESQ=E*E

*  True anomaly
      V=EM+2.0*E*SIN(EM)+1.25*ESQ*SIN(2.0*EM)

*  True ecliptic longitude
      ELT=V+GAMMA

*  True distance
      R=(1.0-ESQ)/(1.0+E*COS(V))

*  Moon's mean longitude
      ELMM=MOD(4.72+83.9971*T,TWOPI)

*  Useful functions
      COSELT=COS(ELT)
      SINEPS=SIN(EPS0)
      COSEPS=COS(EPS0)
      W1=-R*SIN(ELT)
      W2=-SPEED*(COSELT+E*COS(GAMMA))
      SELMM=SIN(ELMM)
      CELMM=COS(ELMM)

*  Earth position and velocity
      PV(1)=-R*COSELT-REMB*CELMM
      PV(2)=(W1-REMB*SELMM)*COSEPS
      PV(3)=W1*SINEPS
      PV(4)=SPEED*(SIN(ELT)+E*SIN(GAMMA))+SEMB*SELMM
      PV(5)=(W2-SEMB*CELMM)*COSEPS
      PV(6)=W2*SINEPS

      END

      SUBROUTINE CHKSC1
C
C     Routine for SCHED called by the main routine that checks scan 
C     parameters before SCHOPT.  The main scan checker CHKSCN is
C     called after SCHOPT and all scan details are known.  But the
C     scan optimization routines can get confused by some problems
C     so catch them here.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    KSCN, LSCN, ISTA, KS
      LOGICAL    GOTERR, HAVEPL, HAVESA
C ----------------------------------------------------------------------
      GOTERR = .FALSE.
C
C     Loop over scans.
C
      HAVEPL = .FALSE.
      HAVESA = .FALSE.
      DO KSCN = 1, NSCANS
C
C        Look for attempts to use ephemeris or satellite at stations
C        where this shouldn't be done.  Usually this is for stations
C        for which we don't know how to specify position rates.
C
C        Also look for attempts to look for both planets and
C        satellites in the same schedule.  This doesn't seem to work
C        for unknown reasons.  By planets here, I mean something using
C        the ephemeris.  If doing satellites, you can also do a planet
C        by treating it like a satellite and getting the info from the
C        bsp file.
C
         DO ISTA = 1, NSTA
            IF( STASCN(KSCN,ISTA) ) THEN
               IF( PLANET(SRCNUM(KSCN)) .OR. SATEL(SRCNUM(KSCN)) ) THEN
                  IF( CONTROL(STANUM(ISTA)) .NE. 'VLBA' .AND.
     1                .NOT. VLBADAR(STANUM(ISTA)) .AND.
     2                CONTROL(STANUM(ISTA)) .NE. 'VLA' ) THEN
                     GOTERR = .TRUE.
                     CALL WLOG( 1, 'CHKSC1: Trying to use ephemeris '//
     1                    'or satellite position for '//SCNSRC(KSCN) )
                     CALL WLOG( 1, '        at '//STATION(STANUM(ISTA)) 
     1                    //' but SCHED doesn''t know how.' )
                  END IF
               END IF
               IF( PLANET(SRCNUM(KSCN)) ) HAVEPL = .TRUE.
               IF( SATEL(SRCNUM(KSCN)) ) HAVESA = .TRUE.
C
            END IF
         END DO
C
      END DO
C
      IF( HAVEPL .AND. HAVESA ) THEN
         CALL WLOG( 1, 'CHKSC1:  Trying to use ephmeris and '//
     1     'satellites in the same schedule' )
         CALL WLOG( 1, 'CHKSC1:  That might cause a crash that '//
     1     'looks like an inability to read a bsp file.' )
      END IF
C
C     If got an error, quit.
C
      IF( GOTERR ) THEN
         CALL ERRLOG( 'CHKSC1: Errors found.' )
      END IF
C
C     Look for FORMAT='NONE' on recording scans.  This format should
C     be allowed on non-recording scans.
C
      IF( .NOT. ( NOSET .OR. NOTAPE ) ) THEN
         DO KSCN = 1, NSCANS
            DO ISTA = 1, NSTA
               IF( STASCN(KSCN,ISTA) ) THEN
                  KS = NSETUP(KSCN,ISTA)
                  IF( FORMAT(KS) .EQ. 'NONE' .AND. .NOT. NOREC(KSCN) ) 
     1                THEN
                     WRITE( MSGTXT, '( A, A )' ) 
     1                     'CHKSC1:  *****  Format NONE specified ',
     2                     'for a recording scan.  Not allowed!'
                     CALL WLOG( 1, MSGTXT )
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( A )' )
     1                  '                Scan and setup information:'
                     CALL WLOG( 1, MSGTXT )
                     MSGTXT = ' '
                     CALL PRTSCN( KSCN, 'CHKSC1' )
                     CALL PRTSET( KS, ILOG )
                     CALL WLOG( 1, ' ' )
                     CALL WLOG( 1, 'CHKSC1:  See the error message '//
     1                     'before the scan and setup information.' )
                     CALL ERRLOG( 
     1                     'CHKSC1: Switch to a recording format.' )
                  END IF
               END IF
            END DO
C     C  
         END DO
      END IF
C
C     Check that there are at least some record scans if using a
C     recording format.
C
      IF( VLBITP ) THEN
         DO KSCN = 1, NSCANS
            IF( .NOT. NOREC(KSCN) ) GO TO 100
         END DO
         CALL WLOG( 1, ' ' )
         CALL WLOG( 1, 'CHKSC1:   *** This schedule uses formats ' //
     1       'that suggest it should     ***' )
         CALL WLOG( 1, '          *** be recording but there are ' //
     1       'no recording scans.        ***' )
         CALL WLOG( 1, '          *** Was this intended? ' //
     1       'It might be for reference pointing ***' )
         CALL WLOG( 1, '          *** If not, check OBSTYPE and ' //
     1       'RECORD/NORECORD             ***' )
         CALL WLOG( 1, ' ' )
       END IF
  100 CONTINUE
C
C     Warn users if they are setting FREQ and BW in the scans and
C     they switch setup files without setting changing those
C     parameters.  This is a fairly benign warning so don't worry
C     about lots of complications such as what stations are in 
C     what scans.  Issue the warning if there is a setup file change
C     without a change in specified FREQ or BW.  Note that changing
C     either to zero constitutes being a change so is ok as desired.
C     Also only worry about the first channel even though there are
C     scenarios that would get past this.  Only warn once.
C
      DO KSCN = 2, NSCANS
         LSCN = KSCN - 1
         IF( SETNUM(KSCN) .NE. SETNUM(LSCN) ) THEN
            IF( ( FREQ(1,KSCN) .EQ. FREQ(1,LSCN) .AND. 
     1            FREQ(1,LSCN) .NE. 0.D0 ) .OR. 
     2          ( BW(1,KSCN) .EQ. BW(1,LSCN) .AND. 
     3            BW(1,LSCN) .NE. 0.D0 ) ) THEN
               CALL WLOG( 1, 'WARNING:  See note in sched.runlog ' //
     1            'about frequency and bandwidth changes.' )
               CALL WRTMSG( 0, 'CHKSC1', 'freqbw' )
               GO TO 200
            END IF
         END IF
      END DO
  200 CONTINUE
C
C     Check that HIGROUP is not used when not using OPTMODE='HIGHEL'
C
      DO KSCN = 1, NSCANS
         IF( HIGROUP(KSCN) .GE. 2 .AND. OPTMODE .NE. 'HIGHEL' ) THEN
           CALL ERRLOG( 'CHKSC1: HIGROUP used without OPTMODE=HIGHEL' )
         END IF
      END DO
C
      RETURN
      END

      CHARACTER*32 FUNCTION VXNMRL( IXX )
C
C     Routine specific for the VEX extension of SCHED. 
C     function generates a name for ROLL block IXX
C     By H.J. van Langevelde, JIVE, 300496 
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER IXX, KS, ROLLBY
C ----------------------------------------------------------------------
C     
C     Depends on Barrel Roll...
C
      KS = RLISSET(IXX)
      ROLLBY = -1
      IF( BARREL(KS) .EQ. 'roll_off' ) ROLLBY = 0
      IF( BARREL(KS) .EQ. 'roll_16' ) ROLLBY = 16
      IF( BARREL(KS) .EQ. 'roll_8' ) ROLLBY = 8
      IF( BARREL(KS) .EQ. 'roll_auto' ) THEN
         IF( FORMAT(KS)(1:7) .EQ. 'MARKIII' ) THEN
            ROLLBY = 0
         ELSE
            IF( TAPEMODE(KS) .EQ. 1 ) ROLLBY = 16
            IF( TAPEMODE(KS) .EQ. 2 ) ROLLBY = 16
            IF( TAPEMODE(KS) .EQ. 4 ) ROLLBY = 8
            IF( TAPEMODE(KS) .EQ. 0 ) ROLLBY = 0
         END IF
      END IF
C
C     so an appropriate name is
C        
      VXNMRL = 'RandomScramble' 
      IF( ROLLBY .EQ. 16) VXNMRL = 'StndRoll/16'
      IF( ROLLBY .EQ. 8) VXNMRL = 'StndRoll/8'
      IF( ROLLBY .EQ. 0) VXNMRL = 'NoRoll'
C
      RETURN
      END

      SUBROUTINE GETCRDN( ISCN, ISTA, CRDN, CRSETC )
C
C     Subroutine used in writing the VLBA crd files that determines
C     how many legacy system baseband channels to use when recording 
C     through the RDBE and which RDBE channels to use for the basic
C     setup information such as band, polarization, IF etc.
C     the number of channels used in the legacy hardware.  The routine
C     is required because there can be more RDBE channels than legacy
C     channels, especially since the number of BBCs was drawn down to
C     four (early 2014).
C
C     The results can be controlled by the user, usually for reference
C     pointing, using CRDNCH (often used with CRDFREQ or CRDDOP),
C     CRDSETCH, CRDCH1.  More commonly, this routine will set up 
C     default values.
C     
C     The defaults will sample all IFs in use.  This mainly matters
C     when the S/X system is in use and some observations were lost before
C     this was set carefully.  If the legacy system thinks it is X only,
C     which happened with the RDBE_PFB and only 4 S band channels, it will
C     aim the subreflector at the X band receiver.  But the new system
C     knows about all channels and deploys the ellipsoid.  Thus there
C     are no S band fringes because the subreflector is aimed at X band, 
C     and there are no X band fringes because the ellipsoid is blocking
C     the optical path.  The diagnosis is hard because the data all look
C     reasonable.
C
C     This routine is called by VLBASU, FSFREQ (which is called many
c     times), and PCALFQ so be sure nothing is done that would create 
C     problems when called multiple times.
C
C     Input: 
C        ISCN:    Current scan number.  Often called with the refernece
C                 scan of a frequency set.
C        ISTA:    Schedule station number for the station.
C                 Note in some routines, the catalog number would be more
C                 natural, but we need ISTA for NSETUP etc.
C     Output:
C        CRDN:    Then number of channels for the crd files.
C        CR1:     The setup channel to use for the first crd channel
C                 parameters that are the same in the RDBE and legacy system.
C        CRN:     The setup channel to use for the last crd channel.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER    MIF
      PARAMETER  (MIF=4)
      INTEGER    ISCN, KSTA, CRDN, CRSETC(*), ISTA
      INTEGER    ICH, IIF, ICHCR, ICRD, I, J, K, ITEMP
      INTEGER    KS, NIF, NCHIF(MIF), CHIF(MAXCHN,MIF)
      INTEGER    NCRDIF(MIF), CRDBBC(MAXCHN,MIF), IFCHI(MAXCHN)
      CHARACTER  NAMIF(MIF)*2
      REAL       RINCR
      LOGICAL    CRDEBUG
      DATA       CRDEBUG / .FALSE. /
C-----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'GETCRDN: starting' )
C
C     Get the station catalog index for schedule station ISTA and
C     the setup group.  Note that the frequency sets are not yet known when
C     this is called from DOPCRD, so don't invoke them.
C
      KSTA = STANUM(ISTA)
      KS = NSETUP(ISCN,ISTA)
C      
C     First deal with some of the cases where the CRD parameters should 
C     match the setup.
C
C     For VLBA stations, this is when the RDBE is not in use (DAR not RDBE)
C     and the crd files are actually setting up the experiment.
C
C     Otherwise use this in the cases where no crd file will be written.
C     See CRDWRT for the IF statement there.  VLBADAR is probably obsolete -
C     see routine STREAD.
C
      IF( DAR(KSTA)(1:4) .NE. 'RDBE' .OR. .NOT. (
     1   ( CONTROL(STANUM(ISTA)) .EQ. 'VLBA' .OR. 
     2      VLBADAR(STANUM(ISTA)) ) ) )  THEN
         CRDN = NCHAN(KS)
         DO ICHCR = 1, NCHAN(KS)
            CRSETC(ICHCR) = ICHCR
         END DO
      ELSE
C
C        Ok, we are going to need crd parameters but SCHED is focusing
C        on setting up the RDBE.   In other words, this is not primarly 
C        a legacy (MARK5A or pointing) schedule.  
C
C        For the number of channels, use CRDNCH if it was given.
C        INFDB did not let it be greater than MAXCRD, which is 4 after
C        Feb 2014 because some BBCs of the original 8 are being
C        removed.  We will only be allocating channel per BBC, even
C        though more are allowed for MARK5A/pointing schedules.
C
C        Note that the frequency or doppler settings don't matter here.
C
         IF( CRDNCH(ISCN) .GT. 0 ) THEN
C
C           Use the specified number of channels.  Check the total.
C           Use current scan, not setup reference scan as the CRD
C           parameters can change.
C
            CRDN = CRDNCH(ISCN)
            IF( CRDN .GT. NCHAN(KS) ) THEN
               CALL WLOG( 1, 'GETCRDN: The specified CRDNCH assumes' //
     1            ' more channels than are in the setup file: ' )
               MSGTXT = ' '
               WRITE( MSGTXT, '(  A, A )' ) 
     1               '         ', SETNAME(KS)
               CALL ERRLOG( MSGTXT )
            END IF
         ELSE
C
C           Set the values when using the default.  This is when the 
C           user did not set CRDNCH.  Note that CRDCH1 cannot be set
C           without setting CRDNCH - enforced by INFDB.
C
            CRDN = MIN( MAXCRD, NCHAN(KS) )
         END IF
C
C        Now set the setup file channels to specify the channels to use 
C        for basic information such as IF name etc.
C
C        First if CRDCH1 or CRDSETCH was used, CRDSETCH will be filled
C        out in INFDB.  But protect against invalid values now that the
C        setups are well established.
C
         IF( CRDSETCH(1,ISCN) .GT. 0 ) THEN
            DO ICHCR = 1, CRDN
               CRSETC(ICHCR) = CRDSETCH(ICHCR,ISCN) 
               IF( CRSETC(ICHCR) .LT. 1 .OR. 
     1             CRSETC(ICHCR) .GT. NCHAN(KS) ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I2, A, I3 )' )
     1               'GETCRDN:  CRDSETCH(', ICHCR, ') = ', 
     2               CRDSETCH(ICHCR,ISCN), 
     3               ' not between 1 and the number of channels', 
     4               NCHAN(KS)
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I2, A, I3 )' )
     1               '          for scan ', ISCN, ' setup: ',
     2               SETNAME(KS)
                  CALL WLOG( 1, MSGTXT )
                  IF( CRDCH1(ISCN) .GT. 0 ) THEN
                     CALL WLOG( 1, 
     1               '          Note CRDSETCH was derived '//
     2               'from CRDCH1 and CRDCHN' )
                  END IF
                  CALL ERRLOG( 'Fix the channel request.' )
               END IF
            END DO
C
         ELSE
C
C           Channels not specified.  Set the defaults.
C           Try to put at least one channel in each IF.  Also
C           spread the channels reasonably far apart if 
C           possible.
C
C           Set up a list of IF channels to spread the CRD channels over.
C           Get the following from the setup information.
C             NIF           - number of IF channels
C             NCHIF(IIF)   - number of baseband channels per IF channel
C             NAMIF(IIF)   - name of each IF channel
C             IFCHI(ICH)    - IF number for setup baseband channel
C             CHIF(ICF,IIF) - List of setup BB channels for each IF
C
C           There is a spreadsheet sched_4bbc.ods that I used to help
C           think this through.
C             
C
            NIF = 0
            DO IIF = 1, MIF
               NAMIF(IIF) = ' '
               NCHIF(IIF) = 0
               DO ICH = 1, NCHAN(KS)
                  CHIF(ICH,IIF) = 0
               END DO
            END DO
            DO ICH = 1, NCHAN(KS)
               IFCHI(ICH) = 0
            END DO
C
C           See what IFs are there and collect the list of setup BB
C           channels that are use that IF.  Get started with the
C           first, then look through the rest behaving differently
C           for IFs previously seen or new.
C
            NIF = 1
            NAMIF(1)  = IFCHAN(1,KS)
            NCHIF(1)  = 1
            CHIF(1,1) = 1
            IFCHI(1)  = 1
C
C           Loop over the other channels, if there are any.
C
            IF( NCHAN(KS) .GE. 2 ) THEN
               DO ICH = 2, NCHAN(KS)
                  DO IIF = 1, NIF
                     IF( IFCHAN(ICH,KS) .EQ. NAMIF(IIF) ) THEN
C
C                       Matches a channel seen before.
C
                        NCHIF(IIF) = NCHIF(IIF) + 1
                        CHIF(NCHIF(IIF),IIF) = ICH
                        IFCHI(ICH) = IIF
C
                     END IF
                  END DO
C
C                 Deal with a new IF.  But if the number of IFs goes 
C                 over the max, don't add it as we won't be able to 
C                 use it.  Later, if IFCHI is still 0, it had an IF 
C                 that was not counted.  For the VLBA, that should 
C                 never be an issue as there are only 4 IFs possible.
C
                  IF( IFCHI(ICH) .EQ. 0 .AND. NIF .LT. MIF ) THEN
                     NIF = NIF + 1
                     NAMIF(NIF) = IFCHAN(ICH,KS)
                     NCHIF(NIF) = 1
                     CHIF(NCHIF(NIF),NIF) = ICH
                     IFCHI(ICH) = NIF
                  END IF
               END DO
            END IF
C
C           Get the number of crd channels to allocate to each IF.
C           This loops through the crd channels assigning an IF to
C           each.  Here it steps through the available IFs as often
C           as necessary to allocate an IF to all crd channels.
C           Don't allocate more channels to an IF than there are 
C           setup channels that have that IF.
C           
            DO IIF = 1, NIF
               NCRDIF(IIF) = 0
            END DO
C
            IIF = 0
            ICHCR = 0
            I = 0
            DO WHILE ( ICHCR .LT. CRDN )
               I = I + 1
               IIF = MOD( I, NIF ) + 1
               IF( NCRDIF(IIF) .LT. NCHIF(IIF) ) THEN
                  NCRDIF(IIF) = NCRDIF(IIF) + 1
                  ICHCR = ICHCR + 1
               END IF
               IF( I .GT. MIF * MAXCHN ) CALL ERRLOG( 'GETCRDN:' //
     1            ' Programming error in IF assignments. ' //
     2            'Please report.' )
            END DO               
C
C           Now we have the number of setup BB channels per IF (NCHIF)
C           and the number of CRD channels per IF (NCRDIF).
C
C           Get which of the BB channels (CHIF) to keep.  Evenly space
C           the ones kept within the list.  To get the increment, you
C           want to divide the number of setup channels in the IF
C           by the number you can keep.  But you want the kept ones
C           centered in the list.  That is best done by using an
C           increment that is the number of channels in either case
C           plus 1 to account for the upper end that you don't want
C           to hit.  Getting this right is what the spreadsheet was
C           for.
C
            ICRD = 0
            DO IIF = 1, NIF
               RINCR = REAL( NCHIF(IIF) + 1 ) / 
     1                 REAL( NCRDIF(IIF) + 1 )
               DO J = 1, NCRDIF(IIF)
                  K = NINT( J * RINCR )
                  CRDBBC(J,IIF) = CHIF(K,IIF)
                  ICRD = ICRD + 1
                  CRSETC(ICRD) = CRDBBC(J,IIF)
               END DO
            END DO

C
C           Sanity check.  ICRD should equal CRDN.
C
            IF( ICRD .NE. CRDN ) THEN
               CALL WLOG( 1, 'GETCRDN:  Programming problem: '//
     1              'Number of CRD channels assigned not right.' )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I5, A, I5 )' )
     1            '    CRDN = ', CRDN, '  ICRD = ', ICRD 
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I5, A, 16I4 )' )
     1            '    CRSETC = ', (CRSETC(I),I=1,ICRD)
               CALL WLOG( 1, MSGTXT )
               CALL ERRLOG( '    Please report this problem' )
            END IF
C
C           Sort the CRSETC list so that the CRD channels come
C           in the same order.
C
            IF( CRDN .GT. 1 ) THEN
               DO I = 1, CRDN - 1
                  DO J = I + 1, CRDN
                     IF( CRSETC(J) .LT. CRSETC(I) ) THEN
                        ITEMP = CRSETC(I)
                        CRSETC(I) = CRSETC(J)
                        CRSETC(J) = ITEMP
                     END IF
                  END DO
               END DO
            END IF           
C
C           So the list is made.
C           I'd be tempted to write the results, but it happens
C           every scan.  Do so if CRDEBUG is on.
C
            IF( CRDEBUG ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I5, I4, I3, A, 16I5 )' ) 
     1             'GETCRDN:  ISCN, KS, CRDN: ', ISCN, KS, CRDN,
     2             '  CRSETC: ', (CRSETC(I),I=1,CRDN)
               CALL WLOG( 1, MSGTXT )
            END IF
C
         END IF
      END IF
C
C     Make sure the highest numbered CRSETC is not
C     to high.
C
      IF( CRSETC(CRDN) .GT. NCHAN(KS) ) THEN
         CALL WLOG( 1, 'GETCRDN: The specified CRD parameters ' //
     1      'assume more channels than are in the' )
         MSGTXT = ' '
         WRITE( MSGTXT, '(  A, A )' ) 
     1         '         setup file: ', SETNAME(KS)
         CALL WLOG( 1, MSGTXT )
      END IF
C
      IF( DEBUG ) CALL WLOG( 0, 'GETCRDN: ending' )
      RETURN
      END

      SUBROUTINE SBHWRAP( ISRC, TSCAN, TBASE, ESCAN, EBASE, 
     1     ISET, KFSETS)
Cf2py intent(in) ISRC, ISET
Cf2py intent(out) TSCAN, TBASE, ESCAN, EBASE, KFSETS
C     Wrapper around SBHOURS to make sure f2py knows how much
C     memory to allocate for KFSETS.
      INTEGER ISRC, ISET
      DOUBLE PRECISION   TBASE, TSCAN, TBSTRT, ESCAN, EBASE
      CHARACTER   KFSETS*(78)
      CALL SBHOURS( ISRC, TSCAN, TBASE, ESCAN, EBASE, 
     1     ISET, KFSETS)
      RETURN
      END

      SUBROUTINE sla_NUT (DATE, RMATN)
*+
*     - - - -
*      N U T
*     - - - -
*
*  Form the matrix of nutation for a given date - Shirai & Fukushima
*  2001 theory (double precision)
*
*  Reference:
*     Shirai, T. & Fukushima, T., Astron.J. 121, 3270-3283 (2001).
*
*  Given:
*     DATE    d          TDB (loosely ET) as Modified Julian Date
*                                           (=JD-2400000.5)
*  Returned:
*     RMATN   d(3,3)     nutation matrix
*
*  Notes:
*
*  1  The matrix is in the sense  v(true) = rmatn * v(mean) .
*     where v(true) is the star vector relative to the true equator and
*     equinox of date and v(mean) is the star vector relative to the
*     mean equator and equinox of date.
*
*  2  The matrix represents forced nutation (but not free core
*     nutation) plus corrections to the IAU~1976 precession model.
*
*  3  Earth attitude predictions made by combining the present nutation
*     matrix with IAU~1976 precession are accurate to 1~mas (with
*     respect to the ICRS) for a few decades around 2000.
*
*  4  The distinction between the required TDB and TT is always
*     negligible.  Moreover, for all but the most critical applications
*     UTC is adequate.
*
*  Called:   sla_NUTC, sla_DEULER
*
*  Last revision:   1 December 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,RMATN(3,3)

      DOUBLE PRECISION DPSI,DEPS,EPS0



*  Nutation components and mean obliquity
      CALL sla_NUTC(DATE,DPSI,DEPS,EPS0)

*  Rotation matrix
      CALL sla_DEULER('XZX',EPS0,-DPSI,-(EPS0+DEPS),RMATN)

      END

      CHARACTER*(*) FUNCTION TFORM ( RAD, TYPE, NSIGN, NDEG, NSEC, 
     +       DELIM )
C
C    A function to return time or angle data provided in radians
C    in a character form suitable for printing.  Several formats are
C    provided.  Output is rounded and leading zeros are included. 
C
C    RCW  16 Feb. 1988
C
C    INPUTS:
C        RAD      R*8     The time or angle in radians.
C        TYPE     C*1     'T' => time,  anything else, angle.
C        NSIGN    I       0 => Do not output, or leave room for, sign.
C                            eg. for use with elevations. 
C                         > 0 => First character is sign.  Blank for positive.
C                         < 0 => First character is sign.  + for positive.
C        NDEG     I       2 => only two digits for hour or degrees.  
C                         Anything else => implies 3 digits.
C        NSEC     I       Number of seconds digits.  This will be reduced if
C                         necessary so as not to overflow TFORM whose size is
C                         specified in the calling routine.  Absolute upper
C                         limit is 19. 
C                         If 3 or more, includes one for decimal.
C                         1 => 2.  Otherwise there can be confusion.
C                         Can be zero for output of deg and min only.
C        DELIM    C*3     1 character each to go after degrees (or hours),
C                         minutes, and seconds.  @ means do not leave space.
C                         Some common cases:
C                             '  @'  spaces between elements, nothing at end.
C                             'hms'  a VLBA time-like number.
C                             ':: '  typical use of colons.
C                             'd''"' a VLBA angle.
C                             '@@@'  A SNAP time.
C  ---------------------------------------------------------------------
      INTEGER    NSIGN, MSIGN, NDEG, MDEG, NSEC , DEG, MINU, TSEC
      INTEGER    II, I, IDIG, IMOD
      INTEGER    SDIG,  CHLEN, MAXSEC
      DOUBLE PRECISION  RAD, SECRAD, SECIN, SEC, PI, TEST, TMOD, DELT
      LOGICAL    PLUS
      CHARACTER  TYPE*1, DELIM*3, SIGN*1, TEMP*25, OUTCH*28
      PARAMETER  (PI=3.1415926535897932D0)
      PARAMETER  (SECRAD=180.D0*3600.D0/PI)
C ---------------------------------------------------------------------
C     Check for allowed values.
C
      TFORM = ' '
      MSIGN = NSIGN
      IF( MSIGN.NE.0 ) MSIGN = 1
      PLUS = .FALSE.
      IF( NSIGN.LT.0 ) PLUS = .TRUE.
      MDEG = NDEG
      IF( MDEG.NE.2 ) MDEG = 3
C
C     Don't allow too long character strings for the 
C     temporary variables.
C
      CHLEN = MIN( LEN(TFORM), 25 )
      MAXSEC = CHLEN - MSIGN - MDEG - 2 - 3
      IF( DELIM(1:1).EQ.'@') MAXSEC = MAXSEC + 1
      IF( DELIM(2:2).EQ.'@') MAXSEC = MAXSEC + 1
      IF( DELIM(3:3).EQ.'@') MAXSEC = MAXSEC + 1
      MAXSEC = MIN( MAXSEC, 19 )
      SDIG = MIN( NSEC, MAXSEC )
      IF( SDIG.EQ.1 ) SDIG = 2
C
C     Convert from radians to seconds.
C
      SECIN = RAD * SECRAD
      IF( TYPE .EQ. 'T' ) SECIN = SECIN / 15.D0
C
C     Set sign for output and convert SECIN to positive.
C
      SIGN = ' '
      IF( SECIN .LT. 0.D0 ) SIGN = '-'
      IF( SECIN .GE. 0.D0 .AND. PLUS ) SIGN = '+'
      SECIN = ABS( SECIN )
C
C     Deal with the rounding.  Need to do before breaking out degrees
C     and minutes. 
C
C     Note that MOD(SECIN, 10**(SDIG-3)) can overflow an integer.  Hence
C     the somewhat strange scheme used below.  Also, the 0.01*TEST is 
C     added to prevent, for example, 5.0 from being expressed as 4.99999..
C
      IF( SDIG .GE. 3 ) THEN
         TEST = 10.D0 ** (3.D0-SDIG)
         TMOD = MOD( SECIN, TEST )
         IMOD = TMOD / TEST  + 0.5D0
         SECIN = SECIN - TMOD  +  (IMOD+0.01) * TEST 
      ELSE IF( SDIG .EQ. 2 .OR. SDIG .EQ. 3 ) THEN 
         II = SECIN + 0.5D0
         SECIN = II
      ELSE IF( SDIG .EQ. 1) THEN
         II = (SECIN/10.D0) + 0.5D0
         SECIN = II * 10.D0
      ELSE IF( SDIG .EQ. 0 ) THEN
         II = ( SECIN + 30.D0 ) / 60.D0
         SECIN = II * 60
      END IF
C
C     Add a small number so the integerization will go well.
C     Use something appropriate for the number of output digits.
C
      IF( SDIG .LT. 5 ) THEN
         DELT = 1.D-5
      ELSE
         DELT = 10.D0 ** ( -SDIG )
      END IF
      SECIN = SECIN + DELT
C
C     Determine degrees (hours), minutes, and seconds.
C     TSEC is needed to get leading zeros on seconds.
C     Help the integerization with a very small addition.
C
      DEG = INT( SECIN / 3600.D0 )
      MINU = INT( (SECIN - DEG*3600.D0) / 60.D0 )
      SEC = SECIN - DEG*3600.D0 - MINU*60.D0 
      TSEC = INT( SEC / 10.0D0 )
      SEC = SEC - TSEC*10.D0
C
C     Write the temporary character variable.
C     Format will be sdddmmss.ssssssssssss
C
      WRITE( TEMP, '(A1,I3.3,I2.2,I1,F18.16)')
     +        SIGN, DEG, MINU, TSEC, SEC
      IF( TEMP(8:8).EQ.' ' ) TEMP(8:8) = '0'
C
C     Now construct the output form, OUTCH.
C
      OUTCH = ' '
      IDIG = 1
      IF( MSIGN.NE.0 ) THEN
         OUTCH(IDIG:IDIG) = TEMP(1:1)
         IDIG = IDIG + 1
      END IF
      IF( MDEG .EQ.2 ) THEN
         OUTCH(IDIG:IDIG+1) = TEMP(3:4)
         IDIG = IDIG + 2
      ELSE
         OUTCH(IDIG:IDIG+2) = TEMP(2:4)
         IDIG = IDIG + 3
      END IF
      IF( DELIM(1:1).NE.'@' ) THEN
         OUTCH(IDIG:IDIG) = DELIM(1:1)
         IDIG = IDIG + 1
      END IF
C                 minutes
      OUTCH(IDIG:IDIG+1) = TEMP(5:6)
      IDIG = IDIG + 2
      IF( DELIM(2:2).NE.'@' ) THEN
         OUTCH(IDIG:IDIG) = DELIM(2:2)
         IDIG = IDIG + 1
      END IF
C                 seconds
      IF( SDIG.GE.1 ) THEN
         DO 200 I = 1,SDIG
            OUTCH(IDIG+I-1:IDIG+I-1) = TEMP(6+I:6+I)
200      CONTINUE
      END IF
      IDIG = IDIG + SDIG
C
      IF( DELIM(3:3).NE.'@' .AND. SDIG.NE.0 ) THEN
         OUTCH(IDIG:IDIG) = DELIM(3:3)
         IDIG = IDIG + 1
      END IF
C
C     Transfer OUTCH to TFORM.  Doing now rather than earlier
C     protects against cases when TFORM is to short for the number
C     of characters that were set.
C
      TFORM = OUTCH
C
      RETURN
      END

      SUBROUTINE SLEW( ISCN, LSCN, ISTA )
C
C     This routine calculates the slew distances and time in
C     getting from scan LSCN to the current scan ISCN.  It is 
C     always called after a call to SCHSRC which sets the geometry
C     for the scan and determines the wrap.  Someday, maybe is should
C     be moved into SCHSRC, but for now, keep it out.
C
C     This routine is called from STAGEO, SUVOPT, and PLOTSTA, 
C     all of which call SCHSRC shortly before calling SLEW.
C
C     Units are degrees for Az, El, X, and Y.  Ha is in hours.  Dec
C     is radians on input, but the DEC4 parameters are degrees.
C     Slew time is in fractional days at the end.
C
C     It turns out that there is a "retarded" effect (like retarded
C     baselines) that becomes significant with long slews on slow
C     antennas.  It can change the slew time by several, to more than
C     ten, seconds.  It is a result of the fact that the Earth rotates
C     causing the Az and El to change during the slew.  This routine,
C     up to Dec. 2010, did not take that effect into account and just
C     used the positions calculated earlier by SCHSRC for the start
C     of the next observation.  It has now been modified to calculate
C     the slew time, then get the geometry for the calculated arrival
C     time, and then recalculate the slew time.  One iteration like
C     that should be sufficient.  Keep the same wrap for azimuth as
C     in the nominal data, and don't modify the nominal scan data.
C     Those are for the start time - common to all antennas - while 
C     the position at the end of the slew is very specific to this
C     antenna.
C
C     For now, this routine does not reconsider the wrap state at
C     the antenna.  There will be rare cases where doing the 
C     position calculations for the improved times in the second pass
C     would cause a wrap to be required that was not detected by 
C     SCHSRC.  We ignore that possiblility now.
C
C     Note that valid mount types are checked in HORCHK.
C
      INCLUDE 'sched.inc'
C
      INTEGER            ISCN, KSCN, LSCN, ISTA, KSTA, PASS, KS
      REAL               LASTAX1, LASTAX2, CURAX1, CURAX2
      LOGICAL            KSUSED, OKLEV
      DOUBLE PRECISION   AX1SLEW, AX2SLEW, DMINSU, TARRIVE
      REAL               TACC1, TACC2, DACC1, DACC2, TSLW1, TSLW2
      REAL               RATE1, RATE2, AX1ADU, AX2ADU
      REAL               LDEC4, DEC4
      REAL               AHA, AEL, AAZ, APA, AZDIFF
      DOUBLE PRECISION   ALSTTIM
C --------------------------------------------------------------
      IF( DEBUG .AND. ISCN .LE. 3 ) CALL WLOG( 0, 'SLEW: Starting.' )
C
      KSTA = STANUM(ISTA)
C
C     Do the calculation for an actual move.
C
C     First get the previous position. 
C     
      IF( LSCN .EQ. 0 ) THEN
C     
C        First scan.
C     
C        Usually VLBI runs are not back to back and the antennas are
C        given a bit of time to get to source before the start.  So
C        assume that the telescope is at the beginning-of-scan position
C        at the start of the first scan.  This is a change as of Dec. 12
C        2010.
C
         LDEC4 = DECP(SRCNUM(ISCN)) / RADDEG
         CALL ANTPOS( KSTA, ISCN, ' ', LDEC4,
     1           AZ1(ISCN,ISTA), EL1(ISCN,ISTA), HA1(ISCN,ISTA), 
     2           LASTAX1, LASTAX2 )
C     
      ELSE
C     
C        Get position at end of scan LSCN.  Note wrap position in Az
C        should have been established already by routine WRAP.
C        This is the position at the start of the slew.
C     
         LDEC4 = DECP(SRCNUM(LSCN)) / RADDEG
         CALL ANTPOS( KSTA, LSCN, UP2(LSCN,ISTA), LDEC4,
     1           AZ2(LSCN,ISTA), EL2(LSCN,ISTA), HA2(LSCN,ISTA),
     2           LASTAX1, LASTAX2 )
C     
      END IF
C
C     Now get the position when the antenna arrives on-source for the
C     current scan.
C
C     Go through the next bit of code twice to iterate the slew time
C     based on the arrival time at the new source.  This is what
C     I call a "retarded slew" calculation.  It takes into account
C     the fact that the Earth rotates, and source positions in units
C     like Az and El change during the slew.  This effect can cause
C     errors of 10 sec or more in the slew time calculation with slow
C     antennas.  Note that the slew time calculation done with this
C     iteration is almost independent on the estimated scan start
C     time - it is based on where the antenna was at the end of the
C     previous scan and the coordinates of the destination source,
C     along with the slew rates.
C
      DO PASS = 1, 2
C
         IF( PASS .EQ. 1 ) THEN
C
C           On PASS 1, use the positions for the new source at the 
C           nominal start time of the scan.  These were calculated
C           by calls to SCHGEO and WRAP before SLEW was called
C     
            DEC4 = DECP(SRCNUM(ISCN)) / RADDEG
            CALL ANTPOS( KSTA, ISCN, UP1(ISCN,ISTA), DEC4,
     1           AZ1(ISCN,ISTA), EL1(ISCN,ISTA), HA1(ISCN,ISTA),
     2           CURAX1, CURAX2 )
C
         ELSE IF( LSCN .NE. 0 ) THEN
C
C           Recalculate the slew based on the geometry at the
C           actual arrival time.
C           First get that arrival time based on the first pass 
C           calculation.  The first pass number has not yet
C           had the settle time added or been converted to days.
C           We don't want the settle time here.  Do the day
C           conversion from seconds.
C
            TARRIVE = STOPJ(LSCN) + 
     1                TSLEW(ISCN,ISTA) / ( 1440.0D0 * 60.D0 )
C
C           Get the geometry.  Note that ISCN is only used to get
C           the station and source coordinates.  SCHGEO does not
C           modify any of the values in the arrays of scan data.
C
            CALL SCHGEO( ISCN, ISTA, TARRIVE, 
     1                   AHA, AEL, AAZ, ALSTTIM, APA )
C
C           If necessary, shift the azimuth to the wrap given
C           by the previous call to WRAP (before SLEW was called).
C
C            write(*,*) '   slew test 1: ', iscn, ista,
C     1              '  el: ', el1(iscn,ista), ael, 
C     2              '  az: ', az1(iscn,ista), aaz
            AZDIFF = AAZ - AZ1(ISCN,ISTA)
            AZDIFF = NINT( AZDIFF / 360.0 ) * 360.0            
            AAZ = AAZ - AZDIFF
C            write(*,*) 'slew test out ', iscn, ista, ' modified az: ',
C     1              aaz, azdiff
C
C           Now get the position in the telescope's native axes.
C           Can get into trouble with the limits consistency check if
C           the antenna is near its limits and the original estimate
C           was on one side and the new is on the other side.
C
            CALL ANTPOS( KSTA, ISCN, UP1(ISCN,ISTA), DEC4,
     1           AAZ, AEL, AHA, CURAX1, CURAX2 )
C
         ELSE
C
C           First scan.  Just keep the CURAX1 and CURAX2 from pass 1.
C
         END IF
C        
C        
C        Get the slew time in minutes.  All rates assumed to be deg/min.
C        Acceleration is assumed to be in deg/s/s.
C        Consider the two cases of when the antenna reaches full speed
C        and when it has to start slowing before reaching full speed.
C        TACC and DACC are the total time and distance spent both
C        accelerating and decelerating.
C        Note that the equation for DACC does not show two factors of
C        2 that cancel, one for both acceleration and deceleration, and
C        the other from D=0.5at^2.
C        Likewise, the equation for TSLEW in the case of not reaching
C        full speed is really T = 2sqrt(2(D/2)/a).
C        TACC1 and TACC2 are in seconds.
C        RATE1 and RATE2 are deg/sec  (trying to use seconds for all).
C        
C        The above was for the original implementation of acceleration.
C        It assumed acceleration and deceleration were the same.  But some
C        antennas, including the DSN, have different rates.
C        
C        First the slew distance.
C        
         AX1SLEW = ABS( CURAX1 - LASTAX1 )
         AX2SLEW = ABS( CURAX2 - LASTAX2 )
C        
C        Then how long does it take and how far does it go to get to
C        full speed.
C        
         RATE1 = AX1RATE(KSTA) / 60.0
         RATE2 = AX2RATE(KSTA) / 60.0
         AX1ADU = 1.0 / AX1ACC(1,KSTA) + 1.0 / AX1ACC(2,KSTA)
         AX2ADU = 1.0 / AX2ACC(1,KSTA) + 1.0 / AX2ACC(2,KSTA)
         TACC1 = RATE1 * AX1ADU
         TACC2 = RATE2 * AX2ADU
         DACC1 = RATE1**2 * AX1ADU * 0.5
         DACC2 = RATE2**2 * AX2ADU * 0.5
C        
C        Then get the actual time, with the method depending on whether
C        full speed was reached.
C        
         IF( AX1SLEW .LT. DACC1 ) THEN
            TSLW1 = SQRT( 2.0 * AX1SLEW * AX1ADU )
         ELSE
            TSLW1 = TACC1 + ( AX1SLEW - DACC1 ) / RATE1
         END IF
         IF( AX2SLEW .LT. DACC2 ) THEN
            TSLW2 = SQRT( 2.0 * AX2SLEW * AX2ADU )
         ELSE
            TSLW2 = TACC2 + ( AX2SLEW - DACC2 ) / RATE2
         END IF
C        
C        Use the largest.
C        
         TSLEW(ISCN,ISTA) = MAX( TSLW1, TSLW2 )
C
      END DO
C        
C     When there is no source change, there can be confusion.
C     Presumably the slew time is zero, assuming tracking continues.  
C     But when there is a gap between scans, the sky rotates a bit, 
C     and this routine used to come up with a non-zero slew time 
C     (second or two, typically, maybe more if there are GAPs scheduled).
C     That can be pretty confusing in the printouts.  So, set the 
C     actual slew time, before TSETTLE etc, to zero in this case.  But
C     don't always set it to zero.  If a wrap is needed, a long slew
C     may be required and would be reflected in the above calculations.
C     So only set TSLEW to zero if it is already small - implying no wrap.
C
      IF( LSCN .NE. 0 ) THEN
         IF( SRCNUM(LSCN) .EQ. SRCNUM(ISCN) .AND.
     1        TSLEW(ISCN,ISTA) .LT. 20.D0 * ONESEC ) THEN
            TSLEW(ISCN,ISTA) = 0.D0
         END IF
C   
C        Add the settling time for the station.  
C
         TSLEW(ISCN,ISTA) = TSLEW(ISCN,ISTA) + TSETTLE(KSTA)
      END IF
C
C     Make sure that the "slew" time does not drop below the minimum
C     setup time.
C
      DMINSU = MINSETUP(KSTA)
      TSLEW(ISCN,ISTA) = MAX( TSLEW(ISCN,ISTA), DMINSU )
C
C     Be sure there is time for the "set and remember" level setting
C     operation on the VLBA or VLA (or any other antenna with 
C     TLEVSET set non-zero).  There are special problems doing this
C     because SLEW is called often during calculations for trial 
C     scans that will not be part of the final schedule (pointing, 
C     DELZN, etc).  Those trials do need to know if the extra time 
C     will be added.  But having added it is no assurance that the 
C     station no longer needs the time - the scan that added it may 
C     not get used in the final schedule.  I don't see a clean 
C     solution to this, so, each time the routine is called, look 
C     back for a previous incidence of the setup.  Crude, but 
C     computers are fast now.
C
C     It turns out there is another issue.  Users will sometimes
C     schedule scans that are explicitly meant for the level setting,
C     especially on the VLA.  Try to sense when that happens, and
C     don't add the time for the level setting if it can be done
C     during the scan.
C
C     Check if this scan is the first with this setup.
C
      KS = NSETUP(ISCN,ISTA)
      KSUSED = .FALSE.
      KSCN = ISCN - 1
      DO WHILE( .NOT. KSUSED .AND. KSCN .GE. SCAN1 )
         IF( STASCN(KSCN,ISTA) .AND. NSETUP(KSCN,ISTA) .EQ. KS )
     1        THEN
            KSUSED = .TRUE.
         END IF
         KSCN = KSCN - 1
      END DO
C
C     Also see if this could be a level setting scan.
C
      OKLEV = NOREC(ISCN) .AND. 
     1        SNGL( DUR(ISCN) * 86400.D0 ) .GE. TLEVSET(KSTA) - 1
      IF( STANAME(ISTA)(1:3) .EQ. 'VLA' ) THEN
         OKLEV = OKLEV .AND. 
     1           VLAPEAK(ISCN) .NE. 'ADJUST' .AND. 
     2           VLAMODE(ISCN) .NE. 'VA'
      ELSE
         OKLEV = OKLEV .AND. DOPEAK(ISCN) .LT. 1
      END IF
C
C     Now if it is first, and the scan itself can't serve, then
C     claim the slew has to be long enough to accommodate the leve
C     setting.
C
      IF( .NOT. KSUSED .AND. .NOT. OKLEV ) THEN
C
C        Change index on TLEVSET from ISTA to KSTA Jan. 7, 2012 RCW.
C
         IF( TLEVSET(KSTA) .GT. TSLEW(ISCN,ISTA) ) THEN
            TSLEW(ISCN,ISTA) = TLEVSET(KSTA)
         END IF
      END IF
C
C     Convert TSLEW from seconds to fractional days.
C
      TSLEW(ISCN,ISTA) = TSLEW(ISCN,ISTA) / ( 1440.0D0 * 60.D0 )
C
      RETURN
      END

      DOUBLE PRECISION FUNCTION sla_DAT (UTC)
*+
*     - - - -
*      D A T
*     - - - -
*
*  Increment to be applied to Coordinated Universal Time UTC to give
*  International Atomic Time TAI (double precision)
*
*  Given:
*     UTC      d      UTC date as a modified JD (JD-2400000.5)
*
*  Result:  TAI-UTC in seconds
*
*  Notes:
*
*  1  The UTC is specified to be a date rather than a time to indicate
*     that care needs to be taken not to specify an instant which lies
*     within a leap second.  Though in most cases UTC can include the
*     fractional part, correct behaviour on the day of a leap second
*     can only be guaranteed up to the end of the second 23:59:59.
*
*  2  For epochs from 1961 January 1 onwards, the expressions from the
*     file ftp://maia.usno.navy.mil/ser7/tai-utc.dat are used.
*
*  3  The 5ms time step at 1961 January 1 is taken from 2.58.1 (p87) of
*     the 1992 Explanatory Supplement.
*
*  4  UTC began at 1960 January 1.0 (JD 2436934.5) and it is improper
*     to call the routine with an earlier epoch.  However, if this
*     is attempted, the TAI-UTC expression for the year 1960 is used.
*
*
*     :-----------------------------------------:
*     :                                         :
*     :                IMPORTANT                :
*     :                                         :
*     :  This routine must be updated on each   :
*     :     occasion that a leap second is      :
*     :                announced                :
*     :                                         :
*     :  Latest leap second:  2009 January 1    :
*     :                                         :
*     :-----------------------------------------:
*
* This copy of dat.f is being used by SCHED and other VLBA related
* programs at NRAO, Socorro.
* SCHED!!!!!!
*     Note for SCHED maintainer.  Be sure to update the
*     same information in the naif kernel file.
*     as of Feb 2006, that is $PLANET_DATA/naif0007.tls
*
*
*  Last revision before import to RCW libraries:   5 July 2008
*  Updated by RCW March 28, 2013 for July 2012 leap second.
*
*  Copyright P.T.Wallace.  All rights reserved.
*-

      IMPLICIT NONE

      DOUBLE PRECISION UTC

      DOUBLE PRECISION DT



      IF (.FALSE.) THEN

* - - - - - - - - - - - - - - - - - - - - - - *
*  Add new code here on each occasion that a  *
*  leap second is announced, and update the   *
*  preamble comments appropriately.           *
* - - - - - - - - - - - - - - - - - - - - - - *

*     2017 January 1
      ELSE IF (UTC.GE.57754D0) THEN
         DT=37.D0

*     2015 July 1
      ELSE IF (UTC.GE.57204D0) THEN
         DT=36.D0

*     2012 July 1
      ELSE IF (UTC.GE.56109D0) THEN
         DT=35.D0

*     2009 January 1
      ELSE IF (UTC.GE.54832D0) THEN
         DT=34D0

*     2006 January 1
      ELSE IF (UTC.GE.53736D0) THEN
         DT=33D0

*     1999 January 1
      ELSE IF (UTC.GE.51179D0) THEN
         DT=32D0

*     1997 July 1
      ELSE IF (UTC.GE.50630D0) THEN
         DT=31D0

*     1996 January 1
      ELSE IF (UTC.GE.50083D0) THEN
         DT=30D0

*     1994 July 1
      ELSE IF (UTC.GE.49534D0) THEN
         DT=29D0

*     1993 July 1
      ELSE IF (UTC.GE.49169D0) THEN
         DT=28D0

*     1992 July 1
      ELSE IF (UTC.GE.48804D0) THEN
         DT=27D0

*     1991 January 1
      ELSE IF (UTC.GE.48257D0) THEN
         DT=26D0

*     1990 January 1
      ELSE IF (UTC.GE.47892D0) THEN
         DT=25D0

*     1988 January 1
      ELSE IF (UTC.GE.47161D0) THEN
         DT=24D0

*     1985 July 1
      ELSE IF (UTC.GE.46247D0) THEN
         DT=23D0

*     1983 July 1
      ELSE IF (UTC.GE.45516D0) THEN
         DT=22D0

*     1982 July 1
      ELSE IF (UTC.GE.45151D0) THEN
         DT=21D0

*     1981 July 1
      ELSE IF (UTC.GE.44786D0) THEN
         DT=20D0

*     1980 January 1
      ELSE IF (UTC.GE.44239D0) THEN
         DT=19D0

*     1979 January 1
      ELSE IF (UTC.GE.43874D0) THEN
         DT=18D0

*     1978 January 1
      ELSE IF (UTC.GE.43509D0) THEN
         DT=17D0

*     1977 January 1
      ELSE IF (UTC.GE.43144D0) THEN
         DT=16D0

*     1976 January 1
      ELSE IF (UTC.GE.42778D0) THEN
         DT=15D0

*     1975 January 1
      ELSE IF (UTC.GE.42413D0) THEN
         DT=14D0

*     1974 January 1
      ELSE IF (UTC.GE.42048D0) THEN
         DT=13D0

*     1973 January 1
      ELSE IF (UTC.GE.41683D0) THEN
         DT=12D0

*     1972 July 1
      ELSE IF (UTC.GE.41499D0) THEN
         DT=11D0

*     1972 January 1
      ELSE IF (UTC.GE.41317D0) THEN
         DT=10D0

*     1968 February 1
      ELSE IF (UTC.GE.39887D0) THEN
         DT=4.2131700D0+(UTC-39126D0)*0.002592D0

*     1966 January 1
      ELSE IF (UTC.GE.39126D0) THEN
         DT=4.3131700D0+(UTC-39126D0)*0.002592D0

*     1965 September 1
      ELSE IF (UTC.GE.39004D0) THEN
         DT=3.8401300D0+(UTC-38761D0)*0.001296D0

*     1965 July 1
      ELSE IF (UTC.GE.38942D0) THEN
         DT=3.7401300D0+(UTC-38761D0)*0.001296D0

*     1965 March 1
      ELSE IF (UTC.GE.38820D0) THEN
         DT=3.6401300D0+(UTC-38761D0)*0.001296D0

*     1965 January 1
      ELSE IF (UTC.GE.38761D0) THEN
         DT=3.5401300D0+(UTC-38761D0)*0.001296D0

*     1964 September 1
      ELSE IF (UTC.GE.38639D0) THEN
         DT=3.4401300D0+(UTC-38761D0)*0.001296D0

*     1964 April 1
      ELSE IF (UTC.GE.38486D0) THEN
         DT=3.3401300D0+(UTC-38761D0)*0.001296D0

*     1964 January 1
      ELSE IF (UTC.GE.38395D0) THEN
         DT=3.2401300D0+(UTC-38761D0)*0.001296D0

*     1963 November 1
      ELSE IF (UTC.GE.38334D0) THEN
         DT=1.9458580D0+(UTC-37665D0)*0.0011232D0

*     1962 January 1
      ELSE IF (UTC.GE.37665D0) THEN
         DT=1.8458580D0+(UTC-37665D0)*0.0011232D0

*     1961 August 1
      ELSE IF (UTC.GE.37512D0) THEN
         DT=1.3728180D0+(UTC-37300D0)*0.001296D0

*     1961 January 1
      ELSE IF (UTC.GE.37300D0) THEN
         DT=1.4228180D0+(UTC-37300D0)*0.001296D0

*     Before that
      ELSE
         DT=1.4178180D0+(UTC-37300D0)*0.001296D0

      END IF

      sla_DAT=DT

      END

      SUBROUTINE CHKIF( KS, RESULT, LOSUM, BBCBW )
C
C     Subroutine to check that frequencies are within the IF's.
C     Before this routine was available, only setup frequencies 
C     were checked.  Doppler and user set frequencies were not
C     checked.
C
C     This routine depends on the variables FIFMIN and FIFMAX
C     being set for each IF and setup.
C
C     This should only be called when DOPPLER or FREQ or BW are
C     used.  In those cases, SCHED prevents inconsistent channelization.
C     Otherwise there is potential confusion with channelization.
C
      INCLUDE      'sched.inc'
      INCLUDE      'schset.inc'
C
      INTEGER            KS, ICH
      DOUBLE PRECISION   BWTOT, OVERLAP, OVERCH
      CHARACTER          RESULT*(*)
      DOUBLE PRECISION   BBCBW(MCHAN)
      DOUBLE PRECISION   LOSUM(MCHAN)
C ---------------------------------------------------------------------
C     Check for how much frequency overlap exists with the IFs.
C     This used to be done checking using FREQ and BW rather than
C     LOSUM and BBCBW, but ran into problems when one or the other
C     of those two was zero for the scan.
C
      BWTOT = 0.D0
      OVERLAP = 0.D0
      DO ICH = 1, NCHAN(KS)
         IF( NETSIDE(ICH,KS) .EQ. 'U' ) THEN 
            OVERCH = MIN( LOSUM(ICH) + BBCBW(ICH), 
     1                     FIFMAX(ICH,KS) ) - 
     2                MAX( LOSUM(ICH), FIFMIN(ICH,KS) )
            OVERCH = MAX( OVERCH, 0.0D0 )
         ELSE
            OVERCH = MIN( LOSUM(ICH), FIFMAX(ICH,KS) ) - 
     1                MAX( LOSUM(ICH) - BBCBW(ICH), 
     2                     FIFMIN(ICH,KS) )
            OVERCH = MAX( OVERCH, 0.0D0 )
         END IF
         OVERLAP = OVERLAP + OVERCH
         BWTOT = BWTOT + BBCBW(ICH)
      END DO
C
C     Check how the overlap did.  Protect against bit rounding.
C
      IF( OVERLAP .GE. BWTOT * 0.99999D0 ) THEN
         RESULT = 'OK'
      ELSE
         WRITE( RESULT, '( A, F8.2, A, F8.2, A )' )
     1     ' Only ', OVERLAP, ' MHz of ', BWTOT, 
     2     ' MHz in scheduled channels is within IFs.'
      END IF
C
      RETURN
      END

C*VLBOPE -- open a VLB data file [Lunux-UNIX] with f2c
C+
      INTEGER FUNCTION VLBOPE (UNIT, RNAME, RTYPE, RSTATUS, RESULT)
      INTEGER UNIT
      CHARACTER*(*) RNAME
      CHARACTER*(*) RTYPE
      CHARACTER*(*) RSTATUS
      CHARACTER*(*) RESULT
C
C     f2c will not concatenate strings when one is declared *(*)!
C
      CHARACTER*1024 NAME
      CHARACTER*10   TYPE
      CHARACTER*10   STATUS
C
C Input parameters:
C   UNIT : Fortran unit number to be used
C   NAME : file name
C   TYPE : file type, one of the strings
C      'MERGE'  merge format
C      'FITS'   disk FITS format (image or uvfits)
C      'MODEL'  model file (text)
C      'TEXT'   arbitrary text file
C   STATUS :
C      'OLD' to open a file for reading (file must already exist)
C      'NEW' to open a new file for writing (file must not already
C            exist, unless the operating system can create a new
C            version)
C
C Output parameters:
C   VLBOPE : receives 1 if the file was opened successfully,
C      0 if the open failed
C   RESULT : receives the full file name, if the file
C      was opened successfully, or an error message (text) if the
C      open failed; the declared length of this variable should
C      be big enough to accommodate the result; 255 bytes should be
C      enough.
C
C Discussion: this encapsulates all system-dependent OPEN parameters
C like READONLY, CARRIAGECONTROL in a single subroutine.  Moving to
C a different operating system should require only this routine to be 
C changed, assuming the operating system can cope with Fortran formatted
C and unformatted read and write.
C-----------------------------------------------------------------------
      INTEGER ITYPE, ISTAT, IER, LEN1, BLKNO
      CHARACTER*11 FMT
      CHARACTER*4  CC
      CHARACTER*80 STRING
      COMMON /FITS2/ BLKNO
C
C     Transfer to local variables for concatenations.
C
      NAME = RNAME
      TYPE = RTYPE
      STATUS = RSTATUS
C
C Verify the TYPE argument.
C
      IF (TYPE.EQ.'MERGE') THEN
          ITYPE = 1
          FMT = 'UNFORMATTED'
          CC = 'NONE'
      ELSE IF (TYPE.EQ.'FITS') THEN
          ITYPE = 2
          FMT = 'UNFORMATTED'
          CC = 'NONE'
      ELSE IF (TYPE.EQ.'MODEL' .OR. TYPE.EQ.'TEXT') THEN
          ITYPE = 3
          FMT = 'FORMATTED'
          CC = 'LIST'
      ELSE
          CALL ERROR('VLBOPE: invalid argument TYPE='//TYPE)
      END IF
C
C Verify the STATUS argument.
C
      IF (STATUS.EQ.'OLD') THEN
          ISTAT = 1
      ELSE IF (STATUS.EQ.'NEW') THEN
          ISTAT = 2
      ELSE
          CALL ERROR('VLBOPE: invalid argument STATUS='//STATUS)
      END IF
C
C Attempt to open the file.
C
      IF (ISTAT.EQ.1) THEN
C         -- 'OLD' file
          IF (ITYPE.EQ.2) THEN
              OPEN (UNIT=UNIT, FILE=NAME, STATUS='OLD',
C    1              RECORDTYPE='FIXED', 
     2              RECL=720, 
     3              ACCESS='DIRECT',
C    4              READONLY, 
     5              FORM='UNFORMATTED', 
     6              IOSTAT=IER)
              BLKNO = 0
          ELSE
              OPEN (UNIT=UNIT, FILE=NAME, STATUS='OLD',
C    1              READONLY, 
     2              ACCESS='SEQUENTIAL', FORM=FMT, IOSTAT=IER)
          END IF
      ELSE
C         -- 'NEW' file
          IF (ITYPE.EQ.2) THEN
              OPEN (UNIT=UNIT, 
     :              FILE=NAME,
     :              STATUS='NEW',
C    :              RECORDTYPE='FIXED',
     :              ACCESS='DIRECT',
     :              RECL=720,
     :              FORM='UNFORMATTED', 
     :              IOSTAT=IER)
          ELSE
              OPEN (UNIT=UNIT, FILE=NAME, STATUS='NEW',
     1              ACCESS='SEQUENTIAL', FORM=FMT, 
C    2              CARRIAGECONTROL=CC, 
     3              IOSTAT=IER)
          END IF
      END IF
C
C Success: find the complete file name.
C
      IF (IER.EQ.0) THEN
          INQUIRE (UNIT=UNIT, NAME=RESULT)
          VLBOPE = 1
C
C Failure: determine the error, and issue a message.
C
      ELSE
          IF (ISTAT.EQ.1) THEN
              CALL PUTOUT('++ Cannot find '//TYPE//' file: '//
     1                NAME(1:LEN1(NAME)))
          ELSE
              CALL PUTOUT('++ Cannot create '//TYPE//' file: '//
     1                NAME(1:LEN1(NAME)))
          END IF
          CALL GERROR(STRING)
          CALL PUTOUT('++ '//STRING(1:LEN1(STRING)))
          RESULT = STRING
          VLBOPE = 0
      END IF
C-----------------------------------------------------------------------
      END

      SUBROUTINE sla_AMPQK (RA, DA, AMPRMS, RM, DM)
*+
*     - - - - - -
*      A M P Q K
*     - - - - - -
*
*  Convert star RA,Dec from geocentric apparent to mean place
*
*  The mean coordinate system is the post IAU 1976 system,
*  loosely called FK5.
*
*  Use of this routine is appropriate when efficiency is important
*  and where many star positions are all to be transformed for
*  one epoch and equinox.  The star-independent parameters can be
*  obtained by calling the sla_MAPPA routine.
*
*  Given:
*     RA       d      apparent RA (radians)
*     DA       d      apparent Dec (radians)
*
*     AMPRMS   d(21)  star-independent mean-to-apparent parameters:
*
*       (1)      time interval for proper motion (Julian years)
*       (2-4)    barycentric position of the Earth (AU)
*       (5-7)    heliocentric direction of the Earth (unit vector)
*       (8)      (grav rad Sun)*2/(Sun-Earth distance)
*       (9-11)   ABV: barycentric Earth velocity in units of c
*       (12)     sqrt(1-v**2) where v=modulus(ABV)
*       (13-21)  precession/nutation (3,3) matrix
*
*  Returned:
*     RM       d      mean RA (radians)
*     DM       d      mean Dec (radians)
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Note:
*
*     Iterative techniques are used for the aberration and
*     light deflection corrections so that the routines
*     sla_AMP (or sla_AMPQK) and sla_MAP (or sla_MAPQK) are
*     accurate inverses;  even at the edge of the Sun's disc
*     the discrepancy is only about 1 nanoarcsecond.
*
*  Called:  sla_DCS2C, sla_DIMXV, sla_DVDV, sla_DVN, sla_DCC2S,
*           sla_DRANRM
*
*  P.T.Wallace   Starlink   7 May 2000
*
*  Copyright (C) 2000 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION RA,DA,AMPRMS(21),RM,DM

      INTEGER I,J

      DOUBLE PRECISION GR2E,AB1,EHN(3),ABV(3),P3(3),P2(3),
     :                 AB1P1,P1DV,P1DVP1,P1(3),W,PDE,PDEP1,P(3)

      DOUBLE PRECISION sla_DVDV,sla_DRANRM



*  Unpack scalar and vector parameters
      GR2E = AMPRMS(8)
      AB1 = AMPRMS(12)
      DO I=1,3
         EHN(I) = AMPRMS(I+4)
         ABV(I) = AMPRMS(I+8)
      END DO

*  Apparent RA,Dec to Cartesian
      CALL sla_DCS2C(RA,DA,P3)

*  Precession and nutation
      CALL sla_DIMXV(AMPRMS(13),P3,P2)

*  Aberration
      AB1P1 = AB1+1D0
      DO I=1,3
         P1(I) = P2(I)
      END DO
      DO J=1,2
         P1DV = sla_DVDV(P1,ABV)
         P1DVP1 = 1D0+P1DV
         W = 1D0+P1DV/AB1P1
         DO I=1,3
            P1(I) = (P1DVP1*P2(I)-W*ABV(I))/AB1
         END DO
         CALL sla_DVN(P1,P3,W)
         DO I=1,3
            P1(I) = P3(I)
         END DO
      END DO

*  Light deflection
      DO I=1,3
         P(I) = P1(I)
      END DO
      DO J=1,5
         PDE = sla_DVDV(P,EHN)
         PDEP1 = 1D0+PDE
         W = PDEP1-GR2E*PDE
         DO I=1,3
            P(I) = (PDEP1*P1(I)-GR2E*EHN(I))/W
         END DO
         CALL sla_DVN(P,P2,W)
         DO I=1,3
            P(I) = P2(I)
         END DO
      END DO

*  Mean RA,Dec
      CALL sla_DCC2S(P,RM,DM)
      RM = sla_DRANRM(RM)

      END

      SUBROUTINE PTVLBA( ISCN, PTADD, TSTOP, KS )
C
C     Writes pointing sequence.  
C
      INCLUDE     'sched.inc'
      INCLUDE     'schset.inc'
C
      INTEGER     I, PTADD, ISCN, IDUR, KS
      INTEGER     RLEVEL(MCHAN)
      REAL        DOAZ, DOEL
      CHARACTER   TSTOP*9
C --------------------------------------------------------------------
C     Get the center pointing position.  This is a sum from both
C     the main schedule and the setup file.
C
      DOAZ = SAZCOL(ISCN) + AZCOLIM(KS)
      DOEL = SELCOL(ISCN) + ELCOLIM(KS)
C
C     Do setup scan on half power point to get reasonable levels.
C     First go to half power point.  Note that subroutine VLBA
C     only does setup scans if tape is being written.
C
      DO I = 1, NCHAN(KS)
         RLEVEL(I) = -1 
      END DO
      CALL VLBAINT( 'level', 5, NCHAN(KS), RLEVEL, LLEVEL, MLEVEL,
     1           .FALSE., IUVBA )
      WRITE( IUVBA, '( ''azcolim='',F7.2, '' elcolim='',F7.2, 
     2      '' dur='',I4,''s'', /, 
     3      ''stop='', A, ''   !NEXT! '' )' )
     3      DOAZ - PTINCR(KS), 
     4      DOEL, PTSLEW(ISCN) + PTADD, TSTOP
C
C     Then sit there while fixing the BBC levels.  Take long
C     enough for this to get a pcx test.  Assume that 2 times
C     PTDUR will be long enough.
C
      DO I = 1, NCHAN(KS)
         RLEVEL(I) = 256
      END DO
      CALL VLBAINT( 'level', 5, NCHAN(KS), RLEVEL, LLEVEL, MLEVEL,
     1           .FALSE., IUVBA )
C
C     Check the scan duration - see if it is an even number of 
C     loops.
C
      IDUR = NINT( DUR(ISCN) * 86400.D0 ) - 2 * PTDUR - PTSLEW(ISCN)
      IF( MOD( IDUR, 10 * PTDUR ) .NE. 0 ) THEN
         CALL WLOG( 1, 'PTVLBA: Scan length is not an even number ' //
     1          'of pointing loops (PTSLEW+2*PTDUR+N*10*PTDUR).' )
      END IF
C
      CALL PTPAT( IUVBA, DOAZ, DOEL, PTINCR(KS), PTOFF(KS), PTDUR, 
     1            QUAL(ISCN) )
C
      RETURN
      END

      SUBROUTINE VXSCH( )
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 020596 
C     This routine generates a VEX format description
C     of the experiment $SCHED section only
C
C     Deleting tape stuff, including S2.  July 20, 2010  RCW.
C     Copy of original kept in sched_ARCHIVE_nonSVN/obsolete_routines/
C     and also in SVN versions 294 and earlier.
C
C     When USEDISK is false since tape was taken out, some elements of 
C     the lines were not written, causing parsing errors on read.  
C     fixed  Nov. 15, 2011  RCW.
C
C     Be selective about skipping FORMAT=NONE scans.  For now, do not
C     do so for VLBA stations.  Perhaps add more exceptions later,
C     or make it a stations.dat parameter, or make the Field System
C     happy with such scans.  RCW  Dec 8, 2011
C
C     Switch to use of TSCAL for warnings about calibration time.
C     Nov. 4, 2013  RCW.
C
C     Add the wrap zone specification, but block it temporarily
C     for most stations.  Jan 2014.  RCW.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER     ISCN, ISTA, LEN1, NCHR, INT, ILEN
      INTEGER     MCH, ICH, JCH1, JCH2
      INTEGER     DAY1, INTSTOP, LPOS, INPAGE
      INTEGER     YEAR, DATLAT
      INTEGER     TRANSTAR, TRANEND, TRANLEN, GRABSTOP
      INTEGER     I, LASTSCN, KS, NTSYS(MAXSTA)
      INTEGER     NTSYSON(MAXSTA), TSYSGAP(MAXSTA), TPDRIV
      REAL        STASPD(MANT) 
      CHARACTER   FULTIM*18, TMPSRC*32
      CHARACTER   LINE*132, TFORM*9, TRANTYPE*10, SCANNAME*10
      CHARACTER   DISKFILE*30, STNLC*2, ZONE*5
      DOUBLE PRECISION  STARTT, TAPOFF, IDAY
      LOGICAL     SKIPPED, WARNFS, WARNTS(MAXSTA), DATATRAN, WARNGP
      LOGICAL     GAPERR, SKIPNONE, TSYSMESS, WARNTSOF(MAXSTA)
      LOGICAL     ANYNONE, WARNBANK, OLDWARNB
      REAL        STGB, SCNGAP, MINGAP
C -------------------------------------------------------------
      IF (DEBUG) CALL WLOG( 1,'VXSCH: Start VEX SCHED section ')
      LINE = ' '      
      WARNFS = .FALSE.
      WARNGP = .FALSE.
      WARNBANK = .FALSE.
      OLDWARNB = .FALSE.
      DO ISTA = 1,NSTA
        WARNTSOF(ISTA) = .FALSE.
        NTSYSON(ISTA) = 0
        WARNTS(ISTA) = .FALSE.
        NTSYS(ISTA) = 0
        TSYSGAP(ISTA) = 0
      END DO
C
C     initalise STASPD, speed for stations
C
      DO ISTA=1,MANT
         STASPD(ISTA) = -1.0
      END DO
C
C     Old code called TIMEJ and TDATECW to set up a date line.  
C     But then the results were never used.  Removed Jan. 2, 2013
C
C     Write SCHED section add some comments in case this gets pasted
C     into VEX schedule
C
      WRITE( IVEX, '( A, A1, /, A1, 1X, A, A, /, A1, 1X, A )')  
     1     '$SCHED', SEP,
     2     COM,'schedule section for experiment ', EXPCODE, COM, EXPT
C
C     Now loop through scans. A few shortcuts are kept
C     RCW Jan. 2, 2013: Removed unneeded STARTT and STOPT initializations.
C     INTSTOP initialization probably not needed.  
C
      INPAGE = -100
      INTSTOP = 0
      DO ISCN = SCAN1, SCANL
C
C        If the scan was skipped, just note that fact.
C        This is likely to be because of some SCHED optimization mode.
C
         SKIPPED = .TRUE.
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) SKIPPED = .FALSE.
         END DO
C
C        Skip the scan if FORMAT=NONE and no stations need to keep
C        such scans (set SKIPNONE=.TRUE.).  SKIPNONE should end up 
C        false for any scan with a different format or for a scan that
C        includes stations, such as the VLBA, that needs such scans.
C        Such scans include reference pointing scans.
C        ANYNONE records whether the FORMAT=NONE regardless of whether
C        the scan will be retained.  It triggers a comment.
C
         SKIPNONE = .TRUE.
         ANYNONE = .FALSE.
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN  
               KS = NSETUP(ISCN,ISTA)
               IF( FORMAT(KS)(1:4) .NE. 'NONE' .OR. 
     1             STANAME(ISTA)(1:4) .EQ. 'VLBA'   ) THEN
                  SKIPNONE = .FALSE.
               END IF
               IF( FORMAT(KS)(1:4) .EQ. 'NONE' ) 
     1             ANYNONE = .TRUE.
            END IF
         END DO
C
C
C        Check various tape issues, return a common tape offset
C
         CALL VXSCHK( ISCN, TAPOFF, WARNFS, WARNTS, WARNTSOF, NTSYS,
     1                  NTSYSON, TSYSGAP, WARNBANK)
C        Let the user know which was the first scan to raise warnbank
         IF (.NOT. OLDWARNB .AND. WARNBANK) THEN
            CALL WLOG(0, ' ' )
            WRITE( MSGTXT, '(A)' )
     1         'VXSCH: The scan detailed below has exceeded the ' //
     2         'limit for continuous recording. Insert a gap ' //
     3         'before this scan, or reduce its length if necessary:'
            CALL WLOG(0, MSGTXT )
            CALL PRTSCN( ISCN, 'VXSCH' )
            CALL WLOG(0, ' ' )
         END IF
         OLDWARNB = WARNBANK
C
C
         IF( SKIPPED ) THEN
            TMPSRC = SCNSRC(ISCN)
            CALL VXSTNM( TMPSRC, .FALSE.)
            WRITE( IVEX, '(A1, 4X, A, A)' ) COM, 'Skipping scan on:',
     1          TMPSRC(1:LEN1(TMPSRC))
            INPAGE = INPAGE + 1
         ELSE IF( SKIPNONE ) THEN
C
C           Skip a scan with FORMAT=NONE if there are no stations that 
C           need to keep such scans, such as the VLBA.
C
            TMPSRC = SCNSRC(ISCN)
            CALL VXSTNM( TMPSRC, .FALSE.)
            MSGTXT = ' '
            WRITE( MSGTXT, '(A1, 4X, A, A, A)' ) COM, 'Skipping scan ',
     1          'with FORMAT=NONE on:',
     2          TMPSRC(1:LEN1(TMPSRC))
            WRITE( IVEX, '(A)' ) MSGTXT(1:LEN1(MSGTXT))
            INPAGE = INPAGE + 1
         ELSE
C  
C           Now process a good scan.
C           First write scanname, probably easiest and useful as number
C           Allow for more than 10000 - highly unlikely but just possible
C           with a 24 hr schedule of 15 second scans and using WRAP24
C           which turns it into a 48 hour schedule.
C
            IF( ISCN .LE. 9999 ) THEN
               WRITE( SCANNAME, '( A2, I4.4 )' ) 'No', ISCN
            ELSE
               WRITE( SCANNAME, '( A2, I5.5 )' ) 'No', ISCN
            END IF
            WRITE( IVEX, '( A, 1X, A, A, A1 )' )
     1           'scan', SCANNAME(1:LEN1(SCANNAME)), SEP
            INPAGE = INPAGE + 1
C
C           Maybe there's a comment.  DRUDG has a maximum line length
C           of 128 including the comment character.  ANNOT is 128
C           characters long and it is printed in the vex file with
C           8 other characters in front.  If needed, break the line.
C           Try to break at a word.
C
            IF (ANNOT(ISCN) .NE. ' ' ) THEN
               JCH1 = -1
               NCHR = LEN1( ANNOT(ISCN) )
               IF( NCHR .LE. 120 ) THEN
                  MCH = NCHR
                  JCH1 = 0
                  JCH2 = 0
               ELSE
                  DO ICH = 120, NCHR - 120 + 1, -1
                     IF( ANNOT(ISCN)(ICH:ICH) .EQ. ' ' ) THEN
                        MCH = ICH
                        JCH1 = ICH + 1
                        JCH2 = NCHR
                        GO TO 200
                     END IF
                  END DO
  200             CONTINUE
                  IF( JCH1 .EQ. -1 ) THEN
                     MCH = 120
                     JCH1 = 121
                     JCH2 = NCHR
                  END IF
               END IF
               IF( ANNOT(ISCN) .NE. ' ' ) THEN
                  WRITE( IVEX, '( A1, 5X, A )' ) COM, 
     1               'Note a COMMENT was inserted during scheduling: '
                  WRITE( IVEX, '( A1, 7X, A )' ) COM,
     1                      ANNOT(ISCN)(1:MCH)
                  INPAGE = INPAGE + 1
                  IF( JCH1 .GT. 1 ) THEN
                     WRITE( IVEX, '( A1, 10X, A )' ) COM, 
     1                      ANNOT(ISCN)(JCH1:JCH2)
                     INPAGE = INPAGE + 1
                  END IF
               END IF
            END IF
C
C           Add a comment for FORMAT=NONE scans.
C
            IF( ANYNONE ) THEN
               WRITE( IVEX, '( A1, 5X, A )' ) COM,
     1            'This is a FORMAT=NONE, non-recording scan.'
               INPAGE = INPAGE + 1
            END IF
C
C           Add any intents.  This is as comments for now.
C
            IF( NSCINT(ISCN) .GE. 1 ) THEN
               DO INT = 1, NSCINT(ISCN)
                  LINE = ' '
                  ILEN = LEN1( INTENT(ISCINT(INT,ISCN)) )
                  WRITE( LINE, '( 5A )' ) COM,
     1                ' intent = ', QOT, 
     2                INTENT(ISCINT(INT,ISCN))(1:ILEN), QOT
                  WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
                  INPAGE = INPAGE + 1
               END DO
C
C              For VLA phasing scans, add the phasing subscan length.
C              This is here because there is a scan dependent argument
C              in the INTENT.
C
               IF( PHASING(ISCN) ) THEN
                  WRITE( LINE, '( 4A, I3.3, A )' ) COM,
     1                ' intent = ', QOT, 
     2                'VLA:PHASE_SUBSCAN=', VLAPTIME(ISCN), QOT
                  WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
                  INPAGE = INPAGE + 1
               END IF
            END IF
C
C           May move scan time fwd for tapestart: then write comment
C
C            print*, 'tapoff=',ABS(TAPOFF*86400d0) 
            IF ( ABS(TAPOFF*86400d0) .GT. 1 ) THEN 
               CALL TIMEJ( STARTJ(ISCN), YEAR, DAY1, STARTT )
               WRITE( FULTIM(1:5), '( I4, A1 )' ) YEAR,'y'
               WRITE( FULTIM(6:9), '( I3.3, A1 )' ) DAY1,'d'
               FULTIM(10:18) = TFORM( STARTT, 'T', 0, 2, 2, 'hms' )

               WRITE( LINE, '( A1, 4X, A, A, A, A )' ) 
     1             COM, 'start=', FULTIM, ' <= original start, ',
     2             'modified for tape start.'

               WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
               INPAGE = INPAGE + 1
            END IF
C                  
C           Get scan times.  Be sure to use the start time year, day
C           etc.  RCW Jan. 2, 2013 after problem at year boundary.
C           There was a call to TIMEJ for the STOPJ too, but the output
C           wasn't used for anything so it was removed.
C           
C
            CALL TIMEJ( (STARTJ(ISCN)-TAPOFF), YEAR, DAY1, STARTT )
            WRITE( FULTIM(1:5), '( I4, A1 )' ) YEAR,'y'
            WRITE( FULTIM(6:9), '( I3.3, A1 )' ) DAY1,'d'
            FULTIM(10:18) = TFORM( STARTT, 'T', 0, 2, 2, 'hms' )
C        
            WRITE( LINE, '( 5X, A, A, A1 )' ) 
     1          'start=', FULTIM, SEP
C            
C           write mode, why not use 1 line for compactness
C
            LPOS = LEN1(LINE)+1
            WRITE( LINE(LPOS:) , '( 1X, A, A, A1 )' ) 'mode=',
     1          MDLINK(MODSCN(ISCN))(1:LEN1(MDLINK(MODSCN(ISCN)))), 
     2          SEP
C  
C           Write source
C
            LPOS = LEN1(LINE)+1
            TMPSRC = SCNSRC(ISCN)
            CALL VXSTNM( TMPSRC, .FALSE. )
            WRITE( LINE(LPOS:) , '( 1X, A, A, A1 )' ) 'source=',
     1          TMPSRC(1:LEN1(TMPSRC)), SEP
C
C           Flush line
C
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
            INPAGE = INPAGE + 1
C
C           Write the data_transfer section, if appropriate
C
            DATATRAN = .FALSE.
C
C           first, a sanity check
C
            IF( GRABTO(ISCN) .EQ. 'FILE' .AND. DATAPATH(ISCN) .EQ.
     1                  'IN2NET' ) THEN
              CALL PRTSCN( ISCN, 'VXSCH' )
              WRITE ( MSGTXT, '(A, A, A)' ) 
     1          'VXSCH: You have requested a GRABTO (ftp) scan, but ',
     2          'you are  not recording to disk. You must set ',
     3          'DATAPATH=IN2DISK'
              CALL ERRLOG ( MSGTXT )
            END IF
            IF( GRABTO(ISCN) .EQ. 'NET' ) THEN
              CALL PRTSCN( ISCN, 'VXSCH' )
              WRITE ( MSGTXT, '(A, A)' ) 
     1          'VXSCH: You have requested GRABTO=NET, but ',
     2          'that is not supported in VEX and will be ignored. '
              CALL WLOG ( 1, MSGTXT )
            END IF
C
C           set things up for an ftp scan
C           Note default on read (from inmain.f) for GRABTIMEs 1 and 2
C           is UNSET = -9999.D0.  Here test against LT zero. This was 
C           to allow GRABTIME(2) to be zero which didn't work before.  
C           Feb. 20, 2013  RCW.
C           
C           In defaults.f, the GRABTIME=30,10 defaults were set when 
C           GRABTO is not "NONE" and DATAPATH is IN2DISK so there
C           may be some duplication of effort going on.
C
            IF( GRABTO(ISCN) .EQ. 'FILE' ) THEN
C              ftp scans
               WRITE( IVEX, '( A, A )' ) COM, ' ftp scan'
               DATATRAN = .TRUE.
               TRANTYPE = 'disk2file'
               INTSTOP = NINT( ( STOPJ(ISCN) - 
     .             (STARTJ(ISCN)-TAPOFF) ) 
     1             * 86400d0)
C              default TRANLEN should be 30 seconds               
               TRANLEN = NINT(GRABTIME(1,ISCN) )
               IF ( TRANLEN .LE. 0) TRANLEN = 30
C              default TRANEND should be 10 seconds from end of scan
               GRABSTOP = NINT (GRABTIME(2,ISCN))
               IF (GRABSTOP .LT. 0) GRABSTOP = 10
               TRANSTAR = INTSTOP - (TRANLEN + GRABSTOP)
               TRANEND = INTSTOP - GRABSTOP
C              check the transfer time is consistent with the scan length
               IF (TRANSTAR .LT. 0 .OR. TRANEND .LT. 0 .OR. 
     1                  TRANSTAR .GT. TRANEND) THEN
                 CALL WRTMSG( 0, 'VXSCH', 'vexgrabtime')
                 CALL PRTSCN( ISCN, 'VXSCH' )
                 WRITE( MSGTXT, '( A, A, A, A )' )
     1              'VXSCH:   WARNING: You have scheduled a GRABTO ',
     2              'scan, but the GRABTIME is not consistent with ',
     3              'the scan length. Please increase the scan length ',
     4              'or change the GRABTIME parameters.'
                 CALL ERRLOG( MSGTXT )
               END IF
            END IF
C
C           set things up for an evlbi scan
C
            IF( DATAPATH(ISCN) .EQ. 'IN2NET' ) THEN
C              evlbi scans
               WRITE( IVEX, '( A, A )' ) COM, ' eVLBI scan'
               DATATRAN = .TRUE.
               TRANTYPE = 'in2net'
               INTSTOP = NINT( ( STOPJ(ISCN) - 
     .             (STARTJ(ISCN)-TAPOFF) ) 
     1             * 86400d0)
C              for evlbi always transfer whole scan, so don't fill in the
C               transfer times
C               TRANLEN = NINT(GRABTIME(1,ISCN) )
C               TRANLEN = INTSTOP
C               TRANSTAR = INTSTOP - TRANLEN 
C               TRANEND = INTSTOP 
            END IF
C           Write the data_transfer statements
            IF ( DATATRAN ) THEN
C
C              Make sure that we are not continuous recording from
C              the previous scan. Insist on a 10 second gap (this can
C              be shorter when we get rid of adaptive tape motion).
C
               IF( ISCN .GT. SCAN1 ) THEN
                  SCNGAP = REAL( ( STARTJ(ISCN) - TAPOFF 
     1                          - STOPJ (ISCN-1) ) * 86400.d0)
                  IF ( GRABTO(ISCN) .EQ. 'FILE' ) THEN
                    MINGAP = 11.0
                  END IF
                  IF ( DATAPATH(ISCN) .EQ. 'IN2NET' ) THEN
                    IF ( ISCN .GT. SCAN1 .AND. DATAPATH(ISCN) .NE.
     1                             DATAPATH(ISCN-1) ) THEN
                      MINGAP = 11.0
                    ELSE
                      MINGAP = 0.0
                    END IF
                  END IF
C                      
                  IF ( ISCN .GT. SCAN1 .AND. SCNGAP .LT. MINGAP ) THEN
                    CALL PRTSCN ( ISCN, 'VXSCH' )
                    WRITE ( MSGTXT, '(A, A, A, I4, A)' )
     1              'VXSCH: You have scheduled an ftp or eVLBI ',
     2              'scan as part of continuous recording - you must ',
     3              'leave a ', NINT(MINGAP), 
     4              ' second gap before the scan.'
                    CALL ERRLOG ( MSGTXT )
                  END IF
               END IF
C
C              write the data transfer statements for each station
C
               DO ISTA = 1, NSTA
C
C                 check if enough time is available at the end of the scan
C                 to do the ftp data transfer - print warning if not
C
                  IF( GRABTO(ISCN) .EQ. 'FILE' .AND. ISCN .LT. SCANL) 
     1                                                          THEN
                     CALL VXTRAN ( TRANLEN, ISCN, ISTA, GAPERR )
                     IF (GAPERR) WARNGP = .TRUE.
                  END IF
                  LINE = ' '
                  LPOS = 6
                  IF( STASCN(ISCN,ISTA) ) THEN
C                   Form the file name
                    IF( GRABTO(ISCN) .EQ. 'FILE' ) THEN
                      WRITE( STNLC, '(A)') STCODE(STANUM(ISTA))(1:2)
                      CALL DWCASE( STNLC )
                      WRITE( DISKFILE, '( A, A1, A2, A1, A, A1, A3 )' )
     1                   EXPCODE(1:LEN1(EXPCODE)), '_', 
     2                   STNLC(1:2), '_', 
     3                   SCANNAME(1:LEN1(SCANNAME)), '.', 'm5a'
                     ELSE
                       WRITE( DISKFILE, '( 1X )' )
                     END IF
C                       
                     WRITE( LINE(LPOS:LPOS+14), '( A )' ) 
     1                      'data_transfer='
                     LPOS = LEN1(LINE) + 1
                     WRITE( LINE(LPOS:LPOS+3), '( A2, A1 )' ) 
     1                    STCODE(STANUM(ISTA))(1:2), COL
                     LPOS = LEN1(LINE) + 1
                     WRITE( LINE(LPOS:LPOS+12), '( 1X, A, A1 )' ) 
     1                    TRANTYPE(1:LEN1(TRANTYPE)), COL
                     LPOS = LEN1(LINE) + 1
                     WRITE( LINE(LPOS:), '( 1X, A, A1 )' ) 
     1                    DISKFILE(1:LEN1(DISKFILE)), COL
                     LPOS = LEN1(LINE) + 1
                     IF( GRABTO(ISCN) .EQ. 'FILE' ) THEN
                       WRITE( LINE(LPOS:), '( I5, 1X, A, A1 )' ) 
     1                      TRANSTAR, 'sec', COL
                     ELSE IF( DATAPATH(ISCN) .EQ. 'IN2NET' ) THEN
                       WRITE( LINE(LPOS:), '( 1X, A1 )' ) COL
                     END IF
                     LPOS = LEN1(LINE) + 1
                     IF( GRABTO(ISCN) .EQ. 'FILE' ) THEN
                       WRITE( LINE(LPOS:), '( I5, 1X, A, A1 )' ) 
     1                      TRANEND, 'sec', COL
                     ELSE IF( DATAPATH(ISCN) .EQ. 'IN2NET' ) THEN
                       WRITE( LINE(LPOS:), '( 1X, A1 )' ) COL
                     END IF
                     LPOS = LEN1(LINE) + 1
C                    for now, the 'options' field is always blank. 
                     WRITE( LINE(LPOS:), '( 1X, A1 )' ) 
     1                    SEP
C                     LPOS = LEN1(LINE) + 1
                  END IF
                  WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
               END DO
            END IF
C     
C           Write the antenna based data, maybe start with header
C     
            IF( INPAGE .GT. 78 ) INPAGE = 0
            IF( INPAGE .LE. 0 ) THEN
               WRITE(IVEX, '( A1, 14X, A1, A9, A1, A9, A1, A9, A1, 
     1             A5, A1, A7, A1, A4, A1, A7 )' )
     2             COM, COL, 'data_good', COL, 'data_stop', COL, 
     3             'goto_foot', COL,
     4             ' pass', COL, '  wrap ', COL, 'driv',COL, 'tape at'
               INPAGE = 1
            END IF
            DO ISTA = 1, NSTA
C
C              Do not write non-VLBA stations for which FORMAT=NONE
C              Note use of NSETUP rather than MODSET.  I think this
C              should be equivalent.  This is a step toward using 
C              the main SCHED bookkeeping which I think will be 
C              simpler.
C
               IF( STASCN(ISCN,ISTA) .AND. (
     1              STANAME(ISTA)(1:4) .EQ. 'VLBA' .OR.
     2              FORMAT(NSETUP(ISCN,ISTA)) .NE. 'NONE' ) ) THEN
C     
C                 Write this in fixed format use LINE
C
                  LINE = ' '
                  LPOS = 6
                  WRITE( LINE(LPOS:LPOS+7), '( A )' ) 'station='
C
C                 Station code
C                     
                  LPOS = LEN1(LINE) + 1
                  WRITE( LINE(LPOS:LPOS+2), '( A2, A1 )' )  
     1                 STCODE(STANUM(ISTA))(1:2), COL
C
C                 next is start time in job with good data
C
                  LPOS = LEN1(LINE) + 1
C
C                 estimate good data start based on slewing
C
                  DATLAT = IDNINT( ( TONSRC(ISCN,ISTA) - 
     .                (STARTJ(ISCN) - TAPOFF) ) 
     1                * 86400D0 )
                  IF( DATLAT .LE. 0 ) DATLAT = 0
C
C                 Write INTSTOP, last bit af good data 
C                 Use a difference of integers to avoid round off 
C                 situations giving a duration one second too large.
C                 This gets a bit tricky because the numbers for
C                 the Julian days are too big to be held in a normal
C                 integer, so the high order digits need to be 
C                 subtracted first.
C
                  IDAY = DINT( STARTJ(ISCN) )
                  INTSTOP = NINT( ( STOPJ(ISCN) - IDAY ) * 86400.D0 ) - 
     1              NINT( ( STARTJ(ISCN) - IDAY - TAPOFF ) * 86400.D0 )
                  DATLAT = MIN( DATLAT, INTSTOP )
                  WRITE( LINE(LPOS:LPOS+9), '( I5, A4, A1 )' ) DATLAT,
     1                ' sec', COL
                  LPOS = LEN1(LINE) + 1
                  WRITE( LINE(LPOS:LPOS+9), '( I5, A4, A1 )' ) INTSTOP,
     1                ' sec', COL
C
                  LPOS = LEN1(LINE) + 1
C
                  IF( USEDISK(ISTA) ) THEN
C
C                    Find the last scan that this station participated
C                    in and print the GB at the end of that scan.
C                    Note, STASCN(ISCN,ISTA) is a flag that indicates
C                    that station ISTA is in scan ISCN.  
C
                     IF( ISCN .GT. SCAN1 ) THEN
                        LASTSCN = 0
                        DO I = SCAN1, ISCN-1
                          IF( STASCN(I, ISTA) ) LASTSCN = I
                        END DO
                        IF( LASTSCN .GT. 0 ) THEN
                          STGB = GBYTES(LASTSCN,ISTA)
                        ELSE
                          STGB = 0.0
                        END IF
                     ELSE 
                        STGB = 0.0
                     END IF
                     WRITE( LINE(LPOS:LPOS+12), '( F9.3, A3, A1 )' ) 
     1                      STGB,' GB', COL
C
                  ELSE
C                     
C                    If not using disk (eg pointing), just put in blanks.
C
                     WRITE( LINE(LPOS:LPOS+2), '( 2X, A1 )' ) COL 
C
                  END IF
C
C                 Next is pass and subpass
C
                  LPOS = LEN1(LINE) + 1
                  IF ( DISK(STANUM(ISTA)) .EQ. 'LBADR' ) THEN
                     WRITE( LINE(LPOS:LPOS+5), '( 3X, I1, 1X, A1 )' ) 
     1                   0,  COL
                  ELSE
C
C                     In all other cases, put in the space and separator.
C
                      WRITE( LINE(LPOS:LPOS+3), 
     1                     '( 3X, A1 )' ) COL
                  END IF
C
C                 Pointscr not implemented leave blank
C                 Get the pointing sector from WRAPZONE.
C                 But only do this for the VLBA for now until the EVN
C                 etc are comfortable with having it here.  There is
C                 a fear that some stations will pay attention to it,
C                 but not have it properly implemented.
C
                  IF( STANAME(ISTA)(1:4) .EQ. 'VLBA' ) THEN
                     CALL WRAPZONE( IVEX, ISCN, ISTA, ZONE )
                  ELSE 
                     ZONE = ' '
                  END IF
C
                  LPOS = LEN1(LINE) + 1
                  WRITE( LINE(LPOS:LPOS+7), '( 1X, A5, 1X, A1 )' ) 
     1                    ZONE, COL
C
C                 Write tapedrive in last column, should be head 1 day
C                 agreed with NRV that norec can be drive 0
C                 With removal of tape stuff, this is 1 if recording, 
C                 0 if not.
C
                  TPDRIV = 1
                  IF( NOREC(ISCN) .OR. .NOT. USEDISK(ISTA) ) TPDRIV = 0
                  LPOS = LEN1(LINE) + 1
                  WRITE( LINE(LPOS:LPOS+2), '( 1X, I1, A1 )' ) TPDRIV,
     1                 SEP
C
C                 flush line
C
                  WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
                  INPAGE = INPAGE + 1
C     
               ELSE IF( STASCN(ISCN,ISTA) ) THEN
C     
C                 Write a comment line indicating the station is
C                 being skipped because of FORMAT=NONE
C
                  LINE = ' '
                  LPOS = 6
                  WRITE( LINE, '( A1, 4X, A, A1, 4X, A, A, A )' ) 
     1               COM, 'station=', STCODE(STANUM(ISTA))(1:2), COL,
     2              ' Skipping scan with FORMAT=NONE on:',
     3               TMPSRC(1:LEN1(TMPSRC))
C
               END IF
            END DO
            WRITE( IVEX, '( A, A1 )' ) 'endscan', SEP
            INPAGE = INPAGE + 1
C
         END IF
      END DO
C
C     Print warning about frequency of Tsys.   Switch trigger for this
C     from CONTROL=VEX and not VLA to TSCAL='GAP'  Nov. 4, 2013 RCW.
C
      TSYSMESS = .FALSE.
      DO ISTA = 1, NSTA
C         IF( WARNTS(ISTA) .AND. ( CONTROL(STANUM(ISTA)) .EQ. 'VEX' 
C     1      .AND. STATION(STANUM(ISTA))(1:3) .NE. 'VLA' ) ) THEN
         IF( WARNTS(ISTA) .AND. ( TSCAL(STANUM(ISTA)) .EQ. 'GAP' ) ) 
     1        THEN 
C
            WRITE( MSGTXT, '( A, A, A, I5, A , I4, A)' ) 
     2         'VXSCH: ', STATION(STANUM(ISTA)), ' has ',
     3         NTSYS(ISTA), 
     4         ' Tsys measurements. Maximum interval = ',
     5         TSYSGAP(ISTA), ' minutes.'
            CALL WLOG( 1, MSGTXT )
            TSYSMESS = .TRUE.
         END IF
      END DO
      IF( TSYSMESS ) THEN
         CALL WLOG( 1,'VXSCH: Tsys calibration at most MkIV stations '//
     1       'is taken during every gap in recording, ')
         CALL WLOG( 1,'       but these ' //
     1       'appear over 15 min apart for the stations listed above!')
         CALL WLOG( 1,'       This can be improved by inserting'//
     1       ' gaps at regular intervals. ')
         CALL WLOG( 1,'       Note this is not an issue for '//
     1       ' Westerbork or Arecibo' )
         CALL WRTMSG( 0, 'VXSCH', 'tsysgap' )
      END IF
C
C     Only give the warning about Tsys measurements off source if 
C     TSCAL is 'GAP'.
C
      TSYSMESS = .FALSE.
      DO ISTA = 1, NSTA
         IF( WARNTSOF(ISTA) .AND. TSCAL(STANUM(ISTA)) .EQ. 'GAP' ) THEN
            WRITE( MSGTXT, '( 2A, A, I5, A, I5, A )' ) 
     1         'VXSCH: ', STATION(STANUM(ISTA)), ': only ',
     2         NTSYSON(ISTA), ' out of ', NTSYS(ISTA),
     3         ' Tsys measurements are on-source'
            CALL WLOG( 1, MSGTXT )
            TSYSMESS = .TRUE.
         ENDIF
      END DO
      IF( TSYSMESS ) THEN
         CALL WLOG( 1, 'VXSCH: Stations listed above are affected ' //
     1        'by slewing during Tsys calibration')
         CALL WRTMSG( 0, 'VXSCH', 'tsysoffsrc' )
      END IF
C
      IF( WARNFS ) 
     1    CALL WLOG( 1,'VXSCH: WARNING: Scan timing problem '//
     2    'for PCFS, this VEX will NOT run!!!!')
      IF( WARNGP ) THEN
         CALL WRTMSG( 0, 'VXSCH', 'ftpgap' )
      END IF
C
      IF( WARNBANK ) THEN
C
C        Use the WRTMSG call to give the full warning about insufficient
C        gaps for media changes.
C        
         CALL WRTMSG( 1, 'VXSCH', 'warnbank' )
      END IF
C
      RETURN
      END

C*SYMSUB -- DCL symbol substitution [UNIX]
C+
	SUBROUTINE SYMSUB (A,B,L,N)
	CHARACTER*(*) A,B
        INTEGER L,N
C
C SYMSUB: perform DCL symbol substitution in a string. For UNIX, this
C routine just copies input to output, without making any changes.
C
C Arguments:
C  Input:  CHARACTER*(*) A	Input string.
C  Output: CHARACTER*(*) B	Output string; may be same as A.
C  Output: INTEGER L		The number of characters in B.
C  Output: INTEGER N		The number of substitutions performed.
C
C History:
C  Version 1.0:  1983 Dec 5	T.J. Pearson
C  Version 1.1:  1984 Jan 2	TJP; change from &XX to {XX}
C  Version 1.2:  1991 Feb 14    TJP: Unix version.
C-----------------------------------------------------------------------
      INTEGER I
C
      L = MIN(LEN(A),LEN(B))
      DO 10 I=1,L
          B(I:I) = A(I:I)
   10 CONTINUE
      N = 0
      END

      SUBROUTINE SHORTN
C
C     Get a short version of the name of each source.  Look through
C     the aliases for an option.  Use the one from the schedule, if 
C     it qualifies.  Do only on final call (OPENIT=.TRUE.) so all
C     sources are present.  Don't complain yet if there is none - 
C     only do so when it is needed.  It won't be for most (only 
C     SNAP and special VLA).
C
      INCLUDE  'sched.inc'
C
      INTEGER         ISRC, INAME, NCHAR, LEN1
      LOGICAL         SLWARN
      SAVE            SLWARN
      DATA            SLWARN / .TRUE. /
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SHORTN: Starting.' )
C
C     Loop over catalog sources.
C
      DO ISRC = 1, MSRC
         SOUR8(ISRC) = ' '
         DO INAME = 1, MALIAS
C
C           Use the name used in the schedule for the short name
C           if it is short enough.
C
            NCHAR = LEN1( SOURCE(INAME,ISRC) )
            IF( CSUSED(INAME,ISRC) .EQ. '*' .AND.
     1          NCHAR .LE. 8 .AND. NCHAR .GE. 1 ) THEN
               SOUR8(ISRC) = SOURCE(INAME,ISRC)
            END IF
C
C           While at it, don't allow imbedded blanks in any names.
C
            IF( NCHAR .GT. 0 .AND. 
     1          INDEX( SOURCE(INAME,ISRC)(1:NCHAR), ' ' ) .NE. 0 ) THEN
               CALL ERRLOG( 'SHORTN: Imbedded blanks not '//
     1             'allowed in source names: '//SOURCE(INAME,ISRC) )
            END IF
C
C           Warn about possible problems when using long names.
C           This was confirmed and reworded on Jan. 15, 2012.
C           See email on that day from David Gordon.
C
            IF( CSUSED(INAME,ISRC) .EQ. '*' .AND.
     1          NCHAR .GT. 8 .AND. SLWARN ) THEN
               CALL WLOG( 1, 'SHORTN: WARNING - Source '//
     1            'names longer than 8 characters used. ' )
               CALL WLOG( 1, '        This will be a problem if '//
     1            'geodetic software (SOLV etc) is used.' )
               CALL WLOG( 1, '        This might be a problem on '//
     1            'some correlators.' )
               SLWARN = .FALSE.
            END IF
         END DO
C
C        Now if the schedule source name was long, look for a short
C        alias.
C
         IF( SOUR8(ISRC) .EQ. ' ' ) THEN
            DO INAME = 1, MALIAS
               NCHAR = LEN1( SOURCE(INAME,ISRC) )
               IF( NCHAR .LE. 8 .AND. NCHAR .GE. 1 ) THEN
                  SOUR8(ISRC) = SOURCE(INAME,ISRC)
                  IF(CSUSED(INAME,ISRC) .EQ. ' ' ) 
     1               CSUSED(INAME,ISRC) = '+'
                  GO TO 995
               END IF
            END DO
  995       CONTINUE
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE OMSFREQ( KS, IUNIT )
C
C     Subroutine for SCHED called by OMSSET that writes frequency
C     group information to the OMS file.  This was requested by
C     Lorant Sjouwerman to aid in setting which VLA IF various
C     channels come from to assign calibration information to channels.
C
C     The code is stolen shamelessly from PRTFREQ.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER            IUNIT, KS, KF, NNCHAN
      INTEGER            ICH1, ILINE, CRSETC(MAXCHN)
      DOUBLE PRECISION   BBCFREQ(MCHAN), BBCBW(MCHAN)
      DOUBLE PRECISION   LOSUM(MCHAN)
      INTEGER            CRDN
      DOUBLE PRECISION   CRDF(MCHAN), CRDB(MCHAN), CRDLOSUM(MCHAN)
      CHARACTER          CRDS(MCHAN)*1
C----------------------------------------------------------------------
      NNCHAN = NCHAN(KS)
      IF( DEBUG ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, 3I7 )' ) 'OMSFREQ starting. ', 
     1       NNCHAN, NFSET, MAXPC
         CALL WLOG( 0, MSGTXT )
      END IF
C
C     List the frequency sets.  Don't worry about all the error
C     checking that is in PRTFREQ.
C
      IF( NFSET .GT. 0 ) THEN
         DO KF = 1, NFSET
            IF( FSETKS(KF) .EQ. KS ) THEN
C
C              Get the frequencies to be used for this frequency set.
C              We will be concerned only about the main recording 
C              frequencies, not any different frequencies used for
C              reference pointing etc (CRD.. parameters below).
C
               CALL FSFREQ( KF, LOSUM, BBCFREQ, BBCBW,
     1         CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC )
C        
C              Write the frequencies etc for this frequency set.
C        
               IF( NNCHAN .GT. 0 ) THEN
                  WRITE( IUNIT, '( 1X )' )
                  WRITE( IUNIT, '( A )' )
     1               '    BEGIN = FREQUENCY_SET'
                  WRITE( IUNIT, '( 1X )' )
                  ICH1 = 25
                  ILINE = 1
                  CALL LSTFREQ( IUNIT, LOSUM, BBCFREQ, BBCBW, ICH1, 
     1                NNCHAN, ILINE, 1024, 200, .TRUE., .TRUE., 
     2                '        LO_SUM         = ',
     3                '        BBC_FREQUENCY  = ',
     4                '        BANDWIDTH      = ' )
C
                  WRITE( IUNIT, '( 1X )' )
                  WRITE( IUNIT, '( A )' )
     1               '    END = FREQUENCY_SET'
               END IF
            END IF
         END DO
      END IF
C
      RETURN
      END

      SUBROUTINE JPLEP2( FILE, NAME, TIME, LONG, LAT, HEIGHT, OBSV, 
     1                   RA, DEC, DRA, DDEC, DIST, IER )
C
C  !!!NOTE!!!
C     This version of the ephemeris subroutine (JPLEP2) is a copy of
C     the standard subroutine (JPLEPH).  JPLEP2 calls JPLPO2 instead 
C     of JPLPOS.  JPLPO2 only considers the 2 specific cases: VLA and 
C     VLBA.  See notes in JPLPO2.
C  !!!END NOTE!!!
C
C     15 Oct 2001  Added SAVE FIRST, SS to this routine  RCW
C
C     The first calls to this routine will be just to determine if
C     a specified source is in the ephemeris and to get nominal
C     coordinates if it is.  IER is used to tell the result.
C
C     Input variables:
         CHARACTER         FILE*(*)     ! Ephemeris file name (<80 chr).
         CHARACTER         NAME*(*)     ! Object name (up to 12 char).
         DOUBLE PRECISION  TIME         ! Modified Julian day (UTC).
         DOUBLE PRECISION  LONG         ! East longitude (radians).
         DOUBLE PRECISION  LAT          ! Geodetic latitude (radians).
         DOUBLE PRECISION  HEIGHT       ! Geodetic height (meters).
         CHARACTER         OBSV*(*)     ! Which observatory
C                                       !  ('VLA' or 'VLBA').
C     Returned data:
         DOUBLE PRECISION  RA           ! RA (radians).
         DOUBLE PRECISION  DEC          ! Dec (radians).
         DOUBLE PRECISION  DRA          ! RA rate (seconds of
C                                       !    time per UT day).
         DOUBLE PRECISION  DDEC         ! Dec rate (seconds of
C                                       !    arc per UT day).
         DOUBLE PRECISION  DIST         ! distance to planet (AU)
         INTEGER           IER          ! Error condition (0 => ok).
C                                       !    1 => NAME not supported
C                                       !    2 => TIME not supported
C ---------------------------------------------------------------------
      DOUBLE PRECISION TDTTIM, JTDT, sla_DAT, LEAPS, VALS(400), SS(3)
      INTEGER NPLAN, NP, II, NVS
      PARAMETER (NPLAN = 10)
      LOGICAL FIRST
      CHARACTER PLANET(NPLAN)*12, NAMS(400)*6, EPHFI2*80

      COMMON / FNAME / EPHFI2

      DATA PLANET / 'MERCURY     ', 'VENUS       ', 'MOON        ',
     *              'MARS        ', 'JUPITER     ', 'SATURN      ',
     *              'URANUS      ', 'NEPTUNE     ', 'PLUTO       ',
     *              'SUN         ' /
      DATA FIRST / .TRUE. /
      SAVE        FIRST, SS

      IER = 1
      II = 1
      DO WHILE (II .LE. NPLAN .AND. IER .EQ. 1)
         IF (NAME .EQ. PLANET(II)) THEN
            IER = 0
            NP = II
         END IF
         II = II + 1
      END DO
      IF (IER .EQ. 0) THEN
C find the TDT (given UTC)
         LEAPS = sla_DAT (TIME)
         TDTTIM = TIME + (LEAPS + 32.184D0) / 86400.0D0
         JTDT = TDTTIM + 2400000.5D0
         IF (FIRST) THEN
            FIRST = .FALSE.
            EPHFI2 = FILE
            CALL CONST (NAMS, VALS, SS, NVS)
         END IF
         IF (JTDT .LT. SS(1) .OR. JTDT .GT. SS(2)) THEN
C ephemeris doesn't support that date/time
            IER = 2
         ELSE
            CALL JPLPO2 (TDTTIM, NP, LONG, LAT, HEIGHT, RA, DRA, DEC,
     *                   DDEC, DIST, OBSV)
         END IF
      END IF
      RETURN
      END

      LOGICAL FUNCTION VXCFTR( ISET, JSET )
C
C     Routine specific for the VEX extension of SCHED.
C     returns true if TR block in 2 SCHED sets are identical
C     for now it is mostly 14 pos, so depends on fanout, nchan and bits
C     and format
C     By H.J. van Langevelde, JIVE, 010996
C
C     Added comparison of DBE and FIRMFILE  Feb. 13, 2013  RCW.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER ISET, JSET
      LOGICAL IDENT
      INTEGER ISTA, ISCAT, JSCAT, ICH, IP, STAI, STAJ
C ----------------------------------------------------------------------
C
      IDENT = .TRUE.      
C
C     TRACK dependendence on SUBPASS section trivial
C
      IF( TAPEMODE(ISET) .NE. TAPEMODE(JSET) ) IDENT = .FALSE.
      IF( NCHAN(ISET) .NE. NCHAN(JSET) ) IDENT = .FALSE.
      IF( SAMPRATE(ISET) .NE. SAMPRATE(JSET) ) IDENT = .FALSE.
      IF( BITS(1,ISET) .NE. BITS(1,JSET) ) IDENT = .FALSE.
C
C     compare the format, and the fanout
C
      IF( FORMAT(ISET) .NE. FORMAT(JSET) ) IDENT = .FALSE.
      IF( FANOUT(ISET) .NE. FANOUT(JSET) ) IDENT = .FALSE.
C
C     Compare the DEB and FIRMFILE settings.
C
      IF( DBE(ISET) .NE. DBE(JSET) ) IDENT = .FALSE.
      IF( FIRMFILE(ISET) .NE. FIRMFILE(JSET) ) IDENT = .FALSE.
C
C     because of the S2 modes depend on cabling, S2 are not identical
C     for different DAR
C
      IF( IDENT .AND. FORMAT(ISET) .EQ. 'S2' ) THEN
C
C        find stations in order to compare DAR
C
         DO ISTA = 1, NSTA
            IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,ISET) )
     4          ISCAT = STANUM(ISTA)
         END DO
         DO ISTA = 1, NSTA
            IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,JSET) )
     4          JSCAT = STANUM(ISTA)
         END DO
         IF( DAR(ISCAT) .NE. DAR(JSCAT) ) IDENT = .FALSE.
      END IF
C
C     compare MEDIA - no subpass for disks
C
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,ISET) )
     4       STAI = ISTA
      END DO
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,JSET) )
     3       STAJ = ISTA
      END DO
      IF( USETAPE(STAI) .NEQV. USETAPE(STAJ) ) IDENT = .FALSE.
C
C     compare details of TRACKS
C
      IF( IDENT ) THEN
         DO ICH = 1, NCHAN(ISET)
            DO IP = 1, TAPEMODE(ISET)
               IF( TRACK(ICH,IP,ISET) .NE. TRACK(ICH,IP,JSET) )
     1             IDENT = .FALSE.
            END DO
         END DO
      END IF
C
      VXCFTR = IDENT 
C
      RETURN
      END

      SUBROUTINE CRDWRT( ISCN, ISTA, FIRSTS )
C
C     Subroutine for SCHED.  Calls appropriate routine to write
C     machine readable output.  Global files like VEX will have
C     been written earlier.
C
C     This used to include many different file types.  In fact, the
C     original purpose of SCHED was to write the distinct file type
C     required for each station.  The world is now much more 
C     standardized on Vex.  Now, the only thing left here is the 
C     VLBA crd files and this routine looks superfluous, but keep
C     for now in case it's original need every returns.  The crd 
C     files will go away too when the VME computers at the VLBA 
C     sites are abandoned..  RCW May 2012 and Sep 2013.
C
      INCLUDE 'sched.inc'
C
      INTEGER     ISCN, ISTA
      LOGICAL     FIRSTS
C-----------------------------------------------------------------
      IF( DEBUG .AND. ( FIRSTS .OR. ISCN .EQ. -999 ) ) THEN
         CALL WLOG( 0, 'CRDWRT: Making ' //
     1      CONTROL(STANUM(ISTA))//' control file for '//STANAME(ISTA) )
      END IF
C
      IF( ( CONTROL(STANUM(ISTA)) .EQ. 'VLBA' .OR. 
     1      VLBADAR(STANUM(ISTA)) ) .AND. .NOT. VLAONLY ) THEN
         CALL VLBA( ISCN, ISTA, FIRSTS )
      END IF
C
      RETURN
      END

      SUBROUTINE OPTTIM( LASTISCN, LASTSSCN, ISCN, ADJUST, 
     1                   USETIME, DOPRESC )
Cf2py intent(in) LASTISCN, LASTSSCN, ISCN, ADJUST, USETIME, DOPRESC
C
C     Routine that adjust the time of optimized scans.  It's main
C     use is in SCHOPT, but it is also called from GMKSCN and MAKESCN.
C
C     This is not meant to be the routine that gets the scan 
C     geometry - in fact it does not calculate geometry for DUR 
C     type scheduling (ie when ADJUST is false).  The scan geometry
C     should be calculated after OPTTIM is run because, if adjusting
C     times, it will fill the arrays with numbers meant mainly for
C     its internal use.
C
C     Note that, even with optimization, if an explicit start or
C     stop time was specified, it will be used.  ADJUST refers to
C     to whether the start time can be altered.  DURONLY also indicates
C     whether the start and/or stop can be adjusted.
C
C     If, and only if, DOPRESC is true, adjust the start time by 
C     PRESCAN (regardless of ADJUST), being careful not to overlap 
C     the previous scan.  This should only be true on the very last
C     call, or this routine tends to add extra offsets with each call.
C
C     If USETIME is true and all LASTISCNs for stations in the scan
C     are zero (indicating that this is their first scan), then use 
C     the scan time as is.  If false, use the experiment start time.
C
C     SSTIME is the time for which to do the geometry calculation.
C     it will be set to the last stop time for any station scheduled
C     to be in the scan.  Previously, this just used STARTJ(ISCN), but
C     that turned out to be too far off for dwell time scheduling.  
C     We got away with that for a long time because OPTTIM was called
C     in OPTDWELL (now gone) and later in SCHOPT) so it iterated to 
C     a good result.
C
C     LASTSSCN is the last scan for the station that is not an 
C     inserted scan (mainly pointing).  Respect GAP for these scans,
C     but not for LASTISCN.  In some calls, LASTISCN will be used
C     for LASTSSCN, but not in the final call for the overall schedule.
C
      INCLUDE 'sched.inc'
C
      INTEGER          LASTISCN(*), LASTSSCN(*)
      INTEGER          ISCN, ISTA, LSCN, I
      DOUBLE PRECISION LASTTIME, TIME1J, TIME2J, T_AVAIL, TIME1K
      DOUBLE PRECISION MAXLASTT, TOLER, TBEGSRT(MAXSTA+1), DTEMP
      DOUBLE PRECISION SSTIME
      LOGICAL          ADJUST, ALL0, USETIME, DOPRESC
      PARAMETER        (TOLER=ONESEC/1000.D0)
C --------------------------------------------------------------------
      IF( DEBUG .AND. ISCN .LE. 3 ) CALL WLOG( 0, 'OPTTIM: Starting.' )
      MAXLASTT = -99.D9
      LSCN = 0
C
C      Some debugging code that might be useful again some day
C      double precision start
C      integer          year1, day1
C      character        cstart*8, tform*8
C      call timej( startj(iscn), year1, day1, start )
C      cstart = tform( start, 'T', 0, 2, 2, '::@' )
C      if( iscn .gt. 170 .and. iscn .lt. 190 ) then
C       write(*,*) 'opttim:', iscn, duronly(iscn), int(gap(iscn)/onesec),
C     1     ' ',  adjust, ' ', cstart
C      end if
C
      IF( ADJUST .AND. DURONLY(ISCN) .NE. 2 .AND. DURONLY(ISCN) .NE. 3
     1    .AND. DURONLY(ISCN) .NE. 6 .AND. DURONLY(ISCN) .NE. 7 ) THEN
C
C        Get the start time based on previous scans and on slews.  This
C        can use dwell or dur.  Note that user input DWELL(1) (now in DUR 
C        logical DWELL set to whether or not it was used) was given to 
C        be the on-source time for input DWELL(2) (internal variable 
C        NOWAIT) antennas to get on source.  Input DWELL(3) (internal
C        variable MINDW) is the minimum on source time for all antennas.  
C        TIME1K collects the last antenna arrival time when worrying 
C        about allowing some to be late.
C
         TIME1J = -99.D9
         TIME1K = -99.D9
         ALL0 = .TRUE.
C
C        Initialize the sorted stop times array used when not waiting
C        for NOWAIT antennas.
C
         DO I = 1, MAXSTA+1
            TBEGSRT(I) = 0.D0
         END DO
C
C        Loop through the stations getting the most recent stop time
C        of a previous scan for the antennas in this scan.  This is
C        the earliest possible start time for the next scan.
C        Use the schedule scan time if there are no LASTISCN's.  That 
C        would normally be the first scan which will trigger ALL0 and 
C        be handled separately anyway.  Allow for GAP with LASTSSCN,
C        but not LASTISCN.
C
         SSTIME = 0.D0
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) .AND. LASTISCN(ISTA) .NE. 0) THEN
               SSTIME = MAX( SSTIME, STOPJ(LASTSSCN(ISTA)) + GAP(ISCN),
     1                       STOPJ(LASTISCN(ISTA)) )
            END IF
         END DO
C
C         IF( SSTIME .EQ. 0.D0 ) SSTIME = STARTJ(ISCN)
C        Use this instead.  But it's not used when LASTISCN is 0.
C
         IF( SSTIME .EQ. 0.D0 ) SSTIME = TFIRST
C
C        Loop through stations checking slews to get the time to start.
C
         DO ISTA = 1, NSTA
C
C           Now deal with scans that are not first.
C
            IF( STASCN(ISCN,ISTA) .AND. LASTISCN(ISTA) .NE. 0) THEN
C
C              Get the geometry for the earliest possible start time
C              which is SSTIME.
C              Note that, when setting T_AVAIL, STAGEO takes into 
C              account slews for DWELL type scheduling, but not 
C              when using DUR.  T_AVAIL is meant to be the earliest 
C              that this station can start the scan given the scheduling type.
C
               CALL STAGEO( ISCN, ISTA, SSTIME, 
     1                 LASTISCN(ISTA), LASTTIME, T_AVAIL, 'OPTTIM' )
C
C              With dwell scheduling, you can specify to wait for all
C              but the last NOWAIT antennas.  This helps deal with slow,
C              but sensitive antennas and with sources near zenith.
C              Only do the math if NOWAIT is one or more.
C
               IF( DWELL(ISCN) .AND. NOWAIT(ISCN) .GE. 1 ) THEN
                  IF( UP1(ISCN,ISTA) .EQ. ' ' .AND. 
     1                UP2(ISCN,ISTA) .EQ. ' ' .AND. 
     2                LASTISCN(ISTA) .NE. 0 ) THEN
C
                     T_AVAIL = MAX( T_AVAIL, STOPJ(LASTISCN(ISTA)),
     1                   STOPJ(LASTSSCN(ISTA)) + GAP(ISCN) )
C
C                    Add this station in its place in the list
C                    of start times sorted into inverse time order.
C                    Start by replacing the last element of TBEGSRT
C                    of interest if the new T_AVAIL is later.  Note
C                    that this works if NOWAIT(ISCN) = 0, although we
C                    will not get here in that case.
C
                     IF( T_AVAIL .GT. TBEGSRT(NOWAIT(ISCN)+1) ) THEN
                        TBEGSRT(NOWAIT(ISCN)+1) = T_AVAIL
C
C                       NOWAIT assured to be .GE. 1 above.  Push the new 
C                       time up the stack to put in it's proper place.
C                       The stack needs to be NOWAIT(ISCN) + 1 deep 
C                       because ultimately we will use that element.
C                       For simplicity, the new time is loaded into
C                       element NOWAIT(ISCN) + 2, then pushed up.
C
                        DO I = NOWAIT(ISCN), 1, -1
                           IF( TBEGSRT(I+1) .GT. TBEGSRT(I) ) THEN
                              DTEMP = TBEGSRT(I)
                              TBEGSRT(I) = TBEGSRT(I+1)
                              TBEGSRT(I+1) = DTEMP
                           END IF
                        END DO
                     END IF
C
C                    Also save the last time any station gets there.
C
                     TIME1K = MAX( TIME1K, T_AVAIL )
C
                  END IF
C
C
               ELSE IF( DWELL(ISCN) ) THEN
C
C                 Deal with Dwell scheduling without NOWAIT.  This is perhaps
C                 the dominent option.
C
                  TIME1J = MAX( TIME1J, T_AVAIL )
C
               ELSE
C
C                 Finally deal with duration scheduling.
C
                  TIME1J = MAX( TIME1J, LASTTIME )
C
               END IF
C
C              Save the last stop time of the previous scan seen at any 
C              station in the scan.  This will be used in applying GAP 
C              or dealing with non-dwell scheduling.
C
               IF( LASTTIME .GT. MAXLASTT ) THEN
                  MAXLASTT = LASTTIME
                  LSCN = LASTISCN(ISTA)
               END IF
               ALL0 = .FALSE.
            END IF
         END DO
C
C        We're not done yet for the case with DWELL and NOWAIT as we 
C        needed the sorted list of start times.  Now pick the one we want.
C        Note that TBEGSRT(1) will be non-zero if and only if we want 
C        to be doing this (or there were no stations in the scan) so 
C        we don't need to test DWELL etc.
C
         IF( TBEGSRT(1) .NE. 0.D0 ) THEN
            TIME1J = TBEGSRT(NOWAIT(ISCN)+1)
C
C           If that didn't produce a viable result, see if any other 
C           start times work (a possible cause would be that the number 
C           of stations in the scan was less than NOWAIT).  This will
C           be a rare case anyway so don't worry about the corner case 
C           where there ends up being only one station in the scan.
C        
            IF( TIME1J .EQ. 0.D0 ) THEN
               DO I = 1, NOWAIT(ISCN)
                  IF( TBEGSRT(I) .GT. 0.D0 ) THEN
                     TIME1J = TBEGSRT(I)
                  END IF
               END DO
            END IF
         END IF
C
C        Set time if this is the first scan for all antennas in 
C        the scan. I think this covers any remaining possible cases.
C        Recall that this need not be the first scan of the
C        experiment if all the included stations were not in
C        earlier scans.
C        This will also give a number for the case where no 
C        stations are up.
C
C        Jan. 30, 2012.  Change to use the first time of the project
C        for the start time when no stations were in a previous scan.
C        unless USETIME is true.  If it is true, use the time already
C        associated with the scan.  This is used by optimization 
C        routines, especially GEOCHK.
C
C        This change was provoked by undesired behavior when VLA dummy
C        scans were scheduled in parallel with other stations at the
C        start of an observation.
C
C        Feb. 8 , 2013.  No longer subtract GAP from MAXLASTT for this
C        first scan because it won't automatically be added back when
C        gap is used later.
C
         IF( ALL0 ) THEN
            IF( USETIME ) THEN
               TIME1J = STARTJ(ISCN)
               MAXLASTT = STARTJ(ISCN) - GAP(ISCN)
            ELSE 
               TIME1J = TFIRST
               MAXLASTT = TFIRST - GAP(ISCN)
            END IF
         END IF
C
C        If TIME1K did not get set, set it the same as TIME1J
C
         IF( TIME1K .LE. 0.D0 ) THEN
            TIME1K = TIME1J
         END IF
C
C        So far, the time has been set based on slew time.  Now treat
C        GAP as the minimum interval to the next scan, which may require
C        moving the start to later.  This also deals with a case where
C        TIME1J has not been set - like all antennas in the scan were
C        down.  Do the same for TIME1K.
C
C        Before Feb. 2014, GAP was zeroed after pointing scans were
C        inserted.  But this caused problems for schedules that had
C        some DWELL and some DUR/GAP scans as the DWELL scans caused
C        ADJUST to be set positive, but the intervals of the DUR/GAP
C        scans needed to be retained.  Those intervals are the
C        intervals to the last non-inserted scan (non-pointing scan). 
C        LASTSSCN was introduced to keep track of the of the original 
C        scans.
C
C        First set TIME1J and K to the earliest time the antenna can
C        do something.  Usually MAXLASTT is usually from LASTTIME from
C        STAGEO, which is normally STOPJ(LASTISCN).
C               
         TIME1J = MAX( TIME1J, MAXLASTT )
         TIME1K = MAX( TIME1K, MAXLASTT )
C
C        Now be sure we didn't get closer than GAP to the previous
C        regular (non-inserted) scan.  But don't do for pointing scans.
C
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) .AND. LASTSSCN(ISTA) .NE. 0 ) THEN
               TIME1J = MAX( TIME1J, STOPJ(LASTSSCN(ISTA)) + GAP(ISCN) )
               TIME1K = MAX( TIME1K, STOPJ(LASTSSCN(ISTA)) + GAP(ISCN) )
            END IF
         END DO
C
      ELSE
C
C        Deal with scans for which we are not allowed to adjust the 
C        start time.
C
C        Set the start time to the requested value.
C
         TIME1J = STARTJ(ISCN)
         TIME1K = STARTJ(ISCN)
C
      END IF
C
C     Set scan stop time.  This is easier.
C
C     First deal with the case of when we are allowed to adjust the
C     stop time.  This is when the STOP time was not explicitly set 
C     and has to be set with the help of the start time and duration.  
C     Note that the case of stop time implicit forced by a forced
C     start time and duration can be treated in the same way as the
C     flexible stop time - the forced start and dur ensure it comes
C     out right.  If the STOP time has been forced, just use it.
C     The value of DURONLY tells us which case we are in.
C    
C     At this point, also take into account MINDW - the minimum 
C     dwell time for all antennas.
C
      IF( DURONLY(ISCN) .LE. 3 ) THEN
         TIME2J = TIME1J + DUR(ISCN)
         IF( NOWAIT(ISCN) .GE. 1 .AND. MINDW(ISCN) .GT. 0.D0 ) THEN
            TIME2J = MAX( TIME2J, TIME1K + MINDW(ISCN) ) 
         END IF
      ELSE
         TIME2J = STOPJ(ISCN)
      END IF
C 
C     Prepare to deal with PRESCAN insertion and with a check for
C     overlapped scans.  Get the last stop time for stations in the
C     scan and preserve the scan number of that last stop time.
C     MAXLASTT and LSCN were derived before, but only for the
C     case when adjustments could be made.  Do here again to get
C     all scans.  At the previous use, there was concern about how 
C     to set first scans.  Here we are only going to worry about 
C     PRESCAN and overlaps so we be a bit simpler.
C
      MAXLASTT = -99.D9
      LSCN = 0
      DO ISTA = 1, NSTA
         IF( STASCN(ISCN,ISTA) .AND. LASTISCN(ISTA) .GT. 0 ) THEN
            IF( STOPJ(LASTISCN(ISTA)) .GT. MAXLASTT ) THEN
               MAXLASTT = STOPJ(LASTISCN(ISTA)) 
               LSCN = LASTISCN(ISTA)
            ENDIF
         END IF
      END DO
C
C     Adjust the start time for PRESCAN for all cases (ADJUST set
C     or not), but only if DOPRESC is true.  The DOPRESC is needed
C     to avoid scans marching along with successive calls to OPTTIM.
C     DOPRESC should only be set on the last call from SCHOPT.
C
C     Recall that PRESCAN is an historical parameter for moving the
C     start time away from where it might normally land.  Various
C     other parameters have taken it's place, but it might still be
C     useful for delaying scan starts for an extra amount of time when
C     using DWELL to absolutely insure there is no bad data.
C
C     Note that PRESCAN can be of either sign.  If it is negative,
C     it should not be allowed to back the scan up over the end of
C     the preceeding scan.  It differs from GAP in that it can be
C     shortened if it is longer than the interval between scans as
C     set so far and does not move the overall scan timing, just 
C     the start.
C
C     Don't mess up the UPTIME optimization mode in the process.  That
C     mode can have backward time jumps.
C
C     This works for the first scan when MAXLASTT is not set because
C     MAXLASTT will not be chosen over TIME1J+PRESCAN.
C
      IF( DOPRESC ) THEN
         IF( OPTMODE .NE. 'UPTIME' ) THEN
            TIME1J = MAX( MAXLASTT, TIME1J + PRESCAN(ISCN) )
         ELSE
           TIME1J = TIME1J + PRESCAN(ISCN)
         END IF
      END IF
C
C     Now do a sanity check.  Make sure we don't have overlapped scans.
C     Don't panic if that happens with OPTMODE=UPTIME as each source
C     will start at the experiment start time.
C
      IF( TIME1J .LT. MAXLASTT - TOLER .AND. 
     1    OPTMODE .NE. 'UPTIME' ) THEN
         WRITE( MSGTXT, '( 2A, I5 )' )
     1       'OPTTIM: Specified start time before last scan ',
     2       'stop time in scan: ', ISCN
         CALL WLOG( 1, MSGTXT )
         CALL PRTSCN( LSCN, 'OPTTIM' )
         CALL PRTSCN( ISCN, 'OPTTIM' )
         CALL ERRLOG( 'OPTTIM: Check scan times and days.' )
      END IF
C
C     Avoid crossing 0 hr when setting scan times.
C     This not needed any more.  But save the code in case
C     it ever comes up again.
C
C      DOUBLE PRECISION    SCDUR
C      IF( ADJUST ) THEN
C         IF( INT( TIME1J ) .NE. INT( TIME2J ) ) THEN
C            SCDUR = TIME2J - TIME1J
C            TIME1J = INT( TIME2J )
C            TIME2J = TIME1J + SCDUR
C         END IF
C      END IF
C
C     Now set the scan boundaries.  Once this was rounded to the 
C     nearest second, but that messes up LST schedules, especially
C     if they are meant for the VLA.
C
      STARTJ(ISCN) = TIME1J
      STOPJ(ISCN) = TIME2J
C
C     Be sure that the scan is at least 1 sec long.
C
      IF( STOPJ(ISCN) - STARTJ(ISCN) .LT. 0.D0 ) THEN
         WRITE( MSGTXT, '( A, I5 )' )
     1       'OPTTIM: Stop before Start in scan number', ISCN
         CALL WLOG( 1, MSGTXT )
         CALL PRTSCN( ISCN, 'OPTTIM' )
         CALL ERRLOG( 'OPTTIM: Check scan times and days.' )
      END IF
      IF( STOPJ(ISCN) - STARTJ(ISCN) .LT. ONESEC ) THEN
         WRITE( MSGTXT, '( A, I5, A )' )
     1       'OPTTIM: Adjusted times make scan number', ISCN, 
     2       ' shorter than one second long. '
         CALL WLOG( 1, MSGTXT )
         CALL PRTSCN( ISCN, 'OPTTIM' )
         CALL ERRLOG( 'Check scan times and especially PRESCAN.' )
      END IF
C
      RETURN
      END

      SUBROUTINE VLBABWS( LABEL, NCL, NCHAN, ARRAY, OLDARRAY, OLDCHAN,
     1                    FIRSTS, IUVBA ) 
C
C     Routine to put an array of setup parameters into a VLBA style
C     control file.  This one is for bandwidth or sample rate 
C     specifications. It converts the values in ARRAY, assumed to 
C     be in MHz, into the correct ASCII format for the on-line systems.
C
C     Only NCHAN channels will be written.  The current array will be
C     tested against the most recent one and only channels that have
C     changed will be written.  LABEL*NCL is the keyword for the output
C     record (eg bandwidth) and IUVBA is the output unit number.  
C     OLDARRAY should be dimensioned the same as ARRAY.  If the number 
C     of channels increases, information for the new ones should be 
C     written.
C
C     Some hoop jumping is done to avoid writing blanks.
C
C     The Feb 1991 version of the on-line system dropped the subscript from
C     the samplerate.  Feb 8, 1991 - RCW added code to write this correctly.
C
C     Set MCHAN very high to avoid problems if the number of channels
C     is changed elsewhere.
C
      INTEGER     MCHAN
      PARAMETER   (MCHAN=128)
      CHARACTER   LABEL*(*), OUTLINE*80, FMT1*4, FMT2*4
      CHARACTER   FMTCH*4, MSGLINE*132
      DOUBLE PRECISION  ARRAY(*), OLDARRAY(*)
      DOUBLE PRECISION  LOG2
      INTEGER     NCHAN, OLDCHAN, KCHAR, NCHAR, LEN1, NCL
      INTEGER     I, ICHADD, IDAADD, IUVBA, NBWS
      LOGICAL     FIRSTS, WRTLAB, DEQUAL
      INTEGER     MBWS
      PARAMETER   ( MBWS = 13 )
      CHARACTER*7   SPECBWS(MBWS), PRTBWS(MCHAN)
C
      SAVE        LOG2, SPECBWS, FMT1, FMT2
C
      DATA          LOG2         / 0.693147181 /
      DATA  SPECBWS / '62.5K', '125K', '250K', '500K',
     1               '1M', '2M', '4M', '8M', '16M', '32M',
     2               '64M', '128M', '256M' /
C
      DATA        FMT1, FMT2  / '(I1)', '(I2)' /
C----------------------------------------------------------------------
      NCHAR = 0
      WRTLAB = .TRUE.
      IF( FIRSTS ) OLDCHAN = 0
      IF( NCHAN .GT. MCHAN ) 
     1      CALL ERRLOG( ' VLBABWS: Too many channels.' )
      DO I = 1, NCHAN
C
C        Does this channel need to be processed?
C
         IF( FIRSTS .OR. .NOT. DEQUAL( ARRAY(I), OLDARRAY(I) ) .OR. 
     1       I .GT. OLDCHAN ) THEN
C
C           Get the format and number of digits needed for the channel 
C           number.
C
            IF( I .LE. 9 ) THEN
               FMTCH = FMT1
               ICHADD = 1
            ELSE
               FMTCH = FMT2
               ICHADD = 2
            END IF
C
C           Determine the ASCII version of the number to be printed.
C
            NBWS = LOG( (ARRAY(I) + 0.02D0 ) / 0.0625D0 ) / LOG2  +  1
            IF( NBWS .LT. 1 .OR. NBWS .GT. MBWS ) THEN
               CALL WLOG ( 1,
     1          'VLBABWS: Bad bandwidth or sample rate specification ' )
               MSGLINE = ' '
               WRITE( MSGLINE, '( 3A, I3 )' ) 
     1           '         label = ', LABEL,
     2           '         channel = ', I
               CALL WLOG( 1, MSGLINE )
               MSGLINE = ' '
               WRITE( MSGLINE, '( A, F8.3, A, I4, A, I4 )' ) 
     1           '         bandwidth/samprate (MHz) = ', ARRAY(I),
     2           '         index of bandwidth = ', NBWS, '  Max=', MBWS
               CALL WLOG( 1, MSGLINE )
               CALL ERRLOG( '         Fix the problem.' //
     1             '  Possible programming issue.' )
            END IF
            PRTBWS(I) = SPECBWS(NBWS)
C
C           Get the format and number of digits needed for the array 
C           number.
C
            IDAADD = LEN1(PRTBWS(I))
C
C           Get the number of characters for this point.
C
            KCHAR = ICHADD + IDAADD + 4
            IF( NCHAR + KCHAR .GT. 80 ) THEN
C
C              Write out the previous line.
C
               WRITE( IUVBA, '(A)' ) OUTLINE(1:NCHAR)
C
               NCHAR = 0
               WRTLAB = .TRUE.
            END IF
C
C           Write the beginning of the line.
C
            IF( WRTLAB ) THEN
               OUTLINE = ' '
               NCHAR = NCL
               OUTLINE(1:NCHAR+1) = LABEL(1:NCL)//'='
               NCHAR = NCHAR + 1
               WRTLAB = .FALSE.
            ELSE
               OUTLINE(NCHAR+1:NCHAR+1) = ','
               NCHAR = NCHAR + 1
            END IF
C
C           Write in the actual data point.  Has to be different
C           for samplerate!!!
C
            IF( LABEL(1:3) .NE. 'sam' ) THEN
               OUTLINE(NCHAR+1:NCHAR+1) = '('
               WRITE( OUTLINE(NCHAR+2:NCHAR+ICHADD+1), FMTCH ) I
               NCHAR = NCHAR + ICHADD + 2
               OUTLINE(NCHAR:NCHAR) = ','
               WRITE( OUTLINE(NCHAR+1:NCHAR+IDAADD), '(A)' ) 
     1             PRTBWS(I)(1:IDAADD)
               NCHAR = NCHAR + IDAADD + 1
               OUTLINE(NCHAR:NCHAR) = ')'
            ELSE
               IF( I .GT. 1 ) CALL ERRLOG( ' VLBABWS: Only 1 '//
     1            'samplerate allowed.' )
               WRITE( OUTLINE(NCHAR+1:NCHAR+IDAADD), '(A)' ) 
     1             PRTBWS(I)(1:IDAADD)
               NCHAR = NCHAR + IDAADD
            END IF
C
         END IF
C
C        Arrange to sense changes next time.
C
         OLDARRAY(I) = ARRAY(I)
C
      END DO
C
C     Record number of channels.
C
      OLDCHAN = NCHAN
C
C     Write out the last line.
C
      IF( NCHAR .GT. 0 ) WRITE( IUVBA, '(A)' ) OUTLINE(1:NCHAR)
C
      RETURN
      END

      SUBROUTINE LSQFIT ( IDEBUG,print_solution,
     +                    PRINT_COR,MAXDAT,NUMXES,
     +                    N,VNAME,X,ID,S,C,E,XHAT2,ERROR,IERR )

C --------------------------------------------------------------------
C     Extracted from Mark Reid's make_geodetic_blocks_ut_8.f that, in
C     my directory, had a date of March 11, 2010 but is probably 
C     considerably older.  I'm not sure of the original source of 
C     the code.  It doesn't match my ancient Numerical Recipes code.
C     I have retyped a some of the code to follow normal SCHED coding
C     practice, have corrected some comments and fixed and have altered
C     some code that I think followed bad practice (mainly getting 
C     rid of the implicit declaration and following the SCHED style
C     of requiring everything be declared - real good at catching typos). 
C     I removed the tabs - I HATE TABS!  You can't see them and they
C     have consequences.  To my knowledge, I have not changed the
C     actual actions of the code.
C     In Mark's code, it was called "LEAST_SQUARES_FIT"
C     Added IERR and more info about failures.
C     RCW  July 2, 2010.
C --------------------------------------------------------------------

C     SUBROUTINE FOR LINEAR LEAST SQUARE FITTING...
C     IT REQUIRES INPUT OF THE FOLLOWING:
C        IDEBUG    = DEBUGGING PARAMETER
C                    0 = SUPRESS PRINT OUT BEYOND SOLUTION AND CORRELATI
C                    3 = PRINT OUT ALL DATA AND MATRICES
C        print_solution = logical flag: print out least-squares solution
C       PRINT_COR = LOGICAL FLAG: PRINT CORRELATION MATRIX
C       MAXDAT    = MAX NUM DATA POINTS.  DIMENSION LIMITS IN MAIN PROG.
C        NUMXES    = NUMBER OF PARAMETERS IN MODEL (WHETHER SOLVED FOR O
C                    Maximum is 40 (guess)
C        N         = NUMBER OF EQUATIONS
C        VNAME     = ALPHANUMERIC 'NAME' FOR THE PARAMETERS
C        X         = 1-D ARRAY OF INITIAL PARAMETER VALUES
C        ID        = 1-D ARRAY OF 'SOLVE FOR' CODES
C                  0 = HOLD PARAMETER CONSTANT
C                  1 = SOLVE FOR PARAMETER
C        S         = 1-D ARRAY OF DATA (E.G. VLB DIFFERENCED PHASES)
C        C         = 2-D ARRAY OF PARTIAL DERIVATIVES OF MODEL
C                    First dimension is maximum number of data points.
C                    That has a maximum of 20000
C        E         = 1-D ARRAY OF ERRORS ON DATA POINTS
C        IERR      = 0 - Don't print some of error messages.  1 - Do
C
C     THE OUTPUT INCLUDES:
C        XHAT2     = 1-D ARRAY OF FINAL LEAST SQUARE VALUES FOR ALL 
C                    PARAMETERS
C        ERROR     = 1-D ARRAY Errors on the parameters.
C        IERR      = Return code.  0=> ok.  1=> inversion failed.

C        THE SOLUTION AND CORRELATIONS ARE AUTOMATICALLY PRINTED OUT

C      IMPLICIT REAL*8 (A-H,O-Z)   

      INTEGER           IDEBUG, MAXDAT, N, NUMXES, IERR
      DOUBLE PRECISION  C(MAXDAT,*)
      DOUBLE PRECISION  S(*),E(*),X(*),XHAT2(*), ERROR(*)
      INTEGER           ID(*)
      character*8       VNAME(*),QUEST(2)
C
      INTEGER           I, J, L, M, IN, JNEW, ITEST2, INOTE
      INTEGER           PRTERR
      DOUBLE PRECISION  B(40,40),BSTORE(40,40),XIDENT(40,40),
     +                  COR(40,40),STDEV(40),PR(40),
     +                  XHAT(40),SNEW(20000),PRODCT(20000)
      DOUBLE PRECISION  BMIN10, BMAX10, B1, BADJST, DETERM
C
      INTEGER           LL(40),MM(40), MSIZE
      DATA              MSIZE /40/

C
      LOGICAL PRINT_COR, print_solution

      DATA QUEST/'YES     ','NO      '/

C ---------------------------------------------------------------------
      PRTERR = IERR
      IERR = 0
 9999 FORMAT (1X,10(1PD13.5))
 9998 FORMAT (1X,20F6.2)
 9417 FORMAT (/1X)
C
      IF (IDEBUG.ge.3) then

         WRITE (6,5522)
 5522    FORMAT (////50X,' C MATRIX')
         do I=1,N
            WRITE (6,9999) (C(I,J),J=1,NUMXES)
         enddo
         WRITE (6,5523)
 5523    FORMAT (////40X,'        S(I)           E(I)')
         do I=1,N
            WRITE (6,9999) S(I),E(I)
         enddo

      endif

C     Count number of solve-for parameters (M)...
      M=0
      DO I=1,NUMXES
         M=M+ID(I)
      enddo

C     Check number of data .ge. number of parameters...
      IF ( N.lt.M )  then
         WRITE (6,2094)  N,M
 2094    FORMAT (////' LEAST_SQUARES_FIT: # DATA POINTS (',I4,
     +                  ') < # PARAMETERS (',I2,').  STOP' )
         STOP
      endif

c     Compress partial derivative matrix to retain only those
c     associated with solve-for parameters...
      JNEW=0
      do J=1,NUMXES
         if ( ID(J) .ne. 0 ) then
            JNEW=JNEW+1
            do I=1,N
               C(I,JNEW)=C(I,J)
            enddo
         endif
      enddo

C     Weight equations by dividing each by their error: E(I)
      do I=1,N
         SNEW(I)=S(I)/E(I)
         do J=1,M
            C(I,J)=C(I,J)/E(I)
         enddo
      enddo

C     Debug printout...
      IF (IDEBUG.ge.3) then
         WRITE (6,2006)
 2006    FORMAT ('1'/////50X,' CSTAR MATRIX')
         do I=1,N
            WRITE (6,9999) (C(I,J),J=1,M)
         enddo
         WRITE (6,2009)
 2009    FORMAT (/////50X,'     SSTAR')
         do I=1,N
            WRITE (6,9999) SNEW(I)
         enddo
      endif

C     Square up partial deravitive matrix...
      ITEST2=0
      BMIN10=0.D0
      BMAX10=0.D0
      DO I=1,M
         DO J=1,M
            B(I,J)=0.D0
         enddo
      enddo

      do I=1,M
         do J=1,M
            do L=1,N
               B(I,J)=B(I,J) + C(L,I)*C(L,J)
            enddo
c           Test for big range of exponents...
            if (B(I,J).ne.0.D0) then
               B1=DLOG10( DABS( B(I,J) ) )
               IF (BMIN10.GT.B1) BMIN10=B1
               IF (BMAX10.LT.B1) BMAX10=B1
            endif
            BSTORE(I,J)=B(I,J)
         enddo
      enddo

c     More debug printout...
      if (IDEBUG.ge.3) then
         WRITE (6,2010)
 2010    FORMAT ('1'/////50X,' C*TRANSPOSE C')
         do I=1,M
            WRITE (6,9999) (B(I,J),J=1,M)
         enddo
      endif


c     Warn user if the matrix has a large range of exponents...
      IF (DABS(BMAX10-BMIN10).ge.16.D0) then
         WRITE (6,9622) BMIN10,BMAX10
 9622    FORMAT (///1X,'********   BMIN10 = ',F6.1,
     +          'BMAX10 = ',F6.1,'   *************',///1X)
      endif

c     "Center" exponents about zero...
      BADJST=10.D0**( (BMAX10+BMIN10)/2.D0 )
      do I=1,M
         do J=1,M
            B(I,J)=B(I,J)/BADJST
         enddo
      enddo

c     About to invert the matrix...
C        THE SUBROUTINE 'MINV' IS A DOUBLE PRECISION MATRIX INVERSION
C        IT INVERTS THE MATRIX 'BB' AND STORES IT AS 'BB' (I.E. THE ORIGIN
C        MATIRX IS DESTROYED

      CALL MINV(B,M,DETERM,LL,MM,MSIZE)

c     Re-scale inverted matrix for "Centering"
      do I=1,M
         do J=1,M
            B(I,J)=B(I,J)/BADJST
         enddo
      enddo

c     More debug printout...
      IF (IDEBUG.ge.3) then
         WRITE (6,2011) DETERM
 2011       FORMAT ('1'////'  THE DETERMINANT IS',1PD13.5)
         WRITE (6,2022)
 2022       FORMAT (////45X,' (C*TRANSPOSE C*) INVERSE')
         do I=1,M
            WRITE (6,9999) (B(I,J),J=1,M)
         enddo
      endif

c     Prepare to check matrix inversion by multiplying inverse matrix
c     by the original martix to obtain (hopefully) the indentity matrix...
      do I=1,M
         do J=1,M
            XIDENT(I,J)=0.D0
         enddo
      enddo

      do I=1,M
         do J=1,M
            do L=1,M
               XIDENT(I,J)=XIDENT(I,J) + B(I,L)*BSTORE(L,J)
            enddo
            if (I.ne.J) then
c              Off-diagonal elements should be near zero...
               IF (DABS(XIDENT(I,J)).GT.1.D-06) ITEST2=1
            else
c              Diagonal elements should be near unity...
               IF (DABS(XIDENT(I,I)-1.D0).GT.1.D-06) ITEST2=-1
            endif
         enddo
      enddo

      if (ITEST2.eq.0) then

c        Matrix seemed to invert.
c        Calculate corrections (XHAT's) to parameters...
         do I=1,M
            XHAT(I)=0.D0
            do J=1,N
               PRODCT(J)=0.D0
               do L=1,M
                  PRODCT(J)=PRODCT(J) + B(I,L)*C(J,L)
               enddo
               XHAT(I)=XHAT(I)+PRODCT(J)*SNEW(J)
            enddo
         enddo

C        XHAT'S ARE (IF ADDED TO THE X'S) THE UNCONSTRAINED LEAST SQUARE
C        SOLUTION OF THE 'SOLVE FOR' PARAMETERS ONLY.
C        XHAT2(J) = THE LEAST SQUARES SOLTIONS (INCLUDING NON SOLVE FOR
C        PARAMETERS)
         IN=0
         do J=1,NUMXES
            if (ID(J).ne.0) then
               IN=IN+1
               XHAT2(J)=XHAT(IN) + X(J)
            else
               XHAT2(J)=X(J)
            endif
         enddo

c        Calculate correlation coefficients...
         do I=1,M
            do J=1,M
               COR(I,J)=-BSTORE(I,J)/DSQRT(BSTORE(I,I)*BSTORE(J,J))
            enddo
         enddo

c        Check for unphysical negative variances...
         INOTE=0
         do I=1,M
            IF (B(I,I).le.0.D0) then
               B(I,I)=-B(I,I)
               INOTE = INOTE + 1
            endif
         enddo
         if (INOTE.gt.0) then
            WRITE (6,2071) INOTE
 2071         FORMAT (///' ***** THERE ARE ',I2,' NEGATIVE VARIANCES; ',
     +            'SOLUTION IS UNPHYSICAL')
         endif

c        Convert variances to standard deviations...
         do J=1,M
            STDEV(J)=DSQRT(B(J,J))
         enddo


C        REARRANGE CALCULATED 1 SIGMA ERRORS TO APPLY TO THE SOLVED 
C        FOR PARAMETERS
         IN=0
         do J=1,NUMXES
            if (ID(J).ne.0) then
               IN=IN+1
               ERROR(J)=STDEV(IN)
            else
               ERROR(J)=0.D0
            endif
         enddo

         if ( print_solution ) then
C           OUTPUT FOR THE UNCONSTRAINED LEAST SQUARES SOLUTION
            WRITE (6,2040)
 2040       FORMAT (/1X,'PARAMETER    ORIGINAL VALUE   LEAST SQUARE',
     +               ' VALUE  1 SIGMA ERRORS   SOLVED FOR?')
            do J=1,NUMXES
               L=1
               IF (ID(J).EQ.0) L=2

               if ( L.eq.1 ) then
                  WRITE (6,2041) VNAME(J),X(J),XHAT2(J),ERROR(J),
     1                QUEST(L)
 2041               FORMAT (2X,A8,5X,3(F13.6,5X),4X,A8)
               endif

            enddo
         endif

c        Print correlations?
         if ( PRINT_COR )  then
C           CALCULATE THE CORRELATION COEFFICIENTS (COR)... 
            do I=1,M
               do J=1,M
                  COR(I,J)=B(I,J)/DSQRT(B(I,I)*B(J,J))
               enddo
            enddo

c           WRITE (6,2056)
c 2056         FORMAT(/10X,' THE CORRELATION COEFFICIENTS')
c           do I=1,M
c              WRITE (6,9998) (COR(I,J),J=1,M)
c           enddo

C           THE MULTIPLE CORRELATION COEFFICIENTS (PR) ARE CALCULATED
            do I=1,M
               PR(I)= 1.D0 - (1.d0/(BSTORE(I,I)*B(I,I)))
            enddo
c           WRITE (6,2060)
c 2060      FORMAT (///10X,'THE MULTIPLE CORRELATION COEFFICIENTS'/)
            I = 0
            do J=1,NUMXES
               if ( ID(J).ne.0 ) then
                  I = I + 1
C                 Not sure if the true PR is the sqrt(PR)??
c                 WRITE (6,2061) VNAME(J),PR(I)
c 2061               FORMAT (10X,A8,2X,F10.5)
               endif
            enddo

         endif

       else

c         Print out warning... and set error flag.

          IF( ITEST2 .EQ. 1 .AND. PRTERR .GE. 1 ) 
     1      WRITE( 6, '( A, I2, A )' ) 
     2          ' LSQFIT * ITEST2 =', ITEST2,
     3          '  MATRIX INVERSION FAILED. Off-diagonal elements '//
     4          'after multiplication by inverse too large. '
          IF( ITEST2 .EQ. -1 .AND. PRTERR .GE. 1  )
     1      WRITE( 6, '( A, I2, A )' ) 
     2          ' LSQFIT * ITEST2 =', ITEST2,
     3          '  MATRIX INVERSION FAILED. Diagonal elements not '//
     4          'near unity after multiplication by inverse. '
          IERR = 1

      endif

      RETURN
      END


      SUBROUTINE MINV(A,N,D,L,M,MSIZE)

C      IMPLICIT REAL*8 (A-H,O-Z)    ! RCW: See explicit declarations below.
C
C     IBM SCIENTIFIC SUBROUTINE PACAKAGE PAGE 118
C     ******************************************************************
C
C     PURPOSE  INVERT A MATRIX
C
C     DESCRIPTION OF PARAMETERS
C        A  INPUT MATRIX, DESTROYED IN COMPUTATION AND REPLACED BY INVER
C        N  ORDER OF MATRIX A
C        D  RESULTANT DETERMINANT
C        L  WORK VECTOR OF LENGTH N
C        M  WORK VECTOR OF LENGTH N
C     MSIZE ORDER OF TWO DIMENSIONAL MATRIX A IN MAIN PROGRAM
C
C     METHOD
C        THE STANDARD GAUSS-JORDAN METHOD IS USED. THE DETERMINANT IS A
C        CALCULATED. A DETERMINANT OF ZERO INDICATES THAT THE MATRIX IS
C        SINGULAR.
C
C     ******************************************************************
C
C     Explicit declarations for SCHED.  SCHED is compiled with a switch
C     that requires these.
C
      DOUBLE PRECISION A(*), D
      INTEGER          N, L(*),M(*), MSIZE
C
      INTEGER          NI, IJ, NM, K, LL
      INTEGER          IK, NK, KK, KI, JI, J, I, JK, KJ, IZ, JP
      DOUBLE PRECISION BIGA, HOLD
      INTEGER          JQ, JR
C -----------------------------------------------------------------------
C
C     STORE MATRIX A IN VECTOR FORM (COLUMN BY COLUMN)
C     SEE SSP PROGRAM ARRAY  P.98
C
      IF(MSIZE.EQ.N) GO TO 2
      NI=MSIZE-N
      IJ=0
      NM=0
      DO 230 K=1,N
      DO 225 LL=1,N
      IJ=IJ+1
      NM=NM+1
  225 A(IJ)=A(NM)
  230 NM=NM+NI
    2 CONTINUE
C
C     SEARCH FOR LARGEST ELEMENT
C
      D=1.0D0
      NK=-N
      DO 80 K=1,N
      NK=NK+N
      L(K)=K
      M(K)=K
      KK=NK+K
      BIGA=A(KK)
      DO 20 J=K,N
      IZ=N*(J-1)
      DO 20 I=K,N
      IJ=IZ+I
   10 IF(ABS(BIGA)-ABS(A(IJ))) 15,20,20
   15 BIGA=A(IJ)
      L(K)=I
      M(K)=J
   20 CONTINUE
C
C     INTERCHANGE ROWS
C
      J=L(K)
      IF(J-K) 35,35,25
   25 KI=K-N
      DO 30 I=1,N
      KI=KI+N
      HOLD=-A(KI)
      JI=KI-K+J
      A(KI)=A(JI)
   30 A(JI)=HOLD
C
C     INTERCHANGE COLUMNS
C
   35 I=M(K)
      IF(I-K) 45,45,38
   38 JP=N*(I-1)
      DO 40 J=1,N
      JK=NK+J
      JI=JP+J
      HOLD=-A(JK)
      A(JK)=A(JI)
   40 A(JI)=HOLD
C
C     DIVIDE COLUMN BY MINUS PIVOT (VALUE OF PIVOT ELEMENT IS CONTAINED
C     BIGA)
C
   45 IF(BIGA) 48,46,48
   46 D=0.0D0
      RETURN
   48 DO 55 I=1,N
      IF(I-K) 50,55,50
   50 IK=NK+I
      A(IK)=A(IK)/(-BIGA)
   55 CONTINUE
C
C     REDUCE MATRIX
C
      DO 65 I=1,N
      IK=NK+I
      HOLD=A(IK)
      IJ=I-N
      DO 65 J=1,N
      IJ=IJ+N
      IF(I-K) 60,65,60
   60 IF(J-K) 62,65,62
   62 KJ=IJ-I+K
      A(IJ)=HOLD*A(KJ)+A(IJ)
   65 CONTINUE
C
C     DIVIDE ROW BY PIVOT
C
      KJ=K-N
      DO 75 J=1,N
      KJ=KJ+N
      IF(J-K) 70,75,70
   70 A(KJ)=A(KJ)/BIGA
   75 CONTINUE
C
C     PRODUCT OF PIVOTS
C
      D=D*BIGA
C
C     REPLACE PIVOT BY RECIPROCAL
C
      A(KK)=1.0D0/BIGA
   80 CONTINUE
C
C     FINAL ROW AND COLUMN INTERCHANGE
C
      K=N
  100 K=K-1
      IF(K) 150,150,105
  105 I=L(K)
      IF(I-K) 120,120,108
  108 JQ=N*(K-1)
      JR=N*(I-1)
      DO 110 J=1,N
      JK=JQ+J
      HOLD=A(JK)
      JI=JR+J
      A(JK)=-A(JI)
  110 A(JI)=HOLD
  120 J=M(K)
      IF(J-K) 100,100,125
  125 KI=K-N
      DO 130 I=1,N
      KI=KI+N
      HOLD=A(KI)
      JI=KI-K+J
      A(KI)=-A(JI)
  130 A(JI)=HOLD
      GO TO 100
  150 CONTINUE
C
C     PUT MATRIX BACK INTO SQUARE FORM
C
      IF(MSIZE.EQ.N) GO TO 4
      IJ=N*N+1
      NM=N*MSIZE+1
      DO 210 K=1,N
      NM=NM-NI
      DO 210 LL=1,N
      IJ=IJ-1
      NM=NM-1
  210 A(NM)=A(IJ)
    4 CONTINUE
      RETURN
      END

      SUBROUTINE SUVOPT( QUALITY, NLONG, NLAT, QLIMS, GHLAT, GHLONG )
C
C     Make a grid around a station and get the quality factor
C     on points on the grid.
C
C     When this is run, only one station should be color red.  That
C     is the one for which the grid will be made.
C
C     The same quality factor will be used as for UVOPT.
C
C     Dec. 14, 2010.  Changed calls to SCHSRC to calls to STAGEO
C     as SCHSRC will be part of STAGEO soon.
C
      INCLUDE    'sched.inc'
      INCLUDE    'plot.inc'
C
C     Set the grid parameters. Be sure to change the format
C     statement near the end if you change this.
C
      INTEGER    NLAT, NLONG
      REAL       QUALITY(NLONG,NLAT), QLIMS(4)
      DOUBLE PRECISION  STEP
C
C     Use LASTJSCN rather than LASTISCN to avoid confusion with
C     the LASTISCN in SCHOPT.
C
      INTEGER    ILONG, ILAT, NTEST, ISTA, KSTA, KS, ISCN, LEN1
      INTEGER    IOERR, VLBOPE, FLAG(MAXSTA), NCOMB, IC, IER
      INTEGER    LASTJSCN
      LOGICAL    EXISTS
      REAL       TOP5(5,MAXSRC)
      CHARACTER  OPTFILE*80, INFOLINE*128
      CHARACTER  OPSTAT*4, OPTEXT*256
      DOUBLE PRECISION   SLAT, SLONG, LASTTIME, T_AVAIL
      REAL       QLATMIN, QLATMAX, QLONMIN, QLONMAX
C
      CHARACTER  GHLAT(NLAT)*9, GHLONG(NLONG)*10, TFORM*15
      CHARACTER  CHLAT*9, CHLONG*10
C --------------------------------------------------------------------
C     Get the user specified step size.
C
      STEP = ( GRIDSTEP / 60.D0 ) * RADDEG
C
C     Make a .opt file much like that made by UVOPT.
C
C     Open the .opt print file.  Always write over 
C     whatever was there before.  Make a new one 
C     for each optimization effort.
C     
      WRITE( OPTFILE, '(A,A)' ) EXPCODE(1:LEN1(EXPCODE)), '.OPT'
      CALL DWCASE( OPTFILE )
      INQUIRE( FILE=OPTFILE, EXIST=EXISTS )
      IF( EXISTS ) THEN
         OPSTAT = 'OLD'
      ELSE
         OPSTAT = 'NEW'
      END IF
      CALL WLOG( 0, 'SUVOPT:  Writing new configuration file '//
     1   OPTFILE(1:LEN1(OPTFILE)) )
      IOERR = VLBOPE( IOPT, OPTFILE, 'TEXT', OPSTAT, OPTEXT )
      IF( IOERR .NE. 1 ) CALL ERRLOG( ' Open problem:'//OPTEXT )
C
C     Write some information about the stations.  First the ones
C     to be helf fixed.
C
      WRITE( IOPT,*) 'Station optimization.'
      WRITE( IOPT, '( A, I4, A, I4 )' ) '   GRIDNR = ', GRIDNR, 
     1     '   GRIDNT = ', GRIDNT
      WRITE( IOPT, '( A, F10.2, A, F10.2 )' ) '   GRIDMIN = ', GRIDMIN, 
     1     '   GRIDMAX = ', GRIDMAX
      WRITE( IOPT, '( A, F10.2 )' ) '   GRIDW0 = ', GRIDW0
C
      WRITE( IOPT,*) 'Stations held fixed: '
      DO ISTA = 1, NSTA
         IF( PSTBCK(ISTA,1) .EQ. 1 .AND. PSTBCK(ISTA,2) .EQ. 0 ) THEN
            CHLAT = TFORM( LAT(STANUM(ISTA)), ' ', 1, 2, 2, ':: ' )
            CHLONG = TFORM( LONG(STANUM(ISTA)), ' ', 1, 3, 2, ':: ' )
            WRITE( IOPT, '( 3X, A8, 4X, A, 4X, A )' )
     1          STANAME(ISTA), CHLAT, CHLONG
         END IF
      END DO
C
      NTEST = 0
      KSTA = 0
      WRITE( IOPT,*) ' '
      WRITE( IOPT,*) 'Station for grid: '
C
C     Get the station for the grid.  Set flags for UVQUAL while at it.
C
      DO ISTA = 1, NSTA
         FLAG(ISTA) = 0
         IF( PSTBCK(ISTA,1) .EQ. 1 .AND. PSTBCK(ISTA,2) .EQ. 0 ) 
     1      FLAG(ISTA) = 1
         IF( PSTBCK(ISTA,1) .EQ. 1 .AND. PSTBCK(ISTA,2) .EQ. 1 ) THEN
            NTEST = NTEST + 1
            IF( NTEST .GT. 1 ) THEN
               FLAG(ISTA) = 1
               CALL WLOG( 1, 'SUVOPT:  Too many red points.  Do first.')
            ELSE
C
C              Get station information for the tested station.  Use the
C              original elevation.  Keep LAT and LONG to restore later.
C
               FLAG(ISTA) = 2
               KSTA = ISTA
               KS = STANUM(ISTA)
               SLAT = LAT(KS)
               SLONG = LONG(KS)
               CHLAT = TFORM( SLAT, ' ', 1, 2, 2, ':: ' )
               CHLONG = TFORM( SLONG, ' ', 1, 3, 2, ':: ' )
               WRITE( IOPT, '( 3X, A8, 4X, A, 4X, A )' )
     1             STANAME(ISTA), CHLAT, CHLONG
            END IF
         END IF
      END DO
      IF( KSTA .EQ. 0 ) THEN
         CALL WLOG( 1, 'SUVOPT: No station to test.  Highlight one.' )
         CLOSE( UNIT = IOPT )
         RETURN
      END IF
C
C     Loop over location grid moving station KSTA to grid points.
C
      IC = 0
      NCOMB = NLAT * NLONG
      DO ILAT = 1, NLAT
         LAT(KS) = SLAT + ( NLAT / 2 - ILAT + 1 ) * STEP
         IF( ILAT .EQ. 1 ) QLATMAX = LAT(KS) / RADDEG
         IF( ILAT .EQ. NLAT) QLATMIN = LAT(KS) / RADDEG
         DO ILONG = 1, NLONG
            LONG(KS) = SLONG + ( NLONG / 2 - ILONG  + 1 ) * STEP
            IF( ILONG .EQ. 1 ) QLONMAX = LONG(KS) / RADDEG
            IF( ILONG .EQ. NLONG ) QLONMIN = LONG(KS) / RADDEG
            IC = IC + 1
C
C           Set the geometry and schedule parameters, much like
C           moving a station in PLOTSTA.
C        
            CALL GEOXYZ( 0, LONG(KS), LAT(KS), ELEV(KS),
     1            XPOS(KS), YPOS(KS), ZPOS(KS), IER )
            IF( IER .NE. 0 ) CALL WLOG( 1,
     1          'SUVOPT: Problem with coordinate '//
     2          'conversions for '// STANAME(STANUM(KSTA)) )
C
C           Now update the scan geometry parameters.
C            
            LASTJSCN = 0
            DO ISCN = SCAN1, SCANL
               IF( STASCN(ISCN,KSTA) ) THEN
C
C                 Call STAGEO.  Prior to Dec. 14, 2010, this was
C                 calls to SCHSRC and SLEW plus setting TONSRC.
C                 I want to absorb SCHSRC into STAGEO.
C
                  CALL STAGEO( ISCN, ISTA, STARTJ(ISCN), LASTJSCN,
     1                 LASTTIME, T_AVAIL, 'SUVOPT_1' )
                  LASTJSCN = ISCN
               END IF
            END DO
C
C           Get the quality measure for this array.
C
            CALL UVQUAL( IC, FLAG, QUALITY(ILONG,ILAT), TOP5, INFOLINE )
C
C           Write the result.
C
            GHLAT(ILAT) = TFORM( LAT(KS), ' ', 1, 2, 2, ':: ' )
            GHLONG(ILONG) = TFORM( LONG(KS), ' ', 1, 3, 2, ':: ' )
C            WRITE( IOPT, '( 3X, A8, 4X, A, 4X, A, 2I5, F8.4 )' )
C     1             STANAME(KSTA), GHLAT(ILAT), GHLONG(ILONG), 
C     2             ILAT, ILONG, QUALITY(ILONG,ILAT)
         END DO
C
         MSGTXT = ' ' 
         WRITE( MSGTXT, '( A, I7, A, I8 )' ) 
     1      'UVOPT:  Station grid. Latitude row: ', ILAT,
     2      '  Grid point: ', IC
         CALL WLOG( 0, MSGTXT(1:LEN1(MSGTXT)) )
         MSGTXT = ' ' 
      END DO
C
C     Put back the station coordinates.
C     Reset the geometry and schedule parameters.
C     
      LONG(KS) = SLONG
      LAT(KS) = SLAT
C
      CALL GEOXYZ( 0, LONG(KS), LAT(KS), ELEV(KS),
     1      XPOS(KS), YPOS(KS), ZPOS(KS), IER )
      IF( IER .NE. 0 ) CALL WLOG( 1,
     1    'SUVOPT: Problem with coordinate '//
     2    'conversions for '// STANAME(KSTA) )
C     
C     Now update the scan geometry parameters.
C      
      LASTJSCN = 0
      DO ISCN = SCAN1, SCANL
         IF( STASCN(ISCN,KSTA) ) THEN
            CALL STAGEO( ISCN, ISTA, STARTJ(ISCN), LASTJSCN,
     1                   LASTTIME, T_AVAIL, 'SUVOPT_2' )
            LASTJSCN = ISCN
         END IF
      END DO
C
C     Write the quality grid.
C
      WRITE( IOPT, '( 1X, /, A )' ) ' Latitude, Longitude Grid.'
      WRITE( IOPT, '( 8X, A10, 24( A7 ) )' ) 
     1      ( GHLONG(ILONG), ILONG = 1, NLONG )
      DO ILAT = 1, NLAT
         WRITE( IOPT, '( 1X, /, 2X, A9, 25F7.3 )' ) GHLAT(ILAT), 
     1      ( QUALITY(ILONG,ILAT), ILONG = 1, NLONG )
      END DO
C
C     Plot contours on the map.
C
      QLIMS(1) = QLONMIN
      QLIMS(2) = QLONMAX
      QLIMS(3) = QLATMIN
      QLIMS(4) = QLATMAX
C
C     Close the print file so that the buffers will flush.
C
      CLOSE( UNIT=IOPT )
C
      RETURN
      END

      SUBROUTINE PLTRAN( VZ, TT, CSU, CSV, IDIMU, IDIMV,
     1                   KL, KH, LL, LH, ML, MH, NL, NH, FNM )
C
C     PLTRAN is a subroutine for fourier transforming in
C     two dimensions an array of data. The actual transform
C     is done by the Fast Fourier Transform subroutine PLFFT
C
C     PLTRAN is an alias of subroutine TRANS that is part of
C     the program "INVERT" ( AUG. 23,1982 )
C
      INCLUDE 'beam.inc'
C
      INTEGER           IDIMU, IDIMV, KL, KH, LL, LH
      INTEGER           ML, MH, NL, NH, L, I, K, M, N, II, JJ
      DOUBLE PRECISION  VZ, FNM, RI(2), TT(KXSIZE*4)
      COMPLEX*16        CSU(KXSIZE*2), CSV(KXSIZE*2), TP
      DIMENSION         VZ(KXSIZE*2,KYSIZE*2)
      EQUIVALENCE       ( RI(1), TP )
C -------------------------------------------------------------------
C
C     Start row loop
C
      DO 40 L = LL, LH
C
C        Clear trans array
C
         DO 10 I = 1, IDIMU
            II       = 2 * I - 1
            TT(II)   = 0.0
            TT(II+1) = 0.0
 10      CONTINUE
C
C        Load into trans array
C
         DO 20 K = KL, KH
            TP       = CMPLX( VZ(K,L), -VZ(K,L) ) * CSU(K)
            JJ       = 2 * K - 1
            TT(JJ)   = RI(1)
            TT(JJ+1) = RI(2)
 20      CONTINUE
C
C        Transform
C
         CALL PLFFT( TT, TT(2), IDIMU, IDIMU, IDIMU, -2 )
C
C        Return to row
C
         DO 30 M = ML, MH
            JJ = 2 * M - 1
            VZ(M,L) = DBLE( CMPLX( TT(JJ), TT(JJ+1) ) * CSU(M) ) * FNM
 30      CONTINUE
C
 40   CONTINUE
C
C     Start column loop
C
      DO 80 M = ML, MH
C
C        Clear trans array
C
         DO 50 I = 1, IDIMV
            II       = 2 * I - 1
            TT(II)   = 0.0
            TT(II+1) = 0.0
 50      CONTINUE
C
C        Load into trans array
C
         DO 60 L = LL, LH
            TP       = CMPLX( VZ(M,L), -VZ(M,L) ) * CSV(L)
            JJ       = 2 * L - 1
            TT(JJ)   = RI(1)
            TT(JJ+1) = RI(2)
 60      CONTINUE
C
C        Transform
C
         CALL PLFFT( TT, TT(2), IDIMV, IDIMV, IDIMV, -2 )
C
C        Return to column
C
         DO 70 N = NL, NH
            JJ      = 2 * N - 1
            VZ(M,N) = DBLE( CMPLX( TT(JJ), TT(JJ+1) ) * CSV(N) ) * FNM
 70      CONTINUE
C
 80   CONTINUE
C
      RETURN
      END

      SUBROUTINE FMTPICK( NEEDFMT )
C
C     I don't think this routine will ever be called in the era of
C     disk.  I'm leaving it around for now just in case.
C
C     Routine for SCHED, called by SETFORM, that deals with picking
C     formats for VLBA/MKIV stations when not all are forced by 
C     user input or constraints.  We would like to pick the set that
C     gives a processing speedup factor of 2, if we can.
C     Since setting even one format will usually force the rest, 
C     this has to be done in a manner coordinated across all setups.
C     The correlation is the result of the requirement that all
C     track bit rates be the same and the desire that the number of
C     tracks in use at a station stay constant.
C
C     Note that if there were any high bandwidth modes (TWOHEAD, 
C     FASTTRK), the formats would already have been forced and we
C     would not be in this routine.
C
C     At least for now, we won't try to adjust the formats to allow
C     the chosen correlator integration times.  Maybe run a check 
C     on that later.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
      INTEGER           KS, ISETF, ISCN, MINNTRK
      REAL              MAXFBPS(MAXSET)
      REAL              TTBPS(MAXSET), BTBPS(MAXSET)
      REAL              MAXBPS, USEFBPS
      REAL              ACCBPS, ACCTIM, AVGBPS
      REAL              USENTRK, SETBPS(MAXSET)
      LOGICAL           NEEDFMT(*), OK
      DOUBLE PRECISION  TOTIME, SETTIME(MAXSET)
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'FMTPICK starting' )
C
C     Ask for feedback if the routine is called.
C
      CALL WLOG( 1, 'FMTPICK:  Please inform Craig Walker at '//
     1  'cwalker@nrao.edu if you see this message.' )
      CALL WLOG( 1, '          It means you reached a part of SCHED '//
     1  'not thought to still be active.' )
      CALL WLOG( 1, '          Please include your input file.' )
C
C     Get the total observing time that each setup file (not group) is 
C     used.
C
      TOTIME  = 0.0D0
      DO ISETF = 1, NSETF
         SETTIME(ISETF) = 0.D0
      END DO
      DO ISCN = 1, NSCANS
         IF( .NOT. NOREC(ISCN) ) THEN
            TOTIME = TOTIME + DUR(ISCN)
            ISETF = SETNUM(ISCN)
            SETTIME(ISETF) = SETTIME(ISETF) + DUR(ISCN)
         END IF
      END DO
C
C     Get the maximum total nominal bit rate both overall (MAXBPS) and for 
C     each setup file (MAXFBPS).  Only use unset formats (this keeps
C     any isolated, forced formats from affecting things).
C     Get the maximum and minimum track bits per second for each setup 
C     file (BTBPS and TTBPS).  Use the nominal bit rate TOTBPS as the
C     actual bit rate WRTBPS is affected by format specific overheads.
C
      MAXBPS = 0.0
      MINNTRK = 0.0
      DO ISETF = 1, NSETF
         MAXFBPS(ISETF) = 0.0
         TTBPS(ISETF) = 99999.
         BTBPS(ISETF) = 0.0
      END DO
      DO KS = 1, NSET
         IF( VLBAMKIV(KS) .AND. RECUSED(KS) .AND. NEEDFMT(KS) ) THEN
            ISETF = ISETNUM(KS)
            MAXBPS = MAX( MAXBPS, TOTBPS(KS) )
            MINNTRK = MAX( MINNTRK, MINTRAK(KS) )
            MAXFBPS(ISETF) = MAX( MAXFBPS(ISETF), TOTBPS(KS) )
            TTBPS(ISETF) = MIN( TTBPS(ISETF), MAXTBPS(KS) )
            BTBPS(ISETF) = MAX( BTBPS(ISETF), MINTBPS(KS) )
         END IF
      END DO
C
C     Check a limit
C
      IF( MAXBPS .GT. 256.0 ) THEN
         CALL WLOG( 1, 'FMTPICK: There is a bit rate above 256' //
     1      ' that has not yet been set.' )
         CALL WLOG( 1, '         Probable programming error ' )
         CALL WLOG( 1, '         Workaround - set TPMODE or full '//
     1        'FORMAT for more VLBA/MKIV formats.' )        
         CALL ERRLOG( 'Please report' )
      END IF
C
C     Get the average total bit rate based on the maximum for 
C     each setup file.
C
      ACCBPS = 0.0
      ACCTIM = 0.0      
      DO ISETF = 1, NSETF
         IF( MAXFBPS(ISETF) .GT. 0.0 ) THEN
            ACCBPS = ACCBPS + MAXFBPS(ISETF) * SETTIME(ISETF)
            ACCTIM = ACCTIM + SETTIME(ISETF)
         END IF
      END DO
      IF( ACCTIM .GT. 0.0 ) THEN
         AVGBPS = ACCBPS / ACCTIM
      ELSE 
C
C        It seems that there are no setups used for VLBAMKIV.
C        Let SETFORM deal with the problem.
C
         GO TO 999
      END IF
C
C     Get the number of tracks to use.  USENTRK tries to get speedup
C     2.  MAXBPS insures that there are enough tracks for the fastest
C     setups.  MINNTRK insures that there are enough tracks for 
C     the slowest bit rate scans.
C
      USENTRK = NINT( AVGBPS / 4.0 )
      IF( USENTRK .GT. 24 .OR. MAXBPS .GT. 128.0 .OR. 
     1    MINNTRK .GT. 16 ) THEN
         USENTRK = 32
      ELSE IF( USENTRK .GT. 12 .OR. MAXBPS .GT. 64.0 .OR. 
     1    MINNTRK .GT. 8 ) THEN
         USENTRK = 16
      ELSE
         USENTRK = 8
      END IF
C
C     Ok, now we have a number of tracks to use.  Treating it as
C     the same for all stations at this point.  Find the track bit
C     rate to use for each setup file.  Using USEFBPS here in case
C     some setup had a weird number of channels.
C
      DO ISETF = 1, NSETF
         IF( MAXFBPS(ISETF) .NE. 0.0 ) THEN
            IF( MAXFBPS(ISETF) .GT. 128.0 ) THEN
               USEFBPS = 256.0 
            ELSE IF( MAXFBPS(ISETF) .GT. 64.0 ) THEN
               USEFBPS = 128.0 
            ELSE IF( MAXFBPS(ISETF) .GT. 32.0 ) THEN
               USEFBPS = 64.0 
            ELSE IF( MAXFBPS(ISETF) .GT. 16.0 ) THEN
               USEFBPS = 32.0 
            ELSE
               USEFBPS = 16.0 
            END IF
C
C           Get the bit rate for this setup file.
C
            SETBPS(ISETF) = MAXFBPS(ISETF) / USENTRK
C
C           React to it being out of bounds.  If it is too low, we
C           can boost it and waste tracks.  If it is too high, we
C           made an error and need too many tracks.  Something was
C           wrong with MINNTRK.
C
            IF( SETBPS(ISETF) .GT. TTBPS(ISETF) ) THEN
               CALL WLOG( 1, 'FMTPICK: Derived too high a track' //
     1            ' bit rate' )
               CALL WLOG( 1, '         Setup file: ' // SETFILE(ISETF) )
               CALL WLOG( 1, '         Probable programming error ' )
               CALL WLOG( 1, '         Workaround - set TPMODE or full '
     1              // 'FORMAT for more VLBA/MKIV formats.' )        
               CALL ERRLOG( 'Please report' )
C
            ELSE IF( SETBPS(ISETF) .LT. BTBPS(ISETF) ) THEN
               SETBPS(ISETF) = BTBPS(ISETF)
            END IF
         END IF
      END DO
C
C     Ok now I think I can set all the formats.
C
      DO KS = 1, NSET
         IF( VLBAMKIV(KS) .AND. RECUSED(KS) .AND. NEEDFMT(KS) ) THEN
            ISETF = ISETNUM(KS)
            CALL SETFMT( KS, SETBPS(ISETF), OK )
            IF( OK ) NEEDFMT(KS) = .FALSE.
         END IF
      END DO
C
  999 CONTINUE
      RETURN
      END

      SUBROUTINE SCNGEO( LASTISCN, NGOOD, ISCN )
Cf2py intent(in) LASTISCN, ISCN
Cf2py intent(out) NGOOD
C
C     Subroutine for SCHED that gets the geometry of a scan for all
C     stations.  It is basically a station loop for STAGEO
C     (nee OPTGEO) which does the calculations for one station.
C     STAGEO gets items like the az and el, slew times etc for each
C     station.  
C
C     SCNGEO also counts the number of stations that are up which might 
C     be used to eliminate the scan later.
C
C     SCNGEO is called by SCHOPT and by routines involved in adding scans
C     for pointing or DELZN (ADDPEAK, GMKSCN, MKSCN, SRINSERT).
C
      INCLUDE      'sched.inc'
C
      INTEGER      LASTISCN(MAXSTA), NGOOD, ISCN, ISTA   
      DOUBLE PRECISION  T_AVAIL, LASTTIME
C ---------------------------------------------------------------------
      IF( DEBUG .AND. ISCN .LT. SCAN1 + 5 ) 
     1   CALL WLOG( 0, 'SCNGEO starting' ) 
C
C     Loop over stations.
C
      NGOOD = 0
      DO ISTA = 1, NSTA
C
C        Get the geometry for all stations.  Occasionally tables
C        are printed that show the elevations, for example, of stations
C        including those that are down.  So calculate that for all
C        stations, but then only use the stations in the scan to 
C        calculate things like slews.
C
C        Get the geometry at each antenna for this source, whether or not
C        it will observe.  The output arguments for STAGEO (LASTTIME
C        and T_AVAIL) are not used for this application).
C
         CALL STAGEO( ISCN, ISTA, STARTJ(ISCN), LASTISCN(ISTA),
     1              LASTTIME, T_AVAIL, 'SCNGEO' )
C
C        Count the number of stations in the scan that will get good
C        data.
C
         IF( STASCN(ISCN,ISTA) ) THEN
C     
C           Count the number of antennas that are up.  Will use later
C           to decide whether to keep the scan.   For this
C           to matter, non-default OPMINANT and OPMINEL would
C           have to be specified. 
C     
            IF( EL1(ISCN,ISTA) .GE. OPMINEL(ISCN) .AND. 
     1          EL2(ISCN,ISTA) .GE. OPMINEL(ISCN) .AND.
     2          UP1(ISCN,ISTA) .EQ. ' ' .AND. 
     3          UP2(ISCN,ISTA) .EQ. ' ' ) THEN
               NGOOD = NGOOD + 1
            END IF
C     
         ELSE
C     
C           Clear the UP indicators for scans that are not used to keep
C           from cluttering the summary etc.
C           Note that AUTODOWN has not yet been called.  UP indicators
C           for stations scheduled to be in the scan, but removed by 
C           AUTODOWN, will be left intact.
C     
            UP1(ISCN,ISTA) = ' '
            UP2(ISCN,ISTA) = ' '
C     
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE HALIM( ISCN, IREFSTA, HAMIN, HAMAX, THAMIN, THAMAX )
Cf2py intent(in) ISCN, IREFSTA
Cf2py intent(out) HAMIN, HAMAX, THAMIN, THAMAX
C
C     Routine for optimization modes.
C     This routine figures out the hour angle limits for an input scan
C     based on the position of the source, the antenna chosen for 
C     hour angle calculation, the minimum elevation, the minimum number
C     of antennas, and, approximately, the horizon at each antenna.  It
C     also gets the appropriate times corresponding to those limits.
C
C     HAMIN and HAMAX are the reference station hour angle limits that
C        conform to the required number of stations being up.  
C     THAMIN and THAMAX are MJD times that go with those limits.  
C        THAMIN is the last rise before the experiment stop time.  
C        THAMAX is the first set after the start time.
C
      INCLUDE 'sched.inc'
C
      INTEGER           ISCN, ISTA, IREFSTA, NUP
      REAL              HAMIN, HAMAX
      LOGICAL           GOOD, HADGOOD, SEENRISE, SEENSET
      CHARACTER         HORCHK*1
      DOUBLE PRECISION  TTEST, TINT, THAMIN, THAMAX
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'HALIM starting.' )
C
C     Calculate the local hour angle limits for each scan.  
C     The source must be up at the minimum number of stations.
C     A source is up when it is above the minimum elevation for an 
C     optimization is above the horizon, and is above the antenna 
C     hardware limits.
C
C     Do an iterative search in time.  Because of the complexities
C     of checking horizons etc, this is easier than trying to calculate
C     the result analytically.  This routine is only called once per 
C     input scan so some inefficiency can be tolerated.
C
C     Go to the time of transit at the reference antenna first.
C     This is the transit closest to the experiment start time.
C     Then work backward for the rise time and forward for the stop
C     time.  Don't worry about staying in experiment boundaries -
C     we're just finding hour angle limits here.
C
C     Note that what I'm doing might not work too well with an array
C     that is distributed around the Earth with a reference antenna
C     on the fringes.  For such situations the simple concepts of 
C     a rise and set time are not so clear cut.  The reference station
C     should be in the main cluster of antennas.
C
C     In fact, for now I don't want to deal with cases where the 
C     reference antenna would not participate in a valid scan.  That
C     potentially adds layers of complexity that are unnecessary in
C     for the survey applications that this mode is for.
C   
C     This algorithm might also be fooled if a source sets on the
C     array for less than the initial TINT (1 hour).
C
C     Note that throughout, the convention is that times are in days
C     and hour angles are in hours.  Also recall that intervals of
C     hour angle are different from intervals of time by the sidereal
C     rate (SIDR=1.0027...).
C
C
C     First be sure that the source can be seen from the required
C     number of stations.  This is just a declination vs latitude
C     test so there may still be a problem trying to get enough
C     stations on source at once.
C
      NUP = 0
      DO ISTA = 1, NSTA
         IF( LAT(STANUM(ISTA)) - 90.0 * RADDEG  + 
     1        OPMINEL(ISCN) * RADDEG .LE. DECP(SRCNUM(ISCN)) ) THEN
            NUP = NUP + 1
         END IF
      END DO
      IF( NUP .LT. OPMIAN(ISCN) ) THEN
         MSGTXT = 'Fewer than OPMINANT stations can ever see source ' //
     1        SCNSRC(ISCN) // ' above OPMINEL.'
         CALL WLOG( 1, MSGTXT )
         CALL ERRLOG( 'Leave out the source or change OPMINANT ' //
     1        'or OPMINEL' )
      END IF
C
C     ---------------------------
C     Work backward from the stop time to find the last rise time to 
C     within about a minute.
C
      TTEST = STARTJ(1) + OPDUR
      TINT = -1.0D0 / 24.D0
      HADGOOD = .FALSE.
      SEENRISE = .FALSE.
      DO WHILE( ABS( TINT ) .GE. 30.D0 / 86400.D0 )
         NUP = 0 
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
C
               CALL SCHGEO( ISCN, ISTA, TTEST, HA1(ISCN,ISTA), 
     1                   EL1(ISCN,ISTA), AZ1(ISCN,ISTA),
     2                   LST1(ISCN,ISTA), PA1(ISCN,ISTA) )
               UP1(ISCN,ISTA) = HORCHK( STANUM(ISTA), HA1(ISCN,ISTA),
     1                 AZ1(ISCN,ISTA), EL1(ISCN,ISTA), SRCNUM(ISCN) )
C
               IF( UP1(ISCN,ISTA) .EQ. ' ' .AND. 
     1             EL1(ISCN,ISTA) .GT. OPMINEL(ISCN) ) THEN
                  NUP = NUP + 1
               END IF
            END IF
         END DO
C
C        Check if for this time, enough antennas can see the source.
C        If so, this is a "GOOD" time.
C
         GOOD = NUP .GE. OPMIAN(ISCN)
C
C        Keep a record of whether the source was ever up at enough 
C        stations.  Once that is true, keep a record that a rise
C        was seen.
C
         IF( GOOD ) HADGOOD = .TRUE.
         IF( HADGOOD .AND. .NOT. GOOD ) SEENRISE = .TRUE.
C
C        Test if there never is a rise in a day.  Go a bit more than
C        a day in case of edge effects.  If there was some good data,
C        then presume that the source never set.  Set HAMIN and
C        HAMAX accordingly and skip most of rest of routine.  Set
C        the time range to start at the observation start.  If
C        there was no good data, assume that the source was never
C        up at enough stations.  Quit and give user a chance to 
C        adjust matters.
C
         IF( ABS( STARTJ(1) + OPDUR - TTEST ) .GT. 1.2D0 ) THEN
            IF( HADGOOD ) THEN
               HAMIN = -24.0
               HAMAX = 24.0
               THAMIN = STARTJ(1)
               THAMAX = STARTJ(1) + 1.D0
               GO TO 999
            ELSE
               MSGTXT = 'Fewer than OPMINANT stations can ever see '//
     1          'source ' // SCNSRC(ISCN) // ' above OPMINEL at once.'
               CALL WLOG( 1, MSGTXT )
               CALL ERRLOG( 'Leave out the source or change ' //
     1                   'OPMINANT or OPMINEL' )
            END IF
         END IF
C
C        If a rise has been seen, cut TINT in half.  If the source
C        is up for the current scan, make TINT negative.  If down,
C        make it positive.  This should home on the rise time.
C
         IF( SEENRISE ) THEN
            TINT = TINT / 2.D0
            IF( GOOD ) THEN
               TINT = -1.D0 * ABS( TINT )
            ELSE
               TINT = ABS( TINT )
            END IF
         END IF
         TTEST = TTEST + TINT
      END DO
C
C     Now the best rise time estimate should be in TTEST.
C     Get the rise hour angle and transfer the rise time to the output
C     variable.
C
      CALL SCHGEO( ISCN, IREFSTA, TTEST, HA1(ISCN,ISTA), 
     1             EL1(ISCN,ISTA), AZ1(ISCN,ISTA),
     2             LST1(ISCN,ISTA), PA1(ISCN,ISTA) )
      HAMIN = HA1(ISCN,ISTA)
      THAMIN = TTEST
C
C     ---------------------------
C     Now repeat for the set time.
C     ---------------------------
C     Work forward from the start time to find the first set time.
C
      TTEST = STARTJ(1)
      TINT = 1.0D0 / 24.D0
      HADGOOD = .FALSE.
      SEENSET = .FALSE.
      DO WHILE( ABS( TINT ) .GE. 30.D0 / 86400.D0 )
         NUP = 0 
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
C
               CALL SCHGEO( ISCN, ISTA, TTEST, HA1(ISCN,ISTA), 
     1                   EL1(ISCN,ISTA), AZ1(ISCN,ISTA),
     2                   LST1(ISCN,ISTA), PA1(ISCN,ISTA) )
               UP1(ISCN,ISTA) = HORCHK( STANUM(ISTA), HA1(ISCN,ISTA),
     1                 AZ1(ISCN,ISTA), EL1(ISCN,ISTA), SRCNUM(ISCN) )
C
               IF( UP1(ISCN,ISTA) .EQ. ' ' .AND. 
     1             EL1(ISCN,ISTA) .GT. OPMINEL(ISCN) ) THEN
                  NUP = NUP + 1
               END IF
            END IF
         END DO
         GOOD = NUP .GE. OPMIAN(ISCN)
         IF( GOOD ) HADGOOD = .TRUE.
         IF( HADGOOD .AND. .NOT. GOOD ) SEENSET = .TRUE.
C
C        Test if there never is a rise in a day.  We shouldn't get
C        here because of the rise test.  But perhaps the non-complete
C        sampling could do it.  The always up case could then override
C        a HAMIN found by the rise test, but any set source will not
C        be down by much and, since down will usually have to do with
C        the OPMINEL, this won't really matter.
C
         IF( ABS( TTEST - STARTJ(1) ) .GT. 1.2D0 ) THEN
            IF( HADGOOD ) THEN 
               HAMIN = -24.0
               HAMAX = 24.0
               THAMIN = STARTJ(1)
               THAMAX = STARTJ(1) + 1.D0
               GO TO 999
            ELSE
               MSGTXT = 'Fewer than OPMINANT stations can ever see '//
     1           'source ' // SCNSRC(ISCN) // 
     2           ' above OPMINEL at once (set).'
               CALL WLOG( 1, MSGTXT )
               CALL ERRLOG( 'Leave out the source or change ' //
     1                   'OPMINANT or OPMINEL' )
            END IF
         END IF
C
C        If a set has been seen, cut TINT in half.  If the source
C        is up for the current scan, make TINT positive.  If down,
C        make it negative.  This should home on the set time.
C
         IF( SEENSET ) THEN
            TINT = TINT / 2.D0
            IF( GOOD ) THEN
               TINT = ABS( TINT )
            ELSE
               TINT = -1.D0 * ABS( TINT )
            END IF
         END IF
         TTEST = TTEST + TINT
      END DO
C
C     Now the desired set time estimate should be in TTEST
C
      CALL SCHGEO( ISCN, IREFSTA, TTEST, HA1(ISCN,ISTA), 
     1             EL1(ISCN,ISTA), AZ1(ISCN,ISTA),
     2             LST1(ISCN,ISTA), PA1(ISCN,ISTA) )
      HAMAX = HA1(ISCN,ISTA)
      THAMAX = TTEST
C
C     Done.
C
  999 CONTINUE
      RETURN
      END

      SUBROUTINE FLAGWRT( UNIT, STCODEF, STARTF, STOPF, REASON )
C
C     Routine for SCHED called by FLAGS that actually writes the line
C     in the flagfile.  This saves a lot of repetition in FLAGS
C     when writing multiple types of flags.
C
      INTEGER            UNIT
      CHARACTER          STCODEF*(*), REASON*(*)
      DOUBLE PRECISION   STARTF, STOPF, START, STOP
C
      INTEGER            YEAR, DAY1, DAY2, LEN1
      CHARACTER          TIMER*26, TFORM*12
      CHARACTER          CSTART*8, CSTOP*8
C ----------------------------------------------------------------------
C     Get the day and time of ends of the flag.
C
      CALL TIMEJ( STARTF, YEAR, DAY1, START )
      CALL TIMEJ( STOPF, YEAR, DAY2, STOP )
C     
C     Write the time range specification.
C     
      CSTART = TFORM( START, 'T', 0, 2, 2, ',,@' )
      CSTOP  = TFORM( STOP, 'T', 0, 2, 2, ',,@' )
      WRITE( TIMER, '( I3, A, A, A, I4, A, A )' )
     1   DAY1, ',', CSTART,',', DAY2, ',',CSTOP
C     
C     Write the flag line to the flag file.
C
      WRITE( UNIT, '( 7A )' )
     1   'ant_name=''', STCODEF(1:LEN1(STCODEF)),
     2   ''' timerang=', TIMER, 
     3   '  reason=''', REASON(1:LEN1(REASON)), ''' /'
C
      RETURN
      END

      SUBROUTINE OPTCELLS( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
Cf2py intent(in) LASTISCN, KSCN, ISCN
Cf2py intent(out) ADJUST, KEEP, DONE
C
C     **  CSUB may have replaced this completely.
C            But last I tried, CSUB was not working.  Also AIPS is not
C            overly fond of subarrays.
C
C
C     Routine for SCHED that trys to optimize sky coverage over each   
C     antenna by examining a grid in AZ and EL.  
C
C     In each cell in the grid, the time of the last observation
C     in that cell is stored.  For each call, the routine loops
C     through all sched input scans (keep a reasonable number, and
C     only one per source).  It calculates which cell each source
C     will be in at TAPPROX and looks at the time since the last
C     sample.  These time differences are weighted and summed over all
C     stations.  The source with the highest weight is chosen.
C
C     This routine will always create new scans after NSCANS
C     (equivalent of NEWSCANS=.TRUE.).
C
C     *********   Do something reasonable if there are no sources up.
C
C     LASTISCN(ISTA) is the most recent scan including the station.
C     ISCN is the output scan number (between SCAN1 and SCANL).
C     JSCN is the input scan number (between 1 and NSCANS).
C     ADJUST flags for when OPTSCN should adjust times.  True for
C          all scans except first.
C     KEEP will be true in all cases for this optimization mode.
C     DONE indicates beyond experiment stop time or otherwise finished.
C
C     During operation, the geometry parameters for the input
C     scans will be used to hold geometry for the current test time.
C
C     This routine does not take into account GAP.  OPTTIM later
C     in SCHOPT will do so.
C
      INCLUDE 'sched.inc'
C
      INTEGER     MAXISC
      PARAMETER   (MAXISC=1000)       ! Number of input scans.
C
      INTEGER           LASTISCN(MAXSTA), KSCN, ISCN, JSCN, LSCN
      INTEGER           ISTA, JSTA, ISCAT, JSCAT
      INTEGER           GOTSTA(MAXISC), IE, IA, YR, DY, MXSCN
      INTEGER           LASTJSCN, MAXSKIP, STSKIP(MAXSTA), ISK1
      INTEGER           LOOKBACK, NBAS, NBASE
      REAL              POINTS(MAXISC), MAXPTS, MAXAPT, SL_ADJ
      REAL              PT_ADD, WT_MUL, WTBAS(MAXSTA)
      LOGICAL           KEEP, ADJUST, DONE, ALL0
      LOGICAL           OKSTA(MAXISC,MAXSTA)
      DOUBLE PRECISION  TIMESRC(MAXISC), TAPPROX, TIME1
      DOUBLE PRECISION  LCTIME, LASTTIME 
      DOUBLE PRECISION  TIMERAD, MEANBAS(MAXSTA), MEANBASE, BASELINE
      CHARACTER         TIMECH*8, TFORM*8
      SAVE              LASTJSCN
C
C     Cell stuff.
C
      INTEGER           ELI(MAXISC,MAXSTA), AZI(MAXISC,MAXSTA)
      INTEGER           IEL, IAZ
      REAL              CELLTIME(3,3,MAXSTA)
      REAL              ELCELL(2),  AZCELL(2), AZTEST, AZCOFF
      SAVE              AZCOFF, ELCELL, AZCELL, CELLTIME
C
C     The cell boundaries.  Make input some day?
C     AZCOFF is added to the azimuth to get the "test" azimuth
C     so that I can have a cell that crosses 0.
C
      DATA      AZCOFF  / 60. /
      DATA      ELCELL  / 20., 45. /
      DATA      AZCELL  / 120., 240. /  
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'Starting OPTCELLS' )
      DONE = .FALSE.
      KEEP = .TRUE.
      ADJUST = .TRUE.
C
      IF( KSCN .EQ. 1 ) THEN
C
C        Check that various requirements are met for the optimization.
C
C        Make sure that there aren't too many input scans.
C
         IF( NSCANS .GT. MAXISC ) THEN
            WRITE( MSGTXT, '( A, I6 )' ) 
     1        ' OPTCELLS:  Too many input scans for cell optimizer'//
     2        ' - max: ', MAXISC
            CALL ERRLOG( MSGTXT )
         END IF
C
C        Make sure that OPDUR is available.
C
         IF( OPDUR .LE. 0.D0 ) THEN
            CALL ERRLOG( 
     1       ' OPTCELLS: For OPTMODE=CELLS, OPDUR must be given.' )
         END IF
C
C        Initializations.
C        Start the set of new scans beyond NSCANS and use first start
C        time.  TAPPROX is the approximate start time of the next scan.
C        Don't allow this time to be adjusted.
C
         ADJUST   = .FALSE.
         STARTJ(ISCN) = STARTJ(1)
         TAPPROX  = STARTJ(ISCN)
         LASTJSCN = 0
C
C        Initialize times to about some nominal time before the start. 
C        Also get antenna weighting factors by considering the mean
C        baseline to each station.  I want to downweight antennas that
C        are clustered.  Without something like that, it is not doing
C        as well for MK and SC in the VLBA as it is for PT, LA etc.
C
         NBASE = 0
         MEANBASE = 0.D0
         DO ISTA = 1, NSTA
            DO IEL = 1, 3
               DO IAZ = 1, 3
                  CELLTIME(IEL,IAZ,ISTA) = STARTJ(1) - 0.5D0/24.D0
               END DO
            END DO
            NBAS = 0
            MEANBAS(ISTA) = 0.D0
            ISCAT = STANUM(ISTA)
            DO JSTA = 1, NSTA
               JSCAT = STANUM(JSTA)
               IF( ISTA .NE. JSTA ) THEN
                  BASELINE = SQRT(
     1                ( XPOS(JSCAT) - XPOS(ISCAT) )**2 +
     2                ( YPOS(JSCAT) - YPOS(ISCAT) )**2 +
     3                ( ZPOS(JSCAT) - ZPOS(ISCAT) )**2 )
                  NBAS = NBAS + 1
                  MEANBAS(ISTA) = MEANBAS(ISTA) + BASELINE
                  NBASE = NBASE + 1
                  MEANBASE = MEANBASE + BASELINE
               END IF
            END DO
            MEANBAS(ISTA) = MEANBAS(ISTA) / NBAS
         END DO
         MEANBASE = MEANBASE / NBASE
         DO ISTA = 1, NSTA
            WTBAS(ISTA) = ( MEANBAS(ISTA)/ MEANBASE )**2
C            write(*,*) 'optcells wt ', ista, wtbas(ista), 
C     1          meanbas(ista), meanbase
         END DO
C
      ELSE
C      
C        The best guess for the next start time is the end of the
C        last scan.
C
         TAPPROX = STOPJ(ISCN-1)
C
      END IF
C
C     Now search through the input scans looking for which to do next.
C
C     Look at the sky position for each scan for
C     each source and accumulate priority points.
C     Don't consider doing the same source again (LASTJSCN sets this).
C
      DO JSCN = 1, NSCANS
         POINTS(JSCN) = 0.0
         GOTSTA(JSCN) = 0
         IF( JSCN .NE. LASTJSCN ) THEN
            DO ISTA = 1, NSTA
               OKSTA(JSCN,ISTA) = .FALSE.
               IF( STASCN(JSCN,ISTA) ) THEN
C
C                 Get the geometric parameters.
C
                  CALL STAGEO( JSCN, ISTA, TAPPROX, LASTISCN(ISTA),
     1                   LASTTIME, TONSRC(JSCN,ISTA), 'OPTCELLS' )
C
C                 Only do anything if the station is up.
C
                  IF( UP1(JSCN,ISTA) .EQ. ' ' .AND. 
     1                UP2(JSCN,ISTA) .EQ. ' ' .AND.
     2                EL1(JSCN,ISTA) .GT. OPMINEL(JSCN) .AND.
     3                EL2(JSCN,ISTA) .GT. OPMINEL(JSCN) ) THEN
                     OKSTA(JSCN,ISTA) = .TRUE.
                     GOTSTA(JSCN) = GOTSTA(JSCN) + 1
C
C                    Take out effect of cable wrap and add offset.
C
                     AZTEST = MOD( AZ1(JSCN,ISTA) + AZCOFF, 360.0 )
                     IF( AZTEST .LT. 0.0 ) AZTEST = AZTEST + 360.0
C
C                    Get El cell
C
                     IF( EL1(JSCN,ISTA) .LT. ELCELL(1) ) THEN
                        ELI(JSCN,ISTA) = 1
                     ELSE IF( EL1(JSCN,ISTA) .LT. ELCELL(2) ) THEN
                        ELI(JSCN,ISTA) = 2
                     ELSE
                        ELI(JSCN,ISTA) = 3
                     END IF
C
C                    Az:
C
                     IF( ELI(JSCN,ISTA) .EQ. 3 ) THEN
                        AZI(JSCN,ISTA) = 1
                     ELSE
                        IF( AZTEST .LT. AZCELL(1) ) THEN
                           AZI(JSCN,ISTA) = 1
                        ELSE IF( AZTEST .LT. AZCELL(2) ) THEN
                           AZI(JSCN,ISTA) = 2
                        ELSE
                           AZI(JSCN,ISTA) = 3
                        END IF
                     END IF
                  END IF
               END IF
C
            END DO
C
C           Now get earliest time for this source.
C           If OPNOSUB, do now allow scans to overlap.  They can abut
C           if they don't share antennas.
C
            TIMESRC(JSCN) = 1.D10
            ALL0 = .TRUE.
            DO ISTA = 1, NSTA
               IF( OKSTA(JSCN,ISTA) .AND. LASTISCN(ISTA) .NE. 0 ) THEN
                  ALL0 = .FALSE.
                  TIMESRC(JSCN) = MIN(TIMESRC(JSCN), TONSRC(JSCN,ISTA))
                  IF( OPNOSUB .AND. ISCN .GT. SCAN1 ) THEN
                     TIMESRC(JSCN) = MAX( TIMESRC(JSCN), STOPJ(ISCN-1) )
                  END IF
               END IF
            END DO
            IF( ALL0 ) TIMESRC(JSCN) = STARTJ(1)
C
C           Accumulate the priority points.  Make them in minutes.
C           This is based on the sum of times since last points in the
C           cells hit for all stations.  Thus the source with the
C           highest number of points is the one that samples the
C           best collection of cells that haven't been sampled in a
C           long time.
C
C           Add a little extra emphasis for low elevation cells on 
C           stations where not all low elevation cells can be hit.
C           Detect this by looking for long times to last hit in cells.
C
C           Be sure this source ok (enough stations up) , and 
C           then get points.
C
            IF( GOTSTA(JSCN) .GE. OPMIAN(JSCN) ) THEN
               DO ISTA = 1, NSTA
                  IF( OKSTA(JSCN,ISTA) ) THEN
C
C                    Get which cell is sampled.
C
                     IE = ELI(JSCN,ISTA)
                     IA = AZI(JSCN,ISTA)
C
C                    Determine any extra weight.  This will be for
C                    points in the lowest elevation range only.
C                    The function is one that is very small for times
C                    less than OPTLOWT (input parameter) and rises
C                    to near unity for longer times.  Thus a low
C                    elevation scan could get close to 3 times the
C                    weight it might have.
C
                     WT_MUL = 1
                     IF( IE .EQ. 1 ) THEN
                        DO IAZ = 1, 3
                           IF( IAZ .NE. IA ) THEN
                              PT_ADD = 1440.D0 * ( TIMESRC(JSCN) - 
     1                                 CELLTIME(IE,IAZ,ISTA) )
                              WT_MUL = WT_MUL +
     1                          PT_ADD**2 / ( OPTLOWT**2 + PT_ADD**2 )
                           END IF
                        END DO
                     END IF
C
C                    Get minutes since the previous sample of this cell.
C
                     LCTIME = CELLTIME(IE,IA,ISTA)
                     PT_ADD =  1440.D0 * ( TIMESRC(JSCN) - LCTIME )
C
C                    Increment the points for this source, weighted.
C
C                    Try an experiment and use the points for the
C                    most beneficial antenna, not summed.  With
C                    summed, the groups of nearby antennas may 
C                    be favored.  Or try weights.
C
                     POINTS(JSCN) = POINTS(JSCN) + 
     1                   WTBAS(ISTA) * PT_ADD * WT_MUL
C                     POINTS(JSCN) = MAX( POINTS(JSCN), PT_ADD * WT_MUL )
C
                  END IF
               END DO
            END IF
         END IF
C         
      END DO
C
C     Get the current maximum of POINTS to help in weighting
C     other effects.  Unused scans (sources) will have points=0.
C     **** this is not used any more except in the debug write.
C
      MAXPTS = 0.0
      DO JSCN = 1, NSCANS
         IF( POINTS(JSCN) .GT. MAXPTS ) THEN
            MAXPTS = POINTS(JSCN)
         END IF         
      END DO
C
C     Adjust the POINTS by a multiplier that lowers weights
C     of sources requiring a long slew.  The multiplier is
C     near unity at first, then at about OPTSLEW, it starts
C     dropping fairly sharply.
C
C     TIME1 is the earliest start time. Recall that high POINTS
C     favor a scan.  
C
      TIME1 = 1.D10
      DO JSCN = 1, NSCANS
         IF( GOTSTA(JSCN) .GE. OPMIAN(JSCN) ) THEN
            TIME1 = MIN( TIME1, TIMESRC(JSCN) )
         END IF
      END DO
C
C     Get the multiplier and adjust the points.
C
      DO JSCN = 1, NSCANS
         IF( GOTSTA(JSCN) .GE. OPMIAN(JSCN) ) THEN
            SL_ADJ = 1440.D0 * ( TIMESRC(JSCN) - TIME1 )
            WT_MUL = OPTSLEW**2 / ( SL_ADJ**2 + OPTSLEW**2 )
            POINTS(JSCN) = POINTS(JSCN) * WT_MUL
         END IF
      END DO
C
C     Downweight a scan if it does not include a station that
C     has had too few scans recently.  Hardwire the parameters
C     for now - maybe make inputs some day.
C
      LOOKBACK = 6
      DO ISTA = 1, NSTA
         STSKIP(ISTA) = 0
      END DO
      IF( ISCN .GT. SCAN1 + 2 ) THEN
         ISK1 = MAX( ISCN - LOOKBACK , SCAN1 )
         DO LSCN = ISK1, ISCN - 1
            DO ISTA = 1, NSTA
C
C              Test if station is in scan and above minimim
C              elevation limit.  Note with OPNOSUB, there could
C              be stations in the scan that have too low elevation.
C
               IF( .NOT. ( STASCN(LSCN,ISTA) .AND. 
     1             EL1(LSCN,ISTA) .GT. OPMINEL(LSCN) ) ) THEN
                  STSKIP(ISTA) = STSKIP(ISTA) + 1
               END IF
            END DO
         END DO
      END IF
      DO JSCN = 1, NSCANS
         MAXSKIP = 0
         DO ISTA = 1, NSTA
            IF( .NOT. ( STASCN(JSCN,ISTA) .AND. 
     1          EL1(JSCN,ISTA) .GT. OPMINEL(JSCN) ) ) THEN
               MAXSKIP = MAX( MAXSKIP, STSKIP(ISTA) )
            END IF
         END DO
C
C        Now do the downweight.
C
         IF( MAXSKIP .GT. LOOKBACK / 3 ) THEN
            POINTS(JSCN) = 0.2 * POINTS(JSCN)
         END IF
      END DO
C
C     Choose the next JSCN - the input scan number.
C
      MAXAPT = -1.D10
      MXSCN = 0
      DO JSCN = 1, NSCANS
         IF( POINTS(JSCN) .GT. MAXAPT ) THEN
            MXSCN = JSCN
            MAXAPT = POINTS(JSCN)
         END IF         
      END DO
C
      IF( MXSCN .GT. 0 ) THEN
         JSCN = MXSCN
      ELSE
         CALL ERRLOG( 'OPTCELLS: Something weird went wrong '//
     1       'with POINTS.' )
      END IF
C
C     Copy JSCN stuff into scan ISCN.  This includes DUR, but not 
C     STARTJ and STOPJ.  Set nominal values for those separately.
C
      CALL SCNDUP( ISCN, JSCN, .FALSE., 'OPTCELLS' )
      STARTJ(ISCN) = TIMESRC(JSCN)
      STOPJ(ISCN)  = STARTJ(ISCN) + DUR(ISCN)
C
C     Set flag to prevent using this scan again immediately.
C
      LASTJSCN = JSCN
C
C     Write some info to screen.  Note that one scan beyond end
C     will be printed because the end is detected later in SCHOPT.
C
      CALL TIMEJ( STARTJ(ISCN), YR, DY, TIMERAD )
      TIMECH = TFORM( TIMERAD, 'T', 0, 2, 2, '::@' )
      WRITE( MSGTXT, '(A, A12, I4, 1X, A, 2F10.3 )' ) 
     1        ' Source, time, maxpts, maxapt: ',
     1        SCNSRC(ISCN), DY, TIMECH, MAXPTS, MAXAPT
      CALL WLOG( 0, MSGTXT )
C
C     Refill the CELLTIME array.  JSCN has been chosen.  Also set
C     STASCN to give stations to include.  The request for avoiding
C     subarrays was taken into account earlier when setting the 
C     start time.
C
      DO ISTA = 1, NSTA
C         STASCN(ISCN,ISTA) = OPNOSUB
         IF( OKSTA(JSCN,ISTA) ) THEN
            CELLTIME(ELI(JSCN,ISTA),AZI(JSCN,ISTA),ISTA) = 
     1               STARTJ(ISCN)
            STASCN(ISCN,ISTA) = .TRUE.
         ELSE
            STASCN(ISCN,ISTA) = .FALSE.
         END IF
      END DO 
C
      RETURN
      END

      SUBROUTINE SCHPRE
C
C     The source catalog can contain B1950, J2000, and/or apparent 
C     coordinates of date. SCHED prints all three.  Where there is a 
C     choice, the control file will contain the epoch given in the 
C     catalog.  If more than one was given (flagged in PEPOCH), 
C     the preference order is DATE, J2000, B1950.
C
C     The routine precesses to the epochs not provided in the catalog 
C     using the Starlink SLALIB precession routines. Date coordinates
C     (where not given) are computed for the stop time of the first 
C     scan.  The B1950/J2000 conversions assume that the coordinates 
C     were determined from observations at epoch PRECDATE (User input)
C     which defaults to 1979.9, which is the value used to determine
C     B1950 coordinates on the VLA.
C
C     Note that any use of B1950 coordinates can introduce a lot of
C     uncertainty in source positions at milliarcsecond levels.  It
C     is not recommended.
C
C     Proper motions and paralax added March 2003 RCW.  
C
C     Modified for apparent rather than mean coordinates of date and
C     B1950/J2000 coordinate transforms fixed by John Reynolds, 
C     Feb. 1991
C
C     Updated the SLA routines to GNU licensed versions in April 2013.
C     Without modification of this code, this caused the coordinates
C     of date to change by a few tens of milli-arcseconds.  The B1950
C     and J2000 did not change.

C
      INCLUDE 'sched.inc'
C
      INTEGER           ISRC, YEAR, DAY
      DOUBLE PRECISION  DR, DD  !  Dummy proper motion parameters.
      DOUBLE PRECISION  STOP    !  Dummy for stop time.
      DOUBLE PRECISION  RAIN, DECIN, RAOUT, DECOUT
      DOUBLE PRECISION  RPMRA, RPMDEC
      DOUBLE PRECISION  NEWEPO, SLA_EPJ
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SCHPRE:  Starting.' )
C
      CALL TIMEJ( STOPJ(1), YEAR, DAY, STOP )      
      DO ISRC = 1, MSRC
C
C        Check if some sort of coordinates were provided.
C
         IF(C1950(ISRC).EQ.' ' .AND. C2000(ISRC).EQ.' ' 
     1        .AND. CDATE(ISRC).EQ.' ' ) THEN
            CALL ERRLOG( ' No coordinates for '//SOURCE(1,ISRC) )
         END IF
C
C        First check if we need to deal with proper motions or
C        paralax.  Recall that PMRA and PMDEC are in arcsec/yr
C        (converted in RDSRC from input mas values),
C        DRA is in change of time seconds/UT day, and DDEC is in
C        change of arcseconds/UT day.
C
         IF( PMRA(ISRC) .NE. 0.D0 .OR.
     1       PMDEC(ISRC) .NE. 0.D0 .OR.
     2       PARALAX(ISRC) .NE. 0.D0 ) THEN
C
C           We need to take out the proper motion and paralax.
C
C           First get the starting point coordinates.
C
            IF( C2000(ISRC) .EQ. '*' ) THEN
               RAIN = RA2000(ISRC)
               DECIN = D2000(ISRC)
            ELSE IF( C1950(ISRC) .EQ. '*' ) THEN
               RAIN = RA1950(ISRC)
               DECOUT = D1950(ISRC)
            ELSE IF( CDATE(ISRC) .EQ. '*' ) THEN
               RAIN = RAP(ISRC)
               DECOUT = DECP(ISRC)
            END IF
C
C           Get the time near the observation to use to get
C           current positions.  If PMTIME is zero, set it to
C           the new reference time so that DRA and DDEC can
C           be used to deal with fast proper motions.
C
            IF( PMTIME(ISRC) .NE. 0.D0 ) THEN
               NEWEPO = SLA_EPJ( PMTIME(ISRC) )
            ELSE
               NEWEPO = SLA_EPJ( STOPJ(1) )
               PMTIME( ISRC ) = STOPJ(1)
            END IF
C
C           Convert the proper motions to radians per year.
C           RPMRA is supposed to be the rate of change of the 
C           coordinate, not the angular rate.  Hence the divide
C           by cos(dec)
C
            RPMRA = PMRA(ISRC) * RADDEG / ( 3600.D0 * COS( DECIN ) )
            RPMDEC = PMDEC(ISRC) * RADDEG / 3600.0D0
C
C           Apply the proper motions and paralax.  Note I am ignoring
C           the velocity term.
C
            CALL SLA_PM( RAIN, DECIN, RPMRA, RPMDEC, PARALAX(ISRC), 
     1                 0.D0, EPOCHT(ISRC), NEWEPO, RAOUT, DECOUT )
C
C           Install the new coordinates.
C
            IF( C2000(ISRC) .EQ. '*' ) THEN
               RA2000(ISRC)  = RAOUT
               D2000(ISRC) = DECOUT
            ELSE IF( C1950(ISRC) .EQ. '*' ) THEN
               RA1950(ISRC)  = RAOUT
               D1950(ISRC) = DECOUT
            ELSE IF( CDATE(ISRC) .EQ. '*' ) THEN
               RAP(ISRC)  = RAOUT
               DECP(ISRC) = DECOUT
            END IF
C
C           Add the PMRA and PMDEC to the DRA and DDEC
C           Some stellar proper motions are large enough to
C           cause motions of a few beams for VLBI during
C           a day.  This is no problem for pointing, but
C           to be pedantic, here we go.
C
            DRA(ISRC) = DRA(ISRC) + PMRA(ISRC)
     1                 / ( 365.25D0 * 15.D0 * COS( DECOUT ) )
            DDEC(ISRC) = DDEC(ISRC) + PMDEC(ISRC) / 365.25D0
         END IF
C
C        Get the missing coordinates.
C
C        If 1950 coordinates were not given, get them.
C
         IF( C1950(ISRC).EQ.' ' ) THEN
            IF( C2000(ISRC).EQ.'*' ) THEN
               CALL SLA_FK54Z( RA2000(ISRC), D2000(ISRC),
     1            PRECDATE, RA1950(ISRC), D1950(ISRC), DR, DD )
            ELSE
               CALL SLA_AMP( RAP(ISRC), DECP(ISRC), STOPJ(1),
     1            2000.D0, RA2000(ISRC), D2000(ISRC) )
               CALL SLA_FK54Z( RA2000(ISRC), D2000(ISRC),
     1            PRECDATE, RA1950(ISRC), D1950(ISRC), DR, DD )
            END IF
         END IF
C
C        If 2000 coordinates were not given, get them.
C
         IF( C2000(ISRC).EQ.' ' ) THEN
            IF( C1950(ISRC).EQ.'*' ) THEN
               CALL SLA_FK45Z( RA1950(ISRC), D1950(ISRC),
     1            PRECDATE, RA2000(ISRC), D2000(ISRC) )
            ELSE
               CALL SLA_AMP( RAP(ISRC), DECP(ISRC), STOPJ(1),
     1            2000.D0, RA2000(ISRC), D2000(ISRC) )
            END IF
         END IF
C
C        If coordinates of date were not given, get them.
C
         IF( CDATE(ISRC).EQ.' ' ) THEN
            CALL SLA_MAP( RA2000(ISRC), D2000(ISRC),
     1         0.D0, 0.D0, 0.D0, 0.D0, 2000.D0, STOPJ(1),
     2         RAP(ISRC), DECP(ISRC) )
         END IF
C
      END DO
C
C     Do any required precessions to the full catalog source
C     list if it will be used.
C
      IF( PLOT ) CALL SRLPRE( PRECDATE, STOPJ(1) )
C
      RETURN
      END

      LOGICAL FUNCTION VXCFDA( ISTA, JSTA )
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 020596 
C     returns true if DA block in 2 SCHED STAs are identical
C     cf high or low density, thick or thin, n_heads etc
C     Updated for 1.4 220796 Huib
C
C     CR: 8 Nov 2005. Note we have a problem here. If there is a station
C      in the schedule that never appears in a scan (possible when AUTOTAPE is
C      being used), then the tests for ISET and JSET can return
C      undefined values which result in a segmentation error. Need to
C      think how to deal with this - may affect other parts of the VEX
C      writer too.
C
C     As part of removing tape, I have commented out some of the tests
C     here as they are tape specific.  July 22, 2010  RCW
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER ISTA, JSTA, ISET, JSET, ISCAT, JSCAT, I
      LOGICAL IDENT
C ----------------------------------------------------------------------
C
      IDENT = .TRUE.      
C
C     Find out both densities and lengths and recorder
C
C      IF( DENSITY(ISTA) .NE. DENSITY(JSTA) ) 
C     1     IDENT = .FALSE.
C      IF( TPLENG(ISTA) .NE. TPLENG(JSTA) ) 
C     1     IDENT = .FALSE.
C
C     Note STNDRIV is not given in the current station catalogs (NDRIVES)
C     in the Mark5A era.  It might return if stations get more than one
C     disk system but that is not yet supported.  The default for 
C     STNDRIV is 2, which was appropriate for tapes at the VLBA, but not
C     for any current system.  That should not have any effect.  The same
C     comments go for NHEADS.  In fact, I don't see where that one will
C     return so I have commented it out (RCW).
C
      IF( STNDRIV(STANUM(ISTA)) .NE. STNDRIV(STANUM(JSTA)) )
     1     IDENT = .FALSE.
C      IF( NHEADS(STANUM(ISTA)) .NE. NHEADS(STANUM(JSTA)) )
C     1     IDENT = .FALSE.
C
C     Can also be a lot of things between the format & control
C     find a typical Set for each telescope
C
      ISET = 0
      ISCAT = STANUM(ISTA)
      DO I = 1, NSET
         IF ( USED(I) .AND. ( 
     1       STATION(ISCAT) .EQ. SETSTA(1,I) )) ISET = I
      END DO
      IF ( ISET .EQ. 0 ) THEN
         CALL WLOG (1, 'VXCFDA: ' // STATION(ISCAT) // ' does ' //
     1   'not appear in any scans!' )
      END IF
C
      JSET = 0
      JSCAT = STANUM(JSTA)
      DO I = 1, NSET
         IF ( USED(I) .AND. (
     1       STATION(JSCAT) .EQ. SETSTA(1,I) )) JSET = I
      END DO
C
C     Recorder and USETAPE are obsolete RCW.
C        but add back in DISK to be able to separate Mark5A & 5B stations
C        into different $DAS-section blocks -- rmc (16sep2011)
C
      IF( CONTROL(ISCAT) .NE. CONTROL(JSCAT) ) IDENT = .FALSE.
      IF( DAR(ISCAT) .NE. DAR(JSCAT) ) IDENT = .FALSE.
      IF( DISK(ISCAT) .NE. DISK(JSCAT) ) IDENT = .FALSE.
C      IF( RECORDER(ISCAT) .NE. RECORDER(JSCAT) ) IDENT = .FALSE.
C      IF( USETAPE(ISTA) .NEQV. USETAPE(JSTA) ) IDENT = .FALSE.
C
C     If station appears in no scans, then ISET and JSET can still be 0
      IF( ISET .GT. 0 .AND. JSET .GT. 0 ) THEN
C
C        This could be made more elegant, as the fanout may be omitted 
C        but no harm can be done, only an extra def section
C        Actually, for cases with observations with different formats
C        in different scans, this could falsely claim stations are
C        different.
C
         IF( FORMAT(ISET) .NE. FORMAT(JSET) ) IDENT = .FALSE.
         IF( FANOUT(ISET) .NE. FANOUT(JSET) ) IDENT = .FALSE.
      END IF
C
      VXCFDA = IDENT 
C
      RETURN
      END

      LOGICAL FUNCTION BADLO( PARM, FREQ, FMULT, NADD, 
     1                  FADD1, FADD2, FMIN, FMAX, MSG )
C
C     Function for SCHED, called by CHKVLA and maybe others, that
C     checks an LO setting.  
C
C     Problems with precision preclude using a simple statement such as 
C       IF ( MOD( VLASYNB(KS), 50.0 ) .NE. 10.1 ) THEN
C     Require the match to be good to a part in 2.E10. 
C     All numbers were converted to DOUBLE PRECISION to make this
C     possible.
C
C     The LO (FREQ) must be N*FMULT +- FADD.
C     There can be zero to two (NADD) FADDs: FADD1 and FADD2.  
C     If NADD = -1, just check the range.
C     FREQ must lie between FMIN and FMAX.
C
C     MSG just saves space by using calling routine's variable.
C
      CHARACTER          PARM*(*)
      INTEGER            NADD
      DOUBLE PRECISION   FREQ, FMULT, FADD1, FADD2, AFREQ, BFREQ
      DOUBLE PRECISION   FMIN, FMAX
      DOUBLE PRECISION   TEST, DIFF
      LOGICAL            GOOD
      CHARACTER          MSG*(*)
C --------------------------------------------------------------------
      IF( NADD .LT. -1 .OR. NADD .GT. 2 ) THEN
         CALL ERRLOG( 'BADLO: Bad value for NADD' )
      END IF
C
      BADLO = .FALSE.
C
      AFREQ = ABS( FREQ )
      TEST = AFREQ / 2.D10
      IF( NADD .EQ. 0 ) THEN
C
C        Check for N*FMULT if no offsets.
C
         DIFF = ABS( FMULT * DNINT( AFREQ / FMULT ) - AFREQ )
         IF( DIFF .GT. TEST ) BADLO = .TRUE.
      ELSE IF( NADD .GE. 1 ) THEN
         GOOD = .FALSE.
C
C        Check for N*FMULT + FADD1
C
         BFREQ = AFREQ - FADD1
         DIFF = ABS( FMULT * DNINT( BFREQ / FMULT ) - BFREQ )
         IF( DIFF .LE. TEST ) GOOD = .TRUE.                  
C
C        Check for N*FMULT - FADD1
C
         BFREQ = AFREQ + FADD1
         DIFF = ABS( FMULT * DNINT( BFREQ / FMULT ) - BFREQ )
         IF( DIFF .LE. TEST ) GOOD = .TRUE.                  
C
         IF( NADD .EQ. 2 ) THEN
C
C           Check for N*FMULT + FADD2
C
            BFREQ = AFREQ - FADD2
            DIFF = ABS( FMULT * DNINT( BFREQ / FMULT ) - BFREQ )
            IF( DIFF .LE. TEST ) GOOD = .TRUE.                  
C
C           Check for N*FMULT - FADD2
C
            BFREQ = AFREQ + FADD2
            DIFF = ABS( FMULT * DNINT( BFREQ / FMULT ) - BFREQ )
            IF( DIFF .LE. TEST ) GOOD = .TRUE.                  
C
         END IF
C
         IF( .NOT. GOOD ) BADLO = .TRUE.
C
      END IF
C
C     Check range.
C
      IF( FREQ .LT. FMIN .OR. FREQ .GT. FMAX ) THEN
         BADLO = .TRUE.
      END IF
C
C     Write warnings.
C
      IF( BADLO ) THEN
         MSG = ' '
         WRITE( MSG, '( 3A, F10.3 )' )
     1       'BADLO: Bad LO frequency.  Parameter ', PARM,
     2       ' = ', FREQ
         CALL WLOG( 1, MSG )
         MSG = ' '
         IF( NADD .EQ. 0 ) THEN
            WRITE( MSG, '( A, F10.3 )' )
     1          '       It should be N * ', FMULT
         ELSE IF( NADD .EQ. 1 ) THEN
            WRITE( MSG, '( A, F10.3, A, F8.3 )' )
     1          '       It should be N * ', FMULT, ' +- ', FADD1
         ELSE IF( NADD .EQ. 2 ) THEN
            WRITE( MSG, '( A, F10.3, A, F8.3, A, F8.3 )' )
     1          '       It should be N * ', FMULT, ' +- ', FADD1, 
     2          ' or +- ', FADD2
         END IF
         IF( NADD .NE. -1 ) CALL WLOG( 1, MSG )
C
         MSG = ' '
         WRITE( MSG, '( A, F10.3, A, F10.3 )' )
     1       '       It should be between ', FMIN, ' and ', FMAX
         CALL WLOG( 1, MSG )
C
      END IF
C
      RETURN
      END

      SUBROUTINE DOPCRD
C
C     This is a varient on DOPFQ specifically for setting the frequencies
C     for the the legacy system, mostly on the VLBA, when doing
C     observations with the RDBE - especially with the PFB where fine
C     frequency tuning is not allowed.  It is mainly for use to arrange
C     for reference pointing on maser lines.
C
C     Called by DOPFQ.
C
C     The number of channels is specified by CRDNCH which is required
C     when CRDFREQ or CRDDOP (but not CRDBW) is specified.  Some channel
C     information is obtained from the setup file channels and one may
C     not wish to use just the first CRDNCH of those (think dual band
C     cases), especially with the PFB.  CRDCH1 allows the user to 
C     specify the first channel of the setup file to use for the crd
C     file channel 1.  The rest will be sequential from there when 
C     using CRDNCH.  CRDSETCH allows an arbitrary list of channels
C     to be specified.
C
C     CRDBW will be required user input if either CRDFREQ or CRDDOP
C     has been specified.  Specification of CRDFREQ and CRDDOP is
C     considered invalid as they stomp on each other.
C
C     If CRDDOP is specified, this routine sets CRDFREQ based on the
C     source velocity information, experiment timing, and CRDBW.  If 
C     multiple velocities are given for the source, they will be 
C     assumed to apply to the CRD channels, not necessarily the 
C     setup channels.  
C
C     CRDFREQ will only be used later in making the crd files 
C     when it has been set, either as an explicit input or here as a 
C     result of doppler calculations.  Otherwise the BBCs will be set to
C     values based on the RDBE channel settings.
C
C     The main purpose of this routine is to get away from needing a 
C     whole second schedule for the legacy system, which includes the 
C     control computer that deals with antenna control, when doing 
C     reference pointing.
C
C     The user inputs are:
C       CRDNCH(ISCN)      - Number of channels to specify to the BBCs.
C       CRDCH1(ISCN)      - Start setup file channel to get channel
C                           parameters such as IF, Pol, FIRSTLO etc.
C       CRDFREQ(ICH,ISCN) - LO sum for channel ICH in scan ISCN in 
C                           the legacy system.  Comparable to FREQ 
C                           for the main schedule.
C       CRDBW(ICH,ISCN)   - Bandwidth for the BBC channel/scan.
C       CRDDOP/CRDNODOP   - Comparable to DOPPLER/NODOP but for the BBCs.
C
C     In addition, CRDSIDE(ICH,KS) is saved for each setup group to 
C     preserve the original sideband specification prior to any changes
C     related to correlator sideband inversion (CORINV etc).
C
C     The rest of the setup will be the same as for the main channels,
C     including the IFCHAN, IF and RF sidebands, and all the external 
C     LO settings.  Also the spectral line to use is the same as for 
C     the main schedule.  The number of channels will be limited to 
C     8 compared to the usual PFB number of 16.  For just reference 
C     pointing, this could be just one, but I won't make it that 
C     restrictive.  Note that using the main channel sideband is likely 
C     to cause the use of lower sideband, but that should be ok.
C
C     PCALX frequency choices will be made in WRTFREQ.
C
C     The velocities are obtained from the source catalog.  Caution - the
C     velocities are by channel.  It is not particularly wise to try to
C     do Doppler setting for both the main channels and the pointing BBC
C     (CRD) channels.
C
C     The rest frequencies were read in the LINEINIT records in the main
C     schedule input.
C
C     Use SLA lib routines to do the calculations.  For now, do the 
C     calculations for the center of the Earth for the middle of the
C     experiment.  TFIRST and TEND were calculated by SCHTIM, which
C     must be called earlier.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER          ISCN, YEAR, DAY, IGP, NGP, ICH
      INTEGER          ISETF, SBW
      INTEGER          ICHS
      REAL             RA4, DEC4, SLA_RVLSRK, VELC, TIME4
      REAL             VSUN, VEARTH, TL
      LOGICAL          DEQUAL
      DOUBLE PRECISION TMID, TIME, VELTOT, VELSRC
      DOUBLE PRECISION DFREQ(MAXCHN), DBW(MAXCHN)
C
C     Velocity of light m/s
C
      PARAMETER (VELC=2.99792458E8)
C
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'DOPBBC: Starting. ' )
C
C     Loop through scans looking for ones that need doppler calc (CRDDOP).
C     Don't worry about OKXC etc for this one.
C
C     Note that the CRD parameters, except CRDNCH, were initialized as
C     part of the user input reading process for CRDFREQ and CRDBW and
C     as part of establishing the frequency sets for CRDSIDE.  CRDNCH
C     still needs to be set.  It will be used later as a flag concerning
C     whether to use the CRD parameters, or use the old scheme for
C     deriving the BBC frequencies from the main baseband data.
C
      DO ISCN = SCAN1, SCANL
         ISETF = SETNUM(ISCN)
C
C        Initialize the CRD variables for this scan.
C        Note that CRDSIDE is per setup group, not setup file.  It was
C        set in SETFCAT to equal SIDEBD, before sideband inversions but
C        after the normal frequency settings are done.
C
C        First check that inappropriate requests have not been made.
C
         IF( CRDDOP(ISCN) ) THEN
C
C           Don't attempt to set frequencies when there is no setup.
C
            IF( NOSET ) THEN
               CALL ERRLOG( 'DOPCRD: Doppler calculations requested '//
     1           'with no setup.  I cannot do that!' )
            END IF
C
C           Balk at CRDDOP when different stations have incompatible
C           channelization (OKXC false).  "see above" refers to message
C           from SFINFO.  One way to get this is to have no setup.
C
            IF( .NOT. OKXC(ISETF) ) THEN
               CALL ERRLOG( 'DOPCRD: Doppler calculations requested '//
     1           'but have been disabled.  See SFINFO message above.' )
            END IF
C
C           Don't allow both frequency setting and Doppler request.  
C           Assume a test against channel 1 is adequate.
C
            IF( CRDFREQ(1,ISCN) .NE. 0.D0 ) THEN
               CALL WLOG( 1, ' DOPCRD.  Both Doppler calculation ' //
     1             'and a specific frequency requested ' )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I5, A )' )
     1            '          for legacy system reference pointing in ',
     2            'scan ', ISCN
               CALL WLOG( 1, MSGTXT )
               CALL ERRLOG(  
     1             '          Please choose only one option.' )
            END IF
C
         END IF
C
C        Check that CRDFREQ and CRDBW were not specified when 
C        the channelization is unclear.  Again the "see above" refers
C        to a message from SFINFO.  Really this only catches CRDBW
C        because CRDDOP will be true if CRDFREQ not zero.
C
         IF( .NOT. CRDDOP(ISCN) .AND. .NOT. OKXC(ISETF) .AND.
     1     ( CRDFREQ(1,ISCN) .NE. 0.D0 .OR. 
     2     CRDBW(1,ISCN) .NE. 0.0 ) ) THEN
C
            CALL WLOG( 1, 'PBBCDOP: CRDFREQ or CRDBW requested but ' 
     1          // 'disabled.  See SFINFO message above.' )
            CALL ERRLOG( '        Fix channelization or don''t use '//
     1                  'CRDFREQ or CRDBW.' )
         END IF
C
C        Check that CRDNCH is viable - less than the number of BBCs
C        and the number of channels in the main setup (so we don't
C        try using some unset parameter like FIRSTLO).
C        Recall that INFDB forced that it be set by the user if 
C        CRDFREQ or CRDDOP were set, so we should not need to set it
C        or test for too low a value.
C
         IF( CRDNCH(ISCN) .GT. MIN( MAXCRD, MSCHN(ISETF) ) ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I3, A )' )
     1          'DOPCRD: CRDNCH must be less than', MAXCRD, 
     2          '(number of BBCs) and less than the '
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, 
     1          '        number of channels in the setup file.' )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5, A, I5 )' ) 

     2          ISCN
            CALL ERRLOG( MSGTXT )
         END IF
C
C        Be sure the required bandwidths were given.
C        If so. Transfer it to DBW for internal use in this routine.
C
         IF( CRDFREQ(1,ISCN) .GT. 0.D0 .OR. CRDDOP(ISCN) ) THEN
            DO ICH = 1, CRDNCH(ISCN)
               IF( CRDBW(ICH,ISCN) .LE. 0.D0 ) THEN
                  MSGTXT = ' ' 
                  WRITE( MSGTXT, '( 2A, I5, A, I5 )' )
     1               'DOPCRD: CRDFREQ, but not CRDBW, was specified ',
     2               'for BBC channel ', ICH,' in scan ', ISCN
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT = ' '
                  CALL ERRLOG( '        Please specify CRDBW ' )
               ELSE
                  DBW(ICH) = CRDBW(ICH,ISCN)
               END IF
C
C              Complain if the bandwidth is not allowed (not subject to
C              the normal checking earlier because these are not the 
C              main setup channels).
C
               IF( .NOT. (
     1             DEQUAL( DBW(ICH), 0.0625D0 ) .OR. 
     2             DEQUAL( DBW(ICH), 0.125D0 ) .OR. 
     3             DEQUAL( DBW(ICH), 0.25D0 ) .OR. 
     4             DEQUAL( DBW(ICH), 0.5D0 ) .OR. 
     5             DEQUAL( DBW(ICH), 1.0D0 ) .OR. 
     6             DEQUAL( DBW(ICH), 2.0D0 ) .OR. 
     7             DEQUAL( DBW(ICH), 4.0D0 ) .OR. 
     8             DEQUAL( DBW(ICH), 8.0D0 ) .OR. 
     9             DEQUAL( DBW(ICH), 16.D0 ) ) ) THEN
                  MSGTXT = ' ' 
                  WRITE( MSGTXT, '( A, I5, A, I5, A, F6.2 )' )
     1               'DOPBBC:  Invalid CRDBW found in scan ', ISCN, 
     2               ' channel ', ICH, ' Value: ', DBW(ICH)
                  CALL WLOG( 0, MSGTXT )
                  CALL ERRLOG( '         Must be power of two between '
     1               // '0.0625 and 16 MHz' )
               END IF
C
            END DO
         END IF
C
C        Now deal with a Doppler request.
C
         IF( CRDDOP(ISCN) ) THEN
C
C           Get the velocity of the Earth in the direction of the 

C           and the solar system velocity of the Earth.  Get both 
C           from SLA_LIB routines.
C
C           Note that the midpoint of the experiment will be used for
C           the calculation.  Thus, despite redoing the calculation for
C           each scan, each source will use the same velocity for every
C           scan.
C
            TMID = (TFIRST + TEND) / 2.0
            CALL TIMEJ( TMID, YEAR, DAY, TIME )
            TIME4 = TIME / TWOPI
            RA4  = RA2000(IDOPSRC(ISCN))
            DEC4 = D2000(IDOPSRC(ISCN))
            VSUN = SLA_RVLSRK( RA4, DEC4 )
            RA4  = RAP(IDOPSRC(ISCN))
            DEC4 = DECP(IDOPSRC(ISCN))
            CALL SLA_ECOR( RA4, DEC4, YEAR, DAY, TIME4, VEARTH, TL )
C
C           Determine which group of lines is to be used.
C
            NGP = 0
            DO IGP = 1, NLGP
               IF( LINES(ISCN) .EQ. LINENAME(IGP) ) THEN
                  NGP = IGP
               END IF
            END DO
            IF( NGP .EQ. 0 )
     1          CALL ERRLOG( 'DOPCRD: Spectral line set '//LINES(ISCN)//
     2            ' not initialized.' )
C
C           This routine calculates the center frequency, then subtracts
C           (or adds) half the bandwidth to get the LO sum.  
C
C           Do the Doppler for all possible channels.  In the inputs,
C           any channel for which there was no rest frequency, 
C           bandwidth, or velocity given, had that the missing 
C           number set to the value for channel 1.  
C
C           Here the channel number is going to be the same as BBC number
C           as we won't be using both sidebands from a BBC.
C           Use any required parameters from the logical channels for the
C           setup file as previously established.
C
C           Set CRDFREQ to band edge.  The net sideband for the channel
C           was found by SBPAIR and is stored in SFSIDE, based on the
C           setup file.  This is being done before any sideband inversion
C           requests are made.  Round the frequency to the nearest 0.01 MHz.
C           Don't worry about channels sharing BBCs - that won't happen
C           in the cases where the CRD stuff applies as we are only doing
C           one per BBC.
C
C           Set the frequency for each channel.
C
C           At this point, we start using channel information from
C           the main setup.  Use CRDSETCH to map from crd channels to
C           setup file channels.  INFDB forced it to have been set when
C           using CRDDOP.  We might have used GETCRDN to get the mapping
C           CRSETC, but that routine needs a station, and this routine
C           is not for a specific station.
C
            DO ICH = 1, CRDNCH(ISCN)
C
C              Set up to add or subtract the bandwidth.  As a 
C              software check, complain about unrecognized SFSIDE.
C              Note that we will use the main setup file sideband.
C
C              Note that correlator inversions could cause an issue here,
C              but leave accounting for that to WRTFREQ.
C
C              SFSIDE will be indexed based on the setup file channels
C              (ICHS).  All the CRD parameters are for the crd channel 
C              index (ICH).  The mapping between the two is in CRDSETCH.
C              The user could have specified the mapping with CRDCH1 and
C              CRDNCH, but INFDB used those to fill in CRDSETCH.
C              For most projects, SCHED will set defaults (in GETCRDN)
C              if CRDSETCH is not filled.  But this routine is called
C              without a station where GETCRDN needs a station for other
C              setup information.  So INDFB enforces that CRDSETCH (
C              or CRDCH1) be given if CRDDOP is requested.  Here, the
C              only item from the setup that is used is the sideband.
C
               ICHS = CRDSETCH(ICH,ISCN)
               IF( SFSIDE(ICHS,ISETF) .EQ. 'U' ) THEN
                  SBW = 1
               ELSE IF( SFSIDE(ICHS,ISETF) .EQ. 'L' ) THEN
                  SBW = -1
               ELSE
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I3, A, A, A )' )
     1                'DOPCRD: Unrecognized SFSIDE(', ICHS, 
     1                ') = ''', SFSIDE(ICHS,ISETF) , ''''
                  CALL ERRLOG( MSGTXT )
               END IF
C
C              Now get the frequency.  If no velocity was given,
C              use the setup frequency.  This was flagged with
C              a "CONT" from RDSRC and a VLSR=-1.E9 from SRREAD.
C
               IF( VLSR(ICH,IDOPSRC(ISCN)) .LT. -1.E8 ) THEN
                  DFREQ(ICH) = 0.D0
               ELSE
C
C                 Actually calculate the frequency based on the
C                 VELREF and VELDEF requests.  Note that VLSR
C                 is now a bit of a misnomer.
C
C                 First convert a Z to a velocity. 
C
                  IF( VELDEF(IDOPSRC(ISCN)) .EQ. 'Z' ) THEN
                     VELSRC = VLSR(ICH,IDOPSRC(ISCN)) * VELC / 1.D3
                  ELSE
                     VELSRC = VLSR(ICH,IDOPSRC(ISCN))
                  END IF
C
C                 Now get the total velocity by adding in the 
C                 Earth's motions.  This is where the frame enters.
C
                  IF( VELREF(IDOPSRC(ISCN)) .EQ. 'L' ) THEN
                     VELTOT = VELSRC + VEARTH + VSUN
                  ELSE IF( VELREF(IDOPSRC(ISCN)) .EQ. 'H' ) THEN
                     VELTOT = VELSRC + VEARTH
                  ELSE IF( VELREF(IDOPSRC(ISCN)) .EQ. 'G' ) THEN
                     VELTOT = VELSRC
                  ELSE
                     CALL ERRLOG( 
     1                 'DOPCRD:  Bad VREF in source catalog: '//
     2                 VELREF(IDOPSRC(ISCN)) )
                  END IF
C
C                 Now calculate the frequency.
C
                  IF( VELDEF(IDOPSRC(ISCN)) .EQ. 'R' ) THEN
                     DFREQ(ICH) = RESTFREQ(ICH,NGP) * 
     1                  ( 1.D0 - VELTOT * 1.E3 / VELC ) - 
     2                  SBW * DBW(ICH) / 2.D0
                  ELSE IF( VELDEF(IDOPSRC(ISCN)) .EQ. 'O' .OR.
     1                     VELDEF(IDOPSRC(ISCN)) .EQ. 'Z' ) THEN
                     DFREQ(ICH) = RESTFREQ(ICH,NGP) / 
     1                  ( 1.D0 + VELTOT * 1.E3 / VELC ) - 
     2                  SBW * DBW(ICH) / 2.D0
                  ELSE
                     CALL ERRLOG( 
     1                 'DOPCRD:  Bad VDEF in source catalog: '//
     2                 VELDEF(IDOPSRC(ISCN)) )
                  END IF
C
C                 Round it to the required 0.01 MHz, which is good for
C                 the BBC's.  DOPINCR might have been set for the PFB
C                 or something else.  In other words, the the LO 
C                 equation is assumed to be FREQ = N * 0.01
C            
                  DFREQ(ICH) = 0.01D0 * 
     1                 DNINT( DFREQ(ICH) * 100.D0 )
C            
C                 Don't worry about overlapped channels.
C            
C                 Leave a flag that we did doppler on this source and
C                 keep track of the maximum number of channels used.
C
C                 Don't try to distinguish BBC and regular for this bit
C                 of bookkeeping.
C
                  DIDNDOP(IDOPSRC(ISCN)) = 
     1                 MAX( DIDNDOP(IDOPSRC(ISCN)), ICH )
                  DOPPED(SRCNUM(ISCN)) = .TRUE.
C
               END IF
            END DO
C
C           Took out warning related to VLAONLY observations.  We are
C           no longer supporting those.
C
C           Transfer the calculated frequency DFREQ to CRDFREQ
C           (the bandwidth is not changed in this routine).
C
            DO ICH = 1, CRDNCH(ISCN)
               CRDFREQ(ICH,ISCN) = DFREQ(ICH)
            END DO
C
         END IF
C
      END DO
C
      RETURN
      END

      SUBROUTINE sla_CLYD (IY, IM, ID, NY, ND, JSTAT)
*+
*     - - - - -
*      C L Y D
*     - - - - -
*
*  Gregorian calendar to year and day in year (in a Julian calendar
*  aligned to the 20th/21st century Gregorian calendar).
*
*  Given:
*     IY,IM,ID   i    year, month, day in Gregorian calendar
*
*  Returned:
*     NY         i    year (re-aligned Julian calendar)
*     ND         i    day in year (1 = January 1st)
*     JSTAT      i    status:
*                       0 = OK
*                       1 = bad year (before -4711)
*                       2 = bad month
*                       3 = bad day (but conversion performed)
*
*  Notes:
*
*  1  This routine exists to support the low-precision routines
*     sla_EARTH, sla_MOON and sla_ECOR.
*
*  2  Between 1900 March 1 and 2100 February 28 it returns answers
*     which are consistent with the ordinary Gregorian calendar.
*     Outside this range there will be a discrepancy which increases
*     by one day for every non-leap century year.
*
*  3  The essence of the algorithm is first to express the Gregorian
*     date as a Julian Day Number and then to convert this back to
*     a Julian calendar date, with day-in-year instead of month and
*     day.  See 12.92-1 and 12.95-1 in the reference.
*
*  Reference:  Explanatory Supplement to the Astronomical Almanac,
*              ed P.K.Seidelmann, University Science Books (1992),
*              p604-606.
*
*  P.T.Wallace   Starlink   26 November 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      INTEGER IY,IM,ID,NY,ND,JSTAT

      INTEGER I,J,K,L,N

*  Month lengths in days
      INTEGER MTAB(12)
      DATA MTAB/31,28,31,30,31,30,31,31,30,31,30,31/



*  Preset status
      JSTAT=0

*  Validate year
      IF (IY.GE.-4711) THEN

*     Validate month
         IF (IM.GE.1.AND.IM.LE.12) THEN

*        Allow for (Gregorian) leap year
            IF (MOD(IY,4).EQ.0.AND.
     :         (MOD(IY,100).NE.0.OR.MOD(IY,400).EQ.0)) THEN
               MTAB(2)=29
            ELSE
               MTAB(2)=28
            END IF

*        Validate day
            IF (ID.LT.1.OR.ID.GT.MTAB(IM)) JSTAT=3

*        Perform the conversion
            I=(14-IM)/12
            K=IY-I
            J=(1461*(K+4800))/4+(367*(IM-2+12*I))/12
     :        -(3*((K+4900)/100))/4+ID-30660
            K=(J-1)/1461
            L=J-1461*K
            N=(L-1)/365-L/1461
            J=((80*(L-365*N+30))/2447)/11
            I=N+J
            ND=59+L-365*I+((4-N)/4)*(1-J)
            NY=4*K+I-4716

*        Bad month
         ELSE
            JSTAT=2
         END IF
      ELSE

*     Bad year
         JSTAT=1
      END IF

      END

C*JULDA -- find Julian Date and GMST at midnight for a given day
C+
      SUBROUTINE JULDA (YEAR, MONTH, DAY, DATE, GMST)
      INTEGER YEAR
      INTEGER MONTH
      INTEGER DAY
      DOUBLE PRECISION DATE
      DOUBLE PRECISION GMST
C
C Returns DATE = Julian Date and GMST = Greenwich Mean sidereal time
C at 0 hrs U.T. on day DAY/MONTH/YEAR. Accuracy not tested; GMST is
C correct at least to nearest second
C
C History:
C  1977 Aug  5 - TJP.
C  1991 May 18 - TJP.
C-----------------------------------------------------------------------
      INTEGER MOFF(12), IC, NYRM1, JD, NDAYS
      DOUBLE PRECISION DU,SMD,T
      DATA MOFF/0,31,59,90,120,151,181,212,243,273,304,334/
C
C JD number at 12 hrs UT on Jan 0 of year YEAR (Gregorian Calendar).
C
      NYRM1 = YEAR-1
      IC = NYRM1/100
      JD = 1721425 + 365*NYRM1 + NYRM1/4 - IC + IC/4
C
C Number of days from Standard Epoch 1900 Jan 0.5 (JD 2415020.0) to
C Jan 0.0 of YEAR.
C
      DU = DBLE(JD-2415020) - 0.5D0
C
C Day number; is it a leap year?
C
      NDAYS = MOFF(MONTH) + DAY
      IF (MONTH.GT.2 .AND. ( 
     1     ( MOD(YEAR,4).EQ.0 .AND. MOD(YEAR,100).NE.0 ) .OR.
     2     MOD(YEAR,400).EQ.0 ) ) NDAYS = NDAYS+1
C
C UT from Epoch to today (days), (centuries).
C
      SMD = DU+DBLE(NDAYS)
      T = SMD/36525.D0
C
C Greenwich Mean Sidereal Time.
C
      GMST = DBLE(6*3600 + 38*60) +45.836D0
     1     + 8 640 184.542D0*T  +  0.0929D0*T**2
      GMST = MOD(GMST,86400D0)
C
C Julian Date.
C
      DATE = 2415020.D0+SMD
C
      END

      SUBROUTINE STAUV( ISCN, ISTA, U1, U2, V1, V2 )
C
C     Subroutine for uv plotting in SCHED that gets the station
C     UV for data about to be plotted.
C
C     Plot the UVs that would be used for mapping.  This has 
C     opposite sign of U from what would be used to imagine
C     easily where stations are on the ground (HAZININE convention).
C
C     Note that these U and V are in kilometers.
C
C     The results here might be thought of as for a baseline from the
C     center of the Earth to the station.  Actual baseline parameters
C     can be calculated from differences.
C
      INCLUDE 'sched.inc'
C
      INTEGER     ISCN, ISTA, CATSTA, CATSRC
      REAL        U1, U2, V1, V2
Cf2py intent(out) U1
Cf2py intent(out) U2
Cf2py intent(out) V1
Cf2py intent(out) V2
      REAL        HAR, CH, SH, CD, SD, UXY
C -------------------------------------------------------------------
C     Get station number in catalog.
C
      CATSTA = STANUM(ISTA)
      CATSRC = SRCNUM(ISCN)
C
C     Get the trig terms.
C
      CD = COS( DECP(CATSRC) )
      SD = SIN( DECP(CATSRC) )
      UXY = SQRT( XPOS(CATSTA)**2 + YPOS(CATSTA)**2 )
C
C     UV at scan start.
C
      HAR = HA1(ISCN,ISTA) * RADHR
      CH = COS( HAR )
      SH = SIN( HAR )
      U1 =  (-UXY) * SH / 1000.0 
      V1 = ( ZPOS(CATSTA) * CD - UXY * SD * CH ) / 1000.0
C
C     UV at scan stop.
C
      HAR = HA2(ISCN,ISTA) * RADHR
      CH = COS( HAR )
      SH = SIN( HAR )
      U2 = (-UXY) * SH / 1000.0
      V2 = (  ZPOS(CATSTA) * CD - UXY * SD * CH) / 1000.0
C
      RETURN
      END

      SUBROUTINE SCHTIM 
C
C     Subroutine for SCHED that:
C       1. Checks that each station has a monotonic time sequence.  
C       2. Check for schedule gaps that might cause non-simultaneous 
C          tape changes.
C     Get total time range.  Check the TFIRST from SATTIM against
C     the final, "optimized" schedule.
C     Get first time for use in setting tape changes.
C     Count readback opportunities.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER           ISCN, ISTA, NCNT
      INTEGER           SY, SD, TY, TD, MAXSTOP
      REAL              C1GBYTES(MAXSTA), D1GBYTES(MAXSTA)
      LOGICAL           TSWARN, RECLAST(MAXSTA), GOTCORE(MAXSTA)
      LOGICAL           DOSC
      DOUBLE PRECISION  ST, TL, FIRSTT, NRSEC, RECTIME
      DOUBLE PRECISION  ONEMIN, ONEHR, TLAST(MAXSTA)
      CHARACTER         TFORM*8, CSTART*8, CSTOP*8
C  -----------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SCHTIM: Starting.' )
C
C     Initialize.  Prevent counting start of expt as a readback.
C     NRDBCK and NSTOP set to -1 to ignore the break before obs start.
C     NRDBCK is no longer used outside this routine.  Remove it some day.
C     It was a tape issue.
C
      ONEMIN = 60.D0 * ONESEC
      ONEHR = 3600.D0 * ONESEC
      FIRSTT = 999.D9
      TEND   = -999.D9
      TSWARN = .FALSE.
      DO ISTA = 1, NSTA
         TLAST(ISTA) = UNSET
C
         NSTSC(ISTA) = 0
         SCNHR(ISTA) = 0.0
         TPHR(ISTA) = 0.0
         TPSCN(ISTA) = 0
         TGBYTES(ISTA) = 0.0
C
         ENSTSC(ISTA) = 0
         ESCNHR(ISTA) = 0.0
         ETPHR(ISTA) = 0.0
         ETPSCN(ISTA) = 0
         EGBYTES(ISTA) = 0.0
C
         DNSTSC(ISTA) = 0
         DSCNHR(ISTA) = 0.0
         DTPHR(ISTA) = 0.0
         DTPSCN(ISTA) = 0
         DGBYTES(ISTA) = 0.0
C
         C1GBYTES(ISTA) = 0.0
         D1GBYTES(ISTA) = 0.0
         GOTCORE(ISTA) = .FALSE.
         NSTOP(ISTA) = -1
         RECLAST(ISTA) = .TRUE.
         NRDBCK(ISTA) = 0
      END DO
      IF( DEBUG ) CALL WLOG( 0, 'SCHTIM:  Counting readback tests.' )
C
C     First be sure that this schedule has at least one scan.
C
      NCNT = 0
      DO ISCN = SCAN1, SCANL
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
               NCNT = NCNT + 1
            END IF
         END DO
      END DO
      IF( NCNT .EQ. 0 ) THEN
         CALL ERRLOG( 'SCHTIM: There are no scheduled scans.' )
      END IF
C
C     Now count the readbacks and tape stoppages.
C
      DO ISCN = SCAN1, SCANL
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
C
C              Simplify later testing for DOSCANS range.
C
               DOSC = DOSCANS(1) .EQ. 0 .OR.
     1           ( ISCN .GE. DOSCANS(1) .AND. ISCN .LE. DOSCANS(2) )
C
C              Save first and last times of scans actually used.
C
               FIRSTT = MIN( STARTJ(ISCN), FIRSTT )
               TEND   = MAX( STOPJ(ISCN), TEND )
C
C              Deal with scans out of order.  Note that this can
C              be legal for OPTMODE=UPTIME.
C
               IF( STARTJ(ISCN) - TPSTART(ISCN,ISTA) + ONESEC .LT. 
     1             TLAST(ISTA) .AND. .NOT.
     2             OPTMODE .EQ. 'UPTIME' ) THEN
                  CALL TIMEJ( STARTJ(ISCN), SY, SD, ST )
                  CALL TIMEJ( TLAST(ISTA), TY, TD, TL )
                  CSTART = TFORM( ST, 'T', 0, 2, 2, '::@' )
                  CSTOP = TFORM( TL, 'T', 0, 2, 2, '::@' )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I5, A, I4, 1X, 2A, I4, 1X, A )' )
     1               'SCHTIM:  Scan overlap details - Scan: ', ISCN, 
     2               '  Start: ', SD, CSTART, ' Last stop: ', TD, CSTOP
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT = ' '
                  CALL ERRLOG ( 'SCHTIM: Two scans for '//
     1               STATION(STANUM(ISTA))//' overlap in time.' )
               END IF
C
C              Count scans and total time.  Also count disk scans
C              (TPSCN) which are blocks of recording without a break.
C
               ENSTSC(ISTA) = ENSTSC(ISTA) + 1
               IF( PREEMPT(ISCN) .NE. 'EXTRA' ) 
     1             NSTSC(ISTA) = NSTSC(ISTA) + 1
               IF( DOSC ) DNSTSC(ISTA) = DNSTSC(ISTA) + 1
C
               ESCNHR(ISTA) = ESCNHR(ISTA) + 
     1             ( STOPJ(ISCN) - STARTJ(ISCN) ) / ONEHR
               IF( PREEMPT(ISCN) .NE. 'EXTRA' ) 
     1             SCNHR(ISTA) = SCNHR(ISTA) + 
     2                ( STOPJ(ISCN) - STARTJ(ISCN) ) / ONEHR
               IF( DOSC ) DSCNHR(ISTA) = DSCNHR(ISTA) + 
     2                ( STOPJ(ISCN) - STARTJ(ISCN) ) / ONEHR
C
               IF( .NOT. NOREC(ISCN) ) THEN
C
C                 The recording time depends on the system.  Nominally
C                 the media start at STARTJ - TPSTART.  But the 
C                 RDBE/VLBA and VLA systems look instead at the good
C                 data start time in the VEX file.  So try to account
C                 for that difference here.  I'm not sure about the
C                 DBBC.
C
                  IF( USEONSRC(STANUM(ISTA)) ) THEN
                     RECTIME =  STOPJ(ISCN) - MAX( ( STARTJ(ISCN) - 
     1                    TPSTART(ISCN,ISTA) ), TONSRC(ISCN,ISTA) )
                  ELSE
                     RECTIME = ( STOPJ(ISCN) - STARTJ(ISCN) + 
     1                        TPSTART(ISCN,ISTA) )
                  END IF
C
                  ETPHR(ISTA) = ETPHR(ISTA) + RECTIME / ONEHR
                  IF( PREEMPT(ISCN) .NE. 'EXTRA' ) 
     1               TPHR(ISTA) = TPHR(ISTA) + RECTIME / ONEHR
                  IF( DOSC ) DTPHR(ISTA) = DTPHR(ISTA) + 
     1               RECTIME / ONEHR
C
                  IF( STARTJ(ISCN) - TPSTART(ISCN,ISTA) - ONESEC .GT. 
     1                TLAST(ISTA) .OR. .NOT. RECLAST(ISTA) ) THEN
                     ETPSCN(ISTA) = ETPSCN(ISTA) + 1
                     IF( PREEMPT(ISCN) .NE. 'EXTRA' ) 
     1                  TPSCN(ISTA) = TPSCN(ISTA) + 1
                     IF( DOSC ) DTPSCN(ISTA) = DTPSCN(ISTA) + 1
                  END IF
C
C                 Take the opportunity to get the total bytes recorded.  
C                 This will be the same as the bytes at the end of the 
C                 last scan this station is in.  Also get the bytes in the
C                 core scans.  Keep C1GBYTES and CLGBYTES as the values
C                 at the start and end of the core.  The core total is
C                 the difference.
C
C                 Record the GBYTES of the last EXTRA scan seen.
C                 This will end up being the value at the start of the core.
C                 Also get the GBYTES of the last non-DOSCANS scan.
C
                  IF( PREEMPT(ISCN) .NE. 'EXTRA' ) 
     1                 GOTCORE(ISTA) = .TRUE.
                  IF( .NOT. GOTCORE(ISTA) ) 
     1                 C1GBYTES(ISTA) = GBYTES(ISCN,ISTA)
                  IF( DOSCANS(1) .GT. 0 .AND. ISCN .LT. DOSCANS(1) )
     1                 D1GBYTES(ISTA) = GBYTES(ISCN,ISTA)
C
C                 Record the total core gbytes as of the last core scan 
C                 seen and the total of all scans on the last scan seen.
C
                  EGBYTES(ISTA) = GBYTES(ISCN,ISTA)
                  IF( PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
                     TGBYTES(ISTA) = GBYTES(ISCN,ISTA) - C1GBYTES(ISTA)
                  END IF
                  IF( DOSC ) THEN
                     DGBYTES(ISTA) = GBYTES(ISCN,ISTA) - D1GBYTES(ISTA)
                  END IF
               END IF
C
C              Count readbacks.  They can happen in gaps or during
C              no-record scans.  It seems that the on-line system
C              really needs one minute plus one second per track
C              to do a test.  There are a maximum of 32 tracks, so
C              1:32 is the actual amount needed.  Allow a bit
C              of slop so test against 1:45.  We tell users 2:00,
C              so that is generous.  With LST scheduling, a gap
C              (but not a prescan) of 2:00 comes out slightly under
C              two minutes and was triggering warnings.
C              In two tape mode, the readbacks are done sequentially
C              so test against 3:30.
C
               IF( TWOHEAD ) THEN
                  NRSEC = 210.D0
               ELSE
                  NRSEC = 105.D0
               END IF
               MSGTXT = ' '
C
C              Count gaps before scans, but not at first scan.
C
               IF( STARTJ(ISCN) - TPSTART(ISCN,ISTA) - TLAST(ISTA) .GE. 
     1              NRSEC * ONESEC .AND. TLAST(ISTA) .NE. UNSET ) THEN
                  NRDBCK(ISTA) = NRDBCK(ISTA) + 1
                  CALL TIMEJ( STARTJ(ISCN), SY, SD, ST )
                  CSTART = TFORM( ST, 'T', 0, 2, 2, '::@' )
                  IF( DEBUG ) THEN
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( A, I5, A, A, A, I5, A, A )' )
     1                   '         Readback number', NRDBCK(ISTA), 
     2                   ' for ', STATION(STANUM(ISTA)), 
     3                   ' is before scan', ISCN, ' at ', CSTART
                     CALL WLOG( 0, MSGTXT )
                  END IF
               END IF
C
C              Count long norecording scans, but not first.
C
               IF( NOREC(ISCN) .AND. TLAST(ISTA) .NE. UNSET .AND.
     1             STOPJ(ISCN) - STARTJ(ISCN) .GE. NRSEC * ONESEC ) THEN
                  NRDBCK(ISTA) = NRDBCK(ISTA) + 1
                  IF( DEBUG ) THEN
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( A, I5, A, A, A, I5, A, A )' )
     1                   '         Readback number', NRDBCK(ISTA), 
     2                   ' for ', STATION(STANUM(ISTA)), 
     3                   ' is during scan', ISCN, ' at ', CSTART
                     CALL WLOG( 0, MSGTXT )
                  END IF
               END IF
C
C              Count the tape stoppages of all lengths.  If recording
C              this scan, count if there is a gap since the last
C              scan, if that was also a recording scan.  If not
C              recording, count this scan if the last scan was a
C              recording scan.  I'm only trying to count a string
C              of non-recording scans as one.
C
               IF( .NOT. NOREC(ISCN) ) THEN
                  IF( STARTJ(ISCN) - TPSTART(ISCN,ISTA) - TLAST(ISTA)
     1                   .GT. ONESEC .AND. RECLAST(ISTA) ) THEN
                     NSTOP(ISTA) = NSTOP(ISTA) + 1
                  END IF
               ELSE
                  IF( RECLAST(ISTA) ) THEN
                     NSTOP(ISTA) = NSTOP(ISTA) + 1
                  END IF
               END IF
C
C              Save end of last scan and whether it was recording.
C
               TLAST(ISTA) = STOPJ(ISCN)
               RECLAST(ISTA) = .NOT. NOREC(ISCN)
            END IF
         END DO
      END DO
C
C     If no scans will for a station will be written to the output
C     files, abort.  The VEX file does not like this.  It is possible
C     that this will make it difficult to put a station in the EXTRA
C     scans that are not in the core, but that can still be done by
C     giving DOSCANS.  
C
C     (Removed ".NOT. DODOWN" from the SCNHR IF statement below.  Not
C     sure why it was there, and now DODOWN is scan dependent and
C     this is not a scan dependent place in the code.  Dec 2010 RCW).
C
      DO ISTA = 1, NSTA
         IF( DNSTSC(ISTA) .EQ. 0 .AND. DOSCANS(1) .NE. 0 ) THEN
            CALL WLOG( 1, 'SCHTIM: There are no scans for '//
     1         STANAME(ISTA)//' with the source up in the range '//
     2         'specified with DOSCANS.' )
            CALL ERRLOG( 'Please add scans or take out the station.' )
         END IF
C
         IF( NSTSC(ISTA) .EQ. 0 .AND. FUZZY ) THEN
            CALL WLOG( 1, 'SCHTIM: There are no scans for '//
     1         STANAME(ISTA)//' with the source up and PREEMPT '//
     2         'not set to EXTRA.' )
            CALL ERRLOG( 'Please add scans or take out the station.' )
         END IF
C
         IF( ESCNHR(ISTA) .LE. 0.0  ) THEN
            CALL WLOG( 1, 'SCHTIM: There are no scans for '//
     1         STANAME(ISTA)//' with the source up.' )
            CALL ERRLOG( 'Please add scans or take out the station.' )
         END IF
      END DO
C
C     Warn if TFIRST .NE. FIRSTT (first time specified in input 
C
      IF( ABS( TFIRST - FIRSTT ) .GT. 2.0D0 / 86400.D0 ) THEN
         CALL WLOG( 1, 'SCHTIM: Earliest output scan start time ' //
     1       'differs from earliest in input schedule.' )
         IF( AUTOPEAK )  CALL WLOG( 1,
     1                '        This may be due to an inserted ' //
     2       'reference pointing scan.' )
      END IF
C
C     Readback test opportunity warning removed July 23, 2010 - tape only.
C
C     Complain about too many tape stoppages.  Complain if more
C     than 10 per hour.  Don't worry if tapes are not being used.
C
C     Jan. 2009.  For Mark5A and Mark5B there is a maximum of 1000
C     recording scans (blocks between stoppages) per module.  So
C     a warning is needed, although it can be for much more than
C     10 per hour.  This will go away with Mark5C.  For now, warn
C     if the rate is enough to fill the 1000 in 24 hr.
C
      MAXSTOP = ( TEND - TFIRST ) * 1000.0
      DO ISTA = 1, NSTA
         IF( NSTOP(ISTA) .GT. MAXSTOP .AND. VLBITP ) THEN
            CALL WLOG( 1,
     1        'SCHTIM:  ' // STANAME(ISTA) // 
     2        ' averages more than 10 tape stops per hour.' )
            TSWARN = .TRUE.     
         END IF
      END DO
      IF( TSWARN .AND. CORREL(1:7) .EQ. 'FXCORR' ) THEN
         CALL WLOG( 0, 
     1    '   Tape synchronization on the  VLBA hardware correlator ' )
         CALL WLOG( 0, 
     1    '   is better when the tape does not stop often. ' )
         CALL WLOG( 0,
     1    '   Parameters  MINPAUSE and PRESTART may be used to '
     2    // ' encourage continuous tape motion.' )
      END IF
C
      RETURN
      END

      SUBROUTINE VLBA( ISCN, ISTA, FIRSTS )
C
C     Writes a basic VLBA control schedule.  The setup must be added.  
C
C     If the control file for the recorder at the VLA is being written, 
C     do not write many of the unneeded VLBA equipment parameters.  
C
C     Do not attempt to avoid writing the unneeded VLA tape control 
C     file when the wideband tape recorder is not being used.  The
C     user can just ignore it.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER           ISCN, ISTA, QUOUT, KSTA
      INTEGER           LASTDY, DOY1, DOY2
      INTEGER           PTADD, LKS, LSTA
      INTEGER           LSCN, LEN1, KS, KR, LKR
      DOUBLE PRECISION  LSTOP
      LOGICAL           FIRSTS, FRS, DOSET, LPTVLB
      LOGICAL           WRTSET, CRLWARN, SLEWPBM
      CHARACTER         VLBAD1*9, VLBAD2*9
      CHARACTER         FRSDUR*17, TSTART*9, TSTOP*9
      CHARACTER         LCRDLINE*80
C
C     Save variables.
C
      SAVE              LSTA, LKS, LKR, LASTDY, LPTVLB, LSCN
      SAVE              LSTOP, CRLWARN, LCRDLINE
C
      DATA          CRLWARN  / .TRUE. /
C
      DATA          LSTA, LKS, LKR, LSCN / 0, 0, 0, 0 /
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'VLBA: Starting' )
      IF( ISTA .NE. LSTA ) LSCN = 0
C
C     Wrap up the schedule on the last call.
C
      IF( ISCN .EQ. -999 ) THEN
         CALL VLBAEND( ISTA, LASTDY, LSCN )
      ELSE
C        Deal with a regular scan.
C
C        On the first call for the station, initialize some variables
C        and call VLBAINI to start writing the control file.
C
         IF( FIRSTS ) THEN
            LASTDY = -999
            LPTVLB = .FALSE.
            LSTOP = 0.D0
            CALL VLBAINI( ISCN, ISTA )
         END IF
C
C        Detremine if a setup scan will be needed - true if writing tape
C        and there is more than a 1 second gap between scans.
C
         DOSET =  VLBITP .AND. ( FIRSTS .OR. 
     1      ( STARTJ(ISCN) - TPSTART(ISCN,ISTA) - LSTOP ) .GT. ONESEC )
C
C        But don't do a setup scan if there is a reasonable chance that
C        the on-line system and SCHED will disagree on the wrap.  See
C        the discussion in the comments in wrap.f for details.  Added
C        Jan. 9, 2014  RCW.
C
         KSTA = STANUM(ISTA)
         IF( LSCN .NE. 0 ) THEN
            SLEWPBM = AZ1(ISCN,ISTA) .LE. AX1LIM(2,KSTA) - 360.0 .AND.
     1                AZ2(ISCN,ISTA) .GT. AX1LIM(2,KSTA) - 360.0 .AND.
     2                AZ2(LSCN,ISTA) .GT. 250.0 
            MSGTXT = ' '
            IF( DOSET .AND. SLEWPBM ) THEN
               WRITE( MSGTXT, '( A, I5, A, A, A )' )
     1            'VLBA:  Not writing setup file for scan ', ISCN,
     2            ', station ', STANAME(ISTA), 
     3            ' to avoid potential incorrect wrap.'
               CALL WLOG( 1, MSGTXT )
            END IF
         ELSE
            SLEWPBM = .FALSE.
         END IF
         DOSET = DOSET .AND. .NOT. SLEWPBM
C
C        Get the scan started.  VLBAST deals with scan times, source
C        information, caltime, and pointing requests.
C
         CALL VLBAST( ISCN, ISTA, FIRSTS, LSTOP,
     1          TSTART, TSTOP, DOSET, DOY1, DOY2, VLBAD1, VLBAD2 )
C
C        Detect a new setup file.  WRTFREQ will deal with new
C        frequency groups.
C
         KS = NSETUP(ISCN,ISTA)
         KR = FSETI(ISCN,ISTA)
         WRTSET = FIRSTS .OR. ISTA .NE. LSTA .OR. KS .NE. LKS .OR.
     1         KR .NE. LKR
         LKS = KS
         LKR = KR
         LSTA = ISTA
C
C        Write most of setup information.  Call every scan since
C        some parameters can be changed by the main schedule.
C
         CALL VLBASU( ISCN, ISTA, FIRSTS, FRS, WRTSET )
C
C        Write the arbitrary line - used for developing new features 
C        in the on-line system.
C
         IF( CRDLINE(ISCN) .NE. ' ' .AND. 
     1       ( CRDLINE(ISCN) .NE. LCRDLINE .OR. FIRSTS ) ) THEN
            WRITE( IUVBA, '(A)' ) CRDLINE(ISCN)(1:LEN1(CRDLINE(ISCN)))
            IF( CRLWARN ) THEN
               CALL WLOG( 1, 'WARNING: Test parameter CRDLINE being' //
     1          ' used.  Be sure you know what you are doing.' )
               CRLWARN = .FALSE.
            END IF
         END IF

         LCRDLINE = CRDLINE(ISCN)
C
C        Do a setup scan for VLBA observations when there
C        is a gap between scans.  Also do one at the start of any
C        experiment to force a scan header in the monitor data at the
C        experiment start time.
C
         IF( DOSET .OR. FIRSTS ) THEN
C
C           Turn recording off for the setup scan.
C
            CALL VLBADK( ISCN, ISTA, .TRUE. )
C
C           Stop time and !NEXT! for setup scan.
C           Write a dur=0 into setup scan for frequency switched
C           observations so that SETUP is not only 15s long.
C           Change date if necessary.
C
            IF( DOY1 .NE. LASTDY ) THEN
               WRITE( IUVBA, '(''  date = '', A9 )' ) VLBAD1
               LASTDY = DOY1
            END IF
            IF( FRS .OR. LPTVLB ) THEN
               FRSDUR = '   dur=0  !NEXT!'
            ELSE
               FRSDUR = '   !NEXT!'
            END IF
            WRITE( IUVBA, '( 3A )' ) 'stop=', TSTART, FRSDUR
C
         END IF
C
C        ---------   Setup scan done.  -----------
C
C        Write qualifier if there is a setup scan or freq. switching.
C
         IF( DOSET .OR. FIRSTS .OR. FRS ) THEN
            IF( FRS ) THEN
               QUOUT = 1
            ELSE
               QUOUT = QUAL(ISCN)
            END IF
            WRITE( IUVBA, '( A, I3 )' ) 'qual=', QUOUT
         END IF
C
C        Ask for the pointing to be peaked up if requested.  Only
C        do the for full VLBA systems.  This used to be done during
C        a setup scan if one happened.  But the on-line system has
C        a 40 second timeout to get to source, plus if DWELL is used,
C        time may be short.  Therefore put it during the main scan.
C
         IF( .NOT. VLBADAR(STANUM(ISTA)) ) THEN
            IF( DOPEAK(ISCN) .GT. NCHAN(KS) ) THEN
               WRITE( MSGTXT, '( A, I4 )' ) 
     1             'VLBA: Invalid channel specified for PEAK: ', 
     2             DOPEAK(ISCN)
               CALL ERRLOG( MSGTXT )
            ELSE IF( DOPEAK(ISCN) .GT. 0 ) THEN
               WRITE( IUVBA, '( A, I2 )' ) 'peakchan = ', DOPEAK(ISCN)
            END IF
         END IF
C
C        Turn recording on or off.
C
         CALL VLBADK( ISCN, ISTA, .FALSE. )
C  
C        Change day number if necessary.
C
         IF( DOY2 .NE. LASTDY .AND. ROTPAT .EQ. 0 ) THEN
            WRITE( IUVBA, '(''date='', A9 )' ) VLBAD2
            LASTDY = DOY2
         END IF
C
C        Finish off scan.  Just give stop time and !NEXT! for 
C        most scans, but deal with the special sequence requests
C        for pointing, Ta, or frequency switching if necessary.
C
C        PTADD is the amount to add to slew time for pointing.
C
         IF( .NOT. FIRSTS ) THEN
            PTADD = ( STARTJ(ISCN) - LSTOP ) * 3600.D0 * 24.D0
         ELSE
            PTADD = 0
         END IF
C
         IF( PNTVLBA(ISCN) ) THEN
            IF( ROTPAT .EQ. 0 ) THEN
               CALL PTVLBA( ISCN, PTADD, TSTOP, KS )
            ELSE
               CALL ROTVLBA( ISCN, ISTA, PTADD, LASTDY )
            END IF
         ELSE IF( TANVLBA(ISCN) ) THEN
            CALL TAVLBA( ISCN, PTADD, TSTOP, KS )
         ELSE IF( DOPN3DB(ISCN) ) THEN
            CALL PN3DB( ISCN, PTADD, TSTOP, KS )
         ELSE IF( FRS ) THEN
            CALL FSVLBA( TSTOP, KS )
         ELSE
            IF( LPTVLB ) THEN
               WRITE( IUVBA, '( 3A )' )
     1          'stop=', TSTOP, '   dur=0s  !NEXT!'
            ELSE
               WRITE( IUVBA, '( 3A )' )
     1          'stop=', TSTOP, '   !NEXT!'
            END IF
         END IF
         LPTVLB = PNTVLBA(ISCN) .OR. TANVLBA(ISCN)
C
C        Record the last scan processed for use in the final call.
C        Do at the end of the scan loop so it can be used as a
C        lastscan number.  Recall that the test for this station
C        being in the scan happens in STAFILES, several layers up
C        from here.
C
         LSCN = ISCN
C
C        Also set this scan's stop time to be the "last" stop time.
C
         LSTOP = STOPJ(ISCN)
C
      END IF      ! Not final wrapup.
C
      IF( DEBUG ) CALL WLOG( 0, 'VLBA: Ending' )
      RETURN
      END

      SUBROUTINE VXWRSU
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the SU = $SOURCE section 
C     By H.J. van Langevelde, JIVE, 300496 
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
      INTEGER   ISRC, I, NVXSRC
      INTEGER   LEN1
      CHARACTER TMPSRC*32
      LOGICAL   FOUND
C ----------------------------------------------------------------------
C
C     Source section
C
      NVXSRC = 0
      WRITE( IVEX, '( A, A1 )' ) '$SOURCE', SEP
C  
      DO ISRC = 1, MSRC      
         IF( SUSED(ISRC) ) THEN

            FOUND = .FALSE.

            DO I = 1, MALIAS
C
C           denoted by '*'
C
               IF( CSUSED(I,ISRC) .EQ. '*' ) THEN
C
C              Count and warn if too many for PCFS
C              See email exchange of June 26, 2013 for change to 1000.
C
                  NVXSRC = NVXSRC + 1
                  IF ( NVXSRC .GT. 1000 ) THEN
                     WRITE( MSGTXT, '( A )' ) 
     1                   'VXWRSU: WARNING: More than 1000 sources'// 
     2                   ' in this schedule. This VEX will NOT run'//
     3                   ' on the Field System!'
                     CALL WLOG( 1,MSGTXT)
                  END IF
C
                  TMPSRC = SOURCE(I,ISRC)
                  CALL VXSTNM(TMPSRC,.FALSE.)
                  WRITE( IVEX, '( A1 )' ) COM
                  WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1                 TMPSRC(1:LEN1(TMPSRC)), SEP 
                  FOUND = .TRUE.
                  CALL VXSUDT( ISRC, I )
C
                  WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP  
               END IF
            END DO
C
C           Check if found.  
C           (This comment was also here, but doesn't seem to 
C           apply - RCW Mar 2012):, then write other coordinates in comments
C
C           Output text changed Mar 2012  RCW.
C
            IF( .NOT. FOUND ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A )' )
     1            'VXWRSU: A catalog source is marked as used but ',
     2                  'the alias used is not identified.'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I5, 2A )' )
     1            'VXWRSU: Source number is: ', ISRC, 
     2            '  The first alias is: ', 
     3            SOURCE(1,ISRC)
               CALL WLOG( 1, MSGTXT )
C                
               CALL ERRLOG('VXWRSU: Probable program bug.'//
     1             '  Please report.' )
            END IF
         END IF
      END DO
      WRITE( IVEX, '( A )' ) COMLIN
      RETURN
      END

      SUBROUTINE SETCHAN( KS )
C
C     Set a variety of channel data that might need to be defaulted
C     and that can be set before the frequency setup is finally 
C     settled.  These are meant to be items that are independent
C     of the station hardware, other than the fact that the number
C     of BBCs needs to be known.
C
C     This routine should come before SETFREQ to allow setting of
C     sidebands etc.  Because of this, the defaulting of sidebands
C     will not be fully general in cases where freqref is not 
C     available before SETFREQ.  It will not opt for upper/lower
C     pairs in that case.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
      INTEGER           ICH, ISETF, LEN1, KS
      LOGICAL           NEEDSB, DUALIF, GOTPOL, GOTNSD, GOTFQ
      DOUBLE PRECISION  MAXBW 
      REAL              BITRATE
C --------------------------------------------------------------------
      IF( KS .LE. 3 .AND. SDEBUG ) CALL WLOG( 0, 'SETCHAN: Starting' )
C
      ISETF = ISETNUM(KS)
C
C     Deal with polarization.
C
C     If it is still unset after this, it might be determined in 
C     SETFCAT based on knowing which IF is which polarization.
C
C     If no POL or IF was specified, default to dual.  Test on first
C     channel.  Then panic if some other channels were set.  Set
C     POL(1,KS) after tests to avoid confusing output from ERRSET.
C
      IF( POL(1,KS) .EQ. ' ' .AND. IFCHAN(1,KS) .EQ. ' ' ) THEN
         IF( NCHAN(KS) .GE. 2 ) THEN
            DO ICH = 2, NCHAN(KS)
               IF( POL(ICH,KS) .NE. ' ' ) THEN
                  CALL WLOG( 1, 'POL specified for some channel '//
     1               'but not for first.' )
                  CALL ERRSET( KS )
               END IF
               IF( IFCHAN(ICH,KS) .NE. ' ' ) THEN
                  CALL WLOG( 1, 'IFCHAN specified for some channel '//
     1               'but not for first.' )
                  CALL ERRSET( KS )
               END IF
            END DO
         END IF
         POL(1,KS) = 'DUAL'
      END IF
C
C     First deal with a specification of DUAL polarization.
C
      IF( POL(1,KS) .EQ. 'DUAL' ) THEN
         DO ICH = 1, NCHAN(KS), 2
            POL(ICH,KS) = 'RCP'
            POL(ICH+1,KS) = 'LCP'
         END DO
      END IF
C
C     If RCHAN and LCHAN were used, perhaps we can set POL.
C     Also detect if dual polarization was used.  Some related
C     defaulting was done when the setup file was read by RDSET.
C
      DUALPOL(KS) = .FALSE.
      GOTPOL = .TRUE.
      DO ICH = 1, NCHAN(KS)
         IF( POL(ICH,KS)(1:3) .NE. 'RCP' .AND.
     1       POL(ICH,KS)(1:3) .NE. 'LCP' .AND.
     2       POL(ICH,KS)(1:1) .NE. 'X' .AND.
     3       POL(ICH,KS)(1:1) .NE. 'Y' ) THEN
            IF( IFCHAN(ICH,KS) .EQ. RCHAN(KS) ) THEN
               POL(ICH,KS) = 'RCP'
            ELSE IF( IFCHAN(ICH,KS) .EQ. LCHAN(KS) ) THEN
               POL(ICH,KS) = 'LCP'
            ELSE
               GOTPOL = .FALSE.
            END IF
         END IF
         IF( POL(ICH,KS) .NE. POL(1,KS) ) DUALPOL(KS) = .TRUE.
      END DO
C
C     The only allowed situation where the polarization is not yet
C     known is if the IF's have been been specified, but we don't
C     yet know what polarization they are.  Below in setting 
C     sidebands, we should try to recognize this situation.  So
C     test for more than one specified IF.
C
      IF( GOTPOL ) THEN
         DUALIF = DUALPOL(KS)
      ELSE
         DUALIF = .FALSE.
         DO ICH = 1, NCHAN(KS)
            IF( IFCHAN(ICH,KS) .NE. ' ' .AND. IFCHAN(1,KS) .NE. ' '
     1          .AND. IFCHAN(ICH,KS) .NE. IFCHAN(1,KS) ) THEN
               DUALIF = .TRUE.
            END IF
         END DO
      END IF
C
C     Set the sample rate or bandwidths if one is not given.  Assume 
C     Nyquist rate.  Strictly, the sample rate is not needed for
C     some formats, but it won't hurt.  The bandwidth is needed for
C     all but VLAONLY modes and SETDEFS (which calls this routine)
C     has already filtered against that.
C
      MAXBW = 0.0
      DO ICH = 1, NCHAN(KS)
         MAXBW = MAX( MAXBW, BBFILT(ICH,KS) )
      END DO
      IF( SAMPRATE(KS) .EQ. 0.0 .AND. MAXBW .GT. 0.0 ) THEN
         SAMPRATE(KS) = 2.0 * MAXBW
      END IF
      IF( SAMPRATE(KS) .GT. 0.0 .AND. MAXBW .EQ. 0.0 ) THEN
         DO ICH = 1, NCHAN(KS)
            BBFILT(ICH,KS) = SAMPRATE(KS) / 2.0
         END DO
      END IF
      IF( SAMPRATE(KS) .EQ. 0.0 .AND. MAXBW .EQ. 0.0 ) THEN
         CALL WLOG( 1, '         Setup: ' // 
     1         SETNAME(KS)(1:LEN1(SETNAME(KS))) )
         CALL WLOG( 1, '         Station: '// SETSTA(1,KS) )
         CALL ERRLOG( 'SETCHAN: SAMPRATE or BBFILTER needed.' )         
      END IF
C
C     Get the total bandwidth and bitrate.  Useful later.
C     This is the nominal bit rate.  An adjustment for headers is
C     needed for the actual write rate.  BITRATE is the same
C     as TOTBPS(KS) will be after SETFORM, but that has not been
C     called yet.
C
      TOTBW(KS) = 0.0D0
      DO ICH = 1, NCHAN(KS)
         TOTBW(KS) = TOTBW(KS) + BBFILT(ICH,KS)
         BITRATE = NCHAN(KS) * SAMPRATE(KS) * BITS(1,KS)
      END DO
C
C     Deal with sidebands.
C
C     If neither NETSIDE nor SIDEBD have been set, we have freedom
C     to set NETSIDE as we please.  Choose upper unless there are
C     too few BBC's, or the RDBE/PFB is in use, in which case lower 
C     is required for SIDEDB which may force NETSIDE to be lower.  
C     Note that the VLA also has a forced sideband, but it is net upper
C     so we can use the regular default here.  
C
C     If we must use upper and lower, then we need to be sure
C     that the frequencies specified so far don't preclude the option.
C     Do this as a check, because if we can't use upper and lower,
C     then we can't do the setup.  Also there is a potential problem 
C     with BBC assignments when using both sidebands.  Let the BBC 
C     setting stuff later worry about that.
C
      NEEDSB = NETSIDE(1,KS) .NE. 'U' .AND. NETSIDE(1,KS) .NE. 'L' .AND.
     2         SIDEBD(1,KS) .NE. 'U' .AND. SIDEBD(1,KS) .NE. 'L'
C
C     Abort if there are too few BBCs period.  This is probably
C     redundant with other checks, but oh well.  With the new systems,
C     we no longer have dual sidebands per BBC, so the check is a bit
C     more complicated.
C
      IF( NEEDSB .AND. ( MSCHN(ISETF) .GT. 2 * MINBBC(ISETF) .OR. 
     1    ( MSCHN(ISETF) .GT. MINBBC(ISETF) .AND. 
     2     ( DAR(ISETSTA(KS))(1:4) .EQ. 'RDBE' .OR.
     3       DAR(ISETSTA(KS)) .EQ. 'WIDAR' ) ) ) ) THEN
         WRITE( SETMSG, '( A, I3 )' )
     1        'SETCHAN: Too many channels for maximum BBCs '//
     2        'available at some site: ', MINBBC(ISETF)
         CALL ERRSET(KS)
      END IF
C
C     The RDBE PFB personality presents a special problem.  The baseband
C     channels must be lower sideband (SIDEBD) in all circumstances.
C     But we don't know the IF sideband yet unless NETSIDE or (FIRSTLO
C     and FREQREF) were given.  Unfortunately, SCHED has not yet dealt
C     with the frequencies.  Plus SETFREQ, which has not yet been
C     called, will invoke sideband inversion when necessary.  It is
C     all too complicated to deal with here.  Just require that NETSIDE
C     or FIRSTLO plus FREQREF be provided.  It is common to use 
C     FIRSTLO and BBSYN, but for this NETSIDE should be given.
C     The DBBC_PFB may be the same.  Treat it as such for now.
C
C     The PFB is not expected to be in regular use for long, so I don't 
C     want to jump through too many hoops for it.
C
      IF( DBE(KS) .EQ. 'RDBE_PFB' .OR. DBE(KS) .EQ. 'DBBC_PFB' ) THEN
         DO ICH = 1, NCHAN(KS)
            GOTNSD = NETSIDE(ICH,KS) .NE. 'L' .OR. 
     1               NETSIDE(ICH,KS) .NE. 'U' 
            GOTFQ  = FIRSTLO(ICH,KS) .NE. 0.D0 .AND.
     1               FREQREF(ICH,KS) .EQ. 0.D0 
            IF( .NOT. GOTNSD .AND. .NOT. GOTFQ ) THEN
               CALL WLOG( 1, 'SETCHAN:  For the '// DBE(KS) //
     1            'personality, SCHED needs NETSIDE or FIRSTLO '//
     2            'and FREQREF' )
               CALL WLOG( 1, '          specified in the setup file.' )
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( 4A )' )
     1             '          Neither is given for ', 
     2             STATION(ISETSTA(KS)), ' in setup file: ',
     3             SETFILE(ISETF)(1:LEN1(SETFILE(ISETF)))
               CALL WLOG( 1, MSGTXT )
               CALL ERRLOG( 
     1              'Please provide NETSIDE or FIRSTLO+FREQREF' )
            END IF
C
C           Now we can set NETSIDE assuming FREQREF and FIRSTLO 
C           are availble.
C
            IF( .NOT. GOTNSD .AND. GOTFQ ) THEN
               IF( FIRSTLO(ICH,KS) .GT. FREQREF(ICH,KS) ) THEN
                  NETSIDE(ICH,KS) = 'U'
               ELSE
                  NETSIDE(ICH,KS) = 'L'
               END IF
            END IF
         END DO
         NEEDSB = .FALSE.
      END IF
C
C     Deal with defaulting when we need to use both the upper and 
C     lower sidebands from each BBC.  Only do when there are too few 
C     BBC's to do otherwise.  Note that we would not have gotten past
C     an earlier test if this were one of the systems that cannot
C     handle dual sidebands per BBC.
C
C     There are pathalogical cases where this will not necessarily
C     come out right.  Hope that they will be caught in checking 
C     and users will then specify the setup more completely.
C
      IF( NEEDSB .AND. MSCHN(ISETF) .GT. MINBBC(ISETF) ) THEN
         SETMSG = ' '
         WRITE( SETMSG, '( A, I3 )' )
     1        'SETCHAN: Must use dual sidebands because of the ' //
     2        'maximum BBCs available at some site: ', MINBBC(ISETF)
         CALL WLOG( 0, SETMSG )
         IF( DUALPOL(KS) .OR. DUALIF ) THEN
            DO ICH = 1, NCHAN(KS), 4
               NETSIDE(ICH,KS)   = 'L'
               NETSIDE(ICH+1,KS) = 'L'
               NETSIDE(ICH+2,KS) = 'U'
               NETSIDE(ICH+3,KS) = 'U'
C
C              Check compatible frequencies.  Don't worry if all are
C              zero - test will be ok anyway.
C
               IF( FREQREF(ICH+1,KS) .NE. FREQREF(ICH,KS) .OR. 
     1             FREQREF(ICH+2,KS) .NE. FREQREF(ICH,KS) .OR. 
     2             FREQREF(ICH+3,KS) .NE. FREQREF(ICH,KS) ) THEN
                  CALL WLOG( 1, 'SETCHAN: Frequencies not compatible '//
     1                  'with defaulted sidebands for ')
                  CALL WLOG( 1, '         dual polarization, dual '//
     1                     ' sideband observations' )
                  CALL ERRSET(KS)
               END IF
C
C              Check appropriate polarization specification.
C
               IF( POL(ICH+1,KS) .EQ. POL(ICH,KS) .OR. 
     1             POL(ICH+2,KS) .EQ. POL(ICH+3,KS) ) THEN
                  CALL WLOG( 1, 'SETCHAN: Polarizations not appropriate'
     1                  //' for defaulted sidebands for ')
                  CALL WLOG( 1, '         dual polarization, dual '//
     1                     ' sideband observations' )
                  CALL ERRSET(KS)
               END IF
            END DO
         ELSE
            DO ICH = 1, NCHAN(KS), 2
               NETSIDE(ICH,KS)   = 'L'
               NETSIDE(ICH+1,KS) = 'U'
C
C              Check compatible frequencies.  Don't worry if both zero.
C
               IF( FREQREF(ICH+1,KS) .NE. FREQREF(ICH,KS) ) THEN
                  CALL WLOG( 1, 'SETCHAN: Frequencies not compatible '//
     1               'with dual sideband observations.')
                  CALL ERRSET(KS)
               END IF
            END DO
C
         END IF
C
C     Now the easy case (one channel per BBC).  Don't worry if both
C     are zero.
C
      ELSE IF( NEEDSB ) THEN
         DO ICH = 1, NCHAN(KS)
            NETSIDE(ICH,KS) = 'U'
         END DO
         IF( DUALPOL(KS) ) THEN
            DO ICH = 1, NCHAN(KS), 2
               IF( FREQREF(ICH+1,KS) .NE. FREQREF(ICH,KS) ) THEN
                  CALL WLOG( 1, 'SETCHAN: Frequencies not compatible '//
     1               'with dual polarization observations.')
                  CALL ERRSET(KS)
               END IF
            END DO
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE OPTHAS( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
Cf2py intent(in) LASTISCN, KSCN, ISCN
Cf2py intent(out) ADJUST, KEEP, DONE
C
C     Determine scans to observe with OPTMODE='HASEQ'.  This 
C     mode makes one pass through the schedule assigning the next 
C     scan based on a quality measure.  It is meant to be the first, 
C     and simplest, of the astronomy optimization modes that can 
C     completely reorder the input schedule.
C
C
C     Note we can let the geometry parameters and times be altered  
C     in the input scan to save a lot of shuffling of data.
C
C     Input call arguments:
C       KSCN:   Count calls to the optimization routines
C       ISCN:   Output scan number (provided by SCHOPT)
C     Output call arguments:
C       ADJUST:  True=>later operations are allowed to change the time.
C       KEEP:    Do keep this scan (will always be true here)
C       DONE:    Done making output scans 
C                   (this call won't generate a scan.)
C
      INCLUDE 'sched.inc'
C
C     Save a bit of space by making the input scan variables half size.
C     If there are more than MAXSCN/2 input scans, the program can't
C     work anyway since it creates a new version of the schedule in
C     the tail of the scan arrays.
C
      INTEGER    MAXINS
      PARAMETER  ( MAXINS = MAXSCN / 2 )
      INTEGER    KSCN, ISCN, LASTISCN(MAXSTA)
      LOGICAL    ADJUST, KEEP, DONE
C
      INTEGER    JSCN, LSCN, NOUT, ISRC, ISTA, RSTA, WTMSCN
      INTEGER    SCNUSED(MAXINS)
      INTEGER    IDUMMY, NSKIP, YEAR, DAY1, DAY2, DAYR, DAYS
      DOUBLE PRECISION  TAPPROX, LASTTIME, TSPACE
      REAL       HAMIN(MAXINS), HAMAX(MAXINS)
      REAL       HABEGIN(MAXINS), HAEND(MAXINS)
      REAL       SCNWT(MAXINS), WTMAX
      REAL       OPSLEW, HAP, MINDUR
      REAL       TIMEWT, SLEWWT, RISEWT, SETWT
      DOUBLE PRECISION  DURTOT, SDTOT, START, HTSTOP
      DOUBLE PRECISION  TUSE(MAXINS), TAVAIL(MAXINS), OPHAT(MAXINS)
      DOUBLE PRECISION  OPHAWIDT(MAXINS)
      DOUBLE PRECISION  SKIPTIME, SRCSEP, ATSRC, SKIPINC
      DOUBLE PRECISION  THAMIN(MAXINS), THAMAX(MAXINS)
      CHARACTER  TFORM*8, CSTART*8, CSKIP*8, COPT*8, CRISE*8, CSET*8
C
      INTEGER    SRUSED(MAXINS), SRLOOK(MAXINS)
      LOGICAL    LDUMMY
      SAVE       NOUT, SCNUSED, DURTOT, RSTA
      SAVE       HAMIN, HAMAX, HABEGIN, HAEND, THAMIN, THAMAX
      SAVE       TUSE, TAVAIL
      SAVE       SRUSED, SRLOOK, SKIPTIME, SKIPINC, NSKIP
      SAVE       SDTOT
      SAVE       OPHAT, OPHAWIDT
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'OPTHAS: Starting.' )
C
C     Assume that the number of output scans should be equal to the 
C     number of scans provided by the user.
C
      IF( NOUT .GT. NSCANS ) THEN
         DONE = .TRUE.
         GO TO 999
      END IF
C
      KEEP = .TRUE.
C
C     Initialize many items on first call.
C
      IF( KSCN .EQ. 1 ) THEN
         NOUT = 0
         SKIPTIME = 0.D0
         NSKIP = 0
         SKIPINC = 5.D0 * 60.D0 / 86400.D0
C
C        Check some requirements.
C        Requre OPDUR so we can do rational things relative to the end
C        of observations.
C
         IF( NSCANS .GT. MAXINS ) THEN
            WRITE( MSGTXT, '( A, A, I4, A, I4 )' ) 
     1         'OPHAS: Too many requested scans for OPTMODE=HAS.  ',
     2         'Max:', MAXINS, '  Requested:', NSCANS 
            CALL ERRLOG( MSGTXT )
         END IF
         IF( OPDUR .LE. 0.D0 ) THEN
            CALL ERRLOG( 'OPHAS: Please specify OPDUR for OPTMODE=HAS' )
         END IF
C
C        Keep things simpler by not going over 24 hours sidereal in
C        start times.  Allow for durations.
C
         MINDUR = 0.0
         DO JSCN = 1, NSCANS
            MINDUR = MIN( MINDUR, DUR(JSCN) )
         END DO
         IF( OPDUR * SIDR - MINDUR .GT. 1.D0 ) THEN
            CALL ERRLOG( 'OPHAS: OPTMODE=HAS not meant for ' //
     1          'observations over 24 hours sidereal + min scan dur.' )
         END IF
C
C        HTSTOP is the observation stop time.  Most scan setting 
C        calculations are for the scan start time so this will often
C        need to be adjusted by the duration.
C
         HTSTOP = STARTJ(1) + OPDUR
C
C        Get the station number for the reference station.
C
         CALL STANO( OPHASTA, IDUMMY, RSTA, LDUMMY )
C
C        Initialize bookkeeping for the accounting of when a source
C        was used.
C
         DO ISRC = 1, NSRC
            SRUSED(ISRC) = 0
         END DO
         DO JSCN = 1, NSCANS
            SRLOOK(JSCN) = 0
         END DO

C
C        Determine how often each source is requested.
C        For each scan, tell which look at the source this was.
C        Initialize SCNUSED.  
C        Accumulate the total in scan time.
C
         DURTOT = 0.D0
         SDTOT = 0.D0
         DO JSCN = 1, NSCANS
            ISRC   = SRCNUM(JSCN)
            SRUSED(ISRC)  = SRUSED(ISRC) + 1
            SRLOOK(JSCN)  = SRUSED(ISRC)
            SCNUSED(JSCN) = 0
            DURTOT = DURTOT + DUR(JSCN)
         END DO
C
C        Compare the total time request with OPDUR.
C
         IF( DURTOT .GT. OPDUR ) THEN
            WRITE( MSGTXT, '( A, F8.3, A  )' )
     1         'OPTHAS: ** The total time in requested scans of', 
     1         DURTOT * 24.D0, ' hours' 
            CALL WLOG( 1, MSGTXT )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, F8.3, A )' )
     1         '           exceeds the experiment duration (OPDUR) of ',
     2         OPDUR * 24.D0, ' hours.'
            CALL WLOG( 1, MSGTXT )
            MSGTXT = ' '
            CALL WLOG( 1, '           Not all scans can be scheduled.' )
         END IF
C
C        For each scan, find the minimum and maximum hour
C        angles for the scan start time to adhere to the minimum 
C        elevation and minimum number of antennas.  
C        This is done on a per-scan basis to allow for different 
C        elevation limits or minimum antennas.
C        Also allows for future imposed limits.
C        Note that HAMAX is the HA of the start of the scan so that
C        the scan will be valid to the end.  This presumes later tests
C        will be based on the start time.
C        Also get the reference station hour angles at the start
C        and end of the experiment to help with later optimizations.
C        And get the total hours the source is available for observing
C
         DO JSCN = 1, NSCANS
C
C           Get the hour angle limits.
C
            CALL HALIM( JSCN, RSTA, HAMIN(JSCN), HAMAX(JSCN),
     1                  THAMIN(JSCN), THAMAX(JSCN) )
C
C           Get the experiment start and stop hour angles for the
C           start of scan.
C
            CALL SCHGEO( JSCN, RSTA, STARTJ(1), HA1(JSCN,RSTA), 
     1             EL1(JSCN,RSTA), AZ1(JSCN,RSTA),
     2             LST1(JSCN,RSTA), PA1(JSCN,RSTA) )
            CALL SCHGEO( JSCN, RSTA, HTSTOP - DUR(JSCN), 
     1             HA2(JSCN,RSTA), EL2(JSCN,RSTA), AZ2(JSCN,RSTA),
     2             LST2(JSCN,RSTA), PA2(JSCN,RSTA) )
            HABEGIN(JSCN) = HA1(JSCN,RSTA)
            HAEND(JSCN) = HA2(JSCN,RSTA)
C
C           Get the time each source is available and the desired
C           observe time.
C           A possible weakness in this is that if the user gives
C           different opminants, the rise and set for a source will
C           change and the default scan times will not be a clean
C           sequence.
C
            CALL HAAVAI( THAMIN(JSCN), THAMAX(JSCN),
     1                   STARTJ(1), HTSTOP - DUR(JSCN),
     2                   TAVAIL(JSCN), TUSE(JSCN), 
     3                   SRUSED(SRCNUM(JSCN)), SRLOOK(JSCN), 
     4                   SIDR )
C
C           Abort if the source is never up.
C
            IF( TAVAIL(JSCN) .EQ. -1.D0 ) THEN
               CALL WLOG( 1, ' ' )
               MSGTXT = ' ****** ' //SCNSRC(JSCN) // 
     1           ' is never above OPMINEL and the horizon at ' //
     2           'OPMINANT stations at once.'
               CALL WLOG( 1, MSGTXT )
               CALL ERRLOG( 'Leave out the source or change ' //
     1                   'OPMINANT or OPMINEL' )
             END IF
C
C           Get the desired hour angles.  SRUSED can't be zero from
C           the way it was set (says here!).  If OPHA is not 0.0, that  
C           means it was set by the user.
C
            IF( OPHA(JSCN) .EQ. 0.0 ) THEN
               OPHAT(JSCN) = TUSE(JSCN)
            ELSE
               OPHAT(JSCN) = ( OPHA(JSCN) - HABEGIN(JSCN) ) / SIDR +
     1               STARTJ(1)
               IF( OPHAT(JSCN) .LT. STARTJ(1) ) THEN
                  OPHAT(JSCN) = OPHAT(JSCN) + 24.D0 / SIDR
                  IF( OPHAT(JSCN) .GT. STARTJ(1) + OPDUR ) THEN
                     WRITE( MSGTXT, '( A, I5, 2X, A, F7.2 )' )
     1                 'OPHAS: Requested hour angle ',
     2                 'outside range: scan, source, OPHA: ',
     3                 JSCN, SCNSRC(JSCN), OPHA(JSCN)
                     CALL WLOG( 1, MSGTXT )
                     MSGTXT = ' '                     
                  END IF
               END IF
            END IF
            IF( OPHAWID(JSCN) .EQ. 0.0 ) THEN
               OPHAWIDT(JSCN) = 0.7D0 * TAVAIL(JSCN) / 
     1                SRUSED(SRCNUM(JSCN))
            ELSE
               OPHAWIDT(JSCN) = OPHAWID(JSCN) / 86400.D0
            END IF
C
         END DO
C
      END IF
C
C     Jump back to here if no scan could be found be we aren't to
C     the end of the experiment.  SKIPTIME will be set to push the
C     scan time forward.
C
  100 CONTINUE
C
C     Now go through the input scans and pick one.
C
C     Get the nominal start time of the scan for calculating
C     geometry, slews etc.  For the first scan, use the experiment
C     start time and don't allow that to be adjusted later.
C     For later scans, use the last scan stop time and allow 
C     adjustment later.
C
C     Allow skipping at the start.
C
      IF( KSCN .EQ. 1 ) THEN
C         STARTJ(ISCN) = STARTJ(1)
C         STOPJ(ISCN) = STARTJ(1) + DUR(1)
         TAPPROX = STARTJ(1) + SKIPTIME
         ADJUST = .FALSE.
      ELSE IF( SKIPTIME .NE. 0.D0 ) THEN
         TAPPROX = STOPJ(ISCN-1) + SKIPTIME
         ADJUST = .FALSE.
         IF( TAPPROX .GT. STARTJ(1) + OPDUR ) THEN
            DONE = .TRUE.
            GO TO 999
         END IF
      ELSE
         TAPPROX = STOPJ(ISCN-1)
         ADJUST = .TRUE.
      END IF
      WTMAX = 0.0
      WTMSCN = 0
      IF( OPPRTLEV .GE. 3 ) THEN
         WRITE( MSGTXT, '( A, A, A )' )
     1      '              Scan   Source     New scan time',
     2      ' Opt scan time  TIMEWT  SLEWWT  RISEWT   SETWT',
     3      '   SCNWT     dT      WID  SlewSec'
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
      END IF
      DO JSCN = 1, NSCANS
         IF( SCNUSED(JSCN) .EQ. 0 ) THEN
C
C           Note that so far there is no need for SCNWT to be an array.
C
            SCNWT(JSCN) = 0.0
C
C           First see if the source is up at the reference station.
C           If not, we save a lot of work.
C           Note that the elev limits and minimum number of 
C           stations are already incorporated in the HAMIN and HAMAX.
C
            CALL SCHGEO( JSCN, RSTA, TAPPROX, HA1(JSCN,RSTA), 
     1             EL1(JSCN,RSTA), AZ1(JSCN,RSTA),
     2             LST1(JSCN,RSTA), PA1(JSCN,RSTA) )
            IF( HA1(JSCN,RSTA) .GE. HAMIN(JSCN) .AND.
     1          HA1(JSCN,RSTA) .LE. HAMAX(JSCN) ) THEN
C
C              Now get the geometry for all stations so that we can
C              utilize slew times etc.  Also, for the slew time, get
C              the time the last antenna that will be up is on source.
C              Couch the slew time in seconds.
C
               ATSRC = 0.D0
               DO ISTA = 1, NSTA
                  IF( STASCN(JSCN,ISTA) ) THEN
                     CALL STAGEO( JSCN, ISTA, TAPPROX, LASTISCN(ISTA),
     1                      LASTTIME, TONSRC(JSCN,ISTA), 'OPTHAS' )
                     IF( KSCN .GT. 1 .AND. 
     1                      UP1(JSCN,ISTA) .EQ. ' ' ) THEN
                        ATSRC = MAX( ATSRC, TONSRC(JSCN,ISTA) )
                     END IF
                  END IF
               END DO
               IF( KSCN .GT. 1 ) THEN
                  OPSLEW = ( ATSRC - STOPJ(ISCN-1) ) * 86400.D0
               ELSE
                  OPSLEW = 0.D0
               END IF
C
C              Make a priority based schedule.
C
C              Get the interval since the last scan on this source.
C              Set to 24.0 hr if this is the first scan on the source.
C              Then don't let sources be too close together.
C
               SRCSEP = 1.D0
               IF( KSCN .GT. 1 ) THEN
                  DO LSCN = SCAN1, SCANL
                     IF( SCNSRC(JSCN) .EQ. SCNSRC(LSCN) ) THEN
                        TSPACE = TAPPROX - STOPJ(LSCN)
                        SRCSEP = MIN( SRCSEP, TSPACE )
                     END IF
                  END DO
               END IF
C
C              Enforce the minimum separation.  Also ignore scans
C              that are just too far off in time.  Make that max time
C              a user input some day.
C
               IF( SRCSEP .LT. OPMINSEP(JSCN) * OPHAWIDT(JSCN)
     1              .OR. ABS( TAPPROX - OPHAT(JSCN) ) .GT. 
     2              OPHMAXDT(JSCN) / 86400.D0 ) THEN
C
                  SCNWT(JSCN) = 0.D0
C
               ELSE
C
C                 Get a weight for this scan that is low before the
C                 desired hour angle and high after.
C                 Use an arctan to get a nice
C                 functional form that will emphasize the right 
C                 spacing.
C                 The desired separation is the available interval 
C                 devided by the number of scans requested on the 
C                 source.  This was set up in HAAVAI.
C                 Note the factor of 1.5 in the ATAN just adjusts the 
C                 shape of the curve.  It is arbitrary.  I might need
C                 to play with it.
C
C                 NOTE:  the weight equations are in the manual.  Update
C                        the manual if changes are made.
C
                  TIMEWT = OPHAWT(JSCN) * ( 0.5 + ( 1.0 / PI ) * 
     1                 ATAN( 1.5 * ( TAPPROX - OPHAT(JSCN) ) / 
     2                     OPHAWIDT(JSCN) ) )
C
C                 Adjust the weight according to the slew time.  But
C                 don't reward no source change.  Also SCNWT=0 is a flag
C                 that we don't want this scan so don't undo that flag.
C                 Recall OPSLEWTI and OPSLEW are in seconds
C
                  SLEWWT = 0.0
                  IF( SCNSRC(JSCN) .NE. SCNSRC(ISCN-1) .AND. 
     1                OPSLEWTI(JSCN) .GT. 0.0 ) THEN
                     SLEWWT = MAX( 0.0, OPSLEWWT(JSCN) * 
     1                  ( 1.0 - OPSLEW / OPSLEWTI(JSCN) ) )
                  END IF
C
C                 Try to get sources near rise and set.
C                 Recall OPHLIMTI is in seconds at this point.
C                 This is only worrying about rise and set, not
C                 beginning and end of observation.
C
                  RISEWT = 0.0
                  SETWT = 0.0
                  IF( OPHLIMTI(JSCN) .GT. 0.0 ) THEN
                     RISEWT = MAX( 0.0, OPHLIMWT(JSCN) *
     1                  ( 1.0 - ABS( HA1(JSCN,RSTA) - HAMIN(JSCN) ) *
     2                  3600.0 / OPHLIMTI(JSCN) ) )
                     SETWT = MAX( 0.0, OPHLIMWT(JSCN) *
     1                  ( 1.0 - ABS( HA1(JSCN,RSTA) - HAMAX(JSCN) ) *
     2                  3600.0 / OPHLIMTI(JSCN) ) )
                  END IF
C
C                 Snare the scan with the highest weight.
C
                  SCNWT(JSCN) = TIMEWT + SLEWWT + RISEWT + SETWT
                  IF( SCNWT(JSCN) .GT. WTMAX ) THEN
                     WTMAX = SCNWT(JSCN)
                     WTMSCN = JSCN
                  END IF
C
C                 Write out all the weights for debugging.
C
                  IF( OPPRTLEV .GE. 3 ) THEN
                     CALL TIMEJ( TAPPROX, YEAR, DAY1, START ) 
                     CSTART = TFORM( START, 'T', 0, 2, 2, '::@' )
                     CALL TIMEJ( OPHAT(JSCN), YEAR, DAY2, START )
                     COPT = TFORM( START, 'T', 0, 2, 2, '::@' )
                     WRITE( MSGTXT,'( A, I5, 1X, A, I5, 1X, A, I5,'//
     1                   ' 1X, A, 8F8.2 )' )
     2                   ' SCAN WEIGHT ', JSCN, SCNSRC(JSCN), DAY1, 
     3                   CSTART, DAY2, COPT, TIMEWT, SLEWWT, RISEWT, 
     4                   SETWT, SCNWT(JSCN), 
     5                   ( TAPPROX - OPHAT(JSCN) ) * 24.D0, 
     6                   OPHAWIDT(JSCN) * 24.D0, OPSLEW
                     CALL WLOG( 0, MSGTXT )
                     MSGTXT = ' '
                  END IF
               END IF
            END IF
         END IF
      END DO
C
C     Now keep the scan with the highest weight
C
      IF( WTMSCN .GT. 0 ) THEN
         NOUT = NOUT + 1
         CALL SCNDUP( ISCN, WTMSCN, .FALSE., 'OPTHAS' )
         STARTJ(ISCN) = TAPPROX
         STOPJ(ISCN)  = STARTJ(ISCN) + DUR(ISCN)
         SCNUSED(WTMSCN) = ISCN
         SKIPTIME = 0.D0
         SDTOT = SDTOT + DUR(ISCN)
C
C        Tell the user about this scan.
C
         IF( OPPRTLEV .GE. 2 ) THEN
            CALL TIMEJ( TAPPROX, YEAR, DAY1, START ) 
            CSTART = TFORM( START, 'T', 0, 2, 2, '::@' )
            WRITE( MSGTXT,'( A, I5, 1X, A, I5, 1X, A, A, F10.2, A, ' //
     1          ' F10.3 )' )
     2          'USE SCAN ', WTMSCN, SCNSRC(WTMSCN), DAY1, CSTART,
     3          '  HA=', HA1(WTMSCN,RSTA), '  Weight: ', WTMAX
            CALL WLOG( 0, MSGTXT )
            MSGTXT = ' '
          END IF
C
      ELSE
C
C        If got here, couldn't find a usable scan.
C
         SKIPTIME = SKIPTIME + SKIPINC
         NSKIP = NSKIP + 1
         IF( OPPRTLEV .GE. 1 ) THEN
            CALL TIMEJ( TAPPROX, YEAR, DAY1, START )
            CSKIP = TFORM( START, 'T', 0, 2, 2, '::@' )
            WRITE( MSGTXT, '( A, F6.2, 2A, F7.2, A, I5, A )') 
     1        'OPTHAS:  Skipping ', SKIPINC * 86400.D0 / 60.D0, 
     2        ' min at ', CSKIP, SKIPTIME * 86400.D0 / 60.D0,  
     3        ' min after scan ', ISCN, 
     4        ' because no scans are available.'
            CALL WLOG( 0, MSGTXT )
            MSGTXT = ' '
         END IF
C
C        Jump back to the beginning of the scan search to try again
C        at the later time.
C
         GO TO 100
C
      END IF
C
C     Test that the scan is in the requested window.
C
      IF( OPDUR .GT. 0.D0 .AND. 
     1    STOPJ(ISCN) .GT. STARTJ(1) + OPDUR ) THEN
         WRITE( MSGTXT, '( A )') 
     1       'OPTHAS:  Schedule stopped because requested total ' //
     2       'duration reached'
         CALL WLOG( 1, MSGTXT )
         MSGTXT = ' '
         DONE = .TRUE. 

      END IF
C
  999 CONTINUE
C
C     Write a summary of use of input scans.
C
      IF( DONE ) THEN
C
         CALL WLOG( 0, ' ' )
         WRITE( MSGTXT, '( A )' )
     1       'OPTHAS:  HAS mode schedule made.'
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         CALL WLOG( 0, ' ' )
         IF( OPPRTLEV .LE. 0 ) THEN
            WRITE( MSGTXT, '( A, I2, A )' )
     1       '         OPPRTLEV=', OPPRTLEV, 
     2       ':  Minimum information printed.'
         ELSE IF( OPPRTLEV .EQ. 1 ) THEN
            WRITE( MSGTXT, '( A, I2, A )' )
     1       '         OPPRTLEV=', OPPRTLEV, 
     2       ':  Include summary of fate of each input scan.'
         ELSE IF( OPPRTLEV .EQ. 2 ) THEN
            WRITE( MSGTXT, '( A, I2, A, A )' )
     1       '         OPPRTLEV=', OPPRTLEV, 
     2       ':  Minimum feedback as scans chosen plus fate ',
     3       'of input scans.'
         ELSE IF( OPPRTLEV .GE. 3 ) THEN
            WRITE( MSGTXT, '( A, I2, A, A )' )
     1       '         OPPRTLEV=', OPPRTLEV, 
     2       ':  Details of each scan choice plus summaries.'
         END IF
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         WRITE( MSGTXT, '( A, I5 )' )
     1       '         Requested scans: ', NSCANS
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         WRITE( MSGTXT, '( A, I5 )' )
     1       '         Scheduled scans: ', NOUT
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         WRITE( MSGTXT, '( A, F7.3, A )' )
     1       '         Sum of requested durations: ', DURTOT * 24.D0, 
     2       ' hr.'
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         WRITE( MSGTXT, '( A, F7.3, A )' )
     1       '         Sum of scheduled durations: ', SDTOT * 24.D0, 
     2       ' hr.'
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         CALL TIMEJ( STARTJ(SCAN1), YEAR, DAY1, START )
         CSTART = TFORM( START, 'T', 0, 2, 2, '::@' )
         WRITE( MSGTXT, '( A, I5, 2X, A )' )
     1       '         Start day and time: ', DAY1, CSTART
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         CALL TIMEJ( STOPJ(SCANL), YEAR, DAY1, START )
         CSTART = TFORM( START, 'T', 0, 2, 2, '::@' )
         WRITE( MSGTXT, '( A, I5, 2X, A, F12.3 )' )
     1       '         Stop day and time and total duration (hr): ',
     2       DAY1, CSTART, ( STOPJ(SCANL) - STARTJ(SCAN1) ) * 24.D0
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         WRITE( MSGTXT, '( A, F8.2 )' )
     1       '         Requested duration (hours) ', OPDUR * 24.D0
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         WRITE( MSGTXT, '( A, F8.3 )' )
     1    '         Maximum allowed deviation from optimum time '//
     2    '(hr; scan 1)', OPHMAXDT(1) / 3600.D0
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         WRITE( MSGTXT, '( A, F7.3, A, I5 )' )
     1       '         Number of ', SKIPINC * 86400.D0 / 60.D0, 
     2       ' minutes skips because of no scan available: ', NSKIP
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
         WRITE( MSGTXT, '( A, F8.3, A )' )
     1       '         Total time in skips: ', 
     2        SKIPINC * NSKIP * 86400.D0 / 60.D0, 
     3       ' minutes.  (Some may be after last scan)'
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
C        Table header
C
         IF( OPPRTLEV .GE. 1 ) THEN
            CALL WLOG( 0, ' ' )
            CALL WLOG( 0, 'OPTHAS:  Input scan information.  ' //
     1                   'Columns are:' )
            CALL WLOG( 0, '         Output scan number and time ' )
            CALL WLOG( 0, '         Reference station hour angle.  ' //
     1                'for scheduled scan.' )
            CALL WLOG( 0, '         Allowed reference station hour ' //
     1                'angle range (for scan start).' )
            CALL WLOG( 0, '         Reference station hour ' //
     1                 'angles for beginning and end of observations.' )
            CALL WLOG( 0, '         Total hours this source is ' //
     1                 'available.' )
            CALL WLOG( 0, '         The reference station is: ' //
     1                 STANAME(RSTA) )
            CALL WLOG( 0, '  Input    Source    Output      Time  '//
     1         '        HA        Time        HA      HA      HA   '//
     2         '   HA  Available     Rise         Set')
            CALL WLOG( 0, '   Scan               Scan   Day    hms'//
     1         '       Scan        Opt       Min     Max    Start  '//
     2      '  End    Hours' )
C
C           Write the information for each scan to the log.
C
            DO JSCN = 1, NSCANS
               IF( SCNUSED(JSCN) .NE. 0 ) THEN
                  CALL TIMEJ( STARTJ(SCNUSED(JSCN)), YEAR, DAY1, START )
                  CSTART = TFORM( START, 'T', 0, 2, 2, '::@' )
                  HAP = HA1(SCNUSED(JSCN),RSTA)
               ELSE
                  DAY1 = 0
                  CSTART = ' '
                  HAP = 0.0
               END IF
               CALL TIMEJ( OPHAT(JSCN), YEAR, DAY2, START )
               COPT = TFORM( START, 'T', 0, 2, 2, '::@' )
               CALL TIMEJ( THAMIN(JSCN), YEAR, DAYR, START )
               CRISE = TFORM( START, 'T', 0, 2, 2, '::@' )
               CALL TIMEJ( THAMAX(JSCN), YEAR, DAYS, START )
               CSET = TFORM( START, 'T', 0, 2, 2, '::@' )
               WRITE( MSGTXT, '( I5, 4X, A12, I5, I6, 2X, A8, '//
     1           'F8.3, I5, 2X, A, 5F8.3, I5, 1X, A, I5, 1X, A )' )
     1           JSCN, SCNSRC(JSCN), SCNUSED(JSCN), 
     2           DAY1, CSTART, HAP, DAY2, COPT,
     3           HAMIN(JSCN), HAMAX(JSCN), 
     4           HABEGIN(JSCN), HAEND(JSCN), TAVAIL(JSCN) * 24.D0,
     5           DAYR, CRISE, DAYS, CSET
               CALL WLOG( 0, MSGTXT )
               MSGTXT = ' '
            END DO
         END IF
         WRITE( MSGTXT, '( A, I5, A, I5, A )' )
     1      'OPTHAS: There were ', NSCANS, ' requested scans and ', 
     2      NOUT, ' Scheduled scans.'
         CALL WLOG( 1, MSGTXT ) 
         MSGTXT = ' '
         CALL WLOG( 1, 'OPTHAS: See the sched.runlog for details.' )
      END IF
C
      RETURN
      END

      SUBROUTINE sla_PRECL (EP0, EP1, RMATP)
*+
*     - - - - - -
*      P R E C L
*     - - - - - -
*
*  Form the matrix of precession between two epochs, using the
*  model of Simon et al (1994), which is suitable for long
*  periods of time.
*
*  (double precision)
*
*  Given:
*     EP0    dp         beginning epoch
*     EP1    dp         ending epoch
*
*  Returned:
*     RMATP  dp(3,3)    precession matrix
*
*  Notes:
*
*     1)  The epochs are TDB Julian epochs.
*
*     2)  The matrix is in the sense   V(EP1)  =  RMATP * V(EP0)
*
*     3)  The absolute accuracy of the model is limited by the
*         uncertainty in the general precession, about 0.3 arcsec per
*         1000 years.  The remainder of the formulation provides a
*         precision of 1 mas over the interval from 1000AD to 3000AD,
*         0.1 arcsec from 1000BC to 5000AD and 1 arcsec from
*         4000BC to 8000AD.
*
*  Reference:
*     Simon, J.L. et al., 1994. Astron.Astrophys., 282, 663-683.
*
*  Called:  sla_DEULER
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION EP0,EP1,RMATP(3,3)

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T0,T,TAS2R,W,ZETA,Z,THETA



*  Interval between basic epoch J2000.0 and beginning epoch (1000JY)
      T0 = (EP0-2000D0)/1000D0

*  Interval over which precession required (1000JY)
      T = (EP1-EP0)/1000D0

*  Euler angles
      TAS2R = T*AS2R
      W =      23060.9097D0+
     :          (139.7459D0+
     :           (-0.0038D0+
     :           (-0.5918D0+
     :           (-0.0037D0+
     :             0.0007D0*T0)*T0)*T0)*T0)*T0

      ZETA =   (W+(30.2226D0+
     :            (-0.2523D0+
     :            (-0.3840D0+
     :            (-0.0014D0+
     :              0.0007D0*T0)*T0)*T0)*T0+
     :            (18.0183D0+
     :            (-0.1326D0+
     :             (0.0006D0+
     :              0.0005D0*T0)*T0)*T0+
     :            (-0.0583D0+
     :            (-0.0001D0+
     :              0.0007D0*T0)*T0+
     :            (-0.0285D0+
     :            (-0.0002D0)*T)*T)*T)*T)*T)*TAS2R

      Z =     (W+(109.5270D0+
     :             (0.2446D0+
     :            (-1.3913D0+
     :            (-0.0134D0+
     :              0.0026D0*T0)*T0)*T0)*T0+
     :            (18.2667D0+
     :            (-1.1400D0+
     :            (-0.0173D0+
     :              0.0044D0*T0)*T0)*T0+
     :            (-0.2821D0+
     :            (-0.0093D0+
     :              0.0032D0*T0)*T0+
     :            (-0.0301D0+
     :              0.0006D0*T0
     :             -0.0001D0*T)*T)*T)*T)*T)*TAS2R

      THETA =  (20042.0207D0+
     :           (-85.3131D0+
     :            (-0.2111D0+
     :             (0.3642D0+
     :             (0.0008D0+
     :            (-0.0005D0)*T0)*T0)*T0)*T0)*T0+
     :           (-42.6566D0+
     :            (-0.2111D0+
     :             (0.5463D0+
     :             (0.0017D0+
     :            (-0.0012D0)*T0)*T0)*T0)*T0+
     :           (-41.8238D0+
     :             (0.0359D0+
     :             (0.0027D0+
     :            (-0.0001D0)*T0)*T0)*T0+
     :            (-0.0731D0+
     :             (0.0019D0+
     :              0.0009D0*T0)*T0+
     :            (-0.0127D0+
     :              0.0011D0*T0+0.0004D0*T)*T)*T)*T)*T)*TAS2R

*  Rotation matrix
      CALL sla_DEULER('ZYZ',-ZETA,THETA,-Z,RMATP)

      END

      SUBROUTINE DEFSET
C
C     Routine for SCHED that sets defaults for setup files.
C     Extracted from GETSET  28 Jan 2003.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER    KS
C ---------------------------------------------------------------------
C     Expand out the setup groups so there is one per input station.
C     Also fill in the station list if none was given (full default).  
C     If stations were given, remove any that are not needed for 
C     this schedule.  After this, all remaining setups are used.
C
      CALL SETEXPND
C
C     Set the setup defaults when needed.
C
      CALL SETDEFS
C
C     Check the setups.
C
C     First check the firmware specified.
C
      CALL CHKFIRM
C
C     Check many of the input numbers.  Do for all setup groups that
C     were actually used.  The setup loop is usually inside the routine,
C     but not for CHKSET.
C
      DO KS = 1, NSET
         CALL CHKSET( KS )
      END DO
C
C     Check things that shouldn't vary between groups in a setup file.
C
      CALL CHKSFIL
C
C     Get logical channels as needed by the doppler and in-line freq
C     options to know how to associate channels in those specs with
C     setup file channels.
C
      CALL SFINFO
C
C     Detect channels assigned to the same BBC so DOPFQ can give them
C     the same frequency.  Also get setup file channel net sidebands.
C     Do some consistency on these issues.
C
      CALL SBPAIR
C
C     Check that some correlator restrictions have not been
C     violated.
C
      CALL CHKVDIFX
      CALL CHKJIVE
C
C     Finished.
C
      RETURN
      END

      SUBROUTINE RECONFIG( ISCN, LSCN, ISTA, NEWCONF, NEWPCAL )
C
C     Compare setup group KS used in scan ISCN with group JS used
C     in scan LSCN to determine if they will require a formatter 
C     reconfigure on the legacy VLBA systems.  The results also
C     apply to MarkIV systems.
C
C     Warning, this routine must be called after the pcal sets
C     have been determined.  That means after CHKSCN which in turn
C     means after schedule optimization etc.  So it can only
C     be used for checking, not scan time setting.
C
C     This is a stripped down and modified version of SAMESET.
C     Note that this time, frequencies must be considered, hence
C     the scan numbers.
C
C
C     It is not clear that this routine is up to date.  The legacy
C     VLBA systems have been retired for data recording (Dec. 2013).
C     Change is happening to the other systems too.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER   ISCN, LSCN, ISTA
      INTEGER   KS, JS, ICH, IPC
      LOGICAL   LOCDBG, NEWCONF, NEWPCAL, SAMECONF
C
C     For checking a pcal detector setup change.
C
      INTEGER       KF, LF
      CHARACTER     KPCX1(MAXPC)*3, KPCX2(MAXPC)*3
      CHARACTER     LPCX1(MAXPC)*3, LPCX2(MAXPC)*3
      INTEGER       KPCFR1(MAXPC), KPCFR2(MAXPC)
      INTEGER       LPCFR1(MAXPC), LPCFR2(MAXPC)
C
      PARAMETER  (LOCDBG=.FALSE.)
C ---------------------------------------------------------------------
C     Don't do this if this is the first scan.
C     This also protects later parts of the program from index 0.
C     Also don't do if no setups are being used (eg project planning)
C     Note SAMECONF tests for same configuration, then at end, we
C     invert it to get NEWCONF.
C
      IF( LSCN .EQ. 0 .OR. NOSET ) THEN 
         SAMECONF = .TRUE.
         NEWPCAL = .FALSE.
         GO TO 999
      END IF
C
C     Get the setups that must be considered.
C
      KS = NSETUP(ISCN,ISTA)
      JS = NSETUP(LSCN,ISTA)
C
C     Write the debugging "I am here" line.
C
      IF( SDEBUG .OR. LOCDBG ) THEN
         WRITE( MSGTXT, '( A, 4I4, A, I4 )' )
     1      'RECONFIG: Starting on scans, station, setups ', 
     2      ISCN, LSCN, ISTA, KS, ' and ', JS
            CALL WLOG( 0, MSGTXT )
            MSGTXT = ' '
      END IF
C
C     First test the obvious items that will cause a reconfigure.
C     Note that the frequency, Doppler, and bandwidth commands only
C     affect the formatter through the pulse cal detection.  The
C     sample rate does not change when BW is changed by scan.
C
      SAMECONF = NCHAN(KS)    .EQ. NCHAN(JS)    .AND.
     1          SAMPRATE(KS) .EQ. SAMPRATE(JS) .AND.
     2          FANOUT(KS)   .EQ. FANOUT(JS)   .AND.
     3          FORMAT(KS)   .EQ. FORMAT(JS)   .AND.
     4          BARREL(KS)   .EQ. BARREL(JS) 
C
C     Test some channel dependent values.
C
      DO ICH = 1, NCHAN(KS)
         SAMECONF = SAMECONF .AND. 
     1     SIDEBD(ICH,KS)  .EQ. SIDEBD(ICH,JS)  .AND.
     2     BITS(ICH,KS) .EQ. BITS(ICH,JS)       .AND.
     3     BBC(ICH,KS)  .EQ. BBC(ICH,JS)
      END DO
C
C     Worry about the pcal setup.  This was easier with the pcal 
C     groups, but those are gone.  Now compare the settings to 
C     be used with the last ones.  First get the frequency group 
C     for both inputs, then calculate the detector setup and compare.
C
      KF = FSETI(ISCN,ISTA)
      LF = FSETI(LSCN,ISTA)
      CALL PCALFQ( FSPCAL(KF), KF, KPCX1, KPCX2, KPCFR1, KPCFR2 )
      CALL PCALFQ( FSPCAL(LF), LF, LPCX1, LPCX2, LPCFR1, LPCFR2 )
C
      NEWPCAL = FSPCAL(KF) .NE. FSPCAL(LF) 
      DO IPC = 1, MAXPC
         IF( KPCX1(IPC) .NE. LPCX1(IPC) .OR.
     1       KPCX2(IPC) .NE. LPCX2(IPC) .OR.
     2       KPCFR1(IPC) .NE. LPCFR1(IPC) .OR.
     3       KPCFR2(IPC) .NE. LPCFR2(IPC) ) NEWPCAL = .TRUE.
      END DO
C
C     Jump here on first or non-recording scan.
C
  999 CONTINUE
C
      NEWCONF = .NOT. SAMECONF
      IF( LOCDBG ) THEN
         WRITE( MSGTXT, '( A, L1 )' )
     1     'RECONFIG END: ', NEWCONF, NEWPCAL
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
      END IF
C
      RETURN
      END

      SUBROUTINE FSFREQWR( KF, LOSUM, BBCFREQ, BBCBW,
     1     CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC )
Cf2py intent(in) KF
Cf2py intent(out) LOSUM, BBCFREQ, BBCBW
Cf2py intent(out) CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC
      INTEGER            KF
      DOUBLE PRECISION   LOSUM(32)
      DOUBLE PRECISION   BBCFREQ(32), BBCBW(32) 
      DOUBLE PRECISION   CRDF(32), CRDB(32), CRDLOSUM(32)
      INTEGER            CRDN, CRSETC(32)
      CHARACTER          CRDS(32)*1

      CALL FSFREQ( KF, LOSUM, BBCFREQ, BBCBW,
     1     CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC )
      RETURN
      END

      SUBROUTINE VEXOUT
C
C     Routine for SCHED called by the top level routine that 
C     sets up to call the VEX writer.  It makes some decisions
C     about whether such a call should be allowed.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER   ISET, ISCN, ISRC
      LOGICAL   FMTNONE, ALLNONE
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'VEXOUT starting.' )
C
C     For the moment (9feb2001), the VEX writer cannot deal with
C     FORMAT=NONE.  Therefore block it, but give Huib a back
C     door for testing.
C     Modified Oct 27, 2008 to pass schedules that only have some
C     format NONE scans.  Those scans will simply be left out of
C     the Vex file.  Don't pass schedules that are all format NONE
C     but want VEX.  This will change more in the near future as we
C     figure out how to do pointing runs with VEX.
C
C     As the switch to the DiFX correlator occurs, most interferometry
C     observations will use VEX.  But block VEX output when doing
C     OBSTYPE='CONFIG' where there may be a special binary with MSET
C     = MAXMOD set too small to actually use.
C
C     Allow VEX files to be written for moving sources, but warn that
C     the positions should be obtained elsewhere for correlation.
C     (Feb 27, 2010 RCW)
C
C     Nov. 2011.  We need Vex files for pointing observations, so
C     no longer block non-recording projects.  The Vex files will
C     now drive the new control systems at VLBA stations which are
C     setting all the switches in the antenna.
C
C
      IF( DOVEX ) THEN
C
C        Look for recording scans on planets or satellites.  We don't
C        know how to describe those in Vex yet.
C
         MOVING = .FALSE.
         DO ISCN = SCAN1, SCANL
            ISRC = SRCNUM(ISCN)
            IF( SUSED(ISRC) .AND. .NOT. NOREC(ISCN) .AND.
     1         ( PLANET(ISRC) .OR. SATEL(ISRC) .OR.
     2          DRA(ISRC) .GE. 0.0001/15.0 .OR. 
     3          DDEC(ISRC) .GE. 0.0001  ) ) THEN
               MOVING = .TRUE.
            END IF
         END DO
         IF( MOVING ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '(A,A)' )
     1        '++++ VEXOUT: Cannot pass accurate positions for ',
     2        'planets or satellites in the VEX file.'
            CALL WLOG( 1, MSGTXT )
            MSGTXT = ' '
            WRITE( MSGTXT, '(A,A)' )
     1        '        For correlation, get the source positions ',
     2        'elsewhere - like from ephemeris.'
            CALL WLOG( 1, MSGTXT )
            MSGTXT = ' '
            WRITE( MSGTXT, '(A,A)' )
     1        '        For VLBA pointing observations as of 2011, the ',
     2        'VEX positions'
            CALL WLOG( 1, MSGTXT )
            MSGTXT = ' '
            WRITE( MSGTXT, '(A,A)' )
     1        '        are not used so this is ok.  You may ignore the',
     2        ' warnings from VXSUDT.'
            CALL WLOG( 1, MSGTXT )

         END IF
C
C        Check for any FORMAT 'NONE' and all FORMAT 'NONE'.  Don't
C        write VEX for all FORMAT 'NONE'
C
         FMTNONE = .FALSE.
         ALLNONE = .TRUE.
         DO ISET = 1, NSET
            IF( USED(ISET) .AND. FORMAT(ISET) .EQ. 'NONE' ) 
     1           FMTNONE = .TRUE.
            IF( USED(ISET) .AND. FORMAT(ISET) .NE. 'NONE' ) 
     1           ALLNONE = .FALSE.
         END DO
C
C        Actually write the VEX file, or explain why not.
C        Only allow all format='none' for VLBA pointing files.
C        Can I change that eventually?
C        Don't write it for a configuration test.
C
C         IF( OVERRIDE .OR. .NOT. FMTNONE ) THEN
         IF( ( OVERRIDE .OR. .NOT. ALLNONE .OR. 
     1         OBSTYP .EQ. 'PTVLBA') .AND. 
     2         OBSTYP .NE. 'CONFIG' ) THEN
C
            CALL VXWRT
C
C           Also write a template v2d file for DiFX correlation.
C
            IF( .NOT. OBSTYP .EQ. 'PTVLBA' ) CALL V2DOUT
C
         ELSE IF( ALLNONE ) THEN
            WRITE( MSGTXT, '(A,A)' )
     1        'VEXOUT: Cannot use VEX with a schedule in which ',
     2        'all scans have FORMAT=NONE.'
            CALL ERRLOG( MSGTXT )
         ELSE IF( CONFIG ) THEN
            WRITE( MSGTXT, '(A,A)' )
     1        'VEXOUT: Do not mix VEX with Configuration tests. ',
     2        'Set DOVEX=-1'
            CALL ERRLOG( MSGTXT )
         ELSE
            WRITE( MSGTXT, '(A,A)' )
     1        'VEXOUT: Programming error - should not get here.',
     2        ' VEX file not being written.'
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE VXWRTR
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the TR = $TRACKS section 
C     By H.J. van Langevelde, JIVE, 300496 
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C      
      INTEGER   ITR, KS, ICH, IBIT, IFAN, IP, HEDSTK, NS2USD
      INTEGER   LPOS, I, ISTA, TRACK1, ITRK
      INTEGER   LEN1
      INTEGER   ISCAT
      CHARACTER LINE*132, THEBIT*4, TPSUBP, S2MDNM*7, IS2USD(16)*4
      CHARACTER THEDAR*5
      LOGICAL   S2OK, LOWBBC, HIBBC
C
C ----------------------------------------------------------------------
C
      LINE = ' ' 
C
C     Nov 2011 - MarkIII is now ancient history so a abort if FORMAT=
C     MARKIII was no longer needed.
      WRITE( IVEX, '( A, A1 )' ) '$TRACKS', SEP     
C
C     Deal with no requested track information - like pointing.
C
C      IF( NTRVEX .EQ. 0 .OR. OBSTYP .EQ. 'NONE' .OR. 
C     1      OBSTYP .EQ. 'PTVLBA' ) THEN
      IF( NTRVEX .EQ. 0 ) THEN
C
C        Try to support pointing observations (no recording) with 
C        dummy format specification.  RCW  Nov. 21, 2011.
C

      write(*,*) 'vxwrtr remove this bit if track sections below work'
         IF( OBSTYP .EQ. 'PTVLBA' ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A )' )
     1          'VXWRTR: Setting format to NONE for ',
     2          'pointing observations.'
            CALL WLOG( 1, MSGTXT )
            WRITE( IVEX, '( A )' )
     1         'def TRACKS.NONE;'
            WRITE( IVEX, '( A1, A, A )' ) COM,
     1          ' This is a fake format for ',
     2          'non-recording observations.'
            WRITE( IVEX, '( 5X, A, A, A1 )' )
     1          'track_frame_format = ','NONE', SEP
C
C           Wrap up.
C
            WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
            WRITE( IVEX, '( A )' ) COMLIN
         ELSE
            CALL ERRLOG( 'VSWRTR:  No VEX TRACK blocks requested. '//
     1       'Something wrong.' )
         END IF
C
C        Jump to end of routine.  This should be an IF/THEN/ELSE,
C        but I did not want to indent the whole rest of the routine
C        again.  RCW, Nov 2011
C
         GO TO 999
      END IF
C
C     start with the right business
C
      DO ITR = 1, NTRVEX
         KS = TRISSET(ITR)
C
C        Find a station using this setup so you can check its medium later
C
         DO ISTA = 1, NSTA
            IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,KS) )
     4      ISCAT = ISTA
         END DO
C
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1        TRLINK(ITR)(1:LEN1(TRLINK(ITR))), SEP
         CALL VXSTLI( ITR, NSTATR, ISTATR )
C
C        Write the DBE if one was specified and the FIRMFILE, if 
C        specified.
C
         IF( DBE(KS) .NE. ' ' )
     1       WRITE( IVEX, '( A1, A, A, A )' ) COM,
     2         '    firmware_type = ', DBE(KS)(1:LEN1(DBE(KS))), SEP
         IF( FIRMFILE(KS) .NE. ' ' )
     1       WRITE( IVEX, '( A1, A, A, A )' ) COM,
     2         '    firmware_file = ', 
     3         FIRMFILE(KS)(1:LEN1(FIRMFILE(KS))), SEP
C
C        If format is none, write a minimal track def.
C
         IF( FORMAT(KS)(1:4) .EQ. 'NONE' ) THEN
            WRITE( IVEX, '( A1, A, A )' ) COM,
     1          ' This is a fake format for ',
     2          'non-recording observations.'
            WRITE( IVEX, '( 5X, A, A, A1 )' )
     1          'track_frame_format = ','NONE', SEP
            WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
         ELSE
C
C          ignore fan in's for now, do fan-outs, figure out what it is
C                
           IF( .NOT. (FORMAT(KS)(1:6) .EQ. 'VLBA1:' .OR. 
     1                FORMAT(KS)(1:7) .EQ. 'MARKIII' .OR.
     2                FORMAT(KS)(1:4) .EQ. 'VDIF' .OR.
     3          FORMAT(KS)(1:2) .EQ. 'S2' .OR.
     4          FORMAT(KS)(1:3) .EQ. 'LBA' .OR.
     5          FORMAT(KS)(1:6) .EQ. 'MKIV1:' .OR.
     6          FORMAT(KS)(1:6) .EQ. 'MARK5B' ) .OR. 
     7         ( FANOUT(KS) .LT. 0.9 .AND.
     8         FORMAT(KS)(1:2) .NE. 'S2' )) THEN
              WRITE( MSGTXT, '( A, A, F6.2 )' )
     1            'VXWRTR: unsupported recording mode/fan: ', 
     2            FORMAT(KS), FANOUT(KS)
              CALL ERRLOG( MSGTXT )
           END IF
           WRITE( IVEX, '( A1, 4X, A, A, A, I1.1 )' ) COM,
     1          'format = ', FORMAT(KS)(1:LEN1(FORMAT(KS))), 
     2          ', and fan-out = ', NINT(FANOUT(KS))
C          
C          write a comment about the tpspeed and data rate
C                
           IF( FORMAT(KS)(1:2) .NE. 'S2' ) THEN
                    IF( USETAPE(ISCAT) ) THEN
                 WRITE( IVEX, '( A1, 4X, A, F6.2, A, I4, A, I4, A )' ) 
     1               COM, 'mode requires ', SAMPRATE(KS)/FANOUT(KS), 
     2               'Mb/s/tr; tape speed low dens:', NINT(SPEEDL(KS)),
     3               'ips, high dens:', NINT(SPEEDH(KS)), 'ips'
              ELSE IF( USEDISK(ISCAT) ) THEN
                 WRITE( IVEX, '( A1, 4X, A, F6.2, A )' ) 
     1               COM, 'mode requires ', SAMPRATE(KS)/FANOUT(KS), 
     2               'Mb/s/tr; stations using disks'
              END IF
C          
C             Now the format and modulation
C                
              IF( FORMAT(KS)(1:7) .EQ. 'MARKIII' ) THEN
                       WRITE( IVEX, '( 5X, A, A, A1 )' )
     1               'track_frame_format = ','Mark3A', SEP
                 WRITE( IVEX, '( 5X, A, A, A1 )' )
     1               'data_modulation = ','off', SEP
              ELSE IF( FORMAT(KS)(1:4) .EQ. 'VLBA' ) THEN
                 WRITE( IVEX, '( 5X, A, A, A1 )' )
     1               'track_frame_format = ','VLBA', SEP
                 WRITE( IVEX, '( 5X, A, A, A1 )' )
     1                  'data_modulation = ','on', SEP
              ELSE IF( FORMAT(KS)(1:4) .EQ. 'MKIV' ) THEN
                 WRITE( IVEX, '( 5X, A, A, A1 )' )
     1               'track_frame_format = ','Mark4', SEP
C          
C                and awaiting a MkIV firmware upgrade it is off
C                
                 WRITE( IVEX, '( 5X, A, A, A1 )' )
     1                     'data_modulation = ','off', SEP
              ELSE IF( FORMAT(KS)(1:6) .EQ. 'MARK5B' ) THEN
                 WRITE( IVEX, '( 5X, A, A, A1 )' )
     1               'track_frame_format = ','MARK5B', SEP
              ELSE IF( FORMAT(KS)(1:4) .EQ. 'VDIF' ) THEN
C
C                VDIF5032 is appropriate for RDBE/DDC and WIDAR,
C                but might need something else for other 
C                systems.
C
                 WRITE( IVEX, '( 5X, A, A, A1 )' )
     1               'track_frame_format = ','VDIF5032', SEP
           
              ELSE IF( FORMAT(KS)(1:3) .EQ. 'LBA' ) THEN
C                       WRITE( IVEX, '( 5X, A, A, A1 )' )
C     1              'S2_recording_mode = ', 'LBA', SEP
                 WRITE( IVEX, '( 5X, A, A, A1 )' )
     1               'S2_data_source = ','VLBA', SEP
                 WRITE( IVEX, '( 5X, A, A, A1 )' )
     1               'S2_recording_mode = ','none', SEP
C                 WRITE( IVEX, '( 5X, A, A, A1 )' )
C     1              'track_frame_format = ', 'LBA', SEP
C                 WRITE( IVEX, '( 5X, A, A, A1 )' )
C     1               'data_modulation = ','off', SEP
              ELSE
                 WRITE( MSGTXT, '( A, A )' )
     1               'VXWRTR: unsupported recording mode: ', FORMAT(KS)
                 CALL ERRLOG( MSGTXT )
              END IF
           ELSE
C          
C             write S2 data soure command, need to know DAR:
C                
              DO ISTA = 1, NSTA
                       IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,KS) )
     1               THEDAR = DAR(STANUM(ISTA))
              END DO
C          
              WRITE( IVEX, '( A1, 4X, A, F5.2, A )' ) 
     1                  COM, 'mode requires ', SAMPRATE(KS), 
     2            'Mb/s/IF;'
C          
C             Then find S2 mode
C                
              CALL VXS2MD( KS, S2MDNM, S2OK, NS2USD, IS2USD, .TRUE. )
                    IF( .NOT. S2OK ) 
     1            CALL ERRLOG('VXWRTR: inconsistent or impossible'//
     2            ' S2 mode ')
              WRITE( LINE, '( 5X, A, A, A1 )' )
     1            'S2_recording_mode = ', S2MDNM(1:LEN1(S2MDNM)), SEP
              LPOS = LEN1(LINE) + 1
              WRITE( LINE(LPOS:), '( 1X, A1, 1X, A )' ) COM, 'streams'
C          
C             write up to 8 input channels in comment
C                
              IF( NS2USD .GT. 8 ) THEN
C                
C                can only be 16, write on two lines
C                
                 DO I = 1, 8
                          LPOS = LEN1(LINE) + 1
                    IF( IS2USD(I) .NE. ' ' ) THEN
                       WRITE( LINE(LPOS:), '( A1, A2, I2.2)' ) 
     1                     COL, 'IN', I-1
                    END IF
                 END DO
                 WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
C          
C                Now other line:
C                
                 LINE = ' '
                       WRITE( LINE, '( A1, 37X )' ) COM
                 DO I = 9, 16
                    LPOS = LEN1(LINE) + 1
                    IF( IS2USD(I) .NE. ' ' ) THEN
                       WRITE( LINE(LPOS:), '( A1, A2, I2.2 )' ) 
     1                     COL, 'IN', I-1
                    END IF
                 END DO
                 WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
              ELSE
C          
C                there are less than 9 inputs active, out of 16
C                
                 DO I = 1, 16
                          LPOS = LEN1(LINE) + 1
                    IF( IS2USD(I) .NE. ' ' ) THEN
                       WRITE( LINE(LPOS:), '( A1, A2, I2.2 )' ) 
     1                     COL, 'IN', I-1
                    END IF
                 END DO
                 WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
              END IF
C          
C             write the S2_data_source
C                
              WRITE( LINE, '( 5X, A )' )
     1                  'S2_data_source = '
              LPOS = LEN1(LINE) + 1
              IF( THEDAR .EQ. 'MKIV' ) THEN
C          
C                Any BBC can be send to output; Sched supports 1+2 
C                      channel BBC 1+2 or 1+3 or 2+4
C                pending further development
C          
                 WRITE( LINE(LPOS:), '( 1X, A, 1X, A1, 1X, A1, A, I2.2,
     1                     1X, A1, 1X, A1, A, I2.2, A1 )') 
     1               'Mark4_formatter', COL, LNK, 'BBC', BBC(1,KS),
     2               COL, LNK, 'BBC', BBC(2,KS), SEP
              ELSE IF( THEDAR .EQ. 'VLBA' .OR. 
     1               THEDAR .EQ. 'VLBAG' ) THEN
C          
C                could be BBC 1-4 or 5-8
C                
                 LOWBBC = .FALSE.
                       HIBBC = .FALSE.
                 DO ICH = 1, NCHAN(KS)
                    IF( BBC(ICH,KS) .LT. 5 .AND. BBC(ICH,KS) .GE. 1 ) 
     1                  THEN
                       IF( HIBBC ) CALL ERRLOG('VXWRTR: Inconsistent '//
     1                     'DAR connection')
                       LOWBBC = .TRUE.
                    ELSE IF( BBC(ICH,KS) .LT. 9 
     1                     .AND. BBC(ICH,KS) .GE. 5 ) THEN
                       IF( LOWBBC ) CALL ERRLOG('VXWRTR: Inconsistent '
     1                     //'DAR connection')
                       HIBBC = .TRUE.
                    ELSE 
                       CALL ERRLOG(
     1                      'VXWRTR: Inconsistent DAR connection')
                    END IF
                 END DO
                 IF( HIBBC ) THEN
                    WRITE( LINE(LPOS:), '( 1X, A, A1 )' ) 
     1                  'VLBA_BBC_5-8', SEP
                 ELSE
                    WRITE( LINE(LPOS:), '( 1X, A, A1 )' ) 
     1                  'VLBA_BBC_1-4', SEP
                 ENDIF
              ELSE
                 CALL WLOG( 1,'VXWRTR: WARNING, un-documented '//
     1               'S2_data_source, may not be recognized by PCFS ')
C          
C                A secial case of undocummented is NONE => none
C                
                 IF( THEDAR .EQ. 'NONE') THEN
                          WRITE( LINE(LPOS:), '( 1X, A, A1 )' ) 
     1                  'none', SEP
                 ELSE
                    WRITE( LINE(LPOS:), '( 1X, A, A1 )' ) 
     1                  THEDAR, SEP
                 END IF
              ENDIF
              WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
C          
C             write the obsolete S2_record_source in comment
C                
              WRITE( LINE, '( A1, 4X, A )' )
     1                  COM, 'S2_record_source =obsolete, but'
              LPOS = LEN1(LINE) + 1
              IF( NS2USD .GT. 8 ) THEN
C          
C                can only be 16, write on two lines
C                
                 DO I = 1, 8
                          LPOS = LEN1(LINE) + 1
                    IF( IS2USD(I) .NE. ' ' ) THEN
                       WRITE( LINE(LPOS:), '( A1, A4 )' ) 
     1                     COL, IS2USD(I)
                    END IF
                 END DO
                 WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
C          
C                and the 2nd line:
C                
                 LINE = ' '
                       WRITE( LINE, '( A1, 36X )' ) COM
                 DO I = 9, 16
                    LPOS = LEN1(LINE) + 1
                    IF( IS2USD(I) .NE. ' ' ) THEN
                       WRITE( LINE(LPOS:), '( A1, A4 )' ) 
     1                     COL, IS2USD(I)
                    END IF
                 END DO
              ELSE
C          
C                there are less than 9 inputs active, out of 16
C                
                 DO I = 1, 16
                          LPOS = LEN1(LINE) + 1
                    IF( IS2USD(I) .NE. ' ' ) THEN
                       WRITE( LINE(LPOS:), '( A1, A4 )' ) 
     1                     COL, IS2USD(I)
                    END IF
                 END DO
                 WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
              END IF
C          
C          done with S2
C                
           END IF
C                
C          This version should allow a second head set
C                
           IF( FORMAT(KS)(1:2) .NE. 'S2' ) THEN
                    LINE = ' '
C          
C             only tapemode 1,2 4, 8 supported in SCHED, PCFS does
C                   4 max, see vxwrpo
C          
              DO IP = 1, TAPEMODE(KS)
                       TPSUBP = 'X'
C          
C
                 IF( USETAPE(ISCAT) ) THEN
                    IF( IP .EQ. 1) TPSUBP = 'A'
                    IF( IP .EQ. 2) TPSUBP = 'B'
                    IF( IP .EQ. 3) TPSUBP = 'C'
                    IF( IP .EQ. 4) TPSUBP = 'D'
                    IF( IP .EQ. 5) TPSUBP = 'E'
                    IF( IP .EQ. 6) TPSUBP = 'F'
                    IF( IP .EQ. 7) TPSUBP = 'G'
                    IF( IP .EQ. 8) TPSUBP = 'H'
                 ELSE IF( USEDISK(ISCAT) ) THEN
                    TPSUBP = ' '
                 END IF
C          
                 DO ICH = 1, NCHAN(KS)
                    DO IBIT = 1, BITS(1,KS) 
C          
C                      different bits per channel not supported (ICH,KS)
C                
                       LINE = ' '
                             THEBIT = 'huhh'
                       IF( IBIT .EQ. 1) THEBIT='sign'
                       IF( IBIT .EQ. 2) THEBIT=' mag'
                       IF( TWOHEAD .AND.
     1                     TRACK(ICH,IP,KS) .GT. 33 ) THEN
                          HEDSTK = 2
                          TRACK1 = TRACK(ICH,IP,KS) - 64
                       ELSE
                          HEDSTK = 1
                          TRACK1 = TRACK(ICH,IP,KS)
                       ENDIF
                       WRITE( LINE(1:39), '( 5X, A, 1X, A1, 1X, A1, 
     1                     1X, A1, A, I2.2, 1X, A1, 1X, A, 1X, A1, 
     2                     1X, I1.1, 1X )' ) 
     3                     'fanout_def =', TPSUBP, COL, LNK, 'CH', ICH, 
     4                     COL, THEBIT, COL, HEDSTK
                       IF( FORMAT(KS)(1:3) .NE. 'LBA' .AND. 
     1                     FORMAT(KS)(1:6) .NE. 'MARK5B' .AND.
     2                     FORMAT(KS)(1:4) .NE. 'VDIF' ) THEN
                          DO IFAN = 1, NINT(FANOUT(KS))
C          
C                         here are some implicit assumptions made, 
C                               about VLBA (and MkIV!) standard modes, 
C                               see MkIV Memo 230
C          
                             LPOS = LEN1(LINE)+1
                                   WRITE( LINE(LPOS:LPOS+4), '(
     1                           A1, 1X, I2, 1X )' ) COL, 
     2                           TRACK1+(IFAN-1)*2+
     3                           (IBIT-1)*2*NINT(FANOUT(KS))
                          END DO
                       ELSE IF( FORMAT(KS)(1:4) .EQ. 'VDIF' ) THEN
C
C                         For VDIF format, just set the track number
C                         to the channel number.   That was set in settrk.f.
C                         (W. Brisken email May 14, 2012.  Change by RCW)
C
                          LPOS = LEN1(LINE)+1
                          WRITE( LINE(LPOS:LPOS+4), '(A1, 1X, I2)') 
     1                       COL, TRACK1
                       ELSE 
C                         For LBA and Mark5B, the layout is simpler - 
C                         There is no fanout and simple mapping of 
C                         track to channel that we set in settrk.f.
C          
                          LPOS = LEN1(LINE)+1
                          ITRK = TRACK1 + IBIT - 1
C                          IF( FORMAT(KS)(1:6) .EQ. 'MARK5B' )
C     1                       ITRK = ITRK + 2
                          WRITE( LINE(LPOS:LPOS+4), '(A1, 1X, I2)') 
     1                       COL, ITRK
                       END IF
                       WRITE( IVEX, '( A, A1 )' ) LINE(1:LEN1(LINE)), 
     1                      SEP
                    END DO
                 END DO
              END DO 
           END IF
           WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
C           
        END IF   
      END  DO
      WRITE( IVEX, '( A )' ) COMLIN
C
C     Jump to here if NTRVEX was zero.
C
  999 CONTINUE
      RETURN
      END

      SUBROUTINE SUMOPE( RESTART, PDATE, MJD )
C
C     Routine for SCHED that opens the summary file and writes the
C     cover information and correlator information into it.  It also
C     calculates some correlator related parameters such as the data
C     set size.
C
C
      INCLUDE 'sched.inc'
C
      INTEGER        LEN1, VLBOPE, IOERR, NCH, MJD, I
      CHARACTER      PRTFILE*80, OPTEXT*255, OPSTAT*4
      CHARACTER      PDATE*(*)
      LOGICAL        EXISTS, RESTART
C ------------------------------------------------------------------
C
C     Construct the name of the summary file.
C
      WRITE( PRTFILE, '(A,A)' )  EXPCODE(1:LEN1(EXPCODE)), '.SUM'
      CALL DWCASE( PRTFILE )
      IF( DEBUG ) CALL WLOG( 0, 'SUMOPE: Opening ' //
     1      PRTFILE(1:LEN1(PRTFILE)) )
C
C     Find out if the .sum file already exists.
C
      INQUIRE( FILE=PRTFILE, EXIST=EXISTS )
      IF( EXISTS .AND. ( RESTART .OR. OVERWRIT ) ) THEN
         OPSTAT = 'OLD'
      ELSE IF( EXISTS ) THEN
         NCH = LEN1(PRTFILE) 
         CALL WLOG( 1, 'SUMOPE: ' //
     1       PRTFILE(1:NCH) // ' already exists.' )
         CALL ERRLOG( 
     1   'SUMOPE: You need to delete old output files or use OVERWRIT.')
      ELSE
         OPSTAT = 'NEW'
      END IF
C
C     Announce your intentions.
C
      CALL WLOG( 1, 'SUMOPE:  Writing summary file ' //
     1     PRTFILE(1:LEN1(PRTFILE)) )
C
C     OPEN summary file.
C
      IOERR = VLBOPE( ISUM, PRTFILE, 'TEXT', OPSTAT, OPTEXT )
      IF( IOERR .NE. 1 ) CALL ERRLOG( ' Open problem:'//OPTEXT )
C
C     Identify the schedule
C
      WRITE( ISUM, '( 20X, A, A, /, 1X, /, A, /, 1X, /, 2A, /, 2A )' )
     1      'SUMMARY FILE FOR PROJECT: ', EXPCODE,
     2      'COVER INFORMATION: ',
     3      '  Experiment: ', EXPT(1:LEN1(EXPT)),
     4      '  Exp. Code:  ', EXPCODE            
C
C     Write the date
C
      WRITE( ISUM, '( A, A )' ) '  Start ', PDATE
C
C     Give the rest of the cover information.
C
      WRITE( ISUM, '( 1X, /, 2(2X,A,/), 1X,/, 2X,A, /, 1X,/, 4(2X,A,/),'
     1      //'1X,/, 4(2X,A,/), 1X,/, 2X,A,/, 1X,/, 4(2X,A,/) )' )
     2      (COVER(I)(1:MAX(1,LEN1(COVER(I)))), I=1,MCOVER)
C
C     Write the cover letter if there is one.
C
      IF( COVERLET ) THEN
         WRITE( ISUM, '( 1X, /, A, /, 1X )' )
     1      'COVER LETTER:'
         CALL WRTCOV( ISUM )
      ELSE
         WRITE( ISUM, '( 1X, /, A )' )
     1      'No cover letter provided.'
      END IF
C
C     Derive and list the times that the schedule can be preempted
C     at some stations (Meant for PT and MK use by USNO).
C
      CALL PROTECT( ISUM )
C
C     Write the correlator information.
C
      CALL CORLST
C
C     List the stations.
C
      CALL STALST( MJD )
C
      RETURN
      END

      INTEGER FUNCTION LEN1(S)
      CHARACTER*(*) S
C
C Find the length of a character string excluding trailing blanks.
C A blank string returns a value of 0.
C
C Argument:
C  S      (input)  : character string.
C
C Returns:
C  LEN1            : number of characters in S, excluding trailing
C                    blanks, in range 0...LEN(S). A blank string
C                    returns a value of 0.
C
C Subroutines required:
C  None
C
C Fortran 77 extensions:
C  None
C
C History:
C  1987 Nov 12 - TJP.
C-----------------------------------------------------------------------
      INTEGER  I
C
      IF (S.EQ.' ') THEN
          LEN1 = 0
      ELSE
          DO 10 I=LEN(S),1,-1
              LEN1 = I
              IF (S(I:I).NE.' ') GOTO 20
   10     CONTINUE
          LEN1 = 0
   20     CONTINUE
      END IF
      END

      SUBROUTINE DEFAULTS
C
C     Subroutine for SCHED that takes the user input from both main
C     schedule input and from the catalogs etc and fills out information
C     that was not provided.  It is also a convenient place to check
C     inappropriate catalog choices or attempt to use Mark5A on the 
C     VLBA for other than pointing.
C
C     Jan. 29, 2013  Change the defaults for MINPAUSE and PRESTART.
C     Make them system dependent.
C     Dec 2013  Move MINPAUSE and PRESTART defaulting to RECCTL.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    ISCN, ISTA, KS, KSTA
      LOGICAL    FRDBE, SRDBE, M5AWARN
      DATA       M5AWARN /.TRUE./
      SAVE       M5AWARN
C
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'DEFAULTS starting.' )
C
C     Protect against mixing RDBE and non-RDBE stations and frequency files.
C
      FRDBE = INDEX( FREQFILE, 'RDBE' ) .NE. 0
      SRDBE = INDEX( STAFILE, 'RDBE' ) .NE. 0
      IF( FRDBE .NEQV. SRDBE ) THEN
         MSGTXT = 'DEFAULTS: **** Did you intend to mix RDBE and '//
     1     'non-RDBE station and frequency files? ****'
         CALL WLOG( 1, ' ' )
         CALL WLOG( 1, MSGTXT )
         CALL WLOG( 1, ' ' )
      END IF
C
C     Discourage use of MARK5A on the VLBA except for pointing.
C
      DO ISTA = 1, NSTA
         KSTA = STANUM(ISTA)
         IF( STATION(KSTA)(1:4) .EQ. 'VLBA' .AND. 
     1       DISK(KSTA) .EQ. 'MARK5A' .AND. M5AWARN .AND.
     2       .NOT. NOTAPE ) THEN
            CALL WLOG( 1, 'STREAD: ==== WARNING ==== Mark5A '//
     1          'specified for a VLBA  station.' )
            CALL WLOG( 1, '        Those recorders have been '//
     1          'removed from most VLBA stations.' )
            M5AWARN = .FALSE.
         END IF
      END DO
C
C     Tie up the loose ends with the source catalogs, adding planets
C     etc if needed.  Be sure that the Julian scan times are available
C     for the ephemeris (deal with scan times first).
C
      CALL SRFINISH
C
C     Now tie up any loose ends related to automatic reference pointing.
C     The stations and source catalogs should be available by here.
C
      CALL PKFINISH
C
C     Make sure some items for the VLA are set.
C
      CALL VLASCNS
C
C     Work on setups if there are any.
C
      IF( .NOT. NOSET ) THEN
C
C        Set setup defaults and check the setups.
C
         CALL DEFSET
C
C        Set the default for DOPINCR.  It's a bit complicated with the
C        digital systems, so use a subroutine.
C
         CALL SDOPINCR
C
      END IF
C
C     Set the system dependent defaults for PRESTART and MINPAUSE.
C
      CALL RECCTL
C
C     Default the grab stuff.  Put after setups defaulted so we
C     have the bit rate.  The GRABGAP assumes that the required
C     bit rate is the total over all channels.
C
      DO ISCN = SCAN1, SCANL
         IF( GRABTO(ISCN) .NE. 'NONE' .AND.
     1       DATAPATH(ISCN) .EQ. 'IN2DISK' ) THEN
            IF( GRABTIME(1,ISCN) .LT. 0.0 ) GRABTIME(1,ISCN) = 30
            IF( GRABTIME(2,ISCN) .LT. 0.0 ) GRABTIME(2,ISCN) = 10
            IF( GRABGAP(ISCN) .EQ. 0.0 ) THEN
               DO ISTA = 1, NSTA
                  IF( STASCN(ISCN,ISTA) ) THEN
                     KS = NSETUP( ISCN, ISTA )
                     GRABGAP(ISCN) = MAX( GRABGAP(ISCN), 
     1                  5. + GRABTIME(1,ISCN) * TOTBPS(KS) / 110. )
                  END IF
               END DO
            END IF
         END IF
      END DO
C
C     Clearly lots of stuff still needs to be moved here to cleanly
C     separate the inputs from the default setting.  Someday......
C
C
      RETURN
      END

      SUBROUTINE SETTPS( ISCN, LASTISCN )
Cf2py intent(in) ISCN, LASTISCN
C
C     Routine for SCHED to set TPSTART - how long before the scan
C     start time to start the recording.  Recorders may be started
C     early to help the correlator sync up and/or to prevent the
C     recorder from stopping for too short a time between scans.
C
C     If VEX is used, all stations should nominally start their 
C     recordings at the same time ("start" in the SCHED section 
C     of the VEX file).  That is why this code was moved out of 
C     TPSCH which only knows about one station.
C
C     However, while the nominal start time  is common to all 
C     antennas, the new VLBA system (~2012), and DiFX, believe the 
C     station dependent start time offset and don't start recording 
C     or correlation until that time.  That basically obsoletes much 
C     of the hoop jumping related to dealing with tape start times.
C     Also the disk systems don't mind short recording stoppages - 
C     in fact the Mark5C always stops between scans.
C
C     To preserve the common start time, do not change TPSTART later 
C     if DOVEX (which it is for all recording observations).  If not 
C     DOVEX, TPSTART may be reduced later at tape turnarounds or changes.
C
C     Jan 09:  The disk systems don't mind very short stops so don't
C     worry about that aspect any more.  That was an issue related
C     to spin up and spin down of the tapes.
C
C     Try to prevent excessively long recording scans. Feb. 26, 2010 RCW
C     Code was added to insert gaps, but that was a can of worms.
C     Comment out that code (we may want it again later), but keep a stern
C     warning if a scan longer than an hour is encountered.  Mar. 7, 2010.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER           ISCN, ISTA, KSTA, LASTISCN(MAXSTA), KS
      INTEGER           DAY, YEAR
      LOGICAL           FIRSTS, PRESWARN, SGWARN
      DOUBLE PRECISION  LSTOPJ(MAXSTA), SCNGAP(MAXSTA)
      DOUBLE PRECISION  TPMIN, TOL, LASTGAP(MAXSTA)
      DOUBLE PRECISION  TIMED
C      CHARACTER         TIMECH*8
      CHARACTER          TFORM*8, CSTART*8
      PARAMETER         ( TOL = 0.1D0 / 86400.D0 )
      DATA              PRESWARN, SGWARN / .TRUE., .TRUE. /
      SAVE              LASTGAP
C  -------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'SETTPS starting' )
C
C     Initialize.
C
      DO ISTA = 1, NSTA
         TPSTART(ISCN,ISTA) = 0.D0
      END DO
      TPMIN = 1.D0
C
C     Loop through the stations finding TPSTART assuming it can
C     vary by station.
C
      DO ISTA = 1, NSTA
         IF( STASCN(ISCN,ISTA) .AND. .NOT. NOSET .AND. 
     1       RECORDER(STANUM(ISTA)) .NE. 'S2' ) THEN
C
C           Flag first scan for station.  Get setup.  Get last stop.
C           Note that we will not try to keep recorder going through
C           NORECORD scans, even if short.
C
            FIRSTS = LASTISCN(ISTA) .EQ. 0
            KS = NSETUP( ISCN, ISTA )
            IF( FIRSTS ) THEN
               LSTOPJ(ISTA) = STOPJ(ISCN) - 0.5
               LASTGAP(ISTA) = STARTJ(ISCN)
            ELSE
               LSTOPJ(ISTA) = STOPJ(LASTISCN(ISTA)) 
            END IF
            SCNGAP(ISTA) = STARTJ(ISCN) - LSTOPJ(ISTA)
C
C           Get TPSTART based on PRESTART and MINPAUSE.
C           First just based on PRESTART.
C
            TPSTART(ISCN,ISTA) = MIN( PRESTART(ISCN), SCNGAP(ISTA) )
C
C           Don't stop for short gaps.  If FIRSTS, lastiscn(ista)
C           is zero, so should test the latter after the former.
C           Use a small tolerance in the tests to avoid roundoff
C           differences between machines.  TOL is about 0.1 second.
C
            IF( .NOT. FIRSTS ) THEN
               IF( SCNGAP(ISTA) + TOL .GT. TPSTART(ISCN,ISTA) .AND.
     1             SCNGAP(ISTA) + TOL .LT. TPSTART(ISCN,ISTA) +
     2                MINPAUSE(ISCN) .AND. 
     3             .NOT. NOREC(LASTISCN(ISTA)) .AND.
     4             .NOT. NOREC(ISCN) ) THEN
C
                  TPSTART(ISCN,ISTA) = SCNGAP(ISTA)
C
               END IF
C
C              Stub the following break insertion, but keep a
C              strong warning.  The break insertion opened too big
C              a can of worms, especially with non-NRAO systems.
C              In fact, change from doing it if ALLDISK set to only
C              doing it for stations with MARK5A systems.
C              
C              Original comment: 
C              Do a station dependent break if the record scan
C              has been too long.  This will propagate to all
C              stations in the VEX case when starts are aligned.
C              Only do this if all stations are using disk to
C              prevent short stoppages for other systems that might
C              not like it.  Make the inserted stoppage 3 seconds
C              to prevent it being zeroed in SCH24.
C
C              The maximum record scan is a bit arbitrary, but
C              set the limit at 1.1 hours for now.
C
               IF( ALLDISK .AND. DISK(STANUM(ISTA)) .EQ. 'MARK5A' ) 
     1               THEN
                  IF( TPSTART(ISCN,ISTA) .EQ. SCNGAP(ISTA) ) THEN
                     IF( STARTJ(ISCN) - LASTGAP(ISTA) .GT. 
     1                   1.01D0 / 24.D0 ) THEN
C
C                        Don't actually do it.
C
C                        TPSTART(ISCN,ISTA) = TPSTART(ISCN,ISTA) -
C     1                     3.0D0 * ONESEC
C
C                       If one station gets a forced gap, update 
C                       the LASTGAP for all as they will all get
C                       one when the start times are aligned.  With
C                       the stub, keep this to trigger additional
C                       warnings if the long scans keep up, but to
C                       not trigger too many warnings.
C
                        DO KSTA = 1, NSTA
                           LASTGAP(KSTA) = STARTJ(ISCN)
                        END DO
C
C                       Tell the user about it.
C
                        MSGTXT = ' '
                        CALL TIMEJ( STARTJ(ISCN), YEAR, DAY, TIMED )
                        CSTART = TFORM( TIMED, 'T', 0, 2, 2, '::@' )
                        WRITE( MSGTXT, '( A, I5, 4A )' )
     1                   'SETTPS: By scan ', ISCN, ' at ', CSTART, 
     2                   ' there has been over an hour of continuous',
     3                   ' recording on a Mark5A system.'
                        CALL WLOG( 1, MSGTXT )
                        MSGTXT = ' '
                        CALL WLOG( 1,
     1                   '        This puts excessive amounts of '//
     2                   'data at risk if there are playback problems.')
                        CALL WLOG( 1,
     1                   '        Use GAP, or reduce PRESTART or '//
     2                   'MINPAUSE to add a gap.' )
                     END IF
                  ELSE
                     LASTGAP(ISTA) = STARTJ(ISCN)
                  END IF
               END IF
            END IF
C
C           Record the smallest TPSTART for this scan that was 
C           forced by the preceeding stop time.  Comment out the
C           allowance for the cases where a short stoppage was inserted.
C           Put that back if gap insertion is resumed.
C
            IF( TPSTART(ISCN,ISTA) .EQ. SCNGAP(ISTA) ) THEN
C
C     1          TPSTART(ISCN,ISTA) + 3.0 * ONESEC .EQ. 
C     2          SCNGAP(ISTA) )  THEN
C
               TPMIN = MIN( TPMIN, TPSTART(ISCN,ISTA) )
            END IF
C
         END IF
C
      END DO
C
C     Set TPMIN for case where no TPSTARTS were forced by 
C     the scan gap.
C
      IF( TPMIN .EQ. 1.D0 ) TPMIN = PRESTART(ISCN)
C
C     Now have TPSTART.  If necessary, synchronize the recorder starts.
C     VEX requires this for now.
C
      IF( DOVEX ) THEN
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) .AND. .NOT. NOSET .AND. 
     1          RECORDER(STANUM(ISTA)) .NE. 'S2' ) THEN
C
C              Actually set the time to prestart the recorders.  This
C              will set TPSTART to the same value for all stations
C              in the scan.
C
               TPSTART(ISCN,ISTA) = TPMIN
C
C              Warn if synchronizing the starts will cause some
C              short recorder stoppages that could be a problem on the
C              correlator.  This can only happen if the 
C              stop times of the previous scan are
C              staggered (probably implies subarraying in use).
C              
C              Jan 09.  Disks don't mind, so don't worry about this.
C              Keep the code available in case it is needed again.
C
C               IF( SGWARN .AND.
C     1             SCNGAP(ISTA) .GT. TPMIN .AND.
C     2             SCNGAP(ISTA) .LT. TPMIN +
C     3                   MINPAUSE(ISCN) .AND.
C     4             .NOT. NOREC(LASTISCN(ISTA)) .AND. 
C     5             .NOT. NOREC(ISCN) ) THEN
C
C                  SGWARN = .FALSE.
C                  CALL WLOG( 0, 'SETTPS: **** WARNING ****' )
C                  CALL WLOG( 0, '    Synchronized recorder starts '//
C     1              'for VEX have left some short recording stops.' )
C                  CALL WLOG( 0, '    This may cause problems at ' //
C     1              'the correlator.' )
C                  CALL TIMEJ( STARTJ(ISCN), YEAR, DAY, TIMED )
C                  TIMECH = TFORM( TIMED, 'T', 0, 2, 2, '::@' )
C                  MSGTXT = ' '
C                  WRITE( MSGTXT, '( A, I3, A, A, A, A )' )
C     1               '    Problem first encountered at ', DAY,
C     2               '/', TIMECH, ' at ', STCODE(STANUM(ISTA))
C                  CALL WLOG( 0, MSGTXT )
C                  MSGTXT = ' '
C                  WRITE( MSGTXT, '( 2A )' ) 
C     1               '    Note VEX file contains all ',
C     2               'stations, not just VEX stations.'
C                  CALL WLOG( 0, MSGTXT )
C
C               END IF
            END IF
         END DO
      END IF
C     
C     Warn users if some short gaps were filled.  Don't confuse
C     users by giving this message after the warning above about
C     synchronized starts.
C
      DO ISTA = 1, NSTA
         IF( STASCN(ISCN,ISTA) .AND. (.NOT. NOSET) .AND. 
     1       RECORDER(STANUM(ISTA)) .NE. 'S2' .AND. 
     2       PRESWARN .AND. SGWARN ) THEN
            IF( TPSTART(ISCN,ISTA) .GT. PRESTART(ISCN) .AND.
     1          TPSTART(ISCN,ISTA) .GT. 0.D0 ) THEN
               CALL WRTMSG( 0, 'SETTPS', 'taperunning' )
               PRESWARN = .FALSE.
            END IF
         END IF
      END DO
C
      RETURN
      END
 

      SUBROUTINE V2DOUT
C
C     Routine to write a v2d template file.  That is the file used
C     to pass new or modified information to the correlator setup
C     to supplement the vex file.  It will also be a path for 
C     passing source lists for multiple field processing.
C
C     Much borrowed from OMSOUT
C
      INCLUDE           'sched.inc'
      INCLUDE           'schset.inc'
      INCLUDE           'vxlink.inc'
C
      LOGICAL           EXISTS
      INTEGER           LEN1, VLBOPE, IOERR, ICH, NCH, ISTA, ISET
      INTEGER           ISRC, KSRC, ICSRC
      INTEGER           IPAIR, CCHAN
      CHARACTER         V2DFILE*80, OPSTAT*4, OPTEXT*255
      INTEGER           JSRC
      CHARACTER         TRA*16, TDEC*16, TFORM*16, UPCODE*3
C
C----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'V2DOUT starting' )
C
C     Construct the name of the v2d file.
C     
      WRITE( V2DFILE, '(A,A)' )  EXPCODE(1:LEN1(EXPCODE)), '.TV2D'
      CALL DWCASE( V2DFILE )
      IF( DEBUG ) CALL WLOG( 0, 'V2DOUT: Opening ' //
     1      V2DFILE(1:LEN1(V2DFILE)) )
C     
C     Find out if the .v2d file already exists.
C     
      INQUIRE( FILE=V2DFILE, EXIST=EXISTS )
      IF( EXISTS .AND. OVERWRIT ) THEN
         OPSTAT = 'OLD'
      ELSE IF( EXISTS ) THEN
         WRITE( MSGTXT, '( A, A, A )' )  'V2DOUT: ', 
     1       V2DFILE(1:LEN1(V2DFILE)), ' already exists.'
         CALL WLOG( 1, MSGTXT )
         CALL ERRLOG( 
     1      'V2DOUT: You need to delete old output files '//
     2      'or use OVERWRIT.')
      ELSE
         OPSTAT = 'NEW'
      END IF
C     
C     Announce your intentions.
C     
      CALL WLOG( 0, 'V2DOUT:  Writing V2D file ' //
     1     V2DFILE(1:LEN1(V2DFILE)) )
C     
C     Open V2D file.
C      
      IOERR = VLBOPE( IV2D, V2DFILE, 'TEXT', OPSTAT, OPTEXT )
      IF( IOERR .NE. 1 ) CALL ERRLOG( ' Open problem:'//OPTEXT )
C
C     What is this file?
C
      WRITE( IV2D, '( A, A )' )  
     1   '#  Template v2d file for DiFX correlation of ', 
     2   EXPCODE(1:LEN1(EXPCODE))
C
C     Fill in vex file name and antennas.
C
      WRITE( IV2D, '( 1X, /, A, A, A )' ) 'vex = ', 
     1     VEXFILE(1:LEN1(VEXFILE)), '.obs'
C
C     Give the station codes.  
C
      MSGTXT = ' '
      UPCODE = STCODE(STANUM(1))
      CALL UPCASE( UPCODE )
      WRITE( MSGTXT, '( A, A )' ) 'antennas = ', UPCODE
      NCH = LEN( MSGTXT )
      IF( NSTA .GE. 2 ) THEN
         DO ISTA = 2, NSTA
            ICH = LEN1( MSGTXT) 
            UPCODE = STCODE(STANUM(ISTA))
            CALL UPCASE( UPCODE )
            WRITE( MSGTXT(ICH+1:NCH), '( A, A )' ) ', ', 
     1           UPCODE
         END DO
      END IF
      ICH = LEN1( MSGTXT) 
      WRITE( IV2D, '( A )' ) MSGTXT(1:ICH)      
C
C     Make antenna stub blocks:
C
         DO ISTA = 1, NSTA
            ICH = LEN1( MSGTXT) 
            UPCODE = STCODE(STANUM(ISTA))
            CALL UPCASE( UPCODE )
            WRITE( IV2D, '( A, A, A )' ) 'ANTENNA ', 
     1           UPCODE(1:LEN1(UPCODE)), ' { }'
         END DO
C
C     Write channel setup.
C     Include some hints for anyone modifying the file.
C
      WRITE( IV2D, '( 1X, /, A, /, A, /, A, /, A, /, A )' )
     1   '# The nChan should never be less than 128.',
     2   '# For numbers of channels < 128, set specAvg so nChan/specAvg'
     3   ,'# gives the desired number of channels',
     4   'SETUP default', '{'
      WRITE( IV2D, '( A, F7.3 )' ) '  tInt =', CORAVG
C     Format change email of 6/6/2001 Deller - old:  
C     WRITE( IV2D, '( A, I6 )' ) '  nChan = ', CORFFT
      WRITE( IV2D, '( A, I6 )' ) '  nFFTChan = ', CORFFT
      IF( CORCHAN .GT. 0 ) THEN
         CCHAN = CORCHAN
      ELSE 
         CCHAN = 16
      END IF
C
C     Format change email of 6/6/2001 Deller - old:  
C      WRITE( IV2D, '( A, I4 )' ) '  specAvg =', CORFFT / CCHAN
      WRITE( IV2D, '( A, I4 )' ) '  nChan =', CCHAN
C
C      WRITE( IV2D, '( 2A )' )
C     1     'numBufferedFFTs = 10 #This is a DiFX parameter, ', 
C     2     'defaulting to 10 is good'
C
      IF( CORPOL ) THEN         
         WRITE( IV2D, '( 2A )' ) '  doPolar = True ',
     1      '# Full stokes'
      ELSE
         WRITE( IV2D, '( 2A )' ) '  doPolar = False ',
     1      '# No cross hand correlations'
      END IF
      WRITE( IV2D, '( A )' ) '}'
C
C     RULE needed.  I don't know much about it yet.
C
      WRITE( IV2D, '( 1X, /, A, /, A, /, A, /, A, /, A )' )
     1   '# This, along with SETUP default above, should always be done'
     2   ,'RULE default',
     3   '{',
     4   '  setup = default',
     5   '}'
C
C     SETUP placeholders.
C
      WRITE( IV2D, '( 1X, /, A )' ) '#  SETUP place holders (commented)'
      DO ISET = 1, NSETF
         WRITE( IV2D, '( A, A, A )' ) '# SETUP ',
     1        SETFILE(ISET)(1:LEN1(SETFILE(ISET))), ' {}'
      END DO
C
C     Write sources.  First those without extra phases centers, then
C     those that have offset phase centers.
C
C     Use the SRCNAME in the schedule source list to get the name 
C     actually used.  That is element KSRC.  That avoids searching 
C     through for the right alias.
C
      WRITE( IV2D, '( 1X, /, A )' )
     1  '# Sources (pointing centers) with recorded data but no ' //
     2  'offset pointing centers:'
      DO ISRC = 1, MSRC
         IF( USEDREC(ISRC) .AND. .NOT. USEDCENT(ISRC) ) THEN
            KSRC = SRLSTN(ISRC)
            IF( CALCODE(ISRC) .EQ. ' ' ) THEN
               WRITE( IV2D, '( 5A )' ) 'SOURCE ', 
     1            SRCNAME(KSRC)(1:LEN1(SRCNAME(KSRC))), ' { }'
            ELSE
               WRITE( IV2D, '( 5A )' ) 'SOURCE ', 
     1            SRCNAME(KSRC)(1:LEN1(SRCNAME(KSRC))), ' { calCode = ',
     2            CALCODE(ISRC)(1:LEN1(CALCODE(ISRC))), ' }'
            END IF
         END IF
      END DO
C
C     Now the multiple phase centers.
C
      IF( NPAIR .GE. 1 ) THEN
         WRITE( IV2D, '( 1X, /, A )' )
     1     '# Sources (pointing centers) with recorded data and ' //
     2     'offset pointing centers:'
C
C        Finally time to write the information source/centers data.
C
         DO IPAIR = 1, NPAIR
            KSRC = SRLSTN(PAIRSRC(IPAIR))
            WRITE( IV2D, '( 3A )' ) 'SOURCE ', 
     1         SRCNAME(KSRC)(1:LEN1(SRCNAME(KSRC))), ' {'
            IF( PAIRSRC(IPAIR) .EQ. CTRSRCI(1,PAIRCENT(IPAIR)) ) THEN
               WRITE( IV2D, '( A )' ) '  doPointingCenter = True'
            ELSE
               WRITE( IV2D, '( A )' ) '  doPointingCenter = False'
            END IF
            DO ICSRC = 1, NCSRC(PAIRCENT(IPAIR))
               JSRC = CTRSRCI(ICSRC,PAIRCENT(IPAIR))
               TRA =  TFORM( RA2000(JSRC), 'T', 0, 2, 10, '::@' )
               TDEC = TFORM( D2000(JSRC), ' ', 1, 2, 9, '::@' )
               IF( TDEC(1:1) .EQ. ' ' ) TDEC = TDEC(2:16)//' '
               WRITE( IV2D, '( 6A )' )
     1             '  addPhaseCentre = name@', 
     2             CTRSRCN(ICSRC,PAIRCENT(IPAIR))(1:LEN1(
     3                CTRSRCN(ICSRC,PAIRCENT(IPAIR)))),
     4             '/ra@', TRA, '/dec@', TDEC
            END DO
            WRITE( IV2D, '( A )' ) '}'
         END DO
      END IF
C
C
      RETURN
      END

      SUBROUTINE PLWEIG( IVZ, U, V, W, NPTS,
     1                   KLDIMU, KLDIMV, UINT, VINT ) 
C
C     Routine for sched that calculate the Weights array to
C     give Dirty Beam.
C
C     PLWEIG is an alias of subroutine WEIGHT that is part of
C     the program "INVERT" ( AUG. 23,1982 )
C
      INCLUDE 'beam.inc'
C
      INTEGER          NPTS(1), NPNTS
      INTEGER          ENORM, ER0, I, J, Q, IU, IV, KLO, KHI
      INTEGER          JLO, JHI, K, M, N
      INTEGER          KLDIMU, KLDIMV, KLDTU, KLDTV
      DOUBLE PRECISION U(NPBAS,NBASE), V(NPBAS,NBASE)
      DOUBLE PRECISION UINT, VINT
      DOUBLE PRECISION IVZ(KXSIZE*2,KYSIZE*2), W(NPBAS,NBASE)
      DOUBLE PRECISION UU, VV
C -------------------------------------------------------------------
C
      KLDTU = 2 * KLDIMU
      KLDTV = 2 * KLDIMV
      ENORM = 0
      ER0   = 1
C
C     Zero Weight array
C
      DO 5 J = 1, KLDTV
         DO 5 I = 1, KLDTU
            IVZ(I,J) = 0.0
 5    CONTINUE
C
      DO 106 I = 1, NBASE
         NPNTS = NPTS(I)
C
         DO 65 Q = 1, NPNTS
            ENORM = ENORM + 1
            UU  = U(Q,I)
            VV  = V(Q,I)
            IU  = UU / UINT + KLDIMU + 1
            IV  = VV / VINT + KLDIMV + 1
            KLO = MAX0(IU-1, 1)
            KHI = MIN0(IU+1, KLDTU)
            JLO = MAX0(IV-1, 1)
            JHI = MIN0(IV+1, KLDTV)
C
            DO 63 J = JLO, JHI
               DO 63 K = KLO, KHI
                  IVZ(K,J) = IVZ(K,J) + 1 / ER0
                  M        = KLDTU - K + 1
                  N        = KLDTV - J + 1
                  IVZ(M,N) = IVZ(M,N) + 1 / ER0
 63         CONTINUE
 65      CONTINUE
 106  CONTINUE
C
C     Calculate Weights
C
      DO 131 I = 1, NBASE
         NPNTS = NPTS(I)
         DO 130 Q = 1, NPNTS
            UU     = U(Q,I)
            VV     = V(Q,I)
            IU     = UU / UINT + KLDIMU + 1
            IV     = VV / VINT + KLDIMV + 1
            W(Q,I) = 1.0 / IVZ(IU,IV)
 130     CONTINUE
 131  CONTINUE
C
      DO 20 J = 1, KLDTV
         DO 20 I = 1, KLDTU
            IVZ(I,J) = IVZ(I,J) / ENORM
 20   CONTINUE
C
      RETURN
      END

      SUBROUTINE SUNPOS( JTIME, RAS, DECS )
Cf2py intent(in) JTIME
Cf2py intent(out) RAS, DECS
C
C     Routine to get the approximate position of the Sun at Julian 
C     time TIME using the SLALIB routines.
C
C     Inputs:   JTIME    Modified Julian Day, including fraction. 
C     Outputs:  RAS      RA of sun in radians.
C               DECS     Dec of sun in radians.
C
C     Called in SCHED by GETSUN.  Also in plot stuff??
C
      INTEGER           YEAR, DAY
      REAL              RSUN(6), FRACTDAY
      DOUBLE PRECISION  JTIME, RAS, DECS, RADDAY, TWOPI
      PARAMETER         (TWOPI=3.141592653589793238D0*2.0D0)
C --------------------------------------------------------------------
C     Convert TIME to the units wanted by SLA_EARTH
C
      CALL TIMEJ( JTIME, YEAR, DAY, RADDAY )
      FRACTDAY = RADDAY / TWOPI
      CALL SLA_EARTH( YEAR, DAY, FRACTDAY, RSUN )
      RAS = ATAN2( -RSUN(2), -RSUN(1) )
      DECS = (-1.)*ATAN2( RSUN(3), SQRT( RSUN(1)**2 + RSUN(2)**2 ) )
C
      RETURN
      END

      CHARACTER*32 FUNCTION VXNMBB( IXX ) 
C
C     Routine specific for the VEX extension of SCHED. 
C     returns a name for an BBC block definition,
C     currently only writes simple consecutive numbering
C     By H.J. van Langevelde, JIVE, 140596 
C
C     Note by Cormac Reynolds (20090826): the logic in this routine does
C     not work for the LBA where the DC edge does not have to be the
C     same for both sidebands from a single BBC (e.g. you can get 2
C     USBs from a single BBC - they do not even have to be contiguous).
C     Digital systems! Anyway, it's just a name, so no dramas.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER ISET, IXX, NUNBBC, ICH
      CHARACTER NAME*32 
C ----------------------------------------------------------------------
C
      ISET = BBISSET( IXX )
      NAME = ' '
C
      NUNBBC = 0
      DO ICH=1,NCHAN(ISET)
         IF( MOD(ICH,2).EQ.0) THEN
            IF( BBSYN(ICH,ISET) .NE. BBSYN(ICH-1,ISET) .OR. 
     1          IFCHAN(ICH,ISET) .NE. IFCHAN(ICH-1,ISET) ) 
     2          NUNBBC = NUNBBC+1
         ELSE
            NUNBBC = NUNBBC + 1
         END IF
      END DO
      IF( NUNBBC .GT. 9 ) THEN
         WRITE( NAME(1:6), '( I2, A4 )' ) NUNBBC,'BBCs'
      ELSE
         WRITE( NAME(1:5), '( I1, A4 )' ) NUNBBC,'BBCs'
      ENDIF
C
C     Net sidebands does not occur in BBC comparison
C
      VXNMBB = NAME
C
      RETURN
      END

      SUBROUTINE HAAVAI( THAMIN, THAMAX, TBEGIN, TEND, 
     1                   TAVAIL, TUSE, NHA, IHA, SIDR )
Cf2py intent(in) THAMIN, THAMAX, TBEGIN, TEND, NHA, IHA
Cf2py intent(out) TAVAIL, TUSE
Cf2py intent(hide) SIDR
C
C     Subroutine for OPTHAS that gets the total time the source is 
C     available.
C
C     Also determine the default hour angles (TUSE) to use for even 
C     spacing of NHA scans.
C
C     Note:  HA parameters are in hours, T parameter in days.
C
C     THAMIN is the rise time MJD
C     THAMAX is the set time (start of scan that sets) MJD
C     TBEGIN is the MJD at experiment start.
C     TEND is the last MJD for the start of a scan 
C     TAVAIL is the total time the source is "up" (output)
C     TUSE is the start MJD at which to try to observe this scan.
C     NHA is the number of times the source will be observed.
C     IHA is which one of those we are dealing with.
C     SIDR is the sidereal rate (1.0027...) dUT * SIDR = dHA
C
      INTEGER           NHA, IHA
      DOUBLE PRECISION  SIDR, TBEGIN, TEND, THAMIN, THAMAX
      DOUBLE PRECISION  TUSE, TAVAIL
      DOUBLE PRECISION  TADD, TINC
C ----------------------------------------------------------------------
C     THAMIN is the last rise before the experiment end.
C     THAMAX is the first set after the experiment start.
C     There are really three distinct cases to worry about.
C        1.  Source is never up.  Trigger an abort from OPTHAS.
C        2.  Source is up once.  This includes always up.
C        3.  Source is up twice (sets, then rises)
C 
C     They are distinguished by the whether THAMIN is before or 
C     after THAMAX.  Since we prohibit runs of more than 24 hr,
C     the source cannot be up twice and not be up at both begin
C     and end.
C
      IF( THAMAX .GT. THAMIN + 1.D0 ) THEN
         TAVAIL = -1.D0
         TUSE = 0.D0
      ELSE IF( THAMAX .GE. THAMIN ) THEN
         TAVAIL = MIN( THAMAX, TEND ) - MAX( TBEGIN, THAMIN )
         TUSE = MAX( TBEGIN, THAMIN ) + ( TAVAIL / NHA ) * ( IHA - 0.5 )
      ELSE
         TAVAIL = THAMAX - TBEGIN + TEND - THAMIN
         TADD = THAMAX - TBEGIN
         TINC = TAVAIL / NHA
         TUSE = TBEGIN + TINC * ( IHA - 0.5 )
         IF( TUSE .GT. THAMAX ) THEN
            TUSE = TUSE + THAMIN - THAMAX
         END IF
      END IF
C
C     So that is a whole lot simpler than my earlier attempts to deal
C     with this in terms of hour angles which are not monotonic.  
C     However this did add some complexity to HALIM to find THAMIN
C     and THAMAX.
C
      RETURN
      END

      SUBROUTINE STAFILES
C
C     Subroutine for SCHED, called by the main routine, that loops
C     through the stations creating the individual station files.
C     Global files such as the VEX and VSOP (DRUDG) output are 
C     handled separately. This routine creates the crd, sch, and 
C     obs files.
C
C     For each station, keep track of the setups used and then 
C     write them at the end of the operator schedule file.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER      ISTA, ISCN, SETUSED(MSET), NSUSED, I, KS
      LOGICAL      FIRSTS, OVBA, OLOC, GOT
C  --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'STAFILES: Station loop starting.' )
      DO ISTA = 1, NSTA
C
C        Open the various files with antenna specific info.
C
         CALL FILEOPEN( ISTA, OVBA, OLOC )
C
C        Initialize bookkeeping of setup files.
C
         NSUSED = 0
C
C        Now loop through the scans.
C
         FIRSTS = .TRUE.
         DO  ISCN = SCAN1, SCANL
            IF( STASCN(ISCN,ISTA) ) THEN
               IF( DEBUG .AND. ( ISCN .LE. 3 .OR. ISCN .GE. SCANL - 2 )
     1             ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I5 )' ) 
     1                'STAFILES: Starting loop for scan ', ISCN
                  CALL WLOG( 0, MSGTXT )
               END IF
C
C              Get the setup group number for this scan/station
C              and record whether it was used.
C
               KS = NSETUP( ISCN, ISTA )
               GOT = .FALSE.
               IF( NSUSED .NE. 0 ) THEN
                  DO I = 1, NSUSED
                     IF( SETUSED(I) .EQ. KS ) GOT = .TRUE.
                  END DO
               END IF
               IF( .NOT. GOT ) THEN
                  NSUSED = NSUSED + 1
                  SETUSED(NSUSED) = KS
               END IF
C
C              Write operator schedule.
C
               CALL PRTSCH( ISCN, ISTA, FIRSTS )
C
C              Write out telescope control files.
C
               CALL CRDWRT( ISCN, ISTA, FIRSTS )
C
               FIRSTS = .FALSE.
            END IF
         END DO
C
C        IF( DEBUG ) CALL WLOG( 0, 'STAFILES: Done with scan loop.' )
C
C        Put final lines in telescope control file and CLOSE it.
C        Last call is flagged by scan number -999.
C
         CALL CRDWRT( -999, ISTA, .FALSE. )
         IF( OVBA ) CLOSE( UNIT=IUVBA )
         IF( OLOC ) CLOSE( UNIT=IULOC )
         IF( DEBUG ) CALL WLOG( 0, 'STAFILES: Files closed.' )
C
C        Put setup information in the operator schedule.
C
         WRITE( IPRT, '( 1X, /, 1X, /, A, /, 2A )' ) 
     1       'SETUP FILE INFORMATION:',
     2       '   NOTE: If DOPPLER, FREQ, or BW were used, see the ',
     3       'individual scans for the final BBC settings.'
C
         DO I = 1, NSUSED
            CALL PRTSET( SETUSED(I), IPRT )
         END DO
C
C        Put source list in operator schedule and close it.
C
         CALL SRCLST( IPRT, 1 )
         CLOSE( UNIT=IPRT )
C
         IF( DEBUG ) CALL WLOG( 0, 'STAFILES: Done with station.' )
C
      END DO   ! Station loop
C
      IF( DEBUG ) CALL WLOG( 0, 'STAFILES: Ending.' )
      RETURN
      END

      SUBROUTINE WRTCOV( IFILE )
C
C     Write the cover letter information to the desired output file.
C     This is a dump of what is in the cover letter scratch file.
C
      INCLUDE 'sched.inc'
C
      INTEGER      IOERR, IFILE, VLBOPE, LEN1
      LOGICAL      DONECOV
      CHARACTER    LINE*256
C --------------------------------------------------------------------
      IF( COVERLET ) THEN
         IOERR = VLBOPE( ICOV, 'schedcov.tmp', 'TEXT', 'OLD', LINE )
         IF( IOERR .NE. 1 ) THEN
            CALL WLOG( 1, LINE )
            CALL ERRLOG( 'WRTCOV: Cannot open '//
     1       'cover letter scratch file.  This should not happen.' )
         END IF
C
C        Now transfer the cover letter to the scratch file.
C
         DONECOV = .FALSE.
         DO WHILE( .NOT. DONECOV )
            READ( ICOV, '( A )', END = 200 ) LINE
            WRITE( IFILE, '( A )' ) LINE(1:LEN1(LINE))
         END DO
  200    CONTINUE
         CLOSE( UNIT=ICOV )
      END IF
C
      RETURN
      END

      SUBROUTINE VXSCHK( ISCN, TAPOFF, WARNFS, WARNTS, WARNTSOF, 
     1                  NTSYS, NTSYSON, TSYSGAP, WARNBANK)
Cf2py intent(in) ISCN
Cf2py intent(out) TAPOFF
Cf2py intent(in, out) WARNFS, WARNTS, WARNTSOF, NTSYS, NTSYSON, TSYSGAP
Cf2py intent(in, out) WARNBANK
      IMPLICIT NONE
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 061200
C     This routine checks several scan related       
C     timing issues for the $CHED section, including
C     tape (and disk) issues. It returns a common TAPOFF
C
C     For all stations in scan:
C        tape offsets are all equal
C     For all VEX scans
C         check scan is 15s
C         long scans should set Warnts, unless last reverse
C         Very long scans with disks should set Warnbank
C
C     For any scan but first
C        check early start doesn't overlap
C     For above and VEX control
C        36s tape reversal
C        40s mode change   (THIS MIGHT BE TOO HIGH - RCW Sep 1, 2014).
C        OBSOLETE: tape change time
C        37m postpass
C
C     Note 29/12/00 Craig suggested to make sure one knows what 
C     last station is (LASTISCN in SCHOPT) I think however, that
C     is not urgent
C
C     Moved the PARAMETER statement in front of the DATA statements
C     as required by the standard and a user's compiler.  Feb. 4, 2010 RCW.
C
C     Removing tape items, including all TPPACK calls.  July 20, 2010. RCW.
C     Copies of the routine before that in svn revision 294 and earlier.
C     Also in sched_ARCHIVE_nonSVN/obsolete_routines
C
      INTEGER ISCN, LASTSCN
      DOUBLE PRECISION TAPOFF, LASTSTOP
      LOGICAL WARNFS

      INCLUDE 'sched.inc'      
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'

      INTEGER ISTA
      LOGICAL TPOINI, WARNTS(MAXSTA), WARNBANK
C
      LOGICAL WARNTSOF(MAXSTA), FIELDSY(MAXSTA)
      INTEGER LASTTSYS(MAXSTA), LASTTSON(MAXSTA), DATLAT, I 
      INTEGER NTSYSON(MAXSTA), NTSYS(MAXSTA), TSYSGAP(MAXSTA), THISGAP
      REAL LASTBYTE(MAXSTA)
      REAL MAXDISKU
      PARAMETER (MAXDISKU = 22.*60. * 2.016 * (1024./1000.) / 8.)
      SAVE LASTTSYS, LASTTSON, LASTBYTE
      DATA LASTTSYS /MAXSTA*0/
      DATA LASTTSON /MAXSTA*0/
      DATA LASTBYTE /MAXSTA*0.0/
C-----------------------------------------------------------------------
C
C     MAXDISKU is 22 mins of 2 Gbps recording (allow factor 1.008 for
C     headers).
C
      IF ( DEBUG .AND. ISCN .LE. 2) 
     .    CALL WLOG( 1,'VXSCHK:  Checking VEX tapes ')
C
C     Don't know offset and isn't set
C
      TAPOFF = 0.
      TPOINI = .FALSE.
C
C     Major loop over all stations in scan
C
      DO ISTA = 1, NSTA
C
C        Check if this is likely to be a field system station.  Maybe
C        we need to make this more explicit in the station catalog 
C        because CONTROL=VEX no longer necessarily implies field system.
C        Field system stations require some checks not needed elsewhere.
C        Added May 30, 2012 RCW
C
         FIELDSY(ISTA) = CONTROL(STANUM(ISTA)) .EQ. 'VEX' .AND.
     1      STATION(STANUM(ISTA))(1:3) .NE. 'VLA'
C
C        Process the stations actually in the scan.
C
         IF( STASCN(ISCN,ISTA) ) THEN
C        
C           Current VEX does not allow for different tape starts, so 
C           check and set the overall offset TPOFF.  Note that this
C           should have already been enforced earlier in SCHED when
C           the scans were being established (RCW).
C
            IF( TPOINI ) THEN
C           Remember tpstart is already the offset from startj
               IF( ABS(TPSTART(ISCN,ISTA) - TAPOFF)
     1             .GT. 0.1d0/86400D0 ) THEN
                  CALL PRTSCN( ISCN, 'VXSCHK' )
                  WRITE( MSGTXT, '( A, I3, A )' ) 
     1                'Station tape starts differ,'// 
     2                ' set MINPAUSE to ',
     3                INT(TPSTART(ISCN,ISTA)*86400d0
     4                /SPEEDUP(NSETUP(ISCN,ISTA))),
     5                's to produce VEX file!'
                  CALL ERRLOG( MSGTXT )
               END IF
            ELSE
               TAPOFF = TPSTART(ISCN,ISTA) 
               TPOINI = .TRUE.
            END IF
C        
C        Other checks depend on this not being the first scan
C        Close the STASCN loop.  These checks also apply only
C        to the field system.
C
         END IF
         IF( STASCN(ISCN,ISTA) .AND. FIELDSY(ISTA)
     1      .AND. DISK(STANUM(ISTA)) .NE. 'LBADR' ) THEN
C
C           Field system scans should be longer than 15s, 
C           according to NRV
C        
            IF( NINT( ( STOPJ(ISCN) - (STARTJ(ISCN)-TAPOFF) ) 
     1          * 86400d0) .LT. 15 ) THEN
               CALL PRTSCN( ISCN, 'VXSCHK' )
               WRITE( MSGTXT, '( A, A, A )' ) 
     1             'VXSCHK:  WARNING: Scan length < 15s',
     2             'for station ',STATION(STANUM(ISTA))
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1,'         Currently FS supports '//
     1             'minimal scan length of 15s')
               WARNFS = .TRUE.
            END IF
C 
C           continuous motion for long periods should cause a *MAJOR*
C           warning because bank switches can only occur during gaps in
C           recording.  The definition of 'long' depends on the datarate
C           (we worry about disk consumption, not time).
C
C           Find the last scan that this station participated in (will
C           be zero if this is the first scan for this station).
            LASTSCN = 0
            DO I = SCAN1, ISCN-1
              IF( STASCN(I, ISTA) ) LASTSCN = I
            END DO
C
C           Only need to check for long passes at disk stations.
C           Elsewhere in SCHED, there are warnings about long 
C           recording scans, so don't try to duplicate that here.
C           This warning is for field system stations so restrict
C           it to CONTROL=VEX.
C
            IF( USEDISK(ISTA) .AND. FIELDSY(ISTA) ) THEN
               IF (LASTSCN .EQ. 0) THEN
                  LASTBYTE(ISTA) = 0
               ELSE IF( NINT( ( (STARTJ(ISCN)-TAPOFF) - 
     1               STOPJ(LASTSCN) ) * 86400d0) .GT. 10)  THEN
C                 This means there is a gap before this scan 
                  LASTBYTE(ISTA) = GBYTES(LASTSCN, ISTA)
               END IF
               IF( (GBYTES(ISCN,ISTA) - LASTBYTE(ISTA))  
     1               .GT. MAXDISKU ) THEN
C                 This means there was no recent gap - issue a warning
                  WARNBANK = .TRUE.
C     1        gbytes(iscn,ista), lastbyte(ista), maxdisku
               END IF
            END IF
C
C 
C           Scans longer than 15 min should cause a warning
C           because Tsys is only measured at scan start
C           Restrict this to the field system stations
C           as others tend to have continuous Tsys.
C
            IF( NINT( ( STOPJ(ISCN) - (STARTJ(ISCN)-TAPOFF) ) 
     1          * 1440d0) .GT. 15 .AND. FIELDSY(ISTA) ) THEN
               WARNTS(ISTA) = .TRUE.
C              And record the longest gap for information
               THISGAP = NINT( ( STOPJ(ISCN) - 
     1                   (STARTJ(ISCN)-TAPOFF) ) * 1440d0)
               IF( THISGAP .GT. TSYSGAP(ISTA) ) THEN
                  TSYSGAP(ISTA) = THISGAP
               END IF
            END IF
C        
C           In fact, continuous motion also prevents the Tsys from being
C           measured (cal diode only fired during gaps in recording), so try 
C           to prevent greater than 15 mins of continuous motion
C           Assume a gap of more than 10 seconds means that the cal diode
C           will be fired.
C           Ignore the TAPOFF of the LASTTSYS scan (small error, not
C           enough to worry about).
C           Check if the time between the beginning of the last Tsys scan
C           and the end of the current scan is greater than 15
C           minutes. 
C
C           Default the last on-source Tsys to be scan 1
            IF( LASTTSON(ISTA) .EQ. 0 ) THEN
               LASTTSON(ISTA) = SCAN1
            END IF
C
C           Default Last Tsys scan to first scan
C
            IF( LASTTSYS(ISTA) .EQ. 0 ) THEN
              LASTTSYS(ISTA) = SCAN1
            END IF
C
C           check if there was a Tsys gap this scan.  Avoid a zero
C           index by setting the last stop time to a day earlier for
C           the first scan.
C
            IF( LASTSCN .EQ. 0 ) THEN
               LASTSTOP = (STARTJ(ISCN)-TAPOFF) - 1.D0
            ELSE
               LASTSTOP = STOPJ(LASTSCN)
            END IF
            IF( NINT( ( (STARTJ(ISCN)-TAPOFF) - LASTSTOP ) 
     1          * 86400d0) .GT. 10 ) THEN
C
C              This means there is a TSYS in this scan 
C
               LASTTSYS(ISTA) = ISCN
               NTSYS(ISTA) = NTSYS(ISTA) + 1
C
C              We also like to encourage the Tsys to
C              be on-source, so check for that here. This is station
C              dependent (slew times differ). Make sure there is an
C              on-source Tsys every 15 minutes for every antenna.
C
               DATLAT = IDNINT( ( TONSRC(ISCN,ISTA) - 
     .            (STARTJ(ISCN) - TAPOFF) ) 
     1            * 86400D0 )
               IF( DATLAT .LE. 0 )  THEN
                  LASTTSON(ISTA) = ISCN
                  NTSYSON(ISTA) = NTSYSON(ISTA) + 1
               ELSE IF( NINT( ( (STOPJ(ISCN)) - STARTJ(LASTTSON(ISTA)) )
     1            * 1440d0) .GT. 15 ) THEN  
                  WARNTSOF(ISTA) = .TRUE.
               END IF
            END IF
C
C           Check if there is no recent Tsys for this station - issue 
C           a warning if so.
C
            IF( NINT( ( (STOPJ(ISCN)) - STARTJ(LASTTSYS(ISTA)) ) 
     1          * 1440d0) .GT. 15 ) THEN
               WARNTS(ISTA) = .TRUE.
C              And record the longest gap for information
               THISGAP = NINT( ( (STOPJ(ISCN)) - 
     1                STARTJ(LASTTSYS(ISTA)) ) * 1440d0 ) 
               IF( THISGAP .GT. TSYSGAP(ISTA) ) THEN
                  TSYSGAP(ISTA) = THISGAP
               END IF
            END IF
C
         END IF
      END DO
C
C     Other checks depend on this not being the first scan
C     Close the STASCN loop and start Majour loop again (note the
C     RETURN half way through this to ensure not first scan.
C
      DO ISTA = 1, NSTA
C
         IF( STASCN(ISCN,ISTA) ) THEN
C        
C        Current VEX does not allow for different tape starts, so 
C        check and set the overall offset TPOFF
C
            IF( TPOINI ) THEN
C           Remember tpstart is already the offset from startj
               IF( ABS(TPSTART(ISCN,ISTA) - TAPOFF)
     .             .GT. 0.1d0/86400D0 ) THEN
                  CALL PRTSCN( ISCN, 'VXSCHK' )
                  WRITE( MSGTXT, '( A, I3, A )' ) 
     .                'Station tape starts differ,'// 
     .                ' set MINPAUSE to ',
     .                INT(TPSTART(ISCN,ISTA)*86400d0
     .                /SPEEDUP(NSETUP(ISCN,ISTA))),
     .                's to produce VEX file!'
                  CALL ERRLOG( MSGTXT )
               END IF
            ELSE
               TAPOFF = TPSTART(ISCN,ISTA) 
               TPOINI = .TRUE.
            END IF
         END IF

         IF( ISCN .EQ. 1 ) RETURN
         IF( STASCN(ISCN,ISTA) .AND. STASCN(ISCN-1,ISTA) ) THEN 
C        
C        First check if TAPOFF moves into previous scan
C        
            IF( (STARTJ(ISCN) - TAPOFF) .LT.  STOPJ(ISCN-1) 
     1          .AND.  ISCN .NE. SCAN1 ) THEN
C           
C           Problem if stations overlap
C           
               CALL PRTSCN( ISCN, 'VXSCHK' )
               WRITE( MSGTXT, '( A, A, A )' ) 
     1             'VXSCHK:  WARNING: Tape early start failed ',
     2             'station ', STATION(STANUM(ISTA))
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1,'         Early tape starts only '//
     1             'work if there are sufficient gaps.')
               WARNFS = .TRUE.
            END IF
         END IF
C
C
C        End loop on STASCN(ISCN&ISCN-1) 
C        Next Vex specific things
C
         IF( STASCN(ISCN,ISTA) .AND. STASCN(ISCN-1,ISTA) .AND.
     1       FIELDSY(ISTA) ) THEN
C        
C           Removed tape reversal check.
C        
C           Check for mode change < 40s 
C           RCW  Sep 1, 2014.  This number is probably too high but
C           I'm not sure what to change it do.  So just alter the
C           warning for now.
C
            IF ( MODSCN(ISCN) .NE. MODSCN(ISCN-1) .AND.
     1          (STARTJ(ISCN) - TAPOFF) .LT. 
     2          (STOPJ(ISCN-1) + 40.1d0/86400d0)
     3          .AND.  ISCN .NE. SCAN1 ) THEN
C
C              If the stations match it is impossible
C
               CALL PRTSCN( ISCN, 'VXSCHK' )
               WRITE( MSGTXT, '( A, A, A )' ) 
     1             'VXSCHK:  WARNING: Mode setup <= 40s for ',
     3             'station ', STATION(STANUM(ISTA))
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1,'         FS Stations once needed 40s '//
     1             'for any mode change, incl frequency shift.')
               CALL WLOG( 1,'         This may no longer be true '//
     1             'but the new value is not yet clear.')
               WARNFS = .TRUE.
            END IF
C        
C           Removed postpass warning and calculations.
C
C        End loop on STASCN(ISCN&ISCN-1) VEX
C
         END IF
         
      END DO

      RETURN
      END

      SUBROUTINE sla_DMXV (DM, VA, VB)
*+
*     - - - - -
*      D M X V
*     - - - - -
*
*  Performs the 3-D forward unitary transformation:
*
*     vector VB = matrix DM * vector VA
*
*  (double precision)
*
*  Given:
*     DM       dp(3,3)    matrix
*     VA       dp(3)      vector
*
*  Returned:
*     VB       dp(3)      result vector
*
*  To comply with the ANSI Fortran 77 standard, VA and VB must be
*  different arrays.  However, the routine is coded so as to work
*  properly on many platforms even if this rule is violated.
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DM(3,3),VA(3),VB(3)

      INTEGER I,J
      DOUBLE PRECISION W,VW(3)


*  Matrix DM * vector VA -> vector VW
      DO J=1,3
         W=0D0
         DO I=1,3
            W=W+DM(J,I)*VA(I)
         END DO
         VW(J)=W
      END DO

*  Vector VW -> vector VB
      DO J=1,3
         VB(J)=VW(J)
      END DO

      END

      SUBROUTINE SRCWRT( IOUT, IP )
C
C     Subroutine for SCHED that writes the actual source lines for
C     SRCLST.  See first few lines of code for meaning of IP.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schpeak.inc'
C
      INTEGER       MSEP, ML
      PARAMETER     ( MSEP = 7 )
      PARAMETER     ( ML = 10 + 2 * MAXSET )
C
      INTEGER       IP, ISRC, LEN1, IOUT, INAME
      INTEGER       ICHN
      INTEGER       MLINE, CLINE, NMLINE, IL, NPCH
      INTEGER       ISET, NFC, NCHSET, CH1SET, IPAIR, ICSRC
      DOUBLE PRECISION  TSCAN, TBASE, ESCAN, EBASE
      CHARACTER     FF*1
      CHARACTER*16  TFORM, TRA50, TRA20, TRAP, TDEC50, TDEC20, TDECP
      CHARACTER*16  TRAPM, TDECPM
      CHARACTER     CVELREF*12, CVELDEF*18, HEADLINE*80, KFSETS*78
      CHARACTER*132 LINE(ML), PFSETS*30, PRSRC*12
      LOGICAL       PMUSED, CALL1
      DATA          CALL1 / .TRUE. /
      SAVE          CALL1
C ------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'SRCWRT starting.' )
      FF = CHAR( 12 )
C
      IF( IP .EQ. 1 ) THEN
        HEADLINE = ' POSITIONS OF SOURCES USED IN RECORDING SCANS'
      ELSE IF( IP .EQ. 2 ) THEN
        HEADLINE = ' POSITIONS OF ADDITIONAL SOURCES USED ONLY '//
     1     'IN NON-RECORDING SCANS'
      ELSE IF( IP .EQ. 3 ) THEN
        HEADLINE = ' POSITIONS OFADDITIONAL SOURCES USED ONLY FOR '//
     1     'PHASE CENTERS'
      END IF
C
      IF( CALL1 ) THEN
         WRITE( IOUT, '( A1, A, /, A, /, A, A, /, A, /, ' //
     1    'A, A, F10.3, /, A )' )
     2    FF, HEADLINE(1:LEN1(HEADLINE)),
     3    '     Catalog positions marked with *. ',
     4    '     Precession of date coordinates is based on stop ',
     5    'time of first scan.',
     6    '     Names used in schedule marked with *. ',
     7    '     Observation date used in B1950/J2000 coordinate ',
     8    'conversion (PRECDATE):', PRECDATE,
     9    '     No adjustments are made for rates (DRA, DDEC).'
      ELSE
         WRITE( IOUT, '( 1X, /, A )' ) HEADLINE(1:LEN1(HEADLINE))
      END IF
      CALL1 = .FALSE.
C
      IF( IP .EQ. 2 ) THEN
         WRITE( IOUT, '( 1X, /, A, A)' )
     1    '     An unused dummy source of a scan that becomes ',
     2    'a geodetic segment will show up here.'
      END IF
C
      WRITE( IOUT, '( 2X, /, A, 24X, A, 23X, A /, 22X, A, 6X, A, 
     1        /, 2X )' )
     2    '   Source', ' Source position (RA/Dec) ', 'Error',
     3    '  (B1950)             (J2000)             (Date) ',
     4    '     (mas)'
C
C     Loop over sources.
C
      DO ISRC = 1, MSRC
         IF( ( IP .EQ. 1 .AND. USEDREC(ISRC) ) .OR.
     1       ( IP .EQ. 2 .AND. SUSED(ISRC) .AND. .NOT. USEDREC(ISRC) )
     2       .OR. ( IP .EQ. 3 .AND. .NOT. SUSED(ISRC) .AND. 
     3        USEDPHS(ISRC) ) ) THEN
C
            DO IL = 1, ML
               LINE(IL) = ' '
            END DO
            NMLINE = 0
C
C           Write the names into the first columns for up to 
C           MALIAS lines if there are multiple names.
C
            DO INAME = 1, MALIAS
               IF( SOURCE(INAME,ISRC) .NE. ' ' ) THEN
                  NMLINE = NMLINE + 1
                  WRITE( LINE(NMLINE), '( T2, A1, 1X, A12 )' ) 
     1                CSUSED(INAME,ISRC), SOURCE(INAME,ISRC)
               END IF
            END DO
C
C           Write the source positions on the first 2 lines.
C
            TRA50 = TFORM( RA1950(ISRC), 'T', 0, 2, 9, '   ' )
            TRA20 = TFORM( RA2000(ISRC), 'T', 0, 2, 9, '   ' )
            TRAP  = TFORM( RAP(ISRC),    'T', 0, 2, 9, '   ' )
            TDEC50 = TFORM( D1950(ISRC),  ' ', 1, 2, 8, '   ' )
            TDEC20 = TFORM( D2000(ISRC),  ' ', 1, 2, 8, '   ' )
            TDECP  = TFORM( DECP(ISRC),   ' ', 1, 2, 8, '   ' )

            WRITE( LINE(1)(20:132), '( 3( A1, 1X, A16, 2X ), F8.2 )' )
     1          C1950(ISRC), TRA50, 
     2          C2000(ISRC), TRA20, 
     3          CDATE(ISRC), TRAP, RAERR(ISRC)
            WRITE( LINE(2)(20:132), '( 3( A1, A16, 3X ), F8.2 )' )  
     1          C1950(ISRC), TDEC50, 
     2          C2000(ISRC), TDEC20, 
     3          CDATE(ISRC), TDECP, DECERR(ISRC)
C
C           Make a line giving where SCHED got the position.
C
            IF( WHICHCAT(ISRC) .EQ. 'i' ) THEN
               LINE(3) = LINE(3)(1:21) //
     1              'From catalog imbedded in main SCHED input file.'
            ELSE IF( WHICHCAT(ISRC) .EQ. '1' ) THEN
               LINE(3) = LINE(3)(1:21) //
     1              SRCFILE(1:LEN1(SRCFILE))
            ELSE IF( WHICHCAT(ISRC) .EQ. '3' ) THEN
               LINE(3) = LINE(3)(1:21) //
     1              SRCFILE2(1:LEN1(SRCFILE2))
            ELSE IF( WHICHCAT(ISRC) .EQ. 'P' ) THEN
               LINE(3) = LINE(3)(1:21) //
     1              'Planet.  Position is for scan 1, center Earth.'
            ELSE IF( WHICHCAT(ISRC) .EQ. 'S' ) THEN
               LINE(3) = LINE(3)(1:21) //
     1              'Satellite. Position is for scan 1, center Earth.'
            ELSE IF( WHICHCAT(ISRC) .EQ. '2' ) THEN
               LINE(3) = LINE(3)(1:21) //
     1              PSRCFILE(1:LEN1(PSRCFILE))
            ELSE
               CALL ERRLOG( 'SRCLST: Programming problem.  WHICHCAT '//
     1              'not set.' )
            END IF
C
C           Start keeping track of the current line because some of
C           the following are not done in all cicumstances.
C
            CLINE = 3
C
C           Write any remark included in catalog for this source.
C
            IF( REMARK(ISRC) .NE. ' ') THEN
               CLINE = CLINE + 1
               LINE(CLINE) = LINE(CLINE)(1:21) //
     1              REMARK(ISRC)(1:LEN1(REMARK(ISRC)))
            END IF
C
C           Write any velocities used.
C
            IF( DIDNDOP(ISRC) .GT. 0 ) THEN
               IF( VELDEF(ISRC) .EQ. 'R' ) THEN
                  CVELDEF = 'radio definition'
               ELSE IF( VELDEF(ISRC) .EQ. 'O' ) THEN
                  CVELDEF = 'optical definition'
               ELSE IF( VELDEF(ISRC) .EQ. 'Z' ) THEN
                  CVELDEF = 'redshift'
               ELSE
                  CALL ERRLOG( 'SRCLST: Bad VELDEF - program problem.' )
               END IF
               IF( VELREF(ISRC) .EQ. 'L' ) THEN
                  CVELREF = 'LSR'
               ELSE IF( VELREF(ISRC) .EQ. 'H' ) THEN
                  CVELREF = 'heliocentric'
               ELSE IF( VELREF(ISRC) .EQ. 'G' ) THEN
                  CVELREF = 'geocentric'
               ELSE
                  CALL ERRLOG( 'SRCLST: Bad VELREF - program problem.' )
               END IF
C
               CLINE = CLINE + 1
               WRITE( LINE(CLINE)(22:132), '( 5A )' ) 
     1            'Doppler based on ',
     2            CVELREF(1:LEN1(CVELREF)), ' frame and ',
     3            CVELDEF(1:LEN1(CVELDEF)), '.  Velocities:'
C
               CLINE = CLINE + 1
               NPCH = MIN( DIDNDOP(ISRC), 8 )
               WRITE( LINE(CLINE)(22:132), '( 8( F9.2,:) )' )
     1            ( VLSR(ICHN,ISRC), ICHN=1,NPCH )
C
               IF( DIDNDOP(ISRC) .GE. 9 ) THEN
                  CLINE = CLINE + 1
                  NPCH = MIN( DIDNDOP(ISRC), 16 )
                  WRITE( LINE(CLINE)(22:132), '( 8( F9.2,:) )' )
     1               ( VLSR(ICHN,ISRC), ICHN=9,NPCH )
               END IF

            ELSE IF(  DOPPED(ISRC) ) THEN
               CLINE = CLINE + 1
               WRITE( LINE(CLINE)(22:132), '( A )' ) 
     1            'Doppler based on other sources.'
            END IF
C
C           Tell about proper motions.
C
            PMUSED = PMRA(ISRC) .NE. 0.D0 .OR.
     1               PMDEC(ISRC) .NE. 0.D0 .OR. 
     2               PARALAX(ISRC) .NE. 0.D0
            IF( PMUSED ) THEN
               TRAPM  = TFORM( RACAT(ISRC),    'T', 0, 2, 9, '   ' )
               TDECPM  = TFORM( DECCAT(ISRC),   ' ', 1, 2, 8, '   ' )
C
               CLINE = CLINE + 1
               WRITE( LINE(CLINE)(22:132), '( A, F10.5 )' )
     1             'Proper motion used.  Reference epoch: ', 
     2             EPOCHT(ISRC)
C
               CLINE = CLINE + 1
               WRITE( LINE(CLINE)(22:132), '( 4A )' )
     1             '   At epoch: RA = ', TRAPM, 
     2             '   Dec = ', TDECPM
C
               CLINE = CLINE + 1
               WRITE( LINE(CLINE)(22:132), '( A, F8.2, A, F8.2, A )' )
     1             '   Rates: RA = ', PMRA(ISRC) * 1000.0, 
     2             ' mas/yr   Dec = ', PMDEC(ISRC) * 1000.0, ' mas/yr'
C
               CLINE = CLINE + 1
               WRITE( LINE(CLINE)(22:132), '( A, F9.4, A )' )
     1             '   Paralax: ', PARALAX(ISRC) * 1000.0, ' mas.'
C
            END IF
C
C           Planetary motion used.
C
            IF( DRA(ISRC) .NE. 0.0 .OR.
     1          DDEC(ISRC) .NE. 0.0 ) THEN
               MSGTXT = ' '
               IF( PMUSED ) THEN
                  MSGTXT = 
     1               'Planetary motion (includes proper motion).'
               ELSE
                  MSGTXT = 'Planetary motion used.'
               END IF
C
               CLINE = CLINE + 1
               WRITE( LINE(CLINE)(22:132), '( 2A, F12.4 )' )
     1            MSGTXT(1:LEN1(MSGTXT)), '  Ref. MJD: ', 
     2            PMTIME(ISRC)
C
               CLINE = CLINE + 1
               WRITE( LINE(CLINE)(22:132), '( A, E12.5, 
     1                A, A, E12.5, A  )' )
     2            '   Rates: RA = ', DRA(ISRC), ' s/day ',
     3            '  Dec = ', DDEC(ISRC), ' arcsec/day '
            END IF
C
C           Write ephemeris file names if appropriate.
C
            IF( WHICHCAT(ISRC) .EQ. 'P' ) THEN
               CLINE = CLINE + 1
               WRITE( LINE(CLINE)(22:132), '( A, A )' )
     1               'EPHFILE: ', EPHFILE(1:LEN1(EPHFILE))
            END IF
            IF( WHICHCAT(ISRC) .EQ. 'S' ) THEN
               CLINE = CLINE + 1
               WRITE( LINE(CLINE)(22:132), '( A, A )' ) 'KERFILE: ',
     1                 KERFILE(SATN(ISRC))(1:LEN1(KERFILE(SATN(ISRC))))
               CLINE = CLINE + 1
               IF( SATFILE(SATN(ISRC))(1:4) .NE. 'NONE' ) THEN
                  WRITE( LINE(CLINE)(22:132), '( A, A )' ) 'SATFILE: ',
     1                 SATFILE(SATN(ISRC))(1:LEN1(SATFILE(SATN(ISRC))))
               END IF
               IF( TLEFILE(SATN(ISRC))(1:4) .NE. 'NONE' ) THEN
                  WRITE( LINE(CLINE)(22:132), '( A, A )' ) 'TLEFILE: ',
     1                 TLEFILE(SATN(ISRC))(1:LEN1(TLEFILE(SATN(ISRC))))
               END IF
           END IF
C
C           Tell if the source is a pointing center for a multi-field
C           processing.
C
            IF( NPAIR .GT. 0 ) THEN
               DO IPAIR = 1, NPAIR
                  IF( PAIRSRC(IPAIR) .EQ. ISRC ) THEN
                     CLINE = CLINE + 1
                     WRITE( LINE(CLINE)(22:132), '( A, A )' )
     1                 ' Pointing center for phase center group: ',
     2                 CTRNAME(PAIRCENT(IPAIR))
                  END IF
               END DO
C
C              Tell if the source is in a phase center group for a 
C              multi-field processing.
C
               DO IPAIR = 1, NPAIR
                  DO ICSRC = 1, NCSRC(PAIRCENT(IPAIR))
                     IF( CTRSRCI(ICSRC,PAIRCENT(IPAIR)) .EQ. 
     1                  ISRC ) THEN
                        CLINE = CLINE + 1
                        WRITE( LINE(CLINE)(22:132), '( A, A )' )
     1                    ' Member of phase center group: ',
     2                    CTRNAME(PAIRCENT(IPAIR))
                     END IF
                  END DO
               END DO
            END IF
C
C           Now write out the lines.
C
            MLINE = MAX( NMLINE, CLINE )
            DO IL = 1, MLINE
               WRITE( IOUT, '( A )' ) LINE(IL)(1:LEN1(LINE(IL)))
            END DO
            WRITE( IOUT, '(1X)' )
         END IF
      END DO
C
C     Now write the observing hours summary as a separate section.  
C
      WRITE( IOUT, '( 1X, /, 1X, /, A )' ) 
     1      'SOURCE SCAN SUMMARY FOR SOURCES LISTED ABOVE'


      WRITE( IOUT, '( 1X, /, A, /, A, A )' )
     1    '     Scan hours are for recording scans only. ',
     2    '     Baseline hours are only counted for scans above ',
     3    'horizon at both ends.'
      IF( FUZZY) WRITE( IOUT, '( A, A )' )
     1    '     ''Core'' scans are those for which PREEMPT is ',
     2    'not ''EXTRA''.'
      IF( DOSCANS(1) .NE. 0 ) WRITE( IOUT, '( A, A, /, A )' )
     1    '     The ''DOSCANS'' columns are for scans in the range ',
     2    'selected by DOSCANS',
     3    '     Those are the scans sent to the Vex and other files'
C
      LINE(1) = ' '
      LINE(2) = ' '
      LINE(1) = '  Source       Setup file             Frequency sets'
      LINE(2)(36:78) = '(duplicates not shown)'
C
      IF( FUZZY .AND. DOSCANS(1) .EQ. 0 ) THEN
         LINE(1)(71:101) = ' Core scans  (Hours)  All scans'
         LINE(2)(71:102) = 'Scan  Baseline    Scan  Baseline'
      ELSE IF( FUZZY .AND. DOSCANS(1) .NE. 0 ) THEN
         LINE(1)(71:101) = ' Core scans  (Hours) DOSCANS'
         LINE(2)(71:102) = 'Scan  Baseline    Scan  Baseline'
      ELSE IF( .NOT. FUZZY .AND. DOSCANS(1) .EQ. 0 ) THEN
         LINE(1)(71:86) = 'Observing hours'
         LINE(2)(71:86) = ' Scan  Baseline'
      ELSE IF( .NOT. FUZZY .AND. DOSCANS(1) .NE. 0 ) THEN
         LINE(1)(71:86) = ' DOSCANS hours'
         LINE(2)(71:86) = ' Scan  Baseline'
      ELSE
         CALL ERRLOG( 'SRCWRT: Programming error with FUZZY and '//
     1        'DOSCANS' )
      END IF
C
      WRITE( IOUT, '( A )' ) LINE(1)(1:LEN1(LINE(1)))
      WRITE( IOUT, '( A )' ) LINE(2)(1:LEN1(LINE(2)))
C
C     Get scan and baseline hours for source.  Planning schedules
C     can have TONSRC way past STARTJ so protect against that.
C     Break down by setup file.
C
      DO ISRC = 1, MSRC
         IF( ( IP .EQ. 1 .AND. USEDREC(ISRC) ) .OR.
     1       ( IP .EQ. 2 .AND. SUSED(ISRC) .AND. .NOT. USEDREC(ISRC) )
     2       .OR. ( IP .EQ. 3 .AND. .NOT. SUSED(ISRC) .AND. 
     3        USEDPHS(ISRC) ) ) THEN
C
            DO IL = 1, ML
               LINE(IL) = ' '
            END DO
C
C           Write the name.  There should only be one.
C
            MLINE = 0
            DO INAME = 1, MALIAS
               IF( CSUSED(INAME,ISRC) .EQ. '*' ) THEN
                  PRSRC = SOURCE(INAME,ISRC)
               END IF
            END DO
C
            CLINE = 0
            DO ISET = 1, NSETF
               CALL SBHOURS( ISRC, TSCAN, TBASE, ESCAN, EBASE, 
     1                       ISET, KFSETS )
               IF( ESCAN .GT. 0.D0 ) THEN
C
C                 Characters for setup - get end of file path.
C
                  NCHSET = LEN1(SETFILE(ISET))
                  CH1SET = MAX( NCHSET-20, 1 )
C
C                 Number of characters of list of frequency sets.
C                 This will end up being incomplete in some extreme cases.
C                 Put a + on the end when it is.
C
                  NFC = LEN1( KFSETS )
                  PFSETS = KFSETS
                  IF( NFC .GE. 29 ) THEN
                     PFSETS(29:30) = ' +'
                     NFC = 30
                  END IF
C
                  IF( FUZZY ) then
                     WRITE( IOUT, '( 2X, A, T14 , A, T35, A, T67, '//
     1                 '2( F8.3, F10.3) )' )
     2                 PRSRC, SETFILE(ISET)(CH1SET:NCHSET), 
     3                 PFSETS(1:NFC),
     4                 TSCAN * 24.D0, TBASE * 24.D0, 
     5                 ESCAN * 24.D0, EBASE * 24.D0
                  ELSE
                     WRITE( IOUT, '( 2X, A, T14 , A, T35, A, T67, '//
     1                 '2( F8.3, F10.3) )' )
     2                 PRSRC, SETFILE(ISET)(CH1SET:NCHSET), 
     3                 PFSETS(1:NFC),
     4                 ESCAN * 24.D0, EBASE * 24.D0
                  END IF
                  PRSRC = '  '
C
               END IF
            END DO
         END IF
      END DO
C
      RETURN
      END

      REAL FUNCTION RAN5(IDUM)
      INTEGER IDUM
C
C     I have this in my personal subroutine library.  It was last
C     modified in 2001, perhaps when I changed machines.  I'm not 
C     sure where I picked it up, or if I typed it in.
C     R.C.Walker  May 20, 2010.
C
C     I presume it gives a number between 0 and 1, evenly distributed.
C 
C-
C Park and Miller's "Minimal Standard" random number generator (Comm.
C ACM, 31, 1192, 1988) with Bays-Durham shuffle. Call with IDUM negative
C to initialize. Be sure to preserve IDUM between calls.
C Reference: Press and Farrar, Computers in Physics, Vol.4, No. 2, 
C p.190, 1990.
C-
      INTEGER IA, IM, IQ, IR, NTAB
      REAL    AM, ATAB
      PARAMETER (IA=16807, IM=2147483647, AM=1.0/IM)
      PARAMETER (IQ=127773, IR=2836, NTAB=32, ATAB=NTAB-1)
C-
      INTEGER J, K
      REAL V(NTAB), Y
      SAVE V, Y
      DATA V/NTAB*0.0/, Y/0.5/
C-
      IF (IDUM.LE.0) THEN
          IDUM = MAX(-IDUM,1)
          DO 12 J=NTAB,1,-1
              K = IDUM/IQ
              IDUM = IA*(IDUM-K*IQ) - IR*K
              IF (IDUM.LT.0) IDUM = IDUM+IM
              V(J) = AM*IDUM
   12     CONTINUE
          Y = V(1)
      END IF
    1 CONTINUE
          K = IDUM/IQ
          IDUM = IA*(IDUM-K*IQ) - IR*K
          IF (IDUM.LT.0) IDUM = IDUM+IM
          J = 1 + INT(ATAB*Y)
          Y = V(J)
          RAN5 = Y
          V(J) = AM*IDUM
      IF (RAN5.EQ.0.0 .OR. RAN5.EQ.1.0) GOTO 1
      RETURN
      END

      INTEGER FUNCTION VXGTST( IMODE )
C
C     Routine specific for the VEX extension of SCHED. 
C     function returns the SCHED setup corresponding to the given VEX mode
C     By C. Reynolds, JIVE, 050802
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER ISET, ISTA, IMODE
C ----------------------------------------------------------------------
C     
C     Find a station that uses this setup and get the sched setup from MODSET 
C
      ISET = 0
      DO ISTA = 1, NSTA
         IF( MODSET(ISTA,IMODE) .NE. 0 ) THEN  
           ISET = MODSET(ISTA,IMODE)
         END IF
      END DO
      VXGTST = ISET
      RETURN
      END

      SUBROUTINE PRTSET( KS, IUNIT )
C
C     Routine for SCHED that prints a summary of the information in
C     a setup group.  The calling routine should determine which 
C     groups to print.  Called by SCHSUM, ERRSET, CHKSC1, 
C     and STAFILES.  The output unit will vary by calling routine.
C
C     KS is the setup group to print.  IUNIT is the output unit for 
C     the print.  It is the sum file for SCHSUM, the 
C
C     Since this will be the first use of the .sum file, open it here.
C
C     This routine is called by ERRSET, so be sure that neither it,
C     nor anything it calls, also calls ERRSET!  Guess how I found
C     that possibility.

      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'schfreq.inc'
C
      INTEGER           LEN1, KS, KF, IP, ICH, JCH 
      INTEGER           IUNIT, ISTA
      CHARACTER         FMT*80
      LOGICAL           GOTFRQ, NEWFRQ, SIDEINV
C ---------------------------------------------------------------------
      ISTA = ISCHSTA(ISETSTA(KS))
      IF( DEBUG ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I5, I5 )' ) 
     1      'PRTSET: Starting - setup, unit: ', KS, IUNIT
         CALL WLOG( 0, MSGTXT )
      END IF
C
C     Write the setup file name.
C
      WRITE( IUNIT, '( 1X, /, 1X, /, 2A )' )
     1       ' ======== Setup file: ', SETNAME(KS)(1:LEN1(SETNAME(KS))) 
C
C     Give matching entry in frequency catalog.  Can be more than
C     one entry since differents channels can use different ones
C     in some special cases.
C
      GOTFRQ = .FALSE.
      DO ICH = 1, NCHAN(KS)
         GOTFRQ = GOTFRQ .OR. IFREQNUM(ICH,KS) .GE. 1
      END DO
      IF( GOTFRQ ) THEN
         WRITE( IUNIT, '( A, A, A )' )
     1     '   Matching groups in ',  FREQFILE(1:LEN1(FREQFILE)), ':'
         DO ICH = 1, NCHAN(KS)
            KF = IFREQNUM(ICH,KS)
            NEWFRQ = .TRUE.
            IF( ICH .GE. 2 ) THEN
               DO JCH = 1, ICH - 1
                  IF( KF .EQ. IFREQNUM(JCH,KS) ) NEWFRQ = .FALSE.
               END DO
            END IF
            MSGTXT = ' '
            IF( NEWFRQ ) THEN
               WRITE( MSGTXT(1:18), '( 5X, A )' )
     1            FRNAME(KF)(1:LEN1(FRNAME(KF)))
               IF( FRNOTE(KF) .NE. ' ' ) THEN
                  WRITE( MSGTXT(22:256), '( A )' ) 
     1                FRNOTE(KF)(1:LEN1(FRNOTE(KF)))
               END IF
               WRITE( IUNIT, '( A )' ) MSGTXT(1:LEN1(MSGTXT))
            END IF
         END DO
C
C        Warn if incomplete overlap.
C
         IF( BESTOVER(KS) .LT. TOTBW(KS) ) THEN
            SETMSG = ' '
            WRITE( IUNIT, '( A, F7.2, A, F7.2, A )' )
     1         '    ****** Only ', BESTOVER(KS), ' of ', TOTBW(KS), 
     2         ' MHz total bandwidth is within the IFs'
            WRITE( IUNIT, '( A, A )' ) 
     1         '           in the setup file before any FREQ or ',
     2         'DOPPLER shifts.' 
         END IF
C
C     Warn if there was no matching frequency catalog entry.
C
      ELSE
         WRITE( IUNIT, '( A )' )
     1     ' --- WARNING ---  This group does not match an entry'
     2     // ' in the frequency catalog.'
         WRITE( IUNIT, '( A )' )
     1     '                  This might be ok because the catalog'
     2     // ' is not complete.'
         WRITE( IUNIT, '( A )' )
     1     '                  But be very careful to be sure that'
     2     // ' the setup is correct.'
      END IF
C
C     Write the rest only if it was used in the experiment.
C
      IF( .NOT. VLAONLY ) THEN
C
C        Group number and station and some other items.
C
         WRITE( IUNIT, '( 1X, /, A, I4, 2A, A, I5, /,  ' //
     1       ' 3A, I1, A, F7.3 )' ) 
     2       '   Setup group: ', KS, 
     3       '         Station: ', SETSTA(1,KS),
     4       '          Total bit rate: ', NINT( TOTBPS(KS) ),
     5       '   Format: ', FORMAT(KS),
     6       '          Bits per sample: ', BITS(1,KS),
     7       '         Sample rate:', SAMPRATE(KS)
C
C        Various items, especilly related to tapes.
C
         IF( NOTAPE .OR. .NOT. RECUSED(KS) ) THEN
            WRITE( IUNIT, '( A, I3, A, A )' )
     1           '   Number of channels:', NCHAN(KS),
     2           '    DBE type: ', DBE(KS)
         ELSE
            WRITE( IUNIT, '( A, I3, A, A, T54, A, F6.2 )' )
     1           '   Number of channels:', NCHAN(KS),   
     2           '    DBE type: ', DBE(KS),
     3           '   Speedup factor: ', SPEEDUP(KS)
         END IF
C
         IF( .NOT. NOTAPE ) THEN
C
C           For tape, give the tape speeds and time per pass.
C           For disk, just note that disk is being used.
C           With one station per setup, this is now much simpler.
C           and old subroutine PRTTPP has been relegated to the
C           archive.
C
            IF( FORMAT(KS) .NE. 'NONE' .AND. ISTA .NE. 0 ) THEN
               IF( USEDISK(ISTA) ) THEN
                  WRITE( IUNIT, '( 1X, /, A, F7.3, A, F6.2, A )' )
     1               '   Disk used to record data.'
               END IF
            END IF
C
C           Say something about setups used for other than recording.
C
            IF( .NOT. RECUSED(KS) ) THEN
               WRITE( IUNIT, '( 1X, /, A )' )
     1           '   Setup not used for recording data.'
            END IF
C
         END IF
C
C        Warning about sideband inversion.
C
         SIDEINV = .FALSE.
         DO ICH = 1, NCHAN(KS)
            IF( CORINV(ICH,KS) .NE. 0.D0 ) SIDEINV = .TRUE.
         END DO
         IF( SIDEINV ) THEN
            WRITE( IUNIT, '( 1X, /, A, A )' )
     1         '   Frequencies shifted and sidebands ',
     2         'inverted because RDBE_PFB can only'
            WRITE( IUNIT, '( A, A )' )
     1         '   do LSB.  Use a correlator, ',
     2         'such as DiFX, that can invert sidebands.'
         END IF
C
C        Frequency info.
C
         CALL PRTFREQ( KS, IUNIT )
C
C        Track info.
C
         IF( .NOT. NOTAPE .AND. RECUSED(KS) ) THEN
            WRITE( IUNIT, '( 1X, /, A )' ) '   Track assignments are: '
            FMT = ' '
            IF( NCHAN(KS) .EQ. 1 ) THEN
               FMT =   '( A, I1, A, I3 )'
            ELSE
               WRITE( FMT, '( A, I3, A )' )  '( A, I1, A, I3, ',
     1              NCHAN(KS) - 1, '('','', I3 ) )' 
            END IF
            DO IP = 1, TAPEMODE(KS)
               WRITE( IUNIT, FMT ) '    track', IP, '= ', 
     1              ( TRACK(ICH,IP,KS), ICH = 1, NCHAN(KS) )
            END DO
            WRITE( IUNIT, '( A, A )' ) '    barrel=', BARREL(KS)
         END IF
C
      END IF
C
      IF( DEBUG ) CALL WLOG( 0, 'PRTSET: Done with setup.' )
C
      RETURN
      END

      REAL FUNCTION sla_RVLSRK (R2000, D2000)
*+
*     - - - - - - -
*      R V L S R K
*     - - - - - - -
*
*  Velocity component in a given direction due to the Sun's motion
*  with respect to an adopted kinematic Local Standard of Rest.
*
*  (single precision)
*
*  Given:
*     R2000,D2000   r    J2000.0 mean RA,Dec (radians)
*
*  Result:
*     Component of "standard" solar motion in direction R2000,D2000 (km/s)
*
*  Sign convention:
*     The result is +ve when the Sun is receding from the given point on
*     the sky.
*
*  Note:  The Local Standard of Rest used here is one of several
*         "kinematical" LSRs in common use.  A kinematical LSR is the
*         mean standard of rest of specified star catalogues or stellar
*         populations.  The Sun's motion with respect to a kinematical
*         LSR is known as the "standard" solar motion.
*
*         There is another sort of LSR, the "dynamical" LSR, which is a
*         point in the vicinity of the Sun which is in a circular orbit
*         around the Galactic centre.  The Sun's motion with respect to
*         the dynamical LSR is called the "peculiar" solar motion.  To
*         obtain a radial velocity correction with respect to the
*         dynamical LSR use the routine sla_RVLSRD.
*
*  Reference:  Delhaye (1965), in "Stars and Stellar Systems", vol 5,
*              p73.
*
*  Called:
*     sla_CS2C, sla_VDV
*
*  P.T.Wallace   Starlink   11 March 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      REAL R2000,D2000

      REAL VA(3), VB(3)

      REAL sla_VDV

*
*  Standard solar motion (from Methods of Experimental Physics, ed Meeks,
*  vol 12, part C, sec 6.1.5.2, p281):
*
*  20 km/s towards RA 18h Dec +30d (1900).
*
*  The solar motion is expressed here in the form of a J2000.0
*  equatorial Cartesian vector:
*
*      VA(1) = X = -SPEED*COS(RA)*COS(DEC)
*      VA(2) = Y = -SPEED*SIN(RA)*COS(DEC)
*      VA(3) = Z = -SPEED*SIN(DEC)

      DATA VA / -0.29000, +17.31726, -10.00141 /



*  Convert given J2000 RA,Dec to x,y,z
      CALL sla_CS2C(R2000,D2000,VB)

*  Compute dot product with solar motion vector
      sla_RVLSRK=sla_VDV(VA,VB)

      END

      SUBROUTINE TIMEJ( JTIME, YEAR, DAY, TIME )
Cf2py intent(in) JTIME
Cf2py intent(out) TIME
Cf2py intent(out) YEAR
Cf2py intent(out) DAY
C
C     Routine for SCHED that takes the Modified Julian Date and returns
C     the year, day of year, and time of day.  JTIME is in fractional
C     days.  TIME is in radians.
C
      DOUBLE PRECISION   JTIME, TIME, RADDAY, FD
      PARAMETER          (RADDAY = 2.D0 * 3.141592653589793238D0)
      INTEGER            YEAR, DAY, JM, JD, NY, J
      CHARACTER*60       MSGTXT
      CHARACTER*10       TFORM, CTIME
C --------------------------------------------------------------------
      CALL SLA_DJCL( JTIME, YEAR, JM, JD, FD, J )
      IF( J.NE.0 )  CALL ERRLOG( ' Time out of range for SLA_DJCL' )
      TIME = FD * RADDAY
      CALL SLA_CALYD( YEAR, JM, JD, NY, DAY, J )
      IF( J.NE.0 ) THEN
         CTIME = TFORM( TIME, 'T', 0, 2, 2, '::@' )
         WRITE( MSGTXT, '( A, A, 3I4, A )' ) ' Bad time in TIMEJ -',
     1       ' y,m,d,h: ', YEAR, JM, JD, CTIME
         CALL ERRLOG( MSGTXT )
      END IF
C
      RETURN
      END

      SUBROUTINE CHKVDAR( KS, SNBBC, ERRS )
Cf2py intent(in, out) ERRS
C
C     Routine for SCHED called by CHKSET that checks items related
C     to the VLBA DAR's.  It will only be called if the DAR is
C     of the VLBA type.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER           KS, ICH, I, SNBBC
      LOGICAL           ERRS, BADLO, DEQUAL
      DOUBLE PRECISION  TSTFRQ
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKVDAR: Starting.')
C
C     IFDIST must be 0, 20, A, 20A, or A20.  
C
      DO I = 1, 4
         IF( IFDIST(I,KS) .NE. '0' .AND. IFDIST(I,KS) .NE. '20' .AND.
     1       IFDIST(I,KS) .NE. 'A' .AND. IFDIST(I,KS) .NE. '20A' 
     2       .AND. IFDIST(I,KS) .NE. 'A20' ) THEN
            MSGTXT = 'CHKVDAR: Invalid IFDIST '//IFDIST(I,KS)// 
     1             ' specified '
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
      END DO
C
C     Check items that depend on observation type.
C
      IF( VLBITP .AND. FORMAT(KS) .NE. 'NONE' ) THEN 
         IF( SAMPRATE(KS) .NE. 0.25 .AND. SAMPRATE(KS) .NE. 0.5 .AND. 
     1       SAMPRATE(KS) .NE. 1.0  .AND. SAMPRATE(KS) .NE. 2.0 .AND. 
     2       SAMPRATE(KS) .NE. 4.0  .AND. SAMPRATE(KS) .NE. 8.0 .AND.  
     3       SAMPRATE(KS) .NE. 16.  .AND. SAMPRATE(KS) .NE. 32. ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, F8.3 )' )
     1           'CHKVDAR: Invalid SAMPRATE specified: ', SAMPRATE(KS)
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
         IF( BITS(1,KS) .NE. 1 .AND. BITS(1,KS) .NE. 2 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5 )' ) 'CHKVDAR: BITS must be 1 or 2'
     1           // ' - Requested: ', BITS(1,KS)
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
      END IF
C
C     Check channel parameters.
C
      DO ICH = 1, NCHAN(KS)
C
C        IF channel assignment.
C
         IF( IFCHAN(ICH,KS) .NE. 'A' .AND. 
     1       IFCHAN(ICH,KS) .NE. 'B' .AND.
     2       IFCHAN(ICH,KS) .NE. 'C' .AND. 
     3       IFCHAN(ICH,KS) .NE. 'D' ) THEN
            CALL WLOG( 1, 'CHKVDAR: IFCHAN ''' // IFCHAN(ICH,KS) //
     1          ''' not A,B,C, or D' )
            ERRS = .TRUE.
         END IF
C
C        BBC assignment.
C
         IF( BBC(ICH,KS) .LT. 1 ) THEN
            CALL WLOG( 1, 'CHDVDAR: BBC number less than 1! ')
            ERRS = .TRUE.
         END IF
         IF( BBC(ICH,KS) .GT. SNBBC ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I3, A, I3, 2A )' )
     1         'CHKVDAR: Channel', ICH, ' uses a BBC (', BBC(ICH,KS),
     2         ') that does not exist at some station.'
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
C        BBC synthesizer setting.  Getting a good double precision
C        is a bit tricky.  Round at a level below what we are testing.
C        Later SCHED modified so BBSYN is double to start with
C
C            TSTFRQ = DNINT ( DBLE( BBSYN(ICH,KS) ) * 1.D4 ) / 1.D4
         TSTFRQ = BBSYN(ICH,KS)
         IF( BADLO( 'BBSYN', TSTFRQ, 0.01D0, 0, 0.D0, 0.D0,
     1       500.D0, 1000.D0, MSGTXT ) ) THEN
            ERRS = .TRUE.
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, F9.2, 2A )' )
     1         '        FIRSTLO and first sideband are:', 
     2         FIRSTLO(ICH,KS), '  ', SIDE1(ICH,KS)
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
C        BBC filter bandwidth.
C
         IF( .NOT. (
     1         DEQUAL( BBFILT(ICH,KS), 0.0625D0 ) .OR. 
     2         DEQUAL( BBFILT(ICH,KS), 0.125D0 ) .OR. 
     3         DEQUAL( BBFILT(ICH,KS), 0.25D0 ) .OR. 
     4         DEQUAL( BBFILT(ICH,KS), 0.5D0 ) .OR. 
     5         DEQUAL( BBFILT(ICH,KS), 1.0D0 ) .OR. 
     6         DEQUAL( BBFILT(ICH,KS), 2.0D0 ) .OR. 
     7         DEQUAL( BBFILT(ICH,KS), 4.0D0 ) .OR. 
     8         DEQUAL( BBFILT(ICH,KS), 8.0D0 ) .OR. 
     9         DEQUAL( BBFILT(ICH,KS), 16.D0 ) ) ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, 2F9.3 )' )
     1         'CHDVDAR: Invalid BBFILTER specified: ', BBFILT(ICH,KS)
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
C        Check the frequency request if there is frequency switching.
C        Modified when BBSYN2 made double in the include file.
C
         IF( FRSWITCH(KS) ) THEN
C            TSTFRQ = DNINT ( DBLE( BBSYN2(ICH,KS) ) * 1.D4 ) / 1.D4
            TSTFRQ = BBSYN2(ICH,KS)
            IF( BADLO( 'BBSYN2', TSTFRQ, 0.01D0, 0, 0.D0, 0.D0,
     1          500.D0, 1000.D0, MSGTXT ) ) THEN
               ERRS = .TRUE.
            END IF
         END IF
C
      END DO
C
      RETURN
      END

C*PROGNM -- return file name of current program [Convex-UNIX]
C+
      SUBROUTINE PROGNM (PROG)
      CHARACTER*(*) PROG
C
C Return the file name of the currently executing program, minus
C any directories.
C
C Argument:
C  PROG   (output) : receives the file name.
C
C Subroutines required:
C  GETARG (Convex)
C
C History:
C  1990 Jan  9 - TJP.
C-----------------------------------------------------------------------
      CHARACTER*255 T
      INTEGER I,J
C
      CALL GETARG(0, T)
      I = 1
   10 J = INDEX(T(I:),'/')
      IF (J.EQ.0) THEN
          PROG = T(I:)
      ELSE
          I = I+J
          GOTO 10
      END IF
C
      END

C++++++++++++++++++++++++++++++++
C
      SUBROUTINE STATE(ET2,LIST,PV,PNUT)
C
C++++++++++++++++++++++++++++++++
C
C THIS SUBROUTINE READS AND INTERPOLATES THE JPL PLANETARY EPHEMERIS FILE
C
C     CALLING SEQUENCE PARAMETERS:
C
C     INPUT:
C
C         ET2   DP 2-WORD JULIAN EPHEMERIS EPOCH AT WHICH INTERPOLATION
C               IS WANTED.  ANY COMBINATION OF ET2(1)+ET2(2) WHICH FALLS
C               WITHIN THE TIME SPAN ON THE FILE IS A PERMISSIBLE EPOCH.
C
C                A. FOR EASE IN PROGRAMMING, THE USER MAY PUT THE
C                   ENTIRE EPOCH IN ET2(1) AND SET ET2(2)=0.
C
C                B. FOR MAXIMUM INTERPOLATION ACCURACY, SET ET2(1) =
C                   THE MOST RECENT MIDNIGHT AT OR BEFORE INTERPOLATION
C                   EPOCH AND SET ET2(2) = FRACTIONAL PART OF A DAY
C                   ELAPSED BETWEEN ET2(1) AND EPOCH.
C
C                C. AS AN ALTERNATIVE, IT MAY PROVE CONVENIENT TO SET
C                   ET2(1) = SOME FIXED EPOCH, SUCH AS START OF INTEGRATION,
C                   AND ET2(2) = ELAPSED INTERVAL BETWEEN THEN AND EPOCH.
C
C        LIST   12-WORD INTEGER ARRAY SPECIFYING WHAT INTERPOLATION
C               IS WANTED FOR EACH OF THE BODIES ON THE FILE.
C
C                         LIST(I)=0, NO INTERPOLATION FOR BODY I
C                                =1, POSITION ONLY
C                                =2, POSITION AND VELOCITY
C
C               THE DESIGNATION OF THE ASTRONOMICAL BODIES BY I IS:
C
C                         I = 1: MERCURY
C                           = 2: VENUS
C                           = 3: EARTH-MOON BARYCENTER
C                           = 4: MARS
C                           = 5: JUPITER
C                           = 6: SATURN
C                           = 7: URANUS
C                           = 8: NEPTUNE
C                           = 9: PLUTO
C                           =10: GEOCENTRIC MOON
C                           =11: NUTATIONS IN LONGITUDE AND OBLIQUITY
C                           =12: LUNAR LIBRATIONS (IF ON FILE)
C
C
C     OUTPUT:
C
C          PV   DP 6 X 11 ARRAY THAT WILL CONTAIN REQUESTED INTERPOLATED
C               QUANTITIES.  THE BODY SPECIFIED BY LIST(I) WILL HAVE ITS
C               STATE IN THE ARRAY STARTING AT PV(1,I).  (ON ANY GIVEN
C               CALL, ONLY THOSE WORDS IN 'PV' WHICH ARE AFFECTED BY THE
C               FIRST 10 'LIST' ENTRIES (AND BY LIST(12) IF LIBRATIONS ARE
C               ON THE FILE) ARE SET.  THE REST OF THE 'PV' ARRAY
C               IS UNTOUCHED.)  THE ORDER OF COMPONENTS STARTING IN
C               PV(1,I) IS: X,Y,Z,DX,DY,DZ.
C
C               ALL OUTPUT VECTORS ARE REFERENCED TO THE EARTH MEAN
C               EQUATOR AND EQUINOX OF J2000 IF THE DE NUMBER IS 200 OR
C               GREATER; OF B1950 IF THE DE NUMBER IS LESS THAN 200. 
C
C               THE MOON STATE IS ALWAYS GEOCENTRIC; THE OTHER NINE STATES 
C               ARE EITHER HELIOCENTRIC OR SOLAR-SYSTEM BARYCENTRIC, 
C               DEPENDING ON THE SETTING OF COMMON FLAGS (SEE BELOW).
C
C               LUNAR LIBRATIONS, IF ON FILE, ARE PUT INTO PV(K,11) IF
C               LIST(12) IS 1 OR 2.
C
C         NUT   DP 4-WORD ARRAY THAT WILL CONTAIN NUTATIONS AND RATES,
C               DEPENDING ON THE SETTING OF LIST(11).  THE ORDER OF
C               QUANTITIES IN NUT IS:
C
C                        D PSI  (NUTATION IN LONGITUDE)
C                        D EPSILON (NUTATION IN OBLIQUITY)
C                        D PSI DOT
C                        D EPSILON DOT
C
C           *   STATEMENT # FOR ERROR RETURN, IN CASE OF EPOCH OUT OF
C               RANGE OR I/O ERRORS.
C
C
C     COMMON AREA STCOMX:
C
C          KM   LOGICAL FLAG DEFINING PHYSICAL UNITS OF THE OUTPUT
C               STATES. KM = .TRUE., KM AND KM/SEC
C                          = .FALSE., AU AND AU/DAY
C               DEFAULT VALUE = .FALSE.  (KM DETERMINES TIME UNIT
C               FOR NUTATIONS AND LIBRATIONS.  ANGLE UNIT IS ALWAYS RADIANS.)
C
C        BARY   LOGICAL FLAG DEFINING OUTPUT CENTER.
C               ONLY THE 9 PLANETS ARE AFFECTED.
C                        BARY = .TRUE. =\ CENTER IS SOLAR-SYSTEM BARYCENTER
C                             = .FALSE. =\ CENTER IS SUN
C               DEFAULT VALUE = .FALSE.
C
C       PVSUN   DP 6-WORD ARRAY CONTAINING THE BARYCENTRIC POSITION AND
C               VELOCITY OF THE SUN.
C
C
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      SAVE

      DOUBLE PRECISION ET2(2),PV(6,12),PNUT(4),T(2),PJD(4),BUF(1500),
     *                 SS(3),CVAL(400),PVSUN(3,2)

      INTEGER LIST(12),IPT(3,13)

      DOUBLE PRECISION AU, EMRAT, S, AUFAC
      INTEGER NUMDE, NCON, NRECL, KSIZE, NRFILE, IRECSZ, J, I, NRL,
     *        NR, K, NCOEFS, IND

      LOGICAL FIRST

      CHARACTER*6 TTL(14,3),CNAM(400)
      CHARACTER*80 NAMFIL
      COMMON/FNAME/NAMFIL

      LOGICAL KM,BARY

      COMMON/EPHHDR/CVAL,SS,AU,EMRAT,NUMDE,NCON,IPT
      COMMON/CHRHDR/CNAM,TTL
      COMMON/STCOMX/KM,BARY,PVSUN

      DATA FIRST/.TRUE./
C redundant with blanked SAVE  RCW      SAVE FIRST
C
C       ENTRY POINT - 1ST TIME IN, GET POINTER DATA, ETC., FROM EPH FILE
C
      IF(FIRST) THEN
        FIRST=.FALSE.
        CALL FSIZER2(NRECL,KSIZE,NRFILE)

        IF(NRECL .EQ. 0) WRITE(*,*)'  ***** FSIZER IS NOT WORKING *****'

        IRECSZ=NRECL*KSIZE
        NCOEFS=KSIZE/2

        OPEN(NRFILE,
     *       FILE=NAMFIL,
     *       ACCESS='DIRECT',
     *       FORM='UNFORMATTED',
     *       RECL=IRECSZ,
     *       STATUS='OLD')

        READ(NRFILE,REC=1)TTL,CNAM,SS,NCON,AU,EMRAT,
     .   ((IPT(I,J),I=1,3),J=1,12),NUMDE,(IPT(I,13),I=1,3)

        READ(NRFILE,REC=2)CVAL

        NRL=0

      ENDIF


C       ********** MAIN ENTRY POINT **********


      IF(ET2(1) .EQ. 0.D0) RETURN

      S=ET2(1)-.5D0
      CALL SPLIT(S,PJD(1))
      CALL SPLIT(ET2(2),PJD(3))
      PJD(1)=PJD(1)+PJD(3)+.5D0
      PJD(2)=PJD(2)+PJD(4)
      CALL SPLIT(PJD(2),PJD(3))
      PJD(1)=PJD(1)+PJD(3)

C       ERROR RETURN FOR EPOCH OUT OF RANGE

      IF(PJD(1)+PJD(4).LT.SS(1) .OR. PJD(1)+PJD(4).GT.SS(2)) GO TO 98

C       CALCULATE RECORD # AND RELATIVE TIME IN INTERVAL

      NR=IDINT((PJD(1)-SS(1))/SS(3))+3
      IF(PJD(1).EQ.SS(2)) NR=NR-1
      T(1)=((PJD(1)-(DBLE(NR-3)*SS(3)+SS(1)))+PJD(4))/SS(3)

C       READ CORRECT RECORD IF NOT IN CORE

      IF(NR.NE.NRL) THEN
        NRL=NR
        READ(NRFILE,REC=NR,ERR=99)(BUF(K),K=1,NCOEFS)
      ENDIF

      IF(KM) THEN
      T(2)=SS(3)*86400.D0
      AUFAC=1.D0
      ELSE
      T(2)=SS(3)
      AUFAC=1.D0/AU
      ENDIF

C   INTERPOLATE SSBARY SUN

      CALL INTERP(BUF(IPT(1,11)),T,IPT(2,11),3,IPT(3,11),2,PVSUN)

      DO I = 1, 3
         DO J = 1, 2
            PVSUN(I,J) = PVSUN(I,J) * AUFAC
         END DO
      END DO

C   CHECK AND INTERPOLATE WHICHEVER BODIES ARE REQUESTED

      DO 4 I=1,10
      IF(LIST(I).EQ.0) GO TO 4

      CALL INTERP(BUF(IPT(1,I)),T,IPT(2,I),3,IPT(3,I),
     & LIST(I),PV(1,I))

      DO K = 1, 2
         DO J = 1, 3
            IND = J + (K - 1) * 3
            IF (I .LE. 9 .AND. .NOT. BARY) THEN
               PV(IND,I)=PV(IND,I)*AUFAC-PVSUN(J,K)
            ELSE
               PV(IND,I)=PV(IND,I)*AUFAC
            END IF
         END DO
      END DO

   4  CONTINUE

C       DO NUTATIONS IF REQUESTED (AND IF ON FILE)

      IF(LIST(11).GT.0 .AND. IPT(2,12).GT.0)
     * CALL INTERP(BUF(IPT(1,12)),T,IPT(2,12),2,IPT(3,12),
     * LIST(11),PNUT)

C       GET LIBRATIONS IF REQUESTED (AND IF ON FILE)

      IF(LIST(12).GT.0 .AND. IPT(2,13).GT.0)
     * CALL INTERP(BUF(IPT(1,13)),T,IPT(2,13),3,IPT(3,13),
     * LIST(12),PV(1,11))

      RETURN

  98  WRITE(*,198)ET2(1)+ET2(2),SS(1),SS(2)
 198  format(' ***  Requested JED,',f12.2,
     * ' not within ephemeris limits,',2f12.2,'  ***')

      stop

   99 WRITE(*,'(2F12.2,A80)')ET2,'ERROR RETURN IN STATE'

      STOP

      END

      SUBROUTINE PCALFQ( PCOPT, KF, PCX1, PCX2, PCFR1, PCFR2 )
C
C     Routine to set the pcal tone commands for frequency set KF.
C     Called by RECONFIG
C     and WRTFREQ, perhaps others.  These pcal commands control
C     the detectors in the legacy system on the VLBA.  They appear
C     only in the crd files.  They may differ from what is in the 
C     Vex file.
C
C     If PCOPT = "SET", get the setup file values for setup group KS=KF.
C     This option is not yet used.  PCOPT is usually the pcal state
C     (1MHZ, 5MHZ, or OFF) which is what is was meant to be in the past.
C     But the pcal state is now an item in the frequency set and is
C     obtained there.
C
C     PCX1 and PCX1 are the detector/bit to use (eg. S2, M4 etc).
C     PCFR1 and PCFR2 are the tone frequency to use in kHz. 
C
C     This routine takes into account any FREQ and BW set in the scan
C     It also takes into account and CRD parameters that are meant
C     to only affect the VLBA crd files.
C
C     Aug. 2013.  Modifying the way we deal with PCALX.  This is
C     triggered by addition of infrastructure to allow the VLBA
C     legacy system BBCs to be set to different frequencies than
C     the main recording channels, mainly to allow reference pointing
C     on masers while using the RDBE_PFB which cannot do narrow 
C     bands or be finely tuned.  In the process, there will no longer
C     be pulse cal sets - they are merged with frequency sets.
C
C     The pcalx information for the tone detectors in the legacy 
C     system can be provided by the user in the setup.  But that 
C     information is likely to become inappropriate if any of the
C     scan parameters FREQ, BW, DOPPLER, CRDDOP, CRDFREQ, CRDBW, or
C     PCAL are given.  Any changes in these parameters triggers
C     a new (or previously used) frequency set.
C
C     In the new scheme, the pcalx assignments will be made on the
C     fly by this routine when they are needed for crd files, the .sum
C     file etc.  There is an assumption, enforced by the nature
C     of the code, that the pcx setup will be unique to a frequency
C     set.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER           KF, KS
      INTEGER           ICH, ID, IP, ICT, IDD
      INTEGER           NTONES(MCHAN)
      INTEGER           TONE1(MCHAN), TONE2(MCHAN), TONE3(MCHAN)
      INTEGER           INTBW, NTPB
      INTEGER           PCFR1(MAXPC), PCFR2(MAXPC)
      INTEGER           KSTA, KSCN, ISTA, CRSETC(MAXCHN)
      DOUBLE PRECISION  RTONE1
      DOUBLE PRECISION  BBCFREQ(MCHAN), BBCBW(MCHAN)
      DOUBLE PRECISION  TONEINT, LOSUM(MCHAN)
      CHARACTER         PCX1(MAXPC)*3, PCX2(MAXPC)*3
      CHARACTER         PCALC1*3, UPCAL*4, PCOPT*4
      INTEGER           CRDN, ICHS
      DOUBLE PRECISION  CRDF(MCHAN), CRDB(MCHAN), CRDLOSUM(MCHAN)
      CHARACTER         CRDS(MCHAN)*1, CNETSIDE*1
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'PCALFQ starting ' )
C
C     Allow a call that uses the setup file values rather than any
C     that might have been provided in the scan dependent variables
C     FREQ, BW, and DOPPLER, or the CRD equivalents.  Here we assume
C     that KF is the desired setup group.
C     Note added later:  Not used - not sure why this was provided.
C
      IF( PCOPT .EQ. 'SET' ) THEN
         KS = KF
         UPCAL = SPCAL(KS)
         CRDN = NCHAN(KS)
         DO ICH = 1, NCHAN(KS)
            LOSUM(ICH) = FREQREF(ICH,KS)
            BBCBW(ICH) = BBFILT(ICH,KS)
            CRDF(ICH) = LOSUM(ICH)
            CRDB(ICH) = BBCBW(ICH)
            CRDS(ICH) = SIDEBD(ICH,KS)
            CRDLOSUM(ICH) = LOSUM(ICH)
         END DO
      ELSE
C
C        Get information from the frequency set.
C        This includes the frequencies that we will actually
C        be using for the legacy system for which we are trying
C        to set the pulse cal detector values.
C
         KS = FSETKS(KF)
         UPCAL = FSPCAL(KF)
         CALL FSFREQ( KF, LOSUM, BBCFREQ, BBCBW,
     1         CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC )
C
      END IF
      KSCN = FSETSCN(KF)
      KSTA = ISETSTA(KS)
      ISTA = ISCHSTA(KSTA)
C
C     Get the tone interval.  The case and validity of the PCAL 
C     commands was checked on input of PCAL in the setups and schedule.
C
      TONEINT = -1.D0
      IF( UPCAL .EQ. '1MHz' ) THEN
         TONEINT = 1.D0
      ELSE IF( UPCAL .EQ. '5MHz' ) THEN
         TONEINT = 5.D0
      ELSE IF( UPCAL .EQ. 'off' ) THEN
         TONEINT = 0.D0
      ELSE
C
C        Earlier tests should have failed so we shouldn't get here.
C
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, A, A, F7.3)' )
     1     'PCALFQ: Programming error with PCAL. PCAL=''', UPCAL,
     2     '''  TONEINT=', TONEINT 
         CALL ERRLOG( MSGTXT )
      END IF
C
C     If the first PCALX1 is set and the pcal setting is the same
C     as for the setup group, assume that all other PCALX values are
C     also set and don't need to change.  Just write out what came 
C     from the setup file. Otherwise, set the defaults.
C
      IF( PCALX1(1,KS) .NE. ' ' .AND. UPCAL .EQ. SPCAL(KS) ) THEN
C
         DO IP = 1, MAXPC
            PCX1(IP) = PCALX1(IP,KS)
            PCX2(IP) = PCALX2(IP,KS)
            PCFR1(IP) = PCALFR1(IP,KS)
            PCFR2(IP) = PCALFR2(IP,KS)
            IF( PCX1(IP) .EQ. ' ' ) PCX1(IP) = 'OFF'
            IF( PCX2(IP) .EQ. ' ' ) PCX2(IP) = 'OFF'
         END DO
C
      ELSE
C
C        Find the tone frequencies that might be of interest,
C        namely the lowest and highest frequency ones in the 
C        bandpass.  Count the tones of interest (0, 1, 2, or 3).
C        Zero will mean just do state counts.
C        Avoid tones at the band edges (0 and CRDB).
C        RTONE1 is the tone frequency in MHz (real).
C        TONE1 etc are the tone frequencies in kHz (integer).
C
C        For all this, use the CRD values as they represent the
C        signals that the detectors will see.
C
         CALL GETCRDN( KSCN, ISTA, CRDN, CRSETC )
C
         DO ICH = 1, CRDN
            NTONES(ICH) = 0
         END DO
C
C        There may be an offset between the output crd channels
C        and the setup channels.  ICH refers to the output to the
C        crd file.  ICHS refers to the setup file.  GETCRDN did
C        the work setting this up.
C
         IF( TONEINT .GT. 0.D0 ) THEN
            DO ICH = 1, CRDN
               ICHS = CRSETC(ICH)
               INTBW = 1000 * CRDB(ICH)
C
C              Get the first tone.
C              Need the net sideband.  CRDS is the BBC sideband
C              before any sideband inversion tricks were done.
C              Get a CNETSIDE which is the net sideband in the
C              BBC.  Presumably NETSIDE has reflected the 
C              inversions so can't be used directly.
C
               IF( CRDS(ICH) .EQ. SIDE1(ICHS,KS) ) THEN
                  CNETSIDE = 'U'
               ELSE
                  CNETSIDE = 'L'
               END IF
C
               IF( CNETSIDE.EQ.'U' .AND. CRDLOSUM(ICH).NE.0.D0 ) THEN
                  TONE1(ICH) = DNINT( 1.D3 * 
     1                   ( TONEINT - MOD( CRDLOSUM(ICH), TONEINT ) ) )
                  IF( TONE1(ICH) .EQ. 0 ) 
     1                   TONE1(ICH) = DNINT( TONEINT * 1000.D0 )
                  IF( TONE1(ICH) .LT. INTBW ) NTONES(ICH) = 1
                  RTONE1 = TONE1(ICH) / 1000.0D0
               ELSE IF( CNETSIDE .EQ. 'L' .AND. 
     1                  CRDLOSUM(ICH) .NE. 0.D0 ) THEN
                  TONE1(ICH) = 
     1                 DNINT( 1.D3 * MOD( CRDLOSUM(ICH), TONEINT ))
                  IF( TONE1(ICH) .EQ. 0 ) 
     1                   TONE1(ICH) = DNINT( TONEINT * 1000.D0 )
                  IF( TONE1(ICH) .LT. INTBW ) NTONES(ICH) = 1
                  RTONE1 = TONE1(ICH) / 1000.0D0
               ELSE
                  CALL WLOG( 1,
     1                 'PCALFQ: Invalid sideband or no LO sum.' )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( 3A, 2I5 )' )
     1                 '        BBC Net Sideband ', CNETSIDE,
     2                 ' in frequency set/channel: ', KS, ICH
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, F14.6 )' )
     1                 '        Legacy system LO sum: ', 
     2                 CRDLOSUM(ICH)
                  CALL WLOG( 1, MSGTXT )

                  CALL ERRLOG( '        when setting VLBA legacy '//
     1                  'system pulse cal detectors.' )
               END IF
C
C              Get the second tone.  The 0.005 prevents the tone from
C              ending up right on the band edge.  
C
               IF( NTONES(ICH) .EQ. 1 .AND. 
     1             CRDB(ICH) - RTONE1 .GT. TONEINT ) THEN
                  NTPB = ( CRDB(ICH) - RTONE1 - 0.005D0 ) / TONEINT
C
C                 Try to prevent getting too close to the upper edge 
C                 of the band where there is a strong filter roll off.
C
                  IF( TONE1(ICH) / 1000.0D0 + NTPB * TONEINT .GT.
     1                  0.85D0 * CRDB(ICH) ) THEN
                     IF( NTPB .LE. 8 .AND. NTPB .GE. 3 ) THEN
                        NTPB = NTPB - 1
                     ELSE IF( NTPB .GT. 8 ) THEN
                        NTPB = NTPB - 2
                     END IF
                  END IF
C
                  TONE2(ICH) = TONE1(ICH) + 
     1               NINT( NTPB * TONEINT * 1000.0D0 )
                  NTONES(ICH) = 2
C
C                 Get the third tone if there is room.
C
                  IF( NTPB .GT. 1 ) THEN
                     NTONES(ICH) = 3
                     TONE3(ICH) = TONE1(ICH) + NINT( TONEINT * 1.0D3 )
                  END IF                  
C
               END IF
            END DO
         END IF
C
C        Loop through the channels assigning the low tones.
C        ID is a detector count.  IP is the detection unit of
C        which there are MAXPC.  ICT is the channel.
C
         ID = 0
C
         DO ICH = 1, CRDN
            IF( NTONES(ICH) .GE. 1 .AND. ID .LT. MAXTON ) THEN
               ID = ID + 1
               IP = ( ID + 1 ) / 2
               ICT = 1 + MOD( ID + 1, 2 )
               WRITE( PCALC1, '(A,I2)' ) 'S', ICH
               IF( ICH .LT. 10 ) PCALC1 = PCALC1(1:1)//PCALC1(3:3)//' '
               IF( ICT .EQ. 1 ) THEN
                  PCX1(IP) = PCALC1
                  PCFR1(IP) = TONE1(ICH)
               ELSE
                  PCX2(IP) = PCALC1
                  PCFR2(IP) = TONE1(ICH)
               END IF
            END IF
         END DO
C
C        Now do the high frequency tones (tone2).
C
         DO ICH = 1, CRDN
            IF( NTONES(ICH) .GE. 2 .AND. ID .LT. MAXTON ) THEN
               ID = ID + 1
               IP = ( ID + 1 ) / 2
               ICT = 1 + MOD( ID + 1, 2 )
               WRITE( PCALC1, '(A,I2)' ) 'S', ICH
               IF( ICH .LT. 10 ) PCALC1 = PCALC1(1:1)//PCALC1(3:3)//' '
               IF( ICT .EQ. 1 ) THEN
                  PCX1(IP) = PCALC1
                  PCFR1(IP) = TONE2(ICH)
               ELSE
                  PCX2(IP) = PCALC1
                  PCFR2(IP) = TONE2(ICH)
               END IF
            END IF
         END DO
C
C        Now do the state counts.  If 2 bit, use a pair of detectors.
C        If this means skipping a detector, assign it to S1, freq 0.
C
         DO ICH = 1, CRDN
            IF( ID .LT. MAXTON ) THEN
               ID = ID + 1
               IP = ( ID + 1 ) / 2
               ICT = MOD( ID + 1, 2 ) + 1
               IF( BITS(ICH,KS) .EQ. 2 .AND. ICT .EQ. 2 ) THEN
                  PCX2(IP) = 'S1'
                  PCFR2(IP) = 0
                  ID = ID + 1
                  IP = IP + 1
                  ICT = 1
               END IF
               IF( ID .LE. MAXTON ) THEN
                  WRITE( PCALC1, '(A,I2)' ) 'S', ICH
                  IF(ICH .LT. 10) PCALC1 = PCALC1(1:1)//PCALC1(3:3)//' '
                  IF( ICT .EQ. 1 ) THEN
                     PCX1(IP) = PCALC1
                     PCFR1(IP) = 0
                  ELSE
                     PCX2(IP) = PCALC1
                     PCFR2(IP) = 0
                  END IF
                  IF( BITS(ICH,KS) .EQ. 2 ) THEN
                     PCX2(IP) = 'M'//PCALC1(2:3)
                     PCFR2(IP) = 0
                     ID = ID + 1
                  END IF
               END IF
            END IF
         END DO
C
C        Finally do the middle frequency tones (tone3).
C
         DO ICH = 1, CRDN
            IF( NTONES(ICH) .GE. 3 .AND. ID .LT. MAXTON ) THEN
               ID = ID + 1
               IP = ( ID + 1 ) / 2
               ICT = 1 + MOD( ID + 1, 2 )
               WRITE( PCALC1, '(A,I2)' ) 'S', ICH
               IF( ICH .LT. 10 ) PCALC1 = PCALC1(1:1)//PCALC1(3:3)//' '
               IF( ICT .EQ. 1 ) THEN
                  PCX1(IP) = PCALC1
                  PCFR1(IP) = TONE3(ICH)
               ELSE
                  PCX2(IP) = PCALC1
                  PCFR2(IP) = TONE3(ICH)
               END IF
            END IF
         END DO
C
C        If not all detectors have been used, turn off the rest.
C
         IF( ID .LT. MAXTON ) THEN
            DO IDD = ID + 1, MAXTON
               IP = ( IDD + 1 ) / 2
               ICT = MOD( IDD + 1, 2 ) + 1
               IF( ICT .EQ. 1 ) THEN
                  PCX1(IP) = 'OFF'
                  PCFR1(IP) = 0
               ELSE
                  PCX2(IP) = 'OFF'
                  PCFR2(IP) = 0
               END IF
            END DO
         END IF
C
      END IF
C
C     Guarantee uppercase.
C
      DO IP = 1, MAXPC
         CALL UPCASE( PCX1(IP) )
         CALL UPCASE( PCX2(IP) )
      END DO
C
      RETURN
      END

      SUBROUTINE SCHDAY( JTIME, VLBAD, HUMAND, DOY, TIME )
C
C     Routine to take Julian time (STARTJ or STOPJ)
C     and convert to format needed for DATE parameter for VLBA and 
C     to a human readable format of the form:  Tue, 1988 Mar 12
C     Also returns the day of year and the fraction of the day.  The
C     fraction needs to be converted to radians before most uses.
C
      DOUBLE PRECISION       JTIME, TIME 
      CHARACTER    VLBAD*9, HUMAND*16, MNAME*3, DNAME*3
      INTEGER      KY, KM, KD, J, DOY, JY, JD
C -----------------------------------------------------------------------
      CALL SLA_DJCL( JTIME, KY, KM, KD, TIME, J )
      IF( J .EQ. -1 ) CALL ERRLOG( 'Unacceptable date in SCHDAY' )
C
      CALL TDATECW(KY,KM,KD,JD,MNAME,DNAME)
C
      WRITE( VLBAD, '(I4.4,A3,I2.2)' ) KY, MNAME, KD
C
      WRITE( HUMAND, '(A3,'', '',I4,1X,A3,1X,I2.2 )' ) DNAME, 
     1               KY, MNAME, KD
C
      CALL SLA_CALYD( KY, KM, KD, JY, DOY, J )
      IF( J .GE. 1 ) CALL ERRLOG( 'Date problem in SCHDAY' )
C
      RETURN
      END

      SUBROUTINE VXSORT( BLOCK, NXXVEX, XXISSET, NMODXX, IMODXX,
     1     NSTAXX, ISTAXX, XXLINK )
C
C     Routine for SCHED that goes through the setup groups and
C     finds out how many sections of type XX (e.g. FQ) etc there will be.
C     This is complicated, the code can be compacter, but than it is
C     really incomprehensible. Note that some more MODE, FREQ, PHASECAL
C     sections are to be discovered in VXSCNS.
C
C     Dec 2011.  Allow retention of FORMAT=NONE modes.  RCW.
C
C     Input:
C        BLOCK = Two letter code, denoting which $BLOCK we are sorting
C     Output:
C        NXXVEX = Number of defs in $BLOCK
C        XXISSET = List of sets each $BLOCK def refers to
C        NMODXX(IMODE) = Number of BLOCK defs refered in mode IMODE
C        IMODXX(I,IMODE) = List of BLOCK defs referred in mode IMODE
C        NSTAXX(IXX,IMODE) = Number of Station in $BLOCK IXX used by IMODE
C        ISTAXX(ISTA,IXX,IMODE) = List of stations in BLOCK IXX used in IMOD
C        XXLINK(IXX) = Name of link IXX.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      CHARACTER BLOCK*2, XXLINK(MAXSTA)*32
      INTEGER NXXVEX
      INTEGER NMODXX(MAXMOD), IMODXX(MAXMOD,MAXMOD)
      INTEGER XXISSET(MAXMOD), NSTAXX(MAXMOD,MAXMOD), 
     .    ISTAXX(MAXSTA,MAXMOD,MAXMOD)
      INTEGER VXGTST
C
C     local variables
C     
      INTEGER   I, J, KS, JS, ISTA, JSTA, ISCAT, IMODE, IXX, JXX
      INTEGER   SETISXX(MSET), LEN1
      LOGICAL NEWFND, VXCFFQ, VXCFIF, VXCFBB, VXCFTR, VXCFHP
      LOGICAL VXCFRL, VXCFPO, VXCFPH
      LOGICAL PROBLEM
C ----------------------------------------------------------------------
C
C     Safe to initialize counters
C
      DO IMODE = 1,MAXMOD
         DO IXX = 1,MAXMOD
            NSTAXX(IXX,IMODE)= 0
         ENDDO
      ENDDO
C
C     First find out how many $BLOCKS there are and keep one
C     of the sets that specifies it (many sets can use one $FREQ or $IF)
C
      WRITE( MSGTXT, '( A, A, A )' ) 
     1    ' VXSORT: Start sorting ', BLOCK, ' definition'
      IF( DEBUG ) CALL WLOG( 1, MSGTXT(1:LEN1(MSGTXT) ))
      NXXVEX = 0
      DO KS = 1, NSET
C
C        Obviously a new block when it's the first.
C        Keep regardless of FORMAT=NONE status.
C
C         IF( USED(KS) .AND. ( FORMAT(KS)(1:4) .NE. 'NONE' .OR.
C     1         OBSTYP .EQ. 'PTVLBA' ) ) THEN
         IF( USED(KS) ) THEN
            IF( NXXVEX .EQ. 0 ) THEN
               NEWFND = .TRUE.
            ELSE
C
C              Find if any set JS has same characteristics as KS = 1 to JS-1 
C
               NEWFND = .TRUE.
               DO IXX = 1, NXXVEX
                  JS = XXISSET(IXX)
                  IF( USED(JS) ) THEN 
C
C                    testing done in one of the functions, 
C                    store which block covers a certain set that is not unique
C
                     IF( BLOCK .EQ. 'FQ' ) THEN
                        IF( VXCFFQ( KS, JS ) ) THEN
                           NEWFND = .FALSE.
                           SETISXX(KS) = IXX
                        END IF
                     ELSE IF( BLOCK .EQ. 'IF' ) THEN
                        IF( VXCFIF( KS, JS ) ) THEN
                           NEWFND = .FALSE.
                           SETISXX(KS) = IXX
                        END IF
                     ELSE IF( BLOCK .EQ. 'BB' ) THEN
                        IF( VXCFBB( KS, JS ) ) THEN
                           NEWFND = .FALSE.
                           SETISXX(KS) = IXX
                        END IF
                     ELSE IF( BLOCK .EQ. 'TR' ) THEN
                        IF( VXCFTR( KS, JS ) ) THEN
                           NEWFND = .FALSE.
                           SETISXX(KS) = IXX
                        END IF
                     ELSE IF( BLOCK .EQ. 'HP' ) THEN
                        IF( VXCFHP( KS, JS ) ) THEN
                           NEWFND = .FALSE.
                           SETISXX(KS) = IXX
                        END IF
                     ELSE IF( BLOCK .EQ. 'PH' ) THEN
                        IF( VXCFPH( KS, JS ) ) THEN
                           NEWFND = .FALSE.
                           SETISXX(KS) = IXX
                        END IF
                     ELSE IF( BLOCK .EQ. 'PO' ) THEN
                        IF( VXCFPO( KS, JS ) ) THEN
                           NEWFND = .FALSE.
                           SETISXX(KS) = IXX
                        END IF
                     ELSE IF( BLOCK .EQ. 'RL' ) THEN
                        IF( VXCFRL( KS, JS ) ) THEN
                           NEWFND = .FALSE.
                           SETISXX(KS) = IXX
                        END IF
                     ELSE
                        CALL ERRLOG(' VXSORT: unsupported BLOCK def ')
                     END IF
                  END IF
               END DO
            END IF
C
C           If it is new, take action
C
            IF( NEWFND ) THEN
C
C           fill a new block and give it a name
C
               NXXVEX = NXXVEX + 1
               IF( NXXVEX .GT. MAXMOD ) CALL ERRLOG(
     1             'VXSORT: Number of $'//BLOCK//' defs '//
     1             'exceeding MAXMOD, need to re-compile...')
C
C              Store which set has pars for this block,
C
               XXISSET(NXXVEX) = KS
C
C              and which block covers this set (for local use only),
C
               SETISXX(KS) = NXXVEX
C
C              and think up a name (there are a few cases that these
C              won't actually be used, can't help that here).
C
               CALL VXNMXX( BLOCK, NXXVEX, XXLINK )
C
            END IF
         END IF
      END DO
C
C     now in a mode, there can be a number of e.g. FREQ settings
C     each for a group of antennas
C     first determine which defs are referenced where
C
      DO IMODE = 1, NMDVEX
         NMODXX(IMODE) = 0
C
C        Go through the antennas in a experiment
C
         DO ISTA = 1, NSTA
C
            KS = MODSET(ISTA,IMODE)
C
C           Note that, if the station is not used with the mode
C           (egvsop.key does that), then KS can end up zero, which
C           is trouble below.  Jump to next station if this happens.
C           RCW Nov 2011
C
            IF( KS .NE. 0 ) THEN
C               IF( USED(KS) .AND. ( FORMAT(KS)(1:4) .NE. 'NONE' .OR.
C     1            OBSTYP .EQ. 'PTVLBA' ) ) THEN
               IF( USED(KS) ) THEN
C
C              Obviously there is a new SET when there is no previous one
C
                  IF( MODSET(ISTA,IMODE) .NE. 0 .AND. 
     1                   NMODXX(IMODE) .EQ. 0 ) THEN
                     NEWFND = .TRUE.
                  ELSE
C 
C                    Find if a set already used for a previous antenna:
C
                     IF( MODSET(ISTA,IMODE) .EQ. 0 ) THEN
                        NEWFND = .FALSE.
                     ELSE
                        NEWFND = .TRUE.
                        DO J = 1, NMODXX(IMODE)
C
C                       Check if XX already used, note many modes 
C                       may use 1 XX
C
                           IF( SETISXX(MODSET(ISTA,IMODE)) .EQ. 
     1                         IMODXX(J,IMODE) )
     2                         NEWFND = .FALSE.
                        END DO
                     END IF
                  END IF
C
C                 Now take the appropriate action
C
                  IF( NEWFND ) THEN
C
C                    so a new block def is found for this mode, remember
C                    which block it is that is referenced in this mode
C
                     NMODXX(IMODE) = NMODXX(IMODE) + 1
                     IF( NMODXX(IMODE) .GT. MAXMOD ) CALL ERRLOG(
     1                 'VXSORT: Number of $'//BLOCK//' defs in $MODE '//
     2                 'exceeding MAXMOD, should never happen...')
                     IMODXX(NMODXX(IMODE),IMODE) = 
     1                  SETISXX(MODSET(ISTA,IMODE))
                  END IF
               END IF
            END IF
         END DO
      END DO
C     
C     Now we need to figure out which antennas are used in this 
C     list of blocks. Some defs (IXX) use different lists of antennas
C     in different modes, this is now implemented.
C
      DO IMODE = 1, NMDVEX
         DO I = 1, NMODXX(IMODE)
C
C           find each block def used in this mode, for short
C
            IXX = IMODXX(I,IMODE)
C
C           loop through stations and find their names
C
            DO ISTA = 1, NSTA
               ISCAT = STANUM(ISTA)
C
C              now KS = XXISET(IXX) has a description of the settings
C              for this block, but the station name can occur in many 
C              of the sets SETISXX(I) that use IXX (sorry it's tough).
C
               NEWFND = .FALSE.
C
C              first find an exact match:
C              should be possible to make clearer
C
               DO KS = 1, NSET
C                  IF( USED(KS) .AND. ( FORMAT(KS)(1:4) .NE. 'NONE' .OR.
C     1                OBSTYP .EQ. 'PTVLBA' ) ) THEN
                  IF( USED(KS) ) THEN
                     IF( SETISXX(KS) .EQ. IXX .AND. 
     1                   KS .EQ. MODSET(ISTA,IMODE)) THEN
                        IF( STATION(ISCAT) .EQ. SETSTA(1,KS) ) THEN
                           NEWFND = .TRUE.
                           IF( NSTAXX(IXX,IMODE) .GE. 1 ) THEN
                              DO J = 1, NSTAXX(IXX,IMODE)
                                 IF( ISTA .EQ. 
     1                               ISTAXX(J,IXX,IMODE) ) THEN
                                    NEWFND = .FALSE.
                                 END IF
                              END DO
                           END IF
                        ELSE IF( STATION(ISCAT)(1:3) .EQ. 'VLA' .AND.
     1                         SETSTA(1,KS)(1:3) .EQ. 'VLA' ) THEN
                           CALL WLOG( 1,' VXSORT: Warning: '//
     1                         'VLA names should match '//
     2                         'exactly for VEX extension ')
                        END IF                     
                     END IF
                  END IF
               END DO
C
C              so we have found a new station for this def
C
               IF( NEWFND ) THEN
                  NSTAXX(IXX,IMODE) = NSTAXX(IXX,IMODE) + 1
                  ISTAXX(NSTAXX(IXX,IMODE),IXX,IMODE) = ISTA
               END IF
            END DO
         END DO
      END DO
C
C     Test whether a complication with stations in different
C     defs used across modes occurs. Huib thinks this is solved
C     but lets keep the check.
C
      PROBLEM = .FALSE.
      IF( NMDVEX .GT. 1) THEN
         DO IMODE = 1, NMDVEX
           KS = VXGTST( IMODE ) 
           IF( USED(KS) .AND. ( FORMAT(KS)(1:4) .NE. 'NONE' .OR.
     1          OBSTYP .EQ. 'VLBA' ) ) THEN
             IF( NMODXX(IMODE) .GT. 1 ) THEN
                DO I = 2, NMODXX(IMODE)
                   IXX = IMODXX(I,IMODE)
                   DO ISTA = 1, NSTAXX(IXX,IMODE)
                      DO J = 1, I-1
                         JXX = IMODXX(J,IMODE)
                         DO JSTA = 1, NSTAXX(JXX,IMODE)
                            IF (ISTAXX(ISTA,IXX,IMODE) .EQ. 
     1                          ISTAXX(JSTA,JXX,IMODE)) THEN
                               PROBLEM = .TRUE.
                               WRITE (MSGTXT, '( A, A, A, A, A, A,
     .                             A, I2 )' ) 
     1                             'VXSORT: Problem with ', BLOCK, 
     2                             ' def, ref''d by ',
     3                             MDLINK(IMODE)(1:LEN1(MDLINK(IMODE))),
     4                             ' cannot resolve ', 
     5                          STATION(STANUM(ISTAXX(ISTA,IXX,IMODE))),
     6                             ' = ', ISTAXX(ISTA,IXX,IMODE)
                               CALL WLOG( 1, MSGTXT )
C
                               WRITE (MSGTXT, '( A, I2, A, I2, 
     .                             A, A, 
     .                             A, I2, A, I2, 
     .                             A, A, A )' ) 
     1                             'Occurs in  ',IXX,'-',IMODE,  
     2                             ' (',
     3                             XXLINK(IXX)(1:LEN1(XXLINK(IXX))),
     4                             ') and in ', JXX,'-',IMODE,
     4                             ' (',
     5                             XXLINK(JXX)(1:LEN1(XXLINK(JXX))),
     6                             ')'
                               CALL WLOG( 1, MSGTXT )
                            END IF
                         END DO
                      END DO
                   END DO
                END DO 
             END IF
           END IF
         END DO
      END IF
      IF( PROBLEM ) THEN
         WRITE (MSGTXT, '( A )' ) 
     1       'VXSORT: ERROR Schedule too '//
     2       'complicated to sort, requires a '//
     3       'Sched/VEX upgrade.'
         CALL ERRLOG( MSGTXT )
      END IF
C
C     Done...
C     
      RETURN
      END

      SUBROUTINE ERRLOG( MESSAGE )
C
C     Routine for SCHED that deals with an error abort.  This is
C     to be used where ERROR used to be used.  It writes to
C     logfile, closes the logfile, and calls ERROR.
C
      INCLUDE  'sched.inc'
      CHARACTER   MESSAGE*(*)
C -----------------------------------------------------------------
C     Alert the user that something is very wrong.
C
      CALL WLOG( 1, ' ' )
      CALL WLOG( 1, MESSAGE )
      CALL WLOG( 1, ' ' )
      CALL WLOG( 1, '+++ERROR+++ SCHED terminating' )
      CALL WLOG( 1, '   The above is a fatal error.' )
      CALL PUTOUT( '   There may be much more information in '//
     1     LOGFILE  )
C
C     Then call error.
C
      CALL ERROR( 'SCHED terminating.  Fix input and restart.' )
C
C     Actually will never get back here, but for show:
C
      RETURN
      END

      SUBROUTINE LISTFREQ
C
C     Routine for SCHED, called by GETFREQ, that makes a table of
C     the frequencies available in the frequency catalog.  The
C     user can provide limits for the frequency ranges.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schfreq.inc'
C
      INTEGER      IF, KF, I, NS, VLBOPE, IOERR, LEN1
      CHARACTER    OPSTAT*4, OPTEXT*256, PRLST*80 
      CHARACTER    FMTA*60, FMT1*60, FMT2*60, FMT3*60
      LOGICAL      DOIT, EXISTS, DOVLA(MFREQ)
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'LISTFREQ starting. ' )
C
C     Only do anything if something was requested.
C
      IF( FREQLIST(1) .NE. UNSET ) THEN
C
C        Set default for second frequency if needed.
C
         IF( FREQLIST(2) .EQ. UNSET ) FREQLIST(2) = FREQLIST(1)
C
C        Open the frequencies file.
C
         PRLST = 'frequencies.list'
         INQUIRE( FILE=PRLST, EXIST=EXISTS )
         IF( EXISTS ) THEN
            OPSTAT = 'OLD'
         ELSE
            OPSTAT = 'NEW'
         END IF
         IOERR = VLBOPE( IFRQLST, PRLST, 'TEXT', OPSTAT, OPTEXT )
         IF( IOERR .NE. 1 ) CALL ERRLOG( 'LISTFREQ: Open problem: '//
     1           OPTEXT )
C
C        Make tables header for main table.
C
         WRITE( IFRQLST, '( A )' )  ' FREQUENCY SETUPS'
         WRITE( IFRQLST, '( A, 2F10.2, A )' )  
     1         '    Frequency range: ', FREQLIST, ' MHz. '
         WRITE( IFRQLST, '( A , A )' )
     1         '    File: ', FREQFILE(1:LEN1(FREQFILE))
         WRITE( IFRQLST, '( A )' )
     1         '    Note that groups with low ''Prio'' are prefered.'
         WRITE( IFRQLST, '( 1X, /, A , A )' )
     1         ' Entry Prio IF   Low Freq  High Freq  Pol   ',
     2         'FirstLO   FE  Stations/Synth '       
C
C        Set up for variable format.
C
         FMTA = '( I5, I5, 3X, A2, 2F10.2, 3X, A3, F10.2, 2X, A4'
         FMT2 = FMTA(1:LEN1(FMTA)) // ' )'
         FMT3 = FMTA(1:LEN1(FMTA)) // ', 1X, 3F6.1 )'
C
C        Loop through frequency groups.
C
         DO KF = 1, NFREQ
C
C           Check frequency range.
C
            DOIT = .FALSE.
            DOVLA(KF) = .FALSE.
            DO IF = 1, FNIF(KF)
               IF( FREQLIST(1) .LT. FRF2(IF,KF) .AND.
     1             FREQLIST(2) .GT. FRF1(IF,KF) ) DOIT = .TRUE.
            END DO
C
C           If in range, write table entry.
C
            IF( DOIT ) THEN
               NS = 1
               DOVLA(KF) = FSTNAM(1,KF)(1:3) .EQ. 'VLA'
               DO I = 2, MFSTA
                  IF( FSTNAM(I,KF) .NE. ' ' ) NS = I
               END DO
               WRITE( FMT1, '( 2A, I2, A )' ) 
     1              FMTA(1:LEN1(FMTA)), ',', NS, '(2A) )'
               WRITE( IFRQLST, '( ''----'', A12, 64(''-'') )' )
     1              FRNAME(KF)
               DO IF = 1, FNIF(KF)
                  IF( IF .EQ. 1 .AND. .NOT. DOVLA(KF) ) THEN
                     WRITE( IFRQLST, FMT1 ) KF, PRIO(KF), 
     1                  FIFNAM(IF,KF), FRF1(IF,KF), FRF2(IF,KF),
     2                  FPOL(IF,KF), FLO1(IF,KF), FFE(IF,KF),
     3                  (' ', FSTNAM(I,KF)(1:LEN1(FSTNAM(I,KF))),I=1,NS)
                  ELSE IF( IF .EQ. 2 .AND. .NOT. DOVLA(KF) ) THEN
                     WRITE( IFRQLST, FMT3 ) KF, PRIO(KF), 
     1                  FIFNAM(IF,KF), FRF1(IF,KF), FRF2(IF,KF),
     2                  FPOL(IF,KF), FLO1(IF,KF), FFE(IF,KF),
     3                  FSYN(1,KF), FSYN(2,KF), FSYN(3,KF)
                  ELSE IF( DOVLA(KF) ) THEN
                     WRITE( IFRQLST, FMT1 ) KF, PRIO(KF), 
     1                  FIFNAM(IF,KF), FRF1(IF,KF), FRF2(IF,KF),
     2                  FPOL(IF,KF), FLO1(IF,KF), FFE(IF,KF),
     3                  ' ', FVCHNSTA(IF,KF)(1:LEN1(FVCHNSTA(IF,KF)))
                  ELSE
                     WRITE( IFRQLST, FMT2 ) KF, PRIO(KF), 
     1                  FIFNAM(IF,KF), FRF1(IF,KF), FRF2(IF,KF),
     2                  FPOL(IF,KF), FLO1(IF,KF), FFE(IF,KF)
                  END IF
               END DO
               IF( FRNOTE(KF) .NE. ' ' ) WRITE( IFRQLST, '( 2A )' )
     1              '  ', FRNOTE(KF)(1:LEN1(FRNOTE(KF)))
            END IF
         END DO
         WRITE( IFRQLST, '( 80(''-''), /, 80(''-'') )' )
C
C        Make tables of VLA special parameters.
C
         WRITE( IFRQLST, '( 1X, /, 1X, /, A )' )
     1         ' VLA Parameters.'
         WRITE( IFRQLST, '( 1X, /, A )' )
     1         ' Entry  BAND  BW    FEAB   FECD   SYNA    ' //
     2         'SYNB   FLUKEA  FLUKEB FEFILTER'
         WRITE( IFRQLST, '( 80(''-'') )' )
         DO KF = 1, NFREQ
            IF( DOVLA(KF) ) THEN
               WRITE( IFRQLST, '( I5, 4X, A2, 2X, A4, 2F7.2, '//
     1                  ' 2F8.1, 2F8.2, 3X, A4 )' )
     2              KF, FVBAND(KF), FVBW(KF), FVFEAB(KF), FVFECD(KF), 
     3              FVSYNA(KF), FVSYNB(KF), FVFLKA(KF), FVFLKB(KF), 
     4              FVFILT(KF)
            END IF
         END DO
         WRITE( IFRQLST, '( 80(''-''), /, 80(''-'') )' )
C
C        Now rewind the output file and spill it to the screen
C
         REWIND( UNIT=IFRQLST )
  200    CONTINUE
            READ( IFRQLST, '(A)', END=210 ) MSGTXT
            CALL WLOG( 1, MSGTXT )
            GO TO 200
  210    CONTINUE
C
         CALL WLOG(1, 'LISTFREQ: The above table was written to ' //
     1       'file ''frequencies.list''.' )
C
C        Close the frequencies file.
C
         CLOSE( UNIT=IFRQLST )
C
      END IF
C
      RETURN
      END

      CHARACTER*32 FUNCTION VXNMPH( IPH, XTRAFQ )
C
C     function generates a name for PH block IPH (phase cal)
C            (HP corrected to PH  RCW Feb. 9, 2010)
C     By H.J. van Langevelde, JIVE, 300496
C     IPH, is number of LINK, necessary to find SET
C     XTRAFQ = .TRUE. used for extra frequencies detected
C     in main schedule, uses VXFQ etc
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      LOGICAL XTRAFQ
      INTEGER IPH, KS, ICH
      LOGICAL UPSIDE, LOSIDE, PHDETECT
      CHARACTER NAME*32
C ----------------------------------------------------------------------
C     
C     These are named according to increment and sideband, but they could
C     depend on frequency setting
C
      NAME = ' '
      KS = PHISSET( IPH ) 
C
C     first, what sideband
C
      UPSIDE = .FALSE.
      LOSIDE = .FALSE.
      DO ICH = 1, NCHAN(KS)
         IF( XTRAFQ ) THEN
            IF( VXNETSID(ICH,IPH) .EQ. 'U' ) UPSIDE = .TRUE.
            IF( VXNETSID(ICH,IPH) .EQ. 'L' ) LOSIDE = .TRUE.
         ELSE
            IF( NETSIDE(ICH,KS) .EQ. 'U' ) UPSIDE = .TRUE.
            IF( NETSIDE(ICH,KS) .EQ. 'L' ) LOSIDE = .TRUE.
         END IF
      END DO
      IF( UPSIDE .AND. LOSIDE ) THEN
         NAME(1:3) = 'Dsb'
      ELSE
         IF( UPSIDE ) THEN
            NAME(1:3) = 'Usb'
         ELSE IF( LOSIDE ) THEN 
            NAME(1:3) = 'Lsb'
         ELSE
            CALL ERRLOG('VXNMPH: No sideband set ')
         END IF
      END IF
C
C     and increment
C
      IF( XTRAFQ ) THEN
C
         PHDETECT = DODETECT(IPH)
      ELSE
         PHDETECT = .TRUE.
         IF( SPCAL(KS) .EQ. 'off' ) PHDETECT = .FALSE.
         IF( SPCAL(KS) .EQ. '1MHz' ) PHDETECT = .TRUE.
         IF( SPCAL(KS) .EQ. '5MHz' ) PHDETECT = .TRUE.
         IF( SPCAL(KS) .EQ. ' ' ) PHDETECT = .TRUE.
      END IF
C     
C     so an appropriate name is
C        
      NAME(4:12) = 'NotSet' 
      IF( PHDETECT ) THEN
         NAME(4:13) = 'Detect'
      ELSE
         NAME(1:11) = 'NoDetect'
      END IF
C
      VXNMPH = NAME
C
      RETURN
      END

      SUBROUTINE BBCCDAS( KS )
C
C     Make the BBC assignments for the CDAS.
C
C     For now, require the user set them.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER      KS, ICH
C-------------------------------------------------------------
      DO ICH = 1, NCHAN(KS)
         IF( BBC(ICH,KS) .LE. 0 ) THEN
            CALL WLOG( 1, 
     1         'BBCCDAS:  The user must set the BBC assignments ' //
     2         'for any CDAS stations.' )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I4 )' )
     1         '           They are missing in setup ', KS
            CALL ERRLOG( MSGTXT )
         END IF
      END DO
C
C     See the attachments on my email to Cormac on Dec. 16, 2013 for
C     some more information.  It seems that BBCs 1-4 are attached to
C     IF1, BBCs 5-8 see IF2, BBCs 9-12 see IF3 and BBCs 13-16 see
C     IF4.  I don't yet know the IF names.
C
      RETURN
      END

      SUBROUTINE VXWRRL
      IMPLICIT NONE
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the RL = $ROLL section 
C     By H.J. van Langevelde, JIVE, 300496 
C     Updated fro the real roll and 2 heads 011200
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C      
      INTEGER   IRL, KS, J, ISTA, IMODE, IHEAD
      INTEGER   ROLLBY, NHDSTK, VXNHDS
      INTEGER   LEN1
      CHARACTER LINE*132
      LOGICAL   DOWARN
C ----------------------------------------------------------------------
C
      LINE = ' ' 
      DOWARN = .FALSE.
      WRITE( IVEX, '( A, A1 )' ) '$ROLL', SEP   
C
      DO IRL = 1, NRLVEX
         KS = RLISSET(IRL)
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1        RLLINK(IRL)(1:LEN1(RLLINK(IRL))), SEP
         CALL VXSTLI( IRL, NSTARL, ISTARL )
C
C        Find the roll, there are four modes, for auto we
C        have to come up with the setting...
C
         ROLLBY = -1
         IF( BARREL(KS) .EQ. 'roll_off' ) ROLLBY = 0
         IF( BARREL(KS) .EQ. 'roll_16' ) ROLLBY = 16
         IF( BARREL(KS) .EQ. 'roll_8' ) ROLLBY = 8
         IF( BARREL(KS) .EQ. 'roll_auto' ) THEN
            IF( FORMAT(KS)(1:7) .EQ. 'MARKIII' ) THEN
               ROLLBY = 0
            ELSE
               IF( TAPEMODE(KS) .EQ. 1 ) ROLLBY = 16
               IF( TAPEMODE(KS) .EQ. 2 ) ROLLBY = 16
               IF( TAPEMODE(KS) .EQ. 4 ) ROLLBY = 8
               IF( TAPEMODE(KS) .EQ. 8 ) ROLLBY = 8
               IF( TAPEMODE(KS) .EQ. 0 ) ROLLBY = 0
            END IF
         END IF
C
C        Also find number of heads
C
         NHDSTK = VXNHDS( KS )
C
C        Write a comment
C
         WRITE( IVEX, '( A1, 4X, A, A, A, I2, A, I1, A )' ) COM, 
     1        'barrel-roll set to ''', BARREL(KS)(1:LEN1(BARREL(KS))), 
     2        ''', so reverse-roll by ', ROLLBY, ' (',NHDSTK,' head)'
         
C
C        Standard rolls all have the same rate
C
         IF( ROLLBY .LT. 0) THEN
            WRITE( MSGTXT, '( A, A )' ) 
     1          'VXWRRL: unknown barrel-roll:', 
     2          BARREL(KS)(1:LEN1(BARREL(KS)))
            CALL ERRLOG( MSGTXT )
         END IF
         IF( ROLLBY .EQ. 0 ) THEN
C
C           roll off now defined in VEX 1.5!
C
            WRITE( IVEX, '( 5X, A, A1 )' )  
     1           'roll = off', SEP 
         ELSE
            WRITE( IVEX, '( 5X, A, A1 )' ) 
     1           'roll = on', SEP 
            WRITE( IVEX, '( 5X, A, A1 )' ) 
     1          'roll_reinit_period = 2 sec', SEP 
            WRITE( IVEX, '( 5X, A, A1 )' ) 
     1          'roll_inc_period = 1', SEP 
C
C           write 2 comment lineS
C
            LINE = ' '
            WRITE( LINE(1:24), '( A1, 15X, A2, 1X, A4, 1X )' ) 
     1           COM, 'inpt'
            WRITE( LINE(25:80), '( A )' )
     1           ' writing inp trck to this output sequence'
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
            LINE = ' '
            WRITE( LINE(1:24), '( A1, 15X, A2, 1X, A4, 1X )' )
     1           COM, 'hd','trck'
            DO J = 1, ROLLBY
               WRITE( LINE(25+(J-1)*3:24+J*3), '( I2, 1X )' )  (J-1)
            END DO
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         ENDIF
C     
C        if there is roll, warn about PCFS not implementing it
C     
         IF( ROLLBY .NE. 0 ) THEN
            DO IMODE = 1, NMDVEX 
               DO ISTA = 1, NSTARL(IRL,IMODE)
                  IF( CONTROL(STANUM(ISTARL(ISTA,IRL,IMODE))) 
     1                .EQ. 'VEX' .AND. 
     2                .NOT. MODETEST( KS ) ) DOWARN = .TRUE.
               END DO
            END DO
C
C        At this point we need to know how many heads will roll
C


C
C        first the 8roll, can happen tpmode 4, but also for 2 and 1
C        so I guess we give roll for all 32 tracks
C
            DO IHEAD = 1, NHDSTK
               IF( ROLLBY .EQ. 8 ) THEN
                  CALL VXRL8( IHEAD )
               END IF
C
C        the 16 track roll is a lot more complicated
C
               IF( ROLLBY .EQ. 16 ) THEN
                  CALL VXRL16( IHEAD )
               END IF 
            END DO
         END IF
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
      END DO
      WRITE( IVEX, '( A )' ) COMLIN
C
C     issue a warning for rolling if necessary... 
C
      IF( DOWARN ) 
     1       CALL WLOG( 1,'VXWRRL: WARNING, barrel rolling not yet '//
     2       'permitted for the JIVE correlator')
      IF( DEBUG ) CALL WLOG( 1, 'VXWRRL: Done with setups to VEX.' )
C
      RETURN
      END

      LOGICAL FUNCTION TSTTTY(LUNIT)
      INTEGER LUNIT
C
C Return TRUE if the specified Fortran unit is connected to a terminal.
C------------------------------------------------------------------------
      LOGICAL ISATTY
C
      TSTTTY = ISATTY(LUNIT)
      END

      CHARACTER*32 FUNCTION VXNMFQ( IXX, XTRAFQ ) 
C
C     returns a name for an FREQ block definition
C     By H.J. van Langevelde, JIVE, 300496 
C     IXX, is number of LINK, necessary to find SET
C     XTRAFQ = .TRUE. used for extra frequencies detected
C     in main schedule, then we can use VXFQ links etc
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      LOGICAL XTRAFQ, DUALFRQ
      INTEGER IXX, ISET, ISIDE1, LPOS, LEN1, ICH
      INTEGER NPER, NFC1, NFCN
      CHARACTER NAME*32, FRTXT*16
      DOUBLE PRECISION SUMILO 
      REAL BBVAL
C ----------------------------------------------------------------------
C
      ISET = FQISSET( IXX )
C
C     First let's see if this is a dual Freq mode
C
      DUALFRQ = .FALSE.
      DO ICH = 2, NCHAN(ISET)
         IF( ABS(FIRSTLO(1,ISET) - FIRSTLO(ICH,ISET)) .GT. 1E3 )
     1        DUALFRQ = .TRUE.
      END DO
C
C     check pols and sidebands
C
      NAME = ' '
C
C     find first frequency. Mixed BW not allowed currently
C
      IF( XTRAFQ ) THEN
         SUMILO = VXLOSUM(1,IXX)
      ELSE
         IF( SIDE1(1,ISET) .EQ. 'U' ) THEN
            ISIDE1 = 1
         ELSE IF( SIDE1(1,ISET) .EQ. 'L' ) THEN
            ISIDE1 = -1
         ELSE
            CALL ERRLOG( 'VXNMFQ: First LO sideband problem.' )
         END IF
C
         SUMILO = FIRSTLO(1,ISET) + ISIDE1 * BBSYN(1,ISET)
      END IF
C
C     write a name with the freq in it.
C     Let the number of digits used depend on the tuning.
C
      IF( DUALFRQ ) THEN
         NAME(1:8) = 'DualFreq'
      ELSE
         NPER=7
         CALL FRCHAR( SUMILO, NPER, NFC1, NFCN, FRTXT )
         WRITE( NAME, '(A)' ) FRTXT(NFC1:NFCN)
         LPOS = LEN1( NAME ) + 1
         WRITE( NAME(LPOS:LPOS+2), '(A)' ) 'MHz'
      END IF
C
      LPOS = LEN1( NAME ) + 1
C
C     add the number of channels
C
      IF( NCHAN(ISET) .GT. 9 ) THEN
         WRITE( NAME(LPOS:LPOS+2), '( I2, A1 )' ) NCHAN(ISET),'x'
      ELSE
         WRITE( NAME(LPOS:LPOS+1), '( I1, A1 )' ) NCHAN(ISET),'x'
      ENDIF
C
      LPOS = LEN1( NAME ) + 1
C
C     and filter width
C
      BBVAL = BBFILT(1,ISET)
      IF( XTRAFQ) BBVAL = VXBBFILT(1,IXX)
C
C     Add 3 digit MHz for DDC and also change cutoff points to
C     x.50 from x.99 to better match the use of NINT for the wider
C     band cases.  RCW May 7, 2012.
C     Add 4 digit MHz for ALMA.  AJM Feb 1, 2016
C
      IF( BBVAL .GT. 999.50 ) THEN
         WRITE( NAME(LPOS:LPOS+6), '( I4, A3 )' )
     1        NINT( BBVAL ),'MHz'
      ELSE IF( BBVAL .GT. 99.50 ) THEN
         WRITE( NAME(LPOS:LPOS+5), '( I3, A3 )' ) 
     1        NINT( BBVAL ),'MHz'
      ELSE IF( BBVAL .GT. 9.50 ) THEN
         WRITE( NAME(LPOS:LPOS+4), '( I2, A3 )' ) 
     1        NINT( BBVAL ),'MHz'
      ELSE IF( BBVAL .GT. 0.99 ) THEN
         WRITE( NAME(LPOS:LPOS+3), '( I1, A3 )' ) 
     1        NINT( BBVAL ),'MHz'
      ELSE IF( BBVAL .GT. 0.099 ) THEN
         WRITE( NAME(LPOS:LPOS+5), '( I3, A3 )' ) 
     1        NINT( BBVAL*1e3 ),'kHz'
      ELSE
         WRITE( NAME(LPOS:LPOS+6), '( F4.1, A3 )' ) 
     1        BBVAL*1e3,'kHz'
      END IF
C
      VXNMFQ = NAME
C
      RETURN
      END

      SUBROUTINE GEOMAKE( LASTISCN, JSCN, ISCN, SEGSRCS, NSEG,
     1                    GSTASCN, GSTARTJ )
Cf2py intent(in) LASTISCN, JSCN, ISCN
Cf2py intent(out) SEGSRCS
Cf2py intent(in, out) NSEG, GSTASCN, GSTARTJ
C
C     Routine for SCHED called by ADDGEO that makes a list
C     of sources from the list of geo sources to fit into a
C     geodetic segment at the time of a scan for which such
C     a request was made.
C
C     The basic plan:
C        Loop through trial lists of sources.
C           Choose by random number generator.
C               Don't use previously used source
C               Keep track of sources that are not up and don't use.
C           Calculate a quality measure.
C               Like RMS spanned Sec(Z) of antenna with worst value.
C               Make it  SUM( (SEC(Z) - MEAN(SEC(Z)) )**2 
C                  Don't divide by number of scans so we can favor
C                  groups with more scans.
C        Keep a record of the best sequence (in SEGSRCS).
C            Replace SEGSRCS if a better sequence is found.
C
C        For each set, just stuff the scans into the scans starting
C        with ISCN.  JSCN is the template scan - less than SCAN1.
C
C     Some day, inhibit getting too close to the Sun.
C
      INCLUDE   'sched.inc'
C
      INTEGER           LASTISCN(*), JSCN, ISCN, SEGSRCS(*), NSEG
      LOGICAL           GSTASCN(MSEG,MAXSTA)
      DOUBLE PRECISION  GSTARTJ(*)
C
      INTEGER           MAXPAR
      PARAMETER         (MAXPAR=MAXSTA*2)
C
      INTEGER           ISEG, ITRIAL, LSCN, I, J, IDUM, ISTA, NSTSCN
      INTEGER           NTSEG, TSRC(MSEG)
      INTEGER           MINSPS, HALFSCNS, NPRST, NPRT, ICH, USEGEO(MGEO)
      REAL              BESTQUAL, TESTQUAL, BESTSIG(MAXSTA)
      REAL              RAN5, DUMMY, SEGELEV(MAXSTA,MGEO), SGAP
      LOGICAL           OKGEO(MGEO), PRDEBUG, RETAIN, KEPT
      DOUBLE PRECISION  TGEO1, TGEOEND, STARTB, SIGMA(MAXPAR)
      CHARACTER         SELTYPE(MSEG)*3, WSTA(MSEG)*3
C
      DATA              IDUM   / -12345 /
      SAVE              IDUM
C ---------------------------------------------------------------------
      IF( DEBUG .OR. GEOPRT .GE. 2 ) CALL WLOG( 1, 'GEOMAKE starting.' )
      NPRST = MIN( 20, NSTA )
C
      BESTQUAL = 9999.
      DO ISEG = 1, MSEG
         SEGSRCS(ISEG) = 0
      END DO
      KEPT = .FALSE.
C
C     Prime the random number generator a bit.  I don't know
C     if this is needed, but without it, the first antenna choices
C     didn't seem too random.
C
      DO I = 1, 100
         DUMMY = RAN5(IDUM)
      END DO
C
C     Save some parameters related to the block of scans.
C     This is mainly the start and stop times.  Take as the
C     beginning of the block the latest end of the previous
C     scan at any station. 
C
      TGEO1 = 0.D0
      DO ISTA = 1, NSTA
         IF( STASCN(JSCN,ISTA) ) THEN
            IF( LASTISCN(ISTA) .NE. 0 ) THEN
               TGEO1 = MAX( TGEO1, STOPJ(LASTISCN(ISTA)))
            ELSE
               TGEO1 = MAX( TGEO1, TFIRST )
            END IF
         END IF
      END DO
C
      STARTB = TGEO1
      TGEOEND = TGEO1 + GEOLEN(ISCN)
C
      IF( GEOPRT .GE. 2 ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, * ) 'GEOMAKE START TIMES', STARTB, 
     1        STARTJ(ISCN), TGEOEND
         CALL WLOG( 0, MSGTXT )
      END IF
C
C     Warn about inappropriate OPMIAN, then set one.
C
      IF( OPMIAN(JSCN) .LT. 2 ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I4, A )' ) 
     1     'GEOMAKE:  OPMINANT of ', OPMIAN(JSCN), 
     2     ' too small for automatic insertion of geodetic sections.'
         CALL WLOG( 1, MSGTXT ) 
         MSGTXT = ' '
         OPMIAN(JSCN) = NSTA / 2
         WRITE( MSGTXT, '( A, I4 )' ) 
     1     '          Resetting to OPMINANT = ', OPMIAN(JSCN)
         CALL WLOG( 1, MSGTXT ) 
         MSGTXT = ' '
      END IF
C
C     Look at all sources to see if they can be used and if they
C     seem useful enough to be favored.  Get a list of elevations.
C
      CALL GEOCHK( JSCN, ISCN, STARTB, TGEOEND, OKGEO, USEGEO,
     1             SEGELEV )
C
C     The idea now is to make a bunch of possible sequences and test
C     their quality using the algorithm in geoqual.  There are two
C     parts of this process that are a bit tricky.  The first is 
C     selecting the sequences to try.  The second is the quality 
C     measure.  See GEOQUAL for details the quality measure in use.
C
C     Loop over the trials.  GEOTRIES is a user parameter.
C
      DO ITRIAL = 1, GEOTRIES
         IF( GEOPRT .GE. 1 ) THEN
            CALL WLOG( 0, ' ' )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5, A, I5 )' ) 
     1           'GEOMAKE starting to construct trial segment', 
     2           ITRIAL, '.  First scan: ', ISCN
            CALL WLOG( 0, MSGTXT )
         END IF
C
C        Make a sequence of scans for the geodetic block.
C
         CALL MAKESEG( JSCN, ISCN, LASTISCN, 
     1                 OKGEO, USEGEO, SEGELEV, STARTB, TGEOEND, 
     2                 LSCN, NTSEG, TSRC, IDUM, SIGMA, SELTYPE,
     3                 WSTA )
C
C        Make sure each antenna is in a reasonable number of scans.
C        There is some hoop jumping because the number of scans can
C        vary.   Only test stations that are in the template JSCN.
C        MINSPS is "Minimum Scans Per Station".  Meanwhile, protect
C        against any station with only one scan (A short geoseg 
C        combined with long slews might create such a case).
C
         HALFSCNS = MAX( INT( ( LSCN - ISCN + 1.0 ) / 2.0 + 0.6 ),
     1                   2 )
         MINSPS = 9999
         DO ISTA = 1, NSTA
            IF( STASCN(JSCN,ISTA) ) THEN
               NSTSCN = 0
               DO I = ISCN, LSCN
                  IF( STASCN(I,ISTA) ) THEN
                     NSTSCN = NSTSCN + 1
                  END IF
               END DO
               MINSPS = MIN( MINSPS, NSTSCN )
            END IF
         END DO
C
C                       Programming warning:
C
C                       This is a potential source of trouble if
C                       slow stations are getting left out.
C                       It used to test against being in half of the
C                       scans, but that could be a problem when
C                       slow stations are being left out of scans.
C                       So for now, just test against a minimum number
C                       to get a solution.
C
C         RETAIN = MINSPS .GE. HALFSCNS
         RETAIN = MINSPS .GE. 3
C
C        For kept sequences, test the quality.
C
         IF( RETAIN ) THEN
C
            IF( GEOPRT .GE. 2 ) THEN
               NPRT = MIN( NTSEG, 30 )
               IF( NTSEG .GT. NPRT ) WRITE(*,*) 
     1            ' Showing first ', NPRT, ' scans of ', NTSEG
               CALL WLOG( 0, 
     1              'GEOMAKE ---------------------------------- ' )
               MSGTXT = ' '
               WRITE( MSGTXT,'( A, I4, A, 30I3 )' ) 
     1              'GEOMAKE    FINISHED ONE SEQUENCE - Trial:', 
     2               ITRIAL, ' Geosrcs:', (TSRC(ISEG), ISEG=1,NPRT)
               CALL WLOG( 0, MSGTXT )
            END IF
C
C           Get the quality measure of scans ISCN to LSCN.  Isolate this
C           to a subroutine in case someone wants to brew their own measure.
C           Here continue to reward arbitrarily low elevation scans (0.0
C           after JSCN).  Note that SecZ(90-14.48) is close to 4.0.
C        
            PRDEBUG = GEOPRT .GE. 2
            CALL GEOQUAL( ISCN, ISCN, LSCN, JSCN, 14.48, 
     1                    TESTQUAL, PRDEBUG, SIGMA )
C
C           Provide some feedback on the current segment.
C
            IF( GEOPRT .GE. 0 ) THEN
               CALL WLOG( 0, ' ' )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I5, A, I5, A, F7.2, A, F7.2 )') 
     1                'GEOMAKE: Finished making trial segment. ',
     2                ITRIAL, ' Number of scans:', ntseg, '  Quality:', 
     3                TESTQUAL, '  Previous best:', BESTQUAL
               CALL WLOG( 0, MSGTXT )
               IF( NTSEG .GT. 50 ) THEN
                  CALL WLOG( 1, '  Only first 50 scans printed' )
                  NPRT = 50 
               ELSE
                  NPRT = NTSEG
               END IF
               MSGTXT = ' '
               WRITE( MSGTXT,'( A, 50I4 )' )  '     Sources:   ', 
     1               (TSRC(ISEG),ISEG=1,NPRT)
               CALL WLOG( 0, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT,'( A, 50I4 )' )  '     Priority:  ', 
     1               (USEGEO(TSRC(ISEG)),ISEG=1,NPRT)
               CALL WLOG( 0, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, 20F5.1 )' ) 
     1              '     Sigmas by station: ', 
     2              (SIGMA(ISTA),ISTA=1,NPRST)
               CALL WLOG( 0, MSGTXT )
            END IF
C        
C           See whether to save this one source set.
C        
            IF( TESTQUAL .LT. BESTQUAL ) THEN
C
C              Annouce that a new best was found.
C
C               IF( GEOPRT .GE. 0 ) THEN

                  IF( GEOPRT .EQ. 0 ) CALL WLOG( 0, ' ' )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I5, A, 2I3, A, F7.3 )' )
     1             'New best geodetic segment - Trial: ', ITRIAL, 
     2             ' Number of scans & fewest scans/sta: ', 
     3             NTSEG, MINSPS, '  Quality: ', 
     4             TESTQUAL
                  CALL WLOG( 0, MSGTXT )
C               END IF
C
C              Save the new sequence.  Note that STASCN will have
C              been set in ways to allow leaving slow antennas
C              out.  It should not be regenerated in a call to 
C              MAKESCN or whatever.  It is saved here because,
C              as more segments are tried, it will change.
C
               BESTQUAL = TESTQUAL
               DO ISEG = 1, NTSEG
                  I = ISCN + ISEG - 1
                  SEGSRCS(ISEG) = TSRC(ISEG)
                  GSTARTJ(ISEG) = STARTJ(I)
                  DO ISTA = 1, NSTA
                     GSTASCN(ISEG,ISTA) = STASCN(I,ISTA)
                     BESTSIG(ISTA) = SIGMA(ISTA)
                  END DO
               END DO
               NSEG = NTSEG
               KEPT = .TRUE.
            END IF
         ELSE
            IF( GEOPRT .GE. 0 ) THEN
               CALL WLOG( 0, 'GEOMAKE: Segment not kept.' //
     1           '  Not enough scans at some stations.' )
            END IF
         END IF
C
C        If requested, write details about each trial sequence.
C
         IF( ( GEOPRT .GE. 0 .AND. KEPT ) .OR. GEOPRT .GE. 1 ) THEN
            MSGTXT = ' '
            IF( RETAIN ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, 20F7.2 )' ) 
     1              '   Sigmas by station:                ', 
     2              (SIGMA(ISTA),ISTA=1,NPRST)
               CALL WLOG( 0, MSGTXT )
            ELSE
               CALL WLOG( 0, '  Rejected without testing.'//
     1            '  Some station(s) with too few scans.' )
            END IF
            WRITE( MSGTXT, '( A, 20( 4X, A2, 1X) )' ) 
     1           ' Num  Gap(s) Sel Source      Worst   ', 
     2           (STCODE(STANUM(ISTA)),ISTA=1,NPRST)
            CALL WLOG( 0, MSGTXT )
            DO I = 1, NTSEG
               J = ISCN + I - 1
               IF(  I .EQ. 1 .AND. ISCN .EQ. SCAN1 ) THEN
                  SGAP = 0.0
               ELSE
                  SGAP = ( STARTJ(J) - STOPJ(J-1) ) / ONESEC
               END IF
               MSGTXT = ' '
C
C              Cut off the WSTA station code at 2 characters for 
C              historical reasons.  Could be put back.
C
               WRITE( MSGTXT,'( I4, F8.0, 1X, A, 1X, A12, 2X, A2 )' ) 
     1              TSRC(I), SGAP, SELTYPE(I), 
     2              GEOSRC(TSRC(I)), WSTA(I)
               ICH = 40
               DO ISTA = 1, NPRST
                  IF( STASCN(J,ISTA) ) THEN
                     WRITE( MSGTXT(ICH:ICH+10), '( F5.0, 1X )' )
     1                       EL1(J,ISTA)
                  ELSE
                     WRITE( MSGTXT(ICH:ICH+10), '( A, F4.0, A )' )
     1                       '(', EL1(J,ISTA), ')'
                  END IF
                  ICH = ICH + 7
               END DO
               CALL WLOG( 0, MSGTXT )
            END DO
C
         END IF
         KEPT = .FALSE.
         IF( MOD( ITRIAL, 10 ) .EQ. 0 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5 )' ) 
     1           'Finished trial geodetic segment number ',
     2           ITRIAL
            CALL WLOG( 1, MSGTXT )
         END IF

      END DO

C
C     Write result
C
      IF( GEOPRT .GE. 0) THEN
         NPRT = MIN( NTSEG, 30 )
         MSGTXT = ' '
         IF( NTSEG .GT. NPRT ) WRITE( MSGTXT, '( A, I5, A, I5 )' ) 
     1      ' Showing first ', NPRT, ' scans of ', NTSEG
         CALL WLOG( 0, '   ' )
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I3, A, 30I4 )' ) 
     1          'GEOMAKE FINISHED:', NSEG, 
     2          ' Selected geodetic sources: ', 
     3         (SEGSRCS(ISEG), ISEG=1,NPRT)
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
      END IF
C
C     Write the station quality summary regardless of GEOPRT.
C     Only write the index line if it won't be written below.
C
      IF( GEOPRT .LT. 0 ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, 20( 4X, A2, 1X) )' ) 
     1        '                                     ', 
     2        (STCODE(STANUM(ISTA)),ISTA=1,NPRST)
         CALL WLOG( 0, MSGTXT )
      END IF
      MSGTXT = ' '
      WRITE( MSGTXT, '( A, F7.2, A, 20F7.2 )' ) 
     1     ' Quality: ', BESTQUAL, 
     2     '  Sigmas by station: ', 
     3     (BESTSIG(ISTA),ISTA=1,NPRST)
      CALL WLOG( 1, MSGTXT )
C
C     Back to special printouts.
C
      IF( GEOPRT .GE. 0) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, 20( 4X, A2, 1X) )' ) 
     1        ' Num   Gap(s)  Source                ', 
     2        (STCODE(STANUM(ISTA)),ISTA=1,NPRST)
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
C
C        The above was the column headers.
C        To write the actual output lines, the segment needs to be
C        transferred to the scans arrays. That is done in ADDGEO.
C        So put the writing of the output lines there.
C
      END IF
C
      RETURN
      END

C*PUTOUT -- write line on standard output [Convex-UNIX]
C+
      SUBROUTINE PUTOUT(TEXT)
      CHARACTER*(*) TEXT
C
C This subroutine writes one line on the standard output; the text to be
C written is supplied as a character-string argument.
C
C Argument:
C  TEXT   (input)  : character string for output.
C
C Subroutines required:
C  Fortran formatted I/O.
C
C History:
C  1987 Nov 11 - TJP
C  2000 Dec 06 - RCW added length determination.
C
      INTEGER  LEN1
C-----------------------------------------------------------------------
      WRITE (6,'(A)') TEXT(1:LEN1(TEXT))
      END

      SUBROUTINE CHKVLBA( KS, ERRS )
Cf2py intent(in, out) ERRS
C
C     Routine for SCHED, called by CHKSET, that checks a number of
C     items specific to the VLBA.
C
C     Allow 4 IFs from 6cm and allow wider LO range as it is 4-8 GHz.
C     Nov 2011  RCW.
C
C     Set VFESYN while going through bands.  That is for the VLBA and
C     gives which of the front end synthesizers is being used.  This 
C     will be used later to set a sign on the synthesizer setting
C     to indicate the IF sideband.  It only worries about the 
C     second mix as the mix in the high frequency front ends
C     is (so far) always upper sideband.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
C     Test is a tolerance limit for FIRSTLO - SYNTH tests in MHz.
C
      INTEGER     I, KS, ICH, IIF, KIIF, JCH
      LOGICAL     ERRS, OK, BADLO, LOIFWARN, IFOK
      LOGICAL     WARNED(MAXSET), GOTWARN
      DOUBLE PRECISION  R8FREQ(3), TEST, TFR1, TFR2
      DOUBLE PRECISION  FRLOW, FRHIGH
      PARAMETER   (TEST=1.D-3)
      SAVE        IFNAMES, WARNED
      CHARACTER   IFNAMES(4)*1
      DATA        IFNAMES   / 'A', 'B', 'C', 'D' /
      DATA        WARNED / MAXSET * .FALSE. /
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKVLBA: Starting VLBA checks.' )
C
C     Check the FE specifications.
C     For understandability, step through the allowed combinations.
C
      OK = .FALSE.
C
      IF( ( FE(2,KS) .EQ. '90cm' .OR. FE(2,KS) .EQ. '50cm' .OR. 
     1      FE(2,KS) .EQ. 'omit' ) .AND.
     2    ( FE(4,KS) .EQ. '90cm' .OR. FE(4,KS) .EQ. '50cm' .OR. 
     3      FE(4,KS) .EQ. 'omit' ) .AND.
     4    ( FE(1,KS) .EQ. 'omit' .AND. FE(3,KS) .EQ. 'omit' ) ) 
     5   OK = .TRUE.
C
      IF( ( FE(1,KS) .EQ. '20cm' .OR. FE(1,KS) .EQ. 'omit' ) .AND.
     1    ( FE(3,KS) .EQ. '20cm' .OR. FE(3,KS) .EQ. 'omit' ) .AND.
     2    ( FE(2,KS) .EQ. '90cm' .OR. FE(2,KS) .EQ. 'omit' ) .AND. 
     3    ( FE(4,KS) .EQ. '90cm' .OR. FE(4,KS) .EQ. 'omit' ) ) 
     4   OK = .TRUE.
C
      IF( ( FE(1,KS) .EQ. '13cm' .OR. FE(1,KS) .EQ. 'omit' ) .AND.
     1    ( FE(3,KS) .EQ. '13cm' .OR. FE(3,KS) .EQ. 'omit' ) .AND.
     2    ( FE(2,KS) .EQ. '4cm' .OR. FE(2,KS) .EQ. 'omit' ) .AND.
     3    ( FE(4,KS) .EQ. '4cm' .OR. FE(4,KS) .EQ. 'omit' ) ) 
     4   OK = .TRUE.
C
      IF( ( FE(1,KS) .EQ. '6cm'  .OR. FE(1,KS) .EQ. 'omit' ) .AND.
     1    ( FE(3,KS) .EQ. '6cm'  .OR. FE(3,KS) .EQ. 'omit' ) .AND. 
     2    ( FE(2,KS) .EQ. '6cm'  .OR. FE(2,KS) .EQ. 'omit' ) .AND. 
     3    ( FE(4,KS) .EQ. '6cm'  .OR. FE(4,KS) .EQ. 'omit' ) )
     4   OK = .TRUE.
C
      IF( ( FE(2,KS) .EQ. '3cm' .OR. FE(2,KS) .EQ. 'omit' ) .AND.
     1    ( FE(4,KS) .EQ. '3cm' .OR. FE(4,KS) .EQ. 'omit' ) .AND.
     2    ( FE(1,KS) .EQ. 'omit' .AND. FE(3,KS) .EQ. 'omit' ) ) 
     3   OK = .TRUE.
C
      IF( ( FE(2,KS) .EQ. '2cm' .OR. FE(2,KS) .EQ. 'omit' ) .AND.
     1    ( FE(4,KS) .EQ. '2cm' .OR. FE(4,KS) .EQ. 'omit' ) .AND.
     2    ( FE(1,KS) .EQ. 'omit' .AND. FE(3,KS) .EQ. 'omit' ) ) 
     3   OK = .TRUE.
C
      IF( ( FE(2,KS) .EQ. '1cm' .OR. FE(2,KS) .EQ. '1.3cm' .OR. 
     1      FE(2,KS) .EQ. 'omit' ) .AND.
     2    ( FE(4,KS) .EQ. '1cm' .OR. FE(4,KS) .EQ. '1.3cm' .OR. 
     3      FE(4,KS) .EQ. 'omit' ) .AND.
     2    ( FE(1,KS) .EQ. 'omit' .AND. FE(3,KS) .EQ. 'omit' ) ) 
     3   OK = .TRUE.
C
      IF( ( FE(1,KS) .EQ. '7mm'  .OR. FE(1,KS) .EQ. 'omit' ) .AND.
     1    ( FE(3,KS) .EQ. '7mm'  .OR. FE(3,KS) .EQ. 'omit' ) .AND.
     2    ( FE(2,KS) .EQ. 'omit' .OR. FE(4,KS) .EQ. 'omit' ) ) 
     3   OK = .TRUE.
C
      IF( ( FE(2,KS) .EQ. '3mm' .OR. FE(2,KS) .EQ. 'omit' ) .AND.
     1    ( FE(4,KS) .EQ. '3mm' .OR. FE(4,KS) .EQ. 'omit' ) .AND.
     2    ( FE(1,KS) .EQ. 'omit' .AND. FE(3,KS) .EQ. 'omit' ) ) 
     3   OK = .TRUE.
C
      IF( .NOT. OK ) THEN
         CALL WLOG( 1, 'CHKVLBA: Invalid combination of FEs: ' )
         CALL WLOG( 1, '         1:'//FE(1,KS)//' 2:'//FE(2,KS)//
     1                ' 3:'//FE(3,KS)//' 4:'//FE(4,KS) )     
         ERRS = .TRUE.
      END IF
C
C     Make sure some front end was specified.
C
      IF( FE(1,KS) .EQ. 'omit' .AND. FE(2,KS) .EQ. 'omit' .AND.
     1    FE(3,KS) .EQ. 'omit' .AND. FE(4,KS) .EQ. 'omit' ) THEN
         CALL WLOG( 1, 'CHKVLBA: Some FEs must be specified for'//
     1           ' the VLBA.' )
         ERRS = .TRUE.
      END IF
C
C     Check for valid IF names.  I think user supplied names get
C     checked earlier, but an error can happen with freq.dat if some
C     channels, but not all, fit in the best freq.dat entry.  I had
C     this happen with and S/X wideband setup where I had not set
C     the sidebands properly, but had set the LOs.
C
      DO ICH = 1, NCHAN(KS)
         IFOK = .FALSE.
         DO IIF = 1, 4
            IF( IFCHAN(ICH,KS) .EQ. IFNAMES(IIF) ) THEN
               IFOK = .TRUE.
            END IF
         END DO
         IF( .NOT. IFOK ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I3, 3A )' )
     1         'CHKVLBA: Bad IF channel name, channel: ', ICH, 
     2         ', name: ''', IFCHAN(ICH,KS), ''''
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, '         Hint - check what came from ' //
     1         'the frequency file.' )
            ERRS = .TRUE.
         END IF
      END DO
C
C     Check the channels to be sure a front end was specified.
C     Allow for alternate inputs - eg mm VLBI.
C
      DO ICH = 1, NCHAN(KS)
         DO IIF = 1, 4
            IF( IFCHAN(ICH,KS) .EQ. IFNAMES(IIF) .AND. 
     1          FE(IIF,KS) .EQ. 'omit' .AND. (
     2          IFDIST(IIF,KS) .NE. 'A  ' .AND. 
     3          IFDIST(IIF,KS) .NE. 'A20' .AND.
     4          IFDIST(IIF,KS) .NE. '20A' ) ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I2, A, A, A, I2, A )' )
     1            'CHKVLBA: IF for channel ', ICH, ' is ', IFNAMES(IIF),
     2            ' but FE(', IIF, ') was not specified. '
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
            IF( IFCHAN(ICH,KS) .EQ. IFNAMES(IIF) .AND. (
     1          IFDIST(IIF,KS) .EQ. 'A  ' .OR.
     2          IFDIST(IIF,KS) .EQ. 'A20' .OR.
     3          IFDIST(IIF,KS) .EQ. '20A' ) ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( 2A )' )
     1           'CHKVLBA: WARNING - alternate IF specified for IF ', 
     2           IFNAMES(IIF)
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, '          I hope you know what you '//
     1                      'are doing!')
            END IF
         END DO
      END DO
C
C     Now check the synthesizer settings.  R8FREQ is a double
C     precision version of SYNTH in MHz.  It is used later too.
C     March 2013 SYNTH converted to double so this is simpler.  It is
C     now just the MHz version of Synth.
C
      DO I = 1, 3
C         R8FREQ(I) = DNINT( SYNTH(I,KS) * 1.D6 ) / 1.D3
         R8FREQ(I) = SYNTH(I,KS) * 1.D3
C
C        We need two versions here, one for the old synthesizers and
C        one for the new.  For the transition, only allow the fine
C        tuning if MODETEST is set.  Also, the new synthesizer hardware
C        will only be used for synthesizers 1 and 2.  An old style
C        synthesizer with its coarse tuning restrictions will be 
C        used for synthesizer 3.  The old synthesizers are thought to
C        put out a cleaner signal and, hence, are better for multiplying
C        up for receiver first LOs.
C
         IF( MODETEST(KS) .AND. ( I .EQ. 1 .OR. I .EQ. 2 ) ) THEN
            IF( BADLO( 'SYNTH X 1000.', R8FREQ(I), 0.01D0, 0, 0.D0,
     1          0.D0, 2000.0D0, 16000.D0, MSGTXT ) ) ERRS = .TRUE.
         ELSE
            IF( BADLO( 'SYNTH X 1000.', R8FREQ(I), 500.D0, 1, 100.D0, 
     1          0.D0, 2000.0D0, 16000.D0, MSGTXT ) ) ERRS = .TRUE.
         END IF
      END DO
C
C     Check the synthesizer settings against FIRSTLO.  Note that
C     this effectively checks that the right synthesizer was set.
C     Note that if alternate inputs are being used, believe the FIRSTLO.
C     It would be likely that the VLBA receiver systems are not being
C     used (eg mm VLBI)
C
C     While going through the receivers, set the bookkeeping of which
C     synthesizer is used for each IF.  This is only the synthesizer 
C     1 or 2, not synthesizer 3 which is used for the mix in the front 
C     end for the 1cm, 7mm, and 3mm receivers. The exception is when 
C     synthesizer 3 is used for the extra bandwidth mode in S/X.  zero 
C     means none which will apply for 50/90cm.
C
      DO ICH = 1, NCHAN(KS)
         OK = .TRUE.
         KIIF = 0
         VFESYN(ICH,KS) = 0
         DO IIF = 1, 4
            IF( IFCHAN(ICH,KS) .EQ. IFNAMES(IIF) .AND. (
     1          IFDIST(IIF,KS) .NE. 'A  ' .AND. 
     2          IFDIST(IIF,KS) .NE. 'A20' .AND.
     3          IFDIST(IIF,KS) .NE. '20A' ) ) THEN
C
C              90 and 50 cm use fixed LO's .  Actually, these bands
C              are equivalent - the frequency is selected with the
C              BBC frequency.  90cm has 500 MHz added.  50cm passes
C              straight through to the IF.
C
               IF( FE(IIF,KS) .EQ. '90cm' .OR. FE(IIF,KS) .EQ. '50cm' )
     1             THEN
                  IF( FIRSTLO(ICH,KS) .NE. -500.0D0 .AND.
     1                FIRSTLO(ICH,KS) .NE. 0.0D0 ) OK = .FALSE.
                  VFESYN(ICH,KS) = 0
C
C              4cm can use either of two synthesizers.
C
               ELSE IF( FE(IIF,KS) .EQ. '4cm' .AND. DUALX(KS) ) THEN
                  IF( IFCHAN(ICH,KS) .EQ. 'B' ) THEN
                     IF( ABS( FIRSTLO(ICH,KS) - R8FREQ(1) ) .GT. TEST )
     1                  OK = .FALSE.
                     VFESYN(ICH,KS) = 1
                  ELSE IF( IFCHAN(ICH,KS) .EQ. 'D' ) THEN
                     IF( ABS( FIRSTLO(ICH,KS) - R8FREQ(3) ) .GT. TEST )
     1                     OK = .FALSE.
                     VFESYN(ICH,KS) = 3
                  ELSE
                     CALL WLOG( 1, 'CHKVLBA: Bad IFCHAN in DUALX mode.')
                     ERRS = .TRUE.
                  END IF
C
C              Bands that use synthesizer 1.
C
               ELSE IF( FE(IIF,KS) .EQ. '3cm' .OR.
     1             ( FE(IIF,KS) .EQ. '4cm' .AND. .NOT. DUALX(KS) ) .OR.
     2               FE(IIF,KS) .EQ. '2cm' ) THEN
                  IF( ABS( FIRSTLO(ICH,KS) - R8FREQ(1) ) .GT. TEST )
     1               OK = .FALSE.
                  VFESYN(ICH,KS) = 1
C
C              Bands that use synthesizer 2.
C
               ELSE IF( FE(IIF,KS) .EQ. '20cm' .OR.
     1                  FE(IIF,KS) .EQ. '13cm' ) THEN
                  IF( ABS( FIRSTLO(ICH,KS) - R8FREQ(2) ) .GT. TEST) 
     1                OK = .FALSE.
                  VFESYN(ICH,KS) = 2
C
C              Deal with 6 cm which can use either.
C
               ELSE IF( FE(IIF,KS) .EQ. '6cm' .AND. 
     1                ( IFCHAN(ICH,KS) .EQ. 'A' .OR. 
     2                  IFCHAN(ICH,KS) .EQ. 'C' ) ) THEN
                  IF( ABS( FIRSTLO(ICH,KS) - R8FREQ(2) ).GT.TEST ) THEN
                     OK = .FALSE.
                  END IF
                  VFESYN(ICH,KS) = 2
               ELSE IF( FE(IIF,KS) .EQ. '6cm' .AND. 
     1                ( IFCHAN(ICH,KS) .EQ. 'B' .OR. 
     2                  IFCHAN(ICH,KS) .EQ. 'D' ) ) THEN
                  IF( ABS( FIRSTLO(ICH,KS) - R8FREQ(1) ).GT.TEST ) THEN
                     OK = .FALSE.
                  END IF
                  VFESYN(ICH,KS) = 1
C
C              1cm, 7mm, and 3mm use 2 synthesizers.
C
               ELSE IF ( FE(IIF,KS) .EQ. '1cm' .OR.
     1                   FE(IIF,KS) .EQ. '1.3cm' ) THEN
                  IF( ABS( FIRSTLO(ICH,KS) - ( R8FREQ(1) + R8FREQ(3) ) )
     1               .GT. TEST ) OK = .FALSE.
                  VFESYN(ICH,KS) = 1
C
               ELSE IF ( FE(IIF,KS) .EQ. '7mm' ) THEN
                  IF( ABS( FIRSTLO(ICH,KS) - 
     1                ( R8FREQ(2) + 3.0D0 * R8FREQ(3) ) ) .GT. TEST ) 
     2               OK = .FALSE.
                  VFESYN(ICH,KS) = 2
C
               ELSE IF ( FE(IIF,KS) .EQ. '3mm' ) THEN
                  IF( ABS( FIRSTLO(ICH,KS) - 
     1                ( R8FREQ(1) + 6.0D0 * R8FREQ(3) ) ) .GT. TEST ) 
     2               OK = .FALSE.
                  VFESYN(ICH,KS) = 1
C
C              Shouldn't get here.
C
               ELSE
                  CALL WLOG( 1, 'CHKVLBA: Cannot check synthesizers '//
     1                  'because of bad FE' )
                  ERRS = .TRUE.
               END IF              
               KIIF = IIF
            END IF
         END DO
C
C        Write message for this channel.
C
         IF( .NOT. OK ) THEN
            MSGTXT = ' '
            IF( IIF .NE. 0 ) THEN
               WRITE( MSGTXT, '( A, I2, A, A )' )
     1           'CHKVLBA: FIRSTLO for channel ', ICH, 
     2           ' incorrect for SYNTH setting for ', FE(KIIF,KS)
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, '         Check settings and which '//
     1                   'synthesizer is being set.' )
            ELSE
               CALL WLOG( 1, 'CHKVLBA: Bad IFCHAN spec - cannot '//
     1               'check FIRSTLO' )
            END IF
            ERRS = .TRUE.
         END IF
C
      END DO      
C
C     Check the 50 cm filter.
C
      IF( LCP50CM(KS) .NE. 'NARROW' .AND. LCP50CM(KS) .NE. 'BROAD' )
     1   THEN
         CALL WLOG( 1, 'CHKVLBA: Invalid LCP50CM = '//LCP50CM(KS) )
         ERRS = .TRUE.
      END IF
      IF( RCP50CM(KS) .NE. 'NARROW' .AND. RCP50CM(KS) .NE. 'BROAD' )
     1   THEN
         CALL WLOG( 1, 'CHKVLBA: Invalid RCP50CM = '//RCP50CM(KS) )
         ERRS = .TRUE.
      END IF
C
C     Check the noise specifications.
C
      IF( NOISEFRQ(KS) .NE. 'VLA' .AND. NOISEFRQ(KS) .NE. 'VLBA' ) THEN
         CALL WLOG( 1, 'CHKVLBA: Invalid NOISEFRQ = '//NOISEFRQ(KS) )
         ERRS = .TRUE.
      END IF
      DO IIF = 1, 4
         IF( NOISE(IIF,KS) .NE. 'off' .AND.
     1       NOISE(IIF,KS) .NE. 'low-s' .AND.
     2       NOISE(IIF,KS) .NE. 'low-c' .AND.
     3       NOISE(IIF,KS) .NE. 'high-s' .AND.
     4       NOISE(IIF,KS) .NE. 'high-c' .AND.
     5       NOISE(IIF,KS) .NE. 'low-s' ) THEN
            CALL WLOG( 1, 'CHKVLBA: Invalid NOISE = '//NOISE(IIF,KS) )
            ERRS = .TRUE.
         END IF
      END DO
C
C     Try to prevent LOs from some channels interfering with other 
C     channels.  This is mainly an issue for the wide C band but 
C     do a more generic check.  Don't attempt to be clever to avoid
C     looking at all channels.
C
C     The limits used for the test are rather arbitrary and drawn out
C     of a hat, but should be reasonable.
C     Don't check P band this way.
C     Jan. 10, 2014  Saw plots of the filter shapes today.  The IF
C     filters in the IF converters are very soft on the low side and
C     somewhat sharper on the high side.  Plus the RDBE band is shifted
C     higher than the previous center.  Previously the low and high
C     limits for this warning were 400 and 1200.  Keep the 1200,
C     but drop the lower limit to 300.
C
      LOIFWARN = .TRUE.
      DO ICH = 1, NCHAN(KS)
         IF( FIRSTLO(ICH,KS) .GT. 1000.D0 ) THEN
            IF( SIDE1(ICH,KS) .EQ. 'U' ) THEN
               TFR1 = FIRSTLO(ICH,KS) + 300.0D0
               TFR2 = FIRSTLO(ICH,KS) + 1200.0D0
            ELSE 
               TFR1 = FIRSTLO(ICH,KS) - 1200.0D0
               TFR2 = FIRSTLO(ICH,KS) - 300.0D0
            END IF
            DO JCH = 1, NCHAN(KS)
               IF( FIRSTLO(JCH,KS) .GT. TFR1 .AND. 
     1             FIRSTLO(JCH,KS) .LT. TFR2 .AND.
     2             LOIFWARN .AND. FIRSTLO(JCH,KS) .GT. 1000.D0 ) THEN
                  CALL WLOG( 1, ' ' )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I3, A, A, A )' )
     1               'CHKVLBA WARNING:  In setup ', KS, ' the first ',
     2               ' LO for one channel is in or close to the IF ',
     3               ' for another.'
                  CALL WLOG( 1, MSGTXT )
                  CALL WLOG( 1, 
     1              '               This can cause bad interference' )
                  CALL WLOG( 1,
     1              '               See sched.runlog for details.' )
                  CALL PRTSET( KS, ILOG ) 
                  LOIFWARN = .FALSE.
               END IF
            END DO
         END IF
      END DO
C
C     Do some special S band checks.
C
      IF( ( FE(1,KS) .EQ. '13cm' .OR. FE(1,KS) .EQ. '13cm' ) .AND.
     1    .NOT. WARNED(ISETNUM(KS)) ) THEN
         GOTWARN = .FALSE.
         DO ICH = 1, NCHAN(KS)
            IF( IFCHAN(ICH,KS) .EQ. 'A' .OR. 
     1          IFCHAN(ICH,KS) .EQ. 'C' ) THEN
C
C              Get the high and low RF frequencies.
C
               IF( NETSIDE(ICH,KS) .EQ. 'U' ) THEN
                  FRLOW = FREQREF(ICH,KS)
                  FRHIGH = FREQREF(ICH,KS) + BBFILT(ICH,KS)
               ELSE
                  FRLOW = FREQREF(ICH,KS) - BBFILT(ICH,KS)
                  FRHIGH = FREQREF(ICH,KS)
               END IF
C
C              Warn if out of RFI filter.
C
               IF( FRLOW .LT. 2200.D0 ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I4, A, A, A, I3, A, F7.0, ' //
     1                    ' A, F7.0, A )' )
     2                'CHKVLBA:  Setup ', KS, ' at ', SETSTA(1,KS),
     3                '.  Channel ', ICH, ', ', FRLOW, '-', FRHIGH,
     4                ' MHz partially or fully '
                  CALL WLOG( 1, MSGTXT )
C
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A )' )
     1                '          below the bottom of the 2200-2400 ',
     2                 'MHz RFI filter at all sites but PT, MK, FD'
                  CALL WLOG( 1, MSGTXT )
                  GOTWARN = .TRUE.
               END IF

               IF( FRHIGH .GT. 2400.D0 ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I4, A, A, A, I3, A, F7.0, ' //
     1                    ' A, F7.0, A )' )
     2                'CHKVLBA:  Setup ', KS, ' at ', SETSTA(1,KS),
     3                '.  Channel ', ICH, ', ', FRLOW, '-', FRHIGH,
     4                ' MHz partially or fully '
                  CALL WLOG( 1, MSGTXT )
C
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A )' )
     1                '          above the top of the 2200-2400 ',
     2                 'MHz RFI filter at all sites but PT, MK, FD'
                  CALL WLOG( 1, MSGTXT )
                  GOTWARN = .TRUE.
               END IF
C
C              Warn of satellite radio
C
               IF( FRLOW .LT. 2345.D0 .AND. FRHIGH .GT. 2320.D0 ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I4, A, A, A, I3, A,  F7.0, ' //
     1                    ' A, F7.0, A )' )
     2                'CHKVLBA:  Setup ', KS, ' at ', SETSTA(1,KS),
     3                '.  Channel ', ICH, ', ', FRLOW, '-', FRHIGH,
     4                ' MHz will be affected'
                  CALL WLOG( 1, MSGTXT )
C
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A )' )
     1                '          by strong RFI from Sirius and ',
     2                 'XM satellite radio between 2320 and 2345 MHz.'
                  CALL WLOG( 1, MSGTXT )
                  GOTWARN = .TRUE.
               END IF
            END IF
         END DO
         IF( GOTWARN ) THEN
            WARNED(ISETNUM(KS)) = .TRUE.
            CALL WLOG( 1, 'CHKVLBA:  S band warnings not repeated '//
     1          'for other stations using the same setup file.' )
         END IF
      END IF
C
C     That's all for now.  More could be added some day.
C
      RETURN
      END

      CHARACTER*32 FUNCTION VXNMPR( IXX )
C
C     Routine specific for the VEX extension of SCHED
C     function generates a name for PR block IXX
C     NOTE: slightly less general then other "vxnm" routines
C     By H.J. van Langevelde, JIVE, 010996
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
      INTEGER IXX
C ----------------------------------------------------------------------
C
C     Pass order depends on TAPEMODE
C
      WRITE( VXNMPR, '( A, I2.2 )' ) 'Mode_', IXX
C
      RETURN
      END

      SUBROUTINE OPTHIEL( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
Cf2py intent(in) LASTISCN, ISCN
Cf2py intent(in, out) KSCN
Cf2py intent(out) ADJUST, KEEP, DONE
C
C     Routine for optimization mode of sched that decides what to
C     do with the next input scan.  It is used for OPTMODE=HIGHEL
C     It will construct a new scan list (ISCN > NSCANS) using a 
C     simple scheme.  Each time it encounters a scan with the
C     parameter HIGROUP set greater than 1, it will consider the
C     next HIGROUP scans and select the one with the highest
C     minimum elevation across the array.  It will only use that
C     one scan of the group, and will push KSCN ahead so that the
C     next scan is the one beyond the group.
C
      INCLUDE 'sched.inc'
C
      INTEGER           LASTISCN(MAXSTA), KSCN, ISCN
      LOGICAL           KEEP, ADJUST, DONE
C
      INTEGER           NGOOD, NPRIO, SKIP(MAXSRC), ISTA, ISRC
      INTEGER           MISSED, JKSCN, JISCN, MSCN
      REAL              SCNLO, GRPMXLO, ELA
      DOUBLE PRECISION  TAPPROX, TBEGIN, T_AVAIL, LASTTIME
      LOGICAL           OKSTA(MAXSTA), USESTA
      SAVE              SKIP, MISSED
C ---------------------------------------------------------------------
      DONE = .FALSE.
C
C     Do not allow fixed times (too confusing).
C
      ADJUST = .TRUE.
C
C     KSCN is the count of input scans for this optimization mode.
C     Quit when all have been processed.
C
      IF( KSCN .GT. NSCANS ) THEN
         DONE = .TRUE.
         GO TO 999
      END IF
C
C     Make sure HIGROUP is at least 1.  Also be sure it is not
C     large enough to go past the input scans.
C
      HIGROUP(KSCN) = MAX( HIGROUP(KSCN), 1 )
      IF( KSCN + HIGROUP(KSCN) - 1 .GT. NSCANS ) THEN
         CALL ERRLOG( 'OPTHIEL: HIGROUP in last scan too large.' )
      END IF
C
C     Just copy the input to the output if HIGROUP(KSCN) = 1
C
      IF( HIGROUP(KSCN) .EQ. 1 ) THEN
         CALL SCNDUP( ISCN, KSCN, .TRUE., 'OPTHIEL' )
         GO TO 999
      END IF
C
C     Get the time to use for the geometric calculations.
C     Use the most recent stop time for any antenna scheduled to be 
C     in any of the HIGROUP scans.
C
C     Use the nominal start time if this is the first scan for
C     all participating stations.  Also, make sure if only some 
C     antennas are new, they don't set the start time.
C
      TAPPROX = TFIRST
      DO ISTA = 1, NSTA
         USESTA = .FALSE.
         DO JKSCN = KSCN, KSCN + HIGROUP(KSCN) - 1
            IF( STASCN(JKSCN,ISTA) ) USESTA = .TRUE.
         END DO
         IF( USESTA ) THEN
            IF( LASTISCN(ISTA) .NE. 0 ) THEN
               TAPPROX = MAX( TAPPROX, 
     1              STOPJ(LASTISCN(ISTA)) + GAP(ISCN) )
            END IF
         END IF
      END DO
C
C     Copy the next HIGROUP input scans to the output scans and
C     get their geometries. Ultimately all but one will be overwritten.
C
      GRPMXLO = -100.0
      DO JKSCN = KSCN, KSCN + HIGROUP(KSCN) - 1
         JISCN = ISCN + JKSCN - KSCN
         CALL SCNDUP( JISCN, JKSCN, .TRUE., 'OPTHIEL' )
         SCNLO = 100.0
         DO ISTA = 1, NSTA
            IF( STASCN(JISCN,ISTA) ) THEN
               CALL STAGEO( JISCN, ISTA, TAPPROX, LASTISCN(ISTA),  
     1          LASTTIME, T_AVAIL, 'OPTSKD' )
               ELA = ( EL1(JISCN,ISTA) + EL2(JISCN,ISTA) ) / 2.0
               SCNLO = MIN( SCNLO, ELA )
            END IF
         END DO
         IF( SCNLO .GT. GRPMXLO ) THEN
            GRPMXLO = SCNLO
            MSCN = JISCN            
         END IF
      END DO
C
C     So scan MSCN is the one with the highest minimum elevation.
C
C     Move it to output scan ISCN.
C
      CALL SCNDUP( ISCN, MSCN, .TRUE., 'OPTHIEL' )
C
C     Adjust KSCN so we don't look again at the scans just considered.
C     Should end up here being one less than the input scan we
C     wish to consider next.
C
      KSCN = KSCN + HIGROUP(KSCN) - 1
C
C     Jump here when done.
C
  999 CONTINUE
C
C     Set KEEP.  I don't think this routine should ever want a scan
C     not kept.
C
      KEEP = .TRUE.
      RETURN
      END

      SUBROUTINE FILEOPEN( ISTA, OVBA, OLOC )
C
C     Opens the station files for SCHED.  They are:
C       1.  The crd. file - VLBA style file for control of the tape 
C                           drives and, for many stations, the
C                           antennas.
C       2.  The obs. file - for antenna control where that requires
C                           a file different from the crd. file.
C                           These are no longer used, but have not
C                           been stripped out yet (Dec 2012)
C       3.  The sch. file - Something for operators or the scheduler
C                           to look at for a readable summary of
C                           scans for that station.
C
C     Called from the SCHED main routine to avoid clutter there.
C
C --------------------------------------------------------------------
C
      INCLUDE    'sched.inc'
C
      INTEGER      ISTA, LEN1, IOERR, VLBOPE
      CHARACTER    PRTFILE*80, CRDFILE*80, OPTEXT*255
      CHARACTER    CRDTYPE*4, OPSTAT*4
      LOGICAL      OVBA, OLOC, EXISTS
C --------------------------------------------------------------------
      CALL WLOG( 1, ' Processing ' // STANAME(ISTA) )
C
C     Open printed schedule file
C
      WRITE( PRTFILE, '(A,A,A)' ) EXPCODE(1:LEN1(EXPCODE)), 
     1          'SCH.', STCODE(STANUM(ISTA))
      CALL DWCASE( PRTFILE )
      INQUIRE( FILE=PRTFILE, EXIST=EXISTS )
      IF( EXISTS .AND. OVERWRIT ) THEN
         OPSTAT = 'OLD'
      ELSE IF( EXISTS ) THEN
         CALL WLOG( 1, 'FILEOPEN: '//PRTFILE//' already exists.' )
         CALL ERRLOG( 'FILEOPEN: You need to delete old output files'
     1                // ' or set OVERWRIT.' )
      ELSE
         OPSTAT = 'NEW'
      END IF
      IOERR = VLBOPE( IPRT, PRTFILE, 'TEXT', OPSTAT, OPTEXT )
      IF( IOERR .NE. 1 ) CALL ERRLOG( OPTEXT )
C
C     Open file for telescope control.  There are a number
C     of stations that need 2 files, one for the DAR and
C     one for the antenna.  VLBADAR is true for them.
C
      IF( CONTROL(STANUM(ISTA)) .NE. 'NONE' ) THEN
C
C        Open a VLBA type control file if needed.  CRDTYPE is the
C        part of the file name that identifies the type of file.
C        It is crd. for the primary control file and obs. for the
C        antenna control file for stations that need separate 
C        antenna and tape control files.  If this is pure VLA,
C        don't open a file.
C
         OVBA = .FALSE.
         OLOC = .FALSE.
C
         IF( ( CONTROL(STANUM(ISTA)) .EQ. 'VLBA' .OR.
     1       VLBADAR(STANUM(ISTA)) ) .AND. .NOT. VLAONLY ) THEN
            CRDTYPE = 'crd.'
            WRITE( CRDFILE, '(A,A,A)' ) EXPCODE(1:LEN1(EXPCODE)), 
     1            CRDTYPE, STCODE(STANUM(ISTA))
            CALL DWCASE( CRDFILE )
            INQUIRE( FILE=CRDFILE, EXIST=EXISTS )
            IF( EXISTS .AND. OVERWRIT ) THEN
               OPSTAT = 'OLD'
            ELSE IF( EXISTS ) THEN
               CALL WLOG( 1, 'FILEOPEN: '//CRDFILE//' already exists.' )
               CALL ERRLOG( 'FILEOPEN: You need to delete old output '
     1                // 'files or set OVERWRIT.' )
            ELSE
               OPSTAT = 'NEW'
            END IF
            IOERR = VLBOPE( IUVBA, CRDFILE, 'TEXT', OPSTAT, OPTEXT )
            IF( IOERR .NE. 1 ) CALL ERRLOG( OPTEXT )
            OVBA = .TRUE.
         END IF
C 
C        Open other types of control files.
C          Shouldn't get here because these files are no longer being 
C          used.  But there are a few "CONTROL=VSOP" stations still
C          in the station catalog so be careful.
C
         IF( CONTROL(STANUM(ISTA)) .NE. 'VLBA' .AND. 
     1       CONTROL(STANUM(ISTA)) .NE. 'VEX' ) THEN
            CRDTYPE = 'obs.'
            WRITE( CRDFILE, '(A,A,A)' ) EXPCODE(1:LEN1(EXPCODE)), 
     1            CRDTYPE, STCODE(STANUM(ISTA))
            CALL DWCASE( CRDFILE )
            INQUIRE( FILE=CRDFILE, EXIST=EXISTS )
            IF( EXISTS .AND. OVERWRIT ) THEN
               OPSTAT = 'OLD'
            ELSE IF( EXISTS ) THEN
               CALL WLOG( 1, 'FILEOPEN: '//CRDFILE//' already exists.' )
               CALL ERRLOG( 'FILEOPEN: You need to delete old output '
     1                // 'files or set OVERWRIT.' )
            ELSE
               OPSTAT = 'NEW'
            END IF
            IOERR = VLBOPE( IULOC, CRDFILE, 'TEXT', OPSTAT, OPTEXT)
            IF( IOERR .NE. 1 ) CALL ERRLOG( OPTEXT )
            OLOC = .TRUE.
         END IF
C
      END IF
C     
      RETURN
      END

      SUBROUTINE SRCLST( IOUT, MODE )
C
C     Subroutine for SCHED that writes source list to print file.
C     MODE=2 - write a second list in format for transfer of 
C              coordinates to the correlator data base.
C     MODE=1 - No such second list.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schpeak.inc'
C
      INTEGER       MSEP, ML
      PARAMETER     ( MSEP = 7 )
      PARAMETER     ( ML = 20 )
C
      INTEGER       ISRC, IOUT, J, K, MODE
      INTEGER       NPAIRS, ISEP, IP
      INTEGER       KSRC, JN, KN
      INTEGER       HISTSEP(MSEP)
      REAL          HISTLEV(MSEP)
      REAL          MAXSEP, SRCSEP
      DOUBLE PRECISION  SLA_DSEP
      LOGICAL       ANYS(3)
      DATA          HISTLEV / 3.0, 5.0, 7.5, 10.0, 15., 20., 30. /
C ------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'SRCLST starting.' )
C
C     Detect if there are sources in any of the 3 categories.  Those
C     are 1) used in recording, 2) used in non-recoreding scans, and
C     3) used in multiple phase center lists.
C
      DO IP = 1, 3
         ANYS(IP) = .FALSE.      
      END DO
      DO ISRC = 1, MSRC
         IF( USEDREC(ISRC) ) ANYS(1) = .TRUE.
         IF( SUSED(ISRC) .AND. .NOT. USEDREC(ISRC) ) ANYS(2) = .TRUE.
         IF( USEDPHS(ISRC) .AND. .NOT. SUSED(ISRC) ) ANYS(3) = .TRUE.
      END DO
C
C     Actually write the main source list.
C
      DO IP = 1, 3
         IF( ANYS(IP) ) THEN
            CALL SRCWRT( IOUT, IP )
         END IF
      END DO
C
C     Give sun distance summary.
C
      WRITE( IOUT, '( 2( 1X, / ), A )' ) 'EFFECT OF SOLAR CORONA'
      WRITE( IOUT, '( 1X, /, A, A, /, A, A )' )
     1  '  The solar corona can cause unstable phases for sources',
     2  ' too close to the Sun.',
     3  '  SCHED provides warnings at individual scans for distances',
     4  ' less than 10 degrees.'
C
      WRITE( IOUT, '( A, A, /, A )' )
     1    '  The distance from the Sun to each source in this schedule',
     2    ' is:',
     3    '    Source         Sun distance (deg) '
      DO ISRC = 1, MSRC
         IF( SUSED(ISRC) ) THEN
            DO J = 1, MALIAS
               IF( CSUSED(J,ISRC) .NE. ' ' ) THEN
                  WRITE( IOUT, '( 3X, A12, 4X, F8.1 )' )
     1                 SOURCE(J,ISRC), SUNDIS(ISRC)
               END IF
            END DO
         END IF
      END DO
C
      WRITE( IOUT, '( X, /, A, A, /, A, A, /, A, /, A )' )
     1  '  Barry Clark estimates from predictions by Ketan Desai of',
     2  ' IPM scattering sizes ', 
     3  '  that the Sun will cause amplitude reductions on the ',
     4  ' longest VLBA baselines ',
     5  '  at a solar distance of 60deg F^(-0.6) where F is in GHz. ',
     6  '  For common VLBI bands, this is: '
C
      WRITE( IOUT, '( 9(A, F8.0, A, /) )' )
     1  '       327 MHz    ', 60.0*(0.327**(-0.6)), ' deg ',
     1  '       610 MHz    ', 60.0*(0.610**(-0.6)), ' deg ',
     1  '       1.6 GHz    ', 60.0*(1.6**(-0.6)), ' deg ',
     1  '       2.3 GHz    ', 60.0*(2.3**(-0.6)), ' deg ',
     1  '       5.0 GHz    ', 60.0*(5.0**(-0.6)), ' deg ',
     1  '       8.4 GHz    ', 60.0*(8.4**(-0.6)), ' deg ',
     1  '      15.0 GHz    ', 60.0*(15.**(-0.6)), ' deg ',
     1  '      22.0 GHz    ', 60.0*(22.**(-0.6)), ' deg ',
     1  '      43.0 GHz    ', 60.0*(43.**(-0.6)), ' deg '
C
C     Make a list of source separations for pairs closer than some
C     amount.  Make two passes through this part of the code.  For
C     the first, make a cumulative histogram of the number of pairs
C     of each separation.  Then determine the maximum separation to
C     use and still give a finite list.  Then go through writing the
C     list.  Never try going above 30 deg.
C
      IF( IOUT .EQ. ISUM .AND. MSRC .GE. 2 ) THEN
         DO ISEP = 1, MSEP
            HISTSEP(ISEP) = 0
         END DO
         MAXSEP = 1.0
         DO K = 1, 2
            IF( K .EQ. 2 ) THEN
               WRITE( IOUT, '( 1X, A )' ) 'SOURCE SEPARATIONS'
               WRITE( IOUT, '( 1X, /, A, F6.2, A, /, 1X )' )
     1          ' Source separations in degrees for pairs closer than ',
     2            MAXSEP,' degrees.'
            END IF
C
            NPAIRS = 0
            DO ISRC = 1, MSRC - 1
               IF( SUSED(ISRC) ) THEN
                  JN = 1
                  DO J = 1, MALIAS
                     IF( CSUSED(J,ISRC) .NE. ' ' ) THEN
                        JN = J
                     END IF
                  END DO
                  DO KSRC = ISRC + 1, MSRC
                     IF( SUSED(KSRC) ) THEN
                        KN = 1
                        DO J = 1, MALIAS
                           IF( CSUSED(J,KSRC) .NE. ' ' ) THEN
                              KN = J
                           END IF
                        END DO
                        SRCSEP = SLA_DSEP( RAP(ISRC), DECP(ISRC),
     1                       RAP(KSRC), DECP(KSRC) ) / RADDEG
C
C                       On first pass, fill out the histogram.
C                       On the second, write the pair.
C
                        IF( K .EQ. 1 ) THEN
                           DO ISEP = 1, MSEP
                              IF( SRCSEP .LE. HISTLEV(ISEP) ) THEN
                                 HISTSEP(ISEP) = HISTSEP(ISEP) + 1
                              END IF
                           END DO
                        ELSE IF( SRCSEP .LE. MAXSEP ) THEN
                           WRITE( IOUT, 
     1                        '( 5X, A12, 2X, A12, 2X, F8.4 )' )
     2                        SOURCE(JN,ISRC), SOURCE(KN, KSRC), SRCSEP
                           NPAIRS = NPAIRS + 1
                        END IF
                     END IF
                  END DO
               END IF
            END DO
C
C           On the first pass, determine MAXSEP
C
            IF( K .EQ. 1 ) THEN
               DO ISEP = 1, MSEP
                  IF( HISTSEP(ISEP) .LE. 50 ) THEN
                     MAXSEP = HISTLEV(ISEP)
                  END IF
               END DO
            END IF
         END DO
      END IF
C
C     Now make the third source list in the format for the transfer 
C     of coordinates to the correlator data base.  This was for the
C     old VLBA data base and may no longer be needed.
C     On Feb. 4, 2013, Paul Dyer said they don't need it so I am 
C     commenting it out.  If someone squawks, it can be put back.
C
C Put in front.     CHARACTER*16  TFORM, TRA20, TDEC20
C                   INTEGER       LENS, LENR, LEND, LEN1
C
C      IF( MODE .EQ. 2 .AND. .NOT. NOTAPE ) THEN
C         WRITE( IOUT, '( 3( 1X, / ), A, A )' )
C     1      'SOURCE LIST IN SPECIAL FORMAT'
C         WRITE( IOUT, '( 1X, /, A, A )' )
C     1      ' J2000 coordinates formatted for possible transfer to ',
C     2      'the correlator data base:' 
C         DO ISRC = 1, MSRC
C            IF( SUSED(ISRC) ) THEN
C               TRA20 = TFORM( RA2000(ISRC), 'T', 0, 2, 9, 'hms' )
C               LENR = LEN1( TRA20 )
C               IF( D2000(ISRC) .GE. 0.D0 ) THEN
C                 TDEC20 = TFORM( D2000(ISRC),  ' ', 0, 2, 8, 'd''"' )
C               ELSE
C                 TDEC20 = TFORM( D2000(ISRC),  ' ', 1, 2, 8, 'd''"' )
C               END IF
C               LEND = LEN1( TDEC20 )
CC
C               DO J = 1, MALIAS
C                  IF( CSUSED(J,ISRC) .NE. ' ' ) THEN
C                     LENS = LEN1( SOURCE(J,ISRC) )
C                     
C                     WRITE( IOUT, '( 6A )' )
C     1                 'name = ''', SOURCE(J,ISRC)(1:LENS),
C     2                 '''  ra = ', TRA20(1:LENR),
C     3                 '  dec = ', TDEC20(1:LEND)
C                  END IF
C               END DO
C            END IF
C         END DO
C      END IF
C
      RETURN
      END

      DOUBLE PRECISION FUNCTION sla_EPB2D (EPB)
*+
*     - - - - - -
*      E P B 2 D
*     - - - - - -
*
*  Conversion of Besselian Epoch to Modified Julian Date
*  (double precision)
*
*  Given:
*     EPB      dp       Besselian Epoch
*
*  The result is the Modified Julian Date (JD - 2400000.5).
*
*  Reference:
*     Lieske,J.H., 1979. Astron.Astrophys.,73,282.
*
*  P.T.Wallace   Starlink   February 1984
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION EPB


      sla_EPB2D = 15019.81352D0 + (EPB-1900D0)*365.242198781D0

      END

      REAL FUNCTION sla_VDV (VA, VB)
*+
*     - - - -
*      V D V
*     - - - -
*
*  Scalar product of two 3-vectors  (single precision)
*
*  Given:
*      VA      real(3)     first vector
*      VB      real(3)     second vector
*
*  The result is the scalar product VA.VB (single precision)
*
*  P.T.Wallace   Starlink   November 1984
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      REAL VA(3),VB(3)


      sla_VDV=VA(1)*VB(1)+VA(2)*VB(2)+VA(3)*VB(3)

      END

      SUBROUTINE STANO( NAME, KSTA, ISTA, DOIT )
C
C     Routine that finds a station NAME in the station catalog.
C     NAME can match either the catalog station name or the
C     station code.
C
C     KSTA is the station catalog index (STATION and STCODEU).  Zero
C          implies NAME not in list.
C     ISTA is the index in the schedule station list entry (STANAME).
C          Zero implies station not in list.  Note that a station
C          must be in the catalog to be in STANAME.
C     DOIT is true if station name (STATION(ISTA)) matches DOSTA.
C
C     While at it, do not allow NAME to match two stations (this
C     will disallow scheduling with codes where two antennas at the
C     same site have the same code).
C
      INCLUDE   'sched.inc'
C
      CHARACTER   NAME*(*)
      INTEGER     ISTA, JSTA, KSTA, NC, LEN1
Cf2py intent(out) ISTA
Cf2py intent(out) KSTA
      LOGICAL     DOIT
Cf2py intent(out) DOIT
C ---------------------------------------------------------------
C     First find the station in the catalog.  Allow matches with
C     either the station code or the station name.  Don't allow more
C     than one match.  STREAD already prevented multiple entries
C     with the same name, so multiple matches are likely to be code
C     problems.
C
      KSTA = 0
      DO JSTA = 1, MSTA
         IF( NAME .EQ. STATION(JSTA) .OR.
     1       NAME .EQ. STCODEU(JSTA) ) THEN
            IF( KSTA .EQ. 0 ) THEN
               KSTA = JSTA
            ELSE
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, A )' ) 
     1               'STANO:  Station name ', NAME(1:LEN1(NAME)),
     2               ' matches 2 catalog stations.'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, A )' ) 
     1               '        You may be using the station',
     2              ' code for a site with multiple entries in ',
     3              'the stations catalog.'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A )' ) 
     1               '        This can happen if there are multiple',
     2               ' antennas or recording systems at a site.'
               CALL WLOG( 1, MSGTXT )
               WRITE( MSGTXT, '( A, A )' ) 
     1               '        If so, you should use the station ',
     2               'name which will be distinct.'
               CALL WLOG( 1, MSGTXT )
               CALL ERRLOG(  '        Fix the station list.' )
            END IF
         END IF
      END DO
C
C     Check for STANAME index.  Comparing catalog station name against
C     previously found stations, if any.
C
      ISTA = 0
      IF( KSTA .GT. 0 .AND. NSTA .GT. 0 ) THEN
         DO JSTA = 1, NSTA
            IF( STATION(KSTA) .EQ. STANAME(JSTA) ) THEN
               ISTA = JSTA
            END IF
         END DO
      END IF
C
C     Now check against DOSTA.
C
      NC = LEN1( DOSTA )
      IF( DOSTA .EQ. 'ALL' ) THEN
         DOIT = .TRUE.
      ELSE
         IF( KSTA .GT. 0 ) THEN
            DOIT = STATION(KSTA)(1:NC) .EQ. DOSTA(1:NC)
         ELSE
            DOIT = NAME(1:NC) .EQ. DOSTA(1:NC)
         END IF
      END IF
C
      RETURN
      END

      CHARACTER*32 FUNCTION VXNMDA( IXX )
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 020596 
C     function generates a name for DA block IXX
C     for VLBA & 1 drive only density and poss tapelength
C
C     Some tape stuff removed July 22, 2010 RCW.  It is possible
C     this whole routine isn't needed any more, but I didn't chase
C     that.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER IXX, KS, ISTA, LEN1, LPOS, I, ISCAT
      CHARACTER NAME*32
C ----------------------------------------------------------------------
C     
C     Find a station that uses this DAS def
C
      ISTA = -1
      DO I = 1, NSTA
         IF( ISTADA(I) .EQ. IXX ) ISTA = I
      END DO
C
      IF( ISTA .LT. 0 ) CALL ERRLOG(' VXNMDA: no station for DAS def ')
C
C     and a set in which this station occurs
C
      ISCAT = STANUM(ISTA)
      DO I = 1, NSET
         IF ( USED(I) .AND. (
     1       STATION(ISCAT) .EQ. SETSTA(1,I) )) KS = I
      END DO
C
C     name depends on density (and number of drives and tape length)
C
      WRITE( NAME, '( I1 )' ) STNDRIV(ISCAT)
C
      LPOS = LEN1(NAME)+1
      WRITE( NAME(LPOS:), '( A )' ) DAR( ISCAT )
      LPOS = LEN1(NAME)+1
      IF( RECORDER(ISCAT) .NE. DAR(ISCAT) ) THEN
         WRITE( NAME(LPOS:), '( A1 )' ) '+'
         LPOS = LPOS+1
         WRITE( NAME(LPOS:), '( A )' ) RECORDER(ISCAT)
      END IF
      LPOS = LEN1(NAME)+1
C
C     Deleted check of NHEADS that only went if USETAPE.
C
C     density & length
C
      LPOS = LEN1(NAME)+1
      NAME(LPOS:LPOS) = '<'
      LPOS = LPOS+1
C
C     Deleted S2 stuff and USETAPE stuff.
C
      IF ( USEDISK(ISTA) .AND. DISK(STANUM(ISTA)) .EQ. 'MARK5A' )
     1     THEN
         NAME(LPOS:LPOS+5) = 'Mark5A'
      ELSE IF ( USEDISK(ISTA) .AND. DISK(STANUM(ISTA)) .EQ. 'LBADR' )
     1     THEN
         NAME(LPOS:LPOS+4) = 'LBADR'
      END IF
C
      VXNMDA = NAME
C
      RETURN
      END

      SUBROUTINE OPENWRAP ( UNIT, RNAME, RTYPE, RSTATUS, RESULT, RET)
Cf2py intent(in) UNIT, RNAME, RTYPE, RSTATUS
Cf2py intent(out) RESULT, RET
      INTEGER UNIT
      CHARACTER RNAME*80
      CHARACTER RTYPE*10
      CHARACTER RSTATUS*10
      CHARACTER RESULT*255
      INTEGER RET, VLBOPE
      RET = VLBOPE(UNIT, RNAME, RTYPE, RSTATUS, RESULT)
      RETURN
      END

      DOUBLE PRECISION FUNCTION sla_DRANRM (ANGLE)
*+
*     - - - - - - -
*      D R A N R M
*     - - - - - - -
*
*  Normalize angle into range 0-2 pi  (double precision)
*
*  Given:
*     ANGLE     dp      the angle in radians
*
*  The result is ANGLE expressed in the range 0-2 pi.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION ANGLE

      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925286766559D0)


      sla_DRANRM = MOD(ANGLE,D2PI)
      IF (sla_DRANRM.LT.0D0) sla_DRANRM = sla_DRANRM+D2PI

      END

      SUBROUTINE SCNDUP( TO, FROM, COPYALL, CALLER )
C
C     Routine for sched that copies one scan (FROM) into scan another 
C     (TO). It copies all items which have a MAXSCN array size
C     in sched.inc.  Last checked 20oct2000 RCW.
C
C     It is used for expanding loops in SCHIN through SCHREP.
C
C     It is also used by some optimization routines such as OPTCELLS
C     that make a new schedule and by the reference pointing inserters.
C
C     If COPYALL is set, literally everything dimensioned MAXSCN is
C     copied.  If it is .FALSE., the following happens:
C
C       STARTJ and STOPJ are not copied.
C       DURONLY is set to 1
C       ANNOT is set to ' '
C       
C     Note that with COPYALL true, the calculated parameters are 
C     copied but many should be recalculated after the call.  In most
C     usage, they have not yet been calculated.  See the bottom of
C     the routine for which parameters are involved.
C
C     CALLER was added as a debugging aid.  It should contain the
C     name of the calling routine.
C
      INCLUDE   'sched.inc'
C
      INTEGER      TO, FROM, JST, ICHAN, I
      LOGICAL      COPYALL
      CHARACTER    CALLER*(*)
C ------------------------------------------------------------------
      IF( DEBUG ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I5, A, I5, 3A, L1 )' ) 
     1      'SCNDUP: Duplicating scan ',
     2      FROM, ' to scan ', TO, '.  Called by: ', CALLER,
     3      '  copyall = ', COPYALL
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
         WRITE( MSGTXT, '( 2A )' ) 
     1      'SCNDUP: ANNOT: ', ANNOT(FROM)
         CALL WLOG( 0, MSGTXT )
      END IF
C
C     Protect against overflowed arrays.
C
      IF( TO .GT. MAXSCN ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I15, A, I15 )')  
     1       'SCHDUP: Output scan number ', TO, 
     2       ' too big for arrays of dimension: ',MAXSCN
         CALL ERRLOG( MSGTXT )
      END IF
C
C     Duplicate most parameters.
C     Listed almost in order of position in sched.inc for ease of 
C     maintenance.  Some missordering to minimize IFs and DOs.
C
      PRESCAN(TO)  = PRESCAN(FROM)
      DUR(TO)      = DUR(FROM)
      GAP(TO)      = GAP(FROM)
      IF( COPYALL ) THEN
         STARTJ(TO) = STARTJ(FROM)
         STOPJ(TO)  = STOPJ(FROM)
      END IF
C
C     Don't set START and STOP.  In some of the optimization calls,
C     they have already been set and we don't want to overwrite them.
C
      DO ICHAN = 1, MAXCHN
         FREQ(ICHAN,TO) = FREQ(ICHAN,FROM)
         BW(ICHAN,TO)   = BW(ICHAN,FROM)
         CRDFREQ(ICHAN,TO) = CRDFREQ(ICHAN,FROM)
         CRDBW(ICHAN,TO)   = CRDBW(ICHAN,FROM)
         IF( ICHAN .LE. MAXCRD ) 
     1          CRDSETCH(ICHAN,TO) = CRDSETCH(ICHAN,FROM)
      END DO
      GOTCRD(TO)   = GOTCRD(FROM)
      CRDNCH(TO)   = CRDNCH(FROM)
      CRDCH1(TO)   = CRDCH1(FROM)
      CRDDOP(TO)   = CRDDOP(FROM)      
C
      DOPINCR(TO,1)  = DOPINCR(FROM,1)
      DOPINCR(TO,2)  = DOPINCR(FROM,2)
      SRCNUM(TO)   = SRCNUM(FROM)
      IDOPSRC(TO)  = IDOPSRC(FROM)
      QUAL(TO)     = QUAL(FROM)
      SETNUM(TO)   = SETNUM(FROM)
      CENTERS(TO)  = CENTERS(FROM)
      ICENT(TO)    = ICENT(FROM)
      GEOLEN(TO)   = GEOLEN(FROM)
      GEOISCN(TO)  = GEOISCN(FROM)
C
      DO JST = 1,MAXSTA
         NSETUP(TO,JST) = NSETUP(FROM,JST)
         FSETI(TO,JST)  = FSETI(FROM,JST)
         STASCN(TO,JST) = STASCN(FROM,JST) 
      END DO
C
      DOPEAK(TO)   = DOPEAK(FROM)
      POINT(TO)    = POINT(FROM)
      ORIGEN(TO)   = ORIGEN(FROM)
C
C     Note Oct 21, 2013 - inverted the behavior with ANNOT.  I think
C     it was a bug.  RCW.
C
      IF( COPYALL ) THEN
         DURONLY(TO) = DURONLY(FROM)
         ANNOT(TO)   = ANNOT(FROM)
      ELSE
         DURONLY(TO) = 1
         ANNOT(TO)   = ' '
      END IF
C
      NOTSYS(TO)   = NOTSYS(FROM)
      DOPCAL(TO)   = DOPCAL(FROM)
      DWELL(TO)    = DWELL(FROM)
      NOWAIT(TO)   = NOWAIT(FROM)
      MINDW(TO)    = MINDW(FROM)
      TANT1(TO)    = TANT1(FROM)
      TANT2(TO)    = TANT2(FROM)
      SCNSRC(TO)   = SCNSRC(FROM) 
      DOPSRC(TO)   = DOPSRC(FROM)
      LINES(TO)    = LINES(FROM)
      PCAL(TO)     = PCAL(FROM)
      SCANTAG(TO)  = SCANTAG(FROM)
      PREEMPT(TO)  = PREEMPT(FROM)
C
      IVLAPHS(TO)  = IVLAPHS(FROM)
      VLATSYS(TO)  = VLATSYS(FROM)
      VLAPEAK(TO)  = VLAPEAK(FROM)
      VLAMODE(TO)  = VLAMODE(FROM)
      VLAPHS(TO)   = VLAPHS(FROM)
      VLAINTEG(TO) = VLAINTEG(FROM)
      VLAPTIME(TO) = VLAPTIME(FROM)
C
      PTSLEW(TO)   = PTSLEW(FROM)
      CALTIME(TO)  = CALTIME(FROM)
      PNTVLBA(TO)  = PNTVLBA(FROM)
      TANVLBA(TO)  = TANVLBA(FROM)
      DOPN3DB(TO)  = DOPN3DB(FROM)
      FOCUS(TO)    = FOCUS(FROM)
      ROTATION(TO) = ROTATION(FROM)
      SAZCOL(TO)   = SAZCOL(FROM)
      SELCOL(TO)   = SELCOL(FROM)
      CRDLINE(TO)  = CRDLINE(FROM)
C
C     Intents.
C
      NSCINT(TO)   = NSCINT(FROM)
      DO I = 1, MSCINT
         ISCINT(I,TO) = ISCINT(I,FROM)
      END DO
C
C     Tape parameters.  Many should not be duplicated for some scans.
C
      MINPAUSE(TO) = MINPAUSE(FROM)
      PRESTART(TO) = PRESTART(FROM)
      NOREC(TO)    = NOREC(FROM)
C
C     eVLBI parameters.
C
      GRABTIME(1,TO) = GRABTIME(1,FROM)
      GRABTIME(2,TO) = GRABTIME(2,FROM)
      GRABGAP(TO) = GRABGAP(FROM)
      DATAPATH(TO) = DATAPATH(FROM)
      GRABTO(TO) = GRABTO(FROM)
C
C     Calculated parameters.  Usually these won't be available yet.
C     But they might be if we are just shifting the order of scans
C     later in the program.  Of course, some like slew times really
C     should be recalculated.
C
      IF( COPYALL ) THEN
         DO JST = 1, MAXSTA
            TPSTART(TO,JST) = TPSTART(FROM,JST)
            TCORR(TO,JST)   = TCORR(FROM,JST)
            GBYTES(TO,JST)  = GBYTES(FROM,JST)
            LST1(TO,JST)    = LST1(FROM,JST)
            LST2(TO,JST)    = LST2(FROM,JST)
            TONSRC(TO,JST)  = TONSRC(FROM,JST)
            TSLEW(TO,JST)   = TSLEW(FROM,JST)
            EL1(TO,JST) = EL1(FROM,JST)
            AZ1(TO,JST) = AZ1(FROM,JST)
            HA1(TO,JST) = HA1(FROM,JST)
            PA1(TO,JST) = PA1(FROM,JST)
            UP1(TO,JST) = UP1(FROM,JST)
            EL2(TO,JST) = EL2(FROM,JST)
            AZ2(TO,JST) = AZ2(FROM,JST)
            HA2(TO,JST) = HA2(FROM,JST)
            PA2(TO,JST) = PA2(FROM,JST)
            UP2(TO,JST) = UP2(FROM,JST)
         END DO
      END IF
C
C     Optimization stuff
C
      OPMISS(TO)   = OPMISS(FROM)
      OPMINEL(TO)  = OPMINEL(FROM)
      OPMIAN(TO)   = OPMIAN(FROM)
      OPMINSEP(TO) = OPMINSEP(FROM)
      OPSLEWWT(TO) = OPSLEWWT(FROM)
      OPSLEWTI(TO) = OPSLEWTI(FROM)
      OPHLIMWT(TO) = OPHLIMWT(FROM) 
      OPHLIMTI(TO) = OPHLIMTI(FROM)
      OPHMAXDT(TO) = OPHMAXDT(FROM)
      OPHA(TO)     = OPHA(FROM)
      OPHAWID(TO)  = OPHAWID(FROM)
      OPHAWT(TO)   = OPHAWT(FROM)
      HIGROUP(TO)  = HIGROUP(FROM)
C
      RETURN
      END

C+++++++++++++++++++++++++++++++++
C
      SUBROUTINE INTERP(BUF,T,NCF,NCM,NA,IFL,PV)
C
C+++++++++++++++++++++++++++++++++
C
C     THIS SUBROUTINE DIFFERENTIATES AND INTERPOLATES A
C     SET OF CHEBYSHEV COEFFICIENTS TO GIVE POSITION AND VELOCITY
C
C     CALLING SEQUENCE PARAMETERS:
C
C       INPUT:
C
C         BUF   1ST LOCATION OF ARRAY OF D.P. CHEBYSHEV COEFFICIENTS OF POSITION
C
C           T   T(1) IS DP FRACTIONAL TIME IN INTERVAL COVERED BY
C               COEFFICIENTS AT WHICH INTERPOLATION IS WANTED
C               (0 .LE. T(1) .LE. 1).  T(2) IS DP LENGTH OF WHOLE
C               INTERVAL IN INPUT TIME UNITS.
C
C         NCF   # OF COEFFICIENTS PER COMPONENT
C
C         NCM   # OF COMPONENTS PER SET OF COEFFICIENTS
C
C          NA   # OF SETS OF COEFFICIENTS IN FULL ARRAY
C               (I.E., # OF SUB-INTERVALS IN FULL INTERVAL)
C
C          IFL  INTEGER FLAG: =1 FOR POSITIONS ONLY
C                             =2 FOR POS AND VEL
C
C
C       OUTPUT:
C
C         PV   INTERPOLATED QUANTITIES REQUESTED.  DIMENSION
C               EXPECTED IS PV(NCM,IFL), DP.
C
C
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      SAVE
C
      INTEGER NCF, NCM, NA, IFL, NP, NV, L, I, J
      DOUBLE PRECISION BUF(NCF,NCM,*),T(2),PV(NCM,*),PC(18),VC(18)

      DOUBLE PRECISION TWOT, DNA, DT1, TC, VFAC, TEMP
C
      DATA NP/2/
      DATA NV/3/
      DATA TWOT/0.D0/
      DATA PC(1),PC(2)/1.D0,0.D0/
      DATA VC(2)/1.D0/
C
C       ENTRY POINT. GET CORRECT SUB-INTERVAL NUMBER FOR THIS SET
C       OF COEFFICIENTS AND THEN GET NORMALIZED CHEBYSHEV TIME
C       WITHIN THAT SUBINTERVAL.
C
      DNA=DBLE(NA)
      DT1=DINT(T(1))
      TEMP=DNA*T(1)
      L=IDINT(TEMP-DT1)+1

C         TC IS THE NORMALIZED CHEBYSHEV TIME (-1 .LE. TC .LE. 1)

      TC=2.D0*(DMOD(TEMP,1.D0)+DT1)-1.D0

C       CHECK TO SEE WHETHER CHEBYSHEV TIME HAS CHANGED,
C       AND COMPUTE NEW POLYNOMIAL VALUES IF IT HAS.
C       (THE ELEMENT PC(2) IS THE VALUE OF T1(TC) AND HENCE
C       CONTAINS THE VALUE OF TC ON THE PREVIOUS CALL.)

      IF(TC.NE.PC(2)) THEN
        NP=2
        NV=3
        PC(2)=TC
        TWOT=TC+TC
      ENDIF
C
C       BE SURE THAT AT LEAST 'NCF' POLYNOMIALS HAVE BEEN EVALUATED
C       AND ARE STORED IN THE ARRAY 'PC'.
C
      IF(NP.LT.NCF) THEN
        DO 1 I=NP+1,NCF
        PC(I)=TWOT*PC(I-1)-PC(I-2)
    1   CONTINUE
        NP=NCF
      ENDIF
C
C       INTERPOLATE TO GET POSITION FOR EACH COMPONENT
C
      DO 2 I=1,NCM
      PV(I,1)=0.D0
      DO 3 J=NCF,1,-1
      PV(I,1)=PV(I,1)+PC(J)*BUF(J,I,L)
    3 CONTINUE
    2 CONTINUE
      IF(IFL.LE.1) RETURN
C
C       IF VELOCITY INTERPOLATION IS WANTED, BE SURE ENOUGH
C       DERIVATIVE POLYNOMIALS HAVE BEEN GENERATED AND STORED.
C
      VFAC=(DNA+DNA)/T(2)
      VC(3)=TWOT+TWOT
      IF(NV.LT.NCF) THEN
        DO 4 I=NV+1,NCF
        VC(I)=TWOT*VC(I-1)+PC(I-1)+PC(I-1)-VC(I-2)
    4   CONTINUE
        NV=NCF
      ENDIF
C
C       INTERPOLATE TO GET VELOCITY FOR EACH COMPONENT
C
      DO 5 I=1,NCM
      PV(I,2)=0.D0
      DO 6 J=NCF,2,-1
      PV(I,2)=PV(I,2)+VC(J)*BUF(J,I,L)
    6 CONTINUE
      PV(I,2)=PV(I,2)*VFAC
    5 CONTINUE
C
      RETURN
C
      END

      SUBROUTINE SETBBC( KS )
C
C     Routine for SCHED, called by SETDEFS, that assigns BaseBand 
C     Converters (BBCs) to channels.  It also assigns the IF's if
C     they were not specified in the setup file.  This used to be
C     in SETFCAT, but the Mark IV complications made it better to
C     put it here.
C
C     Two channels can share a BBC if they have the same FREQSET and
C     the same IFCHAN.  Otherwise they have to be different.
C     Note that they don't have to share the same sideband.
C
C     Note that the maximum number of channels in this whole setup file
C     is MSCHN(ISETNUM(KS)).  The minimum number of BBC's available
C     is MINBBC(ISETNUM(KS)).
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
      INCLUDE    'schfreq.inc'
C
      INTEGER    ICH, KS, KF, KIF
C --------------------------------------------------------------------
      IF( SDEBUG ) CALL WLOG( 0, 'SETBBC: Starting.' )
C
C     Assign the IF channels based on the frequency catalog
C     if they were not in the setup file.
C
      DO ICH = 1, NCHAN(KS)
         IF( IFREQNUM(ICH,KS) .GE. 1 ) THEN
            KF = IFREQNUM(ICH,KS)
            KIF = IFREQIF(ICH,KS)
            IF( IFCHAN(ICH,KS) .EQ. ' ' ) THEN
               IFCHAN(ICH,KS) = FIFNAM(KIF,KF)
            END IF
         ELSE
C
C           If there is no corresponding frequency catalog entry, 
C           require that the IFCHANS have been set.
C
            IF( IFCHAN(ICH,KS) .EQ. ' ' ) THEN
               WRITE( MSGTXT, '( A, I3, A, I3, A )' )
     1             'SETBBC: Cannot set IFCHANs.  First bad channel: ',
     2             ICH, ' of ', NCHAN(KS), ' total.'
               CALL WLOG( 1, MSGTXT )
               CALL ERRSET( KS )
            END IF

         END IF
      END DO
C
C
C     Try assigning BBC's.  Each of these IF's, except the 
C     first used to have a dependence on the FORMAT, 
C     requiring VLBA or MARKIII for the VLBA and VLBAG 
C     DARs and MKIV or MARKIII for the VLBA4 and MKIV 
C     DARs.  I don't think those dependencies are required,
C     and without them, the BBC's can be set without 
C     knowledge of the recording - desirable with the 
C     proliferation of systems.
C
      IF( RECORDER(ISETSTA(KS)) .EQ. 'S2' .AND.
     1       ( DAR(ISETSTA(KS)) .EQ. 'VLBA' .OR.
     2         DAR(ISETSTA(KS)) .EQ. 'VLBAG' .OR.
     3         DAR(ISETSTA(KS)) .EQ. 'VLBA4' ) ) THEN
C
C        S2 system on any type of VLBA DAR.
C
         CALL BBCVS2( KS )    
C
      ELSE IF( DAR(ISETSTA(KS)) .EQ. 'VLBA' ) THEN
C
C        Normal VLBA systems.
C
         CALL BBCVLBA( KS )
C
      ELSE IF( DAR(ISETSTA(KS))(1:4) .EQ. 'RDBE' ) THEN
C
C        RDBE and RDBE2 digital backend, including VLBA
C
         CALL BBCRDBE( KS )
C
      ELSE IF( DAR(ISETSTA(KS)) .EQ. 'WIDAR' ) THEN
C
C        WIDAR (VLA) digital backend.
C
         CALL BBCWIDAR( KS )
C
      ELSE IF( DAR(ISETSTA(KS)) .EQ. 'VLBAG' ) THEN
C
C        VLBA systems with "geodetic wiring".
C
         CALL BBCGEO( KS )
C
      ELSE IF( DAR(ISETSTA(KS)) .EQ. 'VLBA4' ) THEN
C
C        VLBA systems with "geodetic wiring" and Mark IV formatters.
C
         CALL BBCGEO( KS )
C
      ELSE IF( DAR(ISETSTA(KS)) .EQ. 'MKIV' ) THEN
C
C        Mark IV systems.  This hopefully works for S2 attached
C        to Mark IV.
C
         CALL BBCM4( KS )
C
      ELSE IF( DAR(ISETSTA(KS)) .EQ. 'DBBC') THEN
C
C     Gino Tuccari's DBBC
C
         CALL BBCDBBC( KS )
C
      ELSE IF( DAR(ISETSTA(KS)) .EQ. 'CDAS') THEN
C
C        Chinese DAR
C
         CALL BBCCDAS( KS )
C
      ELSE IF( DAR(ISETSTA(KS)) .EQ. 'R1002') THEN
C
C
         CALL BBCKVSR( KS )
C
      ELSE IF( DAR(ISETSTA(KS)) .EQ. 'LBA') THEN
C
C     Australian LBA system
         CALL BBCLBA( KS )
C
      ELSE IF( DAR(ISETSTA(KS)) .NE. 'NONE' ) THEN
C
C        Do not try to default with other formats.
C
         DO ICH = 1, NCHAN(KS)
            IF( BBC(ICH,KS) .EQ. 0 ) THEN
               WRITE( MSGTXT, '( 4A )' )
     1           'SETBBC: SCHED does not set default BBCs for format: ',
     2           FORMAT(KS), ', DAR type: ', DAR(ISETSTA(KS))
               CALL WLOG( 1, MSGTXT )
               CALL ERRSET( KS )
            END IF
         END DO
      END IF
C
      RETURN
      END

      CHARACTER*32 FUNCTION VXNMIF( IIF, XTRAIF ) 
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 140596 
C     Returns a name for an IF block definition
C     Updated 230796, Huib
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      LOGICAL XTRAIF
      INTEGER ISET, IIF, LPOS, LEN1, ICH, PHMODE
      CHARACTER NAME*32, NMPOL*1, UPCAL*4
      LOGICAL DUALFRQ
C ----------------------------------------------------------------------
C
      ISET = IFISSET( IIF )
C
C     First let's see if this is a dual Freq mode
C
      DUALFRQ = .FALSE.
      DO ICH = 2, NCHAN(ISET)
         IF( ABS(FIRSTLO(1,ISET) - FIRSTLO(ICH,ISET)) .GT. 1E3 )
     1        DUALFRQ = .TRUE.
      END DO
C
C     check pols and sidebands
C
      NAME = ' '
C
      IF( DUALFRQ ) THEN
         NAME(1:8) = 'DualFreq'
      ELSE
         NAME(1:3) = 'LO@'
C
         IF( FIRSTLO(1,ISET) .GT. 9.999E4 ) THEN
            WRITE( NAME(4:12), '( I6, A3 )' ) 
     1           NINT( FIRSTLO(1,ISET) ), 'MHz'
         ELSE IF( FIRSTLO(1,ISET) .GT. 9.999E3 ) THEN
            WRITE( NAME(4:11), '( I5, A3 )' ) 
     1           NINT( FIRSTLO(1,ISET) ), 'MHz'
         ELSE IF( FIRSTLO(1,ISET) .GT. 9.99E2 ) THEN
            WRITE( NAME(4:10), '( I4, A3 )' ) 
     1           NINT( FIRSTLO(1,ISET) ), 'MHz'
         ELSE IF( FIRSTLO(1,ISET) .GT. 99.9 ) THEN
            WRITE( NAME(4:9), '( I3, A3 )' ) 
     1           NINT( FIRSTLO(1,ISET) ), 'MHz'
         ELSE IF( FIRSTLO(1,ISET) .GT. 9.9 ) THEN
            WRITE( NAME(4:10), '( F4.1, A3 )' ) FIRSTLO(1,ISET), 'MHz'
C        zero LO and negative values can occur at 90 and 50 cm
         ELSE IF( FIRSTLO(1,ISET) .GE. 0.0 ) THEN
            WRITE( NAME(4:9), '( F3.1, A3 )' ) FIRSTLO(1,ISET), 'MHz'
         ELSE IF( FIRSTLO(1,ISET) .GT. -10.0 ) THEN
            WRITE( NAME(4:10), '( F4.1, A3 )' ) FIRSTLO(1,ISET), 'MHz'
         ELSE IF( FIRSTLO(1,ISET) .GT. -100.0 ) THEN
            WRITE( NAME(4:10), '( I3, A3 )' ) 
     1           NINT( FIRSTLO(1,ISET) ), 'MHz'
         ELSE IF( FIRSTLO(1,ISET) .GT. -1000.0 ) THEN
            WRITE( NAME(4:11), '( I4, A3 )' ) 
     1           NINT( FIRSTLO(1,ISET) ), 'MHz'
         ELSE
            WRITE( MSGTXT, '( A, G13.6, A )' )
     1          'VXNMIF: LO value (', FIRSTLO(1, ISET),
     2          ') does not fit name.'
            CALL WLOG( 1, MSGTXT )
            WRITE( NAME(4:11), '( A )' ) 'aBitIFfy'
         END IF
C     
      END IF
      NMPOL = '_'
      DO ICH = 1, NCHAN(ISET)
C
C        find out if all same pol or dual, can be RCP or LCP (after checkset)
C
         IF( NMPOL .EQ. '_' ) THEN
            NMPOL = POL(ICH,ISET)(1:1)
         ELSE 
            IF( NMPOL .NE. POL(ICH,ISET)(1:1) ) NMPOL = 'D'
         ENDIF
C
      END DO
C
      LPOS = LEN1( NAME ) + 1
C
      WRITE( NAME(LPOS:LPOS+4), '( A1, A3 )' )
     1     NMPOL,'Pol'
C
C     about p cal
C
      IF( XTRAIF ) THEN
         PHMODE = NINT(TONEINT(IIF))
      ELSE
         PHMODE = -1
         UPCAL = SPCAL(ISET)
         CALL UPCASE(UPCAL)
         IF( UPCAL .EQ. 'OFF' ) PHMODE = 0
         IF( UPCAL .EQ. '1MHZ' ) PHMODE = 1
         IF( UPCAL .EQ. '5MHZ' ) PHMODE = 5
         IF( UPCAL .EQ. ' ' ) PHMODE = 1      
      END IF
C
      LPOS = LEN1( NAME ) + 1
C
      IF( PHMODE .EQ. 0) NAME(LPOS:LPOS+5) = 'NoTone'
      IF( PHMODE .EQ. 1) NAME(LPOS:LPOS+5) = 'Tone/1'
      IF( PHMODE .EQ. 5) NAME(LPOS:LPOS+5) = 'Tone/5'     
C
      VXNMIF = NAME
C
      RETURN
      END

      SUBROUTINE sla_DEULER (ORDER, PHI, THETA, PSI, RMAT)
*+
*     - - - - - - -
*      D E U L E R
*     - - - - - - -
*
*  Form a rotation matrix from the Euler angles - three successive
*  rotations about specified Cartesian axes (double precision)
*
*  Given:
*    ORDER   c*(*)   specifies about which axes the rotations occur
*    PHI     d       1st rotation (radians)
*    THETA   d       2nd rotation (   "   )
*    PSI     d       3rd rotation (   "   )
*
*  Returned:
*    RMAT    d(3,3)  rotation matrix
*
*  A rotation is positive when the reference frame rotates
*  anticlockwise as seen looking towards the origin from the
*  positive region of the specified axis.
*
*  The characters of ORDER define which axes the three successive
*  rotations are about.  A typical value is 'ZXZ', indicating that
*  RMAT is to become the direction cosine matrix corresponding to
*  rotations of the reference frame through PHI radians about the
*  old Z-axis, followed by THETA radians about the resulting X-axis,
*  then PSI radians about the resulting Z-axis.
*
*  The axis names can be any of the following, in any order or
*  combination:  X, Y, Z, uppercase or lowercase, 1, 2, 3.  Normal
*  axis labelling/numbering conventions apply;  the xyz (=123)
*  triad is right-handed.  Thus, the 'ZXZ' example given above
*  could be written 'zxz' or '313' (or even 'ZxZ' or '3xZ').  ORDER
*  is terminated by length or by the first unrecognized character.
*
*  Fewer than three rotations are acceptable, in which case the later
*  angle arguments are ignored.  If all rotations are zero, the
*  identity matrix is produced.
*
*  P.T.Wallace   Starlink   23 May 1997
*
*  Copyright (C) 1997 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      CHARACTER*(*) ORDER
      DOUBLE PRECISION PHI,THETA,PSI,RMAT(3,3)

      INTEGER J,I,L,N,K
      DOUBLE PRECISION RESULT(3,3),ROTN(3,3),ANGLE,S,C,W,WM(3,3)
      CHARACTER AXIS



*  Initialize result matrix
      DO J=1,3
         DO I=1,3
            IF (I.NE.J) THEN
               RESULT(I,J) = 0D0
            ELSE
               RESULT(I,J) = 1D0
            END IF
         END DO
      END DO

*  Establish length of axis string
      L = LEN(ORDER)

*  Look at each character of axis string until finished
      DO N=1,3
         IF (N.LE.L) THEN

*        Initialize rotation matrix for the current rotation
            DO J=1,3
               DO I=1,3
                  IF (I.NE.J) THEN
                     ROTN(I,J) = 0D0
                  ELSE
                     ROTN(I,J) = 1D0
                  END IF
               END DO
            END DO

*        Pick up the appropriate Euler angle and take sine & cosine
            IF (N.EQ.1) THEN
               ANGLE = PHI
            ELSE IF (N.EQ.2) THEN
               ANGLE = THETA
            ELSE
               ANGLE = PSI
            END IF
            S = SIN(ANGLE)
            C = COS(ANGLE)

*        Identify the axis
            AXIS = ORDER(N:N)
            IF (AXIS.EQ.'X'.OR.
     :          AXIS.EQ.'x'.OR.
     :          AXIS.EQ.'1') THEN

*           Matrix for x-rotation
               ROTN(2,2) = C
               ROTN(2,3) = S
               ROTN(3,2) = -S
               ROTN(3,3) = C

            ELSE IF (AXIS.EQ.'Y'.OR.
     :               AXIS.EQ.'y'.OR.
     :               AXIS.EQ.'2') THEN

*           Matrix for y-rotation
               ROTN(1,1) = C
               ROTN(1,3) = -S
               ROTN(3,1) = S
               ROTN(3,3) = C

            ELSE IF (AXIS.EQ.'Z'.OR.
     :               AXIS.EQ.'z'.OR.
     :               AXIS.EQ.'3') THEN

*           Matrix for z-rotation
               ROTN(1,1) = C
               ROTN(1,2) = S
               ROTN(2,1) = -S
               ROTN(2,2) = C

            ELSE

*           Unrecognized character - fake end of string
               L = 0

            END IF

*        Apply the current rotation (matrix ROTN x matrix RESULT)
            DO I=1,3
               DO J=1,3
                  W = 0D0
                  DO K=1,3
                     W = W+ROTN(I,K)*RESULT(K,J)
                  END DO
                  WM(I,J) = W
               END DO
            END DO
            DO J=1,3
               DO I=1,3
                  RESULT(I,J) = WM(I,J)
               END DO
            END DO

         END IF

      END DO

*  Copy the result
      DO J=1,3
         DO I=1,3
            RMAT(I,J) = RESULT(I,J)
         END DO
      END DO

      END

      SUBROUTINE ADDGEO( LASTISCN, ISCN, GEOOPT, KEEP )
Cf2py intent(in) LASTISCN, ISCN
Cf2py intent(in, out) GEOOPT
Cf2py intent(out) KEEP
C
C     This is the main routine for the automatic insertion of
C     geodetic segments, mainly for atmospheric calibration.
C
C     LASTISCN, as usual, is an array giving the scan number
C     of the last scan for each station.
C
C     ISCN is the output scan number.  The first scan is SCAN1.
C     Scans 1 to NSCANS are an input scans list.  If geodetic
C     segment insertions are being done, scans will be added to
C     that list, so SCAN1 will be NSCAN+1.  
C
C     GEOOPT is a variable set here (other than being initialized
C     in SCHOPT) that is a count of the number of additional scans
C     that need to be inserted before this geo segment is done.
C     Other parts of SCHOPT test it's value and basically keep 
C     handing control back to this routine until it is zero.  This
C     is very analagous to how the pointing scan insertion happens.
C
C     KEEP tells SCHOPT to keep the scan.  Just set it.
C
C     Addition of a geo segment is requested by giving a source 
C     name of "GEOSEG".  
C

      INCLUDE 'sched.inc'
C
      INTEGER            LASTISCN(*), ISCN, GEOOPT
      LOGICAL            KEEP
C
C     SEGSRCS are the source numbers in the geodetic source list of
C     sources we want to observe.  It is used rather than the main
C     catalog source numbers (GEOSRCI(SEGSRCS(I))) because getting 
C     the desired source name out of the source catalog is a bit
C     messy.
C
      INTEGER            SEGSRCS(MSEG)
      INTEGER            NSEG, JSCN, IOUT, NGOOD, ISTA, ICH, NPRST
      REAL               SGAP
      LOGICAL            OKSTA(MAXSTA)
      LOGICAL            GSTASCN(MSEG,MAXSTA), SSTASCN(MAXSTA)
      DOUBLE PRECISION   TAPPROX, GSTARTJ(MSEG)
C
C     Want to keep some values between calls.
C
      SAVE               JSCN, SEGSRCS, NSEG, GSTASCN, GSTARTJ
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'ADDGEO starting.' )
C
C     Will only be in this routine if GEOLEN .GT. 0.D0 (starting new
C     geodetic segment, although later scans in the segment will also
C     have the original placeholder's scan's GEOLEN) or we are in the
C     middle of writing geodetic scans (GEOOPT .GE. 1 )
C
C     On initial scan requesting a segment:
C
      IF( GEOOPT .EQ. 0 ) THEN
C
C        Save the template scan number
C
         JSCN = GEOISCN(ISCN)
C
C        Pick the geo sources to use.
C
         CALL GEOMAKE( LASTISCN, JSCN, ISCN, SEGSRCS, NSEG, GSTASCN,
     1                 GSTARTJ )
C
         GEOOPT = NSEG
      END IF
C
C     Send out next scan of the segment.
C        Copy most scan parameters from the scan that had source "GEOSEG"
C        Insert the source.
C        Determine if source is up - set STASCN.
C        Determine scan timing with OPTTIM
C     Actually GEOOPT should never be 0 at this point, but test anyway.
C
      IF( GEOOPT .NE. 0 ) THEN
C
C        Get the index for this source in the SEGSRCS array.
C        This is ISEG in the routines that make the segments.
C
         IOUT = NSEG - GEOOPT + 1         
C
C        Make the next scan.
C        Copy all scan parameters from the template but get the source,
C        the antennas to use, and the start time from what came 
C        from MAKEGEO. 
C
         DO ISTA = 1, NSTA
            SSTASCN(ISTA) = GSTASCN(IOUT,ISTA)
         END DO
         TAPPROX = GSTARTJ(IOUT)
         CALL GMKSCN( LASTISCN, ISCN, JSCN, GEOSRCI(SEGSRCS(IOUT)),
     1        GEOSRC(SEGSRCS(IOUT)), TAPPROX, OPMINEL(JSCN), 0,
     2        NGOOD, OKSTA, SSTASCN, 'FORCE' )
C
C        Get the number of scans left to do and tell SCHED to keep 
C        this scan.  Also flag the origen of the scan.
C
         GEOOPT = GEOOPT - 1
         KEEP = .TRUE.
         ORIGEN(ISCN) = 3
C
         IF( GEOPRT .GE. 0 ) THEN
C
C           Write the lines of the table of sources and elevations.
C           Do them one by one as they are prepared for output by
C           ADDGEO.  The table headers are constructed at the
C           end of MAKEGEO.
C        
            IF(  ISCN .EQ. SCAN1 ) THEN
               SGAP = 0.0
            ELSE
               SGAP = ( STARTJ(ISCN) - STOPJ(ISCN-1) ) / ONESEC
            END IF
            MSGTXT = ' '
            WRITE( MSGTXT,'( I4, F8.0, 1X, 1X, A12 )' ) 
     1          SEGSRCS(IOUT), SGAP, GEOSRC(SEGSRCS(IOUT))
            ICH = 40
            NPRST = MIN( 20, NSTA )
            DO ISTA = 1, NPRST
               IF( STASCN(ISCN,ISTA) ) THEN
                  WRITE( MSGTXT(ICH:ICH+10), '( F5.0, 1X )' )
     1                    EL1(ISCN,ISTA)
               ELSE
                  WRITE( MSGTXT(ICH:ICH+10), '( A, F4.0, A )' )
     1                    '(', EL1(ISCN,ISTA), ')'
               END IF
               ICH = ICH + 7
            END DO
            CALL WLOG( 0, MSGTXT )
         END IF
C
      END IF
C
C     At end, GEOOPT will be zero on the last output scan.
C
      RETURN
      END

      SUBROUTINE OPTUPT( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
Cf2py intent(in, out) LASTISCN
Cf2py intent(in) KSCN, ISCN
Cf2py intent(out) ADJUST, KEEP, DONE
C
C     Routine for SCHED that creates a schedule useful for planning.
C     Each scan (source) is expanded to a series of scans, each of
C     length DUR, spanning the time from START(1) to START(1) + OPTDUR
C
C     This routine, along with new plotting capabilities, should make
C     it possible to stop supporting UPTIME.
C
C     Reset LASTISCN when changing source to prevent unrealistic slew
C     worries.
C
      INCLUDE  'sched.inc'
C
      INTEGER           ISCN, INSCN, KSCN, JSCN, LSCN, LASTISCN(*)
      INTEGER           ISTA
      LOGICAL           KEEP, ADJUST, DONE, DUP
      DOUBLE PRECISION  LASTTIME, T_AVAIL
      SAVE              INSCN
C ---------------------------------------------------------------------
      DONE = .FALSE.
      KEEP = .TRUE.
      ADJUST = .FALSE.
C
C     Some initializations on first scan.
C
      IF( KSCN .EQ. 1 ) THEN
C
C        Warn that station files will not be written.
C
         CALL WLOG( 0, 'OPTUPT:  OPTMODE=UPTIME was specified.  Station'
     1       // ' files (sch, crd, ' )
         CALL WLOG( 0, '         vex, and drudg) will not be written.' )
C
C        Start the set of new scans beyond NSCANS and use first start
C        time.  TAPPROX is the approximate start time of the next scan.
C        Don't allow this time to be adjusted.
C
         INSCN    = 1
         STARTJ(ISCN) = STARTJ(1)
C
C        Make sure that OPDUR is available.
C
         IF( OPDUR .LE. 0.D0 ) THEN
            CALL ERRLOG( 
     1       ' OPTCUPT: For OPTMODE=UPTIME, OPDUR must be given.' )
         END IF
C
C        Check that each scan is a different source.
C
         WRITE( MSGTXT, '( A, I5, A )' ) '         There are ', NSCANS,
     1        ' input scans with sources: '
         CALL WLOG( 0, MSGTXT )
         DUP = .FALSE.
         DO JSCN = 1, NSCANS
            MSGTXT = ' '
            WRITE( MSGTXT, '( 5X, I5, 2A )' ) JSCN, ': ', SCNSRC(JSCN)
            CALL WLOG( 0, MSGTXT )
            IF( JSCN .GT. 1 ) THEN
               DO LSCN = 1, JSCN - 1
                  IF( SCNSRC(JSCN) .EQ. SCNSRC(LSCN) ) DUP = .TRUE.
               END DO
            END IF
         END DO
         IF( DUP ) THEN
            CALL WLOG( 1, '       There were duplicate sources. ' )
            CALL WLOG( 1, '       This is probably not what you ' // 
     1                 'wanted for OPTYPE=UPTIME.' )
         END IF
C
      ELSE
C
C        Set the new start time.
C
         STARTJ(ISCN) = STOPJ(ISCN-1) + GAP(INSCN)
C
      END IF
C
C     Set the stop time of the scan.
C
      STOPJ(ISCN) = STARTJ(ISCN) + DUR(INSCN)
C
C     See if it is time to start the next source.
C     If it is, start new sequence and reset LASTISCN
C
      IF( STOPJ(ISCN) .GT. STARTJ(1) + OPDUR ) THEN
C
         IF( INSCN .GE. NSCANS ) THEN
            DONE = .TRUE.
            KEEP = .FALSE.
         ELSE
            INSCN = INSCN + 1
            STARTJ(ISCN) = STARTJ(1)
            STOPJ(ISCN) = STARTJ(ISCN) + DUR(INSCN)
            DO ISTA = 1, NSTA
               LASTISCN(ISTA) = 0
            END DO
         END IF
C
      END IF
C
      IF( .NOT. DONE ) THEN
C
C        Fill in the required information for the scan.
C
         CALL SCNDUP( ISCN, INSCN, .FALSE., 'OPTUPT' )
C
C        Only keep stations that are up.
C
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
               CALL STAGEO( ISCN, ISTA, STARTJ(ISCN), 
     1             0, LASTTIME, T_AVAIL, 'OPTUPT' )
               STASCN(ISCN,ISTA) = UP1(ISCN,ISTA) .EQ. ' ' .AND.
     1             UP2(ISCN,ISTA) .EQ. ' ' .AND.
     2             ( EL1(ISCN,ISTA) + EL2(ISCN,ISTA) ) / 2.0 .GT. 
     3              OPMINEL(ISCN)               
C
            END IF
         END DO
C
      END IF
C
      RETURN
      END

      CHARACTER*32 FUNCTION VXNMPO( IXX )
C
C     Routine specific for the VEX extension of SCHED
C     function generates a name for PO block IXX
C     By H.J. van Langevelde, JIVE, 010996
C
C     Removed tape section July 22, 2010 RCW.
C     Allow no disk if OBSTYP is NONE or PTVLBA.  Nov. 14, 2011
C     Note that this should also be ok if there are FORMAT=NONE
C     scans in a recording observation (USEDISK true).
C     The PO block is the pass order block, which is basically
C     obsolete.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
      INTEGER IXX, KS, ASTAT, ISTA
C ----------------------------------------------------------------------
C
C     Pass order depends on TAPEMODE
C
      KS = POISSET(IXX)
      IF( FORMAT(KS) .EQ. 'S2' ) THEN
         IF( TAPEMODE(KS) .LT. 10 ) THEN
            WRITE( VXNMPO, '( A, I1, A )' ) 'S2with',
     1          TAPEMODE(KS), 'Groups'
         ELSE
            WRITE( VXNMPO, '( A, I2, A )' ) 'S2with',
     1          TAPEMODE(KS), 'Groups'
         END IF
      ELSE IF( FORMAT(KS) .EQ. 'LBA' ) THEN
         WRITE( VXNMPO, '( A )' ) 'LBADummy'
      ELSE
C
C     Check if two heads applies
C     Long tape section removed.
C
         DO ISTA = 1, NSTA
            IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,KS) ) 
     4          ASTAT = ISTA
         END DO
C
         IF( USEDISK(ASTAT) .OR. OBSTYP .EQ. 'NONE' .OR.
     1      OBSTYP .EQ. 'PTVLBA' .OR. FORMAT(KS)(1:4) .EQ. 'NONE' ) THEN
            VXNMPO = 'DiskVoid'
         ELSE 
            CALL ERRLOG('VXNMPO: Not using disks at '//
     1           STATION(STANUM(ASTAT))// '!' )
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE sla_PREC (EP0, EP1, RMATP)
*+
*     - - - - -
*      P R E C
*     - - - - -
*
*  Form the matrix of precession between two epochs (IAU 1976, FK5)
*  (double precision)
*
*  Given:
*     EP0    dp         beginning epoch
*     EP1    dp         ending epoch
*
*  Returned:
*     RMATP  dp(3,3)    precession matrix
*
*  Notes:
*
*     1)  The epochs are TDB (loosely ET) Julian epochs.
*
*     2)  The matrix is in the sense   V(EP1)  =  RMATP * V(EP0)
*
*     3)  Though the matrix method itself is rigorous, the precession
*         angles are expressed through canonical polynomials which are
*         valid only for a limited time span.  There are also known
*         errors in the IAU precession rate.  The absolute accuracy
*         of the present formulation is better than 0.1 arcsec from
*         1960AD to 2040AD, better than 1 arcsec from 1640AD to 2360AD,
*         and remains below 3 arcsec for the whole of the period
*         500BC to 3000AD.  The errors exceed 10 arcsec outside the
*         range 1200BC to 3900AD, exceed 100 arcsec outside 4200BC to
*         5600AD and exceed 1000 arcsec outside 6800BC to 8200AD.
*         The SLALIB routine sla_PRECL implements a more elaborate
*         model which is suitable for problems spanning several
*         thousand years.
*
*  References:
*     Lieske,J.H., 1979. Astron.Astrophys.,73,282.
*      equations (6) & (7), p283.
*     Kaplan,G.H., 1981. USNO circular no. 163, pA2.
*
*  Called:  sla_DEULER
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION EP0,EP1,RMATP(3,3)

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T0,T,TAS2R,W,ZETA,Z,THETA



*  Interval between basic epoch J2000.0 and beginning epoch (JC)
      T0 = (EP0-2000D0)/100D0

*  Interval over which precession required (JC)
      T = (EP1-EP0)/100D0

*  Euler angles
      TAS2R = T*AS2R
      W = 2306.2181D0+(1.39656D0-0.000139D0*T0)*T0

      ZETA = (W+((0.30188D0-0.000344D0*T0)+0.017998D0*T)*T)*TAS2R
      Z = (W+((1.09468D0+0.000066D0*T0)+0.018203D0*T)*T)*TAS2R
      THETA = ((2004.3109D0+(-0.85330D0-0.000217D0*T0)*T0)
     :        +((-0.42665D0-0.000217D0*T0)-0.041833D0*T)*T)*TAS2R

*  Rotation matrix
      CALL sla_DEULER('ZYZ',-ZETA,THETA,-Z,RMATP)

      END

      SUBROUTINE VXRL16(HEAD)
      IMPLICIT NONE
C
C     Routine specific for the VEX extension of SCHED. 
C     Writes the Roll table for 16 track roll
C     By Huib Jan van Langevelde, JIVE 011200
C     Uses the revised, reverse roll
C
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 

      INTEGER HEAD

      INTEGER NGROUP, IGROUP, ITRACK, ALTGRP, I, J, JALT
      INTEGER ROLLTO, MINTRK
      INTEGER LEN1
      CHARACTER LINE*132, DEL*1
      
      LINE = ' '
      NGROUP = 4          
C
C     loop groups, still 4 for 16 roll, but after 8 group changes
C
      DO IGROUP = 1, NGROUP
C
C        write columns, maxtrack depends on group we're in
C
         DO I = 1, 32/NGROUP
C
C        home track is still simple
C
            IF( IGROUP .LE. NGROUP/2 ) THEN  
C
C           do even numbers
C
               ITRACK = (IGROUP-1)*2*32/NGROUP + I*2
            ELSE
               ITRACK = (IGROUP-1-NGROUP/2)*2*32/NGROUP + I*2 + 1
            ENDIF
            WRITE( LINE(1:24), '( 5X, A, I1, 1X, A1, 1X, I2, 1X, A1 )' ) 
     1          'roll_def = ',HEAD, COL, ITRACK, COL
C        
C           let's roll, but be carfull out there!
C
            DO J = 1, 16
               DEL = COL
               IF( J .EQ. 16 ) DEL = SEP
C
C                    out track switches to other group after 8
C
               IF( J .LE. 8 ) THEN
                  ALTGRP = IGROUP
                  JALT = J
               ELSE       
                  IF( MOD (IGROUP, 2) .EQ. 0 ) THEN
                     ALTGRP = IGROUP - 1
                     JALT = J - 8
                  ELSE
                     ALTGRP = IGROUP + 1
                     JALT = J - 8
                  END IF
               ENDIF
C
C              now it should be the track
C
               IF( ALTGRP .LE. NGROUP/2 ) THEN 
C
C              this is simply itrack+2*(JALT-1) for even 
C
                  ROLLTO = (ALTGRP-1)*2*32/NGROUP+I*2-(JALT-1)*2
                  MINTRK = (ALTGRP-1)*2*32/NGROUP + 2
               ELSE
C
C              and for odd it is:
C
                  ROLLTO = (ALTGRP-1-NGROUP/2)
     1                *2*32/NGROUP+I*2-(JALT-1)*2+1
                  MINTRK = 
     1                (ALTGRP-1-NGROUP/2)
     2                *2*32/NGROUP+2+1
               ENDIF
               IF( ROLLTO .LT. MINTRK)  ROLLTO=ROLLTO+2*32/NGROUP
C
C              so let's write it out...
C
               WRITE( LINE(25+(J-1)*3:24+J*3), '( I2, A1 )' )
     1             ROLLTO, DEL
            END DO
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
         WRITE( IVEX, '( A1 )' ) COM

      END DO
      
      RETURN
      END

      SUBROUTINE CHKDISK( KS, ERRS )
Cf2py intent(in, out) ERRS
C
C     Routine for SCHED that checks some generic disk specific
C     setup parameters.  There isn't much here yet.
C
C     This routine is only called if USEDISK(ISTA) is set.
C       KS is setup group
C       ERRS indicates an error was found and SCHED should die after
C            other checks are done.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER  KS, ISTA, NTRACKS
      LOGICAL  ERRS
C -----------------------------------------------------------------
C     Get the station number.
C
      ISTA = ISCHSTA(ISETSTA(KS))
C
C     Don't allow less than 8 tracks for Mark5A.
C     But don't complain if not recording with this setup.
C     Don't worry about non-recording setups - like pointing.
C
      IF( DISK(ISETSTA(KS)) .EQ. 'MARK5A' .AND. RECUSED(KS) ) THEN
         NTRACKS = NCHAN(KS) * FANOUT(KS) * BITS(1,KS)
         IF( NTRACKS .LT. 8 ) THEN
            CALL WLOG( 1, 'CHKDISK:  Less than 8 tracks for '//
     1         'Mark5A at '// SETSTA(1,KS) )
C
C           We used to just issue warnings.  But the padding with
C           extra channels seems to have gone away.  These cases
C           will be rare and the old system is slated for removal,
C           so just make it an error and request a fix.
C
C            CALL WLOG( 1, 
C     1         '          On VLBA systems, dummy data will '//
C     2         'be added to make 8.  This will use extra disk. ')
            CALL WLOG( 1, 
     1            '          Note ntracks = nchan * fanout * bits)' )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I3, A, I3, A, F4.1, A, I2 )' )
     1         '                Tracks=', NTRACKS, 
     2         '  NCHAN=', NCHAN(KS), 
     3         '  FANOUT=', FANOUT(KS),
     4         '  BITS=', BITS(1,KS)
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, 
     1          '          Please adjust one or more of these '//
     2          'parameters to get at least 8 tracks and try again.' )
C
C           Walter doesn't want this to be an error, just a warning.
C           Changed his mind later.
C
            ERRS = .TRUE.
         END IF
      END IF   
C
      RETURN
      END

      SUBROUTINE TFORMWRP ( OUTCH, RAD, TYPE, NSIGN, NDEG, NSEC, DELIM )
Cf2py intent(out) OUTCH
C
C     Wrapper function, to force f2py to generate a function which has 
C     memory space for enough output characters
C     
      CHARACTER  TYPE*1, DELIM*3, OUTCH*28, TFORM*28
      DOUBLE PRECISION  RAD
      INTEGER    NSIGN, NDEG, NSEC
      OUTCH = TFORM(RAD, TYPE, NSIGN, NDEG, NSEC, DELIM)
      RETURN
      END

      SUBROUTINE TAVLBA( ISCN, PTADD, TSTOP, KS )
C
C     Writes antenna temperature measuring sequence.
C     Based closely on PTVLBA
C
      INCLUDE     'sched.inc'
      INCLUDE     'schset.inc'
C
      INTEGER     PTADD, I, ISCN, KS
      INTEGER     RLEVEL(MCHAN), QL
      REAL        DOAZ, DOEL
      CHARACTER   TSTOP*9
C --------------------------------------------------------------------
C     Get the center pointing position.  This is a sum from both
C     the main schedule and the setup file.
C
      DOAZ = SAZCOL(ISCN) + AZCOLIM(KS)
      DOEL = SELCOL(ISCN) + ELCOLIM(KS)
C
C     Do setup scan on half power point to get reasonable levels.
C
      DO I = 1, NCHAN(KS)
         RLEVEL(I) = -1 
      END DO
      CALL VLBAINT( 'level', 5, NCHAN(KS), RLEVEL, LLEVEL, MLEVEL,
     1           .FALSE., IUVBA )
      WRITE( IUVBA, '( ''azcolim='',F7.2, '' elcolim='',F7.2, 
     2      '' dur='',I4,''s'', /, 
     3      ''stop='', A, ''   !NEXT! '' )' )
     3      DOAZ - PTINCR(KS), 
     4      DOEL, PTSLEW(KS) + PTADD, TSTOP
C
      DO I = 1, NCHAN(KS)
         RLEVEL(I) = 256
      END DO
      QL = QUAL(ISCN)
      CALL VLBAINT( 'level', 5, NCHAN(KS), RLEVEL, LLEVEL, MLEVEL,
     1           .FALSE., IUVBA )
      WRITE( IUVBA, '( A, I3, A, I4, A )' )
     1   'qual=', 40+QL, '  dur=', PTDUR, 's  !NEXT!' 
C
      WRITE( IUVBA,'( A, I3, A,  F7.2, '' !BEGIN LOOP! !NEXT!'',/, 
     1    2( A, I3, A,  F7.2, '' !NEXT!'',/),
     3    A, I3, A,  F7.2, '' !LOOP BACK!  !NEXT!'')')
     4   'qual=', 12+QL, ' azcolim=', DOAZ-PTOFF(KS),
     6   'qual=', 10+QL, ' azcolim=', DOAZ,
     8   'qual=', 24+QL, ' azcolim=', DOAZ+PTOFF(KS),
     6   'qual=', 10+QL, ' azcolim=', DOAZ
C
      RETURN
      END

      SUBROUTINE LST2UT( LONG, SIDDAY, LSTTIM, YEAR, DAY, UT )
C
C     A routine to calculate YEAR, DAY, and UT from Modified Local 
C     Sidereal Day (The day number on VLA schedules) and LSTtim for
C     a station at longitude LONG.  It uses the equations of SLA_GMST
C     but goes backwards from that routine using an iterative 
C     proceedure.  LSTtim and UT should be in fractional days.
C
      INTEGER            SIDDAY, YEAR, DAY, ITER
Cf2py intent(out) YEAR
Cf2py intent(out) DAY
      DOUBLE PRECISION   LONG, LSTTIM, UT, GMST, GMSTD, JULTIM
Cf2py intent(out) UT
      DOUBLE PRECISION   TU, GMSTDN, JULNEW, TWOPI, S2R
      PARAMETER          (TWOPI=6.283185307179586476925287D0)
      PARAMETER          (S2R=0.7272205216643039849D-4)
C ----------------------------------------------------------------------
C     Get first guess of Julian time.  This just uses a low order
C     version of the equation from SLA_GMST.  The sidereal day offset
C     (6713) is the difference between the number of julian days and
C     sidereal days from the beginning of the julian calandar to the
C     year 2000.  Actually I got the number by requiring agreement 
C     of the results with the VLA schedule.
C       R. C. Walker.
C
      GMST = LSTTIM * TWOPI + LONG
      GMSTD = ( SIDDAY - 6713) * TWOPI + GMST 
      JULTIM = ( GMSTD - 24110.54841D0 * S2R ) / TWOPI
      ITER = 0
C
C     Iterate to the julian time using the equation for sidereal time
C     from SLA_GMST.  There must be a direct equation but I don't have
C     it.  The Julian century of 36525 days exactly is what is wanted
C     for the time axis, not something closer to reality (36524....)
C
100      CONTINUE
         TU = (JULTIM - 51544.5D0) / 36525D0
         GMSTDN = JULTIM * TWOPI + ( 24110.54841D0 + (8640184.812866D0
     1       + ( 0.093104D0 - 6.2D-6 * TU ) * TU ) * TU ) * S2R 
         JULNEW = JULTIM + (GMSTD-GMSTDN)/TWOPI
         IF( ABS(JULNEW-JULTIM) .LT. 1.D-6 ) THEN
            JULTIM = JULNEW
            GO TO 200
         ELSE
            JULTIM = JULNEW
            ITER = ITER+1
            GO TO 100
         END IF
200   CONTINUE
C
C     Get year, day of year, and UT (rad).
C
      CALL TIMEJ( JULTIM, YEAR, DAY, UT )
C
      UT = UT / TWOPI
C
      RETURN
      END

      SUBROUTINE VXTRAIF(ISCN, NMODE, OMODE, INTERVAL)
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 250796 
C
C     Adds a couple of extra IF definitions, becasue
C     a change of Phase cal insertion is detected in VXSCNS
C     NMODE = MODE # new mode in which these IF come
C     OMODE = MODE # of mode to which changes are made
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      LOGICAL VXCFIF, FOUND
      REAL INTERVAL
      INTEGER NMODE, OMODE, ISCN, JSCN
C
      CHARACTER VXNMIF*32
C
      INTEGER IXTRA, ISTA, NTMPST, TMPSTA(MAXSTA), INSCAN
C ----------------------------------------------------------------------
C
C     start adding a number of modes
C
      DO IXTRA = 1, NMODIF(OMODE)
         NTMPST = 0
         DO ISTA = 1, NSTA
            FOUND = .FALSE.
C
C           check if any of the next scans use this telescope
C           in the same group. 
C
            DO JSCN = ISCN, SCANL
               IF( SETNUM(ISCN) .EQ. SETNUM(JSCN) .AND. 
     1             STASCN(JSCN,ISTA) ) THEN 
                  FOUND = .TRUE.
                  INSCAN = JSCN
                  GOTO 100
                END IF
            END DO
C
  100       CONTINUE
            IF( FOUND ) THEN
C
C              a proper comparison needs to use vxcfif, 
C              because many IF sections are not the straight order number
C
               IF( VXCFIF(NSETUP(INSCAN,ISTA), 
     1             IFISSET(IMODIF(IXTRA,OMODE))) ) THEN
                  NTMPST = NTMPST +1
                  TMPSTA(NTMPST) = ISTA
               END IF
            END IF
         END DO
C
C        Update if anything was found
C
         IF( NTMPST .GT. 0 ) THEN
            NMODIF(NMODE) = NMODIF(NMODE) + 1
            NIFVEX = NIFVEX + 1
            IF( NIFVEX .GT. MAXMOD ) CALL ERRLOG(
     1          'VXTRAIF: Number of $IF defs exceeding MAXMOD,'//
     2          '  array size...')
C
C           Need the SETUPS that are valid for this scan
C
            IMODIF(NMODIF(NMODE),NMODE) = NIFVEX
            IFISSET(NIFVEX)=IFISSET(IMODIF(IXTRA,OMODE))
C     
C           and the corresponding links
C
            TONEINT(NIFVEX) = INTERVAL
C
C           Tone names and linking to FQ blocks sorted out
C           in VXTONE, but need a list of stations used.
C
            NSTAIF(NIFVEX,NMODE) = NTMPST
            DO ISTA = 1, NTMPST
               ISTAIF(ISTA,NIFVEX,NMODE) = TMPSTA(ISTA)
            END DO
C
C           IF names can be obtained from VXNMIF
C           Again 2nd par set .TRUE. to use VXLINK frequencies
C
            IFLINK(NIFVEX) = VXNMIF( NIFVEX, .TRUE. )
            CALL VXUNQL( NIFVEX, IFLINK )
         END IF
C     
C        done inventing new IF
C
      END DO
C
      RETURN
      END

      SUBROUTINE CHK4DAR( KS, SNBBC, ERRS )
Cf2py intent(in, out) ERRS
C
C     Routine for SCHED called by CHKSET that checks items related
C     to the MARK IV DAR's.  It will only be called if the DAR is
C     of the MARK IV type.
C     By H.J. van Langevelde, JIVE, 281196 
C
C     2007-10-18 Modified by Cormac to know a little bit about GEO
C     patching. Previously could only handle ASTRO patching. Also added
C     a 'FREE' patch to allow blackbelts to do crazy things.
C
C     Rules for astro patching: Odd numbered VCs go on IF1N (and 2A),
C     even numbered on IF2N (and 1A). At least one of IF1N or IF2N must
C     be used. High/low patch should be the same for all VCs if
C     possible.
C
C     Rules for geo patching:
C        VCs 1-2    IF1N low
C        VC  3      IF1N high/low
C        VC  4      IF1N high
C        VCs 5-8    IF1N high or IF3N high or IF3O high
C        VC  9      IF2N low
C        VC  10     IF2N high/low
C        VCs 11-14  IF2N high
C     Geo patching doesn't typically have anything on the alt input.
C
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER        SNBBC, KS, ICH, I, LNAME, LEN1, JCH
      LOGICAL        ERRS, ALDONE, IFISLO, IFISHI, SPLPATCH
      LOGICAL        USENOR, PATERR, GEOPATER, GEOSPLPA
      REAL           LOWEDGE, HIEDGE
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'CHK4DAR: starting.' )
C
C
C
      LNAME = LEN1( SETNAME(KS) )
C
C     Check FORMAT.
C
      IF( VLBITP .AND. FORMAT(KS) .NE. 'NONE' ) THEN
         IF( FORMAT(KS) .NE. 'MARKIII' .AND. 
     1       FORMAT(KS) .NE. 'MKIV1:1' .AND. 
     2       FORMAT(KS) .NE. 'MKIV1:2' .AND.
     3       FORMAT(KS) .NE. 'MKIV1:4' .AND. 
     4       FORMAT(KS) .NE. 'MKIV2:1' .AND.
     5       FORMAT(KS) .NE. 'MKIV4:1' .AND.
     6       FORMAT(KS) .NE. 'MARK5B' .AND.
     7       FORMAT(KS) .NE. 'S2' ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A)' )
     1          'CHK4DAR: Invalid FORMAT for wideband observing '//
     2          '(see OBSTYPE): ', FORMAT(KS)
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
      END IF
C
C     For MkIV IFDIST should not be used (currently)
C
      DO I = 1, 4
         IF( IFDIST(I,KS) .NE. '0'  ) THEN
            MSGTXT = 'CHK4DAR: IFDIST specified: '//IFDIST(I,KS)// 
     1             ' not allowed in MkIV mode '
            CALL WLOG ( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
      END DO
C
C     Check items that depend on observation. Huib can't find
C     documentation must be same as VLBA
C
      IF( VLBITP ) THEN 
         IF( SAMPRATE(KS) .NE. 0.25 .AND. SAMPRATE(KS) .NE. 0.5 .AND. 
     1       SAMPRATE(KS) .NE. 1.0  .AND. SAMPRATE(KS) .NE. 2.0 .AND. 
     2       SAMPRATE(KS) .NE. 4.0  .AND. SAMPRATE(KS) .NE. 8.0 .AND.  
     3       SAMPRATE(KS) .NE. 16.  .AND. SAMPRATE(KS) .NE. 32. ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, F8.3 )' )
     1          'CHK4DAR: Invalid SAMPRATE specified: ', SAMPRATE(KS)
            CALL WLOG ( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
         IF( BITS(1,KS) .NE. 1 .AND. BITS(1,KS) .NE. 2 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5 )' ) 'CHK4DAR: BITS must be 1 or 2'
     1           // ' - Requested: ', BITS(1,KS)
            CALL WLOG ( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
      END IF
C
C     Check channel parameters, here is the fun for MkIV
C
      PATERR = .FALSE.
      GEOSPLPA = .FALSE.
      GEOPATER = .FALSE.
      USENOR = .FALSE.
      IFISLO = .FALSE.
      IFISHI = .FALSE.
      SPLPATCH = .FALSE.
      DO ICH = 1, NCHAN(KS)
C
C        IF channel assignment. Remember this maps as follow
C
         IF( IFCHAN(ICH,KS) .NE. '1N' .AND. 
     1       IFCHAN(ICH,KS) .NE. '1A' .AND.
     2       IFCHAN(ICH,KS) .NE. '2N' .AND. 
     3       IFCHAN(ICH,KS) .NE. '2A' .AND.
     4       IFCHAN(ICH,KS) .NE. '3N' .AND.
     5       IFCHAN(ICH,KS) .NE. '3O' ) THEN
            CALL WLOG ( 1, 'CHK4DAR: IFCHAN ''' // IFCHAN(ICH,KS) //
     1          ''' not 1N,1A,2A,2N,3N or 3O' )
            ERRS = .TRUE.
         END IF
         IF( IFCHAN(ICH,KS)(1:1) .EQ. '3' ) THEN
                CALL WLOG ( 1, 'CHK4DAR: Not many astronomical ' //
     2          'stations support IF=3, do I?' )
         END IF
C        
C        Make sure that at least one of the inputs is NOR. If NOR is not
C        used at all, then there is no signal from the telescope.
         IF( IFCHAN(ICH,KS) .EQ. '1N' .OR. 
     1       IFCHAN(ICH,KS) .EQ. '2N') THEN
            USENOR = .TRUE.
         END IF
C
C        1N should not occur with 1A, 2N not with 2A
C
         ALDONE = .FALSE.
         IF( ICH .GT. 1 ) THEN
            DO JCH = 1, ICH-1
C
C              looks like I did this not optimal, but is historical:
C
               IF( ( IFCHAN(ICH,KS) .EQ. '1N' .AND.
     1             IFCHAN(JCH,KS) .EQ. '1A' ) .OR. 
     2             ( IFCHAN(ICH,KS) .EQ. '2A' .AND. 
     3             IFCHAN(JCH,KS) .EQ. '2N' )  .OR.
     2             ( IFCHAN(ICH,KS) .EQ. '1A' .AND. 
     3             IFCHAN(JCH,KS) .EQ. '1N' )  .OR.
     2             ( IFCHAN(ICH,KS) .EQ. '2N' .AND. 
     3             IFCHAN(JCH,KS) .EQ. '2A' )) THEN
                  IF( .NOT. ALDONE ) THEN 
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( A  )' )
     1                   'CHK4DAR: IFCHAN setup assigns IFbox '//
     2                   'to two inputs simultaneously '
                     CALL WLOG( 1, MSGTXT )
                     ERRS = .TRUE.
                     ALDONE = .TRUE.
                  END IF
               END IF
            END DO
         END IF
C
C        BBC assignment, check total number
C
         IF( BBC(ICH,KS) .LT. 1 ) THEN
            CALL WLOG( 1, 'CHK4DAR: BBC number less than 1! ')
            ERRS = .TRUE.
         END IF
         IF( BBC(ICH,KS) .GT. SNBBC ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I3, A, I3, 2A )' )
     1         'CHK4DAR: Channel', ICH, ' uses a BBC (', BBC(ICH,KS),
     2         ') that does not exist.'
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
C        Now check patching
C
         IF( M4PATCH(KS) .EQ. 'FREE' ) THEN
C           This switches off all patching checks. Should only be used by 
C           blackbelts
            WRITE( MSGTXT, '(A, A, A)' )
     1         'You have specified FREE patching in setup ',
     2         SETNAME(KS)(1:LEN1(SETNAME(KS))),
     3         '. This schedule will almost certainly *not* work. Be'//
     4         ' very sure that you know what you are doing!'
            CALL WLOG( 1, MSGTXT )
         ELSE IF( M4PATCH(KS) .EQ. 'GEO1' ) THEN
C           Check for consistency with standard geodetic patching
            IF( BBC(ICH,KS) .LE. 4 .AND. 
     1           IFCHAN(ICH,KS) .NE. '1N' ) THEN

                MSGTXT = ' '
                WRITE( MSGTXT, '( A, I2, A, A3, A, A )' )
     1              'CHK4DAR: MkIV geodetic patching '//
     2              'has BBCs 1-4 on IF 1N, not BBC = ',
     3              BBC(ICH,KS), ' with IF= ',
     4              IFCHAN(ICH,KS), ' in setup ',
     5              SETNAME(KS)(1:LEN1(SETNAME(KS)))
                CALL WLOG( 1, MSGTXT )
                ERRS = .TRUE.
                GEOPATER = .TRUE.
            ELSE IF( ( BBC(ICH,KS) .GE. 5 .AND. BBC(ICH,KS) .LE. 8 ) 
     1          .AND. ( IFCHAN(ICH,KS) .NE. '3N' .AND. 
     2                  IFCHAN(ICH,KS) .NE. '3O' .AND.
     3                  IFCHAN(ICH,KS) .NE. '1N' ) ) THEN
                MSGTXT = ' '
                WRITE( MSGTXT, '( A, I2, A, A3, A, A )' )
     1              'CHK4DAR: MkIV geodetic patching '//
     2              'has BBCs 5-8 on IF 3N or 3O or 1N, not BBC = ',
     3              BBC(ICH,KS), ' with IF= ',
     4              IFCHAN(ICH,KS), ' in setup ',
     5              SETNAME(KS)(1:LEN1(SETNAME(KS)))
                CALL WLOG( 1, MSGTXT )
                ERRS = .TRUE.
                GEOPATER = .TRUE.
            ELSE IF( BBC(ICH,KS) .GE. 9 .AND. 
     1                IFCHAN(ICH,KS) .NE. '2N' ) THEN
                MSGTXT = ' '
                WRITE( MSGTXT, '( A, I2, A, A3, A, A )' )
     1              'CHK4DAR: MkIV geodetic patching '//
     2              'has BBCs 9-14 on IF 2, not BBC = ',
     3              BBC(ICH,KS), ' with IF= ',
     4              IFCHAN(ICH,KS), ' in setup ',
     5              SETNAME(KS)(1:LEN1(SETNAME(KS)))
                CALL WLOG( 1, MSGTXT )
                ERRS = .TRUE.
                GEOPATER = .TRUE.
            END IF
         ELSE IF( M4PATCH(KS) .EQ. 'ASTRO' ) THEN
C           This means we have astro patching
            IF( MOD(BBC(ICH,KS),2) .EQ. 0 ) THEN
               IF( IFCHAN(ICH,KS) .NE. '2A' 
     1             .AND. IFCHAN(ICH,KS) .NE. '2N' ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I2, A, A3, A, A )' )
     1                'CHK4DAR: MkIV astronomical patching '//
     2                'has even numbered BBCs on IF2 not: BBC= ',
     3                BBC(ICH,KS), ' with IF= ',
     4                IFCHAN(ICH,KS), ' in setup ',
     5                SETNAME(KS)(1:LEN1(SETNAME(KS)))
                  CALL WLOG( 1, MSGTXT )
                  ERRS = .TRUE.
                  PATERR = .TRUE.
               END IF
            ELSE
               IF( IFCHAN(ICH,KS) .NE. '1N' 
     1             .AND. IFCHAN(ICH,KS) .NE. '1A' ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I2, A, A3, A, A )' )
     1                'CHK4DAR: MkIV astronomical patching '//
     2                'has odd numbered BBCs on IF1 not: BBC= ',
     3                BBC(ICH,KS), ' with IF= ',
     4                IFCHAN(ICH,KS), ' in setup ',
     5                SETNAME(KS)(1:LEN1(SETNAME(KS)))
                  CALL WLOG( 1, MSGTXT )
                  ERRS = .TRUE.
                  PATERR = .TRUE.
               END IF
            END IF
         ELSE
            ERRS = .TRUE.
            MSGTXT = ' Unrecognized M4PATCH: ' // M4PATCH(KS)
            CALL WLOG( 1, MSGTXT )
         END IF

C        Get the edge of the baseband filters, because this is what
C        Drudg uses to determine whether to patch to high or low.
         LOWEDGE = BBSYN(ICH, KS)
         HIEDGE = BBSYN(ICH, KS)
         IF (NETSIDE(ICH,KS) .EQ. 'L') THEN
            LOWEDGE = LOWEDGE - BBFILT(ICH,KS)
         ELSE IF (NETSIDE(ICH,KS) .EQ. 'U') THEN
            HIEDGE = HIEDGE + BBFILT(ICH,KS)
         END IF
C
C        BBC synthesizer setting, must be between 100 and 500
C
         IF( BBSYN(ICH,KS) .LT. 100.0 .OR.
     1       BBSYN(ICH,KS) .GT. 500.0 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, F8.2 )' )
     1         'CHK4DAR: BBSYN not between 100 and 500: ', 
     2         BBSYN(ICH,KS)
            CALL WLOG( 1, MSGTXT )
            WRITE( MSGTXT, '( A, F9.2, 2A )' )
     1         '        FIRSTLO and first sideband are:', 
     2         FIRSTLO(ICH,KS), '  ', SIDE1(ICH,KS)
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
C
C           We can also check whether High/Low IF output used conforms
C           with standards. 
C
C           For ASTRO patching, usually prefer that VCs are all on low
C           or all on high. There is some overlap between the high and
C           low patches and Drudg will try to keep all VCs on the same
C           patch if possible, so ignore VCs that lie in this range
C           (email from Himwich). 
C
C           For GEO patching the preference for high or low patch
C           depends on the VC number, and again Drudg will try to put
C           VCs in the overlap region on the right patch.
C
         ELSE IF( M4PATCH(KS) .EQ. 'GEO1' ) THEN
            IF( ( BBC(ICH,KS) .LE. 2 .OR.
     1            BBC(ICH,KS) .EQ. 9 ) 
     2         .AND. ( HIEDGE .GT. 230 ) )  THEN
C
C              These VCs should be on low
C
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I2.2, A )' )
     1           'CHK4DAR: Improper patching BBC#',
     2            BBC(ICH,KS), 
     3            ' is not on Low.'
                  CALL WLOG( 1, MSGTXT )
               GEOSPLPA = .TRUE.
            ELSE IF( ( ( BBC(ICH,KS) .GE. 4 .AND. BBC(ICH,KS) .LE. 8 ) 
     1        .OR. ( BBC(ICH,KS) .GE. 11 .AND. BBC(ICH,KS) .LE. 14 ) ) 
     2        .AND. ( LOWEDGE .LT. 210 ) )  THEN
C
C              These VCs should be on high
C
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I2.2, A )' )
     1             'CHK4DAR: Inconsistent patching BBC#',
     2             BBC(ICH,KS), 
     3             ' is not on High.'
               CALL WLOG( 1, MSGTXT )
               GEOSPLPA = .TRUE.
            ELSE
C              Will get here for VCs 3 and 10 where either patch is o.k.
            END IF

         ELSE IF( M4PATCH(KS) .EQ. 'ASTRO' ) THEN
C
C           This must be astro patching. Patches can be high or low, but
C           should be the same for all VCs if possible.
C            
            IF( LOWEDGE .LT. 210 ) THEN 
C     
C              must be low
C
               IFISLO = .TRUE.
               IF( IFISHI ) THEN
C                 must issue warning
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I2.2, A )' )
     1                'CHK4DAR: Inconsistent patching BBC#',
     2                BBC(ICH,KS), ' is not on High '
                  CALL WLOG( 1, MSGTXT )
                  SPLPATCH = .TRUE.
               END IF
            ELSE IF( HIEDGE .GT. 230 ) THEN 
C
C              must be high
C
               IFISHI = .TRUE.
               IF( IFISLO ) THEN
C                 must issue warning
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I2.2, A )' )
     1                'CHK4DAR: Inconsistent patching BBC#',
     2                BBC(ICH,KS), ' is not on Low '
                  CALL WLOG( 1, MSGTXT )
                  SPLPATCH = .TRUE.
               END IF
C
            END IF
         ELSE IF( M4PATCH(KS) .EQ. 'FREE') THEN
C           Anything goes. This is the 'blackbelt' mode for people like
C           Dave Graham.
         ELSE
            ERRS = .TRUE.
            MSGTXT = ' Unrecognized M4PATCH: ' // M4PATCH(KS)
            CALL WLOG( 1, MSGTXT )
         END IF
C
C        BBC filter bandwidth, the following set exists
C
         IF( BBFILT(ICH,KS).NE.0.0625 .AND. BBFILT(ICH,KS).NE.0.125
     1       .AND. BBFILT(ICH,KS).NE.0.250 .AND. BBFILT(ICH,KS).NE.0.5 
     2       .AND. BBFILT(ICH,KS).NE.1.0   .AND. BBFILT(ICH,KS).NE.2.0 
     3       .AND. BBFILT(ICH,KS).NE.4.0   .AND. BBFILT(ICH,KS).NE.8.0
     4       .AND. BBFILT(ICH,KS).NE.16. ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, F8.2 )' )
     1          'CHK4DAR: Invalid BBFILTER specified: ',
     2          BBFILT(ICH,KS)
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
C
C           but some of these are not standard in the rack:
C
         ELSE IF( BBFILT(ICH,KS) .EQ. 0.250 
     1          .OR. BBFILT(ICH,KS).EQ.1.000 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, F6.2, A )' )
     1          'CHK4DAR: The ', BBFILT(ICH,KS),
     2          'MHz filter only available as plug-in '//
     3          'at most MkIV stations, contact friend of VLBI'
            CALL WLOG( 1, MSGTXT )
C
C              not an error, available as plug in...
C
         ELSE IF( BBFILT(ICH,KS) .EQ. 0.500 
     1          .OR. BBFILT(ICH,KS).EQ. 0.125 ) THEN
C
C              and the narrow ones could be restricted to 1st 8 USB
C
            IF( BBC(ICH,KS) .GT. 8 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, A, I2.2, A )' )
     1             'CHK4DAR: ', SETNAME(KS)(1:LEN1(SETNAME(KS))),
     2             ' uses narrow filter in BBC#', BBC(ICH,KS),
     3             ', verify with station! '
               CALL WLOG( 1, MSGTXT )
            ENDIF
            IF (SIDEBD(ICH,KS) .EQ. 'L' ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, A )' ) 
     1             'CHK4DAR: ', SETNAME(KS)(1:LEN1(SETNAME(KS))),
     2             'uses narrow filters in LSB, verify with station! '
               CALL WLOG( 1, MSGTXT )
            END IF
         END IF
C
C        copy this bit on frequency switching, already disallowed
C
         IF( FRSWITCH(KS) .AND. (BBSYN2(ICH,KS) .LT. 100.0 .OR.
     1       BBSYN2(ICH,KS) .GT. 500.0 ) ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, F8.2 )' )
     1         'CHK4DAR: BBSYN2 not between 100 and 500: ', 
     2          BBSYN2(ICH,KS)
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
C        stop use of VC's above 8 in 1:4 fan-out, Graham 22/1/01
C
         IF( BBC(ICH,KS) .GT. 8 .AND. FANOUT(KS) .EQ. 4.0 ) THEN 
            WRITE( MSGTXT, '( A, A )' ) 
     1          'CHK4DAR: BBC9 and above cannot be used in 1:4',
     2          ' fan-out choose another setup '
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
      END DO
C
      IF( PATERR ) THEN
        CALL WRTMSG(0, 'CHK4DAR', 'astropatch' )
      END IF
C
      IF( GEOPATER .OR. GEOSPLPA ) THEN
        CALL WRTMSG(0, 'CHK4DAR', 'geopatch' )
      END IF
C
      IF( M4PATCH(KS) .EQ. 'FREE' ) THEN
        CALL WRTMSG(0, 'CHK4DAR', 'freepatch' )
      ELSE IF( M4PATCH(KS) .EQ. 'GEO1' ) THEN
         WRITE( MSGTXT, '(A)' )
     1      'You have specified geodetic patching (M4PATCH=GEO1).'//
     2      ' This is experimental - check results carefully!'
         CALL WLOG( 1, MSGTXT )
      END IF
C
      IF( .NOT. USENOR ) THEN
         WRITE(MSGTXT, '( A, A, A)' )
     1       'CHk4DAR: Neither IFCHAN 1N nor 2N have been assigned ',
     2       ' in setup ',SETNAME(KS)(1:LEN1(SETNAME(KS)) )
         CALL WLOG( 1, MSGTXT )
         WRITE(MSGTXT, '(A, A)' )
     1      'This is not a valid setup for a MkIV data acquisition ',
     2      'rack. Please check your setting of IFCHAN'
         CALL WLOG( 1, MSGTXT )
         ERRS = .TRUE.
      END IF
        
C
      IF (SPLPATCH) THEN 
         WRITE(MSGTXT, '( A, A, A, A)' )
     1       'CHk4DAR: Requested mixed patching for ',SETSTA(1,KS),
     2       ' in setup ',SETNAME(KS)(1:LEN1(SETNAME(KS)) )
         CALL WLOG( 1, MSGTXT )
         WRITE(MSGTXT, '( A, A )' )
     1       '         Decrease frequency coverage or change LO, ', 
     2       'or verify with station that this is OK!'
         CALL WLOG( 1, MSGTXT )
C
      END IF 
C
      IF (GEOSPLPA) THEN
         WRITE(MSGTXT, '( A, A, A, A)' )
     1       'CHk4DAR: Requested non-standard geodetic patching for ',
     2       SETSTA(1,KS), ' in setup ',
     3       SETNAME(KS)(1:LEN1(SETNAME(KS)) )
         CALL WLOG( 1, MSGTXT )
         WRITE(MSGTXT, '( A, A )' )
     1       '         Change frequency or LO, ', 
     2       'or verify with station that this is OK! ' //
     3       'See sched.runlog for more details.'
         CALL WLOG( 1, MSGTXT )
C
      END IF 

      RETURN
      END
C

      LOGICAL FUNCTION VXCFFQ( ISET, JSET )
C 
C     Routine specific for the VEX extension of SCHED. 
C     returns true if Freq block in 2 SCHED sets are identical
C     By H.J. van Langevelde, JIVE, 300496 
C 
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER ISET, JSET, ICH ! ISIDE1, JSIDE1 (comment Sep 2013 RCW)
      LOGICAL IDENT
      CHARACTER UPCALI*4, UPCALJ*4
C ----------------------------------------------------------------------
C
      IDENT = .TRUE.
C
C     first check n channels, different if different PCal:
C
      UPCALI = SPCAL(ISET)
      UPCALJ = SPCAL(JSET)
      CALL UPCASE(UPCALI)
      CALL UPCASE(UPCALJ)
      IF( UPCALI .NE. UPCALJ ) THEN
         IDENT = .FALSE.
C
C        or different number of channels
C
      ELSE IF( NCHAN(ISET) .NE. NCHAN(JSET) ) THEN
         IDENT = .FALSE.
      ELSE
C
C        check pols, first in ISET
C
         DO ICH = 1, NCHAN(ISET)
C
C           now compare pols, can only be RCP or LCP (chkset)
C
            IF( POL(ICH,ISET) .NE. POL(ICH,JSET) ) IDENT = .FALSE. 
C
C           Check the frequencies.
C           I removed the unnecessary calculation of ILOSUM and 
C           JLOSUM.  The values are already available as FREQREF.
C           RCW  Nov. 8, 2011
C
            IF( ABS(FREQREF(ICH,ISET)-FREQREF(ICH,JSET)) .GT. 1D-4 ) 
     1           IDENT = .FALSE.
C
C           check bandwidth
C
            IF( BBFILT(ICH,ISET) .NE. BBFILT(ICH,JSET) ) IDENT = .FALSE.
C
C           Check the net sideband.  We ran into a real schedule that 
C           shifted by one BBC bandwidth and flipped sideband causing
C           two different cases to appear to be the same.
C
            IF( NETSIDE(ICH,ISET) .NE. NETSIDE(ICH,JSET) ) 
     1           IDENT = .FALSE.
C
C           finally wiring should be identical
C
            IF( BBC(ICH, ISET) .NE. BBC(ICH, JSET)) IDENT = .FALSE.
C     
         END DO
C
C        and sample rate and number of bits
C
         IF( SAMPRATE(ISET) .NE. SAMPRATE(JSET) ) IDENT = .FALSE.
         IF( BITS(1,ISET) .NE. BITS(1,JSET) ) IDENT = .FALSE.
C
      END IF
C
      VXCFFQ = IDENT
C
      RETURN
      END

      SUBROUTINE GETPAIRS
C
C     Make pairs of sources with a pointing center and a named group
C     of phase centers.  This is useful when writing out source lists
C     etc.
C
C     A given pointing source could, in principle, have more than
C     one list of centers (think multi-band work) or a given list
C     of centers could be used with more than one pointing center
C     (not sure why).  Set up the infrastructure to be compatible
C     with either, but then don't allow either because I don't see
C     how Adam's V2D spec can support either.  
C
      INCLUDE   'sched.inc'
C
C      integer   len1
      INTEGER   ISCN, IPAIR, JPAIR
C -----------------------------------------------------------------
C
C     Construct the pairs.
C
      NPAIR = 0
      DO ISCN = SCAN1, SCANL
         IF( ICENT(ISCN) .NE. 0 ) THEN
            IF( NPAIR .NE. 0 ) THEN
               DO IPAIR = 1, NPAIR
                  IF( PAIRSRC(IPAIR) .EQ. SRCNUM(ISCN) .AND.
     1                PAIRCENT(IPAIR) .EQ. ICENT(ISCN) ) THEN
                     GO TO 100
                  END IF
               END DO
            END IF
            NPAIR = NPAIR + 1
            PAIRSRC(NPAIR) = SRCNUM(ISCN)
            PAIRCENT(NPAIR) = ICENT(ISCN)
  100       CONTINUE
         END IF
      END DO     
C
C     Have a cow for now if there is more than one phase list
C     center per pointing source.  v3d doesn't support that.
C     I think the centers can be duplicated with different 
C     pointing centers although I don't know why you would do that.
C     The check is simply done by looking for duplicate source
C     in the pairs list.
C
      IF( NPAIR .GE. 2 ) THEN
         DO IPAIR = 2, NPAIR
            DO JPAIR = 1, IPAIR - 1           
               IF( PAIRSRC(JPAIR) .EQ. PAIRSRC(IPAIR) .OR.
     1             PAIRCENT(JPAIR) .EQ. PAIRCENT(IPAIR) ) THEN
                  MSGTXT = ' '
                  CALL WLOG( 1, ' ' )
                  WRITE( MSGTXT, '( A, A, 3X, A )' )
     1              'Sources: ', SRCNAME(SRLSTN(PAIRSRC(JPAIR))),
     2               SRCNAME(SRLSTN(PAIRSRC(IPAIR)))
                  CALL WLOG(1, MSGTXT )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A, 3X, A )' )
     1              'Centers: ', CTRNAME(PAIRCENT(JPAIR)), 
     2              CTRNAME(PAIRCENT(IPAIR))
                  CALL WLOG(1, MSGTXT )
                  MSGTXT = ' '
                  IF( PAIRSRC(JPAIR) .EQ. PAIRSRC(IPAIR) ) 
     1               CALL ERRLOG( 'Two lists of phase centers '//
     2               'cannot be used with the same pointng center' )
                  IF( PAIRCENT(JPAIR) .EQ. PAIRCENT(IPAIR) )
     1               CALL WLOG( 1, 'Do you really indend to use '//
     2               'two pointing centers with the same list '//
     3               'of phase centers?' )
               END IF
            END DO
         END DO
      END IF
C
      RETURN
      END

      SUBROUTINE CORLST
C
C     Routine for SCHED that writes the correlator information
C     to the summary file.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
C     Note that the "E" accumulators are to include the "EXTRA" 
C     scans while the original versions are for the core.
C
      INTEGER           ISTA, ISCN, I, NSANT, NBAS, NPOL, LEN1, IC
      REAL              DATARATE, MAXSPD, EMAXSPD, DMAXSPD
      DOUBLE PRECISION  STIME
      DOUBLE PRECISION  TTIME, TRTIME, TBTIME
      DOUBLE PRECISION  TIMEB, TIMEL, TLAST
      DOUBLE PRECISION  ETTIME, ETRTIME, ETBTIME
      DOUBLE PRECISION  ETIMEB, ETIMEL, ETLAST
      DOUBLE PRECISION  DTTIME, DTRTIME, DTBTIME
      DOUBLE PRECISION  DTIMEB, DTIMEL, DTLAST
      LOGICAL           OVERLAP, GOTCENT, DOSC
      CHARACTER*90      LINEH, LINE1, LINE2, LINE3, LINE4, LINE5, LINE6
C
C     Note that MAXDR and DATASIZE are passed through the include
C     to the correlator specific routines and the OMS routines 
C     which must be called later.


C  *************  go looking for MAXDR and DATASIZE and add E equiv.


C ------------------------------------------------------------------
C     Only do this if tapes are being used.
C
      IF( NOTAPE ) THEN
         WRITE( ISUM, '( 1X, /, A )' )
     1      'No recordings.  Correlation requests ignored.'
      ELSE
C
C        Write the first line of CORSTUFF - the section header.
C
         WRITE( ISUM, '( 1X, /, A )' ) CORSTUFF(1)(1:LEN1(CORSTUFF(1)))
C
C        Flag a request for multiple correlation centers.
C
         IF( NPAIR .GT. 0 ) THEN
            WRITE( ISUM, '( 1X,/, A ) ' )
     1           '  THIS PROJECT USES MULTIPLE PHASE CENTERS.'
C
C           Check that the number of FFT channels is reasonable for
C           multiple phase centers.  It might be better in CHKCOR, 
C           but it is not necessarily clear by then that the multiple
C           phase centers are being used.  Use a crude check.
C
C           Eventually examine the field of view used in each group
C           of centers and the baseband bandwidth and make a 
C           recommendation.  But that is work so it is put off for
C           now (Feb 2014).
C
            IF( CORFFT .LT. 4000 ) THEN
               CALL WLOG( 1, 'CORLST:   WARNING - your number of '//
     1            'channels in the correlator FFT may not ' )
               CALL WLOG( 1, '          be adequate for multiple '//
     1            'phase centers.' )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I6, A )' ) 
     1            '          You have specified CORCHAN(2) =', 
     2            CORFFT
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, '          More typical is several '//
     1            'thousand to avoid smearing on offset phase centers.')
               CALL WLOG( 1, '          Please consider CORCHAN(2) '//
     1            'carefully.')
               CALL WLOG( 1, '          See the SCHED manual '//
     1            'sections on multiple phase centers and on '//
     2            'parameter CORCHAN.')
               WRITE( ISUM, '( A )' )
     1            '    Worry about possible inadequate FFT channels.' 
            END IF
         END IF
C
C        Write the correlator summary stuff that was compiled earlier.
C
         WRITE( ISUM, '( 1X, /,  9(A,/), 1X, /, ' // 
     1        ' 5(A,/), 1X, /, 5(A,/) )' ) 
     2      ( CORSTUFF(I)(1:LEN1(CORSTUFF(I))), I = 2, MCOR )
C
C        Get the parameters of the observation that are needed to get 
C        the data rates and volume.
C
C        Get the factor related to the polarization processing.
C
         NPOL = 1
         IF( CORPOL ) NPOL = 2
C
C        Initialize some accumulators.
C
         TTIME = 0.D0
         TRTIME = 0.D0
         TBTIME = 0.D0
         MAXDR = 0.0
         TIMEB = 1.D10
         TIMEL = 0.D0
         TLAST = 0.D0
         DATASIZE = 0.D0
         OVERLAP = .FALSE.
         GOTCENT = .FALSE.
         MAXSPD = 0.0
C
         ETTIME = 0.D0
         ETRTIME = 0.D0
         ETBTIME = 0.D0
         EMAXDR = 0.0
         ETIMEB = 1.D10
         ETIMEL = 0.D0
         ETLAST = 0.D0
         EDATASIZ = 0.D0
         EMAXSPD = 0.0
C
         DTTIME = 0.D0
         DTRTIME = 0.D0
         DTBTIME = 0.D0
         DMAXDR = 0.0
         DTIMEB = 1.D10
         DTIMEL = 0.D0
         DTLAST = 0.D0
         DDATASIZ = 0.D0
         DMAXSPD = 0.0
C
C        Loop through scans.
C
         DO ISCN = SCAN1, SCANL
C
C           Simplify the repeated test for DOSCANS.
C
            DOSC = DOSCANS(1) .EQ. 0 .OR.
     1        ( ISCN .GE. DOSCANS(1) .AND. ISCN .LE. DOSCANS(2) )
C
C           Start and end times of experiment to determine elapsed time.
C
            ETIMEB = MIN( ETIMEB, STARTJ(ISCN) )
            ETIMEL = MAX( ETIMEL, STOPJ(ISCN) )
            IF( PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
               TIMEB = MIN( TIMEB, STARTJ(ISCN) )
               TIMEL = MAX( TIMEL, STOPJ(ISCN) )
            END IF
            IF( DOSC ) THEN
               DTIMEB = MIN( DTIMEB, STARTJ(ISCN) )
               DTIMEL = MAX( DTIMEL, STOPJ(ISCN) )
            END IF
C
C           Get number of stations in the scan.
C
            NSANT = 0
            DO ISTA = 1, NSTA
               IF( STASCN(ISCN,ISTA) ) THEN
                  NSANT = NSANT + 1            
               END IF
            END DO
C
C           Get time in all scans, including non-recording scans.
C
            IF( NSANT .GT. 0 ) THEN
               STIME = ( STOPJ(ISCN) - STARTJ(ISCN) ) * 86400.D0
               ETTIME = ETTIME + STIME
               IF( PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
                  TTIME = TTIME + STIME
               END IF
               IF( DOSC ) THEN
                  DTTIME = DTTIME + STIME
               END IF
            END IF
C
C           For scans recording data, get the time and the time 
C           multiplied by the number of baselines.  Look for signs
C           that the derived data volume will be wrong.
C
C           The estimate here will be an overestimate of the actual
C           time used in some cases.  This is because the time that 
C           the recorders will be on actually depends on the 
C           on-source time for VLA and VLBA MARK5C observations.
C           Thus the starts are station dependent.  For now, just 
C           warn of the over estimate of baseline time, but don't
C           jump through the hoops to fix it.  Some day.....
C
            IF( NSANT .GT. 0 .AND. .NOT. NOREC(ISCN) ) THEN
               NBAS = NSANT * ( NSANT - 1 ) / 2 + NSANT
               ETRTIME = ETRTIME + STIME
               ETBTIME = ETBTIME + STIME * NBAS
               IF( PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
                  TRTIME = TRTIME + STIME
                  TBTIME = TBTIME + STIME * NBAS
               END IF
               IF( DOSC ) THEN
                  DTRTIME = DTRTIME + STIME
                  DTBTIME = DTBTIME + STIME * NBAS
               END IF
C
C              Test for backward time jumps.
C
               IF( STARTJ(ISCN) .LT. TLAST ) OVERLAP = .TRUE.
               TLAST = STOPJ(ISCN)
C
C              Get the data rate based on a Romney formula.
C              The data rate in bytes/sec is given APPROXIMATELY as
C              This is for the VLBA correlator, but is probably 
C              pretty close for any correlator.
C
C               4 * Ns * (Ns + 1) * Nc * Nsp * P * Su / Tavg
C
C               where Ns   = number of stations
C                     Nc   = number of (BaseBand) channels (1, ... 32)
C                     Nsp  = spectral resolution (8, 16, 32 ... 512)
C                     P    = 2 for polarization, 1 for none
C                     Su   = speed up factor (1, 2, 4)
C                    Tavg = time average in seconds
C
C              Note that FSPEED will now always be 1.0.  It is somewhat
C              of a meaningless parameter any more with disk recordings.
C
               IF( CORAVG .GT. 0.0 .AND. .NOT. NOSET ) THEN
                  DATARATE = 4.0 * NSANT * (NSANT+1) * 
     1                       MSCHN(SETNUM(ISCN)) * CORCHAN *
     2                       NPOL * FSPEED(SETNUM(ISCN)) / CORAVG
               ELSE
                  DATARATE = 0.0
               END IF
               EMAXDR = MAX( EMAXDR, DATARATE )
               EMAXSPD = MAX( EMAXSPD, FSPEED(SETNUM(ISCN)))
               IF( PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
                  MAXDR = MAX( MAXDR, DATARATE )
                  MAXSPD = MAX( MAXSPD, FSPEED(SETNUM(ISCN)))
               END IF
               IF( DOSC ) THEN
                  DMAXDR = MAX( DMAXDR, DATARATE )
                  DMAXSPD = MAX( DMAXSPD, FSPEED(SETNUM(ISCN)))
               END IF
C
C              Accumulate the data size.  Note double precision - for 
C              multiple Gbytes, small numbers being added to large 
C              numbers might stop accumulating.
C
               IF( FSPEED(SETNUM(ISCN)) .NE. 0.0 ) THEN
                  EDATASIZ = EDATASIZ + DATARATE * STIME / 
     1                       FSPEED(SETNUM(ISCN))
                  IF( PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
                     DATASIZE = DATASIZE + DATARATE * STIME / 
     1                       FSPEED(SETNUM(ISCN))
                  END IF
                  IF( DOSC ) THEN
                     DDATASIZ = DDATASIZ + DATARATE * STIME / 
     1                       FSPEED(SETNUM(ISCN))
                  END IF
               END IF
C
               IF( ICENT(ISCN) .NE. 0 ) GOTCENT = .TRUE.
C
            END IF
         END DO
C
C        Now write the above results.  Only make the Core/Extras 
C        distinction if there are differences.
C
         WRITE( ISUM, '( 1X, /, A )' )
     1       'DERIVED INFORMATION FOR CORRELATION: '
         LINEH = ' '
         LINE1 = '  Elapsed time for project (hours):' 
         LINE2 = '  Total time in scheduled scans (hours):'
         LINE3 = '  Total time in recording scans (hours): '
         LINE4 = '  Total baseline hours (recording scans):'
         LINE5 = '  Projected max correlator output rate (kB/s):'
         LINE6 = '  Projected correlator output data size (MB):'
         IC    = 47
C
C        Write the core data to the lines if there were fuzzy ends.
C
         IF( FUZZY ) THEN
            WRITE( LINEH(IC+6:IC+10), '( A )' ) 'Core'
            WRITE( LINE1(IC+2:IC+9), '( F8.2 )' )
     1           ( TIMEL - TIMEB ) * 24.D0
            WRITE( LINE2(IC+2:IC+9), '( F8.2 )' ) TTIME / 3600.D0
            WRITE( LINE3(IC+2:IC+9), '( F8.2 )' ) TRTIME / 3600.D0
            WRITE( LINE4(IC+2:IC+9), '( F8.2 )' ) TBTIME / 3600.D0
            WRITE( LINE5(IC:IC+9), '( F10.1 )' ) MAXDR / 1000.0
            WRITE( LINE6(IC:IC+9), '( F10.1 )' ) DATASIZE / 1.D6
            IC = IC + 10
         END IF
C
C        Now write the sums for all data.  Always do this.
C
         WRITE( LINEH(IC+2:IC+10), '( A )' ) 'All scans'
         WRITE( LINE1(IC+2:IC+9), '( F8.2 )' )
     1        ( ETIMEL - ETIMEB ) * 24.D0
         WRITE( LINE2(IC+2:IC+9), '( F8.2 )' ) ETTIME / 3600.D0
         WRITE( LINE3(IC+2:IC+9), '( F8.2 )' ) ETRTIME / 3600.D0
         WRITE( LINE4(IC+2:IC+9), '( F8.2 )' ) ETBTIME / 3600.D0
         WRITE( LINE5(IC:IC+9), '( F10.1 )' ) EMAXDR / 1000.0
         WRITE( LINE6(IC:IC+9), '( F10.1 )' ) EDATASIZ / 1.D6
         IC = IC + 10
C
C        Then the sums for the DOSCANS.
C
         IF( DOSCANS(1) .GT. 0 ) THEN
            WRITE( LINEH(IC+4:IC+10), '( A )' ) 'DOSCANS'
            WRITE( LINE1(IC+2:IC+9), '( F8.2 )' )
     1           ( DTIMEL - DTIMEB ) * 24.D0
            WRITE( LINE2(IC+2:IC+9), '( F8.2 )' ) DTTIME / 3600.D0
            WRITE( LINE3(IC+2:IC+9), '( F8.2 )' ) DTRTIME / 3600.D0
            WRITE( LINE4(IC+2:IC+9), '( F8.2 )' ) DTBTIME / 3600.D0
            WRITE( LINE5(IC:IC+9), '( F10.1 )' ) DMAXDR / 1000.0
            WRITE( LINE6(IC:IC+9), '( F10.1 )' ) DDATASIZ / 1.D6
         END IF
C
C        Now write the lines.
C

         WRITE( ISUM, '( A, 6( /, A ) )' ) LINEH(1:LEN1(LINEH)), 
     1         LINE1(1:LEN1(LINE1)), LINE2(1:LEN1(LINE2)),
     2         LINE3(1:LEN1(LINE3)), LINE4(1:LEN1(LINE4)), 
     3         LINE5(1:LEN1(LINE5)), LINE6(1:LEN1(LINE6))
C
         WRITE( ISUM, '( A, A, /, A, A, /, A, A, /, A, A )' )
     1       ' NOTES:  Above numbers assume the same correlator ',
     2       'parameters are used for all data.',
     3       '         The ''baseline hours'' include the ',
     4       'autocorrelations (for data size calculations).',
     3       '         The correlator output data rate is for ',
     4       'real-time processing.',
     5       '         Above numbers assume the same correlator',
     6       ' parameters are used for all data.'
         WRITE( ISUM, '( A, A, /, A, A )' )
     1       '         The recordings for a scan are assumed to ',
     2       'start at the scan START minus PRESTART.',
     3       '         Some stations (VLA, VLBA/MARK5C) wait for ',
     4       'good data so the estimates may be high.'
         IF( FUZZY ) WRITE( ISUM, '( A )' )
     1       '         ''Core'' are scans with PREEMPT not ''EXTRA''.'
         IF( DOSCANS(1) .NE. 0 ) WRITE( ISUM, '( A, A )' )
     1       '         Only scans in the DOSCANS range will be written',
     2       ' to the Vex and other files.'
         IF( GOTCENT ) WRITE( ISUM, '( A, /, A )' ) 
     1       '         Multiple phase center processing requested.',
     2       '     Correlator output numbers are for first file only.'

         IF( DATASIZE .GT. 16.0E9 ) THEN
            WRITE( ISUM, '( A )' )
     1       '  NOTE:  Output data set size large.  '
         END IF
C
C        Deal with correlator specific situations.  Only Socorro 
C        hardware correlator for now (and that has been shut down).
C
         CALL CORSOC
C
C        Warn if there are reasons to believe the data rates are wrong.
C
         IF( OVERLAP ) THEN
            WRITE( ISUM, '( 1X, /, A, /, 4( A, / ) )' )
     1      ' **** WARNING *****', 
     2      '      Overlapping scans were detected.  Either there '//
     3            'was subarraying',
     4      '      or some stations were scheduled separtely from '//
     5            'others.',
     6      '      If the latter, the output data rates and volume '//
     7            'are underestimated',
     8      '      because the number of baselines is underestimated.'
C
C           I think any pointing scans should have NOREC set and so 
C           shouldn't trigger this warning.  But I'm leaving the code
C           here in case I'm missing something.
C
C            IF( AUTOPEAK ) THEN
C               WRITE( ISUM, '( A, /, A )' )
C     1         '      This might be due to inserted pointing scans '//
C     2               'in which case', 
C     3         '      there is no impact on data estimates.'
C            END IF
C
            WRITE( ISUM, '( 1X, / )' )
         END IF
      END IF
C
      RETURN
      END

      CHARACTER*9 FUNCTION VLBASTOP( STOPJ, ADDSEC, LASTDY, TWOPI,
     1    IUVBA ) 
C
C     Function mainly for VLBAEND that gets the TSTOP character 
C     string and updates the day if necessary.
C
C     Be careful where this is called because it will write the
C     day to the output file if it is needed.
C
      DOUBLE PRECISION  STOPJ, FRACD, ADDSEC, TWOPI
      INTEGER         LASTDY, DOY, IUVBA
      CHARACTER       TFORM*15, VLBAD*9, HUMAND*16
C -----------------------------------------------------------------
C     Get the time in fraction of a day and in human readable forms.
C
      CALL SCHDAY( STOPJ + ADDSEC / 86400.D0, VLBAD, 
     1             HUMAND, DOY, FRACD )
C
C     Get the stop time character string.
C
      VLBASTOP  = TFORM( FRACD*TWOPI, 'T', 0, 2, 2, 'hms' )
C
C     Update the day number if needed.  Write to VLBA file.
C
      IF( DOY .NE. LASTDY ) THEN
         WRITE( IUVBA, '(''date='', A9 )' ) VLBAD
         LASTDY = DOY
      END IF
C
C     Done.
C
      RETURN
      END

      LOGICAL FUNCTION VXCFRL( ISET, JSET )
C 
C     Routine specific for the VEX extension of SCHED. 
C     returns true if RL block in 2 SCHED sets are identical
C     for now it is all 14 track, so depends on BARREL and TAPEMODE
C     By H.J. van Langevelde, JIVE, 300496 
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER ISET, JSET, IROLL, JROLL
      LOGICAL IDENT
C ----------------------------------------------------------------------
C
      IDENT = .TRUE.      
C
C     Find out both rolls
C
      IROLL = -1
      IF( BARREL(ISET) .EQ. 'roll_off' ) IROLL = 0
      IF( BARREL(ISET) .EQ. 'roll_16' ) IROLL = 16
      IF( BARREL(ISET) .EQ. 'roll_8' ) IROLL = 8
      IF( BARREL(ISET) .EQ. 'roll_auto' ) THEN
         IF( FORMAT(ISET)(1:7) .EQ. 'MARKIII' ) THEN
            IROLL = 0
         ELSE
            IF( TAPEMODE(ISET) .EQ. 1 ) IROLL = 16
            IF( TAPEMODE(ISET) .EQ. 2 ) IROLL = 16
            IF( TAPEMODE(ISET) .EQ. 4 ) IROLL = 8
            IF( TAPEMODE(ISET) .EQ. 0 ) IROLL = 0
         END IF
      END IF
C
      JROLL = -1
      IF( BARREL(JSET) .EQ. 'roll_off' ) JROLL = 0
      IF( BARREL(JSET) .EQ. 'roll_16' ) JROLL = 16
      IF( BARREL(JSET) .EQ. 'roll_8' ) JROLL = 8
      IF( BARREL(JSET) .EQ. 'roll_auto' ) THEN
         IF( FORMAT(JSET)(1:7) .EQ. 'MARKIII' ) THEN
               JROLL = 0
         ELSE
            IF( TAPEMODE(JSET) .EQ. 1 ) JROLL = 16
            IF( TAPEMODE(JSET) .EQ. 2 ) JROLL = 16
            IF( TAPEMODE(JSET) .EQ. 4 ) JROLL = 8
            IF( TAPEMODE(JSET) .EQ. 0 ) JROLL = 0
         END IF
      END IF
C
      IF( IROLL .NE. JROLL ) IDENT = .FALSE.
C
      VXCFRL = IDENT 
C
      RETURN
      END

      SUBROUTINE VXWRSI
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the SI = $SITE section 
C     By H.J. van Langevelde, JIVE, 300496 
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
C     Huib's local variables 
C      
      INTEGER   IXX, NLINES, I, J, ISTA, ISCAT
      INTEGER   LEN1, EPYEAR, EPDAY
      DOUBLE PRECISION  EPTIME, DEPMJD
      CHARACTER LINE*132, TFORM*15, CHRLON*11, CHRLAT*11, DEL*1
      CHARACTER TMPSTA*32
      LOGICAL   VIOLFS
C ----------------------------------------------------------------------
C
      VIOLFS = .FALSE.
      LINE = ' ' 
C
C     Site section
C
      WRITE( IVEX, '( A, A1 )' ) '$SITE', SEP
      DO IXX = 1, NSIVEX
C
C        find a station to which this refers
C
         ISTA = -1
         DO I = 1, NSTA
            IF( ISTASI(I) .EQ. IXX ) ISTA = I
         END DO
C
         IF( ISTA .LT. 0 ) 
     1        CALL ERRLOG(' VXWRSI: no station for $SITE def ')
C
         ISCAT = STANUM(ISTA)
C
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1        SILINK(IXX)(1:LEN1(SILINK(IXX))),SEP       
C
C        first the simple things
C         
         WRITE( IVEX, '( 5X, A, A, A1 )' ) 'site_type = ','fixed',SEP
         TMPSTA = STATION(ISCAT)
         CALL VXSTKY(TMPSTA,.FALSE.)
         WRITE( IVEX, '( 5X, A, A, A1 )' ) 'site_name = ',
     1        TMPSTA(1:LEN1(TMPSTA)), SEP
         WRITE( IVEX, '( 5X, A, A, A1 )' ) 'site_ID = ',
     1        STCODE(ISCAT)(1:LEN1(STCODE(ISCAT))), SEP 
C
C        Position, calculated from ELEV, LONG, LAT or stored
C 
         CHRLON = TFORM( LONG(ISCAT), ' ', 1, 3, 4, ':::' )
         CHRLAT = TFORM( LAT(ISCAT), ' ', 1, 2, 4, ':::' )
         WRITE( IVEX, '( A1, 4X, A, F8.2, 1X, A, A, 1X, A, A )' )
     1        COM, 'elev=', ELEV(ISCAT), 
     2        'long=', CHRLON ,
     2        'lat=', CHRLAT 
C
C        x,y,z next:
C
         WRITE( IVEX, '( 5X, A, F14.5, 1X, A, A1, F14.5, 1X, A, A1,
     1        F14.5, 1X, A, A1 )' )
     2        'site_position =', XPOS(ISCAT), 'm', COL, YPOS(ISCAT),
     3        'm', COL, ZPOS(ISCAT), 'm', SEP
C
C        Write out site_velocity (Nov 2008)
C
         WRITE( IVEX, '( 5X, A, F10.6, 1X, A6, A1, F10.6, 1X, A6, A1,
     1        F10.6, 1X, A5, A1 )' )
     2        'site_velocity =', DXPOS(ISCAT), 'm/yr', COL, 
     3        DYPOS(ISCAT), 'm/yr', COL, DZPOS(ISCAT), 'm/yr', SEP
C
C        Write out site_position_epoch (Nov 2008)
C
C        The epoch format used the MJD, which is actually not 
C        according to the VEX standard.  The following line is in 
C        the correct format, but it is a comment until the 
C        reading programs are ready.  The line after is what has
C        been in use.
C
         DEPMJD = DBLE( MJDRATE(ISCAT) )
         CALL TIMEJ( DEPMJD, EPYEAR, EPDAY, EPTIME )
         WRITE( IVEX, '( A1, 4X, A, A )' )  COM,
     1        'First line below is VEX standard format.  ',
     2        'Use only when readers are ready.'
         WRITE( IVEX, '( A1, 4X, A, 1X, I4, A1, I3.3, 2A1 )' )  COM, 
     1        'site_position_epoch =', EPYEAR, 'y', EPDAY, 'd', SEP
C
         WRITE( IVEX, '( 5X, A, 1X, I7, A1 )' )
     1        'site_position_epoch =', MJDRATE(ISCAT), SEP
C
C        No info on zen_atmos or ocean load,
C        so next write horizon, fill lines to 80 columns
C
         IF( NHORIZ(ISCAT) .GT. 1 ) THEN
            IF (NHORIZ(ISCAT) .GT. 60 ) THEN
               VIOLFS = .TRUE.
               WRITE( MSGTXT, '( A, A, A, I3, A )' ) 
     1             'VXWRSI: WARNING: More than 60 points on ',
     2             STATION(ISCAT), ' horizon! (', NHORIZ(ISCAT),
     3             ')'
               CALL WLOG( 1, MSGTXT )
            END IF
C
C           there is a horizon, how many lines needed for 8 cols?
C
            NLINES = ((NHORIZ(ISCAT)-1) / 8) + 1
            IF( MOD( (NHORIZ(ISCAT)-1), 8) .EQ. 0 ) NLINES = NLINES -1
C
C           make robust for length of line
C
            LINE =  ' '
C
C           first line is always the same, write the first point with deg
C
            WRITE( LINE(1:31), '( 5X, A16, F5.1, 1X, A3, A1 )' )
     1           'horizon_map_az =', HORAZ(1,ISCAT), 'deg', COL
            DO J = 1, NLINES
               IF( J .NE. 1 ) WRITE( LINE(1:31), '( 31X )')
               DO I= 1, MIN(8, NHORIZ(ISCAT)-((J-1)*8+1))
C
C                 set delimiter 
C
                  DEL = COL
                  IF( (J-1)*8+1+I .EQ. NHORIZ(ISCAT) ) DEL = SEP
C
C                 write rest of line
C
                  WRITE( LINE(32+(I-1)*6:31+I*6), '( F5.1, A1 )' )
     1                 HORAZ((J-1)*8+I+1,ISCAT), DEL
               END DO
C
C              flush line and reset
C
               WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
               LINE =  ' '
            END DO
C
C           elevation array in exactly the same way:
C
            LINE =  ' '
            WRITE( LINE(1:31), '( 5X, A16, F5.1, 1X, A, A1 )' )
     1           'horizon_map_el =', HOREL(1,ISCAT), 'deg', COL
            DO J = 1, NLINES
               IF( J .NE. 1 ) WRITE( LINE(1:31), '( 31X )')
               DO I= 1, MIN(8, NHORIZ(ISCAT)-((J-1)*8+1))
                  DEL = COL
                  IF( (J-1)*8+I+1 .EQ. NHORIZ(ISCAT) ) DEL = SEP
C
                  WRITE( LINE(32+(I-1)*6:31+I*6), '( F5.1, A1 )' )
     1                 HOREL((J-1)*8+I+1,ISCAT), DEL
               END DO
C
               WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
               LINE =  ' '
            END DO
C
         END IF
C
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP  
      END DO
      WRITE( IVEX, '( A )' ) COMLIN
C
      IF( VIOLFS )
     1    CALL WLOG( 1,'VXWRSI: More than 60 points on horizon '//
     2    'mask, not supported in PCFS; this VEX will NOT run!!!!')
C
      RETURN
      END

C++++++++++++++++++++++++++
C
      SUBROUTINE PLEPH ( ET, NTARG, NCENT, RRD )
C
C++++++++++++++++++++++++++
C  NOTE : Over the years, different versions of PLEPH have had a fifth argument:
C  sometimes, an error return statement number; sometimes, a logical denoting
C  whether or not the requested date is covered by the ephemeris.  We apologize
C  for this inconsistency; in this present version, we use only the four necessary 
C  arguments and do the testing outside of the subroutine.
C
C
C
C     THIS SUBROUTINE READS THE JPL PLANETARY EPHEMERIS
C     AND GIVES THE POSITION AND VELOCITY OF THE POINT 'NTARG'
C     WITH RESPECT TO 'NCENT'.
C
C     CALLING SEQUENCE PARAMETERS:
C
C       ET = D.P. JULIAN EPHEMERIS DATE AT WHICH INTERPOLATION
C            IS WANTED.
C
C       ** NOTE THE ENTRY DPLEPH FOR A DOUBLY-DIMENSIONED TIME **
C          THE REASON FOR THIS OPTION IS DISCUSSED IN THE 
C          SUBROUTINE STATE
C
C     NTARG = INTEGER NUMBER OF 'TARGET' POINT.
C
C     NCENT = INTEGER NUMBER OF CENTER POINT.
C
C            THE NUMBERING CONVENTION FOR 'NTARG' AND 'NCENT' IS:
C
C                1 = MERCURY           8 = NEPTUNE
C                2 = VENUS             9 = PLUTO
C                3 = EARTH            10 = MOON
C                4 = MARS             11 = SUN
C                5 = JUPITER          12 = SOLAR-SYSTEM BARYCENTER
C                6 = SATURN           13 = EARTH-MOON BARYCENTER
C                7 = URANUS           14 = NUTATIONS (LONGITUDE AND OBLIQ)
C                            15 = LIBRATIONS, IF ON EPH FILE
C
C             (IF NUTATIONS ARE WANTED, SET NTARG = 14. FOR LIBRATIONS,
C              SET NTARG = 15. SET NCENT=0.)
C
C      RRD = OUTPUT 6-WORD D.P. ARRAY CONTAINING POSITION AND VELOCITY
C            OF POINT 'NTARG' RELATIVE TO 'NCENT'. THE UNITS ARE AU AND
C            AU/DAY. FOR LIBRATIONS THE UNITS ARE RADIANS AND RADIANS
C            PER DAY. IN THE CASE OF NUTATIONS THE FIRST FOUR WORDS OF
C            RRD WILL BE SET TO NUTATIONS AND RATES, HAVING UNITS OF
C            RADIANS AND RADIANS/DAY.
C
C            The option is available to have the units in km and km/sec.
C            For this, set km=.true. in the STCOMX common block.
C

C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DOUBLE PRECISION RRD(6),ET2Z(2),ET2(2),PV(6,13)
      DOUBLE PRECISION SS(3),CVAL(400),PVSUN(6)

      LOGICAL BSAVE,KM,BARY

      INTEGER LIST(12),IPT(39),DENUM

      INTEGER NCON, NTARG, NCENT, I, K
      DOUBLE PRECISION AU, EMRAT, ET

      COMMON/EPHHDR/CVAL,SS,AU,EMRAT,DENUM,NCON,IPT

      COMMON/STCOMX/KM,BARY,PVSUN

C     INITIALIZE ET2 FOR 'STATE' AND SET UP COMPONENT COUNT
C
      ET2(1)=ET
      ET2(2)=0.D0
      GO TO 11

C     ENTRY POINT 'DPLEPH' FOR DOUBLY-DIMENSIONED TIME ARGUMENT 
C          (SEE THE DISCUSSION IN THE SUBROUTINE STATE)

      ENTRY DPLEPH(ET2Z,NTARG,NCENT,RRD)

      ET2(1)=ET2Z(1)
      ET2(2)=ET2Z(2)

  11  DO I=1,6
      RRD(I)=0.D0
      ENDDO

  96  IF(NTARG .EQ. NCENT) RETURN

      DO I=1,12
      LIST(I)=0
      ENDDO

C     CHECK FOR NUTATION CALL

      IF(NTARG.NE.14) GO TO 97
        IF(IPT(35).GT.0) THEN
          LIST(11)=2
          CALL STATE(ET2,LIST,PV,RRD)
          RETURN
        ELSE
          WRITE(6,297)
  297     FORMAT(' *****  NO NUTATIONS ON THE EPHEMERIS FILE  *****')
          STOP
        ENDIF

C     CHECK FOR LIBRATIONS

  97  IF(NTARG.NE.15) GO TO 98
        IF(IPT(38).GT.0) THEN
          LIST(12)=2
          CALL STATE(ET2,LIST,PV,RRD)
          DO I=1,6
          RRD(I)=PV(I,11)
          ENDDO
          RETURN
        ELSE
          WRITE(6,298)
  298     FORMAT(' *****  NO LIBRATIONS ON THE EPHEMERIS FILE  *****')
          STOP
        ENDIF

C       FORCE BARYCENTRIC OUTPUT BY 'STATE'

  98  BSAVE=BARY
      BARY=.TRUE.

C       SET UP PROPER ENTRIES IN 'LIST' ARRAY FOR STATE CALL

      DO I=1,2
      K=NTARG
      IF(I .EQ. 2) K=NCENT
      IF(K .LE. 10) LIST(K)=2
      IF(K .EQ. 10) LIST(3)=2
      IF(K .EQ. 3) LIST(10)=2
      IF(K .EQ. 13) LIST(3)=2
      ENDDO

C       MAKE CALL TO STATE

      CALL STATE(ET2,LIST,PV,RRD)

      IF(NTARG .EQ. 11 .OR. NCENT .EQ. 11) THEN
      DO I=1,6
      PV(I,11)=PVSUN(I)
      ENDDO
      ENDIF

      IF(NTARG .EQ. 12 .OR. NCENT .EQ. 12) THEN
      DO I=1,6
      PV(I,12)=0.D0
      ENDDO
      ENDIF

      IF(NTARG .EQ. 13 .OR. NCENT .EQ. 13) THEN
      DO I=1,6
      PV(I,13)=PV(I,3)
      ENDDO
      ENDIF

      IF(NTARG*NCENT .EQ. 30 .AND. NTARG+NCENT .EQ. 13) THEN
      DO I=1,6
      PV(I,3)=0.D0
      ENDDO
      GO TO 99
      ENDIF

      IF(LIST(3) .EQ. 2) THEN
      DO I=1,6
      PV(I,3)=PV(I,3)-PV(I,10)/(1.D0+EMRAT)
      ENDDO
      ENDIF

      IF(LIST(10) .EQ. 2) THEN
      DO I=1,6
      PV(I,10)=PV(I,3)+PV(I,10)
      ENDDO
      ENDIF

  99  DO I=1,6
      RRD(I)=PV(I,NTARG)-PV(I,NCENT)
      ENDDO

      BARY=BSAVE

      RETURN
      END

      SUBROUTINE SDOPINCR
C
C     Get defaults for DOPINCR (kHz).  Use 15.625 kHz for RDBE_DDC.
C     Use DOPINCR=32000.D0,16000.D0 for RDBE_PFB.  For all else
C     use 10kHz.  Worry about the cases where more than one are
C     present.  Note NSETUP was set in the call to DEFSET above.
C     STASCN is set in GETSTA called by SCHIN.  While DOPINCR can
C     be scan dependent, use a default that is the same for the
C     whole observation.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    ISCN, ISTA, KS
      LOGICAL    GOTDDC, GOTPFB, GOTOTHER, ANYDOP
C -------------------------------------------------------------------
      GOTDDC = .FALSE.
      GOTPFB = .FALSE.
      GOTOTHER = .FALSE.
      ANYDOP = .FALSE.
      DO ISCN = SCAN1, SCANL
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
               KS = NSETUP(ISCN,ISTA)
               IF( DBE(KS) .EQ. 'RDBE_DDC' ) THEN
                  GOTDDC = .TRUE.
               ELSE IF( DBE(KS) .EQ. 'RDBE_PFB' ) THEN
                  GOTPFB = .TRUE.
               ELSE
                  GOTOTHER = .TRUE.
               END IF
            END IF
            IF( DOPCAL(ISCN) ) ANYDOP = .TRUE.
         END DO
      END DO
C
C     Only worry about this if there was some Doppler setting.
C
      IF( ANYDOP ) THEN
C
C        Complain if the PFB was used as the offset DOPINCR(ISCN,2)
C        cannot be set reliably without knowing the FIRSTLO, and
C        that could vary in global runs and by scan.  In principle,
C        some cases could be handled, but that is too much trouble.  
C        Don't default DOPINCR for the PFB.  It shouldn't be used for
C        DOPPLER anyway.
C
         IF( GOTPFB ) THEN
          DO ISCN = SCAN1, SCANL
           IF( DOPCAL(ISCN) .AND. DOPINCR(ISCN,1) .EQ. 0.D0 ) THEN
C
C           Issue warnings and die.
C
            CALL WLOG( 1, 'DEFAULTS:  You are asking for DOPPLER '//
     1                    'setting with an observation that' )
            CALL WLOG( 1, '           includes stations using ' //
     1                    'the RDBE_PFB and without '//
     2                    'setting DOPINCR.' )
            CALL WLOG( 1, '           Using DOPPLER with the PFB '//
     1                    ' is a bad idea and doing it without ' )
            CALL WLOG( 1, '           DOPINCR is not allowed. '//
     1                    'It is too complicated to set defaults' )
            CALL WLOG( 1, '           as the required value of ' //
     1                    'DOPINCR(2) depends on the LO setup. ' )
            CALL ERRLOG( 'Change DBE or set DOPINCR ' )
C     
           END IF
          END DO
         ELSE IF( GOTDDC .AND. GOTOTHER ) THEN
            DO ISCN = SCAN1, SCANL
               IF( DOPINCR(ISCN,1) .EQ. 0.D0 ) THEN
                  DOPINCR(ISCN,1) = 250.D0
                  DOPINCR(ISCN,2) = 0.D0
               END IF
            END DO
         ELSE IF( GOTDDC ) THEN
            DO ISCN = SCAN1, SCANL
               IF( DOPINCR(ISCN,1) .EQ. 0.D0 ) THEN
                  DOPINCR(ISCN,1) = 15.625D0
                  DOPINCR(ISCN,2) = 0.D0
               END IF
            END DO
         ELSE  !  (GOTOTHER)
            DO ISCN = SCAN1, SCANL
               IF( DOPINCR(ISCN,1) .EQ. 0.D0 ) THEN
                  DOPINCR(ISCN,1) = 10.D0
                  DOPINCR(ISCN,2) = 0.D0
               END IF
            END DO
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE MTEQUAT( KSTA, UP, SEL, SHA, SDEC, THA, TDEC )
C
C     Mount specific routine for SCHED that checks if a source is
C     up at an equatorial mount antenna when position (SHA,SDEC)
C     is requested.  If not, it returns flag UP and estimated actual
C     position (THA, TDEC), with both coordinates in degrees.
C
C     SHA on input is in hours, as are the HA limits.
C
C     KSTA is the station number in the station catalog.
C
C     The 140' is a primary example.  It will require three sets
C     of limits, so I should add that at some point.  For now, just
C     assume one set of limits plus the ZALIM.
C     Once there are more, require that the sets of limits adjoin, but
C     don't overlap in Dec and are in increasing order of Dec.
C
C     HA in hours, Dec in degrees.
C
      INCLUDE 'sched.inc'
C
      INTEGER         KSTA, IBOX, LOWER, UPPER
      REAL            SEL, SHA, SDEC, THA, TDEC
      REAL            DECLOW, DECHIGH
      LOGICAL         GOTT, CHECK(MAXCAT)
      CHARACTER       UP*1
      SAVE            CHECK
      DATA            CHECK  / MAXCAT*.TRUE. /
C -------------------------------------------------------------------
C     Complain if limits not given.
C
      IF( NAXLIM(KSTA) .LT. 1 .OR. NAXLIM(KSTA) .GT. 3 ) THEN
         CALL ERRLOG( 'MTEQUAT: Need between 1 and 3 sets of axis '//
     1     'limits for '//STATION(KSTA) )
      END IF
C
C     Some initializations.
C
      DECLOW  = AX2LIM(1,KSTA)
      DECHIGH = AX2LIM(2*NAXLIM(KSTA),KSTA)
C
C     The first time we see this source, check the ranges to see that
C     the boxes are in increasing Dec order and the dec boundaries
C     adjoin.  Complain if otherwise.
C
      IF( CHECK(KSTA) ) THEN
         DO IBOX = 1, NAXLIM(KSTA)
            LOWER = 2 * IBOX - 1
            UPPER = 2 * IBOX
C
            IF( AX2LIM(LOWER,KSTA) .GE. AX2LIM(UPPER,KSTA) ) THEN
               CALL ERRLOG( 'MTEQUAT: Lower limit > '//
     1              ' upper limit for dec box for '//STATION(KSTA) )
            END IF
C
            IF( IBOX .LT. NAXLIM(KSTA) ) THEN
               IF( AX2LIM(UPPER,KSTA) .NE. AX2LIM(LOWER+2,KSTA) ) THEN
                  CALL ERRLOG( 'MTEQUAT: Dec limit boxes not '//
     1                 ' adjoining for '//STATION(KSTA) )
               END IF
            END IF
         END DO
         CHECK(KSTA) = .FALSE.
      END IF
C
C     Set up as if the source is up, then change if not.
C
      UP = ' '
      THA = SHA
      TDEC = SDEC
C
C     Initializations.
C
      GOTT = .FALSE.
      DECLOW = AX2LIM(1,KSTA)
      DECHIGH = AX2LIM(2*NAXLIM(KSTA),KSTA)
C
C     Loop through boxes.
C
      DO IBOX = 1, NAXLIM(KSTA)
         LOWER = 2 * IBOX - 1
         UPPER = 2 * IBOX
C         
C        Go through Dec boxes.  Jump out once SDEC found so should
C        
         IF( SDEC .LT. AX2LIM(UPPER,KSTA) ) THEN
            IF( SDEC .LT. AX2LIM(LOWER,KSTA) ) THEN
               UP = 'D'
               TDEC = AX2LIM(LOWER,KSTA)
            END IF
            IF( SHA .LT. AX1LIM(LOWER,KSTA) ) THEN
               UP = 'D'
               THA = AX1LIM(LOWER,KSTA)
            ELSE IF( SHA .GT. AX1LIM(UPPER,KSTA) ) THEN
               UP = 'D'
               THA = AX1LIM(UPPER,KSTA)
            END IF
            IF( UP .EQ. ' ' ) GO TO 100
         END IF
C
      END DO
C
C     Was not in one of the Dec ranges.
C
      UP = 'D'
      LOWER = 2 * NAXLIM(KSTA) - 1
      UPPER = 2 * NAXLIM(KSTA)
      TDEC = AX2LIM(UPPER,KSTA)
      IF( SHA .LT. AX1LIM(LOWER,KSTA) ) THEN
         THA = AX1LIM(LOWER,KSTA)
      ELSE IF( SHA .GT. AX1LIM(UPPER,KSTA) ) THEN
         THA = AX1LIM(UPPER,KSTA)
      ELSE
         THA = SHA
      END IF     
C
C     Jump here once position located.
C
  100 CONTINUE
C
C     Check the zenith angle limit.  Don't assume that the antenna
C     will be here - it will probably be at the AX2LIM(1,KSTA)
C
      IF( 90.0 - SEL .GT. ZALIM(KSTA) ) THEN
         UP = 'D'
      END IF
C
C     Convert the output HA to degrees.
C
      THA = THA * 15
C
      RETURN
      END

      SUBROUTINE BBCM4( KS )
C
C
C     Routine for Sched called by SETBBC that assigns video converters
C     for Mark IV systems.
C
C     Mark IV is a bit more complicated than VLBA because there
C     is a fixed wiring between video converters (MarkIII/IV
C     term for what the VLBA (and SCHED) call a BBC) and the IFs.
C     IFs 1N and 1A are attached to the odd BBCs while 2N and 2A
C     are attached to the even BBC's.  Use M4VC1 and M4VC2 to
C     keep track of the next available odd and even BBC.
C
C     On top of that, no more than 8 BBCs may use FORMAT=MKIV1:4.
C     A mistake on this one will be caught by CHK4DAR.  But try
C     to prevent for many cases by setting NNBBC to 8 for bit rates 
C     less than or equal to 512 Mbps and for sample rates of 32 Mbps.
C     I don't like waiting until the format is being set to apply
C     this constraint.  It affects to much else.  So prevent what
C     I can here, and force the user to worry about it later if 
C     something slips through.
C
C     If the experiment has only one polarization, it may need
C     more than just the odd or even BBC's to cover all the
C     channels.  In this case, different BBC's will be assigned
C     different IFCHANs to get the same signal!  There is some
C     hoop jumping to set this up.
C
C     The original version of this routine was rather complicated.
C     A more general scheme was needed for the geodetic wired VLBA
C     systems, so that is used (in BBCALT) for both.
C     This routine and BBCGEO just set up the data arrays.
C
C     It seems that many EVN stations only properly maintain the
C     lower 8 BBC's so they want BBC assignments restricted to those
C     when possible.  This means that single polarization 
C     observations should pick up the alternate inputs to stay 
C     below 8.  I think I can deal with the variety of implications
C     by claiming there are only "N" IFs for dual polarization 
C     observations but both "N" and "A" IFs for single polarization
C     observations.  In BBCALT, whichever is available to a given
C     BBC will be taken.  In the usual case, channel N will end up
C     on BBC N for single polarization, but there will be slight
C     scrambling for dual (because RCP usually comes first, but
C     that would have to be on an A IF if the BBCs were in order.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    I, KS, NNBBC
      INTEGER    MAXBBC, MAXIF, NIF
      PARAMETER  (MAXBBC=14)
      PARAMETER  (MAXIF=4)
      INTEGER    IFBBC(MAXBBC,MAXIF)
      CHARACTER  IFNAM(MAXIF)*2
      LOGICAL    UBBC(MAXBBC)
      DATA  (IFBBC(I,1),I=1,MAXBBC) / 1,0,1,0,1,0,1,0,1,0,1,0,1,0 /
      DATA  (IFBBC(I,2),I=1,MAXBBC) / 0,1,0,1,0,1,0,1,0,1,0,1,0,1 /
      DATA  (IFBBC(I,3),I=1,MAXBBC) / 1,0,1,0,1,0,1,0,1,0,1,0,1,0 /
      DATA  (IFBBC(I,4),I=1,MAXBBC) / 0,1,0,1,0,1,0,1,0,1,0,1,0,1 /
      DATA  (IFNAM(I),I=1,MAXIF) / '1N', '2N', '1A', '2A' /
C -------------------------------------------------------------------  
C     Software check:
C
      IF( NBBC(ISETSTA(KS)) .GT. MAXBBC ) THEN
         WRITE( MSGTXT, '( 3A, I4 )' )
     1       'BBCM4: Number of VCs at ', SETSTA(1,KS), 
     2       ' Larger than maximum expected: ', MAXBBC
         CALL WLOG( 1, MSGTXT )
         CALL WLOG( 1, '   Catalog or programming problem ' )
         CALL ERRSET( KS )
      END IF
C
C     Set the number of BBC's.  There is a restriction in the Mark IV
C     systems that 1:4 fan out cannot be used on VCs higher than 9.
C     Therefore, claim that the maximum number of VCs is 8 if using
C     MKIV1:4 or using a mode that is likely to use MKIV1:4.  This
C     protection won't be perfect, but should work much of the time.
C
      IF( FORMAT(KS) .EQ. 'MKIV1:4' .OR. 
     1  ( DAR(ISETSTA(KS)) .EQ. 'MKIV' .AND. SAMPRATE(KS).GE.32.0 .AND.
     2  NCHAN(KS) * BITS(1,KS) * SAMPRATE(KS) .LE. 512.0 ) ) THEN
         NNBBC = MIN( NBBC(ISETSTA(KS)), 8 )
      ELSE
         NNBBC = NBBC(ISETSTA(KS))
      END IF
C
C     Deal with the desire to stay in lower 8 BBCs.
C
      IF( DUALPOL(KS) ) THEN
         NIF = 2
      ELSE
         NIF = 4
      END IF
C
C     Call BBCALT to do the work.
C
      CALL BBCALT( KS, MAXBBC, NIF, IFBBC, IFNAM, UBBC, NNBBC, ' ',
     1     'BBCM4' )
C
      RETURN 
      END

      SUBROUTINE VXWRBB
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the BB = $BBC section 
C     By H.J. van Langevelde, JIVE, 300496 
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
C     Huib's local variables 
C      
      INTEGER   IBB, KS, ICH, JCH
      INTEGER   LEN1
      LOGICAL NEWFND
C ----------------------------------------------------------------------
C
C     the BBC section is fairly trivial in the SCHED context
C     it connects BBC's to IF's, find out how many
C     Physical number is set to logical number for SCHED
C
      WRITE( IVEX, '( A, A1 )' ) '$BBC', SEP    
      DO IBB = 1, NBBVEX
         KS = BBISSET(IBB)
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1        BBLINK(IBB)(1:LEN1(BBLINK(IBB))), SEP
         CALL VXSTLI( IBB, NSTABB, ISTABB )
C
C        only write for new BBC's
C
         DO ICH = 1, NCHAN(KS)
            NEWFND = .TRUE.
            IF( ICH .GT. 1 ) THEN
               DO JCH = 1, ICH-1
                  IF( BBC(ICH,KS) .EQ. BBC(JCH,KS)) NEWFND = .FALSE.
               END DO
            END IF
            IF( NEWFND ) THEN 
               WRITE( IVEX, '( 5X, A, 1X, A1, A, I2.2, 1X, A1, I3, 
     1             1X, A1, 1X, A1, A, A, A1  )' ) 
     2             'BBC_assign =', 
     3             LNK, 'BBC', BBC(ICH,KS), COL, BBC(ICH,KS), COL, LNK, 
     4             'IF_', IFCHAN(ICH,KS)(1:LEN1(IFCHAN(ICH,KS))), SEP
            END IF
         END DO
C
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
      END DO
      WRITE( IVEX, '( A )' ) COMLIN
C
      RETURN
      END

      SUBROUTINE VXMODE
C
C     Routine for the VEX extension of SCHED.
C     Finds out how many different modes are to be used in this vex
C     file. Stores for each mode the setups that each antenna was using
C     to find the different $BLOCKS per antenna for each mode
C     H.J.van Langevelde JIVE, 130596
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
C     variables
C     
      INTEGER   I, ISETFL, ISET, ICH1, ICH2, ISTA, ISCAT
      INTEGER   LEN1
      CHARACTER NAME*32
      LOGICAL   NEWVXMD
C ----------------------------------------------------------------------
C     There is a comment below claiming that SETNAME can be blank.  That
C     surprises me so look for it.  RCW Oct. 15, 2011.
C
      DO ISET = 1, NSET
         IF( SETNAME(ISET) .EQ. ' ' ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A, I4 )' )
     1         'VXMODE: Info for programmer - blank SETNAME found.',
     2         '  Setup group ', ISET
            CALL WLOG( 1, MSGTXT )
         END IF
      END DO
C
C
C
C     A (VEX)$MODE is the status of a scan and should define something for
C     all antennas. One (SCHED)SETup cannot be more than 1 MODE, but
C     usually 1 MODE has more than 1 SET, defining different antenas.
C     NSETF is usually the number of modes, but we have to build a list
C     of antenna setups:
C
      NMDVEX = 1      
      DO ISETFL = 1, NSETF
C
C        It seems sometimes setname can be empty, be careful.
C
         NAME = ' ' 
         ICH2 = LEN1( SETFILE(ISETFL) )
         IF( SETFILE(ISETFL)(ICH2-3:ICH2) .EQ. '.set' 
     1        .OR. SETFILE(ISETFL)(ICH2-3:ICH2) .EQ. '.SET' )
     2        ICH2 = ICH2 - 4
         ICH1 = 1
         DO I = 1, ICH2
            IF( SETFILE(ISETFL)(I:I).EQ.'/'.OR.
     1           SETFILE(ISETFL)(I:I).EQ.'\\') ICH1 = I+1
         END DO
         IF ( ICH2 .GT. ICH1+1 .AND. ICH2 .NE. 80) THEN
C
C           truncate to 32 chars
C
            ICH2 = MIN( (ICH1+32), ICH2 )
            NAME = SETFILE(ISETFL)(ICH1:ICH2) 
         ENDIF
C
C        for all antennas, each mode has 1 original sched-set
C        unfortunately they don't match right up
C
         NEWVXMD = .FALSE.
         DO ISET = 1, NSET
            IF( USED(ISET) ) THEN 
C
C              Only if this group is in this file.
C
               IF( SETNAME(ISET) .EQ. SETFILE(ISETFL) ) THEN
                  DO ISTA = 1, NSTA
                     ISCAT = STANUM(ISTA)
C
                     IF ( STATION(ISCAT) .EQ. SETSTA(1,ISET) ) THEN
C
C                    We should keep this the lowest matching number, don't set
C                    again when already set.
C
                       IF( MODSET(ISTA,NMDVEX) .EQ. 0 ) THEN
                          MODSET(ISTA,NMDVEX) = ISET
                          NEWVXMD = .TRUE.
                       END IF
                     ENDIF
                  END DO
               END IF
            END IF
         END DO
C
C        every used file is a new mode
C
         IF( NEWVXMD ) THEN
           MDISFIL(NMDVEX) = ISETFL
           IF( NMDVEX .GT. MAXMOD ) CALL ERRLOG(
     1         'VXMODE: Number of $MODE defs '//
     2         'exceeding MAXMOD, need to re-compile...')
           MDLINK(NMDVEX) = NAME
           CALL VXUNQL( NMDVEX, MDLINK )
           NMDVEX = NMDVEX + 1
         END IF
      END DO
C
C     Last increment of NMDVEX is never used, so reduce by 1
C
      NMDVEX = NMDVEX - 1
C
      RETURN
      END

      SUBROUTINE OPTNONE( KSCN, ISCN, ADJUST, KEEP, DONE )
Cf2py intent(in) KSCN, ISCN
Cf2py intent(out) ADJUST, KEEP, DONE
C
C     Routine for sched routine schopt that picks next scan in the
C     case of no optimization.  This just returns the current input
C     scan with appropriate flags set.  It copies it to a new slot
C     if requested, which might be needed when inserting peaking scans.
C
C     Dwell scans used to be handled in OPTDWELL, but that was mostly
C     redundant with OPTTIM that is called later, so was removed.
C     In the process, the setting of ADJUST got a little more 
C     complicated here.
C
      INCLUDE 'sched.inc'
C
      INTEGER    ISCN, KSCN
      LOGICAL    ADJUST, KEEP, DONE
C ---------------------------------------------------------------------
      IF( DEBUG .AND. KSCN .LE. 3 ) CALL WLOG( 0, 'OPTNONE: Starting.' )
C
C     Set output flags so no adjustments will be made later.
C
      KEEP   = .TRUE.
      DONE   = KSCN .GT. NSCANS
      IF( .NOT. DONE ) THEN
C
C        Copy the input scan to the output if necessary.
C
         IF( KSCN .NE. ISCN ) THEN
            CALL SCNDUP( ISCN, KSCN, .TRUE., 'OPTNONE' )
         END IF
C
      END IF
C
C     Set whether to allow start time adjustments.  Note that, if
C     stop times only were specified (DURONLY(ISCN)=4), OPTTIM will not
C     adjust the stop time regardless of the setting of ADJUST.
C
      ADJUST = ( DWELLS .AND. ISCN .GT. SCAN1 ) .AND. 
     1         ( DURONLY(ISCN) .EQ. 1 .OR. DURONLY(ISCN) .EQ. 4 ) 
C
      RETURN
      END



C     Some notes about my thinking dealing with the Feb. 2014 GMVA run.

C     Nasty case:  There are DWELL scans in the project so ADJUST gets
C     set to true.  But there are START times on later scans, followed
C     by only DUR scheduling.  So DWELL should be false.  If there
C     are inserted pointing scans, GAP gets set to zero.
C
C     Does gap apply to the gap from the inserted scan or from the previous
C     recording scan?  It depends on what you are trying to use GAP for.
C
C     Do I need OPTNONE to be scan specific about ADJUST, being sensitive to
C     the history since the last START or STOP?
C
C     In the end, I added ORIGEN and LASTSSCN to deal with these situations.
C     I'm not all that confident of the results yet.

      SUBROUTINE VERSCHED( VERNUM, VERSION )
C
C     Set a version number for the SCHED main code.  
C     Note that a coarser, date based version is set in sched.f
C
      REAL VERNUM
      CHARACTER  VERSION*(*)
C ----------------------------------------------------------------------
C      VERNUM = 5.18    !  Oct 2001 release
C      VERNUM = 5.19    !  Early 2002 development
C      VERNUM = 5.20    !  02 July 2002 release.
C      VERNUM = 5.21    !  Post 02 July 2002 release development
C      VERNUM = 5.22    !  15 Sept. 2003 release.
C      VERNUM = 5.23    !  Post 15 Sept. 2003 release.
C      VERNUM = 5.24    !  Trial release of 30 July 2004
C      VERNUM = 5.25    !  Internal NRAO release of 4 October 2004
C      VERNUM = 5.26    !  Development after 4 October 2004
C
C      Change version scheme to be mainly numerical in Feb 2005.
C
C      VERNUM = 6.0     !  Released March 8, 2005
C      VERNUM = 6.01    !  Released March 30, 2005.  Bug fixes.
C      VERNUM = 6.02    !  Released July 29, 2005.
C      VERNUM = 6.03    !  Mostly development versions
C      VERNUM = 6.04    !  Mar. 2006
C      VERNUM = 6.05    !  June 2006
C      VERNUM = 7.0     !  Development > Dec 2006
C
C      Now even versions are releases, odd versions are development.
C      Not really sticking to that.
C
C      VERNUM = 8.0     !  Release Dec. 2008
C      Version 8.1 is in an svn branch.  Taken from this on Feb 18, 2009
C      VERNUM = 9.0      !  Beta version of Oct 14, 2009
C      VERSION = 'Beta version released Oct. 14, 2009'
C      VERSION = 9.1    !  Development version before 9.2
C      VERNUM  = 9.2
C      VERSION = 'Release of March 8, 2010'
C      VERNUM  = 9.3
C      VERSION = 'Release March 23, 2010 with Apr. 8 bug fix.'
C      VERNUM  = 9.4
C      VERSION = 'Release Jan. 13, 2011.'
C       VERNUM  = 10.0
C       VERSION = 'Release Sept. 15, 2011'
C       VERNUM  = 10.1
C       VERSION = 'Development version after Sept. 21, 2011'
C       VERSION = 'Beta version of Dec. 7, 2011'
C       VERSION = 'Development version after Dec. 7, 2011'
C       VERSION = 'Beta version of Feb. 7, 2012'
C       VERSION = 'Development version after Feb. 7, 2012'
C       VERSION = 'Release of about Feb. 14, 2012'
C       VERNUM  = 10.2
C       VERSION = 'Development version after beta of May 4, 2012'
C       VERSION = 'Development version after beta of June 25, 2012'
C       VERSION = 'Release of about July 12, 2012'
C       VERNUM  = 10.3
C       VERSION = 'Beta version of Sept. 12, 2012'
C                 There was a beta of Sept. 20.
C       VERSION = 'Beta version of Nov. 5, 2012'
C       VERNUM  = 11.0
C       VERSION = 'sched_temp version of Jan. 24, 2013'
C       VERSION = 'Release of Feb. 15, 2013'
C       VERNUM  = 11.1
C       VERSION = 'Version 11.1 Beta of about April 26, 2013'
C       VERSION = 'Version 11.1 Beta of June 19, 2013'    
C       VERSION = 'Development version 11.1 after June 19, 2013'    
C       VERSION = 'Version 11.1 Beta  Jan. 2, 2014' 
C       VERNUM  = 11.2
C       VERSION = 'Release of Jan. 22, 2014 - update 1'
C       VERSION = 'Development version for 11.3'
C       VERNUM  = 11.3
C       VERSION = 'Release of April 4, 2014'
C       VERSION = 'Version 11.3 update 1.  April 14, 2014'
C       VERNUM  = 11.4
C       VERSION = 'Release 11.4.  March 14, 2015'
        VERNUM  = 11.6
        VERSION = 'Release 11.6; Feburary 2020'
C
      RETURN
      END

      SUBROUTINE OPTCSUB( LASTISCN, KSCN, ISCN, ADJUST, KEEP, DONE )
Cf2py intent(in) LASTISCN, KSCN, ISCN
Cf2py intent(out) ADJUST, KEEP, DONE
C

C  ****** doesn't seem to be working properly  Mar 17, 2010.  Not making
C         subarrays and many output scans skipped.  Need to debug.
C         Might partly be a gfortran issue - which means more variables
C         might need to be SAVEd.

C     Routine for SCHED that trys to optimize sky coverage over each   
C     antenna by examining a grid in AZ and EL.  This routine is
C     different from OPTCELLS in that it uses, even encourages, 
C     subarraying.  There will be two primary subarrays, each with
C     at least OPMINANT antennas.  If the best such combination
C     leaves 2 or more antennas free (sources not up), those antennas
C     will go to some other source as a 3ed subarray.
C
C     During operation, the geometry parameters for the input
C     scans will be used to hold geometry for the current test time.
C
C     This routines does not take into account GAP, but that is 
C     added by OPTTIM later in SCHOPT.
C
      INCLUDE 'sched.inc'
C
      INTEGER     MAXISC
      PARAMETER   (MAXISC=1000)       ! Number of input scans.
C
      INTEGER           LASTISCN(MAXSTA), ISCN, JSCN, KSCN, ISTA
      INTEGER           SCNSTA(MAXSTA), NS1, NS2, NS3, SCN1, SCN2, SCN3
      LOGICAL           KEEP, ADJUST, DONE
      DOUBLE PRECISION  TIME1, TIME2, TIME3
      SAVE              SCN1, SCN2, SCN3, NS1, NS2, NS3
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'OPTCSUB starting ' )
      DONE = .FALSE.
      KEEP = .TRUE.
      ADJUST = .TRUE.
C
C     Some initializations on first scan.
C
      IF( KSCN .EQ. 1 ) THEN
C
         IF( OPNOSUB ) CALL ERRLOG( 'OPTCSUB: Mode CSUB and OPNOSUB'//
     1       ' do not make sense together.' )
C
C        Start the set of new scans beyond NSCANS and use first start
C        time.  TAPPROX is the approximate start time of the next scan.
C        Don't allow this time to be adjusted.
C
         ADJUST   = .FALSE.
         STARTJ(ISCN) = STARTJ(1)
C
C        Make sure that OPDUR is available.
C
         IF( OPDUR .LE. 0.D0 ) THEN
            CALL ERRLOG( 
     1       ' OPTCSUB: For OPTMODE=CSUB, OPDUR must be given.' )
         END IF
C
      END IF
C
C     If there are no subarrays needing to be put into scans,
C     get the subarrays for the next time.
C
      IF( NS1 .LT. 2 .AND. NS2 .LT. 2 .AND. NS3 .LT. 2 ) THEN
C
         CALL OPTCSAR( LASTISCN, KSCN, ISCN, SCNSTA, NS1, NS2, NS3, 
     1                 SCN1, SCN2, SCN3, TIME1, TIME2, TIME3 )
C
      END IF
C
C     Pass out the next subarray.
C
      JSCN = 0
 
C          Here scn2 is bad (big negative number) when ns2 is reasonable.
      IF( NS1 .GE. 2 ) THEN
         JSCN = SCN1
         STARTJ(ISCN) = TIME1
         NS1 = 0
      ELSE IF( NS2 .GE. 2 ) THEN
         JSCN = SCN2
         STARTJ(ISCN) = TIME2
         NS2 = 0
      ELSE IF( NS3 .GE. 2 ) THEN
         JSCN = SCN3
         STARTJ(ISCN) = TIME3
         NS3 = 0
      END IF
C
      IF( JSCN .EQ. 0 ) THEN
         WRITE( MSGTXT, '( A, I5 ) ' ) 'OPTCSUB: No data for scan ', 
     1                    ISCN
         CALL ERRLOG( MSGTXT )
      END IF
C
C     Copy JSCN stuff into scan ISCN.
C     The nominal STARTJ and STOPJ must also be set.
C
      CALL SCNDUP( ISCN, JSCN, .FALSE., 'OPTCSUB' )
      STOPJ(ISCN) = STARTJ(ISCN) + DUR(ISCN)
C
C     Set the flags for which antennas are in the current scan.
C
      DO ISTA = 1, NSTA
         STASCN(ISCN,ISTA) = JSCN .EQ. SCNSTA(ISTA)
      END DO
C      write(*,*) 'optcsub: ', iscn, (stascn(iscn,ista),ista=1,nsta),
C     1    jscn, scn1, scn2, scn3
C
      RETURN
      END

      INTEGER FUNCTION HEADPOS( TPINDX, SYSTEM, IHEAD )
C
C     Function for SCHED called by VLBA and perhaps other routines that
C     returns the head position in microns for the head index position.a
C     IHEAD is the number of the head for this call.  For VLBA systems,
C     it is always 1, but put in the hooks for otherwise.  For Mark IV,
C     it can be one or two.
C
C
      INTEGER     TPINDX, HEADA(14), HEADB(6), HEADB2(6), IHEAD
      CHARACTER   SYSTEM*(*), MSG*10
      SAVE  HEADA, HEADB
C
C     Set the head positions for SYSTEM = VLBA14.
C
      DATA  HEADA / -319,   31, -271,  79, -223, 127, -175,
     1               175, -127,  223, -79,  271, -31,  319 /
C
C     Set the head pos for SYSTEM = MKIV2H
C
      DATA  HEADB  / -301,  47, -253,  95, -205, 143 /
      DATA  HEADB2 / -143, 205,  -95, 253,  -47, 301 /
C  ---------------------------------------------------------------------
      IF( SYSTEM .EQ. 'VLBA14' ) THEN
         IF( TPINDX .GE. 1 .AND. TPINDX .LE. 14 ) THEN
            IF( IHEAD .EQ. 1 .OR. IHEAD .EQ. 2 ) THEN
               HEADPOS = HEADA( TPINDX)
            ELSE
               WRITE( MSG, '(I10)' ) IHEAD
               CALL ERRLOG( 'HEADPOS: Bad head number: ' // MSG )
            END IF
         ELSE
            WRITE( MSG, '(I10)' ) TPINDX
            CALL ERRLOG( 'HEADPOS: Bad index position: ' // MSG )
         END IF
      ELSE IF( SYSTEM .EQ. 'MKIV2H' ) THEN
         IF( TPINDX .GE. 1 .AND. TPINDX .LE. 6 ) THEN
            IF( IHEAD .EQ. 1 ) THEN
               HEADPOS = HEADB( TPINDX)
            ELSE IF( IHEAD .EQ. 2 ) THEN
               HEADPOS = HEADB2( TPINDX)
            ELSE
               WRITE( MSG, '(I6)' ) IHEAD
               CALL ERRLOG( 'HEADPOS: Bad head number: '//MSG(1:6) )
            END IF
         ELSE
            WRITE( MSG, '(I6)' ) TPINDX
            CALL ERRLOG( 'HEADPOS: Bad index position: '//MSG(1:6) )
         END IF
      ELSE
         MSG = SYSTEM
         CALL ERRLOG( 'HEADPOS: Unknown head position system: '//MSG )
      END IF
C
      RETURN
      END

      SUBROUTINE VXWRIF
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the IF = $IF section 
C     By H.J. van Langevelde, JIVE, 300496 
C     Update to 1.4 240796
C
C     Add comment about receiver, receiver LO, and 610 MHz filter
C     for VLBA.  Aug. 11, 2011  R. C. Walker
C     Add a digit to the FIRSTLO output to support the new VLBA
C     synthesizers.  Mar. 20, 2013  RCW  (Synthesizers not in place yet.)
C
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C      
      INTEGER IIF, KS, ICH, J, I1, I2
      INTEGER LEN1
      LOGICAL NEWFND, DOWARN
      CHARACTER   VBCOM*40
C ----------------------------------------------------------------------
C
C     Write the IF section
C
      DOWARN = .FALSE.
      WRITE( IVEX, '( A, A1 )' ) '$IF', SEP     
C
      DO IIF = 1, NIFVEX
         KS = IFISSET(IIF)
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1        IFLINK(IIF)(1:LEN1(IFLINK(IIF))), SEP
         CALL VXSTLI( IIF, NSTAIF, ISTAIF )
C
C        Loop over channels.
C
         DO ICH = 1, NCHAN(KS)
C
C           See if this is the first channel that uses the IF.
C
            NEWFND = .FALSE.
            IF( ICH .EQ. 1 ) THEN
               NEWFND = .TRUE.
            ELSE
               NEWFND = .TRUE.
               DO J = 1, ICH-1
                  IF( IFCHAN( ICH, KS ) .EQ. IFCHAN( J,KS)  ) THEN
                     NEWFND = .FALSE.
                  END IF
               END DO
            END IF
C
C           could save NIF and IFNAMSs
C
C           If this is a new IF, then write most of the if_def line.
C
            IF( NEWFND ) THEN
C
               IF( TONEINT(IIF) .NE. 1.0 ) DOWARN = .TRUE.
C
C              Fill in most of the line to the MSGTXT string:
C
               MSGTXT = ' '
C
               WRITE( MSGTXT, '( 5X, A, A1, A, A, 1X, A1, 
     1             1X, A, 1X, A1, 1X, A1, 1X, A1, F9.2, 1X, A, 1X, 
     2             A1, 1X, A1)' ) 
     3             'if_def = ', LNK, 'IF_', 
     4             IFCHAN(ICH,KS)(1:LEN1(IFCHAN(ICH,KS))), COL, 
     5             IFCHAN(ICH,KS)(1:LEN1(IFCHAN(ICH,KS))), COL,
     6             POL(ICH,KS)(1:1), COL,
     7             FIRSTLO( ICH, KS), 'MHz',
     8             COL, SIDE1( ICH, KS )
C
C              Add the pulse cal specification and comment.
C
C              Add a blank comment (just a "*") even if there will be
C              no Pcal comment.  This is related to parsing the comment
C              with the receiver information.  The VEX parser used for
C              the VLBA observing system does not easily return the line
C              on which a comment was found.  The simplest way to keep
C              track is to make all if_def line have a comment.  Hopefully
C              future VEX definitions will get us out of this kludge.
C              RCW  Sep. 8, 2011
C
               I1 = LEN1( MSGTXT ) + 1
               IF( TONEINT(IIF) .GT. 1E-15 ) THEN               
                  I2 = I1 + 11
                  WRITE( MSGTXT(I1:I2), 
     1                '( 1X, A1, 1X, I1, 1X, A, 1X, A1, 1X, A1 )' ) 
     2                COL, NINT(TONEINT(IIF)),'MHz', SEP, COM
               ELSE
                  I2 = I1+15
                  WRITE( MSGTXT(I1:I2), '( 1X, A1, 1X, A1, 1X, A  )' ) 
     1                SEP, COM, 'PCall off!'
               END IF
C
C              Now add the VLBA receiver information in a comment.
C              Hopefully this is a stop-gap until VEX2 provides a
C              better mechanism.
C
               CALL VXVBRX( KS, ICH, VBCOM )
               I1 = LEN1( MSGTXT )
               MSGTXT = MSGTXT(1:I1) // VBCOM
C
C              Write the line.
C
               WRITE( IVEX, '( A )' ) MSGTXT(1:LEN1(MSGTXT))
C
            END IF
         END DO
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP
C     
      ENDDO
      WRITE( IVEX, '( A )' ) COMLIN
C
C     warn in case of none standard PCAL
C
      IF( DOWARN .AND. .NOT. ALLVLBA ) THEN
         CALL WLOG( 1,'VXWRIF: WARNING, Phase cal not under '//
     2       'computer control for some stations.' ) 
         CALL WLOG( 1,'        Contact stations by e-mail to '//
     1       'make sure phase cal is switched off ')
         CALL WLOG( 1,'        Phase cal is under computer '//
     1       'control for VLBA stations and many others. ')
      END IF

      RETURN
      END

      SUBROUTINE sla_FK54Z (R2000,D2000,BEPOCH,
     :                      R1950,D1950,DR1950,DD1950)
*+
*     - - - - - -
*      F K 5 4 Z
*     - - - - - -
*
*  Convert a J2000.0 FK5 star position to B1950.0 FK4 assuming
*  zero proper motion and parallax (double precision)
*
*  This routine converts star positions from the new, IAU 1976,
*  FK5, Fricke system to the old, Bessel-Newcomb, FK4 system.
*
*  Given:
*     R2000,D2000     dp    J2000.0 FK5 RA,Dec (rad)
*     BEPOCH          dp    Besselian epoch (e.g. 1950D0)
*
*  Returned:
*     R1950,D1950     dp    B1950.0 FK4 RA,Dec (rad) at epoch BEPOCH
*     DR1950,DD1950   dp    B1950.0 FK4 proper motions (rad/trop.yr)
*
*  Notes:
*
*  1)  The proper motion in RA is dRA/dt rather than cos(Dec)*dRA/dt.
*
*  2)  Conversion from Julian epoch 2000.0 to Besselian epoch 1950.0
*      only is provided for.  Conversions involving other epochs will
*      require use of the appropriate precession routines before and
*      after this routine is called.
*
*  3)  Unlike in the sla_FK524 routine, the FK5 proper motions, the
*      parallax and the radial velocity are presumed zero.
*
*  4)  It is the intention that FK5 should be a close approximation
*      to an inertial frame, so that distant objects have zero proper
*      motion;  such objects have (in general) non-zero proper motion
*      in FK4, and this routine returns those fictitious proper
*      motions.
*
*  5)  The position returned by this routine is in the B1950
*      reference frame but at Besselian epoch BEPOCH.  For
*      comparison with catalogues the BEPOCH argument will
*      frequently be 1950D0.
*
*  Called:  sla_FK524, sla_PM
*
*  P.T.Wallace   Starlink   10 April 1990
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION R2000,D2000,BEPOCH,
     :                 R1950,D1950,DR1950,DD1950

      DOUBLE PRECISION R,D,PX,RV



*  FK5 equinox J2000 (any epoch) to FK4 equinox B1950 epoch B1950
      CALL sla_FK524(R2000,D2000,0D0,0D0,0D0,0D0,
     :               R,D,DR1950,DD1950,PX,RV)

*  Fictitious proper motion to epoch BEPOCH
      CALL sla_PM(R,D,DR1950,DD1950,0D0,0D0,1950D0,BEPOCH,
     :            R1950,D1950)

      END

C+++++++++++++++++++++++++
C
      SUBROUTINE SPLIT(TT,FR)
C
C+++++++++++++++++++++++++
C
C     THIS SUBROUTINE BREAKS A D.P. NUMBER INTO A D.P. INTEGER
C     AND A D.P. FRACTIONAL PART.
C
C     CALLING SEQUENCE PARAMETERS:
C
C       TT = D.P. INPUT NUMBER
C
C       FR = D.P. 2-WORD OUTPUT ARRAY.
C            FR(1) CONTAINS INTEGER PART
C            FR(2) CONTAINS FRACTIONAL PART
C
C            FOR NEGATIVE INPUT NUMBERS, FR(1) CONTAINS THE NEXT
C            MORE NEGATIVE INTEGER; FR(2) CONTAINS A POSITIVE FRACTION.
C
C       CALLING SEQUENCE DECLARATIONS
C
      DOUBLE PRECISION  TT, FR(2)

C       MAIN ENTRY -- GET INTEGER AND FRACTIONAL PARTS

      FR(1)=DINT(TT)
      FR(2)=TT-FR(1)

      IF(TT.GE.0.D0 .OR. FR(2).EQ.0.D0) RETURN

C       MAKE ADJUSTMENTS FOR NEGATIVE INPUT NUMBER

      FR(1)=FR(1)-1.D0
      FR(2)=FR(2)+1.D0

      RETURN

      END

      SUBROUTINE VXSTKY( NAMEIN, SERIOUS )
C
C     function to check NAMEIN is a valid (unquoted) VEX string
C     suitable for a VEX key value, quote it if not.
C     no blanks, etc, 32 chars, produces warning if SERIOUS
C     H.J. van Langevelde, JIVE 121200
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      CHARACTER NAMEIN*(*)
      LOGICAL SERIOUS
C
      INTEGER MAXSTR
      PARAMETER ( MAXSTR = 32 )
C
      CHARACTER NAMOUT*(MAXSTR)
      INTEGER LPOS, ILAST, ISTART, IOUT
      LOGICAL TOQUOT
      INTEGER LEN1
C ----------------------------------------------------------------------
C
      TOQUOT = .FALSE.
      IF( NAMEIN .EQ. ' ' ) NAMEIN = 'Nescio'
      ILAST = LEN1(NAMEIN)
C
C     search for leading blanks
C
      DO LPOS = 1, ILAST
         IF( NAMEIN(LPOS:LPOS) .NE. BLN ) GOTO 50
      END DO
   50 CONTINUE
      ISTART = LPOS
C
C     characters &, :, ; $ * are reserved in VEX, I reserve #
C     for numbering, Quote occurences
C
      DO LPOS = 1, ILAST
         IF( NAMEIN(LPOS:LPOS) .EQ. COL .OR.
     1       NAMEIN(LPOS:LPOS) .EQ. SEP .OR.
     2       NAMEIN(LPOS:LPOS) .EQ. LNK .OR. 
     2       NAMEIN(LPOS:LPOS) .EQ. BLN .OR. 
     3       NAMEIN(LPOS:LPOS) .EQ. '$' .OR.
     4       NAMEIN(LPOS:LPOS) .EQ. COM .OR.
     5       NAMEIN(LPOS:LPOS) .EQ. '#' ) THEN
            TOQUOT = .TRUE.
         END IF
      END DO
C
C     Copy but only 32 or 30 positions
C
      ILAST = MIN( ILAST, MAXSTR+ISTART )
      IOUT = 1
      IF ( TOQUOT ) THEN
         NAMOUT(1:1)= QOT
         IOUT = 2
         ILAST=MIN( ILAST,MAXSTR-3+ISTART)
      ENDIF

      DO LPOS = ISTART, ILAST
         NAMOUT(IOUT:IOUT) = NAMEIN(LPOS:LPOS)
         IOUT = IOUT + 1
      END DO

      IF ( TOQUOT ) THEN
         NAMOUT(IOUT:IOUT)= QOT
         IOUT = IOUT+1
      ENDIF
C
      DO LPOS = IOUT, MAXSTR
         NAMOUT(LPOS:LPOS) = BLN
      END DO
C
C
      IF( TOQUOT .AND. ( SERIOUS .OR. DEBUG ) ) THEN
         WRITE( MSGTXT , '( A, A, A )' )
     1       'VXSTKY: Quoting VEX string: <', 
     2       NAMOUT(1:LEN1(NAMOUT)),'> '
         CALL WLOG( 1, MSGTXT )
      END IF
C     
      NAMEIN = NAMOUT
C
      RETURN
      END

      SUBROUTINE BBCVS2( KS )
C
C     Routine for SCHED, called by SETBBC, that sets the BBC
C     assignments for S2 systems attached to VLBA DAR's.
C     Only allow IF's A and C.  That way it works for both VLBA
C     and VLBAG systems.
C
C     The code needed, once the arrays are established, is the same
C     as for BBCM4 (Mark IV), so it has been put in BBCALT, which
C     is shared.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    I, KS
      INTEGER    MAXBBC, MAXIF, NNBBC
C
C   ******   Set MAXBBC smaller once the catalogs are changed.
C            Dec2004  What does this mean?  What catalog change?
C
      PARAMETER  (MAXBBC=14)
      PARAMETER  (MAXIF=2)
      INTEGER    IFBBCD(MAXBBC,MAXIF), IFBBCS(MAXBBC,MAXIF)
      CHARACTER  IFNAM(MAXIF)*2, WARNING*4
      LOGICAL    UBBC(MAXBBC)
      DATA  (IFBBCD(I,1),I=1,MAXBBC) / 1,0,1,0,1,0,1,0,1,0,1,0,1,0 /
      DATA  (IFBBCD(I,2),I=1,MAXBBC) / 0,1,0,1,0,1,0,1,0,1,0,1,0,1 /
      DATA  (IFNAM(I),I=1,MAXIF) / 'C', 'A' /
      DATA  (IFBBCS(I,1),I=1,MAXBBC) / 1,0,1,0,1,0,1,0,1,0,1,0,1,0 /
      DATA  (IFBBCS(I,2),I=1,MAXBBC) / 1,0,1,0,1,0,1,0,1,0,1,0,1,0 /
C
C     Why can the even BBCs not be used for single pol obs?
C
C     The manual claims that there is information in the document 
C     ``Compatibility of S2 and VSOPT recordings at S2 and VSOPT
C     Correlators'' by R.\ Wietfeldt, available at
C     ftp::s2.sgl.ists.ca:pub/s2/svlbi/s2vsop\_compat\_memo\_v*.ps.Z.
C     but the link appears to have expired as of the end of 2004.
C -------------------------------------------------------------------  
C     Software check:
C
      IF( NBBC(ISETSTA(KS)) .GT. MAXBBC ) THEN
         WRITE( MSGTXT, '( 3A, I4 )' )
     1       'BBCGEO: Number of BBCs at ', SETSTA(1,KS), 
     2       ' Larger than maximum expected: ', MAXBBC 
         CALL WLOG( 1, MSGTXT )
         CALL WLOG( 1, '   Catalog or programming problem ' )
         CALL ERRSET( KS )
      END IF
C
      WARNING = 'S2'
C
C     Set the number of BBC's.
C
      NNBBC = NBBC(ISETSTA(KS))
C
C     Call BBCALT to do the work.
C
      IF( DUALPOL(KS) ) THEN
         CALL BBCALT( KS, MAXBBC, MAXIF, IFBBCD, IFNAM, UBBC, NNBBC,
     1             WARNING, 'BBCVS2-1' )
      ELSE
         CALL BBCALT( KS, MAXBBC, MAXIF, IFBBCS, IFNAM, UBBC, NNBBC,
     1             WARNING, 'BBCVS2-2' )
      END IF
C
      RETURN 
      END

      SUBROUTINE MAKESEG( JSCN, ISCN, LASTISCN, 
     1                    OKGEO, USEGEO, SEGELEV, STARTB, TGEOEND, 
     2                    LSCN, NTSEG, TSRC, IDUM, SIGMA, SELTYPE,
     3                    WSTA )
Cf2py intent(in) JSCN, ISCN, LASTISCN, OKGEO, USEGEO, SEGELEV, STARTB
Cf2py intent(in) TGEOEND, SIGMA
Cf2py intent(out) LSCN, NTSEG, TSRC, SELTYPE, WSTA
Cf2py intent(in, out) IDUM
C
C     Routine for SCHED called by GEOMAKE that invents a 
C     series of sources to try as a geodetic sequence.
C
C     This particular version selects sources that improve the
C     quality measure (or something closely related) while minimizing
C     slews.  For the first few sources, it randomly picks from
C     among the ones available with the shortest slews, including
C     knowing about where the antenna is before the segment.
C
C     Inputs:
C        JSCN:      Template scan.  Less than ISCN usually.
C        ISCN:      The first scan of the sequence
C        LASTISCN:  The preceeding scan for each station at the start.
C        OKGEO:     Sources in the geodetic set that have a useful
C                   elevation distribution.
C        SEGELEV    2D array (sta,source) of elevations
C                   Not used with current algorithm.
C        STARTB:    Start time of the sequence.
C        TGEOEND:   End time for a sequence.
C        IDUM:      Seed for the random number generator
C        SIGMA:     Used for the zenith atmosphere errors from GEOQUAL.
C                   Mainly sent here so don't need a separate array
C                   from the one in GEOMAKE.
C 
C     Outputs:
C        LSCN:      The last scan of the sequence
C        NTSEG:     Number of scans in the geodetic sequence.
C        TSRC:      The sequence of geodetic source numbers for the
C                   geodetic sequence.
C        SELTYPE:   Selection type used:  SP=sigma+slew penalty, 
C                        S=sigma, no penalty, RMS=rms sigma.
C                        NR=nearby random.
C        WSTA:      Worst station.
C
C     The chosen output scans will be deposited in scans ISCN to LSCN.
C
      INCLUDE 'sched.inc'
C
      INTEGER            MSEG10
      PARAMETER          (MSEG10=10*MSEG)
      INTEGER            JSCN, ISCN, LSCN, LASTISCN(*)
      INTEGER            TSRC(*), NTSEG, USEGEO(*), IDUM
      LOGICAL            OKGEO(*)
      REAL               SEGELEV(MAXSTA,MGEO)
      DOUBLE PRECISION   STARTB, TGEOEND, SIGMA(*)
      CHARACTER          SELTYPE(*)*3, WSTA(*)*3
C
      INTEGER            ISTA, IS, ISEG, IGEO, IC, LSEG, JJSCN 
      INTEGER            LASTLSCN(MAXSTA), NNEAR, NRAND, CTSC
      INTEGER            KSCN, MAXPRIO, IISCN, SSCN1, NPRT, MAXIC
      INTEGER            NGOOD, NCHANCE, CHANCE(MSEG10), TEMPCH 
      INTEGER            INSCN(MAXSTA), INSCT, SELECTED(MGEO)
      INTEGER            HIGHSTA, HIGHSTA1, HIGHSTA2, HIGHSTA3
      INTEGER            LHIGHSTA, NEEDLOW, NEEDHIGH, LHGOAL
      INTEGER            STALOW(MAXSTA), NSTALOW, NNEWLOW
      INTEGER            STAHIGH(MAXSTA), NSTAHIGH, NNEWHIGH
      INTEGER            TSRC1, TSRC2, TSRC3, NSTASCN(MAXSTA), MINNSS
      LOGICAL            OKSTA(MAXSTA), LSTAS
      LOGICAL            STAOK, SRCOK, NEWC, PRDEBUG, DORAND
      LOGICAL            SSTASCN(MAXSTA), KSTASCN(MGEO,MAXSTA)
      REAL               RAN5, TESTQUAL, PENALTY, ELA
      REAL               SLQUAL, BSLQUAL
      REAL               FQUAL, BFQUAL, FQUALSL, BFQUALSL
      REAL               PKSIG
      REAL               SAVSIG(MAXSTA), SAVSIG1(MAXSTA)
      REAL               SAVSIG2(MAXSTA), SAVSIG3(MAXSTA)
      REAL               HIGHSIG, HIGHSIG1, HIGHSIG2, HIGHSIG3
      REAL               LHIGHSIG
      DOUBLE PRECISION   TAPPROX, TESTTIME(MSEG10), TEMPTIME
      DOUBLE PRECISION   SLEWTIME, TSEP, T0
      CHARACTER          LSRCNAME*12, LASTTYPE*5, METHOD*4
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'MAKESEG starting' )
      NPRT = MIN( 20, NSTA )
C
C     Initializations
C
      ISEG = 0
      LSEG = 0
      NRAND = 0
      DORAND = .TRUE.
      NTSEG = 0
      DO IGEO = 1, NGEO
         SELECTED(IGEO) = 0
      END DO
      DO IS = 1, MSEG
         TSRC(IS) = 0
         SELTYPE(IS) = '   '
      END DO
      LHIGHSTA = 0
      LHIGHSIG = 0.0
      LASTTYPE = ' '
C
C     For the first source, be relaxed about what is chosen.  This
C     was flagged as a test in the 9.4 release, but that release
C     seems to be working, so keep it.  Note that MAXPRIO 5 are 
C     sources that can be observed but don't contribute anything
C     special.  The only higher setting is 9, which are not useful
C     for a variety of reasons.
C
      MAXPRIO = 6
C
C     In the initial source selection, try to get low and high elevations
C     at each station using sources close to previous one to avoid
C     long slews.  LHGOAL is the desired number of sources at each
C     station with low (or high) elevation scans.  Start trying to get
C     one of each (LHGOAL=1).  Later this will be raised to 2.
C
      LHGOAL = 1
C
C     Keep track of the number of scans each station is in.
C     Mainly use this to try to avoid too few for the quality
C     measure least square fit.  Initialize the counter here.
C     Also keep track of the number of low elevation scans
C     a station has, at least for before each station has minimal
C     low and high elevation sources.
C
      DO ISTA = 1, NSTA
         INSCN(ISTA) = 0
         STALOW(ISTA) = 0
         STAHIGH(ISTA) = 0
      END DO
      NSTALOW = 0
      NSTAHIGH = 0
C
C     Copy LASTISCN to LASTLSCN where it can then get modified
C     in calls to other routines during trials of sets of sources
C     without affecting the input values.
C
      DO ISTA = 1, NSTA
         LASTLSCN(ISTA) = LASTISCN(ISTA)
      END DO
C
C     Set start time of the first new scan.  This is mainly
C     for the case when the segment is at the start of the
C     experiment and all LASTISCN entries are zero.
C
      STARTJ(ISCN) = STARTB
C
C     Write column headers if it's going to print the sigmas.
C
      IF( GEOPRT .GE. 1 ) THEN
         WRITE( MSGTXT, '( T40, 20( 2X, A2, 1X) )' ) 
     1           '                      ', 
     2           (STCODE(STANUM(ISTA)),ISTA=1,NPRT)
         CALL WLOG( 0, MSGTXT )
      END IF
C
C     Start selecting scans.  Jump to 100 to get next source.
C
  100 CONTINUE
C
C        Set the scan number.
C
         ISEG = ISEG + 1
         IF( ISEG .GT. MSEG ) THEN
            CALL WLOG( 1, ' ' )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5, A )' )
     1        ' Trying to exceed SCHED''s limit of ', MSEG, 
     2        ' scans in an inserted geodetic segment.'
            CALL WLOG( 1, MSGTXT )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A )' )
     1        ' Shorten the requested segment or divide it into ',
     2        'multiple segments.'
            CALL ERRLOG( MSGTXT )
         END IF
         LSCN = ISEG + ISCN - 1
C
C        Initialize these or they get remembered to next trial
C        sequence.
C
         HIGHSTA = 0
         HIGHSIG = 0
C
C        Sometimes there might be too little data to fit for all the
C        parameters.  This happens when any antenna is in less than
C        3 scans (actually one can have 2, but ignore that), although 
C        it might be disguised by using all the baselines.  Get the 
C        minimum number of scans so far per station and don't allow
C        the use of the least squares fit until there are 3 per station.
C        MINNSS is the minimum number of scans for a station.
C
C        First count the number of scans each station is in for which
C        the source is up.  Note LSCN is the next scan which for which
C        the source is not yet picked.
C        
         DO ISTA = 1, NSTA
            NSTASCN(ISTA) = 0
            IF( LSCN .GT. ISCN ) THEN
               DO JJSCN = ISCN, LSCN - 1 
                  IF( STASCN(JJSCN,ISTA) .AND. UP1(JJSCN,ISTA) .EQ. ' ' 
     1                .AND. UP2(JJSCN,ISTA) .EQ. ' ' ) THEN
                     NSTASCN(ISTA) = NSTASCN(ISTA) + 1
                  END IF
               END DO
            END IF
         END DO
C
C        Now get the minimum across stations.
C
         MINNSS=999
         DO ISTA = 1, NSTA
            MINNSS = MIN( NSTASCN(ISTA), MINNSS )
         END DO
C
C        Note the start of new source attempt if putting out debug print.
C
         IF( GEOPRT .GE. 2 ) THEN
            CALL WLOG( 0, ' ' )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I3, A, L1, A, I3, A, I2 )' ) 
     1         '----MAKESEG:  Starting to work on next source: ISEG: ',
     2         ISEG, '   DORAND:', DORAND, '   MINNSS:', MINNSS, 
     3         '   MAXPRIO: ', MAXPRIO
            CALL WLOG( 0, MSGTXT )
            MSGTXT = ' '
         END IF
C
C        
C        Set the first scan to use for quality measures using GEOBACK.
C        That is the "look back" distance if you want the quality measure
C        determined only over the more recent scans.
C        Set a separate first scan for avoiding repeats of individual 
C        sources.  In some cases where there are limited options, a 
C        sequence might benefit from using the same source twice. But they
C        shouldn't be adjacent scans.  Use GEOSREP for this function.
C        Setting these first scans saves repeats below.
C
         IISCN = MAX( ISCN, LSCN - GEOBACK + 1 ) 
         SSCN1 = MAX( ISCN, LSCN - GEOSREP + 1 )
C
C        At first, using psuedo fits to select the best source won't be
C        very productive because there are too few scans.  So start by
C        selecting sources such that there is at least one high and
C        one low elevation scan for each antenna.  After that, use the
C        test fits.  Use NRAND to keep track of the number of sources
C        picked this way.
C
C        Set the number of sources to pick before starting to 
C        measure the quality measure.  For these, restrict to
C        better sources using USEGEO and take ones that involve
C        short slews.
C
C        ====  First sources - get something low el and something high 
C        ====  el for each station 
C
C        Also force this selection scheme if any station has only one scan
C        as it cannot reach the required 3 with one additional scan.
C
         IF( ( ( NSTALOW .LT. NSTA .OR. NSTAHIGH .LT. NSTA ) .AND. 
     1       DORAND ) .OR. MINNSS .LE. 1 ) THEN
            NRAND = NRAND + 1
            METHOD = 'RAND'
C
C           Find all of the sources with USEGEO .LE. MAXPRIO below the limit 
C           that can contribute to the number stations with low or high
C           elevation data.  MAXPRIO starts as 2, but is raised to 3 
C           (> 5, the highest for useful sources) if there are no more
C  RCW  Should that be <5?
C           prio 1 or 2 sources available.
C           Of the sources that qualify, find the closest 5 and choose one
C           at random.  For the first scan of the experiment, choose
C           from all with USEGEO low enough.
C
C           Note that the NGOOD test should be passed if USEGEO is 
C           acceptable, but the geo segments are of finite length so
C           the up status can change compared to what GEOCHK used.
C
C           SELECTED is the last scan in which this source
C           was selected.  It is used to help prevent rapid repeats.
C
C           With STALOW and STAHIGH, keep track of the number of stations 
C           with low or high elevation scans.  Insist that any new 
C           source increase one of those numbers.  Once both reach NSTA,
C           switch to doing test fits.
C
C           This selection process is much faster than the scheme used 
C           below based on a psuedo LSQ fit for SecZ.  Try to use it as
C           much as possible.  That means trying to find 2 low and 2 high
C           sources for each station.
C
            NNEAR = 5
            NCHANCE = 0
C
            DO IGEO = 1, NGEO
               IF( USEGEO(IGEO) .LE. MAXPRIO  .AND. 
     1             SELECTED(IGEO) .LT. SSCN1 ) THEN
                  IF( ISEG .EQ. 1 ) THEN
                     TAPPROX = STARTB
                  ELSE
                     TAPPROX = STOPJ(LSCN-1) + 60.D0 * ONESEC
                  END IF
C
C                 For debug print, mark attempt for this source.
                  IF( GEOPRT .GE. 2 ) THEN
                     MSGTXT = ' ' 
                     WRITE( MSGTXT, 
     1                 '( 2A, I4, A, I4, 3A, I4, A, F13.6 )' )
     2                 'MAKESEG random section - looking for nearby ',
     3                 'source.  Considering:', iseg, ' SRC: ', igeo,
     4                  ' ',  GEOSRC(igeo), '  USEGEO: ', USEGEO(IGEO), 
     5                  ' at ', TAPPROX
                     CALL WLOG( 0, MSGTXT )
                  END IF
C
C                 Insert the new scan.  GMKSCN is like MAKESCN
C                 but also is capable of removing stations based
C                 on long slews.  It can also make or take a 
C                 predetermined list of stations to include.
C
                  CALL GMKSCN( LASTLSCN, LSCN, JSCN, GEOSRCI(IGEO),
     1                    GEOSRC(IGEO), TAPPROX, OPMINEL(JSCN), 0,
     2                    NGOOD, OKSTA, SSTASCN, 'SET  ' )
C
C                 Save SSTASCN for after source selection is done.
C
                  DO ISTA = 1, NSTA
                     KSTASCN(IGEO,ISTA) = SSTASCN(ISTA)
                  END DO
C
C                 Count then number of new stations for which this source
C                 adds the first low elevation data.  Do the same for
C                 high elevation data.  Then count the number of such
C                 stations.  Accept sources that add significant numbers
C                 of stations with low and high el scans.  See the code
C                 for what "significant" means.
C
                  NNEWLOW = 0
                  NNEWHIGH = 0
                  NEEDLOW = 0
                  NEEDHIGH = 0
                  DO ISTA = 1, NSTA
                     IF( STALOW(ISTA) .LT. LHGOAL ) 
     1                     NEEDLOW = NEEDLOW + 1
                     IF( STAHIGH(ISTA) .LT. LHGOAL ) 
     1                     NEEDHIGH = NEEDHIGH + 1
                     IF( SSTASCN(ISTA) ) THEN
                        ELA = ( EL1(LSCN,ISTA) + EL2(LSCN,ISTA) ) / 2.0
                        IF( ELA .LE. GEOLOWEL ) THEN
                           IF( STALOW(ISTA) .LT. LHGOAL ) THEN
                              NNEWLOW = NNEWLOW + 1
                           END IF
                        END IF
                        IF( ELA .GE. GEOHIEL ) THEN
                           IF( STAHIGH(ISTA) .LT. LHGOAL ) THEN
                              NNEWHIGH = NNEWHIGH + 1
                           END IF
                        END IF
                     END IF
                  END DO
                  SRCOK = ( NNEWLOW + NNEWHIGH .GT. NSTA / 3 ) .OR. 
     1                    NNEWLOW + NNEWHIGH .GE. 
     2                    MAX( 1, ( NEEDLOW + NEEDHIGH ) / 3 )
C
C                  SRCOK = ( NNEWLOW .GE. 1 .AND. NSTALOW .LT. NSTA ) 
C     1               .OR. ( NNEWHIGH .GE. 1 .AND. NSTAHIGH .LT. NSTA ) 
C
C      Save another set of currently unused debug printout.
C      write(*,*) 'makeseg iseg nrand ', iseg, nrand, igeo, nstalow, 
C     1    nstahigh, nnewlow, nnewhigh, ' ', srcok, needlow, needhigh,
C     2    lhgoal
C
C                 Check that every station has been in enough scans
C                 by now.  That means they have been in half.  Recall
C                 that integer division gives the next lowest integer.
C                 Also require that enough stations be in the scan.
C
                  STAOK = .TRUE.
                  NEWC = .FALSE.
                  DO ISTA = 1, NSTA
                     INSCT = INSCN(ISTA)
                     IF( STASCN(LSCN,ISTA) ) INSCT = INSCT + 1
                     IF( INSCT .LT. ISEG / 2 ) THEN
                        STAOK = .FALSE.
                     END IF
                  END DO
                  IF( SRCOK .AND. STAOK .AND. NGOOD .GE. OPMIAN(JSCN) )
     1                 THEN
C
C                    Add to the CHANCE array if we're just starting.
C                    Also for the first source of the experiment, 
C                    just add all of the qualifying sources.
C
                     IF( NCHANCE .LT. NNEAR .OR. LSCN .EQ. SCAN1 ) THEN
                        NCHANCE = NCHANCE + 1
                        CHANCE(NCHANCE) = IGEO
                        TESTTIME(NCHANCE) = STARTJ(LSCN)
                        NEWC = .TRUE.
C
C                    Accumulate the best NNEAR cases.  First replace
C                    the end of the NNEAR long list if the current
C                    one ends earlier.
C
                     ELSE IF( STARTJ(LSCN) .LT. TESTTIME(NNEAR) ) THEN
                        CHANCE(NNEAR) = IGEO
                        TESTTIME(NNEAR) = STARTJ(LSCN)
                        NEWC = .TRUE.
                     END IF
C
                     IF( GEOPRT .GE. 2 ) THEN
                        IF( LSCN .EQ. SCAN1 ) THEN
                           LSRCNAME = 'First scan'
                           TSEP = 0.D0
                        ELSE
                           LSRCNAME = SCNSRC(LSCN-1)
                           TSEP = (STARTJ(LSCN)-STOPJ(LSCN-1))*86400.D0
                        END IF
                        MSGTXT = ' '
                        WRITE( MSGTXT, * ) 'MAKESEG getting slew info',
     1                     IGEO, LSCN, ' Last source: ', LSRCNAME, 
     2                     '  Testing: ', GEOSRC(IGEO)
                        CALL WLOG( 0, MSGTXT )
                        DO ISTA = 1, NSTA
                           IF( LSCN .EQ. SCAN1 ) THEN
                              LSTAS = .FALSE.
                           ELSE
                              LSTAS = STASCN(LSCN-1,ISTA)
                           END IF
                           MSGTXT = ' '
                           WRITE( MSGTXT, '(A,2I5,5F7.1,2L2,F7.1)' ) 
     1                       ' makeseg els, azs, tslew: ', ISTA, 
     2                       LASTLSCN(ISTA), 
     3                       EL2(LASTLSCN(ISTA),ISTA), EL1(LSCN,ISTA),
     4                       AZ2(LASTLSCN(ISTA),ISTA), AZ1(LSCN,ISTA),
     5                       TSLEW(LSCN,ISTA)*86400.D0,
     6                       LSTAS, STASCN(LSCN,ISTA), TSEP
                           CALL WLOG( 0, MSGTXT )
                        END DO
                     END IF
C
C                    Now push up anything that was added to where
C                    it belongs.  This is sorting the sources in the
C                    chance array by slew time.  Don't bother for the
C                    first source.
C
                     IF( NEWC .AND. .NOT. LSCN .EQ. SCAN1 ) THEN
                        DO IC = NCHANCE-1, 1, -1
                           IF( TESTTIME(IC+1) .LT. TESTTIME(IC) ) THEN
                              TEMPCH = CHANCE(IC)
                              TEMPTIME = TESTTIME(IC)
                              CHANCE(IC) = CHANCE(IC+1)
                              TESTTIME(IC) = TESTTIME(IC+1)
                              CHANCE(IC+1) = TEMPCH
                              TESTTIME(IC+1) = TEMPTIME
                           END IF
                        END DO
                     END IF
                  END IF
               END IF
            END DO
C
C           Make sure there are some sources.  If not, adjust MAXPRIO
C           With a good list, this should this should not happen.  But
C           it does sometimes with Mark's original list.  Exit to the
C           fitting part if we get here twice on the same ISEG and there
C           are enough scans for a fit.  If there aren't enough for
C           a fit, increase MAXPRIO again.  If get past all acceptable
C           sources, complain about too few sources to choose from and
C           quit.
C
            IF( NCHANCE .EQ. 0 ) THEN
C
C              Debug print.
C
               IF( GEOPRT .GE. 1 ) THEN
                  MSGTXT =  ' '
                  WRITE( MSGTXT, '( A, I2, A )' )
     1               'MAKESEG: No priority <= ', MAXPRIO, 
     2               ' sources found for random source additions.'
                  CALL WLOG( 0, MSGTXT )
               END IF
C
C              Take action depending on MAXPRIO.
C              Only resort to priority 4 and 5 sources when we won't have
C              enough scans for a LSQ fit when adding one more.  In other
C              words, require each station have at least 2 scans (MINNSS>=2).
C
               IF( MAXPRIO .GE. 3 .AND. MAXPRIO .LT. 5 ) THEN
                  IF( MINNSS .GE. 2 ) THEN
                     DORAND = .FALSE.
                     IF (GEOPRT .GE. 1 ) THEN
                        CALL WLOG( 0, 
     1                  '         Select a source using a SecZ fit.' )
                     END IF
                  ELSE
                     MAXPRIO = MAXPRIO + 1
                     DORAND = .TRUE.
                  END IF
               ELSE IF( MAXPRIO .GE. 5 ) THEN
                  MSGTXT = 'Too few useful sources to choose from to ' 
     1                // 'construct a geodetic segment. '
                  CALL WLOG( 1, MSGTXT )
                  CALL WLOG( 1, '   Possible solutions include: ' )
                  CALL WLOG( 1, '     Add sources ' )
                  MSGTXT =      '     Adjust GEOLOWEL and GEOHIEL '//
     1              'so more sources are considered useful.'
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT =      '     Try different OPMINANT or '//
     1              'OPMINEL'
                  CALL WLOG( 1, MSGTXT )
                  CALL ERRLOG( '    Pick a solution and try again.' )
               ELSE
                  MAXPRIO = MAXPRIO + 1
                  IF( GEOPRT .GE. 1 ) THEN
                     CALL WLOG( 0, 
     1                  '         Allow scans with low stations but '
     2                  // 'no very high elevation stations.' )
                  END IF
               END IF
C
C              Reset counters from this attempt and go back to try again.
C
               ISEG = ISEG - 1
               NRAND = NRAND - 1
               GO TO 100
            END IF               
C
C           Pick one of the top choices randomly.  Don't take one that
C           for which the scan is more than one minute after the first.
C           Ok, the first DO loop is trivial for IC = 1, but keeps the 
C           code simpler.  Note if NCHANCE is zero, we won't get here.

C ***********************  is this causing the infinite loop?


C
            DO IC = 1, NCHANCE
               IF( TESTTIME(IC) .LE. TESTTIME(1) + 60.D0 * ONESEC )
     1             THEN
                  MAXIC = IC
               END IF
            END DO
            IC = INT( 1 + RAN5(IDUM) * MAXIC )
            IF( GEOPRT .GE. 2 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, 2I4 )' ) 
     1            'MAKESEG picked random source: ', IC, CHANCE(IC)
               CALL WLOG( 0, MSGTXT )
            END IF
            TSRC(ISEG) = CHANCE(IC)
            DO ISTA = 1, NSTA
               SSTASCN(ISTA) = KSTASCN(TSRC(ISEG),ISTA)
            END DO
            SELTYPE(ISEG) = 'NR'
            WSTA(ISEG) = '-- '
C
C           Write some slew time information if requested.
C
            IF( GEOPRT .GE. 2 ) THEN
               T0 = DINT( STOPJ(LSCN) )
               MSGTXT = ' '
               WRITE( MSGTXT,'( A, 2I4, F10.2, 2I4 )' )
     1             'MAKESEQ slew times: ', TSRC(ISEG), IC, 
     2             (STOPJ(LSCN-1)-T0)*24.D0*60.D0, NCHANCE, MAXIC
               CALL WLOG( 0, MSGTXT )
               MSGTXT = ' '
               CALL WLOG( 0, ' Time below is minutes in day ' )
               CALL WLOG( 0, 
     1             '                    Src    Time  Since Last stop' )
               DO IS = 1, NCHANCE
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( 10X, A, I3, I4, A, A12, 2F10.2 )' )
     1             '   ', IS, CHANCE(IS), ' ', GEOSRC(CHANCE(IS)), 
     2             (TESTTIME(IS)-T0)*24.D0*60.D0, 
     3             (TESTTIME(IS)-STOPJ(LSCN-1))*24.D0*60.D0
                  CALL WLOG( 0, MSGTXT )
               END DO
            END IF
C
C        ==============  Rest of sources based on fit  =============
C
         ELSE
            METHOD = 'FIT'
C
C           For the rest of the sources, pick the one from the whole 
C           list that gives the lowest quality measure (highest 
C           quality), which is a combination of the fit rms's from 
C           GEOQUAL and the slew time.  This will be deterministic 
C           for each set of the first NRAND sources, but those first 
C           NRAND are random which should make the whole sequence 
C           randomly different each time the routine is called.
C
C           Note SELECTED is the last scan in which this source
C           was selected.  It is used to help prevent rapid repeats.
C
            BSLQUAL = 1.E9
            BFQUAL = 1.E9
            BFQUALSL = 1.E9
            TSRC(ISEG) = 0
            TSRC1 = 0
            TSRC2 = 0
            TSRC3 = 0
            DO IGEO = 1, NGEO
               IF( OKGEO(IGEO) .AND. SELECTED(IGEO) .LT. SSCN1 ) THEN
C
C                 Insert the source as the next scan to get all the
C                 required geometric parameters in a simple way.
C
                  TAPPROX = STOPJ(LSCN-1) + 60.D0 * ONESEC
C
C                 Insert the new scan.  GMKSCN is like MAKESCN
C                 but also is capable of removing stations based
C                 on long slews.  It can also make or take a 
C                 predetermined list of stations to include.
C                 Don't let it skip a scan on the station we really
C                 want to fix (LHIGHSTA)
C
                  CALL GMKSCN( LASTLSCN, LSCN, JSCN, GEOSRCI(IGEO),
     1                    GEOSRC(IGEO), TAPPROX, OPMINEL(JSCN),
     2                    LHIGHSTA, NGOOD, OKSTA, SSTASCN, 'SET  ' )
C
C                 Save SSTASCN as a function of source for use 
C                 after source selection.
C
                  DO ISTA = 1, NSTA
                     KSTASCN(IGEO,ISTA) = SSTASCN(ISTA)
                  END DO
C
C                 Decide if this is usable.
C
                  STAOK = .TRUE.
C
C                 Insist that the last high station (highest Sigma)
C                 be in the scan.
C
                  IF( LHIGHSTA .NE. 0 ) THEN
                     IF( .NOT. SSTASCN(LHIGHSTA) ) STAOK = .FALSE.
                  END IF
C
C                 First get the numbers needed and protect against
C                 a source choice that leaves some station with too
C                 few scans.  Additionally try to prevent having too
C                 few scans with this station in the GEOBACK look
C                 back set to do a fit.
C
                  IF( STAOK ) THEN
                     DO ISTA = 1, NSTA
C
C                       Require that a station be in half of scans.
C
                        INSCT = INSCN(ISTA)
                        IF( STASCN(LSCN,ISTA) ) INSCT = INSCT + 1
                        IF( INSCT .LT. ISEG / 2 ) STAOK = .FALSE.
C
C                       Require a station have 2 scans in the lookback
C                       set.  Only need to worry if the station is not
C                       in this scan.
C
                        IF( .NOT. STASCN(LSCN,ISTA) ) THEN
                           CTSC = 0
                           DO IS = IISCN, LSCN - 1
                              IF( STASCN(IS,ISTA) ) CTSC = CTSC + 1
                           END DO
                           IF( CTSC .LT. 2 ) STAOK = .FALSE.
                        END IF
C
                     END DO
                  END IF
C
                  IF( NGOOD .GE. OPMIAN(JSCN) .AND. STAOK .AND.
     1                STOPJ(LSCN) .LE. TGEOEND ) THEN
C
C                    Run GEOQUAL on the scans we have so far.
C
C                    Set up for initial call or incremental call.
C                    There shouldn't be any changes in any but the
C                    current scan, except on the first call for
C                    this segment.  GEOQUAL can be told not to bother
C                    repeating calculations for scans IISCN to KSCN
C                    by setting KSCN appropriately.  TSRC(ISEG) is 
C                    just a handy number that can be used to detect
C                    the first time GEOQUAL will be run for finding
C                    a source to add for scan LSCN.
C
C                    While at it, set up for a finite lookback
C                    time by using IISCN.  This is to prevent the 
C                    sequence from stagnating after it has a good 
C                    set for all stations.  With the current
C                    version of the algorithm, this might not be
C                    useful
C
C                    Also set the minimum elevation that will be
C                    rewarded in the fit so that not too much
C                    emphasis is placed on scans very close to
C                    the horizon.  The number is after JSCN
C                    in the GEOQUAL call and is set for SecZ=4.  
C
                     IF( TSRC(ISEG) .EQ. 0 ) THEN
                        KSCN = IISCN
                     ELSE
                        KSCN = LSCN
                     END IF
                     PRDEBUG = GEOPRT .GE. 2
C
                     IF( GEOPRT .GE. 2 ) THEN
                        CALL WLOG( 0, ' ' )
                        MSGTXT = ' '
                        WRITE( MSGTXT, * ) 
     1                   'Makeseg about to test quality ', ISEG, 
     2                   ISCN, IISCN, KSCN, LSCN, JSCN,
     3                   '  geosrc:', IGEO, ' ', GEOSRC(IGEO)
                        CALL WLOG( 0, MSGTXT )
                     END IF
C
                     CALL GEOQUAL( IISCN, KSCN, LSCN, JSCN, 14.48,
     1                    TESTQUAL, PRDEBUG, SIGMA )
C
C                    Construct the quality measures we want to use
C                    here.  Unlike in the final selection, here
C                    we want to take slews into account.  We also 
C                    want to reward improvement for stations that
C                    aren't the worst.  Note that, if there were a
C                    failure to invert the matrix, probably from
C                    inadequate data for some station, the testqual
C                    will be very high and this source will be 
C                    bypassed, unless there are no sources that work.
C                    
C                    Calculate three different quality measures.  Later
C                    choose which one to use.  All are based on the
C                    theoretical sigmas from a fit for the zenith
C                    atmosphere (sec(Z) term) base on the sources
C                    in the segment so far.  The three measures are
C                    1.)  FQUALSL: The sigma of the fit for the station 
C                         that had the highest sigma using the scans for
C                         which sources are already selected (LHIGHSTA)
C                         with an additional penalty added for long slews.
C                    2.)  FQUAL:  Just the sigma of the previous worst 
C                         station without the slew penalty.
C                    3.)  SLQUAL: The rms of all the sigmas across all 
C                         stations plus a slew penalty.
C
C                    Note that LHIGHSTA is the station with the highest
C                    sigma, LHIGHSIG, in the previous scan.  HIGHSTA
C                    is the station with the highest sigma HIGHSIG
C                    in the current sequence - being accumulated for
C                    use in setting up the next sequence.  SAVSIG
C                    is being accumulated for printing.
C
C                    Sigma of station with worst sigma last time.
C
                     IF( LHIGHSTA .GE. 1 ) THEN
                        FQUAL = SIGMA( LHIGHSTA )
                     ELSE
                        FQUAL = 0.0
                     END IF
C
C                    RMS sigma across array.
C
                     SLQUAL = 0.0
                     PKSIG = 0
                     DO ISTA = 1, NSTA
                        SLQUAL = SLQUAL + SIGMA(ISTA)**2
                        PKSIG = MAX( PKSIG, SIGMA(ISTA) )
                     END DO
                     SLQUAL = SQRT( SLQUAL / NSTA )
C
C                    Add in the slew penalty where needed.
C
                     SLEWTIME = STARTJ(LSCN) - STOPJ(LSCN-1)
                     PENALTY = GEOSLEW * SLEWTIME / ( 30.0 * ONESEC)
C
C       write(*,*) 'makeseg qual', lscn, igeo, slqual, fqual, penalty,
C     1     (sigma(ista),ista=1,nsta)
C
                     SLQUAL = SLQUAL + PENALTY
                     IF( FQUAL .NE. 0.0 ) THEN
                        FQUALSL = FQUAL + PENALTY
                     ELSE
                        FQUALSL = 0.0
                     END IF
C	   	   
C                    Spew info if requested.
C
                     IF( GEOPRT .GE. 2 ) THEN
                        MSGTXT = ' '
                        WRITE( MSGTXT,
     1                     '( A, 2I4, A, I4, 3A, 3F7.2, I5, F7.2)')
     2                     'Makeseg quality - LSCN:',
     3                     LSCN, ISEG, ' Source:', IGEO, '  ',
     4                     GEOSRC(IGEO), ' Quality: ', FQUALSL, FQUAL,
     5                     SLQUAL, LHIGHSTA, PKSIG
                        CALL WLOG( 0, MSGTXT )
                     END IF
C
C                    Keep this track of the best source based on
C                    each quality measure.  For each type, keep
C                    track of the worst station.
C
                     IF( FQUALSL .NE. 0.0 .AND. 
     1                   FQUALSL .LT. BFQUALSL ) THEN
                        BFQUALSL = FQUALSL
                        TSRC1 = IGEO
                        HIGHSTA1 = 0
                        HIGHSIG1 = 0.0
                        DO ISTA = 1, NSTA
                           IF( SIGMA(ISTA) .GT. HIGHSIG1 ) THEN
                              HIGHSTA1 = ISTA
                              HIGHSIG1 = SIGMA(ISTA)
                           END IF
                           SAVSIG1(ISTA) = SIGMA(ISTA)
                        END DO
                        IF( GEOPRT .GE. 2 ) THEN
                           MSGTXT = ' '
                           WRITE( MSGTXT, 
     1                       '( 2A, I5, 2A, F8.2, I5, F8.2 )' ) 
     2                       'makeseg: Got new best sigma with ',
     3                       'slew penalty: ', igeo, ' ', 
     4                       geosrc(igeo), fqualsl, highsta1,
     5                       highsig1
                           CALL WLOG( 0, MSGTXT )
                        END IF
                     END IF
C
                     IF( FQUAL .NE. 0.0 .AND. FQUAL .LT. BFQUAL ) THEN
                        BFQUAL = FQUAL
                        TSRC2 = IGEO
                        HIGHSTA2 = 0
                        HIGHSIG2 = 0.0
                        DO ISTA = 1, NSTA
                           IF( SIGMA(ISTA) .GT. HIGHSIG2 ) THEN
                              HIGHSTA2 = ISTA
                              HIGHSIG2 = SIGMA(ISTA)
                           END IF
                           SAVSIG2(ISTA) = SIGMA(ISTA)
                        END DO
                        IF( GEOPRT .GE. 2 ) THEN
                           MSGTXT = ' '
                           WRITE( MSGTXT, 
     1                         '( 2A, I5, 2A, F8.2, I5, F8.2 )' ) 
     2                         'makesig: Got new best sigma without ',
     3                         'slew penalty: ',
     4                         igeo, ' ', geosrc(igeo), fqual, highsta2, 
     5                         highsig2
                           CALL WLOG( 0, MSGTXT )
                        END IF
                     END IF
C
                     IF( SLQUAL .LT. BSLQUAL ) THEN
                        BSLQUAL = SLQUAL
                        TSRC3 = IGEO
                        HIGHSTA3 = 0
                        HIGHSIG3 = 0.0
                        DO ISTA = 1, NSTA
                           SAVSIG3(ISTA) = SIGMA(ISTA)
                           IF( SIGMA(ISTA) .GT. HIGHSIG3 ) THEN
                              HIGHSTA3 = ISTA
                              HIGHSIG3 = SIGMA(ISTA)
                           END IF
                        END DO
                        IF( GEOPRT .GE. 2 ) THEN
                          MSGTXT = ' '
                          WRITE(*, '( 2A, I5, 2A, F8.2, I5, F8.2 )' ) 
     1                      'makeseg: Got new best RMS sigma with ', 
     2                      'slew penalty: ',
     3                      igeo, ' ', geosrc(igeo), slqual, 
     4                      highsta3, highsig3
                          CALL WLOG( 0, MSGTXT )
                        END IF
                     END IF
                  END IF
               END IF
            END DO
C
C           Choose the next source based on the quality measures.
C           If the best using the rms of the worst station last time
C           with a slew penalty gives a good improvement for that
C           station, use it.  If not, use the one with the best rms
C           without a penalty.  If even that doesn't give much
C           improvement, take the best based on the improvement of
C           the rms errors.  Don't use the schemes based on the
C           previous worst, when that has not been determined.  Use
C           the best RMS then.
C
C           Allow for the last scan+1 when no sources were picked
C           for which all of the TSRCs will be zero.  Also use the
C           RMS one for ISEG = NRAND + 1 where there is no LHIGHSTA
C
C           Use the one that improves the previous worst station,
C           with slew penalty, if it is enough better than the the
C           one without the slew penalty.  Beyond the relative 
C           improvement, require an absolute improvement over the
C           previous case.
C
            IF( LHIGHSTA .NE. 0 ) THEN
               IF( TSRC1 .NE. 0 .AND. 
     1             ( LHIGHSIG - SAVSIG1(LHIGHSTA) ) .GT.  
     2             ( LHIGHSIG - SAVSIG2(LHIGHSTA) ) * 0.7 .AND. 
     3             LHIGHSIG / SAVSIG1(LHIGHSTA) .GT. 1.10 ) THEN
                  TSRC(ISEG) = TSRC1
                  SELTYPE(ISEG) = 'SP'
                  WSTA(ISEG) = STCODE(STANUM(HIGHSTA1))
C
C                 Deal with the information for the next pass.
C
                  HIGHSTA = HIGHSTA1
                  HIGHSIG = HIGHSIG1
                  DO ISTA = 1, NSTA
                     SAVSIG(ISTA) = SAVSIG1(ISTA)
                  END DO
                  LASTTYPE = 'SIGP'
C
C                 Optional print.
C
                  IF( GEOPRT .GE. 1 ) THEN
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( A, I4, A, F8.2, A, 3(F8.2,''/'',
     1                  I2, ''/'', I3 ) )' ) 'MAKESEG:', 
     2                  ISEG, ' Choice used slew penalty. Last:', 
     3                  LHIGHSIG, '  Options (sig/sta/src):', 
     4                  SAVSIG1(LHIGHSTA), HIGHSTA1, TSRC1, 
     5                  SAVSIG2(LHIGHSTA), HIGHSTA2, TSRC2, 
     6                  SAVSIG3(LHIGHSTA), HIGHSTA3, TSRC3
                     CALL WLOG( 0, MSGTXT )
                  END IF
C
C              Use the version without the slew penalty if the one
C              with the penalty wasn't so good, and the absolute
C              improvement is good.  Require it to be significantly better
C              to justify the long slew.
C
C              If the RMS was used in the last iteration, the same 
C              station is worst for the RMS, and the sigma is better 
C              with this option, take it without requiring the 
C              especially big improvement.
C
               ELSE IF( TSRC2 .NE. 0 .AND. 
     1             ( ( LHIGHSIG / SAVSIG2(LHIGHSTA) .GT. 1.25 ) .OR.
     2             ( LASTTYPE .EQ. 'RMS' .AND. 
     3               HIGHSTA3 .EQ. LHIGHSTA .AND. 
     3               HIGHSIG3 .GT. HIGHSIG2 ) ) ) THEN
                  TSRC(ISEG) = TSRC2
                  SELTYPE(ISEG) = 'S'
                  WSTA(ISEG) = STCODE(STANUM(HIGHSTA2))
C
C                 Deal with the information for the next pass.
C
                  HIGHSTA = HIGHSTA2
                  HIGHSIG = HIGHSIG2
                  DO ISTA = 1, NSTA
                     SAVSIG(ISTA) = SAVSIG2(ISTA)
                  END DO
                  LASTTYPE = 'SIG'
C
C                 Optional print.
C
                  IF( GEOPRT .GE. 1 ) THEN
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( A, I4, A, F8.2, A, 3(F8.2,''/'',
     1                  I2, ''/'', I3 ) )' ) 'MAKESEG:', 
     2                  ISEG, ' Choice used sigma only.   Last:',
     3                  LHIGHSIG, '  Options (sig/sta/src):', 
     4                  SAVSIG1(LHIGHSTA), HIGHSTA1, TSRC1, 
     5                  SAVSIG2(LHIGHSTA), HIGHSTA2, TSRC2, 
     6                  SAVSIG3(LHIGHSTA), HIGHSTA3, TSRC3
                     CALL WLOG( 0, MSGTXT )
                  END IF
               END IF
            END IF
C
C           Use the RMS sigma if needed, as detected by TSRC(ISEG)=0. 
C           This will always be the case for ISEG equal to NRAND+1, 
C           which had LHIGHSTA=0 and skipped the opportunities to set
C           TSRC(ISEG) above.  It will also be the case when the 
C           improvements required above were not met.
C
            IF( TSRC3 .NE. 0 .AND. TSRC(ISEG) .EQ. 0 ) THEN
               TSRC(ISEG) = TSRC3
               SELTYPE(ISEG) = 'RMS'
               WSTA(ISEG) = STCODE(STANUM(HIGHSTA3))
C
C              Deal with the information for the next pass.
C
               HIGHSTA = HIGHSTA3
               HIGHSIG = HIGHSIG3
               DO ISTA = 1, NSTA
                  SAVSIG(ISTA) = SAVSIG3(ISTA)
               END DO
               LASTTYPE = 'RMS'
C
C              Optional print.
C
               IF( GEOPRT .GE. 1 ) THEN
                  MSGTXT = ' '
                  WRITE(*,'( A, I4, A, F8.2, A, 3(F8.2,''/'',I2,
     1               ''/'', I3 ) )' ) 'MAKESEG:', 
     2              ISEG, ' Choice used RMS sigma.    Last:',
     3              LHIGHSIG, '  Options (sig/sta/src):', 
     4              SAVSIG1(LHIGHSTA), HIGHSTA1, TSRC1, 
     5              SAVSIG2(LHIGHSTA), HIGHSTA2, TSRC2, 
     6              SAVSIG3(LHIGHSTA), HIGHSTA3, TSRC3
                  CALL WLOG( 0, MSGTXT )
               END IF
C
            END IF
C
C           Recover the stations to use.
C
            IF( TSRC(ISEG) .NE. 0 ) THEN
               DO ISTA = 1, NSTA
                  SSTASCN(ISTA) = KSTASCN(TSRC(ISEG),ISTA)
               END DO
            END IF
C
C           End of source selection.
C
         END IF
C
C        ===============
C        If a source was found and the stop time was early enough,
C        construct a scan with the source and go back for the next
C        source.
C
         IF( TSRC(ISEG) .GT. 0 ) THEN
C
            IF( GEOPRT .GE. 2 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, * ) 'Makeseg got the next source - seg:', 
     1           ISEG, '  Geosrc:', TSRC(ISEG), 
     2           '  ', GEOSRC(TSRC(ISEG)), ' tapprox:', TAPPROX,
     3           ' stascn: ', (sstascn(ista),ista=1,nsta) 
               CALL WLOG( 0, MSGTXT )
            END IF
C
C           Insert the chosen source in the sequence.  Don't second
C           guess the number of good stations etc.  Use the list
C           of stations previously determined.  Also, do not recheck
C           the stop time.
C
            CALL GMKSCN( LASTLSCN, LSCN, JSCN, GEOSRCI(TSRC(ISEG)),
     1           GEOSRC(TSRC(ISEG)), TAPPROX, OPMINEL(JSCN), 0,
     2           NGOOD, OKSTA, SSTASCN, 'FORCE' )
C
C           Accumulate INSCN(ISTA), SELECTED, LASTLSCN, STALOW, and
C           STAHIGH.
C
            DO ISTA = 1, NSTA
               IF( STASCN(LSCN,ISTA) ) THEN
                  INSCN(ISTA) = INSCN(ISTA) + 1
                  LASTLSCN(ISTA) = LSCN
                  ELA = ( EL1(LSCN,ISTA) + EL2(LSCN,ISTA) ) / 2.0
                  IF( ELA .LE. GEOLOWEL ) THEN
                     STALOW(ISTA) = STALOW(ISTA) + 1
                  END IF
                  IF( ELA .GE. GEOHIEL ) THEN
                     STAHIGH(ISTA) = STAHIGH(ISTA) + 1
                  END IF
               END IF
            END DO
C
C           Get NSTALOW and NSTAHIGH
C
            NSTALOW = 0
            NSTAHIGH = 0
            DO ISTA = 1, NSTA
               IF( STALOW(ISTA) .GE. LHGOAL ) NSTALOW = NSTALOW + 1
               IF( STAHIGH(ISTA) .GE. LHGOAL ) NSTAHIGH = NSTAHIGH + 1
            END DO
C
C           After there is one high and one low, go back for the
C           second.
C      ***  Deactivated for now by asking LHGOAL to be below 0.
C                  Normally that would be below 1.
C
            IF( NSTALOW .GE. NSTA .AND. NSTAHIGH .GE. NSTA .AND. 
     1          LHGOAL .LE. 0 ) THEN
               LHGOAL = 2
               NSTALOW = 0
               NSTAHIGH = 0
               DO ISTA = 1, NSTA
                  IF( STALOW(ISTA) .GE. LHGOAL ) NSTALOW = NSTALOW + 1
                  IF( STAHIGH(ISTA) .GE. LHGOAL ) NSTAHIGH = NSTAHIGH+1
               END DO
            END IF


            SELECTED(TSRC(ISEG)) = LSCN
C
C           If requested, give feedback on the fit quality.
C
            IF( GEOPRT .GE. 1 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, 2I4, 1X, A )' ) 
     1          'Makeseg source:',
     2           ISEG, TSRC(ISEG), GEOSRC(TSRC(ISEG))
               IF( METHOD .EQ. 'FIT' ) THEN
                  WRITE( MSGTXT(33:256), '( A, I3, A, 20F5.1 )' ) 
     1               ' High:', HIGHSTA, '  Sigmas: ', 
     3                (SAVSIG(ISTA),ISTA=1,NPRT)
               END IF
               CALL WLOG( 0, MSGTXT )
            END IF
C
C           Save the identity of the worst station.
C
            LHIGHSTA = HIGHSTA
            LHIGHSIG = HIGHSIG
C
C           Reset DORAND to give a chance of filling out low and
C           high el scans.  We might have done a fit iteration because
C           some source couldn't be used because it was not up at a
C           station with too few scans so far.  Also use this opportunity
C           to force going to using psuedo fits for the last few scans
C           of the segment.
C
C           Reset MAXPRIO in case it had been adjusted when getting
C           the last source.
C
            IF( STOPJ(LSCN) .GT. STARTB + 
     1          0.7D0 * ( TGEOEND - STARTB ) ) THEN
               DORAND = .FALSE.
            ELSE
               DORAND = .TRUE.
            END IF
            MAXPRIO = 2
C
C           Go back for the next source.
C
            GO TO 100
C
         ELSE
            IF( GEOPRT .GE. 2 ) THEN
               CALL WLOG( 0, 'makeseg:  No source found that fits' )
               CALL WLOG( 0, '          Ending sequence.' )
            END IF
C
C           If no source was found, either it is too late, or there
C           are no more available sources.  If so, end the sequence.
C           For output, LSCN should be the last scan.
C
            ISEG = ISEG - 1
            NTSEG = ISEG
            LSCN = ISCN + NTSEG - 1 
         END IF
C
C     Now we are out of the GO TO loop and basically done.
C     There used to be some feed back here, but moved to GEOMAKE.
C     Indention above is for the GO TO 100 loop.
C
      RETURN
      END

      SUBROUTINE BBCDBBC( KS )
C
C
C     Routine for Sched called by SETBBC that assigns video converters
C     for Gino Tuccari's DBBC system, as used at Effelsberg.
C
C     There are two personalities for the DBBC. The difference is that the 
C     IF selection for the BBCs by unit number is somewhat more restricted.
C     The PFB personality is essentially the same as the RDBE, so just run
C     through the same code for that.  The DDC is quite different.
C
C     CR March, 2013: There are essentially 3 flavours (DBBCVER) of DBBC
C     with different IF->BBC mappings. They are described below as
C     'astro', 'geo' or 'hybrid'. Note that the astro flavour can have
C     either 2 or 4 IFs, but for now we assume 4 IFs are available. The
C     code below forms the masks for allowed IF->BBC mappings then
C     passes that to BBCALT in common with MkIV, etc.
C
C     Each IF also has 4 inputs, one of which we must select to get the
C     right signal out.
C
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER     KS, I
      INTEGER     MAXBBC, MAXIF
      PARAMETER   (MAXBBC=16)
      PARAMETER   (MAXIF=4)
      LOGICAL     UBBC(MAXBBC)
      CHARACTER   IFNAM(MAXIF)*2
      CHARACTER   WARNING*4, MYDBBCVER*8
      INTEGER     IFBBC(MAXBBC, MAXIF), MIF
      DATA        (IFNAM(I),I=1,MAXIF) / 'A', 'B', 'C', 'D' /
C Note that IFNAM is also defined in CHKDBBC (should match!)

C
C -------------------------------------------------------------------  
C     Software check:
C
      IF( DEBUG ) CALL WLOG( 1, 'BBCDBBC: Starting' )
C
      MYDBBCVER = DBBCVER(ISETSTA(KS))
C
C     Check against the maximum number of BBCs.
C
      IF( NBBC(ISETSTA(KS)) .GT. MAXBBC ) THEN
         WRITE( MSGTXT, '( 3A, I4 )' )
     1       'BBCDBBC: Number of VCs at ', SETSTA(1,KS), 
     2       ' Larger than maximum expected: ', MAXBBC
         CALL WLOG( 1, MSGTXT )
         CALL WLOG( 1, '   Catalog or programming problem ' )
         CALL ERRSET( KS )
      END IF
C
C     Which BBC can see which IF is dependent on the DBBC flavour. 
C     Put the (complicated) IF->BBC mapping in external routine so it
C     can be reused by chkdbbc.
C
      CALL IFDBBC( MYDBBCVER, MAXBBC, MAXIF, IFBBC, MIF )
C
      WARNING = 'DBBC'
C
C     Use the standard routine to set the BBC->IF mappings.
C
      CALL BBCALT( KS, MAXBBC, MIF, IFBBC, IFNAM, UBBC, MAXBBC,
     1          WARNING, 'BBCDBBC')
C
      RETURN 
      END

      SUBROUTINE UVOPT
C
C     Optimize the UV coverage.  Called from PLOTSTA when an 'O'
C     is typed while the cursor is on the stations plot.
C
C     The optimization proceedure is a simple try many combinations
C     of stations.  The quality measure is number of UV cells sampled.
C     A polar, logarithmic grid will be used.
C
C     This routine does the following steps
C
C         Determine how many stations (NOPT ) to try to optimize.  
C         This will be the count of stations with 
C         PSTBCK(ISTA,1) = 1 and PSTBCK(ISTA,2) = 1 (Red on the 
C         stations plot.).
C
C         Set up to try all combinations of NOPT of the stations 
C         that have PSTBCK(ISTA,2) = 1 (Red or yellow with red dot).
C
C         (From the above, you can see how to set up the optimization
C         by toggling all potential sites to red or yellow with red dot,
C         leaving only NOPT of them full red.)
C
C         Set up the grid.  Hardwired at first.  Later user input.
C
C         Cycle through the selected sources, calculating UV, assigning
C         to cells and incrementing cell counts.  Keep a separate
C         count per source, but also keep some weighted sum.
C
C         Keep a record of which combination had the highest count.
C
C         When done, set PSTBCK(ISTA,1) to 1 for the stations 
C         in the best array.  Set the others to 0.  Then on the
C         next command to do a UV plot, the optimized array will
C         be plotted.
C
      INCLUDE    'sched.inc'
      INCLUDE    'plot.inc'
C
      INTEGER    NOPT, NTRY, ISTA, NCOMB
      INTEGER    FLAG(MAXSTA), FLAGBEST(MAXSTA)
      INTEGER    CTR(MAXSTA), I, IC, COUNT, LEN1, ISRC
      REAL       QUALITY, MAXQUAL, TOP5(5,MAXSRC)
      LOGICAL    CARRY(MAXSTA), DONE
      CHARACTER  CHLAT*9, CHLONG*10, TFORM*15
      INTEGER    IOERR, VLBOPE
      LOGICAL    EXISTS
      CHARACTER  OPTFILE*80
      CHARACTER  OPSTAT*4, OPTEXT*256
C
C     Keep information about top arrays.
C
      INTEGER    MKEEP 
      PARAMETER  (MKEEP=200)
      CHARACTER  INFOLINE*128, KEEPLINE(MKEEP)*128
      INTEGER    KEEPNMIN, IK, PRTNMAX, NKEEP
      REAL       KEEPQUAL(MKEEP), KEEPQMIN, PRTQMAX
      LOGICAL    SENT(MKEEP)
C --------------------------------------------------------------------
C     Open the .opt print file.  Always write over 
C     whatever was there before.  Make a new one 
C     for each optimization effort.
C     
      WRITE( OPTFILE, '(A,A)' ) EXPCODE(1:LEN1(EXPCODE)), '.OPT'
      CALL DWCASE( OPTFILE )
      INQUIRE( FILE=OPTFILE, EXIST=EXISTS )
      IF( EXISTS ) THEN
         OPSTAT = 'OLD'
      ELSE
         OPSTAT = 'NEW'
      END IF
      CALL WLOG( 0, 'UVOPT:  Writing new configuration file '//
     1   OPTFILE(1:LEN1(OPTFILE)) )
      IOERR = VLBOPE( IOPT, OPTFILE, 'TEXT', OPSTAT, OPTEXT )
      IF( IOERR .NE. 1 ) CALL ERRLOG( ' Open problem:'//OPTEXT )
C
C     Write some information about the stations.  First the ones
C     to be helf fixed.
C
      WRITE( IOPT,*) 'UV optimization.'
      WRITE( IOPT, '( A, I4, A, I4 )' ) '   GRIDNR = ', GRIDNR, 
     1     '   GRIDNT = ', GRIDNT
      WRITE( IOPT, '( A, F10.2, A, F10.2 )' ) '   GRIDMIN = ', GRIDMIN, 
     1     '   GRIDMAX = ', GRIDMAX
      WRITE( IOPT, '( A, F10.2 )' ) '   GRIDW0 = ', GRIDW0
C
      WRITE( IOPT,*) 'Stations held fixed: '
      DO ISTA = 1, NSTA
         IF( PSTBCK(ISTA,1) .EQ. 1 .AND. PSTBCK(ISTA,2) .EQ. 0 ) THEN
            CHLAT = TFORM( LAT(STANUM(ISTA)), ' ', 1, 2, 2, ':: ' )
            CHLONG = TFORM( LONG(STANUM(ISTA)), ' ', 1, 3, 2, ':: ' )
            WRITE( IOPT, '( 2X, A, A8, 2X, 2A, 2X, 3A, F6.0, A )' )
     1          'station=', STANAME(ISTA), 'lat=', CHLAT, 
     2          'long=', CHLONG, '  elev=', ELEV(STANUM(ISTA)), ' /'
         END IF
      END DO
C
      WRITE( IOPT,*) ' '
      WRITE( IOPT,*) 'Stations to choose from: '
      DO ISTA = 1, NSTA
         IF( PSTBCK(ISTA,2) .EQ. 1 ) THEN
            CHLAT = TFORM( LAT(STANUM(ISTA)), ' ', 1, 2, 2, ':: ' )
            CHLONG = TFORM( LONG(STANUM(ISTA)), ' ', 1, 3, 2, ':: ' )
            WRITE( IOPT, '( 2X, A, A8, 2X, 2A, 2X, 3A, F6.0, A )' )
     1          'station=', STANAME(ISTA), 'lat=', CHLAT, 
     2          'long=', CHLONG, '  elev=', ELEV(STANUM(ISTA)), ' /'
         END IF
      END DO
C
      DO ISRC = 1, NSRC
         DO I = 1, 5
            TOP5(I,ISRC) = 0.0
         END DO
      END DO
C
C     Count the number of stations to optimize and the number of
C     alternatives from which to pick.  FLAG is used in the looping
C     to indicate which stations to try.
C
      NOPT = 0
      NTRY = 0
      DO ISTA = 1, NSTA
         IF( PSTBCK(ISTA,2) .EQ. 1 ) THEN
            NTRY = NTRY + 1
            IF( PSTBCK(ISTA,1) .EQ. 1 ) THEN
               NOPT = NOPT + 1
            END IF
         END IF
      END DO
      IF( NOPT .EQ. 0 ) THEN
         CALL WLOG( 1, 'UVOPT: No stations to optimize' )
         CLOSE( UNIT=IOPT )
         RETURN
      END IF
C
C     Count the number of configurations we will try.  Eventually
C     this can be used to give warnings or give limits.
C     This is  (NTRY!-NOPT!)/NOPT! = 
C          (NTRY/1)*((NTRY-1)/2)*((NTRY-3)/3)*....
C
      NCOMB = 1
      IF( NTRY .GT. NOPT ) THEN
         DO I = 1, NOPT
            NCOMB = NCOMB * ( NTRY + 1 - I ) / I
         END DO
      END IF
C
      MSGTXT = ' '
      WRITE( IOPT,*) ' '
      WRITE( MSGTXT, '( A, I10, A )' ) 
     1   'UVOPT: About to try ', NCOMB, ' different configurations'
      WRITE( IOPT, '(A)' ) MSGTXT(1:LEN1(MSGTXT) )
      CALL WLOG( 0, MSGTXT(1:LEN1(MSGTXT) ) )
      MSGTXT = ' '
      WRITE( MSGTXT, '( A, I3, A, I4 )' ) 
     1   '       picking ', NOPT, ' stations from a list of ', NTRY
      WRITE( IOPT, '(A)' ) MSGTXT(1:LEN1(MSGTXT) )
      CALL WLOG( 0, MSGTXT(1:LEN1(MSGTXT) ) )
      MSGTXT = ' '
C
C     Have NOPT numbers, which are the sequence among the NTRY
C     stations, for the stations to use for a combination.  For
C     example CTR(2)=5 means that the second station of the NOPT
C     being tried will be the fifth that has PSTBCK(ISTA,2)=1.
C     This seems a bit complicated, but I didn't see a cleaner
C     way to deal with it when NOPT is not known and I don't want
C     to put an upper limit on it.
C
      DO I = 1, NOPT
         CTR(I) = I
         CARRY(I) = .FALSE.
      END DO
      CTR(NOPT) = CTR(NOPT) - 1
C
C     Start the loop.  This is some fancy hoop jumping.
C
      DONE = .FALSE.
      MAXQUAL = 0.0
      KEEPNMIN = 1
      KEEPQMIN = 1.E10
      NKEEP = 0
      DO IK = 1, MKEEP
         KEEPQUAL(IK) = 0.0
      END DO
      DO IC = 1, NCOMB
         CARRY(NOPT) = .TRUE.
         DO I = NOPT, 2, -1
            IF( CARRY(I) ) CTR(I) = CTR(I) + 1
            CARRY(I-1) = CTR(I) .GT. NTRY - ( NOPT - I )
         END DO
         IF( CARRY(1) ) CTR(1) = CTR(1) + 1
         IF( CTR(1) .GT. NTRY + 1 - NOPT ) THEN
            DONE = .TRUE.
         ELSE
            DO I = 2, NOPT
               IF( CARRY(I-1) ) CTR(I) = CTR(I-1) + 1
            END DO
         END IF
C
C        Reset the flags.  0 means not involved. 1 is an 
C        unchanging station.  2 is a changing station, set
C        below.  Distinguishing allows the UV counter to only
C        recalculate the changing part.
C
         DO ISTA = 1, NSTA
            IF( PSTBCK(ISTA,1) .EQ. 1 .AND. PSTBCK(ISTA,2) .EQ. 0 ) THEN
               FLAG(ISTA) = 1
            ELSE
               FLAG(ISTA) = 0
            END IF
         END DO
C
C        Go through the FLAGS setting the right ones based
C        on CTR.
C
         DO I = 1, NOPT
            COUNT = 0
            DO ISTA = 1, NSTA
               IF( PSTBCK(ISTA,2) .EQ. 1 ) COUNT = COUNT + 1
               IF( CTR(I) .EQ. COUNT ) THEN
                  FLAG(ISTA) = 2
                  GO TO 100
               END IF
            END DO
  100       CONTINUE
         END DO
C
C        
         IF( MOD( IC, 10 ) .EQ. 1 ) THEN
            MSGTXT = ' ' 
            WRITE( MSGTXT, '( A, I7, A, I8, A, 10I3 )' ) 
     1         'UVOPT:  Sample configuration ', IC, ' of ', 
     2            NCOMB, ' Stations: ',
     3            ( CTR(I),I=1,NOPT )
            CALL WLOG( 0, MSGTXT(1:LEN1(MSGTXT)) )
            MSGTXT = ' ' 
         END IF
C
C        Get the quality measure for this array.
C
         CALL UVQUAL( IC, FLAG, QUALITY, TOP5, INFOLINE )
C
C        Keep track of best.  Do on best to initialize FLAGBEST.
C
         IF( QUALITY .GT. MAXQUAL .OR. IC .EQ. 1 ) THEN
            MAXQUAL = QUALITY
            DO ISTA = 1, NSTA
               FLAGBEST(ISTA) = FLAG(ISTA)
            END DO
         END IF
C
C        Keep the INFOLINE for the top MKEEP arrays for later printing
C          
         IF( NKEEP .LT. MKEEP .AND. QUALITY .GT. 0.0 ) THEN
            NKEEP = NKEEP + 1
            KEEPQUAL(IC) = QUALITY
            KEEPLINE(IC) = INFOLINE
            IF( KEEPQUAL(IK) .LT. KEEPQMIN ) THEN
               KEEPNMIN = IC
               KEEPQMIN = KEEPQUAL(IC)
            END IF
         ELSE IF( QUALITY .GT. KEEPQMIN ) THEN
            NKEEP = MKEEP
C
C           Replace the old minimum with this one.
C
            KEEPQUAL(KEEPNMIN) = QUALITY
            KEEPLINE(KEEPNMIN) = INFOLINE
C
C           Now find the new minimum for use next time.
C           
            KEEPQMIN = 1.E10
            DO IK = 1, MKEEP
               IF( KEEPQUAL(IK) .LT. KEEPQMIN ) THEN
                  KEEPNMIN = IK
                  KEEPQMIN = KEEPQUAL(IK)
               END IF
            END DO
         END IF
C         
      END DO
C
C     Set PSTBCK(ISTA,1)=1 for the best stations and =0 for
C     the rest.
C
      WRITE( IOPT, * ) ' '
      WRITE( IOPT, * ) 'The best array of this bunch: '
      DO ISTA = 1, NSTA
         IF( FLAGBEST(ISTA) .EQ. 0 ) THEN
            PSTBCK(ISTA,1) = 0
         ELSE IF( FLAGBEST(ISTA) .EQ. 1 ) THEN
            PSTBCK(ISTA,1) = 1
         ELSE IF( FLAGBEST(ISTA) .EQ. 2 ) THEN
            PSTBCK(ISTA,1) = 1
         END IF
         IF( FLAGBEST(ISTA) .GE. 1 ) THEN
            CHLAT = TFORM( LAT(STANUM(ISTA)), ' ', 1, 2, 2, ':: ' )
            CHLONG = TFORM( LONG(STANUM(ISTA)), ' ', 1, 3, 2, ':: ' )
            WRITE( IOPT, '( 2X, A, A8, 2X, 2A, 2X, 3A, F6.0, A, I2 )' )
     1          'station=', STANAME(ISTA), 'lat=', CHLAT, 
     2          'long=', CHLONG, '  elev=', ELEV(STANUM(ISTA)), 
     3          ' / ! ', FLAGBEST(ISTA)
         END IF
      END DO
C
      WRITE( IOPT, * ) ' '
      WRITE( IOPT, * ) 'The top 5 quality factors for each source:'
      DO ISRC = 1, NSRC
         IF( PSOBCK(ISRC) .EQ. 1 ) THEN
            WRITE( IOPT, '( A, 5F7.4 )' )
     1         SRCNAME(ISRC), ( TOP5(I,ISRC), I=1,5 )
         END IF
      END DO
      WRITE( IOPT, * ) ' '
      WRITE( IOPT, * ) 'The top 5 overall quality factors:'
      WRITE( IOPT, '( A, 5F7.4 )' )
     1   'Sum over sources ', ( TOP5(I,MAXSRC), I=1,5 )
C
      DO ISRC = 1, NSRC
         WRITE( IOPT, '( A, A, 2I6 )' )
     1     'Source: ', SRCNAME(ISRC), ISRC, 
     2     PSOBCK(ISRC)
      END DO
C
C     Write the information lines from the top arrays.
C     Sort by a very crude mechanism, but this will be very fast
C     compared to the rest of this routine's work.
C
      WRITE( IOPT, '( A )' ) ' '
      WRITE( IOPT, '( A, I6, A )' ) 'Top ', NKEEP, ' arrays. '
      WRITE( IOPT, '( A )' ) '  Numbers are a sequence number, '//
     1   'the overall quality, and the individual source qualities.'
C
      DO I = 1, NKEEP
         SENT(I) = .FALSE.
      END DO
      IF( NKEEP .EQ. 0 ) THEN
         WRITE( IOPT, '( A )' )
     1      '  There were no arrays with data on the grid. '
      ELSE
         DO I = 1, NKEEP
            PRTQMAX = 0.0
            PRTNMAX = 0
            DO IC = 1, NKEEP
               IF( KEEPQUAL(IC) .GT. PRTQMAX .AND. .NOT. SENT(IC) ) THEN
                  PRTNMAX = IC
                  PRTQMAX = KEEPQUAL(IC)
               END IF
            END DO
            IF( PRTNMAX .GE. 0 ) THEN
               WRITE( IOPT, '(I4, A, A)' ) I, ':', 
     1              KEEPLINE(PRTNMAX)(1:LEN1(KEEPLINE(PRTNMAX)) )
            END IF
            SENT(PRTNMAX) = .TRUE.
         END DO
      END IF
C
C     Close the print file so that the buffers will flush.
C
      CLOSE( UNIT=IOPT )
C
      RETURN
      END

      SUBROUTINE SETTRK( NCHAN, TAPEMODE, FORMAT, BITS, TRACK, MCHAN,
     1           KBBC, SIDEBAND, DBE, DAR, KS, TWOHEAD, DEBUG, ILOG )
Cf2py intent(out) TRACK
C
C     Routine for SCHED, called by SETDEFS, that sets the track 
C     assignments, if needed.  It will only be called if
C     TRACK(1,1,KS) is 0 which is the trigger to use this routine.
C
C     Note that SETDEF calls this routine with the element of the 
C     arrays in the call argument for a particular setup.  That means
C     that the number of indices will be one less than in the 
C     include files.  I don't think I'd do that if writing it again.
C
C
      INTEGER    MCHAN, KS, ILOG
      INTEGER    NCHAN, TAPEMODE, BITS, TRACK(MCHAN,8), KBBC(MCHAN)
      CHARACTER  FORMAT*8, SIDEBAND(MCHAN)*1, MSG*80
      CHARACTER  DAR*(*), DBE*(*)
      LOGICAL    TWOHEAD, DEBUG
C
      INTEGER    ICH, ICH1, IP, MAXCHN, CHPASS
      CHARACTER  TEXT*80
C
C     For Mark5B
C     Cannot use a call argument as a dimension in f77 on Sun (g77 
C     and gfortran didn't complain).  Set the dimension higher than
C     any likely channel setting, and check it later.
C
      INTEGER    MMCH
      PARAMETER  (MMCH=32)
      INTEGER    MK5BCH(MMCH), M5BBBC, IM5, ICHMK5B(MMCH)
C 
C     For LBA
      INTEGER    LBACH(MMCH), LBABBC, ILBA, ICHLBA(MMCH)
C
C     M5BCH is the sequence number of this SCHED channel in the
C     Mark5B channels, which go by BBC number with upper sidebands
C     first, then lower sidebands.
C
C     Specify the track patterns in DATA statements in order to
C     make it totally clear what is going on.  They could be
C     derived in algorithms, but they would then be harder to 
C     understand.  The DATA statements give the patterns for
C     the 32 track or 16 channel modes (the limits).  The 
C     multiple pass (TAPEMODE passes) modes are subsets and are 
C     treated as such.  For the MarkIII modes, extra channels
C     can be added and recorded in on the tracks that true
C     Mark III doesn't use.
C
C     The two tape modes on the VLBA specify the tracks of the
C     second drive by adding 64 to the track number that would
C     be used on the first drive.
C
C     The track number specified is the first of the group used
C     for that channel.  The channel uses contiguous even or 
C     odd channels (evens and odds are never mixed).
C
      INTEGER    A8(8), A4(16), A2(32), A1(32), AN(32)
      INTEGER    M3A(32), M3B1(16), M3B2(16)
      INTEGER    M3E1(8), M3E2(8), M3E3(8), M3E4(8)
C
      SAVE       A8, A4, A2, A1, M3A, M3B1, M3B2
      SAVE       M3E1, M3E2, M3E3, M3E4
C
C     8 track per channel:  (VLBA1:4, 2 bit)
C
      DATA A8 / 2, 18, 3, 19,  66, 82, 67, 83 /
C
C     4 track per channel:  (VLBA1:4, 1 bit), (VLBA1:2, 2 bit)
C
      DATA A4 /  2, 10, 18, 26,  3, 11, 19, 27,
     1          66, 74, 82, 90, 67, 75, 83, 91  /
C
C     2 track per channel: (VLBA1:2, 1 bit), (VLBA1:1, 2 bit)
C
      DATA A2 / 2, 6,10,14,18,22,26,30, 3, 7,11,15,19,23,27,31, 
     1         66,70,74,78,82,86,90,94,67,71,75,79,83,87,91,95 /
C                    
C     One track per channel: (VLBA1:1, 1 bit)
C     
      DATA A1 /2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,
     1          3,5,7,9,11,13,15,17,19,21,23,25,27,29,31,33/
C
C     Fan in - May never happen.
C
C
C
C     Mark III mode A: This is included for the VEX stations
C     that can actually do it.  As for all, the VLBA 36 track
C     numbering system is used.  With this track scheme, the
C     first 14 channels are the Mark III B equivalents (odd
C     video converters).  The next 14 are the extras, normally
C     4 VCs lower than the M3B frequecies and 3 VC's higher.
C     The final 4 heads are extras for a 32 track system.
C
      DATA M3A / 18, 4,20, 6,22, 8,24,10,26,12,28,14,30,16,
     1           19, 5,21, 7,23, 9,25,11,27,13,29,15,31,17,
     2           32,2,33,3 /
C
C     Mark III mode B: Use a pattern of net lower followed by 
C     net upper sideband.  IE, channels in ascending frequency
C     order.  Test by checking that the sidebands are 
C     alternating.  Mode C uses the same pattern, but with 
C     RCP/LCP pairs instead of LSB/USB pairs.
C
      DATA M3B1 /18, 4,20, 6,22, 8,24,10,26,12,28,14,30,16,32,2/
      DATA M3B2 /19, 5,21, 7,23, 9,25,11,27,13,29,15,31,17,33,3/
C
C     Mark III mode E:
C
      DATA M3E1 /  4,  6,  8, 10, 12, 14, 16,  2 /
      DATA M3E2 / 18, 20, 22, 24, 26, 28, 30, 32 /
      DATA M3E3 /  5,  7,  9, 11, 13, 15, 17,  3 /
      DATA M3E4 / 19, 21, 23, 25, 27, 29, 31, 33 /
C
C----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0,'SETTRK: Starting.  Format: ' // FORMAT )
C
C     Check for inappropriate MMCH parameter and for too many channels
C     in the requested data.
C
      IF( MCHAN .GT. MMCH ) THEN
         WRITE( TEXT, '( A, I4, A, I4 )' )
     1          'SETTRK: Programming problem: local PARAMETER MMCH=',
     2          MMCH, ' too small for MCHAN = ', MCHAN
         CALL WLOG( 1, TEXT )
         CALL ERRSET( KS )
      END IF
C  
      IF( NCHAN .GT. MCHAN ) THEN
         WRITE( TEXT, '( A, I4, A, I4 )' )
     1          'SETTRK: Too many channels:', NCHAN, '  Max:', MCHAN
         CALL WLOG( 1, TEXT )
         CALL ERRSET( KS )
      END IF
C
C     Step through the possible VLBA modes.
C
      IF( FORMAT(1:4) .EQ. 'VLBA' ) THEN
         IF( FORMAT .EQ. 'VLBA1:4' .AND. BITS .EQ. 2 ) THEN
            MAXCHN = 4
            IF( TWOHEAD ) MAXCHN = 8
            DO ICH = 1, MAXCHN
               AN(ICH) = A8(ICH)
            END DO
         ELSE IF( FORMAT .EQ. 'VLBA1:4' .AND. BITS .EQ. 1 .OR.
     1            FORMAT .EQ. 'VLBA1:2' .AND. BITS .EQ. 2 ) THEN
            MAXCHN = 8
            IF( TWOHEAD ) MAXCHN = 16
            DO ICH = 1, MAXCHN
               AN(ICH) = A4(ICH)
            END DO
         ELSE IF( FORMAT .EQ. 'VLBA1:2' .AND. BITS .EQ. 1 .OR.
     1            FORMAT .EQ. 'VLBA1:1' .AND. BITS .EQ. 2 ) THEN
            MAXCHN = 16
            IF( TWOHEAD ) MAXCHN = 32
            DO ICH = 1, MAXCHN
               AN(ICH) = A2(ICH)
            END DO
         ELSE IF( FORMAT .EQ. 'VLBA1:1' .AND. BITS .EQ. 1 ) THEN
            MAXCHN = 32  !  Will flag by station ability.
            DO ICH = 1, MAXCHN
               AN(ICH) = A1(ICH)
            END DO
         ELSE IF( FORMAT .EQ. 'VLBA2:1' .OR.
     1            FORMAT .EQ. 'VLBA4:1' ) THEN
            CALL WLOG( 1, 'SETTRK: Automatic track assignment not'//
     1             ' available for fan in modes yet.' )
            CALL ERRSET( KS )
         ELSE
            WRITE( TEXT, '( A, A, A, I3 )' ) 
     1          'SETTRK: Invalid VLBA FORMAT ', FORMAT, ' or bits ',
     2          BITS
            CALL WLOG( 1, TEXT )
            CALL ERRSET( KS )
         END IF
C
C        Now set TRACK based on appropriate subsets of the default
C        channels for VLBA cases.
C
         IF( TAPEMODE * NCHAN .GT. MAXCHN ) THEN
            WRITE( MSG, '( A, I3, A, I3, A, I3, A )' )
     1             'SETTRK: tpmode (', TAPEMODE, ') * nchan (', NCHAN,
     2             ') too large. Max: (', MAXCHN, ').'
            CALL WLOG( 1, MSG )
            CALL ERRSET( KS )
         END IF
         IF( TAPEMODE .GT. 0 ) THEN
            CHPASS = MAXCHN / TAPEMODE
         ELSE
            CALL WLOG( 1,
     1           'SETTRK: Programming error - TAPEMODE below 1' )
            CALL PRTSET( KS, ILOG )
            CALL ERRSET( KS )
         END IF
         DO IP = 1, TAPEMODE
            DO ICH = 1, NCHAN
               ICH1 = ( IP - 1 ) * CHPASS
               TRACK(ICH,IP) = AN(ICH1+ICH)
            END DO
         END DO
C
      ELSE IF( FORMAT(1:4) .EQ. 'MKIV' ) THEN
C
C        Do the same thing for Mark IV.  This is kept separate
C        in case it proves necessary eventually to use
C        different numbers.
C
         IF( FORMAT .EQ. 'MKIV1:4' .AND. BITS .EQ. 2 ) THEN
            MAXCHN = 4
            IF( TWOHEAD ) MAXCHN = 8
            DO ICH = 1, MAXCHN
               AN(ICH) = A8(ICH)
            END DO
         ELSE IF( FORMAT .EQ. 'MKIV1:4' .AND. BITS .EQ. 1 .OR.
     1            FORMAT .EQ. 'MKIV1:2' .AND. BITS .EQ. 2 ) THEN
            MAXCHN = 8
            IF( TWOHEAD ) MAXCHN = 16
            DO ICH = 1, MAXCHN
               AN(ICH) = A4(ICH)
            END DO
         ELSE IF( FORMAT .EQ. 'MKIV1:2' .AND. BITS .EQ. 1 .OR.
     1            FORMAT .EQ. 'MKIV1:1' .AND. BITS .EQ. 2 ) THEN
            MAXCHN = 16
            IF( TWOHEAD ) MAXCHN = 32
            DO ICH = 1, MAXCHN
               AN(ICH) = A2(ICH)
            END DO
         ELSE IF( FORMAT .EQ. 'MKIV1:1' .AND. BITS .EQ. 1 ) THEN
            MAXCHN = 32  !  Will flag by station ability later
            DO ICH = 1, MAXCHN
               AN(ICH) = A1(ICH)
            END DO
         ELSE IF( FORMAT .EQ. 'MKIV2:1' .OR.
     1            FORMAT .EQ. 'MKIV4:1' ) THEN
            CALL WLOG( 1, 'SETTRK: Automatic track assignment not'//
     1             ' available for fan in modes yet.' )
            CALL ERRSET( KS )
         ELSE
            WRITE( TEXT, '( A, A, A, I3 )' ) 
     1          'SETTRK: Invalid MKIV FORMAT ', FORMAT, ' or bits ',
     2          BITS
            CALL WLOG( 1, TEXT )
            CALL ERRSET( KS )
         END IF
C
C        Now set TRACK based on appropriate subsets of the default
C        channels for MKIV cases.
C
         IF( TAPEMODE * NCHAN .GT. MAXCHN ) THEN
            WRITE( MSG, '( A, I3, A, I3, A, I3, A )' )
     1             'SETTRK: tpmode (', TAPEMODE, ') * nchan (', NCHAN,
     2             ') too large. Max: (', MAXCHN, ').'
            CALL WLOG( 1, MSG )
            CALL ERRSET( KS )
         END IF
         IF( TAPEMODE .GT. 0 ) THEN
            CHPASS = MAXCHN / TAPEMODE
         ELSE
            CALL WLOG( 1,
     1           'SETTRK: Programming error - TAPEMODE below 1' )
            CALL PRTSET( KS, ILOG )
            CALL ERRSET( KS )
         END IF
         DO IP = 1, TAPEMODE
            DO ICH = 1, NCHAN
               ICH1 = ( IP - 1 ) * CHPASS
               TRACK(ICH,IP) = AN(ICH1+ICH)
            END DO
         END DO
C
      ELSE IF( FORMAT .EQ. 'MARK5B' ) THEN
C
         IF( DBE(1:4) .EQ. 'RDBE' .OR. DAR(1:4) .EQ. 'NONE' ) THEN
C
C           Deal with the NRAO RDBE which simply wants the tracks
C           numbered following the channel ordering.  Also use this
C           scheme for no, or unknown, formatters.
C
            IF( BITS .EQ. 2 ) THEN
               DO ICH = 1, NCHAN
                  TRACK(ICH,1) = 2*ICH
               END DO
            ELSE
               DO ICH = 1, NCHAN
                  TRACK(ICH,1) = ICH + 1
               END DO
            END IF

         ELSE
C
C           Full MARK5B systems.
C
C           The wiring is fixed between the BBC's and the "tracks".  
C           We need the channels in order of BBC number upper sideband
C           followed by BBC number, lower sideband.  I'll be crude and 
C           just loop through the channels finding the order.  MK5BCH
C           is the sequence number of this sched channel in the Mark5B
C           channels.  It is basically the index of the appropriate 
C           track assignment array to use.
C           IM5 Index for looping over the Mark5B channels
C           ICHM5B  SCHED channel of Mark5B channel
C           MK5BCH  Mark5B channel of SCHED channel
C      	 
            DO ICH = 1, NCHAN
               MK5BCH(ICH) = 0
               ICHMK5B(ICH) = 0
            END DO
            DO IM5 = 1, NCHAN
               M5BBBC = 100000
               DO ICH = 1, NCHAN
                  IF( SIDEBAND(ICH) .EQ. 'U' .AND. 
     1                KBBC(ICH) .LT. M5BBBC .AND. 
     2                MK5BCH(ICH) .EQ. 0 ) THEN
                     ICHMK5B(IM5) = ICH
                     M5BBBC = KBBC(ICH)
                  END IF
               END DO
C      	 
C              Process lower sidebands only when uppers are done.
C      	 
               IF( ICHMK5B(IM5) .EQ. 0 ) THEN
                  M5BBBC = 100000
                  DO ICH = 1, NCHAN
                     IF( SIDEBAND(ICH) .EQ. 'L' .AND. 
     1                   KBBC(ICH) .LT. M5BBBC .AND. 
     2                   MK5BCH(ICH) .EQ. 0 ) THEN
                        ICHMK5B(IM5) = ICH
                        M5BBBC = KBBC(ICH)
                     END IF
                  END DO
               END IF
               MK5BCH(ICHMK5B(IM5)) = IM5
            END DO
C      	 
C           Now assign the tracks
C      	 
            DO ICH = 1, NCHAN
               IF( BITS .EQ. 1 ) THEN
                  TRACK(ICH,1) = MK5BCH(ICH)
               ELSE IF ( BITS .EQ. 2 ) THEN
                  TRACK(ICH,1) = MK5BCH(ICH)*2
               END IF
            END DO
C
         END IF
C
      ELSE IF( FORMAT .EQ. 'LBA' ) THEN
C        Tracks (bitstreams) are simply ordered by BBC. Similar to
C        Mark5b but the two sidebands for a single BBC follow each
C        other. Note also that the dual sidebands from an LBA BBC can
C        both be USB. 2 bits is the only option.
         DO ICH = 1, NCHAN
            LBACH(ICH) = 0
         END DO
         DO ILBA = 1, NCHAN
            LBABBC = 100000
            DO ICH = 1, NCHAN
               IF( KBBC(ICH) .LT. LBABBC .AND. 
     1             LBACH(ICH) .EQ. 0 ) THEN
                  ICHLBA(ILBA) = ICH
                  LBABBC = KBBC(ICH)
               END IF
            END DO
            LBACH(ICHLBA(ILBA)) = ILBA
         END DO
         DO ICH = 1, NCHAN
C           First bitstream is 0
            TRACK(ICH,1) = LBACH(ICH)*2-2
         END DO
C
      ELSE IF( FORMAT .EQ. 'VDIF' ) THEN
C
C        Simply set the tracks for both bits to be the channel number.
C        (W. Brisken email May 14, 2012.  Change by RCW)
C
         DO ICH = 1, NCHAN
            TRACK(ICH,1) = ICH
         END DO
C
      ELSE IF( FORMAT .EQ. 'MARKIII' ) THEN
C
C        Now deal with Mark III.
C        Don't allow 2 bit data.
C
         IF( BITS .GT. 1 ) THEN
            CALL WLOG( 1, 'SETTRK: 2 bit Mark III - You''re kidding!' )
            CALL ERRSET( KS )
         END IF
C
         IF( TAPEMODE .EQ. 1 ) THEN
C
C           Test for the alternating sidebands.  Improve this some
C           day to allow for dual polarization.
C
            DO ICH = 1, NCHAN, 2
               IF( SIDEBAND(ICH) .EQ. SIDEBAND(ICH+1) ) THEN
                  CALL WLOG( 1, 'SETTRK: Auto track assignments are'//
     1              ' for alternating sidebands in MarkIII A mode. ' )
                  CALL ERRSET( KS )
               END IF
            END DO
C
C           Test number of channels.
C
            IF( NCHAN .GT. 32 ) THEN
               CALL WLOG( 1, ' SETTRK: Too many channels for Mark III'//
     1                 ' mode A. ' )
               CALL ERRSET( KS )
            END IF
C
C           Set channel assignments.
C
            DO ICH = 1, NCHAN
               TRACK(ICH,1) = M3A(ICH)
            END DO
         ELSE IF( TAPEMODE .EQ. 2 ) THEN
C
C           Test for the alternating sidebands.
C
            DO ICH = 1, NCHAN, 2
               IF( SIDEBAND(ICH) .EQ. SIDEBAND(ICH+1) ) THEN
                  CALL WLOG( 1, 'SETTRK: Auto track assignments are'//
     1              ' for alternating sidebands in MarkIII mode B. ' )
                  CALL WLOG( 1, '        This setup does not '//
     1              'alternate sidebands (is it Mode C?).' )
                  CALL ERRSET( KS )
               END IF
            END DO
C
C           Test number of channels.
C
            IF( NCHAN .GT. 16 ) THEN
               CALL WLOG( 1, ' SETTRK: Too many channels for Mark III'//
     1              ' mode B or C. ' )
               CALL ERRSET( KS )
            END IF
C
C           Set channel assignments.
C
            DO ICH = 1, NCHAN
               TRACK(ICH,1) = M3B1(ICH)
               TRACK(ICH,2) = M3B2(ICH)
            END DO
         ELSE IF( TAPEMODE .EQ. 4 ) THEN
C
C           Test number of channels.
C
            IF( NCHAN .GT. 8 ) THEN
               CALL WLOG( 1, ' SETTRK: Too many channels for Mark III'//
     1              ' mode E. ' )
               CALL ERRSET( KS )
            END IF
C
C           Set channel assignments.
C
            DO ICH = 1, NCHAN
               TRACK(ICH,1) = M3E1(ICH)
               TRACK(ICH,2) = M3E2(ICH)
               TRACK(ICH,3) = M3E3(ICH)
               TRACK(ICH,4) = M3E4(ICH)
            END DO
         END IF
C
      ELSE
         TEXT = FORMAT
         CALL WLOG( 1, 'SETTRK: Invalid FORMAT ' // TEXT(1:8) )
         CALL ERRSET( KS )
      END IF
C
      RETURN
      END

      SUBROUTINE WRTFREQ( ISCN, ISTA, FIRSTS, WRTSET )
C
C     Routine for SCHED, called by VLBASU, that writes the frequency
C     and bandwidth specifications, plus the pulse cal commands,
C     to the VLBA crd files that control the VLBA legacy system.
C
C     If the RDBE is in use and bandwidths greater than 16 MHz have
C     been requested, or if CRDDOP, CRDFREQ, or CRDBW has been 
C     specified, this routine will write channels somewhat different 
C     than the main schedule channels.  The main channels may have 
C     bandwidths too great for the legacy BBCs.  Also the main channels
C     may need to conform to RDBE (especially PFB) tuning restrictions
C     which make pointing on masers difficult.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
      INCLUDE  'schfreq.inc'
C
      INTEGER           ISCN, ISTA, KP, LKP, KF, LKF
      INTEGER           LEN1, NPC, ich
      INTEGER           CRDN, CRSETC(MAXCHN)
      DOUBLE PRECISION  LOSUM(MCHAN)
      DOUBLE PRECISION  BBCBW(MCHAN), BBCFREQ(MCHAN)
      DOUBLE PRECISION  CRDF(MCHAN), CRDB(MCHAN), CRDLOSUM(MCHAN)
      LOGICAL           FIRSTS, WRTSET
      CHARACTER         CRDS(MCHAN)*1
      CHARACTER         PCX1(MAXPC)*3, PCX2(MAXPC)*3
      INTEGER           PCFR1(MAXPC), PCFR2(MAXPC)
C
C     Keep track of last use.  
C
      INTEGER           MBBCBW, MBBCFREQ
      DOUBLE PRECISION  LBBCBW(MCHAN), LBBCFREQ(MCHAN)
      INTEGER           LPCALFR1(MAXPC), LPCALFR2(MAXPC)
      INTEGER           MPCALFR1, MPCALFR2, MPCALX1, MPCALX2
      CHARACTER         LPCALX1(MAXPC)*3, LPCALX2(MAXPC)*3
      CHARACTER         LPCAL*4, UPPCAL*4
C
C     Common for communication with FSVLBA (for frequency switching).
C
      COMMON  /CVLBA/   LBBCFREQ, MBBCFREQ
C
      SAVE    /CVLBA/, LKF, LKP, MBBCBW, LBBCBW, LPCAL
      SAVE    LPCALX1, LPCALX2, MPCALX1, MPCALX2
      SAVE    LPCALFR1, LPCALFR2, MPCALFR1, MPCALFR2
C----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'WRTFREQ starting ' )
C
C     Force writing bbsynth and bbfilter on first file specified.
C     Then will write whenever there are changes.
C
      IF( FIRSTS ) THEN
         MBBCFREQ = 0
         MBBCBW = 0
         LKF = 0
         LKP = 0
         LPCAL = ' '
      END IF
C
C     Get the frequency set.  We are no longer using pcal sets.
C
      KF = FSETI(ISCN,ISTA)
C
C     Get the frequency etc for this station/scan.  Save some work
C     if there hasn't been a change.  Write the results for any
C     changes.
C
C     Note that the use of CRDBW or CRDFREQ (directly or through 
C     CRDDOP) triggers a new frequency set, so testing for a new
C     set should pick up changes needed for those reasons in addition
C     to true setup file changes.
C
      IF( WRTSET .OR. KF .NE. LKF ) THEN
         LKF = KF
C
C        Get the frequencies.  For this routine, the values delivered
C        by FSFREQ in the CRD variables can be used in all cases.  Even
C        when CRDFREQ or CRDDOP are not used, FSFREQ transfers the correct
C        values to the CRD numbers.
C
         CALL FSFREQ( KF, LOSUM, BBCFREQ, BBCBW,
     1         CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC )
C
C        Write the frequency and bandwidth.
C        FSFREQ takes care of restricting the data to the proper
C        setup channels when the number of crd channels does not
C        match the number of RDBE channels.
C
         CALL VLBAREAL( 'bbsynth', 7, CRDN, CRDF, LBBCFREQ,
     1         MBBCFREQ, '(F6.2)', 6, FIRSTS, IUVBA )
         CALL VLBABWS( 'bbfilter', 8, CRDN, CRDB, LBBCBW,
     1         MBBCBW, FIRSTS, IUVBA )
C
C
C        Get the pulse cal detector settings.
C
C        Note that, with Vex, it seems that only a numerical index 
C        of which tone in the band to detect is specified.  Treat
C        that separately from the legacy VLBA system.  PCALFQ
C        deals with the details of calculating the detection data.
C
         CALL PCALFQ( FSPCAL(KF), KF, PCX1, PCX2, PCFR1, PCFR2 )
C
C        First, specify the setting for the generators.
C        The old files had an all upper case version of pcal, do duplicate
C        that.  I'm not sure that is needed.
C        
         UPPCAL = FSPCAL(KF)
         CALL UPCASE( UPPCAL )
         IF( FSPCAL(KF) .NE. LPCAL) 
     1      WRITE( IUVBA, '( A, A )' ) 'pcal=', 
     2             UPPCAL(1:LEN1(UPPCAL))
         LPCAL = FSPCAL(KF)
C
C        Now write the pcalx commands based on the returns from PCALFQ.
C        These should be the normal defaults when MARK5A recordings are
C        being made.
C
         NPC = MAXPC
         CALL VLBACHAR( 'pcalxbit1', 9, NPC, 
     1          PCX1, LPCALX1, MPCALX1, FIRSTS, IUVBA )
         CALL VLBACHAR( 'pcalxbit2', 9, NPC, 
     1          PCX2, LPCALX2, MPCALX2, FIRSTS, IUVBA )
         CALL VLBAINT( 'pcalxfreq1', 10, NPC, 
     1          PCFR1, LPCALFR1, MPCALFR1, FIRSTS, IUVBA )
         CALL VLBAINT( 'pcalxfreq2', 10, NPC, 
     1          PCFR2, LPCALFR2, MPCALFR2, FIRSTS, IUVBA )
C
      END IF
      LKP = KP         
C
C
      IF( DEBUG ) CALL WLOG( 1, 'WRTFREQ Ending ' )
      RETURN
      END

      SUBROUTINE CHKSET( KS )
C
C     Routine to check the validity of inputs from the SETUP file.  
C     This is called for setup group KS
C
C     Remove checks of tape recorders.  July 22, 2010  RCW.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
      INCLUDE  'schfreq.inc'
C
      INTEGER           KS, ICH, JCH, ISTA
      INTEGER           LEN1, LNAME, ITOUT
      LOGICAL           ERRS, SAMPWARN, OVERWARN, WARN2CM
      DOUBLE PRECISION  BBWIDI, BBWIDJ
      DOUBLE PRECISION  FLOWI, FLOWJ, FHIGHI, FHIGHJ
      SAVE              ITOUT, WARN2CM
      DATA              ITOUT / 1 /
      DATA              WARN2CM / .TRUE. /
C ----------------------------------------------------------------------
C     Get the schedule station number
C
      ISTA = ISCHSTA(ISETSTA(KS))
C
C     Debug help.
C
      IF( DEBUG ) THEN
         CALL WLOG( 0, 'CHKSET: Starting on '//SETSTA(1,KS)//
     1                   ' in:' )
         CALL WLOG( 0, '        ' //  SETNAME(KS) )
      END IF
C
C     Initializations.
C
      ERRS = .FALSE.
      LNAME = LEN1( SETNAME(KS) )
      SAMPWARN = .TRUE.
C
C     Warn if OBSTYP requests no recording while format suggests otherwise.
C     This might be legitimate for certain tests, so don't crash.
C
      IF( NOTAPE .AND. FORMAT(KS) .NE. 'NONE' ) THEN
         WRITE( MSGTXT, '( 4A )' ) 
     1       'CHKSET: *** WARNING - OBSTYPE=', OBSTYP,
     2       ' but setup has FORMAT=', FORMAT(KS)
         CALL WLOG( ITOUT, MSGTXT )
         MSGTXT = ' '
         WRITE( MSGTXT, '( A )' )
     1       '        No tapes will be recorded with this OBSTYPE.'
         CALL WLOG( ITOUT, MSGTXT )
         MSGTXT = ' '
         IF( OBSTYP .EQ. 'NONE' ) THEN
            CALL WLOG( ITOUT, 
     1       '        NONE is the default OBSTYPE.  ' //
     2       'Did you forget to specify it?' )
         ELSE
            WRITE( MSGTXT, '( A )' )
     1       '        Was this intended?'
            CALL WLOG( ITOUT, MSGTXT )
         END IF
         MSGTXT = ' '
         ITOUT = 0
      END IF
C
C     Don't check VLBI related parameters if this is VLA only.
C     Many of the parameters that are specific to certain types
C     of observatories will be checked in other routines like
C     CHKVLBA and CHKVLA.
C
      IF( .NOT. VLAONLY ) THEN
C
C        Check the Mark 2 format.
C
         IF( MARK2 .AND. FORMAT(KS) .NE. 'MARKII' ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A )' )
     1       'CHKSET: For OBSTYP=MKII, FORMAT must be MARKII, not: ',
     2        FORMAT(KS)
            CALL WLOG( 1, MSGTXT )
            ERRS = .TRUE.
         END IF
C
C        Prohibit frequency switching if VEX or VSOP (DRUDG) 
C        files are to be written.
C
         IF( ( DOVEX .OR. DOVSOP ).AND. FRSWITCH(KS) ) THEN
            CALL WLOG( 1, 'CHKSET:  Cannot frequency switch with VEX '//
     1          'or VSOP file.' )
            ERRS = .TRUE.
         END IF
C
C        Check generic parameters related to channels and DAR.
C
C        Be sure there are some channels.  Die immediately if not
C        to prevent DO loop over bad range.
C
         IF( NCHAN(KS) .LT. 1 ) THEN
            CALL WLOG( 1, 'CHKSET: Setup file must have at least 1 '
     1             // 'channel unless OBSTYPE=VLA.' )
            CALL ERRLOG( 'CHKSET: The error is in ' // 
     1                SETNAME(KS)(1:LNAME) )
         END IF
C
C        Now check the channels.
C
         OVERWARN = .FALSE.
         DO ICH = 1, NCHAN(KS)
C
C           Sideband.
C
            IF( SIDEBD(ICH,KS) .NE. 'U' .AND. 
     1          SIDEBD(ICH,KS) .NE. 'L' ) THEN
               CALL WLOG( 1, 'CHKSET: Sideband not U or L in ' // 
     1                       SETNAME(KS)(1:LNAME) )
               ERRS = .TRUE.
            END IF
C
C           Polarization.
C
            IF( POL(ICH,KS)(1:3) .NE. 'RCP' .AND.
     1          POL(ICH,KS)(1:3) .NE. 'LCP' .AND.
     2          POL(ICH,KS)(1:1) .NE. 'X' .AND.
     3          POL(ICH,KS)(1:1) .NE. 'Y' ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( 3A, I4, A )' )
     1            'CHKSET: In setup ', SETNAME(KS)(1:LEN1(SETNAME(KS))),
     2            ' polarization of chan ', ICH,
     3            ' not given or deduced (should be RCP, LCP, X or Y).'
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
C
C           Check to see if two polarizations are expected from the
C           same IF (I seen users do that one and the warning about
C           not all bandwidth being in the IF is not too clear.
C
            IF( ICH .GE. 2 .AND. ICH .LT. NCHAN(KS) ) THEN
               DO JCH = ICH, NCHAN(KS)
                  IF( POL(ICH,KS) .NE. POL(JCH,KS) .AND. 
     1                IFCHAN(ICH,KS) .EQ. IFCHAN(JCH,KS) ) THEN
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( 7A, I3, 3A, I3, A )' )
     1                  'CHKSET:  In setup ', SETNAME(KS)(1:LNAME),
     2                  ' IF channel ', IFCHAN(ICH,KS), 
     3                  ' is assigned to ', POL(ICH,KS), ' in chan ',
     4                  ICH, ' and to ', POL(JCH,KS), ' in chan ',
     5                  JCH, '  Not possible.'
                     CALL WLOG( 1, MSGTXT )
                     ERRS = .TRUE.
                  END IF
               END DO
            END IF
C
C           Be sure bandwidth is not more than half the sample rate.
C
            IF( VLBITP ) THEN
               IF( BBFILT(ICH,KS) .GT. 0.5001D0 * SAMPRATE(KS) ) THEN
                  CALL WLOG( 1, 'CHKSET: Bandwidth more than half of '//
     1              'sample rate' )
                  ERRS = .TRUE.
               END IF
               IF( BBFILT(ICH,KS) .LT. 0.4999D0 * SAMPRATE(KS) .AND. 
     1             SAMPWARN ) THEN
                  CALL WLOG( 0, 
     1                    'CHKSET note: Oversampling specified. ' )
                  SAMPWARN = .FALSE. 
               END IF
C
            END IF
C
C           Warn of overlapping channels.  Don't worry about overlaps
C           due to the round down to the nearest 10 kHz when the
C           62.5 and 125 kHz channels are used.
C
            IF( ICH .GT. 1 ) THEN
C
C              Get frequency range of channel ICH.
C
               BBWIDI = AINT( BBFILT(ICH,KS) / 10.0D0 ) * 10.0D0
               IF( NETSIDE(ICH,KS) .EQ. 'L' ) THEN
                  FLOWI  = FREQREF(ICH,KS) - BBWIDI
                  FHIGHI = FREQREF(ICH,KS)
               ELSE
                  FLOWI  = FREQREF(ICH,KS)
                  FHIGHI = FREQREF(ICH,KS) + BBWIDI
               END IF
C
C              Now compare with other lower numbered channels.
C
               DO JCH = 1, ICH - 1
C
C                 Require polarization match.
C
                  IF( POL(ICH,KS) .EQ. POL(JCH,KS) ) THEN
C
C                    Get frequency range of other channel.
C
                     BBWIDJ = AINT( BBFILT(JCH,KS) / 10.0 ) * 10.0 
                     IF( NETSIDE(JCH,KS) .EQ. 'L' ) THEN
                        FLOWJ  = FREQREF(JCH,KS) - BBWIDJ
                        FHIGHJ = FREQREF(JCH,KS)
                     ELSE
                        FLOWJ  = FREQREF(JCH,KS)
                        FHIGHJ = FREQREF(JCH,KS) + BBWIDJ
                     END IF
C
C                    Look for overlap.
C
                     IF( ( FLOWI.GE.FLOWJ .AND. FLOWI.LT.FHIGHJ ) .OR.
     1                   ( FHIGHI.GT.FLOWJ .AND. FHIGHI.LE.FHIGHJ ) ) 
     2                    THEN
                        OVERWARN = .TRUE.
                     END IF
C
                  END IF
               END DO
            END IF
C
         END DO
C
C        Write the overlapping channel warning.
C
         IF( OVERWARN ) THEN
            CALL WLOG( 1, 'CHKSET: Setup file: ' // 
     1         SETNAME(KS)(1:LEN1(SETNAME(KS))) //
     2         ' Has overlapping channels.  Intended?' )
         END IF
C
C        Check many items specific to certain DARs.
C        Note that the "geodetic" VLBA systems need some extra checks
C        beyond what the normal VLBA systems get thanks to incomplete
C        wiring.
C
         IF( DAR(ISETSTA(KS))(1:4) .EQ. 'RDBE' )  
     1         CALL CHKRDBE( KS, ERRS )
         IF( DAR(ISETSTA(KS))(1:4) .EQ. 'DBBC' )  
     1         CALL CHKDBBC( KS, ERRS )
         IF( DAR(ISETSTA(KS)) .EQ. 'WIDAR' ) 
     1         CALL CHKWIDAR( KS, ERRS )
         IF( DAR(ISETSTA(KS)) .EQ. 'VLBA'  .OR. 
     1       DAR(ISETSTA(KS)) .EQ. 'VLBAG' .OR.
     2       DAR(ISETSTA(KS)) .EQ. 'VLBA4' )  
     3         CALL CHKVDAR( KS, NBBC(ISETSTA(KS)), ERRS )
         IF( DAR(ISETSTA(KS)) .EQ. 'VLBA4' ) 
     1         CALL CHKV4DAR( KS, ERRS )
         IF( DAR(ISETSTA(KS)) .EQ. 'VLBAG' ) 
     1         CALL CHKGDAR( KS, ERRS )
         IF( DAR(ISETSTA(KS)) .EQ. 'MKIV'  ) 
     1         CALL CHK4DAR( KS, NBBC(ISETSTA(KS)), ERRS )
         IF( DAR(ISETSTA(KS)) .EQ. 'CDAS'  ) 
     1         CALL CHKCDAS( KS, ERRS )

C
C        Check various recorder related parameters.  Stripped of 
C        tape stuff July 22, 2010.  RCW
C
         IF( VLBITP ) THEN
C
C           Some disk items.
C
            IF( USEDISK(ISTA) ) THEN
               CALL CHKDISK( KS, ERRS )
            END IF
C
C           Check the bit rate per track and the tape speeds.    
C
            IF( ( RECORDER(ISETSTA(KS)) .EQ. 'VLBA' .OR. 
     1            RECORDER(ISETSTA(KS)) .EQ. 'MKIV' .OR.
     1            RECORDER(ISETSTA(KS)) .EQ. 'VLBA4' ) .AND.
     2            FORMAT(KS) .NE. 'NONE' ) THEN
               CALL CHKSPD( KS, ERRS )
            END IF
C
C           Force all channels to use the same number of bits.
C           note that this is not really required by the system,
C           but the correlator might have a fit with mixed mode data.
C
            DO ICH = 1, NCHAN(KS)
               IF( BITS(ICH,KS) .NE. BITS(1,KS) ) THEN
                  CALL WLOG( 1, 'CHKSET: All channels must use the same'
     1               // ' number of bits. ' )
                  ERRS = .TRUE.
               END IF
            END DO
C
C           Pulse cal specification SPCAL was set to right case 
C           and checked in RDSET.
C
         END IF
C
      END IF   ! not VLAONLY
C
C     Warn 2cm users about different standard frequencies.
C     Only worry about the VLBA and the narrower band systems.
C
      IF( WARN2CM .AND.
     1    FREQREF(1,KS) .GT. 15100.D0 .AND. 
     2    FREQREF(1,KS) .LT. 15500.D0 .AND. 
     3    SETSTA(1,KS)(1:4) .EQ. 'VLBA' .AND.
     4    TOTBPS(KS) .LT. 1000.0 ) THEN
         MSGTXT = 'CHKSET:  See sched.runlog for information' //
     1        ' on 2cm frequencies.'
         CALL WLOG( 1, ' ' )
         CALL WLOG( 1, MSGTXT )
         MSGTXT = ' '
         CALL WRTMSG( 0, 'CHKSET', 'warn2cm' )
         WARN2CM = .FALSE.
      END IF

C
C     Check some more VLBA specific parameters.
C
      IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) 
     1     CALL CHKVLBA( KS, ERRS )
C
C     Check the VLA parameters.
C
      IF( SETSTA(1,KS)(1:3) .EQ. 'VLA' ) 
     1     CALL CHKVLA( KS, ERRS )
C
C     Abort if problems were found.
C
      IF( ERRS ) THEN
         CALL WLOG( 1, 'CHKSET:  Freq groups used or checked: ' )
         DO ICH = 1, NCHAN(KS)
            IF( IFREQNUM(ICH,KS) .GT. 0 ) THEN
               WRITE( MSGTXT, '( A, I3, 2X, A, A )' ) ' Channel: ', 
     1             ICH, '  Frequency Group: ', 
     2              FRNAME(IFREQNUM(ICH,KS))
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
            END IF
         END DO
         CALL ERRSET( KS )
      END IF
C
      RETURN
      END

      SUBROUTINE SRCFLG( GOTALL )
Cf2py intent(out) GOTALL
C
C     Routine for SCHED called by SRREAD and SRFINISH that compares 
C     catalog entries with sources requested in the schedule and sets
C     the appropriate pointers.  It is called again later by SCHOPT
C     after the optimization routines are run and after pointing 
C     sources are added.
C
C     It marks which alias is used.  Marking whether or not the source
C     was used (SUSED) is handled elsewhere.
C
C     It also checks whether all sources have been found.
C     MSRC is assumed to be greater than 0 on the call.
C
C     This routine is called more than once with source lists that 
C     may have changed and/or grown.  Therefore it resets everything
C     from scratch.
C
      INCLUDE  'sched.inc'
C
      INTEGER        KSRC, ISRC, INAME
      LOGICAL        GOTALL
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SRCFLG starting' )
C
C     Initialize the pointers and flags.
C
      DO ISRC = 1, MSRC
         SRLSTN(ISRC) = 0
         DO INAME = 1, MALIAS
            CSUSED(INAME,ISRC) = ' '
         END DO
      END DO
      DO KSRC = 1, NSRC
         SRCATN(KSRC) = 0 
      END DO
C
C     Loop over sources in schedule.  
C
      DO KSRC = 1, NSRC
C
C        Loop over catalog sources we have at this point and loop
C        over the aliases.
C
         DO ISRC = 1, MSRC
            DO INAME = 1, MALIAS
C 
C              Check for match between schedule and catalog sources.
C 
               IF( SRCNAME(KSRC) .EQ. SOURCE(INAME,ISRC) ) THEN
C
C                 Get used flags and pointer to schedule source for
C                 the catalog source.
C
                  CSUSED(INAME,ISRC) = '*'
                  SRLSTN(ISRC) = KSRC
C
C                 Get the pointer to the catalog source for the 
C                 schedule source.
C
                  SRCATN(KSRC) = ISRC
C
                  GO TO 100
               END IF
            END DO
         END DO
  100    CONTINUE
      END DO
C
C     Check if have all schedule sources in the catalog.  Don't complain
C     yet because we may have a planet or satellite and that will
C     be checked separately.
C
      GOTALL = .TRUE.
      DO KSRC = 1, NSRC
         IF( SRCATN(KSRC) .EQ. 0 ) THEN
            GOTALL = .FALSE.
         END IF
      END DO
C
      RETURN
      END

C++++++++++++++++++++++++
C
      SUBROUTINE FSIZER2(NRECL,KSIZE,NRFILE)
C
C++++++++++++++++++++++++
C  THIS SUBROUTINE OPENS THE FILE, 'NAMFIL', WITH A PHONY RECORD LENGTH, READS 
C  THE FIRST RECORD, AND USES THE INFO TO COMPUTE KSIZE, THE NUMBER OF SINGLE 
C  PRECISION WORDS IN A RECORD.  
C
C  THE SUBROUTINE ALSO SETS THE VALUES OF  NRECL, AND NRFILE.

C     IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      SAVE

      CHARACTER*6 TTL(14,3),CNAM(400)
      CHARACTER*80 NAMFIL
      COMMON/FNAME/NAMFIL

      DOUBLE PRECISION SS(3), AU, EMRAT

      INTEGER IPT(3,13), NRECL, NRFILE, KSIZE, MRECL, NCON, J, I, 
     *        NUMDE, KMX, KHI, ND

      NRECL=4
      NRFILE=12

C  *****************************************************************
C  *****************************************************************

C  **  OPEN THE DIRECT-ACCESS FILE AND GET THE POINTERS IN ORDER TO 
C  **  DETERMINE THE SIZE OF THE EPHEMERIS RECORD

      MRECL=NRECL*1000

        OPEN(NRFILE,
     *       FILE=NAMFIL,
     *       ACCESS='DIRECT',
     *       FORM='UNFORMATTED',
     *       RECL=MRECL,
     *       STATUS='OLD')

      READ(NRFILE,REC=1)TTL,CNAM,SS,NCON,AU,EMRAT,
     * ((IPT(I,J),I=1,3),J=1,12),NUMDE,(IPT(I,13),I=1,3)

      CLOSE(NRFILE)

C  FIND THE NUMBER OF EPHEMERIS COEFFICIENTS FROM THE POINTERS

      KMX = 0
      KHI = 0

      DO I = 1,13
         IF (IPT(1,I) .GT. KMX) THEN
            KMX = IPT(1,I)
            KHI = I
         ENDIF
      ENDDO

      ND = 3
      IF (KHI .EQ. 12) ND=2

      KSIZE = 2*(IPT(1,KHI)+ND*IPT(2,KHI)*IPT(3,KHI)-1)

      RETURN

      END

      SUBROUTINE SRLPRE( PRECDATE, OBSTIME )
C
C     Routine for SCHED that precesses all sources in the full
C     catalog source list.  That list is only used for plotting
C     as of when this routine was written.  It is kept in 
C     low precision to save space for what could be a large list.
C
      INCLUDE         'srlist.inc'
C
      INTEGER            I
      DOUBLE PRECISION   RA8, DEC8, RAJ, DECJ, PRECDATE, OBSTIME
C ----------------------------------------------------------------------
      DO I = 1, SRLN
         IF( SRLEPO(I) .NE. 'J' ) THEN
            RA8 = SRLRA(I)
            DEC8 = SRLDEC(I)
            IF( SRLEPO(I) .EQ.' B' ) THEN
               CALL SLA_FK45Z( RA8, DEC8, PRECDATE, RAJ, DECJ )
            ELSE
               CALL SLA_AMP( RA8, DEC8, OBSTIME, 2000.D0, RAJ, DECJ )
            END IF            
            SRLRA(I) = RAJ
            SRLDEC(I) = DECJ
            SRLEPO(I) = 'J'
         END IF
C
      END DO
C
      RETURN
      END

      SUBROUTINE VXRL8(HEAD)
      IMPLICIT NONE
C
C     Routine specific for the VEX extension of SCHED. 
C     Writes the Roll table for 8 track roll
C     By Huib Jan van Langevelde, JIVE 011200
C     Uses the revised, reverse roll
C
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
      
      INTEGER HEAD

      INTEGER NGROUP, IGROUP, ITRACK, I, J
      INTEGER ROLLTO, MINTRK
      INTEGER LEN1
      CHARACTER LINE*132, DEL*1
      
      LINE = ' '
      NGROUP = 32/8
C
C     loop groups, 4 for 8 roll
C
      DO IGROUP = 1, NGROUP
C
C     maximal track number in a group, cf home track below
C
         IF( IGROUP .LE. NGROUP/2 ) THEN
C
C        do even numbers
C
            MINTRK = (IGROUP-1)*2*32/NGROUP + 2
         ELSE
            MINTRK = (IGROUP-1-NGROUP/2)*2*32/NGROUP+2
         ENDIF
C
C     write the columns
C
         DO I = 1, 32/NGROUP
C
C        home track is still simple
C
            IF( IGROUP .LE. NGROUP/2 ) THEN  
C
C           do even numbers
C
               ITRACK = (IGROUP-1)*2*32/NGROUP + I*2
            ELSE
               ITRACK = (IGROUP-1-NGROUP/2)*2*32/NGROUP + I*2 + 1
            ENDIF
            WRITE( LINE(1:24), '( 5X, A, I1, 1X, A1, 1X, I2, 1X, A1 )' ) 
     1          'roll_def = ',HEAD, COL, ITRACK, COL
C        
C        let's roll, but be carfull out there!
C
            DO J = 1, 8
               DEL = COL
               IF( J .EQ. 8 ) DEL = SEP
C           
C           simple formula to determine out track:
C           
               ROLLTO = ITRACK-2*(J-1)
               IF( ROLLTO .LT. MINTRK)  ROLLTO=ROLLTO+2*32/NGROUP
               WRITE( LINE(25+(J-1)*3:24+J*3), '( I2, A1 )' )
     1             ROLLTO, DEL
            END DO
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
         WRITE( IVEX, '( A1 )' ) COM
      END DO
      
      RETURN
      END

      INTEGER FUNCTION GNSET( ISCN, ISTA )
C
C     Function to select the required setup group index  for the 
C     specified current scan and station.  It is used in SETEXPND 
C     to set the variable NSETUP(ISCN,ISTA) which is where most 
C     routines get the setup.  It is also used in MAKEPTG in the 
C     process of making pointing scans.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER    ISCN, ISTA, KS, ISETF, LEN1, LSTA, LKS, LNAME, LN1
      LOGICAL    GOTVLA, GOTSET
      CHARACTER  LSETFILE*80
      SAVE       LSETFILE, LKS, LSTA
      DATA       LSETFILE, LKS, LSTA  / ' ', 0, 0 /
C -------------------------------------------------------------
C     Get the setup file number for this scan.
C
      ISETF = SETNUM(ISCN)
C
C     First see if the main loop can be shortcircuited because
C     there is no change or because the station is not in the scan.
C
      IF( .NOT. STASCN(ISCN,ISTA) ) THEN
         GNSET = MAX( LKS, 1 )
      ELSE IF( SETFILE(ISETF) .EQ. LSETFILE .AND.
     1         ISTA .EQ. LSTA ) THEN
         GNSET = LKS
C
C     Loop through the setup groups looking for right one.  Do a 
C     check that the setup file was found at all.
C
      ELSE
         GNSET = 0
         GOTVLA = .FALSE.
         GOTSET = .FALSE.
         DO KS = 1, NSET
       
            IF( SETFILE(ISETF) .EQ. SETNAME(KS) ) THEN
               GOTSET = .TRUE.
               IF( STANAME(ISTA) .EQ. SETSTA(1,KS) ) THEN
                  GNSET = KS
                  GO TO 100
               END IF
C
C              For warnings later, remember if there were any VLA
C              stations in the setup.  This only needed if the setup
C              is not found so can come after the above GOTO.
C
               IF( SETSTA(1,KS)(1:3) .EQ. 'VLA' ) GOTVLA = .TRUE.
C
            END IF
C
         END DO
C
C        Warn of possible programming error.
C
         IF( .NOT. GOTSET ) THEN
            WRITE( MSGTXT, '( A, A, A )' ) 
     1         'GNSET: Setup file not in list of files - ',
     2         'programming problem.'
            CALL WLOG( 1, MSGTXT )
            LNAME = LEN1( SETFILE(ISETF) )
            CALL WLOG( 1, 'File: ' // SETFILE(ISETF)(1:LNAME) )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I5, A, A )' )
     1            'Scan:', ISCN, '  Station: ', STANAME(ISTA)
            CALL WLOG( 1, MSGTXT )
            CALL ERRLOG( 'GNSET: Report the problem.' )

         END IF
C
  100    CONTINUE
C
C        If still don't have something, die.  Comment out the special 
C        warning if the problem was at the VLA as I am trying to make
C        the various VLA names equivalent.
C
         IF( GNSET .EQ. 0 ) THEN
C            IF( STANAME(ISTA) .EQ. 'VLA' .AND. GOTVLA ) THEN
C               CALL WLOG( 1, ' ' )
C               CALL WLOG( 1, 'GNSET: For VLBI observations at the '//
C     1             'VLA, use VLA1 or VLA27 in the schedule.' )
C            END IF
            LN1 = 1
            LNAME = LEN1( SETFILE(ISETF) )
            IF( LNAME .GT. 45 ) LN1 = LNAME - 45
            WRITE( MSGTXT, '( 4A )' ) ' GNSET: No setup for ', 
     1             STANAME(ISTA), ' in ', 
     2             SETFILE(ISETF)(LN1:LNAME)
            CALL ERRLOG( MSGTXT )
         END IF
C
      END IF   ! Need new value.
C
C     Keep results.  Don't keep one from a scan that does not include
C     the station.
C
      IF( STASCN(ISCN,ISTA) ) THEN
         LSETFILE = SETFILE(ISETF)
         LSTA = ISTA
         LKS = GNSET
      END IF
C
      RETURN
      END

      SUBROUTINE OPTCSPT( ISCN1, ISCN2, NSTA, POINTS, ARPTS, SCNSTA, 
     1                LSRC, MAXISC, MAXSTA, MINANT1, MINANT2,
     2                SCN1, SCN2, NS1, NS2, NS3 )
C
C     Routine for SCHED subroutine OPTCSUB that calculates the
C     quality factor for each subarray combination (ARPTS) given the
C     quality factor for each source/antenna combination (POINTS)
C
C     This is in a subroutine so that it can be repeated easily.
C
C     It is called with two input sources (scans) specified by
C     ISCN1 and ISCN2.  For each antenna, it picks which source to
C     use by which has the highest points for that antenna.  It then
C     adjusts to conform to the required minimum number of antennas
C     per subarray.  It may end up putting all stations on the same
C     source in this process.  
C
      INTEGER      NSTA, MAXSTA, MAXISC, MINANT1, MINANT2
      INTEGER      ISCN1, ISCN2, SCNSTA(MAXSTA), LSRC(MAXSTA)
      INTEGER      ISTA, N1, N2, N3, ISWITCH, NJ, NK
      INTEGER      SCN1, SCN2, NS1, NS2, NS3
      REAL         POINTS(MAXISC,MAXSTA), DIFF, MDIFF
      REAL         ARPTS, PTSUM, PTSJ, PTSK, PENALTY
C ------------------------------------------------------------------
C     Loop over antennas. 
C
      PTSUM = 0.0
      N1    = 0
      N2    = 0
      N3    = 0
      DO ISTA = 1, NSTA
C
C        Pick the best of the two sources for the antenna.
C
         IF( POINTS(ISCN1,ISTA) .GE. POINTS(ISCN2,ISTA) .AND.
     1       POINTS(ISCN1,ISTA) .GT. 0.0 ) THEN
            N1 = N1 + 1
            PTSUM = PTSUM + POINTS(ISCN1,ISTA)
            LSRC(ISTA) = ISCN1
         ELSE IF( POINTS(ISCN2,ISTA) .GT. 0.0 ) THEN
            N2 = N2 + 1
            PTSUM = PTSUM + POINTS(ISCN2,ISTA)
            LSRC(ISTA) = ISCN2
         ELSE
C
C           Leave unassigned if neither is up.
C
            N3 = N3 + 1
            LSRC(ISTA) = 0
         END IF
C
      END DO
C
C     Get the best 2 subarray combinations that satisfy the
C     minimum number of antenna constraints.  This is only
C     possible if there are enough antennas up.
C
  100 CONTINUE
         IF( N1 .LT. MINANT1 .AND. N1 + N2 .GE. MINANT1 + MINANT2 ) THEN
            MDIFF = PTSUM
            ISWITCH = 0
            DO ISTA = 1, NSTA
               IF( LSRC(ISTA) .EQ. ISCN2 .AND. 
     1             POINTS(ISCN1,ISTA) .GT. 0.0 ) THEN
                  DIFF = POINTS(ISCN2,ISTA) - POINTS(ISCN1,ISTA)
                  IF( DIFF .LT. MDIFF ) THEN
                     ISWITCH = ISTA
                     MDIFF = DIFF
                  END IF
               END IF
            END DO
C
C           If found a possible switch to make, do it.  Sometimes
C           there will be no stations where the other source is up.
C
            IF( ISWITCH .NE. 0 ) THEN
               LSRC(ISWITCH) = ISCN1
               PTSUM = PTSUM - MDIFF
               N1 = N1 + 1
               N2 = N2 - 1
               GO TO 100
            END IF
         ELSE IF( N2 .LT. MINANT2 .AND. N1 + N2 .GE. 
     1              MINANT1 + MINANT2 ) THEN
            MDIFF = PTSUM
            ISWITCH = 0
            DO ISTA = 1, NSTA
               IF( LSRC(ISTA) .EQ. ISCN1 .AND. 
     1             POINTS(ISCN2,ISTA) .GT. 0.0) THEN
                  DIFF = POINTS(ISCN1,ISTA) - POINTS(ISCN2,ISTA)
                  IF( DIFF .LT. MDIFF ) THEN
                     ISWITCH = ISTA
                     MDIFF = DIFF
                  END IF
               END IF
            END DO
            IF( ISWITCH .NE. 0 ) THEN
               LSRC(ISWITCH) = ISCN2
               PTSUM = PTSUM - MDIFF
               N1 = N1 - 1
               N2 = N2 + 1
               GO TO 100
            END IF
         END IF
C
C     If either N1 or N2 is still too small, force 
C     choice of a single source case.
C
      IF( N1 .LT. MINANT1 .OR. N2 .LT. MINANT2 ) THEN
C
         PTSUM = 0.0
         N1    = 0
         N2    = 0
         N3    = NSTA
C
      END IF    
C
C     The above selects the best subarrayed  option.  Now compare
C     this with having all scans on the same source.
C     Get the point sums for the single source cases.
C
      PTSJ = 0.0
      PTSK = 0.0
      NJ   = 0
      NK   = 0
      DO ISTA = 1, NSTA
         IF( POINTS(ISCN1,ISTA) .GT. 0.0 ) THEN
            PTSJ = PTSJ + POINTS(ISCN1,ISTA)        
            NJ = NJ + 1
         END IF
         IF( POINTS(ISCN2,ISTA) .GT. 0.0 ) THEN
            PTSK = PTSK + POINTS(ISCN2,ISTA)
            NK = NK + 1
         END IF
      END DO
C
C     Insure that inadequate arrays don't get used.
C
      IF( NJ .LT. 2 ) THEN
         NJ = 0
         PTSJ = 0.0
      END IF
      IF( NK .LT. 2 ) THEN
         NK = 0
         PTSK = 0.0
      END IF
C
C     Get best combination.  Add a penalty factor for the
C     subarray case since full arrays have advantages.
C
      PENALTY = 0.6
      IF( PTSUM * PENALTY .GT. PTSJ .AND. 
     1    PTSUM * PENALTY .GT. PTSK ) THEN
C
C        The subarrays were best and are ok.
C        No need to change N1, N2, N3, LSRC or PTSUM
C
      ELSE IF( PTSJ .NE. 0.0 .OR. PTSK .NE. 0.0 ) THEN
C
C        One of the single source options was best.
C        Install it.  At this point allow as few as 2 antennas.
C
         N1 = 0
         N2 = 0
         N3 = 0
         PTSUM = 0.0
         IF( PTSJ .GE. PTSK ) THEN
C
C           The first source was best.
C
            DO ISTA = 1, NSTA
               IF( POINTS(ISCN1,ISTA) .NE. 0.0 ) THEN
                  LSRC(ISTA) = ISCN1
                  PTSUM = PTSUM + POINTS(ISCN1,ISTA)
                  N1 = N1 + 1
               ELSE
                  LSRC(ISTA) = 0
                  N3 = N3 + 1
               END IF
            END DO
C
         ELSE
C
C           The second source was best.
C
            DO ISTA = 1, NSTA
               IF( POINTS(ISCN2,ISTA) .NE. 0.0 ) THEN
                  LSRC(ISTA) = ISCN2
                  PTSUM = PTSUM + POINTS(ISCN2,ISTA)
                  N2 = N2 + 1
               ELSE
                  LSRC(ISTA) = 0
                  N3 = N3 + 1
               END IF
            END DO
C
         END IF
C
      ELSE
C
C        No good data are available.
C
         PTSUM = 0.0
         N1    = 0
         N2    = 0
         N3    = NSTA
         DO ISTA = 1, NSTA
            LSRC(ISTA) = 0
         END DO
C         
      END IF
C
C     Now determine if the current subarrays are better than ones
C     previously tested.
C
      IF( PTSUM .GT. ARPTS ) THEN
         ARPTS = PTSUM
         DO ISTA = 1, NSTA
            SCNSTA(ISTA) = LSRC(ISTA)
         END DO
         NS1 = N1
         NS2 = N2
         NS3 = N3
         SCN1 = ISCN1
         SCN2 = ISCN2
      END IF
C
      RETURN
      END

      SUBROUTINE SETUSYN
C
C     Routine for SCHED, called by SETDEFS (in turn called from 
C     DEFSET) to set any VLBA synthesizers that have not yet
C     been set, presumably because they are not going to be used.
C     The job is complicated by the need to avoid harmonics of 
C     the in-use synthesizers from beating against harmonics (including
C     the fundamental) of the un-used synthesizers to creat unwanted
C     tones in the IFs.  This was a serious issue in RFI testing
C     of the wideband C band receivers using the old default for 
C     unused synthesizers, 15.4 GHz.  It was most apparent with 
C     tones at 6200MHz (3*5.4 vs 15.4) and 7300 (2*8.1 vs 15.4).
C     The peak amplitudes of the tones could be several hundred in the
C     autocorrelation (average 1) and, without smoothing, they caused
C     ripples across the baseband of up to about 0.5.  Hanning smoothing
C     knocks that way down.  The tones related to synthesizers 1 and
C     2 are much worse than those associated with synthesizer 3, at
C     least for 6cm where both 1 and 2 go to the same IF converter.
C
C     This effect was identified on Oct 17, 2012.  Other higher order
C     cases were also found once the mechanism was identified.
C
C     Previously, the unset synthesizers were put at 15.4 GHz except
C     at 2cm where 10.9 GHz was used.  I vaguely recall that 15.9 was not 
C     used because that would beat against a common 4cm LO (7.6 GHz)
C     second harmonic to produce a birdy.  But even the 15.4 setting has
C     problems with other harmonics at 4 cm.  Here we calculate 
C     frequencies that should be ok on a case by case basis.  For 
C     an overview of possible interactions between LOs, see the 
C     program syn3_c.f in the $SCHED/RELATED_CODE/MAKEFREQ area.
C
C     With the new 6cm receiver, LO's between 3.4 and 8.6 GHz can be 
C     used.  Since there are two IFs, two synthesizers can be used with
C     settings based on the scientific needs of the observation.  
C     Most combinations will be subject to harmonic trouble.  This 
C     routine will try to warn about them.  It will also try to find a
C     benign setting for the third synthesizer.  But that is not always
C     possible so a best case will be picked and  warnings will be 
C     issued about possible trouble.  Note that the third synthesizer 
C     does not cause as much trouble as the other two, presumably 
C     because it does not feed the IF converter.
C
C     This routine will procede with two steps.  First, a setting 
C     that is benign for the synthesizers that have not  been set 
C     (maximum of 2) is selected.  This is done by starting down 
C     a list of possible options until a viable one is found.  
C     The list allows weird preference orders to be selected.  
C     The list is in TLO.  A preference will be given to a setting
C     that has no in-band birdies when harmonics are mixed with
C     harmonics of the pre-set LOs.  If no ideal case can be found,
C     a setting where the trouble is between the highest possible
C     harmonics will be selected.
C
C     Once all three synthesizer settings are known, the user will 
C     be warned if there are problems with mixing of harmonics 
C     creating tones in the IFs.  We don't claim to understand 
C     all the criteria that went into the user selected LOs so we 
C     ask the user to pay attention.  An enhancement would be to
C     try to avoid the actual baseband channels selected, but I'll
C     put that off for now.
C
C     Dec. 19, 2012.  The synthesizers create tones at harmonics of 
C     half the output frequency when working at or above 8.1 GHz.  Try
C     to protect against those.  They exist because a doubler is used
C     for the higher frequencies.  This will probably not be a problem
C     with the new synthesizers under development in 2013 for use in
C     slots 1 and 2.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
      INCLUDE   'schfreq.inc'
C
      INTEGER    KS, I, J, K, L, NLO, NTLO, NHI, NHJ, NHT
      INTEGER    BESTI, MLHAR, IHAR, LSETUP, DLO, SY(3), TSY
      LOGICAL    TONHD, USEIT, GOTGOOD
      DOUBLE PRECISION   FMAX
      PARAMETER  ( NTLO = 56 )
      PARAMETER  ( FMAX = 60.0D0 )
      DOUBLE PRECISION   LO(3), TLO(NTLO), IFF, LOI, LOJ, LOT
      DATA  TLO  / 
     1 15.4D0, 15.1D0, 14.9D0, 14.6D0, 14.4D0, 14.1D0, 15.6D0, 15.9D0,
     2 13.9D0, 13.6D0, 13.4D0, 13.1D0, 12.9D0, 12.6D0, 12.4D0, 12.1D0,
     3 11.9D0, 11.6D0, 11.4D0, 11.1D0, 10.9D0, 10.6D0, 10.4D0, 10.1D0,
     4  9.9D0,  9.6D0,  9.4D0,  9.1D0,  8.9D0,  8.6D0,  8.4D0,  8.1D0,
     5  7.9D0,  7.6D0,  7.4D0,  7.1D0,  6.9D0,  6.6D0,  6.4D0,  6.1D0,
     6  5.9D0,  5.6D0,  5.4D0,  5.1D0,  4.9D0,  4.6D0,  4.4D0,  4.1D0,
     7  3.9D0,  3.6D0,  3.4D0,  3.1D0,  2.9D0,  2.6D0,  2.4D0,  2.1D0 /
C ------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SETUSYN starting' )
C
C     First detect use of 2 LO's.  If so, check for issues 
C     with harmonics and report them.  Also flag if one needs 
C     to be set because only one is used.
C
C     There are deep nested loops so the indenting is less than
C     usual to keep the lines reasonably long.
C
C     Only issue the warnings for the first VLBA station in a setup
C     file to avoid lots of repetitions.  But do repeat the calculations
C     of where to set the LOs.  There are odd corner cases where 
C     different VLBA stations might have different settings so the user
C     will miss some warnings, but the settings will be done properly.
C
C
C     Loop over all setups and select only those for VLBA stations
C     (Other stations are unlikly to have the same first LO system)
C
      LSETUP = 0
      DO KS = 1, NSET
       TONHD = .TRUE.
       IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) THEN
C
C        Make a short list of the synthesizer settings already
C        established.
C
         NLO = 0
         DO I = 1, 3
            IF( SYNTH(I,KS) .NE. 0.D0 ) THEN
               NLO = NLO + 1
               LO(NLO) = SYNTH(I,KS)
               SY(NLO) = I
            END IF
         END DO
C
C        +++++
C        Find the possible birdies from pre-set tones.
C        +++++
C
C        Only do when 2 or 3 synthesizers have been set.
C
C        Test out to the 5th harmonic of the primary, or 10th when
C        checking harmonics of the tone at half the primary
C        for old type LOs above 8.1 GHz.  Don't worry about signals
C        above 60 GHz.  Give special warning when one of the
C        offending "harmonics" is the primary synthesizer output
C        as I expect those will be strong.
C
C        This segment is only for warnings so skip if just doing
C        a new station for the last setup file.
C
         IF( NLO .GE. 2 .AND. ISETNUM(KS) .NE. LSETUP ) THEN
C
C         Checking pairs of tones.  Loop over the first LO of a
C         pair.  It can only go to NLO - 1.
C
          DO I = 1, NLO - 1
C
C          Set the base tone for this LO.  MODETEST allows the
C          test value to be the output frequency when using the
C          new synthesizer.
C
           IF( LO(I) .LE. 8.0 .OR. 
     1         ( MODETEST(KS) .AND. SY(I) .LT. 3 ) ) THEN
              LOI = LO(I)
              NHI = MIN( 5, INT( FMAX / LOI ) )
           ELSE
              LOI = LO(I) / 2.0
              NHI = MIN( 10, INT( FMAX / LOI ) )
           END IF
C
C          Loop over the second frequency of the pair.
C
           DO J = I + 1, NLO
            IF( LO(J) .LE. 8.0 .OR. 
     1         ( MODETEST(KS) .AND. SY(J) .LT. 3 )) THEN
               LOJ = LO(J)
               NHJ = MIN( 5, INT( FMAX / LOJ ) )
            ELSE
               LOJ = LO(J) / 2.0
               NHJ = MIN( 10, INT( FMAX / LOJ ) )
            END IF
C
C           Now loop over the harmonics of each frequency
C           and look at the difference.  Note that the LOs
C           are in GHz so the IF is 0.512-1.024.
C           Allow a birdy at 500 (out of band), but not 1000 (in band)
C           Since all birdies will be at N*0.1 GHz, using 0.52 is
C           equivalent to 0.512.
C
            DO K = 1, NHI
             DO L = 1, NHJ
              IFF = ABS( LOI * K - LOJ * L )
              IF( IFF .GT. 0.52 .AND. IFF .LT. 1.03 ) THEN
               CALL HARMWARN( KS, SY(I), LO(I), LOI, 
     1                        SY(J), LO(J), LOJ, K, L, IFF, TONHD )
              END IF
             END DO
            END DO
           END DO
          END DO
         END IF
C
C        +++++
C        Set unused synthesizers.
C        +++++
C
C        Now set the unset synthesizers to try to avoid RFI
C        from mixes of harmonics.  Also avoid putting an LO
C        in the RF for 2cm.  Try 15.4 and a couple below before
C        trying 15.6 and up.  The easiest way to orchestrate
C        this is to have a table (DATA) of options.
C
C        Below the loops are over:
C        I:  The index for the list (TLO) of possible LOs to use 
C            for the unset synthesizers
C        J:  The index of the list of previously set synthesizer 
C            frequencies (LO).
C        K:  The harmonic of the TLO(I).
C        L:  The harmonic of the previously set values (LO(J)).
C
C        Don't bother with any of this if all synthesizers set.
C
C        Deal with the tones at half the LO, and harmonics thereof,
C        for frequencies above 8 GHz.
C   
C
C        Loop over preset LOs.  GOTGOOD is just a flag that indicates
C        we don't need to explore harmonics with a newly chosen 
C        unused synthesizer setting.  It will be true if we didn't
C        choose any settings (all harmonics listed above) or if we
C        did not find a good setting with no harmonic issues.
C
         GOTGOOD = NLO .EQ. 3 
         IF( NLO .LT. 3 ) THEN
C
C         Loop over the TLO options list for values for the unset
C         synthesizers.  Note that this may need to change with
C         the new synthesizers which have finer set points and for
C         which power consumption considerations suggest that the
C         sum of SYNTH(1,KS)+SYNTH(2,KS) should be close to 18 GHz
C         ideally.  For now, the existing algorithm should find
C         a usable frequency so don't worry about it yet.
C
C         For future thinking: One way to set a new synthesizer 
C         would be to use a frequency that is very close to a 
C         harmonic of another, so the harmonics never separate by
C         more than 500 MHz.  But with 2 preset LOs, especially if
C         one is the old-style one with coarse tuning, it won't 
C         be that simple.
C
          MLHAR = 0
          I = 1
          DO WHILE( I .LE. NTLO )
C
C          Avoid putting a tone in the 2cm band - jump down below
C          11.5 if this is 2cm.  This protects the whole band.  Is
C          is now needed for other bands too?
C
           IF( TLO(I) .LE. 11.5D0 .OR. ( FE(2,KS) .NE. '2cm' .AND.
     1                 FE(4,KS) .NE. '2cm' ) ) THEN
C
C           Loop over the assigned synthesizer frequencies (set above)
C           looking to see if TLO(I) is usable.  For the TLO frequencies
C           don't bother going above the third harmonic of the primary,
C           but that will be the sixth harmonic of the half tone.
C           If a good frequency is found with no harmonic issues, take
C           it and jump out.  Otherwise prioritize the options and
C           take the one with the highest, lowest harmonic. Really!  
C           For each possible TLO, look at the harmonic numbers for
C           all combinations of LOs and TLO that can cause birdies in
C           the IF(s).  Find the lowest for that TLO.  Then pick the
C           TLO that has the highest value of that lowest harmonic number.
C           Confused yet?
C
C           Try to very strongly discourage anything with a first harmonic
C           value of 1 (the actual signal) participating in a birdy.
C           Those will be much stronger then others.
C
C           Don't worry about tones above 60 GHz (I picked that out of 
C           thin air).
C
            USEIT = .TRUE.
            IF( TLO(I) .LE. 8.D0 ) THEN
              LOT = TLO(I)
              NHT = MIN( 5, INT( FMAX / LOT ) )
            ELSE
              LOT = TLO(I) / 2.D0
              NHT = MIN( 10, INT( FMAX / LOT ) )
            END IF
C
C           Loop over the already chosen synthesizer settings.
C           IHAR will be the minimum harmonic number for cases 
C           where the IF frequency of the harmonic interference 
C           falls in the 512-1024 range.  It will be used in
C           selecting the least bad LO when a good one (no harmonic
C           issues) can be found.
C
            IHAR = 100
            DO J = 1, NLO
             IF( LO(J) .LE. 8.D0 .OR. 
     1           ( MODETEST(KS) .AND. SY(J) .LT. 3 ) ) THEN
               LOJ = LO(J)
               NHJ = MIN( 10, INT( FMAX / LOJ ) )
             ELSE
               LOJ = LO(J) / 2.D0
               NHJ = MIN( 10, INT( FMAX / LOJ ) )
             END IF
C
C            Don't set the unused synthesizer to the same frequency
C            as a used one.  That has potential for trouble.
C
             IF( LOT .EQ. LOJ ) USEIT = .FALSE.
C
C            Now loop over the harmonics. 
C
             IF( USEIT ) THEN
              DO K = 1, NHT
               DO L = 1, NHJ
C
C               Allow a birdy at 500 (out of band), but not 1000 (in band)
C
                IFF = ABS( LOT * K - LOJ * L )
                IF( IFF .GT. 0.52 .AND. IFF .LT. 1.03 ) THEN
                 IHAR = MIN( K, L, IHAR )
                 USEIT = .FALSE.
                END IF
               END DO
              END DO
             END IF
            END DO
C
C           If no birdy possibilities were found, use this TLO.
C           Skip out of the search.
C
            IF( USEIT ) THEN
             DLO = I
             GOTGOOD = .TRUE.
             GO TO 100
C
C           Otherwise, check if this is the best so far (highest IHAR)
C           and, if so, keep track.
C
            ELSE
             IF( IHAR .GT. MLHAR ) THEN
              MLHAR = IHAR
              BESTI = I
             END IF
            END IF
           END IF
           I = I + 1
          END DO 
C
C         If got here, we need to select the best case of those
C         that may have birdies.
C
          DLO = BESTI
         END IF
C
C        Jump here when a usable set is found.  
C
  100    CONTINUE
C
C        Set the unspecified synthesizers to the value selected 
C        above.  Retain the number of the synthesizer set (TSY).
C        Go backwards so that number is the lowest.
C
         TSY = 0 
         DO I = 3, 1, -1
            IF( SYNTH(I,KS) .EQ. 0.D0 ) THEN
               SYNTH(I,KS) = TLO(DLO)
               TSY = I
            END IF
         END DO
C
C        Now, if necessary, warn of frequencies of possible birdies
C        with the synthesizer.  This is just warnings so skip
C        if on a setup file we've done for another VLBA station.
C        Note that the concern about the fundamental tone being
C        at half the output is for the old synthesizers, not the
C        new ones to be deployed in slots 1 and 2 in 2014 (maybe).
C
C        Here we only need to compare the one setting used for the 
C        previously unset synthesizers with the forced settings.
C        We don't need to do this when a good alternative was 
C        found, which would cause GOTGOOD to be set true.  Any
C        problems between previously set synthesizers have already
C        been dealt with in the first HARMWARN call above.
C
C        Note that, if more than one synthesizer needed to be set, 
C        they will be set to the same frequency.  So we only need
C        to test that frequency.
C
C        So start the nested loops with the one new frequency.
C             
         IF( .NOT. GOTGOOD .AND. ISETNUM(KS) .NE. LSETUP ) THEN
C         IF( ISETNUM(KS) .NE. LSETUP ) THEN
          IF( TLO(DLO) .LE. 8.D0 ) THEN
             LOT = TLO(DLO)
             NHT = MIN( 5, INT( FMAX / LOT ) )
          ELSE
             LOT = TLO(DLO) / 2.D0
             NHT = MIN( 10, INT( FMAX / LOT ) )
          END IF
C
C         Loop over the forced settings.  There was an error
C         in the loop lower limit prior to Oct 24, 2013 which would
C         have done something weird.  It was:  DO I = I + 1, NLO.
C         That should have caused trouble, but it seems none of the
C         examples get to this point.  I don't know if anything 
C         else does (all either forced settings or good numbers found
C         by SCHED).
C
          DO I = 1, NLO
           IF( LO(I) .LE. 8.D0 ) THEN
              LOI = LO(I)
              NHI = MIN( 5, INT( FMAX / LOI ) )
           ELSE
              LOI = LO(I) / 2.D0
              NHI = MIN( 10, INT( FMAX / LOI ) )
           END IF
C
C          Double loop over harmonics.
C
           DO K = 1, NHT
            DO L = 1, NHI
             IFF = ABS( LOT * K - LOI * L )
             IF( IFF .GT. 0.52 .AND. IFF .LT. 1.03 ) THEN
              CALL HARMWARN( KS, SY(I), LO(I), LOI, 
     1               TSY, TLO(DLO), LOT, L, K, IFF, TONHD )
             END IF
            END DO
           END DO
C
          END DO
C
         END IF
C
C        Remember this was the last setup.
C
         LSETUP = ISETNUM(KS)
C
       END IF
      END DO
C
      RETURN
      END

      SUBROUTINE CHKSPD( KS, ERRS )
Cf2py intent(in, out) ERRS
C
C     Routine for SCHED called by CHKSET that checks the 
C     bit rate per track and the tape speeds for VLBA, Mark III, and
C     Mark IV recorder systems.  The speed checks are obsolete
C     and are removed.
C
      INCLUDE     'sched.inc'
      INCLUDE     'schset.inc'
C
      INTEGER     KS, BITRATE
      LOGICAL     ERRS, OK
C -------------------------------------------------------------------
C     Only make these checks for Mark III/IV or VLBA formats.
C
      IF( FORMAT(KS) .NE. 'MARKIII' .AND. 
     1    FORMAT(KS)(1:4) .NE. 'VLBA' .AND. 
     2    FORMAT(KS)(1:4) .NE. 'MKIV' ) 
     3      RETURN
C
C     Check the requested bit rate per track.  All of these systems
C     can handle 2, 4, and 8 Mbps per track.  The MarkIV formatters
C     can also do 16 Mbps per track.  A VLBA4 DAR is mostly a VLBA
C     DAR but includes a MarkIV formatter, so it can also do 16 Mbps
C     per track.
C
      BITRATE = TBPS(KS) + 0.001
      OK = BITRATE .EQ. 2 .OR. BITRATE .EQ. 4 .OR. BITRATE .EQ. 8
      OK = OK .OR. 
     1    ( BITRATE .EQ. 16 .AND. DAR(ISETSTA(KS)) .EQ. 'MKIV' ) .OR.
     4    ( BITRATE .EQ. 16 .AND. DAR(ISETSTA(KS)) .EQ. 'VLBA4' )
      IF( .NOT. OK ) THEN
         CALL WLOG( 1, 'CHKSPD: SAMPRATE and FORMAT(KS) do not ' //
     1      'combine to give valid bit rate on tape.' )
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, F10.3, 2A, A, I5, 4A )' ) 
     1         'CHKSPD: SAMPRATE=', SAMPRATE(KS), '   FORMAT=',
     2         FORMAT(KS), '   BITRATE=', BITRATE, '  DAR at ',
     3         STATION(ISETSTA(KS)), ' is ', DAR(ISETSTA(KS))
         CALL WLOG( 1, MSGTXT )
         ERRS = .TRUE.
      END IF
C
C     The checking of the tape speeds was here and was removed
C     on Jan. 7, 2011.  RCW.
C
      RETURN
      END

      SUBROUTINE OPTCSAR( LASTISCN, KSCN, ISCN, SCNSTA, NS1, NS2, NS3, 
     1                    SCN1, SCN2, SCN3, TIME1, TIME2, TIME3 )
C
C     Routine for SCHED, called by OPTCSUB, that trys to determine
C     the optimimal subarrays for good sky coverage over each   
C     antenna.  It examines a grid in AZ and EL.  This routine is
C     related to OPTCELLS except in the use of subarrays.  There will 
C     be two primary subarrays which are optimized, each with
C     at least OPMIAN antennas.  If the best such combination
C     leaves 2 or more antennas free (sources not up), those antennas
C     will go to some other source as a 3ed subarray.
C
C     During operation, the geometry parameters for the input
C     scans will be used to hold geometry for the current test time.
C
C     Note that this routine and the OPTCELLS stuff should perhaps
C     be merged some day.
C    
C     This routine doesn't take into account GAP.  OPTTIM is run 
C     later and does take that into account.
C
      INCLUDE 'sched.inc'
C
      INTEGER     MAXISC
      PARAMETER   (MAXISC=1000)       ! Number of input scans.
C
      INTEGER           LASTISCN(MAXSTA), KSCN, ISCN, JSCN, ISTA
      INTEGER           ISCN1, ISCN2
      INTEGER           SCN1, SCN2, SCN3, NS1, NS2, NS3
      INTEGER           IE, IA, I
      INTEGER           SCNSTA(MAXSTA), NS, LSRC(MAXSTA)
      DOUBLE PRECISION  TIMER
      INTEGER           YEAR, DAY2, MINMIAN
      CHARACTER         TFORM*10, TIMSTR1*10, TIMSTR2*10
      REAL              ARPTS, POINTS(MAXISC,MAXSTA)
      REAL              PTS3, MPTS3
      REAL              PT_ADD, WT_MUL, SL_ADJ
      DOUBLE PRECISION  TAPPROX, TIME1, TIME2, TIME3, TIMEC, DURC
      DOUBLE PRECISION  LASTTIME, LASTSTOP
      SAVE              LASTTIME, LASTSTOP, LSRC
C
C     Cell stuff.
C
      INTEGER           ELI(MAXISC,MAXSTA), AZI(MAXISC,MAXSTA)
      INTEGER           IEL, IAZ
      DOUBLE PRECISION  CELLTIME(3,3,MAXSTA)
      REAL              ELCELL(2),  AZCELL(2), AZTEST, AZCOFF
      SAVE              AZCOFF, ELCELL, AZCELL, CELLTIME
C
C     The cell boundaries.  Make input some day?
C     AZCOFF is added to the azimuth to get the "test" azimuth
C     so that I can have a cell that crosses 0.
C
      DATA      AZCOFF  / 60. /
      DATA      ELCELL  / 15., 70. /
      DATA      AZCELL  / 120., 240. /  
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'OPTCSAR starting ' )
C
      IF( KSCN .EQ. 1 ) THEN
C
C        Make sure that there aren't too many input scans.
C
         IF( NSCANS .GT. MAXISC ) THEN
            WRITE( MSGTXT, '( A, I6 )' ) 
     1        ' OPTCSAR:  Too many input scans for CSUB optimizer'//
     2        ' - max: ', MAXISC
            CALL ERRLOG( MSGTXT )
         END IF
C
C        Initializations.
C        Start the set of new scans beyond NSCANS and use first start
C        time.  TAPPROX is the approximate start time of the next scan.
C        Don't allow this time to be adjusted.
C
         TAPPROX  = STARTJ(1)
         LASTSTOP = STARTJ(1)
C
C        Initialize cell times to well before the start of the 
C        program to try to force quickly getting a complete set
C        of samples.
C
         DO ISTA = 1, NSTA
            DO IEL = 1, 3
               DO IAZ = 1, 3
                  CELLTIME(IEL,IAZ,ISTA) = STARTJ(1) - 20.0 * DUR(1)
               END DO
            END DO
         END DO
C
      ELSE
C      
C        The best guess for the next start time is the end of the
C        last scan.
C
         TAPPROX = STOPJ(ISCN-1)
         LASTSTOP = TAPPROX
C
      END IF
C
C     Initialize the points arrays.  
C     POINTS is for source of input scan JSCN and station ISTA.
C
      ARPTS = 0.0
      DO JSCN = 1, NSCANS
         DO ISTA = 1, NSTA
            POINTS(JSCN,ISTA) = 0.0
         END DO
      END DO
C
C     Get the quality factor for each source/station.
C
C     Loop over sources.
C
      DO JSCN = 1, NSCANS
C
C        Loop over stations.
C
         DO ISTA = 1, NSTA
C
C           Be sure that the input information has not excluded this
C           station from this source (unlikely, but might as well).
C
            IF( STASCN(JSCN,ISTA) ) THEN
C
C              Get geometry and time available.
C
               CALL STAGEO( JSCN, ISTA, TAPPROX, LASTISCN(ISTA),
     1                      LASTTIME, TONSRC(JSCN,ISTA), 'OPTCSAR' )
C
C              For first scan at the station, set TONSRC to the
C              nominal start time.
C
               IF( TONSRC(JSCN,ISTA) .EQ. 0.D0 ) THEN
                  TONSRC(JSCN,ISTA) = TAPPROX
               END IF
C
C              Get cell and time since last sample or that cell.
C              From this get the POINTS.
C              Set POINTS to zero if source is not up at the station.
C
               IF( UP1(JSCN,ISTA) .EQ. ' ' .AND. 
     1             UP2(JSCN,ISTA) .EQ. ' ' .AND.
     2             EL1(JSCN,ISTA) .GT. OPMINEL(JSCN) .AND.
     3             EL2(JSCN,ISTA) .GT. OPMINEL(JSCN) ) THEN
C
C                 Take out effect of cable wrap and add offset.
C
                  AZTEST = MOD( AZ1(JSCN,ISTA) + AZCOFF, 360.0 )
                  IF( AZTEST .LT. 0.0 ) AZTEST = AZTEST + 360.0
C
C                 Calculate which cell the data point is in.
C                 El:
C
                  IF( EL1(JSCN,ISTA) .LT. ELCELL(1) ) THEN
                     ELI(JSCN,ISTA) = 1
                  ELSE IF( EL1(JSCN,ISTA) .LT. ELCELL(2) ) THEN
                     ELI(JSCN,ISTA) = 2
                  ELSE
                     ELI(JSCN,ISTA) = 3
                  END IF
C
C                 Az:
C
                  IF( AZTEST .LT. AZCELL(1) ) THEN
                     AZI(JSCN,ISTA) = 1
                  ELSE IF( AZTEST .LT. AZCELL(2) ) THEN
                     AZI(JSCN,ISTA) = 2
                  ELSE
                     AZI(JSCN,ISTA) = 3
                  END IF
                  IE = ELI(JSCN,ISTA)
                  IA = AZI(JSCN,ISTA)
C
C                 Get the points for this station/scan (units minutes).
C                 First get the minutes since the last sample.
C
                  POINTS(JSCN,ISTA) = 1440.D0 * 
     1                 ( TONSRC(JSCN,ISTA) - CELLTIME(IE,IA,ISTA) )
C
C
C                 Now make an adjustment for slew times.  It might
C                 be better conceptually to do this after the 
C                 final selection of antennas is known and do for
C                 the whole subarray, but that would be difficult.
C
C                 First get the time the source is available relative
C                 to some nominal time - the nominal start of
C                 the scan.  If negative, set to zero (this number
C                 is later squared so a negative value would be seen
C                 as bad too.
C
                  SL_ADJ = ( TONSRC(JSCN,ISTA) - LASTSTOP ) * 1440.0
                  IF( SL_ADJ .LT. 0.0 ) SL_ADJ = 0.0
C
C                 Now develop a multiplier that favors scans that
C                 start before LASTSTOP + OPTSLEW.
C
                  WT_MUL = OPTSLEW**2 / ( SL_ADJ**2 + OPTSLEW**2 )
C
C                 Scale the points for this source/station
C
                  POINTS(JSCN,ISTA) = POINTS(JSCN,ISTA) * WT_MUL
C
C                 Determine any extra weight for samples of low
C                 elevation cells.  This helps stations that never
C                 see low in some directions.
C                 points in the lowest elevation range only.
C                 The function is one that is very small for times
C                 less than OPTLOWT (input parameter) and rises
C                 to near unity for longer times.  Thus a low
C                 elevation scan could get close to 3 times the
C                 weight it might have.
C
                  WT_MUL = 1
                  IF( IE .EQ. 1 ) THEN
                     DO I = 1, 3
                        IF( I .NE. IA ) THEN
                           PT_ADD = 1440.D0 * ( TONSRC(JSCN,ISTA) - 
     1                              CELLTIME(I,IA,ISTA) )
                           WT_MUL = WT_MUL +
     1                       PT_ADD**2 / ( OPTLOWT**2 + PT_ADD**2 )
                        END IF
                     END DO
                  END IF
C
C                 Scale the points for the extra low el weights.
C
                  POINTS(JSCN,ISTA) = POINTS(JSCN,ISTA) * WT_MUL
C
C                 Zero out the points if the source is the same as
C                 the last one observed at this station.
C
                  IF( LASTISCN(ISTA) .GT. 0 ) THEN
                     IF( SRCNUM(JSCN) .EQ. SRCNUM(LASTISCN(ISTA)) ) THEN
                        POINTS(JSCN,ISTA) = 0.0
                     END IF
                  END IF
C
               ELSE
C
C                 Station not up.  Set to zero.
C
                  POINTS(JSCN,ISTA) = 0.0
                  ELI(JSCN,ISTA) = 0
                  AZI(JSCN,ISTA) = 0
                  IE = 0
                  IA = 0
C
               END IF
C
            END IF
         END DO
      END DO
C
C     For each possible pair of sources, find the best subarrays.
C     Skip this if there is no hope of making subarrays based on the
C     minimum OPMIAN.
C
      MINMIAN = 100
      DO JSCN = 1, NSCANS
         MINMIAN = MIN( OPMIAN(JSCN), MINMIAN )
      END DO
C

      IF( MINMIAN .LT. NSTA / 2 .AND. .NOT. OPNOSUB ) THEN
         DO ISCN1 = 1, NSCANS - 1
            DO ISCN2 = ISCN1 + 1, NSCANS
C
C              Derive the optimal subarray configuration for this
C              pair.  Then compare that with the current best.
C              ARPTS will be the sum of POINTS for the best 
C              configuration and SCNSTA will be that configuration.
C              LSRC is in the call just to get its size right.
C
               CALL OPTCSPT( ISCN1, ISCN2, NSTA, POINTS, ARPTS, 
     1                 SCNSTA, LSRC, MAXISC, MAXSTA, OPMIAN(ISCN1), 
     2                 OPMIAN(ISCN2), SCN1, SCN2, NS1, NS2, NS3 )
C
            END DO
         END DO
      ELSE
         NS1 = 0
         NS2 = 0
         NS3 = NSTA
         DO ISTA = 1, NSTA
            SCNSTA(ISTA) = 0
         END DO         
      END IF
C
C     If there are 2 or more unused antennas, find the best source
C     for them.
C
      MPTS3 = 0.0
      SCN3 = 0
      IF( NS3 .LT. 2 ) THEN
C
         NS3 = 0
C
      ELSE
C
C        Loop over input scans.
C
         DO JSCN = 1, NSCANS
            NS = 0
            PTS3 = 0.0
C
C           Loop over the unused stations.
C
            DO ISTA = 1, NSTA
               IF( SCNSTA(ISTA) .EQ. 0 ) THEN
C
C                 Get points if source is up.
C
                  IF( POINTS(JSCN,ISTA) .GT. 0.0 ) THEN
                     NS = NS + 1
                     PTS3 = PTS3 + POINTS(JSCN,ISTA)
                  END IF
C
               END IF
            END DO
C
C           Now see if this source (scan) has all antennas and more 
C           points than previous best.
C
            IF( PTS3 .GT. MPTS3 .AND. NS .GE. 2 ) THEN
               MPTS3 = PTS3
               SCN3 = JSCN
            END IF
         END DO
C
C        If didn't get any sources, set NS3 to 0.
C        Otherwise, install the source.  Add a bit of unnecessary
C        protection against down sources unless OPNOSUB was specified.
C
         NS3 = 0
         IF( MPTS3 .NE. 0.0 ) THEN
            DO ISTA = 1, NSTA
               IF( OPNOSUB .OR. ( SCNSTA(ISTA) .EQ. 0 .AND. 
     1             POINTS(SCN3,ISTA) .NE. 0.0 ) ) THEN
                  SCNSTA(ISTA) = SCN3
                  NS3 = NS3 + 1
               END IF
            END DO
         END IF
C
C
      END IF
C
C     Now NS1, NS2, NS3, SCN1, SCN2, SCN3, and SCNSTA have been
C     set as required.
C
C     Get the start times for each subarray.
C
      TIME1 = 1.D10
      TIME2 = 1.D10
      TIME3 = 1.D10
      DO ISTA = 1, NSTA
         JSCN = SCNSTA(ISTA)
         TIMEC = 0.D0
         IF( JSCN .NE. 0 ) THEN
            IF( SCNSTA(ISTA) .EQ. SCN1 ) THEN
               TIME1 = MIN( TIME1, TONSRC(SCN1,ISTA) )
            ELSE IF( SCNSTA(ISTA) .EQ. SCN2 ) THEN
               TIME2 = MIN( TIME2, TONSRC(SCN2,ISTA) )
            ELSE IF( SCNSTA(ISTA) .EQ. SCN3) THEN
               TIME3 = MIN( TIME3, TONSRC(SCN3,ISTA) )
            END IF
         END IF
      END DO
C
C     Refill the CELLTIME array.  Use scan stop time to discourage
C     doubling up on scans.
C
      DO ISTA = 1, NSTA
         JSCN = SCNSTA(ISTA)
         TIMEC = 0.D0
         IF( JSCN .NE. 0 ) THEN
            IF( JSCN .EQ. SCN1  ) THEN
               TIMEC = TIME1
               DURC  = DUR(JSCN)
            ELSE IF( JSCN .EQ. SCN2 ) THEN
               TIMEC = TIME2
               DURC  = DUR(JSCN)
            ELSE IF( JSCN .EQ. SCN3 ) THEN
               TIMEC = TIME3
               DURC  = DUR(JSCN)
            END IF
            IF( TIMEC .NE. 0.D0 ) THEN
               CELLTIME(ELI(JSCN,ISTA),AZI(JSCN,ISTA),ISTA) = 
     1             TIMEC + DURC
            END IF
         END IF
      END DO
C
C     Print some gory details in debug mode.
C
      IF( DEBUG) THEN
         CALL TIMEJ( TIMEC, YEAR, DAY2, TIMER )
         TIMSTR1 = TFORM( TIMER, 'T', 0, 2, 2, '::@' )
         CALL TIMEJ( TAPPROX, YEAR, DAY2, TIMER )
         TIMSTR2 = TFORM( TIMER, 'T', 0, 2, 2, '::@' )
         WRITE( MSGTXT, '( A, I4, 4A )' ) 
     1        ' NEW SCAN SET - day: ', DAY2, 
     2        ' timec: ', TIMSTR1, ' tapprox: ', TIMSTR2
         CALL WLOG( 0, MSGTXT )
         WRITE( MSGTXT, '( A, 2I5, A, 3I4, A, 3I4 )' )
     1         ' SCAN ', KSCN, ISCN, '    ns: ', NS1, NS2, NS3, 
     2        '    scn: ', SCN1, SCN2, SCN3
         CALL WLOG( 0, MSGTXT )
         DO ISTA = 1, NSTA
            IF( SCNSTA(ISTA) .NE. 0 ) THEN
               JSCN = SCNSTA(ISTA)
               WRITE( MSGTXT, '( I4, A, A8, 2X, A12, F8.2, 1X, A1 )' )
     1            JSCN, ' ', STATION(STANUM(ISTA)), 
     2            SCNSRC(JSCN), EL1(JSCN,ISTA), UP1(JSCN,ISTA)
            ELSE
               WRITE( MSGTXT, '(I4, A, A8, A )' ) 
     1            JSCN, ' ', STATION(STANUM(ISTA)), '  ------ '
            END IF
            CALL WLOG( 0, MSGTXT )
         END DO
      END IF
C
      RETURN
      END

      SUBROUTINE VXWRMD
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the MD = $MODE section 
C     By H.J. van Langevelde, JIVE, 300496 
C     Dec. 2011  RCW:  Write modes even for FORMAT=NONE.  The VLBA 
C     needs them.  In cases that don't use the VLBA, they are unlikely 
C     to be scheduled and, if they are, they will be safely ignored, 
C     I hope, as no scans using they will actually be written in the
C     $SCHED block.
C
C     Allow station list lines to go beyond 132 characters for projects
C     with large numbers of stations.  Apparently the VEX parsers only
C     care about the length of the parsable tokens which is what is
C     between the colons.  A comment is one parsable token, so that 
C     has problems if over 128 characters, but the station lists 
C     created here can be long.  Limit the length for the ref lines
C     to 512 characters, but make LINE a bit longer so we don't have
C     to worry about overflowing it on the last addition.  If 512 is
C     not adequate, simply increase the length of LINE and recompile.
C     Apr. 27, 2012.  RCW.
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
      INTEGER   IXX, I, ISTA, IMODE, LPOS
      INTEGER   LEN1, NTAPEST, ISET, MAXLINE
      CHARACTER LINE*520, LSETNAME*80, DEL*1
      INTEGER   VXGTST
C     NTAPEST is a temporary counter for the number of stations in a
C     given mode that use tapes.
C ----------------------------------------------------------------------
C
      LINE = ' ' 
      MAXLINE = LEN( LINE )
C
C     Loop through the SETUP groups and write the modes
C
      WRITE( IVEX, '( A, A1 )' ) '$MODE', SEP
C
C     First issue a warning for more than 20 modes...
C     This is a field system issue.  The VLBA should take more.
C
      IF( NMDVEX .GT. 20 ) THEN
         MSGTXT = ' ' 
         WRITE( MSGTXT, '( A, I3, A )' ) 
     1       '++++ VXWRMD: WARNING: More than 20 VEX modes (', NMDVEX,
     2       ') in this schedule. '
         CALL WLOG( 1,MSGTXT)
         MSGTXT = ' ' 
         WRITE( MSGTXT, '( 2A )' ) 
     1       '             ',
     2       'This VEX will NOT run in the field system!' 
         CALL WLOG( 1,MSGTXT)
         MSGTXT = ' ' 
         WRITE( MSGTXT, '( 2A )' )
     1       '             ',
     2       'It should be ok on the VLBA.' 
         CALL WLOG( 1,MSGTXT)
      END IF
C
      LSETNAME = ' '
      DO IMODE = 1, NMDVEX
         IXX = IMODE
C
C        Find a station that uses this Vex mode so we can find its Sched
C        setup to check the FORMAT.  Add a comment for format=none, but
C        go ahead and write the mode.  Some stations (eg VLBA) may need
C        the scans fully defined for activities like single dish tests and
C        reference pointing.
C
         ISET = VXGTST( IMODE )
         IF( FORMAT(ISET)(1:4) .EQ. 'NONE' ) THEN
            WRITE( IVEX, '( A1 )' ) COM
            WRITE( IVEX, '( A1, A )' ) COM, 
     1         'The following mode is used with FORMAT=NONE.'
         END IF
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1           MDLINK(IMODE)(1:LEN1(MDLINK(IMODE))), SEP
C
C        Procedure name are synchronous with IMODE
C
         WRITE( LINE, '( 5X, A, A, A1 )' )
     1       'ref $PROCEDURES = ',
     2       PRLINK(IXX)(1:LEN1(PRLINK(IXX))), SEP
         WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
C
C        Other references have been sorted out in vxsort.
C        Write here the freq section that belongs to this mode
C
         DO I = 1, NMODFQ(IMODE)
            IXX = IMODFQ(I,IMODE)
C
C           if there is just 1 FQ, no need to split Ants
C           but for 1.5 the complete list is still required:
C
C            IF( NMODFQ(IMODE) .EQ. 1 ) THEN
C
            IF( NMODFQ(IMODE) .EQ. -999 ) THEN
               WRITE( LINE, '( 5X, A, A  )' ) 
     1             'ref $FREQ = ',
     2             FQLINK(IXX)(1:LEN1(FQLINK(IXX)))
               LPOS = LEN1(LINE)
               WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) SEP
            ELSE
               IF( NSTAFQ(IXX,IMODE) .NE. 0 ) THEN
                  WRITE( LINE, '( 5X, A, A )' ) 
     1                'ref $FREQ = ',
     2                FQLINK(IXX)(1:LEN1(FQLINK(IXX)))
                  LPOS = LEN1(LINE)
                  WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) COL
                  DO ISTA = 1, NSTAFQ(IXX,IMODE)
                     DEL = COL
                     IF( ISTA .EQ. NSTAFQ(IXX,IMODE) ) DEL = SEP
                     WRITE( LINE(LPOS+2:LPOS+4), '( A )' )
     1                   STCODE(STANUM(ISTAFQ(ISTA,IXX,IMODE)))
C
C                    reduce the spaces
C
                     LPOS = LEN1(LINE)
                     WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) DEL
C
C                    Check for too long line.
C
                     IF( LPOS .GT. MAXLINE - 8 ) THEN
                        CALL ERRLOG( 'VXWRMD: Too many stations '//
     1                    'for VEX MODE lines.  Change code?' )
                     END IF
                  END DO
               ELSE
                  WRITE( LINE, '( A1, 4X, A, A, A )' ) 
     1                COM, 'ref $FREQ = ',
     2                FQLINK(IXX)(1:LEN1(FQLINK(IXX))),
     3                ' <= obsolete definition'
                  LPOS = LEN1(LINE)
               END IF
            END IF
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
C
C        write the IF links for this mode
C
         DO I = 1, NMODIF(IMODE)
            IXX = IMODIF(I,IMODE)
C
C           if there is just 1 IF, no need to split Ants
C
C           need all anyaway, set from 1 to -999
C
            IF( NMODIF(IMODE) .EQ. -999 ) THEN
               WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1             'ref $IF = ',
     2             IFLINK(IXX)(1:LEN1(IFLINK(IXX)))
               LPOS = LEN1(LINE)
               WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) SEP
            ELSE
               IF( NSTAIF(IXX,IMODE) .NE. 0 ) THEN
                  WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1                'ref $IF = ',
     2                IFLINK(IXX)(1:LEN1(IFLINK(IXX)))
                  LPOS = LEN1(LINE)
                  WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) COL
                  DO ISTA = 1, NSTAIF(IXX,IMODE)
                     DEL = COL
                     IF( ISTA .EQ. NSTAIF(IXX,IMODE)) DEL = SEP
                     WRITE( LINE(LPOS+2:LPOS+4), '( A )' )
     1                   STCODE(STANUM(ISTAIF(ISTA,IXX,IMODE)))
C
C                    reduce the spaces
C
                     LPOS = LEN1(LINE)
                     WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) DEL
C
C                    Check for too long line.
C
                     IF( LPOS .GT. MAXLINE - 8 ) THEN
                        CALL ERRLOG( 'VXWRMD: Too many stations '//
     1                    'for VEX MODE lines.  Change code?' )
                     END IF
                  END DO
               ELSE
                  WRITE( LINE, '( A1, 4X, A, A, A )' ) 
     1                COM, 'ref $IF = ',
     2                IFLINK(IXX)(1:LEN1(IFLINK(IXX))),
     3                ' <= obsolete definition'
                  LPOS = LEN1(LINE)
               END IF
            END IF
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
C
C        write the BB section for this mode
C
         DO I = 1, NMODBB(IMODE)
            IXX = IMODBB(I,IMODE)
C
C           if there is just 1 BB, no need to split Ants
C
C           need all anyaway, set from 1 to -999
C
            IF( NMODBB(IMODE).EQ.-999 ) THEN
               WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1             'ref $BBC = ',
     2             BBLINK(IXX)(1:LEN1(BBLINK(IXX)))
               LPOS = LEN1(LINE)
               WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) SEP
            ELSE
               IF( NSTABB(IXX,IMODE) .NE. 0 ) THEN
                  WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1                'ref $BBC = ',
     2                BBLINK(IXX)(1:LEN1(BBLINK(IXX)))
                  LPOS = LEN1(LINE)
                  WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) COL
                  DO ISTA = 1, NSTABB(IXX,IMODE)
                     DEL = COL
                     IF( ISTA .EQ. NSTABB(IXX,IMODE)) DEL = SEP
                     WRITE( LINE(LPOS+2:LPOS+4), '( A )' )
     1                   STCODE(STANUM(ISTABB(ISTA,IXX,IMODE)))
C
C                    reduce the spaces
C
                     LPOS = LEN1(LINE)
                     WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) DEL
C
C                    Check for too long line.
C
                     IF( LPOS .GT. MAXLINE - 8 ) THEN
                        CALL ERRLOG( 'VXWRMD: Too many stations '//
     1                    'for VEX MODE lines.  Change code?' )
                     END IF
                  END DO
               ELSE
                  WRITE( LINE, '( A1, 4X, A, A, A )' ) 
     1                COM, 'ref $BBC = ',
     2                BBLINK(IXX)(1:LEN1(BBLINK(IXX))),
     3                ' <= obsolete definition'
                  LPOS = LEN1(LINE)
               END IF
            END IF
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
C
C        write the Track section for this mode
C
         DO I = 1, NMODTR(IMODE)
            IXX = IMODTR(I,IMODE)
C
C           if there is just 1 TR, no need to split Ants
C
C           need all anyaway, set from 1 to -999
C
            IF( NMODTR(IMODE) .EQ. -999 ) THEN
               WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1             'ref $TRACKS = ',
     2             TRLINK(IXX)(1:LEN1(TRLINK(IXX)))
               LPOS = LEN1(LINE)
               WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) SEP
            ELSE
               IF( NSTATR(IXX,IMODE) .NE. 0 ) THEN
                  WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1                'ref $TRACKS = ',
     2                TRLINK(IXX)(1:LEN1(TRLINK(IXX)))
                  LPOS = LEN1(LINE)
                  WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) COL
                  DO ISTA = 1, NSTATR(IXX,IMODE)
                     DEL = COL
                     IF( ISTA .EQ. NSTATR(IXX,IMODE)) DEL = SEP
                     WRITE( LINE(LPOS+2:LPOS+4), '( A )' )
     1                   STCODE(STANUM(ISTATR(ISTA,IXX,IMODE)))
C
C                 reduce the spaces
C
                     LPOS = LEN1(LINE)
                     WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) DEL
C
C                    Check for too long line.
C
                     IF( LPOS .GT. MAXLINE - 8 ) THEN
                        CALL ERRLOG( 'VXWRMD: Too many stations '//
     1                    'for VEX MODE lines.  Change code?' )
                     END IF
                  END DO
               ELSE
                  WRITE( LINE, '( A1, 4X, A, A, A )' ) 
     1                COM, 'ref $TRACKS = ',
     2                TRLINK(IXX)(1:LEN1(TRLINK(IXX))),
     3                ' <= obsolete definition'
                  LPOS = LEN1(LINE)                  
               END IF
            END IF
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
C
C        write the HP section for this mode
C
         DO I = 1, NMODHP(IMODE)
            IXX = IMODHP(I,IMODE)
C           Count the number of stations in this mode that are using
C           tapes. HEADPOS is irrelevant if there are none.
            NTAPEST = 0
            DO ISTA = 1, NSTAHP(IXX,IMODE)
               IF( USETAPE((ISTAHP(ISTA,IXX,IMODE))) .OR. 
     1           DISK(STANUM(ISTAHP(ISTA,IXX,IMODE)))
     2             .EQ. 'LBADR' ) THEN
                  NTAPEST = NTAPEST + 1
               END IF
            END DO
C
C           if there is just 1 HP, no need to split Ants
C
C           need all anyaway, set from 1 to -999
C
            IF( NMODHP(IMODE) .EQ. -999 ) THEN
               WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1             'ref $HEAD_POS = ',
     2             HPLINK(IXX)(1:LEN1(HPLINK(IXX)))
               LPOS = LEN1(LINE)
               WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) SEP
            ELSE
               IF( NSTAHP(IXX,IMODE) .NE. 0 .AND. NTAPEST .GT. 0) THEN
                  WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1                'ref $HEAD_POS = ',
     2                HPLINK(IXX)(1:LEN1(HPLINK(IXX)))
                  LPOS = LEN1(LINE)
                  WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) COL
                  DO ISTA = 1, NSTAHP(IXX,IMODE)
                     IF( USETAPE((ISTAHP(ISTA,IXX,IMODE))) .OR.
     1                   DISK((STANUM(ISTAHP(ISTA,IXX,IMODE)))) 
     2                   .EQ. 'LBADR' ) THEN
                        DEL = COL
                        IF( ISTA .EQ. NSTAHP(IXX,IMODE)) DEL = SEP
                        WRITE( LINE(LPOS+2:LPOS+4), '( A )' )
     1                      STCODE(STANUM(ISTAHP(ISTA,IXX,IMODE)))
C     
C                    reduce the spaces
C
                        LPOS = LEN1(LINE)
                        WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) DEL
C
C                    Check for too long line.
C
                        IF( LPOS .GT. MAXLINE - 8 ) THEN
                           CALL ERRLOG( 'VXWRMD: Too many stations '//
     1                       'for VEX MODE lines.  Change code?' )
                     END IF
                     END IF
                  END DO
               ELSE
                  WRITE( LINE, '( A1, 4X, A, A, A )' ) 
     1                COM, 'ref $HEAD_POS = ',
     2                HPLINK(IXX)(1:LEN1(HPLINK(IXX))),
     3                ' <= obsolete definition'
                  LPOS = LEN1(LINE)                  
               END IF
            END IF
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
C
C        write the RL section for this mode
C
         DO I = 1, NMODRL(IMODE)
            IXX = IMODRL(I,IMODE)
C
C           if there is just 1 RL, no need to split Ants
C
C           need all anyaway, set from 1 to -999
C
            IF( NMODRL(IMODE) .EQ. -999 ) THEN
               WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1             'ref $ROLL = ',
     2             RLLINK(IXX)(1:LEN1(RLLINK(IXX)))
               LPOS = LEN1(LINE)
               WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) SEP
            ELSE
               IF( NSTARL(IXX,IMODE) .NE. 0 ) THEN
                  WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1                'ref $ROLL = ',
     2                RLLINK(IXX)(1:LEN1(RLLINK(IXX)))
                  LPOS = LEN1(LINE)
                  WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) COL
                  DO ISTA = 1, NSTARL(IXX,IMODE)
                     DEL = COL
                     IF( ISTA .EQ. NSTARL(IXX,IMODE)) DEL = SEP
                     WRITE( LINE(LPOS+2:LPOS+4), '( A )' )
     1                   STCODE(STANUM(ISTARL(ISTA,IXX,IMODE)))
C
C                 reduce the spaces
C
                     LPOS = LEN1(LINE)
                     WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) DEL
C
C                    Check for too long line.
C
                     IF( LPOS .GT. MAXLINE - 8 ) THEN
                        CALL ERRLOG( 'VXWRMD: Too many stations '//
     1                    'for VEX MODE lines.  Change code?' )
                     END IF
                  END DO
               ELSE
                  WRITE( LINE, '( A1, 4X, A, A, A )' ) 
     1                COM, 'ref $ROLL = ',
     2                RLLINK(IXX)(1:LEN1(RLLINK(IXX))),
     3                ' <= obsolete definition'
                  LPOS = LEN1(LINE)                  
               END IF
            END IF
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
C
C        write the PO section for this mode
C
         DO I = 1, NMODPO(IMODE)
            IXX = IMODPO(I,IMODE)
C
C           Count the number of stations in this mode that are using
C           tapes. PASS_ORDER is irrelevant if there are none.
            NTAPEST = 0
            DO ISTA = 1, NSTAHP(IXX,IMODE)
               IF( USETAPE((ISTAHP(ISTA,IXX,IMODE))) .OR.
     1            DISK((STANUM(ISTAHP(ISTA,IXX,IMODE)))) 
     2                .EQ. 'LBADR' ) THEN
                  NTAPEST = NTAPEST + 1
               END IF
            END DO
C
C           if there is just 1 PO, no need to split Ants
C
C           need all anyaway, set from 1 to -999
C
            IF( NMODPO(IMODE) .EQ. -999 ) THEN
               WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1             'ref $PASS_ORDER = ',
     2             POLINK(IXX)(1:LEN1(POLINK(IXX)))
               LPOS = LEN1(LINE)
               WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) SEP
            ELSE
              IF( NSTAPO(IXX,IMODE) .NE. 0 .AND. NTAPEST .GT. 0 ) THEN
                  WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1                'ref $PASS_ORDER = ',
     2                POLINK(IXX)(1:LEN1(POLINK(IXX)))
                  LPOS = LEN1(LINE)
                  WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) COL
                  DO ISTA = 1, NSTAPO(IXX,IMODE)
                     IF( USETAPE((ISTAPO(ISTA,IXX,IMODE))) .OR.
     1                   DISK((STANUM(ISTAPO(ISTA,IXX,IMODE)))) 
     2                   .EQ. 'LBADR' ) THEN
                        DEL = COL
                        IF( ISTA .EQ. NSTAPO(IXX,IMODE)) DEL = SEP
                        WRITE( LINE(LPOS+2:LPOS+4), '( A )' )
     1                      STCODE(STANUM(ISTAPO(ISTA,IXX,IMODE)))
C
C                 reduce the spaces
C
                       LPOS = LEN1(LINE)
                       WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) DEL
                     END IF
C
C                    Check for too long line.
C
                     IF( LPOS .GT. MAXLINE - 8 ) THEN
                        CALL ERRLOG( 'VXWRMD: Too many stations '//
     1                    'for VEX MODE lines.  Change code?' )
                     END IF
                  END DO
               ELSE
                  WRITE( LINE, '( A1, 4X, A, A, A )' ) 
     1                COM, 'ref $PASS_ORDER = ',
     2                POLINK(IXX)(1:LEN1(POLINK(IXX))),
     3                ' <= obsolete definition'
                  LPOS = LEN1(LINE)                  
               END IF
            END IF
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
C
C        write the PH section for this mode
C
         DO I = 1, NMODPH(IMODE)
            IXX = IMODPH(I,IMODE)
C
C           if there is just 1 PH, no need to split Ants
C
C           need all anyaway, set from 1 to -999
C
            IF( NMODPH(IMODE) .EQ. -999 ) THEN
               WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1             'ref $PHASE_CAL_DETECT = ',
     2             PHLINK(IXX)(1:LEN1(PHLINK(IXX)))
               LPOS = LEN1(LINE)
               WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) SEP
            ELSE
               IF( NSTAPH(IXX,IMODE) .NE. 0 ) THEN
                  WRITE( LINE, '( 5X, A, A, A1, A, A1 )' ) 
     1                'ref $PHASE_CAL_DETECT = ',
     2                PHLINK(IXX)(1:LEN1(PHLINK(IXX)))
                  LPOS = LEN1(LINE)
                  WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) COL
                  DO ISTA = 1, NSTAPH(IXX,IMODE)
                     DEL = COL
                     IF( ISTA .EQ. NSTAPH(IXX,IMODE)) DEL = SEP
                     WRITE( LINE(LPOS+2:LPOS+4), '( A )' )
     1                   STCODE(STANUM(ISTAPH(ISTA,IXX,IMODE)))
C
C                 reduce the spaces
C
                     LPOS = LEN1(LINE)
                     WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) DEL
C
C                    Check for too long line.
C
                     IF( LPOS .GT. MAXLINE - 8 ) THEN
                        CALL ERRLOG( 'VXWRMD: Too many stations '//
     1                    'for VEX MODE lines.  Change code?' )
                     END IF
                  END DO
               ELSE
                  WRITE( LINE, '( A1, 4X, A, A, A )' ) 
     1                COM, 'ref $PHASE_CAL_DETECT = ',
     2                PHLINK(IXX)(1:LEN1(PHLINK(IXX))),
     3                ' <= obsolete definition'
                  LPOS = LEN1(LINE)                  
               END IF
            END IF
            WRITE( IVEX, '( A )' ) LINE(1:LEN1(LINE))
         END DO
C
C        That's all, Folks!
C
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP  
      END DO
C
C     these were the SETUPS in mode section
C
      WRITE( IVEX, '( A )' ) COMLIN
      RETURN
      END

      DOUBLE PRECISION FUNCTION sla_GMST (UT1)
*+
*     - - - - -
*      G M S T
*     - - - - -
*
*  Conversion from universal time to sidereal time (double precision)
*
*  Given:
*    UT1    dp     universal time (strictly UT1) expressed as
*                  modified Julian Date (JD-2400000.5)
*
*  The result is the Greenwich mean sidereal time (double
*  precision, radians).
*
*  The IAU 1982 expression (see page S15 of 1984 Astronomical Almanac)
*  is used, but rearranged to reduce rounding errors.  This expression
*  is always described as giving the GMST at 0 hours UT.  In fact, it
*  gives the difference between the GMST and the UT, which happens to
*  equal the GMST (modulo 24 hours) at 0 hours UT each day.  In this
*  routine, the entire UT is used directly as the argument for the
*  standard formula, and the fractional part of the UT is added
*  separately.  Note that the factor 1.0027379... does not appear in the
*  IAU 1982 expression explicitly but in the form of the coefficient
*  8640184.812866, which is 86400x36525x0.0027379...
*
*  See also the routine sla_GMSTA, which delivers better numerical
*  precision by accepting the UT date and time as separate arguments.
*
*  Called:  sla_DRANRM
*
*  P.T.Wallace   Starlink   14 October 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION UT1

      DOUBLE PRECISION sla_DRANRM

      DOUBLE PRECISION D2PI,S2R
      PARAMETER (D2PI=6.283185307179586476925286766559D0,
     :           S2R=7.272205216643039903848711535369D-5)

      DOUBLE PRECISION TU



*  Julian centuries from fundamental epoch J2000 to this UT
      TU=(UT1-51544.5D0)/36525D0

*  GMST at this UT
      sla_GMST=sla_DRANRM(MOD(UT1,1D0)*D2PI+
     :                    (24110.54841D0+
     :                    (8640184.812866D0+
     :                    (0.093104D0-6.2D-6*TU)*TU)*TU)*S2R)

      END

      SUBROUTINE FMTS2( KS, OK )
C
C     Routine for SCHED called by SETFMT that sets the format 
C     for S2 systems for setup group KS.  It will attempt to 
C     set FORMAT, SPEEDUP, FANOUT, and TAPEMODE.  OK will 
C     return .TRUE. if it succeeds.  It will return .FALSE. 
C     if not, which for S2 should not happen.
C
      INCLUDE        'sched.inc'
      INCLUDE        'schset.inc'
C
      INTEGER        KS, TMODE, LEN1
      REAL           TBPR, RECBPS
      LOGICAL        OK
C
C     Fix the bit rate for a recorder.
C 
      PARAMETER      (RECBPS=16.0)
C ---------------------------------------------------------------------
C   
C     FORMAT is already set or we wouldn't be in this routine.
C     I think the format is totally determined by the total bit rate.
C
      IF( FANOUT(KS) .NE. 0.0 ) GO TO 999
C
C     TAPEMODE is the number of passes through the N recorders
C     at RECBPS Mbps per recorder.
C
      TBPR = NCHAN(KS) * SAMPRATE(KS) * BITS(1,KS)
      TMODE = NINT( RECBPS * STNDRIV(ISETSTA(KS)) / TBPR )
      IF( TAPEMODE(KS) .GT. 0 ) THEN
         IF( TAPEMODE(KS) .NE. TMODE ) THEN
            CALL WLOG( 1, 
     1        'FMTS2: FORMAT S2 TPMODE does not seem appropriate' )
            MSGTXT = ' ' 
            WRITE( MSGTXT, '( A, I5, A, I5 )' ) 
     1         '        User supplied TPMODE =', TAPEMODE(KS), 
     2         ' - appropriate value for format = ', TMODE
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, '      Setup file: ' //
     1         SETNAME(KS)(1:LEN1(SETNAME(KS))) )
         END IF
      ELSE
         TAPEMODE(KS) = TMODE
      END IF
C 
C     I don't really know what fanout and speedup should be.  But
C     assume that FANOUT is sample rate/16
C 
      FANOUT(KS) = SAMPRATE(KS) / RECBPS
      SPEEDUP(KS) = 1.0
C
  999 CONTINUE
      OK = .TRUE.
      RETURN
      END

      CHARACTER*32 FUNCTION VXNMHP( IXX )
C
C     Routine specific for the VEX extension of SCHED
C     function generates a name for HP block IXX
C     for now it is all 14 track, except for S2
C     By H.J. van Langevelde, JIVE, 010996
C
C     Removed tape section July 22, 2010 RCW.
C     Allow OBSTYPE NONE or PTVLBA.  Nov. 14, 2011.
C     Note that the HP block is the head position block, 
C     which is basically obsolete.
C     Dec. 8, 2011.  Note that all observations that are recording
C     data will pass ok, even if there are FORMAT=NONE scans.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C      
      INTEGER IXX, ASTAT
      INTEGER KS, ISTA
C ----------------------------------------------------------------------
C     
C     Different for S2 (meaningless)
C
      KS = HPISSET(IXX)
      IF( FORMAT(KS) .EQ. 'S2' ) THEN
         VXNMHP = 'S2Void'
      ELSE IF( FORMAT(KS) .EQ. 'LBA' ) THEN
         VXNMHP = 'LBAVoid'
      ELSE
C
C     Check if two heads applies
C
         DO ISTA = 1, NSTA
            IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,KS))
     4            ASTAT = ISTA
         END DO
C
         IF( USEDISK(ASTAT) .OR. OBSTYP .EQ. 'PTVLBA' .OR.
     1       OBSTYP .EQ. 'NONE' .OR. FORMAT(KS)(1:4) .EQ. 'NONE' ) THEN
            VXNMHP = 'DiskVoid'
         ELSE
            CALL ERRLOG('VXNMHP: Not using disks at '//
     1           STATION(STANUM(ASTAT))// '!' )
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE VXSTLI( IXX, NSTAXX, ISTAXX )
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a comment line to indicate which stations used by def
C     By H.J. van Langevelde, JIVE, 051296 
C
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C
      INTEGER   IXX,NSTAXX(MAXMOD,MAXMOD), ISTAXX(MAXSTA,MAXMOD,MAXMOD)
C
      INTEGER   ISTA, LPOS, LEN1, IMODE
C From commented code: ISET, VXGTST
      CHARACTER LINE*132
C ----------------------------------------------------------------------
C
      DO IMODE = 1, NMDVEX
C
C        Find the sched setup corresponding to this mode so we can check
C        the format
C        RCW Dec 2011.  Don't filter the FORMAT=NONE cases.
C        RCW Apr 2012.  These are comment lines so the total length
C        should not exceed 128 characters.
C
C         ISET = VXGTST( IMODE )
C         IF( FORMAT(ISET)(1:4) .NE. 'NONE' .OR. 
C     1       OBSTYP .EQ. 'PTVLBA' ) THEN
           IF ( NSTAXX(IXX,IMODE) .GT. 0 ) THEN
              WRITE( LINE, '( A1, A, I2, 4X, A )' ) 
     1            COM, ' mode = ', IMODE, 'stations = '
              DO ISTA = 1, NSTAXX(IXX,IMODE)
C
C                Break the line if this station is going to
C                push it over the 128 character comment limit.
C
                 LPOS = LEN1( LINE )
                 IF( LPOS + 1 + 
     1              LEN1(STCODE(STANUM(ISTAXX(ISTA,IXX,IMODE))))
     2              .GE. 128 ) THEN
                    WRITE(IVEX, '( A )' ) LINE(1:LPOS)
                    LINE = ' '
                    WRITE( LINE, '( A1 )' ) COM
                    LPOS = 25
                 END IF
C
C                Write the station code.
C
                 WRITE( LINE(LPOS+1:LPOS+3), '( A )' )
     1               STCODE(STANUM(ISTAXX(ISTA,IXX,IMODE)))
C
C                Reduce the spaces and add the colon.
C
                 LPOS = LEN1( LINE )
                 IF( ISTA .NE. NSTAXX(IXX,IMODE) ) THEN 
                    WRITE( LINE(LPOS+1:LPOS+1), '( A1 )' ) COL
                    LPOS = LPOS+1
                 END IF
              END DO
C
C             Write out the line (or last line if it was broken).
C
              WRITE(IVEX, '( A )' ) LINE(1:LEN1(LINE))
C
           END IF
C         END IF
      END DO
C
      RETURN
      END
   

      SUBROUTINE SCHDEFS( FTYPE, FILENAME )
C
C     Routine for SCHED, which can be machine dependent, to hold the
C     default file names for SCHED.  It can be called by a variety
C     of routines.
C
C     This is the Unix/Linux version.
C
      CHARACTER    FTYPE*(*), FILENAME*(*)
Cf2py intent(in, out) FILENAME
      CHARACTER    FTEXT*80
C----------------------------------------------------------------------
      IF( FTYPE .EQ. 'location' ) THEN
         FILENAME = '$SCHED/catalogs/locations.dat'
      ELSE IF( FTYPE .EQ. 'stations' ) THEN
         FILENAME = '$SCHED/catalogs/stations_RDBE.dat'
      ELSE IF( FTYPE .EQ. 'sources' ) THEN
C
C        This could be sources.gsfc or sources.petrov.
C        sources.gsfc has more aliases.  Use it.
C        sources.petrov has many more sources as of Feb. 2015
C
         FILENAME = '$SCHED/catalogs/sources.gsfc'
      ELSE IF( FTYPE .EQ. 'frequency' ) THEN
         FILENAME = '$SCHED/catalogs/freq_RDBE.dat'
      ELSE IF( FTYPE .EQ. 'peakcommand' ) THEN
         FILENAME = '$SCHED/catalogs/peak.cmd'
      ELSE IF( FTYPE .EQ. 'refpointing' ) THEN
         FILENAME = '$SCHED/catalogs/sources.peak'
      ELSE IF( FTYPE .EQ. 'messages' ) THEN
         FILENAME = '$SCHED/catalogs/messages.txt'
      ELSE
         FTEXT = 'SCHFILES: Unrecognized file type:' // FTYPE
         CALL PUTOUT( FTEXT )
         CALL ERROR( 'Programming problem' )
      END IF
C
      RETURN
      END

      SUBROUTINE CHKFIRM
C
C     Routine called by DEFSET that checks that the firmware
C     specified by DBE in the setup file and the DAR
C     specified in the station catalog are compatible. 
C
C     Might some FORMAT checks go here too?
C
C     This routine used to set the DBE if needed.  But that violates
C     the overall SCHED logic of setting everything possible before 
C     making the checks.  So I split that out to SETFIRM on Oct. 
C     31, 2013.  RCW.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER   KS, KSTA, LEN1
      LOGICAL   GOTERR
C ----------------------------------------------------------------
C
C     Loop over the setup files.
C
      GOTERR = .FALSE.
      DO KS = 1, NSET
         KSTA = ISETSTA(KS)
C
C        Note that all VLBA stations (all RDBE stations?) will be
C        RDBE2.  Somewhere else, protect against using the PFB with
C        more than one RDBE (the fixed output bit rate doesn't allow
C        that.
C
         IF( DAR(KSTA)(1:4) .EQ. 'RDBE' ) THEN
            IF( DBE(KS) .NE. 'RDBE_PFB' .AND.
     1          ( DBE(KS) .NE. 'RDBE_DDC' .AND. NCHAN(KS) .LE. 8 )) THEN
               GOTERR = .TRUE.
            END IF
C
         ELSE IF( DAR(KSTA) .EQ. 'DBBC' ) THEN
            IF( DBE(KS) .NE. 'DBBC_PFB' .AND. 
     1          DBE(KS) .NE. 'DBBC_DDC' ) THEN
               GOTERR = .TRUE.
            END IF
         ELSE IF( DAR(KSTA) .EQ. 'WIDAR' ) THEN
            IF( DBE(KS) .NE. 'WIDAR' ) THEN
               GOTERR = .TRUE.
            END IF
         ELSE
            IF( DBE(KS) .NE. ' ' ) THEN
               GOTERR = .TRUE.
            END IF
         END IF
C
C        Write the error message and die.
C
         IF( GOTERR ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( 5A, I4, 2A )' ) 'CHKFIRM:  Invalid DBE (',
     1         DBE(KS)(1:LEN1(DBE(KS))),
     2         ') specified for DAR = ', 
     3         DAR(KSTA)(1:LEN1(DAR(KSTA))), 
     4         ' and NCHAN=', NCHAN(KS), ' at station ', 
     5         SETSTA(1,KS)(1:LEN1(SETSTA(1,KS)))
            CALL WLOG( 1, MSGTXT )
            MSGTXT = ' '
            MSGTXT = 
     1         '          Are you using the right station catalog?' 
            CALL ERRLOG( MSGTXT )
         END IF
      END DO
      RETURN
      END

      SUBROUTINE AZELXYEW( AZ, EL, X, Y, RADDEG )
C
C     Routine for sched that converts Az and El to X and Y for
C     checking limits and slews at XYEW mount antennas.  Such 
C     antennas have a fixed E-W axel.  Adapted from azelxyns.f
C
C   ***********  I don't really know if this is right.  Same for XYNS.
C     The sign conventions are especially uncertain.  Fortunately,
C     Hobart, the only XYEW antenna I am aware of, has symmetric 
C     limits.
C
C     Az is clockwise from north looking down.
C     El is El
C     X is clockwise from up looking west (positive to north).
C     Y is clockwise from up looking north when x=0 (positive to east).
C     The fixed axis is the EW axis.
C
      REAL              AZ, EL, X, Y, ELADJ
      DOUBLE PRECISION  AZR, ELR, XR, YR, DIAG, HT, EST, STH
      DOUBLE PRECISION  RADDEG
C -------------------------------------------------------------------
C     There is a dead zone just off the end of the axis in the
C     east and west direction at the horizon.  To protect against
C     it, do not allow the elevation to be right at the horizon.
C     The change is small and, since no observations should be done
C     in the position anyway, should be benign.
C
      ELADJ = EL
      IF( EL .LT. 0.02 .AND. EL .GE. 0.0 ) ELADJ = 0.02
      IF( EL .GT. -0.02 .AND. EL .LT. 0.0 ) ELADJ = -0.02
C
C     Get the radian equivalents of the angles.
C
      AZR = AZ * RADDEG
      ELR = ELADJ * RADDEG
C
C     We need to use ATAN2 to be sure of getting below horizon stuff
C     right.  This just helps sense out-of-limit conditions.
C
      HT = SIN( ELR )
      STH = COS( ELR ) * COS( AZR )
      EST = COS( ELR ) * SIN( AZR )
      DIAG = HT**2.D0 + STH**2.D0
C
C     Protect against round off problems.
C
      IF( DIAG .LT. 0.D0 ) THEN
         DIAG = 0.D0
      ELSE
         DIAG = SQRT( DIAG )
      END IF
C
C     Now X and Y.
C
      XR = ATAN2( STH, HT )
      YR = ATAN2( EST, DIAG )
      X = XR / RADDEG
      Y = YR / RADDEG
C
      RETURN
      END

      SUBROUTINE VXTRAN ( TRANLEN, ISCN, ISTA, GAPERR )
C
C     Routine for the VEX extension of SCHED.
C     Calculates how long an ftp scan will take to copy from the Mark5
C     to the linux disk. If this is longer than the gap at the end of
C     the scan, issue a warning.
C     C. Reynolds JIVE, 30 Sep 2004
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
C     variables
C     
      INTEGER   TRANLEN, ISCN, ISTA
      REAL BITRATE, TRANTIME, SCNGAP
      LOGICAL GAPERR
C 
C ----------------------------------------------------------------------
C
      IF (DEBUG) CALL WLOG( 1,'VXTRAN: Check transfer time for ftp'//
     1          ' scans')
      GAPERR = .FALSE.
C
C     get the data rate for the current scan. First need the setup for
C     current scan
C
      BITRATE = TOTBPS( NSETUP(ISCN, ISTA) )
C
C     estimate how long it will take to transfer the data based on an
C     assumed baud rate and including some latency
C
      TRANTIME = 5. + REAL (TRANLEN) * BITRATE /110.
C
C     Calculate the gap before the next scan and warn if too short
C
      SCNGAP = REAL( ( STARTJ(ISCN+1) - STOPJ (ISCN) ) * 86400.d0)
      IF ( SCNGAP .LT. TRANTIME ) THEN
        WRITE ( MSGTXT, '(A, A, A, I6, A)' )     
     1      'VXTRAN: You have scheduled an ftp (GRABTO) scan but you ',
     2      'have not left a long enough gap to transfer the data ',
     3      'before the next scan starts. Try inserting a gap of',
     4      NINT (TRANTIME) + 1, ' seconds after the ftp scan:'
        CALL WLOG ( 1, MSGTXT )
        CALL SCANID ( 1, ISCN, ISTA )
        GAPERR = .TRUE.
      END IF
C
      RETURN
      END

C*DWCASE -- convert character string to lower case
C+
      SUBROUTINE DWCASE (SRC)
      CHARACTER*(*) SRC
C
C Convert character string to lower case; all upper case letters
C (A-Z) are converted to upper case equivalents (a-z); other characters
C are unchanged. This version assumes the ASCII character set.
C
C Arguments:
C  SRC    (in/out) : input string to be converted.
C
C History:
C  1987 nov 12 - TJP.  UPCASE
C  1991 apr 1  - RCW.  Adapted for lower case.
C-----------------------------------------------------------------------
      INTEGER I, K
C
      DO 10 I=1,LEN(SRC)
          K = ICHAR(SRC(I:I))
          IF (K.GE.ICHAR('A') .AND. K.LE.ICHAR('Z'))
     1         SRC(I:I) = CHAR(K+32)
   10 CONTINUE
C
      END

      SUBROUTINE sla_FK45Z (R1950,D1950,BEPOCH,R2000,D2000)
*+
*     - - - - - -
*      F K 4 5 Z
*     - - - - - -
*
*  Convert B1950.0 FK4 star data to J2000.0 FK5 assuming zero
*  proper motion in the FK5 frame (double precision)
*
*  This routine converts stars from the old, Bessel-Newcomb, FK4
*  system to the new, IAU 1976, FK5, Fricke system, in such a
*  way that the FK5 proper motion is zero.  Because such a star
*  has, in general, a non-zero proper motion in the FK4 system,
*  the routine requires the epoch at which the position in the
*  FK4 system was determined.
*
*  The method is from Appendix 2 of Ref 1, but using the constants
*  of Ref 4.
*
*  Given:
*     R1950,D1950     dp    B1950.0 FK4 RA,Dec at epoch (rad)
*     BEPOCH          dp    Besselian epoch (e.g. 1979.3D0)
*
*  Returned:
*     R2000,D2000     dp    J2000.0 FK5 RA,Dec (rad)
*
*  Notes:
*
*  1)  The epoch BEPOCH is strictly speaking Besselian, but
*      if a Julian epoch is supplied the result will be
*      affected only to a negligible extent.
*
*  2)  Conversion from Besselian epoch 1950.0 to Julian epoch
*      2000.0 only is provided for.  Conversions involving other
*      epochs will require use of the appropriate precession,
*      proper motion, and E-terms routines before and/or
*      after FK45Z is called.
*
*  3)  In the FK4 catalogue the proper motions of stars within
*      10 degrees of the poles do not embody the differential
*      E-term effect and should, strictly speaking, be handled
*      in a different manner from stars outside these regions.
*      However, given the general lack of homogeneity of the star
*      data available for routine astrometry, the difficulties of
*      handling positions that may have been determined from
*      astrometric fields spanning the polar and non-polar regions,
*      the likelihood that the differential E-terms effect was not
*      taken into account when allowing for proper motion in past
*      astrometry, and the undesirability of a discontinuity in
*      the algorithm, the decision has been made in this routine to
*      include the effect of differential E-terms on the proper
*      motions for all stars, whether polar or not.  At epoch 2000,
*      and measuring on the sky rather than in terms of dRA, the
*      errors resulting from this simplification are less than
*      1 milliarcsecond in position and 1 milliarcsecond per
*      century in proper motion.
*
*  References:
*
*     1  Aoki,S., et al, 1983.  Astron.Astrophys., 128, 263.
*
*     2  Smith, C.A. et al, 1989.  "The transformation of astrometric
*        catalog systems to the equinox J2000.0".  Astron.J. 97, 265.
*
*     3  Yallop, B.D. et al, 1989.  "Transformation of mean star places
*        from FK4 B1950.0 to FK5 J2000.0 using matrices in 6-space".
*        Astron.J. 97, 274.
*
*     4  Seidelmann, P.K. (ed), 1992.  "Explanatory Supplement to
*        the Astronomical Almanac", ISBN 0-935702-68-7.
*
*  Called:  sla_DCS2C, sla_EPJ, sla_EPB2D, sla_DCC2S, sla_DRANRM
*
*  P.T.Wallace   Starlink   21 September 1998
*
*  Copyright (C) 1998 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION R1950,D1950,BEPOCH,R2000,D2000

      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925287D0)

      DOUBLE PRECISION W
      INTEGER I,J

*  Position and position+velocity vectors
      DOUBLE PRECISION R0(3),A1(3),V1(3),V2(6)

*  Radians per year to arcsec per century
      DOUBLE PRECISION PMF
      PARAMETER (PMF=100D0*60D0*60D0*360D0/D2PI)

*  Functions
      DOUBLE PRECISION sla_EPJ,sla_EPB2D,sla_DRANRM

*
*  CANONICAL CONSTANTS  (see references)
*

*  Vectors A and Adot, and matrix M (only half of which is needed here)
      DOUBLE PRECISION A(3),AD(3),EM(6,3)
      DATA A,AD/ -1.62557D-6,  -0.31919D-6, -0.13843D-6,
     :           +1.245D-3,    -1.580D-3,   -0.659D-3/

      DATA (EM(I,1),I=1,6) / +0.9999256782D0,
     :                       +0.0111820610D0,
     :                       +0.0048579479D0,
     :                       -0.000551D0,
     :                       +0.238514D0,
     :                       -0.435623D0 /

      DATA (EM(I,2),I=1,6) / -0.0111820611D0,
     :                       +0.9999374784D0,
     :                       -0.0000271474D0,
     :                       -0.238565D0,
     :                       -0.002667D0,
     :                       +0.012254D0 /

      DATA (EM(I,3),I=1,6) / -0.0048579477D0,
     :                       -0.0000271765D0,
     :                       +0.9999881997D0,
     :                       +0.435739D0,
     :                       -0.008541D0,
     :                       +0.002117D0 /



*  Spherical to Cartesian
      CALL sla_DCS2C(R1950,D1950,R0)

*  Adjust vector A to give zero proper motion in FK5
      W=(BEPOCH-1950D0)/PMF
      DO I=1,3
         A1(I)=A(I)+W*AD(I)
      END DO

*  Remove e-terms
      W=R0(1)*A1(1)+R0(2)*A1(2)+R0(3)*A1(3)
      DO I=1,3
         V1(I)=R0(I)-A1(I)+W*R0(I)
      END DO

*  Convert position vector to Fricke system
      DO I=1,6
         W=0D0
         DO J=1,3
            W=W+EM(I,J)*V1(J)
         END DO
         V2(I)=W
      END DO

*  Allow for fictitious proper motion in FK4
      W=(sla_EPJ(sla_EPB2D(BEPOCH))-2000D0)/PMF
      DO I=1,3
         V2(I)=V2(I)+W*V2(I+3)
      END DO

*  Revert to spherical coordinates
      CALL sla_DCC2S(V2,W,D2000)
      R2000=sla_DRANRM(W)

      END

      SUBROUTINE sla_CS2C (A, B, V)
*+
*     - - - - -
*      C S 2 C
*     - - - - -
*
*  Spherical coordinates to direction cosines (single precision)
*
*  Given:
*     A,B      real      spherical coordinates in radians
*                           (RA,Dec), (long,lat) etc.
*
*  Returned:
*     V        real(3)   x,y,z unit vector
*
*  The spherical coordinates are longitude (+ve anticlockwise looking
*  from the +ve latitude pole) and latitude.  The Cartesian coordinates
*  are right handed, with the x axis at zero longitude and latitude, and
*  the z axis at the +ve latitude pole.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      REAL A,B,V(3)

      REAL COSB



      COSB = COS(B)

      V(1) = COS(A)*COSB
      V(2) = SIN(A)*COSB
      V(3) = SIN(B)

      END

      SUBROUTINE RECCTL
C
C     Set the system dependent defaults for PRESTART and MINPAUSE.
C     This routine for SCHED is called by DEFAULTs.
C
C     There is some discussion of what to do here.  For most of the 
C     modern systems, setting both to zero is appropriate.  But some
C     systems need some time to get started and synced.  We're still
C     debating the best course.  It will likely depend on the control
C     system and recorder.
C
C     Note that the field system has a built-in 10s minimum pause that
C     is apparently controllable in the VEX file (but I haven't found
C     the parameter).  This might serve to apply MINPAUSE there without
C     subjecting systems that don't need it to the offset start time.
C
C     So SCHED could just not worry, but then the disk space
C     calculations could be off.  Perhaps I could account for this at
C     the time of the space calculation.  It could be done by station
C     there, but not here (MINPAUSE is global in the scan).
C
C     Apparently MARKIV systems need about 4 seconds to get going.
C     See email from Ed Himwich Dec 30, 2013.  DBBC systems and VLBA5
C     did not take a significant time.
C
C     It seems that the direction is toward not needing these parameters
C     so make that the default, although acknowledge the field system
C     10 sec internal MINPAUSE.
C

C  The following is meant to be temporary until we decide what to do.
C     For now
C     Set both to zero for the RDBE/VLBA, WIDAR and RDBE with control 
C     systems (eg GBT).  For the DBBC, use PRESTART=0, but acknowledge
C     the defacto MINPAUSE=10.  So here is the desired outcome from
C     an email from RCW on Dec. 19, 2013:
C     PRESTART = 0 if only the following combinations are present:
C           DAR=RDBE
C           DAR=WIDAR
C           DAR=DBBC
C           DAR=LBA
C     PRESTART = 5 if anything else is present
C 
C     MINPAUSE = 0 if only the following combinations are present:
C           DAR=RDBE  CONTROL=VLBA
C           DAR=WIDAR
C           DAR=LBA
C     MINPAUSE = 10 if anything else, including DBBC, is present.
C
C     Note that MINPAUSE and PRESTART influence the global scan 
C     start time so they are common to all antennas.  They are 
C     allowed to vary from scan to scan.  Note that with the VLBA,
C     the data good time from VEX is used as the start time of 
C     recordings so these parameters don't have much effect.  The
C     Field System uses the nominal start time.
C
C     Routine started Dec. 2013  RCW.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    ISCN, ISTA, KSTA
      LOGICAL    USEPS5, USEMP10
C     LOGICAL    USE0
C --------------------------------------------------------------------------
C     Note that PRESTART and MINPAUSE are experiment wide so use the
C     highest wanted by any of the systems.
C
      USEPS5 = .FALSE.
      USEMP10 = .FALSE.
      DO ISTA = 1, NSTA
         KSTA = STANUM(ISTA)
C
C        Only use 5 second prestart for VLBA legacy system and
C        Mark IV.
C
         IF( DAR(KSTA) .EQ. 'VLBA' .OR. DAR(KSTA) .EQ. 'MKIV' )
     1       USEPS5 = .TRUE.
C
C        Only use 10 second minpause for the field system and
C        the VLBA legacy system.
C
         IF( ( CONTROL(KSTA) .EQ. 'VEX' .AND. DAR(KSTA) .NE. 'WIDAR' )
     1       .OR. DAR(KSTA) .EQ. 'VLBA' )  USEMP10 = .TRUE.
C
      END DO

C
C     Actually set the default values.
C
      DO ISCN = SCAN1, SCANL
         IF( USEPS5 ) THEN
            IF( PRESTART(ISCN) .EQ. UNSET * ONESEC ) 
     1            PRESTART(ISCN) = 5.D0 * ONESEC
         ELSE
            IF( PRESTART(ISCN) .EQ. UNSET * ONESEC ) 
     1          PRESTART(ISCN) = 0.D0
         END IF
         IF( USEMP10 ) THEN
            IF( MINPAUSE(ISCN) .EQ. UNSET * ONESEC ) 
     1            MINPAUSE(ISCN) = 10.D0 * ONESEC
         ELSE
            IF( MINPAUSE(ISCN) .EQ. UNSET * ONESEC ) 
     1          MINPAUSE(ISCN) = 0.D0
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE sla_PREBN (BEP0, BEP1, RMATP)
*+
*     - - - - - -
*      P R E B N
*     - - - - - -
*
*  Generate the matrix of precession between two epochs,
*  using the old, pre-IAU1976, Bessel-Newcomb model, using
*  Kinoshita's formulation (double precision)
*
*  Given:
*     BEP0    dp         beginning Besselian epoch
*     BEP1    dp         ending Besselian epoch
*
*  Returned:
*     RMATP  dp(3,3)    precession matrix
*
*  The matrix is in the sense   V(BEP1)  =  RMATP * V(BEP0)
*
*  Reference:
*     Kinoshita, H. (1975) 'Formulas for precession', SAO Special
*     Report No. 364, Smithsonian Institution Astrophysical
*     Observatory, Cambridge, Massachusetts.
*
*  Called:  sla_DEULER
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION BEP0,BEP1,RMATP(3,3)

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION BIGT,T,TAS2R,W,ZETA,Z,THETA



*  Interval between basic epoch B1850.0 and beginning epoch in TC
      BIGT = (BEP0-1850D0)/100D0

*  Interval over which precession required, in tropical centuries
      T = (BEP1-BEP0)/100D0

*  Euler angles
      TAS2R = T*AS2R
      W = 2303.5548D0+(1.39720D0+0.000059D0*BIGT)*BIGT

      ZETA = (W+(0.30242D0-0.000269D0*BIGT+0.017996D0*T)*T)*TAS2R
      Z = (W+(1.09478D0+0.000387D0*BIGT+0.018324D0*T)*T)*TAS2R
      THETA = (2005.1125D0+(-0.85294D0-0.000365D0*BIGT)*BIGT+
     :        (-0.42647D0-0.000365D0*BIGT-0.041802D0*T)*T)*TAS2R

*  Rotation matrix
      CALL sla_DEULER('ZYZ',-ZETA,THETA,-Z,RMATP)

      END

      SUBROUTINE SRINSERT( JSCN, KSRC, SRNAME, 
     1                     STARTK, STOPK, LASTISCN, MSCN )
Cf2py intent(in) JSCN, KSRC, SRNAME, STARTK, STOPK, LASTISCN, MSCN
C
C     Routine for SCHED used by ADDPEAK while adding pointing scans.
C     It could conceivably be used by others some day.  ADDPEAK 
C     takes a template scan and changes the times and source with
C     the help of this routine.  This action is done multiple times
C     so it was easier to split it out.  This routine gets the 
C     geometry and slew parameters for the new scan (JSCN) and for 
C     another, usually the one with the original target source (MSCN).
C     ADDPEAK is especially interested in the slew time between the
C     two, calculated under the assumption that MSCN immediately
C     follows JSCN for the stations involved in both.
C     This helps determine if there is adequate time for insertion
C     of scans like peaking scans and also helps determine which
C     possible source to use for an inserted scan.
C
C     KSRC is the source catalog list entry for the new source.
C     STARTK and STOPK are the new start and stop times.
C
C     STASCN is assumed to have been determined externally.
C
C     The first calls will be for hypothetical sources.  The final
C     one for the source/scan actually to be used.
C
      INCLUDE       'sched.inc'
      INCLUDE       'schpeak.inc'
C
      INTEGER            KSRC, JSCN, MSCN, LASTISCN(MAXSTA)
      INTEGER            LASTKSCN(MAXSTA), ISTA, NGOOD
      DOUBLE PRECISION   STARTK, STOPK
      CHARACTER          SRNAME*(*)
C ---------------------------------------------------------------------
      IF( DEBUG .AND. MSCN .LT. 5 ) CALL WLOG( 0, 'SRINSERT starting.' )
C
C     Put in the new source.  Also reset a variety of parameters that
C     probably don't have appropriate settings.  Note that some 
C     items like SETNUM and NSETUP will be added by MAKEPTG for pointing
C     scans.  For here, they will be left as for the original.
C
C     Treat the scan times as not adjustable.  DURONLY=6 will cause
C     appropriate constraints to be set in OPTTIM (new as of October 22, 
C     2013. RCW).
C
      PRESCAN(JSCN) = 0.D0
      DUR(JSCN)     = STOPK - STARTK
      GAP(JSCN)     = 0.D0
      STARTJ(JSCN)  = STARTK
      STOPJ(JSCN)   = STOPK
      SRCNUM(JSCN)  = KSRC
      IDOPSRC(JSCN) = KSRC
      QUAL(JSCN)    = 0
      DURONLY(JSCN) = 6
      DWELL(JSCN)   = .FALSE.
      ANNOT(JSCN)   = 
     1  'Following scan added by Sched for reference pointing'
      SCNSRC(JSCN)  = SRNAME
      DOPSRC(JSCN)  = SCNSRC(JSCN)
      VLAPHS(JSCN)  = SCNSRC(JSCN)
      IVLAPHS(JSCN) = SRCNUM(JSCN)
C
C     Get the last scans to use for the geometry calculations.
C
      DO ISTA = 1, NSTA
         IF( STASCN(JSCN,ISTA) ) THEN
            LASTKSCN(ISTA) = JSCN
         ELSE
            LASTKSCN(ISTA) = LASTISCN(ISTA)
         END IF
      END DO
C
C     Get the geometry for scans JSCN and MSCN using appropriate 
C     last scan arrays.
C
      CALL SCNGEO( LASTISCN, NGOOD, JSCN )
      CALL SCNGEO( LASTKSCN, NGOOD, MSCN )
C
      RETURN
      END

      SUBROUTINE MAKEPTG( LASTISCN, ISCN, KEEP )
Cf2py intent(in) LASTISCN, ISCN
Cf2py intent(in, out) KEEP
C
C     Subroutine for SCHED, called by SCHOPT, that converts a scan into
C     a reference pointing scan.  This involves:
C
C       Changing the antenna list to only include antennas that have
C       been specified as able to do reference pointing.
C
C       Change the setup file to the reference pointing setup file.
C
C     For the VLA, it also sets up non-pointing scans to use the
C     pointing results if any have been derived.
C
      INCLUDE     'sched.inc'
      INCLUDE     'schset.inc'
      INCLUDE     'schpeak.inc'
C
      INTEGER      ISCN, LASTISCN(*)
      LOGICAL      KEEP
C
      INTEGER      IGRP, NPST, ISTA, ICHN, IG, KS, ISRC
      INTEGER      USESET, USELSET, GNSET
      LOGICAL      USEGRP(MPKGRP), FIRST, DOCRD
      DOUBLE PRECISION  LVSTOP(MAXSTA)
      REAL         LVAZ(MAXSTA), LVEL(MAXSTA)
      SAVE         LVSTOP, LVAZ, LVEL, FIRST
      DATA         FIRST  / .TRUE. /
C ---------------------------------------------------------------------
      IF( DEBUG .AND. ISCN .LE. SCAN1 + 5 ) 
     1         CALL WLOG( 0, 'MAKEPTG starting' )
C
      IF( FIRST ) THEN
         DO ISTA = 1, NSTA
            LVSTOP(ISTA) = 0.D0
            LVAZ(ISTA) = 1.E5
            LVEL(ISTA) = 1.E5
         END DO
         FIRST = .FALSE.
      END IF
C
C     Get the source number
C
      ISRC = SRCNUM(ISCN)
C
C     Deal with a non-pointing scan.  For now, this only means setting
C     VLAPEAK to an appropriate value.  Don't change it if the user
C     has set it (values other than D).  Otherwise set it to T if
C     there has been a pointing scan recently and close enough.  The
C     tolerance limits should probably be input parameters some day.
C     Note that the default for LVSTOP should preclude setting 
C     VLAPEAK = T before any pointing has been done, including in
C     projects that don't involve pointing.
C
C     Note the on the VLBA, you can't turn off the use of the last
C     peak until the project code changes.  Once pointing is started,
C     it must be continued, which is why nothing can be done here.
C
C     It is assumed that the AZ and EL are already associated with
C     the scans, which should be true after ADDPEAK or the SCNGEO
C     call earlier in SCHOPT.
C
      IF( POINT(ISCN) .LT. 0 ) THEN
         DO ISTA = 1, NSTA
            IF( STATION(STANUM(ISTA))(1:3) .EQ. 'VLA' .AND.
     1          STASCN(ISCN,ISTA) ) THEN
C
               IF( VLAPEAK(ISCN) .EQ. 'DETERMINE' ) THEN
C
C                 Check if the last pointing was appropriate.
C
                  IF( STARTJ(ISCN)-LVSTOP(ISTA) .LT. 2.0D0 / 24.D0 .AND.
     1                ABS( AZ1(ISCN,ISTA) - LVAZ(ISTA) ) .LT. 50.0 .AND. 
     2                ABS( EL1(ISCN,ISTA)-LVEL(ISTA) ) .LT. 40.0 ) THEN
C
                     VLAPEAK(ISCN) = 'APPLY'
                  ELSE
                     VLAPEAK(ISCN) = 'OFF'
                  END IF
C
               END IF
C
            END IF
         END DO
C        
      ELSE
C
C        Peaking requested.  Be sure that a pointing file (peak.cmd or 
C        whatever) was provided.
C
         IF( NPKGRP .LE. 0 ) THEN
            WRITE( MSGTXT, '( 2A )' )
     1        'MAKEPTG: Automatic conversion of scans to pointing ',
     2        'was requested, but no pointing '
            CALL WLOG( 1, MSGTXT )
            MSGTXT = ' '
            WRITE( MSGTXT, '( 2A )' )
     1        '         groups are available.  This should not happen.'
            CALL WLOG( 1, MSGTXT )
            CALL ERRLOG( 'MAKEPTG:  Programming problem.' )
         END IF
C   
C        Get the peakup group.
C   
         IGRP = POINT(ISCN)
C
C        Set STASCN to only include stations in the peakup group.
C        If POINT=0, take stations in any group.
C        Count those stations and record which groups are used.
C   
         DO IG = 1, NPKGRP
            USEGRP(IG) = .FALSE.
         END DO
         NPST = 0
         DO ISTA = 1, NSTA
            STASCN(ISCN,ISTA) = STASCN(ISCN,ISTA) .AND.
     1           ( ( PKGROUP(ISTA) .EQ. IGRP .OR. 
     2           IGRP .EQ. 0 ) .AND. PKGROUP(ISTA) .NE. 0 )
            IF( STASCN(ISCN,ISTA) ) THEN
               NPST = NPST + 1
               USEGRP(PKGROUP(ISTA)) = .TRUE.
            END IF
         END DO
C   
C        Skip the scan if there are no stations in it after the above
C        selection.
C   
         IF( NPST .EQ. 0 ) THEN
            KEEP = .FALSE.
            RETURN
         END IF
C
C        If POINT is zero (IGRP=0), that means use any stations in
C        the pointing file.  Insist that all stations involved use 
C        the same setup file.  Check that to be sure.  Waited to here
C        so that we only check groups that were used.
C
         USESET = 0
         USELSET = 0
         IF( IGRP .EQ. 0 .AND. NPKGRP .GT. 1 ) THEN
            DO IG = 1, NPKGRP
C
               IF( USEGRP(IG) ) THEN
C
C                 Record the setup when first seen.
C
                  IF( USESET .EQ. 0 ) USESET = PKLSET(IG)
                  IF( USELSET .EQ. 0 ) USELSET = PKLSETL(IG)
C
C                 Look for a change that shouldn't happen.
C
                  IF( PKLSET(IG) .NE. USESET .OR. 
     1                PKLSETL(IG) .NE. USELSET) THEN
                     CALL WLOG( 1, 'MAKEPTG:  POINT was set to zero '//
     1                  '(or no value) for some scan and' )
                     CALL WLOG( 1, '          not all groups in the '//
     1                  'PEAKFILE use the same setup file' )
                     CALL WLOG( 1, '          or the same line '//
     1                  'setup file.')
                     CALL WLOG( 1, '          Either specify  '//
     1                  'pointing groups with POINT or use common '//
     2                  'pointing setups.' )
                     CALL ERRLOG( 
     1                  'MAKEPTG: change POINT or pointing setups.' )
                  END IF
C
               END IF
C
            END DO
         END IF
C   
C        Make the necessary conversions.  Assume that the source is
C        right - either set by the scheduler or added by ADDPEAK.
C   
C        Setup file.  Use different ones for line and continuum 
C        sources.
C   
         IF( CALCODE(SRCNUM(ISCN)) .NE. 'L' ) THEN
            SETNUM(ISCN) = PKLSET( MAX( 1, IGRP ) )      
         ELSE
            SETNUM(ISCN) = PKLSETL( MAX( 1, IGRP ) )      
         END IF
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
               NSETUP(ISCN,ISTA) = GNSET(ISCN,ISTA)
            END IF
         END DO
C   
C        Doppler specifications.
C          If the source did not have VLSR set, it was set to -1.E9.
C          If the bandwidth should be 2 MHz, the CALCODE is 'L', which
C          is also a flag to use the difference scheme for getting
C          pointing data (not implemented for reference pointing).
C   
C        If the RDBE_PFB is in use, use the CRD parameters, not the
C        main DOPCAL etc., because the PFB can't tune adequately.
C        Search all stations for a PFB.
C
         DOCRD = .FALSE.
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) THEN
               KS = NSETUP(ISCN,ISTA)
               IF( DBE(KS) .EQ. 'RDBE_PFB' ) DOCRD = .TRUE.
            END IF
         END DO
C
         IF( VLSR(1,SRCNUM(ISCN)) .GT. -1.E8 ) THEN
C
C           Needs doppler
C
            IF( DOCRD ) THEN
C
C              Don't set DOPCAL because we cannot tune the PFB.
C              Just set CRDDOP.
C
               GOTCRD(ISCN) = .TRUE.
               CRDDOP(ISCN) = .TRUE.
               CRDNCH(ISCN) = 2
               CRDSETCH(1,ISCN) = 1
               CRDSETCH(2,ISCN) = 2
               IF( CALCODE(ISRC) .EQ. 'L' ) THEN
                  DO ICHN = 1, MAXCHN
                     CRDBW(ICHN,ISCN) = 2.0D0
                  END DO
               ELSE
                  DO ICHN = 1, MAXCHN
                     CRDBW(ICHN,ISCN) = MIN( 16.D0, BBFILT(ICHN,KS) )
                  END DO
               END IF
               DO ICHN = 1, MAXCHN
                  CRDFREQ(ICHN,ISCN) = 0.0D0
               END DO
            ELSE
C
C              Not PFB, so tune the main channels.
C
               DOPCAL(ISCN) = .TRUE.
               DO ICHN = 1, MAXCHN
                  BW(ICHN,ISCN) = 2.0D0
                  FREQ(ICHN,ISCN) = 0.0D0
               END DO
            END IF
            PCAL(ISCN) = 'off'
         ELSE
C
C           Not a line source.  Set for continuum pointing.
C           Do not need any Doppler, crd or main.
C           Set for setup file bandwidth.

            DOPCAL(ISCN) = .FALSE.
            DO ICHN = 1, MAXCHN
               BW(ICHN,ISCN) = 0.0D0
            END DO
         END IF
C   
         TANT1(ISCN) = .FALSE.
         TANT2(ISCN) = .FALSE.
         NOTSYS(ISCN) = .TRUE.
         IF( DOPEAK(ISCN) .LE. 0 ) DOPEAK(ISCN) = 1
         LINES(ISCN) = PKLINES( MAX( 1, POINT(ISCN) ) )
         NOREC(ISCN) = .TRUE.
C   
C        Store the last time and position of a pointing scan for use 
C        in determining whether to use these results in future scans.  
C        This is really only useful for the VLA, so that is the 
C        only station filled in, but keep everything in arrays in case
C        it gets useful on other stations later.   While at it,
C        set the VLAMODE and VLAPEAK if the VLA is in the scan.
C        Not using the LASTISCN values because that might not have
C        been a pointing scan.
C        
C        For the VLA, assume we start fresh without using
C        previous solutions.  I am not setting up the AUTOPEAK
C        or POINT functions to handle double reference pointing yet.
C        We may not have the geometry yet so get what is needed.
C   
C        Again, assume that AZ and EL are already calculated.
C
         DO ISTA = 1, NSTA
            IF( ( STATION(STANUM(ISTA)) .EQ. 'VLA' .OR. 
     1          STATION(STANUM(ISTA)) .EQ. 'VLA27' ) .AND.
     2          STASCN(ISCN,ISTA) ) THEN
C
               LVSTOP(ISTA) = STOPJ(ISCN)
               LVAZ(ISTA) = AZ1(ISCN,ISTA)
               LVEL(ISTA) = EL1(ISCN,ISTA)
C
C              This IF block is redundant until other stations 
C              are involved.
C
               IF( STATION(STANUM(ISTA)) .EQ. 'VLA' .OR. 
     1             STATION(STANUM(ISTA)) .EQ. 'VLA27' ) THEN
                  VLAMODE(ISCN) = ' '
                  VLAPEAK(ISCN) = 'DETERMINE'
               END IF
            END IF
         END DO
C   
      END IF
C   
      RETURN
      END

      SUBROUTINE WLOG( TERM, MESSAGE )
C
C     Routine for SCHED that writes messages to the run log
C     and, optionally, to the terminal.
C
C     It should replace the old routine PUTOUT in most cases.
C
C     TERM should be 0 (write to log file only) or 1 (write to 
C     logfile and terminal).  Anything else is an error.
C
      INCLUDE  'sched.inc'
      INTEGER    TERM
      CHARACTER  MESSAGE*(*)
      INTEGER    LEN1, NCH
C-----------------------------------------------------------------------
C     Programming check:
C
      IF( TERM .NE. 0 .AND. TERM .NE. 1 ) THEN
         WRITE( ILOG, '( A, I10, /, A )' ) 
     1       'WLOG:  TERM not 0 or 1. Programming error.  TERM = ',
     2       TERM, ' The message being logged is:'
         WRITE( *, '( A, I10, /, A )' ) 
     1       'WLOG:  TERM not 0 or 1. Programming error.  TERM = ', 
     2       TERM, ' The message being logged is:'
      END IF
C
C
C     Get the length of the character string.  Don't get into trouble
C     with blanks.
C
      NCH = MAX( LEN1( MESSAGE ), 1 )
C
C     Write the string to the terminal if in DEBUG mode.  If there
C     is a crash, the log file doesn't necessarily get written.
C
      IF( DEBUG ) WRITE( *, '(A)' ) MESSAGE(1:NCH)
C
C     Write the string to the log file.
C
      WRITE( ILOG, '(A)' ) MESSAGE(1:NCH)
C
C     If TERM is 1, write to the screen too.
C     This should be discouraged except for error messages that 
C     explain an abort.
C
      IF( TERM .NE. 0 .AND. .NOT. DEBUG ) THEN
         WRITE (*,'(A)') MESSAGE(1:NCH)
      END IF
C
      RETURN
      END

      SUBROUTINE ENVIR( INFILE )
C
C     Subroutine for unix systems that looks for an environment variable
C     at the front of file name FILE (ie, it starts with $).  If one
C     is there, it expands it and returns FILE fully expanded.  
C     Otherwise it returns with FILE unmodified.
C
C     This uses the Fortran Library routine GETENV.
C
      CHARACTER    INFILE*(*), FILE*80, ENVNAM*80, ENVVAL*80
      INTEGER      ICHN, NCHF, LEN1, NECHF
C ---------------------------------------------------------------------
C     Avoid problems with systems (Linux) that don't like concatenation
C     with a subroutine argument declared *(*).
C
      FILE = INFILE
C
C     Check for $ as first character.
C
      IF( FILE(1:1) .EQ. '$' ) THEN
C
C        Get full length of the file name.
C
         NCHF = LEN1( FILE )
C
C        Get the length of the environment variable.  Assume it contains
C        no "/"s.  Anything after the "/" is to be added to the expanded
C        environment variable.  If there are no "/"s at all, assume that
C        the environment variable fully specifies the file.
C
         ICHN = INDEX( FILE, '/' ) - 1
         IF( ICHN .EQ. -1 ) ICHN = NCHF
C
C        Strip off the "$".
C
         ENVNAM = FILE(2:ICHN)
C
C        Expand the environment variable.
C
         CALL GETENV( ENVNAM, ENVVAL )
C
C        Reconstruct the file name.  Abort if the environment 
C        variable does not expand.
C
         IF( ENVVAL .NE. ' ' ) THEN
            IF( NCHF .GT. ICHN ) THEN
C
C              File is environment plus extra.  Be careful not to 
C              end up with "//".
C
               NECHF = LEN1(ENVVAL)
               IF( ENVVAL(NECHF:NECHF) .EQ. '/' ) NECHF = NECHF - 1
               INFILE = ENVVAL(1:NECHF)//FILE(ICHN+1:NCHF)
            ELSE
C
C              File is fully specified by the environment variable.
C
               INFILE = ENVVAL
            END IF
         ELSE
C
C           Abort with error.
C
            CALL ERROR( 'ENVIR: Cannot expand environment variable in '
     1           // FILE(1:LEN1(FILE)) )
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE VXWREX
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the EX = $EXPERIMENT section 
C     By H.J. van Langevelde, JIVE, 300496 
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
C     Huib's local variables 
C      
      INTEGER   YEAR, DAY, DOY, MONTH, JD
      INTEGER   ICH, JCH1(4), JCH2(4), NCH(4), MCH(4)
      INTEGER   LEN1, I
      CHARACTER VEXVAL*32, MNAME*3, DNAME*3, TMPEXP*32, TFORM*9, TTIME*9
      DOUBLE PRECISION STOPT,STARTT

C ----------------------------------------------------------------------
C     
      WRITE( IVEX, '( A, A1 )' ) '$EXPER', SEP
C     
C     We will have only one experiment, designated by it's name
C
      WRITE( IVEX, '( A1 )' ) COM
      TMPEXP = EXPCODE
      CALL VXSTNM( TMPEXP,.FALSE. )
      WRITE( IVEX, '( A, A, A1 )' ) 'def ',
     1    TMPEXP(1:LEN1(TMPEXP)), SEP
      TMPEXP = EXPCODE
      CALL VXSTKY( TMPEXP, .FALSE. )
      WRITE( IVEX, '( 5X, A, A, A1 )' ) 'exper_name = ',
     1    TMPEXP(1:LEN1(TMPEXP)), SEP
C
C     experiment description
C     protect against zero length strings where they are possible.
C
      WRITE( IVEX, '( 5X, A, A1, A, A1, A1 )' ) 'exper_description = ', 
     1     QOT, EXPT(1:MAX(1,LEN1(EXPT))), QOT, SEP
C
C     find PI name
C
      VEXVAL = PINAME(1:32)
      CALL VXSTKY( VEXVAL, .FALSE.)
      WRITE( IVEX, '( 5X, A, A, A1 )' ) 'PI_name = ', 
     1     VEXVAL(1:MAX(1,LEN1(VEXVAL))), SEP
C
C     PI e-mail
C
      VEXVAL = EMAIL(1:32)
      CALL VXSTKY( VEXVAL, .FALSE.)
      WRITE( IVEX, '( 5X, A, A, A1 )' ) 'PI_email = ', 
     1     VEXVAL(1:MAX(1,LEN1(VEXVAL))), SEP      
C
C     other stuff that we happen to have available goes
C     into comments, like adresses
C
      WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'address:   ', 
     1     ADDRESS(1)(1:MAX(1,LEN1(ADDRESS(1))))
      DO I = 2,4
         WRITE( IVEX, '( A1, 4X, A, A )' ) COM, '           ', 
     1       ADDRESS(I)(1:MAX(1,LEN1(ADDRESS(I))))
      END DO
      WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'phone:     ', 
     1     PHONE(1:MAX(1,LEN1(PHONE)))
      WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'during obs:', 
     1     OBSPHONE(1:MAX(1,LEN1(OBSPHONE)))
      WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'fax:       ', 
     1     FAX(1:MAX(1,LEN1(FAX)))
C
C     Write the notes.  The NOTE variables can be 128 characters
C     long, but VEX output lines can only be 128 characters.  
C     between the comment indicator COM and the blanks, there
C     are 16 characters before the start of the comment.  So there
C     is some hoop jumping to break a note into two lines if 
C     needed (more than 112 characters).  RCW Nov. 11, 2010.
C
      DO I = 1, 4
         JCH1(I) = -1
         NCH(I) = LEN1( NOTE(I) )
         IF( NCH(I) .LE. 112 ) THEN
            MCH(I) = NCH(I)
            JCH1(I) = 0
            JCH2(I) = 0
         ELSE
            DO ICH = 112, NCH(I) - 112 + 1, -1
               IF( NOTE(I)(ICH:ICH) .EQ. ' ' ) THEN
                  MCH(I) = ICH
                  JCH1(I) = ICH + 1
                  JCH2(I) = NCH(I)
                  GO TO 100
               END IF
            END DO
  100       CONTINUE
            IF( JCH1(I) .EQ. -1 ) THEN
               MCH(I) = 112
               JCH1(I) = 113
               JCH2(I) = NCH(I)
            END IF
         END IF
      END DO
      DO I = 1,4
         IF( NOTE(I) .NE. ' ' ) THEN
            IF( I .EQ. 1 ) THEN
               WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'notes:     ', 
     1                NOTE(I)(1:MCH(I))
            ELSE
               WRITE( IVEX, '( A1, 15X, A )' ) COM, 
     1                NOTE(I)(1:MCH(I))
            END IF
            IF( JCH1(I) .GT. 1 ) THEN
               WRITE( IVEX, '( A1, 18X, A )' ) COM,
     1                NOTE(I)(JCH1(I):JCH2(I))
            END IF
         END IF
      END DO
C
C     good idea to write some dates, computers should read $SCHED
C
C
      CALL TIMEJ( STOPJ(1), YEAR, DOY, STOPT )
      MONTH = 1
      DAY = DOY
      CALL TDATECW( YEAR, MONTH, DAY, JD, MNAME, DNAME )
C
      WRITE( IVEX, '( A1 )' ) COM
      WRITE( IVEX, '( A1, 4X, A, I4, A, I3 )' ) COM, 'year, doy: ', 
     1     YEAR,', ',DOY
      WRITE( IVEX, '( A1, 4X, A, A3, 1X, I2, 1X, A3, 1X, I4 )' )
     $    COM, 'date     : ', 
     1    DNAME, DAY, MNAME, YEAR
      WRITE( IVEX, '( A1, 4X, A, I5 )' ) COM, 'MJD      : ', 
     1    INT( JD - 2400000.5 )

C
C     Write experiment nominal start and end time
C
      CALL TIMEJ( STARTJ(1), YEAR, DOY, STARTT )
      TTIME = TFORM( STARTT, 'T', 0, 2, 2, 'hms' )
      WRITE( IVEX, '( 5X, A, I4, A, I3.3, A, A, A)' )  
     1      'exper_nominal_start=', YEAR,'y',DOY,'d', 
     2      TTIME, SEP
      CALL TIMEJ( STOPJ(SCANL), YEAR, DOY, STOPT )
      TTIME = TFORM( STOPT, 'T', 0, 2, 2, 'hms' )
      WRITE( IVEX, '( 5X, A, I4, A, I3.3, A, A, A)' )  
     1      'exper_nominal_stop=', YEAR,'y',DOY,'d', 
     2      TTIME, SEP
C
C     Include cover letter
C
      CALL VXCOVR( IVEX )
C
C     Target Correlator can be supplied
C
      VEXVAL = CORREL(1:32)
      CALL VXSTKY( VEXVAL, .FALSE.)
      IF( VEXVAL .NE. ' ' ) THEN
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( 5X, A, A, A1 )' ) 'target_correlator = ', 
     1     VEXVAL(1:MAX(1,LEN1(VEXVAL))), SEP
      END IF
C
C     Others correlation parameters currently in comments:
C
      IF( CORAVG .NE. 0. )  THEN
         WRITE( IVEX, '( A1 )' ) COM
         WRITE( IVEX, '( A1, 4X, A, F9.3, A )' ) COM, 
     1     'integr_time    : ',CORAVG, ' s'
      END IF
C
      IF( CORCHAN .NE. 0 ) 
     1     WRITE( IVEX, '( A1, 4X, A, I6 )' ) COM, 'number_channels:',
     2     CORCHAN
C
      IF( CORNANT .NE. 0 ) 
     1     WRITE( IVEX, '( A1, 4X, A, I3 )' ) COM, 'number_antenna :',
     2     CORNANT
C
      IF( CORPOL ) THEN 
         WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'cross_polarize : ',
     1       'Yes'
      ELSE
         WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'cross_polarize : ',
     1       'No'
      END IF
C
      IF( CORWTFN .NE. ' ' ) 
     1     WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'weight_func    : ',
     2     CORWTFN(1:MAX(1,LEN1(CORWTFN)))
C
      IF( CORTAPE .NE. ' ' ) 
     1     WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'distrib_medium : ',
     2     CORTAPE(1:MAX(1,LEN1(CORTAPE)))
C
      IF( CORDFMT .NE. ' ' ) 
     1     WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'distrib_format : ',
     2     CORDFMT(1:MAX(1,LEN1(CORDFMT)))
C
      IF( CORSRCS .NE. ' ' ) 
     1     WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'source_pos_cat : ',
     2     CORSRCS(1:MAX(1,LEN1(CORSRCS)))
C
      IF( CORSHIP(1) .NE. ' ' ) 
     1    WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'distribute_to  : '
      DO I = 1, 4
         IF( CORSHIP(I) .NE. ' ' ) 
     1       WRITE( IVEX, '( A1, 4X, A, A )' ) COM, '                 ',
     2       CORSHIP(I)(1:MAX(1,LEN1(CORSHIP(I))))
      END DO
C
      IF( CORNOTE(1) .NE. ' ' ) 
     1    WRITE( IVEX, '( A1, 4X, A, A )' ) COM, 'corr_notes : '
C
C     Like the NOTES above, write the CORNOTES without overflowing
C     the 128 character limit for VEX lines even though CORNOTES
C     input can be up to 128 characters and the output does not
C     start in column 1.  Try to break on word boundaries.
C     long, but VEX output lines can only be 128 characters.  
C     Between the comment indicator COM and the blanks, there
C     are 16 characters before the start of the comment.
C     RCW Nov. 21, 2010
C
      DO I = 1, 4
         JCH1(I) = -1
         NCH(I) = LEN1( CORNOTE(I) )
         IF( NCH(I) .LE. 112 ) THEN
            MCH(I) = NCH(I)
            JCH1(I) = 0
            JCH2(I) = 0
         ELSE
            DO ICH = 112, NCH(I) - 112 + 1, -1
               IF( CORNOTE(I)(ICH:ICH) .EQ. ' ' ) THEN
                  MCH(I) = ICH
                  JCH1(I) = ICH + 1
                  JCH2(I) = NCH(I)
                  GO TO 200
               END IF
            END DO
  200       CONTINUE
            IF( JCH1(I) .EQ. -1 ) THEN
               MCH(I) = 112
               JCH1(I) = 113
               JCH2(I) = NCH(I)
            END IF
         END IF
      END DO
      DO I = 1,4
         IF( CORNOTE(I) .NE. ' ' ) THEN
            WRITE( IVEX, '( A1, 15X, A )' ) COM,
     1                CORNOTE(I)(1:MCH(I))
            IF( JCH1(I) .GT. 1 ) THEN
               WRITE( IVEX, '( A1, 18X, A )' ) COM, 
     1                CORNOTE(I)(JCH1(I):JCH2(I))
            END IF
         END IF
      END DO
C
C     done for the day
C
      WRITE( IVEX, '( A1 )' ) COM
      WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP  
C
      WRITE( IVEX, '( A )' ) COMLIN
      RETURN
      END

      SUBROUTINE TWOHDSET
C
C     Routine for SCHED that warns the user of "twohead" mode
C     and sets the HEADMODE, which determines the positioning
C     of the heads as a function of pass in VLBA and MKIV systems.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
      INTEGER   ISTA 
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'TWOHDSET: starting' )
C
C     Let the user know that 2 head mode is being used.
C     Warn the user if any stations can't do it.  Those sations will
C     only record half the data.  Such stations should not now exist
C     after the switch to Mark5.  This will need further modification
C     soon for Mark5C (comment June 2009).
C
      IF( TWOHEAD ) THEN
         CALL WLOG( 1, 'TWOHDSET: Using 64 track mode for wide ' //
     1       'bandwidth.' )
      END IF
      IF( FASTTRK ) THEN
         CALL WLOG( 1, 'TWOHDSET:  Using 16 Mbps per track record '//
     1     'rate.  Mark IV format on disk only.' )
      END IF
C
C     Set the head mode (HEADMODE) to use for each station.  This
C     determines the pattern of head positions both in terms of
C     sequence and actual offsets.  All VLBA observations, and all
C     MarkIV single head observations use the same mode.  MarkIV
C     two head modes use a different mode, for which the number of
C     head positions is different from the single pass case.
C
C     For the Mark IV 2 head mode, set the number of passes per
C     head position to an appropriately low value, overriding
C     the default which is normally 14.  The tape initialization
C     parameters were rearranged to have a set for every station
C     in order to make this possible without messing up other
C     stations.
C
C     This is not relevant to disk recordings, but it doesn't hurt
C     to set it.
C
      DO ISTA = 1, NSTA
         IF( HEADMODE(ISTA) .EQ. ' ' ) THEN
            IF( TWOHEAD .AND. NHEADS(STANUM(ISTA)) .GT. 1 .AND.
     1          ( RECORDER(STANUM(ISTA)) .EQ. 'MKIV' .OR.
     2            RECORDER(STANUM(ISTA)) .EQ. 'VLBA4' ) ) THEN
               HEADMODE(ISTA) = 'MKIV2H'
            ELSE
               HEADMODE(ISTA) = 'VLBA14'
            END IF
         END IF
      END DO
      DO ISTA = 1, NSTA
         IF( HEADMODE(ISTA) .EQ. 'MKIV2H' ) THEN
            NHDPOS(ISTA) = 6
         END IF
      END DO
C
      RETURN
      END
      

      SUBROUTINE CHKRDBE( KS, ERRS )
Cf2py intent(in, out) ERRS
C
C     Routine for SCHED called by CHKSET that checks items related
C     to the use of the RDBE digital backend.
C
C     The frequency and bandwidth checks are broken out to a 
C     subroutine (CHKRDFQ) so that it can also be called by FSFREQ
C     to check in-schedule changes of frequency and bandwidth.
C
C     The RDBE PFB personality can only do lower sideband.  But
C     DiFX can invert sidebands.  So, if an upper sideband is
C     found, add the bandwidth to the BBC frequency and invert
C     the sideband.  Oct 11, 2011.
C
C     Add the dual RDBE case.  Nov. 8, 2012  RCW.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER           KS, ICH, IIF, MIF, NIF, KSTA, NNIF(4)
      INTEGER           LEN1
      LOGICAL           ERRS, SBWARN, IFNEW, OK4
      CHARACTER         USEDIFC(4)*2
      DATA              SBWARN / .TRUE. /
      SAVE              SBWARN
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKRDBE: Starting' )
C
C     ---------
C     Need to do something about the solar attenuators similar to 
C     the IFDIST entry for the VLBA DAR.
C     ---------
C
C     Get the station catalog number for the station.
C
      KSTA = ISETSTA(KS)
C
C     Set the usable number of IF (2 for RDBE, 4 for RDBE2)
C
      MIF = 2
      IF( DAR(KSTA) .EQ. 'RDBE2' .AND. FORMAT(KS) .EQ. 'VDIF' .AND.
     1    DBE(KS) .EQ. 'RDBE_DDC' ) MIF = 4
C
C     Check the format.  The current status as of Feb. 4, 2014 is:
C
C        PFB or DDC     NONE    ok
C        PFB  One RDBE  VDIF    Not implemented.
C        PFB  One RDBE  MARK5B  Ok
C        PFB  Two RDBE  Any     Can't do because of bit rate limitations.
C        DDC  All cases VDIF    Ok
C        DDC  One RDBE  MARK5B  No.  MARK5B/DDC support ended before Nov 2014.
C        DDC  Two RDBE  MARK5B  No.  Cannot be merged.
C
      IF( DBE(KS) .EQ. 'RDBE_PFB' .AND. ( FORMAT(KS) .NE. 'MARK5B' 
     1    .AND. FORMAT(KS) .NE. 'NONE' ) ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( 3A )' )
     1      'CHKRDBE:  Format ', FORMAT(KS), ' specified for setup ',
     2      SETNAME(KS)(1:LEN1(SETNAME(KS)))
         CALL WLOG( 1, MSGTXT )
         CALL WLOG( 1, '          It must be MARK5B for DBE=RDBE_PFB.' )
         ERRS = .TRUE.
      END IF
C
C     Now only need one DDC case and it does not depend on the number of
C     IFs.
C
      IF( DBE(KS) .EQ. 'RDBE_DDC' .AND.
     1    ( FORMAT(KS) .NE. 'VDIF' .AND. FORMAT(KS) .NE. 'NONE' ) ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( 3A )' )
     1      'CHKRDBE:  Format ', FORMAT(KS), ' specified for setup ',
     2      SETNAME(KS)(1:LEN1(SETNAME(KS)))
         CALL WLOG( 1, MSGTXT )
         CALL WLOG( 1, '          It must be VDIF or NONE' //
     1        'for DBE=RDBE_DDC.' )
         ERRS = .TRUE.
      END IF
C
      IF( VLBITP .AND. FORMAT(KS) .NE. 'NONE' ) THEN 
C
C        Make sure there are no more than 2 IFs requested for 
C        DAR=RDBE or 4 IFs for DAR=RDBE2.  Get a count of IFs and
C        number of channels per IF for later use.
C
         DO IIF = 1, 4
            USEDIFC(IIF) = ' '
            NNIF(IIF) = 0
         END DO
         NIF = 0
C
         DO ICH = 1, NCHAN(KS)
C
C           See if this channel's IF is one that is in lower 
C           numbered channels.
C
            IFNEW = .TRUE.
            IF( NIF .GE. 1 ) THEN
               DO IIF = 1, NIF
                  IF( IFCHAN(ICH,KS) .EQ. USEDIFC(IIF) ) THEN
                     IFNEW = .FALSE.
                     NNIF(IIF) = NNIF(IIF) + 1
                  END IF
               END DO
            END IF
C
C           If it is new, increment the count and add the IF to
C           the record of previously used ones.  Complain and die
C           if there are too many.
C           
            IF( IFNEW ) THEN
               NIF = NIF + 1
               IF( NIF .GT. MIF ) THEN
C
C                 Here we have a problem - too many IFs.
C
                  IF( MIF .EQ. 4 ) THEN
                     CALL WLOG( 1, 
     1                    'CHKRDBE: More than 4 IF''s requested '//
     2                    'for 2 RDBE station using the DDC and VDIF' )
                  ELSE
                     CALL WLOG( 1, 
     1                    'CHKRDBE: More than 2 IF''s requested '//
     2                    'for single RDBE station or PFB '//
     3                    'or format other than VDIF' )
                  END IF
                  ERRS = .TRUE.
               END IF
               NNIF(NIF) = 1
               USEDIFC(NIF) = IFCHAN(ICH,KS)
            END IF
         END DO
C
C        Check the RDBE_PFB personality.
C        Most checks are meant to be used both before and after 
C        the filter selection is available.
C        There is one check that is meant to be temporary that
C        forces the current frequencies.
C
         IF( DBE(KS) .EQ. 'RDBE_PFB' ) THEN
C
C           NCHAN must be 16 (in initial version).
C
            IF( NCHAN(KS) .NE. 16 ) THEN
               MSGTXT = ' '              
               WRITE( MSGTXT, '( A, A, I4 )' )
     1           'CHKRDBE: For DBE=RDBE_PFB, NCHAN must be 16.', 
     2           ' Setup specified: ', NCHAN(KS)
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
C
C           Sample rate must be 64 Msamp/sec.
C
            IF( SAMPRATE(KS) .NE. 64.0 ) THEN
               MSGTXT = ' '              
               WRITE( MSGTXT, '( A, F8.3, A )' )
     1           'CHKRDBE: Invalid SAMPRATE specified: ', SAMPRATE(KS),
     2           ' for DBE=RDBE_PFB. Must be 64.0 Msamp/s.'
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
C
C           Bits per sample must be 2.
C
            DO ICH = 1, NCHAN(KS)
               IF( BITS(ICH,KS) .NE. 2 ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A, I3 )' )
     1               'CHKRDBE: BITS must be 2 for DBE=RDBE_PFB. ',
     2               '  Value specified is: ', BITS(ICH,KS)
                  CALL WLOG( 1, MSGTXT )
                  ERRS = .TRUE.
               END IF
            END DO
C
C           All baseband sidebands must be lower.
C           Here is were we get a bit tricky and try to use
C           inverted sidebands and let the correlator 
C           fix it.
C
            DO ICH = 1, NCHAN(KS)
               IF( SIDEBD(ICH,KS) .NE. 'L' ) THEN
                  IF( SBWARN ) THEN
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( A, A, A )' )
     1                  'CHKRDBE: SIDEBAND must be LSB for ',
     2                  '  DBE=RDBE_PFB. Value specified is: ', 
     3                  SIDEBD(ICH,KS)
                     CALL WLOG( 1, MSGTXT )
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( A, A )' )
     1                  '         Setup file is: ',
     2                  SETNAME(KS)(1:LEN1(SETNAME(KS)))
                     CALL WLOG( 1, MSGTXT )
                  END IF
C
C                 Now let's fix it, if it was 'U' - ie not some
C                 other bad spec.
C                 Add other correlators to the list eventually.
C
                  IF( SIDEBD(ICH,KS) .EQ. 'U' .AND.
     1                ( CORREL .EQ. 'SOCORRO' .OR.
     2                  CORREL .EQ. 'VLBA' .OR.
     3                  CORREL .EQ. 'VLBADIFX' .OR.
     4                  CORREL .EQ. 'LBA' ) ) THEN
C
C                    Tell the user we will invert sidebands.
C
                     IF( SBWARN ) THEN
                        MSGTXT = ' '
                        WRITE( MSGTXT, '( A,A )' )
     1                     '         DiFX can invert the sideband',
     2                     ' so we''ll do that.'
                        CALL WLOG( 1, MSGTXT )
                     END IF
C
C                    Now do the inversion.
C
C                    For FREQREF, we need the net sideband to know
C                    whether to add or subtract CORINV.
C
C                    CORINV is the amount that got added to FREQREF 
C                    to get the LO setting. For comparison with 
C                    channels that will get correlated against
C                    this one, subtract CORINV.  
C
C                    Note in all cases we will be increasing the 
C                    BBSYN frequency because we will be switching
C                    from BBC sideband 'U' to 'L'.   FREQREF can go 
C                    either way depending on the IF sideband.
C
                     IF( NETSIDE(ICH,KS) .EQ. 'U' ) THEN
                        NETSIDE(ICH,KS) = 'L'
                        CORINV(ICH,KS) = DBLE( SAMPRATE(KS) ) / 2.D0
                     ELSE
                        NETSIDE(ICH,KS) = 'U'
                        CORINV(ICH,KS) = 
     1                       -1.D0 * DBLE( SAMPRATE(KS) ) / 2.D0
                     END IF
                     SIDEBD(ICH,KS) = 'L'
                     BBSYN(ICH,KS) = BBSYN(ICH,KS) + 
     1                              ABS( CORINV(ICH,KS) )
C
C                    Get the new reference frequeny.  The direction
C                    of the shift is in the sign of CORINV.
C
                     FREQREF(ICH,KS) = FREQREF(ICH,KS) + CORINV(ICH,KS)
C
                  ELSE
C
C                    We have the wrong baseband sideband and a correlator
C                    that can't deal with it.
C
                     IF( SIDEBD(ICH,KS) .NE. 'U' ) ERRS = .TRUE.
C
                  END IF
                  SBWARN = .FALSE.
               END IF
            END DO
C
C           Bandwidths and frequencies will be checked in CHKRDFQ.
C
C           Still to be checked - IF, POL.
C
         END IF
C
C        ===  Now check the DDC personality. ===
C
         IF( DBE(KS) .EQ. 'RDBE_DDC' ) THEN
C
C           NCHAN must be 8 or less with 2 RDBEs or 4 or less with
C           one.  MIF is already set depending on the capability.
C
            IF( MIF .EQ. 4 .AND. NCHAN(KS) .GT. 8 ) THEN
               MSGTXT = ' '              
               WRITE( MSGTXT, '( A, A, A, I4 )' )
     1           'CHKRDBE: For DAR=RDBE2, DBE=RDBE_DDC, and VDIF ',
     2           'format, NCHAN must <= 8.', 
     3           ' Setup specified ', NCHAN(KS)
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
            IF( MIF .EQ. 2 .AND. NCHAN(KS) .GT. 4 ) THEN
               CALL WLOG( 1, 
     1           'CHKRDBE: If there is a single RDBE using the DDC '//
     2           'personality, or the format is not VDIF,' )
               MSGTXT = ' '              
               WRITE( MSGTXT, '( A, I4 )' )
     1           '         NCHAN must be <= 4.  Setup specified.', 
     2           NCHAN(KS)
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
C
C           Check for invalid distributions of IFs for RDBE2 (MIF=4).
C           For NIF 3, all possible combinations that have NIF < 8
C           conform to the restrictions which say that one IF can
C           have up to 8 channels and the other 2 must be less than
C           or equal to 4 each (only one IF can go to both RDBE's).
C           If one IF has more than 4 channels, the largest possible 
C           number of channels the others can have is 3, so it's ok.
C           So no test beyond the total number test is needed.
C
C           If NIF is 4, there must be two pairs, each with less
C           than 4 channels (each such pair goes to an RDBE and 
C           no IF can go to both RDBEs).  Note that there can be
C           pairs with more than 4 as long as they are kept
C           separated.  There are only 3 possible combinations so
C           just make a brute force check.  That will be more
C           understandable.
C
            IF( NIF .EQ. 4 ) THEN
               OK4 = ( NNIF(1) + NNIF(2) .LE. 4 .AND. 
     1                 NNIF(3) + NNIF(4) .LE. 4 ) .OR. 
     2               ( NNIF(1) + NNIF(3) .LE. 4 .AND. 
     3                 NNIF(2) + NNIF(4) .LE. 4 ) .OR. 
     4               ( NNIF(1) + NNIF(4) .LE. 4 .AND. 
     5                 NNIF(2) + NNIF(3) .LE. 4 )
               IF( .NOT. OK4 ) THEN
                  CALL WLOG( 1, 
     1               'CHKRDBE:  When using 2 RDBEs, with 4 IFs, '//
     2               'it must be possible to pair the IFs so ' )
                  WRITE( MSGTXT, '( A, A, A )' )
     1               '          that each pair has less than 4 ',
     2               'channels total.  This is not the case for ',
     3               'setup ', SETNAME(KS)
                  ERRS = .TRUE.
               END IF
            END IF
C
C           Sample rate can have many values.
C           These may need to shift down by 1 if we do complex
C           sampling.
C
            IF( SAMPRATE(KS) .NE. 256.0 .AND. 
     a          SAMPRATE(KS) .NE. 128.0 .AND. 
     1          SAMPRATE(KS) .NE. 64.0 .AND.
     2          SAMPRATE(KS) .NE. 32.0 .AND.
     3          SAMPRATE(KS) .NE. 16.0 .AND.
     4          SAMPRATE(KS) .NE. 8.0 .AND.
     5          SAMPRATE(KS) .NE. 4.0 .AND.
     6          SAMPRATE(KS) .NE. 2.0 .AND.
     7          SAMPRATE(KS) .NE. 1.0 .AND.
     8          SAMPRATE(KS) .NE. 0.5 ) THEN
               MSGTXT = ' '              
               WRITE( MSGTXT, '( A, F8.3, A )' )
     1           'CHKRDBE: Invalid SAMPRATE specified: ', SAMPRATE(KS),
     2           ' for DBE=VLBA_DDC. Must be 0.5 to 256 Msamp/s.'
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
C
C           Bits per sample must be 2.
C
            DO ICH = 1, NCHAN(KS)
               IF( BITS(ICH,KS) .NE. 2 ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A, I3 )' )
     1               'CHKRDBE: BITS must be 2 for DBE=RDBE_DDC. ',
     2               '  Value specified is: ', BITS(ICH,KS)
                  CALL WLOG( 1, MSGTXT )
                  ERRS = .TRUE.
               END IF
            END DO
C
C           Bandwidths and frequencies checked in CHKRDFQ
C
         END IF
C
C        Check the frequencies and bandwidths.  This is pulled out
C        so that it can be used again later on frequencies set in-line
C        or using Doppler.
C
         CALL CHKRDFQ( KS, 0, BBFILT(1,KS), BBSYN(1,KS), ERRS )
C
      END IF
C
      RETURN
      END

      LOGICAL FUNCTION VXCFBB( ISET, JSET )
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 020596 
C     returns true if BB block in 2 SCHED sets are identical
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER ISET, JSET, NBBCI, NBBCJ, ICH, JCH
      INTEGER IBBC(MAXCHN), JBBC(MAXCHN)
      CHARACTER IIF(MAXCHN)*2, JIF(MAXCHN)*2
      LOGICAL IDENT, NEWFND
C ----------------------------------------------------------------------
C
      IDENT = .TRUE.      
C
C     BBC section, depends on NBBC but also on which IF they connect
C     and actually also on which BBC/VCs are used
C
      NBBCI = 0
      DO ICH= 1, NCHAN(ISET)
         NEWFND = .TRUE.
         IF( ICH .GT. 1 ) THEN
            DO JCH = 1, ICH-1
               IF( BBC(ICH,ISET) .EQ. BBC(JCH,ISET)) NEWFND = .FALSE.
            END DO
         END IF
         IF( NEWFND ) THEN
            NBBCI = NBBCI + 1
            IIF(NBBCI) = IFCHAN(ICH,ISET)
            IBBC(NBBCI) = BBC(ICH,ISET)
         END IF
      END DO
C
      NBBCJ = 0
      DO ICH=1,NCHAN(JSET)
         NEWFND = .TRUE.
         IF( ICH .GT. 1 ) THEN
            DO JCH = 1, ICH-1
               IF( BBC(ICH,JSET) .EQ. BBC(JCH,JSET)) NEWFND = .FALSE.
            END DO
         END IF
         IF( NEWFND ) THEN
            NBBCJ = NBBCJ + 1
            JIF(NBBCJ) = IFCHAN(ICH,JSET)
            JBBC(NBBCJ) = BBC(ICH,JSET)
         END IF
      END DO
C
C     Now we can compare directly
C
      IF( NBBCI .NE. NBBCJ ) THEN
         IDENT = .FALSE.
      ELSE
         DO ICH = 1, NBBCI
            IF( IIF(ICH) .NE. JIF(ICH) .OR.
     1          IBBC(ICH) .NE. JBBC(ICH) )
     2          IDENT = .FALSE.
         END DO
      END IF
C
      VXCFBB = IDENT 
C
      RETURN
      END

      SUBROUTINE PLVER( PLTVER )
C
C     Set a version number for the SCHED main code.  
C     Note that a coarser, date based version is set in sched.f
C
      REAL PLTVER
Cf2py intent(out) PLTVER
C ----------------------------------------------------------------------
C      PLTVER = 1.02   ! Went with 16 Oct 2001 version.
C      PLTVER = 1.03   ! RCW configuration search stuff.
C      PLTVER = 1.04   ! RCW.  Used in 15 May 2002 release.
C      PLTVER = 1.05   ! A few enhancements by FT over 1.04.
      PLTVER = 1.06   ! A few bug fixes by FT over 1.05.  Feb 2006.
C
      RETURN
      END

C*KRDLIN -- read one line of text from input file (KEYIN) [UNIX]
C+
      SUBROUTINE KRDLIN(UNIT, REC, MAXREC, OUTC, DIALOG, REFLEC, IER)
      INTEGER UNIT, MAXREC, OUTC, IER
      LOGICAL DIALOG, REFLEC
      CHARACTER*(*) REC
C
C KEYIN: read one line of text from input file and perform DCL symbol
C substitution.
C
C Also turn any line feed characters into blanks to allow reading DOS
C format files.
C
C Protect against crazies who put more than 255 characters in a line.
C  Jan 2014 RCW.
C-----------------------------------------------------------------------
      INTEGER LEN1, NSUB, I
      CHARACTER*255 T
      CHARACTER*260 TL
      CHARACTER     CR*1, BLANK*1
C
      CR = CHAR( 13 )
      BLANK = ' '
      IF (UNIT.EQ.0) GOTO 340
   10 IF (DIALOG) WRITE (OUTC, '(''* '',$)')
      READ (UNIT, '(A)', END=340) TL
      MAXREC = LEN1(TL)
      IF( MAXREC .GT. 255 ) THEN
         WRITE( OUTC, '( A, /, A )' ) 
     1    'KRDLIN: ERROR - input line longer than 255 characters',
     2    TL
         STOP
      ELSE
         T = TL
      END IF
      IF (MAXREC.LT.1) GOTO 10
      IF (REFLEC) WRITE (OUTC, '(1X,A)') T(1:MAXREC)
      DO 20 I = 1, MAXREC
         IF( T(I:I) .EQ. CR ) T(I:I) = BLANK
   20 CONTINUE
      CALL SYMSUB(T(1:MAXREC), REC, MAXREC, NSUB)
      REC(MAXREC+1:) = ' '
      IF (NSUB.GT.0) WRITE (OUTC, '(1X,A)') REC(1:MAXREC)
      IER = 0
      RETURN
  340 IER = 1
      RETURN
      END

      SUBROUTINE VXNMXX( BLOCK, NXX, XXLINK )
C
C     Routine specific for the VEX extension of SCHED. 
C     Generic naming function, returns a unique name for a definition
C     in a certain $BLOCK, following VEX rules (special char 32)
C     Uses a #02 - #99 extension if identical names occur
C     By H.J. van Langevelde, JIVE, 300496 
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C      
      CHARACTER BLOCK*2, XXLINK(MAXMOD)*32
      CHARACTER VXNMHP*32, VXNMRL*32, VXNMPO*32, VXNMPH*32, VXNMFQ*32
      CHARACTER VXNMIF*32, VXNMBB*32, VXNMTR*32 
      CHARACTER VXNMDA*32, VXNMSI*32, VXNMAN*32
      INTEGER NXX
C ----------------------------------------------------------------------
C
C     first call a specific naming function
C
      IF( BLOCK .EQ. 'HP' ) THEN
         XXLINK(NXX) = VXNMHP( NXX )
      ELSE IF( BLOCK .EQ. 'RL' ) THEN
         XXLINK(NXX) = VXNMRL( NXX )
      ELSE IF( BLOCK .EQ. 'PO' .AND. .NOT. OBSTYP .EQ. 'PTVLBA' ) THEN
         XXLINK(NXX) = VXNMPO( NXX )
      ELSE IF( BLOCK .EQ. 'PH' ) THEN
         XXLINK(NXX) = VXNMPH( NXX, .FALSE. )
      ELSE IF( BLOCK .EQ. 'FQ' ) THEN
         XXLINK(NXX) = VXNMFQ( NXX, .FALSE. )
      ELSE IF( BLOCK .EQ. 'IF' ) THEN
         XXLINK(NXX) = VXNMIF( NXX, .FALSE. )
      ELSE IF( BLOCK .EQ. 'BB' ) THEN
         XXLINK(NXX) = VXNMBB( NXX )
C      ELSE IF( BLOCK .EQ. 'TR' .AND. .NOT. OBSTYP .EQ. 'PTVLBA' ) THEN
      ELSE IF( BLOCK .EQ. 'TR' ) THEN
         XXLINK(NXX) = VXNMTR( NXX )
      ELSE IF( BLOCK .EQ. 'DA' ) THEN
         XXLINK(NXX) = VXNMDA( NXX )
      ELSE IF( BLOCK .EQ. 'SI' ) THEN
         XXLINK(NXX) = VXNMSI( NXX )
      ELSE IF( BLOCK .EQ. 'AN' ) THEN
         XXLINK(NXX) = VXNMAN( NXX )
      ELSE
         CALL ERRLOG( 'VXNMXX: unsupported BLOCK type ')
         WRITE( XXLINK(NXX), '( A, I2.2 )' )  BLOCK//'Set', NXX
      END IF
C
C     check whether it is valid
C
      CALL VXUNQL( NXX, XXLINK )
C
      RETURN
      END

      SUBROUTINE CORDEF( CHPOL )
C
C     Deal with correlator setup parameters for the non-VLBA 
C     correlators.  Mainly, this is just setting the defaults if 
C     values have not been set.  It also checks the correlator
C     settings.
C
      INCLUDE 'sched.inc'
C
      LOGICAL       MISCOR
      CHARACTER     CHPOL*(*)
C --------------------------------------------------------------------      
      IF( DEBUG ) CALL WLOG( 0, 'CORDEF starting.' )
      MISCOR = .FALSE.
C
      IF( CORAVG .EQ. 0.0 ) THEN
         CORAVG = 2.0
      END IF
C
      IF( CORCHAN .EQ. 0 ) THEN
         CORCHAN = 16
      END IF
C
      IF( CORNANT .EQ. 0 ) THEN
         CORNANT = NSTA
      END IF
C
      IF( CHPOL(1:2) .NE. 'ON ' .AND. CHPOL(1:3) .NE. 'OFF' ) THEN
         CHPOL = 'ON'
         CORPOL = .TRUE.
      END IF
C
C     Deal with case where parameters weren't provided.
C
      IF( MISCOR ) THEN
         CALL WLOG( 1, 'CORDEF:  A required correlator parameter '//
     1      'not provided for a non-VLBA correlator.' )
C
C        Allow plotting, but not output files.
C
         IF( PLOT ) THEN
            MISSING = .TRUE.
         ELSE
            CALL ERRLOG( 'Add correlator info and try again.' )   
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE IFDBBC( MYDBBCVER, MAXBBC, MAXIF, IFBBC, MIF )
Cf2py intent(out) IFBBC, MIF
C
C     CR: 26 March, 2013
C     Routine for Sched called by BBCDBBC and CHKDBBC which gives the
C     allowed IF-> BBC mappings for the different flavours of DBBC.
C
      INCLUDE    'sched.inc'
C
      CHARACTER   MYDBBCVER*(*)
      INTEGER     MAXBBC, MAXIF
      INTEGER     IFBBC(MAXBBC, MAXIF), MIF, IIF, IBBC
C
C  -----------------------------------------------------------
C     Software check:
C
      IF( DEBUG ) CALL WLOG( 1, 'IFDBBC: Starting' )
C
C     Initialise the IF->BBC lists. IFBBC(IBBC, IIF) = 0 means IBBC not
C     accessible from IIF. 
C
      DO IBBC = 1, MAXBBC
         DO IIF = 1, MAXIF
            IFBBC(IBBC, IIF) = 0
         END DO
      END DO
      IF( MYDBBCVER .EQ. 'ASTRO' ) THEN
C        'Astro' version, 4 IFs with 4 BBCs each
         MIF = 4
         DO IBBC = 1, 4
            IFBBC(IBBC, 1) = 1
            IFBBC(IBBC+4, 2) = 1
            IFBBC(IBBC+8, 3) = 1
            IFBBC(IBBC+12, 4) = 1
         END DO
      ELSE IF( MYDBBCVER .EQ. 'GEO' ) THEN
C        'geo' version, 2 IFs with 8 BBCs each
         MIF = 2
         DO IBBC = 1, 8
            IFBBC(IBBC, 1) = 1
            IFBBC(IBBC+8, 2) = 1
         END DO
      ELSE IF( MYDBBCVER .EQ. 'HYBRID' ) THEN
C        'hybrid' version, 3 IFs with 2x4 and 1x8 BBCs
         MIF = 3
         DO IBBC = 1, 4
            IFBBC(IBBC, 1) = 1
            IFBBC(IBBC+4, 2) = 1
         END DO
         DO IBBC = 1, 8
            IFBBC(IBBC+8, 3) = 1
         END DO
      ELSE
         WRITE( MSGTXT, '( A, A )' )
     1       'IFDBBC: DBBCVER not recognised:', MYDBBCVER
         CALL WLOG( 1, MSGTXT )
         CALL ERRLOG( 'catalog error' )
C
      END IF
C
      RETURN
      END

      SUBROUTINE ADDPEAK( LASTISCN, ISCN, PEAKOPT, IADJUST )
Cf2py intent(in) LASTISCN, ISCN
Cf2py intent(in, out) PEAKOPT, IADJUST
C
C     Routine for SCHED, called by SCHOPT, that inserts reference
C     pointing scans.
C
C     The routine is set up to handle multiple groups of
C     antennas to be processed together.
C
C     It is assumed that the final scan time for the main observing
C     scan has been set.  This routine will establish the final
C     times for the pointing scans.
C
C     PEAKOPT is an instruction generated here (only can be set to
C     zero when SCHOPT is initialized) and used as a flag to indicate
C     what to do on the next call.  It gives the number of peaking
C     scans left to process after this pass through the schopt scan
C     loop is done.
C
      INCLUDE     'sched.inc'
      INCLUDE     'schset.inc'
      INCLUDE     'schpeak.inc'
C
      INTEGER           ISCN, LASTISCN(*), PEAKOPT
      INTEGER           NADDED, NGOOD
C
      INTEGER           IS, ISTA, KSTA, USEPSRC
      INTEGER           LASTKSCN(MAXSTA), LASTJSCN(MAXSTA)
      INTEGER           KSCN, MSCN, KSRC, PSRC, IGRP, JSCN, KEEPORIG
      INTEGER           NTRY, I, YEAR, DAY1, OKSC, NUP(MPKGRP)
      LOGICAL           SROK(MPKSRC), SROK2(MPKSRC), IADJUST
      LOGICAL           TRYGRP(MPKGRP), TRYGRP2(MPKGRP), ADD2
      LOGICAL           WATCHIT, LASTPTG, GOTST, TABHEAD
      REAL              MINEL, MAXEL
      DOUBLE PRECISION  MINSLEW, MAXSLEW, MINTOT
      DOUBLE PRECISION  TGAP(MAXSTA), TOTTIME, TOTTIME2
      DOUBLE PRECISION  STARTK, STOPK, START2, STOP2
      DOUBLE PRECISION  SLEWMIN, SLEWMAX(MPKSRC), START, FREQTEST
      DOUBLE PRECISION  MSETTLE(MPKGRP)
      CHARACTER         TFORM*8, STIME*8
C
      SAVE              NADDED
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'ADDPEAK starting' )
C
C     Just return if autopointing was not requested or pointing was
C     requested with POINT on a scan not generated by this routine.
C     Recall POINT=-1 is a way for the user to say don't point here
C     when AUTOPEAK is on.
C
      IF( .NOT. AUTOPEAK .OR.
     1    ( POINT(ISCN) .GE. -1 .AND. PEAKOPT .EQ. 0 ) ) GO TO 999
C
C     Peaking requested.  Be sure that a pointing file was
C     provided.
C
      IF( NPKGRP .LE. 0 ) THEN
         CALL WLOG( 1,
     1     'ADDPEAK: Want automatic pointing, but there are no groups' )
         CALL WLOG( 1, '     This should not happen. ' )
         CALL ERRLOG ( 'ADDPEAK: Programming error' )
      END IF
C
C     Deal with a new observing scan.
C
      IF( PEAKOPT .EQ. 0 ) THEN
C
C        Allow the user to watch the decision process.
C
         IF( PKWATCH ) THEN
            CALL WLOG( 0, ' ' )
            CALL TIMEJ( STARTJ(ISCN), YEAR, DAY1, START )
            STIME = TFORM( START, 'T', 0, 2, 2, '::@' )
            WRITE( MSGTXT, '( A, I5, 1X, A, 1X, A )' )
     1         'ADDPEAK: Trying to add pointing scan for target scan ',
     2         ISCN, SCNSRC(ISCN), STIME
            CALL WLOG( 0, MSGTXT )
            MSGTXT = ' '
         END IF
C
C        Some initializations.
C
         DO IGRP = 1, NPKGRP
            TRYGRP(IGRP) = .FALSE.
            TRYGRP2(IGRP) = .FALSE.
            NUP(IGRP) = 0
            MSETTLE(IGRP) = 0.D0
         END DO
C
C        Don't try if there were no antennas up for this scan.
C        OPTTIM in SCHOPT got the scan geometry for the main scan.
C
         NGOOD = 0
         DO ISTA = 1, NSTA
            IGRP = PKGROUP(ISTA)
            IF( STASCN(ISCN,ISTA) .AND. IGRP .NE. 0 ) THEN
               IF( UP1(ISCN,ISTA) .EQ. ' ' .OR.
     1             UP2(ISCN,ISTA) .EQ. ' ' ) THEN
                  NGOOD = NGOOD + 1
                  NUP(IGRP) = NUP(IGRP) + 1
               END IF
            END IF
         END DO
         IF( NGOOD .LE. 0 ) THEN
            IF( PKWATCH ) THEN
               CALL WLOG( 0, 'ADDPEAK:  Source down or below OPMINEL '//
     1          'at all stations.' )
            END IF
            GO TO 999
         END IF
C
C        First save some work when there is clearly not enough time
C        or the frequency is wrong.
C        While at it, flag groups that might be useful.
C        Note TRYGRP2 indicates it is worth trying at add a second
C        peaking scan.
C
C        Don't do pointing if the last scan was recent and
C        was pointing.
C
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) .AND.
     1          PKGROUP(ISTA) .GT. 0 ) THEN
               IS = NSETUP( ISCN, ISTA )
               IGRP = PKGROUP(ISTA)
C
C              Test that the frequency is high enough.
C
               FREQTEST = FREQREF(1,IS)
               IF( PKMINFQ(IGRP) .LT. FREQTEST ) THEN
C
                  IF( LASTISCN(ISTA) .NE. 0 ) THEN
                     TGAP(ISTA) = STARTJ(ISCN) - STOPJ(LASTISCN(ISTA))
                     LASTPTG = ( POINT(LASTISCN(ISTA)) .EQ. 0 .OR.
     1                   POINT(LASTISCN(ISTA)) .EQ. IGRP ) .AND.
     2                   TGAP(ISTA) .LT. 600.D0 / 86400.D0
                     IF( TGAP(ISTA) .GT. PKDWELL(IGRP) .AND.
     1                   .NOT. LASTPTG .AND. NUP(IGRP) .GT. 0 ) THEN
                        TRYGRP(IGRP) = .TRUE.
                     END IF
                     IF( TGAP(ISTA) .GT. 2.D0 * PKDWELL(IGRP) .AND.
     1                   .NOT. LASTPTG .AND. NUP(IGRP) .GT. 0 ) THEN
                        TRYGRP2(IGRP) = .TRUE.
                     END IF
                  ELSE
                     TGAP(ISTA) = 10000.D0
                     TRYGRP(IGRP) = NUP(IGRP) .GT. 0
                     TRYGRP2(IGRP) = NUP(IGRP) .GT. 0
                  END IF
C
               END IF
            END IF
C
C           While in the station loop, set the default for LASTKSCN
C           and LASTJSCN to be LASTISCN.  LASTKSCN is for the target
C           source scan.  LASTJSCN is for a possible second pointing
C           scan.  LASTISCN does not change for the first pointing
C           scan.
C
            LASTKSCN(ISTA) = LASTISCN(ISTA)
            LASTJSCN(ISTA) = LASTISCN(ISTA)
C
         END DO
C
C        Get the maximum number of scans that could be inserted if
C        all groups are used for the number of scans determined to
C        be possible above for the group.
C
         NTRY = 0
         DO IGRP = 1, NPKGRP
            IF( TRYGRP(IGRP) ) NTRY = NTRY + 1
            IF( TRYGRP2(IGRP) ) NTRY = NTRY + 1
         END DO
C
C        Write some output if the user is trying to monitor the
C        process.
C
         IF( PKWATCH ) THEN
            IF( NTRY .GE. 1 ) THEN
               DO IGRP = 1, NPKGRP
                  IF( TRYGRP2(IGRP) ) THEN
                     WRITE( MSGTXT, '( A, I2, A )' )
     1                  'ADDPEAK: Pointing group ', IGRP,
     2                  ':  Will try to add double pointing scans.'
                  ELSE IF( TRYGRP(IGRP) ) THEN
                     WRITE( MSGTXT, '( A, I2, A )' )
     1                  'ADDPEAK: Pointing group ', IGRP,
     2                  ':  Will try to add one pointing scan.'
                  ELSE
                     IF( NUP(IGRP) .EQ. 0 ) THEN
                        WRITE( MSGTXT, '( A, I2, A, A )' )
     1                  'ADDPEAK: Pointing group ', IGRP,
     2                  ':  No stations up in scan.'
                     ELSE
                        WRITE( MSGTXT, '( A, I2, A, A )' )
     1                  'ADDPEAK: Pointing group ', IGRP,
     2                  ':  Gap too short to add pointing scans.'
                     END IF
                  END IF
                  CALL WLOG( 0, MSGTXT )
                  MSGTXT = ' '
               END DO
            ELSE
               CALL WLOG( 0, 'ADDPEAK: Insufficient time to add '//
     1            'pointing or last scan was pointing.' )
            END IF
         END IF
C
C        Return if there were no possible places to add scans.
C
         IF( NTRY .EQ. 0 ) GO TO 999
C
C        Ok, there is a chance that something will fit and this is
C        a frequency at which we should be thinking about doing
C        something, at least for some station.
C
C        Now make NTRY new scans to be the templates.  The calculated
C        parameters will be copied.  Note that with the third argument
C        (COPYALL) true, the start, stop, duronly and annot will also
C        be copied so this preserves scan times as desired for moving
C        as opposed to duplicating a scan (we're mainly worried about
C        the last copy - the one that will become the main observing
C        scan (scan MSCN below).  Also note that there end up being 
C        NTRY+1 versions of this scan of which at most NTRY will become 
C        pointing scans.  Set ORIGEN to 4 to indicate these are added
C        scans.  Later we will set the original scan back to its
C        input value.
C
         KEEPORIG = ORIGEN(ISCN)
         ORIGEN(ISCN) = 4
         DO I = 1, NTRY
            KSCN = ISCN + I
            CALL SCNDUP( KSCN, ISCN, .TRUE., 'ADDPEAK' )
            ORIGEN(KSCN) = 4
         END DO
C
C        Loop through the groups.  MSCN is the one that will stay the
C        original for sure so it can be used for slew calculations etc.
C        KSCN is the one we are trying to insert.  NADDED is the number
C        already added.
C
         NADDED = 0
         MSCN = ISCN + NTRY
         DO IGRP = 1, NPKGRP
            IF( TRYGRP(IGRP) ) THEN
               IF( PKWATCH ) THEN
                  WRITE( MSGTXT, '( A, I2 )' )
     1               'ADDPEAK:  Working on pointing group ', IGRP
                  CALL WLOG( 0, MSGTXT )
                  MSGTXT = ' '
                  TABHEAD = .TRUE.
               END IF
C
               KSCN = ISCN + NADDED
C
C              Get the stations that will be in the inserted scan.
C              GOTST indicates that we got at least one for this group.
C
               GOTST = .FALSE.
               DO ISTA = 1, NSTA
                  STASCN(KSCN,ISTA) = STASCN(MSCN,ISTA) .AND.
     1                PKGROUP(ISTA) .EQ. IGRP .AND.
     2                ( UP1(MSCN,ISTA) .EQ. ' ' .OR.
     3                UP2(MSCN,ISTA) .EQ. ' ' )
                  IF( STASCN(KSCN,ISTA) ) GOTST = .TRUE.
               END DO
C
C              Loop through the possible pointing sources, looking
C              for the one closest to the target source that is
C              up at all stations for which the target is up
C              (the latter is guaranteed by the above setting of
C              STASCN).
C
               IF( GOTST ) THEN
                  DO PSRC = 1, NPKSRC(IGRP)
C
C                    Insert the source into the current scan with
C                    some guesses for the times.  SRINSERT will do
C                    the geometry calculations for both this scan
C                    and MSCN, to get slew times.
C
                     STOPK = STARTJ(MSCN) - 20.0 * ONESEC
                     STARTK = STOPK - PKDWELL(IGRP)
                     KSRC = PKSRNUM(PSRC,IGRP)
                     CALL SRINSERT( KSCN, KSRC, PKSRC(PSRC,IGRP),
     1                              STARTK, STOPK, LASTISCN, MSCN )
C
C                    Look for the one closest to the target that is
C                    up at all required stations.  First check that
C                    the source is above the minimum elevation at all 
C                    stations that need it.  Recall STASCN retains 
C                    the information about whether the target source 
C                    is up at the station.
C
                     SROK(PSRC) = .TRUE.
                     SROK2(PSRC) = .TRUE.
                     WATCHIT = .FALSE.
                     MINEL = 100.0
                     MAXEL = 0.0
                     MINSLEW = 1000.0D0
                     MAXSLEW = 0.0D0
                     MINTOT = 10000.0D0
                     DO ISTA = 1, NSTA
                        IF( STASCN(KSCN,ISTA) .AND.
     1                      EL1(KSCN,ISTA) .LT. PKMINEL(IGRP) ) THEN
                           SROK(PSRC) = .FALSE.
                           SROK2(PSRC) = .FALSE.
                        END IF
C
C                       Determine whether to print anything about this
C                       source if PKWATCH is set.
C
                        IF( PKWATCH ) THEN
                           IF( STASCN(KSCN,ISTA) .AND.
     1                         UP1(KSCN,ISTA) .EQ. ' ' .AND.
     2                         UP2(KSCN,ISTA) .EQ. ' ' ) THEN
                              WATCHIT = .TRUE.
                           END IF
C
C                          Collect extrema.
C
                           IF( STASCN(KSCN,ISTA) ) THEN
                              MINEL = MIN( MINEL, EL1(KSCN,ISTA) )
                              MAXEL = MAX( MAXEL, EL1(KSCN,ISTA) )
                              MINSLEW = MIN( MINSLEW, 
     1                             TSLEW(MSCN,ISTA) * 86400.D0 )
                              MAXSLEW = MAX( MAXSLEW, 
     1                             TSLEW(MSCN,ISTA) * 86400.D0 )
                           END IF
                        END IF
                     END DO
C
C                    Now test that the pointing scans have any chance of
C                    fitting in the slot at all stations in the group.
C
                     IF( SROK(PSRC) ) THEN
                        DO ISTA = 1, NSTA
                           IF( STASCN(KSCN,ISTA) ) THEN
C
C                             Check time for one scan.
C
                              TOTTIME = PKDWELL(IGRP) +
     1                            TSLEW(KSCN,ISTA) + TSLEW(MSCN,ISTA)
                              IF( TGAP(ISTA) .LT. TOTTIME ) THEN
                                 SROK(PSRC) = .FALSE.
                              END IF
                              MINTOT = MIN( MINTOT, TOTTIME * 86400.D0 )
C
C                             Check time for 2 scans.  Add a "slew" 
C                             time for the second pointing set.  Use
C                             the TSETTLE (sec) time.
C
                              KSTA = STANUM(ISTA)
                              TOTTIME2 = 2.D0 * PKDWELL(IGRP) +
     1                           TSLEW(KSCN,ISTA) + TSLEW(MSCN,ISTA) +
     2                           TSETTLE(KSTA) / 86400.D0
                              IF( TGAP(ISTA) .LT. TOTTIME2 ) THEN
                                 SROK2(PSRC) = .FALSE.
                              END IF
C
C                             Collect the largest TSETTLE into MSETTLE
C                             It doesn't matter too much where this is
C                             done since these are fixed values per 
C                             station.  This is a place where we are
C                             only looking at the stations in the group
C                             which is what we want.
C
                              MSETTLE(IGRP) = 
     1                            MAX( MSETTLE(IGRP), TSETTLE(KSTA) )
                           END IF
                        END DO
                     END IF
C
C                    Now find the maximum slew time between the
C                    reference and target for this source.
C
                     SLEWMAX(PSRC) = 0.D0
                     IF( SROK(PSRC) ) THEN
                        DO ISTA = 1, NSTA
                           IF( STASCN(KSCN,ISTA) ) THEN
                              SLEWMAX(PSRC) = MAX( SLEWMAX(PSRC),
     1                               TSLEW(MSCN,ISTA) )
                           END IF
                        END DO
                     END IF
C
C                    Watch line.
C
                     IF( PKWATCH .AND. WATCHIT ) THEN
                        IF( TABHEAD ) THEN
                           CALL WLOG( 0, ' Num   Source      '//
     1                             'Slew times (sec) '//
     2                             '  Elevations (deg)  Scans OK'//
     3                             '  Min T' )
                           TABHEAD = .FALSE.
                        END IF
                        WRITE( MSGTXT, '(I5, 2X, A, F7.0, A, F5.0,'//
     1                     ' 6X, F4.0, A, F4.0, L6, L3, F9.0 )' )
     2                     PSRC, PKSRC(PSRC,IGRP),
     3                     MINSLEW, ' to ', MAXSLEW,
     4                     MINEL, ' to ', MAXEL,
     5                     SROK(PSRC), SROK2(PSRC),
     6                     MINTOT
                        CALL WLOG( 0, MSGTXT )
                        MSGTXT = ' '
                     END IF
                  END DO
C
C                 Get the source with the smallest maximum slew time.
C
                  USEPSRC = 0
                  SLEWMIN = 1.D0
                  DO PSRC = 1, NPKSRC(IGRP)
                     IF( SROK(PSRC) ) THEN
                        IF( SLEWMAX(PSRC) .GT. 0.D0 .AND.
     1                      SLEWMAX(PSRC) .LT. SLEWMIN ) THEN
                           SLEWMIN = SLEWMAX(PSRC)
                           USEPSRC = PSRC
                        END IF
                     END IF
                  END DO
C
C                 Ok, now have the source to use, or know there
C                 isn't one.
C
                  IF( USEPSRC .NE. 0 ) THEN
                     PSRC = USEPSRC
                     KSRC = PKSRNUM(PSRC,IGRP)
C
C                    Determine if we add one or two scans.  Only add two
C                    if TRYGRP2 was true, or there might not be enough
C                    dummy scans.
C
                     ADD2 = TRYGRP2(IGRP) .AND. SROK2(PSRC)
C
C                    Insert the actual scan(s) that we are going to use.
C                    JSCN is the one just before the target, and
C                    possibly the only one.  The 2 scan (START2 etc)
C                    is the first one of two, if there are two.
C
                     JSCN = KSCN
                     OKSC = 0
                     STOPK = STARTJ(MSCN) - SLEWMIN
                     STARTK = STOPK - PKDWELL(IGRP)
C
C                    Deal with the second scan, if one is to be added.
C                    This will actually be the first in the time
C                    sequence.
C
                     IF( ADD2 ) THEN
                        NADDED = NADDED + 2
                        OKSC = 2
C
C                       Insert the first scan of the two.  Note that
C                       SRINSERT runs SCNGEO for both the new scan
C                       and MSCN.  For the new scan, this should be
C                       all that is needed.  For MSCN, LASTISCN may
C                       change so it should be run again later.  It
C                       is in SRINSERT for the use above where slews
C                       were needed.
C                       Place a gap of TSETTLE between the pointing 
C                       scans.
C
                        STOP2 = STARTK - MSETTLE(IGRP) / 86400.D0
                        START2 = STOP2 - PKDWELL(IGRP)
                        CALL SRINSERT( KSCN, KSRC, PKSRC(PSRC,IGRP),
     1                                 START2, STOP2, LASTISCN, MSCN )
                        POINT(KSCN) = IGRP
C
C                       Set up for the second scan.  Recall LASTJSCN
C                       is set to LASTISCN much earlier.
C
                        JSCN = KSCN + 1
                        DO ISTA = 1, NSTA
                           IF( STASCN(KSCN,ISTA) ) THEN
                              LASTJSCN(ISTA) = KSCN
                           END IF
                        END DO
                     ELSE
                        JSCN = KSCN
                        NADDED = NADDED + 1
                        OKSC = 1
                     END IF
C
C                    Add the scan closest in time to the target source.
C
                     CALL SRINSERT( JSCN, KSRC, PKSRC(PSRC,IGRP),
     1                              STARTK, STOPK, LASTJSCN, MSCN )
                     POINT(JSCN) = IGRP
C
C                    Watch print.
C
                     IF( PKWATCH ) THEN
                        WRITE( MSGTXT, '( A, I2, A, A, A, I2 )' )
     1                     'ADDPEAK: Adding ', OKSC, ' scan(s) on ',
     2                     PKSRC(PSRC,IGRP), ' for pointing group ',
     3                     IGRP
                        CALL WLOG( 0, MSGTXT )
                        MSGTXT = ' '
                     END IF
C
C                    Record this scan as the last before the target for
C                    the participating stations.  This will only be used
C                    for the geometry calculations for the output target
C                    scan.
C
                     DO ISTA = 1, NSTA
                        IF( STASCN(JSCN,ISTA) ) THEN
                           LASTKSCN(ISTA) = JSCN
                        END IF
                     END DO
C
                  ELSE
C
C                    Deal with no source available.
C                    Nothing to do, I think
C
                     IF( PKWATCH ) THEN
                        WRITE( MSGTXT, '( A, A, I2 )' )
     1                     'ADDPEAK: No pointing sources available ',
     2                     'for pointing group ', IGRP
                        CALL WLOG( 0, MSGTXT )
                        MSGTXT = ' '
                     END IF
                  END IF
               ELSE
C
C                 Let user know there were no stations in this
C                 group/scan.
C
                  IF( PKWATCH ) THEN
                     WRITE( MSGTXT, '( A, I2, A )' )
     1                   'ADDPEAK:  No stations for group ', IGRP,
     2                   ' in this scan. '
                     CALL WLOG( 0, MSGTXT )
                     MSGTXT = ' '
                  END IF
               END IF
C
C
            END IF
         END DO
C
C        Now cover ourselves in case we didn't add a scan after
C        having inserted hypothetical ones.  Copy MSCN to the
C        scan after the last of the inserts. Then update the
C        slew times etc.  Keep the original scan's ORIGEN.
C
         KSCN = ISCN + NADDED
         IF( KSCN .NE. MSCN) THEN
            CALL SCNDUP( KSCN, MSCN, .TRUE., 'ADDPEAK2' )
         END IF
         ORIGEN(KSCN) = KEEPORIG
C
C        Set some scan variables to more reasonable values if
C        scans were inserted.
C
C        SCHED used to set gap to zero here, but that created problems
C        with DURATION/GAP schedules that had some DWELL scans.  Such
C        schedules want fixed intervals between the DUR/GAP scans but
C        the whole timing needs to be able to slide because of the
C        DWELL scans.  This was all found while dealing with Krichbaum's
C        GMVA schedule in Feb. 2014.
C
C        Instead now use ORIGEN and LASTSSCN to keep track of the 
C        last non-inserted scan.  In OPTTIM, respect GAP for original
C        scans but not inserted ones.
C
C         IF( NADDED .NE. 0 ) THEN
C            GAP(KSCN) = 0.D0
C         END IF
C
C        Update the scan slew times, geometry etc.  SRINSERT may
C        have taken care of this, as may SCHOPT later, but just to 
C        be sure it is all done right and for the right "last scans",
C        do it here.
C
         CALL SCNGEO( LASTKSCN, NGOOD, KSCN )
         POINT(KSCN) = -999
C
C        Set the counter for adding the scans.
C
         IF( NADDED .GT. 0 ) THEN
            PEAKOPT = NADDED
         ELSE
            PEAKOPT = 0
         END IF
C
      ELSE
C
C        Grind through any scans set up by the processing of the
C        last target scan.  There really isn't much to do as we
C        set everything up before.  We just need to decrement
C        PEAKOPT.
C
C        Note that PEAKOPT will not hit zero until the NADDED new
C        scans, and the original observing scan, have been flushed
C        through.  So it is zero when the original scan is sent.
C
         IF( PEAKOPT .GT. 0 ) PEAKOPT = PEAKOPT - 1
C
C        Note that LASTISCN will still be correct for the first pointing
C        scan and the normal mechanism for updating LASTISCN will work
C        ok for all other scans.
C
      END IF
C
C     For IADJUST, we want to set it false for any added pointing
C     scans.  One could debate whether to override the original ADJUST
C     for the last scan, but I think it is ok to keep the original.
C     That is easier because PEAKOPT will be zero for it, or for any 
C     scans we are not touching, so we can simply test on PEAKOPT.
C
      IF( PEAKOPT .GE. 1 ) IADJUST = .FALSE.
C
  999 CONTINUE
      RETURN
      END

      SUBROUTINE OMSCOR
C
C     Write correlation parameters into the OMS file.
C     OMS at Socorro correlator.
C
      INCLUDE       'sched.inc'
C
      INTEGER       IFFT, IAVG, MINFFT, LEN1
      CHARACTER     CPOL*3
C ------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'OMSCOR starting' )
C
      WRITE( IOMS, '( 1X, /, A, /, 1X )' ) 
     1       'BEGIN = CORRELATOR_PARAMETERS'
      CPOL = 'NO '
      IF( CORPOL ) CPOL = 'YES'
      WRITE( IOMS, '( A, A )' )  '    POLARIZATION      = ', CPOL
      WRITE( IOMS, '( A, F11.6 )' ) '    TIME_AVERAGE      = ', CORAVG
      IF( CAEXACT ) THEN
         WRITE( IOMS, '( A )' ) '    TWEAK_INT_TIME    = NO '
      ELSE
         WRITE( IOMS, '( A )' ) '    TWEAK_INT_TIME    = YES '
      END IF
C
C     Only do some parameters only for the Socorro hardware correlator
C
      IF( CORREL(1:6) .EQ. 'FXCORR' .AND. .NOT. NOTAPE ) THEN
C
C        Get the FFT size and spectral averaging.
C
         IF( CORPOL ) THEN
            MINFFT = 256
         ELSE
            MINFFT = 512
         END IF
         IF( 2 * CORCHAN .GE. MINFFT ) THEN
            IFFT = 2 * CORCHAN
            IAVG = 1
         ELSE
            IFFT = MINFFT
            IAVG = MINFFT / ( 2 * CORCHAN )
         END IF
C   
C        Write the desired information
C   
         WRITE( IOMS, '( A, I8 )' ) '    FFT_SIZE          = ', IFFT
         WRITE( IOMS, '( A, I4 )' ) '    SPECTRAL_AVERAGE  = ', IAVG
         WRITE( IOMS, '( A, A )' )  '    WINDOW            = ', CORWTFN
         IF( CORAV2 .NE. 0.0 .AND. CORAV2 .NE. CORAVG ) THEN
            WRITE( IOMS, '( A, F11.6 )' ) '    ALT_AVERAGE_TIME  = ', 
     1           CORAV2
            IF( CAEXACT2 ) THEN
               WRITE( IOMS, '( A )' ) '    TWEAK_ALT_INT_TIME = NO '
            ELSE
               WRITE( IOMS, '( A )' ) '    TWEAK_ALT_INT_TIME = YES '
            END IF

         END IF
C
      ELSE IF( ( CORREL(1:4) .EQ. 'VLBA' .OR. 
     1     CORREL(1:7) .EQ. 'SOCORRO' .OR.
     2     CORREL(1:8) .EQ. 'VLBADIFX' ) .AND. 
     3     .NOT. NOTAPE ) THEN
C
C        Get the FFT size and spectral averaging for VLBADIFX.  This 
C        correlator can, in principle, do any size FFT, but is more
C        efficient with 256 or so so it seems like a reasonable 
C        value for the minimum.  If someone later wants smaller ones,
C        we can provide a mechanism for specifying them.
C
         MINFFT = 256
         IF( 2 * CORCHAN .GE. MINFFT ) THEN
            IFFT = 2 * CORCHAN
            IAVG = 1
         ELSE
            IFFT = MINFFT
            IAVG = MINFFT / ( 2 * CORCHAN )
         END IF
C   
C        Write the desired information
C   
         WRITE( IOMS, '( A, I8 )' ) '    FFT_SIZE          = ', IFFT
         WRITE( IOMS, '( A, I4 )' ) '    SPECTRAL_AVERAGE  = ', IAVG
         WRITE( IOMS, '( A, A )' )  '    WINDOW            = ', CORWTFN
         IF( CORAV2 .NE. 0.0 .AND. CORAV2 .NE. CORAVG ) THEN
            WRITE( IOMS, '( A, F8.3 )' ) '    ALT_AVERAGE_TIME  = ', 
     1           CORAV2
         END IF
C
      END IF
C
      WRITE( IOMS, '( A, A )' ) '    OUTPUT_TAPE       = ', CORTAPE
      WRITE( IOMS, '( A, A )' ) '    OUTPUT_FORMAT     = ', CORDFMT
      IF( CORSHIP(1) .NE. ' ' ) WRITE( IOMS, '( A, A )' )
     1     '    SHIPPING          = ', CORSHIP(1)(1:LEN1(CORSHIP(1)))
      IF( CORSHIP(2) .NE. ' ' ) WRITE( IOMS, '( A, A )' )
     1     '    SHIPPING          = ', CORSHIP(2)(1:LEN1(CORSHIP(2)))
      IF( CORSHIP(3) .NE. ' ' ) WRITE( IOMS, '( A, A )' )
     1     '    SHIPPING          = ', CORSHIP(3)(1:LEN1(CORSHIP(3)))
      IF( CORSHIP(4) .NE. ' ' ) WRITE( IOMS, '( A, A )' )
     1     '    SHIPPING          = ', CORSHIP(4)(1:LEN1(CORSHIP(4)))
      IF( CORNOTE(1) .NE. ' ' ) WRITE( IOMS, '( A, A )' )
     1     '    NOTE              = ', CORNOTE(1)(1:LEN1(CORNOTE(1)))
      IF( CORNOTE(2) .NE. ' ' ) WRITE( IOMS, '( A, A )' )
     1     '    NOTE              = ', CORNOTE(2)(1:LEN1(CORNOTE(2)))
      IF( CORNOTE(3) .NE. ' ' ) WRITE( IOMS, '( A, A )' )
     1     '    NOTE              = ', CORNOTE(3)(1:LEN1(CORNOTE(3)))
      IF( CORNOTE(4) .NE. ' ' ) WRITE( IOMS, '( A, A )' )
     1     '    NOTE              = ', CORNOTE(4)(1:LEN1(CORNOTE(4)))
      WRITE( IOMS, '( A, F8.2 )' ) '    DATA_OUTPUT_RATE  = ', 
     1     MAXDR / 1000.0
      WRITE( IOMS, '( A, F8.1 )' ) '    DATA_SET_SIZE     = ',
     1     DATASIZE / 1.D6
C
      WRITE( IOMS, '( A, A )' ) '    SOURCE_POS_ORIGIN = ',
     1        CORSRCS(1:LEN1(CORSRCS))
      WRITE( IOMS, '( 1X, /, A, /, 1X )' ) 
     1        'END = CORRELATOR_PARAMETERS'
C
      RETURN
      END

      SUBROUTINE CHKSFIL
C
C     Routine for SCHED called by DEFSET that checks parameters that
C     shouldn't vary between setup groups within a file.
C
C     For now, only the speed up factor and samplerate are checked.
C     In fact, even the speedup factor is no longer needed by any 
C     known correlators.  The speedup factor is really not a relevant
C     concept for the disk based recordings.  They can play back
C     at arbitrary speeds.  So take out that check.  Jan. 11 2011.  RCW.
C
C     Allow the mixed bandwidth mode where several channels from one
C     station play against one from another station.  Don't allow
C     FREQ and DOPPLER when this happens as it becomes ambiguous.
C
C     Older comment, reworded:  The speedup factor only mattered for some
C     correlators.  The sample rate won't matter for DiFX eventually,
C     but leave that for now.  Dec. 3, 2009 RCW
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER  ISETF, KS, RSAMP(MAXSET)
C         LOGICAL  DOCHKSU
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SETSFIL: Starting.' )
C
C     Initialize the variables that are to be set.
C     These are used elsewhere so set them even if not using them.
C
      DO ISETF = 1, NSETF
         FSPEED(ISETF) = 1.0
         RSAMP(ISETF) = 0.0
      END DO
C
C     Loop through the setup groups that are used.
C
      DO KS = 1, NSET
C
C        Get the input setup file that this group was in.
C
         ISETF = ISETNUM(KS)
C
C        Get the speedup factor for the input setup file and check 
C        against any previous groups in this setup file to be 
C        sure it doesn't change.  If there was no previous group 
C        the speedup factor will be zero.
C
C        Don't do the test for S2 at the moment.  The implications
C        are unclear.  Work on this.
C
C        Dec 2009 - start restricting these tests because the new
C        correlator, especially DiFX aren't subject to them.
C
C         DOCHKSU = FORMAT(KS) .NE. 'S2' .AND. FORMAT(KS) .NE. 'NONE' 
C     1       .AND. FORMAT(KS) .NE. 'MARKII' 
C
C        CORREL FXCORR has been turned off, so this won't get done.
C
C         DOCHKSU = DOCHKSU .AND. CORREL .EQ. 'FXCORR' 
C         IF( DOCHKSU ) THEN
C            IF( SPEEDUP(KS) .NE. FSPEED(ISETF) .AND. 
C     1          FSPEED(ISETF) .NE. 0.0 ) THEN
C               CALL WLOG( 1, 'CHKSFIL: Two setup groups in the same ' //
C     1          'setup file have different speedup factors.' )
C               CALL WLOG( 1, '         This cannot be correlated on ' //
C     1          'the '// CORREL // ' correlator.' )
C               CALL ERRSET( KS )
C            END IF
C            FSPEED(ISETF) = SPEEDUP(KS)
C         ELSE
C            FSPEED(ISETF) = 1.0
C         END IF
C
C        Now do the same thing for the sample rate.
C        We now need to allow for multiple bands at one station playing
C        against 1 band at another.  That means that this needs to be
C        turned into a warning, not an error.  Also, I'd like to indicate
C        the amount of overlap.  Finally, note that later code (OKXC) will
C        prevent DOPPLER and FREQ from being used in the main schedule
C        because the meaning of channels becomes ambiguous.
C          
         IF( FORMAT(KS) .NE. 'NONE' .AND. 
     1       FORMAT(KS) .NE. 'MARKII' ) THEN
            IF( SAMPRATE(KS) .NE. RSAMP(ISETF) .AND. 
     1          RSAMP(ISETF) .NE. 0.0 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I3, A, I3, 2A )' )
     1             'CHKSFIL: Setup group, ', KS, ' in setup file ',
     2             ISETF, 
     3             ' does not have the same sample rate as ',
     4             ' other groups in the file.'
               CALL WLOG( 1, MSGTXT )
               CALL WRTMSG( 1, 'CHKSFIL', 'MismatchedSamprate' )
            END IF
            RSAMP(ISETF) = SAMPRATE(KS)
         END IF
C
      END DO
C
      RETURN
      END

      SUBROUTINE sla_MAP (RM, DM, PR, PD, PX, RV, EQ, DATE, RA, DA)
*+
*     - - - -
*      M A P
*     - - - -
*
*  Transform star RA,Dec from mean place to geocentric apparent
*
*  The reference frames and timescales used are post IAU 1976.
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Given:
*     RM,DM    dp     mean RA,Dec (rad)
*     PR,PD    dp     proper motions:  RA,Dec changes per Julian year
*     PX       dp     parallax (arcsec)
*     RV       dp     radial velocity (km/sec, +ve if receding)
*     EQ       dp     epoch and equinox of star data (Julian)
*     DATE     dp     TDB for apparent place (JD-2400000.5)
*
*  Returned:
*     RA,DA    dp     apparent RA,Dec (rad)
*
*  Called:
*     sla_MAPPA       star-independent parameters
*     sla_MAPQK       quick mean to apparent
*
*  Notes:
*
*  1)  EQ is the Julian epoch specifying both the reference frame and
*      the epoch of the position - usually 2000.  For positions where
*      the epoch and equinox are different, use the routine sla_PM to
*      apply proper motion corrections before using this routine.
*
*  2)  The distinction between the required TDB and TT is always
*      negligible.  Moreover, for all but the most critical
*      applications UTC is adequate.
*
*  3)  The proper motions in RA are dRA/dt rather than cos(Dec)*dRA/dt.
*
*  4)  This routine may be wasteful for some applications because it
*      recomputes the Earth position/velocity and the precession-
*      nutation matrix each time, and because it allows for parallax
*      and proper motion.  Where multiple transformations are to be
*      carried out for one epoch, a faster method is to call the
*      sla_MAPPA routine once and then either the sla_MAPQK routine
*      (which includes parallax and proper motion) or sla_MAPQKZ (which
*      assumes zero parallax and proper motion).
*
*  5)  The accuracy is sub-milliarcsecond, limited by the
*      precession-nutation model (IAU 1976 precession, Shirai &
*      Fukushima 2001 forced nutation and precession corrections).
*
*  6)  The accuracy is further limited by the routine sla_EVP, called
*      by sla_MAPPA, which computes the Earth position and velocity
*      using the methods of Stumpff.  The maximum error is about
*      0.3 mas.
*
*  P.T.Wallace   Starlink   17 September 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION RM,DM,PR,PD,PX,RV,EQ,DATE,RA,DA

      DOUBLE PRECISION AMPRMS(21)



*  Star-independent parameters
      CALL sla_MAPPA(EQ,DATE,AMPRMS)

*  Mean to apparent
      CALL sla_MAPQK(RM,DM,PR,PD,PX,RV,AMPRMS,RA,DA)

      END

      SUBROUTINE ERRSET( KS )
C
C     Subroutine for SCHED used by various setup file checking and
C     defaulting routines when there is an error.  It writes the
C     name of the offending setup file and the first station name
C     to the screen, and then aborts the program.
C
C     It also writes the setup file details as far as they are known
C     to this poine.
C
C     This used to be called SETERR, but there is a routine by that 
C     name in the NAIF software so I had to change it when spacecraft
C     tracking was added.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER        KS, LEN1
C ---------------------------------------------------------------------
      IF( SDEBUG ) CALL WLOG( 0, 'ERRSET starting.' )
      CALL WLOG( 0, ' ' )
      CALL WLOG( 0, ' ' )  
      CALL WLOG( 0, '======================== Setup Error' //
     1              ' ========================' )
C
      IF( KS .LE. 0 .OR. KS .GT. MSET ) THEN
         CALL WLOG( 0, 'The line(s) above and/or in the logfile ' //
     1         'describe a fatal setup error.' ) 
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I5, A )' ) 
     1         'The program thinks the error is in setup group ',
     1         KS, ' which is not a valid index.'
         CALL WLOG( 0, MSGTXT )
         CALL WLOG( 0, 'This could be either a user or programming ' //
     1                 'error.' )
         CALL WLOG( 0, 'Please report it to cwalker@nrao.edu' )
         CALL WLOG( 0, '====================================' //
     1              '=========================' )
         CALL ERRLOG( ' ' )
      ELSE
         CALL WLOG( 0, ' ' )
         CALL WLOG( 0, 'The preceeding lines here and/or lines in the'
     1         // ' terminal output describe a ' )
         CALL WLOG( 0, 'fatal setup error in file:'  )
         CALL WLOG( 0, ( SETNAME(KS)(1:LEN1(SETNAME(KS))) ) )
         CALL WLOG( 0, 'Station: ' // SETSTA(1,KS) )
         CALL WLOG( 0, '====================================' //
     1              '=========================' )
         CALL WLOG( 0, 'To help debug the problem, the setup ' //
     1       'information as determined so far is:' )
C        
C        Use the standard setup printing routine to dump the setup.
C        
         CALL PRTSET( KS, ILOG )
C        
         CALL WLOG( 1, ' ' )
         CALL WLOG( 0, ' ' )
         CALL WLOG( 0, 'End of setup as determined before the error '
     1        // 'was found.' )
         CALL WLOG( 0, '====================================' //
     1              '=========================' )
         CALL PUTOUT( '   There is more information about the bad ' //
     1          'setup in ' // LOGFILE(1:LEN1(LOGFILE)) )
         CALL ERRLOG( ' ' )
C
      END IF
C
      RETURN
      END

      SUBROUTINE FLUXH( IUNIT, FFILE )
C
C     Spelled FLUXH because FLUSH seems to be an intrinsic in GNU 
C     FORTRAN (others?).
C
C     Utility routine to flush the buffers of a text file.
C     This makes it reasonable to read the file before the program
C     is really done with it.
C
C     If anyone knows a better way to do this in FORTRAN, let me know.
C
      INTEGER    IUNIT, IERR, VLBOPE
      CHARACTER  FFILE*(*), OPTEXT*(256), LOCFILE*(256)
C ----------------------------------------------------------------------
C
C     Required by some compilers for concatenations:
C
      LOCFILE = FFILE
C
C     Close the file.
C
      CLOSE( UNIT = IUNIT )
C
C     Now open it again.
C
      IERR = VLBOPE( IUNIT, FFILE, 'TEXT', 'OLD', OPTEXT )
      IF( IERR .NE. 1 ) THEN 
         CALL WLOG( 1, 'FLUSH: CANNOT REOPEN FILE ' // LOCFILE )
         CALL WLOG( 1, '       Error text: ' // OPTEXT )
         CALL ERROR( ' Check why file cannot be opened' )
      END IF
C
C     Read to the end.
C
  100 CONTINUE
         READ( UNIT = IUNIT, FMT = '( A )', END = 200 ) OPTEXT
         GO TO 100
  200 CONTINUE
C
C     The GFORTRAN 4.6 compilers don't want to write after an EOF
C     and the above sequence puts one at the end of the file, then
C     positions to just beyond it.  Put in a backspace to back up
C     over the EOF.
C
      BACKSPACE( UNIT = IUNIT )
C
      RETURN
      END

      SUBROUTINE FSFREQ( KF, LOSUM, BBCFREQ, BBCBW,
     1         CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC )
C
C     Routine for SCHED that gets the LO sum, the baseband frequency,
C     and the bandwidth for each channel for a frequency set.
C     It has to take into account any FREQ and BW requests in
C     the schedule, besides the setup file information.  Note that
C     the bandwidth must be half the sample rate with most of the 
C     modern systems, so the bandwidth setting capability is no
C     longer all that useful.  This could be changed in SCHED by
C     adjusting the sample rate, but that is a big job left for
C     some later time.
C
C     This routine also provides the values for the VLBA legacy system
C     which might be different for reference pointing or if the 
C     new system is being used at too wide a bandwidth or with
C     too many channels.  These parameters are:
C       CRDN          Number of channels for the BBCs (1 per BBC).
C       CRDF(ICH)     Baseband frequency for channel.
C       CRDB(ICH)     Bandwidth for channel.
C       CRDS(ICH)     Baseband sideband for channel (U/L)
C       CRDLOSUM(ICH) LO sum to use for setting up PCALX.
C     The legacy system sample rate can 
C     Note CRDS is from SIDEBD, which is SIDEBAND in the setup.
C
C     Note that, for historical reasons, there is a potential 
C     confusion because the BBC parameters of the call
C     refer to the RDBE channels for the VLBA when that is
C     in use while the CRD parameters are for the legacy BBCs.
C
C     Do not call ERRSET from this routine despite the temptation.
C     It is called by ERRSET, so that can cause big trouble.
C
C     This routine is called by a number of routines including:
C     CHKSCN, FSMATCH, OMSFREQ, PCALFQ, PRTFREQ, PRTSCH, STAFRD, and
C     WRTFREQ.
C
      INCLUDE     'sched.inc'
      INCLUDE     'schset.inc'
      INCLUDE     'schfreq.inc'
C
      INTEGER            KF, KS, KSCN, ILC, ISETF, KSTA, ISTA
      INTEGER            IFIF, IFCAT, LEN1, ICH
      CHARACTER          SDAR*5
      DOUBLE PRECISION   LOSUM(*)
      DOUBLE PRECISION   BBCFREQ(*), BBCBW(*) 
      DOUBLE PRECISION   CRDF(*), CRDB(*), CRDLOSUM(*), FDROP
      LOGICAL            FWARN, ERRS, DEQUAL
C
      INTEGER            CRDN, CRSETC(*), ICHS
      CHARACTER          CRDS(*)*1
      INTEGER            ICRDS(MCHAN)
      INTEGER            ISIDE1(MCHAN), INETSIDE(MCHAN)
      DOUBLE PRECISION   FSHIFT
C
      DATA               FWARN / .TRUE. /
      SAVE               FWARN
C ----------------------------------------------------------------------
      IF( DEBUG ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I5 )' )
     1     'FSFREQ: starting for freq group ', KF
         CALL WLOG( 0, MSGTXT )
      END IF
C
C     Make sure this wasn't mistakenly called with KF = 0, perhaps 
C     when NOSETUP was specified.  I had a complaint from JIVE about
C     this happening.  It is probably ok to just not take action.
C
      IF( KF .EQ. 0 ) THEN
         CALL WLOG( 1, 'FSFREQ: Called for frequency set zero.  '//
     1        'Non-fatal (?) programming issue.' )
         GO TO 999
      END IF
C
C     Get the setup group, the defining scan of the frequency set,
C     and the setup file.  Also get the schedule station number of
C     the catalog station.
C
      KS    = FSETKS(KF)
      KSCN  = FSETSCN(KF)
      KSTA  = ISETSTA(KS)
      ISETF = ISETNUM(KS)
      ISTA  = ISCHSTA(KSTA)
      IF( ISTA .LE. 0 ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I5, A, I5 )' )
     1      'FSFREQ:  Schedule station corresponding to setup ', 
     2      'station ', KSTA, ' is ', ISTA 
         CALL WLOG( 1, MSGTXT )
         CALL ERRLOG( '         That is now allowed. ' //
     1      'Programming error? ' )
      END IF
C
C     Get the number of channels and the list of setup file channels
C     to use for parameters other than frequency and bandwidth.
C
      CALL GETCRDN( KSCN, ISTA, CRDN, CRSETC )
C
C----------------------------------------
C     Deal with the VLBI channels (These are for the Vex file).
C----------------------------------------
C
C     On the VLBA, these are likely to be in the RDBE as the MARK5A
C     system is retired.
C 
C     Loop through the setup group channels.
C
      DO ICH = 1, NCHAN(KS)
C
C        If we are getting frequencies from the scan inputs, they
C        must be for the correct logical channel, which just might
C        not be for that same channel number in the setup group.
C
C        Note that, if FREQ or BW come from scan input and OKXC is
C        false, the program should have aborted in DOPFQ.  OKXC
C        is allowed to be false if the frequencies are from the
C        setup group only.
C
C        Get the setup file "logical" channel.  Note that, if
C        OKXC is false, ILC will not be used except in some
C        IF statments that should fail.  It is set here to ICH
C        to keep those IF statements from having addressing 
C        exceptions.
C
         IF( OKXC(ISETF) ) THEN
            ILC = SFCHAN(ICH,KS)
         ELSE
            ILC = ICH
         END IF
C
C        Assume that the sideband structure and firstlo are the
C        same as the setup file.
C
         IF( SIDE1(ICH,KS) .EQ. 'U' ) THEN
            ISIDE1(ICH) = 1
         ELSE IF( SIDE1(ICH,KS) .EQ. 'L' ) THEN
            ISIDE1(ICH) = -1
         ELSE
            CALL WLOG( 1,
     1         'FSFREQ: First LO sideband not correctly specified.' )
            CALL WLOG( 1, ' Setup file: ' // 
     1         SETNAME(KS)(1:LEN1(SETNAME(KS))) )
            CALL ERRLOG( ' Fix the problem ' )
         END IF
C
C        Get the BBC frequency using the FREQ input or setup value.

         IF( OKXC(ISETF) .AND. FREQ(ILC,KSCN) .GT. 0.0D0 ) THEN
C
C           Use the frequency from the main schedule.  The fact that
C           it is not zero implies that either DOPPLER or FREQ was
C           specified for the scan(s).  Avoid spurious low significant 
C           digits but allow down to fractional Hz.  The allowed digits
C           will be set elsewhere and we don't want to preclude those
C           tests here.  FREQ will be in the system (logical channels)
C           before the sideband inversion reflected in CORINV for
C           RDBE/PFB stations.  So CORINV needs to be added.
C
            BBCFREQ(ICH) = ABS( FREQ(ILC,KSCN) + CORINV(ICH,KS) - 
     1                        FIRSTLO(ICH,KS) )
            BBCFREQ(ICH) =  DNINT( BBCFREQ(ICH) * 1.D7 ) / 1.D7
C
C           Check that the assumed sideband is correct.  Pedantically,
C           this should be corrected for CORINV, but it won't matter.
C
            IF( ( FREQ(ILC,KSCN) -
     1           FIRSTLO(ICH,KS) ) * ISIDE1(ILC) .LT. 0 ) THEN
               CALL WLOG( 1, 'FSFREQ: Frequency from main schedule' //
     1              ' not consistent with sideband from setup file.' )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, 2F14.5, I3 )' )
     1             '        Frequency, first LO, sideband: ',
     2              FREQ(ILC,KSCN), FIRSTLO(ICH,KS), ISIDE1(ILC)
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, ' Setup file: ' //
     1                    SETNAME(KS)(1:LEN1(SETNAME(KS))) )
               CALL ERRLOG( ' Fix frequencies ' )
            END IF
C
C           Check that FREQ is in the RF range for the current
C           frequency catalog group, if a frequency catalog group
C           was used.  The frequency catalog group is IFREQNUM, which
C           can be channel dependent, as determined in SETFCAT).  
C           This check only needed when a frequency is specified in 
C           the schedule, which it is if you got through the last 
C           IF statement.  The check has already been checked for 
C           setup file freqs.
C
            IF( IFREQNUM(ICH,KS) .GE. 1 .AND. FWARN ) THEN
               IFIF = IFREQIF(ICH,KS)
               IFCAT = IFREQNUM(ICH,KS)
               IF( ( FREQ(ILC,KSCN) + CORINV(ICH,KS) .LT. 
     1                 FRF1(IFIF,IFCAT) .OR. 
     2               FREQ(ILC,KSCN) + CORINV(ICH,KS) .GT. 
     3                 FRF2(IFIF,IFCAT) ) ) THEN
                  CALL WLOG( 1, 'FSFREQ: -- WARNING -- Frequency ' //
     1                 'specified in  schedule (or by Doppler) is ' )
                  CALL WLOG( 1, '          outside limits for IF.' )
                  CALL WLOG( 1, '        Setup file: ' //
     1                       SETNAME(KS)(1:LEN1(SETNAME(KS))) )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I4, A, A )' ) 
     1              '        Setup group:', KS, '  Station: ', 
     2                       SETSTA(1,KS)
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, F9.2 )' )
     1             '        Frequency:', FREQ(ILC,KSCN) + CORINV(ICH,KS)
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, F9.2, A, F9.2 )' )
     1              '        Freq catalog limits: ', FRF1(IFIF,IFCAT),
     2              ' to ', FRF2(IFIF,IFCAT)
                  CALL WLOG( 1, MSGTXT )
                  FWARN = .FALSE.
               END IF
            END IF
C
         ELSE
C
C           Use the SETUP file value.  Simple case.
C
            BBCFREQ(ICH) = BBSYN(ICH,KS)
C
         END IF
C
C        Get the BBC bandwidth specification, again using program input
C        or the setup file value.
C
         IF( OKXC(ISETF) .AND. BW(ILC,KSCN) .NE. 0.0D0 ) THEN
C
C           Set the bandwidth from the BW command and check 
C           against sample rate.  ABS in case of old files with
C           sign of BW indicating sideband.
C
            BBCBW(ICH) = ABS( BW(ILC,KSCN) )
C
            IF( BBCBW(ICH) .GT. 0.50001D0 * SAMPRATE(KS) ) THEN
               CALL WLOG( 1, 'FSFREQ: **** Bandwidth from schedule '
     1                  // ' more than half of sample rate.' )
               CALL WLOG( 1, ' Setup file: ' //
     1                 SETNAME(KS)(1:LEN1(SETNAME(KS))) )
               CALL ERRLOG( ' Fix bandwidth or sample rate ' )
            END IF
C
         ELSE
C
C           Otherwise use the setup file value.
C
            BBCBW(ICH) = BBFILT(ICH,KS)
C
         END IF
C
C        Get the LO sum.  Clean up any odd digits.
C
         LOSUM(ICH) = FIRSTLO(ICH,KS) + ISIDE1(ICH) * BBCFREQ(ICH)
         LOSUM(ICH) =  DNINT( LOSUM(ICH) * 1.D7 ) / 1.D7
C
      END DO
C
C     Check some of the results.
C
      SDAR = DAR(KSTA)
C
C     Make some VLBA specific checks.
C
      IF( SDAR .EQ. 'VLBA' ) THEN
C
C        Check that the BBC frequency is in range for VLBA BBCs and     
C        that the requested bandwidth is valid.
C
         DO ICH = 1, NCHAN(KS)
            IF( BBCFREQ(ICH) .LT. 500.0D0 .OR.
     5          BBCFREQ(ICH) .GE. 1000.0D0 ) THEN
               WRITE( MSGTXT, '( A, I3, F10.2, I5, F10.2, I5 )' )
     1            'FSFREQ: chan, firstLO, setup, freq, freq set: ', 
     2            ICH, FIRSTLO(ICH,KS), KS, LOSUM(ICH), KF
               CALL WLOG( 1, MSGTXT )
               WRITE( MSGTXT, '( A, F10.2 )' )
     1            'FSFREQ: Bad VLBA BBC frequency:', BBCFREQ(ICH)
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, ' Setup file: ' //
     1             SETNAME(KS)(1:LEN1(SETNAME(KS))) )
               CALL ERRLOG( ' Fix frequencies ' )
            END IF
C
            IF( .NOT. ( DEQUAL( BBCBW(ICH), 0.0625D0 ) .OR. 
     1                  DEQUAL( BBCBW(ICH), 0.125D0 ) .OR.
     2                  DEQUAL( BBCBW(ICH), 0.250D0 ) .OR. 
     3                  DEQUAL( BBCBW(ICH), 0.5D0 ) .OR.
     4                  DEQUAL( BBCBW(ICH), 1.0D0 ) .OR. 
     5                  DEQUAL( BBCBW(ICH), 2.0D0 ) .OR.
     6                  DEQUAL( BBCBW(ICH), 4.0D0 ) .OR. 
     7                  DEQUAL( BBCBW(ICH), 8.0D0 ) .OR.  
     8                  DEQUAL( BBCBW(ICH), 16.D0 ) ) ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, F8.2 )' )
     1            'FSFREQ: Invalid bandwidth request (in scan?): ',
     2            BBCBW(ICH)
               CALL ERRLOG( MSGTXT )
            END IF
         END DO
      END IF
C
C     Similar checks for the RDBE or DBBC, but put in subroutine that
C     is called from here and from CHKRDBE or CHKDBBC.  First the RDBE.
C
      ERRS = .FALSE.
      IF( DBE(KS) .EQ. 'RDBE_PFB' .OR. DBE(KS) .EQ. 'RDBE_DDC' ) THEN
         CALL CHKRDFQ( KS, KF, BBCBW, BBCFREQ, ERRS )
      END IF
C
C     DBBC (EVN etc.)
C
      IF( DBE(KS) .EQ. 'DBBC_PFB' .OR. DBE(KS) .EQ. 'DBBC_DDC' ) THEN
         CALL CHKDBFQ( KS, BBCBW, BBCFREQ, ERRS, .FALSE. )
      END IF
C
      IF( ERRS ) THEN
         CALL WLOG( 1, 'FSFREQ:  Fix problem with in-line '//
     1    'or Doppler derived frequencies or bandwidths.' )
         CALL ERRSET( KS )
      END IF
C
C     Similar checks for Mark 4?
C
C
C----------------------------------------------
C     CRD parameters for legacy BBCs.
C----------------------------------------------
C
C     Get the CRD parameters if they are needed, which they always will
C     be for a VLBA station until the legacy system is gone.  For some
C     cases (MARK5A observations, narrow band DDC setups ...), these
C     values will duplicate items in the normal setup, but it is easier
C     for the calling routines if they can always use the value from
C     here so set them regardless.
C
C     First the cases when the CRD parameters should just be the same as
C     the setup or the main FREQ and DOPPLER numbers.  This is when 
C     either a VLBA control system is not being used or the RDBE is 
C     not being used.
C
      IF( SDAR(1:4) .NE. 'RDBE' .OR. 
     1    ( CONTROL(KSTA) .NE. 'VLBA' .AND. .NOT. VLBADAR(KSTA) ) ) THEN
C
C        For this case, the setup values, possibly adjusted by FREQ and 
C        DOPPLER should be used.  On the VLBA, this will likely be a 
C        MARK5A recording case and we should not muck with the BBC 
C        frequencies using the CRD parameters.  Other stations  don't 
C        use the CRD parameters, so just put in the setup values
C        as dummies.
C
         DO ICH = 1, CRDN
            ICHS = CRSETC(ICH)
            CRDF(ICH) = BBCFREQ(ICHS)
            CRDB(ICH) = BBCBW(ICHS)
            CRDS(ICH) = SIDEBD(ICHS,KS)
            CRDLOSUM(ICH) = LOSUM(ICHS)
         END DO
C
      ELSE 
C
C        Now the case when using the RDBE on the VLBA or a station with 
C        the legacy VLBA control system (GBT and EB are the only ones in
C        the station catalog).  The legacy BBCs are used to generate 
C        some Tsys and pulse cal data, but not VLBI data.  More 
C        importantly, the legacy BBCs generate the power data used for 
C        reference pointing on the VLBA.  Since the VLBI data are not
C        affected, we are free to change the frequencies, bandwidths, 
C        and number of channels.
C
C        First get CRDB and CRDS - the legacy BBC bandwidth and 
C        sideband - out of the way as they need the same treatment for
C        all of the cases dealt with later.  Here use CRDBW if it is 
C        not zero and BBCBW if it is.  If BBCBW is over 16 MHz, the 
C        maximum that the BBCs allow, use 16 MHz.  Do not let CRDB
C        exceed BBCBW.  That would create more issues with the samplerate
C        and format than are worth trying to deal with for a case 
C        that is not likely to be used.
C
C        Using CRDBW even in scans that do not have CRDFREQ or CRDDOP 
C        allows adjustment of the BBC bandwidth without setting the 
C        other CRD parameters.  I'm not too sure why you would do that,
C        but it's easy.
C
C        Do for the number of channels given in GETCRDN and relate 
C        those to the specified setup file channels.
C
         DO ICH = 1, CRDN
            ICHS = CRSETC(ICH)
            IF( CRDBW(ICH,KSCN) .LE. 0.D0 ) THEN
               CRDB(ICH) = MIN( BBCBW(ICHS), 16.D0 )
            ELSE IF( CRDBW(ICH,KSCN) .GT. BBCBW(ICHS) ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( 2A )' )
     1            'FSFREQ:  CRDBW value greater than setup file ',
     2            'value.  Don''t do that!'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I4, A, F10.2 )' )
     1            '         Setup: ', KS, '  CRDBW: ', CRDBW(ICH,KSCN)
               CALL ERRLOG( MSGTXT )
            ELSE
               CRDB(ICH) = CRDBW(ICH,KSCN)
            END IF
C
C           Deal with sidebands.  Keep same as RDBE before any
C           inversions.  Note that we need to do the same as in DOPCRD
C           or the frequencies will be wrong.
C
C    *******************  I think I need SIDEDB not CRDSIDE - need to use
C                         the final sideband setting.
C           Note that CRDSIDE is a saved version of SIDEDB from before
C           any sideband inversions were done.  The channel index is
C           the setup file channel index, not the crd channel.
C
            IF( SIDEBD(ICHS,KS) .EQ. 'U' ) THEN
               CRDS(ICH) = 'U'
               ICRDS(ICH) = 1
            ELSE
               CRDS(ICH) = 'L'
               ICRDS(ICH) = -1
            END IF
         END DO
C
C        If CRDFREQ or CRDDOP were used, GOTCRD should be set and CRDFREQ
C        should either be the input value or one calculated by DOPCRD.
C        Since the CRD stuff is scan dependent, we get the needed information
C        from the reference scan for the frequency set.  That was 
C        set above as KSCN.
C
C        CRDNCH is a required user input if CRDFREQ or CRDDOP is used
C        but can be given any time.  Use it if set.  INFDB will already
C        have require that it be set if CRDFREQ or CRDDOP is used.
C        DOPCRD has enforced reasonable values for all scans.  The user
C        could have used CRDCH1 or CRDSETSC to specify that the mapping
C        between setup channels and legacy system channels.  This will 
C        be useful for dual band cases when some CRD channels are 
C        desired from both bands, although SCHED's defaults will also 
C        enforce having all IFs represented.  Anyway, because of this 
C        option, we need to be careful about the meaning of the channel 
C        numbers.  Here ICH is an output CRD channel and ICHS is the 
C        corresponding setup file channel.
C
         IF( GOTCRD(KSCN) ) THEN
            DO ICH = 1, CRDN
               ICHS = CRSETC(ICH)
               CRDF(ICH) = ABS( CRDFREQ(ICH,KSCN) - FIRSTLO(ICHS,KS) )
               CRDB(ICH) = CRDBW(ICH,KSCN)
               CRDLOSUM(ICH) = FIRSTLO(ICHS,KS) + ISIDE1(ICHS) * 
     1               CRDF(ICH)
               CRDLOSUM(ICH) = DNINT( CRDLOSUM(ICH) * 1.D7 ) / 1.D7
C
C              Complain if CRDFREQ has not been set (happened during
C              debugging).
C
               IF( CRDFREQ(ICH,KSCN) .LE. 0.D0 ) THEN
                  CALL WLOG( 1, 'FSFREQ: CRDFREQ zero when either '//
     1                'it or CRDDOP was set by user.' )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I5, A, I5, A, F12.4 )' )
     1                '        KSCN:', KSCN, '    ICH:', ICH,
     2                '    CRDFREQ:', CRDFREQ(ICH,KSCN)
                  CALL WLOG( 1, MSGTXT )
                  CALL ERRLOG( ' Probable programming error.  ' )
               END IF
            END DO
         ELSE
C
C           Now deal with the case where valid BBC frequencies need
C           to be established based on the setup and FREQ/BW entries.
C           They cannot necessarily be the same as in the setup because
C           the RDBE can handle more channels (PFB) and wider bandwidths
C           (DDC and PFB) than the legacy system.  We will try for a 
C           reasonable match.
C
C           This code used to be in WRTFREQ, but has been moved in
C           case I want to use it other than in writing the crd files.
C           The CRDDOP etc parameters forced enough of a restructuring
C           to make it reasonable to put it here.
C
C           Deal with which setup channels to try to match.  We will only
C           do 8 (one per BBC).  This is fine for the DDC, but for the
C           PFB there are 16 channels, so we need to be selective.  
C           For now, do the first 8.  We used to do the middle 8 but 
C           it is easier to do the first 8, although the benefits are
C           less strong than I thought when I switched.  We could go
C           back to the middle 8 some day.  If so, neet to deal with 
C           the bandwidth above.
C
C           Allow the user to have specified the number of channels 
C           even if not doing CRDFREQ or CRDDOP.
C
C
C           Loop over the channels assigning data to use.
C
            DO ICH = 1, CRDN
               ICHS = CRSETC(ICH)
C
C              Get an integer version of NETSIDE for multiplications.
C
               IF( NETSIDE(ICHS,KS) .EQ. 'U' ) THEN
                  INETSIDE(ICH) = 1
               ELSE
                  INETSIDE(ICH) = -1
               END IF
C
C              Start with setting the bandwidth and frequency to the
C              setup file versions.
C
               CRDF(ICH) = BBCFREQ(ICHS)
C
C              If the bandwidth had to be limited to the BBC hardware
C              max, get the amount to shift the frequency to center
C              on the RDBE band.
C
C              Be sure the shift is a multiple of 10 kHz.
C
               FSHIFT = 0.0D0
               IF( BBCBW(ICHS) .GT. 16.0D0 ) THEN
                  CRDB(ICH) = 16.0D0
                  FSHIFT = ( BBCBW(ICHS) - CRDB(ICH) ) / 2.D0
                  FSHIFT = NINT( FSHIFT * 100.D0 ) / 100.D0
               END IF
C
C              Get the new BBC frequency and LO sum.  Note that
C              the effects of the sideband can differ.  Round the
C              new BBC frequency to 10 kHz in case it doesn't 
C              conform to that BBC constraint.  Note that DDC
C              frequency rules might well generate main basebands 
C              that do not conform to the legacy constraints.
C
               CRDF(ICH) = CRDF(ICH) + ICRDS(ICH) * FSHIFT
               CRDF(ICH) = NINT( CRDF(ICH) * 100.D0 ) / 100.D0
C
C              Get the LO sum for the legacy channels.
C
               CRDLOSUM(ICH) = FIRSTLO(ICHS,KS) + 
     1               ISIDE1(ICHS) * CRDF(ICH)
C
C              If the LO sum is an integer number of MHz, the
C              pulse cal tones can be subject to aliasing.  Since
C              the exact frequency settings here are not critical
C              (not going to be used for the recordings), 
C              shift the CRDF and CRDLOSUM in such cases by 10 kHz 
C              so that the tone is at 10 kHz in the baseband.
C
C              Do this before the FDROP adjustment in case this provokes
C              crossing the boundary of allowed values.
C
C              Note that, in some cases with a FIRSTLO that is not an
C              integer MHz (eg new VLBA synthesizer), CKSCHED may 
C              reject the specified tone frequencies
C              even if they are right.  Don't worry about that for the 
C              moment.  Hopefully we'll have pulse cal detection in the 
C              new system before the arrival of full use of the new
C              synthesizers makes this an issue.
C
               IF( ( FSPCAL(KF) .EQ. '1MHz' .OR. 
     1               FSPCAL(KF) .EQ. '5MHz' ) .AND. 
     2             MOD( CRDLOSUM(ICH), 1.D0 ) .EQ. 0.D0 ) THEN
                  CRDLOSUM(ICH) = CRDLOSUM(ICH) - INETSIDE(ICH) * 0.01D0
                  CRDF(ICH) = ABS( FIRSTLO(ICHS,KS) - CRDLOSUM(ICH) )
               END IF
C
C              Get away from the frequency range that can't be 
C              covered by the old BBCs but are ok for the RDBE 
C              (1000.0 to 1024.0 - or even up to 1040 in some cases
C              with a sacrificial channel).  Go by a multiple of 
C              5 MHz to keep pcal detection frequencies for 5 MHz
C              tones.
C
               IF( CRDF(ICH) .GE. 999.95D0 ) THEN
                  FDROP = CRDF(ICH) - 999.95D0
                  FDROP = 5.D0 * ( 1.D0 + DINT( FDROP / 5.D0 ))
                  CRDF(ICH) = CRDF(ICH) - FDROP
                  CRDLOSUM(ICH) = FIRSTLO(ICHS,KS) + 
     1                            ISIDE1(ICHS) * CRDF(ICH)
               END IF
            END DO
         END IF
      END IF

C
  999 CONTINUE
      IF( DEBUG ) CALL WLOG( 0, 'FSFREQ: Ending' )
      RETURN
      END

      SUBROUTINE CHKDBFQ( KS, BBCBW, BBCFREQ, ERRS, VERBOSE )
Cf2py intent(in) KS, BBCBW, BBCFREQ, VERBOSE
Cf2py intent(in, out) ERRS
C
C     Routine for SCHED called by CHKDBBC and FSFREQ that checks
C     the frequencies and bandwidths requested for the DBBC.
C     CHKDBBC checks the input setup file.  FSFREQ checks just
C     before writing the scan info to be sure in-line changes
C     don't cause trouble.
C
C     Note that this routine can get called multiple times for 
C     each setup file, especially if different frequency sets
C     are being checked.  Also, since it is called from FSFREQ,
C     it can get called from print routines etc. The VERBOSE parameter
C     lets you control the output volume at call time.
C
C     Original based on CHKDBFQ, but modified by CR to the best of
C     current knowledge...
C     Removed unused variables from declarations.  Aug. 30, 2013. RCW
C     2017-06-22 added DBBC filter 4 (1024-1536 MHz). CR
C     2018-06-28 added DBBC filters 3 (1536-2048 MHz) and 6 (0-1024 MHz). CR
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER           I
      INTEGER           KS, ICH, JCH, ISIDEBD ! , nwarn
      INTEGER           N40WARN(MAXSET), N528WARN(MAXSET)
      INTEGER           NFWARN, NIFERR
      INTEGER           LEN1, ISETF
      INTEGER           NFILT, FILT_USED, IFILT
      DOUBLE PRECISION  BBOFF, BB1, BB2, SLOP, IF_LOW, IF_HI
      DOUBLE PRECISION  BBCBW(*), BBCFREQ(*)
      PARAMETER         (NFILT=6)
      DOUBLE PRECISION  FILT_LOW(NFILT), FILT_HI(NFILT)
      LOGICAL           ERRS, DEQUAL, OBWARN, SHOWID, FILTERR, ALREADY
      LOGICAL           VERBOSE, FILTWARN
      CHARACTER         IFERRS(MCHAN)*2
C
      DATA     OBWARN   / .TRUE. /
      DATA     N40WARN  / MAXSET*1 /
      DATA     N528WARN / MAXSET*1 /
      DATA     NFWARN   / 0 /
      SAVE     N40WARN, N528WARN, NFWARN, OBWARN
C
C     FILT_LOW and FILT_HI are low and high boundaries for each of the
C     DBBC filters. Order is important as only filters 1&2 are available
C     on *all* DBBC versions. See code for further explanation.
C
      DATA     FILT_LOW / 10.0D0, 512.0D0, 1024.0D0, 10.0D0,
     1                   1536.0D0, 1150.0D0 /
      DATA     FILT_HI / 512.0D0, 1024.0D0, 1536.0D0, 1024.0D0,
     1                   2048.0D0, 1750.0D0 /
C -----------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKDBFQ: Starting' )
C
      SHOWID = .FALSE.
C
C     Get the setup file number
C
      ISETF = ISETNUM(KS)

C
C     Note the checks are needed for all setups, not just ones used for
C     recording.
C
C     First check the DBBC_PFB personality.
C
      IF( DBE(KS) .EQ. 'DBBC_PFB' ) THEN
C
C        All bandwidths must be 32 MHz.
C   ***********************  True.
C
         DO ICH = 1, NCHAN(KS)
            IF( BBCBW(ICH) .NE. 32.0D0 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, F8.3 )' )
     1            'CHKDBFQ: Bandwidth must be 32.0 MHz for ',
     2            'DBE=DBBC_PFB. Value specified is: ', 
     3            BBCBW(ICH)
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
         END DO
C
C        Baseband frequencies must be 1024.0-16.0-N*32.0 for
C        N = 0 to 14.  Also allow 15 so that there can be
C        16 channels in one polarization, but warn that it 
C        will be bad.
C
C        Jan 2012.  Allow the "-1" channel from 1040-1008 MHz 
C        for when people want to span the full 512 MHz IF in
C        one polarization.  The on-line system wants this one,
C        not the one at the low end of the IF (#15).
C
         DO ICH = 1, NCHAN(KS)
            BBOFF = 1024.0D0 + 16.0D0 - BBCFREQ(ICH)
            IF( MOD( BBOFF, 32.0D0 ) .NE. 0.0D0 .OR.
     1          NINT( BBOFF / 32.0D0 ) .LT. 0 .OR.
     2          NINT( BBOFF / 32.0D0 ) .GT. 16 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, F8.2, A )' )
     1            'CHKDBFQ: Invalid BBSYN for DBE=DBBC_PFB: ', 
     2            BBCFREQ(ICH),
     3            '.  Must be 1024+16-N*32 for N=0-15.'
               ERRS = .TRUE.
               CALL WLOG( 1, MSGTXT )
            END IF
            IF( BBCFREQ(ICH) .EQ. 1040.0D0 .AND. 
     1            N40WARN(ISETF) .LE. 1 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, F8.2, A )' )
     1            'CHKDBFQ: Baseband frequency ', BBCFREQ(ICH),
     2            '.  Will produce poor data with the PFB.'
               CALL WLOG( 1, MSGTXT )
               N40WARN(ISETF) = N40WARN(ISETF) + 1
               SHOWID = .TRUE.
            END IF
            IF( BBCFREQ(ICH) .EQ. 528.0D0 .AND. 
     1            N528WARN(ISETF) .LE. 1 ) THEN
C      **********************   Is this one true for the DBBC?
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, F8.2, A, A )' )
     1            'CHKDBFQ: Baseband frequency ', BBCFREQ(ICH),
     2            '.  Will be changed to 1040 by the VLBA on-line',
     3            ' system.'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' ' 
               WRITE( MSGTXT, '( A, A )' )
     1            'CHKDBFQ: Correlation of that channel will be ',
     2            ' corrupted.'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' ' 
               WRITE( MSGTXT, '( A, A, A )' )
     1            'CHKDBFQ:  This is normal for 16 chan, 1 pol, ',
     3            'with sideband inversion at some station.'
               CALL WLOG( 1, MSGTXT )
               N528WARN(ISETF) = N528WARN(ISETF) + 1
               SHOWID = .TRUE.
            END IF
         END DO
      END IF
C
C     ===  Now check the DDC personality. ===
C
      IF( DBE(KS) .EQ. 'DBBC_DDC' ) THEN
C
C        All bandwidths must be between 1 and 16 MHz. 32 MHz is
C        available with the e-series firmware.
C
         DO ICH = 1, NCHAN(KS)
            IF( .NOT. ( DEQUAL( BBCBW(ICH), 32.0D0 ) .OR. 
     2          DEQUAL( BBCBW(ICH), 16.0D0 ) .OR. 
     3          DEQUAL( BBCBW(ICH), 8.0D0 ) .OR. 
     4          DEQUAL( BBCBW(ICH), 4.0D0 ) .OR. 
     5          DEQUAL( BBCBW(ICH), 2.0D0 ) .OR. 
     6          DEQUAL( BBCBW(ICH), 1.0D0 ) ) ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, F8.3 )' )
     1            'CHKDBFQ: Bandwidth must be 1 to 32 MHz for ',
     2            'DBE=DBBC_DDC. Value specified is: ', 
     3            SIDEBD(ICH,KS)
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
C
C           Also Sampling must be Nyquist rate.
C
            IF( .NOT. DEQUAL(1.0D0*SAMPRATE(KS), 2.0D0*BBCBW(ICH))) THEN
               MSGTXT = ' '              
               WRITE( MSGTXT, '( A, A, F8.3, A, F8.3, A )' )
     1           'CHKDBFQ: Invalid SAMPRATE and BBFILTER specified: ', 
     2           'SAMPRATE= ', SAMPRATE(KS), ', BBFILTER= ', BBCBW(ICH),
     3           ' Only Nyquist sampling is permitted on DBBCs.'
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
         END DO
C
C        CR: the available filters depend on the version of the DBBC.
C        For DBBC Versions 1 and 2 the following appears to be correct:
C        Baseband frequencies for a given filter must be between 10-512
C        MHz (filter 2) or 512-1024 MHz (filter 1) or between 1024-1536
C        MHz (filter 4 - not in all firmware versions). They appear to
C        be fully flexible within each range.
C
C        The DBBC version 3 also permits:
C        10-1024 MHz (filter 6), 1536-2048 MHz (filter 3), 1150-1750 MHz
C        (filter 5)
C 
C        
C
         NIFERR = 0
         FILTWARN = .FALSE.
         DO ICH = 1, NCHAN(KS)
            FILTERR = .TRUE.
C
C           Check that it is in a valid IF, and only one filter set is used
C           for each IF
C
            ISIDEBD = 1
            IF( SIDEBD(ICH,KS) .EQ. 'L' ) ISIDEBD = -1
            BB1 = BBCFREQ(ICH)
            BB2 = BBCFREQ(ICH) + ISIDEBD * BBCBW(ICH)
            IF( BB1 .LT. 10.0D0 .OR.
     1          BB1 .GT. 2048.0D0 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, F8.2, A )' )
     1            'CHKDBFQ: Invalid BBSYN for DBE=DBBC_DDC: ', 
     2            BBCFREQ(ICH),
     3            '.  Must be between 10 and 2048 MHz.'
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            ELSE
C              Check that all other BBCs using this IFCHAN fit in one of
C              the available filters. Record the filter that is being
C              used.
               IF_LOW = BB1
               IF_HI = BB1
               DO JCH = ICH+1, NCHAN(KS)
                  IF( IFCHAN(JCH,KS) .EQ. IFCHAN(ICH,KS) ) THEN
                     IF( BBCFREQ(JCH) < IF_LOW ) THEN
                        IF_LOW = BBCFREQ(JCH)
                     END IF
                     IF( BBCFREQ(JCH) > IF_HI ) THEN
                        IF_HI = BBCFREQ(JCH)
                     END IF
                  END IF
               END DO
               FILT_USED = 0
               DO IFILT = 1, NFILT
C                 Find the first matching filter
                  IF( FILT_USED < 1 .AND. 
     1                  IF_LOW > FILT_LOW(IFILT) .AND. 
     2                  IF_HI < FILT_HI(IFILT) ) THEN
                     FILT_USED = IFILT
                  END IF
               END DO
               IF( FILT_USED > 0 ) THEN
                  FILTERR = .FALSE.
               END IF
            END IF


            IF( FILTERR ) THEN
               ALREADY = .FALSE.
               DO I = 1, NIFERR
                  IF( IFCHAN(ICH,KS) .EQ. IFERRS(I) ) ALREADY = .TRUE.
               END DO
               NIFERR = NIFERR + 1
               IFERRS(NIFERR) = IFCHAN(ICH,KS)
               IF( VERBOSE .AND. .NOT. ALREADY ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A, A, A, A )' )
     1               'CHKDBFQ: Illegal BBCSYN placement for ',
     2               'DBE=DBBC_DDC. All BBSYN of an IF ',
     3               'must fit one of the DBBC filters below. ', 
     4               'Check frequencies for IF ', IFCHAN(ICH,KS)
                  CALL WLOG( 1, MSGTXT )
                  CALL WRTMSG( 1, 'CHKDBFQ', 'dbbcfilters' )
                  ERRS = .TRUE.
               END IF
            ELSE
C              Filters 3,5,6 only available on DBBC Version 3.
               IF(VERBOSE .AND. .NOT. FILTWARN .AND. FILT_USED > 3) THEN
                  FILTWARN = .TRUE.
                  MSGTXT = ' '
                  WRITE( MSGTXT, '(A, A, A, A, A)' )
     1               'CHKDBFQ: IF ', IFCHAN(ICH,KS), 
     2               ' uses one of DBBC filters ',
     3               '3, 5 or 6. These are only available on ',
     4               'DBBC Version 3. Check you have it!'
               CALL WLOG( 1, MSGTXT )
               CALL WRTMSG( 1, 'CHKDBFQ', 'dbbcfilters' )
               SHOWID = .TRUE.
               END IF
            END IF
C
C           Check the other end of the sideband.  Just warn of the
C           issue in this case.  Only warn once if it is less than
C           1% of the band - it's probably because of trying to get
C           decent pcal frequencies.
C
            IF( FILT_USED > 0 ) THEN
               SLOP = MAX( FILT_LOW(FILT_USED) - BB2, 
     1                  BB2 - FILT_HI(FILT_USED) )
            ELSE
               SLOP = 0.0D0
            END IF
            IF( VERBOSE ) THEN
               IF( ( SLOP .GT. 0.D0 .AND. OBWARN ) .OR. 
     1               SLOP .GT. 0.01 * BBCBW(ICH) ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I3, A, F8.2, A )' )
     1              'CHKDBFQ: WARNING!  Channel ', ICH, 
     2              ' with bandwidth ', BBCBW(ICH), ' MHz extends '
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, F8.3, A, F8.1, A, F8.1, A )' )
     1               '          ', SLOP,
     2               ' MHz outside the IF band of ',
     3               FILT_LOW(FILT_USED), '-', FILT_HI(FILT_USED), 
     4               ' MHz.'
                  CALL WLOG( 1, MSGTXT )
                  CALL WLOG( 1, '         That part of the band '//
     1               'will be corrupted.' )
                  IF( SLOP .LE. 0.01 * BBCBW(ICH) ) THEN
                     OBWARN = .FALSE.
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( 2A )' )
     1                 '         This is small and may be ',
     2                 'intentional for good pulse cal.'
                     CALL WLOG( 1, MSGTXT )
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( A )' )
     1                 '         This warning will not be repeated.'
                     CALL WLOG( 1, MSGTXT )
                  END IF
                  SHOWID = .TRUE.
               END IF
            END IF
C
C           The DBBC has both a binary and a decimal tuning mode. The
C           binary mode can set the frequency with resolution
C           1024MHz/2^31=0.476 Hz
C           The decimal mode has 10KHz resolution and is normally used.
C           We will enforce the decimal mode here.
C           Allowing some tolerance as Craig did for the RDBE.
C
            IF( DMOD( BBCFREQ(ICH) + 1.D-7, 0.010D0 ) .GT. 2.D-7
     1          .AND. NFWARN .LE. 16 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( 3A )' ) 'CHKDBFQ:  ',
     1           ' BBSYN for the DBBC_DDC must be an even multiple',
     2           ' of 10.0 kHz.'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( 2A, F15.6, A, I3, A, A )' ) 
     1            '          ',
     2            ' Value of: ', BBCFREQ(ICH), 
     3            ' MHz found in channel ', ICH, ' of setup ', 
     4            SETNAME(KS)
               CALL WLOG( 1, MSGTXT )
               IF( NFWARN .GE. 16 ) THEN
                  MSGTXT = 'CHKRDFQ:   Further warnings suppressed '
     1               //'- too many.'
                  CALL WLOG( 1, MSGTXT )                     
               END IF                  
               NFWARN = NFWARN + 1
               SHOWID = .TRUE.
            END IF


         END DO

      END IF
C
C     Identify the setup if there was a problem.
C      
      IF( ERRS .OR. SHOWID ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, A, A, A )' )
     1     'CHKDBFQ: The above problem is for setup ', 
     2     SETNAME(KS)(1:LEN1(SETNAME(KS))),
     3     ' and at least station ', SETSTA(1,KS)
         CALL WLOG( 1, MSGTXT )
      END IF
C
      RETURN
      END

      SUBROUTINE FLAGS
C
C     Routine for SCHED that makes an AIPS UVFLG input table to
C     flag the time at each station from the start of tape motion
C     for a scan to the time the antenna arrives on source, assuming
C     that is a positive interval.  
C
      INCLUDE    'sched.inc'
C
      INTEGER    ISCN, ISTA, LEN1, IOERR, VLBOPE
      INTEGER    YEAR, DOY, MONTH, DAY, JD, IL, NL
      DOUBLE PRECISION  STOP, TLOOP, TINC, HLST
      REAL       HHA, HEL, HAZ, HPA
      CHARACTER  FLAGFILE*40, OPTEXT*255, OPSTAT*4
      CHARACTER  PDATE*80, MNAME*3, DNAME*3, HORCHK*1
      LOGICAL    EXISTS
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'FLAGS starting' )
C
C     Construct the name of the flag file.
C
      WRITE( FLAGFILE, '(A,A)' )  EXPCODE(1:LEN1(EXPCODE)), '.FLAG'
      CALL DWCASE( FLAGFILE )
      IF( DEBUG ) 
     1   CALL WLOG( 0, 'FLAGS: Opening apriori flagging file: ' //
     2      FLAGFILE(1:LEN1(FLAGFILE)) )
C
C     Find out if the .flag file already exists.  Don't worry about
C     not writing over it.  But leave the code there in case I change
C     my mind.
C
      INQUIRE( FILE=FLAGFILE, EXIST=EXISTS )
      IF( EXISTS .AND. OVERWRIT ) THEN
         OPSTAT = 'OLD'
      ELSE IF( EXISTS ) THEN
C         CALL WLOG( 1, 'FLAGS: '//PRTFILE//' already exists.' )
C         CALL ERRLOG( 'FLAGS: You need to delete old output files' )
         OPSTAT = 'OLD'
      ELSE
         OPSTAT = 'NEW'
      END IF
C
C     Announce your intentions.
C
      CALL WLOG( 0, 'FLAGS:   Writing apriori flagging file ' //
     1     FLAGFILE(1:LEN1(FLAGFILE)) )
C
C     OPEN summary file and write station info to it.  
C
      IOERR = VLBOPE( IFLAG, FLAGFILE, 'TEXT', OPSTAT, OPTEXT )
      IF( IOERR .NE. 1 ) CALL ERRLOG( ' Open problem:'//OPTEXT )
C
C     Get the date
C
      CALL TIMEJ( STOPJ(1), YEAR, DOY, STOP )
      MONTH = 1
      DAY = DOY
      CALL TDATECW( YEAR, MONTH, DAY, JD, MNAME, DNAME )
      WRITE( PDATE, '( A, I3, A, A3, I4, 1X, A3, I5, A, I6 )' )
     1         'Day ', DOY, ' is ',  DNAME, DAY, MNAME, YEAR,
     2    '   MJD ', INT( JD - 2400000.5 )
C
C     Write a header.
C
      WRITE( IFLAG, '( 2A,/, A,/, 2A,/, 2A,/, 2A, /, A,/, A,/, A )' )
     1   '!  Apriori edit data for ',  EXPCODE(1:LEN1(EXPCODE)), 
     2   '!  The format is appropriate for UVFLG in AIPS.',
     3   '!  There is one flag per station per scan covering time ',
     4   'from start of tape ', 
     5   '!    motion to antenna arrival on source, ',
     6   'if that is a positive interval.',
     7   '!  These flags are not needed when there are monitor ',
     8   'data flags (eg VLBA).',
     9   '! ',
     a   'opcode = ''FLAG''',
     b   'dtimrang = 1  timeoff = 0 '
C
C     Now get the flags.
C
      DO ISTA = 1, NSTA
         DO ISCN = SCAN1, SCANL
            IF( STASCN(ISCN,ISTA) ) THEN
C
C              Flag for slewing while tape writing.
C              Note that the reason should be < 24 characters.
C
C              Allow for some rounding tolerance now that recordings
C              can start right at TONSRC.  Before dealing with this,
C              a lot of flags with the same start and stop times 
C              were introduced.  Looking in some detail showed 
C              that TONSRC-(STARTJ-TPSTART) was often between .15 and
C              .2 seconds.  Not sure why.  For now, extend the flag
C              1 second early and 0.5 second late.  That seems to have
C              the effect of extending the flag one second beyond the
C              VEX on-source start time for most scans when this antenna
C              is limiting the slew.  That's probably an effect of the
C              .15 second offset and is likely to be what you actually want.
C              Note that, for stations with USEONSRC true, the flag
C              could well start quite a while before the start of recording.
C              but that should be harmless.
C
               IF( TONSRC(ISCN,ISTA) - ( STARTJ(ISCN) - 
     1             TPSTART(ISCN,ISTA) ) .GT. 0.1D0 * ONESEC ) THEN
                  CALL FLAGWRT( IFLAG, STCODE(STANUM(ISTA)), 
     1                   STARTJ(ISCN) - TPSTART(ISCN,ISTA) - ONESEC,
     2                   TONSRC(ISCN,ISTA) + 0.5D0 * ONESEC,
     3                   'Slewing expected.' )
               END IF
C
C              Flags for horizons.
C              First case - down at both ends of scan.
C
               IF( UP1(ISCN,ISTA) .NE. ' ' .AND. 
     1             UP2(ISCN,ISTA) .NE. ' ' ) THEN
                  CALL FLAGWRT( IFLAG, STCODE(STANUM(ISTA)),
     1                   STARTJ(ISCN) - TPSTART(ISCN,ISTA), 
     2                   STOPJ(ISCN),
     3                   'Slew limits or horizon' )
C
               ELSE IF( UP2(ISCN,ISTA) .NE. ' ' ) THEN
C
C                 If setting, get set time to nearest 30 seconds.
C                 It seems non-integer loop indices are being eliminated
C                 in future fortrans so try to get rid of them.
C                 The loop will end at or before TSTOP.
C
                  TINC = 30.D0 / 86400.D0
                  NL = ( STOPJ(ISCN) - STARTJ(ISCN) ) / TINC
                  DO IL = 1, NL
                     TLOOP = STOPJ(ISCN) - IL * TINC
                     CALL SCHGEO( ISCN, ISTA, TLOOP, 
     1                      HHA, HEL, HAZ, HLST, HPA )
                     IF( HORCHK( STANUM(ISTA), HHA, HAZ, HEL, 
     1                   SRCNUM(ISCN) ) .EQ. ' ' ) THEN
                        CALL FLAGWRT( IFLAG, STCODE(STANUM(ISTA)),
     1                      TLOOP, STOPJ(ISCN), 'Source set.' )
                        GO TO 100
                     END IF
                  END DO
C
C                 If still here, source set near start.  Flag scan.
C
                  CALL FLAGWRT( IFLAG, STCODE(STANUM(ISTA)),
     1                   STARTJ(ISCN) - TPSTART(ISCN,ISTA), 
     2                   STOPJ(ISCN),
     3                   'Source set near start' )
C
               ELSE IF( UP1(ISCN,ISTA) .NE. ' ' ) THEN
C
C                 If rising, get rise time to nearest 30 seconds.
C
                  TINC = 30.D0 / 86400.D0
                  NL = ( STOPJ(ISCN) - STARTJ(ISCN) ) / TINC
                  DO IL = 1, NL
C                  DO TLOOP = STARTJ(ISCN) - TPSTART(ISCN,ISTA) + TINC, 
C     1                STOPJ(ISCN), TINC
                     TLOOP = STARTJ(ISCN) + IL * TINC
                     CALL SCHGEO( ISCN, ISTA, TLOOP, 
     1                      HHA, HEL, HAZ, HLST, HPA )
                     IF( HORCHK( STANUM(ISTA), HHA, HAZ, HEL, 
     1                   SRCNUM(ISCN) ) .EQ. ' ' ) THEN
                        CALL FLAGWRT( IFLAG, STCODE(STANUM(ISTA)),
     1                      STARTJ(ISCN) - TPSTART(ISCN,ISTA), TLOOP, 
     2                      'Source rise.' )
                        GO TO 100
                     END IF
                  END DO
C
C                 If still here, source rose right at end.  Flag scan.
C
                  CALL FLAGWRT( IFLAG, STCODE(STANUM(ISTA)),
     1                   STARTJ(ISCN) - TPSTART(ISCN,ISTA), 
     2                   STOPJ(ISCN),
     3                   'Source rise near end' )

               END IF
C
C              Jump here when done checking for rise or set.
C
  100          CONTINUE
C
            END IF
         END DO
         WRITE( IFLAG, '( 1X )' )
      END DO
C
      CLOSE( UNIT=IFLAG )
      RETURN
      END

      SUBROUTINE VXWRPR
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes a specific section of the VEX file 
C     In this case the PR = $PROCEDURES section 
C     By H.J. van Langevelde, JIVE, 300496 
C
C     Dec 2011 RCW.  Write a block even for FORMAT=NONE scans because
C     some stations need to know about such scans for such activities
C     as reference pointing, or single dish observing.
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
      INTEGER   IXX
      INTEGER   LEN1, ISET, VXGTST
C ----------------------------------------------------------------------
C
C     Write timing proc, only STANDARD for now
C
      WRITE( IVEX, '( A, A1 )' ) '$PROCEDURES', SEP
C
      DO IXX = 1, NPRVEX
C
C        Write a comment for format=none.
C           
         ISET = VXGTST( IXX )
         IF( FORMAT(ISET)(1:4) .EQ. 'NONE' ) THEN
            WRITE( IVEX, '( A1 )' ) COM
            WRITE( IVEX, '( A1, A )' ) COM, 
     1          'The following def is used with FORMAT=NONE.'
         END IF
C      
C        Write a prefix (number)
C      
         WRITE( IVEX, '( A1 )' ) COM
         IF (IXX.LT.100) THEN
            WRITE( IVEX, '( A, A, A1 )' ) 'def ', 
     1          PRLINK(IXX)(1:LEN1(PRLINK(IXX))), SEP      
            WRITE( IVEX, '( 5X, A, 1X, A1, I2.2, A1, A1 )' )
     1          'procedure_name_prefix = ', QOT, IXX, QOT, SEP
         ELSE IF (IXX .LT. 1000) THEN
            WRITE( IVEX, '( A, A, A1 )' ) 'def ', 
     1          PRLINK(IXX)(1:LEN1(PRLINK(IXX))), SEP      
            WRITE( IVEX, '( 5X, A, 1X, A1, I2.2, A1, A1 )' )
     1          'procedure_name_prefix = ', QOT, IXX, QOT, SEP
         ELSE
            CALL ERRLOG(' Cannot format prefix statement ')
         END IF
         WRITE( IVEX, '( 5X, A, I4, 1X, A, A1 )' )
     1        'tape_change = ', 420, 'sec', SEP
         WRITE( IVEX, '( 5X, A, I4, 1X, A, A1 )' )
     1        'headstack_motion = ', 6, 'sec', SEP
         WRITE( IVEX, '( 5X, A, I4, 1X, A, A1 )' )
     1        'new_source_command = ', 5, 'sec', SEP
         WRITE( IVEX, '( 5X, A, I4, 1X, A, A1 )' )
     1             'new_tape_setup = ', 20, 'sec', SEP
         WRITE( IVEX, '( 5X, A, A, 1X, A1, I4, 1X, A, A1 )' )
     1        'setup_always = ', 'on', COL, 20, 'sec', SEP
         WRITE( IVEX, '( 5X, A, A, 1X, A1, I4, 1X, A, A1 )' )
     1              'parity_check = ', 'off', COL, 100, 'sec', SEP
         WRITE( IVEX, '( 5X, A, A, 1X, A1, I4, 1X, A, A1 )' )
     1        'tape_prepass = ', 'off', COL, 600, 'sec', SEP
C      
C        Standard Cal procedure for now...
C      
         WRITE( IVEX, '( 5X, A, A, 1X, A1, I4, 1X, A, 1X, A1, 
     1         1X, A, A1 )' )
     2        'preob_cal  = ', 'on', COL, 10, 'sec', COL, 'preob', SEP

         WRITE( IVEX, '( 5X, A, A, 1X, A1, I4, 1X, A, 1X, A1, 
     1        1X, A, A1 )' )
     2        'midob_cal  = ', 'on', COL, 15, 'sec', COL, 'midob', SEP

         WRITE( IVEX, '( 5X, A, A, 1X, A1, I4, 1X, A, 1X, A1, 
     1        1X, A, A1 )' )
     2        'postob_cal = ', 'on', COL, 0, 'sec', COL, 'postob', SEP
         WRITE( IVEX, '( A, A1 )' ) 'enddef',SEP  
C
      END DO
      WRITE( IVEX, '( A )' ) COMLIN      
      RETURN
      END

      SUBROUTINE CHKCODE( CODE )
C
C     Routine for SCHED that confirms that the experiment code
C     conforms to standards.  
C
C     Check that A, B, and G series observations to have 3 numbers.
C     Otherwise, don't care.  The method used is crude, but clear.
C
      CHARACTER*(*)    CODE, PRCODE*8
      INTEGER          I, J, LEN1, DIG1
      LOGICAL          OK, OKDIG, CHKIT
      CHARACTER*1      NUM(10)
      DATA    NUM  / '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' /
C ---------------------------------------------------------------------
C     Check that a code was given as required.
C
      IF( CODE(1:3) .EQ. 'NUG' ) THEN
         CALL ERRLOG(
     1      'CHKCODE: EXPCODE not specified.  Needed for file names.' )
      END IF
C
C     Check format for VLA, VLBA, EVN, Global, and VSOP projects.  Require
C     that they use 3 digits.  Use PRCODE to avoid case sensitivity.
C
      PRCODE = CODE
      CALL UPCASE( PRCODE )
      CHKIT = .FALSE.
      IF( ( PRCODE(1:1) .EQ. 'A' .OR. PRCODE(1:1) .EQ. 'B' .OR.
     1      PRCODE(1:1) .EQ. 'E' .OR. PRCODE(1:1) .EQ. 'G' ) .AND.
     2      PRCODE(1:2) .NE. 'EG'  ) THEN
         CHKIT = .TRUE.
         DIG1 = 3
      END IF
C
      IF( PRCODE(1:1) .EQ. 'V' .OR. PRCODE(1:1) .EQ. 'W' ) THEN
         CHKIT = .TRUE.
         DIG1 = 2
      END IF
C
      IF( CHKIT ) THEN
         OK = .TRUE.
         IF( LEN1( PRCODE ) .LT. DIG1 + 2 ) THEN
            OK = .FALSE.
         ELSE 
            DO J = DIG1, DIG1 + 2
               OKDIG = .FALSE.
               DO I = 1, 10
                  IF( CODE(J:J) .EQ. NUM(I) ) OKDIG = .TRUE.
               END DO           
               IF( .NOT. OKDIG ) OK = .FALSE.
            END DO
         END IF
C
C        Warn if poor.  PRCODE is needed here because g77 does not like
C        to concatinate with a call argument.  It will not be upcased
C        this time.
C
         IF( .NOT. OK ) THEN
            PRCODE = CODE
            CALL WLOG( 0, 'CHKCODE:  EXPCODE = ' // PRCODE )
            CALL WRTMSG( 0, 'CHKCODE', 'expcode' )
         END IF
C
      END IF
C
      RETURN
      END

      SUBROUTINE JPLGOT( GOTALL )
C
C     Routine for SCHED, called by SRREAD, that checks if a source
C     that has not yet been found is a planet in the ephemeris.
C
      INCLUDE   'sched.inc'
C
      LOGICAL           GOTALL
      INTEGER           KSRC, NAM, IV, IER
      DOUBLE PRECISION  PRA, PDEC, PDRA, PDDEC, DIST
C ----------------------------------------------------------------------
      IF( .NOT. GOTALL .AND. EPHFILE .NE. 'NONE' ) THEN
C
         DO KSRC = 1, NSRC
            IF( SRCATN(KSRC) .EQ. 0 ) THEN
C
C              Have a source that is not yet identified.  Call the
C              ephemeris and see if it exists there.  Make the call
C              for station 1 at the start of the experiment.  These
C              will be the coordinates in the "catalog", but the
C              actual coordinates used for each station/scan will
C              be calculated at the time the information is written.
C              This "catalog" information will, however, be used
C              in any optimizations.
C
C              The times haven't been settled yet!  
C
               CALL JPLEP2( EPHFILE, SRCNAME(KSRC), STARTJ(1), 
     1                 (-1.D0)*LONG(1), LAT(1), ELEV(1), 'VLBA', 
     2                  PRA, PDEC, PDRA, PDDEC, DIST, IER )
C
               IF( IER .EQ. 0 ) THEN
C
C                 Add the planet to the source catalog.
C                 Don't know the errors - can they be guessed?
C
                  MSRC = MSRC + 1
C
C                 Don't do SUSED here - it can get it wrong for 
C                 optimized schedules and cause havoc elsewhere.
C                  SUSED(MSRC) = .TRUE.
C
                  SRCATN(KSRC) = MSRC
                  SRLSTN(MSRC) = KSRC
                  PLANET(MSRC) = .TRUE.
                  SOURCE(1,MSRC) = SRCNAME(KSRC)
C
C                 These may not be needed here, but should be harmless.
                  CSUSED(1,MSRC) = '*'
                  DO NAM = 2, MALIAS
                     SOURCE(NAM,MSRC) = ' '
                     CSUSED(NAM,MSRC) = ' '
                  END DO
C
                  C2000(MSRC) = '*'
                  C1950(MSRC) = ' '
                  CDATE(MSRC) = ' '
                  RA2000(MSRC) = PRA
                  D2000(MSRC) = PDEC
                  CALCODE(MSRC) = 'P'
                  REMARK(MSRC) = ' '
                  RAERR(MSRC) = 0.0
                  DECERR(MSRC) = 0.0
                  DO IV = 1, MAXLCH
                     VLSR(IV,MSRC) = 0.0
                  END DO
                  VELREF(MSRC)='G'
                  VELDEF(MSRC)='R'
                  DRA(MSRC) = PDRA
                  DDEC(MSRC) = PDDEC
                  PMTIME(MSRC) = STARTJ(1)
                  WHICHCAT(MSRC) = 'P'
C
C                 Check later if this is for an allowed station.
C                 We don't have enough information yet.
C
               END IF
            END IF
         END DO
C
C        Finally check if we now have all schedule sources.
C
         GOTALL = .TRUE.
         DO KSRC = 1, NSRC
            IF( SRCATN(KSRC) .EQ. 0 ) GOTALL = .FALSE.
         END DO
C
      END IF
C
      RETURN
      END

      SUBROUTINE sla_CLDJ (IY, IM, ID, DJM, J)
*+
*     - - - - -
*      C L D J
*     - - - - -
*
*  Gregorian Calendar to Modified Julian Date
*
*  Given:
*     IY,IM,ID     int    year, month, day in Gregorian calendar
*
*  Returned:
*     DJM          dp     modified Julian Date (JD-2400000.5) for 0 hrs
*     J            int    status:
*                           0 = OK
*                           1 = bad year   (MJD not computed)
*                           2 = bad month  (MJD not computed)
*                           3 = bad day    (MJD computed)
*
*  The year must be -4699 (i.e. 4700BC) or later.
*
*  The algorithm is adapted from Hatcher 1984 (QJRAS 25, 53-55).
*
*  Last revision:   27 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      INTEGER IY,IM,ID
      DOUBLE PRECISION DJM
Cf2py intent(out) DJM
      INTEGER J
Cf2py intent(out) J

*  Month lengths in days
      INTEGER MTAB(12)
      DATA MTAB / 31,28,31,30,31,30,31,31,30,31,30,31 /



*  Preset status.
      J = 0

*  Validate year.
      IF ( IY .LT. -4699 ) THEN
         J = 1
      ELSE

*     Validate month.
         IF ( IM.GE.1 .AND. IM.LE.12 ) THEN

*        Allow for leap year.
            IF ( MOD(IY,4) .EQ. 0 ) THEN
               MTAB(2) = 29
            ELSE
               MTAB(2) = 28
            END IF
            IF ( MOD(IY,100).EQ.0 .AND. MOD(IY,400).NE.0 )
     :         MTAB(2) = 28

*        Validate day.
            IF ( ID.LT.1 .OR. ID.GT.MTAB(IM) ) J=3

*        Modified Julian Date.
            DJM = DBLE ( ( 1461 * ( IY - (12-IM)/10 + 4712 ) ) / 4
     :               + ( 306 * MOD ( IM+9, 12 ) + 5 ) / 10
     :               - ( 3 * ( ( IY - (12-IM)/10 + 4900 ) / 100 ) ) / 4
     :               + ID - 2399904 )

*        Bad month.
         ELSE
            J=2
         END IF

      END IF

      END

      SUBROUTINE GEOCHK( JSCN, ISCN, STARTB, TGEOEND, OKGEO, USEGEO,
     1                   SEGELEV )
Cf2py intent(in) JSCN, ISCN, STARTB, TGEOEND
C 2 argument which are actually out parameters, but the in is required
C to define their dimension
Cf2py intent(in, out) OKGEO, USEGEO
Cf2py intent(out) SEGELEV
C
C     Make a pass through all the geodetic sources looking at the 
C     midpoint of the block to see if enough stations are up.  It tolerates
C     sources somewhat below the limit to allow for the finite time of
C     the geodetic sequence.  Set OKGEO to true if there are enough
C     stations up for the source.
C
C     A main intent is to pare down the sources being considered.
C     Use a dummy ISCN that should be an empty slot for this test.
C     Set USETIME so that TAPPROX is used.
C
C     Try to provide a list (in USEGEO) that will optimize the 
C     chances of getting a good set.  When there are a lot of 
C     sources, it is very easy  to never see the right combinations.  
C     USEGEO will prioritize the sources to try to use.  OKGEO means a 
C     source can be used at all.
C
C     First scheme tried - give sources with low elevation scans an
C     extra chance of being scheduled for each low antenna.  This didn't
C     work too well but accounts for the name (CHANCE) of the array
C     olding the likely sources in the MAKESEG routine.
C
C     Next scheme tried is to keep a source only if it is one of the 3 
C     lowest (but above 11 deg) for some station or one of the 2 highest.
C     Use LOWS(I,STAS) and HIGHS(I,STAS)
C
C     The latest scheme, as of this writing, uses the priority 1 or 2 
C     sources that are closest to the previous source (whether or not it
C     is in the geodetic sequence).  From the 5 closest, it randomly picks
C     one.  Then repeats that until 4 sources are selected.  After that,
C     it does trial fits for SecZ and picks the source that helps the
C     most (see MAKESEG for details).
C
C     Inputs:
C        JSCN:      Template scan (<ISCN usually)
C        ISCN:      First scan of the sequence.
C        STARTB:    Geodetic sequence start time.
C        TGEOEND:   Geodetic sequence end time.
C     Outputs:
C        OKGEO:     Logical flag for source is usable.
C        USEGEO:    Integer priority for each source.
C
      INCLUDE  'sched.inc'
C
      DOUBLE PRECISION  STARTB, TGEOEND
      DOUBLE PRECISION  SRCSEP, REQSEP, TFREQ
      INTEGER           JSCN, ISCN, USEGEO(*)
      LOGICAL           OKGEO(*)
      REAL              SEGELEV(MAXSTA,MGEO)
C
      DOUBLE PRECISION  TAPPROX, TIMRAD, RAS, DECS, SLA_DSEP
      REAL              ELTOL
      INTEGER           NLOW, NHIGH
      INTEGER           ISTA, ICH, IGEO, LSCN, MSPRT
      INTEGER           NREJECT, LASTISCN(MAXSTA)
      INTEGER           YR, DY, NGOOD
      LOGICAL           OKSTA(MAXSTA), USETIME
      CHARACTER         TFORM*8, CTIME*8
C
C------------------------------------------------------------------
C     Initialize USETIME so MAKESCN will use TAPPROX without 
C     adjustment.  Set TAPPROX to the center of the sequence.
C     
C
      USETIME = .TRUE.
      DO ISTA = 1, NSTA
         LASTISCN(ISTA) = 0
      END DO
      TAPPROX = ( TGEOEND + STARTB ) / 2.D0
      NREJECT = 0
C
      IF( NSTA .GT. 20 ) THEN
         CALL WLOG( 1, 'GEOCHK:  Printing only first 20 stations '
     1        // 'information' )
         MSPRT = 20
      ELSE
         MSPRT = NSTA
      END IF
C
C     Write some messages to the user about the source list to
C     follow.
C
      MSGTXT = '             --------------------- '
      CALL WLOG( 1, MSGTXT )
      MSGTXT = ' '
      CALL TIMEJ( TAPPROX, YR, DY, TIMRAD )
      CTIME = TFORM( TIMRAD, 'T', 0, 2, 2, '::@' )
      WRITE( MSGTXT, '( A, I4, I4, 1X, A )' ) 
     1      'Building geodetic segment centered at ', YR, DY, CTIME
      CALL WLOG( 1, MSGTXT )
      MSGTXT = ' '
      WRITE( MSGTXT, 
     1      '( A, I2, 4X, A, I4, 2X, A, I3, 3X, A, I3 )' )
     2  '   Using GEOPRT= ', GEOPRT,  '  GEOTRIES=', GEOTRIES, 
     3  '  GEOBACK=', GEOBACK, '  GEOSREP=', GEOSREP
      CALL WLOG( 1, MSGTXT )
      MSGTXT = ' '
      WRITE( MSGTXT, '( A, F6.2, A, F6.1, A, F6.2, A, F6.2 )' )
     1  '         GEOSLEW=', GEOSLEW, '  GEOSLOW= ', GEOSLOW,
     3  '  GELOWEL=', GEOLOWEL,'  GEOHIEL=', GEOHIEL
      CALL WLOG( 1, MSGTXT )
      CALL WLOG( 1, 
     1  '         See sched.runlog for details of the build process.' )
C
      IF( GEOPRT .GE. 0 ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A )' ),'       Note in fit, SecZ < 4 '
     1     // 'treated as 4 to avoid favoring'
     2     // ' extreme low elevations.'
         CALL WLOG( 0, MSGTXT )
         CALL WLOG( 0, 
     1       'Elevations at center for sources considered are: ' )
         MSGTXT = ' '
         WRITE( MSGTXT, '( 18X, A, 20( A3, 2X ) )' ) 'Prio ',
     1        (STCODE(STANUM(ISTA)),ISTA=1,MSPRT)
         CALL WLOG( 0, MSGTXT )
         MSGTXT = ' '
      END IF
C
C     Set the limits and required numbers for finding sources
C     that contribute both high and low elevation data.
C     The ELTOL allows us to look at sources that are below the
C     elevation cutoff in the center of the segment, but not the 
C     edges.  But the usage here is only to set the priorities. 
C     At the time sources are picked, the actual geometry will be
C     picked, so for now, set ELTOL to zero.
C     The default GEOLOWEL = 23 corresponds to SecZ of 2.55 while 
C     the default GEOHIEL of 40 corresponds to 1.55, giving a 
C     spread of 1.  These parameters are user adjustable. Again, 
C     this is used for selecting the initial sources in a segment.
C
      ELTOL = 0.0
C
C     Set up to test the sun distance.  Sources too close to 
C     the sun were selected uncomfortably often during testing of 
C     the geo segment insertion.  I considered moving the call to 
C     GETSUN to before this routine, but it needs TFIRST and
C     TLAST which are calculated in SCHOPT.
C
C     For parallel schedules with the RDBE and old system, I have
C     found that small changes in frequency between the setups
C     can cause a source to be flagged for one and not the other.
C     That can completely change the results of the geodetic 
C     segment optimization.  

      CALL SUNPOS( TAPPROX, RAS, DECS )
      TFREQ = ( SFFREQ(1,SETNUM(JSCN)) / 1000.D0 )
      REQSEP = 60.D0 * TFREQ**(-0.6)
C
C     Loop through the sources getting the geometry and determining
C     which sources are useful for this segment.  Those that can be
C     used at all will have OKGEO set true and have an assigned
C     USEGEO priority.
C
C     For testing against OPMINEL, allow the source to be a bit
C     lower than the limit because the final use may be at
C     a somewhat different time.  ISCN + 1 is arbitrary and is out
C     of the way of other activity for the moment.
C
      DO IGEO = 1, NGEO
         LSCN = ISCN + 1
C
C        Make a scan with the geodetic source IGEO.  This gets all
C        the geometric information.
C
         CALL MAKESCN( LASTISCN, LSCN, JSCN, GEOSRCI(IGEO),
     1        GEOSRC(IGEO), TAPPROX, OPMINEL(JSCN) - ELTOL,
     2        NGOOD, OKSTA, USETIME )
C
C        Save the elevations.
C
         DO ISTA = 1, NSTA
            SEGELEV(ISTA,IGEO) = (EL1(LSCN,ISTA)+EL2(LSCN,ISTA))/2.0
         END DO
C
C        Make sure enough antennas are good for this source.  
C
         OKGEO(IGEO) = NGOOD .GE. OPMIAN(JSCN)
C
C        Check the sun distance.
C
         SRCSEP = SLA_DSEP( RAP(GEOSRCI(IGEO)), DECP(GEOSRCI(IGEO)),
     1         RAS, DECS ) / RADDEG
         OKGEO(IGEO) = OKGEO(IGEO) .AND. SRCSEP .GT. REQSEP 
C
C        Count those turned down.  This will be tested later to 
C        determine if there will be a problem.  Set USEGEO out of
C        range.
C
         IF( .NOT. OKGEO(IGEO) ) THEN
            NREJECT = NREJECT + 1
            USEGEO(IGEO) = 9
         END IF        
C
C        For sources that are usable, assign priorities.
C        Note that we will work from low priority critera to high
C        priority criteria.
C
C        For normal observations (.GE. 6 stations), the USEGEO priority
C        settings are:
C          5:  Meets OKGEO constraints, but otherwise not interesting.
C          4:  One or more station below GEOLOWEL+10 
C          3:  One or more low station.
C          2:  One or more low and three or more high stations or
C                  three or more low el stations.
C          1:  Two or more low and two or more high stations.
C
         IF( OKGEO(IGEO) ) THEN
            USEGEO(IGEO) = 5
            DO ISTA = 1, NSTA
               IF( STASCN(LSCN,ISTA) .AND.
     1            SEGELEV(ISTA,IGEO) .LE. GEOLOWEL + 10.0 ) 
     2            USEGEO(IGEO) = 4
            END DO
            DO ISTA = 1, NSTA
               IF( STASCN(LSCN,ISTA) .AND.
     1            SEGELEV(ISTA,IGEO) .LE. GEOLOWEL  ) 
     2            USEGEO(IGEO) = 3
            END DO
C
C           Now the multi-station criteria.
C
            NLOW = 0
            NHIGH = 0
            DO ISTA = 1, NSTA
               IF( STASCN(LSCN,ISTA) .AND.
     1             SEGELEV(ISTA,IGEO) .GT. OPMINEL(JSCN) - ELTOL .AND. 
     2             SEGELEV(ISTA,IGEO) .LE. GEOLOWEL )
     3             NLOW = NLOW + 1
               IF( STASCN(LSCN,ISTA) .AND.
     1             SEGELEV(ISTA,IGEO) .GE. GEOHIEL )
     2             NHIGH = NHIGH + 1
            END DO
            IF( ( NLOW .GE. 1 .AND. NHIGH .GE. 3 ) .OR. 
     1          NLOW .GE. 3 ) USEGEO(IGEO) = 2
            IF( NLOW .GE. 2 .AND. NHIGH .GE. 2 ) USEGEO(IGEO) = 1
         END IF
C
C        Write a line with information about each source.
C        Don't show elevations when more than 3 deg below OPMINEL
C
         IF( GEOPRT .GE. 0) THEN
            MSGTXT = ' ' 
            WRITE(MSGTXT,'( I5, 2X, A, 1X, I1 )' ) IGEO, 
     1           GEOSRC(IGEO), USEGEO(IGEO)
            ICH = 17
            DO ISTA = 1, NSTA
               ICH = ICH + 5
               IF( SEGELEV(ISTA,IGEO) .GT. OPMINEL(LSCN) - ELTOL ) THEN
                  WRITE( MSGTXT(ICH:ICH+4), '( F5.0)' ) 
     1               SEGELEV(ISTA,IGEO)
               ELSE
                  WRITE( MSGTXT(ICH:ICH+4), '(A5)' ) '  -- '
               END IF
            END DO
            ICH = ICH + 5
            IF( SRCSEP .LE. REQSEP ) THEN
               WRITE( MSGTXT(ICH:ICH+30), '( A, F5.0, A )' )
     1              '  Too near sun:', SRCSEP, ' deg.'
            END IF
            CALL WLOG(0,MSGTXT)
         END IF
C
      END DO
C
C     Prevent an opportunity for an infinite loop.  There is still
C     a small chance if there is a source up at the middle of the
C     segment, but there is nothing at the beginning.
C
      IF( NREJECT .EQ. NGEO ) THEN
         CALL ERRLOG( 'GEOCHK:  None of the sources specified '//
     1        'for a geodetic segment are up at OPMINANT antennas. ' )
      END IF
C
      RETURN
      END

      SUBROUTINE VXTRAFQ(ISCN, NMODE, OMODE, KFQ)
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 250796 
C
C     Incorporating the effect of allowing sideband inversion
C     at the correlator - adds CORINV to the LO sum.  Also
C     adding more comments to help me understand the routine
C     because setup info like sideband are not transfering 
C     correctly.  This is because the IFQ in the call is
C     really only for some of the stations.  RCW  Oct. 13, 2011.  
C     Reset IFQ in the call to KFQ to get rid of it.  Set IFQ
C     below.
C
C     Adds a couple of extra FQ definitions, because
C     a new mode is detected in VXSCNS and created in VXTRAMD.
C     This routine is called from VXTRAMD
C     NMODE = MODE # new mode in which these IF come
C     OMODE = MODE # of mode to which changes are made
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      LOGICAL VXCFFQ, FOUND
      INTEGER NMODE, OMODE, ISCN, JSCN, IFQ, KFQ
C
      CHARACTER VXNMFQ*32
C
      INTEGER IXTRA, ISTA, NTMPST, TMPSTA(MAXSTA), INSCAN, ICH
C ----------------------------------------------------------------------
C
C     Start adding a number of modes
C
      DO IXTRA = 1, NMODFQ(OMODE)
         NTMPST = 0
         DO ISTA = 1, NSTA
            FOUND = .FALSE.
C
C           Check if any of the next scans, including the current
C           one, use this telescope in the same setup file.  
C           The original comment said setup group, but that is not 
C           literally true when looking at different stations.
C           Except when an antenna comes in late, this will likely
C           end up with INSCAN = ISCN.
C
            DO JSCN = ISCN, SCANL
               IF( SETNUM(ISCN) .EQ. SETNUM(JSCN) .AND. 
     1             STASCN(JSCN,ISTA) ) THEN 
                  FOUND = .TRUE.
                  INSCAN = JSCN
                  GOTO 100
               END IF
            END DO
C
  100       CONTINUE
            IF( FOUND ) THEN
C
C              See if this is the same frequency setup as the FQ mode
C              within OMODE that is being tested.
C              A proper comparison needs to use function VXCFFQ, 
C              because many IF sections are not the straight order number
C              VXCFFQ is true if the frequency blocks are identical.
C              It compares pol, side1, losum, bbfilt, bbc for each channel.
C
               IF( VXCFFQ(NSETUP(INSCAN,ISTA), 
     1             FQISSET(IMODFQ(IXTRA,OMODE))) ) THEN
                  NTMPST = NTMPST +1
                  TMPSTA(NTMPST) = ISTA
               END IF
            END IF
         END DO
C
C        Update if anything was found
C
         IF( NTMPST .GT. 0 ) THEN
            NMODFQ(NMODE) = NMODFQ(NMODE) + 1
            NFQVEX = NFQVEX + 1
            IF( NFQVEX .GT. MAXMOD ) CALL ERRLOG(
     1          'VXTRAFQ: Number of $FQ defs exceeding MAXMOD,'//
     2          '  array size...')
C
C           Need the SETUPS that are valid for this scan
C
            IMODFQ(NMODFQ(NMODE),NMODE) = NFQVEX
            FQISSET(NFQVEX)=FQISSET(IMODFQ(IXTRA,OMODE))
C     
C           and the corresponding values
C
C           RCW Oct 16, 2011.  IFQ (now KFQ) as defined in the 
C           calling routine (IMODFQ(1,IMODE) is not for all 
C           stations.  Get the right one here.
C
            IFQ = IMODFQ(IXTRA,OMODE)
C
C
            NVXCHN(NFQVEX) = NVXCHN(IFQ)
C
C           For a frequency change put it in.  Take into account
C           a sideband inversion if one was needed, mainly for
C           the RDBE (Oct 13, 2011 RCW)
C
            DO ICH = 1, NVXCHN(NFQVEX)
               IF( FREQ(ICH,ISCN).GT.1E-6 ) THEN
                  ISTA = TMPSTA(NTMPST)
                       VXLOSUM(ICH,NFQVEX) = FREQ(ICH,ISCN) + 
     1                     CORINV(ICH,NSETUP(ISCN,ISTA))
               ELSE
                  VXLOSUM(ICH,NFQVEX) = VXLOSUM(ICH,IFQ)
               END IF
C
C            BB can change too
C     
               IF( BW(ICH,ISCN) .GT.1E-6 ) THEN
                  VXBBFILT(ICH,NFQVEX) = BW(ICH,ISCN)
               ELSE
                  VXBBFILT(ICH,NFQVEX) = VXBBFILT(ICH,IFQ)
               END IF
               VXNETSID(ICH,NFQVEX) = VXNETSID(ICH,IFQ)
            END DO
C
C           Tone names and linking to FQ blocks sorted out
C           in VXTONE, but need a list of stations used.
C
            NSTAFQ(NFQVEX,NMODE) = NTMPST
            DO ISTA = 1, NTMPST
               ISTAFQ(ISTA,NFQVEX,NMODE) = TMPSTA(ISTA)
            END DO
C
C           IF names can be obtained from VXNMIF
C           Again 2nd par set .TRUE. to use VXLINK frequencies
C
            FQLINK(NFQVEX) = VXNMFQ( NFQVEX, .TRUE. )
            CALL VXUNQL( NFQVEX, FQLINK )
         END IF
C     
C        done inventing new FQ
C
      END DO
C
      RETURN
      END

      LOGICAL FUNCTION VXCFHP( ISET, JSET )
C
C     Routine specific for the VEX extension of SCHED
C     returns true if HP block in 2 SCHED sets are identical
C     for now it is all 14 track, except for S2
C     By H.J. van Langevelde, JIVE, 010996
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER ISET, JSET, ISTA, STAI, STAJ, FNDHPOS
      INTEGER ISCAT, JSCAT
      LOGICAL IDENT
C ----------------------------------------------------------------------
C
      IDENT = .TRUE.      
C
C     Check if one is S2, then it is different
C
      IF( (FORMAT(ISET) .EQ. 'S2' .OR. FORMAT(JSET) .EQ. 'S2')
     1    .AND. FORMAT(ISET) .NE. FORMAT(JSET) ) IDENT = .FALSE.
C
C     Check if one is LBA, then it is different
C
      IF( (FORMAT(ISET) .EQ. 'LBA' .OR. FORMAT(JSET) .EQ. 'LBA')
     1    .AND. FORMAT(ISET) .NE. FORMAT(JSET) ) IDENT = .FALSE.
C
C     Need to check the number of head positions
C
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,ISET) )  STAI = ISTA
      END DO
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,JSET) ) 
     3       STAJ = ISTA
      END DO
C
C     Make sure stations in a set don't appear with different nhdpos
C
      FNDHPOS = 0
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,ISET) ) THEN
            IF( FNDHPOS .EQ. 0 ) FNDHPOS = NHDPOS(ISTA)
            IF( FNDHPOS .NE. NHDPOS(ISTA) ) THEN
               WRITE( MSGTXT, '( A, A, A )' ) 
     1             'VXCFHP: VEX cannot deal with a station',
     2             ' with discrepant tape mode: ',
     3             STATION(STANUM(ISTA))
               CALL ERRLOG( MSGTXT )
            END IF
         END IF
      END DO

      FNDHPOS = 0
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,JSET)  ) THEN
            IF( FNDHPOS .EQ. 0 ) FNDHPOS = NHDPOS(ISTA)
            IF( FNDHPOS .NE. NHDPOS(ISTA) ) THEN
               WRITE( MSGTXT, '( A, A, A )' ) 
     1             'VXCFHP: VEX cannot deal with a station',
     2             ' with discrepant tape mode: ',
     3             STATION(STANUM(ISTA))
               CALL ERRLOG( MSGTXT )
            END IF
         END IF
      END DO

      IF( IDENT ) IDENT = ( NHDPOS(STAI) .EQ. NHDPOS(STAJ) )
C
C     compare MEDIA - no headpos for disks
C
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,ISET) )
     3       ISCAT = ISTA
      END DO
      DO ISTA = 1, NSTA
         IF( STATION(STANUM(ISTA)) .EQ. SETSTA(1,JSET) )
     3       JSCAT = ISTA
      END DO

      IF( USETAPE(ISCAT) .NEQV. USETAPE(JSCAT) ) IDENT = .FALSE.
C
      VXCFHP = IDENT 
C
      RETURN
      END

      SUBROUTINE TRANSP (MATX)
c
c in-place transpose
c
      DOUBLE PRECISION MATX(3,3), SWAPD

      SWAPD = MATX(2,1)
      MATX(2,1) = MATX(1,2)
      MATX(1,2) = SWAPD
      SWAPD = MATX(3,1)
      MATX(3,1) = MATX(1,3)
      MATX(1,3) = SWAPD
      SWAPD = MATX(3,2)
      MATX(3,2) = MATX(2,3)
      MATX(2,3) = SWAPD
      RETURN
      END

      SUBROUTINE ANTPOS( KSTA, ISCN, UPIN, SDEC, SAZ, SEL, SHA, 
     1                   TAX1, TAX2 )
C
C     Routine for SCHED subroutine SLEW that determines where an
C     antenna is actually pointed taking into account the hardware
C     limits.  Mostly, it decides where to go to get this information
C     depending on mount type.  The geometry routines need to be run
C     earlier to get SAZ, SEL, and SHA.  WRAP needs to have been run
C     to be sure SAZ is on the desired wrap.  Note SAZ can, and usually
C     is, on a larger range than 0-360.
C
      INCLUDE 'sched.inc'
C
C     The "S" parameters are the input source location.
C     The "T" parameters are the output telescope position.
C     TAX1 and TAX2 are the first and second axis coordinates in
C     degrees (HA is converted).  They will be used later by SLEW 
C     with the rates to get slew times.
C
C     Az, El, X, Y, and Dec are in degrees.  Ha is in hours.
C
C     UPIN is the UP flag from SCHGEO (called by STAGEO which also
C     calls SLEW, which calls this routine).
C     ISCN is the scan number - used only for the consistency check
C     message.
C
      INTEGER           KSTA, ISCN
      REAL              SAZ, SEL, SHA, SDEC
      REAL              TAX1, TAX2
      CHARACTER         UPIN*1, UP*1, TEXT*100
C -----------------------------------------------------------------
C
      IF( MOUNT(KSTA) .EQ. 'ALTAZ' ) THEN
         CALL MTALTAZ( KSTA, UP, SAZ, SEL, TAX1, TAX2 )
      ELSE IF( MOUNT(KSTA) .EQ. 'EQUAT' ) THEN
         CALL MTEQUAT( KSTA, UP, SEL, SHA, SDEC, TAX1, TAX2 )
      ELSE IF( MOUNT(KSTA) .EQ. 'XYNS' ) THEN
         CALL MTXYNS( KSTA, UP, SAZ, SEL, TAX1, TAX2 )
      ELSE IF( MOUNT(KSTA) .EQ. 'XYEW' ) THEN
         CALL MTXYEW( KSTA, UP, SAZ, SEL, TAX1, TAX2 )
      END IF
C
      IF( UPIN .NE. UP .AND. SEL .NE. 90.0 .AND. UPIN .NE. 'H' .AND.
     1     UPIN .NE. 'W' ) THEN
         TEXT = ' '
         WRITE( TEXT, '( A, I4, A, 1X, A, 1X, A, 1X, A )' )
     1           'ANTPOS: Consistency check fails on scan ', ISCN,
     2       UP, UPIN, STATION(KSTA), MOUNT(KSTA)
      END IF
C
      RETURN
      END

      SUBROUTINE FCOMPARE( KS, KF, MATCH, OKIF, NBAD, PRTMISS )
C
C     Routine for SCHED called by setfcat that compares a setup file KS
C     with a frequency catalog (eg freq.dat) entry KF to see if they 
C     are compatible.  The purpose is to narrow the range of those 
C     that will be used to search for a source of defaults or error checks.
C
C     Require that every channel in the setup file match, in all ways
C     that have already been set in the setup file, an IF in the
C     frequency catalog.  However allow the FREQREF of some, but
C     not all, channels to fall outside the RF ranges.
C     OKIF tells if the setup file channel is compatible with the
C     frequency catalog group channel except for the frequency, which
C     can be off by up to 20%.
C
C     MATCH means that at least one channel completely matches between
C     the setup file and the frequency catalog group, including in 
C     frequency (without allowing a tolerance).
C
C     Keep track of the best matches.  NBAD is the minimum number
C     of items that did not match for the worst channel.
C
C     SETFCAT will call this routine a second time if a match is
C     not found.  By then NBAD will be set.  On that call, print
C     some details of how the match failed for any with NBAD or
C     NBAD + 1 mismatches.  On those calls, PRTMISS will be .TRUE. 
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
      INCLUDE   'schfreq.inc'
C
      INTEGER          KS, KSTA, KF, IFINDX, ICH, IIF, I
      INTEGER          NBAD, CHBAD, IIFBAD, KFBAD
      LOGICAL          MATCH, IFMATCH, OKIF(MCHAN,MFIF)
      LOGICAL          FREQOK(MCHAN), GOTAFR, PRTMISS
      LOGICAL          RFCLOSE
      LOGICAL          FCSTA, FCIFCH, FCFLO1, FCPOL, FCCH1
      LOGICAL          FCFE, FC50, FCVLAIF
      CHARACTER        CHFLAGS*12
C ---------------------------------------------------------------------
C     Initialize MATCH for the return in case a top level item 
C     is no good.
C
      MATCH = .FALSE.
C
C     Check that the first setup file station uses this frequency
C     catalog entry.  Allow VLBA defaults.
C
      FCSTA = .FALSE.
      DO KSTA = 1, MFSTA
         IF( SETSTA(1,KS) .EQ. FSTNAM(KSTA,KF) .OR. 
     1       ( SETSTA(1,KS)(1:4) .EQ. 'VLBA' .AND.
     2         FSTNAM(KSTA,KF)(1:4) .EQ. 'VLBA' ) ) THEN
            FCSTA = .TRUE.
         END IF
      END DO
C
C     Don't waste more time if the station doesn't match
C
      IF( .NOT. FCSTA ) GO TO 1000
C
C     Check frequency match.  Only do debug printout if some 
C     channel matches.  GOTAFR set true if any channel is in
C     the frequency rainge for any IF in the setup.
C
      GOTAFR = .FALSE.
      DO ICH = 1, NCHAN(KS)
         DO IIF = 1, FNIF(KF)
            IF(  FREQREF(ICH,KS) .GE. FRF1(IIF,KF) .AND.
     1           FREQREF(ICH,KS) .LE. FRF2(IIF,KF) ) THEN
               GOTAFR = .TRUE.
            END IF
         END DO
      END DO
C
C     Don't waste more time if no frequency matches
C     Only a few frequency sets should survive past here.
C
      IF( .NOT. GOTAFR ) GO TO 1000
C
C     Initialize OKIF.
C
      DO ICH = 1, NCHAN(KS)
         DO IIF = 1, FNIF(KF)
            OKIF(ICH,IIF) = .FALSE.
         END DO
      END DO
C
C     Print something if debug print is requested.
C
      IF( SDEBUG ) THEN
         CALL WLOG( 0, ' ' )
         CALL WLOG( 0, ' ' )
         SETMSG = ' '
         WRITE( SETMSG, '( A, I4, A, I4, 1X, A )' )
     1       'FCOMPARE: Got station and frequency match. KS:', KS,
     2       '  KF:', KF, FRNAME(KF)
         CALL WLOG( 0, SETMSG )
         CALL WLOG( 0, 'FCOMPARE: List of logicals are: '//
     1            'FCFLO1, FCPOL, FCCH1, FCVLAIF, FCFE, '//
     2            'FREQOK(ICH), RFCLOSE' )
      END IF
C
C     Check for IFs that match the input channel parameters.
C
      KFBAD = 0
      DO ICH = 1, NCHAN(KS)         
         CHBAD = 99
         DO IIF = 1, FNIF(KF)
C
C           Require any specified IFCHAN match.
C
            FCIFCH = IFCHAN(ICH,KS) .EQ. ' ' .OR.
     1               IFCHAN(ICH,KS) .EQ. FIFNAM(IIF,KF) .OR.
     2               IFCHAN(ICH,KS) .EQ. FALTIF(IIF,KF)
C
C           Require any specified FIRSTLO match
C
            FCFLO1 = FIRSTLO(ICH,KS) .EQ. NOTSET .OR. 
     1               FIRSTLO(ICH,KS) .EQ. FLO1(IIF,KF)
C
C           RF - require be in same general part of RF.  Will
C           check actual RF later.  This is completely required.
C           The other is a precise, but optional (for a subset
C           of channels only) check.  There is no need to
C           differentiate between old DAR (500-1000 MHz IF) and
C           RDBE (512-1024 MHz IF) here as there is in the more
C           precise comparisons.
C
            RFCLOSE = FREQREF(ICH,KS) .GE. 0.8D0 * FRF1(IIF,KF) .AND.
     1               FREQREF(ICH,KS) .LE. 1.2D0 * FRF2(IIF,KF)
C
C           Require any specified polarization match
C
            FCPOL = POL(ICH,KS) .EQ. ' ' .OR.
     1              POL(ICH,KS)(1:1) .EQ. FPOL(IIF,KF)(1:1)
C
C           For 2 cm, be sure filter will be right.  Depends on
C           frequency of channel 1.  This will work for other bands 
C           too if that should become an issue.
C
            FCCH1 = ( FCH1RF1(IIF,KF) .EQ. 0.D0 .OR.
     1                FCH1RF1(IIF,KF) .LT. FREQREF(1,KS) ) .AND.
     2              ( FCH1RF2(IIF,KF) .EQ. 0.D0 .OR.
     3                FCH1RF2(IIF,KF) .GT. FREQREF(1,KS) )
C
C           For the VLA phased array, try to limit choice of IF.
C           Allow for possible different phasing modes using the
C           same setup (ok for RR only, for example - could use
C           VR or VA).  Actually mixing modes would flagged 
C           elsewhere (true?).  Do this test for any VLA "station" since
C           mixed phasing and non-phasing modes are allowed.
C           All of this will be obsolete soon so I'm not going to
C           worry about it (Dec. 2009)
C
            FCVLAIF = .TRUE.
            IF( SETSTA(1,KS)(1:3) .EQ. 'VLA' ) THEN
               IF( VLAVA(KS) .AND. ( FIFNAM(IIF,KF) .EQ. 'B'
     1           .OR. FIFNAM(IIF,KF) .EQ. 'C' ) ) FCVLAIF = .FALSE.
               IF( VLAVB(KS) .AND. ( FIFNAM(IIF,KF) .EQ. 'A'
     1           .OR. FIFNAM(IIF,KF) .EQ. 'D' ) ) FCVLAIF = .FALSE.
               IF( VLAVR(KS) .AND. ( FIFNAM(IIF,KF) .EQ. 'C'
     1           .OR. FIFNAM(IIF,KF) .EQ. 'D' ) ) FCVLAIF = .FALSE.
               IF( VLAVL(KS) .AND. ( FIFNAM(IIF,KF) .EQ. 'A'
     1           .OR. FIFNAM(IIF,KF) .EQ. 'B' ) ) FCVLAIF = .FALSE.
            END IF
C
C           If it is the VLBA, be sure of the front end spec.  This 
C           is a bit complicated because we need to detect the
C           index number of the IF, as used in setup parameters, 
C           based on the name.
C
C           This is for FE only at the moment and that applies
C           only to certain stations (VLBA).  Hence we don't have to
C           test against MarkIV or other IF names.
C
            IFINDX = 0
            IF( FIFNAM(IIF,KF) .EQ. 'A' ) IFINDX = 1
            IF( FIFNAM(IIF,KF) .EQ. 'B' ) IFINDX = 2
            IF( FIFNAM(IIF,KF) .EQ. 'C' ) IFINDX = 3
            IF( FIFNAM(IIF,KF) .EQ. 'D' ) IFINDX = 4
C
C           If not found for stations that need it, die.  Otherwise
C           set a benign default.
C
            IF( IFINDX .EQ. 0 ) THEN
               IF( INDEX( SETSTA(1,KS), 'VLBA' ) .NE. 0 ) THEN
                  CALL ERRLOG( 'FCOMPARE: Unrecognized IF name for '
     1               // SETSTA(1,KS) // ' in frequency catalog.' )
               ELSE
                  IFINDX = 1
               END IF
            END IF
C
C           Now finally test against the FE specification on VLBA
C           stations.
C
            IF( INDEX( SETSTA(1,KS), 'VLBA' ) .NE. 0 ) THEN 
               FCFE =  ( FE(IFINDX,KS) .EQ. 'omit' .OR.
     1             FE(IFINDX,KS) .EQ. FFE(IIF,KF) )
            ELSE
               FCFE = .TRUE.
            END IF
C
C           Add up all the tests.
C
            IFMATCH = FCIFCH .AND. FCFLO1 .AND. FCPOL .AND. FCCH1
     1           .AND. FCVLAIF .AND. FCFE .AND. RFCLOSE
C
C           If the channel matches, other than in the precise frequency,
C           record that fact.  OKIF means all except maybe the exact
C           frequency matches.
C
            IF( IFMATCH ) THEN
               OKIF(ICH,IIF) = .TRUE.
            END IF
C
C           Check for exact frequency in range.  Only require one 
C           channel to be ok - allows for overflow at places like 
C           the VLA.
C           If the routine got past the top few statements, at least
C           one channel is in the frequency range.  Check this specific
C           channel here, but don't let a mismatch prevent an overall
C           match.  Just try to downgrade this option so if a better
C           one exists, it will be used.
C
            FREQOK(ICH) = FREQREF(ICH,KS) .GE. FRF1(IIF,KF) .AND.
     1                    FREQREF(ICH,KS) .LE. FRF2(IIF,KF)
C
C           Record if there are any matching channels.  This means that
C           the freq.dat record can be used.
C
            IF( IFMATCH .AND. FREQOK(ICH) ) MATCH = .TRUE.
C
C           Determine just how bad the match was.
C
            IIFBAD = 0
            IF( .NOT. FCSTA )   IIFBAD = IIFBAD + 1
            IF( .NOT. RFCLOSE ) IIFBAD = IIFBAD + 1
            IF( .NOT. FCIFCH )  IIFBAD = IIFBAD + 1
            IF( .NOT. FCFLO1 )  IIFBAD = IIFBAD + 1
            IF( .NOT. FCPOL )   IIFBAD = IIFBAD + 1
            IF( .NOT. FCCH1 )   IIFBAD = IIFBAD + 1
            IF( .NOT. FCVLAIF ) IIFBAD = IIFBAD + 1
            IF( .NOT. FCFE )    IIFBAD = IIFBAD + 1
            IF( .NOT. FREQOK(ICH) )  IIFBAD = IIFBAD + 1
C
C           See if this was the best IF for this channel, save
C           number of mismatches and flags for printout.
C
            IF( IIFBAD .LT. CHBAD ) THEN
               CHBAD = IIFBAD
               WRITE( CHFLAGS, '( I2, 8L1 )' ) IIF, FCIFCH, 
     1            FCFLO1, FCPOL, FCCH1, FCVLAIF, FCFE, 
     2            FREQOK(ICH), RFCLOSE
            END IF
C
C           End of frequency group IF loop.
C
         END DO
C
C        Pring some current results if in debug mode.
C
         IF( SDEBUG ) THEN
            SETMSG = ' '
            WRITE( SETMSG, '( A, 3I4, 2X, 2L1 )' ) 
     1           'FCOMPARE: Channel checked: ', 
     2           KS, KF, ICH, MATCH
            CALL WLOG( 0, SETMSG )
         END IF
C
C        Get the degree by which the worst channel missed.
C
         KFBAD = MAX( KFBAD, CHBAD )
C
C        Some output if debugging or trying to explain why no
C        match was found (call with PRTMISS set true).
C
         IF( SDEBUG .OR. ( PRTMISS .AND. CHBAD .LE. NBAD + 1) ) THEN
            SETMSG = ' '
            WRITE( SETMSG, '( 3X, A12, I8, 6X, A2, 1X, ' //
     1         ' 8( 5X, A1 ) )' )
     2         FRNAME(KF), ICH, CHFLAGS(1:2),(CHFLAGS(I:I),I=3,10)
            CALL WLOG( 0, SETMSG )
         END IF
C
C        End of channel loop.
C
      END DO
C
C     Some more debug printout.
C
      IF( SDEBUG ) THEN
         SETMSG = ' '
         WRITE( SETMSG, '( A, L1 )' ) 
     1        'FCOMPARE: Out of channel loop: ', MATCH
         CALL WLOG( 0, SETMSG )
      END IF
C
C     Check 50 cm filter.  Maybe use FC50 some day related NBAD.
C
      FC50 =  SETSTA(1,KS)(1:4) .NE. 'VLBA' .OR. (
     1        ( RCP50CM(KS) .EQ. 'DEF' .OR.
     2        RCP50CM(KS) .EQ. FRCP50CM(KF) )  .AND.
     3        ( LCP50CM(KS) .EQ. 'DEF' .OR.
     4        LCP50CM(KS) .EQ. FLCP50CM(KF) ) )
C
      IF( ( MATCH .AND. .NOT. FC50 ) .AND. ( SDEBUG .OR. 
     1    (  PRTMISS .AND. KFBAD .LE. NBAD + 1) ) ) THEN
         CALL WLOG( 0, '          50cm filter doesn''t match.' )
      END IF
C
      MATCH = MATCH .AND. FC50
C
C     Record how bad the miss was.
C
      NBAD = MIN( NBAD, KFBAD )
C
C     Check the synthesizer settings for VLBA sites.  Allow the user
C     to set a synthesizer the frequency catalog doesn't care about
C     to anything.  Note that MATCH in the IF statement insures that 
C     the MATCH = statement is equivalent to MATCH = MATCH .AND. ...
C
      IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' .AND. MATCH ) THEN
         MATCH = ( SYNTH(1,KS) .EQ. 0.D0 .OR. FSYN(1,KF) .EQ. 0.D0 .OR.
     1             SYNTH(1,KS) .EQ. FSYN(1,KF) ) .AND.
     2           ( SYNTH(2,KS) .EQ. 0.D0 .OR. FSYN(2,KF) .EQ. 0.D0 .OR.
     3             SYNTH(2,KS) .EQ. FSYN(2,KF) ) .AND.
     4           ( SYNTH(3,KS) .EQ. 0.D0 .OR. FSYN(3,KF) .EQ. 0.D0 .OR.
     5             SYNTH(3,KS) .EQ. FSYN(3,KF) )
C
         IF( SDEBUG ) THEN
            IF( MATCH ) THEN
               CALL WLOG( 0, 'FCOMPARE: Synth matches.' )
            ELSE
               CALL WLOG( 0, 'FCOMPARE: Problem with synth matches.' )
            END IF
         END IF
C
      END IF
C
C
      IF( SDEBUG ) THEN
         IF( MATCH ) THEN
            CALL WLOG( 0, 'FCOMPARE: Got overall match.' )
         ELSE
            CALL WLOG( 0, 'FCOMPARE: Problem with overall  match.' )
         END IF
      END IF
C
C     Now we are done and MATCH = .TRUE. means that this frequency
C     group is compatible with the setup file in every way except
C     possibly the RF frequency of some channels.  
C
C     Jump here if no frequencies match to minimize time spent on
C     useless frequency sets.      
C
 1000 CONTINUE
      RETURN
      END

      SUBROUTINE TPSUM
C
C     Routine for SCHED called by SCHSUM that writes out a summary
C     of the time span and data output for each station.
C
C     The name is a holdover from before Feb. 2008 when it gave a
C     summary of tape usage and tape changes.
C
      INCLUDE  'sched.inc'
C
      LOGICAL     FIRSTS, FIRSTE
      INTEGER     ISTA, ISCN, YEAR, DAY1, DAY2, NACC
      DOUBLE PRECISION  START, STOP
      REAL        GBY
      CHARACTER   TFORM*8
      CHARACTER   LSTOP*10, LSTART*10, LDAY1*3, LDAY2*3
      CHARACTER   ESTOP*10, ESTART*10, EDAY1*3, EDAY2*3
C
C ------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'TPSUM starting' )

C  GBYTES for DOSCANS is really for all scans.


C
      IF( FUZZY .AND. DOSCANS(1) .EQ. 0 ) THEN
         WRITE( ISUM, '( 1X, /, A, /, 2A, /, 2X, 3(/, 2A) )' )
     1     ' TIME RANGE OF RECORDINGS and TOTAL BYTES:',
     2     '    ''extras'' have PREEMPT=EXTRA, ''core'' has other ',
     3     'PREEMPT settings.',
     4     '              Start extras   Core start time.   ',
     5     'Core end time.    End extras       Core     Total',
     6     ' Station      Day    Time      Day    Time      ',
     7     ' Day    Time      Day    Time     GBytes    GBytes ',
     8     '                 (UT)             (UT)             ',
     9     '  (UT)             (UT)'
      ELSE IF( FUZZY .AND. DOSCANS(1) .NE. 0 ) THEN
         WRITE( ISUM, '( 1X, /, A, /, 2A, /, 2X, 3(/, 2A) )' )
     1     ' TIME RANGE OF RECORDINGS and TOTAL BYTES:',
     2     '    DOSCANS specified.  ''core'' have PREEMPT not ',
     3     'set to EXTRA. ',
     2     '             Start DOSCANS   Core start time.   ',
     3     'Core end time.    End DOSCANS      Core    DOSCANS',
     4     ' Station      Day    Time      Day    Time      ',
     5     ' Day    Time      Day    Time     GBytes    GBytes ',
     6     '                 (UT)             (UT)             ',
     7     '  (UT)             (UT)'
      ELSE IF( DOSCANS(1) .NE. 0 ) THEN
         WRITE( ISUM, '( 1X, 2(/, A), /, 2X, /, 2A, /, 2A, /, A )' )
     1     ' TIME RANGE OF RECORDINGS and TOTAL BYTES:',
     2     '    DOSCANS specified.  Summary is for that range.',
     2     '              DOSCANS start time.  DOSCANS end time.',
     3     '     DOSCANS', 
     4     ' Station          Day    Time         Day    Time   ',
     5     '     GBytes',
     6     '                     (UT)                 (UT)'
      ELSE
         WRITE( ISUM, '( 1X, /, A, /, 2X, /, 2A, /, 2A, /, A )' )
     1     ' TIME RANGE OF RECORDINGS and TOTAL BYTES:',
     2     '                Obs. start time.     Obs. end time. ',
     3      '     Total ', 
     4     ' Station          Day    Time         Day    Time   ',
     5      '     GBytes',
     6     '                     (UT)                 (UT)'
      END IF
C
      DO ISTA = 1, NSTA

C         WRITE( ISUM, '( 2X )' )
         FIRSTS = .TRUE.
         NACC = 0
         DO ISCN = SCAN1, SCANL
C     
C           Is this station involved in this scan?
C     
            IF( STASCN(ISCN,ISTA) .AND. .NOT. NOREC(ISCN) ) THEN
C     
C              Get first start time.
C     
               IF( FIRSTE .AND. .NOT. NOREC(ISCN) .AND. 
     1             DOSCANS(1) .EQ. 0 .OR. ISCN .GE. DOSCANS(1) ) THEN
                  CALL TIMEJ( STARTJ(ISCN), YEAR, DAY1, START )
                  ESTART = TFORM( START, 'T', 0, 2, 2, '::@' )
                  ESTART(9:10) = '  '
                  WRITE( EDAY1, '(I3)' ) DAY1
                  FIRSTE  = .FALSE.
               END IF
C     
C              Get first start time of the core.
C     
               IF( FIRSTS .AND. .NOT. NOREC(ISCN) .AND. 
     1              PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
                  CALL TIMEJ( STARTJ(ISCN), YEAR, DAY1, START )
                  LSTART = TFORM( START, 'T', 0, 2, 2, '::@' )
                  LSTART(9:10) = '  '
                  WRITE( LDAY1, '(I3)' ) DAY1
                  FIRSTS  = .FALSE.
               END IF
C     
C              Collect last scan stop time.  Treat each scan as the
C              last, and when the loop runs out, the parameters from
C              the last scan in which the station participated will
C              be left.
C     
               IF( .NOT. NOREC(ISCN) .AND. 
     1              DOSCANS(1) .EQ. 0 .OR. ISCN .LE. DOSCANS(2) ) THEN
                  CALL TIMEJ( STOPJ(ISCN), YEAR, DAY2, STOP )
                  ESTOP = TFORM( STOP, 'T', 0, 2, 2, '::@' )
                  ESTOP(9:10) = '  '
                  WRITE( EDAY2, '(I3)' ) DAY2
               END IF
               IF( .NOT. NOREC(ISCN) .AND. 
     1              PREEMPT(ISCN) .NE. 'EXTRA' ) THEN
                  CALL TIMEJ( STOPJ(ISCN), YEAR, DAY2, STOP )
                  LSTOP = TFORM( STOP, 'T', 0, 2, 2, '::@' )
                  LSTOP(9:10) = '  '
                  WRITE( LDAY2, '(I3)' ) DAY2
               END IF
C
               NACC = NACC + 1
            END IF
C     
         END DO
C     
C        Write data for the station.
C     
         IF( NACC .GE. 1 ) THEN
            IF( FUZZY ) THEN
               IF( DOSCANS(1) .EQ. 0 ) THEN 
                  GBY = EGBYTES(ISTA)
               ELSE
                  GBY = DGBYTES(ISTA)
               END IF
               WRITE(ISUM,'( 2X, A, T14, A,2X,A, 2X, A,2X,A, 3X,'//
     1               ' A,2X,A, 2X, A,2X,A, F8.0, F10.0 )')
     2             STANAME(ISTA), EDAY1, ESTART, LDAY1, LSTART, 
     3             LDAY2, LSTOP, EDAY2, ESTOP,
     4             TGBYTES(ISTA), GBY
            ELSE
               IF( DOSCANS(1) .EQ. 0 ) THEN 
                  GBY = TGBYTES(ISTA)
               ELSE
                  GBY = DGBYTES(ISTA)
               END IF
               WRITE(ISUM,'( 2X, A, T18, A,2X,A, 5X, A,2X,A, 3X, F8.1)')
     1             STANAME(ISTA), LDAY1, LSTART, LDAY2, LSTOP,
     2             GBY
            END IF
         ELSE
            WRITE(ISUM,'( 2X, A, A )' ) STANAME(ISTA), 
     1          '      No recorded data. '
         END IF
C     
      END DO
      WRITE( ISUM,'(2X)' )
C
      RETURN
      END

      SUBROUTINE TPMFIX
C
C     Removed the tape section (most of the routine) July 23, 2010.
C     Comments below mainly relate to what it used to do.
C  
C     Deal with cases were tape stations have varying TAPEMODE
C     during an observation.  While varying TAPEMODE  might be 
C     possible, it would introduce very serious complications 
C     in the allocation of tape resources and possible inefficient 
C     use of tape.  Don't allow it.  Note that different stations
C     are allowed to use different tapemodes.
C
C     Note that TAPEMODE is really a statement of how many tracks
C     are being used at once.  We don't want this to vary for tape.
C
C     For disk, variable numbers of tracks are not an issue.  Also
C     there is no head position concept.  We just want to keep
C     the same heads all the time - the ones that a tape would have
C     used in the first pass.  So just set TAPEMODE=1.  Note that
C     this is for MARK5A.  For MARK5B, the concept of tracks goes
C     away and we are only setting channels.  This routine will
C     probably be skipped, but I have to think about it.
C
C     The logic used to be a mess when one setup could control 
C     several stations (like VLBA stations).  But SCHED was modified
C     to avoid this situation so the logic is being simplified
C     on June 28, 2005.
C
C     Note that this routine comes between setting the basic 
C     formatter parameters and setting track assignments.  This is
C     not where we attempt to adjust the fan outs etc to equalize
C     the number of tracks.  This was already attempted in SETFORM
C     in setting default formats.  But that might not have 
C     succeeded, or the user might have forced a situation with
C     variable TAPEMODEs.  
C
C     To enforce constant TAPEMODE, for each station separately, go 
C     through all the setups looking at those with VLBA and MKIV 
C     formats.  Get the minimum TAPEMODE.  Then go back and set 
C     the TAPEMODE for all these setups to the minimum.  I tried to
C     deal with this entirely in TPSCH, but that had trouble with
C     track assignments.  A TAPEMODE=4 setup would only get 2 passes
C     per head position, as expected, but they would use only the
C     even tracks, hence writing over half the tracks used by an
C     earlier TAPEMODE=2 scan.
C
C     Modified June 27, 2005 for the new regime with a separate setup
C     for every station.  See the archive of obsolete code for the
C     version that understands multiple stations per setup.  The
C     changes were an immense simplification.  RCW.
C
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
      INTEGER    KS, ISTA
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'TPMFIX starting' )
C
C     Since we are not changing track rates here, only deciding
C     whether to waste some tracks, we can do each station 
C     independently.
C
      DO ISTA = 1, NSTA
         IF( USEDISK(ISTA) ) THEN
            DO KS = 1, NSET
               IF( ISCHSTA(ISETSTA(KS)) .EQ. ISTA .AND.
     1             RECUSED(KS) .AND. (
     2             FORMAT(KS)(1:4) .EQ. 'VLBA' .OR. 
     3             FORMAT(KS)(1:4) .EQ. 'MARK' .OR.
     4             FORMAT(KS)(1:4) .EQ. 'MKIV' ) ) THEN
                  TAPEMODE(KS) = 1
               END IF
            END DO
         END IF
      END DO
C
C     We're done.  If you look at the archive version of this
C     routine, you'll see just how much easier this was!  And this
C     comment was written before the tape stuff was taken out!
C     I can probably remove the routine entirely, but worry about
C     that later.
C
      RETURN
      END

      SUBROUTINE PRTSCH( ISCN, ISTA, FIRSTS )
C
C     Subroutine for SCHED that prints the operator schedule.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER            ISCN, ISTA, ILINE, IPAGE, LEN1, LASTDY
      INTEGER            KY, KM, JD
      INTEGER            LTEST, KD1, KD2, NCHL, LNCHL
      INTEGER            DAY1, DAY2, DAY3, YEAR1, YEAR2, YEAR3
      INTEGER            IFREQ, I
      INTEGER            TEARLY, TDWELL, NFLINES, CRSETC(MAXCHN)
      INTEGER            KF, LKF, GBY1, GBY2, LGBY, ICH1
      DOUBLE PRECISION   LBW(MCHAN), SBW(MCHAN), SBBC(MCHAN)
      DOUBLE PRECISION   LFREQ(MCHAN), SFREQ(MCHAN), START, STOP 
      DOUBLE PRECISION   TSTART, RTCORR, LSTOPJ, DSTART
      LOGICAL            FIRSTS, DOWRTF, DOWRTB
      INTEGER            CRDN
      DOUBLE PRECISION   CRDF(MCHAN), CRDB(MCHAN), CRDLOSUM(MCHAN)
      CHARACTER          CRDS(MCHAN)*1
      CHARACTER          TFORM*15, SHORTN*10
      CHARACTER          CLST1*9, CLST2*9, FF*1
      CHARACTER          CSTART*15, CSTOP*15, CTSTART*15, CTCORR*15
      CHARACTER          PRTSRC*12
      CHARACTER          MNAME1*3, MNAME2*3, DNAME1*3, DNAME2*3
      SAVE               ILINE, IPAGE, LASTDY, LNCHL, LFREQ, LBW
      SAVE               LGBY, LKF
      SAVE               LSTOPJ
C -----------------------------------------------------------------
      IF( DEBUG .AND. FIRSTS ) THEN
         CALL WLOG( 0, 'PRTSCH: Making operator schedule file for' //
     1      STANAME(ISTA) )
      END IF
C
      NCHL = NCHAN(NSETUP(ISCN,ISTA))
C
C     Reset line (ILINE) and page (IPAGE) counters on first scan.
C
      FF = CHAR(12)       !  Form feed.
      IF( FIRSTS ) THEN
         LGBY = 0
         ILINE = 999
         IPAGE = 1
         LASTDY = -999
         LSTOPJ = 0.D0
         LNCHL = 0
         LKF = 0
         DO IFREQ = 1, MCHAN
            LFREQ(IFREQ) = 0.D0
            LBW(IFREQ) = 0.0
         END DO
C
C        Write cover page.
C
         WRITE( IPRT, '( A, /,1X,/, 5A /, 2A, /, 2A, /, 2A )' )
     1      '  COVER INFORMATION ',
     2      ' Station:    ', STANAME(ISTA),
     3      '  (Code ', STCODE(STANUM(ISTA)), ') ', 
     4      ' Experiment: ', EXPT(1:LEN1(EXPT)),
     5      ' Exp. Code:  ', EXPCODE            
         WRITE( IPRT, '( 1X, /, 2(A,/), 1X,/, A, /, 1X,/, 4(A,/), ' //
     1      '1X,/, 4(A,/), 1X,/, A,/, 1X,/, 4(A,/) )' )
     2      (COVER(I)(1:MAX(1,LEN1(COVER(I)))), I=1,MCOVER)
C
C        Write cover letter if one was given.
C
         IF( COVERLET ) THEN
            WRITE( IPRT, '( 1X, /, A, /, 1X )' )
     1          'COVER LETTER:'
            CALL WRTCOV( IPRT )
         END IF
      END IF
C
C     Get time information for the scan.
C
      CALL TIMEJ( STARTJ(ISCN), YEAR1, DAY1, START )
      CALL TIMEJ( STOPJ(ISCN), YEAR2, DAY2, STOP )
C
C     Get the dwell time and the margin of arrival time.
C
      TEARLY = IDNINT( ( STARTJ(ISCN) - TONSRC(ISCN,ISTA) ) * 86400.D0 )
      IF( UP1(ISCN,ISTA) .EQ. ' ' .AND. UP2(ISCN,ISTA) .EQ. ' ' ) THEN
         IF( TEARLY .GE. 0 ) THEN
            TDWELL = IDNINT( ( STOPJ(ISCN) - STARTJ(ISCN) ) * 86400.D0 )
         ELSE
            TDWELL = IDNINT( ( STOPJ(ISCN)-TONSRC(ISCN,ISTA) )*86400.D0)
         END IF
      ELSE
         TDWELL = 0
      END IF
C
C     Test if there are any new frequencies or bandwidths.
C
      KF = FSETI(ISCN,ISTA)
      DOWRTF = .FALSE.
      DOWRTB = .FALSE.
      IF( KF .NE. LKF ) THEN
         CALL FSFREQ( KF, SFREQ, SBBC, SBW,
     1         CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC )
         NCHL = NCHAN( FSETKS(KF) )
         IF( NCHL .NE. LNCHL ) THEN
            DOWRTF = .TRUE.
            DOWRTB = .TRUE.
         END IF
         DO IFREQ = 1, NCHL
            IF( SFREQ(IFREQ) .NE. LFREQ(IFREQ) ) DOWRTF = .TRUE.
            IF( SBW(IFREQ) .NE. LBW(IFREQ) ) DOWRTB = .TRUE.
         END DO
C
C        Save these parameters for comparison next time.
C
         LKF = KF
         LNCHL = NCHL
         DO IFREQ = 1, NCHL
            LFREQ(IFREQ) = SFREQ(IFREQ)
            LBW(IFREQ) = SBW(IFREQ)
         END DO         
C
C        Get the number of lines it will take to print frequencies
C        or bandwidths at 6 per line.  Note that this might not be
C        exact as it depends on how many digits are needed per freq.
C
         NFLINES = 1 + ( NCHL - 1 ) / 6 
C
      ELSE
         NFLINES = 0
      END IF
C
C     Page if necessary.  LTEST is where the line counter will be after
C     this scan.  Test it against LINEPG.
C
      LTEST = ILINE + 2
      IF( DAY2 .NE. LASTDY )     LTEST = LTEST + 2
      IF( ANNOT(ISCN) .NE. ' ' ) LTEST = LTEST + 2
      IF( DOWRTF .OR. DOWRTB )   LTEST = LTEST + 1
      IF( DOWRTF )               LTEST = LTEST + 2 * NFLINES
      IF( DOWRTB )               LTEST = LTEST + NFLINES
C
      IF( LTEST .GT. LINEPG ) THEN
         ILINE = 8
         IPAGE = IPAGE + 1
C
C        Write page header.
C
         WRITE( IPRT, '( A1, A,A, A,A,A, T70, A,I3, /, 15X,A )' ) 
     1      FF, 'Schedule for ', STANAME(ISTA),
     2      '  (Code ', STCODE(STANUM(ISTA)), ') ', 
     3      'Page ', IPAGE,     EXPT(1:LEN1(EXPT))
C
         WRITE( IPRT, '( 2A, /, 2A, /, A, /, 2A, /, A )' )
     1      '  UP:  D => Below limits;  H => Below horizon mask;',
     2      '  W => still slewing at end;  blank => Up.',
     3      '  Early: Seconds between end of slew and start. ',
     4      '  Dwell: On source seconds. ',
     5      '  Disk: GBytes recorded to this point.',
     6      '  TPStart:  Recording start time.',
     7          '  Frequencies are LO sum (band edge).',
     8      '  SYNC: Time correlator is expected to sync up.'
C
         WRITE( IPRT, '( 88(''-''), /, 2A, /, 2A, /, 88(''-'') )' )
     1      'Start UT  Source               Start / Stop           ',
     2      '      Early    Disk   TPStart',
     3      'Stop UT                  LST      EL    AZ   HA  UP   ',
     4      'ParA  Dwell   GBytes    SYNC'
C                         
         LASTDY = -999
      END IF
C
C     Write day number at top of page or when day changes.
C     Use modified CIT routine, TDATECW, to get month name and day name.
C
      IF( DAY2 .NE. LASTDY ) THEN
         LASTDY = DAY2
         KY = YEAR2
         KM = 1
         KD2 = DAY2
         CALL TDATECW( KY, KM, KD2, JD, MNAME2, DNAME2 )
         IF( DAY1 .EQ. DAY2 ) THEN
            WRITE( IPRT, '( 2X, /, A, A3, I4, 1X, A3, I5, A, I4, A )' )
     1         ' --- ', DNAME2, KD2, MNAME2, YEAR2, '   Day', DAY2, 
     2         ' ---'
         ELSE
            KY = YEAR1
            KM = 1
            KD1 = DAY1
            CALL TDATECW( KY, KM, KD1, JD, MNAME1, DNAME1 )
            WRITE( IPRT, '( 2X, /, A, A3, I4, 1X, A3, I5, A, I4, ' //
     1          ' A, A3, I4, 1X, A3, I5, A, I4, A )' )
     2          ' --- Start: ', DNAME1, KD1, MNAME1, YEAR1, '   Day', 
     3          DAY1, ' -- Stop: ', DNAME2, KD2, MNAME2, YEAR2, 
     4          '   Day', DAY2, ' ---'
         END IF
         ILINE = ILINE + 2
      END IF
C
C     Add comment
C
      IF( ANNOT(ISCN) .NE. ' ' ) THEN
         WRITE (IPRT,'(2X,/,'' ---------- '',A,'' ----------'')')
     1      ANNOT(ISCN)(1:MAX(1,LEN1(ANNOT(ISCN))))
         ILINE = ILINE + 2
      END IF
C
C     Write new frequencies and bandwidths.
C     Allow more digits in the frequency specifications.  Only print
C     them all when needed.  To align columns, assume SFREQ(1) has the
C     number of digits normally needed for the frequency.
C
      IF( DOWRTF .OR. DOWRTB ) THEN
         WRITE( IPRT, '( 2X )' )
      END IF
C
      ICH1 = LEN1( ' Next scan frequencies:' )
      CALL LSTFREQ( IPRT, SFREQ, SBBC, SBW, ICH1, NCHL, ILINE,
     1       100, 8, DOWRTF, DOWRTB,
     2       ' Next scan frequencies:',
     3       ' Next BBC frequencies:',
     4       ' Next scan bandwidths:' )
C
C     Schedule file output
C
      CLST1 = TFORM( LST1(ISCN,ISTA), 'T', 0, 2, 2, '  @' )
      CLST2 = TFORM( LST2(ISCN,ISTA), 'T', 0, 2, 2, '  @' )
C
C     Short name, Up-Down comment, and disk stuff.
C
      IF( LEN1(SCNSRC(ISCN)) .GT. 8 .AND. 
     1    SOUR8(SRCNUM(ISCN)) .NE. ' ' ) THEN
         SHORTN = '='//SOUR8(SRCNUM(ISCN))
      ELSE
         SHORTN = '---'
      END IF
C
C     Write scan info.
C
      IF( LEN1( SCNSRC(ISCN) ) .LE. 11 )  THEN
         PRTSRC = ' '//SCNSRC(ISCN)
      ELSE
         PRTSRC = SCNSRC(ISCN)
      END IF
      CSTART = TFORM( START, 'T', 0, 2, 2, '  @' )
      CSTOP = TFORM( STOP,  'T', 0, 2, 2, '  @' )
      IF( NOREC(ISCN) ) THEN
         CTSTART = 'Stopped '
         CTCORR  = ' '
      ELSE
C
C        Get the media start time.  This is no longer so simple because
C        the VLA and VLBA systems believe the good data time from the
C        Vex file.  Other systems still use the old start time.
C        USEONSRC is the flag for which to use.
C


C      For exploring the start times and tcorr.
C      write(*,*) 'prtsch: ', iscn, ista, ' ', stcode(stanum(ista)) ,
C     1    ' ', useonsrc(stanum(ista)), ' ', prestart(iscn),
C     2    startj(iscn), tpstart(iscn,ista) / onesec, 
C     2    ( tonsrc(iscn,ista) - startj(iscn) ) / onesec,
C     3    ( tcorr(iscn,ista) - startj(iscn) ) / onesec


         IF( USEONSRC(STANUM(ISTA)) ) THEN
            DSTART = MAX( ( STARTJ(ISCN) - TPSTART(ISCN,ISTA) ), 
     1           TONSRC(ISCN,ISTA) )
         ELSE
            DSTART = ( STARTJ(ISCN) - TPSTART(ISCN,ISTA) )
         END IF
C
         IF( ABS( LSTOPJ - DSTART ) .LT. ONESEC ) THEN
            CTSTART = 'No stop'
         ELSE
            CALL TIMEJ( DSTART, YEAR3, DAY3, TSTART )
            CTSTART = TFORM( TSTART, 'T', 0, 2, 2, '  @' )
         END IF
C
C        Get the correlator sync time.
C
         CALL TIMEJ( TCORR(ISCN,ISTA), YEAR3, DAY3, RTCORR )
         CTCORR = TFORM( RTCORR, 'T', 0, 2, 2, '  @' )
C
         LSTOPJ = STOPJ(ISCN)
      END IF
C
C     Use the GBYTE position for disks instead of the tape
C     footage.
C
      IF( USEDISK(ISTA) ) THEN
         GBY1 = LGBY
         GBY2 = NINT( GBYTES(ISCN,ISTA) )
      ELSE
         GBY1 = 0.0
         GBY2 = 0.0
      END IF
      LGBY = GBY2
C
C     Write the scan lines.
C
      WRITE( IPRT, '( 2X, /, A8, 1X, A, T24, A8, 2F6.1, F5.1, 2X,  ' //
     1     ' A, F7.1, I6, 1X, I8, 3X, A8 )' )
     2     CSTART, PRTSRC, CLST1, 
     3     EL1(ISCN,ISTA), AZ1(ISCN,ISTA), HA1(ISCN,ISTA), 
     4     UP1(ISCN,ISTA), PA1(ISCN,ISTA), TEARLY, 
     5     GBY1, CTSTART
C
      WRITE( IPRT, '( A8, 2X, A, T24, A8, 2F6.1, F5.1, 2X, ' // 
     1     ' A, F7.1, I6, 1X, I8, 3X, A8 )' ) 
     2     CSTOP, SHORTN, CLST2, 
     3     EL2(ISCN,ISTA), AZ2(ISCN,ISTA), HA2(ISCN,ISTA), 
     4     UP2(ISCN,ISTA), PA2(ISCN,ISTA), TDWELL,
     5     GBY2, CTCORR
C
      ILINE = ILINE + 3
C
C     Print sun warning if needed.
C
      CALL SUNWARN( ISCN, 10.0, ILINE, IPRT )
C
      RETURN
      END

      SUBROUTINE SATGOT( GOTALL )
C
C     Routine for SCHED that checks if the source is a satellite
C     for which a spice flie is available.  It is closely
C     modeled on JPLGOT.
C
      INCLUDE       'sched.inc'
C
      LOGICAL           GOTALL
      INTEGER           KSRC, ISAT, NAM, IV, ISSAT, ICH
      DOUBLE PRECISION  SRA, SDEC, SDRA, SDDEC, T0, DIST, GEOVEL
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SATGOT: starting' )
C
      IF( .NOT. GOTALL .AND. NSAT .NE. 0 ) THEN
C
C        Look through any sources not yet found to try to see if it is
C        a satellite that matches one of the SATNAMEs.
C
         DO KSRC = 1, NSRC
            IF( SRCATN(KSRC) .EQ. 0 ) THEN
C
C              Check against the SATNAMEs.
C
               ISSAT = 0
               IF( NSAT .GE. 1 ) THEN
                  DO ISAT = 1, NSAT
                     IF( SRCNAME(KSRC) .EQ. SATNAME(ISAT) ) THEN
                        ISSAT = ISAT
                     END IF
                  END DO
               END IF
C
C              Call the satellite position routine for the first
C              scan for the first source to get a position for
C              the source catalog.  Note that this routine will
C              be called for each scan/station when actually making
C              schedules.  Use presence of SATFILE to determine which
C              routine to call.  SATINI made sure one, and not both
C              of SATFILE and TLEFILE are not 'NONE'.
C
               IF( ISSAT .NE. 0 ) THEN
                  IF( SATFILE(ISSAT)(1:4) .NE. 'NONE' ) THEN
                     CALL SATEP( ISSAT, 1, 0, 'VLBA', 
     1                     SRA, SDEC, SDRA, SDDEC, T0, DIST, GEOVEL )
                  ELSE
                     CALL SATTLE( ISSAT, 1, 0, 'VLBA', 
     1                     SRA, SDEC, SDRA, SDDEC, T0, DIST, GEOVEL )
                  END IF
C
C                 Add the satellite to the source catalog.
C
                  MSRC = MSRC + 1
                  SATEL(MSRC) = .TRUE.
                  SATN(MSRC) = ISSAT
C
C                 Don't do SUSED here - it can get it wrong for 
C                 optimized schedules and cause havoc elsewhere.
C                  SUSED(MSRC) = .TRUE.
C
                  SRCATN(KSRC) = MSRC
                  SRLSTN(MSRC) = KSRC
                  SOURCE(1,MSRC) = SRCNAME(KSRC)
C
C                 These may not be needed here, but should be harmless.
                  CSUSED(1,MSRC) = '*'
                  DO NAM = 2, MALIAS
                     SOURCE(NAM,MSRC) = ' '
                     CSUSED(NAM,MSRC) = ' '
                  END DO
C
                  C2000(MSRC) = '*'
                  C1950(MSRC) = ' '
                  CDATE(MSRC) = ' '
                  RA2000(MSRC) = SRA
                  D2000(MSRC) = SDEC
                  CALCODE(MSRC) = 'S'
                  REMARK(MSRC) = ' '
                  RAERR(MSRC) = 0.0
                  DECERR(MSRC) = 0.0
                  DO IV = 1, MAXLCH
                     VLSR(IV,MSRC) = 0.0
                  END DO
                  DRA(MSRC) = SDRA
                  DDEC(MSRC) = SDDEC
                  PMTIME(MSRC) = STARTJ(1)
                  WHICHCAT(MSRC) = 'S'
                  VELREF(MSRC) = 'G'
                  VELDEF(MSRC) = 'R'
                  DO ICH = 1, MAXLCH
                     VLSR(ICH,MSRC) = GEOVEL
                  END DO
C
C                 Give this source a special calcode to mark it
C                 as a satellite.  This helps run the correlator.
C
                  CALCODE(MSRC) = 'Z'
C
C                 Check later if this is for an allowed station.
C                 We don't have enough information yet.
C
               END IF
            END IF
         END DO
C
C        Finally check if we now have all schedule sources.
C
         GOTALL = .TRUE.
         DO KSRC = 1, NSRC
            IF( SRCATN(KSRC) .EQ. 0 ) GOTALL = .FALSE.
         END DO
C
      END IF
C
      RETURN
      END

      SUBROUTINE VXTELS( BLOCK, NXXVEX, STAXX, XXLINK )
C
C     Routine for the VEX extension of SCHED.
C     Finds out how many sections of type XX (e.g. DA) etc there will be.
C     Where the def sections are referenced by Station, not by MODE.
C     H.J.van Langevelde JIVE, 130596C
C
C     Input:
C        BLOCK = Two letter code, denoting which $BLOCK we are sorting
C     Output:
C        NXXVEX = Number of defs in $BLOCK
C        STAXX = List of stations, giving which def XX they use
C        XXLINK(IXX) = Name of link IXX.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      CHARACTER BLOCK*2, XXLINK(MAXSTA)*32
      INTEGER NXXVEX
      INTEGER STAXX(MAXSTA)
C
      INTEGER ISTA, JSTA
      LOGICAL NEWFND, VXCFDA, VXCFSI, VXCFAN
C ----------------------------------------------------------------------
C
      WRITE( MSGTXT, '( A, A, A )' ) 
     1    'VXTELS: Start sorting ', BLOCK, ' definition'
      IF( DEBUG ) CALL WLOG( 1, MSGTXT )
      NXXVEX = 0
      DO ISTA = 1, NSTA
C
C        Obviously a new block it's the first
C
         IF( ISTA .EQ. 1 ) THEN
            NEWFND = .TRUE.
         ELSE
C
C           Find if any tel JSTA has same chars ISTA = 1 to JSTA-1 
C
            NEWFND = .TRUE.
            DO JSTA = 1, (ISTA - 1)
C
C              Check Data Acquisition system
C
               IF( BLOCK .EQ. 'DA' ) THEN
                  IF( VXCFDA( ISTA, JSTA ) ) THEN
                     NEWFND = .FALSE.
C
C                    Same as old station, so use same def
C
                     STAXX(ISTA) = STAXX(JSTA)
                  END IF
C
C              Check SITE (a trivial comparison)
C
               ELSE IF( BLOCK .EQ. 'SI' ) THEN
                  IF( VXCFSI( ISTA, JSTA ) ) THEN
                     NEWFND = .FALSE.
C
C                    Same as old station, so use same def
C
                     STAXX(ISTA) = STAXX(JSTA)
                  END IF
C
C              Check station
C
               ELSE IF( BLOCK .EQ. 'AN' ) THEN
                  IF( VXCFAN( ISTA, JSTA ) ) THEN
                     NEWFND = .FALSE.
C
C                    Same as old station, so use same def
C
                     STAXX(ISTA) = STAXX(JSTA)
                  END IF
               ELSE
                  CALL ERRLOG(' VXSORT: unsupported BLOCK def ')
               END IF
            END DO
         END IF
         IF( NEWFND ) THEN
C
C           fill a new block and give it a name
C
            NXXVEX = NXXVEX + 1
            IF( NXXVEX .GT. MAXMOD ) CALL ERRLOG(
     1                 'VXTELS: Number of '//BLOCK//' defs '//
     2                 'exceeding MAXMOD, need to re-compile...')
C
C           store which def this station uses:
C
            STAXX(ISTA) = NXXVEX
C
            CALL VXNMXX( BLOCK, NXXVEX, XXLINK )
C
         END IF
      END DO
C
C     no further complications, done
C
      RETURN
      END

      SUBROUTINE PN3DB( ISCN, PTADD, TSTOP, KS )
C
C     Writes a sequency of half power tracking scans for the PN3DB
C     type of test.  This is used to check the encoders.  This 
C     routine is based on PTVLBA.
C
      INCLUDE     'sched.inc'
      INCLUDE     'schset.inc'
C
      INTEGER     I, PTADD, ISCN, QL, KS
      INTEGER     RLEVEL(MCHAN), TRKDUR
      REAL        DOAZ, DOEL
      CHARACTER   TSTOP*9
C --------------------------------------------------------------------
C     Get the center pointing position.  This is a sum from both
C     the main schedule and the setup file.
C
      DOAZ = SAZCOL(ISCN) + AZCOLIM(KS)
      DOEL = SELCOL(ISCN) + ELCOLIM(KS)
C
C     Do setup scan on half power point to get reasonable levels.
C     First go to half power point.  Note that subroutine VLBA
C     only does setup scans if tape is being written.
C
      DO I = 1, NCHAN(KS)
         RLEVEL(I) = -1 
      END DO
      CALL VLBAINT( 'level', 5, NCHAN(KS), RLEVEL, LLEVEL, MLEVEL,
     1           .FALSE., IUVBA )
      WRITE( IUVBA, '( ''azcolim='',F7.2, '' elcolim='',F7.2, 
     2      '' dur='',I4,''s'', /, 
     3      ''stop='', A, ''   !NEXT! '' )' )
     3      DOAZ - PTINCR(KS), 
     4      DOEL, PTSLEW(ISCN) + PTADD, TSTOP
C
C     Then sit there while fixing the BBC levels.
C
      DO I = 1, NCHAN(KS)
         RLEVEL(I) = 256
      END DO
      CALL VLBAINT( 'level', 5, NCHAN(KS), RLEVEL, LLEVEL, MLEVEL,
     1           .FALSE., IUVBA )
C
C     Make the level fixing scan a fixed 15 seconds.
C
      QL = QUAL(ISCN)
      WRITE( IUVBA, '( A, I3, A, I4, A )' )
     1    'qual=', 30+QL,'  dur=', 15, 's     !NEXT!'
C
C     Get the time to track at the Azimuth half power point.
C     The elevation scan should be the same length, but it will
C     end with the stop time.
C
      TRKDUR = ( DUR(ISCN) * 86400D0 - PTSLEW(ISCN) - 15.D0
     1         - 4.D0 * PTDUR ) / 2.D0
C
      IF( TRKDUR .LE. 0 ) THEN
         CALL ERRLOG( 'PN3DB:  Scan duration shorter than setups.' )
      END IF    
C
C     Then do the pattern
C
      WRITE( IUVBA, '( 5( A, I3, A, F7.2, A, I4, A, / ),' //
     1   'A, I3, A, F7.2, A )' )
     2   'qual=', 12+QL, ' azcolim=', DOAZ-PTOFF(KS), 
     3          ' dur=', PTDUR, 's  !NEXT!',
     4   'qual=', 10+QL, ' azcolim=', DOAZ,
     5          ' dur=', PTDUR, 's  !NEXT!',
     6   'qual=', 11+QL, ' azcolim=', DOAZ-PTINCR(KS),
     7          ' dur=', TRKDUR, 's  !NEXT!',
     8   'qual=', 22+QL, ' azcolim=', DOAZ-PTOFF(KS), 
     9          ' dur=', PTDUR, 's  !NEXT!',
     1   'qual=', 20+QL, ' azcolim=', DOAZ,           
     2          ' dur=', PTDUR, 's  !NEXT!',
     3   'qual=', 23+QL, ' elcolim=', DOEL+PTINCR(KS),
     4          ' dur=0   !NEXT!'
C
      RETURN
      END

      SUBROUTINE SETFMT( KS, TRKBPS, OK )
C
C     Routine for SCHED called by SETFORM that sets the format 
C     for VLBA and MKIV setups.  The parameters that it tries
C     to set are FORMAT, SPEEDUP, FANOUT, and TAPEMODE.
C
C     KS is the setup group.
C     TRKBPS is the track bit rate to try to match.
C     OK is output indicating if format actually got set.
C
      INCLUDE        'sched.inc'
      INCLUDE        'schset.inc'
C
      INTEGER        KS
      REAL           TRKBPS
      LOGICAL        OK
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SETFMT starting' ) 
      OK = .FALSE.
      TBPS(KS) = 0
C
C     Recall that the base FORMAT name has been set by now.
C     Call individual routines to deal with specific formats.
C     If the FORMAT etc have already been set, these routines
C     will just check that TRKBPS is SAMPRATE / FANOUT(KS)
C     and return OK.
C
      IF( FORMAT(KS) .EQ. 'S2' ) THEN
         CALL FMTS2( KS, OK ) 
      ELSE IF( FORMAT(KS) .EQ. 'MARKIII' ) THEN
         CALL FMTMKIII( KS, OK ) 
      ELSE IF( FORMAT(KS)(1:4) .EQ. 'VLBA' ) THEN
         CALL FMTVLBA( KS, TRKBPS, OK )
      ELSE IF( FORMAT(KS)(1:4) .EQ. 'MKIV' ) THEN
         CALL FMTMKIV( KS, TRKBPS, OK )
      ELSE IF( FORMAT(KS)(1:3) .EQ. 'LBA' .OR. 
     1         FORMAT(KS)(1:6) .EQ. 'MARK5B' .OR.
     2         FORMAT(KS)(1:4) .EQ. 'VDIF' ) THEN
         FANOUT(KS) = 1.0
         SPEEDUP(KS) = 1.0
         TAPEMODE(KS) = 1
         OK = .TRUE.
      ELSE
C
C        Format NONE or MARKII get here.
C        I don't think they need to do anything, but maybe I should
C        set some dummy values.  Use values that would be appropriate
C        for VLBA/MKIV.
C
C         IF( TAPEMODE(KS) .EQ. 0 ) TAPEMODE(KS) = 1
C         FANOUT(KS) = MIN( 4.0, SAMPRATE(KS) / 8.0 )
C         FANOUT(KS) = MAX( 1.0, FANOUT(KS) )
C         SPEEDUP(KS) = 1.0
C
C        Changing my mind.  For format NONE, in the past, TAPEMODE=0
C        Just leave it as is and set FANOUT and SPEEDUP to 0.
C        Need to make sure FANOUT is not being used to indicate that
C        the format is set.
C
         FANOUT(KS) = 0.0
         SPEEDUP(KS) = 0.0
C
         OK = .TRUE.
      END IF
C
      RETURN
      END

      SUBROUTINE SETREC
C
C     Routine for SCHED that sets some of the recorder parameters.
C     Called by SETDEFS.  
C
C     The hardest part is setting the format.  See SETFORM for
C     details.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
      INTEGER           KS, ISTA
      LOGICAL           BWARN
      SAVE              BWARN
      DATA              BWARN / .TRUE. /
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SETREC: Starting' )
C
C     Set the formats.  This is the most painful part.  SETFORM
C     and the routines it calls do the work.
C
      CALL SETFORM
C
C     Set some more parameters related to VLBA/MKIV/MARKIII systems.
C
      DO KS = 1, NSET
C
C        Remove the setting of tape speeds - obsolete.  Jan. 7, 2011
C
C        Set the barrel roll default.  This is correlator and
C        format dependent.  Do not use it with disk systems.
C        Probably drive a stake through BARREL some day as I don't
C        think it is used anywhere.
C         
         ISTA = ISCHSTA(ISETSTA(KS))
         IF( BARREL(KS) .EQ. 'not_set' ) THEN
            IF( USEDISK(ISTA) ) THEN
               BARREL(KS) = 'roll_off'
            ELSE IF( CORREL(1:7) .EQ. 'FXCORR' ) THEN
               IF( FORMAT(KS)(1:4) .NE. 'VLBA' .OR. 
     1             CONTROL(ISETSTA(KS)) .EQ. 'VEX' ) THEN
                  BARREL(KS) = 'roll_off'
               ELSE
                  IF( CORCHAN .GE. 1000 ) THEN
                     BARREL(KS) = 'roll_8'
                  ELSE
                     BARREL(KS) = 'roll_auto'
                  END IF
               END IF
            ELSE IF( CORREL(1:4) .EQ. 'JIVE' ) THEN
               BARREL(KS) = 'roll_off'
            ELSE
               BARREL(KS) = 'roll_off'
            END IF
         ELSE IF( BARREL(KS) .NE. 'roll_off' .AND. 
     1            USEDISK(ISTA) ) THEN
            IF( BWARN ) THEN
               CALL WLOG( 1, 'SETREC:  Barrel roll is obsolete - '//
     1              'not used for disk' )
               BWARN = .FALSE.
            END IF
            BARREL(KS) = 'roll_off'
         END IF
C
      END DO
C
C     Make changes to TAPEMODE if needed.
C
C     For disk stations, set TAPEMODE to 1 which better reflects
C     what they do.  This should only affect "track" assignments
C     downstream from here.  Earlier it might affect mode 
C     assignments.
C
C     Obsolete, and removed from routine.  But it used to, for 
C     tape stations, prevent changes in TAPEMODE which can
C     make tape management a nightmare.
C
      CALL TPMFIX
C
C     Tape speed stuff for S2 removed Jan. 7, 2011.  RCW.
C
      RETURN
      END

      SUBROUTINE SETBAND( KS )
C
C     Routine for SCHED that sets the reference frequencies based on a
C     band specification.
C
C     For now, this routine does not know how to set frequencies
C     for the RDBE based systems.  That should change before long but
C     it will be a bit tricky because of the polyphase filters and 
C     I need to get a release out soon.  Note that this routine has
C     to do exactly the same thing for all setup groups in a setup file,
C     or you will have something that cannot be correlated.  That 
C     means it cannot just detect an RDBE based on the group's station.
C     Also worry about the 15.625 vs 10 kHz tuning steps.
C
C     This will work if most other parameters are also defaulting or
C     using values similar to the defaults.  But I imagine that
C     the user could easily concoct a setup file with things like
C     the IFCHAN specified that would lead to an invalid set of
C     frequencies from this routine.  Hopefully, the checking routines
C     later would stop such a schedule from being used.
C     
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER           KS, ICH, MBD, IB, I, ISETF, ICS, ICX, IBS, IBX
      INTEGER           ISTA, NBWARN
      PARAMETER         (MBD=15)
      DOUBLE PRECISION  CFREQ(MBD), FRQLOW(MCHAN), TEMP, TEMPS, TEMPX
      DOUBLE PRECISION  TOTBAND, CBW(MBD)
      CHARACTER         CBAND(MBD)*5
      LOGICAL           GOTNETF, GOTNETS, GOTBBF, GOTBBS, GOTLO1
      LOGICAL           USEJOD
C
C     Specify the bands.  Put any with specific bandwidths before the
C     default.  IBS and IBX are the index for S and X bands.  Put
C     them at 1 and 2 so I don't risk forgetting to change them if
C     bands are added.
C
      DATA  CBAND(1), CFREQ(1), CBW(1)  /  '13cm', 2295.49D0, 0.D0 /
      DATA  CBAND(2), CFREQ(2), CBW(2)  /  '4cm', 8415.49D0, 0.D0 /
C
      DATA  CBAND(3), CFREQ(3), CBW(3)  /  '90cm', 330.49D0, 0.D0 /
      DATA  CBAND(4), CFREQ(4), CBW(4)  /  '50cm', 610.98D0, 0.D0 /
      DATA  CBAND(5), CFREQ(5), CBW(5)  /  '21cm', 1465.49D0, 128.D0 /
      DATA  CBAND(6), CFREQ(6), CBW(6)  /  '21cm', 1435.49D0, 64.D0 /
      DATA  CBAND(7), CFREQ(7), CBW(7)  /  '21cm', 1416.49D0, 0.D0 /
C
C     The second 18cm band will be used when Jodrell, but not the VLA,
C     is present to avoid RFI.
C
      DATA  CBAND(8), CFREQ(8), CBW(8)  /  '18cm', 1658.49D0, 0.D0 /
      DATA  CBAND(9), CFREQ(9), CBW(9)  /  '18cm', 1653.99D0, 0.D0 /
      DATA  CBAND(10), CFREQ(10), CBW(10)  /  '6cm', 4990.49D0, 0.D0 /
C
C     The original 2cm band here is centered at 15285.49. 
C     The standard setup files and pointing files are centered at 
C     15360.99.  The VLA band is 14650-15325 for 0.9 sensitivity.
C     But the default VU band is 15339.90-15389.90.  Confusing.
C     Will have CHKSET write an informational note to 2cm user.
C
      DATA  CBAND(11), CFREQ(11), CBW(11)  /  '2cm', 15285.49D0, 0.D0 /
C
C     The second 1cm band avoids much of the water line.  I didn't
C     use a wavelength spec because 1cm is already too coarse (and
C     really 30 GHz).
C
      DATA  CBAND(12), CFREQ(12), CBW(12) / '1cm', 22235.49D0, 0.D0 /
      DATA  CBAND(13), CFREQ(13), CBW(13) / '24ghz', 23799.49D0, 0.D0 /
      DATA  CBAND(14), CFREQ(14), CBW(14) / '7mm', 43135.49D0, 0.D0 /
      DATA  CBAND(15), CFREQ(15), CBW(15) / 'sx', 0.D0, 0.D0 /
C
C     Keep the indices for the X and S band frequencies used for SX.
C
      DATA  IBS, IBX  /  1,  2  /
      DATA  NBWARN  / 0 /
C ----------------------------------------------------------------------
C     First see if the frequency is needed based on the first 
C     channel.
C
      ISETF = ISETNUM(KS)
      ICH = 1
      GOTNETF = FREQREF(ICH,KS) .GT. 0.D0
      GOTNETS = NETSIDE(ICH,KS) .EQ. 'U' .OR. NETSIDE(ICH,KS) .EQ. 'L'
      GOTLO1  = FIRSTLO(ICH,KS) .NE. NOTSET
      GOTBBF  = BBSYN(ICH,KS) .NE. 0.0D0
      GOTBBS  = SIDEBD(ICH,KS) .EQ. 'U' .OR. SIDEBD(ICH,KS) .EQ. 'L'
      IF( .NOT. GOTNETF .AND. .NOT. (
     1     GOTBBF .AND. GOTBBS .AND. GOTNETS .AND. GOTLO1 ) ) THEN
C
C        Need to set the frequencies.  Only do if can.  Let SETFREQ
C        worry about it if we can't.
C
         IF( BAND(KS) .NE. ' ' ) THEN
C
C           Abort if this is an RDBE.
C
            IF( DBE(KS) .EQ. 'RDBE_PFB' .OR. 
     1          DBE(KS) .EQ. 'RDBE_DDC' ) THEN
               CALL ERRLOG( 
     1            'SETBAND: SCHED cannot yet set frequencies ' //
     2            'from just a BAND specification for RDBE and '//
     3            'DBBC systems.' )
            END IF
C
C           Now to get down to business.
C
            IF( DUALPOL(KS) ) THEN
               TOTBAND = TOTBW(KS) / 2.0 
            ELSE
               TOTBAND = TOTBW(KS)
            END IF
C
C           Identify the band.  Need the total bandwidth for this.
C
            IB = 0
            DO I = 1, MBD
               IF( BAND(KS) .EQ. CBAND(I) .AND. (
     1             ABS( CBW(I) - TOTBAND ) .LT. 1.0 .OR. 
     2             CBW(I) .EQ. 0.0 ) ) THEN
                  IB = I
                  GO TO 100
               END IF
            END DO
            CALL ERRLOG( 'SETBAND:  Invalid band: '//BAND(KS) )
  100       CONTINUE
C
C           Detect if we need the special Jodrell case.
C
            IF( BAND(KS) .EQ. '18cm' .AND. TOTBAND .EQ. 32.0 ) THEN
C
C              For 32 MHz observations at 18 cm, there is an 
C              incompatibility between the VLA 50 MHz band that
C              should be used (1640-1690) and some bad RFI at
C              Jodrell just below 1670.  For this band, detect the
C              use of either station.  If Jodrell is there, but
C              the VLA is not, change to the special frequency
C              set for 18 cm - which would not otherwise have
C              been selected.  I don't plan to be fussy about 
C              whether the stations are used in this setup.  That
C              would take a search through the scans.
C
               USEJOD = .FALSE.
               DO ISTA = 1, NSTA
                  IF( STCODE(STANUM(ISTA)) .EQ. 'Jb' .OR. 
     1                STCODE(STANUM(ISTA)) .EQ. 'Jv' ) USEJOD = .TRUE.
               END DO
               DO ISTA = 1, NSTA
                  IF( STATION(STANUM(ISTA))(1:3) .EQ. 'VLA' ) 
     1                USEJOD = .FALSE.
               END DO
               IF( USEJOD ) IB = IB + 1
            END IF
C
            IF( BAND(KS) .EQ. 'sx' ) THEN
C
C              This is SX band.  Two center frequencies need to be 
C              used.
C
               IF( DUALPOL(KS) ) THEN
                  IF( NCHAN(KS) .LT. 4 ) 
     1               CALL ERRLOG( 'Too few channels for dual pol, ' //
     2                    'dual band observing - need 4.' )
                  TEMPS = CFREQ(IBS) - TOTBAND / 4.0D0
                  TEMPX = CFREQ(IBX) - TOTBAND / 4.0D0
                  FRQLOW(1) = TEMPS
                  ICX = 1 + NCHAN(KS) / 2
                  FRQLOW(ICX) = TEMPX
                  DO ICS = 2, NCHAN(KS)/2
C
C                    S band.
C
                     IF( POL(ICS,KS) .EQ. POL(1,KS) .OR. 
     1                   POL(ICS,KS) .EQ. POL(ICS-1,KS) ) 
     2                   TEMPS = TEMPS + BBFILT(ICS,KS)
                     FRQLOW(ICS) = TEMPS
C
C                    X band.
C
                     ICX = ICS + NCHAN(KS) / 2
                     IF( POL(ICX,KS) .EQ. POL(1,KS) .OR. 
     1                   POL(ICX,KS) .EQ. POL(ICX-1,KS) ) 
     2                   TEMPX = TEMPX + BBFILT(ICX,KS)
                     FRQLOW(ICX) = TEMPX

                  END DO
               ELSE
                  IF( NCHAN(KS) .LT. 2 ) 
     1               CALL ERRLOG( 'Too few channels for, ' //
     2                    'dual band observing - need 2.' )
                  TEMPS = CFREQ(IBS) - TOTBAND / 4.0D0
                  TEMPX = CFREQ(IBX) - TOTBAND / 4.0D0
                  DO ICS = 1, NCHAN(KS)/2
C
C                    S band
C
                     FRQLOW(ICS) = TEMPS
                     TEMPS = TEMPS + BBFILT(ICS,KS)
C
C                    X band
C
                     ICX = ICS + NCHAN(KS) / 2
                     FRQLOW(ICX) = TEMPX
                     TEMPX = TEMPX + BBFILT(ICX,KS)
                  END DO
               END IF

            ELSE
C
C              "Normal cases"
C
C              Do things slightly differently for the single and 
C              dual polarization cases.
C
               IF( DUALPOL(KS) ) THEN
                  TEMP = CFREQ(IB) - TOTBAND / 2.0D0
                  FRQLOW(1) = TEMP
                  DO ICH = 2, NCHAN(KS)
                     IF( POL(ICH,KS) .EQ. POL(1,KS) .OR. 
     1                   POL(ICH,KS) .EQ. POL(ICH-1,KS) ) 
     2                   TEMP = TEMP + BBFILT(ICH,KS)
                     FRQLOW(ICH) = TEMP
                  END DO
               ELSE
                  TEMP = CFREQ(IB) - TOTBAND / 2.0D0
                  DO ICH = 1, NCHAN(KS)
                     FRQLOW(ICH) = TEMP
                     TEMP = TEMP + BBFILT(ICH,KS)
                  END DO
               END IF
            END IF
C
C           Get the reference frequency for each channel.
C
            DO ICH = 1, NCHAN(KS)
               IF( NETSIDE(ICH,KS) .EQ. 'U' ) THEN
                  FREQREF(ICH,KS) = FRQLOW(ICH)
               ELSE IF( NETSIDE(ICH,KS) .EQ. 'L' ) THEN
                  FREQREF(ICH,KS) = FRQLOW(ICH) + BBFILT(ICH,KS)
               ELSE
                  CALL ERRLOG( 'SETBAND: Must have net sideband to '//
     1                'set channel frequencies from BAND.' )
               END IF
C
C              Round to nearest 10 kHz
C 
               FREQREF(ICH,KS) = IDNINT( FREQREF(ICH,KS) * 100.0D0 ) / 
     1                  100.0D0
C
            END DO
C
         END IF
C
C     Check for case where both BAND and setup info are provided. 
C     Warn user.
C
      ELSE IF( BAND(KS) .NE. ' ' .AND. NBWARN .LT. 1) THEN
         CALL WLOG( 1, 'SETBAND:  Both BAND and adequate information '
     1       //' to set frequencies were provided' )
         CALL WLOG( 1, '          BAND will be ignored. ' //
     1       ' Only one warning will be issued.' )
         CALL WLOG( 1, '          Setup file: '// SETNAME(KS) )
         NBWARN = NBWARN + 1
      END IF
C
      RETURN
      END

      SUBROUTINE sla_MAPQKZ (RM, DM, AMPRMS, RA, DA)
*+
*     - - - - - - -
*      M A P Q K Z
*     - - - - - - -
*
*  Quick mean to apparent place:  transform a star RA,Dec from
*  mean place to geocentric apparent place, given the
*  star-independent parameters, and assuming zero parallax
*  and proper motion.
*
*  Use of this routine is appropriate when efficiency is important
*  and where many star positions, all with parallax and proper
*  motion either zero or already allowed for, and all referred to
*  the same equator and equinox, are to be transformed for one
*  epoch.  The star-independent parameters can be obtained by
*  calling the sla_MAPPA routine.
*
*  The corresponding routine for the case of non-zero parallax
*  and proper motion is sla_MAPQK.
*
*  The reference frames and timescales used are post IAU 1976.
*
*  Given:
*     RM,DM    d      mean RA,Dec (rad)
*     AMPRMS   d(21)  star-independent mean-to-apparent parameters:
*
*       (1-4)    not used
*       (5-7)    heliocentric direction of the Earth (unit vector)
*       (8)      (grav rad Sun)*2/(Sun-Earth distance)
*       (9-11)   ABV: barycentric Earth velocity in units of c
*       (12)     sqrt(1-v**2) where v=modulus(ABV)
*       (13-21)  precession/nutation (3,3) matrix
*
*  Returned:
*     RA,DA    d      apparent RA,Dec (rad)
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Notes:
*
*  1)  The vectors AMPRMS(2-4) and AMPRMS(5-7) are referred to the
*      mean equinox and equator of epoch EQ.
*
*  2)  Strictly speaking, the routine is not valid for solar-system
*      sources, though the error will usually be extremely small.
*      However, to prevent gross errors in the case where the
*      position of the Sun is specified, the gravitational
*      deflection term is restrained within about 920 arcsec of the
*      centre of the Sun's disc.  The term has a maximum value of
*      about 1.85 arcsec at this radius, and decreases to zero as
*      the centre of the disc is approached.
*
*  Called:  sla_DCS2C, sla_DVDV, sla_DMXV, sla_DCC2S, sla_DRANRM
*
*  P.T.Wallace   Starlink   18 March 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION RM,DM,AMPRMS(21),RA,DA

      INTEGER I

      DOUBLE PRECISION GR2E,AB1,EHN(3),ABV(3),
     :                 P(3),PDE,PDEP1,W,P1(3),P1DV,
     :                 P1DVP1,P2(3),P3(3)

      DOUBLE PRECISION sla_DVDV,sla_DRANRM




*  Unpack scalar and vector parameters
      GR2E = AMPRMS(8)
      AB1 = AMPRMS(12)
      DO I=1,3
         EHN(I) = AMPRMS(I+4)
         ABV(I) = AMPRMS(I+8)
      END DO

*  Spherical to x,y,z
      CALL sla_DCS2C(RM,DM,P)

*  Light deflection
      PDE = sla_DVDV(P,EHN)
      PDEP1 = PDE+1D0
      W = GR2E/MAX(PDEP1,1D-5)
      DO I=1,3
         P1(I) = P(I)+W*(EHN(I)-PDE*P(I))
      END DO

*  Aberration
      P1DV = sla_DVDV(P1,ABV)
      P1DVP1 = P1DV+1D0
      W = 1D0+P1DV/(AB1+1D0)
      DO I=1,3
         P2(I) = (AB1*P1(I)+W*ABV(I))/P1DVP1
      END DO

*  Precession and nutation
      CALL sla_DMXV(AMPRMS(13),P2,P3)

*  Geocentric apparent RA,Dec
      CALL sla_DCC2S(P3,RA,DA)
      RA = sla_DRANRM(RA)

      END

      CHARACTER*32 FUNCTION VXNMSI( IXX )
C
C     Routine specific for the VEX extension of SCHED. 
C     function generates a name for SI block IXX
C     By H.J. van Langevelde, JIVE, 300496 
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER IXX, KS, ISTA, ISCAT
      CHARACTER NAME*32
C ----------------------------------------------------------------------
C     
C     Find a station that uses this SIS def
C
      KS = -1
      DO ISTA = 1, NSTA
         IF( ISTASI(ISTA) .EQ. IXX ) KS = ISTA
      END DO
C
      IF( KS .LT. 0 ) CALL ERRLOG(' VXNMSI: no station for SITE def ')
C
C     name is simply the station's name
C
      ISCAT = STANUM(KS)
      NAME = STATION(ISCAT)
C        
      VXNMSI = NAME
C
      RETURN
      END

      SUBROUTINE sla_AMP (RA, DA, DATE, EQ, RM, DM)
*+
*     - - - -
*      A M P
*     - - - -
*
*  Convert star RA,Dec from geocentric apparent to mean place
*
*  The mean coordinate system is the post IAU 1976 system,
*  loosely called FK5.
*
*  Given:
*     RA       d      apparent RA (radians)
*     DA       d      apparent Dec (radians)
*     DATE     d      TDB for apparent place (JD-2400000.5)
*     EQ       d      equinox:  Julian epoch of mean place
*
*  Returned:
*     RM       d      mean RA (radians)
*     DM       d      mean Dec (radians)
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Notes:
*
*  1)  The distinction between the required TDB and TT is always
*      negligible.  Moreover, for all but the most critical
*      applications UTC is adequate.
*
*  2)  Iterative techniques are used for the aberration and light
*      deflection corrections so that the routines sla_AMP (or
*      sla_AMPQK) and sla_MAP (or sla_MAPQK) are accurate inverses;
*      even at the edge of the Sun's disc the discrepancy is only
*      about 1 nanoarcsecond.
*
*  3)  Where multiple apparent places are to be converted to mean
*      places, for a fixed date and equinox, it is more efficient to
*      use the sla_MAPPA routine to compute the required parameters
*      once, followed by one call to sla_AMPQK per star.
*
*  4)  The accuracy is sub-milliarcsecond, limited by the
*      precession-nutation model (IAU 1976 precession, Shirai &
*      Fukushima 2001 forced nutation and precession corrections).
*
*  5)  The accuracy is further limited by the routine sla_EVP, called
*      by sla_MAPPA, which computes the Earth position and velocity
*      using the methods of Stumpff.  The maximum error is about
*      0.3 mas.
*
*  Called:  sla_MAPPA, sla_AMPQK
*
*  P.T.Wallace   Starlink   17 September 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION RA,DA,DATE,EQ,RM,DM

      DOUBLE PRECISION AMPRMS(21)



      CALL sla_MAPPA(EQ,DATE,AMPRMS)
      CALL sla_AMPQK(RA,DA,AMPRMS,RM,DM)

      END

      SUBROUTINE BBCGEO( KS )
C
C     Routine for SCHED, called by SETBBC, that sets the BBC
C     assignments for VLBA systems with geodetic wiring.  For these
C     systems (from Ed Himwich email of 20 Oct 1997):
C     BBCs                  IFs
C     1,2                   A,B,C,D
C     3,4,5,6,7,8           A,C
C     9,10,11,12,13,14      B,D
C
C     "I believe all VLBA racks outside the VLBA itself 
C     (and the pseudo-VLBA stations: Green Bank 140', Effelsberg, 
C     and VLA?) have this wiring. (Hmmm, how about SEST?)".
C
C     The code needed, once the arrays are established, is the same
C     as for BBCM4 (Mark IV), so it has been put in BBCALT, which
C     is shared.
C
C     There is an additional complication.  There are not enough
C     sampler inputs to send 2 bit signals from more than 8 BBCs
C     to the formatter.  For now (1997+-) someone changes a plug
C     for two options.  The first is 2 bit on 8 BBCs.  The second
C     is one bit on all BBCs.  Deal with this by sensing 2 bit
C     observations and restricting the number of BBC's to 8.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    I, KS
      INTEGER    MAXBBC, MAXIF, NNBBC
      PARAMETER  (MAXBBC=14)
      PARAMETER  (MAXIF=4)
      INTEGER    IFBBC(MAXBBC,MAXIF)
      CHARACTER  IFNAM(MAXIF)*2, WARNING*4
      LOGICAL    UBBC(MAXBBC)
      DATA  (IFBBC(I,1),I=1,MAXBBC) / 1,1,1,1,1,1,1,1,0,0,0,0,0,0 /
      DATA  (IFBBC(I,2),I=1,MAXBBC) / 1,1,0,0,0,0,0,0,1,1,1,1,1,1 /
      DATA  (IFBBC(I,3),I=1,MAXBBC) / 1,1,1,1,1,1,1,1,0,0,0,0,0,0 /
      DATA  (IFBBC(I,4),I=1,MAXBBC) / 1,1,0,0,0,0,0,0,1,1,1,1,1,1 /
      DATA  (IFNAM(I),I=1,MAXIF) / 'A', 'B', 'C', 'D' /
C
C     Note that the above data statement is also in CHKGDAR.  Changes
C     should be made in both places.
C -------------------------------------------------------------------  
C     Software check:
C
      IF( NBBC(ISETSTA(KS)) .GT. MAXBBC ) THEN
         WRITE( MSGTXT, '( 3A, I4 )' )
     1       'BBCGEO: Number of BBCs at ', SETSTA(1,KS), 
     2       ' Larger than maximum expected: ', MAXBBC 
         CALL WLOG( 1, MSGTXT )
         CALL WLOG( 1, '   Catalog or programming problem ' )
         CALL ERRSET( KS )
      END IF
C
C     Set the maximum number of BBC's based on the number of bits.
C
      IF( BITS(1,KS) .EQ. 2 .AND. NCHAN(KS) .GT. 8 ) THEN
         NNBBC = MIN( NBBC(ISETSTA(KS)), 8 )
         WARNING = 'GEO2'
      ELSE
         NNBBC = NBBC(ISETSTA(KS))
         WARNING = 'GEO1'
      END IF
C
C     Call BBCALT to do the work.
C
      CALL BBCALT( KS, MAXBBC, MAXIF, IFBBC, IFNAM, UBBC, NNBBC,
     1             WARNING, 'BBCGEO' )
C
      RETURN 
      END

      SUBROUTINE VXUNQL( NXX, XXLINK )
C
C     Checks whether the Name has no illegal chars
C     and whether it is unique, else makes it unique
C     we reserve the #I2 at the end of the string to make things
C     unique
C     By H.J. van Langevelde, JIVE, 300496 
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C      
      CHARACTER XXLINK(MAXMOD)*32, NAMORI*32
      INTEGER NXX, LEN1, LPOS, I, SEQPOS, SEQNO
      LOGICAL CHRFND, CHANGED
C ----------------------------------------------------------------------
      IF( DEBUG ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I5, 2X, A )' ) 'VXUNQL: Starting ', 
     1        NXX, XXLINK(NXX)
         CALL WLOG( 1, MSGTXT )
      END IF
C
      CHANGED = .FALSE.
      NAMORI = XXLINK(NXX)
      CALL VXSTNM( XXLINK(NXX), .TRUE. )
C
C     Check if name is unique in this def block
C
      IF( NXX .GT. 1 ) THEN
         DO I = 1, NXX-1
            IF( XXLINK(NXX) .EQ. XXLINK(I) ) THEN
C
C           it's not unique, find out if it has a #seq number
C               
               CHRFND = .FALSE.
               DO LPOS = 1, 32
                  IF( XXLINK(NXX)(LPOS:LPOS) .EQ. '#' ) THEN
                     CHRFND = .TRUE.
                     SEQPOS = LPOS
                  END IF
               END DO
C
C              if it does, increment
C
               IF( CHRFND ) THEN
                  READ( XXLINK(NXX)(SEQPOS+1:SEQPOS+2), 
     1                 '( I2 )' ) SEQNO
C
C                 by adding 1
C
                  IF( SEQNO .LT. 99 ) THEN
                     WRITE( XXLINK(NXX)(SEQPOS+1:SEQPOS+2), 
     1                   '( I2.2 )' ) SEQNO+1
                     CHANGED = .TRUE.
                  ELSE
                     CALL ERRLOG( 'VXUNQL: Passed 99 sequence numbers' )
                  END IF
               ELSE
C
C                 plain name so simply add #02
C                  
                  SEQPOS = LEN1( XXLINK(NXX))+1
                  IF( SEQPOS .LE. 29 ) THEN
                     WRITE( XXLINK(NXX)(SEQPOS:SEQPOS+2), 
     1                    '( A1, I2.2 )' ) '#', 2
                     CHANGED = .TRUE.                  
                  END IF
               END IF
            END IF
C
C        continue loop, name just invented may actually exist already
C
         END DO
      END IF
C
C     now write out a message if we did anything, in Debug mode only 
C
      IF( CHANGED .AND. DEBUG ) THEN
         WRITE( MSGTXT , '( A, A )' )
     1        'VXUNQL: Changed VEX def: ', NAMORI(1:LEN1(NAMORI))
         CALL WLOG( 1, MSGTXT )
         WRITE( MSGTXT , '( A, A )' )
     1        'VXUNQL:              to: ', 
     2        XXLINK(NXX)(1:LEN1(XXLINK(NXX)))
         CALL WLOG( 1, MSGTXT )
      ENDIF
C         
      RETURN
      END

      SUBROUTINE CHKDBBC( KS, ERRS )
C
C     Routine for SCHED called by CHKSET that checks items related
C     to the use of the DBBC digital backend.  This is adapted from,
C     and very similar to CHKRDBE.
C
C     I'm going to need help from Europe because I can't find all
C     the specs for the DBBC.
C
C     The frequency and bandwidth checks are broken out to a 
C     subroutine (CHKDBFQ) so that it can also be called by FSFREQ
C     to check in-schedule changes of frequency and bandwidth.
C
C     The RDBE PFB personality can only do lower sideband.  But
C     DiFX can invert sidebands.  So, if an upper sideband is
C     found, add the bandwidth to the BBC frequency and invert
C     the sideband.  Oct 11, 2011.
C
C     Add the dual RDBE case.  Nov. 8, 2012  RCW.
C
C     Adapted from CHKRDBE.  Jan 20, 2013.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
      INCLUDE  'schfreq.inc'
C
      INTEGER     KS, ICH, JCH, IIF, MIF, NIF, KSTA, NNIF(4), I, IBBC
      INTEGER     MAXBBC, MAXIF, IC, LEN1
      PARAMETER   (MAXBBC=16, MAXIF=4)
      LOGICAL     ERRS, SBWARN, IFNEW, OK, SOMEBAD
C     Can have up to 4 IFs but actual number depends on DBBCVER
      INTEGER     IFBBC(MAXBBC,4)
      CHARACTER   USEDIFC(4)*2, MYDBBCVER*8
      CHARACTER   IFNAM(4)*2
      DATA        SBWARN / .TRUE. /
      SAVE        SBWARN
      DATA        (IFNAM(I),I=1,MAXIF) / 'A', 'B', 'C', 'D' /
C Note that IFNAM is also defined in BBCDBBC (should match!)
C MAXIF is the maximum possible number of IFs (4), MIF is the actual
C number of IFs in this version of the DBBC (which we figure out later)
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKDBBC: Starting' )
C
C     ---------
C     Need to do something about the solar attenuators similar to 
C     the IFDIST entry for the VLBA DAR.
C     ---------
C
C     Get the station catalog number for the station.
C
      KSTA = ISETSTA(KS)
C
C     All constraints (including the number of IFs) depend on the
C     personality (DDC or PFB) and the DBBCVER (astro, geo or hybrid).
C     IFDBBC knows the rules...
      MYDBBCVER = DBBCVER(KSTA)
      CALL IFDBBC( MYDBBCVER, MAXBBC, 4, IFBBC, MIF )
C
C
      IF( VLBITP .AND. FORMAT(KS) .NE. 'NONE' ) THEN 
C
C        Make sure there are no more than the available number of
C        IFs requested.  Get a count of IFs and number of channels 
C        per IF for later use.
C
         DO IIF = 1, 4
            USEDIFC(IIF) = ' '
            NNIF(IIF) = 0
         END DO
         NIF = 0
C
         DO ICH = 1, NCHAN(KS)
C
C           See if this channel's IF is one that is in lower 
C           numbered channels.
C
            IFNEW = .TRUE.
            IF( NIF .GE. 1 ) THEN
               DO IIF = 1, NIF
                  IF( IFCHAN(ICH,KS) .EQ. USEDIFC(IIF) ) THEN
                     IFNEW = .FALSE.
                     NNIF(IIF) = NNIF(IIF) + 1
                  END IF
               END DO
            END IF
C
C           If it is new, increment the count and add the IF to
C           the record of previously used ones.  Complain and die
C           if there are too many.
C           
            IF( IFNEW ) THEN
               NIF = NIF + 1
               IF( NIF .GT. MIF ) THEN
C
C                 Here we have a problem - too many IFs.
C
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, I2, 2A )' )
     1               'CHKDBBC: More than ', MIF, ' IF''s requested ',
     2                    'for a DBBC station.'
                  CALL WLOG( 1, MSGTXT )
                  ERRS = .TRUE.
               END IF
               NNIF(NIF) = 1
               USEDIFC(NIF) = IFCHAN(ICH,KS)
            END IF
         END DO
C
C        Check the DBBC_PFB personality.
C        CR: The PFB code here is based on the RDBE code, with some
C        modifications based on a brief message from Gino Tuccari. 
C        This should be used with great caution...
C
         IF( DBE(KS) .EQ. 'DBBC_PFB' ) THEN
            IF( .NOT. MODETEST(KS) ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, A, A )' )
     1            'CHKDBBC: You have specified DBE=DBBC_PFB ',
     2            'The PFB mode is not yet supported in the DBBC. ',
     3            'This schedule will probably fail. ',
     4            'Specify MODETEST if you are testing.'
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
C
C           NCHAN must be 16 (in initial version).
C
            IF( NCHAN(KS) .NE. 16 ) THEN
               MSGTXT = ' '              
               WRITE( MSGTXT, '( A, A, I4 )' )
     1           'CHKDBBC: For DBE=DBBC_PFB, NCHAN must be 16.', 
     2           ' Setup specified: ', NCHAN(KS)
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
C
C           Sample rate must be 64 Msamp/sec. A future firmware upgrade
C           will allow 2048 Mbps recording with 64 MHz baseband channels
C           (128 Msamp/sec).
C
            IF( SAMPRATE(KS) .NE. 64.0 ) THEN
               MSGTXT = ' '              
               WRITE( MSGTXT, '( A, F8.3, A )' )
     1           'CHKDBBC: Invalid SAMPRATE specified: ', SAMPRATE(KS),
     2           ' for DBE=DBBC_PFB. Must be 64.0 Msamp/s.'
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
C
C           Bits per sample must be 2 or 1.
C
            DO ICH = 1, NCHAN(KS)
               IF( BITS(ICH,KS) .NE. 2 .AND.  BITS(ICH,KS) .NE. 1 ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A, I3 )' )
     1               'CHKDBBC: BITS must be 2 for DBE=DBBC_PFB. ',
     2               '  Value specified is: ', BITS(ICH,KS)
                  CALL WLOG( 1, MSGTXT )
                  ERRS = .TRUE.
               END IF
            END DO
C
C           Basebands are either all LSB or all USB (depending on the
C           Nyquist zone to be used). 1st Nyq is USB, 2nd LSB, 3rd USB,
C           4th LSB.
C
            DO ICH = 1, NCHAN(KS) - 1
               DO JCH = 2, NCHAN(KS)
                  IF( SIDEBD(ICH,KS) .NE. SIDEBD(JCH,KS) ) THEN
                     IF( SBWARN ) THEN
                        MSGTXT = ' '
                        WRITE( MSGTXT, '( A, A )' )
     1                     'CHKDBBC: SIDEBAND must be the same for ',
     2                     'all channels if  DBE=DBBC_PFB. '
                        CALL WLOG( 1, MSGTXT )
                        ERRS = .TRUE.
                        SBWARN = .FALSE.
                     END IF
                  END IF
               END DO
            END DO
C
C           Bandwidths and frequencies will be checked in CHKDBFQ.
C
C     ***********************      Still to be checked - IF, POL.
C
         END IF
C
C        ===  Now check the DDC personality. ===
C
         IF( DBE(KS) .EQ. 'DBBC_DDC' ) THEN
C
C
C
C           Sample rate can have many values.
C           These may need to shift down by 1 if we do complex
C           sampling.
C           Current version of DBBC only allows 1-32 MHz channels and
C           Nyquist sampling.
C
            IF( SAMPRATE(KS) .NE. 64.0 .AND.
     1          SAMPRATE(KS) .NE. 32.0 .AND.
     2          SAMPRATE(KS) .NE. 16.0 .AND.
     3          SAMPRATE(KS) .NE. 8.0 .AND.
     4          SAMPRATE(KS) .NE. 4.0 .AND.
     5          SAMPRATE(KS) .NE. 2.0 ) THEN
               MSGTXT = ' '              
               WRITE( MSGTXT, '( A, F8.3, A )' )
     1           'CHKDBBC: Invalid SAMPRATE specified: ', SAMPRATE(KS),
     2           ' for DBE=DBBC_DDC. Must be 2 to 64 Msamp/s.'
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
C
C           Bits per sample is 2, but 1 bit recording is
C           possible via channel selection. 
C
            DO ICH = 1, NCHAN(KS)
               IF( BITS(ICH,KS) .NE. 2 .AND. BITS(ICH,KS) .NE. 1) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A, I3 )' )
     1               'CHKDBBC: BITS must be 2 or 1 for DBE=DBBC_DDC. ',
     2               '  Value specified is: ', BITS(ICH,KS)
                  CALL WLOG( 1, MSGTXT )
                  ERRS = .TRUE.
               END IF
            END DO
C
C  ******************  There are some "interesting" ifchan assignment
C            restrictions for the DBBC_DDC.  They are DBBCVER dependent.
C            IFDBBC knows the rules and set IFBBC above.
C
            DO ICH = 1, NCHAN(KS)
C              IFs are in range A-D, inputs in range 1-4. You may omit the
C              input number, but it's not encouraged.
               IF( ( IFCHAN(ICH,KS)(1:1) .NE. 'A' .AND.
     1               IFCHAN(ICH,KS)(1:1) .NE. 'B' .AND.
     2               IFCHAN(ICH,KS)(1:1) .NE. 'C' .AND.
     3               IFCHAN(ICH,KS)(1:1) .NE. 'D' )  .OR.
     4             ( IFCHAN(ICH,KS)(2:2) .NE. '1' .AND.
     5               IFCHAN(ICH,KS)(2:2) .NE. '2' .AND.
     6               IFCHAN(ICH,KS)(2:2) .NE. '3' .AND.
     7               IFCHAN(ICH,KS)(2:2) .NE. '4' .AND.
     8               IFCHAN(ICH,KS)(2:2) .NE. ' ' )) THEN
                  CALL WLOG ( 1, 'CHKDBBC: IFCHAN ''' // IFCHAN(ICH,KS)
     1              // ''' not A[1-4], B[1-4], C[1-4] or D[1-4]' )
                  ERRS = .TRUE.
               END IF
C
            END DO
C
C
C           Loop through the channels checking IF assignments.
C
            SOMEBAD = .FALSE.
            DO ICH = 1, NCHAN(KS)
C
C              See if this channel uses an allowed IF given the wiring
C              constraints embodied in the IFBBC array. Only the IF name can
C              be enforced, the input number is known only to the catalogue.
C              Omitting the input number is not an error, but will require
C              remedial action at the station after running drudg.
C
               OK = .FALSE.
               IBBC = BBC(ICH,KS)
               DO IIF = 1, MAXIF
                  IF( IFNAM(IIF) .EQ. IFCHAN(ICH,KS)(1:1) .AND.
     1                IFBBC(IBBC,IIF) .EQ. 1 ) OK = .TRUE.
               END DO
C
C              Give warnings if it was not allowed.
C
               IF( .NOT. OK ) THEN
                  SOMEBAD = .TRUE.
                  SETMSG = ' '
                  WRITE( SETMSG, '( 3A, I3, A, I3 )' )
     1                'CHKDBBC: Illegal IF input ', IFCHAN(ICH,KS),
     2                ' for DBBC, channel ', ICH, '  BBC ', IBBC
                  CALL WLOG( 1, SETMSG )
                  SETMSG = ' '
                  WRITE( SETMSG, '( 2A )' )
     1              '         Allowed IF index and first character',
     2              ' for this BBC are:'
                  IC = LEN1( SETMSG ) + 1
                  DO IIF = 1, MAXIF
                     IF( IFBBC(IBBC,IIF) .EQ. 1 ) THEN
                        WRITE( SETMSG(IC:IC+5), '( 1X, A1, I1, 3A1 )' )
     1                        '(', IIF, ',', IFNAM(IIF), ')'
                        IC = IC + 6
                     END IF
                  END DO
                  CALL WLOG( 1, SETMSG )
                  ERRS = .TRUE.
               END IF
C
            END DO
            IF( SOMEBAD ) THEN
               SETMSG = ' '
               WRITE( SETMSG, '( 2A )' )
     1             '        Be careful of special wiring restrictions ',
     2             'for these DARs.'
               CALL WLOG( 1, SETMSG )
            END IF
         END IF
C
C           Bandwidths and frequencies checked in CHKDBFQ
C
C        Check the frequencies and bandwidths.  This is pulled out
C        so that it can be used again later on frequencies set in-line
C        or using Doppler.
C
         CALL CHKDBFQ( KS, BBFILT(1,KS), BBSYN(1,KS), ERRS, .TRUE. )
C
      END IF
C
      RETURN
      END

      SUBROUTINE CHKJIVE
C
C     Routine for SCHED that checks some basic JIVE 
C     correlator restrictions.
C
      INCLUDE     'sched.inc'
      INCLUDE     'schset.inc'
C
      INTEGER        KS, ROLLERR, HD2ERR, SPUPERR
      INTEGER        VXNHDS, SAMPERR, ICH
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'CHKJIVE: starting.' )
C
C     First, only do this if the experiment is to be processed
C     on the JIVE correlator.
C
      IF( CORREL .EQ. 'JIVE' ) THEN
C
C        The philosophy is to block off all possibilities that
C        will not be available, even if the comissioning phase
C        is complete. During the comissioning several items
C        may be un-available at time, but this is considered
C        a transition phase, on a shorter timescale than typical
C        Sched releases. The comissioning phase of the JIVE correlator
C        is supposed to end in June 1999.
C
C        The following items are expected to be unsupported:
C
         ROLLERR = 0
         DO KS = 1, NSET
            IF (.NOT. MODETEST(KS) ) THEN
C
               IF( BARREL(KS) .NE. 'roll_off' ) THEN
                  ROLLERR = KS
               END IF
            END IF            
         END DO
C
C        Write the error messages.
C
         IF( ROLLERR .NE. 0 ) THEN
            CALL WLOG( 1, 'CHKJIVE:  JIVE Correlator does '//
     1           'not do barrel rolling. Please set barrel="roll_off"' )
            CALL WRTMSG( 0, 'CHKJIVE', 'barrelroll')
            CALL ERRSET( ROLLERR )
         END IF
C
C        Stop two head recording
C
         HD2ERR = 0
         DO KS = 1, NSET
            IF (.NOT. MODETEST(KS) ) THEN
C
               IF( VXNHDS( KS ) .GT. 1 ) THEN
                  HD2ERR = KS
               END IF
            END IF
         ENDDO
C
C        Write the error messages.
C
C         IF( HD2ERR .NE. 0 ) THEN
C            CALL PUTOUT( 'CHKJIVE: JIVE Correlator is not '//
C     1           'expected to deal with 512 MB/s data ' )
C            CALL PUTOUT( '         until the middle of 2001 ')
C            CALL PUTOUT( '         or testers set MODETEST ')
C            CALL SETERR( HD2ERR )
C         END IF
C
C        Also Stop 40 ips and 66 ips recordings
C
         SPUPERR = 0
         DO KS = 1, NSET
            IF (.NOT. MODETEST(KS) ) THEN
C
               IF( SAMPRATE(KS)/FANOUT(KS) .LE. 2.01 ) THEN
                  SPUPERR = KS
               END IF
            END IF            
         END DO
C
C        Write the error messages.
C
         IF( SPUPERR .NE. 0 ) THEN
            CALL WLOG( 1, 'CHKJIVE:  JIVE Correlator does not '//
     1          'currently do speed-up correlation (Oct 2004)' )
            CALL WLOG( 1, '         or testers set MODETEST ')
            CALL WRTMSG( 0, 'CHKJIVE', 'slowdatarate')
            CALL ERRSET( SPUPERR )
         END IF
C
C        Prevent oversampling of 8 (or more)
C
         SAMPERR = 0
         DO KS = 1, NSET
           IF ( .NOT. MODETEST(KS) ) THEN
             DO ICH = 1, NCHAN(KS)
               IF( SAMPRATE(KS) .GT. 8.0*BBFILT(ICH,KS) ) THEN
                 SAMPERR = KS
               END IF
             END DO
           END IF
         END DO
C
C        Write the error messages.
C
         IF( SAMPERR .NE. 0 ) THEN
            CALL WLOG( 1, 'CHKJIVE:  JIVE Correlator has a '//
     1          'maximum oversampling factor of 4. ' )
            CALL WLOG( 1, 'This is exceeded in setup ' // 
     1                  SETNAME(SAMPERR) )
            CALL WLOG( 1, '         Testers *only* may set MODETEST ')
            CALL WRTMSG( 0, 'CHKJIVE', 'oversamp')
            CALL ERRSET( SAMPERR )
         END IF




      END IF
C
      RETURN
      END

      SUBROUTINE BBCKVSR( KS )
C
C
C     Routine for Sched called by SETBBC that assigns video converters
C     for Zelenchk system.
C
      INCLUDE    'sched.inc'
      INCLUDE    'schset.inc'
C
      INTEGER    I, KS, NNBBC
      INTEGER    MAXBBC, MAXIF, NIF
      PARAMETER  (MAXBBC=16)
      PARAMETER  (MAXIF=4)
      INTEGER    IFBBC(MAXBBC,MAXIF)
      CHARACTER  IFNAM(MAXIF)*2
      LOGICAL    UBBC(MAXBBC)
      DATA  (IFBBC(I,1),I=1,MAXBBC) / 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0 /
      DATA  (IFBBC(I,2),I=1,MAXBBC) / 0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1 /
      DATA  (IFBBC(I,3),I=1,MAXBBC) / 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0 /
      DATA  (IFBBC(I,4),I=1,MAXBBC) / 0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1 /
      DATA  (IFNAM(I),I=1,MAXIF) / 'A', 'B', 'C', 'D' /
c$$$      DATA (IFCH(I),I=1,16)  / 'A','B','A','B','A','B','A','B', 
c$$$     1 'A','B','A','B','C','D','C','D' /
c$$$      DATA (BBCS(I),I=1,16) / 1,  9,  1,  9,  2, 10,  2, 10,  
c$$$     1 3, 11,  3, 11,  4, 12,  4, 12 /


C -------------------------------------------------------------------  
C     Software check:
C
      IF( NBBC(ISETSTA(KS)) .GT. MAXBBC ) THEN
         WRITE( MSGTXT, '( 3A, I4 )' )
     1       'BBCM4: Number of VCs at ', SETSTA(1,KS), 
     2       ' Larger than maximum expected: ', MAXBBC
         CALL WLOG( 1, MSGTXT )
         CALL WLOG( 1, '   Catalog or programming problem ' )
         CALL ERRSET( KS )
      END IF
C
      NNBBC = NBBC(ISETSTA(KS))
      NIF = 4
C
C     Call BBCALT to do the work.
C
      CALL BBCALT( KS, MAXBBC, NIF, IFBBC, IFNAM, UBBC, NNBBC, ' ',
     1    'BBCKVSR' )
C
      RETURN 
      END

      SUBROUTINE VXSCNS
C
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 130596 
C     Major overhaul to accomodate simplifications
C     in registering freq and pcal changes Huib 210599
C
C     This is the routine that sorts out the main hurdle in 
C     SCHED -> VEX: The fact that FREQ and PCAL can be changed
C     in the schedule section, but require a global $MODE change
C     in VEX. In addition most FREQ changes, imply changes in 
C     PHASE_CAL and sometimes vice versa. 
C     Routine sets up the array MODSCN in VXLINK.INC
C     And calls for the creation of new modes: VXTRAMD
C
C     Dec 2011 RCW:  Configure FORMAT=NONE setups along with
C     the rest.  The VLBA now needs them and they can be ignored
C     when not used at other stations.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'vxlink.inc'
C
      INTEGER OLDSCN, FRSTSCN
C      INTEGER VXMDIFP(MFSET,MPSET)    PSETI also no longer declared.
      INTEGER VXMDIFP(MFSET)
      INTEGER ISCN, ISETFL, IMODE, I, IFS, LEN1, NC
C From commented code:     INTEGER JSCN, RECSCN, ISET, VXGTST, J
      INTEGER ISTA, NMDORI
      CHARACTER CALSET*4, CALSCN*4
      LOGICAL SKIPPED
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'VXSCNS: Starting.' )
C
C     Loop through scans
C
      NMDORI = NMDVEX
      OLDSCN = 0
C
C RCW  VXMDIFP is the VEX mode that included a given frequency set 
C      and polarization set.  Note a mode can also include other sets
C      for other stations.
C CR 050106: initialise VXMDIFP
C
      DO I = 1, MFSET
C        DO J = 1, MPSET    Removing pcal sets.
C          VXMDIFP(I,J) = 0
C        END DO

         VXMDIFP(I) = 0
      END DO
C
C     Loop through the scans looking for the need for new modes.
C
      DO ISCN = SCAN1, SCANL
C
C        Don't do much if this scan is skipped (like if all antennas
C        are down).  SKIPPED tested below along with FORMAT.
C
         SKIPPED = .TRUE.
         DO ISTA = 1, NSTA
            IF( STASCN(ISCN,ISTA) ) SKIPPED = .FALSE.
         END DO
         IF( .NOT. SKIPPED ) THEN
C
C           First default IMODE to old mode which equals a setup file
C		 
C           RCW notes to aid debugging Oct 15, 2011:  
C           NMDORI set above to NMDVEX, the number of vex modes defined
C           so far.
C           MDISFIL is set in VXMODE.  Basically it is set to the setup 
C           file number, but skipping any that are not used.
C           So the following just gets the default VEX mode for the scan.
C		 
            ISETFL = SETNUM(ISCN)
            IMODE = -1
            DO I = 1, NMDORI
               IF( MDISFIL(I) .EQ. ISETFL ) IMODE = I
            END DO
C		 
C           Abort if this is not a mode.  This was a rather mysterious 
C           error message when encountered, but it tended to mean that
C           all scans using a setup file were skipped.  Added more 
C           informative messages.  Also don't do the test for skipped
C           scans.   Dec 12, 2012  RCW
C           
            IF( IMODE .LT. 0 ) THEN
               CALL WLOG(1, 'VXSCNS: Unexpected Mode'//
     1              ' encountered ')
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, 3I5 )' ) '  Problem in scan:',
     1             ISCN
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               NC = LEN1(SETFILE(SETNUM(ISCN)))
               WRITE( MSGTXT, '( A, A, A )' ) 
     1             ' Were all scans using setup file ',  
     2             SETFILE(SETNUM(ISCN))(1:NC), ' skipped?'
               CALL ERRLOG( 'VXSCNS: Fix setups' )
            END IF
C		 
C           Make a pointer from the scan to the VEX mode.
C		 
            MODSCN(ISCN) = IMODE
C		 
C ---------------------------------------------------
C           RCW:  The following test for FORMAT=NONE was deactivated in 
C           Dec 2011 so modes would be defined in all cases.  
C           The code was left here for reference.
C		 
C           If this Mode uses FORMAT=NONE, then  do nothing more here. This
C           mode can later be replaced with the mode of the previous 
C           recording scan, or can simply be skipped when writing the
C           scans.  Don't do this for single dish VLBA observing for which
C           OBSTYPE='PTVLBA'
C		 
C           To check the FORMAT, a SCHED setup file is needed.  
C           VXGTXT is a function that returns one of possibly several setups
C           used by the mode.  That means that it would be dangerous to mix
C           format = 'none' with other formats at other stations in the 
C           same scan.  I doubt that is done (RCW  Oct 15, 2011).
C		 
C            ISET = VXGTST( IMODE )
C            IF( .NOT. SKIPPED .AND. ( FORMAT(ISET)(1:4) .NE. 'NONE' .OR.
C     1          OBSTYP .EQ. 'PTVLBA' ) ) THEN
C  -------------------------------------------------------
C
C          The VEX modes are the same across antennas in a scan, but some
C          antennas may join later, so find the first scan for which the
C          current (scan) mode will be used.  That involves looking at
C          through the stations for the first scan (FSETSCN) in which the
C          current frequency set was used, then taking the minimum of
C          those.  FRSTSCN will be that first scan.  IFS will
C          be one of the frequency sets used in that first
C          scan for the mode.  This also used to deal with pcal sets,
C          but pcal sets have been absorbed into frequency sets and
C          no longer exist as separate items (Sept. 2013 RCW).
C
           FRSTSCN = MAXSCN + 1
C              IPS = 0
           IFS = 0
           DO ISTA = 1, NSTA
              IF( STASCN(ISCN,ISTA) ) THEN
                 IF (FSETSCN(FSETI(ISCN,ISTA)).LT.FRSTSCN) THEN
                    IFS = FSETI(ISCN,ISTA)
                    FRSTSCN = FSETSCN(IFS)
C
C                   bug fix CR 20051114: make sure ips and ifs get set
C                   to values from the same antenna
C                    IPS = PSETI(ISCN,ISTA)
C
                 END IF
                 IF (IFS.GT.MFSET) THEN
                    CALL ERRLOG('VXSCNS: Too many frequency'//
     1                  ' mode changes ')
                    STOP
                 END IF
C
C                I can only assume this was a leftover Huib v75
C
C                 IF (IPS .NE. PSETI(ISCN,ISTA)) THEN
C                    WRITE( MSGTXT, '( A, A, I5 )' ) 'Problem with ',
C     1                  'PCAL in scan ',ISCN
C                    CALL WLOG( 1, MSGTXT )
C                    CALL PRTSCN( ISCN, 'VXSCNS' )
C                    CALL ERRLOG('VXSCNS: All telescopes should '//
C     .                  'use similar PCal setup ')
C                    STOP
C                 END IF
              ENDIF
           END DO
C
C          In case no station is recording this could have 
C          resulted in IFS=0.
C
C             IF( IPS .EQ. 0 ) IPS = 1
           IF( IFS .EQ. 0 ) THEN
              IFS = 1
              FRSTSCN = FSETSCN(IFS)
           END IF
C
C          Account for the telescopes that came in for first time
C          after others.  This only does anything if VXMDIFP has been
C          set, which will it will not be by here on SCAN1, or on 
C          FRSTSCN.  The IF passes the first scan for the late arriving
C          station that uses the current frequency set.  It doesn't seem
C          to worry about pcal.  It sets the station dependent MODSET
C          (the base setup group for the station/scan) to the value for 
C          this scan and sets VXMDIFP for this scan (set earlier)
C          and station dependent frequency set/pcal set combination to
C          the value used for other stations, which are set when the
C          new mode is created.
C
           DO ISTA = 1, NSTA
              IF( STASCN(ISCN,ISTA) ) THEN  
                 IF (VXMDIFP(IFS) .GT. 0 .AND. 
     .               FSETSCN(FSETI(ISCN,ISTA)).NE.FRSTSCN .AND. 
     .               FSETSCN(FSETI(ISCN,ISTA)).EQ.ISCN ) THEN
                    IF( DEBUG ) THEN
                       MSGTXT = ' '
                       WRITE( MSGTXT, '( A, A, A, I3 )' ) 
     .                     'VXSCNS: Telescope: ', STANAME(ISTA),
     .                     ' joins mode set in scan: ', 
     .                     FSETSCN(FSETI(ISCN,ISTA))
                       CALL WLOG( 1, MSGTXT )
                    END IF
                    MODSET(ISTA,VXMDIFP(IFS)) = MODSET(ISTA,IMODE)
C
C                   set VXMDIFP and MODSET for the new station's IFS and IPS
C                   (bug fix, CR 20051005).
C
C                    VXMDIFP(FSETI(ISCN,ISTA), PSETI(ISCN,ISTA)) =
C     1                          VXMDIFP(IFS,IPS)
                    VXMDIFP(FSETI(ISCN,ISTA)) = VXMDIFP(IFS)
C
                 END IF
              END IF
           END DO
C
C          Deal with a totally new mode.  This is the main point of this
C          routine.  Remember IFS is set for one good value, but
C          it is for just one of the stations.  A problem is that IFS
C          could be for the first scan unmodified or could be 
C          modified by DOPPLER, FREQ, BW etc...
C          Now get the pcal info from the frequency set (Sep 2013  RCW).
C
           IF( VXMDIFP(IFS) .EQ. 0 ) THEN
C
              CALSET = SPCAL(FSETKS(IFS))
              CALSCN = FSPCAL(IFS)
              CALL UPCASE(CALSET)
              CALL UPCASE(CALSCN)
              IF( DEBUG ) THEN
                 MSGTXT = ' '
                 WRITE( MSGTXT, '( A, I3 )' )
     .               'VXSCNS: Unused or new mode in scan ',ISCN
                 CALL WLOG( 1, MSGTXT )
              END IF
C
C             Look for the case when FREQ, BW, and PCAL are not changed
C             with main scan inputs (the setup values are used).
C
              IF( FREQ(1,FRSTSCN).LT.1E-6 .AND. 
     .            BW(1,FRSTSCN).LT.1E-6 .AND. 
     .            CALSET .EQ. CALSCN ) 
     .            THEN
C     
C                This case does not involve FREQ or BW so it is the
C                original mode for the setup.
C                Must set all other telescopes too
C                A station that uses this mode that comes in
C                late might not got VXMDIFP assigned here, but it
C                will be assigned above in the late arrivals section.
C
                 DO ISTA = 1, NSTA
                    IF( STASCN(ISCN,ISTA) ) THEN
C     
                       VXMDIFP(FSETI(ISCN,ISTA)) = IMODE
                    END IF
                 END DO
              ELSE
C
C                This is not the original mode, or at least one of 
C                FREQ (perhaps via Doppler), BW, and PCAL were set.
C                So a new mode is needed.  Call VXTRAMD to do the work.
C
                 CALL VXTRAMD(IMODE,IFS)
                 FRSTSCN = ISCN
                 MODSCN(ISCN) = NMDVEX
C
C                Must set all other telescopes too
C
                 DO ISTA = 1, NSTA
                    IF( STASCN(ISCN,ISTA) ) THEN
C     
                     VXMDIFP(FSETI(ISCN,ISTA)) = NMDVEX
                    END IF
                 END DO
C
C                Set the setup group for each station in the new mode to 
C                be the same as it currently is.  This serves to transfer
C                most setup file parameters to the new mode when a FREQ
C                or BW requires a new mode
C
                 DO ISTA = 1, NSTA  
                    IF( STASCN(ISCN,ISTA) ) THEN
                       MODSET(ISTA,NMDVEX) = MODSET(ISTA,IMODE)
                    END IF
                 END DO
              END IF
C
           END IF
C
C          Any Mode switch.  RCW Oct 15, 2011.  I don't think this IF
C          statement accomplishes anything because it only sets OLDSCN
C          and OLDIPS (since removed), which are not used anywhere.  
C          Is this left over from some previous effort?  In any case, 
C          it's harmless.
C
           IF (FRSTSCN.NE.OLDSCN ) THEN
              IF( FSETSCN(IFS) .NE. OLDSCN ) THEN 
                 OLDSCN = FSETSCN(IFS)
              END IF
           END IF
C
C          Set the pointer to the mode for this scan.
C
           MODSCN(ISCN) = VXMDIFP(IFS)
         END IF
C
C        end loop all scans
C
      END DO
C
C
C     CR 050818: The logic below works if you want the FORMAT=NONE scans
C       to appear in the VEX file as non-recording scans, using the mode from
C       another scan. However, at the current time FS stations would
C       prefer that there were simply gaps in the schedule so they can
C       use their own pointing procedures. So leave this section of code
C       commented out for now and in VXSCH, the FORMAT=NONE scans can be
C       skipped.
C     RCW Nov 2011.  For VLBA pointing, also do not want to replace the mode
C     even though format is NONE as the mode will be important for setting 
C     up the telescope switches.
C
C     Now loop through the scans again and replace the MODSCN for any with 
C     FORMAT=NONE (not processed first time) with the MODSCAN from a recording 
C     scan.
C
C      DO ISCN = SCAN1, SCANL
C         ISET = VXGTST( MODSCN(ISCN) )
C         IF( FORMAT(ISET)(1:4) .EQ. 'NONE' ) THEN
C           RECSCN = 0
CC          Need to allow possibility of using a later scan in case there
CC          is no previous recording scan (there must be one recording
CC          scan somewhere)
C           DO JSCN = SCAN1, SCANL
C             IF( RECSCN .EQ. 0 .OR. JSCN .LT. ISCN ) THEN
C               IF( .NOT. NOREC(JSCN) ) THEN
C                 RECSCN = JSCN
C               END IF
C             END IF
C           END DO
C           IF( RECSCN .EQ. 0 ) THEN
C             CALL ERRLOG( 'VXSCNS: there do not appear to be any ' //
C     1       'recording scans in this schedule! Check use of '//
C     2       'NORECORD, POINT and FORMAT=NONE' )
C           ELSE
C             MODSCN(ISCN) = MODSCN(RECSCN)
C           END IF
C         END IF
C      END DO
C     
      RETURN
      END

      SUBROUTINE FMTVLBA( KS, TRKBPS, OK )
C
C     Routine for SCHED called by SETFMT that sets the VLBA format 
C     for setup group KS.  It will attempt to set FORMAT, SPEEDUP, 
C     FANOUT, and TAPEMODE.  OK will return .TRUE. if it succeeds.  
C     It will return .FALSE. if not, which means that it does not 
C     yet have enough information, which is only possible if it is
C     called with zero for the track bit rate (TRKBPS).  OK false
C     can also imply an error.
C
C     For "twohead" observations, some stations might not have enough
C     drives or heads.  Worry about that later once the formats are
C     set.  For now, it is appropriate just that we will try hard to
C     avoid using 2 "heads" if possible.  The TWOHEAD flag has already
C     been set based on the bit rate, as has the FASTTRK flag for
C     bit rates above 512 Mbps.  For VLBA, FASTTRK is not allowed 
C     because the electronics don't do 16 Mbps/track.
C
C     With tape, it was desirable to keep the number of tracks the 
C     same for all setups.  Specifically, for TWOHEAD observations,
C     scans with narrower bandwidths would still use 64 tracks.
C     With the disk systems, there is no need to keep the number
C     of tracks constant as it no longer complicates media managment.
C     Therefore relax any attempt to preserve the number of tracks
C     when there are no tapes.  Basically this routine is setting
C     the fanout as that, along with the sample rate essentially 
C     determines everything.  For disk, set the fanout to the
C     smallest allowed value as determined by the maximum track 
C     bit rate the formatter can handle.  On the VLBA, that is 8 Mbps.
C
      INCLUDE        'sched.inc'
      INCLUDE        'schset.inc'
C
      INTEGER        KS, TMODE, LEN1, NSTREAM, ALLTRK
      REAL           TRKBPS, MAXBR
      LOGICAL        OK
      CHARACTER      NEWFMT*8
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'FMTVLBA: starting.' )
C
      OK = .FALSE.
C
C     We're not going to get anywhere without the sample rate.  I
C     don't think this should happen, but just in case.
C
      IF( SAMPRATE(KS) .EQ. 0.0 ) THEN
         GO TO 999
      END IF
C
C     Set the maximum bit rate per track and the maximum number of
C     tracks MAXTRAK available for use.  Assume all stations can do 
C     TWOHEAD (2 drives or 2 heads - or simply 64 tracks).  It is 
C     later in SETFORM that the number of channels will be decreased 
C     for stations that don't have enough resources for TWOHEAD.
C
C     The meaning of some variables:
C     NSTREAM  - The number of bit streams.
C     TOTBPS   - The total bit rate.  Derived in SETFORM.  This will
C                be a bit less than WRTBPS, the actual bit rate 
C                because of headers, but is more useful for format 
C                picking.
C     MINTBPS  - The minimum track bit rate that can be used.
C     MAXTBPS  - The maximum track bit rate that can be used.
C     MINTRAK  - The minimum number of tracks required.
C     MAXTRAK  - The maximum number of tracks that can be used.
C     MAXBR    - Maximum track bit rate.
C
C     Set number of tracks.  64 for more than 256 Mbps, 32 otherwise.
C
      MAXBR = 8.0
      IF( ( ANYTAPE .AND. TWOHEAD ) .OR. TOTBPS(KS) .GT. 257.0 ) THEN
         ALLTRK = 64
      ELSE
         ALLTRK = 32
      END IF
C
      NSTREAM = NCHAN(KS) * BITS(1,KS)
      MINTBPS(KS) = MAX( 2.0, SAMPRATE(KS) / 4.0 )
      MAXTBPS(KS) = MIN( SAMPRATE(KS), MAXBR )
      MINTRAK(KS) = TOTBPS(KS) / MAXTBPS(KS)
      MAXTRAK(KS) = MIN( ALLTRK, NINT( TOTBPS(KS) / MINTBPS(KS) ) )
C
C     Don't allow more than 512 Mbps on these systems as it 
C     requires 16 Mbps per track, which the VLBA formatters can't do.
C
      IF( TOTBPS(KS) .GT. 512.0 ) THEN
         CALL WLOG( 1, 'FMTVLBA: Total bit rate too high in ' //
     1      'setup described below.  Max 512 for VLBA format.' )
         CALL ERRSET( KS )
      END IF
C
C     Do a quick sanity check on TAPEMODE(KS) to avoid needing
C     to do it several times later.
C
      IF( TAPEMODE(KS) .LT. 0 ) THEN
         CALL WLOG( 1, 'FMTVLBA: Negative TPMODE?  Not allowed.' )
         CALL ERRSET( KS )
      END IF
C
C     See if we've already set the format.  If so, the routine
C     is being used to check compatability.  Do so.
C
      IF( FANOUT(KS) .NE. 0.0 ) THEN
         OK =  TRKBPS .EQ. 0.0  .OR. ( TRKBPS .NE. 0.0 .AND. 
     1         TRKBPS .EQ. SAMPRATE(KS) / FANOUT(KS) )
         GO TO 999
      END IF
C
C     Sanity checks for the specified bit rate.
C
      IF( TRKBPS .NE. 0.0 ) THEN
         IF( TRKBPS .GT. MAXTBPS(KS) .OR. 
     1       TRKBPS .LT. MINTBPS(KS) ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, F8.2, A, F8.2, A, F8.2 )' ) 
     1       'FMTVLBA: Track bit rate request ', TRKBPS, 
     2       ' outside the possible range for this setup: ',
     3       MINTBPS(KS), ' to ', MAXTBPS(KS)
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, '       setup file: ' // SETNAME(KS) )
            CALL WLOG( 1, '         station: '//
     1          STATION(ISETSTA(KS)) )
            CALL WLOG( 1, '         format: ' // FORMAT(KS) )
            CALL WLOG( 1, '         Probable programming error.' )
            OK = .FALSE.
            CALL ERRSET( KS )
         END IF
      END IF
C
C     Try to get the fanout from the inputs, or from the constraints.
C     
C     If the FORMAT is fully specified, that is all we need.
C     Note that FORMAT(1:4)='VLBA' or we wouldn't be in this routine.
C
      IF( LEN1( FORMAT(KS) ) .EQ. 7 ) THEN 
         IF( FORMAT(KS)(5:7) .EQ. '1:1' ) THEN
            FANOUT(KS) = 1.0
         ELSE IF( FORMAT(KS)(5:7) .EQ. '1:2' ) THEN
            FANOUT(KS) = 2.0
         ELSE IF( FORMAT(KS)(5:7) .EQ. '1:4' ) THEN
            FANOUT(KS) = 4.0
         ELSE IF( LEN1( FORMAT(KS) ) .NE. 4 ) THEN
            CALL WLOG( 1, 'FMTVLBA:  Bad VLBA format specified. '//
     1           ' Fan out spec not proper.' )
            CALL ERRSET( KS )
         END IF
C
      ELSE IF( LEN1( FORMAT(KS) ) .NE. 4 ) THEN
C
C        Protect against spurious format settings.
C
         CALL WLOG( 1, 'FMTVLBA:  Bad VLBA format specified. '//
     1            '  Invalid length. ')
         CALL ERRSET( KS )
      END IF
C
C     See if TAPEMODE(KS) will allow us to set format.
C
      IF( FANOUT(KS) .EQ. 0.0 .AND. TAPEMODE(KS) .NE. 0 ) THEN
C 
C        Complain about impossible cases.  Note we haven't decreased
C        the number of tracks yet for stations no equipped for two
C        drive operation.  Save that for after formats are set.
C
         IF( TOTBPS(KS) .GT. 128 .AND. TAPEMODE(KS) .NE. 1 ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A, I5 )' )
     1        'FMTVLBA: TPMODE should be 1 for more than 128 Mbps ',
     2        'with VLBA format.  Was set to: ', TAPEMODE(KS)
            CALL WLOG( 1, 
     1     '         TPMODE is the passes per head position.' )
            CALL ERRSET( KS )
         ELSE IF( TAPEMODE(KS) .GT. ALLTRK / MINTRAK(KS) ) THEN
            CALL WLOG( 1, 'FMTVLBA: Impossible TPMODE specified. ' )
            CALL WLOG( 1, 
     1          '         TPMODE is the passes per head position.' )
            CALL ERRSET( KS )
         ELSE
C
C           Ok, can conform to the request.  But don't overshoot
C           what is possible.
C
            FANOUT(KS) = MIN( 4.0, 
     1          FLOAT( ALLTRK / ( TAPEMODE(KS) * NSTREAM ) ) )
         END IF
C
      END IF
C
C     Set the format in some cases where there is no choice.
C     First if all available tracks are being used, the mode is
C     forced.  This happens with anything above 128 Mbps.
C     Also assume that all TWOHEAD tape observations use all 64 tracks 
C     (even if some setups have narrower bandwidths).  Note we 
C     have not yet docked channels from the single drive stations.  
C     We'll do that later to avoid logic complications now.
C     Use 129 as something a bit larger than 128.
C
      IF( FANOUT(KS) .EQ. 0.0 ) THEN
         IF( ( ANYTAPE .AND. TWOHEAD  ) .OR. TOTBPS(KS) .GT. 129.0 ) 
     1        THEN
            FANOUT(KS) = MAXTRAK(KS) * SAMPRATE(KS) / TOTBPS(KS)
         END IF
      END IF
C
C     If the sample rate was 32 Mbps, that constrains the fanout.
C
      IF( FANOUT(KS) .EQ. 0.0 .AND. 
     1    SAMPRATE(KS) .EQ. 32.0 ) THEN
         FANOUT(KS) = SAMPRATE(KS) / MAXBR
      END IF
C
C     The minimum track rate also forces the rate.  Use LE, but 
C     be aware that less than 2.0 is not allowed.
C
      IF( FANOUT(KS) .EQ. 0.0 .AND. 
     1    SAMPRATE(KS) .LE. 2.0 ) THEN
         FANOUT(KS) = 1.0
      END IF
C
C     If TRKBPS was set, use that.  Note that we checked
C     earlier that TRKBPS was not greater than the sample rate.
C     Will sanity check later.
C
      IF( FANOUT(KS) .EQ. 0.0 .AND. TRKBPS .GT. 0.0 ) THEN
         FANOUT(KS) = SAMPRATE(KS) / TRKBPS
      END IF
C
C     --------------------
C     The following may actually be all that is needed of this 
C     routine in the disk era unless there is a need to conform
C     to setup file input.  Set the fanout to the minumum
C     possible that the formatter can handle.  This is fine since
C     is no longer necessary to match the track bit rates at 
C     stations.
C
      IF( FANOUT(KS) .EQ. 0.0 ) THEN
         FANOUT(KS) = SAMPRATE(KS) / MAXTBPS(KS)
      END IF
C     ---------------------
C
      IF( FANOUT(KS) .EQ. 0.0 ) THEN
C
C        If got here, something was wrong with the last statments.
C
         OK = .FALSE.
C
      ELSE
C
C        Fill out the format from any FANOUT derived above.
C        Force the result to 1.0, 2.0, or 4.0.  Fractional values
C        can be derived above from non-power-of-two numbers of
C        channels.
C
         OK = .TRUE.
         IF( FANOUT(KS) .GT. 0.0 .AND. FANOUT(KS) .LT. 2.0 ) THEN
            NEWFMT = 'VLBA1:1'
            FANOUT(KS) = 1.0
         ELSE IF( FANOUT(KS) .GE. 2.0 .AND. FANOUT(KS) .LT. 4.0 ) THEN
            NEWFMT = 'VLBA1:2'
            FANOUT(KS) = 2.0
         ELSE IF( FANOUT(KS) .GE. 4.0 ) THEN
            NEWFMT = 'VLBA1:4'
            FANOUT(KS) = 4.0
         ELSE
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, F8.3, A, F8.2 )' ) 
     1         'FMTVLBA: Invalid fanout ', FANOUT(KS), 
     2         'derived for setup described below. TRKBPS was ', 
     3         TRKBPS
            CALL WLOG( 1, MSGTXT )
            CALL ERRSET( KS )
         END IF
C
C        Make sure we haven't changed a fully specified format.
C        I really don't think I should get here.  Maybe this 
C        could be deleted.
C
         IF( LEN1(FORMAT(KS)) .GT. 4 .AND. 
     1       NEWFMT .NE. FORMAT(KS) ) THEN
            MSGTXT = ' ' 
            WRITE( MSGTXT, '( 4A )' )
     1        'FMTVLBA: Derived format ', NEWFMT, 
     2        ' does not match specified format ', FORMAT(KS)
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, '       Probable programming error.' )
         END IF
C
C        Set the format regardless of previous format.
C
         FORMAT(KS) = NEWFMT
C
C        Set tape mode if needed.  Otherwise check the preset
C        tapemode for reasonableness and complain if it is not
C        optimal.  TMODE is the TAPEMODE that eventually uses all
C        tracks for this schedule.  Recall TAPEMODE is the number
C        of passes per head position.
C
         TMODE = ALLTRK / ( NCHAN(KS) * BITS(1,KS) * FANOUT(KS) )
         IF( TMODE .LT. 1 ) THEN
            MSGTXT = ' ' 
            WRITE( MSGTXT, '( A, F8.2, A )' ) 
     1         'FMTVLBA: Derived fanout ', FANOUT(KS),
     2         ' too large for setup detailed below. '
            CALL WLOG( 1, MSGTXT )
         END IF
C
C        Set the TAPEMODE if not already.
C
         IF( TAPEMODE(KS) .EQ. 0 ) THEN
            TAPEMODE(KS) = TMODE
C
C        Now check the reasonableness of a preset TAPEMODE.
C
         ELSE IF( TAPEMODE(KS) .GT. TMODE ) THEN
            CALL WLOG( 1, 'FMTVLBA: Specified TPMODE impossible for '//
     1           'specified format.' )
            CALL WLOG( 0, 
     1        '         TPMODE is the passes per head position.' )
            CALL ERRSET( KS )
         ELSE IF( TAPEMODE(KS) .LT. TMODE ) THEN
            CALL WLOG( 0, 'FMTVLBA: Specified TPMODE not as high '//
     1         'as could be for specified format.' )
            CALL WLOG( 0, '         setup: '// SETNAME(KS) )
            CALL WLOG( 0, '         station: '// 
     1         STATION(ISETSTA(KS)) )
            CALL WLOG( 0, '         format: ' // FORMAT(KS) )
            CALL WLOG( 0, 
     1        '         TPMODE is the passes per head position.' )
         END IF
C
C        Set SPEEDUP and OK before exiting.  Record the track bit rate
C        used.   SPEEDUP is not really a proper concept in the disk
C        world, but calculate it anyway.  Places where it is used
C        are being removed.
C
         SPEEDUP(KS) = 8.0 * FANOUT(KS) / SAMPRATE(KS)
         TBPS(KS) = SAMPRATE(KS) / FANOUT(KS)
         OK = .TRUE.
C
      END IF
C
C     Line 999 is the jump point for some error points above and
C     for when the format does not need to be set.
C
  999 CONTINUE
      RETURN
      END

      SUBROUTINE HARMWARN( KS, SY1, LO1, LOI, SY2 ,LO2, LOJ, K, L,
     1                     IFF, TONHD )
C
C     Routine called by SETUSYN to write out warnings about
C     possible cases of harmonic interference.  This was needed
C     in two places and got a bit complicated so it was split
C     out.
C
C     SY1 and SY2 are the synthesizer number being used.  They 
C     will be printed in the table.
C
C     LO1 and LO2 are the synthesizer settings.  LOI and LOJ are
C     the same for LO1/LO2 < 8.0 and half of LO1/LO2 for over 8.0.
C     K and L are the harmonic numbers of LOI and LOJ (the loop
C     over harmonics is in the calling routine).  IFF is the
C     difference frequency in GHz.  The routine is only called
C     if this is within the IF and warnings need to be written.
C     TONHD just determines whether this is the first call for this
C     setup.  If true, the explanations are written and the table
C     headings are written.  If false, only the table line is
C     written.  TONHD will be true once per setup while the internal
C     flag HWARN will only be true for the very first call.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
C
      INTEGER     KS, K, L, SY1, SY2
      LOGICAL     TONHD, HWARN
      DOUBLE PRECISION  LO1, LO2, LOI, LOJ, IFF, BDIFF
      REAL        K2, L2
C
      INTEGER     LEN1, NRF, IRF, ISIDE1, ICH
      DOUBLE PRECISION  RF(3), RFF
      CHARACTER   INBBC(3)*3
      DATA        HWARN / .TRUE. /
      SAVE        HWARN
C  -------------------------------------------------------------------
      IF( TONHD ) THEN
         TONHD = .FALSE.
         CALL WLOG( 1, ' ' )
C
C        Give the first line of the warning with the setup file
C        name.
C
         MSGTXT = ' '
         WRITE( MSGTXT, '( 3A )' )
     1       'HARMWARN:  Setup file: ', 
     2       SETNAME(KS)(1:LEN1(SETNAME(KS)))
         CALL WLOG( 1, MSGTXT )
C
C        Give a short description of the problem the first time.
C
         IF( HWARN ) THEN
C
C           Write a detailed explanation from the message file.
C
            CALL WRTMSG( 0, 'HARMWARN', 'harmwarn' )
            HWARN = .FALSE.
C
C           Now write the short information above the table.
C
            MSGTXT = ' '
            WRITE( MSGTXT, '( 2A )' )
     1          '          There are possible tones in the ', 
     2          'IF due to mixing of harmonics of the '
            CALL WLOG( 1, MSGTXT )
            MSGTXT = ' '
            WRITE( MSGTXT, '( 2A )' )
     1          '          VLBA front end synthesizer outputs.  ',
     2          'See sched.runlog for detailed information.'
            CALL WLOG( 1, MSGTXT )
C
         ELSE
C
C        The next time, be more terse.
C
            MSGTXT = ' '
            WRITE( MSGTXT, '( 2A ) ' )
     1          '         This setup also has possible tones ',
     2          'from mixing of LO harmonics.'
            CALL WLOG( 1, MSGTXT )
         END IF
C
C        Write the table header
C
         CALL WLOG( 1, ' ' )
         WRITE( MSGTXT, '( 2A )' )
     1       'Setup Syn  LO(GHz)  Osc Harmonic Syn LO(GHz)  ',
     2       'Osc Harmonic   IF (MHz) RF    In BBC'
         CALL WLOG( 0, MSGTXT )
      END IF
C
C     Before writing the line, get the RF frequencies
C     for the offending harmonic mixes.  This is made 
C     messy by the combinations of LOs used for 22 GHz 
C     and up and the lack of a pointer from the synthesizer 
C     to the channel.  So don't try that way.  It is possible
C     to have 3 distinct IFs for S/X with wide X and 2 with
C     normal S/X and with the wide C band.  Find the different
C     cases by searching through the channels for and looking
C     at the FIRSTLOs.  Write a separate line for each case.
C     note that there will rarely be more than one.
C
C     While at it, determine if the tone is in a BBC.
C
      DO IRF = 1, 3
         RF(IRF) = 0.D0
         INBBC(IRF) = 'NO'
      END DO
      NRF = 0
      DO ICH = 1, NCHAN(KS)
         IF( SIDE1(ICH,KS) .EQ. 'U' ) THEN 
            ISIDE1 = 1
         ELSE
            ISIDE1 = -1
         END IF
C
C        Get the tone RF frequency in this channel.
C
         RFF = FIRSTLO(ICH,KS) + ISIDE1 * IFF * 1000.D0
C
C        See if this is new.  Accumulate distinct cases.
C
         IRF = 1
         DO WHILE( IRF .LE. 3 )
            IF( RFF .EQ. RF(IRF) .OR. RF(IRF) .EQ. 0.D0 ) THEN
               RF(IRF) = RFF
               NRF = MAX( IRF, NRF )
C
C              Check if in BBC.
C
               BDIFF = RF(IRF) - FREQREF(ICH,KS)
               IF( ABS( BDIFF ) .LE. BBFILT(ICH,KS) ) THEN
                  IF( ( NETSIDE(ICH,KS) .EQ. 'U' .AND.
     1                BDIFF .GE. 0.D0 ) .OR.
     2                ( NETSIDE(ICH,KS) .EQ. 'L' .AND.
     3                BDIFF .LE. 0.D0 ) ) INBBC(IRF) = 'YES'
               END IF
C
C              Found the RF case this channel belongs in.  Go
C              to the next channel.
C
               GO TO 100
            END IF
C
C           This channel was not in this IRF.  Go to next IRF.
C
            IRF = IRF + 1
         END DO
C
  100    CONTINUE
      END DO
C
C     Write a line for the data.  If NRF is more than one,
C     write an extra line for each case so we can do the
C     In BBC test.  NRF is never more than 3.
C       
      K2 = K
      IF( LO1 .GT. 8.0D0 ) K2 = K / 2.0
      L2 = L
      IF( LO2 .GT. 8.0D0 ) L2 = L / 2.0
      IF( NRF .GE. 1 ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( I4, I4, F8.1, F7.2, F7.1, I5, F7.1, F7.2,'
     1        //' F7.1, 2F10.2, 3X, A3 )' )  KS, SY1, LO1, LOI, K2, 
     2 	      SY2, LO2, LOJ, L2, IFF*1000.0, RF(1), INBBC(1)
         CALL WLOG( 0, MSGTXT )
      END IF
C
      MSGTXT = ' '
      IF( NRF .GE. 2 ) THEN
         WRITE( MSGTXT, '( 66X, F10.2, 3X, A3 )' ) RF(2), INBBC(2)
         CALL WLOG( 0, MSGTXT )
      END IF
C
      MSGTXT = ' '
      IF( NRF .GE. 3 ) THEN
         WRITE( MSGTXT, '( 66X, F10.2, 3X, A3 )' ) RF(3), INBBC(2)
         CALL WLOG( 0, MSGTXT )
      END IF
C
C     Warn if this will be a strong one because a primary
C     synthesizer output is involved and it is synthesizer
C     1 and 2.
C
      IF( ( LO1 .LT. 8.D0 .AND. K .EQ. 1 ) .OR.
     1    ( LO1 .GT. 8.D0 .AND. K .EQ. 2 ) .OR.
     2    ( LO2 .LT. 8.D0 .AND. L .EQ. 1 ) .OR.
     3    ( LO2 .GT. 8.D0 .AND. L .EQ. 2 ) ) THEN
         IF( ( ABS( LO1 - SYNTH(1,KS) ) .LT. 0.001D0 .OR.
     1         ABS( LO1 - SYNTH(2,KS) ) .LT. 0.001D0 ) .AND.
     2       ( ABS( LO2 - SYNTH(1,KS) ) .LT. 0.001D0 .OR.
     3         ABS( LO2 - SYNTH(2,KS) ) .LT. 0.001D0 ) ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( 2A )' ) 
     1          '      Likely strong tone - From synthesizers 1 and 2',
     2          ' and a primary signal is involved.'
            CALL WLOG( 0, MSGTXT )
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE CHKGDAR( KS, ERRS )
Cf2py intent(in, out) ERRS
C
C     Routine for SCHED called by CHKSET that checks a few specific
C     restrictions on the "geodetic" VLBA racks.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER    KS, ICH, IIF, IBBC
      LOGICAL    ERRS, OK, SOMEBAD, SOMETWO
C
      INTEGER    MAXBBC, MAXIF, I
      PARAMETER  (MAXBBC=14)
      PARAMETER  (MAXIF=4)
      INTEGER    IFBBC(MAXBBC,MAXIF)
      CHARACTER  IFNAM(MAXIF)*2
      DATA  (IFBBC(I,1),I=1,MAXBBC) / 1,1,1,1,1,1,1,1,0,0,0,0,0,0 /
      DATA  (IFBBC(I,2),I=1,MAXBBC) / 1,1,0,0,0,0,0,0,1,1,1,1,1,1 /
      DATA  (IFBBC(I,3),I=1,MAXBBC) / 1,1,1,1,1,1,1,1,0,0,0,0,0,0 /
      DATA  (IFBBC(I,4),I=1,MAXBBC) / 1,1,0,0,0,0,0,0,1,1,1,1,1,1 /
      DATA  (IFNAM(I),I=1,MAXIF) / 'A', 'B', 'C', 'D' /
C
C     Note that the above data statement is also in BBCGEO.  Changes
C     should be made in both places.
C ---------------------------------------------------------------------
      IF( SDEBUG ) CALL WLOG( 0, 'CHKGDAR: Starting.' )
C
C     Loop through the channels checking IF assignments.
C
      SOMEBAD = .FALSE.
      DO ICH = 1, NCHAN(KS)
C
C        See if this channel uses an allowed IF given the wiring
C        constraints embodied in the IFBBC array.
C
         OK = .FALSE.
         IBBC = BBC(ICH,KS)
         DO IIF = 1, MAXIF
            IF( IFNAM(IIF) .EQ. IFCHAN(ICH,KS) .AND. 
     1          IFBBC(IBBC,IIF) .EQ. 1 ) OK = .TRUE.
         END DO
C
C        Give warnings if it was not allowed.
C
         IF( .NOT. OK ) THEN
            SOMEBAD = .TRUE.
            SETMSG = ' '
            WRITE( SETMSG, '( 3A, I4 )' )
     1          'CHKGDAR: Illegal IF input ', IFCHAN(ICH,KS),
     2          ' for geodetic type VLBA rack, channel ', ICH
            CALL WLOG( 1, SETMSG )
            ERRS = .TRUE.
         END IF
C
      END DO
      IF( SOMEBAD ) THEN
         SETMSG = ' '
         WRITE( SETMSG, '( 2A )' )
     1       '         Be careful of special wiring restrictions ',
     2       'for these DARs.' 
         CALL WLOG( 0, SETMSG )
      END IF
C
C     Now check that no more than 8 BBCs are being requested with
C     two bit sampling.
C
      SOMEBAD = .FALSE.
      SOMETWO = .FALSE.
      DO ICH = 1, NCHAN(KS)
         IF( BITS(ICH,KS) .NE. 1 ) SOMETWO = .TRUE.
      END DO
      DO ICH = 1, NCHAN(KS)
         IF( SOMETWO .AND. BBC(ICH,KS) .GT. 8 ) SOMEBAD = .TRUE.
      END DO
C
      IF( SOMEBAD ) THEN
         SETMSG = ' '
         WRITE( SETMSG, '( 2A )' )
     1        'CHKGDAR:  Geodetic type VLBA systems cannot use 2 bit ',
     2        'samples from more than the first 8 BBCs.'
         CALL WLOG( 1, SETMSG )
         ERRS = .TRUE.
      END IF
C
      RETURN
      END

      SUBROUTINE SCRAMBLE( ARRAY, N, IDUM )
C
C     Scramble the order of ARRAY to element N.
C     Use an element swapping method.
C     Don't worry about occasionally swapping an element
C     with itself.
C
C     Inputs:
C         ARRAY   An integer array
C         N       Number of elements to scramble.
C         IDUM    Seed for the random number generator.
C
      INTEGER      ARRAY(*), N, IDUM, ILOOP
      INTEGER      I1, I2, TEMP
      REAL         RAN5
C -----------------------------------------------------------
      DO ILOOP = 1, 3 * N
         I1 = INT( RAN5( IDUM ) * N + 1 )
         I2 = INT( RAN5( IDUM ) * N + 1 )
         TEMP = ARRAY(I1)
         ARRAY(I1) = ARRAY(I2)
         ARRAY(I2) = TEMP
      END DO
C
      RETURN
      END

      SUBROUTINE DELSCR( RESTART )
C
C     Delete any scratch files.  I did this instead of implementing
C     STATUS=SCRATCH in the VLBOPE, but maybe that should be changed
C     some day.  I'm generally a bit reluctant to mess with the Cit
C     routines.
C
C     Also close the log file, since this is the end of the program.
C
      INCLUDE     'sched.inc'
C
      LOGICAL     EXISTS, RESTART
      INTEGER     IOERR, VLBOPE, LEN1
C  -------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'DELSCR starting.' )
C
C     Cover letter scratch file.
C
      INQUIRE( FILE='schedcov.tmp', EXIST=EXISTS )
      IF( EXISTS ) THEN
         IOERR = VLBOPE( ICOV, 'schedcov.tmp', 'TEXT', 'OLD', MSGTXT )
         IF( IOERR .NE. 1 ) THEN
            CALL WLOG( 1, MSGTXT )
            CALL ERRLOG( 'WRTCOV: Cannot open '//
     1       'cover letter scratch file.  This should not happen.' )
         ELSE
            CLOSE( UNIT=ICOV, STATUS='DELETE' )
         END IF
      END IF         
C
C     Close the log file.  Use PUTOUT because these don't need to be
C     in the logfile.
C
      IF( .NOT. RESTART ) THEN
         IF( READLOG ) THEN
            CALL PUTOUT( ' ' )
            CALL PUTOUT( ' *** There are special messages in ' // 
     1           LOGFILE )
            CALL PUTOUT( '     Please read them.' )
            CALL PUTOUT( ' ' )
         ELSE
            CALL PUTOUT( ' REMINDER - see ' // 
     1             LOGFILE(1:LEN1(LOGFILE)) //
     2             ' for most run time messages.' )
         END IF
C
         CLOSE( UNIT=ILOG )
C
      END IF
C
      RETURN
      END

      SUBROUTINE FMTMKIII( KS, OK )
C
C     Routine for SCHED called by SETFMT that sets the format 
C     for Mark III for setup group KS.  It will attempt to 
C     set FORMAT, SPEEDUP, FANOUT, and TAPEMODE.  OK will 
C     return .TRUE. if it succeeds.  It will return .FALSE. 
C     if not, which for MarkIII should not happen.
C
      INCLUDE        'sched.inc'
      INCLUDE        'schset.inc'
C
      INTEGER        KS
      REAL           TBPR
      LOGICAL        OK
C ---------------------------------------------------------------------
C   
C     FORMAT is already set or we wouldn't be in this routine.
C     There are no choices for this format.
C
      IF( FANOUT(KS) .NE. 0.0 ) GO TO 999
C
C     Get the total bit rate.
C
      TBPR = NCHAN(KS) * SAMPRATE(KS) * BITS(1,KS)
C
C     First see if the user has set TPMODE (TAPEMODE) which is
C     the number of passes per head position.  For Mark III, this
C     is the only way the user has of affecting the fanout and
C     speedup.
C
      IF( TAPEMODE(KS) .GT. 0 ) THEN
C
C        Do an incomplete consistency check.
C
         IF( ( NCHAN(KS) .GT. 16 .AND. TAPEMODE(KS) .GT. 1 ) .OR.
     1       ( NCHAN(KS) .GT. 8  .AND. TAPEMODE(KS) .GT. 2 ) ) THEN
            CALL WLOG( 1, 
     1         'FMTMKIII: Impossible TPMODE for this format in ' //
     2         'MarkIII format' )
            CALL ERRSET( KS )
         END IF
      ELSE 
         IF( NCHAN(KS) .GT. 16 ) THEN
            TAPEMODE(KS) = 1
         ELSE IF( NCHAN(KS) .GT. 8 ) THEN
            TAPEMODE(KS) = 2
         ELSE 
            TAPEMODE(KS) = 4
         END IF
      END IF
C
      SPEEDUP(KS) = 8.0 / SAMPRATE(KS)
C
      IF( SPEEDUP(KS) .LT. 1.0 ) THEN
         CALL WLOG( 1, 'FMTMKIII: Mark III can''t do sample rates '//
     1           'over 8 Msamp/s' )
         CALL ERRSET( KS )
      END IF
C
C     Fill in some items that are mainly useful for VLBA/MKIV, but 
C     could be useful in mixed mode observations.
C
      FANOUT(KS) = 1.0
      TBPS(KS)   = SAMPRATE(KS)
      MINTRAK(KS) = NCHAN(KS)
      MAXTRAK(KS) = NCHAN(KS)
      MINTBPS(KS) = SAMPRATE(KS)
      MAXTBPS(KS) = SAMPRATE(KS)
C
  999 CONTINUE
      OK = .TRUE.
      RETURN
      END

      SUBROUTINE CHKCDAS( KS, ERRS )
Cf2py intent(in, out) ERRS
C
C     Routine called by CHKSET to check the setup for a CDAS 
C     (Chinese Data Aquisition System) station.
C
C     For now, this is mostly a dummy.  Checks will be added 
C     as they are understood.
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
C
      INTEGER    KS
      LOGICAL    ERRS
C ----------------------------------------------------------------
      MSGTXT = ' '
      WRITE( MSGTXT, '( A, I4, A )' )
     1    'CHKCDAS: Setup ', KS, ' is for a CDAS station.'
      CALL WLOG( 1, '          SCHED does not yet do much checking '//
     1    'of CDAS parameters.' )
      CALL WLOG( 1, '          Be sure your setup parameters are '//
     1    'correct for this station!' )
C
      RETURN
      END

      SUBROUTINE sla_PRENUT (EPOCH, DATE, RMATPN)
*+
*     - - - - - - -
*      P R E N U T
*     - - - - - - -
*
*  Form the matrix of precession and nutation (SF2001)
*  (double precision)
*
*  Given:
*     EPOCH   dp         Julian Epoch for mean coordinates
*     DATE    dp         Modified Julian Date (JD-2400000.5)
*                        for true coordinates
*
*  Returned:
*     RMATPN  dp(3,3)    combined precession/nutation matrix
*
*  Called:  sla_PREC, sla_EPJ, sla_NUT, sla_DMXM
*
*  Notes:
*
*  1)  The epoch and date are TDB (loosely ET).  TT will do, or even
*      UTC.
*
*  2)  The matrix is in the sense   V(true) = RMATPN * V(mean)
*
*  Last revision:   3 December 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION EPOCH,DATE,RMATPN(3,3)

      DOUBLE PRECISION RMATP(3,3),RMATN(3,3),sla_EPJ



*  Precession
      CALL sla_PREC(EPOCH,sla_EPJ(DATE),RMATP)

*  Nutation
      CALL sla_NUT(DATE,RMATN)

*  Combine the matrices:  PN = N x P
      CALL sla_DMXM(RMATN,RMATP,RMATPN)

      END

      SUBROUTINE SETFCAT( KS, NEEDCAT )
C
C     Routine for SCHED, called by SETDEFS, to deal with setup 
C     frequency, sideband and other such information.
C
C     First determine which frequency catalog entry to use for a 
C     setup group.  This catalog entry will be used to set 
C     parameters where necessary and will be used to check 
C     parameters that are provided.  Critically, FREQREF and 
C     NETSIDE are known for each channel by the time this is called.
C
C     If an apropriate entry cannot be found, a warning is issued
C     if NEEDCAT is false and an abort is issued if NEEDCAT is true.
C
C     Once done with the frequency catalog (or if it wasn't used),
C     deal with filling out all the sideband and LO information based
C     on what is available.
C
C     Jan 2013 RCW  Adding continuously tunable options.  This is
C     mainly for the VLA, but could possibly be used for other antennas.
C     Sep 2013 RCW  Adjusting for use with the CRD parameters.
C
C
      INCLUDE   'sched.inc'
      INCLUDE   'schset.inc'
      INCLUDE   'schfreq.inc'
C
      INTEGER        I, KS, KF, ICH, IIF, KIF, NBAD, NBWARN
      INTEGER        USEKF, USEIF(MCHAN), BESTPRIO, LEN1
      LOGICAL        MATCH, GOT, NEEDCAT, OKIF(MCHAN,MFIF), TAKEIT
      CHARACTER      LASTPOL*4
      REAL           OVERLAP, CENTER
      REAL           BESTCENT
      DATA           NBWARN / 0 /
      SAVE           NBWARN
C ---------------------------------------------------------------------
      IF( SDEBUG ) CALL WLOG( 0, 'SETFCAT: Starting' )
C
C     Loop over frequency catalog groups looking for best.
C
      GOT = .FALSE.
      BESTCENT = 1.E5
      BESTOVER(KS) = 0.0
      BESTPRIO = 100
C
      DO KF = 1, NFREQ
C
C        Find if this frequency catalog group is compatible with this
C        setup group (MATCH=.TRUE.).  Also flag which IFs in the 
C        frequency group can be used for each channel (OKIF).
C
         CALL FCOMPARE( KS, KF, MATCH, OKIF, NBAD, .FALSE. )
C
C        Determine which of the frequency groups that are compatible 
C        is best.
C
         IF( MATCH ) THEN
C
C           Determine the amount of bandwidth overlap and the worst
C           offset of a channel from the center of a band.
C
            CALL FMATCH( KS, KF, OVERLAP, CENTER, OKIF, USEIF )
            IF( SDEBUG ) THEN
               SETMSG = ' '
               WRITE( SETMSG, '( A, 2I4, 2F10.2, 32I2)' ) 
     1            'SETFCAT debug: ', KS, KF, OVERLAP, CENTER, 
     2            (USEIF(I),I=1,NCHAN(KS))
               CALL WLOG( 0, SETMSG )
            END IF
C
C           Determine which KF is best.  Go for the best centered
C           of the best priority groups with the most overlap.
C           (Clear as mud, eh!).  Deal separately with the cases
C           where this is clearly the best choice and where we
C           have do decide based on more subtle criteria like 
C           centering.
C

            IF( OVERLAP .GT. 0.0 ) THEN
               IF( SDEBUG ) THEN
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, 2I4, 2A )' )
     1               'SETFCAT GOT OVERLAP:', KS, KF, ' ', FRNAME(KF)
                  CALL WLOG( 0, MSGTXT )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, 2F8.2, 2I3, 2F8.2 )' ) 
     1                '                    ', OVERLAP, BESTOVER(KS),
     2                PRIO(KF), BESTPRIO, CENTER, BESTCENT
                  CALL WLOG( 0, MSGTXT )
               END IF
C
C              Clearly best:
C
               TAKEIT = .FALSE.
               IF( OVERLAP .GT. BESTOVER(KS) .OR. 
     1             ( OVERLAP .EQ. BESTOVER(KS) .AND. 
     2             PRIO(KF) .LT. BESTPRIO ) ) THEN
                  TAKEIT = .TRUE.
C
C              Choose by centering:
C
               ELSE IF( OVERLAP .EQ. BESTOVER(KS) .AND. 
     2             PRIO(KF) .EQ. BESTPRIO ) THEN
                  IF( CENTER .LT. BESTCENT ) THEN
                     TAKEIT = .TRUE.
                  END IF
               END IF
C
C              Actually take it and set this one up as the standard.
C              Get the IF limits for later comparison with doppler
C              and schedule set frequencies.  For channels that
C              don't match, set the frequency limits to zero.
C
               IF( TAKEIT ) THEN
                  IF( SDEBUG) WRITE(*,*) 'SETFCAT taking it:', 
     1                 KS, KF, ' ', FRNAME(KF)
                  GOT = .TRUE.
                  USEKF = KF
                  BESTOVER(KS) = OVERLAP
                  BESTPRIO = PRIO(KF)
                  BESTCENT = CENTER
                  DO ICH = 1, NCHAN(KS)
                     IIF = USEIF(ICH)
                     IF( IIF .GT. 0 ) THEN
                        IFREQIF(ICH,KS) = IIF
                        FIFMIN(ICH,KS) = FRF1(IIF,KF)
                        FIFMAX(ICH,KS) = FRF2(IIF,KF)
                     ELSE
                        IFREQIF(ICH,KS) = IIF
                        FIFMIN(ICH,KS) = 0.0D0
                        FIFMAX(ICH,KS) = 0.0D0
                     END IF
                  END DO
               END IF
            END IF
C
         END IF
      END DO
C
C     Some debug printout.
C
      IF( SDEBUG ) THEN
         SETMSG = ' '
         WRITE( SETMSG, '( A, L1, I4, I4, F10.3, I4, 1X, F10.3 )' ) 
     1           'SETFCAT: Match? ', GOT,  KS, USEKF, BESTOVER(KS), 
     2           BESTPRIO, BESTCENT
         CALL WLOG( 0, SETMSG )            
      END IF
C
C     If got a match, process it.
C     For the moment, keep all channels using the same IFREQNUM
C
      IF( GOT ) THEN
         IF( SDEBUG) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, * ) 
     1         'setfcat got one:', ks, usekf, ' ', frname(usekf)
            CALL WLOG( 0, MSGTXT )
         END IF
C
         DO ICH = 1, NCHAN(KS)
            IFREQNUM(ICH,KS) = USEKF
         END DO



C  partially complete coding here.
C ***************  be sure to set something for all channels.
C      This turned into a very bad case of projectus interruptus.
C      I was trying to put in the infrastructure for using more 
C      than 1 freq.dat entry, but now I'm not sure I remember 
C      what I was planning.  At least a lot of the test results
C      are now by channel.  But the second KF has not been 
C      introduced.   Get back to this some day.



C
C        Check if any of the received band is outside the RF bands.
C
         IF( BESTOVER(KS) .LT. TOTBW(KS) ) THEN
            IF( BESTOVER(KS) / TOTBW(KS) .GE. 0.90 ) NBWARN = NBWARN + 1
            IF( NBWARN .LE. 1 .OR. 
     1          BESTOVER(KS) / TOTBW(KS) .LT. 0.90 ) THEN
               CALL WLOG( 1, 'SETFCAT: In setup: ' // SETNAME(KS) )
               CALL WLOG( 1, '         Station '//SETSTA(1,KS) )
               SETMSG = ' '
               WRITE( SETMSG, '( A, F7.2, A, F7.2, A )' )
     1            '         Only ', BESTOVER(KS), ' of ', TOTBW(KS),
     2            ' MHz total bandwidth is within the IFs'
               CALL WLOG( 1, SETMSG )
               CALL WLOG( 1, '         and on the LO side of '//
     1            'any crossover frequencies' )
               CALL WLOG( 1, 
     1            '         in the setup file before any FREQ or ' //
     2            'DOPPLER shifts.' )
               KF = IFREQNUM(1,KS)
               SETMSG = ' '
               WRITE( SETMSG, '( A, A )' ) 
     1            '         IFs defined in frequency group: ', 
     2            FRNAME(KF)(1:LEN1(FRNAME(KF)))
               CALL WLOG( 1, SETMSG )
               IF( BESTOVER(KS) / TOTBW(KS) .GT. 0.98 ) THEN
                  CALL WLOG( 1, '         The loss is small '//
     1               'and may be the result of setting frequencies '//
     2               'for good pulse cal.' )
               END IF
            ELSE IF( NBWARN .EQ. 2 ) THEN
               CALL WLOG( 1, 'SETFCAT: Additional bandwidth '//
     1            'warnings suppressed for small losses.' )
            END IF
         END IF
C
      ELSE
         IF( SDEBUG ) WRITE(*,*) 'setfcat:  No match '
C
C        If there is not a match, write some details about 
C        any near misses.
C
         NBAD = 99
         CALL WLOG( 0, 'SETFCAT: In setup: ' // SETNAME(KS) )
         CALL WLOG( 0, '         Station '//SETSTA(1,KS) )
         CALL WRTMSG( 0, 'SETFCAT', 'freqnomatch' )
         DO KF = 1, NFREQ
            CALL FCOMPARE( KS, KF, MATCH, OKIF, NBAD, .TRUE. )
         END DO
C
C        If needed information from the catalog, complain and die.
C
         IF( NEEDCAT ) THEN
            CALL WLOG( 1, 'SETFCAT:  Inadequate frequency information.'
     1           // '  See the log file for details.' )
            CALL WRTMSG( 0, 'SETFCAT', 'freqcatwarning' )
            CALL ERRSET( KS )
C
C        Otherwise issue a warning.
C
         ELSE
C
C           Finish off the information output.  Make the warning
C           especially strong if it was the VLBA.  Nearly all valid
C           VLBA setups should be covered by freq.dat.
C
            IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) CALL WLOG( 0,
     1              '          Unless this is 3mm, since this is '//
     2              'the VLBA, it is very '//
     3              'likely that there is an error in the setup.' )
            CALL WLOG( 0, '--------------------------------------- ' )
            CALL WLOG( 0, ' ' )
C
C           Don't have a value for IFREQNUM(ICH,KS)
C
            DO ICH = 1, NCHAN(KS)
               IFREQNUM(ICH,KS) = -1
            END DO
         END IF
      END IF
C
C
C
C     Extract all needed information from the frequency catalog.    
C 
C     Initialize the alternative IF spec.
C
      DO ICH = 1, NCHAN(KS)
         ALTIFC(ICH,KS) = '  '
      END DO
C
C ***********************  Allow for multiple IFREQNUMs.
C      write(*,*) 'setfcat: Allow multiple IFREQNUMs.'
C
C       write(*,*) 'setfcat ifreqnum', ifreqnum(1,ks)
      IF( IFREQNUM(1,KS) .GE. 1 ) THEN
         KF = IFREQNUM(1,KS)
         LASTPOL = ' '
         DO ICH = 1, NCHAN(KS)
            KIF = IFREQIF(ICH,KS)
C
C           If the channel didn't have a match, KIF will be zero.
C           That is not a good array index.
C
            IF( KIF .GT. 0 ) THEN
               IF( FIRSTLO(ICH,KS) .EQ. NOTSET )
     1             FIRSTLO(ICH,KS) = FLO1(KIF,KF)
C
C               Set the IFCHAN in SETBBC.  There are issues with 
C               MarkIV that are better handled there.
C
C               IF( IFCHAN(ICH,KS) .EQ. ' ' )
C     1             IFCHAN(ICH,KS) = FIFNAM(KIF,KF)
C
               ALTIFC(ICH,KS) = FALTIF(KIF,KF)
C
C              If setting the polarization, update DUALPOL.
C              It will be false if the polarization was previously
C              unknown.  Jump through a hoop or two because 
C              the first channel might not be getting set yet.
C
               IF( POL(ICH,KS) .EQ. ' ' ) THEN
                  POL(ICH,KS) = FPOL(KIF,KF)
               END IF
               IF( LASTPOL .NE. ' ' .AND. 
     1             POL(ICH,KS) .NE. LASTPOL ) THEN
                  DUALPOL(KS) = .TRUE.
               END IF
               IF( POL(ICH,KS) .NE. ' ' ) LASTPOL = POL(ICH,KS)
C
               IF( SDEBUG ) THEN
                  SETMSG = ' '
                  WRITE( SETMSG, '( A, 4I4, 3F9.2, 1X, 5A )' ) 
     1               'SETFCAT: A ', ICH, KS, KIF, KF, 
     2               FIRSTLO(ICH,KS), FLO1(KIF,KF), FREQREF(ICH,KS),
     3               IFCHAN(ICH,KS), FIFNAM(KIF,KF), ALTIFC(ICH,KS),
     4               POL(ICH,KS), FPOL(KIF,KF)
                  CALL WLOG( 0, SETMSG )
               END IF
            ELSE
C
C              Channel doesn't match.  Leave parameters alone.
C
            END IF
C
         END DO
C
C        The following items are VLBA specific, but involve variables
C        that are not used elsewhere so it doesn't hurt to do for
C        all.
C
C
C        Deal with the DUALX specification.  It will be set .FALSE.
C        if it was not set in the setup file.  This is the mode that
C        allows both "polarizations" at X band to be RCP at 
C        different frequencies.
C
         IF( ( .NOT. DUALX(KS) ) .AND. FDUALX(KF) ) DUALX(KS) = .TRUE.
C
C        Set the 50 cm filter.  The default is 'DEF'.
C
         IF( RCP50CM(KS) .EQ. 'DEF' ) RCP50CM(KS) = FRCP50CM(KF)
         IF( LCP50CM(KS) .EQ. 'DEF' ) LCP50CM(KS) = FLCP50CM(KF)
C
C        Get the FE spec.  This is a bit tricky because it is not
C        indexed by the channel but by the IF (A=1, B=2, C=3, D=4)
C        The ABCD scheme of the VLBA type systems is not changing
C        with the RDBEs.
C
C        It gets tricky for systems that don't follow the VLBA 
C        style convention.  The MarkIV uses 1N, 2N, 1A, 2A
C        but that will all change with the DBBC.  So don't try to
C        deal with it.  There is an ABCD system with the DBBC.
C        I may need to deal with that eventually as it would get
C        through this filter, but might not be right.
C
         DO IIF = 1, FNIF(KF)
            IF( FE(1,KS) .EQ. 'omit' .AND. FIFNAM(IIF,KF) .EQ. 'A' )
     1          FE(1,KS) = FFE(IIF,KF)
            IF( FE(2,KS) .EQ. 'omit' .AND. FIFNAM(IIF,KF) .EQ. 'B' )
     1          FE(2,KS) = FFE(IIF,KF)
            IF( FE(3,KS) .EQ. 'omit' .AND. FIFNAM(IIF,KF) .EQ. 'C' )
     1          FE(3,KS) = FFE(IIF,KF)
            IF( FE(4,KS) .EQ. 'omit' .AND. FIFNAM(IIF,KF) .EQ. 'D' )
     1          FE(4,KS) = FFE(IIF,KF)
         END DO
C
C        Get the synthesizer settings if they were not already set.
C
         DO I = 1, 3
            IF( SYNTH(I,KS) .EQ. 0.D0 ) SYNTH(I,KS) = FSYN(I,KF) 
         END DO
C
C        Setting old VLA parameters removed for SCHED 10.2
C
      END IF
C
C     Set the default 50CM filters if they haven't been set yet.
C
      IF( RCP50CM(KS) .EQ. 'DEF' ) RCP50CM(KS) = 'NARROW'
      IF( LCP50CM(KS) .EQ. 'DEF' ) LCP50CM(KS) = 'NARROW'
C
C     Finally set the BBC and firstlo sidebands and BBC frequencies.
C     The required information should be available by this time.  
C     If anything important was missing, NEEDCAT would have been 
C     set and an error condition would have happened above.
C
      DO ICH = 1, NCHAN(KS)
C
C        First LO sideband.
C
         IF( FREQREF(ICH,KS) .GT. FIRSTLO(ICH,KS) ) THEN
            SIDE1(ICH,KS)   = 'U'
         ELSE
            SIDE1(ICH,KS)   = 'L'
         END IF
C
C        BBC sideband (do consistency check while at it).
C
         IF( NETSIDE(ICH,KS) .EQ. 'U' .AND. SIDE1(ICH,KS) .EQ. 'U' .OR.
     1       NETSIDE(ICH,KS) .EQ. 'L' .AND. SIDE1(ICH,KS) .EQ. 'L' )
     2       THEN
            IF( SIDEBD(ICH,KS) .EQ. 'L' ) THEN
               SETMSG = ' '
               WRITE( SETMSG, '( A, I2, A )' )  
     1             'SETFCAT: Specified BBC sideband for channel ', ICH,
     2             ' not consistent with value deduced from other data'
               CALL WLOG( 1, SETMSG )
               SETMSG = ' '
               WRITE( SETMSG, '( 8X, 6A )' )
     1            '   Netside=', NETSIDE(ICH,KS), 
     2            '   IF sideband=', SIDE1(ICH,KS),
     3            '   BBC sideband=', SIDEBD(ICH,KS)
               CALL WLOG( 1, SETMSG )
               SETMSG = ' '
               WRITE( SETMSG, '( 8X, A, F10.3, A, F10.3 )' )
     1            '   FREQREF=', FREQREF(ICH,KS), 
     2            '   FIRSTLO=', FIRSTLO(ICH,KS)
               CALL WLOG( 1, SETMSG )
               CALL ERRLOG( 'SETFCAT: Setup file: '// SETNAME(KS) )
            END IF
            SIDEBD(ICH,KS) = 'U'
         ELSE IF( NETSIDE(ICH,KS) .EQ. 'U' .AND. SIDE1(ICH,KS) .EQ. 'L'
     1       .OR. NETSIDE(ICH,KS) .EQ. 'L' .AND. SIDE1(ICH,KS) .EQ. 'U'
     2       ) THEN 
            IF( SIDEBD(ICH,KS) .EQ. 'U' ) THEN
               SETMSG = ' '
               WRITE( SETMSG, '( A, I2, A )' )  
     1             'SETFCAT: Specified BBC sideband for channel ', ICH,
     2             ' not consistent with value deduced from other data'
               CALL WLOG( 1, SETMSG )
               WRITE( SETMSG, '( 8X, 6A )' )
     1            '   Netside=', NETSIDE(ICH,KS), 
     2            '   IF sideband=', SIDE1(ICH,KS),
     3            '   BBC sideband=', SIDEBD(ICH,KS)
               CALL WLOG( 1, SETMSG )
               SETMSG = ' '
               WRITE( SETMSG, '( 8X, A, F10.3, A, F10.3 )' )
     1            '   FREQREF=', FREQREF(ICH,KS), 
     2            '   FIRSTLO=', FIRSTLO(ICH,KS)
               CALL WLOG( 1, SETMSG )
               CALL ERRLOG( 'SETFCAT: Setup file: '// SETNAME(KS) )
            END IF
            SIDEBD(ICH,KS) = 'L'
         ELSE
            CALL ERRLOG( 'SETFCAT: Program error: '//NETSIDE(ICH,KS)//
     1        ' '//SIDE1(ICH,KS) )
         END IF
C
C        Set the nominal BBC frequencies if they are needed.
C
         IF( BBSYN(ICH,KS) .EQ. 0.0D0 ) THEN
            BBSYN(ICH,KS) = ABS( FREQREF(ICH,KS) - FIRSTLO(ICH,KS) )
         END IF
C
C        While thinking about sidebands, save the BBC sideband as of this
C        point for use with the VLBA legacy system if reference pointing.
C        The SIDEBD variable can get altered later if the correlator 
C        sideband inversion option is used.  That can make the bookkeeping
C        complicated for the legacy BBC settings.
C
         CRDSIDE(ICH,KS) = SIDEBD(ICH,KS)
C
      END DO
C
      RETURN
      END

      SUBROUTINE PRTSCN( ISCN, CALLER )
C
C     Print identifying information about a scan.  This will mainly
C     be used to help identify a problem scan when an error occurs.
C
      INCLUDE           'sched.inc'
C
      INTEGER           ISCN, ISTA, LEN1, LC, NC
      DOUBLE PRECISION  START, STOP
      INTEGER           YEAR1, YEAR2, DAY1, DAY2
      CHARACTER         CALLER*(*), TFORM*15, TSTOP*8, TSTART*8
C  ------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 1, 'PRTSCN starting.' )
C
C     Say what is happening and who requested it.  This is the only
C     line that goes to the screen at runtime.
C
      CALL WLOG( 0, '  ' )
      MSGTXT = 'PRTSCN: Scan information is being ' //
     1         'written to the log file for ' // CALLER
      CALL WLOG( 1, MSGTXT )
C
C     Get the start and stop times.
C
      CALL TIMEJ( STARTJ(ISCN), YEAR1, DAY1, START )
      CALL TIMEJ( STOPJ(ISCN), YEAR2, DAY2, STOP )
      TSTART = TFORM( START, 'T', 0, 2, 2, '::@' )
      TSTOP  = TFORM( STOP, 'T', 0, 2, 2, '::@' )
C
      MSGTXT = '  '
      WRITE( MSGTXT, '( A, I5 )' )
     1    '  Scan number:  ', ISCN
      CALL WLOG( 0, MSGTXT )
C
      MSGTXT = '  '
      WRITE( MSGTXT, '( A, I4, A, I3.3, A, A )' )
     1    '  Start time:    ', YEAR1, '-', DAY1, '-', TSTART
      CALL WLOG( 0, MSGTXT )
C
      MSGTXT = '  '
      WRITE( MSGTXT, '( A, I4, A, I3.3, A, A )' )
     1    '  Stop time:     ', YEAR2, '-', DAY2, '-', TSTOP
      CALL WLOG( 0, MSGTXT )
C
      MSGTXT = '  '
      WRITE( MSGTXT, '( A, A )' )
     1    '  Source:        ', SCNSRC(ISCN)(1:LEN1(SCNSRC(ISCN)))
      CALL WLOG( 0, MSGTXT )
C
      MSGTXT = ' '
      WRITE( MSGTXT, '( A )' ) '  Station codes: '
      LC = 17
      DO ISTA = 1, NSTA 
         IF( STASCN(ISCN,ISTA) ) THEN
            NC = LEN1( STCODE(STANUM(ISTA)) )
            IF( LC .NE. 17 ) THEN
               WRITE( MSGTXT(LC+1:LC+1), '( A )' ) ','
               LC = LC + 1
            END IF
            WRITE( MSGTXT(LC+1:LC+NC), '( A )' ) 
     1          STCODE(STANUM(ISTA))(1:NC)
            LC = LC + NC
         END IF
      END DO
      CALL WLOG( 0, MSGTXT )
C
      MSGTXT = ' '
      IF( SETNUM(ISCN) .GT. 0 ) THEN
         WRITE( MSGTXT, '( A, A )' ) '  Setup file:    ',
     1      SETFILE(SETNUM(ISCN))(1:LEN1(SETFILE(SETNUM(ISCN))))
      ELSE
         WRITE( MSGTXT, '( A, A )' ) '  Setup file number ', 
     1      SETNUM(ISCN)
      END IF
      CALL WLOG( 0, MSGTXT )
C
      MSGTXT = ' '
      MSGTXT = '  Scan Comment:  ' //  ANNOT(ISCN)
      CALL WLOG( 0, MSGTXT )
      MSGTXT = ' '
C
      RETURN
      END

      SUBROUTINE VXTON2( IPS, ISET, NLOCHN, LO, SIDE, BBCWID, TONINT, 
     1    NTONE, TNCHN, NTNCHN, ITNCHN )
C
C     Subroutine returns the number of tones in each channel
C     and the sequence they are. Tone zero is level statistics.
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 020896
C     revised to deal with PSETI and FSETI 180699, Huib
C     Removing pcal sets.  Sep. 2013  RCW.
C         Eventually get the desired tone numbers from new variables
C         in the setup file or frequency set.  But that's not done yet.
C
C     Inputs are
C         IPS: override ISET values with these if IPS > 0
C         NLOCHN: Number of frequency channels
C         LO:     Sum LO, double precision!
C         SIDE:   Net side band
C         BBCWID:  Filter width
C         TONINT: Interval for tones
C     Output
C         NTONE:   Number of idependent tone setting
C         TNCHN: list of NCHAN values, linking a channel to a tone def
C         NTNCHN(ICHAN): Number of tones detected per channel
C         ITNCHN(MAXTON,NLOCHN): indicating the tones to detect
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
C
C     Parameterize the number of detectors.  MAXPC, set in schset.inc,
C     is the maximum number of detectors, each of which has two 
C     channels.
C     MAXTON=16 is the maximum number of tones
C     MAXPC is 8 now, soon to be 16.
C
      INTEGER NLOCHN, NTNCHN(NLOCHN), ITNCHN(MAXTON,NLOCHN)
Cf2py intent(out) NTNCHN
Cf2py intent(out) ITNCHN
      INTEGER NTONE, TNCHN(NLOCHN)
Cf2py intent(out) NTONE
Cf2py intent(out) TNCHN
      DOUBLE PRECISION LO(NLOCHN), DTONINT
      REAL TONINT, BBCWID(NLOCHN)
      CHARACTER SIDE(NLOCHN)*1
C
      INTEGER    ID, IP, ICT, IDD, ICH, IDETECT, IPS, JCH, ISET
      INTEGER    TONE1(MCHAN), TONE2(MCHAN), TONE3(MCHAN)
      INTEGER    INTBW, NTPB
      INTEGER    PCF1(MAXPC), PCF2(MAXPC)
      INTEGER    NTNTMP(MAXCHN), ITNTMP(MAXTON,MAXCHN)
      REAL       RTONE1
      CHARACTER  PCX1(MAXPC)*3, PCX2(MAXPC)*3
      CHARACTER  PCALC1*3, TWOCHR*2, PXXS*3
      LOGICAL    UNIQUE, SAME
C ----------------------------------------------------------------------
C     Avoid variable type problems later.
C
      DTONINT = DBLE( TONINT )
C
C     Find the tone frequencies that might be of interest,
C     namely the lowest and highest frequency ones in the 
C     bandpass.  Count the tones of interest (0, 1, 2, or 3).
C     Zero will mean just do state counts.
C     Avoid tones at the band edges (0 and BBFILT).
C     RTONE1 is the tone frequency in MHz (real).
C     TONE1 etc are the tone frequencies in kHz (integer).
C
      DO ICH = 1, NLOCHN
         NTNTMP(ICH) = 0
      END DO
C
C     This routine can be used to calculate tones in IPS or ISET
C       RCW:  This routine is always called with IPS=-1.  PSX1 is
C             being dropped, so comment out the reference.
C     
C
C      IF( IPS.GT. 0 ) THEN
C         PXXS = PSX1(1,IPS) 
C      ELSE
         PXXS = PCALX1(1,ISET)
C      END IF
C
C     When not explicitly set, calculate
C
      IF( PXXS .EQ. ' ' ) THEN
         IF( DTONINT .GT. 0.D0 ) THEN
            DO ICH = 1, NLOCHN
               INTBW = 1000 * BBCWID(ICH)
C     
C           Get the first tone.
C
               IF( SIDE(ICH).EQ.'U'.AND.LO(ICH).NE.0.D0 ) THEN
                  TONE1(ICH) = DNINT( 1.D3 * 
     1                ( DTONINT - MOD( LO(ICH), DTONINT ) ) )
                  IF( TONE1(ICH) .EQ. 0 ) 
     1                TONE1(ICH) = DNINT( DTONINT * 1000.D0 )
                  IF( TONE1(ICH) .LT. INTBW ) NTNTMP(ICH) = 1
                  RTONE1 = TONE1(ICH) / 1000.0
               ELSE IF(SIDE(ICH).EQ.'L' .AND. LO(ICH).NE.0.D0) 
     1                THEN
                  TONE1(ICH) = DNINT( 1.D3 * MOD( LO(ICH), DTONINT ))
                  IF( TONE1(ICH) .EQ. 0 ) 
     1                TONE1(ICH) = DNINT( DTONINT * 1000.D0 )
                  IF( TONE1(ICH) .LT. INTBW ) NTNTMP(ICH) = 1
                  RTONE1 = TONE1(ICH) / 1000.0
               END IF
C     
C              Get the second tone.  The 0.005 prevents the tone from
C              ending up right on the band edge.
C
               IF( NTNTMP(ICH) .EQ. 1 .AND. 
     1             BBCWID(ICH) - RTONE1 .GT. TONINT ) THEN
                  NTPB = ( BBCWID(ICH) - RTONE1 - 0.005 ) / TONINT
                  TONE2(ICH) = TONE1(ICH) + 
     1                NINT( NTPB * TONINT * 1000.0 )
                  NTNTMP(ICH) = 2
C     
C                 Get the third tone if there is room.
C
                  IF( NTPB .GT. 1 ) THEN
                     NTNTMP(ICH) = 3
                     TONE3(ICH) = TONE1(ICH) + NINT( TONINT * 1000.0 )
                  END IF                  
C
               END IF
            END DO
         END IF
C
C        Loop through the channels assigning the low tones.
C        ID is a detector count.  IP is the detection unit of
C        which there are MAXPC.  ICT is the channel.
C
         ID = 0
C
         DO ICH = 1, NLOCHN
            IF( NTNTMP(ICH) .GE. 1 .AND. ID .LT. MAXTON ) THEN
               ID = ID + 1
               IP = ( ID + 1 ) / 2
               ICT = 1 + MOD( ID + 1, 2 )
               WRITE( PCALC1, '(A,I2)' ) 'S', ICH
               IF( ICH .LT. 10 ) PCALC1 = PCALC1(1:1)//PCALC1(3:3)//' '
               IF( ICT .EQ. 1 ) THEN
                  PCX1(IP) = PCALC1
                  PCF1(IP) = TONE1(ICH)
               ELSE
                  PCX2(IP) = PCALC1
                  PCF2(IP) = TONE1(ICH)
               END IF
            END IF
         END DO
C
C        Now do the high frequency tones (tone2).
C
         DO ICH = 1, NLOCHN
            IF( NTNTMP(ICH) .GE. 2 .AND. ID .LT. MAXTON ) THEN
               ID = ID + 1
               IP = ( ID + 1 ) / 2
               ICT = 1 + MOD( ID + 1, 2 )
               WRITE( PCALC1, '(A,I2)' ) 'S', ICH
               IF( ICH .LT. 10 ) PCALC1 = PCALC1(1:1)//PCALC1(3:3)//' '
               IF( ICT .EQ. 1 ) THEN
                  PCX1(IP) = PCALC1
                  PCF1(IP) = TONE2(ICH)
               ELSE
                  PCX2(IP) = PCALC1
                  PCF2(IP) = TONE2(ICH)
               END IF
            END IF
         END DO
C
C        Now do the state counts.  If 2 bit, use a pair of detectors.
C        If this means skipping a detector, assign it to S1, freq 0.
C
         DO ICH = 1, NLOCHN
            IF( ID .LT. MAXTON ) THEN
               ID = ID + 1
               IP = ( ID + 1 ) / 2
               ICT = MOD( ID + 1, 2 ) + 1
               IF( BITS(ICH,ISET) .EQ. 2 .AND. ICT .EQ. 2 ) THEN
                  PCX2(IP) = 'S1'
                  PCF2(IP) = 0
                  ID = ID + 1
                  IP = IP + 1
                  ICT = 1
               END IF
               IF( ID .LE. MAXTON ) THEN
                  WRITE( PCALC1, '(A,I2)' ) 'S', ICH
                  IF(ICH .LT. 10) PCALC1 = PCALC1(1:1)//PCALC1(3:3)//' '
                  IF( ICT .EQ. 1 ) THEN
                     PCX1(IP) = PCALC1
                     PCF1(IP) = 0
                  ELSE
                     PCX2(IP) = PCALC1
                     PCF2(IP) = 0
                  END IF
                  IF( BITS(ICH,ISET) .EQ. 2 ) THEN
                     PCX2(IP) = 'M'//PCALC1(2:3)
                     PCF2(IP) = 0
                     ID = ID + 1
                  END IF
               END IF
            END IF
         END DO
C
C        Finally do the middle frequency tones (tone3).
C
         DO ICH = 1, NLOCHN
            IF( NTNTMP(ICH) .GE. 3 .AND. ID .LT. MAXTON ) THEN
               ID = ID + 1
               IP = ( ID + 1 ) / 2
               ICT = 1 + MOD( ID + 1, 2 )
               WRITE( PCALC1, '(A,I2)' ) 'S', ICH
               IF( ICH .LT. 10 ) PCALC1 = PCALC1(1:1)//PCALC1(3:3)//' '
               IF( ICT .EQ. 1 ) THEN
                  PCX1(IP) = PCALC1
                  PCF1(IP) = TONE3(ICH)
               ELSE
                  PCX2(IP) = PCALC1
                  PCF2(IP) = TONE3(ICH)
               END IF
            END IF
         END DO
C
C        If not all detectors have been used, turn off the rest.
C
         IF( ID .LT. MAXTON ) THEN
            DO IDD = ID + 1, MAXTON
               IP = ( IDD + 1 ) / 2
               ICT = MOD( IDD + 1, 2 ) + 1
               IF( ICT .EQ. 1 ) THEN
                  PCX1(IP) = 'off'
                  PCF1(IP) = 0
               ELSE
                  PCX2(IP) = 'off'
                  PCF2(IP) = 0
               END IF
            END DO
         END IF
C
      ELSE 
C
C        Use the values from the PCal set or setup file
C        RCW:  Again, IPS always=-1 and PS variable are being
C        dropped, so comment them out.
C
C         IF( IPS .GT. 0 ) THEN
C            DO IP = 1, MAXPC
C               PCX1(IP) = PSX1(IP,IPS)
C               PCX2(IP) = PSX2(IP,IPS)
C               PCF1(IP) = PSFR1(IP,IPS)
C               PCF2(IP) = PSFR2(IP,IPS)
C               IF( PCX1(IP) .EQ. ' ' ) PCX1(IP) = 'off'
C               IF( PCX2(IP) .EQ. ' ' ) PCX2(IP) = 'off'
C            END DO
C         ELSE
            DO IP = 1, MAXPC
               PCX1(IP) = PCALX1(IP,ISET)
               PCX2(IP) = PCALX2(IP,ISET)
               PCF1(IP) = PCALFR1(IP,ISET)
               PCF2(IP) = PCALFR2(IP,ISET)
               IF( PCX1(IP) .EQ. ' ' ) PCX1(IP) = 'off'
               IF( PCX2(IP) .EQ. ' ' ) PCX2(IP) = 'off'
            END DO
C         END IF
C
      END IF
C
C     Temporarily, we need upper case for PCX1 and PCX1
C
      DO IP = 1, MAXPC
         CALL UPCASE( PCX1(IP) )
         CALL UPCASE( PCX2(IP) )
      END DO
C
C     Now write out the pcal commands (assuming setup information
C     of any sort was available.)
C
      DO ICH = 1, MAXCHN
         NTNTMP(ICH) = 0
      END DO
C
      DO IP = 1, MAXPC
         IF( PCX1(IP) .NE. 'OFF' ) THEN
            READ(PCX1(IP), '( 1X, A )' ) TWOCHR
            READ( TWOCHR, * ) ICH
            NTNTMP(ICH) = NTNTMP(ICH) + 1
            IF( PCF1(IP) .LT. 1E-5 ) THEN 
               IDETECT = 0
            ELSE
               IDETECT = INT(PCF1(IP)/(1E3*TONINT)) + 1
            END IF
            ITNTMP(NTNTMP(ICH),ICH) = IDETECT
         END IF
C
C        Second detector, ignore M-bit settings, covered by #1
C
         IF( PCX2(IP) .NE. 'OFF' .AND. PCX2(IP)(1:1) .NE. 'M' ) THEN
            READ(PCX2(IP), '( 1X, A )' ) TWOCHR
            READ(TWOCHR,*) ICH
            NTNTMP(ICH) = NTNTMP(ICH) + 1
            IF( PCF2(IP) .LT. 1E-5 ) THEN 
               IDETECT = 0
            ELSE
               IDETECT = INT(PCF2(IP)/(1E3*TONINT)) + 1
            END IF
            ITNTMP(NTNTMP(ICH),ICH) = IDETECT
         END IF
      END DO
C
C     Count and store the unique ones.
C
      NTONE = 0
      DO ICH = 1, NLOCHN
         IF( ICH .EQ. 1 ) THEN 
            UNIQUE = .TRUE.
         ELSE
            UNIQUE = .TRUE.
            DO JCH = 1, ICH-1
               IF( NTNTMP(ICH) .EQ. NTNTMP(JCH) ) THEN
                  SAME = .TRUE.
                  DO IP = 1, NTNTMP(ICH)
                     IF( ITNTMP(IP,ICH) .NE. ITNTMP(IP,JCH) ) 
     1                   SAME = .FALSE.
                  END DO
                  IF ( SAME ) THEN 
                     UNIQUE = .FALSE.
                     TNCHN(ICH) = TNCHN(JCH)
                  END IF
               END IF
            END DO
         END IF
         IF( UNIQUE )  THEN
            NTONE = NTONE + 1
            TNCHN(ICH) = NTONE
            NTNCHN(NTONE) = NTNTMP(ICH)
            DO IP = 1, NTNCHN(NTONE)
               ITNCHN(IP,NTONE) = ITNTMP(IP,ICH)
            END DO
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE UVQUAL( IC, FLAG, QUALITY, TOP5, INFOLINE )
C
C     Routine for the UV coverage optimization that measures the
C     quality of an array.
C
C     IC is a loop index over combinations.
C
C     FLAG tells which stations to use.  If 0, don't.  If 1, will
C     use in all configurations (maybe set up to calcualate once),
C     If 2, use in this array.
C
C     QUALITY is any quality measure where high is good.
C
C     In this incarnation, the number of sampled cells will be
C     counted.  The cells are on a polar, logarithmic grid.
C     Many parameters will be hard wired for now, but maybe 
C     change that later.
C
C     Note that calculations are done for both ends of scans, so
C     it is probably best to have DUR = GAP in the schedule.
C
      INCLUDE       'sched.inc'
      INCLUDE       'plot.inc'
C
      INTEGER       IC, FLAG(*)
      REAL          QUALITY
      REAL          QUALSRC(MAXSRC), TOP5(5,*), BUFFER
      INTEGER       ISTA, JSTA, ISRC, ISCN, IE, C1, CN, I
      INTEGER       LINELEN
      REAL          U1(MAXSTA), U2(MAXSTA), V1(MAXSTA), V2(MAXSTA)
      REAL          UU(2), VV(2)
      LOGICAL       USIT(MAXSTA)
      CHARACTER     INFOLINE*(*)
      REAL          MFS1, MFSINC
C
C     Set up the grid.  Use an even number of theta bins or the
C     fast hermitian scheme won't work (need symmetric).
C
      INTEGER       NR, NT, MNR, MNT, MSR
      PARAMETER     (MNR=100)
      PARAMETER     (MNT=180)
      PARAMETER     (MSR=10)
      REAL          LFMIN, LFMAX, LFINC, RCELL
      REAL          TRINC, RCELL2, FBW
      REAL          GRSUM, GRSUM2, AVG, RMS, VX
      INTEGER       CELLACC(MNR,MNT), IR, IT, W02, IB
      INTEGER       CELLALL(MNR,MNT,MSR), NSR
      LOGICAL       FIRST, NEWBAS, VLAPASS
C --------------------------------------------------------------------
      IF( GRIDMEAS .NE. 'RMS' .AND. GRIDMEAS .NE. 'COUNT' ) THEN
         MSGTXT = 'UVQUAL: Incorrect GRIDMEAS - ' // GRIDMEAS 
         CALL ERRLOG( MSGTXT )
      END IF
      FIRST = IC .EQ. 1
C
C     Hard wire in whether to limit to VLA baselines.
C
      IF( GRIDVLA ) THEN
         IF( FIRST ) WRITE( IOPT, * ) 'UVQUAL: Only using VLA baselines'
         IF( MOD(IC,100) .EQ. 0 ) THEN 
            CALL WLOG( 1, 'UVQUAL: Only using VLA baselines' )
         END IF
      END IF
C
C     Get parameters for testing of multiple lines for MFS.
C     MFSRAT is the ratio of the upper to the lower frequency.
C     NMFS is the number of frequencies to use.  Both are from the user.
C
      IF( NMFS .GT. 1 ) THEN
         MFS1 = 2.0 / ( 1.0 + MFSRAT )
         MFSINC = MFS1 * ( MFSRAT - 1.0 ) / ( NMFS - 1 )
      ELSE
         MFS1 = 1.0
         MFSINC = 0.0
      END IF
C
C     Get some parameters from the includes into the short name
C     versions to help once we are deep in nested DO's and IF's
C     and have to live with the limited line length.
C
      NSR = 0
      NR = GRIDNR
      NT = GRIDNT
      IF( NR .GT. MNR .OR. NT .GT. MNT ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, 4I7 )' ) 
     1       'UVQUAL: GRIDNR or GRIDNT too big: ', GRIDNR,
     2       GRIDNT, MNR, MNT
         CALL WLOG( 1, MSGTXT )
         CALL ERRLOG( 'UVQUAL:  Decrease inputs or up limits.' )
      END IF
C
C     Loop over sources, only keeping those selected for plotting.
C
      W02 = GRIDW0**2
      LFMIN = LOG( GRIDMIN + SQRT( GRIDMIN**2 + W02 ) )
      LFMAX = LOG( GRIDMAX + SQRT( GRIDMAX**2 + W02 ) )
      LFINC = ( LFMAX - LFMIN ) / NR
      TRINC = 360.0 * RADDEG / NT
      QUALITY = 0.0
      DO ISRC = 1, NSRC
         IF( PSOBCK(ISRC) .EQ. 1 ) THEN
            NSR = NSR + 1
C
C           Get the factor to stretch the grid in V.
C           This is rather experimental at the moment.
C
            VX = 0.9 / COS( 34.0 * RADDEG - DECP(SRCATN(ISRC)) )
C
C           Initialize the accumulator
C
            DO IT = 1, NT
               DO IR = 1, NR
                  CELLACC(IR,IT) = 0
                  IF( FIRST ) CELLALL(IR,IT,NSR) = 0
               END DO
            END DO
C
C           Loop over scans keeping only those on the target source.
C
            DO ISCN = SCAN1, SCANL
               IF( SRLSTN(SRCNUM(ISCN)) .EQ. ISRC ) THEN
C
C                 Loop over stations to determine if they are used
C                 and to collect the station UV values.
C      
                  DO ISTA = 1, NSTA
                     USIT(ISTA) = STASCN(ISCN,ISTA) .AND. 
     1                   UP1(ISCN,ISTA) .EQ. ' ' .AND.
     2                   UP2(ISCN,ISTA) .EQ. ' ' .AND.
     3                   FLAG(ISTA) .GT. 0
                     IF( USIT(ISTA) ) THEN
                        CALL STAUV( ISCN, ISTA, U1(ISTA), U2(ISTA), 
     1                              V1(ISTA), V2(ISTA) ) 
                     END IF
                  END DO
C
C                 Now get the UV values
C
                  DO ISTA = 1, NSTA - 1
                     IF( USIT(ISTA) ) THEN
                        DO JSTA = ISTA + 1, NSTA
C
C                          Some restrictions.  Flag baselines that
C                          might change so we can avoid repeating those
C                          that don't.  Also have option to restrict
C                          to baselines to the VLA.
C
                           NEWBAS = FLAG(ISTA) .EQ. 2 .OR. 
     1                          FLAG(JSTA) .EQ. 2 
                           VLAPASS = .NOT. GRIDVLA .OR.
     1                          ( STANAME(ISTA)(1:3) .EQ. 'VLA' .OR.
     1                          STANAME(ISTA)(1:3) .EQ. 'VLA' )
C
                           IF( USIT(JSTA) .AND. ( FIRST .OR. 
     1                          NEWBAS ) .AND. VLAPASS ) THEN
C
C                             Get the baseline U and V, with V
C                             scaled to take into account 
C                             foreshortening.  I think this is a
C                             faster way to do it than changing the
C                             grid.
C
                              UU(1) = U1(ISTA) - U1(JSTA)
                              VV(1) = VX * ( V1(ISTA) - V1(JSTA) )
                              UU(2) = U2(ISTA) - U2(JSTA)
                              VV(2) = VX * ( V2(ISTA) - V2(JSTA) )
C                   
C                             Do some bandwidth synthesis as specified
C                             by the user with UVMFS
C
                              DO IB = 1, NMFS
                                 FBW = MFS1 + ( IB - 1 ) * MFSINC
C
C                                Increment the cell counts.
C                                Don't forget the conjugate points.
C                                If R is out of range, don't count.
C                           
                                 DO IE = 1, 2
                                    RCELL2 = ( FBW * UU(IE) )**2 + 
     1                                       ( FBW * VV(IE) )**2
                                    RCELL = ( LOG( SQRT( RCELL2 ) +
     1                                   SQRT( RCELL2 + W02 ) )
     2                                   - LFMIN ) / LFINC
                                    IR = RCELL + 1.0
                                    IF( IR .GE. 1 .AND. 
     1                                  IR .LE. NR ) THEN
                                       IT = 1 + ATAN2(VV(IE),UU(IE)) / 
     1                                      TRINC
                                       IF( IT .LT. 1 ) 
     1                                     IT = IT + NT
                                       IF( IT .GT. NT ) THEN
                                           MSGTXT = ' '
                                           WRITE( MSGTXT, '( A, 2I5 )' )
     1                                        'UVQUAL bad NT ', NT, IT
                                           CALL WLOG( 1, MSGTXT )
                                       END IF
                                       IF( NEWBAS ) THEN
                                          CELLACC(IR,IT) = 
     1                                      CELLACC(IR,IT) + 1
                                       ELSE
                                          CELLALL(IR,IT,NSR) = 
     1                                      CELLALL(IR,IT,NSR) + 1
                                       END IF
C                           
C                                      Get the hermitian point.
C                           
                                       IT = IT + NT / 2
                                       IF( IT .GT. NT ) IT = IT - NT
                                       IF( NEWBAS ) THEN
                                          CELLACC(IR,IT) = 
     1                                      CELLACC(IR,IT) + 1
                                       ELSE
                                          CELLALL(IR,IT,NSR) = 
     1                                      CELLALL(IR,IT,NSR) + 1
                                       END IF
                                    END IF
                                 END DO
C                           
C                                This UV point accumulated.
C                   
                              END DO
                           END IF
                        END DO
                     END IF
                  END DO
C
C                 All stations done.
C
               END IF
            END DO
C
C           All scans done.
C
            IF( GRIDMEAS .EQ. 'COUNT' ) THEN
C
C              Get the quality measure for this source using count 
C              of filled cells.
C
               QUALSRC(ISRC) = 0.0
               DO IT = 1, NT
                  DO IR = 1, NR
                     IF( CELLACC(IR,IT) + CELLALL(IR,IT,NSR) .GE. 1 )
     1                   THEN
                        QUALSRC(ISRC) = QUALSRC(ISRC) + 1.0
                     END IF
                  END DO
               END DO
               QUALSRC(ISRC) = QUALSRC(ISRC) / ( NR * NT )
               QUALITY = QUALITY + QUALSRC(ISRC)
C
            ELSE IF( GRIDMEAS .EQ. 'RMS' ) THEN
C
C              Try an rms quality measure.  Note the rest of the
C              program is set up to take the highest value as
C              the best while we want the smallest RMS.  So invert.
C
               QUALSRC(ISRC) = 0.0
               GRSUM = 0.0
               GRSUM2 = 0.0
               DO IT = 1, NT
                  DO IR = 1, NR
                     GRSUM = GRSUM + CELLACC(IR,IT) + CELLALL(IR,IT,NSR)
                     GRSUM2 = GRSUM2 + 
     1                   ( CELLACC(IR,IT) + CELLALL(IR,IT,NSR) )**2
                  END DO
               END DO
               AVG = GRSUM / ( NR * NT )
               RMS = SQRT( ( GRSUM2 / ( NR * NT ) ) - AVG**2 )
               QUALSRC(ISRC) = SQRT( AVG ) / RMS
               QUALITY = QUALITY + QUALSRC(ISRC)
            ELSE
               CALL WLOG( 1, 'UVQUAL: Bad quality measure spec.' //
     1              '  Programming problem.' )
               STOP
            END IF
         END IF
      END DO
C
C     All sources done.
C
C     Write a line of information for the best arrays.
C
      LINELEN = LEN( INFOLINE )
      INFOLINE = ' '
      WRITE( INFOLINE, '( I7, F7.4 )' ) IC, QUALITY
      CN = 14
      DO ISRC = 1, NSRC
         IF( PSOBCK(ISRC) .EQ. 1 ) THEN
            C1 = CN + 1
            CN = C1 + 6
            WRITE( INFOLINE(C1:CN), '( F7.4 )' ) QUALSRC(ISRC)
         END IF
      END DO
      DO ISTA = 1, NSTA
         IF( FLAG(ISTA) .GE. 2 ) THEN
            C1 = CN + 2
            CN = C1 + 7
            IF( CN .LE. LINELEN ) THEN
               WRITE( INFOLINE(C1:CN), '( A )' ) STANAME(ISTA)
            END IF
         END IF
      END DO      
C
C     Get the current best values for each source
C
      DO ISRC = 1, NSRC
         IF( PSOBCK(ISRC) .EQ. 1 .AND. QUALSRC(ISRC) .NE. 0.0 ) THEN
            IF( QUALSRC(ISRC) .GT. TOP5(5,ISRC) ) 
     1           TOP5(5,ISRC) = QUALSRC(ISRC)
            DO I = 4, 1, -1
               IF( TOP5(I+1,ISRC) .GT. TOP5(I,ISRC) ) THEN
                  BUFFER = TOP5(I+1,ISRC)
                  TOP5(I+1,ISRC) = TOP5(I,ISRC)
                  TOP5(I,ISRC) = BUFFER
               END IF
            END DO
         END IF
      END DO
C
C     Use the MAXSRC cell of TOP5 to store similar info
C     for the overall quality factor.
C
      ISRC = MAXSRC
      IF( QUALITY .GT. TOP5(5,ISRC) ) 
     1     TOP5(5,ISRC) = QUALITY
      DO I = 4, 1, -1
         IF( TOP5(I+1,ISRC) .GT. TOP5(I,ISRC) .AND. 
     1         QUALITY .NE. 0 ) THEN
            BUFFER = TOP5(I+1,ISRC)
            TOP5(I+1,ISRC) = TOP5(I,ISRC)
            TOP5(I,ISRC) = BUFFER
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE RESYNC
C
C     Routine called by CHKSCN that tries to predict the time that the
C     correlator will start to deliver good data for each scan/station
C     (TCORR).  This is just synchronized correlation with no consideration
C     of slew or band switch times.  This can be used to look for excessive
C     time lost to resync etc.  Resyncs are required when the recording
C     medium is started after being stopped and when a formatter reconfigure
C     knocks the correlator out of sync by giving invalid time codes
C     (constant time in the VLBA case).
C
C     With the RDBE/MARK5C system and DiFX, the scans actually start at
C     TONSRC and there are no resync or reconfigure losses.  So deal with
C     that simple case early, but do put in values for TCORR as that is
C     one possible item for the summary.
C
C     Assumed sync times:
C         Old VLBA correlator with tape (time/speedup): 8s/1   13s/2   25s/4
C         Old VLBA correlator with disk:  tape resync + 10s (improve soon?)
C         VLBADIFX - instant sync.
C         Others (JIVE, Bonn, Haystack) with disk: 1s
C     Assumed reconfigure times (need confirmation):
C         VLBA Formatter: 8 sec.
C         MarkIV Formatter: 3 sec.  But no big effect on resync.
C         RDBE - 5 seconds
C     A reconfigure slows sync on the correlator. 
C         Old VLBA:  Add 7s to reconfigure+resync 
C            Much longer sync times occur on 10-20% of stations
C         JIVE:  20-30s.  Call it 25s.  Consistent?
C              This is when station setup really changes (subjob change),
C              not just a reconfigure, which happens every scan on MkIV.
C         DiFX:  instant.
C         Others:  Not sure, assume no effect.
C
C     Note that a pcal detector change triggers a reconfigure in VLBA
C     formatters, but not MarkIV formatters (they don't have detectors).
C
C     Note: LSCN is the last scan the station was in.
C           LRSCN was the last scan with FORMAT not equal 'NONE'.
C           TCORR(ISCN,ISTA) is the time the correlator is expected to be
C                synced up.
C           NRECONF(1,ISTA) is the total number of reconfigures at the 
C                station
C           NRECONF(2,ISTA) is the number of reconfigures at the 
C                station done while recording.
C           TTSYNC is the total time lost to resynchronizing.
C           TRECON is the time any reconfigure was expected to be done.
C
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER    ISCN, ISTA, LSCN, LRSCN, KS
      INTEGER    NSSCAN, NRWARN
      LOGICAL    RECWARN, NEWCONF, NEWPCAL, CONFIGW
      LOGICAL    SCNRCF, NEWSYNC
      DOUBLE PRECISION  TRECON, TSADD, TTADD
      DATA       NRWARN / 0 /
      SAVE       NRWARN
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'RESYNC starting' )
C
C
      RECWARN = .FALSE.
      CONFIGW = .FALSE.
      DO ISTA = 1, NSTA
         LSCN = 0
         LRSCN = 0
         NRECONF(1,ISTA) = 0
         NRECONF(2,ISTA) = 0
         TTSYNC(ISTA) = 0.0
         NSSCAN = 0
         DO ISCN = SCAN1, SCANL
            TCORR(ISCN,ISTA) = 0.D0
C
C           Deal with the simple case of RDBE/MARK5C and DiFX.  
C           Also applies to DBBC going to DiFX.
C           Eventually see if the DBBC and/or JIVE correlator 
C           should be here.
C
            IF( USEONSRC(STANUM(ISTA)) .AND.
     1          ( CORREL(1:7) .EQ. 'SOCORRO' .OR.
     2            CORREL(1:8) .EQ. 'VLBADIFX' .OR.
     3          CORREL(1:4) .EQ. 'VLBA' ) ) THEN
C
               TCORR(ISCN,ISTA) = 
     1            MAX( ( STARTJ(ISCN) - TPSTART(ISCN,ISTA) ),  
     2                   TONSRC(ISCN,ISTA) )
               TTSYNC(ISTA) = 0.D0
C
C           Deal with the other cases.
C
            ELSE IF( STASCN(ISCN,ISTA) ) THEN
               KS = NSETUP(ISCN,ISTA)
               NSSCAN = NSSCAN + 1
               SCNRCF = .FALSE.
               TRECON = 0.D0
C
C              Set the default TCORR for a scan the station is in. This
C              assumes the correlator is synced from the previous scan
C              and the media has not stopped.  Note TPSTART=0 for non
C              recording scans, which gives the desired behavior.
C
               TCORR(ISCN,ISTA) = STARTJ(ISCN) - TPSTART(ISCN,ISTA)
C
C         write(*,*) 'resync: tcorr ', TCORR(ISCN,ISTA), 
C     1          '  startj:', STARTJ(ISCN), 
C     2          '  tpstart:',  TPSTART(ISCN,ISTA), 
C     3          MINPAUSE(1), PRESTART(1)
C
C              Deal with formatter reconfigures.  Note that a VLBA 
C              reconfigure will start at the end time of the previous 
C              scan, which could be before the start of the current 
C              scan.  This is because there really is a non-recording 
C              scan in the gap with the setup of the following scan.  
C              For MarkIV, there is a reconfigure every scan which takes
C              about 3 seconds, but doesn't cause correlator problems.
C
C              If FORMAT='NONE', the formatter is not used, or reconfigured,
C              at least for VLBA systems so set TCORR to the start time.
C              Vex systems don't currently tolerate FORMAT='NONE' scans.
C
C              TRECON is the time when the reconfigure, if any, is over.
C              The reconfiguration will not happen during a preceeding scan
C              even if that scan is not recording, so use the stop time
C              of the last scan of any type as the start of the reconfigure.
C              But only test for the need to reconfigure against the 
C              last scan that did not have FORMAT='NONE'.
C              Don't worry about any of this with FORMAT='NONE' scans.
C              Note that a reconfigure can happen during a non-recording
C              scan but that is accounted for automatically.
C              Assume that the reconfigure is over by the end of the scan.
C              This might not always be true, but the effort to deal with
C              exceptions doesn't seem worth it.
C
C              The JIVE correlator takes 20-30 seconds to sync after the 
C              station units have to change configuration - which happens
C              by the same criteria as VLBA reconfigures except that they
C              are not subject to pcal detector setups.
C
               IF( FORMAT(KS) .EQ. 'NONE' ) THEN
                  TCORR(ISCN,ISTA) = STARTJ(ISCN) - TPSTART(ISCN,ISTA)
               ELSE
                  CALL RECONFIG( ISCN, LRSCN, ISTA, NEWCONF, NEWPCAL )
C
C                 VLBA Formatter.
C
                  IF( DAR(STANUM(ISTA))(1:4) .EQ. 'VLBA' ) THEN
                     IF( NEWCONF .OR. NEWPCAL ) THEN
C         
                        IF( LSCN .EQ. 0 ) THEN
                           TRECON = STARTJ(ISCN) - 20.D0 / 86400.D0
                        ELSE
                           TRECON = MIN( STOPJ(LSCN) + 8.D0 / 86400.D0, 
     1                                STOPJ(ISCN) )
                        END IF
                        NRECONF(1,ISTA) = NRECONF(1,ISTA) + 1
C         
C                       Count and flag reconfigures during recording.
C         
                        IF( TRECON .GT. STARTJ(ISCN) - 
     1                       TPSTART(ISCN,ISTA) ) THEN
                           NRECONF(2,ISTA) = NRECONF(2,ISTA) + 1
                           SCNRCF = .TRUE.
                        END IF
C                    
                     END IF
C
C                 MarkIV formatter.  There is a reconfigure every scan, but
C                 they don't seem to knock the VLBA correlator out of sync.
C                 Don't count them, but assume that TRECON is 3 sec after
C                 recording start.  But if there is a real change of setup,
C                 requiring a new subjob at JIVE, count that as a reconfigure.
C                 Assume it won't affect VLBA playback so don't set SCNRCF.
C                 As for JIVE playback, NEWCONF is an adequate test for
C                 a long sync.
C
                  ELSE IF( DAR(STANUM(ISTA))(1:4) .EQ. 'MKIV' ) THEN
C
                     TRECON = MIN( TCORR(ISCN,ISTA) + 3.D0 / 86400.D0,
     1                             STOPJ(ISCN) )
                     IF( NEWCONF ) THEN
                        NRECONF(1,ISTA) = NRECONF(1,ISTA) + 1
                     END IF
C
C                 Others - unknown so set TRECON to stop time, but don't
C                 count reconfigures.  This will include DAR=RDBE
C
                  ELSE IF( NEWCONF ) THEN
                     IF( LSCN .EQ. 0 ) THEN
                        TRECON = STARTJ(ISCN) - 20.D0 / 86400.D0
                     ELSE
                        TRECON= STOPJ(LSCN)
                     END IF
                  END IF
C
C                 Get the time that we expect the correlator to be
C                 synced.  The considerations are different for the
C                 different correlators.  TSADD is the time to add
C                 to the later of TRECON or the record start time
C                 to get the sync time.
C
                  TSADD = 0.D0
C
C                 Start with the old VLBA hardware correlator.
C
                  IF( LSCN .EQ. 0 ) THEN
                     NEWSYNC = .TRUE.
                  ELSE
                     NEWSYNC = ( STARTJ(ISCN) - TPSTART(ISCN,ISTA) - 
     1                         STOPJ(LSCN) ) .GT. ONESEC .OR. 
     2                         NOREC(LSCN) .OR. 
     3                         SCNRCF
                  END IF
                  IF( CORREL(1:7) .EQ. 'FXCORR' ) THEN
C
C                    Recording stopped or reconfigure happened while
C                    recording.
C 
                     IF( NEWSYNC ) THEN
C
                        IF( SPEEDUP(KS) .EQ. 1.0 ) THEN
                           TSADD = 8.D0 / 86400.D0
                        ELSE IF( SPEEDUP(KS) .EQ. 2.0 ) THEN
                           TSADD = 13.D0 / 86400.D0
                        ELSE
                           TSADD = 25.D0 / 86400.D0
                        END IF
                        IF( USEDISK(ISTA) ) THEN
                           TSADD = TSADD + 10.D0 / 86400.D0
                        END IF
C
C                       Reconfigured during recording.
C
                        IF( SCNRCF ) THEN
                           TSADD = TSADD + 7.D0 / 86400.D0
                        END IF
                     END IF
C
C                 JIVE correlator.  Recall that TCORR going into
C                 this is the recording medium start time.
C                 Tape case removed.
C
                  ELSE IF( CORREL(1:7) .EQ. 'JIVE' ) THEN
                     IF( NEWCONF ) THEN
                        TSADD = 25.D0 / 86400.D0
                     ELSE
                        TSADD = 1.0D0 / 86400.D0
                     END IF
C
C                 Other correlators
C
                  ELSE
                     IF( CORREL(1:7) .EQ. 'SOCORRO' .OR.
     1                   CORREL(1:4) .EQ. 'VLBA' .OR.
     2                   CORREL(1:8) .EQ. 'VLBADIFX' ) THEN
                        TSADD = 0.D0
                     ELSE
                        TSADD = 1.D0 / 86400.D0
                     END IF
                  END IF
C
C                 Now convert all this to a start time for
C                 the correlator synced data.  Note that up to here,
C                 TCORR is the start of the recording.  
C                 Also make sure TCORR is not past the stop time.
C
                  TCORR(ISCN,ISTA) = TSADD + 
     1                  MAX( TRECON, TCORR(ISCN,ISTA) )
C
C       write(*,*) 'rsync ', ista, iscn,  
C     1      ' start stop: ', startj(iscn),  stopj(iscn),
C     2     ' tsadd, tcorr: ', tsadd, tcorr(iscn,ista), 
C     3     ' tonsrc, trecon:', tonsrc(iscn,ista), trecon
C
                  TCORR(ISCN,ISTA) = MIN( TCORR(ISCN,ISTA), 
     1                  STOPJ(ISCN) )
C
C                 Get the time lost to resynchronizing - including
C                 resync time.  Don't count slewing time.
C
                  TTADD = TCORR(ISCN,ISTA) - 
     1                 MAX( TONSRC(ISCN,ISTA), STARTJ(ISCN) ) 
                  TTSYNC(ISTA) = TTSYNC(ISTA) + MAX( 0.0, TTADD )
C
C                 Warn when a scan is expected to be lost to 
C                 resync.
C
                  IF( TCORR(ISCN,ISTA) .EQ. STOPJ(ISCN) ) THEN
                     NRWARN = NRWARN + 1
                     IF( NRWARN .LE. 100 ) THEN
                        WRITE( MSGTXT, '( A, I5, 3A, F6.2, A )' )
     1                    'RESYNC:  Scan ', ISCN, ' at ', STANAME(ISTA),
     2                    ' at ', MOD(STOPJ(ISCN), 1.D0) * 24.D0, 
     3                    ' hr will be lost to correlator resync.'
                        CALL WLOG( 1, MSGTXT )
                        MSGTXT = ' '
                     ELSE IF( NRWARN .EQ. 101 ) THEN
                        CALL WLOG( 1, 
     1                    'RESYNC:  --- More scans lost to resync.' )
                     END IF
                  END IF
C
                  LRSCN = ISCN
               END IF                  
               LSCN = ISCN
            END IF
         END DO
         IF( TTSYNC(ISTA) * 24.0 .GT. 0.1 * SCNHR(ISTA) ) 
     1           RECWARN = .TRUE.
      END DO
C
C     If there was excessive time spent resyncing, warn and explain.
C
      IF( RECWARN ) THEN
         CALL WLOG( 1, ' ' )
         CALL WLOG( 1, ' **** WARNING ****' )
         CALL WLOG( 1, '    Excessive losses to '//
     1      'correlator resyncs.' )
         CALL WLOG( 1, '    See sched.runlog for '//
     1      'more details.' )
         CALL WRTMSG( 0, 'chkscn', 'resync' )
      END IF
C
      RETURN
      END

C*GEOID  -- convert geodetic coordinates to geocentric coordinates
C+
      SUBROUTINE GEOID (R, T)
      DOUBLE PRECISION R, T
C
C Convert geodetic coordinates to geocentric coordinates (used by VLB
C programs FAKE, HAZI, UPTIME).
C-----------------------------------------------------------------------
      DOUBLE PRECISION RD
      PARAMETER (RD=57.29577951D0)
      DOUBLE PRECISION CT(3),CR(3),CR0,R0,X,ZR,ZT
      INTEGER I
      DATA   CT/-692.7430D0,+1.1633D0,-0.0026D0/
      DATA   CR/+0.001676438D0,-0.000003519D0,+0.000000008D0/
      DATA   CR0/0.998327073D0/, R0/6378160.D0/
C
      X  =  T/RD * 2.D0
      ZR = CR0
      ZT = 0.D0
      DO 10 I=1,3
          ZR  =  ZR + CR(I)*DCOS(X*I)
          ZT  =  ZT + CT(I)*DSIN(X*I)
   10 CONTINUE
      R  =  R + ZR*R0
      T  =  T + ZT/3600.D0
C
      END

      CHARACTER*100 FUNCTION SUMDESC( ITEM, LENGTH, LABFLAG )
C
C     Make the summary file descriptions for the line items.
C
      INCLUDE        'sched.inc'
C
      CHARACTER      ITEM*(*), SITEM*20
      INTEGER        LEN1, LENGTH
      LOGICAL        LABFLAG
C --------------------------------------------------------------------
C     Make copy of ITEM so it can be concatenated (g77 won't 
C     concatinate variables of unknown length).
C
      SITEM = ITEM
      LABFLAG = .FALSE.
C
C     Make the summary line.
C
      IF( ITEM .EQ. 'EL1' ) THEN
         SUMDESC = 'Start elevation.'
         LABFLAG = .TRUE.
C
      ELSE IF( ITEM .EQ. 'EL2' ) THEN
         SUMDESC = 'End elevation.'
         LABFLAG = .TRUE.
C
      ELSE IF( ITEM .EQ. 'ELA' ) THEN
         SUMDESC = 'Average elevation.'
         LABFLAG = .TRUE.
C
      ELSE IF( ITEM .EQ. 'AZ1' ) THEN
         SUMDESC = 'Start azimuth.'
         LABFLAG = .TRUE.
C
      ELSE IF( ITEM .EQ. 'AZ2' ) THEN
         SUMDESC = 'End azimuth.'
         LABFLAG = .TRUE.
C
      ELSE IF( ITEM .EQ. 'AZA' ) THEN
         SUMDESC = 'Average azimuth.'
         LABFLAG = .TRUE.
C
      ELSE IF( ITEM .EQ. 'PA1' ) THEN
         SUMDESC = 'Start paralactic angle.'
C
      ELSE IF( ITEM .EQ. 'PA2' ) THEN
         SUMDESC = 'Stop paralactic angle.'
C
      ELSE IF( ITEM .EQ. 'HA1' ) THEN
         SUMDESC = 'Start hour angle.'
C
      ELSE IF( ITEM .EQ. 'HA2' ) THEN
         SUMDESC = 'Stop hour angle.'
C
C     The following sections are tape items.  Remove some day.
C
      ELSE IF( ITEM .EQ. 'TAPE1' ) THEN
         IF( NOSET ) THEN
            CALL ERRLOG( 'SUMDESC:  Cannot use SUMITEM=TAPE1 and ' //
     1           'NOSETUP together. ' )
         END IF
         SUMDESC = 'Gbytes at scan end.  Better to use DISK in SUMITEM.'
C
      ELSE IF( ITEM .EQ. 'TAPE2' ) THEN
         IF( NOSET ) THEN
            CALL ERRLOG( 'SUMDESC:  Cannot use SUMITEM=TAPE2 and ' //
     1           'NOSETUP together. ' )
         END IF
         SUMDESC = 'Not used - no tapes used in this observation.'
C
      ELSE IF( ITEM .EQ. 'DISK' .OR. ITEM .EQ. 'DISC' ) THEN
         SUMDESC = 'Disk total GBytes at end of scan.'
C
      ELSE IF( ITEM .EQ. 'TPSTART' ) THEN
         SUMDESC = 'Seconds recording starts before scan start time.'
C
      ELSE IF( ITEM .EQ. 'EARLY' ) THEN
         SUMDESC = 'Seconds antenna is on source before scan start.'
         LABFLAG = .TRUE.
C
      ELSE IF( ITEM .EQ. 'DWELL ' ) THEN
         SUMDESC = 'Seconds antenna is on source during scan. '//
     1      '0 shown if down, rise, or set'
         LABFLAG = .TRUE.
C
      ELSE IF( ITEM .EQ. 'SLEW' ) THEN
         SUMDESC = 'Slew time in seconds from previous source.'
C
      ELSE IF( ITEM .EQ. 'SYNC' ) THEN
         SUMDESC = 'Seconds the correlator is expected to be ' // 
     1        'synced up during the scan.'
C
      ELSE IF( ITEM .EQ. ' ' ) THEN
         SUMDESC = 'Nothing requested with SUMITEM.'
C
      ELSE
C
C        Unrecognized item.
C
         CALL ERRLOG( 'SUMDESC: Summary item not recognized: '//
     1         SITEM )
      END IF
C
C     Get the length
C
      LENGTH = LEN1( SUMDESC )
C
      RETURN
      END

      SUBROUTINE PTPAT( IUVBA, DOAZ, DOEL, PTINCR, PTOFF, PTDUR, QL )
C
C     Routine for SCHED called by PTVLBA that writes the 
C     actual pointing pattern.  It is broken out of PTVLBA to 
C     simplify adding forcus rotation patterns.
C
      REAL        DOAZ, DOEL, PTINCR, PTOFF
      INTEGER     PTDUR, IUVBA, QL
C --------------------------------------------------------------------
C     Start with a setup scan.
C
      WRITE( IUVBA, '( A, I3, A, I4, A )' )
     1    'qual=', 30+QL,'  dur=', 2 * PTDUR, 's     !NEXT!'
C
      WRITE( IUVBA,'( A )' ) '  !BEGIN LOOP!'
C
C     Then do the 10 point pattern.
C
      WRITE( IUVBA, '( A, I3, A, F7.2, A, I4, A, /, 
     1    5( A, I3, A, F7.2, A, /),
     2    A, I3, A, F7.2, A, F7.2, A, /, 2( A, I3, A, F7.2, A, /),
     3    A, I3, A, F7.2, A, F7.2)' )'qual=', 12+QL, ' azcolim=', 
     4   DOAZ-PTOFF, ' dur=', PTDUR, 's  !NEXT!',
     5   'qual=', 11+QL, ' azcolim=', DOAZ-PTINCR,   ' !NEXT!',
     6   'qual=', 10+QL, ' azcolim=', DOAZ,          ' !NEXT!',
     7   'qual=', 13+QL, ' azcolim=', DOAZ+PTINCR,   ' !NEXT!',
     8   'qual=', 14+QL, ' azcolim=', DOAZ+PTOFF, ' !NEXT!',
     9   'qual=', 22+QL, ' elcolim=', DOEL-2*PTINCR, ' !NEXT!',
     A   'qual=', 21+QL, ' elcolim=', DOEL-PTINCR,
     B      ' azcolim=',DOAZ,               ' !NEXT!',
     C   'qual=', 20+QL, ' elcolim=', DOEL,          ' !NEXT!',
     D   'qual=', 23+QL, ' elcolim=', DOEL+PTINCR,   ' !NEXT!',
     E   'qual=', 24+QL, ' elcolim=', DOEL+2*PTINCR, 
     F      ' azcolim=', DOAZ-PTOFF
      WRITE( IUVBA, '( A )' )  ' !LOOP BACK!'
      WRITE( IUVBA, '( A )' )               ' !NEXT!'
C
      RETURN
      END

      DOUBLE PRECISION FUNCTION sla_DSEPV (V1, V2)
*+
*     - - - - - -
*      D S E P V
*     - - - - - -
*
*  Angle between two vectors.
*
*  (double precision)
*
*  Given:
*     V1      d(3)    first vector
*     V2      d(3)    second vector
*
*  The result is the angle, in radians, between the two vectors.  It
*  is always positive.
*
*  Notes:
*
*  1  There is no requirement for the vectors to be unit length.
*
*  2  If either vector is null, zero is returned.
*
*  3  The simplest formulation would use dot product alone.  However,
*     this would reduce the accuracy for angles near zero and pi.  The
*     algorithm uses both cross product and dot product, which maintains
*     accuracy for all sizes of angle.
*
*  Called:  sla_DVXV, sla_DVN, sla_DVDV
*
*  Last revision:   14 June 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION V1(3),V2(3)

      DOUBLE PRECISION V1XV2(3),WV(3),S,C
      DOUBLE PRECISION sla_DVDV



*  Modulus of cross product = sine multiplied by the two moduli.
      CALL sla_DVXV(V1,V2,V1XV2)
      CALL sla_DVN(V1XV2,WV,S)

*  Dot product = cosine multiplied by the two moduli.
      C = sla_DVDV(V1,V2)

*  Angle between the vectors.
      IF ( S.NE.0D0 .OR. C.NE.0D0 ) THEN
         sla_DSEPV = ATAN2(S,C)
      ELSE
         sla_DSEPV = 0D0
      END IF

      END

      SUBROUTINE VXS2DF( NDATCH, MBITSC, BSAMPL, NGROUP, 
     1    S2MODE, VALID, NS2USD, IS2USD )
C 
C     Routine specific for the VEX extension of SCHED. 
C     Figures out S2 mode name and checks validity
C     This routine sets default mode names, according
C     to a simple naming convention. It assumes the
C     first NDATCH * Bits inputs are used and calls
C     these "in##"
C     By H.J. van Langevelde, JIVE, 250996
C     If NGROUP is set then checked for consitency
C     else set on return.
C 
C 
      INTEGER NDATCH, BSAMPL, NGROUP, NS2USD
      REAL MBITSC
      CHARACTER S2MODE*7, IS2USD(16)*4
      LOGICAL VALID
C
      REAL TOTAL
      INTEGER NTMP, LPOS, I
      INTEGER LEN1
C ----------------------------------------------------------------------
C
      VALID = .TRUE.
      S2MODE = ' '
C
C     S2 user channels must be 1, 2, 4, 8, 16
C
      TOTAL = NDATCH * BSAMPL
      IF( TOTAL .NE. 1.0 .AND.
     1    TOTAL .NE. 2.0 .AND.
     1    TOTAL .NE. 4.0 .AND.
     1    TOTAL .NE. 8.0 .AND.
     1    TOTAL .NE. 16.0 ) VALID = .FALSE.
C
C     total rate must be 16, 32, 48, 64, 80, 96, 112, 128
C
      TOTAL = NDATCH * MBITSC * BSAMPL
      TOTAL = TOTAL / 16.0 
      IF( TOTAL .NE. 1.0 .AND.
     1    TOTAL .NE. 2.0 .AND.
     1    TOTAL .NE. 3.0 .AND.
     1    TOTAL .NE. 4.0 .AND.
     1    TOTAL .NE. 5.0 .AND.
     1    TOTAL .NE. 6.0 .AND.
     1    TOTAL .NE. 7.0 .AND.
     1    TOTAL .NE. 8.0  ) VALID = .FALSE.
C
C     Figure NGROUP
C
      IF( VALID ) THEN
         TOTAL = NDATCH * MBITSC * BSAMPL
         NTMP = INT( 128. / TOTAL )
         IF( NGROUP .NE. 0 ) THEN
            IF( NGROUP .NE. NTMP ) VALID = .FALSE.
         ELSE
            NGROUP = NTMP
         END IF
      END IF
C
C     Give it a name
C
      IF( VALID ) THEN
         LPOS = LEN1(S2MODE)+1
         IF( MBITSC .LT. 10 ) THEN
            WRITE( S2MODE(LPOS:LPOS), '( I1 )' ) INT( MBITSC )
         ELSE
            WRITE( S2MODE(LPOS:LPOS+1), '( I2 )' ) INT( MBITSC )
         END IF
         LPOS = LEN1(S2MODE)+1
         WRITE( S2MODE(LPOS:LPOS), '( A1 )' ) 'x'
         LPOS = LEN1(S2MODE)+1
         IF( (NDATCH * BSAMPL) .LT. 10 ) THEN
            WRITE( S2MODE(LPOS:LPOS), '( I1 )' ) NDATCH * BSAMPL
         ELSE
            WRITE( S2MODE(LPOS:LPOS+1), '( I2 )' ) NDATCH * BSAMPL
         END IF
         LPOS = LEN1(S2MODE)+1
         WRITE( S2MODE(LPOS:LPOS), '( A1 )' ) '-'
         LPOS = LEN1(S2MODE)+1
         WRITE( S2MODE(LPOS:LPOS), '( I1 )' ) BSAMPL
      END IF
C
C     Number of used channels is 
C
      NS2USD = NDATCH * BSAMPL
C
C     Nothing much important in S2USD write simple cable names
C
      DO I = 1, NS2USD
         WRITE(IS2USD(I), '( A2, I2.2 )' ) 'in', I-1
      END DO
C
      RETURN
      END

      SUBROUTINE CHKRDFQ( KS, KF, BBCBW, BBCFREQ, ERRS )
C
C     Routine for SCHED called by CHKRDBE and FSFREQ that checks
C     the frequencies and bandwidths requested for the RDBE.
C     CHKRDBE checks the input setup file.  FSFREQ is used in
C     several places to get the BBC frequencies and bandwidths.
C     These include just before writing the scan info to be sure 
C     in-line changes don't cause trouble.  Note that, for 
C     non-RDBE setups, this routine will fall through without 
C     doing anything thanks to the second level of IF statements.
C
C     Note that this routine can get called multiple times for 
C     each setup file, especially if different frequency sets
C     are being checked.  Also, since it is called from FSFREQ,
C     it can get called from print routines etc.  So jump through
C     a couple of hoops to prevent too many repeat warnings.
C
C     The bypass of this routine after the first time a frequency
C     set is seen means that it should not actually set anything.
C
C     Note ERRS already has a value on entry.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER           KS, KF, ICH, ISIDEBD
      INTEGER           N40WARN(MAXSET), N528WARN(MAXSET)
      INTEGER           NFWARN
C      INTEGER                    , N2WARN  Warnings commented out.
      INTEGER           IPF, I, NCOW, NIFW, NWB, LEN1, ISETF
      DOUBLE PRECISION  BBOFF, BB1, BB2, CR1, CR2, SLOP, BBTOL
      DOUBLE PRECISION  BBCBW(*), BBCFREQ(*), PLO(3), PHI(3)
      LOGICAL           ERRS, DEQUAL, COWARN, OBWARN, SHOWID, IFWARN
      LOGICAL           KFWARN(MFSET), WRONGB
C
      DATA     NCOW, NIFW, NWB  / 0, 0, 0 /
      DATA     OBWARN   / .TRUE. /
      DATA     KFWARN   / MFSET * .TRUE. /
      DATA     N40WARN  / MAXSET*1 /
      DATA     N528WARN / MAXSET*1 /
      DATA     NFWARN   / 0 /
C      DATA     N2WARN   / 0 /
      DATA     PLO      / 512.D0, 640.D0, 896.D0 /
      DATA     PHI      / 640.D0, 896.D0, 1024.D0 /
      DATA     CR1, CR2 / 640.D0, 896.D0 /
      SAVE     N40WARN, N528WARN, NFWARN, NCOW, NIFW, OBWARN, KFWARN
      SAVE     NWB
C      SAVE     , N2WARN
C
C      PLO and PHI are the ranges for the DDC initial polyphase filter.
C -----------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKRDFQ: Starting' )
C
      SHOWID = .FALSE.
C
C     Only do if KF=0 or KFWARN = .TRUE.
C
      IF( KF .NE. 0 ) THEN
         IF( .NOT. KFWARN(KF) ) RETURN
         KFWARN(KF) = .FALSE.
      END IF
C
C     Get the setup file number
C
      ISETF = ISETNUM(KS)
C
C     Note the checks are needed for all setups, not just ones used for
C     recording.
C
C     First check the RDBE_PFB personality.
C
      IF( DBE(KS) .EQ. 'RDBE_PFB' ) THEN
C
C        All bandwidths must be 32 MHz.
C
         DO ICH = 1, NCHAN(KS)
            IF( BBCBW(ICH) .NE. 32.0D0 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, F8.3 )' )
     1            'CHKRDFQ: Bandwidth must be 32.0 MHz for ',
     2            'DBE=RDBE_PFB. Value specified is: ', 
     3            BBCBW(ICH)
               CALL WLOG( 1, MSGTXT )
               ERRS = .TRUE.
            END IF
         END DO
C
C        Baseband frequencies must be 1024.0-16.0-N*32.0 for
C        N = 0 to 14.  Also allow 15 so that there can be
C        16 channels in one polarization, but warn that it 
C        will be bad.
C
C        Jan 2012.  Allow the "-1" channel from 1040-1008 MHz 
C        for when people want to span the full 512 MHz IF in
C        one polarization.  The on-line system wants this one,
C        not the one at the low end of the IF.
C
         DO ICH = 1, NCHAN(KS)
            BBOFF = 1024.0D0 + 16.0D0 - BBCFREQ(ICH)
            IF( MOD( BBOFF, 32.0D0 ) .NE. 0.0D0 .OR.
     1          NINT( BBOFF / 32.0D0 ) .LT. 0 .OR.
     2          NINT( BBOFF / 32.0D0 ) .GT. 16 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, F8.2, A )' )
     1            'CHKRDFQ: Invalid BBSYN for DBE=RDBE_PFB: ', 
     2            BBCFREQ(ICH),
     3            '.  Must be 1024+16-N*32 for N=0-15.'
               ERRS = .TRUE.
               CALL WLOG( 1, MSGTXT )
            END IF
            IF( BBCFREQ(ICH) .EQ. 1040.0 .AND. 
     1            N40WARN(ISETF) .LE. 1 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, F8.2, A )' )
     1            'CHKRDFQ: Baseband frequency ', BBCFREQ(ICH),
     2            '.  Will produce poor data with the PFB.'
               CALL WLOG( 1, MSGTXT )
               N40WARN(ISETF) = N40WARN(ISETF) + 1
               SHOWID = .TRUE.
            END IF
            IF( BBCFREQ(ICH) .EQ. 528.0 .AND. 
     1            N528WARN(ISETF) .LE. 1 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, F8.2, A, A )' )
     1            'CHKRDFQ: Baseband frequency ', BBCFREQ(ICH),
     2            '.  Will be changed to 1040 by the VLBA on-line',
     3            ' system.'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' ' 
               WRITE( MSGTXT, '( A, A )' )
     1            'CHKRDFQ: Correlation of that channel will be ',
     2            ' corrupted.'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' ' 
               WRITE( MSGTXT, '( A, A, A )' )
     1            'CHKRDFQ:  This is normal for 16 chan, 1 pol, ',
     3            'with sideband inversion at some station.'
               CALL WLOG( 1, MSGTXT )
               N528WARN(ISETF) = N528WARN(ISETF) + 1
               SHOWID = .TRUE.
            END IF
         END DO
      END IF
C
C     ===  Now check the DDC personality. ===
C
      IF( DBE(KS) .EQ. 'RDBE_DDC' ) THEN
C
C        All bandwidths must be between 1MHz and 128 MHz.
C        Narrower bandwidths are possible but can create some
C        problems.  Restrict non-testers to 1 MHz and above.
C        All bandwidths must be the same.  This might lapse 
C        eventually by allowing 2 RDBEs to each have a different
C        BW.
C
         DO ICH = 1, NCHAN(KS)
            IF( .NOT. ( DEQUAL( BBCBW(ICH), 128.0D0 ) .OR. 
     1          DEQUAL( BBCBW(ICH), 64.0D0 ) .OR. 
     2          DEQUAL( BBCBW(ICH), 32.0D0 ) .OR. 
     3          DEQUAL( BBCBW(ICH), 16.0D0 ) .OR. 
     4          DEQUAL( BBCBW(ICH), 8.0D0 ) .OR. 
     5          DEQUAL( BBCBW(ICH), 4.0D0 ) .OR. 
     6          DEQUAL( BBCBW(ICH), 2.0D0 ) .OR. 
     7          DEQUAL( BBCBW(ICH), 1.0D0 ) ) ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, F8.3 )' )
     1            'CHKRDFQ: Bandwidth should be 1 to 128 MHz for ',
     2            'DBE=RDBE_DDC. Value specified is: ', 
     3            SIDEBD(ICH,KS)
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, '         Narrower bands are possible '//
     1            'if MODETEST is specified.' )
               IF( BBCBW(ICH) .LT. 1.D0 .AND. MODETEST(KS) ) THEN
                  CALL WLOG( 1, '        Overriding BW restriction.'//
     2                '  You are on your own to get it right!' )
               ELSE
                  ERRS = .TRUE.
               END IF
            END IF
C
C           Same bandwidth test.
C
            IF( ICH .GE. 2 .AND. BBCBW(ICH) .NE. BBCBW(1) ) THEN
               CALL WLOG(1, 'CHKRDFQ: All channels must have the '//
     1             'same bandwidth with the DDC.  Yours don''t.' )
               ERRS = .TRUE.
            END IF
C
C           The sample rate needs to be twice the bandwidth.  This
C           may preclude bandwidth changes with the same setup as 
C           in-line sample rates are not (yet) supported.  There
C           is only one sample rate and the above test forces all
C           bandwidths to be the same, so just check channel 1.
C
            IF( SAMPRATE(KS) .NE. 2.D0 * BBCBW(1) ) THEN
               CALL WLOG( 1, 'CHKRDFQ: The SAMPRATE must be 2 '//
     1             'times the bandwidth with the DDC.' )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, F10.3, A, F10.3 )' )
     1              '         You have BW = ', BBCBW(1), 
     2              ' and SAMPRATE = ', SAMPRATE(KS)
               CALL WLOG( 1, MSGTXT  )
               CALL WLOG( 1, '         Did you use in-line inputs '//
     1             'to change the bandwidth?' )
               ERRS = .TRUE.
            END IF
         END DO
C
C        Baseband frequencies must be between 512 and 1024 MHz.
C        They can be set to within 1 Hz or less, but must be 
C        a multiple of 256E6/2**32 MHz =0.0596046 Hz. (I don't absolutely
C        guarantee that that isn't 256/2**31, but it doesn't really
C        matter here).  Values that are not integer Hz are a problem
C        because the phase doesn't repeat each second so it is difficult
C        to return to phase after going to another frequency.  Therefore
C        we are going to restrict the tuning increment to the smallest
C        value that is an even number of Hz, namely 15.625 kHz ( which
C        is 256E6/2**14.  That means the allowed values are N*125 kHz plus
C        0, 15.625, 31.250, 46.875, 62.500, 78.125, 93.750, or 109.375
C        kHz.
C
C        Once all frequencies are set, prevent basebands crossing 
C        the crossover points.
C
C        For a while, we did not recommend frequencies that were not 
C        multiples of 250 kHz, the smallest allowed value compatible with
C        the old systems that use N*10kHz.  Compatibility and a concern
C        about possible precision loss were the issues.  The precision 
C        worry has been tested and found to be ok, so we are dropping
C        the 250 kHz advice.  Any non 10kHz multiple should be trapped
C        when checking the non-RDBE stations.
C
         DO ICH = 1, NCHAN(KS)
C
C           Check that it is in the IF.
C
            ISIDEBD = 1
            IF( SIDEBD(ICH,KS) .EQ. 'L' ) ISIDEBD = -1
            BB1 = BBCFREQ(ICH)
            BB2 = BBCFREQ(ICH) + ISIDEBD * BBCBW(ICH)
            IF( BB1 .LT. 512.0D0 .OR.
     1          BB1 .GT. 1024.0D0 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, 
     1               '( A, I4, A, I4, A, F10.2, A )' )
     2            'CHKRDFQ: Baseband ', ICH, ' in setup ', KS, 
     3            ' has baseband frequency ', BB1,
     4            ' outside 512-1024 MHz.'
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, '         This is not allowed.' )
               ERRS = .TRUE.
            END IF
C
C           Check the other end of the sideband.  Just warn of the
C           issue in this case.  Only warn once if it is less than
C           1% of the band - it's probably because of trying to get
C           decent pcal frequencies.
C
            SLOP = MAX( 512.D0 - BB2, BB2 - 1024.D0 )
            IF( ( SLOP .GT. 0.D0 .AND. OBWARN ) .OR. 
     1            SLOP .GT. 0.01 * BBCBW(ICH) ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, I3, A, F8.2, A )' )
     1           'CHKRDFQ:  Channel ', ICH, 
     2           ' with bandwidth ', BBCBW(ICH), ' MHz extends '
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, F8.3, A )' )
     1            '          ', SLOP,
     2            ' MHz outside the IF band of 512-1024 MHz.'
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, '         That Part of the band '//
     1            'will be corrupted.' )
               IF( SLOP .LE. 0.01 * BBCBW(ICH) ) THEN
                  OBWARN = .FALSE.
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( 2A )' )
     1              '         This is small and may be ',
     2              'intentional for good pulse cal.'
                  CALL WLOG( 1, MSGTXT )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A )' )
     1              '         This warning will not be repeated.'
                  CALL WLOG( 1, MSGTXT )
               END IF
               SHOWID = .TRUE.
            END IF
C
C           Check for multiple of 15.625 kHz.  This test allows a 
C           bit of slop (about 100 mHz).  This will be treated as
C           an error and will abort SCHED - the call to ERROR is at
C           the end of this routine.
C
            IF( DMOD( BBCFREQ(ICH) + 1.D-7, 0.015625D0 ) .GT. 2.D-7
     1          .AND. NFWARN .LE. 1 ) THEN
               MSGTXT = ' '
               WRITE( MSGTXT, '( 3A )' ) 'CHKRDFQ:  ',
     1           ' BBSYN for the RDBE_DDC must be an even multiple',
     2           ' of 15.625 kHz.'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( 3A,  A, I3, F15.6 )' ) 
     1            '          ',
     2            ' Found station station/setup/chan/frequency : ', 
     3            SETSTA(1,KS), SETNAME(KS)(1:LEN1(SETNAME(KS))),
     4            ICH, BBCFREQ(ICH)
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, '           ' // SETNAME(KS) )
               IF( NFWARN .GE. 1 ) THEN
                  MSGTXT = 'CHKRDFQ:   Further warnings suppressed '
                  CALL WLOG( 1, MSGTXT )                     
               END IF                  
               NFWARN = NFWARN + 1
               SHOWID = .TRUE.
C
C           Check for multiple of 250 kHz.   We are dropping this one,
C           but leave the code available.
C
C            ELSE IF( DMOD( BBCFREQ(ICH) + 1.D-7, 0.250D0 ) .GT. 2.D-7
C     1          .AND. N2WARN .LE. 1 ) THEN
C               MSGTXT = ' '
C               WRITE( MSGTXT, '( 3A )' ) 'CHKRDFQ:  ',
C     1           ' It is recommended that BBSYN for the RDBE_DDC ',
C     2           'be an even multiple of 250 kHz.'
C               CALL WLOG( 1, MSGTXT )
C               MSGTXT = ' '
C               WRITE( MSGTXT, '( 2A, F15.6, A, I3, A, A )' ) 
C     1            '          ',
C     2            ' Value of: ', BBCFREQ(ICH), 
C     3            ' MHz found in channel ', ICH, ' of setup ', 
C     4            SETNAME(KS)
C               CALL WLOG( 1, MSGTXT )
C               IF( N2WARN .GE. 1 ) THEN
C                  MSGTXT = 'CHKRDFQ:   Further warnings suppressed.'
C                  CALL WLOG( 1, MSGTXT )                     
C               END IF                  
C               N2WARN = N2WARN + 1
C               SHOWID = .TRUE.
            END IF
C
C           Test the crossover points for the DDC.  Allow a small
C           percentage crossover at the end of the band opposite
C           from the LO.  This may be hard to avoid with the highest
C           bandwidths and a desire for a decent pcal frequency.
C           The filter used will be the one that includes the band
C           edge described by BBCFREQ as confirmed by Matt Luce on 
C           March 25, 2013.
C
            ISIDEBD = 1
            IF( SIDEBD(ICH,KS) .EQ. 'L' ) ISIDEBD = -1
            BB1 = BBCFREQ(ICH)
            BB2 = BBCFREQ(ICH) + ISIDEBD * BBCBW(ICH)
C
C           Get which polyphase filter the band will end up in.
C
            IPF = 0
            DO I = 1, 3
C
C              The executor chooses the PFB channel to use.  If 
C              the frequency falls right on a boundary, it goes
C              to the appropriate side for the sideband.
C
               IF( SIDEBD(ICH,KS) .EQ. 'U' ) THEN
                  IF( BB1 .GE. PLO(I) .AND. BB1 .LT. PHI(I) ) THEN
                     IPF = I
                  END IF
               ELSE
                  IF( BB1 .GT. PLO(I) .AND. BB1 .LE. PHI(I) ) THEN
                     IPF = I
                  END IF
               END IF
            END DO
            IF( IPF .EQ. 0 ) THEN
C
C              This case should have already been caught, so don't
C              say anything.
C
               SHOWID = .TRUE.
            ELSE
C
C              Now see if the band goes outside the filter.  Allow
C              a bit of tolerance (2% of bandwidth).
C              For the IF boundaries, this should already have been 
C              caught so some of this might not be needed.
C
               IFWARN = .FALSE.
               COWARN = .FALSE.
               WRONGB = .FALSE.
               BBTOL = 0.02D0 * BBCBW(ICH)
               IF( SIDEBD(ICH,KS) .EQ. 'U' ) THEN
                  IF( BB2 .GT. PHI(IPF) + BBTOL ) THEN
                     IF( IPF .EQ. 3 ) THEN
                        IFWARN = .TRUE.
                     ELSE
                        COWARN = .TRUE.
                     END IF
                     IF( BB2 - PHI(IPF) .GT. 0.5 * BBCBW(ICH) ) 
     1                  WRONGB = .TRUE.
                  END IF
               ELSE
                  IF( BB2 .LT. PLO(IPF) - BBTOL ) THEN
                     IF( IPF .EQ. 1 ) THEN
                        IFWARN = .TRUE.
                     ELSE
                        COWARN = .TRUE.
                     END IF
                     IF( PLO(IPF) - BB2 .GT. 0.5 * BBCBW(ICH) ) 
     1                  WRONGB = .TRUE.
                  END IF
               END IF
C
C              If more than half the baseband is on the other 
C              side of the crossover or band edge, treat as
C              an error.
C
               IF( WRONGB .AND. NWB .LE. 10 ) THEN
                  NWB = NWB + 1
                  CALL WLOG( 1, 'CHKRDFQ:  For the RDBE_DBBC ' //
     1                'the polyphase filter used is the one ' )
                  CALL WLOG( 1, '          containing the baseband ' //
     1                'frequency. ' )
                  CALL WLOG( 1, '          You have a channel with ' //
     1                'most of the bandwidth outside the ' )
                  CALL WLOG( 1, '          the chosen filter. ' )
                  CALL WLOG( 1, '          This is too big an ' //
     1                'error.  Fix the frequency. ' )
                  MSGTXT = ' '
                  WRITE( MSGTXT,
     1               '( A, I3, A, F10.4, A, F10.4, A )' )
     2               '          The bad channel is baseband', ICH, 
     3               ' between IF freqs', BB1, ' and', BB2, ' MHz'
                  CALL WLOG( 1, MSGTXT )
                  CALL WLOG( 1, '          in setup ' //
     1               SETNAME(KS)(1:LEN1(SETNAME(KS))) )
                  CALL WLOG( 1, '          for at least station: ' //
     1                 SETSTA(1,KS) ) 
                  ERRS = .TRUE.
               END IF
C
C              Give milder warnings for lesser violations.
C
               IF( COWARN ) NCOW = NCOW + 1
               IF( IFWARN ) NIFW = NIFW + 1
               IF( ( COWARN .AND. NCOW .LE. 10 ) .OR. 
     1             ( IFWARN .AND. NIFW .LE. 10 ) ) THEN               
C
                  MSGTXT = ' '
                  WRITE( MSGTXT,
     1               '( A, I3, A, F10.4, A, F10.4, A )' )
     2               'CHKRDFQ: ***  Baseband', ICH, 
     4               ' between IF freqs', BB1, ' and', BB2, ' MHz'
                  CALL WLOG( 1, MSGTXT )
C
                  IF( IFWARN .AND. NIFW .LE. 10 ) THEN
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( 2A )' )
     1                  ' goes outside 512-1024 MHz.  ',
     2               'This will produce corrupted data.'
                     CALL WLOG( 1, MSGTXT )
                  ELSE IF( COWARN .AND. NCOW .LE. 10 ) THEN
                     MSGTXT = ' '
                     WRITE( MSGTXT, '( 2A )' )
     1                  '          spans a crossover.  ',
     2                  'This will produce corrupted data.'
                     CALL WLOG( 1, MSGTXT )
C
                     IF( COWARN .AND. NCOW .EQ. 1 ) THEN
                        CALL WLOG( 1, '         Recall crossovers are '
     1                     //'the boundaries between the polyphase '//
     2                     'filter ' )
                        CALL WLOG( 1, '         outputs in the initial'
     2                     //' stage of processing in the RDBE.' )
C
                        MSGTXT = ' '
                        WRITE( MSGTXT, '( A, F10.2, A, F10.2, A )' )
     1                     '         The crossovers are at ', CR1, 
     2                     ' and ', CR2, ' MHz in the IF.'
                        CALL WLOG( 1, MSGTXT )
                     END IF
C  
                     MSGTXT = ' '
                     SHOWID = .TRUE.
                  ELSE IF( COWARN .AND. NCOW .EQ. 11 ) THEN
                     CALL WLOG( 1, ' ' )
                     CALL WLOG( 1, 
     1                'CHKRDFQ:  More crossover warnings suppressed.' )
                     CALL WLOG( 1, ' ' )
                  ELSE IF( IFWARN .AND. NIFW .EQ. 11 ) THEN
                     CALL WLOG( 1, ' ' )
                     CALL WLOG( 1, 
     1                'CHKRDFQ:  More out-of-IF warnings suppressed.' )
                     CALL WLOG( 1, ' ' )
                  END IF
               END IF
            END IF
         END DO
C
      END IF
C
C     Identify the setup if there was a problem.
C      
      IF( ERRS .OR. SHOWID ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, A )' )
     1     'CHKRDFQ: The above problem is for setup ', 
     1     SETNAME(KS)(1:LEN1(SETNAME(KS)))
         CALL WLOG( 1, MSGTXT )
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, A )' )
     1     '         and at least station ', SETSTA(1,KS)
         CALL WLOG( 1, MSGTXT )
      END IF
C
C     Make the non-multiple of 15.625 warning fatal.
C
      IF( NFWARN .GT. 0 ) THEN
         CALL ERROR( 'CHKRDFQ:  Use freqeuenies that are multiples '//
     1       'of 15.625 kHz.' )
      END IF
C
      IF( DEBUG ) CALL WLOG( 0, 'CHKRDFQ: Ending' )
C
C     End.  Note that there is a branch to return above when looking at KFWARN.
C
      RETURN
      END

C*PANGLE -- convert angle in radians to sexagesimal character string
C+
      SUBROUTINE PANGLE(FMT,ANGLE,IH,M)
      CHARACTER*(*) FMT
      DOUBLE PRECISION ANGLE
      CHARACTER*(*) IH
      INTEGER M
C
C Convert an angle in radians to hours, min, sec or degrees, min, sec
C for printing.  The hours (degrees), minutes, and seconds fields are
C separated by a single space, or by the character specified as the
C second character in the FMT argument.
C
C Arguments:
C  FMT    (input)  : 'H' for conversion to hhmmss, 
C                    'D' for conversion to ddmmss.
C  ANGLE  (input)  : the angle in radians.
C  IH     (output) : receives the formatted character string,
C                    right justified.
C  M      (input)  : the number of decimal places required in the
C                    seconds field (may be zero).
C
C History:
C  1987 Nov 12 - TJP.
C  1991 May 18 - TJP.
C  1994 Aug  8 - add FMT option for separator (TJP).
C-----------------------------------------------------------------------
      CHARACTER*1 I(0:9),IBLANK,IPOINT,IPLUS,IMINUS,ISIGN
      CHARACTER*1 SEP, TST
      CHARACTER*2 TMP
      DOUBLE PRECISION UNIT,RD,HRAD,DRAD
      LOGICAL    HOUR
      INTEGER N, K, KL, IUN, IMIN, ISEC, IDEC
      PARAMETER  (HRAD = 3.819718634D0, DRAD = 57.29577952D0)
      DATA       IBLANK/' '/,IPOINT/'.'/,IPLUS/' '/,IMINUS/'-'/,
     1             I/'0','1','2','3','4','5','6','7','8','9'/
C
C
      TMP = FMT
      TST = TMP(1:1)
      SEP = TMP(2:2)
      IF (TST.EQ.'H' .OR. TST.EQ.'h') THEN
          UNIT = ANGLE*HRAD
          HOUR = .TRUE.
      ELSE IF (TST.EQ.'D' .OR. TST.EQ.'d') THEN
          UNIT = ANGLE*DRAD
          HOUR = .FALSE.
      ELSE
          IH = '**ERROR**'
      END IF
C
C            Check that N and M are reasonable
      N = LEN(IH)
      IF(HOUR.AND.N.GE.10+M) GOTO 2
      IF(.NOT.HOUR .AND. N.GE.11+M) GOTO 2
      DO 3 K = 1,N
    3       IH(K:K) = '*'
      RETURN
C
C            Set sign
    2   ISIGN = IPLUS
      IF(UNIT.LT.0D0) ISIGN = IMINUS
      UNIT = DABS(UNIT)*3600D0
C
C            Round off
      RD = 10D0**(-M)
      IF(DMOD(UNIT/RD,1D0).GT.0.5D0) UNIT = UNIT+RD
C
C            Obtain the desired numbers
      IUN = UNIT/3600D0
      IMIN = (UNIT - IUN*3600D0)/60D0
      ISEC = (UNIT - IUN*3600D0 - IMIN*60D0)
      IDEC = (UNIT - IUN*3600D0 - IMIN*60D0 - ISEC)*10**M
C
C
C            Set up array IH
C
      IF(M.EQ.0) GOTO 10
C
      DO 6 K = 1,M
          IH(N-K+1:N-K+1) = I(MOD(IDEC,10**K)/(10**(K-1)))
    6       CONTINUE
C
   10 IH(N-M:N-M) = IPOINT
      IH(N-M-1:N-M-1) = I(MOD(ISEC,10))
      IH(N-M-2:N-M-2) = I(ISEC/10)
      IH(N-M-3:N-M-3) = SEP
      IH(N-M-4:N-M-4) = I(MOD(IMIN,10))
      IH(N-M-5:N-M-5) = I(IMIN/10)
      IH(N-M-6:N-M-6) = SEP
      IH(N-M-7:N-M-7) = I(MOD(IUN,10))
      IH(N-M-8:N-M-8) = I(MOD(IUN,100)/10)
C
      IF(.NOT.HOUR .AND.IUN.GT.100) GOTO 20
      IH(N-M-9:N-M-9) = ISIGN
      KL = N-M-10
      GOTO 21
C
   20 IH(N-M-9:N-M-9) = I(MOD(IUN,1000)/100)
      IH(N-M-10:N-M-10) = ISIGN
      KL = N-M-11
C
   21 IF(KL.LE.0) RETURN
      DO 22 K = 1,KL
   22       IH(K:K) = IBLANK
C-----------------------------------------------------------------------
      END

      SUBROUTINE OMSSET
C
C     Routine for SCHED that writes setup information for OMS
C     at the VLBA correlator.
C
      INCLUDE       'sched.inc'
      INCLUDE       'schset.inc'
C
      INTEGER            I, KS, ISCN, NCHR, NCHR1, ICHAN, LEN1
      INTEGER            ISTA, KF, JS
      INTEGER            SETSCANS, NRSCANS, USE4VLBA(MAXSET), VLBA1
      LOGICAL            VLBASAME, SAMESET, ISVLBA
      DOUBLE PRECISION   SETHOURS, NRHOURS
C ---------------------------------------------------------------------
C     For each setup file, find out if we can use a generic VLBA output
C     group.
C     I figured out later that this will mess up the scan count statistics
C     when not all VLBA stations are in every scans.  This can be a 
C     factor of 2 effect for pointing setups.  And since SC is often
C     the first VLBA station and it often does not see the final scans,
C     it can be a problem there too.
C
      DO KF = 1, NSETF
         USE4VLBA(KF) = 0
         VLBA1 = 0
         VLBASAME = .TRUE.
         DO KS = 1, NSET
            IF( ISETNUM(KS) .EQ. KF .AND. 
     1          SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) THEN
               IF( VLBA1 .EQ. 0 ) THEN
                  VLBA1 = KS
               ELSE
                  IF( .NOT. SAMESET(KS,VLBA1) ) THEN
                     VLBASAME = .FALSE.
                  END IF
               END IF
            END IF
         END DO
         IF( VLBASAME .AND. VLBA1 .NE. 0 ) THEN
            USE4VLBA(KF) = VLBA1
         ELSE
            USE4VLBA(KF) = 0
         END IF
      END DO

C
C     Loop over the setups and write their parameters.  
C     
      DO KS = 1, NSET
C
C        Get some statistics of the usage of this setup.
C
         SETSCANS = 0
         SETHOURS = 0.0
         NRSCANS = 0
         NRHOURS =  0.0
         DO ISCN = SCAN1, SCANL
            DO ISTA = 1, NSTA
               IF( STASCN(ISCN,ISTA) ) THEN 
                  JS = NSETUP(ISCN,ISTA)
                  KF = ISETNUM(JS)
                  ISVLBA = STANAME(ISTA)(1:4) .EQ. 'VLBA'
                  IF( JS .EQ. KS .OR.
     1                ( ISVLBA .AND. USE4VLBA(KF) .EQ. KS ) ) THEN
                     IF( NOREC(ISCN) ) THEN
                        NRSCANS = NRSCANS + 1
                        NRHOURS = NRHOURS + 
     1                      ( STOPJ(ISCN) - STARTJ(ISCN) ) * 24.D0
                     ELSE
                        SETSCANS = SETSCANS + 1
                        SETHOURS = SETHOURS + 
     1                       ( STOPJ(ISCN) - STARTJ(ISCN) ) * 24.D0
                     END IF
C
C                    Only count each scan once.
C
                     GO TO 100
                  END IF
               END IF
            END DO
  100       CONTINUE
         END DO
C
C        If it got used at all, write out info.
C        Don't write any but the first VLBA station if all
C        VLBA setups for this setup file are the same.
C
         KF = ISETNUM(KS)
         IF( ( SETSCANS .GE. 1 .OR. NRSCANS .GE. 1 ) .AND.
     1       ( USE4VLBA(KF) .EQ. KS .OR. USE4VLBA(KF) .EQ. 0 .OR. 
     2         SETSTA(1,KS)(1:4) .NE. 'VLBA' ) ) THEN
C
            WRITE( IOMS, '( 1X, /, A, /, 1X )' )
     1          'BEGIN = STATION_SETUP'
C
            IF( USE4VLBA(KF) .EQ. KS ) THEN
               WRITE( IOMS, '( A, A )' )
     1          '    STATION            = VLBA    '
            ELSE
               WRITE( IOMS, '( A, A )' )
     1          '    STATION            = ', STCODE(ISETSTA(KS))
            END IF
C
            IF( SETSCANS .GE. 1 ) THEN
               WRITE( IOMS, '( A, I4, A, F6.2, A )' )
     1          '    RECORD_SCANS       = ', SETSCANS
               WRITE( IOMS, '( A, F6.2 )' )
     1          '    RECORD_HOURS       = ', SETHOURS
            END IF
C
            IF( NRSCANS .GE. 1 ) THEN
               WRITE( IOMS, '( A, I4, A, F6.2, A )' )
     1          '    NORECORD_SCANS     = ', NRSCANS
               WRITE( IOMS, '( A, F6.2 )' )
     1          '    NORECORD_HOURS     = ', NRHOURS
            END IF
C
            WRITE( IOMS, '( 5( A, 1X ) )' )    
     1          '    FE                 = ', 
     2          (FE(I,KS)(1:LEN1(FE(I,KS))),I=1,4)
            WRITE( IOMS, '( A, I4 )' ) 
     1          '    NUM_CHANNELS       = ', NCHAN(KS)
            WRITE( IOMS, '( A, A )' )  
     1          '    FORMAT             = ', FORMAT(KS)
            WRITE( IOMS, '( A, F5.2 )' ) 
     1          '    SPEEDUP            = ', SPEEDUP(KS)
C     
C           Channel information.
C     
            SETMSG = ' '
            MSGTXT = ' '
            WRITE( SETMSG, '( A )' ) 
     1          '    IF                 = '
            WRITE( MSGTXT, '( A )' ) 
     1          '    BBC_SB             = '
            NCHR = 27
            DO ICHAN = 1, NCHAN(KS)
               WRITE( SETMSG(NCHR:NCHR+1), '( A )' ) 
     1              IFCHAN(ICHAN,KS)
               WRITE( MSGTXT(NCHR:NCHR), '( A )' )
     1              SIDEBD(ICHAN,KS)
               NCHR = NCHR + 3
            END DO
            WRITE( IOMS, '( A )' ) SETMSG(1:NCHR)
            WRITE( IOMS, '( A )' ) MSGTXT(1:NCHR)
C
C           Extra channel information not requested for OMS but
C           maybe useful for other users.
C           Keeping separate track of the length of the POL line
C           because formally POL is CHARACTER*4, but we only use
C           the first.
C
            SETMSG = ' '
            MSGTXT = ' '
            WRITE( SETMSG, '( A )' ) 
     1          '    NET_SB             = '
            WRITE( MSGTXT, '( A )' ) 
     1          '    POL                = '
            NCHR = 27
            NCHR1 = 27
            DO ICHAN = 1, NCHAN(KS)
               WRITE( SETMSG(NCHR:NCHR), '( A1 )' ) 
     1              NETSIDE(ICHAN,KS)
               WRITE( MSGTXT(NCHR1:NCHR1), '( A1 )' )
     1              POL(ICHAN,KS)
               NCHR = NCHR + 3
               NCHR1 = NCHR1 + 3
            END DO
            WRITE( IOMS, '( A )' ) SETMSG(1:NCHR)
            WRITE( IOMS, '( A )' ) MSGTXT(1:NCHR1)
C
C           Write the frequency sets used with this setup.
C
            CALL OMSFREQ( KS, IOMS )
C
C           Close out the station setup section.
C
            WRITE( IOMS, '( 1X, /, A )' )
     1          'END = STATION_SETUP'
         END IF
      END DO
C
      RETURN
      END

      SUBROUTINE VLASCNS
C
C     Routine for SCHED that checks and/or sets some items
C     for the VLA.
C
C     Started Oct. 27, 2012 mainly to be sure phasing modes
C     specified with VLAMODE are reflected in the INTENTS.
C
      INCLUDE   'sched.inc'
C
      INTEGER   ISCN, ISTA
      INTEGER   IIVA, IIVX, IIVO, IIVS, II
      INTEGER   IIDE, IIAP, IIAD, IIOF, LEN1
      LOGICAL   GOTPHINT, GOTVLAMD
      LOGICAL   GOTPTINT, VLADOPK
C -------------------------------------------------------------
C     See if the VLA is used, setting VLASTA if so.
C
      VLASTA = 0
      DO ISTA = 1, NSTA
         IF( STANAME(ISTA)(1:3) .EQ. 'VLA' ) THEN
            VLASTA = ISTA
         END IF
      END DO
C
C     Don't do the rest of this routine if the VLA is not present.
C
      IF( VLASTA .EQ. 0 ) RETURN
C
C     Allow only one method of specifying VLA phasing - specific INTENTS
C     or VLAMODE.  Detect which a user is using.  If both, stop.
C
C     First determine if any VLA phasing INTENTs were specified, and, if so,
C     which they were.
C     While at it, get the intent numbers for the VLA AUTOPHASE commands 
C     if any were issued by the user.
C     Note that the intent for single dish is not actually
C     supported yet.
C
C     Ignore similar commands meant for another site (presence of ":"
C     but not "VLA"), but accept a version that is not qualified by site.
C
      IIVA = 0
      IIVX = 0
      IIVO = 0
      IIVS = 0
      IF( NINTENT .GE. 1 ) THEN
         DO II = 1, NINTENT
            IF( INDEX( INTENT(II), ':' ) .EQ. 0  .OR. 
     1          INDEX( INTENT(II), 'VLA' ) .NE. 0 ) THEN
C
               IF( INDEX( INTENT(II), 'AUTOPHASE_DETERMINE' ) .NE. 0 ) 
     1              THEN 
                  IIVA = II
               ELSE IF( INDEX( INTENT(II), 'AUTOPHASE_APPLY' ) .NE. 0 ) 
     1              THEN
                  IIVX = II
               ELSE IF( INDEX( INTENT(II), 'AUTOPHASE_OFF' ) .NE. 0 ) 
     1              THEN
                  IIVO = II
               ELSE IF( INDEX( INTENT(II), 'SINGLE_DISH' ) .NE. 0 ) 
     1              THEN
                  IIVS = II
               ELSE IF( INDEX( INTENT(II), 'AUTOPHASE' ) .NE. 0 ) THEN
                  CALL WLOG( 1, ' ' )
                  CALL WLOG( 1, '   ************************  ' )
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( 3A )' )
     1                'VLASCNS: Unrecognized AUTOPHASE INTENT used: ',
     2                INTENT(II)(1:LEN1(INTENT(II))), 
     3                '.  Please fix.'
                  CALL WLOG( 1, MSGTXT )
                  CALL WLOG( 1, '         Recognized options are '//
     1                 '(see the manual):' )
                  CALL WLOG( 1, 
     1                          '         AUTOPHASE_DETERIMINE, '//
     2                 'AUTOPHASE_APPLY, AUTOPHASE_OFF, and '//
     3                 'SINGLE_DISH' )
                  CALL WLOG( 1, '         For the VLA, it is better '//
     2                 'to use VLAMODE.' )
                  CALL WLOG( 1, '   ************************  ' )
                  CALL WLOG( 1, ' ' )
               END IF
C
C              Attempt to detect an unrecognized AUTOPHASE command.
C

            END IF
         END DO
      END IF
      GOTPHINT =  IIVA .GT. 0 .OR. IIVX .GT. 0 .OR. 
     1            IIVO .GT. 0 .OR. IIVS .GT. 0 
C
C     Now detect the use of VLAMODE.  Note that the default is ZZ, not
C     one of the allowed modes, but test against the allowed ones.
C
      GOTVLAMD = .FALSE.
      DO ISCN = SCAN1, SCANL
         IF( VLAMODE(ISCN) .EQ. '  ' .OR. VLAMODE(ISCN) .EQ. 'VA' .OR.
     1       VLAMODE(ISCN) .EQ. 'VX' .OR. VLAMODE(ISCN) .EQ. 'VS' ) THEN
            GOTVLAMD = .TRUE.
         END IF
      END DO
C
C     Don't allow both methods in one project.
C
      IF( GOTPHINT .AND. GOTVLAMD ) THEN
         CALL WLOG( 1, 'VLASCNS:  Both VLA phasing INTENTS and '//
     1       'VLAMODE used in the same schedule.' )
         CALL WLOG( 1, '          This confuses SCHED so do not '//
     1       'do it.  VLAMODE is preferred.' )
         CALL ERRLOG( 
     1       '          Use only VLAMODE -or- phasing INTENTS ' )
      END IF
C
C     Now add the INTENTS and set their use if VLAMODE is being used.
C
      IF( GOTVLAMD ) THEN
         IF( NINTENT + 4 .GT. MINTENT ) CALL ERRLOG( 
     1      'VLASCNS: Too many intents for SCHED arrays after adding '//
     2      'phasing commands.' )
         INTENT(NINTENT+1) = 'VLA:AUTOPHASE_DETERMINE'
         IIVA = NINTENT + 1
         INTENT(NINTENT+2) = 'VLA:AUTOPHASE_APPLY'
         IIVX = NINTENT +2
         INTENT(NINTENT+3) = 'VLA:AUTOPHASE_OFF'
         IIVO = NINTENT + 3
         INTENT(NINTENT+4) = 'VLA:SINGLE_DISH'
         IIVS = NINTENT + 4
         NINTENT = NINTENT + 4      
C
C        Loop over scans to set the required phasing intents if they are
C        to be based on VLAMODE.
C
         DO ISCN = SCAN1, SCANL
C
C           Only worry about the scan if the VLA is in it.
C           Note that SCHOPT has not yet been called, so the current
C           scans may not be the final ones and the VLA might be
C           dropped from the list later.  But set the phasing intents now.
C           They might show up later on non-VLA scans, but that is not
C           really a problem.
C
            IF( STASCN(ISCN,VLASTA) ) THEN
               NSCINT(ISCN) = NSCINT(ISCN) + 1
               IF( VLAMODE(ISCN) .EQ. ' ' ) THEN
                   ISCINT(NSCINT(ISCN),ISCN) = IIVO
               ELSE IF( VLAMODE(ISCN) .EQ. 'VA' ) THEN
                   ISCINT(NSCINT(ISCN),ISCN) = IIVA
               ELSE IF( VLAMODE(ISCN) .EQ. 'VX' ) THEN
                   ISCINT(NSCINT(ISCN),ISCN) = IIVX
               ELSE IF( VLAMODE(ISCN) .EQ. 'VS' ) THEN
                   ISCINT(NSCINT(ISCN),ISCN) = IIVS
               ELSE
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A, A, I5 )' )
     1               'VLASCNS: Invalid VLAMODE=', VLAMODE(ISCN),
     2               ' on scan ', ISCN
                  CALL WLOG( 1, MSGTXT )
                  CALL WLOG( 1, '         VLAMODE must be '' '', '//
     1               '''VA'', ''VX'', or ''VS''' )
                  CALL ERRLOG( '         A valid VLA phasing mode '//
     1               'via VLAMODE or INTENT is required.' )
               END IF
C
            END IF
         END DO
C
      END IF
C
C     -----------------
C
C     Now do a rather similar sequence of steps to deal with reference
C     pointing.
C
C     First find out if VLAPEAK is ever invoked for anything but OFF
C     during this observation.  Set VLADOPK.  Check for invalid VLAPEAK
C     commands while at it.
C
      VLADOPK = .FALSE.
      DO ISCN = SCAN1, SCANL
         IF( VLAPEAK(ISCN) .EQ. 'DETERMINE' .OR. 
     1       VLAPEAK(ISCN) .EQ. 'ADJUST' .OR.
     2       VLAPEAK(ISCN) .EQ. 'APPLY' ) THEN
            VLADOPK = .TRUE.
         ELSE IF( VLAPEAK(ISCN) .NE. 'OFF' ) THEN
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, A, A, I5 )' )
     1          'VLASCNS:  Invalid VLAPEAK ', VLAPEAK(ISCN), 
     2          ' found on scan ', ISCN 
            CALL WLOG( 1, MSGTXT ) 
            CALL WLOG( 1, 
     1         '          It must be DETERMINE, ADJUST, APPLY, or OFF' )
            CALL ERRLOG( ' Fix VLAPEAK ' )
         END IF
      END DO
C
C     Detect if any VLA reference pointing INTENTS were given by the
C     observer.  If so, set the pointers.  These would be INTENTS that
C     either have no station qualifier (no ":") or are for the VLA.
C
      IIDE = 0
      IIAP = 0
      IIAD = 0
      IIOF = 0
      IF( NINTENT .GE. 1 ) THEN
         DO II = 1, NINTENT
            IF( INDEX( INTENT(II), ':' ) .EQ. 0  .OR. 
     1          INDEX( INTENT(II), 'VLA' ) .NE. 0 ) THEN
               IF( INDEX( INTENT(II), 'REFERENCE_POINTING_DETERMINE' ) 
     1              .NE. 0 ) IIDE = II
               IF( INDEX( INTENT(II), 'REFERENCE_POINTING_APPLY' ) 
     1              .NE. 0 ) IIAP = II
               IF( INDEX( INTENT(II), 'REFERENCE_POINTING_ADJUST' ) 
     1              .NE. 0 ) IIAD = II
               IF( INDEX( INTENT(II), 'REFERENCE_POINTING_OFF' ) 
     1              .NE. 0 ) IIOF = II
            END IF
         END DO
      END IF
      GOTPTINT = IIDE .NE. 0 .OR. IIAP .NE. 0 .OR. IIAD .NE. 0 .OR.
     1           IIOF .NE. 0
C        
C     Don't allow both INTENTS and VLAPEAKs.
C        
      IF( VLADOPK .AND. GOTPTINT ) THEN
         CALL WLOG( 1, 'VLASCNS:  Both VLA reference pointing '//
     1       'INTENTS and VLAPEAK are used in the same schedule.' )
         CALL WLOG( 1, '          This confuses SCHED so do not '//
     1       'do it.  VLAPEAK is preferred.' )
         CALL ERRLOG( 
     1      '           Use only VLAPEAK -or- pointing INTENTS ' )
      END IF
C
C     If they are using INTENTS, let them hang themselves.  Put if, as
C     recommended, they use VLAPEAK, set up the appropriate intents.
C
      IF( VLADOPK ) THEN
         IF( NINTENT + 4 .GT. MINTENT ) CALL ERRLOG( 
     1      'VLASCNS: Too many intents for SCHED arrays after adding '//
     2      'VLA pointing commands.' )
         IIDE = NINTENT + 1
         INTENT(NINTENT+1) = 'VLA:REFERENCE_POINTING_DETERMINE'
         IIAP = NINTENT + 2
         INTENT(NINTENT+2) = 'VLA:REFERENCE_POINTING_APPLY'
         IIAD = NINTENT + 3
         INTENT(NINTENT+3) = 'VLA:REFERENCE_POINTING_ADJUST'
         IIOF = NINTENT + 4
         INTENT(NINTENT+4) = 'VLA:REFERENCE_POINTING_OFF'
         NINTENT = NINTENT + 4
C         
C        Loop over scans and set the INTENTS as required.
C         
         DO ISCN = SCAN1, SCANL
C         
C           Only worry about the scan if the VLA is in it.
C           Note that SCHOPT has not yet been called, so the current
C           scans may not be the final ones and the VLA might be
C           dropped from the list later.  But set the phasing intents now.
C           They might show up later on non-VLA scans, but that is not
C           really a problem.
C         
            IF( STASCN(ISCN,VLASTA) ) THEN
C         
C              Set the INTENT according to VLAPEAK.
C         
               NSCINT(ISCN) = NSCINT(ISCN) + 1
               IF( VLAPEAK(ISCN) .EQ. 'DETERMINE' ) THEN
                  ISCINT(NSCINT(ISCN),ISCN) = IIDE
               ELSE IF( VLAPEAK(ISCN) .EQ. 'APPLY' ) THEN
                  ISCINT(NSCINT(ISCN),ISCN) = IIAP
               ELSE IF( VLAPEAK(ISCN) .EQ. 'ADJUST' ) THEN
                  ISCINT(NSCINT(ISCN),ISCN) = IIAD
               ELSE IF( VLAPEAK(ISCN) .EQ. 'OFF' ) THEN
                  ISCINT(NSCINT(ISCN),ISCN) = IIOF
               ELSE
                  MSGTXT = ' '
                  WRITE( MSGTXT, '( A, A, A, I5 )' )
     1               'VLASCNS: Invalid VLAPEAK=', VLAPEAK(ISCN),
     2               ' on scan ', ISCN
                  CALL WLOG( 1, MSGTXT )
                  CALL WLOG( 1, '         VLAPEAK must be '//
     1               'OFF, DETERMINE, ADJUST, or APPLY' )
                  CALL ERRLOG( '         Correct VLAPEAK ' )
               END IF
C         
            END IF
C         
         END DO
      END IF
C
C   
      RETURN
      END

      SUBROUTINE STMSG
C
C     Routine for SCHED to write some useful information when it starts
C     up.  Also make some programming, especially parameter, checks.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
      INCLUDE 'schpeak.inc'
      INCLUDE 'plot.inc'
      INCLUDE 'rdcat.inc'
      CHARACTER  OPSTAT*4, OPTEXT*255
      LOGICAL    EXISTS
      INTEGER    IERR, VLBOPE, LEN1
C ---------------------------------------------------------------------
C     Open the run log.  Note cannot use ERRLOG if there is a problem
C     because the log file won't be open.
C
      READLOG = .FALSE.
      LOGFILE = 'sched.runlog'
      INQUIRE( FILE=LOGFILE, EXIST=EXISTS )
      IF( EXISTS ) THEN
         OPSTAT = 'OLD'
      ELSE
         OPSTAT = 'NEW'
      END IF
      IERR = VLBOPE( ILOG, LOGFILE, 'TEXT', OPSTAT, OPTEXT )
      IF( IERR .NE. 1 ) THEN 
         CALL WLOG( 1, 'STMSG: CANNOT OPEN LOG FILE ' // LOGFILE )
         CALL WLOG( 1, '       Error text: ' // OPTEXT )
         CALL ERROR( ' Check why log file cannot be opened' )
      END IF
C
      CALL WLOG( 1, ' ' )
      MSGTXT = ' '
      WRITE( MSGTXT, '( A, F6.2, 2X, A)' ) 
     1   '    Welcome to program SCHED.  Version: ', 
     2            VERNUM, VERSION(1:LEN1(VERSION))
      CALL WLOG( 1, MSGTXT )
      CALL WLOG( 1, ' ' )
C
      CALL WLOG( 1, 'The manual is at ' //
     1    'http://www.aoc.nrao.edu/software/sched/index.html' )
      CALL WLOG( 1, 'Unix users should set $SCHED to the base ' //
     1    'area where SCHED is installed.' )
C
C     Announce the run log.
C
      CALL WLOG( 1, 'Most run time messages will be in '
     1       //LOGFILE )
C
C     Initialize the frequency catalog version in case it isn't used.
C
      FREQVER = 'None used'
C ---------------------------------------------------------------------
C     Give some instructions.
C
      CALL WLOG( 1, ' ' )
      CALL WLOG( 1, 'Some useful commands to give now if running ' //
     1             'interactively:' )
      CALL WLOG( 1, '   SCHedule=<filename>    :  Specify input file.' )
      CALL WLOG( 1, '   PLOT                   :  '//
     1              'Invokes uv, xy, rd, and uptime plotting.' )
      CALL WLOG( 1, '   FREQLIST=lowF,highF    :  Make frequency list'//
     1          ' (MHz).  Then exit.' )
      CALL WLOG( 1, '   EXIT                   :  Leave program.' )
      CALL WLOG( 1, '   /                      :  End of inputs - '//
     1              'run program (or EXIT).' )
      CALL WLOG( 1, ' ' )
C
C ---------------------------------------------------------------------
C     Programming checks:
C
C     Since this is the first SCHED subroutine, use it to check
C     that some parameters from different includes that must be
C     related.  Since requiring sched.inc to come before schset.inc,
C     the number of tests is down.
C
      IF( MAXSTA .GT. PSTMAX ) THEN
         CALL ERRLOG( 'STMSG: Programming error.  MAXSTA .GT. PSTMAX' )
      END IF
C
      IF( MAXSRC .GT. PSOMAX ) THEN
         CALL ERRLOG( 'STMSG: Programming error.  MAXSRC .GT. PSOMAX' )
      END IF
C
      IF( MVEL .LT. MAXCHN ) THEN
         CALL ERRLOG( 'STMSG: Programming error.  MVEL .LT. MAXCHN' )
      END IF

C
C     Warn myself to reset the number of stations and/or scans from
C     configuration search versions to normal versions before a 
C     release.
C
      IF( MAXSTA .GT. 50 ) THEN
         CALL WLOG( 1, ' -------------------------------------' )
         WRITE( MSGTXT, '( A, I5, A )' ) 
     1         'STMSG: *****  MAXSTA greater than 50. (', MAXSTA, 
     2         ')' 
         CALL WLOG( 1, MSGTXT )
         MSGTXT = ' '
         CALL WLOG( 1, '       Reduce MAXSTA before a release' )
         CALL WLOG( 1, ' -------------------------------------' )
      END IF
      IF( MAXSCN .LT. 3000 ) THEN
         CALL WLOG( 1, ' -------------------------------------' )
         WRITE( MSGTXT, '( A, I5, A )' ) 
     1         'STMSG: *****  MAXSCN less than 3000.(', MAXSCN, 
     2         ')' 
         CALL WLOG( 1, MSGTXT )
         MSGTXT = ' '
         CALL WLOG( 1, '       Increase MAXSCN before a release' )
         CALL WLOG( 1, ' -------------------------------------' )
      END IF
C
C ----------------------------------------------------------------------
C     Now to the job at hand.
      RETURN
      END

      SUBROUTINE SRLIST( SNAME, RA8, DEC8, 
     1                   RAE, DECE, SEQUINOX, SCALC, SRUSED )
C
C     Routine for SCHED that makes a source list, using the
C     variables in srlist.inc, of all sources read in the catalogs.
C     This list should not be used for schedule creation, but is
C     meant for schedule planning, plotting etc.  It contains far
C     less information and precision than the main source information
C     kept in variables defined in sched.inc.
C
C     SNAME should be the first name from the catalog.  SCALC is the
C     calcode.  
C
C     All positions will be converted kept in their input equinox for
C     now, but will be converted by SCHPRE.
C
      INCLUDE            'srlist.inc'
C
      CHARACTER          SNAME*12, SCALC*1, SEQUINOX*5, MSGTXT*256
      DOUBLE PRECISION   RA8, DEC8
      REAL               RAE, DECE
      LOGICAL            WARNEPO, WARNN, SRUSED
      DATA               WARNEPO / .TRUE. /
      DATA               WARNN / .TRUE. /
C ----------------------------------------------------------------------
C     Count sources.
C
      SRLN = SRLN + 1
C
C     Make sure we are not overflowing the available arrays.
C
      IF( SRLN .GT. MAXSRL ) THEN
         SRLN = SRLN - 1
C
         IF( WARNN ) THEN
C
C           Write error message, but don't make fatal.  Too often, this
C           list is just not needed by the user.
C
            CALL WLOG( 1, 'SRLIST: Too man sources in source catalogs '
     1           // 'for complete list used by plot routines.' )
            MSGTXT = ' '
            WRITE( MSGTXT, '( A, I6 )' ) 
     1            '        Maximum number is ', MAXSRL
            CALL WLOG( 1, MSGTXT )
            CALL WLOG( 1, '        This only matters if you plan to '
     1           // 'ask SCHED for an RD plot of all catalog sources.' )
            WARNN = .FALSE.
         END IF
C
      ELSE
C
C        Accumulate the data.
C
         SRLNAME(SRLN) = SNAME
         SRLCALC(SRLN) = SCALC
         SRLRA(SRLN)   = RA8
         SRLDEC(SRLN)  = DEC8
         SRLRAE(SRLN)  = RAE
         SRLDECE(SRLN) = DECE
         SRLUSED(SRLN) = SRUSED
C
C        Get the source position in J2000 coordinates.
C        If an unrecognized equinox is used, just take the
C        coordinates unmodified, but give a warning.
C
         IF( SEQUINOX .EQ. 'J2000' ) THEN
            SRLEPO(SRLN) = 'J'
         ELSE IF( SEQUINOX .EQ. 'B1950' ) THEN
            SRLEPO(SRLN) = 'B'
         ELSE IF( SEQUINOX .EQ. 'DATE' ) THEN
            SRLEPO(SRLN) = 'D'
         ELSE
            SRLEPO(SRLN) = 'J'
            IF( WARNEPO ) THEN
               CALL WLOG( 1, 'SRLIST:  There are unrecognized EQUINOXs'
     1              // ' in the catalogs (' //  SEQUINOX // ')' )
               CALL WLOG( 1, 
     1              '         If you do RD plots of all sources, '
     2              // 'they may be based on unprecessed coordinates.' )
               WARNEPO = .FALSE.
            END IF
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE ROTVLBA( ISCN, ISTA, PTADD, LASTDY )
C
C     Writes focus/rotation pattern, which consists of a 
C     at a number of focus and rotation positions pointing sequence.  
C     Units are mm.
C
C     Feb 6, 2007  Account for rotation moving on curved path, not
C     straight, in calculation of az and el collimation offsets. RCW.
C
C     Feb. 22, 2011.  The rotation numbers actually used on the VLBA
C     (or at least reported) have a different zero point and different
C     sign convention (direction corresponding to a positive rotation)
C     from the numbers on the chart I used to get the FEEDPOS 
C     values below.  The actual numbers have an arbitrary zero, so don't
C     use them for the curvature calculations.  But do change curvature
C     calculation to recognize that a positive rotation is clockwise
C     looking down on the feed circle.  Do that by subtracting the
C     original values of FEEDPOS from 360 deg and changing the equations
C     for the collimation offsets.
C
C     June 27, 2011.  I'm getting a lot of failed rotation patterns so
C     something went wrong in the above logic.
C
C     In tjun26u, we had the following pattern:
C
C       Schedule     tsm FRM rec    Schedule      a priori    Measured  a pr. beta
C      foc    rot    foc     rot    azc   elc    azc    elc   azc  elc    azc  elc
C    -17.0    0.0   4.73  245.89    0.0   0.0   4.26  -4.10   4.2 -4.0    0.0  0.0
C      0.0  -12.0   6.42  233.89  -5.93  5.34  -1.67   1.24  -1.1  2.1  -4.69  6.46
C      0.0    0.0   6.43  245.90    0.0   0.0   4.26  -4.10   4.2 -4.0   0.0   0.0
C      0.0   12.0   6.43  257.89   4.69 -6.46   8.95 -10.56   9.1 -9.8   5.93 -5.34
C     17.0    0.0   8.13  245.88    0.0   0.0   4.26  -4.10   4.2 -4.0    0.0  0.0
C
C     So all is good in the focus pattern.
C
C     The scheduled rotation offsets have the same sign convention as 
C     the reported positions.  
C     
C     Reported rotation of 1cm is 303 so convention is clockwise looking
C     down (confirmed by looking at a photograph of Pie Town).
C     At the position of the 2cm receiver, one would expect that the 
C     Az collimation change would be larger for an increase in rotation
C     than for a decrease of the same amount.  That seems to be the 
C     opposite from what the a priori numbers request.  The Measured data 
C     for the positive move are from one point and are marginal.  But it looks
C     sort of like there isn't much effect in reality.  Certainly the
C     a priori numbers don't seem right.
C
C     Aarg - the focrot files have been using SCHED 9.4 and the Feb 2011 fixes
C     were not in that.  They are only in the beta.  But even so, I think
C     I'm not getting it quite right.  Get Jim to get some more data using
C     the beta version.
C
C     July 6, 2011.  Got more 2cm data.  Much improved, but not perfect.
C     Try to get a fit from rotanal using the second order versions.
C
      INCLUDE           'sched.inc'
      INCLUDE           'schset.inc'
C
      INTEGER           I, PTADD, ISCN, ISTA, IPAT, KS
      INTEGER           RLEVEL(MCHAN), DOY, LASTDY, IDUR, ISDUR
      REAL              DOAZ, DOEL, ROTINC, FOCINC, FEEDPOS
      REAL              DOFOC, DOROT, DOAZPAT, DOELPAT, LOWLIM
      DOUBLE PRECISION  PSTOP, FRACD
      CHARACTER         TSTOP*9, VLBAD*9, HUMAND*16, TFORM*9
      LOGICAL           BEGPAT, ENDPAT
C --------------------------------------------------------------------
C     Get the setup file pointer.
C
      KS = NSETUP(ISCN,ISTA)
C
C     Get the center pointing position.  This is a sum from both
C     the main schedule and the setup file.
C
      DOAZ = SAZCOL(ISCN) + AZCOLIM(KS)
      DOEL = SELCOL(ISCN) + ELCOLIM(KS)
C
C     Get some required data for the F/R pattern.
C     On-line system ignores commands to go beyond limit.
C     Limits are 28 and 684 mm.
C     13 cm has minimum of 65 other than at Nl
C     KP is 40 at 13 cm and 57 at 6 cm.
C     Use a maximum FOCINC of 30 and treat Nl specially
C     by not letting focus get below -10 at 13 cm and 
C     -25 at 6 cm.  Note normally FOCINC would be 100 for 13 cm
C     and 44cm for 6 cm.
C
C     FEEDPOS is the position measured clockwise when looking 
C     down on the feed circle.  The zero point is on the
C     E/W axis that goes between the 13cm and 4cm feeds.
C
      LOWLIM = -30.0
      IF( FE(2,KS) .EQ. '2cm' .OR. FE(4,KS) .EQ. '2cm' ) THEN
         ROTINC = 8.0                !  Expect 12 GHz (masers)
         FOCINC = 17.0
         FEEDPOS = ( 360. - 138.0 ) * RADDEG
      ELSE IF( FE(2,KS) .EQ. '1.3cm' .OR. FE(4,KS) .EQ. '1.3cm' .OR. 
     1         FE(2,KS) .EQ. '1cm' .OR. FE(4,KS) .EQ. '1cm') THEN
         ROTINC = 4.5
         FOCINC = 10.0
         FEEDPOS = ( 360. - 78.0 ) * RADDEG
      ELSE IF( FE(1,KS) .EQ. '7mm' .OR. FE(3,KS) .EQ. '7mm' ) THEN
         ROTINC = 2.2
         FOCINC = 5.0
         FEEDPOS = ( 360. - 155.0 ) * RADDEG
      ELSE IF( FE(2,KS) .EQ. '3mm' .OR. FE(4,KS) .EQ. '3mm' ) THEN
         ROTINC = 1.1
         FOCINC = 2.5
         FEEDPOS = ( 360. - 180.0 ) * RADDEG
      ELSE IF( FE(2,KS) .EQ. '90cm' .OR. FE(4,KS) .EQ. '90cm' .OR.
     1         FE(2,KS) .EQ. '50cm' .OR. FE(4,KS) .EQ. '50cm' .OR.
     2         FE(1,KS) .EQ. '20cm' .OR. FE(3,KS) .EQ. '20cm' ) THEN
         CALL ERRLOG( 'PTVLBA:  Cannot do rotpat for 50/90 or 20 cm.' )
      ELSE IF( FE(1,KS) .EQ. '6cm' .OR. FE(3,KS) .EQ. '6cm' ) THEN
         ROTINC = 20.0
         FOCINC = 30.0
         FEEDPOS = ( 360. - 108.0 ) * RADDEG
         IF( STCODE(STANUM(ISTA)) .EQ. 'Nl' ) LOWLIM = -25.0
      ELSE IF( FE(2,KS) .EQ. '4cm' .OR. FE(4,KS) .EQ. '4cm' ) THEN
         ROTINC = 12.0
         FOCINC = 26.0
         IF( FE(1,KS) .EQ. '13cm' .OR. FE(3,KS) .EQ. '13cm' ) THEN
            FEEDPOS = ( 360. - 32.0 ) * RADDEG
         ELSE
            FEEDPOS = ( 360. - 323.0 ) * RADDEG
         END IF
C
C     Put 13 cm after the 4cm so the sx is right.
C
      ELSE IF( FE(1,KS) .EQ. '13cm' .OR. FE(3,KS) .EQ. '13cm' ) THEN
         ROTINC = 45.0
         FOCINC = 30.0
         FEEDPOS = ( 360. - 32.0 ) * RADDEG
         IF( STCODE(STANUM(ISTA)) .EQ. 'Nl' ) LOWLIM = -10.0
      ELSE
         WRITE( MSGTXT, '( A, 4( 1X, A ) )' )
     1       'ROTVLBA:  Unrecognized FE: ', FE(1,KS), FE(2,KS), 
     2       FE(3,KS), FE(4,KS)
         CALL ERRLOG( MSGTXT )
      END IF

C
C     Do setup scan on half power point to get reasonable levels.
C     First go to half power point.  Note that subroutine VLBA
C     only does setup scans if tape is being written.
C
      DO I = 1, NCHAN(KS)
         RLEVEL(I) = -1 
      END DO
      CALL VLBAINT( 'level', 5, NCHAN(KS), RLEVEL, LLEVEL, MLEVEL,
     1           .FALSE., IUVBA )
C
C     Use a stop time that is STARTJ + PTSLEW.  This makes it
C     unnecessary to use PTADD as is used in PTVLBA.
C     Don't use durations until actually into the patterns.  
C     Deal with day changes.
C
      PSTOP = STARTJ(ISCN) + PTSLEW(ISCN) / 86400.D0
      CALL SCHDAY( PSTOP, VLBAD, HUMAND, DOY, FRACD )
      TSTOP = TFORM( FRACD*TWOPI, 'T', 0, 2, 2, 'hms' )
      IF( DOY .NE. LASTDY ) THEN
         WRITE( IUVBA, '(''date='', A9 )' ) VLBAD
         LASTDY = DOY
      END IF
C
C     Scan info.
C
      WRITE( IUVBA, '( A, F7.2, A, F7.2, /, A, /, 3A )' )
     1      'azcolim=', DOAZ - PTINCR(KS), ' elcolim=', DOEL,
     2      'focus=0.0  rotation=0.0  dur=0s ',
     3      'stop=', TSTOP, '   !NEXT! '
C
C     Then sit there while fixing the BBC levels.  Take long
C     enough for this to get a pcx test.  Assume that 2 times
C     PTDUR will be long enough.  The scan is set up in PTPAT.
C
      DO I = 1, NCHAN(KS)
         RLEVEL(I) = 256
      END DO
      CALL VLBAINT( 'level', 5, NCHAN(KS), RLEVEL, LLEVEL, MLEVEL,
     1 .FALSE., IUVBA ) 
C 
C     Now do the offset forcus and rotation positions if that is
C     desired.  For rotation, 40" (0.6666 arc min) collimation
C     change per degree is expected.  A 1 degree rotation
C     corresponds to a shift of the beam on the feed circle of
C     FCR*sin(1) = FCR*0.01745 where FCR is the radius of the feed
C     circle (which I don't happen to know at the moment - but it
C     is not needed - it divides out).  For large rotations, 
C     the beam shifts on a circle so you cannot just multiply the 
C     1 degree number by the rotation shift.  Instead, calculate 
C     the beam shift in the az and el axes and use that to get the 
C     pointing shift.  See the math in the code.
C     
C     Assume zero shift for focus offsets.
C 
C     Divide the total time into ROTPAT segments.  Test if 
C     they are of appropriate length. This allows for multiple 
C     pointing patterns at each focus/rotation position, if 
C     desired.  
C
      ISDUR = NINT( DUR(ISCN) * 86400.D0 ) 
      IDUR = ( ISDUR - PTSLEW(ISCN) - ROTPAT * 2 * PTDUR ) / ROTPAT
      IF( MOD( IDUR, 10 * PTDUR ) .NE. 0 ) THEN

         CALL WLOG( 1, 'ROTVLBA: Scan length not well ' //
     1       'matched to focus/rotation pattern time.' )
         CALL WLOG( 1, '  (need DUR = PTSLEW + ROTPAT*' //
     1       '(2*PTDUR+N*10*PTDUR)).' )
         MSGTXT = ' '
         WRITE( MSGTXT, '( 4( A, I4 ) )' ) 
     1       '  DUR =', ISDUR, ', PTSLEW =', PTSLEW(ISCN),
     2       ', ROTPAT =', ROTPAT, ', and PTDUR =', PTDUR
         CALL WLOG( 1, MSGTXT )
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, I4  )' ) 
     1       '  Time available for each loop of 10 scan pointings:',
     2       IDUR
         CALL WLOG( 1, MSGTXT )
      END IF
      DO IPAT = 1, ROTPAT
C
C        Deal with time, including possible day change.
C
         PSTOP = PSTOP + ( DUR(ISCN) - PTSLEW(ISCN) / 86400.D0 ) /
     1            ROTPAT
         CALL SCHDAY( PSTOP, VLBAD, HUMAND, DOY, FRACD )
         TSTOP = TFORM( FRACD*TWOPI, 'T', 0, 2, 2, 'hms' )
         IF( DOY .NE. LASTDY ) THEN
            WRITE( IUVBA, '(''date='', A9 )' ) VLBAD
            LASTDY = DOY
         END IF
         WRITE( IUVBA, '( A, A )' ) 'stop = ', TSTOP
C
C        Get the focus and rotation values.
C        Change the sign on DOAZPAT's addition to go with the
C        change in the FEEDPOS convention.
C
         DOFOC = FOCUS(ISCN) + FOCINC * FOC(IPAT)
         IF( DOFOC .LT. LOWLIM ) DOFOC = LOWLIM
         DOROT = ROTATION(ISCN) + ROTINC * ROT(IPAT)
         DOAZPAT = DOAZ + ( 0.6666 / 0.01745 ) * 
     1       ( COS( DOROT * RADDEG + FEEDPOS ) - COS( FEEDPOS ) )
         DOELPAT = DOEL + ( 0.6666 / 0.01745 ) *
     1       ( SIN( DOROT * RADDEG + FEEDPOS ) - SIN( FEEDPOS ) )
         WRITE( IUVBA, '( A, F7.2, A, F7.2 )' ) 
     1      'focus = ', DOFOC, '  rotation = ', DOROT
         WRITE( IUVBA, '( A, F7.2, A, F7.2 )' )
     1      'azcolim=', DOAZPAT - PTINCR(KS), ' elcolim=', DOELPAT
         BEGPAT = IPAT .EQ. 1
         ENDPAT = IPAT .EQ. ROTPAT
         CALL PTPAT( IUVBA, DOAZPAT, DOELPAT, PTINCR(KS), 
     1        PTOFF(KS), PTDUR, QUAL(ISCN) )
      END DO
C
      RETURN
      END

      SUBROUTINE VLBAEND( ISTA, LASTDY, LSCN )
C
C     Routine for SCHED called by VLBA to finish off the VLBA control
C     file.  This was much more complicated in the tape days when 
C     postpasses were an issue.
C
C     Note that we are depending on TPCDRIV retaining the value
C     it had at the end of the last valid scan.  Hence its presence
C     among the SAVEd variables in routine VLBA.
C
      INCLUDE  'sched.inc'
C
      INTEGER           LASTDY, LSCN, ISTA
      CHARACTER         TSTOP*9, VLBASTOP*9
      DOUBLE PRECISION  OFFSET
C --------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'VLBAEND: Starting.' )
C
C     Deal with wrapping up the recordings if any were being made.
C
      IF( VLBITP ) THEN
C
C        Turn off the disk, but let tape determine the other details.
C
         IF( USEDISK(ISTA) ) THEN
            WRITE( IUVBA, '( A )' ) 'disk=off'
         END IF
C
C        Do a final short recording off scan then quit.  This final 
C        scan is probably not needed, but was there from the tape
C        days and I won't perturb things.  Keep the 5 seconds total
C        that was used before for now.
C
         OFFSET = 5.D0
         TSTOP = VLBASTOP( STOPJ(LSCN), OFFSET, LASTDY, TWOPI, IUVBA )
         WRITE( IUVBA, '( A, A9, A )' )
     1       'stop=', TSTOP, '   !NEXT!'
C
      END IF
C
C     Finally really quit the program for all cases.
C
      WRITE( IUVBA, '(A)' ) '     !QUIT! '
C
      RETURN
      END

      SUBROUTINE VSOPWRT
C
C     Stub for VSOP writing stuff in use in Japan.
C
C --------------------------------------------------------------------
      CALL WLOG( 1, 'VSOPWRT: Don''t have the VSOP routines.' )
      RETURN
      END

      SUBROUTINE STALST( MJD )
C
C     Subroutine for SCHED that writes a table of station information 
C     to summary file.  Include the tape initialization stuff.
C
C     June 8, 2018 RCW  Allow for STCODE longer than 2 characters in 
C     top row of the baseline length table.  Also clean up some implicit
C     type conversions that generated warnings.
C
      INCLUDE  'sched.inc'
C
      INTEGER    ISTA, ISCAT, IC1, IC2, BLENKM, LEN1, JSTA, JSCAT
      INTEGER    NNSTA, MJD, NMINP, NPREST, ISCN, IM, IP, ISCL, ISCL1
      REAL       BLENSQ, YEARS
      LOGICAL    ANYDISK, ANYELSE, AXWARN, NEW, MOREM, MOREP
      DOUBLE PRECISION  MINPPRT(6), PRESTPRT(6)
C ----------------------------------------------------------------------
C
      WRITE( ISUM, '( 1X, /, 1X, /, 1X, /, A, /, 1X, /, A,A, /, '//
     1         ' 87X, A /, 1X )' )
     1      'STATIONS USED IN SCHEDULE:',
     2      '   Station  Code   Latitude Longitude  Elevation ',
     3      '      X            Y            Z       Axis',
     4      'Offset'
      AXWARN = .FALSE.
      DO ISTA = 1, NSTA
          ISCAT = STANUM(ISTA)
          WRITE( ISUM, '( 3X, A8, 2X, A3, F10.5, F11.5, F9.0, 2X, ' //
     1           ' 3F13.3, F7.3 )' ) 
     2        STATION(ISCAT), STCODE(ISCAT),
     3        LAT(ISCAT)/RADDEG,
     4        LONG(ISCAT)/RADDEG,
     5        ELEV(ISCAT),
     6        XPOS(ISCAT), YPOS(ISCAT), ZPOS(ISCAT), AXOFF(ISCAT)
         IF( AXOFF(ISCAT) .EQ. 0.0 .AND. 
     1       STATION(ISCAT)(1:3) .NE. 'VLA' ) AXWARN = .TRUE.
      END DO
C
C     While we're poking at geometry data, issue a warning if
C     the axis offset is zero for one or more stations.  Don't do
C     this for the VLA (or add other phased arrays eventually).
C
      IF( AXWARN ) THEN
         CALL WLOG( 1, 'STALST:  WARNING - A station has zero '//
     1      'axis offset, which is unlikely. ' )
         CALL WLOG( 1, '         Accurate positions, including '//
     1      'axis offsets are needed for correlation.' )
         CALL WLOG( 1, '         Is your station location '//
     1      'information adequate?' )
         CALL WLOG( 1, '         See the summary file station '// 
     1      'list to see which stations are suspect.' )
      END IF
C
C     Write the rates and adjusted positions.
C
      WRITE( ISUM, '(  1X, /, 1X, /, A, I6 )' )
     1      '   Plate tectonic motion adjustments for MJD ', MJD
      WRITE( ISUM, '( A,A, /, 15X, A, A )' )
     1      '   Station  Code      Station motions (m/yr)  ',
     2      '           Adjusted positions ',
     3      '      X       Y       Z  ', 
     4      '   MJD0        X            Y            Z '
C
C     Not using the real value of 365.24... here because 365.25 is 
C     the number used when deriving the rates in SOLVE according 
C     to John Gipson of GSFC in email on Dec. 11, 2008.  That 
C     number is based on the defined value of 36525 for the 
C     Julian century that is the time unit for many astronomical 
C     calculations.
C
      DO ISTA = 1, NSTA
          ISCAT = STANUM(ISTA)
          YEARS = REAL( ( MJD - MJDRATE(ISCAT) ) / 365.25D0 ) 
          WRITE( ISUM, '( 3X, A8, 2X, A3, 3F8.4, I7, 1X, 3F13.3 )' )
     1        STATION(ISCAT), STCODE(ISCAT),
     2        DXPOS(ISCAT), DYPOS(ISCAT), DZPOS(ISCAT), MJDRATE(ISCAT),
     3        XPOS(ISCAT) + DXPOS(ISCAT) * YEARS, 
     4        YPOS(ISCAT) + DYPOS(ISCAT) * YEARS, 
     5        ZPOS(ISCAT) + DZPOS(ISCAT) * YEARS
      END DO
C
C     Make a matrix of baseline lengths, if there are any
C     baselines (for VLA schedules, there often won't be).
C     Only do first 30 stations across if there are more.
C
      NNSTA = NSTA
      IF( NNSTA .GT. 30 ) NNSTA = 30
      IF( NNSTA .GT. 1 ) THEN
         WRITE( ISUM, '( 1X, /, 1X, /, 1X, /, A, /, 1X )' )
     1         'BASELINE LENGTHS (km)'
         MSGTXT = ' '
C
C        Write the station codes across the top.
C
         ISCL1 = LEN1(STCODE(1))
         DO ISTA = 1, NNSTA
            ISCAT = STANUM(ISTA)
            ISCL = LEN1(STCODE(ISCAT))
            IC1 = 13 - ISCL1 + ( ISTA - 1 ) * 6
            IC2 = IC1 + ISCL - 1
            MSGTXT(IC1:IC2) = STCODE(ISCAT)
         END DO
C
C        Now write a line for each station.
C
         WRITE( ISUM, '( A, /, 1X )' ) MSGTXT(1:LEN1(MSGTXT))
         DO JSTA = 1, NSTA
            JSCAT = STANUM(JSTA)
            MSGTXT = '   ' // STCODE(JSCAT)
            DO ISTA = 1, NNSTA
               ISCAT = STANUM(ISTA)
               BLENSQ = REAL( 
     1                  ( ( XPOS(JSCAT) - XPOS(ISCAT) ) / 1000.0 )**2 +
     2                  ( ( YPOS(JSCAT) - YPOS(ISCAT) ) / 1000.0 )**2 +
     3                  ( ( ZPOS(JSCAT) - ZPOS(ISCAT) ) / 1000.0 )**2 )
               BLENKM = NINT( SQRT( BLENSQ ) )
               IC1 = 8 + ( ISTA - 1 ) * 6
               IC2 = IC1 + 5
               WRITE( MSGTXT(IC1:IC2), '( I5 )' ) BLENKM
            END DO
            WRITE( ISUM, '( A )' ) MSGTXT(1:LEN1(MSGTXT))
         END DO
      END IF
C
C     Recording systems.
C
      IF( .NOT. ( VLAONLY .OR. NOTAPE ) ) THEN
C
C        First find out what we have.
C
         ANYDISK = .FALSE.
         ANYELSE = .FALSE.
         DO ISTA = 1, NSTA      
            ANYDISK = ANYDISK .OR. USEDISK(ISTA)
            ANYELSE = ANYELSE .OR. .NOT. USEDISK(ISTA)
         END DO
         WRITE( ISUM, '( 1X, /, 1X, /, A )' )
     1      'RECORDING SYSTEM AND CALIBRATION INFORMATION:'
C
C        Tell the parameters related to recording:
C        These are scan dependent so collect the ones seen.
C        If there are more than 6, just write 'more' for the last.
C
         NMINP = 1
         NPREST = 1
         MOREM = .FALSE.
         MOREP = .FALSE.
         MINPPRT(1) = MINPAUSE(SCAN1)
         PRESTPRT(1) = PRESTART(SCAN1)
         DO ISCN = SCAN1 + 1, SCANL
            NEW = .TRUE.
            DO IM = 1, NMINP
               IF( MINPAUSE(ISCN) .EQ. MINPPRT(IM) ) NEW = .FALSE.
            END DO
            IF( NEW ) THEN
               IF( NMINP .GE. 5 ) THEN
                  MOREM = .TRUE.
               ELSE
                  NMINP = NMINP + 1
                  MINPPRT(NMINP) = MINPAUSE(ISCN)
               END IF
            END IF               
C
            NEW = .TRUE.
            DO IP = 1, NPREST
               IF( PRESTART(ISCN) .EQ. PRESTPRT(IP) ) NEW = .FALSE.
            END DO
            IF( NEW ) THEN
               IF( NPREST .GE. 5 ) THEN
                  MOREP = .TRUE.
               ELSE
                  NPREST = NPREST + 1
                  PRESTPRT(NPREST) = PRESTART(ISCN)
               END IF
            END IF
         END DO
         WRITE( ISUM, '( 1X, /, A, A )' )
     1      '  List of scan-dependent controls seen for recording ',
     2      'timing.'
C
         MSGTXT = '   MINPAUSE:'
         IC1 = LEN1( MSGTXT ) + 1
         DO IM = 1, NMINP
            WRITE( MSGTXT(IC1:IC1+5), '( F6.0)' ) MINPPRT(IM) / ONESEC
            IC1 = IC1 + 6
         END DO        
         IF( MOREM ) WRITE( MSGTXT(IC1:IC1+4), '( A )' ) ' more'
         WRITE( ISUM, '( A )' ) MSGTXT(1:LEN1(MSGTXT))
C
         MSGTXT = '   PRESTART:'
         IC1 = LEN1( MSGTXT ) + 1
         DO IM = 1, NPREST
            WRITE( MSGTXT(IC1:IC1+5), '( F6.0)' ) PRESTPRT(IM) / ONESEC
            IC1 = IC1 + 6
         END DO        
         IF( MOREP ) WRITE( MSGTXT(IC1:IC1+4), '( A )' ) ' more'
         WRITE( ISUM, '( A )' ) MSGTXT(1:LEN1(MSGTXT))
C
C        Deal with disk stations.
C
         IF( ANYDISK ) THEN
            WRITE( ISUM, '( 1X, /, A, /, A )' )
     1          '  DISKS - Stations potentially recording on disks.',
     2          '   Station    Drive type   DAR     NBBC    Tsys'
            DO ISTA = 1, NSTA
               IF( USEDISK(ISTA) ) THEN
                  ISCAT = STANUM(ISTA)
                  WRITE( ISUM, '( 3X, A8, 5X, A6, 5X, A5, I6,5X,A4 )' )
     1               STATION(ISCAT), DISK(ISCAT), DAR(ISCAT), 
     2               NBBC(ISCAT), TSCAL(ISCAT)
               END IF
            END DO              
         END IF
C
C        Others.
C
         IF( ANYELSE ) THEN
            WRITE( ISUM, '( 1X, /, A, /, A, /, 1X )' )
     1          '  OTHER - Stations with other recording systems.',
     2          '   Station    Drive type '
            DO ISTA = 1, NSTA
               IF( .NOT. ( USEDISK(ISTA) ) ) THEN
                  ISCAT = STANUM(ISTA)
                  WRITE( ISUM, '( 3X, A8, 5X, A6 )' )
     1               STATION(ISCAT),  RECORDER(ISCAT)
               END IF
            END DO              
         END IF
C
      END IF
C
      RETURN
      END

      LOGICAL FUNCTION VXCFPH( ISET, JSET )
C
C     returns true if PH block in 2 SCHED sets are identical
C     Routine specific for the VEX extension of SCHED. 
C     By H.J. van Langevelde, JIVE, 020596 
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER ISET, JSET, NITON, NJTON, ICH, I, J
      INTEGER ISIDE1, DUMMY(MAXCHN)
      INTEGER NTONI(MAXCHN), NTONJ(MAXCHN)
      INTEGER ITONI(MAXTON,MAXCHN), ITONJ(MAXTON,MAXCHN)
      LOGICAL IDENT 
      REAL TONIINT, TONJINT
      DOUBLE PRECISION LOISUM(MCHAN), LOJSUM(MCHAN)
      CHARACTER UPCAL*4
C ----------------------------------------------------------------------
C
      IDENT = .TRUE.      
C
C     Could be set, off or blank
C
      UPCAL = SPCAL(ISET)
      CALL UPCASE(UPCAL)
      IF ( UPCAL .EQ. 'OFF' ) TONIINT = 0.
      IF ( UPCAL .EQ. '1MHZ' ) TONIINT = 1.
      IF ( UPCAL .EQ. '5MHZ' ) TONIINT = 5.
      IF ( UPCAL .EQ. ' ' ) TONIINT = 1.
C      
      UPCAL = SPCAL(JSET)
      CALL UPCASE(UPCAL)
      IF ( UPCAL .EQ. 'OFF' ) TONJINT = 0.
      IF ( UPCAL .EQ. '1MHZ' ) TONJINT = 1.
      IF ( UPCAL .EQ. '5MHZ' ) TONJINT = 5.
      IF ( UPCAL .EQ. ' ' ) TONJINT = 1.
C
      IF( ABS(TONIINT-TONJINT) .GT. 1e-3 ) THEN
         IDENT = .FALSE.
      ELSE
C
C     but can also depend on all tones to be detected, first for ISET
C     start calculating Skyfeq and determine tones
C
         DO ICH = 1, NCHAN(ISET)
            IF( SIDE1(ICH,ISET) .EQ. 'U' ) THEN
               ISIDE1 = 1
            ELSE IF( SIDE1(ICH,ISET) .EQ. 'L' ) THEN
               ISIDE1 = -1
            ELSE
               CALL ERRLOG('VXCFPH: First LO sideband problem.' )
            END IF
            LOISUM(ICH) = FIRSTLO(ICH,ISET) + 
     1           DFLOAT(ISIDE1) * DBLE(BBSYN(ICH,ISET))
         END DO
C     
C        Now calculate find list of tones
C
         CALL VXTON2(-1, ISET, NCHAN(ISET), LOISUM,
     1       NETSIDE(1,ISET), BBFILT(1,ISET), 
     2       TONIINT, NITON, DUMMY,
     3       NTONI, ITONI )
C         
C        and the same for JSET:
C
         DO ICH = 1, NCHAN(JSET)
            IF( SIDE1(ICH,JSET) .EQ. 'U' ) THEN
               ISIDE1 = 1
            ELSE IF( SIDE1(ICH,JSET) .EQ. 'L' ) THEN
               ISIDE1 = -1
            ELSE
               CALL ERRLOG('VXCFPH: First LO sideband problem.' )
            END IF
            LOJSUM(ICH) =  FIRSTLO(ICH,JSET) + 
     1           DFLOAT(ISIDE1) * DBLE(BBSYN(ICH,JSET))
         END DO
C     
C        Now calculate value of tones to detect in JSET
C
         CALL VXTON2(-1, JSET, NCHAN(JSET), LOJSUM,
     1       NETSIDE(1,JSET), BBFILT(1,JSET), 
     2       TONIINT, NJTON, DUMMY,
     3       NTONJ, ITONJ )
C
C        now compare and find out if they are identical
C     
         IF( NITON .NE. NJTON ) THEN
            IDENT = .FALSE.
         ELSE
            DO I = 1, NITON
C
C              can't make this test very rigid, need to change to Double
C
               IF( NTONI(I) .NE. NTONJ(I) ) THEN
                  IDENT = .FALSE.
               ELSE
                  DO J = 1, NTONI(I)
                     IF( ITONI(J,I) .NE. ITONJ(J,I) )
     1                   IDENT = .FALSE.
                  END DO
               END IF
            END DO
         END IF
      END IF
C     
C     Because the phasecal has to know about which IF and has to be set 
C     to a new NPHVEX when there is a new FQ.
C
      IF( NCHAN(ISET) .NE. NCHAN(JSET) ) IDENT = .FALSE.
      DO ICH = 1, NCHAN(JSET)
         IF( ABS(LOISUM(ICH) - LOJSUM(ICH)) .GT. 1D-2 ) IDENT = .FALSE.
      END DO
C
      VXCFPH = IDENT 
C
      RETURN
      END

      SUBROUTINE PRTFREQ( KS, IUNIT )
C
C     Subroutine for SCHED called by PRTSET that writes frequency
C     related information from the setup file into the .sum file.
C
C     It is also used to write to the log file when there are 
C     problems detected with the setup.  IUNIT is the output
C     unit number.  KS is the setup group.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      INTEGER            I, IUNIT, KS, JS, KF, NNCHAN, KSCN, LEN1, IC
      INTEGER            JF, ICH, ICH1, ILINE, CRSETC(MAXCHN), KSTA
      DOUBLE PRECISION   BBCFREQ(MCHAN), BBCBW(MCHAN)
      DOUBLE PRECISION   LOSUM(MCHAN)
      CHARACTER          RESULT*100, FSMATSTR*132
      INTEGER            CRDN
      DOUBLE PRECISION   CRDF(MCHAN), CRDB(MCHAN), CRDLOSUM(MCHAN)
      CHARACTER          CRDS(MCHAN)*1
CC----------------------------------------------------------------------
      NNCHAN = NCHAN(KS)
      KSTA = ISETSTA(KS)
      IF( DEBUG ) THEN
         MSGTXT = ' '
         WRITE( MSGTXT, '( A, 3I7 )' ) 'PRTFREQ starting. ', 
     1       NNCHAN, NFSET, MAXPC
         CALL WLOG( 0, MSGTXT )
      END IF
C
C     Write to the output file.
C
      IF( NNCHAN .GT. 0 ) THEN
         WRITE( IUNIT, '( 1X )' )
         WRITE( IUNIT, '( 2X, A, 8( F10.2, :), /, 10X, 8( F10.2, :), ' 
     1           // ' /, 10X, 8( F10.2, :), /, 10X, 8( F10.2, :) )' )
     2           ' 1st LO=', ( FIRSTLO(I,KS), I = 1, NNCHAN )
         WRITE( IUNIT, '( 2X, A, 8( 9X, A1, :), /, 10X, 8( 9X, A1, :), '
     1           // ' /, 10X, 8( 9X, A1, :), /, 10X, 8( 9X, A1, :) )' )
     2           ' Net SB=', ( NETSIDE(I,KS), I = 1, NNCHAN )
         WRITE( IUNIT, '( 2X, A, 8( 9X, A1, :), /, 10X, 8( 9X, A1, :), '
     1           // ' /, 10X, 8( 9X, A1, :), /, 10X, 8( 9X, A1, :) )' )
     2           ' IF SB =', ( SIDE1(I,KS), I = 1, NNCHAN )
         WRITE( IUNIT, '( 2X, A, 8(6X,A4,:), /, 10X, 8( 6X, A4, :), '
     1           // '/, 10X, 8( 6X, A4, :), /, 10X, 8( 6X, A4, :) )' )
     2           ' Pol.  =', ( POL(I,KS), I = 1, NNCHAN )
         WRITE( IUNIT, '( 2X, A, 8( I10, :), /, 10X, 8( I10, :), ' 
     1           // ' /, 10X, 8( I10, :), /, 10X, 8( I10, :) )' )
     2           ' BBC   =', ( BBC(I,KS), I = 1, NNCHAN )
         WRITE( IUNIT, '( 2X, A, 8( 9X, A1, :), /, 10X, 8( 9X, A1, :), '
     1           // ' /, 10X, 8( 9X, A1, :), /, 10X, 8( 9X, A1, :) )' )
     2           ' BBC SB=', ( SIDEBD(I,KS), I = 1, NNCHAN )
         WRITE( IUNIT, '( 2X, A, 8( 8X, A2, :), /, 10X, 8( 8X, A2, :), '
     1           // ' /, 10X, 8( 8X, A2, :), /, 10X, 8( 8X, A2, :) )' )
     2           ' IF    =', ( IFCHAN(I,KS), I = 1, NNCHAN )
      ELSE
         CALL WLOG( 0, 'PRTFREQ:  No channels!  Program problem.' )
      END IF
C
C     Some non-channel dependent data for vlba stations.
C
      IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) THEN
         WRITE( IUNIT, '( 1X, /, 2X, A, 4(5X,A4) )' )
     1           ' VLBA FE=', (FE(I,KS),I=1,4)
         IF( ABS( SYNTH(1,KS) * 10.D0 - DNINT( SYNTH(1,KS) * 10.D0 ) )
     1       .GT. 1.D-6 .OR.
     2       ABS( SYNTH(2,KS) * 10.D0 - DNINT( SYNTH(2,KS) * 10.D0 ) )
     3       .GT. 1.D-6 ) THEN
            WRITE( IUNIT, '( 2X, A, 2F12.5, F9.1 )' )
     1           ' VLBA Synth=', (SYNTH(I,KS),I=1,3)
         ELSE
            WRITE( IUNIT, '( 2X, A, F6.1, 2F9.1 )' )
     1           ' VLBA Synth=', (SYNTH(I,KS),I=1,3)
         END IF
      END IF
C
C     List the frequency sets.  Try to catch all sets that use this
C     basic setup, even if not used by the station of this setup.
C     LISTKS was set in SCHSUM to record which setup of those that
C     are similar got fully listed.  FSETKS records which setup a
C     frequency set comes from.  Require that LISTKS be the same 
C     for the current setup KS and the one a frequency set is from
C     to be sure they are basically the same.  Meanwhile, actually
C     list the frequency set information for the lowest numbered
C     frequency set of those that are the same, as recorded in
C     FSSAME which was set in GETFSET.
C
      IF( NFSET .GT. 0 ) THEN
         WRITE( IUNIT, '( 1X, /, A, A )' ) '  The following ',
     1         'frequency sets based on these setups were used.'
         IF( SETSTA(1,KS)(1:4) .EQ. 'VLBA' ) THEN
            WRITE( IUNIT, '( A, A )' )
     1         '     See the crd files for VLBA legacy system ',
     2         'setups and pcal detection details.'
         END IF
         DO KF = 1, NFSET
            JS = FSETKS(KF)
            IF( LISTKS(JS) .EQ. LISTKS(KS) .AND. 
     1          FSSAME(KF) .EQ. KF ) THEN
               KSCN = FSETSCN(KF)
C
C              Get the frequencies to be used for this frequency set.
C
               CALL FSFREQ( KF, LOSUM, BBCFREQ, BBCBW,
     1                      CRDN, CRDF, CRDB, CRDS, CRDLOSUM, CRSETC )
C        
C              Write a label that depends on whether this is a 
C              default set.
C        
               IF( FREQ(1,KSCN) .NE. 0.D0 .OR.
     1             BW(1,KSCN) .NE. 0.D0 ) THEN
                  WRITE( MSGTXT, '( A, I4, A )' )
     1                '  Frequency Set:', KF, 
     2                '  Based on FREQ, BW, and/or DOPPLER in schedule.'
C
C                 See if a warning is needed concerning IF ranges.
C
                  CALL CHKIF( KS, RESULT, LOSUM, BBCBW )
C
C                 Warn directly of a problem.  Later also put warning
C                 in the summary file.
C
                  IF( RESULT .NE. 'OK' ) THEN
                     SETMSG = ' '
                     WRITE( SETMSG, '( A, I5, A )' )
     1                    'PRTFREQ:  **** Warning - in frequency set ',
     2                    KF, ' some requested frequencies are '
                     CALL WLOG( 1, SETMSG )
                     CALL WLOG( 1, '         outside the available '//
     1                     'IFs.  See summary file for details.' )
                  END IF
               ELSE
                  WRITE( MSGTXT, '( A, I4, A )' )
     1                '   Frequency Set:', KF, '  Setup file default.'
                  RESULT = 'OK'
               END IF
C
C              The details of the pcal detection on the VLBA used to
C              be included here, but that is getting messier as the
C              legacy system channels are no longer the same frequency
C              or bandwidth as the main schedule channels.  So remove
C              that information.  In fact, the whole concept of 
C              pcal sets is being removed.
C        
C              Note if used with CRD parameters.
C
               IF( GOTCRD(KSCN) ) THEN
                  IC = LEN1( MSGTXT ) + 1
                  WRITE( MSGTXT(IC:LEN(MSGTXT)), '( A )' ) 
     1                 '  Used with CRDFREQ or CRDDOP.'
               END IF                  
C
C              Add the pcal state for this freqency set.
C
               IC = LEN1( MSGTXT ) + 1
               WRITE( MSGTXT(IC:LEN(MSGTXT)), '( A, A )' ) 
     1                 '  Used with PCAL = ', FSPCAL(KF)
C        
C              Write the header line and a warning if there is one.
C
               WRITE( IUNIT, '( 1X, /, A )' ) MSGTXT(1:LEN1(MSGTXT))
               IF( RESULT .NE. 'OK' ) THEN
                  WRITE( IUNIT, '( 1X, A, A )' ) '   **** Warning ',
     1               RESULT(1:LEN1(RESULT) )
               END IF
C        
C              Write the frequencies etc for this frequency set.
C              ILINE is a dummy here.
C        
               IF( NNCHAN .GT. 0 ) THEN
                  ICH1 = 11
                  ILINE = 1
                  CALL LSTFREQ( IUNIT, LOSUM, BBCFREQ, BBCBW, ICH1, 
     1                NNCHAN, ILINE, 100, 8, .TRUE., .TRUE., 
     2                '   LO sum= ',
     3                '   BBC fr= ',
     4                '   Bandwd= ' )
C
               ELSE
                  CALL WLOG( 0, 'PRTFREQ:  Still no channels' )
               END IF
C
C              Deal with the crd information for VLBA stations when
C              using the RDBE.
C
               IF( CONTROL(KSTA) .EQ. 'VLBA' .AND. 
     1             DBE(KS)(1:4) .EQ. 'RDBE' ) THEN
                  WRITE( IUNIT, '( A, I2, A, 8I3 )' )
     1                '   VLBA legacy crd files using ', CRDN, 
     2                ' channels based on RDBE channels: ',
     3                (CRSETC(I),I=1,CRDN)
                  WRITE( IUNIT, '( A, 8F10.2 )' )
     1                '   CRD fr= ', (CRDF(I),I=1,CRDN)
                  WRITE( IUNIT, '( A, 8F10.2 )' )
     1                '   CRD bw= ', (CRDB(I),I=1,CRDN)
               END IF
C
C              Write the matching frequency sets.
C
               WRITE( FSMATSTR, '( A )' )  
     1              '    Matching frequency sets:'
               ICH = LEN1( FSMATSTR ) + 1
               DO JF = 1, NFSET
                  IF( FSSAME(JF) .EQ. KF .AND. ICH .LE. 129 ) THEN
                     WRITE( FSMATSTR(ICH:ICH+4), '( I4 )' ) JF
                     ICH = ICH + 4
                  END IF
               END DO    
               WRITE( IUNIT, '( A )' ) FSMATSTR(1:LEN1(FSMATSTR))
            END IF
         END DO
C
      ELSE
         IF( IUNIT .NE. 6 .AND. IUNIT .NE. ILOG ) THEN
            MSGTXT = 'PRTFREQ:  No frequency sets!  Program problem.'
            CALL WLOG( 1, MSGTXT )
            WRITE( IUNIT, '( A )' ) MSGTXT(1:LEN1(MSGTXT))
         ELSE
            CALL WLOG( 0, 
     1          '      The frequency sets are not yet known.' )
            CALL WLOG( 0,
     1          '      The following are the setup file frequencies.' )
            WRITE( IUNIT, '( A, 8F10.2,:, 6(/,11X,8(F10.2,:)) )' )
     1         '   Ref fr= ', ( FREQREF(I,KS), I  =1, NNCHAN )
            WRITE( IUNIT, '( A, 8F10.2,:, 6(/,11X,8(F10.2,:)) )' )
     1         '   BBC fr= ', ( BBSYN(I,KS), I = 1, NNCHAN )
            WRITE( IUNIT, '( A, 8F10.3,:, 6(/,11X,8(F10.3,:)) )' )
     1         '   Bandwd= ', ( BBFILT(I,KS), I = 1, NNCHAN )
         END IF
      END IF
C
C     The pulse cal information has been removed.  For the VLBA legacy
C     system, the user will need to check the crd files for what got
C     used.
C
      RETURN
      END

      SUBROUTINE sla_FK524 (R2000,D2000,DR2000,DD2000,P2000,V2000,
     :                      R1950,D1950,DR1950,DD1950,P1950,V1950)
*+
*     - - - - - -
*      F K 5 2 4
*     - - - - - -
*
*  Convert J2000.0 FK5 star data to B1950.0 FK4 (double precision)
*
*  This routine converts stars from the new, IAU 1976, FK5, Fricke
*  system, to the old, Bessel-Newcomb, FK4 system.  The precepts
*  of Smith et al (Ref 1) are followed, using the implementation
*  by Yallop et al (Ref 2) of a matrix method due to Standish.
*  Kinoshita's development of Andoyer's post-Newcomb precession is
*  used.  The numerical constants from Seidelmann et al (Ref 3) are
*  used canonically.
*
*  Given:  (all J2000.0,FK5)
*     R2000,D2000     dp    J2000.0 RA,Dec (rad)
*     DR2000,DD2000   dp    J2000.0 proper motions (rad/Jul.yr)
*     P2000           dp    parallax (arcsec)
*     V2000           dp    radial velocity (km/s, +ve = moving away)
*
*  Returned:  (all B1950.0,FK4)
*     R1950,D1950     dp    B1950.0 RA,Dec (rad)
*     DR1950,DD1950   dp    B1950.0 proper motions (rad/trop.yr)
*     P1950           dp    parallax (arcsec)
*     V1950           dp    radial velocity (km/s, +ve = moving away)
*
*  Notes:
*
*  1)  The proper motions in RA are dRA/dt rather than
*      cos(Dec)*dRA/dt, and are per year rather than per century.
*
*  2)  Note that conversion from Julian epoch 2000.0 to Besselian
*      epoch 1950.0 only is provided for.  Conversions involving
*      other epochs will require use of the appropriate precession,
*      proper motion, and E-terms routines before and/or after
*      FK524 is called.
*
*  3)  In the FK4 catalogue the proper motions of stars within
*      10 degrees of the poles do not embody the differential
*      E-term effect and should, strictly speaking, be handled
*      in a different manner from stars outside these regions.
*      However, given the general lack of homogeneity of the star
*      data available for routine astrometry, the difficulties of
*      handling positions that may have been determined from
*      astrometric fields spanning the polar and non-polar regions,
*      the likelihood that the differential E-terms effect was not
*      taken into account when allowing for proper motion in past
*      astrometry, and the undesirability of a discontinuity in
*      the algorithm, the decision has been made in this routine to
*      include the effect of differential E-terms on the proper
*      motions for all stars, whether polar or not.  At epoch 2000,
*      and measuring on the sky rather than in terms of dRA, the
*      errors resulting from this simplification are less than
*      1 milliarcsecond in position and 1 milliarcsecond per
*      century in proper motion.
*
*  References:
*
*     1  Smith, C.A. et al, 1989.  "The transformation of astrometric
*        catalog systems to the equinox J2000.0".  Astron.J. 97, 265.
*
*     2  Yallop, B.D. et al, 1989.  "Transformation of mean star places
*        from FK4 B1950.0 to FK5 J2000.0 using matrices in 6-space".
*        Astron.J. 97, 274.
*
*     3  Seidelmann, P.K. (ed), 1992.  "Explanatory Supplement to
*        the Astronomical Almanac", ISBN 0-935702-68-7.
*
*  P.T.Wallace   Starlink   19 December 1993
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION R2000,D2000,DR2000,DD2000,P2000,V2000,
     :                 R1950,D1950,DR1950,DD1950,P1950,V1950


*  Miscellaneous
      DOUBLE PRECISION R,D,UR,UD,PX,RV
      DOUBLE PRECISION SR,CR,SD,CD,X,Y,Z,W
      DOUBLE PRECISION V1(6),V2(6)
      DOUBLE PRECISION XD,YD,ZD
      DOUBLE PRECISION RXYZ,WD,RXYSQ,RXY
      INTEGER I,J

*  2Pi
      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925287D0)

*  Radians per year to arcsec per century
      DOUBLE PRECISION PMF
      PARAMETER (PMF=100D0*60D0*60D0*360D0/D2PI)

*  Small number to avoid arithmetic problems
      DOUBLE PRECISION TINY
      PARAMETER (TINY=1D-30)

*
*  CANONICAL CONSTANTS  (see references)
*

*  Km per sec to AU per tropical century
*  = 86400 * 36524.2198782 / 149597870
      DOUBLE PRECISION VF
      PARAMETER (VF=21.095D0)

*  Constant vector and matrix (by columns)
      DOUBLE PRECISION A(6),EMI(6,6)
      DATA A/ -1.62557D-6,  -0.31919D-6, -0.13843D-6,
     :        +1.245D-3,    -1.580D-3,   -0.659D-3/

      DATA (EMI(I,1),I=1,6) / +0.9999256795D0,
     :                        -0.0111814828D0,
     :                        -0.0048590040D0,
     :                        -0.000551D0,
     :                        -0.238560D0,
     :                        +0.435730D0 /

      DATA (EMI(I,2),I=1,6) / +0.0111814828D0,
     :                        +0.9999374849D0,
     :                        -0.0000271557D0,
     :                        +0.238509D0,
     :                        -0.002667D0,
     :                        -0.008541D0 /

      DATA (EMI(I,3),I=1,6) / +0.0048590039D0,
     :                        -0.0000271771D0,
     :                        +0.9999881946D0,
     :                        -0.435614D0,
     :                        +0.012254D0,
     :                        +0.002117D0 /

      DATA (EMI(I,4),I=1,6) / -0.00000242389840D0,
     :                        +0.00000002710544D0,
     :                        +0.00000001177742D0,
     :                        +0.99990432D0,
     :                        -0.01118145D0,
     :                        -0.00485852D0 /

      DATA (EMI(I,5),I=1,6) / -0.00000002710544D0,
     :                        -0.00000242392702D0,
     :                        +0.00000000006585D0,
     :                        +0.01118145D0,
     :                        +0.99991613D0,
     :                        -0.00002716D0 /

      DATA (EMI(I,6),I=1,6) / -0.00000001177742D0,
     :                        +0.00000000006585D0,
     :                        -0.00000242404995D0,
     :                        +0.00485852D0,
     :                        -0.00002717D0,
     :                        +0.99996684D0 /



*  Pick up J2000 data (units radians and arcsec/JC)
      R=R2000
      D=D2000
      UR=DR2000*PMF
      UD=DD2000*PMF
      PX=P2000
      RV=V2000

*  Spherical to Cartesian
      SR=SIN(R)
      CR=COS(R)
      SD=SIN(D)
      CD=COS(D)

      X=CR*CD
      Y=SR*CD
      Z=   SD

      W=VF*RV*PX

      V1(1)=X
      V1(2)=Y
      V1(3)=Z

      V1(4)=-UR*Y-CR*SD*UD+W*X
      V1(5)= UR*X-SR*SD*UD+W*Y
      V1(6)=         CD*UD+W*Z

*  Convert position+velocity vector to BN system
      DO I=1,6
         W=0D0
         DO J=1,6
            W=W+EMI(I,J)*V1(J)
         END DO
         V2(I)=W
      END DO

*  Position vector components and magnitude
      X=V2(1)
      Y=V2(2)
      Z=V2(3)
      RXYZ=SQRT(X*X+Y*Y+Z*Z)

*  Apply E-terms to position
      W=X*A(1)+Y*A(2)+Z*A(3)
      X=X+A(1)*RXYZ-W*X
      Y=Y+A(2)*RXYZ-W*Y
      Z=Z+A(3)*RXYZ-W*Z

*  Recompute magnitude
      RXYZ=SQRT(X*X+Y*Y+Z*Z)

*  Apply E-terms to both position and velocity
      X=V2(1)
      Y=V2(2)
      Z=V2(3)
      W=X*A(1)+Y*A(2)+Z*A(3)
      WD=X*A(4)+Y*A(5)+Z*A(6)
      X=X+A(1)*RXYZ-W*X
      Y=Y+A(2)*RXYZ-W*Y
      Z=Z+A(3)*RXYZ-W*Z
      XD=V2(4)+A(4)*RXYZ-WD*X
      YD=V2(5)+A(5)*RXYZ-WD*Y
      ZD=V2(6)+A(6)*RXYZ-WD*Z

*  Convert to spherical
      RXYSQ=X*X+Y*Y
      RXY=SQRT(RXYSQ)

      IF (X.EQ.0D0.AND.Y.EQ.0D0) THEN
         R=0D0
      ELSE
         R=ATAN2(Y,X)
         IF (R.LT.0.0D0) R=R+D2PI
      END IF
      D=ATAN2(Z,RXY)

      IF (RXY.GT.TINY) THEN
         UR=(X*YD-Y*XD)/RXYSQ
         UD=(ZD*RXYSQ-Z*(X*XD+Y*YD))/((RXYSQ+Z*Z)*RXY)
      END IF

*  Radial velocity and parallax
      IF (PX.GT.TINY) THEN
         RV=(X*XD+Y*YD+Z*ZD)/(PX*VF*RXYZ)
         PX=PX/RXYZ
      END IF

*  Return results
      R1950=R
      D1950=D
      DR1950=UR/PMF
      DD1950=UD/PMF
      P1950=PX
      V1950=RV

      END

      SUBROUTINE VERWRAP( VERNUM, VERSION )
Cf2py intent(out) VERNUM
Cf2py intent(out) VERSION
      REAL VERNUM
      CHARACTER  VERSION*40
      CALL VERSCHED( VERNUM, VERSION )
      RETURN
      END

      SUBROUTINE FSVLBA( TSTOP, KS )
C
C     Routine for SCHED that writes the extra lines in a VLBA file for a
C     frequency switching loop.
C
C     This capability should probably be eliminated.  It was useful in the
C     MarkII days, but I doubt that it has been used since. There are several
C     input parameters associated with this.  Note added Sept. 23, 2013 RCW.
C
      INCLUDE  'sched.inc'
      INCLUDE  'schset.inc'
C
      CHARACTER  TSTOP*9
C
C     Common for communication with VLBASU.
C
      INTEGER  MBBCFREQ, KS
      DOUBLE PRECISION  LBBCFREQ(MCHAN)
      COMMON  / CVLBA /  LBBCFREQ, MBBCFREQ
      SAVE    /CVLBA/
C ----------------------------------------------------------------------
      WRITE( IUVBA, '( 3A, I4, A )' )
     1   'stop=', TSTOP, '  dur=', SWTCHDUR(KS), 
     2   's  !BEGIN LOOP!  !NEXT!'
C
      CALL VLBAREAL( 'bbsynth', 7, NCHAN(KS), BBSYN2(1,KS), LBBCFREQ,
     1         MBBCFREQ, '(F6.2)', 6, .FALSE., IUVBA )
C
      WRITE( IUVBA, '( A )' )
     1   'qual=2     !LOOP BACK!  !NEXT!'
C
      RETURN
      END

      SUBROUTINE VXSUDT( ISRC, INAME )
C 
C     Routine specific for the VEX extension of SCHED. 
C     Writes the detailed source paramters,  
C     for ISRC, using INAME alias number
C     By H.J. van Langevelde, JIVE, 051001
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 
C 
      INTEGER   ISRC, INAME

      INTEGER   LEN1
      INTEGER   I
C      REAL      RARATE, DECRAT
      CHARACTER TFORM*17, STRRA*17, STRDEC*17, CH1*1

      WRITE( IVEX, '( 5X, A, A, A1 )' )
     1    'source_name = ', 
     2    SOURCE(INAME,ISRC)(1:LEN1(SOURCE(INAME,ISRC))), SEP
C
C                 we have some info on cal code, write in comment
C
      WRITE( IVEX, '( A1, 4X, A, A1 )' )
     1     COM, 'this source had calibrator code: ', 
     2     CALCODE(ISRC)
C
      IF( PLANET(ISRC) ) THEN
         WRITE( IVEX, '( A1, 4X, A, A )' )
     1     COM, 'This source is a planet.  ',
     2     'The motion is not handled in VEX.'
         WRITE( IVEX, '( A1, 4X, A )' )
     1     COM, 'Do not use the position for pointing or correlation.'
      END IF

      IF( SATEL(ISRC) ) THEN

         WRITE( IVEX, '( A1, 4X, A / A1, 4X, A)' )
     1     COM, 'This source is a satellite; using NRAO extension:  ',
     2     COM, 'Do not use the position for pointing or correlation.'

C        Grab the satellite number and output the name of the TLE
C        file and the satellite number.  The satini routine checks
C        that exactly one of satfile/tlefile contains 'NONE'.

         I = SATN (ISRC)
         IF( SATFILE(I)(1:4) .NE. 'NONE' ) THEN
            WRITE( IVEX, '( 5x, "source_type = ", A, " : ", I8, ";" )')
     1         SATFILE (I)(1:LEN1(SATFILE (I))),
     2         SATNUM (I)
         ELSE
            WRITE( IVEX, '( 5x, "source_type = ", A, " : ", I8, ";" )')
     1         TLEFILE (I)(1:LEN1(TLEFILE (I))),
     2         SATNUM (I)
         END IF
      END IF

C
      DO I = 1, MALIAS
         IF( I .NE. INAME ) THEN
C
C                 source name is not sufficient, alternate source 
C                 names in comment, more than * source could appear
C
            IF( CSUSED(I,ISRC) .EQ. ' ' .OR.
     1          CSUSED(I,ISRC) .EQ. '+' .OR.
     2          CSUSED(I,ISRC) .EQ. '*' ) THEN 
               IF( SOURCE(I,ISRC) .NE. ' ' ) THEN
                  WRITE( IVEX, '( A1, 4X, A, A )' ) COM,
     1                'alternate source name: ',
     2                SOURCE(I,ISRC)(1:LEN1(SOURCE(I,ISRC)))
               END IF
            ELSE
               WRITE( MSGTXT, '( A, A1 )' ) 
     1             'VXWRDT: unclear CSUSED character: ',
     1             CSUSED(INAME,ISRC)
               CALL ERRLOG( MSGTXT )
            END IF
         END IF
      END DO
      IF( REMARK(ISRC) .NE. ' ' ) 
     1    WRITE( IVEX, '( A1, 4X, A )' ) COM, 
     2    REMARK(ISRC)(1:LEN1(REMARK(ISRC)))
C
C        Print the used coordinates, put others in comments,
C        first J2000
C        Dec. 12, 2008  RCW - changed to leave J2000 coordinate
C        uncommented.
C
      STRRA = TFORM( RA2000(ISRC), 'T', 0, 2, 10, 'hms' ) 
      STRDEC = TFORM( D2000(ISRC),  ' ', 1, 2, 9,  'd''"' )
      CH1 = ' '
C      IF( C2000(ISRC) .NE. ' ' ) CH1 = ' '
      WRITE( IVEX, '( A1, 4X, A, A, A1, 1X, A, A, A1, 1X, 
     1    A, A, A1 )' )
     2    CH1, 'ra = ', STRRA(1:LEN1(STRRA)), 
     3    SEP, 'dec = ', STRDEC(1:LEN1(STRDEC)),
     4    SEP, 'ref_coord_frame = ', 'J2000', SEP 
         
C
C        next 1950....
C
      STRRA = TFORM( RA1950(ISRC), 'T', 0, 2, 10, 'hms' ) 
      STRDEC = TFORM( D1950(ISRC),  ' ', 1, 2, 9, 'd''"' )
      CH1 = '*'
C       IF( C1950(ISRC) .NE. ' ' ) CH1 = ' '
      WRITE( IVEX, '( A1, 4X, A, A, A1, 1X, A, A, A1, 1X, 
     1    A, A, A1 )' )
     2    CH1, 'ra = ', STRRA(1:LEN1(STRRA)), 
     3    SEP, 'dec = ', STRDEC(1:LEN1(STRDEC)),
     4    SEP, 'ref_coord_frame = ', 'B1950', SEP
C
C           and last coordinates of DATE
C
C           June 19, 2009. RCW  Allow coordinates of date from user.
C           J2000 version will be used internally and in the Vex file.
C
      STRRA = TFORM( RAP(ISRC), 'T', 0, 2, 10, 'hms' ) 
      STRDEC = TFORM( DECP(ISRC),  ' ', 1, 2, 9, 'd''"' )
      CH1 = '*'
C      IF( CDATE(ISRC) .NE. ' ' ) 
C     1    CALL ERRLOG('VXWRDT: coordinates of date not supported')
      WRITE( IVEX, '( A1, 4X, A, A, A1, 1X, A, A, A1, 1X, 
     1    A, A, A1 )' )
     2    CH1, 'ra = ', STRRA(1:LEN1(STRRA)), 
     3    SEP, 'dec = ', STRDEC(1:LEN1(STRDEC)),
     4    SEP, 'ref_coord_frame = ', 'Date', SEP
C
C     Worked on this Dec. 13, 2008.  RCW
C     SCHED shifts the positions of sources subject to proper motion
C     to close to the time of the observation (default is stop time 
C     of the first scan).  This is because the precision available
C     at some antennas (eg VLA) for rates is not adequate to 
C     describe proper motions over years.  But SCHED can also 
C     handle planetary motions (seconds per day) which are typically
C     much faster than proper motions (arcsec/yr).  When shifting
C     a source position to a current epoch, SCHED also puts the
C     rates into the planetary motion terms even though they 
C     will typically be small.
C
C     DRA and DDEC are the planetary motions.  The units are s/day 
C     and arcsec/dsy (coordinate change per day).  I would prefer
C     to use these units, but the Vex definition seem to want
C     rates more apropriate for proper motion - arcsec/yr.  I
C     fear users may also only update the coordinate once rather
C     than tracking the position.
C
C     Thinking about this, I don't want do activate it until we
C     have a better understanding all around about what should
C     be done.  Don't panic for values too low to matter (like
C     actual stellar proper motions), but, for now, refuse to
C     deal with things moving fast enough to go more than 10
C     arcsec in a day, and warn about correlation if it is 
C     going more than 0.1 mas/day.
C     
      IF( DRA(ISRC) .GE. 0.0001/15.0 .OR. 
     1    DDEC(ISRC) .GE. 0.0001  ) THEN
         CALL WLOG( 1, '++++ VXSUDT: WARNING Planetary motion'//
     1      ' over 0.01 mas/day used.' )
         CALL WLOG( 1, '             VEX file does not describe it.' )
         CALL WLOG( 1, '             Do not use for correlation.' )
         IF( DRA(ISRC) .GE. 10.0/15.0 .OR. 
     1       DDEC(ISRC) .GE. 10.0  ) THEN
            CALL WLOG( 1, 
     1          '++++ VXSUDT: Planetary motion over 10 arcsec/day'//
     2          ' specified for source ' )
            CALL WLOG( 1, 
     1          '             ' // 
     2          SOURCE(INAME,ISRC)(1:LEN1(SOURCE(INAME,ISRC))) )
            CALL WLOG( 1, 
     1          '             Planetary motion is not implemented' //
     2          ' in VEX output, but this is too large for pointing')
            CALL WLOG( 1,
     1          '             for more than a short time.' )
            CALL WLOG( 1,
     1          '             Be sure to update position adequately' //
     2          ' often.' )
         END IF
C
C         The following is what was there after the last update.
C         It has a few problems.  DRA is a change of coordinate
C         value per day.  To get to arcsec, it would need to be
C         divided by cos(dec) in addition to the multiply by 15
C         to get from time to arc units.  Also the epoch is 
C         required to do anything useful with the rates.
C
C         RARATE = 15 * DRA(ISRC) * 365.25
C         DECRAT = DDEC(ISRC) * 365.25
C         WRITE( IVEX, '( 5X, A, G7.2, 1X, A, A1, 
C     1       1X, A, G7.2, 1X, A, A1 )' ) 'ra_rate = ', RARATE,
C     2       'asec/yr', SEP, 'dec_rate = ', DECRAT,
C     3       'asec/yr', SEP
      ENDIF
C
C     and vlsr when needed, not actually used, but others may need it
C
      IF( VLSR(1,ISRC) .GT. -1.E+8 ) THEN
         IF( VELREF(ISRC) .EQ. 'G' ) THEN 
            WRITE( IVEX, '( A1, 4X, A, F10.2, 1X, A,
     1          A1, 1X, A1, A )' )
     2          COM, 'velocity_wrt_Geo = ', VLSR(1,ISRC), 
     3          'km/sec', SEP, COM,
     4          ' warning, only given here for 1st channel'
         END IF
         IF( VELREF(ISRC) .EQ. 'H' ) THEN 
            WRITE( IVEX, '( A1, 4X, A, F10.2, 1X, A, 
     1          A1, 1X, A1, A )' )
     2          COM, 'velocity_wrt_Helio = ', VLSR(1,ISRC), 
     3          'km/sec', SEP, COM,
     2          ' warning, only given here for 1st channel'
         END IF
         IF( VELREF(ISRC) .EQ. 'L' ) THEN 
            WRITE( IVEX, '( A1, 4X, A, F10.2, 1X, A, 
     1          A1, 1X, A1, A )' )
     2          COM, 'velocity_wrt_LSR = ', VLSR(1,ISRC), 
     3          'km/sec', SEP, COM,
     2          ' warning, only given here for 1st channel'
         END IF
         IF( VELDEF(ISRC) .EQ. 'R' ) THEN 
            WRITE( IVEX, '( A1, 4X, A )' )
     2          COM, 
     2          'calculations used radio definition '
         END IF
         IF( VELDEF(ISRC) .EQ. 'O' ) THEN 
            WRITE( IVEX, '( A1, 4X, A )' )
     2          COM, 
     2          'calculations used optical definition '
         END IF
         IF( VELDEF(ISRC) .EQ. 'Z' ) THEN 
            WRITE( IVEX, '( A1, 4X, A )' )
     2          COM, 
     2          'calculations used redshift '
         END IF
      END IF

      RETURN
      END

      SUBROUTINE sla_EVP (DATE, DEQX, DVB, DPB, DVH, DPH)
*+
*     - - - -
*      E V P
*     - - - -
*
*  Barycentric and heliocentric velocity and position of the Earth
*
*  All arguments are double precision
*
*  Given:
*
*     DATE          TDB (loosely ET) as a Modified Julian Date
*                                         (JD-2400000.5)
*
*     DEQX          Julian Epoch (e.g. 2000.0D0) of mean equator and
*                   equinox of the vectors returned.  If DEQX .LE. 0D0,
*                   all vectors are referred to the mean equator and
*                   equinox (FK5) of epoch DATE.
*
*  Returned (all 3D Cartesian vectors):
*
*     DVB,DPB       barycentric velocity, position (AU/s, AU)
*     DVH,DPH       heliocentric velocity, position (AU/s, AU)
*
*  Called:  sla_EPJ, sla_PREC
*
*  Notes:
*
*  1  This routine is accurate enough for many purposes but faster and
*     more compact than the sla_EPV routine.  The maximum deviations
*     from the JPL DE96 ephemeris are as follows:
*
*       barycentric velocity         0.42  m/s
*       barycentric position         6900  km
*
*       heliocentric velocity        0.42  m/s
*       heliocentric position        1600  km
*
*  2  The routine is adapted from the BARVEL and BARCOR subroutines of
*     Stumpff (1980).  Most of the changes are merely cosmetic and do
*     not affect the results at all.  However, some adjustments have
*     been made so as to give results that refer to the IAU 1976 'FK5'
*     equinox and precession, although the differences these changes
*     make relative to the results from Stumpff's original 'FK4' version
*     are smaller than the inherent accuracy of the algorithm.  One
*     minor shortcoming in the original routines that has NOT been
*     corrected is that better numerical accuracy could be achieved if
*     the various polynomial evaluations were nested.
*
*  Reference:
*
*    Stumpff, P., Astron.Astrophys.Suppl.Ser. 41, 1-8 (1980).
*
*  Last revision:   7 April 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the 
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
*    Boston, MA  02111-1307  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,DEQX,DVB(3),DPB(3),DVH(3),DPH(3)

      INTEGER IDEQ,I,J,K

      REAL CC2PI,CCSEC3,CCSGD,CCKM,CCMLD,CCFDI,CCIM,T,TSQ,A,PERTL,
     :     PERTLD,PERTR,PERTRD,COSA,SINA,ESQ,E,PARAM,TWOE,TWOG,G,
     :     PHI,F,SINF,COSF,PHID,PSID,PERTP,PERTPD,TL,SINLM,COSLM,
     :     SIGMA,B,PLON,POMG,PECC,FLATM,FLAT

      DOUBLE PRECISION DC2PI,DS2R,DCSLD,DC1MME,DT,DTSQ,DLOCAL,DML,
     :                 DEPS,DPARAM,DPSI,D1PDRO,DRD,DRLD,DTL,DSINLS,
     :                 DCOSLS,DXHD,DYHD,DZHD,DXBD,DYBD,DZBD,DCOSEP,
     :                 DSINEP,DYAHD,DZAHD,DYABD,DZABD,DR,
     :                 DXH,DYH,DZH,DXB,DYB,DZB,DYAH,DZAH,DYAB,
     :                 DZAB,DEPJ,DEQCOR,B1950

      REAL SN(4),CCSEL(3,17),CCAMPS(5,15),CCSEC(3,4),CCAMPM(4,3),
     :     CCPAMV(4),CCPAM(4),FORBEL(7),SORBEL(17),SINLP(4),COSLP(4)
      EQUIVALENCE (SORBEL(1),E),(FORBEL(1),G)

      DOUBLE PRECISION DCFEL(3,8),DCEPS(3),DCARGS(2,15),DCARGM(2,3),
     :                 DPREMA(3,3),W,VW(3)

      DOUBLE PRECISION sla_EPJ

      PARAMETER (DC2PI=6.2831853071796D0,CC2PI=6.283185)
      PARAMETER (DS2R=0.7272205216643D-4)
      PARAMETER (B1950=1949.9997904423D0)

*
*   Constants DCFEL(I,K) of fast changing elements
*                     I=1                I=2              I=3
      DATA DCFEL/ 1.7400353D+00, 6.2833195099091D+02, 5.2796D-06,
     :            6.2565836D+00, 6.2830194572674D+02,-2.6180D-06,
     :            4.7199666D+00, 8.3997091449254D+03,-1.9780D-05,
     :            1.9636505D-01, 8.4334662911720D+03,-5.6044D-05,
     :            4.1547339D+00, 5.2993466764997D+01, 5.8845D-06,
     :            4.6524223D+00, 2.1354275911213D+01, 5.6797D-06,
     :            4.2620486D+00, 7.5025342197656D+00, 5.5317D-06,
     :            1.4740694D+00, 3.8377331909193D+00, 5.6093D-06/

*
*   Constants DCEPS and CCSEL(I,K) of slowly changing elements
*                      I=1           I=2           I=3
      DATA DCEPS/  4.093198D-01,-2.271110D-04,-2.860401D-08 /
      DATA CCSEL/  1.675104E-02,-4.179579E-05,-1.260516E-07,
     :             2.220221E-01, 2.809917E-02, 1.852532E-05,
     :             1.589963E+00, 3.418075E-02, 1.430200E-05,
     :             2.994089E+00, 2.590824E-02, 4.155840E-06,
     :             8.155457E-01, 2.486352E-02, 6.836840E-06,
     :             1.735614E+00, 1.763719E-02, 6.370440E-06,
     :             1.968564E+00, 1.524020E-02,-2.517152E-06,
     :             1.282417E+00, 8.703393E-03, 2.289292E-05,
     :             2.280820E+00, 1.918010E-02, 4.484520E-06,
     :             4.833473E-02, 1.641773E-04,-4.654200E-07,
     :             5.589232E-02,-3.455092E-04,-7.388560E-07,
     :             4.634443E-02,-2.658234E-05, 7.757000E-08,
     :             8.997041E-03, 6.329728E-06,-1.939256E-09,
     :             2.284178E-02,-9.941590E-05, 6.787400E-08,
     :             4.350267E-02,-6.839749E-05,-2.714956E-07,
     :             1.348204E-02, 1.091504E-05, 6.903760E-07,
     :             3.106570E-02,-1.665665E-04,-1.590188E-07/

*
*   Constants of the arguments of the short-period perturbations
*   by the planets:   DCARGS(I,K)
*                       I=1               I=2
      DATA DCARGS/ 5.0974222D+00,-7.8604195454652D+02,
     :             3.9584962D+00,-5.7533848094674D+02,
     :             1.6338070D+00,-1.1506769618935D+03,
     :             2.5487111D+00,-3.9302097727326D+02,
     :             4.9255514D+00,-5.8849265665348D+02,
     :             1.3363463D+00,-5.5076098609303D+02,
     :             1.6072053D+00,-5.2237501616674D+02,
     :             1.3629480D+00,-1.1790629318198D+03,
     :             5.5657014D+00,-1.0977134971135D+03,
     :             5.0708205D+00,-1.5774000881978D+02,
     :             3.9318944D+00, 5.2963464780000D+01,
     :             4.8989497D+00, 3.9809289073258D+01,
     :             1.3097446D+00, 7.7540959633708D+01,
     :             3.5147141D+00, 7.9618578146517D+01,
     :             3.5413158D+00,-5.4868336758022D+02/

*
*   Amplitudes CCAMPS(N,K) of the short-period perturbations
*           N=1          N=2          N=3          N=4          N=5
      DATA CCAMPS/
     : -2.279594E-5, 1.407414E-5, 8.273188E-6, 1.340565E-5,-2.490817E-7,
     : -3.494537E-5, 2.860401E-7, 1.289448E-7, 1.627237E-5,-1.823138E-7,
     :  6.593466E-7, 1.322572E-5, 9.258695E-6,-4.674248E-7,-3.646275E-7,
     :  1.140767E-5,-2.049792E-5,-4.747930E-6,-2.638763E-6,-1.245408E-7,
     :  9.516893E-6,-2.748894E-6,-1.319381E-6,-4.549908E-6,-1.864821E-7,
     :  7.310990E-6,-1.924710E-6,-8.772849E-7,-3.334143E-6,-1.745256E-7,
     : -2.603449E-6, 7.359472E-6, 3.168357E-6, 1.119056E-6,-1.655307E-7,
     : -3.228859E-6, 1.308997E-7, 1.013137E-7, 2.403899E-6,-3.736225E-7,
     :  3.442177E-7, 2.671323E-6, 1.832858E-6,-2.394688E-7,-3.478444E-7,
     :  8.702406E-6,-8.421214E-6,-1.372341E-6,-1.455234E-6,-4.998479E-8,
     : -1.488378E-6,-1.251789E-5, 5.226868E-7,-2.049301E-7, 0.0E0,
     : -8.043059E-6,-2.991300E-6, 1.473654E-7,-3.154542E-7, 0.0E0,
     :  3.699128E-6,-3.316126E-6, 2.901257E-7, 3.407826E-7, 0.0E0,
     :  2.550120E-6,-1.241123E-6, 9.901116E-8, 2.210482E-7, 0.0E0,
     : -6.351059E-7, 2.341650E-6, 1.061492E-6, 2.878231E-7, 0.0E0/

*
*   Constants of the secular perturbations in longitude
*   CCSEC3 and CCSEC(N,K)
*                      N=1           N=2           N=3
      DATA CCSEC3/-7.757020E-08/,
     :     CCSEC/  1.289600E-06, 5.550147E-01, 2.076942E+00,
     :             3.102810E-05, 4.035027E+00, 3.525565E-01,
     :             9.124190E-06, 9.990265E-01, 2.622706E+00,
     :             9.793240E-07, 5.508259E+00, 1.559103E+01/

*   Sidereal rate DCSLD in longitude, rate CCSGD in mean anomaly
      DATA DCSLD/1.990987D-07/,
     :     CCSGD/1.990969E-07/

*   Some constants used in the calculation of the lunar contribution
      DATA CCKM/3.122140E-05/,
     :     CCMLD/2.661699E-06/,
     :     CCFDI/2.399485E-07/

*
*   Constants DCARGM(I,K) of the arguments of the perturbations
*   of the motion of the Moon
*                       I=1               I=2
      DATA DCARGM/  5.1679830D+00, 8.3286911095275D+03,
     :              5.4913150D+00,-7.2140632838100D+03,
     :              5.9598530D+00, 1.5542754389685D+04/

*
*   Amplitudes CCAMPM(N,K) of the perturbations of the Moon
*            N=1          N=2           N=3           N=4
      DATA CCAMPM/
     :  1.097594E-01, 2.896773E-07, 5.450474E-02, 1.438491E-07,
     : -2.223581E-02, 5.083103E-08, 1.002548E-02,-2.291823E-08,
     :  1.148966E-02, 5.658888E-08, 8.249439E-03, 4.063015E-08/

*
*   CCPAMV(K)=A*M*DL/DT (planets), DC1MME=1-MASS(Earth+Moon)
      DATA CCPAMV/8.326827E-11,1.843484E-11,1.988712E-12,1.881276E-12/
      DATA DC1MME/0.99999696D0/

*   CCPAM(K)=A*M(planets), CCIM=INCLINATION(Moon)
      DATA CCPAM/4.960906E-3,2.727436E-3,8.392311E-4,1.556861E-3/
      DATA CCIM/8.978749E-2/




*
*   EXECUTION
*   ---------

*   Control parameter IDEQ, and time arguments
      IDEQ = 0
      IF (DEQX.GT.0D0) IDEQ=1
      DT = (DATE-15019.5D0)/36525D0
      T = REAL(DT)
      DTSQ = DT*DT
      TSQ = REAL(DTSQ)

*   Values of all elements for the instant DATE
      DO K=1,8
         DLOCAL = MOD(DCFEL(1,K)+DT*DCFEL(2,K)+DTSQ*DCFEL(3,K), DC2PI)
         IF (K.EQ.1) THEN
            DML = DLOCAL
         ELSE
            FORBEL(K-1) = REAL(DLOCAL)
         END IF
      END DO
      DEPS = MOD(DCEPS(1)+DT*DCEPS(2)+DTSQ*DCEPS(3), DC2PI)
      DO K=1,17
         SORBEL(K) = MOD(CCSEL(1,K)+T*CCSEL(2,K)+TSQ*CCSEL(3,K),
     :                   CC2PI)
      END DO

*   Secular perturbations in longitude
      DO K=1,4
         A = MOD(CCSEC(2,K)+T*CCSEC(3,K), CC2PI)
         SN(K) = SIN(A)
      END DO

*   Periodic perturbations of the EMB (Earth-Moon barycentre)
      PERTL =  CCSEC(1,1)          *SN(1) +CCSEC(1,2)*SN(2)+
     :        (CCSEC(1,3)+T*CCSEC3)*SN(3) +CCSEC(1,4)*SN(4)
      PERTLD = 0.0
      PERTR = 0.0
      PERTRD = 0.0
      DO K=1,15
         A = SNGL(MOD(DCARGS(1,K)+DT*DCARGS(2,K), DC2PI))
         COSA = COS(A)
         SINA = SIN(A)
         PERTL = PERTL + CCAMPS(1,K)*COSA+CCAMPS(2,K)*SINA
         PERTR = PERTR + CCAMPS(3,K)*COSA+CCAMPS(4,K)*SINA
         IF (K.LT.11) THEN
            PERTLD = PERTLD+
     :               (CCAMPS(2,K)*COSA-CCAMPS(1,K)*SINA)*CCAMPS(5,K)
            PERTRD = PERTRD+
     :               (CCAMPS(4,K)*COSA-CCAMPS(3,K)*SINA)*CCAMPS(5,K)
         END IF
      END DO

*   Elliptic part of the motion of the EMB
      ESQ = E*E
      DPARAM = 1D0-DBLE(ESQ)
      PARAM = REAL(DPARAM)
      TWOE = E+E
      TWOG = G+G
      PHI = TWOE*((1.0-ESQ*0.125)*SIN(G)+E*0.625*SIN(TWOG)
     :          +ESQ*0.54166667*SIN(G+TWOG) )
      F = G+PHI
      SINF = SIN(F)
      COSF = COS(F)
      DPSI = DPARAM/(1D0+DBLE(E*COSF))
      PHID = TWOE*CCSGD*((1.0+ESQ*1.5)*COSF+E*(1.25-SINF*SINF*0.5))
      PSID = CCSGD*E*SINF/SQRT(PARAM)

*   Perturbed heliocentric motion of the EMB
      D1PDRO = 1D0+DBLE(PERTR)
      DRD = D1PDRO*(DBLE(PSID)+DPSI*DBLE(PERTRD))
      DRLD = D1PDRO*DPSI*(DCSLD+DBLE(PHID)+DBLE(PERTLD))
      DTL = MOD(DML+DBLE(PHI)+DBLE(PERTL), DC2PI)
      DSINLS = SIN(DTL)
      DCOSLS = COS(DTL)
      DXHD = DRD*DCOSLS-DRLD*DSINLS
      DYHD = DRD*DSINLS+DRLD*DCOSLS

*   Influence of eccentricity, evection and variation on the
*   geocentric motion of the Moon
      PERTL = 0.0
      PERTLD = 0.0
      PERTP = 0.0
      PERTPD = 0.0
      DO K=1,3
         A = SNGL(MOD(DCARGM(1,K)+DT*DCARGM(2,K), DC2PI))
         SINA = SIN(A)
         COSA = COS(A)
         PERTL = PERTL +CCAMPM(1,K)*SINA
         PERTLD = PERTLD+CCAMPM(2,K)*COSA
         PERTP = PERTP +CCAMPM(3,K)*COSA
         PERTPD = PERTPD-CCAMPM(4,K)*SINA
      END DO

*   Heliocentric motion of the Earth
      TL = FORBEL(2)+PERTL
      SINLM = SIN(TL)
      COSLM = COS(TL)
      SIGMA = CCKM/(1.0+PERTP)
      A = SIGMA*(CCMLD+PERTLD)
      B = SIGMA*PERTPD
      DXHD = DXHD+DBLE(A*SINLM)+DBLE(B*COSLM)
      DYHD = DYHD-DBLE(A*COSLM)+DBLE(B*SINLM)
      DZHD =     -DBLE(SIGMA*CCFDI*COS(FORBEL(3)))

*   Barycentric motion of the Earth
      DXBD = DXHD*DC1MME
      DYBD = DYHD*DC1MME
      DZBD = DZHD*DC1MME
      DO K=1,4
         PLON = FORBEL(K+3)
         POMG = SORBEL(K+1)
         PECC = SORBEL(K+9)
         TL = MOD(PLON+2.0*PECC*SIN(PLON-POMG), CC2PI)
         SINLP(K) = SIN(TL)
         COSLP(K) = COS(TL)
         DXBD = DXBD+DBLE(CCPAMV(K)*(SINLP(K)+PECC*SIN(POMG)))
         DYBD = DYBD-DBLE(CCPAMV(K)*(COSLP(K)+PECC*COS(POMG)))
         DZBD = DZBD-DBLE(CCPAMV(K)*SORBEL(K+13)*COS(PLON-SORBEL(K+5)))
      END DO

*   Transition to mean equator of date
      DCOSEP = COS(DEPS)
      DSINEP = SIN(DEPS)
      DYAHD = DCOSEP*DYHD-DSINEP*DZHD
      DZAHD = DSINEP*DYHD+DCOSEP*DZHD
      DYABD = DCOSEP*DYBD-DSINEP*DZBD
      DZABD = DSINEP*DYBD+DCOSEP*DZBD

*   Heliocentric coordinates of the Earth
      DR = DPSI*D1PDRO
      FLATM = CCIM*SIN(FORBEL(3))
      A = SIGMA*COS(FLATM)
      DXH = DR*DCOSLS-DBLE(A*COSLM)
      DYH = DR*DSINLS-DBLE(A*SINLM)
      DZH =          -DBLE(SIGMA*SIN(FLATM))

*   Barycentric coordinates of the Earth
      DXB = DXH*DC1MME
      DYB = DYH*DC1MME
      DZB = DZH*DC1MME
      DO K=1,4
         FLAT = SORBEL(K+13)*SIN(FORBEL(K+3)-SORBEL(K+5))
         A = CCPAM(K)*(1.0-SORBEL(K+9)*COS(FORBEL(K+3)-SORBEL(K+1)))
         B = A*COS(FLAT)
         DXB = DXB-DBLE(B*COSLP(K))
         DYB = DYB-DBLE(B*SINLP(K))
         DZB = DZB-DBLE(A*SIN(FLAT))
      END DO

*   Transition to mean equator of date
      DYAH = DCOSEP*DYH-DSINEP*DZH
      DZAH = DSINEP*DYH+DCOSEP*DZH
      DYAB = DCOSEP*DYB-DSINEP*DZB
      DZAB = DSINEP*DYB+DCOSEP*DZB

*   Copy result components into vectors, correcting for FK4 equinox
      DEPJ=sla_EPJ(DATE)
      DEQCOR = DS2R*(0.035D0+0.00085D0*(DEPJ-B1950))
      DVH(1) = DXHD-DEQCOR*DYAHD
      DVH(2) = DYAHD+DEQCOR*DXHD
      DVH(3) = DZAHD
      DVB(1) = DXBD-DEQCOR*DYABD
      DVB(2) = DYABD+DEQCOR*DXBD
      DVB(3) = DZABD
      DPH(1) = DXH-DEQCOR*DYAH
      DPH(2) = DYAH+DEQCOR*DXH
      DPH(3) = DZAH
      DPB(1) = DXB-DEQCOR*DYAB
      DPB(2) = DYAB+DEQCOR*DXB
      DPB(3) = DZAB

*   Was precession to another equinox requested?
      IF (IDEQ.NE.0) THEN

*     Yes: compute precession matrix from MJD DATE to Julian epoch DEQX
         CALL sla_PREC(DEPJ,DEQX,DPREMA)

*     Rotate DVH
         DO J=1,3
            W=0D0
            DO I=1,3
               W=W+DPREMA(J,I)*DVH(I)
            END DO
            VW(J)=W
         END DO
         DO J=1,3
            DVH(J)=VW(J)
         END DO

*     Rotate DVB
         DO J=1,3
            W=0D0
            DO I=1,3
               W=W+DPREMA(J,I)*DVB(I)
            END DO
            VW(J)=W
         END DO
         DO J=1,3
            DVB(J)=VW(J)
         END DO

*     Rotate DPH
         DO J=1,3
            W=0D0
            DO I=1,3
               W=W+DPREMA(J,I)*DPH(I)
            END DO
            VW(J)=W
         END DO
         DO J=1,3
            DPH(J)=VW(J)
         END DO

*     Rotate DPB
         DO J=1,3
            W=0D0
            DO I=1,3
               W=W+DPREMA(J,I)*DPB(I)
            END DO
            VW(J)=W
         END DO
         DO J=1,3
            DPB(J)=VW(J)
         END DO
      END IF

      END

      SUBROUTINE CHKCOR
C
C     Routine to check correlator parameters common to all 
C     correlators.  The code was extracted from SOCDEF and CORDEF.
C
      INCLUDE 'sched.inc'
C
      INTEGER    LEN1
      LOGICAL    MISCOR
C -----------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'CHKCOR starting.' )
      MISCOR = .FALSE.
C
C     Check the weighting function.  I'm not sure this is actually
C     being used.
C
      IF( CORWTFN .NE. 'UNIFORM' .AND. CORWTFN .NE. 'HANNING' .AND.
     1    CORWTFN .NE. 'QANNING' .AND. CORWTFN .NE. 'ZEROPAD' ) THEN
         CALL WLOG( 1, '        Unrecognized correlator weighting'//
     1      ' function: ' // CORWTFN )
      END IF
C
C     Type of media for distribution of correlator output.
C     Most is now done by Internet (FTP or NONE).
C     Remove EXABYTE.  Long ago, removed 9 track tape.
C     Probably add flash memory and hard drives eventually.
C     Never really got into CD or DVD.
C
      IF( CORTAPE(1:3) .NE. 'DAT' .AND. 
     1    CORTAPE(1:4) .NE. 'NONE' .AND.
     2    CORTAPE(1:4) .NE. 'DISK' .AND.
     3    CORTAPE(1:3) .NE. 'FTP' ) THEN
         MISCOR = .TRUE.
         CALL WLOG( 1, '        Unrecognized correlator distribution'
     1    //' media: '// CORTAPE )
      END IF
C
      IF( CORDFMT(1:4) .NE. 'FITS' .AND.
     1    CORDFMT(1:5) .NE. 'MARK4' ) THEN
         MISCOR = .TRUE.
         CALL WLOG( 1, '        Unrecognized correlator distribution'
     1    //' format: '// CORDFMT )
      END IF
C
C     Check that a shipping address was provided for the media that 
C     need to be shipped.
C
      IF( LEN1( CORSHIP(1) ) .EQ. 0 .AND.  
     1          CORTAPE(1:3) .EQ. 'DAT' ) THEN
         MISCOR = .TRUE.
         CALL WLOG( 1, '        Missing distribution tape shipping'//
     1         ' address.' )
      END IF
C
C     Deal with case where parameters weren't provided.
C
      IF( MISCOR ) THEN
         CALL WLOG( 2, ' ' )
         CALL WLOG( 1, 'CHKCOR:  A required correlator parameter '//
     1      'was not provided or had a bad value.' )
C
C        Allow plotting, but not output files.
C
         IF( PLOT ) THEN
            MISSING = .TRUE.
         ELSE
            CALL ERRLOG( 'Fix the correlator info and try again.' )   
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE SRFINISH
C
C     Subroutine for SCHED, called at the start of DEFAULTS, that 
C     wraps up the loose ends for source information.  DEFAULTS
C     is called in SCHED right after SCHIN, which reads the source
C     catalogs as one of its last acts.  SRFINISH checks that all 
C     sources are available in the catalog and adds planets, 
C     satellites etc to the main source catalog if needed.
C
C     The scan times in Julian days should be available before the
C     call as they are needed in the ephemeris routines.
C
C     Note that the list of schedule sources (SRCNAME, SRCATN) gets
C     built by SRCFLG here, but gets rebuilt later in SCHOPT after
C     optimization modes, automatic pointing insertions etc have
C     happened, since those processes can add or subtract sources.
C
      INCLUDE     'sched.inc'
      INCLUDE     'schpeak.inc'
C
      INTEGER     KSRC, ISCN, IPSRC, IGRP, ISRC, INAME, JCENT, IGEO
      INTEGER     ICSRC
      LOGICAL     GOTALL, VEXWARN
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SRFINISH starting' )
C
C     Associate sources in SRCNAME with main catalog entries.
C     Note this gets done again later in SCHOPT after any possible
C     schedule adjustments.
C     
      CALL SRCFLG( GOTALL )
C     
C     If don't have all, check for planets for which we have
C     ephemeris data.  If one of the requested sources is a 
C     planet, add that planet to the main source catalog and
C     set the pointers to and from the schedule sources list.
C     
      VEXWARN = .NOT. GOTALL
      CALL JPLGOT( GOTALL )
C      
C     Warn if there are planets with VEX output.  Block later if
C     they are in recording scans.
C     
      IF( DOVEX .AND. GOTALL .AND. VEXWARN ) THEN
         CALL WLOG( 1, 'SRFINISH: VEX requested for a schedule '//
     1       'with planets. ' )
         CALL WLOG( 1, 'SRFINISH: That is only allowed if all ' // 
     1       'planet scans are non-recording (eg pointing) scans.' )
      END IF
C     
C     If still don't have all, check for satellite for which we
C     have orbital elements.  If one is found, add it to the main
C     source catalog and set the pointers to and from the schedule
C     source list.
C     
      VEXWARN = .NOT. GOTALL
      CALL SATGOT( GOTALL )
C      
C     Warn about satellites with VEX output.  Block later if they are
C     recording scans (in VEXOUT).
C     
      IF( DOVEX .AND. GOTALL .AND. VEXWARN ) THEN
         CALL WLOG( 1, 'SRFINISH: VEX requested for a schedule '//
     1       'with satellites. ' )
         CALL WLOG( 1, 'SRFINISH: That is only allowed if all ' // 
     1       'satellite scans are non-recording (eg pointing) scans.' )
      END IF
C     
C     Complain about missing sources if still don't have all.
C     
      IF( .NOT. GOTALL ) THEN
         DO KSRC = 1, NSRC
            IF( SRCATN(KSRC) .EQ. 0 ) THEN
               CALL WLOG( 1, 'SRFINISH: ' // SRCNAME(KSRC) //
     1           ' not in catalogs, ephemeris or satellite file.' )
               IF( EPHFILE .EQ. 'NONE' ) CALL WLOG( 1, 
     1           '                       No planetary ephemeris'//
     2           ' specified.' )
               IF( NSAT .EQ. 0 ) CALL WLOG( 1, '         '//
     1        '              No satellite info specified.' )
               CALL WLOG( 1, '      Note some source names have '//
     1               'changed.  Look for close matches.' )
            END IF
         END DO
         CALL ERRLOG( 'SRFINISH: Missing sources.' )
      END IF
C     
C     Get a short name for each source.  Also check for invalid
C     names.
C     
      CALL SHORTN
C     
C     Loop through scans and get the main source catalog numbers for
C     all specified sources.  Note that we are not picking up
C     the automatic reference pointing sources here since those
C     scans have not been generated yet.
C
C     Note that, while SRCNAME and SRCATN are used in this process
C     the pointer is not saved so it doesn't matter if that list
C     changes later.  The pointers into the main catalog will still
C     be valid.
C
C     Initialize phase center sources pointers.  SRCNUM, IDOPSRC, and
C     IVLAPHS are initialized in SCHIN.
C
      DO JCENT = 1, NCENT
         DO ICSRC = 1, NCSRC(JCENT)
            CTRSRCI(ICSRC,JCENT) = 0
         END DO
      END DO
      DO ISCN = 1, NSCANS
         DO KSRC = 1, NSRC
            IF( SCNSRC(ISCN) .EQ. SRCNAME(KSRC) ) THEN
               SRCNUM(ISCN) = SRCATN(KSRC)
            END IF
            IF( DOPSRC(ISCN) .EQ. SRCNAME(KSRC) ) THEN
               IDOPSRC(ISCN) = SRCATN(KSRC)
            END IF
            IF( VLAPHS(ISCN) .EQ. SRCNAME(KSRC) ) THEN
               IVLAPHS(ISCN) = SRCATN(KSRC)
            END IF
            IF( ICENT(ISCN) .NE. 0 ) THEN
               DO ISRC = 1, NCSRC(ICENT(ISCN))
                  IF( CTRSRCN(ISRC,ICENT(ISCN)) .EQ. SRCNAME(KSRC)) THEN
                     CTRSRCI(ISRC,ICENT(ISCN)) = SRCATN(KSRC)
                  END IF
               END DO
            END IF
         END DO
      END DO
C
C     Get the main catalog source numbers for the possible 
C     reference pointing sources.
C
      DO IGRP = 1, NPKGRP
         DO IPSRC = 1, NPKSRC(IGRP)
            DO ISRC = 1, MSRC
               DO INAME = 1, MALIAS
                  IF( PKSRC(IPSRC,IGRP) .EQ. SOURCE(INAME,ISRC) ) THEN
                     PKSRNUM(IPSRC,IGRP) = ISRC
                  END IF
               END DO
            END DO
         END DO
      END DO
C
C     geo segment sources.
C
      DO IGEO = 1, NGEO
         GEOSRCI(IGEO) = 0
      END DO
      IF( ANYGEO ) THEN
         DO IGEO = 1, NGEO
            DO ISRC = 1, MSRC
               DO INAME = 1, MALIAS
                  IF( GEOSRC(IGEO) .EQ. SOURCE(INAME,ISRC) ) THEN
                     GEOSRCI(IGEO) = ISRC
                  END IF
               END DO
            END DO
         END DO
      END IF
C
      RETURN
      END

      SUBROUTINE DOPFQ
C
C     Routine for SCHED that does Doppler calculations and sets 
C     frequencies for spectral line sources.  The calculated 
C     frequencies replace any values previously placed in the FREQ 
C     array, such as from FREQ specified for a scan.
C
C     It calls the closely related (almost copied) routine DOPCRD to
C     set frequencies for the BBCs when reference pointing under
C     circumstances when the main channels cannot be adjusted (PFB).
C
C     FREQ is the LO sum (band edge) given the sideband of the 
C     logical channel.  It may need to be adjusted if the station
C     is going to put out a sideband inverted from the logical
C     channel, as is sometimes required for the RDBE/PFB personality.
C     This routine only deals with logical channel values.
C
C     The velocities are obtained from the source catalog.
C
C     The rest frequencies were read in the LINEINIT records in the main
C     schedule input.
C
C     Use SLA lib routines to do the calculations.  For now, do the 
C     calculations for the center of the Earth for the middle of the
C     experiment.  TFIRST and TEND were calculated by SCHTIM, which
C     must be called earlier.
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER          ISCN, YEAR, DAY, IGP, NGP, ICH
      INTEGER          ISETF, SBW, JCH, KS
      REAL             RA4, DEC4, SLA_RVLSRK, VELC, TIME4
      REAL             VSUN, VEARTH, TL
      DOUBLE PRECISION MSBW(MAXCHN,MAXSET)
      LOGICAL          WARN(MAXCHN), FWARN
      DOUBLE PRECISION TMID, TIME, VELTOT, VELSRC, CFREQ1, CFREQ2
      SAVE             WARN
C
C     Velocity of light m/s
C
      PARAMETER (VELC=2.99792458E8)
C
      DATA  WARN  / MAXCHN*.TRUE. /
      DATA  FWARN / .TRUE. /
C ---------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'DOPFQ: Starting. ' )
C
C     Later the minimum bandwidth in use for each setup file will be
C     needed.  Get it by searching the setup files.  The result should
C     be for each logical channel.
C
      DO ISETF = 1, NSETF
         DO ICH = 1, MAXCHN
            MSBW(ICH,ISETF) = 9999.0D0
         END DO
      END DO
      DO KS = 1, NSET
         ISETF = ISETNUM(KS)
         DO ICH = 1, NCHAN(KS)
            JCH = SGCHAN(ICH,KS)
            IF( JCH .NE. 0 ) THEN
               MSBW(ICH,ISETF) = MIN( MSBW(ICH,ISETF), BBFILT(JCH,KS) )
            END IF
         END DO
      END DO
C
C     Loop through scans looking for ones that need doppler calc.
C
      DO ISCN = SCAN1, SCANL
C
         ISETF = SETNUM(ISCN)
         IF( DOPCAL(ISCN) .AND. OKXC(ISETF) .AND. .NOT. VLAONLY ) THEN
C
C           Get the velocity of the Earth in the direction of the 
C           source.  It is the sum of the LSR velocity of the Sun 
C           and the solar system velocity of the Earth.  Get both 
C           from SLA_LIB routines.
C
C           Note that the midpoint of the experiment will be used for
C           the calculation.  Thus, despite redoing the calculation for
C           each scan, each source will use the same velocity for every
C           scan.
C
            TMID = (TFIRST + TEND) / 2.0
            CALL TIMEJ( TMID, YEAR, DAY, TIME )
            TIME4 = TIME / TWOPI
            RA4  = RA2000(IDOPSRC(ISCN))
            DEC4 = D2000(IDOPSRC(ISCN))
            VSUN = SLA_RVLSRK( RA4, DEC4 )
            RA4  = RAP(IDOPSRC(ISCN))
            DEC4 = DECP(IDOPSRC(ISCN))
            CALL SLA_ECOR( RA4, DEC4, YEAR, DAY, TIME4, VEARTH, TL )
C
C           Determine which group of lines is to be used.
C
            NGP = 0
            DO IGP = 1, NLGP
               IF( LINES(ISCN) .EQ. LINENAME(IGP) ) THEN
                  NGP = IGP
               END IF
            END DO
            IF( NGP .EQ. 0 )
     1          CALL ERRLOG( 'DOPFQ: Spectral line set '//LINES(ISCN)//
     2            ' not initialized.' )
C
C
C           This routine calculates the center frequency, then subtracts
C           half the bandwidth to get the LO sum.  The bandwidth 
C           subtracted is either that specified with the BW input
C           to the main routine, or the smallest seen in the setup file.
C
C           Do the Doppler for all possible channels.  In the inputs,
C           any channel for which there was no rest frequency, 
C           bandwidth, or velocity given, had that the missing 
C           number set to the value for channel 1.  
C
C           Assume that the velocity information applies to the
C           setup file "logical channel" (see SFINFO) which may be
C           different from the setup group channel.
C
C           Set FREQ to band edge.  The net sideband for the channel
C           was found by SBPAIR and is stored in SFSIDE, based on the
C           setup file.  Round the frequency to the nearest multiple
C           of DOPINCR (0.01 MHz for the VLBA legacy system).
C           If two channels share the same BBC, SAMEBBC will be set.  
C           In that case, use the frequency calculated for the first 
C           of those channels.
C
            IF( MSCHN(ISETF) .GT. MAXLCH ) THEN
               WRITE( MSGTXT, '( A, I3, A )' ) 
     1           'DOPFQ: With DOPCAL, NCHAN must be ', MAXLCH, 
     2             ' or less. ' 
               CALL ERRLOG( MSGTXT )
            END IF
C
C           Get the bandwidth to use.  Be sure it is unsigned.
C           BW is a scan dependent user input.
C
            DO ICH = 1, MSCHN(ISETF)
               IF( BW(ICH,ISCN) .EQ. 0.0 ) THEN
                  BW(ICH,ISCN) = MSBW(ICH,ISETF)
               END IF
               BW(ICH,ISCN) = ABS( BW(ICH,ISCN) )
C
C              Complain if no bandwidth is available.
C
               IF( BW(ICH,ISCN) .EQ. 0.0 ) THEN
                  CALL ERRLOG( 'DOPFQ: Bandwidths must be specified'//
     2              ' or in setup for Doppler calculations.' )
               END IF
            END DO
C
            DO ICH = 1, MSCHN(ISETF)
C
C              Check for same BBC.
C
               IF( SAMEBBC(ICH,ISETF) .NE. 0 ) THEN
                  FREQ(ICH,ISCN) = FREQ(SAMEBBC(ICH,ISETF),ISCN)
                  IF( WARN(ICH) ) THEN
                     WRITE( MSGTXT, '( A, I2, A, I2, A )' )
     1                  'DOPFQ Note: Setting freq of chan ', ICH, 
     2                  ' = freq of channel ',
     3                  SAMEBBC(ICH,ISETF), ' (shared BBC).'
                     CALL WLOG( 0, MSGTXT )
                     WARN(ICH) = .FALSE.
                  END IF
               ELSE
C
C                 Set up to add or subtract the bandwidth.  As a 
C                 software check, complain about unrecognized SFSIDE.
C
                  IF( SFSIDE(ICH,ISETF) .EQ. 'U' ) THEN
                     SBW = 1
                  ELSE IF( SFSIDE(ICH,ISETF) .EQ. 'L' ) THEN
                     SBW = -1
                  ELSE
                     CALL ERRLOG( 'DOPFQ: Unrecognized SFSIDE '//
     1                   SFSIDE(ICH,ISETF) )
                  END IF
C
C                 Now get the frequency.  If no velocity was given,
C                 use the setup frequency.  This was flagged with
C                 a "CONT" from RDSRC and a VLSR=-1.E9 from SRREAD.
C
                  IF( VLSR(ICH,IDOPSRC(ISCN)) .LT. -1.E8 ) THEN
                     FREQ(ICH,ISCN) = 0.D0
                  ELSE
C
C                    Actually calculate the frequency based on the
C                    VELREF and VELDEF requests.  Note that VLSR
C                    is now a bit of a misnomer.
C
C                    First convert a Z to a velocity. 
C
                     IF( VELDEF(IDOPSRC(ISCN)) .EQ. 'Z' ) THEN
                        VELSRC = VLSR(ICH,IDOPSRC(ISCN)) * VELC / 1.D3
                     ELSE
                        VELSRC = VLSR(ICH,IDOPSRC(ISCN))
                     END IF
C
C                    Now get the total velocity by adding in the 
C                    Earth's motions.  This is where the frame enters.
C
                     IF( VELREF(IDOPSRC(ISCN)) .EQ. 'L' ) THEN
                        VELTOT = VELSRC + VEARTH + VSUN
                     ELSE IF( VELREF(IDOPSRC(ISCN)) .EQ. 'H' ) THEN
                        VELTOT = VELSRC + VEARTH
                     ELSE IF( VELREF(IDOPSRC(ISCN)) .EQ. 'G' ) THEN
                        VELTOT = VELSRC
                     ELSE
                        CALL ERRLOG( 
     1                    'DOPFQ:  Bad VREF in source catalog: '//
     2                    VELREF(IDOPSRC(ISCN)) )
                     END IF
C
C                    Now calculate the frequency.
C
                     IF( VELDEF(IDOPSRC(ISCN)) .EQ. 'R' ) THEN
                        FREQ(ICH,ISCN) = RESTFREQ(ICH,NGP) * 
     1                     ( 1.D0 - VELTOT * 1.E3 / VELC ) - 
     2                     SBW * BW(ICH,ISCN) / 2.D0
                     ELSE IF( VELDEF(IDOPSRC(ISCN)) .EQ. 'O' .OR.
     1                        VELDEF(IDOPSRC(ISCN)) .EQ. 'Z' ) THEN
                        FREQ(ICH,ISCN) = RESTFREQ(ICH,NGP) / 
     1                     ( 1.D0 + VELTOT * 1.E3 / VELC ) - 
     2                     SBW * BW(ICH,ISCN) / 2.D0
                     ELSE
                        CALL ERRLOG( 
     1                    'DOPFQ:  Bad VDEF in source catalog: '//
     2                    VELDEF(IDOPSRC(ISCN)) )
                     END IF
C
C                    Round it to the required DOPINCR.  Note that 
C                    the LO equation is assumed to be 
C                    FREQ = N * DOPINCR(ISCN,1) + DOPINCR(ISCN,2)
C                    The ATCA needs the offset.
C                    Note that DOPINCR is in kHz while FREQ is in MHz.
C            
                     FREQ(ICH,ISCN) = 1.0D-3 * ( DOPINCR(ISCN,2) +
     1                   DOPINCR(ISCN,1) * DNINT( 
     2                   ( FREQ(ICH,ISCN) * 1.0D3 - DOPINCR(ISCN,2) )
     3                      / DOPINCR(ISCN,1) ) )
C            
C                    Check for excessive overlap with previous channels.
C            
                     IF( ICH .GE. 2 .AND. FWARN ) THEN
C            
C                       Get the center frequency of the current channel.
C            
                        IF( SFSIDE(ICH,ISETF) .EQ. 'U' ) THEN
                           CFREQ2 = FREQ(ICH,ISCN) + 0.5 * BW(ICH,ISCN)
                        ELSE
                           CFREQ2 = FREQ(ICH,ISCN) - 0.5 * BW(ICH,ISCN)
                        END IF
C            
C                       Compare with earlier channels of the same pol.
C            
                        DO JCH = 1, ICH - 1
                           IF( SFPOL(ICH,ISETF) .EQ. SFPOL(JCH,ISETF) ) 
     1                        THEN
C            
C                             Get center frequency of earlier channel.
C            
                              IF( SFSIDE(JCH,ISETF) .EQ. 'U' ) THEN
                                 CFREQ1 = FREQ(JCH,ISCN) + 
     1                                    0.5 * BW(JCH,ISCN)
                              ELSE
                                 CFREQ1 = FREQ(JCH,ISCN) - 
     2                                    0.5 * BW(JCH,ISCN)
                              END IF
C            
C                             Have a cow if the two are not separated
C                             by 0.8 of bandwidth.
C            
                              IF( ABS( CFREQ2 - CFREQ1 ) .LT. 0.8 * 0.5
     1                         * ( BW(JCH,ISCN) + BW(ICH,ISCN) ) ) THEN
                                 MSGTXT = ' ' 
                                 WRITE( MSGTXT,'( 3A )')
     1                            'DOPFQ: *** Frequencies of channels ',
     2                            'set by DOPPLER overlap more than ',
     3                            '20%.'
                                 CALL WLOG( 0, MSGTXT )
                                 CALL WLOG( 0, 
     1                              '           Was that intentional?' )
                                 FWARN = .FALSE.
                              END IF
                           END IF
                        END DO
                     END IF
C
C                    Leave a flag that we did doppler on this source and
C                    keep track of the maximum number of channels used.
C
                     DIDNDOP(IDOPSRC(ISCN)) = 
     1                    MAX( DIDNDOP(IDOPSRC(ISCN)), ICH )
                     DOPPED(SRCNUM(ISCN)) = .TRUE.
C
                  END IF
C
               END IF
            END DO
C
         ELSE IF( DOPCAL(ISCN) .AND. VLAONLY ) THEN
C
C           Warn that cannot do doppler adjustments on just VLA.
C           For VLAONLY schedules, SFINFO will set OKXC.
C           May be able to remove this restriction if VLA only schedules
C           become no different than any other single station obs.
C
            CALL ERRLOG( 'DOPFQ: Sched can not do Doppler ' //
     1             'adjustments for VLA only schedules.' )
         END IF
C
C        Balk at dopcal when different stations have incompatible
C        channelization (OKXC false).  "see above" refers to message
C        from SFINFO.  One way to get this is to have no setup.
C
         IF( DOPCAL(ISCN) .AND. ( .NOT. OKXC(ISETF) .OR. NOSET ) ) THEN
            IF( NOSET ) THEN
               CALL ERRLOG( 'DOPFQ: Doppler calculations requested '//
     1           'with no setup.  I cannot do that!' )
            ELSE
               CALL ERRLOG( 'DOPFQ: Doppler calculations requested '//
     1           'but have been disabled.  See above.' )
            END IF
         END IF
C
C        While at it, check that FREQ and BW were not specified when
C        the channelization is unclear.  Again the "see above" refers
C        to a message from SFINFO.
C
         IF( .NOT. DOPCAL(ISCN) .AND. .NOT. OKXC(ISETF) .AND.
     1     ( FREQ(1,ISCN) .NE. 0.D0 .OR. BW(1,ISCN) .NE. 0.0 ) ) THEN
C
            CALL WLOG( 1, 'DOPFQ: FREQ or BW requested but ' //
     1          'disabled.  See above.' )
            CALL ERRLOG( '        Fix channelization or don''t use '//
     1                  'FREQ or BW.' )
         END IF
      END DO
C
C     Call DOPCRD to set the legacy VLBA system frequencies for 
C     reference pointing when the main channels cannot be finely 
C     tuned.  Mainly for reference pointing while using the RDBE
C
      CALL DOPCRD
C
      RETURN
      END

C+++++++++++++++++++++++++++++
C
      SUBROUTINE CONST(NAM,VAL,SSS,N)
C
C+++++++++++++++++++++++++++++
C
C     THIS ENTRY OBTAINS THE CONSTANTS FROM THE EPHEMERIS FILE
C
C     CALLING SEQEUNCE PARAMETERS (ALL OUTPUT):
C
C       NAM = CHARACTER*6 ARRAY OF CONSTANT NAMES
C
C       VAL = D.P. ARRAY OF VALUES OF CONSTANTS
C
C       SSS = D.P. JD START, JD STOP, STEP OF EPHEMERIS
C
C         N = INTEGER NUMBER OF ENTRIES IN 'NAM' AND 'VAL' ARRAYS
C
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      SAVE

      CHARACTER*6 NAM(*),TTL(14,3),CNAM(400)

      DOUBLE PRECISION VAL(*),SSS(3),SS(3),CVAL(400), AU, EMRAT

      INTEGER IPT(3,13),DENUM, NCON, N, I

      COMMON/EPHHDR/CVAL,SS,AU,EMRAT,DENUM,NCON,IPT
      COMMON/CHRHDR/CNAM,TTL

C  CALL STATE TO INITIALIZE THE EPHEMERIS AND READ IN THE CONSTANTS

      CALL STATE(0.D0,0,0.D0,0.D0)

      N=NCON

      DO I=1,3
      SSS(I)=SS(I)
      ENDDO

      DO I=1,N
      NAM(I)=CNAM(I)
      VAL(I)=CVAL(I)
      ENDDO

      RETURN

      END

      SUBROUTINE SRCLOC( ISCN, ISTA, 
     1                   PRA, PDEC, PPMTIME, PDRA, PDDEC )
C
C     Routine for SCHED, called by VLBAST and SCHGEO, to get the
C     source position.  For planets and satellites, it takes into
C     account the changes with time and antenna position.
C
C     ADD PROPER MOTIONS.  But think if that is really right.
C          This is used both for geometry calculations and for
C          output positions.  The answer might be different
C          for the two.
C
      INCLUDE  'sched.inc'
C 
      INTEGER           ISCN, ISTA
      REAL              PDRA, PDDEC
      DOUBLE PRECISION  PRA, PDEC, PPMTIME
C
      INTEGER           ISRC, KSTA, ISAT, IER
      DOUBLE PRECISION  DIST, GEOVEL, DDRA, DDDEC
C ---------------------------------------------------------------------
C
C     Source information:
C
C     Get the position information to use.  For planets, this can
C     be both station and time dependent.  Double precision needed
C     in call for some items that should be single precision later.
C     Also do satellites here as they are essentially the same.
C
      ISRC   = SRCNUM(ISCN)
      KSTA   = STANUM(ISTA)
C
      IF( PLANET(ISRC) .OR. SATEL(ISRC) ) THEN
         IF( PLANET(ISRC) ) THEN
            PPMTIME = STARTJ(ISCN)
            CALL JPLEP2( EPHFILE, SCNSRC(ISCN), PPMTIME, 
     1         (-1.D0)*LONG(KSTA), LAT(KSTA), ELEV(KSTA), 'VLBA',
     2                PRA, PDEC, DDRA, DDDEC, DIST, IER )
            IF( IER .NE. 0 ) THEN
               IF( IER .EQ. 2 ) THEN
                  WRITE( MSGTXT, '( A, I5, 3F15.7 )' )
     1             'VLBAST:  Possible time problem: ', 
     2             ISCN, STARTJ(1), STARTJ(ISCN), PPMTIME
                  CALL WLOG( 1, MSGTXT )
               END IF
               WRITE( MSGTXT, '( A, A, A, I4 )' )
     1            'VLBAST: Problem with ephemeris for ',
     2             SCNSRC(ISCN), '  Error:', IER
               CALL ERRLOG( MSGTXT )
            END IF
         ELSE IF( SATEL(ISRC) ) THEN
            ISAT = SATN(ISRC)
            IF( SATFILE(ISAT) .NE. 'NONE' ) THEN
               CALL SATEP( ISAT, ISCN, ISTA, 'VLBA', PRA, PDEC, 
     1                  DDRA, DDDEC, PPMTIME, DIST, GEOVEL )
            ELSE
               CALL SATTLE( ISAT, ISCN, ISTA, 'VLBA', PRA, PDEC, 
     1                  DDRA, DDDEC, PPMTIME, DIST, GEOVEL )
            END IF
         END IF
C
         PDRA    = DDRA
         PDDEC   = DDDEC
      ELSE
         PRA     = RA2000(ISRC)
         PDEC    = D2000(ISRC)
         PPMTIME = PMTIME(ISRC)
         PDRA    = DRA(ISRC)
         PDDEC   = DDEC(ISRC)
      END IF
C
      RETURN
      END

      SUBROUTINE SFINFO
C
C     Routine for SCHED called by SETDEFS that gets information about
C     the logical channels of a setup file.  It has to look through
C     the setup groups to do so.
C
C     The logical channels deal with the possibility that some stations
C     only record a subset of the setup recorded at other stations.  
C     Possible examples include use of a single polarization at a 
C     station in a dual polarization observation, or use of smaller 
C     number of BBCs at some stations than at others.  It is assumed 
C     that at least one station has all channels and that there are not
C     two setups with the same number of channels and dual polarization
C     (there can be setups with the same number of channels where on
C     is single polarization).
C    
C
      INCLUDE 'sched.inc'
      INCLUDE 'schset.inc'
C
      INTEGER       ISETF, KS, ICHN, KCHN, LEN1
      LOGICAL       SFDUAL(MAXSET), SGDUAL(MSET), DUP(MAXSET)
C ----------------------------------------------------------------------
      IF( DEBUG ) CALL WLOG( 0, 'SFINFO: Starting.' )
C
      IF( NSETF .GE. 1 ) THEN
         DO ISETF = 1, NSETF
            OKXC(ISETF) = .TRUE.
            DO ICHN = 1, MAXCHN
               SFFREQ(1,ISETF) = 0.D0
            END DO
         END DO
      END IF
C
C     Don't bother if doing VLA only.
C
      IF( .NOT. VLAONLY ) THEN
C
C        Initialize.
C
         DO ISETF = 1, NSETF
            SFDUAL(ISETF) = .FALSE.
            DUP(ISETF) = .FALSE.
         END DO
C
C        See if any stations in each setup file use dual polarization.
C        Also do some initialization.  I'm not looking for polarization
C        pairs - just the presence of 2 polarizations.  In such a case,
C        some pair of channels will have opposite polarizations.
C
         DO KS = 1, NSET
            ISETF = ISETNUM(KS)
            SGDUAL(KS) = .FALSE.
            IF( NCHAN(KS) .GE. 2 ) THEN
               DO ICHN = 2, NCHAN(KS)
                  IF( POL(ICHN,KS) .NE. POL(ICHN-1,KS) ) THEN
                     SGDUAL(KS) = .TRUE.
                     SFDUAL(ISETF) = .TRUE.
                  END IF
               END DO
            END IF
         END DO
C
C        Find a "complete" group and establish the "logical" channels.  
C        Want a group with the to the maximum number of channels and,
C        if any groups have it, with dual polarization.  Bias toward 
C        saving the first group of each file by going backwards.
C        Buck out any correlator inversions that might be expected
C        (currently only set in CHKRDBE).
C
         DO KS = NSET, 1, -1
            ISETF = ISETNUM(KS)
            IF( NCHAN(KS) .EQ. MSCHN(ISETF) .AND. 
     1          ( SGDUAL(KS) .EQV. SFDUAL(ISETF) ) ) THEN
               DO ICHN = 1, NCHAN(KS)
                  SFFREQ(ICHN,ISETF) = FREQREF(ICHN,KS) -
     1                                 CORINV(ICHN,KS)
                  SFFILT(ICHN,ISETF) = BBFILT(ICHN,KS)
                  SFPOL(ICHN,ISETF) = POL(ICHN,KS)
                  IF( CORINV(ICHN,KS) .NE. 0.D0 ) THEN
                     IF( NETSIDE(ICHN,KS) .EQ. 'L' ) THEN
                        SFSIDE(ICHN,ISETF) = 'U'
                     ELSE
                        SFSIDE(ICHN,ISETF) = 'L'
                     END IF
                  ELSE
                     SFSIDE(ICHN,ISETF) = NETSIDE(ICHN,KS)
                  END IF
               END DO
            END IF
         END DO
C
C        Now relate the channels in each group to the logical channels.
C        If any group has a channel that does not correspond to a 
C        logical channel, set OKXC(ISETF) to .FALSE..  This will 
C        block a number of tests and features later.
C
C        The following pointers are associated with each setup group.
C        SFCHAN.  For each channel in this setup group, this points to
C           the logical channel of the setup file.
C        SGCHAN.  For this setup group, this points to the channel
C           in the setup group associated with indexed setup file logical
C           channel.
C
C        Again, deal with correlator inversions flagged by CORINV.
C        Assume that NETSIDE and SFSIDE will be either 'L' or 'U' 
C        and nothing else so you can check for opposite sidebands
C        by just checking that they are not equal.  CORINV is the
C        amount that got added to FREQREF to get the LO setting.
C        For comparison with channels that will get correlated against
C        this one, subtract CORINV.
C
         DO KS = 1, NSET
            ISETF = ISETNUM(KS)
C
            DO ICHN = 1, MCHAN
               SFCHAN(ICHN,KS) = 0
               SGCHAN(ICHN,KS) = 0
            END DO
C
            DO ICHN = 1, NCHAN(KS)
               DO KCHN = 1, MSCHN(ISETF)
C
C                 Match center frequency, bandwidth, and polarization.
C
                  IF( ABS( FREQREF(ICHN,KS) - CORINV(ICHN,KS) - 
     1               SFFREQ(KCHN,ISETF) ) .LT. 0.05D0 * BBFILT(ICHN,KS) 
     2               .AND. SFFILT(ICHN,ISETF) .EQ. BBFILT(ICHN,KS)
     3               .AND. POL(ICHN,KS) .EQ. SFPOL(KCHN,ISETF) ) THEN
C
C                    Match sideband, allowing for correlator inversion.
C
                     IF(  ( CORINV(ICHN,KS) .EQ. 0.D0 .AND. 
     1                 NETSIDE(ICHN,KS) .EQ. SFSIDE(KCHN,ISETF) ) .OR.
     2                 ( CORINV(ICHN,KS) .NE. 0.D0 .AND. 
     3                 (NETSIDE(ICHN,KS) .NE. SFSIDE(KCHN,ISETF) ) ) )
     4                    THEN
C
                        SFCHAN(ICHN,KS) = KCHN
                        SGCHAN(KCHN,KS) = ICHN
C   
                     END IF
                  END IF
               END DO
            END DO         
         END DO
C
C        Determine if all channels of all groups in a file are accounted
C        for in the "logical" channels.  Also get upset if some channels
C        are duplicates.
C
         DO KS = 1, NSET
            ISETF = ISETNUM(KS)
            DO ICHN = 1, NCHAN(KS)
               IF( SFCHAN(ICHN,KS) .EQ. 0 ) THEN
C              write(*,*) 'sfinfo set okxc F ', ks, isetf, ichn, 
C     1           sfchan(ichn,ks), freqref(ichn,ks), corinv(ichn,ks),
C     2           sffreq(ichn,isetf)
                  OKXC(ISETF) = .FALSE.
               END IF
               IF( ICHN .GE. 2 ) THEN
                  DO KCHN = 1, ICHN - 1
                     IF( SFCHAN(ICHN,KS) .EQ. SFCHAN(KCHN,KS) .AND.
     1                   SFCHAN(ICHN,KS) .NE. 0 ) THEN
                        DUP(ISETF) = .TRUE.
                     END IF
                  END DO
               END IF
            END DO
         END DO
C
C        Warn the user if there are missmatched channels.
C
         DO ISETF = 1, NSETF
            IF( .NOT. OKXC(ISETF) ) THEN
               CALL WLOG( 1, 
     1             'SFINFO:  **** WARNING ****' )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A, A )' )
     1            '    The setup file:',
     2            SETFILE(ISETF)(1:LEN1(SETFILE(ISETF))),
     3            '  has unmatched channels at different stations.'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A )' ) 
     1           '    Is this intentional?', 
     2           ' Some checks will be disabled.'
               CALL WLOG( 1, '    DOPPLER, FREQ, and BW scan '//
     1               'inputs will be disabled for this setup.' )
            END IF
C
            IF( DUP(ISETF) ) THEN
               CALL WLOG( 1, 
     1               'SFINFO:  **** WARNING ****' )
               WRITE( MSGTXT, '( A, A, A )' )
     1            '    The setup file:',
     2            SETFILE(ISETF)(1:LEN1(SETFILE(ISETF))),
     3            '  has duplicate channels.'
               CALL WLOG( 1, MSGTXT )
               CALL WLOG( 1, '      (ie, Freqency match to 5% of BW. '
     1             // '  Other properties match.)' )
               MSGTXT = ' '
               WRITE( MSGTXT, '( A, A )' ) 
     1             '    Is this intentional?  ', 
     2             'This messes up SCHED internal bookkeeping'
               CALL WLOG( 1, MSGTXT )
               MSGTXT = ' '
               CALL WLOG( 1, '    As a result, DOPPLER, FREQ, and BW '//
     1              'will be disabled for scans using this setup.' )
               CALL WLOG( 1, '    If those are not needed, the '//
     1              'schedule should be ok.' )
C
C              Flag the bookkeeping as bad for later.
C
               OKXC(ISETF) = .FALSE.
            END IF
        END DO
      END IF
C
      RETURN
      END

      INTEGER FUNCTION VXNHDS( KS )
      IMPLICIT NONE
C 
C     Routine specific for the VEX extension of SCHED. 
C     Returns the number of heads used by  
C     Setup KS
C     By H.J. van Langevelde, JIVE, 011200 
C 
      INCLUDE 'sched.inc' 
      INCLUDE 'schset.inc' 
      INCLUDE 'vxlink.inc' 

      INTEGER KS
      INTEGER ICH, IP

      VXNHDS = 1
      IF (TWOHEAD) THEN
C
C     Possibly more than 1, say 2
C
         DO ICH = 1, NCHAN(KS)
            DO IP = 1, TAPEMODE(KS)
               IF ( TRACK(ICH,IP,KS) .GE. 64 ) 
     1             VXNHDS = 2
            END DO
         END DO            
C     
      END IF
      RETURN
      END

      SUBROUTINE SCANID( MODE, ISCN, ISTA )
C
C     Routine for SCHED, to be called mainly when warnings or errors
C     are being issued.  It writes identification information about
C     the scan.  If ISTA is 0, the station identification will be left
C     off.
C
C     MODE is the write mode for messages (routine WLOG) and is 0 or 1.
C     0 writes to the log file only.  1 writes to the logfile and to
C     the terminal.
C
      INCLUDE        'sched.inc'
C
      INTEGER           ISCN, ISTA, YEAR, DAY1, DAY2, LEN1, ICH, MODE
      CHARACTER         TFORM*8, CSTART*8, CSTOP*8
      DOUBLE PRECISION  START, STOP
C -------------------------------------------------------------------      
      IF( DEBUG ) CALL WLOG( 0, 'SCANID starting' )
C
C     Get the scan times.
C
      CALL TIMEJ( STARTJ(ISCN), YEAR, DAY1, START )
      CALL TIMEJ( STOPJ(ISCN), YEAR, DAY2, STOP )
      CSTART = TFORM( START, 'T', 0, 2, 2, '::@' )
      CSTOP = TFORM( STOP, 'T', 0, 2, 2, '::@' )
C
      WRITE( MSGTXT, '( A, I5, I5, A, A, A, I3, A, A, 2X, A )' )
     1   ' Scan', ISCN, DAY1, '/', CSTART, ' - ', DAY2, '/', CSTOP,
     2   SCNSRC(ISCN)
C
C     Add station if ISTA not zero.
C
      IF( ISTA .NE. 0 ) THEN
         ICH = LEN1( MSGTXT )
         WRITE( MSGTXT(ICH+2:ICH+20), '( A, A )' )
     1           '  Station ', STANAME(ISTA)
      END IF
C
C     Now write the result.
C
      ICH = LEN1( MSGTXT )
      CALL WLOG( MODE, MSGTXT(1:ICH) )
C
      RETURN
      END

      SUBROUTINE MTXYEW( KSTA, UP, SAZ, SEL, TX, TY )
C
C     Routine for SCHED that checks if the source is up at an
C     XYEW mount antenna.  It also returns the current position 
C     regardless of where the antenna is requested to point.
C     Adapted from mtxyns.f
C
C     An example of a XYEW antenna is Hobart.
C
      INCLUDE 'sched.inc'
C
      INTEGER      KSTA, IBOX, LOWER, UPPER
      REAL         SAZ, SEL, SX, SY, TX, TY, DIST, RX, RY, DX, DY
      CHARACTER    UP*1
C ---------------------------------------------------------------
C     Complain if limits not given.
C
      IF( NAXLIM(KSTA) .LT. 1 .OR. NAXLIM(KSTA) .GT. 3 ) THEN
         CALL ERRLOG( 'MTXYEW: Need between 1 and 3 sets of axis '//
     1     'limits for '//STATION(KSTA) )
      END IF
C
C     Get the requested X, Y coordinates.
C
      CALL AZELXYEW( SAZ, SEL, SX, SY, RADDEG )
C
C     Find the closest place that the antenna can get to the requested
C     position in terms of the sum of the X and Y offsets.  The offsets
C     will be zero if the source is up.
C
      DIST = 1000.
      DO IBOX = 1, NAXLIM(KSTA)
         LOWER = 2 * IBOX - 1
         UPPER = 2 * IBOX
         RX = MAX( SX, AX1LIM(LOWER,KSTA) )
         RX = MIN( RX, AX1LIM(UPPER,KSTA) )
         RY = MAX( SY, AX2LIM(LOWER,KSTA) )
         RY = MIN( RY, AX2LIM(UPPER,KSTA) )
         DX = ABS( RX - SX )
         DY = ABS( RY - SY )
         IF( DX + DY .LT. DIST ) THEN
            TX = RX
            TY = RY
            DIST = DX + DY
         END IF
      END DO
C
C     Check if up.
C
      IF( TX .EQ. SX .AND. TY .EQ. SY ) THEN
         UP = ' '
      ELSE
         UP = 'D'
      END IF
C
      RETURN
      END

!  Instructions to control reference pointing.

!  This file is maintained in $SCHED/catalogs/Master_NRAO/peak.cmd.
!  The versions in $SCHED/catalogs/ are produced by Update which
!  alters the setup files for each case.

!  This file provides information that allows SCHED to create reference
!  pointing observations with minimal user input, either in response
!  to the POINT command or when using AUTOPEAK.  From this, Update in
!  the catalogs area will create 3 files, one each for use with Mark5a
!  recording, one for the RDBE_PFB and one for the RDBE_DDC.  They only
!  differ in the specified setup file.

!  Not that when POINT or AUTOPEAK are used in RDBE based observations,
!  the CRD parameters such as CRDDOP, CRDBW etc are used so that the
!  legacy BBCs, whose power data are used for pointing, can be set 
!  independently of the RDBE.  This is required for the RDBE_PFB because
!  it cannot use the narrow bandwidths needed for pointing on masers.



!  SOURCE CATALOG:

!  Specify the source catalog file with pointing sources.  These 
!  will be added to the normal source list so the names should be 
!  distinct from sources in the main source list (often sources.vlba).  
!  Note that some sources in the main list can also be used for pointing.

 srcfile = $SCHED/catalogs/sources.pointing ! Reference pointing sources



!  LINE REST FREQUENCIES

! Add the rest frequencies to the list of lines.
! This can also be done in the main schedule inputs.
! For here, use special names that won't conflict with what users
! use in the main program.  This is being done because there are 4
! rest frequencies given, two of which are off the line for use
! with the pointing setup file, which has 4 channels and allows
! on/off line difference power pointing (although that is not yet
! available for reference pointing, it is used for pointing tests.)
! The first two frequencies are the actual line frequency.

lineinit  /
lineset='PSiO431'  restfreq=43122.027, 43122.027, 43222.027, 43222.027 /
lineset='PSiO862'  restfreq=86243.4,   86243.4,   86443.4,   86443.4   /
lineset ='PH2O'    restfreq=22235.08,  22235.08,  22285.08,  22285.08  /
endlines /    



!  CONTROL PARAMETERS

!  The first three parameters are for automatic insertion of peaking 
!  scans only and apply to all 3mm groups.  

minfreq = 60000.0     !  Don't bother for lower frequencies (MHz)
dwell = 1:00          !  Duration of peak scan.
minel = 10.00         !  Minimum elevation for pointing.

!  These also apply to scans for which conversion to pointing is 
!  requested with POINT.  The setup will be modified by Update
!  for the appropriate file for each varient of peak.cmd in the
!  base catalogs directory.  The file choices that replace "pt7mm.set" are:

!     pt7mm.set - for non-rdbe observing.  "peak.cmd"
!     ptd7mm.set - for observing with the RDBE_DDC   "peak_RDBE_DDC.cmd"
!     ptr7mm.set - for observing with the RDBE_PFB   "peak_RDBE_PFB.cmd"
!    For line pointing replace "pt7mm.set" with:
!     pt7mm.set - for non-rdbe observing.  "peak.cmd"
!     ptdl7mm.set - for the RDBE_DDC       "peak_RDBE_DDC.cmd"
!     ptr7mm.set - for the RDBE_PFB        "peak_RDBE_PFB.cmd"
!  These are the same as the continuum for the old systems and for the
!  RDBE.

setup = $SCHED/setups/pt7mm.set
setupl = $SCHED/setups/pt7mm.set
linename = 'PSiO431'



!  SOURCES CHOICES

!  The VLBA pointing for 3mm projects will be done at 7mm.  Essentially all
!  useful sources are variable, so the best sources can vary with time.
!  Keeping only the best sources should be fairly reliable.  The other
!  sources here are shown in case it is important to find something
!  closer to the target.  The scheduler will have to add the desired
!  source(s) to the uncommented list and will have to make the decision
!  on whether the source is expected to be usable.

!! STRONG sources, pretty much guaranteed.  Sources starting with P-
!! are SiO masers.  The others are continuum sources.
!! Vivek Dhawan, 2001 feb12.

sources = 'P-OCeti','P-IkTau','P-TxCam','P-Orinew2','P-RLeo','P-UHer',
          'P-VYCma','P-VXSgr', 'SiO-WHya','SiO-RCas',
          '3C279','1334-127','3C273','3C345','0607-157',
          '3C84'

!  3C446 and NRAO530 used to be in this list, but appear to be too weak
!  as of May 2013 according to the BU Blazar project.
!  3C345's peak is low in the Blazar project, but it's total might be higher.
!  1334-127, 0607-157 are not in the BU project or VLBA regular pointing
!  so their status is unknown
!    This source list need to be revisited.

!! moderately strong sources, but variable so they may not always work..
!! Vivek 2001 Feb12.

!  'P-GXMon','P-RCnc', 'P-RLMi','P-AHSco','P-GYAql','P-ChiCyg','P-NMLCyg',
!  'P-RPeg','P-RAqr'

!! moderately strong continuum sources at 7mm: mostly From BIMA phase-cal list,
!! above about 4Jy at 3mm, expected to be above about 8Jy total at 7mm.  These
!! might be good for pointing.  They need to be tested.

!  '2145+067','2255-282','NRAO150','3C454.3','1921-293','0420-014','4C39.25',
!  'DR21'


!  STATION GROUPS:

!  There can be up to 5 groups of stations that can have separate
!  pointing scans handled automatically (you can do anything you
!  want using full scan specifications).  When pointing is requested,
!  all stations in a group use the same source.  A different source
!  can be picked for other groups, which are typically at other 
!  longitudes.

!  GROUP 1: Eastern VLBA antennas at 3mm.  Station names 
!  or codes can be specified.  These apply to inserted scans 
!  for group 1 or for any scans for which POINT=1 or POINT=0 
!  was specified.

 stations = vlba_sc, vlba_hn, vlba_nl, vlba_fd, vlba_la, 
            vlba_pt, vlba_kp
  /

!  GROUP 2:  Western VLBA stations. 
!  Use most of the same parameters as GROUP 1.

stations = vlba_ov, vlba_br, vlba_mk

  /
